
(* Options *)
Options[BondCurveFitting] = {ConstrainAtZero->True,Tolerance->1.0*^-10,MaxIterations->5000,Calendar->"Target",DayCounter->"Actual/365 (Fixed)",Method->"ExponentialSpline",SettlementDays->2}

(* FittingMethods  *)
(* :Evaluate:     Options[BondCurveFitting] = {ConstrainAtZero->True,Tolerance->1.0*^-10,MaxIterations->5000,Calendar->"Target",DayCounter->"Actual/365 (Fixed)",Method->"ExponentialSpline",SettlementDays->2} 
*)

 (* Abcd *)
Options[AbcdCalibration] = {A->0.,B->0.,C->0.,D->0.,AIsFixed->True,BIsFixed->True,CIsFixed->True,DIsFixed->True,VegaWeighted->True,EndCriteria->0.,Method->0.,Permanent->True,Overwrite->True} 
Options[AbcdCalibrationA] = {} 
Options[AbcdCalibrationB] = {} 
Options[AbcdCalibrationC] = {} 
Options[AbcdCalibrationCompute] = {} 
Options[AbcdCalibrationD] = {} 
Options[AbcdCalibrationEndCriteria] = {} 
Options[AbcdCalibrationError] = {} 
Options[AbcdCalibrationK] = {} 
Options[AbcdCalibrationMaxError] = {} 
Options[AbcdDFunction] = {} 
Options[AbcdFunction] = {A->0.,B->0.,C->0.,D->0.,Permanent->True,Overwrite->True} 
Options[AbcdFunctionA] = {} 
Options[AbcdFunctionB] = {} 
Options[AbcdFunctionC] = {} 
Options[AbcdFunctionCovariance] = {} 
Options[AbcdFunctionD] = {} 
Options[AbcdFunctionInstantaneousCovariance] = {} 
Options[AbcdFunctionInstantaneousValue] = {} 
Options[AbcdFunctionInstantaneousVariance] = {} 
Options[AbcdFunctionInstantaneousVolatility] = {} 
Options[AbcdFunctionLongTermVolatility] = {} 
Options[AbcdFunctionMaximumLocation] = {} 
Options[AbcdFunctionMaximumVolatility] = {} 
Options[AbcdFunctionShortTermVolatility] = {} 
Options[AbcdFunctionVariance] = {} 
Options[AbcdFunctionVolatility] = {} 


 (* Accounting Engines *)
Options[AccountingEngine] = {Permanent->True,Overwrite->True} 
Options[AccountingEngineMultiplePathValues] = {} 


 (* AlphaForm *)
Options[AlphaFormInverseLinear] = {Permanent->True,Overwrite->True} 
Options[AlphaFormLinearHyperbolic] = {Permanent->True,Overwrite->True} 
Options[AlphaFormOperator] = {} 
Options[AlphaFormSetAlpha] = {} 



 (* Asset Swap *)
Options[AssetSwap] = {PayBondCoupon->True,Spread->0.,FloatingLegSchedule->0.,FloatingLegDayCounter->"Actual/365 (Fixed)",ParAssetSwap->True,Permanent->True,Overwrite->True} 
Options[AssetSwapBondLegAnalysis] = {} 
Options[AssetSwapFairCleanPrice] = {} 
Options[AssetSwapFairSpread] = {} 
Options[AssetSwapFloatingLegAnalysis] = {} 
Options[AssetSwapFloatingLegBPS] = {} 
Options[AssetSwapParSwap] = {} 
Options[AssetSwapPayFixedRate] = {} 


 (* Bonds *)
Options[Bond] = {Description->"no description available",Currency->"NullCurrency",SettlementDays->2,Calendar->"Target",FaceAmount->100.,MaturityDate->EvaluationDate[],IssueDate:>EvaluationDate[],Permanent->True,Overwrite->True} 
Options[BondAccrualDays] = {SettlementDate:>EvaluationDate[]} 
Options[BondAccrualEndDate] = {SettlementDate:>EvaluationDate[]} 
Options[BondAccrualPeriod] = {SettlementDate:>EvaluationDate[]} 
Options[BondAccrualStartDate] = {SettlementDate:>EvaluationDate[]} 
Options[BondAccruedAmount] = {SettlementDate:>EvaluationDate[]} 
Options[BondAccruedDays] = {SettlementDate:>EvaluationDate[]} 
Options[BondAccruedPeriod] = {SettlementDate:>EvaluationDate[]} 
Options[BondAtmRateFromYieldTermStructure] = {SettlementDate:>EvaluationDate[]} 
Options[BondBpsFromYield] = {DayCounter->"Actual/365 (Fixed)",Compounding->"Continuous",Frequency->0.,SettlementDate:>EvaluationDate[]} 
Options[BondBpsFromYieldTermStructure] = {SettlementDate:>EvaluationDate[]} 
Options[BondCalendar] = {} 
Options[BondCleanPrice] = {} 
Options[BondCleanPriceFromYield] = {DayCounter->"Actual/365 (Fixed)",Compounding->"Continuous",Frequency->0.,SettlementDate:>EvaluationDate[]} 
Options[BondCleanPriceFromYieldTermStructure] = {SettlementDate:>EvaluationDate[]} 
Options[BondCleanPriceFromZSpread] = {DayCounter->"Actual/365 (Fixed)",Compounding->"Continuous",Frequency->0.,SettlementDate:>EvaluationDate[]} 
Options[BondConvexityFromYield] = {DayCounter->"Actual/365 (Fixed)",Compounding->"Continuous",Frequency->0.,SettlementDate:>EvaluationDate[]} 
Options[BondCurrency] = {} 
Options[BondDescription] = {} 
Options[BondDurationFromYield] = {DayCounter->"Actual/365 (Fixed)",Compounding->"Continuous",Frequency->0.,DurationType->0.,SettlementDate:>EvaluationDate[]} 
Options[BondFlowAnalysis] = {} 
Options[BondIsTradable] = {SettlementDate:>EvaluationDate[]} 
Options[BondIssueDate] = {} 
Options[BondMaturityDate] = {} 
Options[BondNextCashFlowAmount] = {SettlementDate:>EvaluationDate[]} 
Options[BondNextCashFlowDate] = {SettlementDate:>EvaluationDate[]} 
Options[BondNextCouponRate] = {SettlementDate:>EvaluationDate[]} 
Options[BondNotional] = {SettlementDate:>EvaluationDate[]} 
Options[BondNotionals] = {} 
Options[BondPreviousCashFlowAmount] = {SettlementDate:>EvaluationDate[]} 
Options[BondPreviousCashFlowDate] = {SettlementDate:>EvaluationDate[]} 
Options[BondPreviousCouponRate] = {SettlementDate:>EvaluationDate[]} 
Options[BondRedemptionAmount] = {} 
Options[BondRedemptionDate] = {} 
Options[BondReferencePeriodEnd] = {SettlementDate:>EvaluationDate[]} 
Options[BondReferencePeriodStart] = {SettlementDate:>EvaluationDate[]} 
Options[BondSetCouponPricer] = {} 
Options[BondSetCouponPricers] = {} 
Options[BondSettlementDate] = {EvaluationDate:>EvaluationDate[]} 
Options[BondSettlementDays] = {} 
Options[BondStartDate] = {} 
Options[BondYieldFromCleanPrice] = {DayCounter->"Actual/365 (Fixed)",Compounding->"Continuous",Frequency->Automatic,SettlementDate:>EvaluationDate[],Accuracy->1.*^-12,MaxIterations->5000,Guess->0.1} 
Options[BondZSpreadFromCleanPrice] = {DayCounter->"Actual/365 (Fixed)",Compounding->"Continuous",Frequency->"Annual",SettlementDate:>EvaluationDate[],Accuracy->1.*^-12,MaxIterations->5000,Guess->0.1} 
Options[CmsRateBond] = {Description->"CmsRateBond",PaymentBDC->"Following",FaceAmount->100.,FixingDays->0,IsInArrears->False,DayCounter->"Actual/365 (Fixed)",Redemption->100.,IssueDate:>EvaluationDate[],Permanent->True,Overwrite->True} 
Options[FixedRateBond] = {Description->"FixedRateBond",Currency->"NullCurrency",SettlementDays->2,FaceAmount->100.,DayCounter->"Actual/365 (Fixed)",PaymentBDC->"Following",Redemption->100.,IssueDate:>EvaluationDate[],PaymentCalendar->"Target",Permanent->True,Overwrite->True} 
Options[FixedRateBond2] = {Description->"FixedRateBond2",FaceAmount->100.,PaymentBDC->"Following",Redemption->100.,IssueDate:>EvaluationDate[],PaymentCalendar->"Target",Permanent->True,Overwrite->True} 
Options[FloatingRateBond] = {Description->"FloatingRateBond",PaymentBDC->"Following",FaceAmount->100.,FixingDays->0,IsInArrears->False,DayCounter->"Actual/365 (Fixed)",Redemption->100.,IssueDate:>EvaluationDate[],Permanent->True,Overwrite->True} 
Options[ZeroCouponBond] = {Description->"ZeroCouponBond",Calendar->"Target",FaceAmount->100.,PaymentBDC->"Following",Redemption->100.,IssueDate:>EvaluationDate[],Permanent->True,Overwrite->True} 
Options[FixedRateBondForward] = {Description->"FixedRateBondForward",SettlementDays->2,DayCounter->"Actual/365 (Fixed)",BusinessDayConvention->"Following",ValueDate:>EvaluationDate[],Calendar->"Target",Permanent->True,Overwrite->True} 

Options[CallableFixedRateBond] = Join[{Description->"Callable FixedRate Bond"},Rest[Options[FixedRateBond]]] 

 (* Amoritizing Bonds *)
Options[AmortizingFixedRateBond] = Join[{Description->"Amortizing FixedRate Bond"},Rest[Options[FixedRateBond]]]

 (* Brownian Generator *)
Options[MTBrownianGeneratorFactory] = {Seed->0,Permanent->True,Overwrite->True} 


 (* Calendar *)
Options[CalendarAddHoliday] = {Calendar->"Null"} 
Options[CalendarAdjust] = {Calendar->"Null",BusinessDayConvention->"Unadjusted"} 
Options[CalendarAdvance] = {Calendar->"Null",BusinessDayConvention->"Unadjusted",EndOfMonth->False} 
Options[CalendarBusinessDaysBetween] = {Calendar->"Null",IncludeFirst->True,IncludeLast->True} 
Options[CalendarEndOfMonth] = {Calendar->"Null"} 
Options[CalendarHolidayList] = {Calendar->"Null",IncludeWeekEnds->False} 
Options[CalendarIsBusinessDay] = {Calendar->"Null"} 
Options[CalendarIsEndOfMonth] = {Calendar->"Null"} 
Options[CalendarIsHoliday] = {Calendar->"Null"} 
Options[CalendarName] = {Calendar->"Null"} 
Options[CalendarRemoveHoliday] = {Calendar->"Null"}
 
 (* Calibration Helper *)
Options[CalibrationHelperImpliedVolatility] = {Accuracy->1.*^-4,MaxEvaluations->1000,MinVol->0.001,MaxVol->0.5} 
Options[SwaptionHelper] = {FixedLegTenor->Automatic,FixedLegDayCounter->Automatic,FloatingLegDayCounter->Automatic,ErrorType->"RelativePriceError",Permanent->True,Overwrite->True}  
Options[CapHelper] = {FixedLegDayCounter->Automatic,Permanent->True,Overwrite->True}  
 (* Caps/Floors *)
Options[CapFloor] = {Permanent->True,Overwrite->True} 
Options[CapFloorAtmRate] = {} 
Options[CapFloorCapRates] = {} 
Options[CapFloorFloorRates] = {} 
Options[CapFloorImpliedVolatility] = {Guess->0.1,Accuracy->1.*^-12,MaxIter->5000} 
Options[CapFloorLegAnalysis] = {} 
Options[CapFloorMaturityDate] = {} 
Options[CapFloorStartDate] = {} 
Options[CapFloorType] = {} 
Options[MakeCapFloor] = {Strike->0.,Permanent->True,Overwrite->True} 

 (* Caplet Volatility Term Structures *)
Options[CapFloorTermVTSVolatility] = {AllowExtrapolation->True} 
Options[CapFloorTermVTSVolatility2] = {AllowExtrapolation->True} 
Options[ConstantOptionletVolatility] = {NDays->0,Calendar->"Target",DayCounter->"Actual/365 (Fixed)",BusinessDayConvention->"Following",Permanent->True,Overwrite->True} 
Options[OptionletStripper1] = {SwitchStrike->0.,Accuracy->1.*^-12,MaxIter->5000,Permanent->True,Overwrite->True} 
Options[OptionletStripper2] = {Permanent->True,Overwrite->True} 
Options[OptionletVTSBlackVariance] = {} 
Options[OptionletVTSBlackVariance2] = {} 
Options[OptionletVTSVolatility] = {AllowExtrapolation->True} 
Options[OptionletVTSVolatility2] = {AllowExtrapolation->True} 
Options[RelinkableHandleOptionletVolatilityStructure] = {CurrentLink->Null,Permanent->True,Overwrite->True} 
Options[SpreadedOptionletVolatility] = {Permanent->True,Overwrite->True} 
Options[StrippedOptionletBaseBusinessDayConvention] = {} 
Options[StrippedOptionletBaseCalendar] = {} 
Options[StrippedOptionletBaseDayCounter] = {} 
Options[StrippedOptionletBaseSettlementDays] = {} 


 (* Cms Market *)
Options[BrowseCmsMarket] = {} 
Options[CmsMarket] = {Permanent->True,Overwrite->True} 

 (* Cms Market Calibration *)
Options[CmsMarketCalibration] = {Permanent->True,Overwrite->True} 
Options[CmsMarketCalibrationCompute] = {EndCriteria->0.,OptimizationMethod->0.} 
Options[CmsMarketCalibrationDenseSabrParameters] = {} 
Options[CmsMarketCalibrationElapsed] = {} 
Options[CmsMarketCalibrationEndCriteria] = {} 
Options[CmsMarketCalibrationError] = {} 
Options[CmsMarketCalibrationSparseSabrParameters] = {} 
Options[SimultaneousCalibrationBrowseCmsMarket] = {} 


 (* Correlation *)
Options[CotSwapFromFwdCorrelation] = {Displacement->0.,Permanent->True,Overwrite->True} 
Options[ExponentialCorrelations] = {LongTermCorr->0.,Beta->0.,Gamma->0.} 
Options[ExponentialForwardCorrelation] = {Permanent->True,Overwrite->True} 
Options[HistoricalForwardRatesAnalysisFailedDates] = {} 
Options[HistoricalForwardRatesAnalysisFailedDatesErrorMessage] = {} 
Options[HistoricalForwardRatesAnalysisFixingPeriods] = {} 
Options[HistoricalForwardRatesAnalysisSkippedDates] = {} 
Options[HistoricalForwardRatesAnalysisSkippedDatesErrorMessage] = {} 
Options[HistoricalRatesAnalysisSkippedDates] = {} 
Options[HistoricalRatesAnalysisSkippedDatesErrorMessage] = {} 
Options[MarketModelLmLinearExponentialCorrelationModel] = {Factors->0,Permanent->True,Overwrite->True} 
Options[PiecewiseConstantCorrelationCorrelation] = {} 
Options[PiecewiseConstantCorrelationNumberOfRates] = {} 
Options[PiecewiseConstantCorrelationTimes] = {} 
Options[TimeHomogeneousForwardCorrelation] = {Permanent->True,Overwrite->True} 

 (* Coupon Vectors *)
Options[CmsCouponPricer] = {CmsCouponPricerType->"ConundrumByNumericalIntegration",YieldCurveModel->"NonParallelShifts",Permanent->True,Overwrite->True} 
Options[CmsLeg] = {PaymentBDC->"Following",IsInArrears->False,DayCounter->"Actual/365 (Fixed)",Permanent->True,Overwrite->True,
                    FixingDays->{},Floors->{},Gearings->{1.},Spreads->{},Caps->{}} 
Options[CmsZeroLeg] = {PaymentBDC->"Following",IsInArrears->False,DayCounter->"Actual/365 (Fixed)",Permanent->True,Overwrite->True} 
Options[ConundrumPricerByNumericalIntegration] = {LowerLimit->0.,UpperLimit->0.,Precision->0.,Permanent->True,Overwrite->True} 
Options[ConundrumPricerByNumericalIntegrationUpperLimit] = {} 
Options[DigitalCmsLeg] = {PaymentBDC->"Following",IsInArrears->False,DayCounter->"Actual/365 (Fixed)",Permanent->True,Overwrite->True} 
Options[DigitalIborLeg] = {PaymentBDC->"Following",IsInArrears->False,DayCounter->"Actual/365 (Fixed)",Permanent->True,Overwrite->True} 
Options[DigitalReplication] = {Gap->0.,Permanent->True,Overwrite->True} 
Options[FixedRateLeg] = {PaymentBDC->"Following",DayCounter->"Actual/365 (Fixed)",Permanent->True,Overwrite->True} 
Options[FixedRateLeg2] = {PaymentBDC->"Following",Permanent->True,Overwrite->True} 
Options[IborCouponPricer] = {Permanent->True,Overwrite->True} 
Options[IborLeg] = {PaymentBDC->"Following",IsInArrears->False,DayCounter->"Actual/360",Permanent->True,Overwrite->True,
                                    FixingDays->{},Floors->{},Gearings->{},Spreads->{},Caps->{} } 
Options[RangeAccrualLeg] = {PaymentBDC->"Following",DayCounter->"Actual/365 (Fixed)",ObservationsBDC->"Following",Permanent->True,Overwrite->True} 

 (* QuantLib Credit *)
Options[CreditDefaultSwap] = {BuyerSeller->"Buyer",PaymentConvention->"Following",DayCounter->"Actual/365 (Fixed)",SettlesAccrual->True,
                  PayAtDefault->True,ProtectionStart:>EvaluationDate[],Upfront->0.,UpfrontDate:>EvaluationDate[],Permanent->True,Overwrite->True} 
Options[CreditDefaultSwapImpliedHazardRate] = {DayCounter->"Actual/365 (Fixed)",Accuracy->1.*^-12,RecoveryRate->0.4}                  
Options[CreditDefaultSwapConventionalSpread] = {DayCounter->"Actual/365 (Fixed)"}                  


Options[HazardRateCurve] = {DayCounter->"Actual/365 (Fixed)",Permanent->True,Overwrite->True} 
Options[MidPointCdsEngine] = {RecoveryRate->0.4,Permanent->True,Overwrite->True} 
Options[PiecewiseFlatForwardCurve] = {ReferenceDate:>EvaluationDate[],DayCounter->"Actual/365 (Fixed)",Accuracy->1.*^-12,Permanent->True,Overwrite->True} 
Options[PiecewiseFlatHazardRateCurve] = {ReferenceDate:>EvaluationDate[],DayCounter->"Actual/365 (Fixed)",Accuracy->1.*^-12,Permanent->True,Overwrite->True} 
Options[SpreadCdsHelper] = {SettlementDays->2,Calendar->"Target",DayCounter->"Actual/365 (Fixed)",SettleAccrual->True,PayAtDefault->True,Permanent->True,Overwrite->True} 
Options[UpfrontCdsHelper] = {SettlementDays->2,Calendar->"Target",DayCounter->"Actual/365 (Fixed)",SettleAccrual->True,PayAtDefault->True,Permanent->True,Overwrite->True} 

 (* Piecewise Default Curves *)
Options[PiecewiseDefaultCurve] = {NDays->0,Calendar->"Target",DayCounter->"Actual/365 (Fixed)",Accuracy->1.*^-12,TraitsID->"HazardRate",InterpolatorID->"LogLinear",Permanent->True,Overwrite->True} 
Options[PiecewiseDefaultCurveData] = {} 
Options[PiecewiseDefaultCurveDates] = {} 
Options[PiecewiseDefaultCurveJumpDates] = {} 
Options[PiecewiseDefaultCurveJumpTimes] = {} 
Options[PiecewiseDefaultCurveTimes] = {} 


 (* Ctsmmcapletcalibration *)
Options[CTSMMCapletAlphaFormCalibration] = {Displacement->0.,MaximizeHomogeneity->True,AlphaForm->0.,Permanent->True,Overwrite->True} 
Options[CTSMMCapletAlphaFormCalibrationAlpha] = {} 
Options[CTSMMCapletCalibrationCalibrate] = {MaxIter->0,Tol->0.,InnerMaxIter->0,InnerTol->0.} 
Options[CTSMMCapletCalibrationCapletMaxError] = {} 
Options[CTSMMCapletCalibrationCapletRmsError] = {} 
Options[CTSMMCapletCalibrationDeformationSize] = {} 
Options[CTSMMCapletCalibrationFailures] = {} 
Options[CTSMMCapletCalibrationMarketCapletVols] = {} 
Options[CTSMMCapletCalibrationMarketSwaptionVols] = {} 
Options[CTSMMCapletCalibrationModelCapletVols] = {} 
Options[CTSMMCapletCalibrationModelSwaptionVols] = {} 
Options[CTSMMCapletCalibrationSwapPseudoRoot] = {} 
Options[CTSMMCapletCalibrationSwaptionMaxError] = {} 
Options[CTSMMCapletCalibrationSwaptionRmsError] = {} 
Options[CTSMMCapletCalibrationTimeDependentCalibratedSwaptionVols] = {} 
Options[CTSMMCapletCalibrationTimeDependentUnCalibratedSwaptionVols] = {} 
Options[CTSMMCapletMaxHomogeneityCalibration] = {Displacement->0.,Caplet0Swaption1Priority->0.,Permanent->True,Overwrite->True} 
Options[CTSMMCapletOriginalCalibration] = {Displacement->0.,LowestRoot->True,Permanent->True,Overwrite->True} 


 (* CurveState *)
Options[CMSwapCurveState] = {Permanent->True,Overwrite->True} 
Options[CMSwapCurveStateSetOnCMSwapRates] = {} 
Options[ConstantMaturitySwapAnnuitiesFromDiscountRatios] = {} 
Options[ConstantMaturitySwapRatesFromDiscountRatios] = {} 
Options[CoterminalSwapAnnuitiesFromDiscountRatios] = {} 
Options[CoterminalSwapCurveState] = {Permanent->True,Overwrite->True} 
Options[CoterminalSwapCurveStateSetOnCoterminalSwapRates] = {} 
Options[CoterminalSwapRatesFromDiscountRatios] = {} 
Options[CurveStateCMSwapRates] = {} 
Options[CurveStateCoterminalSwapRates] = {} 
Options[CurveStateForwardRates] = {} 
Options[CurveStateRateTaus] = {} 
Options[CurveStateRateTimes] = {} 
Options[ForwardsFromDiscountRatios] = {} 
Options[LMMCurveState] = {Permanent->True,Overwrite->True} 
Options[LMMCurveStateSetOnDiscountRatios] = {} 
Options[LMMCurveStateSetOnForwardRates] = {} 

 (* Date *)
Options[DateEndOfMonth] = {} 
Options[DateIsEndOfMonth] = {} 
Options[DateIsLeap] = {} 
Options[DateMaxDate] = {} 
Options[DateMinDate] = {} 
Options[DateNextWeekday] = {} 
Options[DateNthWeekday] = {} 
Options[ECBAddDate] = {} 
Options[ECBIsECBcode] = {} 
Options[ECBIsECBdate] = {} 
Options[ECBKnownDates] = {} 
Options[ECBNextCode] = {RefDate:>EvaluationDate[]} 
Options[ECBNextCode2] = {} 
Options[ECBNextDate] = {Date:>EvaluationDate[]} 
Options[ECBNextDate2] = {} 
Options[ECBNextDates] = {Date:>EvaluationDate[]} 
Options[ECBRemoveDate] = {} 
Options[ECBcode] = {} 
Options[ECBdate] = {RefDate:>EvaluationDate[]} 
Options[ECBdate2] = {} 
Options[FrequencyFromPeriod] = {} 
Options[IMMIsIMMcode] = {MainCycle->True} 
Options[IMMIsIMMdate] = {MainCycle->True} 
Options[IMMNextCode] = {RefDate:>EvaluationDate[],MainCycle->True} 
Options[IMMNextCodes] = {RefDate:>EvaluationDate[]} 
Options[IMMNextDate] = {RefDate:>EvaluationDate[],MainCycle->True} 
Options[IMMNextDates] = {RefDate:>EvaluationDate[]} 
Options[IMMcode] = {} 
Options[IMMdate] = {RefDate:>EvaluationDate[]} 
Options[PeriodEquivalent] = {} 
Options[PeriodFromFrequency] = {} 
Options[PeriodLessThan] = {} 

 (* Daycounter *)
Options[DayCounterDayCount] = {Daycounter->"Actual/365 (Fixed)"} 
Options[DayCounterName] = {Daycounter->"Actual/365 (Fixed)"} 
Options[DayCounterYearFraction] = {Daycounter->"Actual/365 (Fixed)",RefPeriodStart->Automatic,RefPeriodEnd->Automatic} 

 (* Default Probability Term Structures *)
Options[DefaultTSDefaultProbability] = {AllowExtrapolation->True} 
Options[FlatHazardRate] = {NDays->0,Calendar->"Target",DayCounter->"Actual/365 (Fixed)",Permanent->True,Overwrite->True} 
Options[RelinkableHandleDefaultProbabilityTermStructure] = {CurrentLink->"",Permanent->True,Overwrite->True} 


 (* Driftcalculators *)
Options[CMSMMDriftCalculator] = {Permanent->True,Overwrite->True} 
Options[CMSMMDriftCalculatorCompute] = {} 
Options[LMMDriftCalculator] = {Permanent->True,Overwrite->True} 
Options[LMMDriftCalculatorCompute] = {} 
Options[LMMDriftCalculatorComputePlain] = {} 
Options[LMMDriftCalculatorComputeReduced] = {} 
Options[LMMNormalDriftCalculator] = {Permanent->True,Overwrite->True} 
Options[LMMNormalDriftCalculatorCompute] = {} 
Options[LMMNormalDriftCalculatorComputePlain] = {} 
Options[LMMNormalDriftCalculatorComputeReduced] = {} 
Options[SMMDriftCalculator] = {Permanent->True,Overwrite->True} 
Options[SMMDriftCalculatorCompute] = {} 

 (* Evolution Description *)
Options[EvolutionDescription] = {Permanent->True,Overwrite->True} 
Options[EvolutionDescriptionEvolutionTimes] = {} 
Options[EvolutionDescriptionFirstAliveRate] = {} 
Options[EvolutionDescriptionFromProduct] = {Permanent->True,Overwrite->True} 
Options[EvolutionDescriptionNumberOfRates] = {} 
Options[EvolutionDescriptionNumberOfSteps] = {} 
Options[EvolutionDescriptionRateTaus] = {} 
Options[EvolutionDescriptionRateTimes] = {} 
Options[IsInMoneyMarketMeasure] = {} 
Options[IsInMoneyMarketPlusMeasure] = {Offset->0} 
Options[IsInTerminalMeasure] = {} 
Options[MoneyMarketMeasure] = {} 
Options[MoneyMarketPlusMeasure] = {Offset->0.} 
Options[TerminalMeasure] = {} 

 (* Exercise *)
Options[AmericanExercise] = {PayoffAtExpiry->True,Permanent->True,Overwrite->True} 
Options[BermudanExercise] = {PayoffAtExpiry->True,Permanent->True,Overwrite->True} 
Options[EuropeanExercise] = {Permanent->True,Overwrite->True} 
Options[ExerciseDates] = {} 
Options[ExerciseLastDate] = {} 

 (* Forward Rate Agreement *)
Options[FRA] = {Permanent->True,Overwrite->True} 
Options[FRAforwardRate] = {} 
Options[FRAforwardValue] = {} 
Options[FRAspotValue] = {} 

 (* Handles *)
Options[HandleCurrentLink] = {} 
Options[HandleEmpty] = {} 
Options[RelinkableHandleLinkTo] = {CurrentLink->None} 


 (* Indices *)
Options[BMAIndex] = {YieldCurve->None,Permanent->True,Overwrite->True} 
Options[Eonia] = {YieldCurve->None,Permanent->True,Overwrite->True} 
Options[Euribor] = {YieldCurve->None,Permanent->True,Overwrite->True} 
Options[EuriborSwapIsdaFixA] = {ForwardCurve->None,DiscountCurve->None,Permanent->True,Overwrite->True} 
Options[Euribor365] = {YieldCurve->None,Permanent->True,Overwrite->True} 

Options[IborIndex] = {FamilyName->"",FixingDays->0,BusinessDayConvention -> "Unadjusted",Calendar->"Target",Currency->"NullCurrency",DayCounter->"Actual/Actual",EndOfMonth->True,YieldCurve->None,Permanent->True,Overwrite->True} 
Options[IborIndexBusinessDayConv] = {} 
Options[IborIndexEndOfMonth] = {} 
Options[IndexAddFixings] = {ForceOverwrite->True} 
Options[IndexClearFixings] = {} 
Options[IndexFixing] = {ForecastToday->True} 
Options[IndexFixingCalendar] = {} 
Options[IsValidFixingDate] = {} 
Options[IndexName] = {} 
Options[IndexCurrency] = {} 
Options[IndexDayCounter] = {} 
Options[IndexFamilyName] = {} 
Options[IndexFixingDays] = {} 
Options[IndexMaturity] = {} 
Options[IndexTenor] = {} 
Options[IndexValueDate] = {} 
Options[SwapIndex] = {Calendar->"Target",DiscountCurve->None,Currency->Automatic,Permanent->True,Overwrite->True} 
Options[SwapIndexFixedLegBDC] = {} 
Options[SwapIndexFixedLegTenor] = {} 
Options[SwapIndexUnderlyingSwap]= {Permanent->True,Overwrite->True} 

 (* Instruments *)
Options[InstrumentErrorEstimate] = {} 
Options[InstrumentIsExpired] = {} 
Options[InstrumentNPV] = {} 
Options[InstrumentResults] = {} 
Options[InstrumentSetPricingEngine] = {} 
Options[InstrumentValuationDate] = {} 

 (* Interpolation *)
Options[AbcdInterpolation] = {A->0.,B->0.,C->0.,D->0.,AIsFixed->True,BIsFixed->True,CIsFixed->True,DIsFixed->True,VegaWeighted->True,EndCriteria->0.,OptimizationMeth->0.,Permanent->True,Overwrite->True} 
Options[AbcdInterpolationA] = {} 
Options[AbcdInterpolationB] = {} 
Options[AbcdInterpolationC] = {} 
Options[AbcdInterpolationD] = {} 
Options[AbcdInterpolationEndCriteria] = {} 
Options[AbcdInterpolationMaxError] = {} 
Options[AbcdInterpolationRmsError] = {} 
Options[CubicInterpolation] = {DerApprox->"Kruger",Monotonic->True,LeftConditionType->"SecondDerivative",LeftConditionValue->0.,RightConditionType->"SecondDerivative",RightConditionValue->0.,Permanent->True,Overwrite->True} 
Options[CubicInterpolationACoefficients] = {} 
Options[CubicInterpolationBCoefficients] = {} 
Options[CubicInterpolationCCoefficients] = {} 
Options[CubicInterpolationMonotonicityAdjustments] = {} 
Options[CubicInterpolationPrimitiveConstants] = {} 
Options[ExtrapolatorEnableExtrapolation] = {ExtrapolationFlag->True} 
Options[QLInterpolation] = {InterpolationType->"MonotonicNaturalCubicSpline",Permanent->True,Overwrite->True} 
Options[Interpolation2D] = {InterpolationType->"BiLinear",Permanent->True,Overwrite->True} 
Options[Interpolation2DInterpolate] = {AllowExtrapolation->True} 
Options[Interpolation2DIsInRange] = {} 
Options[Interpolation2DXmax] = {} 
Options[Interpolation2DXmin] = {} 
Options[Interpolation2DXvalues] = {} 
Options[Interpolation2DYmax] = {} 
Options[Interpolation2DYmin] = {} 
Options[Interpolation2DYvalues] = {} 
Options[Interpolation2DzData] = {} 
Options[InterpolationDerivative] = {AllowExtrapolation->True} 
Options[InterpolationInterpolate] = {AllowExtrapolation->True} 
Options[InterpolationIsInRange] = {} 
Options[InterpolationPrimitive] = {AllowExtrapolation->True} 
Options[InterpolationSecondDerivative] = {AllowExtrapolation->True} 
Options[InterpolationXmax] = {} 
Options[InterpolationXmin] = {} 
Options[MixedLinearCubicInterpolation] = {DerApprox->"Kruger",Monotonic->True,
                              LeftConditionType->"SecondDerivative",LeftConditionValue->0.,RightConditionType->"SecondDerivative",RightConditionValue->0.,Permanent->True,Overwrite->True} 
Options[SABRInterpolation] = {Alpha->0.,Beta->0.,Nu->0.,Rho->0.,AlphaIsFixed->True,BetaIsFixed->True,NuIsFixed->True,RhoIsFixed->True,VegaWeighted->True,EndCriteria->0.,OptimizationMeth->0.,Permanent->True,Overwrite->True} 
Options[SABRInterpolationAlpha] = {} 
Options[SABRInterpolationBeta] = {} 
Options[SABRInterpolationEndCriteria] = {} 
Options[SABRInterpolationExpiry] = {} 
Options[SABRInterpolationForward] = {} 
Options[SABRInterpolationMaxError] = {} 
Options[SABRInterpolationNu] = {} 
Options[SABRInterpolationRho] = {} 
Options[SABRInterpolationRmsError] = {} 
Options[SABRInterpolationWeights] = {} 

 (* Leg *)
Options[InterestRate] = {DayCounter->"Actual/365 (Fixed)",Frequency->0.,Permanent->True,Overwrite->True} 
Options[InterestRateCompoundFactor] = {RefPeriodStart:>EvaluationDate[],RefPeriodEnd:>EvaluationDate[]} 
Options[InterestRateCompounding] = {} 
Options[InterestRateDayCounter] = {} 
Options[InterestRateDiscountFactor] = {RefPeriodStart:>EvaluationDate[],RefPeriodEnd:>EvaluationDate[]} 
Options[InterestRateEquivalentRate] = {DayCounter->"Actual/365 (Fixed)",Frequency->0.,RefPeriodStart:>EvaluationDate[],RefPeriodEnd:>EvaluationDate[]} 
Options[InterestRateFrequency] = {} 
Options[InterestRateImpliedRate] = {DayCounter->"Actual/365 (Fixed)",Frequency->0.,RefPeriodStart:>EvaluationDate[],RefPeriodEnd:>EvaluationDate[]} 
Options[InterestRateRate] = {} 
Options[Leg] = {ToBeSorted->True,Permanent->True,Overwrite->True} 
Options[LegAccrualDays] = {IncludeSettlDate->True,SettlementDate:>EvaluationDate[]} 
Options[LegAccrualEndDate] = {IncludeSettlDate->True,SettlementDate:>EvaluationDate[]} 
Options[LegAccrualPeriod] = {IncludeSettlDate->True,SettlementDate:>EvaluationDate[]} 
Options[LegAccrualStartDate] = {IncludeSettlDate->True,SettlementDate:>EvaluationDate[]} 
Options[LegAccruedAmount] = {IncludeSettlDate->True,SettlementDate:>EvaluationDate[]} 
Options[LegAccruedDays] = {IncludeSettlDate->True,SettlementDate:>EvaluationDate[]} 
Options[LegAccruedPeriod] = {IncludeSettlDate->True,SettlementDate:>EvaluationDate[]} 
Options[LegAtmRate] = {IncludeSettlDate->True,SettlementDate:>EvaluationDate[],NpvDate:>EvaluationDate[],NPV->0.} 
Options[LegBPS] = {IncludeSettlDate->True,SettlementDate:>EvaluationDate[],NpvDate:>EvaluationDate[]} 
Options[LegBPSFromYield] = {DayCounter->"Actual/365 (Fixed)",Compounding->"Continuous",Frequency->0.,IncludeSettlDate->True,SettlementDate:>EvaluationDate[],NpvDate:>EvaluationDate[]} 
Options[LegBasisPointValue] = {DayCounter->"Actual/365 (Fixed)",Compounding->"Continuous",Frequency->0.,IncludeSettlDate->True,SettlementDate:>EvaluationDate[],NpvDate:>EvaluationDate[]} 
Options[LegConvexity] = {DayCounter->"Actual/365 (Fixed)",Compounding->"Continuous",Frequency->0.,IncludeSettlDate->True,SettlementDate:>EvaluationDate[],NpvDate:>EvaluationDate[]} 
Options[LegDuration] = {DayCounter->"Actual/365 (Fixed)",Compounding->"Continuous",Frequency->0.,DurationType->0.,IncludeSettlDate->True,SettlementDate:>EvaluationDate[],NpvDate:>EvaluationDate[]} 
Options[LegFlowAnalysis] = {} 
Options[LegFromCapFloor] = {Permanent->True,Overwrite->True} 
Options[LegIsExpired] = {IncludeSettlDate->True,SettlementDate:>EvaluationDate[]} 
Options[LegMaturityDate] = {} 
Options[LegNPV] = {IncludeSettlDate->True,SettlementDate:>EvaluationDate[],NpvDate:>EvaluationDate[]} 
Options[LegNPVFromYield] = {DayCounter->"Actual/365 (Fixed)",Compounding->"Continuous",Frequency->0.,IncludeSettlDate->True,SettlementDate:>EvaluationDate[],NpvDate:>EvaluationDate[]} 
Options[LegNPVFromZSpread] = {DayCounter->"Actual/365 (Fixed)",Compounding->"Continuous",Frequency->0.,IncludeSettlDate->True,SettlementDate:>EvaluationDate[],NpvDate:>EvaluationDate[]} 
Options[LegNextCashFlowAmount] = {IncludeSettlDate->True,SettlementDate:>EvaluationDate[]} 
Options[LegNextCashFlowDate] = {IncludeSettlDate->True,SettlementDate:>EvaluationDate[]} 
Options[LegNextCouponRate] = {IncludeSettlDate->True,SettlementDate:>EvaluationDate[]} 
Options[LegPreviousCashFlowAmount] = {IncludeSettlDate->True,SettlementDate:>EvaluationDate[]} 
Options[LegPreviousCashFlowDate] = {IncludeSettlDate->True,SettlementDate:>EvaluationDate[]} 
Options[LegPreviousCouponRate] = {IncludeSettlDate->True,SettlementDate:>EvaluationDate[]} 
Options[LegReferencePeriodEnd] = {IncludeSettlDate->True,SettlementDate:>EvaluationDate[]} 
Options[LegReferencePeriodStart] = {IncludeSettlDate->True,SettlementDate:>EvaluationDate[]} 
Options[LegSetCouponPricers] = {} 
Options[LegStartDate] = {} 
Options[LegYield] = {DayCounter->"Actual/365 (Fixed)",Compounding->"Continuous",Frequency->0.,IncludeSettlDate->True,SettlementDate:>EvaluationDate[],NpvDate:>EvaluationDate[],Accuracy->1.*^-12,MaxIterations->5000,Guess->0.} 
Options[LegYieldValueBasisPoint] = {DayCounter->"Actual/365 (Fixed)",Compounding->"Continuous",Frequency->0.,IncludeSettlDate->True,SettlementDate:>EvaluationDate[],NpvDate:>EvaluationDate[]} 
Options[LegZSpread] = {DayCounter->"Actual/365 (Fixed)",Compounding->"Continuous",Frequency->0.,IncludeSettlDate->True,SettlementDate:>EvaluationDate[],NpvDate:>EvaluationDate[],Accuracy->1.*^-12,MaxIterations->5000,Guess->0.} 
Options[MultiPhaseLeg] = {ToBeSorted->True,Permanent->True,Overwrite->True} 

 (* Market Model Evolvers *)
Options[ForwardRateIpc] = {Permanent->True,Overwrite->True} 
Options[ForwardRateNormalPc] = {Permanent->True,Overwrite->True} 
Options[ForwardRatePc] = {Permanent->True,Overwrite->True} 
Options[MarketModelEvolverAdvanceStep] = {} 
Options[MarketModelEvolverCurrentStep] = {} 
Options[MarketModelEvolverNumeraires] = {} 
Options[MarketModelEvolverStartNewPath] = {} 

 (* MarketModels *)
Options[AbcdVol] = {Permanent->True,Overwrite->True} 
Options[QLAnnuity] = {NumeraireIndex->0.} 
Options[CmSwapForwardJacobian] = {} 
Options[CmSwapZedMatrix] = {Displacement->0.} 
Options[CoinitialSwapForwardJacobian] = {} 
Options[CoinitialSwapZedMatrix] = {Displacement->0.} 
Options[CotSwapToFwdAdapter] = {Permanent->True,Overwrite->True} 
Options[CoterminalSwapForwardJacobian] = {} 
Options[CoterminalSwapZedMatrix] = {Displacement->0.} 
Options[FlatVol] = {Permanent->True,Overwrite->True} 
Options[FlatVolFactory] = {Displacement->0.,Permanent->True,Overwrite->True} 
Options[FwdPeriodAdapter] = {Permanent->True,Overwrite->True} 
Options[FwdToCotSwapAdapter] = {Permanent->True,Overwrite->True} 
Options[MarketModelCovariance] = {} 
Options[MarketModelDisplacements] = {} 
Options[MarketModelInitialRates] = {} 
Options[MarketModelNumberOfFactors] = {} 
Options[MarketModelNumberOfRates] = {} 
Options[MarketModelNumberOfSteps] = {} 
Options[MarketModelPseudoRoot] = {} 
Options[MarketModelTimeDependentVolatility] = {} 
Options[MarketModelTotalCovariance] = {} 
Options[PseudoRootFacade] = {Permanent->True,Overwrite->True} 
Options[RateInstVolDifferences] = {} 
Options[RateVolDifferences] = {} 
Options[SwapDerivative] = {FwdRateIndex->0.} 

 (* Math *)
Options[CholeskyDecomposition] = {Flexible->True} 
Options[CovarianceDecomposition] = {Tolerance->0.,Permanent->True,Overwrite->True} 
Options[CovarianceDecompositionCorrelationMatrix] = {} 
Options[CovarianceDecompositionStandardDeviations] = {} 
Options[CovarianceDecompositionVariances] = {} 
Options[GetCovariance] = {Tolerance->0.} 
Options[NormDist] = {Mean->0.,StandardDev->0.,Cumulative->True} 
Options[NormInv] = {Mean->0.,StandardDev->0.} 
Options[NormSDist] = {} 
Options[NormSInv] = {} 
Options[PrimeNumber] = {} 
Options[PseudoSqrt] = {} 
Options[RankReducedSqrt] = {} 
Options[SymmetricSchurDecomposition] = {Permanent->True,Overwrite->True} 
Options[SymmetricSchurDecompositionEigenvalues] = {} 
Options[SymmetricSchurDecompositionEigenvectors] = {} 

 (* Optimization *)
Options[ArmijoLineSearch] = {Epsilon->1.*^-8,Alpha->0.05,Beta->0.65,Permanent->True,Overwrite->True} 
Options[ConjugateGradient] = {LineSearch->0.,Permanent->True,Overwrite->True} 
Options[EndCriteria] = {Permanent->True,Overwrite->True} 
Options[EndCriteriaFunctionEpsilon] = {} 
Options[EndCriteriaGradientNormEpsilon] = {} 
Options[EndCriteriaMaxIterations] = {} 
Options[EndCriteriaMaxStationaryStateIterations] = {} 
Options[LevenbergMarquardt] = {Epsfcn->1.*^-8,Xtol->1.*^-8,Gtol->1.*^-8,Permanent->True,Overwrite->True} 
Options[SecondsToString] = {} 
Options[Simplex] = {Permanent->True,Overwrite->True} 
Options[SphereCylinderOptimizerClosest] = {} 
Options[SteepestDescent] = {LineSearch->0.,Permanent->True,Overwrite->True} 

 (* Options *)
Options[BarrierOption] = {Permanent->True,Overwrite->True} 
Options[CaAsianOption] = {Permanent->True,Overwrite->True} 
Options[DaAsianOption] = {Permanent->True,Overwrite->True} 
Options[Delta] = {} 
Options[DeltaForward] = {} 
Options[DividendRho] = {} 
Options[DividendVanillaOption] = {Permanent->True,Overwrite->True} 
Options[Elasticity] = {} 
Options[EuropeanOption] = {Permanent->True,Overwrite->True} 
Options[ForwardVanillaOption] = {Permanent->True,Overwrite->True} 
Options[QLGamma] = {} 
Options[ItmCashProbability] = {} 
Options[QuantoForwardVanillaOption] = {Permanent->True,Overwrite->True} 
Options[QuantoVanillaOption] = {Permanent->True,Overwrite->True} 
Options[Rho] = {} 
Options[Theta] = {} 
Options[ThetaPerDay] = {} 
Options[VanillaOption] = {Permanent->True,Overwrite->True} 
Options[Vega] = {} 

 (* Overnight Indexed Swap *)
Options[MakeDatedOIS] = {StartDate:>EvaluationDate[],EndDate:>EvaluationDate[],FixedRate->0.,FixDayCounter->"Actual/365 (Fixed)",Spread->0.,Permanent->True,Overwrite->True} 
Options[MakeOIS] = {FixedRate->0.,FixDayCounter->"Actual/365 (Fixed)",Spread->0.,Permanent->True,Overwrite->True} 
Options[OvernightIndexedSwap] = {PayerReceiver->0.,FixedRate->0.,FixDayCounter->"Actual/365 (Fixed)",Spread->0.,Permanent->True,Overwrite->True} 
Options[OvernightIndexedSwapFairRate] = {} 
Options[OvernightIndexedSwapFairSpread] = {} 
Options[OvernightIndexedSwapFixedDayCount] = {} 
Options[OvernightIndexedSwapFixedLegAnalysis] = {} 
Options[OvernightIndexedSwapFixedLegBPS] = {} 
Options[OvernightIndexedSwapFixedLegNPV] = {} 
Options[OvernightIndexedSwapFixedRate] = {} 
Options[OvernightIndexedSwapFromOISRateHelper] = {Permanent->True,Overwrite->True} 
Options[OvernightIndexedSwapNominal] = {} 
Options[OvernightIndexedSwapOvernightLegAnalysis] = {} 
Options[OvernightIndexedSwapOvernightLegBPS] = {} 
Options[OvernightIndexedSwapOvernightLegNPV] = {} 
Options[OvernightIndexedSwapSpread] = {} 
Options[OvernightIndexedSwapType] = {} 

 (* Payoffs *)
Options[DoubleStickyRatchetPayoff] = {Permanent->True,Overwrite->True} 
Options[PayoffDescription] = {} 
Options[PayoffName] = {} 
Options[PayoffOptionType] = {} 
Options[PayoffStrike] = {} 
Options[PayoffThirdParameter] = {} 
Options[PayoffValue] = {} 
Options[RatchetMaxPayoff] = {Permanent->True,Overwrite->True} 
Options[RatchetMinPayoff] = {Permanent->True,Overwrite->True} 
Options[RatchetPayoff] = {Permanent->True,Overwrite->True} 
Options[StickyMaxPayoff] = {Permanent->True,Overwrite->True} 
Options[StickyMinPayoff] = {Permanent->True,Overwrite->True} 
Options[StickyPayoff] = {Permanent->True,Overwrite->True} 
Options[StrikedTypePayoff] = {ThirdParameter->1.,Permanent->True,Overwrite->True} 
Options[PlainVanillaPayoff] = {Permanent->True,Overwrite->True} 

 (* Piecewise Yield Curves *)
Options[PiecewiseYieldCurve] = {SettlementDays->2,Calendar->"Target",DayCounter->"Actual/365 (Fixed)",Accuracy->1.*^-12,TraitsID->"Discount",InterpolatorID->"LogLinear",Permanent->True,Overwrite->True} 
Options[PiecewiseYieldCurveData] = {} 
Options[PiecewiseYieldCurveDates] = {} 
Options[PiecewiseYieldCurveJumpDates] = {} 
Options[PiecewiseYieldCurveJumpTimes] = {} 
Options[PiecewiseYieldCurveTimes] = {} 

Options[ShortRateModelYieldCurve] = {DayCounter->"Actual/Actual",Permanent->True,Overwrite->True} 

 (* Prices *)
Options[MidEquivalent] = {Bid->0.,Ask->0.,Last->0.,Close->0.} 
Options[MidSafe] = {Bid->0.,Ask->0.} 

 (* Pricing Engines *)
Get[ToFileName["QuantLib","QLPricingEnginesOptions.m"]]

 (* Processes *)
Options[GeneralizedBlackScholesProcess] = {DayCounter->"Actual/365 (Fixed)",Permanent->True,Overwrite->True} 
Options[BlackScholesProcess] = {Permanent->True,Overwrite->True} 
Options[BlackScholesMertonProcess] = {Permanent->True,Overwrite->True} 
Options[BlackProcess] = {Permanent->True,Overwrite->True} 
Options[GarmanKohlagenProcess] = {Permanent->True,Overwrite->True} 

 (* Products *)
Options[MarketModelMultiProductComposite] = {Permanent->True,Overwrite->True} 
Options[MarketModelMultiProductCompositeAdd] = {} 
Options[MarketModelMultiProductCompositeFinalize] = {} 
Options[MarketModelMultiProductMaxNumberOfCashFlowsPerProductPerStep] = {} 
Options[MarketModelMultiProductNumberOfProducts] = {} 
Options[MarketModelMultiProductPossibleCashFlowTimes] = {} 
Options[MarketModelMultiProductSuggestedNumeraires] = {} 
Options[MarketModelMultiStepRatchet] = {Permanent->True,Overwrite->True} 
Options[MarketModelOneStepForwards] = {Permanent->True,Overwrite->True} 
Options[MarketModelOneStepOptionlets] = {Permanent->True,Overwrite->True} 

 (* Quotes *)
Options[BucketAnalysis] = {Shift->0.,SensitivityAnalysis->0.} 
Options[BucketAnalysisDelta] = {Shift->0.,SensitivityAnalysis->0.} 
Options[BucketAnalysisDelta2] = {Shift->0.,SensitivityAnalysis->0.} 
Options[CompositeQuote] = {Permanent->True,Overwrite->True} 
Options[EurodollarFuturesImpliedStdDevQuote] = {Guess->0.,Accuracy->1.*^-12,Permanent->True,Overwrite->True} 
Options[ForwardSwapQuote] = {Permanent->True,Overwrite->True} 
Options[ForwardValueQuote] = {Permanent->True,Overwrite->True} 
Options[FuturesConvAdjustmentQuote] = {Permanent->True,Overwrite->True} 
Options[FuturesConvAdjustmentQuoteFuturesValue] = {} 
Options[FuturesConvAdjustmentQuoteImmDate] = {} 
Options[FuturesConvAdjustmentQuoteMeanReversion] = {} 
Options[FuturesConvAdjustmentQuoteVolatility] = {} 
Options[ImpliedStdDevQuote] = {Guess->0.,Accuracy->1.*^-12,Permanent->True,Overwrite->True} 
Options[LastFixingQuote] = {Permanent->True,Overwrite->True} 
Options[LastFixingQuoteReferenceDate] = {} 
Options[QuoteIsValid] = {} 
Options[QuoteValue] = {} 
Options[RelinkableHandleQuote] = {CurrentLink->0.,Permanent->True,Overwrite->True} 
Options[SimpleQuote] = {TickValue->0.001,Permanent->True,Overwrite->True} 
Options[SimpleQuoteReset] = {} 
Options[SimpleQuoteSetTickValue] = {} 
Options[SimpleQuoteSetValue] = {Value->0.} 
Options[SimpleQuoteTickValue] = {} 

 (* Random Sequence Generator *)
Options[FaureRsg] = {Permanent->True,Overwrite->True} 
Options[HaltonRsg] = {Permanent->True,Overwrite->True} 
Options[MersenneTwisterRsg] = {Permanent->True,Overwrite->True} 
Options[Rand] = {} 
Options[Randomize] = {} 
Options[SobolRsg] = {Permanent->True,Overwrite->True} 
Options[Variates] = {} 

 (* Range Accrual *)
Options[RangeAccrualFloatersCoupon] = {DayCountID->"Actual/365 (Fixed)",Permanent->True,Overwrite->True} 
Options[RangeAccrualFloatersCouponEndDate] = {} 
Options[RangeAccrualFloatersCouponFromLeg] = {Permanent->True,Overwrite->True} 
Options[RangeAccrualFloatersCouponObservationDates] = {} 
Options[RangeAccrualFloatersCouponObservationsNo] = {} 
Options[RangeAccrualFloatersCouponSetPricer] = {} 
Options[RangeAccrualFloatersCouponStarDate] = {} 
Options[RangeAccrualFloatersPrice] = {} 
Options[RangeAccrualPricerByBgm] = {Permanent->True,Overwrite->True} 
Options[SimpleFloaterPrice] = {} 

 (* RateHelper *)
Options[BondHelper] = {Permanent->True,Overwrite->True} 
Options[DatedOISRateHelper] = {Permanent->True,Overwrite->True} 
Options[DepositRateHelper] = {FixingDays->2,Calendar->"Target",DayCounter->"Actual/365 (Fixed)",BusinessDayConvention->"Following",EndOfMonth->True,Permanent->True,Overwrite->True} 
Options[FixedRateBondHelper] = {FaceAmount->100.,DayCounter->"Actual/365 (Fixed)",PaymentBDC->"Following",Redemption->100.,IssueDate:>EvaluationDate[],Permanent->True,Overwrite->True} 
Options[FraRateHelper] = {FixingDays->2,Calendar->"Target",DayCounter->"Actual/365 (Fixed)",BusinessDayConvention->"Following",EndOfMonth->True,Permanent->True,Overwrite->True} 
Options[FuturesRateHelper] = {Calendar->"Target",DayCounter->"Actual/365 (Fixed)",BusinessDayConvention->"Following",EndOfMonth->True,ConvexityAdjQuote->0.0,Permanent->True,Overwrite->True} 
Options[FuturesRateHelperConvexityAdjustment] = {} 
Options[OISRateHelper] = {Permanent->True,Overwrite->True} 
Options[RateHelperEarliestDate] = {} 
Options[RateHelperImpliedQuote] = {} 
Options[RateHelperLatestDate] = {} 
Options[RateHelperQuoteError] = {} 
Options[RateHelperQuoteIsValid] = {} 
Options[RateHelperQuoteValue] = {} 
Options[RateHelperRate] = {} 
Options[RateHelperSelection] = {FutureRollDays->0,DepoInclusion->0.} 
Options[SwapRateHelper] = {Calendar->"Target",FixedLegDayCounter->"Actual/365 (Fixed)",DiscountingCurve->None,FixedLegConvention->"Following",Spread->0.0,ForwardStart->"0D",Permanent->True,Overwrite->True} 
Options[SwapRateHelperForwardStart] = {} 
Options[SwapRateHelperSpread] = {} 

 (* Schedules *)
Options[Schedule] = {EffectiveDate:>EvaluationDate[],Calendar->"Target",
         BusinessDayConvention->"Unadjusted",TermDateConv->"Unadjusted",GenRule->"Backward",EndOfMonth->True,FirstDate->Automatic,NextToLastDate->Automatic,Permanent->True,Overwrite->True} 
Options[ScheduleBDC] = {} 
Options[ScheduleCalendar] = {} 
Options[ScheduleDates] = {} 
Options[ScheduleEmpty] = {} 
Options[ScheduleEndDate] = {} 
Options[ScheduleEndOfMonth] = {} 
Options[ScheduleIsRegular] = {Index->1} 
Options[ScheduleNextDate] = {RefDate:>EvaluationDate[]} 
Options[SchedulePreviousDate] = {RefDate:>EvaluationDate[]} 
Options[ScheduleRule] = {} 
Options[ScheduleSize] = {} 
Options[ScheduleStartDate] = {} 
Options[ScheduleTenor] = {} 
Options[ScheduleTerminationDateBDC] = {}
 
Options[Callability] ={PriceType ->"Clean",Permanent->True,Overwrite->True}
Options[CallabilitySchedule] ={PriceType ->"Clean",Permanent->True,Overwrite->True}

 (* SequenceStatistics *)
Options[SequenceStatistics] = {Dimension->0.,Permanent->True,Overwrite->True} 
Options[SequenceStatistics2] = {Dimension->0.,Permanent->True,Overwrite->True} 
Options[SequenceStatisticsAverageShortfall] = {} 
Options[SequenceStatisticsCorrelation] = {} 
Options[SequenceStatisticsCovariance] = {} 
Options[SequenceStatisticsDownsideDeviation] = {} 
Options[SequenceStatisticsDownsideVariance] = {} 
Options[SequenceStatisticsErrorEstimate] = {} 
Options[SequenceStatisticsGaussianAverageShortfall] = {} 
Options[SequenceStatisticsGaussianPercentile] = {} 
Options[SequenceStatisticsGaussianPotentialUpside] = {} 
Options[SequenceStatisticsGaussianShortfall] = {} 
Options[SequenceStatisticsGaussianValueAtRisk] = {} 
Options[SequenceStatisticsInc] = {Dimension->0.,Permanent->True,Overwrite->True} 
Options[SequenceStatisticsInc2] = {Dimension->0.,Permanent->True,Overwrite->True} 
Options[SequenceStatisticsKurtosis] = {} 
Options[SequenceStatisticsMax] = {} 
Options[SequenceStatisticsMean] = {} 
Options[SequenceStatisticsMin] = {} 
Options[SequenceStatisticsPercentile] = {} 
Options[SequenceStatisticsPotentialUpside] = {} 
Options[SequenceStatisticsRegret] = {} 
Options[SequenceStatisticsSamples] = {} 
Options[SequenceStatisticsSemiDeviation] = {} 
Options[SequenceStatisticsSemiVariance] = {} 
Options[SequenceStatisticsShortfall] = {} 
Options[SequenceStatisticsSize] = {} 
Options[SequenceStatisticsSkewness] = {} 
Options[SequenceStatisticsStandardDeviation] = {} 
Options[SequenceStatisticsValueAtRisk] = {} 
Options[SequenceStatisticsVariance] = {} 
Options[SequenceStatisticsWeightSum] = {} 

 (* Settings *)
Options[SettingsEvaluationDate] = {} 
Options[SettingsSetEvaluationDate] = {} 

 (* Short Rate Models *)
Options[FuturesConvexityBias] = {A->0.} 
Options[HullWhite] = {Permanent->True,Overwrite->True} 
Options[Vasicek] = {Permanent->True,Overwrite->True} 
Options[BlackKarasinski] = {Permanent->True,Overwrite->True} 
Options[G2] = {Permanent->True,Overwrite->True} 
Options[ExtendedCoxIngersollRoss]= {Permanent->True,Overwrite->True} 
Options[CoxIngersollRoss] = {Permanent->True,Overwrite->True} 
(* CalibratedModel *)
Options[CalibrateModel] = {OptimizerId->Automatic,MaxIterations->1000,MaxStationaryStateIterations->200,RootEpsilon->1.*^-8,FunctionEpsilon->1.*^-8,GradientNormEpsilon->1.*^-8}

 (* Smile Section Structures *)
Options[FlatSmileSection] = {DayCounter->"Actual/365 (Fixed)",Permanent->True,Overwrite->True} 
Options[InterpolatedSmileSection] = {DayCounter->"Actual/365 (Fixed)",Permanent->True,Overwrite->True} 
Options[SabrInterpolatedSmileSection] = {Alpha->0.,Beta->0.,Nu->0.,Rho->0.,AlphaIsFixed->True,BetaIsFixed->True,NuIsFixed->True,RhoIsFixed->True,VegaWeighted->True,EndCriteria->0.,Method->0.,DayCounter->"Actual/365 (Fixed)",Permanent->True,Overwrite->True} 
Options[SabrInterpolatedSmileSection1] = {Alpha->0.,Beta->0.,Nu->0.,Rho->0.,AlphaIsFixed->True,BetaIsFixed->True,NuIsFixed->True,RhoIsFixed->True,VegaWeighted->True,EndCriteria->0.,Method->0.,DayCounter->"Actual/365 (Fixed)",Permanent->True,Overwrite->True} 
Options[SabrInterpolatedSmileSectionAlpha] = {} 
Options[SabrInterpolatedSmileSectionBeta] = {} 
Options[SabrInterpolatedSmileSectionEndCriteria] = {} 
Options[SabrInterpolatedSmileSectionError] = {} 
Options[SabrInterpolatedSmileSectionMaxError] = {} 
Options[SabrInterpolatedSmileSectionNu] = {} 
Options[SabrInterpolatedSmileSectionRho] = {} 
Options[SabrSmileSection] = {Alpha->0.,Beta->0.,Nu->0.,Rho->0.,AlphaIsFixed->True,BetaIsFixed->True,NuIsFixed->True,RhoIsFixed->True,VegaWeighted->True,EndCriteria->0.,Method->0.,Permanent->True,Overwrite->True} 
Options[SmileSectionAtmLevel] = {} 
Options[SmileSectionDayCounter] = {} 
Options[SmileSectionExerciseDate] = {} 
Options[SmileSectionFromSabrVolSurface] = {Permanent->True,Overwrite->True} 
Options[SmileSectionVariance] = {Strike->0.} 
Options[SmileSectionVolatility] = {Strike->0.} 

 (* Statistics *)
Options[GaussianAverageShortfall] = {Mean->0.,StdDev->0.} 
Options[GaussianDownsideDeviation] = {Mean->0.,StdDev->0.} 
Options[GaussianDownsideVariance] = {Mean->0.,StdDev->0.} 
Options[GaussianExpectedShortfall] = {Mean->0.,StdDev->0.} 
Options[GaussianPercentile] = {Mean->0.,StdDev->0.} 
Options[GaussianPotentialUpside] = {Mean->0.,StdDev->0.} 
Options[GaussianRegret] = {Mean->0.,StdDev->0.} 
Options[GaussianShortfall] = {Mean->0.,StdDev->0.} 
Options[GaussianTopPercentile] = {Mean->0.,StdDev->0.} 
Options[GaussianValueAtRisk] = {Mean->0.,StdDev->0.} 
Options[IncrementalStatistics] = {Permanent->True,Overwrite->True} 
Options[Statistics] = {Permanent->True,Overwrite->True} 
Options[StatisticsAverageShortfall] = {} 
Options[StatisticsDownsideDeviation] = {} 
Options[StatisticsDownsideVariance] = {} 
Options[StatisticsErrorEstimate] = {} 
Options[StatisticsExpectedShortfall] = {} 
Options[StatisticsGaussianAverageShortfall] = {} 
Options[StatisticsGaussianDownsideDeviation] = {} 
Options[StatisticsGaussianDownsideVariance] = {} 
Options[StatisticsGaussianExpectedShortfall] = {} 
Options[StatisticsGaussianPercentile] = {} 
Options[StatisticsGaussianPotentialUpside] = {} 
Options[StatisticsGaussianRegret] = {} 
Options[StatisticsGaussianShortfall] = {} 
Options[StatisticsGaussianTopPercentile] = {} 
Options[StatisticsGaussianValueAtRisk] = {} 
Options[StatisticsKurtosis] = {} 
Options[StatisticsMax] = {} 
Options[StatisticsMean] = {} 
Options[StatisticsMin] = {} 
Options[StatisticsPercentile] = {} 
Options[StatisticsPotentialUpside] = {} 
Options[StatisticsRegret] = {} 
Options[StatisticsSamples] = {} 
Options[StatisticsSemiDeviation] = {} 
Options[StatisticsSemiVariance] = {} 
Options[StatisticsShortfall] = {} 
Options[StatisticsSkewness] = {} 
Options[StatisticsStandardDeviation] = {} 
Options[StatisticsTopPercentile] = {} 
Options[StatisticsValueAtRisk] = {} 
Options[StatisticsVariance] = {} 
Options[StatisticsWeightSum] = {} 

 (* Swap *)
Options[MakeCms] = {IborSpread->0.,Permanent->True,Overwrite->True} 
Options[Swap] = {Permanent->True,Overwrite->True} 
Options[SwapLegAnalysis] = {} 
Options[SwapLegBPS] = {} 
Options[SwapLegNPV] = {} 
Options[SwapMaturityDate] = {} 
Options[SwapStartDate] = {} 

 (* Swaption *)
Options[MakeSwaption] = {Strike->Automatic,Permanent->True,Overwrite->True} 
Options[Swaption] = {SettlementType->"Physical",Permanent->True,Overwrite->True} 
Options[SwaptionImpliedVolatility] = {Guess->0.1,Accuracy->1.*^-12,MaxIter->1000} 
Options[SwaptionSettlementType] = {} 
Options[SwaptionType] = {} 

 (* Swaption Volatility Term Structures *)
Options[ConstantSwaptionVolatility] = {NDays->0,Calendar->"Target",DayCounter->"Actual/365 (Fixed)",BusinessDayConvention->"Following",Permanent->True,Overwrite->True} 
Options[DenseSabrParameters] = {} 
Options[MarketVolCube] = {} 
Options[RelinkableHandleSwaptionVolatilityStructure] = {CurrentLink->0.,Permanent->True,Overwrite->True} 
Options[SmileSectionByCube] = {Permanent->True,Overwrite->True} 
Options[SmileSectionByCube2] = {Permanent->True,Overwrite->True} 
Options[SparseSabrParameters] = {} 
Options[SpreadedSwaptionVolatility] = {Permanent->True,Overwrite->True} 
Options[SwaptionVTSBlackVariance] = {AllowExtrapolation->True} 
Options[SwaptionVTSBlackVariance2] = {AllowExtrapolation->True} 
Options[SwaptionVTSBusinessDayConvention] = {} 
Options[SwaptionVTSMatrix] = {Calendar->"Target",DayCounter->"Actual/365 (Fixed)",Permanent->True,Overwrite->True} 
Options[SwaptionVTSMatrixLocate] = {} 
Options[SwaptionVTSMatrixOptionDates] = {} 
Options[SwaptionVTSMatrixOptionTenors] = {} 
Options[SwaptionVTSMatrixSwapTenors] = {} 
Options[SwaptionVTSMaxSwapTenor] = {} 
Options[SwaptionVTSOptionDateFromTenor] = {} 
Options[SwaptionVTSSwapLength] = {} 
Options[SwaptionVTSSwapLength2] = {} 
Options[SwaptionVTSVolatility] = {AllowExtrapolation->True} 
Options[SwaptionVTSVolatility2] = {AllowExtrapolation->True} 
Options[SwaptionVTSatmStrike] = {} 
Options[SwaptionVTSatmStrike2] = {} 
Options[SwaptionVolCube1] = {VegaWeightedSmileFit->True,EndCriteria->0.,MaxErrorTol->0.,OptMethod->0.,Permanent->True,Overwrite->True} 
Options[SwaptionVolCube2] = {VegaWeightedSmileFit->True,Permanent->True,Overwrite->True} 
Options[VolCubeAtmCalibrated] = {} 

 (* Yield Term Structures *)
Options[DiscountCurve] = {DayCounter->"Actual/365 (Fixed)",Permanent->True,Overwrite->True} 
Options[FlatForward] = {NDays->0,Calendar->"Target",DayCounter->"Actual/365 (Fixed)",Compounding->"Continuous",Frequency->"Annual",Permanent->True,Overwrite->True} 
Options[ForwardCurve] = {DayCounter->"Actual/365 (Fixed)",Permanent->True,Overwrite->True} 
Options[ForwardSpreadedTermStructure] = {Permanent->True,Overwrite->True} 
Options[ImpliedTermStructure] = {Permanent->True,Overwrite->True} 
Options[InterpolatedYieldCurve] = {Calendar->"Target",DayCounter->"Actual/365 (Fixed)",TraitsID->"Discount",InterpolatorID->"MonotonicLogCubicNaturalSpline",Permanent->True,Overwrite->True} 
Options[InterpolatedYieldCurveData] = {} 
Options[InterpolatedYieldCurveDates] = {} 
Options[InterpolatedYieldCurveJumpDates] = {} 
Options[InterpolatedYieldCurveJumpTimes] = {} 
Options[InterpolatedYieldCurveTimes] = {} 
Options[RelinkableHandleYieldTermStructure] = {CurrentLink->"",Permanent->True,Overwrite->True} 
Options[TermStructureCalendar] = {} 
Options[TermStructureDayCounter] = {} 
Options[TermStructureMaxDate] = {} 
Options[TermStructureReferenceDate] = {} 
Options[TermStructureSettlementDays] = {} 
Options[TermStructureTimeFromReference] = {} 
Options[YieldTSDiscount] = {AllowExtrapolation->True} 
Options[YieldTSForwardRate] = {DayCounter->"Actual/365 (Fixed)",Compounding->"Continuous",Frequency->"Annual",AllowExtrapolation->True} 
Options[YieldTSForwardRate2] = {DayCounter->"Actual/365 (Fixed)",Compounding->"Continuous",Frequency->"Annual",AllowExtrapolation->True} 
Options[YieldTSZeroRate] = {DayCounter->"Actual/365 (Fixed)",Compounding->"Continuous",Frequency->"Annual",AllowExtrapolation->True} 
Options[ZeroCurve] = {DayCounter->"Actual/365 (Fixed)",Permanent->True,Overwrite->True} 

 (* TimeGrid *)
Options[TimeGrid] = {Permanent->True,Overwrite->True} 

 (* TimeSeries *)
Options[TimeSeries] = {Permanent->True,Overwrite->True} 
Options[TimeSeriesDates] = {} 
Options[TimeSeriesEmpty] = {} 
Options[TimeSeriesFirstDate] = {} 
Options[TimeSeriesFromIndex] = {Permanent->True,Overwrite->True} 
Options[TimeSeriesLastDate] = {} 
Options[TimeSeriesSize] = {} 
Options[TimeSeriesValue] = {} 
Options[TimeSeriesValues] = {} 

 (* Utilities *)
Options[QLVersion] = {} 

 (* Vanilla Swap *)
Options[MakeIMMSwap] = {FixedRate->0.,FirstImmDate:>EvaluationDate[],FixDayCounter->"Actual/365 (Fixed)",Spread->0.,Permanent->True,Overwrite->True} 
Options[MakeVanillaSwap] = {FixedRate->0.,FixDayCounter->"Actual/365 (Fixed)",Spread->0.,Permanent->True,Overwrite->True} 
Options[VanillaSwap] = {FixedLegDayCounter->"Actual/365 (Fixed)",Spread->0.,FloatingLegDayCounter->Automatic,PaymentConvention->"Following",Permanent->True,Overwrite->True} 
Options[VanillaSwapFairRate] = {} 
Options[VanillaSwapFairSpread] = {} 
Options[VanillaSwapFixedDayCount] = {} 
Options[VanillaSwapFixedLegAnalysis] = {} 
Options[VanillaSwapFixedLegBPS] = {} 
Options[VanillaSwapFixedLegNPV] = {} 
Options[VanillaSwapFixedRate] = {} 
Options[VanillaSwapFloatingDayCount] = {} 
Options[VanillaSwapFloatingLegAnalysis] = {} 
Options[VanillaSwapFloatingLegBPS] = {} 
Options[VanillaSwapFloatingLegNPV] = {} 
Options[VanillaSwapFromSwapIndex] = {Permanent->True,Overwrite->True} 
Options[VanillaSwapFromSwapRateHelper] = {Permanent->True,Overwrite->True} 
Options[VanillaSwapNominal] = {} 
Options[VanillaSwapPaymentConvention] = {} 
Options[VanillaSwapSpread] = {} 
Options[VanillaSwapType] = {} 

 (* Volatilities *)
Options[AbcdAtmVolCurve] = {Calendar->"Target",DayCounter->"Actual/365 (Fixed)",Permanent->True,Overwrite->True} 
Options[AtmCurve] = {} 
Options[BlackAtmVolCurveAtmVariance] = {AllowExtrapolation->True} 
Options[BlackAtmVolCurveAtmVariance2] = {AllowExtrapolation->True} 
Options[BlackAtmVolCurveAtmVariance3] = {AllowExtrapolation->True} 
Options[BlackAtmVolCurveAtmVol] = {AllowExtrapolation->True} 
Options[BlackAtmVolCurveAtmVol2] = {AllowExtrapolation->True} 
Options[BlackAtmVolCurveAtmVol3] = {AllowExtrapolation->True} 
Options[BlackConstantVol] = {SettlementDays->2,Calendar->"Target",DayCounter->"Actual/365 (Fixed)",Permanent->True,Overwrite->True} 
Options[BlackVarianceSurface] = {Calendar->"Target",DayCounter->"Actual/365 (Fixed)",Permanent->True,Overwrite->True} 
Options[BlackVolTermStructureBlackForwardVariance] = {AllowExtrapolation->True} 
Options[BlackVolTermStructureBlackForwardVol] = {AllowExtrapolation->True} 
Options[BlackVolTermStructureBlackVariance] = {AllowExtrapolation->True} 
Options[BlackVolTermStructureBlackVol] = {AllowExtrapolation->True} 
Options[SabrVolSurface] = {Permanent->True,Overwrite->True} 
Options[SabrVolatility] = {} 
Options[VolatilitySpreads] = {} 
Options[VolatilitySpreads2] = {} 
Options[VolatilityTermStructureBusinessDayConvention] = {} 
Options[VolatilityTermStructureMaxStrike] = {} 
Options[VolatilityTermStructureMinStrike] = {} 
Options[VolatilityTermStructureOptionDateFromTenor] = {} 

 (* Market Model Volatility *) 
Options[MarketModelLmExtLinearExponentialVolModel] = {Permanent->True,Overwrite->True} 
Options[PiecewiseConstantAbcdVariance] = {A->0.,B->0.,C->0.,D->0.,Permanent->True,Overwrite->True} 
Options[PiecewiseConstantVarianceRateTimes] = {} 
Options[PiecewiseConstantVarianceTotalVariance] = {} 
Options[PiecewiseConstantVarianceTotalVolatility] = {} 
Options[PiecewiseConstantVarianceVariance] = {} 
Options[PiecewiseConstantVarianceVariances] = {} 
Options[PiecewiseConstantVarianceVolatilities] = {} 
Options[PiecewiseConstantVarianceVolatility] = {} 


(* Error messages *)

QuantLibError::msg = "Error: `1` `2`"

