
    (* Pricing Engines *)


AnalyticCapFloorEngine[HandleModel_Symbol,opts___?OptionQ] := qlAnalyticCapFloorEngine[Unique["AnalyticCapFloorEngine"],HandleModel,Permanent,Overwrite] /. {opts} /. Options[AnalyticCapFloorEngine]
AnalyticCapFloorEngine[ObjectId_Symbol,HandleModel_Symbol,opts___?OptionQ] := qlAnalyticCapFloorEngine[ObjectId,HandleModel,Permanent,Overwrite] /. {opts} /. Options[AnalyticCapFloorEngine]
QLConstructor[AnalyticCapFloorEngine]^=True
SyntaxInformation[AnalyticCapFloorEngine] = {"ArgumentsPattern" -> {_.,OptionsPattern[]}} 
AnalyticCapFloorEngine[___] := "never happens" /;Message[QuantLib::arg,"AnalyticCapFloorEngine"] 



BachelierBlackFormula[OptionType_String,Strike_?NumberQ,AtmForwardValue_?NumberQ,StdDev_?NumberQ,opts___?OptionQ] := qlBachelierBlackFormula[OptionType,Strike,AtmForwardValue,StdDev,Deflator] /. {opts} /. Options[BachelierBlackFormula]
QLProcedure[BachelierBlackFormula]^=True
BachelierBlackFormula[___] := "never happens" /;Message[QuantLib::arg,"BachelierBlackFormula"] 



BachelierBlackFormula2[Payoff_Symbol,AtmForwardValue_?NumberQ,StdDev_?NumberQ,opts___?OptionQ] := qlBachelierBlackFormula2[Payoff,AtmForwardValue,StdDev,Deflator] /. {opts} /. Options[BachelierBlackFormula2]
QLProcedure[BachelierBlackFormula2]^=True
BachelierBlackFormula2[___] := "never happens" /;Message[QuantLib::arg,"BachelierBlackFormula2"] 



BinomialPricingEngine[EngineID_String,ProcessID_Symbol,TimeSteps_Integer,opts___?OptionQ] := qlBinomialPricingEngine[Unique["BinomialPricingEngine"],EngineID,ProcessID,TimeSteps,Permanent,Overwrite] /. {opts} /. Options[BinomialPricingEngine]
BinomialPricingEngine[ObjectId_Symbol,EngineID_String,ProcessID_Symbol,TimeSteps_Integer,opts___?OptionQ] := qlBinomialPricingEngine[ObjectId,EngineID,ProcessID,TimeSteps,Permanent,Overwrite] /. {opts} /. Options[BinomialPricingEngine]
QLConstructor[BinomialPricingEngine]^=True
SyntaxInformation[BinomialPricingEngine] = {"ArgumentsPattern" -> {_,_,_.,OptionsPattern[]}} 
BinomialPricingEngine[___] := "never happens" /;Message[QuantLib::arg,"BinomialPricingEngine"] 


TreeCallableFixedRateBondEngine[HandleModel_Symbol,TimeSteps_Integer,opts___?OptionQ] := qlTreeCallableFixedRateBondEngine[Unique["TreeCallableFixedRateBondEngine"],HandleModel,TimeSteps,Permanent,Overwrite] /. Join[{opts}, Options[TreeCallableFixedRateBondEngine]]
TreeCallableFixedRateBondEngine[ObjectId_Symbol,HandleModel_Symbol,TimeSteps_Integer,opts___?OptionQ] := qlTreeCallableFixedRateBondEngine[ObjectId,HandleModel,TimeSteps,Permanent,Overwrite] /. Join[{opts},Options[TreeCallableFixedRateBondEngine]]
QLConstructor[TreeCallableFixedRateBondEngine]^=True
SyntaxInformation[TreeCallableFixedRateBondEngine] = {"ArgumentsPattern" -> {_.,OptionsPattern[]}} 
TreeCallableFixedRateBondEngine[___] := "never happens" /;Message[QuantLib::arg,"TreeCallableFixedRateBondEngine"] 


BlackCalculator[OptionType_String,Strike_?NumberQ,AtmForwardValue_?NumberQ,StdDev_?NumberQ,opts___?OptionQ] := qlBlackCalculator[Unique["BlackCalculator"],OptionType,Strike,AtmForwardValue,StdDev,Deflator,Permanent,Overwrite] /. {opts} /. Options[BlackCalculator]
BlackCalculator[ObjectId_Symbol,OptionType_String,Strike_?NumberQ,AtmForwardValue_?NumberQ,StdDev_?NumberQ,opts___?OptionQ] := qlBlackCalculator[ObjectId,OptionType,Strike,AtmForwardValue,StdDev,Deflator,Permanent,Overwrite] /. {opts} /. Options[BlackCalculator]
QLConstructor[BlackCalculator]^=True
SyntaxInformation[BlackCalculator] = {"ArgumentsPattern" -> {_,_,_,_.,OptionsPattern[]}} 
BlackCalculator[___] := "never happens" /;Message[QuantLib::arg,"BlackCalculator"] 



BlackCalculator2[PayoffID_Symbol,AtmForwardValue_?NumberQ,StdDev_?NumberQ,opts___?OptionQ] := qlBlackCalculator2[Unique["BlackCalculator2"],PayoffID,AtmForwardValue,StdDev,Deflator,Permanent,Overwrite] /. {opts} /. Options[BlackCalculator2]
BlackCalculator2[ObjectId_Symbol,PayoffID_Symbol,AtmForwardValue_?NumberQ,StdDev_?NumberQ,opts___?OptionQ] := qlBlackCalculator2[ObjectId,PayoffID,AtmForwardValue,StdDev,Deflator,Permanent,Overwrite] /. {opts} /. Options[BlackCalculator2]
QLConstructor[BlackCalculator2]^=True
SyntaxInformation[BlackCalculator2] = {"ArgumentsPattern" -> {_,_,_.,OptionsPattern[]}} 
BlackCalculator2[___] := "never happens" /;Message[QuantLib::arg,"BlackCalculator2"] 



BlackCalculatorAlpha[ObjectId_Symbol,opts___?OptionQ] := qlBlackCalculatorAlpha[ObjectId] /. {opts} /. Options[BlackCalculatorAlpha] 
QLMember[BlackCalculatorAlpha]^=True
QLType[BlackCalculatorAlpha]^="QuantLib::BlackCalculator"

BlackCalculatorAlpha[___] := "never happens" /;Message[QuantLib::arg,"BlackCalculatorAlpha"] 



BlackCalculatorBeta[ObjectId_Symbol,opts___?OptionQ] := qlBlackCalculatorBeta[ObjectId] /. {opts} /. Options[BlackCalculatorBeta] 
QLMember[BlackCalculatorBeta]^=True
QLType[BlackCalculatorBeta]^="QuantLib::BlackCalculator"

BlackCalculatorBeta[___] := "never happens" /;Message[QuantLib::arg,"BlackCalculatorBeta"] 



BlackCalculatorDelta[ObjectId_Symbol,Spot_?NumberQ,opts___?OptionQ] := qlBlackCalculatorDelta[ObjectId,Spot] /. {opts} /. Options[BlackCalculatorDelta] 
QLMember[BlackCalculatorDelta]^=True
QLType[BlackCalculatorDelta]^="QuantLib::BlackCalculator"

BlackCalculatorDelta[___] := "never happens" /;Message[QuantLib::arg,"BlackCalculatorDelta"] 



BlackCalculatorDeltaForward[ObjectId_Symbol,opts___?OptionQ] := qlBlackCalculatorDeltaForward[ObjectId] /. {opts} /. Options[BlackCalculatorDeltaForward] 
QLMember[BlackCalculatorDeltaForward]^=True
QLType[BlackCalculatorDeltaForward]^="QuantLib::BlackCalculator"

BlackCalculatorDeltaForward[___] := "never happens" /;Message[QuantLib::arg,"BlackCalculatorDeltaForward"] 



BlackCalculatorDividendRho[ObjectId_Symbol,TimeToMaturity_?NumberQ,opts___?OptionQ] := qlBlackCalculatorDividendRho[ObjectId,TimeToMaturity] /. {opts} /. Options[BlackCalculatorDividendRho] 
QLMember[BlackCalculatorDividendRho]^=True
QLType[BlackCalculatorDividendRho]^="QuantLib::BlackCalculator"

BlackCalculatorDividendRho[___] := "never happens" /;Message[QuantLib::arg,"BlackCalculatorDividendRho"] 



BlackCalculatorElasticity[ObjectId_Symbol,Spot_?NumberQ,opts___?OptionQ] := qlBlackCalculatorElasticity[ObjectId,Spot] /. {opts} /. Options[BlackCalculatorElasticity] 
QLMember[BlackCalculatorElasticity]^=True
QLType[BlackCalculatorElasticity]^="QuantLib::BlackCalculator"

BlackCalculatorElasticity[___] := "never happens" /;Message[QuantLib::arg,"BlackCalculatorElasticity"] 



BlackCalculatorElasticityForward[ObjectId_Symbol,opts___?OptionQ] := qlBlackCalculatorElasticityForward[ObjectId] /. {opts} /. Options[BlackCalculatorElasticityForward] 
QLMember[BlackCalculatorElasticityForward]^=True
QLType[BlackCalculatorElasticityForward]^="QuantLib::BlackCalculator"

BlackCalculatorElasticityForward[___] := "never happens" /;Message[QuantLib::arg,"BlackCalculatorElasticityForward"] 



BlackCalculatorGamma[ObjectId_Symbol,Spot_?NumberQ,opts___?OptionQ] := qlBlackCalculatorGamma[ObjectId,Spot] /. {opts} /. Options[BlackCalculatorGamma] 
QLMember[BlackCalculatorGamma]^=True
QLType[BlackCalculatorGamma]^="QuantLib::BlackCalculator"

BlackCalculatorGamma[___] := "never happens" /;Message[QuantLib::arg,"BlackCalculatorGamma"] 



BlackCalculatorGammaForward[ObjectId_Symbol,opts___?OptionQ] := qlBlackCalculatorGammaForward[ObjectId] /. {opts} /. Options[BlackCalculatorGammaForward] 
QLMember[BlackCalculatorGammaForward]^=True
QLType[BlackCalculatorGammaForward]^="QuantLib::BlackCalculator"

BlackCalculatorGammaForward[___] := "never happens" /;Message[QuantLib::arg,"BlackCalculatorGammaForward"] 



BlackCalculatorItmAssetProbability[ObjectId_Symbol,opts___?OptionQ] := qlBlackCalculatorItmAssetProbability[ObjectId] /. {opts} /. Options[BlackCalculatorItmAssetProbability] 
QLMember[BlackCalculatorItmAssetProbability]^=True
QLType[BlackCalculatorItmAssetProbability]^="QuantLib::BlackCalculator"

BlackCalculatorItmAssetProbability[___] := "never happens" /;Message[QuantLib::arg,"BlackCalculatorItmAssetProbability"] 



BlackCalculatorItmCashProbability[ObjectId_Symbol,opts___?OptionQ] := qlBlackCalculatorItmCashProbability[ObjectId] /. {opts} /. Options[BlackCalculatorItmCashProbability] 
QLMember[BlackCalculatorItmCashProbability]^=True
QLType[BlackCalculatorItmCashProbability]^="QuantLib::BlackCalculator"

BlackCalculatorItmCashProbability[___] := "never happens" /;Message[QuantLib::arg,"BlackCalculatorItmCashProbability"] 



BlackCalculatorRho[ObjectId_Symbol,TimeToMaturity_?NumberQ,opts___?OptionQ] := qlBlackCalculatorRho[ObjectId,TimeToMaturity] /. {opts} /. Options[BlackCalculatorRho] 
QLMember[BlackCalculatorRho]^=True
QLType[BlackCalculatorRho]^="QuantLib::BlackCalculator"

BlackCalculatorRho[___] := "never happens" /;Message[QuantLib::arg,"BlackCalculatorRho"] 



BlackCalculatorStrikeSensitivity[ObjectId_Symbol,opts___?OptionQ] := qlBlackCalculatorStrikeSensitivity[ObjectId] /. {opts} /. Options[BlackCalculatorStrikeSensitivity] 
QLMember[BlackCalculatorStrikeSensitivity]^=True
QLType[BlackCalculatorStrikeSensitivity]^="QuantLib::BlackCalculator"

BlackCalculatorStrikeSensitivity[___] := "never happens" /;Message[QuantLib::arg,"BlackCalculatorStrikeSensitivity"] 



BlackCalculatorTheta[ObjectId_Symbol,Spot_?NumberQ,TimeToMaturity_?NumberQ,opts___?OptionQ] := qlBlackCalculatorTheta[ObjectId,Spot,TimeToMaturity] /. {opts} /. Options[BlackCalculatorTheta] 
QLMember[BlackCalculatorTheta]^=True
QLType[BlackCalculatorTheta]^="QuantLib::BlackCalculator"

BlackCalculatorTheta[___] := "never happens" /;Message[QuantLib::arg,"BlackCalculatorTheta"] 



BlackCalculatorThetaPerDay[ObjectId_Symbol,Spot_?NumberQ,TimeToMaturity_?NumberQ,opts___?OptionQ] := qlBlackCalculatorThetaPerDay[ObjectId,Spot,TimeToMaturity] /. {opts} /. Options[BlackCalculatorThetaPerDay] 
QLMember[BlackCalculatorThetaPerDay]^=True
QLType[BlackCalculatorThetaPerDay]^="QuantLib::BlackCalculator"

BlackCalculatorThetaPerDay[___] := "never happens" /;Message[QuantLib::arg,"BlackCalculatorThetaPerDay"] 



BlackCalculatorValue[ObjectId_Symbol,opts___?OptionQ] := qlBlackCalculatorValue[ObjectId] /. {opts} /. Options[BlackCalculatorValue] 
QLMember[BlackCalculatorValue]^=True
QLType[BlackCalculatorValue]^="QuantLib::BlackCalculator"

BlackCalculatorValue[___] := "never happens" /;Message[QuantLib::arg,"BlackCalculatorValue"] 



BlackCalculatorVega[ObjectId_Symbol,TimeToMaturity_?NumberQ,opts___?OptionQ] := qlBlackCalculatorVega[ObjectId,TimeToMaturity] /. {opts} /. Options[BlackCalculatorVega] 
QLMember[BlackCalculatorVega]^=True
QLType[BlackCalculatorVega]^="QuantLib::BlackCalculator"

BlackCalculatorVega[___] := "never happens" /;Message[QuantLib::arg,"BlackCalculatorVega"] 



BlackCapFloorEngine[YieldCurve_Symbol,VolTS_Symbol,opts___?OptionQ] := qlBlackCapFloorEngine[Unique["BlackCapFloorEngine"],YieldCurve,VolTS,Permanent,Overwrite] /. {opts} /. Options[BlackCapFloorEngine]
BlackCapFloorEngine[ObjectId_Symbol,YieldCurve_Symbol,VolTS_Symbol,opts___?OptionQ] := qlBlackCapFloorEngine[ObjectId,YieldCurve,VolTS,Permanent,Overwrite] /. {opts} /. Options[BlackCapFloorEngine]
QLConstructor[BlackCapFloorEngine]^=True
SyntaxInformation[BlackCapFloorEngine] = {"ArgumentsPattern" -> {_,_.,OptionsPattern[]}} 
BlackCapFloorEngine[___] := "never happens" /;Message[QuantLib::arg,"BlackCapFloorEngine"] 



BlackCapFloorEngine2[YieldCurve_Symbol,Vol_,opts___?OptionQ] := qlBlackCapFloorEngine2[Unique["BlackCapFloorEngine2"],YieldCurve,Vol,DayCounter,Permanent,Overwrite] /. {opts} /. Options[BlackCapFloorEngine2]
BlackCapFloorEngine2[ObjectId_Symbol,YieldCurve_Symbol,Vol_,opts___?OptionQ] := qlBlackCapFloorEngine2[ObjectId,YieldCurve,Vol,DayCounter,Permanent,Overwrite] /. {opts} /. Options[BlackCapFloorEngine2]
QLConstructor[BlackCapFloorEngine2]^=True
SyntaxInformation[BlackCapFloorEngine2] = {"ArgumentsPattern" -> {_,_.,OptionsPattern[]}} 
BlackCapFloorEngine2[___] := "never happens" /;Message[QuantLib::arg,"BlackCapFloorEngine2"] 



BlackFormula[OptionType_String,Strike_?NumberQ,AtmForwardValue_?NumberQ,StdDev_?NumberQ,opts___?OptionQ] := qlBlackFormula[OptionType,Strike,AtmForwardValue,StdDev,Deflator,Displacement] /. {opts} /. Options[BlackFormula]
QLProcedure[BlackFormula]^=True
BlackFormula[___] := "never happens" /;Message[QuantLib::arg,"BlackFormula"] 



BlackFormula2[Payoff_Symbol,AtmForwardValue_?NumberQ,StdDev_?NumberQ,opts___?OptionQ] := qlBlackFormula2[Payoff,AtmForwardValue,StdDev,Deflator,Displacement] /. {opts} /. Options[BlackFormula2]
QLProcedure[BlackFormula2]^=True
BlackFormula2[___] := "never happens" /;Message[QuantLib::arg,"BlackFormula2"] 



BlackFormulaCashItmProbability[OptionType_String,Strike_?NumberQ,AtmForwardValue_?NumberQ,StdDev_?NumberQ,opts___?OptionQ] := qlBlackFormulaCashItmProbability[OptionType,Strike,AtmForwardValue,StdDev,Displacement] /. {opts} /. Options[BlackFormulaCashItmProbability]
QLProcedure[BlackFormulaCashItmProbability]^=True
BlackFormulaCashItmProbability[___] := "never happens" /;Message[QuantLib::arg,"BlackFormulaCashItmProbability"] 



BlackFormulaCashItmProbability2[Payoff_Symbol,AtmForwardValue_?NumberQ,StdDev_?NumberQ,opts___?OptionQ] := qlBlackFormulaCashItmProbability2[Payoff,AtmForwardValue,StdDev,Displacement] /. {opts} /. Options[BlackFormulaCashItmProbability2]
QLProcedure[BlackFormulaCashItmProbability2]^=True
BlackFormulaCashItmProbability2[___] := "never happens" /;Message[QuantLib::arg,"BlackFormulaCashItmProbability2"] 



BlackFormulaImpliedStdDev[OptionType_String,Strike_?NumberQ,AtmForwardValue_?NumberQ,OptionPrice_?NumberQ,opts___?OptionQ] := qlBlackFormulaImpliedStdDev[OptionType,Strike,AtmForwardValue,OptionPrice,Deflator,Displacement,Guess,Accuracy,MaxIter] /. {opts} /. Options[BlackFormulaImpliedStdDev]
QLProcedure[BlackFormulaImpliedStdDev]^=True
BlackFormulaImpliedStdDev[___] := "never happens" /;Message[QuantLib::arg,"BlackFormulaImpliedStdDev"] 



BlackFormulaImpliedStdDev2[PayoffID_Symbol,AtmForwardValue_?NumberQ,OptionPrice_?NumberQ,opts___?OptionQ] := qlBlackFormulaImpliedStdDev2[PayoffID,AtmForwardValue,OptionPrice,Deflator,Displacement,Guess,Accuracy,MaxIter] /. {opts} /. Options[BlackFormulaImpliedStdDev2]
QLProcedure[BlackFormulaImpliedStdDev2]^=True
BlackFormulaImpliedStdDev2[___] := "never happens" /;Message[QuantLib::arg,"BlackFormulaImpliedStdDev2"] 



BlackFormulaImpliedStdDevApproximation[OptionType_String,Strike_?NumberQ,AtmForwardValue_?NumberQ,OptionPrice_?NumberQ,opts___?OptionQ] := qlBlackFormulaImpliedStdDevApproximation[OptionType,Strike,AtmForwardValue,OptionPrice,Deflator,Displacement] /. {opts} /. Options[BlackFormulaImpliedStdDevApproximation]
QLProcedure[BlackFormulaImpliedStdDevApproximation]^=True
BlackFormulaImpliedStdDevApproximation[___] := "never happens" /;Message[QuantLib::arg,"BlackFormulaImpliedStdDevApproximation"] 



BlackFormulaImpliedStdDevApproximation2[Payoff_Symbol,AtmForwardValue_?NumberQ,OptionPrice_?NumberQ,opts___?OptionQ] := qlBlackFormulaImpliedStdDevApproximation2[Payoff,AtmForwardValue,OptionPrice,Deflator,Displacement] /. {opts} /. Options[BlackFormulaImpliedStdDevApproximation2]
QLProcedure[BlackFormulaImpliedStdDevApproximation2]^=True
BlackFormulaImpliedStdDevApproximation2[___] := "never happens" /;Message[QuantLib::arg,"BlackFormulaImpliedStdDevApproximation2"] 



BlackFormulaStdDevDerivative[Strike_?NumberQ,AtmForwardValue_?NumberQ,StdDev_?NumberQ,opts___?OptionQ] := qlBlackFormulaStdDevDerivative[Strike,AtmForwardValue,StdDev,Deflator,Displacement] /. {opts} /. Options[BlackFormulaStdDevDerivative]
QLProcedure[BlackFormulaStdDevDerivative]^=True
BlackFormulaStdDevDerivative[___] := "never happens" /;Message[QuantLib::arg,"BlackFormulaStdDevDerivative"] 



BlackFormulaStdDevDerivative2[PayoffID_Symbol,AtmForwardValue_?NumberQ,StdDev_?NumberQ,opts___?OptionQ] := qlBlackFormulaStdDevDerivative2[PayoffID,AtmForwardValue,StdDev,Deflator,Displacement] /. {opts} /. Options[BlackFormulaStdDevDerivative2]
QLProcedure[BlackFormulaStdDevDerivative2]^=True
BlackFormulaStdDevDerivative2[___] := "never happens" /;Message[QuantLib::arg,"BlackFormulaStdDevDerivative2"] 



BlackScholesCalculator[OptionType_String,Strike_?NumberQ,Spot_?NumberQ,StdDev_?NumberQ,opts___?OptionQ] := qlBlackScholesCalculator[Unique["BlackScholesCalculator"],OptionType,Strike,Spot,Growth,StdDev,Deflator,Permanent,Overwrite] /. {opts} /. Options[BlackScholesCalculator]
BlackScholesCalculator[ObjectId_Symbol,OptionType_String,Strike_?NumberQ,Spot_?NumberQ,StdDev_?NumberQ,opts___?OptionQ] := qlBlackScholesCalculator[ObjectId,OptionType,Strike,Spot,Growth,StdDev,Deflator,Permanent,Overwrite] /. {opts} /. Options[BlackScholesCalculator]
QLConstructor[BlackScholesCalculator]^=True
SyntaxInformation[BlackScholesCalculator] = {"ArgumentsPattern" -> {_,_,_,_.,OptionsPattern[]}} 
BlackScholesCalculator[___] := "never happens" /;Message[QuantLib::arg,"BlackScholesCalculator"] 



BlackScholesCalculator2[PayoffID_Symbol,Spot_?NumberQ,StdDev_?NumberQ,opts___?OptionQ] := qlBlackScholesCalculator2[Unique["BlackScholesCalculator2"],PayoffID,Spot,Growth,StdDev,Deflator,Permanent,Overwrite] /. {opts} /. Options[BlackScholesCalculator2]
BlackScholesCalculator2[ObjectId_Symbol,PayoffID_Symbol,Spot_?NumberQ,StdDev_?NumberQ,opts___?OptionQ] := qlBlackScholesCalculator2[ObjectId,PayoffID,Spot,Growth,StdDev,Deflator,Permanent,Overwrite] /. {opts} /. Options[BlackScholesCalculator2]
QLConstructor[BlackScholesCalculator2]^=True
SyntaxInformation[BlackScholesCalculator2] = {"ArgumentsPattern" -> {_,_,_.,OptionsPattern[]}} 
BlackScholesCalculator2[___] := "never happens" /;Message[QuantLib::arg,"BlackScholesCalculator2"] 



BlackScholesCalculatorDelta[ObjectId_Symbol,opts___?OptionQ] := qlBlackScholesCalculatorDelta[ObjectId] /. {opts} /. Options[BlackScholesCalculatorDelta] 
QLMember[BlackScholesCalculatorDelta]^=True
QLType[BlackScholesCalculatorDelta]^="QuantLib::BlackScholesCalculator"

BlackScholesCalculatorDelta[___] := "never happens" /;Message[QuantLib::arg,"BlackScholesCalculatorDelta"] 



BlackScholesCalculatorElasticity[ObjectId_Symbol,opts___?OptionQ] := qlBlackScholesCalculatorElasticity[ObjectId] /. {opts} /. Options[BlackScholesCalculatorElasticity] 
QLMember[BlackScholesCalculatorElasticity]^=True
QLType[BlackScholesCalculatorElasticity]^="QuantLib::BlackScholesCalculator"

BlackScholesCalculatorElasticity[___] := "never happens" /;Message[QuantLib::arg,"BlackScholesCalculatorElasticity"] 



BlackScholesCalculatorGamma[ObjectId_Symbol,opts___?OptionQ] := qlBlackScholesCalculatorGamma[ObjectId] /. {opts} /. Options[BlackScholesCalculatorGamma] 
QLMember[BlackScholesCalculatorGamma]^=True
QLType[BlackScholesCalculatorGamma]^="QuantLib::BlackScholesCalculator"

BlackScholesCalculatorGamma[___] := "never happens" /;Message[QuantLib::arg,"BlackScholesCalculatorGamma"] 



BlackScholesCalculatorTheta[ObjectId_Symbol,TimeToMaturity_?NumberQ,opts___?OptionQ] := qlBlackScholesCalculatorTheta[ObjectId,TimeToMaturity] /. {opts} /. Options[BlackScholesCalculatorTheta] 
QLMember[BlackScholesCalculatorTheta]^=True
QLType[BlackScholesCalculatorTheta]^="QuantLib::BlackScholesCalculator"

BlackScholesCalculatorTheta[___] := "never happens" /;Message[QuantLib::arg,"BlackScholesCalculatorTheta"] 



BlackScholesCalculatorThetaPerDay[ObjectId_Symbol,TimeToMaturity_?NumberQ,opts___?OptionQ] := qlBlackScholesCalculatorThetaPerDay[ObjectId,TimeToMaturity] /. {opts} /. Options[BlackScholesCalculatorThetaPerDay] 
QLMember[BlackScholesCalculatorThetaPerDay]^=True
QLType[BlackScholesCalculatorThetaPerDay]^="QuantLib::BlackScholesCalculator"

BlackScholesCalculatorThetaPerDay[___] := "never happens" /;Message[QuantLib::arg,"BlackScholesCalculatorThetaPerDay"] 



BlackSwaptionEngine[YieldCurve_Symbol,VolTS_Symbol,opts___?OptionQ] := qlBlackSwaptionEngine[Unique["BlackSwaptionEngine"],YieldCurve,VolTS,Permanent,Overwrite] /. {opts} /. Options[BlackSwaptionEngine]
BlackSwaptionEngine[ObjectId_Symbol,YieldCurve_Symbol,VolTS_Symbol,opts___?OptionQ] := qlBlackSwaptionEngine[ObjectId,YieldCurve,VolTS,Permanent,Overwrite] /. {opts} /. Options[BlackSwaptionEngine]
QLConstructor[BlackSwaptionEngine]^=True
SyntaxInformation[BlackSwaptionEngine] = {"ArgumentsPattern" -> {_,_.,OptionsPattern[]}} 
BlackSwaptionEngine[___] := "never happens" /;Message[QuantLib::arg,"BlackSwaptionEngine"] 



BlackSwaptionEngine2[YieldCurve_Symbol,Vol_,opts___?OptionQ] := qlBlackSwaptionEngine2[Unique["BlackSwaptionEngine2"],YieldCurve,Vol,DayCounter,Permanent,Overwrite] /. {opts} /. Options[BlackSwaptionEngine2]
BlackSwaptionEngine2[ObjectId_Symbol,YieldCurve_Symbol,Vol_,opts___?OptionQ] := qlBlackSwaptionEngine2[ObjectId,YieldCurve,Vol,DayCounter,Permanent,Overwrite] /. {opts} /. Options[BlackSwaptionEngine2]
QLConstructor[BlackSwaptionEngine2]^=True
SyntaxInformation[BlackSwaptionEngine2] = {"ArgumentsPattern" -> {_,_.,OptionsPattern[]}} 
BlackSwaptionEngine2[___] := "never happens" /;Message[QuantLib::arg,"BlackSwaptionEngine2"] 

G2SwaptionEngine[Model_Symbol,Range_?NumberQ,Intervals_Integer,opts___?OptionQ] := G2SwaptionEngine[Unique["G2SwaptionEngine"],Model,Range,Intervals,opts] 
G2SwaptionEngine[ObjectId_Symbol,Model_Symbol,Range_?NumberQ,Intervals_Integer,opts___?OptionQ] := qlG2SwaptionEngine[ObjectId,Model,Range,Intervals,Permanent,Overwrite] /. Join[{opts}, Options[G2SwaptionEngine]]
QLConstructor[G2SwaptionEngine]^=True
SyntaxInformation[G2SwaptionEngine] = {"ArgumentsPattern" -> {_,_.,OptionsPattern[]}} 
G2SwaptionEngine[___] := "never happens" /;Message[QuantLib::arg,"G2SwaptionEngine"] 

JamshidianSwaptionEngine[Model_Symbol,YieldCurve_Symbol,opts___?OptionQ] := JamshidianSwaptionEngine[Unique["JamshidianSwaptionEngine"],Model,YieldCurve,opts] 
JamshidianSwaptionEngine[ObjectId_Symbol,Model_Symbol,YieldCurve_Symbol,opts___?OptionQ] := qlJamshidianSwaptionEngine[ObjectId,Model,YieldCurve,Permanent,Overwrite] /. Join[{opts}, Options[JamshidianSwaptionEngine]]
JamshidianSwaptionEngine[Model_Symbol,opts___?OptionQ] := JamshidianSwaptionEngine[Unique["JamshidianSwaptionEngine"],Model,opts] 
JamshidianSwaptionEngine[ObjectId_Symbol,Model_Symbol,opts___?OptionQ] := qlJamshidianSwaptionEngine[ObjectId,Model,Permanent,Overwrite] /. Join[{opts}, Options[JamshidianSwaptionEngine]]
QLConstructor[JamshidianSwaptionEngine]^=True
SyntaxInformation[JamshidianSwaptionEngine] = {"ArgumentsPattern" -> {_,_.,OptionsPattern[]}} 
JamshidianSwaptionEngine[___] := "never happens" /;Message[QuantLib::arg,"JamshidianSwaptionEngine"] 

TreeSwaptionEngine[Model_Symbol,TimeSteps_Integer,opts___?OptionQ] := TreeSwaptionEngine[Unique["TreeSwaptionEngine"],Model,TimeSteps,opts] 
TreeSwaptionEngine[ObjectId_Symbol,Model_Symbol,TimeSteps_Integer,opts___?OptionQ] := qlTreeSwaptionEngine[ObjectId,Model,TimeSteps,Permanent,Overwrite] /. Join[{opts}, Options[TreeSwaptionEngine]]
TreeSwaptionEngine[Model_Symbol,TimeSteps_Integer,YieldCurve_Symbol,opts___?OptionQ] := TreeSwaptionEngine[Unique["TreeSwaptionEngine"],Model,TimeSteps,YieldCurve,opts] 
TreeSwaptionEngine[ObjectId_Symbol,Model_Symbol,TimeSteps_Integer,YieldCurve_Symbol,opts___?OptionQ] := qlTreeSwaptionEngine[ObjectId,Model,TimeSteps,YieldCurve,Permanent,Overwrite] /. Join[{opts}, Options[TreeSwaptionEngine]]
TreeSwaptionEngine[Model_Symbol,TimeGrid_Symbol,opts___?OptionQ] := qlTreeSwaptionEngine[Unique["TreeSwaptionEngine"],Model,TimeGrid,Permanent,Overwrite] /. Join[{opts}, Options[TreeSwaptionEngine]]
TreeSwaptionEngine[ObjectId_Symbol,Model_Symbol,TimeGrid_Symbol,opts___?OptionQ] := qlTreeSwaptionEngine[ObjectId,Model,TimeGrid,Permanent,Overwrite] /. Join[{opts}, Options[TreeSwaptionEngine]]
TreeSwaptionEngine[Model_Symbol,TimeGrid_Symbol,YieldCurve_Symbol,opts___?OptionQ] := TreeSwaptionEngine[Unique["TreeSwaptionEngine"],Model,TimeGrid,YieldCurve,opts] 
TreeSwaptionEngine[ObjectId_Symbol,Model_Symbol,TimeGrid_Symbol,YieldCurve_Symbol,opts___?OptionQ] := qlTreeSwaptionEngine[ObjectId,Model,TimeGrid,YieldCurve,Permanent,Overwrite] /. Join[{opts}, Options[TreeSwaptionEngine]]
QLConstructor[TreeSwaptionEngine]^=True
SyntaxInformation[TreeSwaptionEngine] = {"ArgumentsPattern" -> {_,_.,OptionsPattern[]}} 
JamshidianSwaptionEngine[___] := "never happens" /;Message[QuantLib::arg,"TreeSwaptionEngine"] 


BondEngine[YieldCurve_Symbol,opts___?OptionQ] := qlBondEngine[Unique["BondEngine"],YieldCurve,Permanent,Overwrite] /. {opts} /. Options[BondEngine]
BondEngine[ObjectId_Symbol,YieldCurve_Symbol,opts___?OptionQ] := qlBondEngine[ObjectId,YieldCurve,Permanent,Overwrite] /. {opts} /. Options[BondEngine]
QLConstructor[BondEngine]^=True
SyntaxInformation[BondEngine] = {"ArgumentsPattern" -> {_.,OptionsPattern[]}} 
BondEngine[___] := "never happens" /;Message[QuantLib::arg,"BondEngine"] 



DiscountingSwapEngine[YieldCurve_Symbol,opts___?OptionQ] := qlDiscountingSwapEngine[Unique["DiscountingSwapEngine"],YieldCurve,IncludeSettlDate,SettlementDate,NpvDate,Permanent,Overwrite] /. {opts} /. Options[DiscountingSwapEngine]
DiscountingSwapEngine[ObjectId_Symbol,YieldCurve_Symbol,opts___?OptionQ] := qlDiscountingSwapEngine[ObjectId,YieldCurve,IncludeSettlDate,SettlementDate,NpvDate,Permanent,Overwrite] /. {opts} /. Options[DiscountingSwapEngine]
QLConstructor[DiscountingSwapEngine]^=True
SyntaxInformation[DiscountingSwapEngine] = {"ArgumentsPattern" -> {_.,OptionsPattern[]}} 
DiscountingSwapEngine[___] := "never happens" /;Message[QuantLib::arg,"DiscountingSwapEngine"] 



PricingEngine[EngineID_String,ProcessID_Symbol,opts___?OptionQ] := qlPricingEngine[Unique["PricingEngine"],EngineID,ProcessID,Permanent,Overwrite] /. {opts} /. Options[PricingEngine]
PricingEngine[ObjectId_Symbol,EngineID_String,ProcessID_Symbol,opts___?OptionQ] := qlPricingEngine[ObjectId,EngineID,ProcessID,Permanent,Overwrite] /. {opts} /. Options[PricingEngine]
QLConstructor[PricingEngine]^=True
SyntaxInformation[PricingEngine] = {"ArgumentsPattern" -> {_,_.,OptionsPattern[]}} 
PricingEngine[___] := "never happens" /;Message[QuantLib::arg,"PricingEngine"] 

AnalyticEuropeanEngine[ProcessID_Symbol,opts___?OptionQ] := qlAnalyticEuropeanEngine[Unique["AnalyticEuropeanEngine"],ProcessID,Permanent,Overwrite] /. {opts} /. Options[AnalyticEuropeanEngine]
AnalyticEuropeanEngine[ObjectId_Symbol,ProcessID_Symbol,opts___?OptionQ] := qlAnalyticEuropeanEngine[ObjectId,ProcessID,Permanent,Overwrite] /. {opts} /. Options[AnalyticEuropeanEngine]
QLConstructor[AnalyticEuropeanEngine]^=True
SyntaxInformation[AnalyticEuropeanEngine] = {"ArgumentsPattern" -> {_.,OptionsPattern[]}} 
AnalyticEuropeanEngine[___] := "never happens" /;Message[QuantLib::arg,"AnalyticEuropeanEngine"] 

AnalyticBarrierEngine[ProcessID_Symbol,opts___?OptionQ] := qlAnalyticBarrierEngine[Unique["AnalyticBarrierEngine"],ProcessID,Permanent,Overwrite] /. {opts} /. Options[AnalyticEuropeanEngine]
AnalyticBarrierEngine[ObjectId_Symbol,ProcessID_Symbol,opts___?OptionQ] := qlAnalyticBarrierEngine[ObjectId,ProcessID,Permanent,Overwrite] /. {opts} /. Options[AnalyticEuropeanEngine]
QLConstructor[AnalyticBarrierEngine]^=True
SyntaxInformation[AnalyticBarrierEngine] = {"ArgumentsPattern" -> {_.,OptionsPattern[]}} 
AnalyticBarrierEngine[___] := "never happens" /;Message[QuantLib::arg,"AnalyticBarrierEngine"] 


MCLongstaffSchwartzEngine[ProcessID_Symbol,opts___?OptionQ] := qlMCLongstaffSchwartzEngine[Unique["MCLongstaffSchwartzEngine"],ProcessID,Permanent,Overwrite] /. {opts} /. Options[MCLongstaffSchwartzEngine]
MCLongstaffSchwartzEngine[ObjectId_Symbol,ProcessID_Symbol,opts___?OptionQ] := qlMCLongstaffSchwartzEngine[ObjectId,ProcessID,Permanent,Overwrite] /. {opts} /. Options[MCLongstaffSchwartzEngine] 
QLConstructor[MCLongstaffSchwartzEngine]^=True
SyntaxInformation[MCLongstaffSchwartzEngine] = {"ArgumentsPattern" -> {_.,OptionsPattern[]}} 
MCLongstaffSchwartzEngine[___] := "never happens" /;Message[QuantLib::arg,"MCLongstaffSchwartzEngine"] 
