
(* Pricing Engines *)

PricingEngines::usage = "functions to construct and use PricingEngine objects."

AnalyticCapFloorEngine::usage = "AnalyticCapFloorEngine[ObjecctId_Symbol,HandleModel_Symbol] Construct an object of class AnalyticCapFloorEngine and return its id
      \nObjectId: id of object to be created\nHandleModel: affine model (providing a discount bond option pricing formula) object ID.\nPermanent: object permanent/nonpermanent"
BachelierBlackFormula::usage = "BachelierBlackFormula[OptionType_String,Strike_?NumberQ,AtmForwardValue_?NumberQ,StdDev_?NumberQ] Black style formula when forward is normal rather than log-normal, i.e. essentially the model of Bachelier.
      \nOptionType: option type (i.e. Call or Put).\nStrike: option strike.\nAtmForwardValue: underlying asset at-the-money forward value.\nStdDev: standard deviation, i.e. annualized ABSOLUTE volatility times the square root of time to option expiry.\nDeflator: Deflator (usually the discount factor, or the annuity, etc.). Default value = 1.0."
BachelierBlackFormula2::usage = "BachelierBlackFormula2[Payoff_Symbol,AtmForwardValue_?NumberQ,StdDev_?NumberQ] Black style formula when forward is normal rather than log-normal, i.e. essentially the model of Bachelier. It uses a PlainVanillaPayoff object as input.
      \nPayoff: PlainVanillaPayoff object ID.\nAtmForwardValue: underlying asset at-the-money forward value.\nStdDev: standard deviation, i.e. annualized ABSOLUTE volatility times the square root of time to option expiry.\nDeflator: Deflator (usually the discount factor, or the annuity, etc.). Default value = 1.0."
BinomialPricingEngine::usage = "BinomialPricingEngine[ObjecctId_Symbol,EngineID_String,ProcessID_Symbol,TimeSteps_Integer] Construct an object of class PricingEngine and return its id
      \nObjectId: id of object to be created\nEngineID: engine type.\nProcessID: GeneralizedBlackScholesProcess object ID.\nTimeSteps: #/time steps.\nPermanent: object permanent/nonpermanent"
BlackCalculator::usage = "BlackCalculator[ObjecctId_Symbol,OptionType_String,Strike_?NumberQ,AtmForwardValue_?NumberQ,StdDev_?NumberQ] Construct an object of class BlackCalculator and return its id
      \nObjectId: id of object to be created\nOptionType: option type (i.e. Call or Put).\nStrike: option strike.\nAtmForwardValue: underlying asset at-the-money forward value.\nStdDev: standard deviation, i.e. annualized percentage volatility times the square root of time to option expiry.\nDeflator: Deflator (usually the discount factor, or the annuity, etc.). Default value = 1.0.\nPermanent: object permanent/nonpermanent"
BlackCalculator2::usage = "BlackCalculator2[ObjecctId_Symbol,PayoffID_Symbol,AtmForwardValue_?NumberQ,StdDev_?NumberQ] Construct an object of class BlackCalculator and return its id
      \nObjectId: id of object to be created\nPayoffID: StrikedTypePayoff ID.\nAtmForwardValue: underlying asset at-the-money forward value.\nStdDev: standard deviation, i.e. annualized percentage volatility times the square root of time to option expiry.\nDeflator: Deflator (usually the discount factor, or the annuity, etc.). Default value = 1.0.\nPermanent: object permanent/nonpermanent"
BlackCalculatorAlpha::usage = "BlackCalculatorAlpha[ObjecctId_Symbol] returns the alpha of the internal formulation of the given BlackCalculator object.
      \nObjectId: id of existing QuantLib::BlackCalculator object"
BlackCalculatorBeta::usage = "BlackCalculatorBeta[ObjecctId_Symbol] returns the beta of the internal formulation of the given BlackCalculator object.
      \nObjectId: id of existing QuantLib::BlackCalculator object"
BlackCalculatorDelta::usage = "BlackCalculatorDelta[ObjecctId_Symbol,Spot_?NumberQ] returns the sensitivity to change in the underlying spot price for the given BlackCalculator object.
      \nObjectId: id of existing QuantLib::BlackCalculator object\nSpot: spot value."
BlackCalculatorDeltaForward::usage = "BlackCalculatorDeltaForward[ObjecctId_Symbol] returns the sensitivity to change in the underlying forward price for the given BlackCalculator object.
      \nObjectId: id of existing QuantLib::BlackCalculator object"
BlackCalculatorDividendRho::usage = "BlackCalculatorDividendRho[ObjecctId_Symbol,TimeToMaturity_?NumberQ] returns the sensitivity to dividend/growth rate for the given BlackCalculator object.
      \nObjectId: id of existing QuantLib::BlackCalculator object\nTimeToMaturity: time to maturity in years."
BlackCalculatorElasticity::usage = "BlackCalculatorElasticity[ObjecctId_Symbol,Spot_?NumberQ] returns the sensitivity in percent to a percent change in the underlying spot price for the given BlackCalculator object.
      \nObjectId: id of existing QuantLib::BlackCalculator object\nSpot: spot value."
BlackCalculatorElasticityForward::usage = "BlackCalculatorElasticityForward[ObjecctId_Symbol] returns the sensitivity in percent to a percent change in the underlying forward price for the given BlackCalculator object.
      \nObjectId: id of existing QuantLib::BlackCalculator object"
BlackCalculatorGamma::usage = "BlackCalculatorGamma[ObjecctId_Symbol,Spot_?NumberQ] returns the second order derivative with respect to change in the underlying spot price for the given BlackCalculator object.
      \nObjectId: id of existing QuantLib::BlackCalculator object\nSpot: spot value."
BlackCalculatorGammaForward::usage = "BlackCalculatorGammaForward[ObjecctId_Symbol] returns the second order derivative with respect to change in the underlying forward price for the given BlackCalculator object.
      \nObjectId: id of existing QuantLib::BlackCalculator object"
BlackCalculatorItmAssetProbability::usage = "BlackCalculatorItmAssetProbability[ObjecctId_Symbol] returns the probability of being in the money in the asset martingale measure for the given BlackCalculator object. It is a risk-neutral probability, not the real world probability.
      \nObjectId: id of existing QuantLib::BlackCalculator object"
BlackCalculatorItmCashProbability::usage = "BlackCalculatorItmCashProbability[ObjecctId_Symbol] returns the probability of being in the money in the bond martingale measure for the given BlackCalculator object. It is a risk-neutral probability, not the real world probability.
      \nObjectId: id of existing QuantLib::BlackCalculator object"
BlackCalculatorRho::usage = "BlackCalculatorRho[ObjecctId_Symbol,TimeToMaturity_?NumberQ] returns the sensitivity to discounting rate for the given BlackCalculator object.
      \nObjectId: id of existing QuantLib::BlackCalculator object\nTimeToMaturity: time to maturity in years."
BlackCalculatorStrikeSensitivity::usage = "BlackCalculatorStrikeSensitivity[ObjecctId_Symbol] returns the sensitivity to strike for the given BlackCalculator object.
      \nObjectId: id of existing QuantLib::BlackCalculator object"
BlackCalculatorTheta::usage = "BlackCalculatorTheta[ObjecctId_Symbol,Spot_?NumberQ,TimeToMaturity_?NumberQ] returns the sensitivity to time to maturity for the given BlackCalculator object.
      \nObjectId: id of existing QuantLib::BlackCalculator object\nSpot: spot value.\nTimeToMaturity: time to maturity in years."
BlackCalculatorThetaPerDay::usage = "BlackCalculatorThetaPerDay[ObjecctId_Symbol,Spot_?NumberQ,TimeToMaturity_?NumberQ] returns the sensitivity to time to maturity per day, assuming 365 days per year, for the given BlackCalculator object.
      \nObjectId: id of existing QuantLib::BlackCalculator object\nSpot: spot value.\nTimeToMaturity: time to maturity in years."
BlackCalculatorValue::usage = "BlackCalculatorValue[ObjecctId_Symbol] returns the option value for the given BlackCalculator object.
      \nObjectId: id of existing QuantLib::BlackCalculator object"
BlackCalculatorVega::usage = "BlackCalculatorVega[ObjecctId_Symbol,TimeToMaturity_?NumberQ] returns the sensitivity to volatility for the given BlackCalculator object.
      \nObjectId: id of existing QuantLib::BlackCalculator object\nTimeToMaturity: time to maturity in years."
BlackCapFloorEngine::usage = "BlackCapFloorEngine[ObjecctId_Symbol,YieldCurve_Symbol,VolTS_Symbol] Construct an object of class BlackCapFloorEngine and return its id
      \nObjectId: id of object to be created\nYieldCurve: discounting YieldTermStructure object ID.\nVolTS: OptionletVolatilityStructure object ID.\nPermanent: object permanent/nonpermanent"
BlackCapFloorEngine2::usage = "BlackCapFloorEngine2[ObjecctId_Symbol,YieldCurve_Symbol,Vol_] Construct an object of class BlackCapFloorEngine and return its id
      \nObjectId: id of object to be created\nYieldCurve: discounting YieldTermStructure object ID.\nVol: Term (i.e. flat) volatility.\nDayCounter: DayCounter ID. Default value = Actual/365 (Fixed).\nPermanent: object permanent/nonpermanent"
BlackFormula::usage = "BlackFormula[OptionType_String,Strike_?NumberQ,AtmForwardValue_?NumberQ,StdDev_?NumberQ] Black 1976 formula for option pricing, using displacement.
      \nOptionType: option type (i.e. Call or Put).\nStrike: option strike.\nAtmForwardValue: underlying asset at-the-money forward value.\nStdDev: standard deviation, i.e. annualized percentage volatility times the square root of time to option expiry.\nDeflator: Deflator (usually the discount factor, or the annuity, etc.). Default value = 1.0.\nDisplacement: displacement in a displaced diffusion model. Default value = 0.0."
BlackFormula2::usage = "BlackFormula2[Payoff_Symbol,AtmForwardValue_?NumberQ,StdDev_?NumberQ] Black 1976 formula for option pricing with displacement. It uses a PlainVanillaPayoff object as input.
      \nPayoff: PlainVanillaPayoff object ID.\nAtmForwardValue: underlying asset at-the-money forward value.\nStdDev: standard deviation, i.e. annualized percentage volatility times the square root of time to option expiry.\nDeflator: Deflator (usually the discount factor, or the annuity, etc.). Default value = 1.0.\nDisplacement: displacement in a displaced diffusion model. Default value = 0.0."
BlackFormulaCashItmProbability::usage = "BlackFormulaCashItmProbability[OptionType_String,Strike_?NumberQ,AtmForwardValue_?NumberQ,StdDev_?NumberQ] Black 1976 probability of being in the money (in the bond martingale measure), i.e. N(d2). It is a risk-neutral probability, not the real world one.
      \nOptionType: option type (i.e. Call or Put).\nStrike: option strike.\nAtmForwardValue: underlying asset at-the-money forward value.\nStdDev: standard deviation, i.e. annualized percentage volatility times the square root of time to option expiry.\nDisplacement: displacement in a displaced diffusion model. Default value = 0.0."
BlackFormulaCashItmProbability2::usage = "BlackFormulaCashItmProbability2[Payoff_Symbol,AtmForwardValue_?NumberQ,StdDev_?NumberQ] Black 1976 probability of being in the money (in the bond martingale measure), i.e. N(d2). It is a risk-neutral probability, not the real world one. It uses a PlainVanillaPayoff object as input.
      \nPayoff: PlainVanillaPayoff  object ID.\nAtmForwardValue: underlying asset at-the-money forward value.\nStdDev: standard deviation, i.e. annualized percentage volatility times the square root of time to option expiry.\nDisplacement: displacement in a displaced diffusion model. Default value = 0.0."
BlackFormulaImpliedStdDev::usage = "BlackFormulaImpliedStdDev[OptionType_String,Strike_?NumberQ,AtmForwardValue_?NumberQ,OptionPrice_?NumberQ] Standard deviation (annualized percentage volatility times the square root of time to option expiry) implied by the Black 1976 formula with displacement.
      \nOptionType: option type (i.e. Call or Put).\nStrike: option strike.\nAtmForwardValue: underlying asset at-the-money forward value.\nOptionPrice: option price.\nDeflator: Deflator (usually the discount factor, or the annuity, etc.). Default value = 1.0.\nDisplacement: displacement in a displaced diffusion model. Default value = 0.0.\nGuess: standard deviation guess. Default value = 0.\nAccuracy: solver accuracy. Default value = 1.0e-6.\nMaxIter: solver max iterations. Default value = 100."
BlackFormulaImpliedStdDev2::usage = "BlackFormulaImpliedStdDev2[PayoffID_Symbol,AtmForwardValue_?NumberQ,OptionPrice_?NumberQ] Standard deviation (annualized percentage volatility times the square root of time to option expiry) implied by the Black 1976 formula. It uses a PlainVanillaPayoff object as input.
      \nPayoffID: PlainVanillaPayoff object ID.\nAtmForwardValue: underlying asset at-the-money forward value.\nOptionPrice: option price.\nDeflator: Deflator (usually the discount factor, or the annuity, etc.). Default value = 1.0.\nDisplacement: displacement in a displaced diffusion model. Default value = 0.0.\nGuess: standard deviation guess. Default value = 0.\nAccuracy: standard deviation accuracy. Default value = 1.0e-6.\nMaxIter: solver max iterations. Default value = 100."
BlackFormulaImpliedStdDevApproximation::usage = "BlackFormulaImpliedStdDevApproximation[OptionType_String,Strike_?NumberQ,AtmForwardValue_?NumberQ,OptionPrice_?NumberQ] Approximation for the standard deviation (annualized percentage volatility times the square root of time to option expiry) implied by the Black 1976 formula.
      \nOptionType: option type (i.e. Call or Put).\nStrike: option strike.\nAtmForwardValue: underlying asset at-the-money forward value.\nOptionPrice: option price.\nDeflator: Deflator (usually the discount factor, or the annuity, etc.). Default value = 1.0.\nDisplacement: displacement in a displaced diffusion model. Default value = 0.0."
BlackFormulaImpliedStdDevApproximation2::usage = "BlackFormulaImpliedStdDevApproximation2[Payoff_Symbol,AtmForwardValue_?NumberQ,OptionPrice_?NumberQ] Approximation for the standard deviation (annualized percentage volatility times the square root of time to option expiry) implied by the Black 1976 formula. It uses a PlainVanillaPayoff object as input.
      \nPayoff: PlainVanillaPayoff object ID.\nAtmForwardValue: underlying asset at-the-money forward value.\nOptionPrice: option price.\nDeflator: Deflator (usually the discount factor, or the annuity, etc.). Default value = 1.0.\nDisplacement: displacement in a displaced diffusion model. Default value = 0.0."
BlackFormulaStdDevDerivative::usage = "BlackFormulaStdDevDerivative[Strike_?NumberQ,AtmForwardValue_?NumberQ,StdDev_?NumberQ] Black 1976 formula for the derivative with respect to the standard deviation (annualized percentage volatility times the square root of time to option expiry), with displacement.
      \nStrike: option strike.\nAtmForwardValue: underlying asset at-the-money forward value.\nStdDev: standard deviation, i.e. annualized percentage volatility times the square root of time to option expiry.\nDeflator: Deflator (usually the discount factor, or the annuity, etc.). Default value = 1.0.\nDisplacement: displacement in a displaced diffusion model. Default value = 0.0."
BlackFormulaStdDevDerivative2::usage = "BlackFormulaStdDevDerivative2[PayoffID_Symbol,AtmForwardValue_?NumberQ,StdDev_?NumberQ] Black 1976 formula for the derivative with respect to the standard deviation (annualized percentage volatility times the square root of time to option expiry). It uses a PlainVanillaPayoff object as input.
      \nPayoffID: PlainVanillaPayoff object ID.\nAtmForwardValue: underlying asset at-the-money forward value.\nStdDev: standard deviation, i.e. annualized percentage volatility times the square root of time to option expiry.\nDeflator: Deflator (usually the discount factor, or the annuity, etc.). Default value = 1.0.\nDisplacement: displacement in a displaced diffusion model. Default value = 0.0."
BlackScholesCalculator::usage = "BlackScholesCalculator[ObjecctId_Symbol,OptionType_String,Strike_?NumberQ,Spot_?NumberQ,StdDev_?NumberQ] Construct an object of class BlackScholesCalculator and return its id
      \nObjectId: id of object to be created\nOptionType: option type (i.e. Call or Put).\nStrike: option strike.\nSpot: spot value.\nGrowth: growth discount factor. Default value = 1.0.\nStdDev: standard deviation, i.e. annualized percentage volatility times the square root of time to option expiry.\nDeflator: Deflator (usually the discount factor, or the annuity, etc.). Default value = 1.0.\nPermanent: object permanent/nonpermanent"
BlackScholesCalculator2::usage = "BlackScholesCalculator2[ObjecctId_Symbol,PayoffID_Symbol,Spot_?NumberQ,StdDev_?NumberQ] Construct an object of class BlackScholesCalculator and return its id
      \nObjectId: id of object to be created\nPayoffID: StrikedTypePayoff ID.\nSpot: spot value.\nGrowth: growth discount factor. Default value = 1.0.\nStdDev: standard deviation, i.e. annualized percentage volatility times the square root of time to option expiry.\nDeflator: Deflator (usually the discount factor, or the annuity, etc.). Default value = 1.0.\nPermanent: object permanent/nonpermanent"
BlackScholesCalculatorDelta::usage = "BlackScholesCalculatorDelta[ObjecctId_Symbol] returns the sensitivity to change in the underlying spot price for the given BlackScholesCalculator object.
      \nObjectId: id of existing QuantLib::BlackScholesCalculator object"
BlackScholesCalculatorElasticity::usage = "BlackScholesCalculatorElasticity[ObjecctId_Symbol] returns the sensitivity in percent to a percent change in the underlying spot price for the given BlackScholesCalculator object.
      \nObjectId: id of existing QuantLib::BlackScholesCalculator object"
BlackScholesCalculatorGamma::usage = "BlackScholesCalculatorGamma[ObjecctId_Symbol] returns the second order derivative with respect to change in the underlying spot price for the given BlackScholesCalculator object.
      \nObjectId: id of existing QuantLib::BlackScholesCalculator object"
BlackScholesCalculatorTheta::usage = "BlackScholesCalculatorTheta[ObjecctId_Symbol,TimeToMaturity_?NumberQ] returns the sensitivity to time to maturity for the given BlackScholesCalculator object.
      \nObjectId: id of existing QuantLib::BlackScholesCalculator object\nTimeToMaturity: time to maturity in years."
BlackScholesCalculatorThetaPerDay::usage = "BlackScholesCalculatorThetaPerDay[ObjecctId_Symbol,TimeToMaturity_?NumberQ] returns the sensitivity to time to maturity per day, assuming 365 days per year, for the given BlackScholesCalculator object.
      \nObjectId: id of existing QuantLib::BlackScholesCalculator object\nTimeToMaturity: time to maturity in years."
BlackSwaptionEngine::usage = "BlackSwaptionEngine[ObjecctId_Symbol,YieldCurve_Symbol,VolTS_Symbol] Construct an object of class BlackSwaptionEngine and return its id
      \nObjectId: id of object to be created\nYieldCurve: discounting yield term structure object ID.\nVolTS: SwaptionVolatilityStructure object ID.\nPermanent: object permanent/nonpermanent"
BlackSwaptionEngine2::usage = "BlackSwaptionEngine2[ObjecctId_Symbol,YieldCurve_Symbol,Vol_] Construct an object of class BlackSwaptionEngine and return its id
      \nObjectId: id of object to be created\nYieldCurve: discounting yield term structure object ID.\nVol: cap/floor term volatility.\nDayCounter: DayCounter ID. Default value = Actual/365 (Fixed).\nPermanent: object permanent/nonpermanent"
BondEngine::usage = "BondEngine[ObjecctId_Symbol,YieldCurve_Symbol] Construct an object of class BondEngine and return its id
      \nObjectId: id of object to be created\nYieldCurve: discounting yield term structure object ID.\nPermanent: object permanent/nonpermanent"
DiscountingSwapEngine::usage = "DiscountingSwapEngine[ObjecctId_Symbol,YieldCurve_Symbol] Construct an object of class DiscountingSwapEngine and return its id
      \nObjectId: id of object to be created\nYieldCurve: discounting yield term structure object ID.\nIncludeSettlDate: TRUE if cashflows paid at the settlement date must be taken into account. Default value = true.\nSettlementDate: cashflows before this date are not taken into account. If missing it is assumed equal to the discounting yield term structure's reference date. Default value = Date[].\nNpvDate: all cashflows are discounted to this date. If missing it is assumed equal to the discounting yield term structure's reference date. Default value = Date[].\nPermanent: object permanent/nonpermanent"
PricingEngine::usage = "PricingEngine[ObjecctId_Symbol,EngineID_String,ProcessID_Symbol] Construct an object of class PricingEngine and return its id
      \nObjectId: id of object to be created\nEngineID: engine type.\nProcessID: GeneralizedBlackScholesProcess object ID.\nPermanent: object permanent/nonpermanent"
TreeCallableFixedRateBondEngine::usage = "TreeCallableFixedRateBondEngine[ObjecctId_Symbol,HandleModel_Symbol,TimeSteps_Integer] Construct an object of class TreeCallableFixedRateBondEngine and return its id
      \nObjectId: id of object to be created\nHandleModel: affine model (providing a short rate model) object ID.\nTimeSteps: Number of time steps in the calculation\nPermanent: object permanent/nonpermanent"
AnalyticBarrierEngine::usage = "AnalyticBarrierEngine[ObjecctId_Symbol,ProcessID_Symbol] Construct an object of class AnalyticBarrierEngine and return its id
      \nObjectId: id of object to be created\nProcessID: GeneralizedBlackScholesProcess object ID.\nPermanent: object permanent/nonpermanent"
AnalyticEuropeanEngine::usage = "AnalyticEuropeanEngine[ObjecctId_Symbol,ProcessID_Symbol] Construct an object of class AnalyticEuropeanEngine and return its id
      \nObjectId: id of object to be created\nProcessID: GeneralizedBlackScholesProcess object ID.\nPermanent: object permanent/nonpermanent"

G2SwaptionEngine::usage ="G2SwaptionEngine[ObjectId_Symbol,Model_Symbol,Range_?NumberQ,Intervals_Integer]"
JamshidianSwaptionEngine::usage ="JamshidianSwaptionEngine[ObjectId_Symbol,Model_Symbol]"
TreeSwaptionEngine::usage = "TreeSwaptionEngine[ObjecctId_Symbol,HandleModel_Symbol,TimeSteps_Integer] Construct an object of class TreeSwaptionEngine and return its id
      \nObjectId: id of object to be created\nHandleModel: affine model (providing a short rate model) object ID.\nTimeSteps: Number of time steps in the calculation\nPermanent: object permanent/nonpermanent"

MCLongstaffSchwartzEngine::usage = "";
     
Category[PricingEngines] = {AnalyticCapFloorEngine,BachelierBlackFormula,BachelierBlackFormula2,BinomialPricingEngine,BlackCalculator,BlackCalculator2,BlackCalculatorAlpha,BlackCalculatorBeta,BlackCalculatorDelta,BlackCalculatorDeltaForward,BlackCalculatorDividendRho,BlackCalculatorElasticity,BlackCalculatorElasticityForward,BlackCalculatorGamma,BlackCalculatorGammaForward,BlackCalculatorItmAssetProbability,BlackCalculatorItmCashProbability,BlackCalculatorRho,BlackCalculatorStrikeSensitivity,BlackCalculatorTheta,BlackCalculatorThetaPerDay,BlackCalculatorValue,BlackCalculatorVega,BlackCapFloorEngine,BlackCapFloorEngine2,BlackFormula,BlackFormula2,BlackFormulaCashItmProbability,BlackFormulaCashItmProbability2,BlackFormulaImpliedStdDev,BlackFormulaImpliedStdDev2,BlackFormulaImpliedStdDevApproximation,BlackFormulaImpliedStdDevApproximation2,BlackFormulaStdDevDerivative,BlackFormulaStdDevDerivative2,BlackScholesCalculator,BlackScholesCalculator2,BlackScholesCalculatorDelta,BlackScholesCalculatorElasticity,BlackScholesCalculatorGamma,BlackScholesCalculatorTheta,BlackScholesCalculatorThetaPerDay,BlackSwaptionEngine,BlackSwaptionEngine2,BondEngine,DiscountingSwapEngine,PricingEngine,TreeCallableFixedRateBondEngine};
AppendTo[QLCategories,PricingEngines]
