(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 8.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       157,          7]
NotebookDataLength[      6356,        236]
NotebookOptionsPosition[      3382,        128]
NotebookOutlinePosition[      5149,        191]
CellTagsIndexPosition[      4964,        182]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell["AccountingEngines", "Chapter",
 CellTags->"Overview"],

Cell["functions to construct and use Accounting Engines objects.", "Text",
 CellTags->"Overview"],

Cell["The first step is to load the QuantLib package. ", "MathCaption",
 CellTags->"Overview"],

Cell["Needs[\"QuantLib`\"]", "Input",
 CellTags->"Overview"],

Cell["\<\
Within the AccountingEngines part there are several constructors and member \
functions available \
\>", "Text",
 CellTags->"Overview"],

Cell["Select[Category[AccountingEngines],QLConstructor[#]&]", "Input",
 CellTags->"Overview"],

Cell["Select[Category[AccountingEngines],QLMember[#]&]", "Input",
 CellTags->"Overview"],

Cell["Select[Category[AccountingEngines],QLProcedure[#]&]", "Input",
 CellTags->"Overview"],

Cell[CellGroupData[{

Cell["Constructors", "Section",
 CellTags->"Constructor"],

Cell[CellGroupData[{

Cell["AccountingEngine", "Subsubsection",
 CellTags->"Constructor"],

Cell[BoxData[{Cell[BoxData[GridBox[{
    {"MarketModelEvolver", 
     RowBox[{"MarketModelEvolver", " ", "object", " ", 
      RowBox[{"ID", "."}]}]},
    {"Product", 
     RowBox[{"MarketModelMultiProduct", " ", "object", " ", 
      RowBox[{"ID", "."}]}]},
    {"InitialNumeraireValue", 
     RowBox[{"initial", " ", "numeraire", " ", 
      RowBox[{"value", "."}]}]}
   }]], "DefinitionBox",
  CellTags->"Constructor"], "\n", Cell["Calling Parameters", 
  "Caption"]}], "Text"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"MarketModelEvolver", "=", "exampleValue"}], ";"}], "\n", 
 RowBox[{
  RowBox[{"Product", "=", "exampleValue"}], ";"}], "\n", 
 RowBox[{
  RowBox[{"InitialNumeraireValue", "=", "exampleValue"}], ";"}]}], "Input",
 CellTags->"Constructor"],

Cell["\<\
obj=AccountingEngine[MarketModelEvolver,Product,InitialNumeraireValue]\
\>", "Input",
 CellTags->"Constructor"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Member function", "Section",
 CellTags->"Member"],

Cell[CellGroupData[{

Cell["AccountingEngineMultiplePathValues", "Subsubsection",
 CellTags->"Member"],

Cell[BoxData[{Cell[BoxData[GridBox[{
    {"SequenceStats", 
     RowBox[{"Sequence", " ", "Statistics", " ", "object", " ", 
      RowBox[{"ID", "."}]}]},
    {"Paths", 
     RowBox[{"number", " ", "of", " ", 
      RowBox[{"paths", "."}]}]}
   }]], "DefinitionBox",
  CellTags->"Member"], "\n", Cell["Calling Parameters", "Caption"]}], "Text"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"SequenceStats", "=", "exampleValue"}], ";"}], "\n", 
 RowBox[{
  RowBox[{"Paths", "=", "8191"}], ";"}]}], "Input",
 CellTags->"Member"],

Cell["AccountingEngineMultiplePathValues[obj,SequenceStats,Paths]", "Input",
 CellTags->"Member"]
}, Open  ]]
}, Open  ]],

Cell["Procedures", "Section",
 CellTags->"Procedure"],

Cell["Enumeration Member", "Section",
 CellTags->"EnumerationMember"]
}, Open  ]]
},
WindowSize->{716, 867},
WindowMargins->{{Automatic, -794}, {-19, Automatic}},
FrontEndVersion->"8.0 for Microsoft Windows (32-bit) (February 23, 2011)",
StyleDefinitions->"HelpBrowser.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "Overview"->{
  Cell[579, 22, 59, 1, 99, "Chapter",
   CellTags->"Overview"],
  Cell[641, 25, 97, 1, 37, "Text",
   CellTags->"Overview"],
  Cell[741, 28, 94, 1, 53, "MathCaption",
   CellTags->"Overview"],
  Cell[838, 31, 60, 1, 41, "Input",
   CellTags->"Overview"],
  Cell[901, 34, 145, 4, 37, "Text",
   CellTags->"Overview"],
  Cell[1049, 40, 93, 1, 41, "Input",
   CellTags->"Overview"],
  Cell[1145, 43, 88, 1, 41, "Input",
   CellTags->"Overview"],
  Cell[1236, 46, 91, 1, 41, "Input",
   CellTags->"Overview"]},
 "Constructor"->{
  Cell[1352, 51, 57, 1, 77, "Section",
   CellTags->"Constructor"],
  Cell[1434, 56, 67, 1, 47, "Subsubsection",
   CellTags->"Constructor"],
  Cell[1987, 73, 273, 7, 82, "Input",
   CellTags->"Constructor"],
  Cell[2263, 82, 121, 3, 41, "Input",
   CellTags->"Constructor"]},
 "Member"->{
  Cell[2433, 91, 55, 1, 77, "Section",
   CellTags->"Member"],
  Cell[2513, 96, 80, 1, 47, "Subsubsection",
   CellTags->"Member"],
  Cell[2943, 109, 171, 5, 62, "Input",
   CellTags->"Member"],
  Cell[3117, 116, 97, 1, 41, "Input",
   CellTags->"Member"]},
 "Procedure"->{
  Cell[3241, 121, 53, 1, 77, "Section",
   CellTags->"Procedure"]},
 "EnumerationMember"->{
  Cell[3297, 124, 69, 1, 51, "Section",
   CellTags->"EnumerationMember"]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"Overview", 3684, 138},
 {"Constructor", 4209, 155},
 {"Member", 4499, 164},
 {"Procedure", 4773, 173},
 {"EnumerationMember", 4865, 176}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[579, 22, 59, 1, 99, "Chapter",
 CellTags->"Overview"],
Cell[641, 25, 97, 1, 37, "Text",
 CellTags->"Overview"],
Cell[741, 28, 94, 1, 53, "MathCaption",
 CellTags->"Overview"],
Cell[838, 31, 60, 1, 41, "Input",
 CellTags->"Overview"],
Cell[901, 34, 145, 4, 37, "Text",
 CellTags->"Overview"],
Cell[1049, 40, 93, 1, 41, "Input",
 CellTags->"Overview"],
Cell[1145, 43, 88, 1, 41, "Input",
 CellTags->"Overview"],
Cell[1236, 46, 91, 1, 41, "Input",
 CellTags->"Overview"],
Cell[CellGroupData[{
Cell[1352, 51, 57, 1, 77, "Section",
 CellTags->"Constructor"],
Cell[CellGroupData[{
Cell[1434, 56, 67, 1, 47, "Subsubsection",
 CellTags->"Constructor"],
Cell[1504, 59, 480, 12, 99, "Text"],
Cell[1987, 73, 273, 7, 82, "Input",
 CellTags->"Constructor"],
Cell[2263, 82, 121, 3, 41, "Input",
 CellTags->"Constructor"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[2433, 91, 55, 1, 77, "Section",
 CellTags->"Member"],
Cell[CellGroupData[{
Cell[2513, 96, 80, 1, 47, "Subsubsection",
 CellTags->"Member"],
Cell[2596, 99, 344, 8, 80, "Text"],
Cell[2943, 109, 171, 5, 62, "Input",
 CellTags->"Member"],
Cell[3117, 116, 97, 1, 41, "Input",
 CellTags->"Member"]
}, Open  ]]
}, Open  ]],
Cell[3241, 121, 53, 1, 77, "Section",
 CellTags->"Procedure"],
Cell[3297, 124, 69, 1, 51, "Section",
 CellTags->"EnumerationMember"]
}, Open  ]]
}
]
*)

(* End of internal cache information *)

