(* Content-type: application/mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 6.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       145,          7]
NotebookDataLength[     11446,        450]
NotebookOptionsPosition[      6053,        249]
NotebookOutlinePosition[      9033,        353]
CellTagsIndexPosition[      8909,        346]
WindowFrame->Normal
ContainsDynamic->False*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell[BoxData["AlphaForm"], "Chapter",
 CellTags->"Overview",
 CellID->67721959],

Cell["functions to construct and use AlphaForm objects.", "Text",
 CellTags->"Overview",
 CellID->150932558],

Cell["The first step is to load the QuantLib package. ", "MathCaption",
 CellTags->"Overview",
 CellID->345308904],

Cell["Needs[\"QuantLib`\"]", "Input",
 CellTags->"Overview",
 CellLabel->"In[1]:=",
 CellID->155644119],

Cell["\<\
Within the AlphaForm part there are several constructors and member functions \
available \
\>", "Text",
 CellTags->"Overview",
 CellID->187848946],

Cell[CellGroupData[{

Cell["Select[Category[AlphaForm],QLConstructor[#]&]", "Input",
 CellTags->"Overview",
 CellLabel->"In[2]:=",
 CellID->537523882],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"AlphaFormInverseLinear", ",", "AlphaFormLinearHyperbolic"}], 
  "}"}]], "Output",
 CellChangeTimes->{
  3.4360685154375*^9, {3.436095917609375*^9, 3.436095941625*^9}, 
   3.43609606496875*^9},
 CellTags->"Overview",
 CellLabel->"Out[2]=",
 CellID->389192321]
}, Open  ]],

Cell[CellGroupData[{

Cell["Select[Category[AlphaForm],QLMember[#]&]", "Input",
 CellTags->"Overview",
 CellLabel->"In[3]:=",
 CellID->171636835],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"AlphaFormOperator", ",", "AlphaFormSetAlpha"}], "}"}]], "Output",
 CellChangeTimes->{
  3.43606851546875*^9, {3.436095918703125*^9, 3.436095942328125*^9}, 
   3.436096065875*^9},
 CellTags->"Overview",
 CellLabel->"Out[3]=",
 CellID->674697302]
}, Open  ]],

Cell[CellGroupData[{

Cell["AlphaFormInverseLinear", "Subsection",
 CellID->8596527],

Cell[BoxData[GridBox[{
   {"RateTimes", 
    RowBox[{
    "0.5", ",", "1.0", ",", "1.5", ",", "2.0", ",", "2.5", ",", "3.0", ",", 
     "3.5", ",", "4.0", ",", "4.5", ",", "5.0", ",", "5.5"}], 
    RowBox[{"rate", " ", "fixing", " ", 
     RowBox[{"times", "."}]}]},
   {"Alpha", "5", 
    RowBox[{"alpha", " ", 
     RowBox[{"coefficient", "."}]}]}
  }]], "DefinitionBox3Col",
 CellID->65034613],

Cell[BoxData[{
 RowBox[{
  RowBox[{"RateTimes", "=", 
   RowBox[{"{", 
    RowBox[{
    "0.5", ",", "1.0", ",", "1.5", ",", "2.0", ",", "2.5", ",", "3.0", ",", 
     "3.5", ",", "4.0", ",", "4.5", ",", "5.0", ",", "5.5"}], "}"}]}], 
  ";"}], "\n", 
 RowBox[{
  RowBox[{"Alpha", "=", "5"}], ";"}]}], "Input",
 CellTags->"Constructors",
 CellLabel->"In[4]:=",
 CellID->102154210],

Cell[CellGroupData[{

Cell["obj=AlphaFormInverseLinear[RateTimes,Alpha]", "Input",
 CellLabel->"In[6]:=",
 CellID->812957420],

Cell[BoxData["AlphaFormInverseLinear1"], "Output",
 CellChangeTimes->{3.4360685156875*^9, 3.43609606890625*^9},
 CellLabel->"Out[6]=",
 CellID->69247828]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["AlphaFormLinearHyperbolic", "Subsection",
 CellID->184290799],

Cell[BoxData[GridBox[{
   {"RateTimes", 
    RowBox[{
    "0.5", ",", "1.0", ",", "1.5", ",", "2.0", ",", "2.5", ",", "3.0", ",", 
     "3.5", ",", "4.0", ",", "4.5", ",", "5.0", ",", "5.5"}], 
    RowBox[{"rate", " ", "fixing", " ", 
     RowBox[{"times", "."}]}]},
   {"Alpha", "5", 
    RowBox[{"alpha", " ", 
     RowBox[{"coefficient", "."}]}]}
  }]], "DefinitionBox3Col",
 CellID->42587283],

Cell[BoxData[{
 RowBox[{
  RowBox[{"RateTimes", "=", 
   RowBox[{"{", 
    RowBox[{
    "0.5", ",", "1.0", ",", "1.5", ",", "2.0", ",", "2.5", ",", "3.0", ",", 
     "3.5", ",", "4.0", ",", "4.5", ",", "5.0", ",", "5.5"}], "}"}]}], 
  ";"}], "\n", 
 RowBox[{
  RowBox[{"Alpha", "=", "5"}], ";"}]}], "Input",
 CellLabel->"In[7]:=",
 CellID->32891236],

Cell[CellGroupData[{

Cell["obj=AlphaFormLinearHyperbolic[RateTimes,Alpha]", "Input",
 CellLabel->"In[9]:=",
 CellID->195109260],

Cell[BoxData["AlphaFormLinearHyperbolic1"], "Output",
 CellChangeTimes->{3.43606851571875*^9, 3.436096072359375*^9},
 CellLabel->"Out[9]=",
 CellID->467820842]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["AlphaFormOperator", "Subsection",
 CellTags->"Member",
 CellID->950427],

Cell[BoxData[GridBox[{
   {"Time", "0", 
    RowBox[{
     RowBox[{"integer", " ", "corresponding", " ", "to", " ", "i"}], "-", 
     RowBox[{"th", " ", 
      RowBox[{"time", "."}]}]}]}
  }]], "DefinitionBox3Col",
 CellTags->"Member",
 CellID->31380412],

Cell[BoxData[
 RowBox[{
  RowBox[{"Time", "=", "0"}], ";"}]], "Input",
 CellTags->"Member",
 CellLabel->"In[10]:=",
 CellID->426550327],

Cell[CellGroupData[{

Cell["AlphaFormOperator[obj,Time]", "Input",
 CellTags->"Member",
 CellLabel->"In[11]:=",
 CellID->33408293],

Cell[BoxData["0.22075791541661138`"], "Output",
 CellChangeTimes->{3.436068515796875*^9, 3.43609607559375*^9},
 CellTags->"Member",
 CellLabel->"Out[11]=",
 CellID->197456478]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["AlphaFormSetAlpha", "Subsection",
 CellTags->"Member",
 CellID->401496050],

Cell[BoxData[GridBox[{
   {"Alpha", "1", 
    RowBox[{
    "Alpha", " ", "parameter", " ", "value", " ", "for", " ", "Alpha", " ", 
     RowBox[{"Form", "."}]}]}
  }]], "DefinitionBox3Col",
 CellTags->"Member",
 CellID->814108326],

Cell[BoxData[
 RowBox[{
  RowBox[{"Alpha", "=", "1"}], ";"}]], "Input",
 CellTags->"Member",
 CellLabel->"In[12]:=",
 CellID->78294016],

Cell[CellGroupData[{

Cell["AlphaFormSetAlpha[obj,Alpha]", "Input",
 CellTags->"Member",
 CellLabel->"In[13]:=",
 CellID->535574640],

Cell[BoxData["True"], "Output",
 CellChangeTimes->{3.4360685158125*^9, 3.436096078546875*^9},
 CellTags->"Member",
 CellLabel->"Out[13]=",
 CellID->76730378]
}, Open  ]]
}, Open  ]]
}, Open  ]]
},
Editable->True,
WindowSize->{616, 750},
WindowMargins->{{Automatic, 962}, {Automatic, 30}},
DockedCells->FEPrivate`FrontEndResource[
 "FEExpressions", "HelpViewerToolbar"],
PageHeaders->{{None, None, None}, {None, None, 
   Cell[
    TextData[{
      Cell[
       TextData[{"Printed from [[YOUR APPLICATION'S NAME]] documentation "}], 
       "PageHeader"], 
      Cell[
       TextData[{
         CounterBox["Page"]}], "PageNumber"]}], 
    CellMargins -> {{Inherited, -29}, {Inherited, Inherited}}]}},
PageFooters->{{None, None, None}, {
   Cell[
    TextData[{"\[Copyright] 2008 Weber & Partner. All rights reserved."}], 
    "PageFooter"], None, None}},
TaggingRules->{"SearchTextTranslated" -> "", "SearchText" -> ""},
CreateCellID->True,
ShowCellTags->False,
FrontEndVersion->"6.0 for Microsoft Windows (32-bit) (May 21, 2008)",
StyleDefinitions->FrontEnd`FileName[{"Wolfram"}, "Reference.nb", 
  CharacterEncoding -> "WindowsANSI"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "Overview"->{
  Cell[590, 23, 79, 2, 99, "Chapter",
   CellTags->"Overview",
   CellID->67721959],
  Cell[672, 27, 108, 2, 44, "Text",
   CellTags->"Overview",
   CellID->150932558],
  Cell[783, 31, 114, 2, 45, "MathCaption",
   CellTags->"Overview",
   CellID->345308904],
  Cell[900, 35, 103, 3, 42, "Input",
   CellTags->"Overview",
   CellID->155644119],
  Cell[1006, 40, 157, 5, 64, "Text",
   CellTags->"Overview",
   CellID->187848946],
  Cell[1188, 49, 128, 3, 42, "Input",
   CellTags->"Overview",
   CellID->537523882],
  Cell[1319, 54, 298, 9, 50, "Output",
   CellTags->"Overview",
   CellID->389192321],
  Cell[1654, 68, 123, 3, 42, "Input",
   CellTags->"Overview",
   CellID->171636835],
  Cell[1780, 73, 284, 8, 50, "Output",
   CellTags->"Overview",
   CellID->674697302]},
 "Constructors"->{
  Cell[2565, 102, 377, 12, 61, "Input",
   CellTags->"Constructors",
   CellID->102154210]},
 "Member"->{
  Cell[4435, 175, 77, 2, 51, "Subsection",
   CellTags->"Member",
   CellID->950427],
  Cell[4515, 179, 254, 8, 73, "DefinitionBox3Col",
   CellTags->"Member",
   CellID->31380412],
  Cell[4772, 189, 135, 5, 28, "Input",
   CellTags->"Member",
   CellID->426550327],
  Cell[4932, 198, 108, 3, 28, "Input",
   CellTags->"Member",
   CellID->33408293],
  Cell[5043, 203, 175, 4, 36, "Output",
   CellTags->"Member",
   CellID->197456478],
  Cell[5267, 213, 80, 2, 51, "Subsection",
   CellTags->"Member",
   CellID->401496050],
  Cell[5350, 217, 230, 7, 73, "DefinitionBox3Col",
   CellTags->"Member",
   CellID->814108326],
  Cell[5583, 226, 135, 5, 28, "Input",
   CellTags->"Member",
   CellID->78294016],
  Cell[5743, 235, 110, 3, 28, "Input",
   CellTags->"Member",
   CellID->535574640],
  Cell[5856, 240, 157, 4, 36, "Output",
   CellTags->"Member",
   CellID->76730378]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"Overview", 7106, 280},
 {"Constructors", 7902, 308},
 {"Member", 8008, 312}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[590, 23, 79, 2, 99, "Chapter",
 CellTags->"Overview",
 CellID->67721959],
Cell[672, 27, 108, 2, 44, "Text",
 CellTags->"Overview",
 CellID->150932558],
Cell[783, 31, 114, 2, 45, "MathCaption",
 CellTags->"Overview",
 CellID->345308904],
Cell[900, 35, 103, 3, 42, "Input",
 CellTags->"Overview",
 CellID->155644119],
Cell[1006, 40, 157, 5, 64, "Text",
 CellTags->"Overview",
 CellID->187848946],
Cell[CellGroupData[{
Cell[1188, 49, 128, 3, 42, "Input",
 CellTags->"Overview",
 CellID->537523882],
Cell[1319, 54, 298, 9, 50, "Output",
 CellTags->"Overview",
 CellID->389192321]
}, Open  ]],
Cell[CellGroupData[{
Cell[1654, 68, 123, 3, 42, "Input",
 CellTags->"Overview",
 CellID->171636835],
Cell[1780, 73, 284, 8, 50, "Output",
 CellTags->"Overview",
 CellID->674697302]
}, Open  ]],
Cell[CellGroupData[{
Cell[2101, 86, 62, 1, 51, "Subsection",
 CellID->8596527],
Cell[2166, 89, 396, 11, 119, "DefinitionBox3Col",
 CellID->65034613],
Cell[2565, 102, 377, 12, 61, "Input",
 CellTags->"Constructors",
 CellID->102154210],
Cell[CellGroupData[{
Cell[2967, 118, 103, 2, 70, "Input",
 CellID->812957420],
Cell[3073, 122, 153, 3, 36, "Output",
 CellID->69247828]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[3275, 131, 67, 1, 51, "Subsection",
 CellID->184290799],
Cell[3345, 134, 396, 11, 119, "DefinitionBox3Col",
 CellID->42587283],
Cell[3744, 147, 349, 11, 47, "Input",
 CellID->32891236],
Cell[CellGroupData[{
Cell[4118, 162, 106, 2, 28, "Input",
 CellID->195109260],
Cell[4227, 166, 159, 3, 36, "Output",
 CellID->467820842]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[4435, 175, 77, 2, 51, "Subsection",
 CellTags->"Member",
 CellID->950427],
Cell[4515, 179, 254, 8, 73, "DefinitionBox3Col",
 CellTags->"Member",
 CellID->31380412],
Cell[4772, 189, 135, 5, 28, "Input",
 CellTags->"Member",
 CellID->426550327],
Cell[CellGroupData[{
Cell[4932, 198, 108, 3, 28, "Input",
 CellTags->"Member",
 CellID->33408293],
Cell[5043, 203, 175, 4, 36, "Output",
 CellTags->"Member",
 CellID->197456478]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[5267, 213, 80, 2, 51, "Subsection",
 CellTags->"Member",
 CellID->401496050],
Cell[5350, 217, 230, 7, 73, "DefinitionBox3Col",
 CellTags->"Member",
 CellID->814108326],
Cell[5583, 226, 135, 5, 28, "Input",
 CellTags->"Member",
 CellID->78294016],
Cell[CellGroupData[{
Cell[5743, 235, 110, 3, 28, "Input",
 CellTags->"Member",
 CellID->535574640],
Cell[5856, 240, 157, 4, 36, "Output",
 CellTags->"Member",
 CellID->76730378]
}, Open  ]]
}, Open  ]]
}, Open  ]]
}
]
*)

(* End of internal cache information *)
