(* Content-type: application/mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 6.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       145,          7]
NotebookDataLength[     35997,       1075]
NotebookOptionsPosition[     26601,        766]
NotebookOutlinePosition[     31922,        925]
CellTagsIndexPosition[     31460,        910]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell["Bonds", "Chapter",
 CellChangeTimes->{3.435902529037228*^9},
 CellTags->"Bonds Overview",
 CellID->369271790],

Cell[TextData[{
 "The first step is to load the ",
 StyleBox["QuantLib",
  FontSlant->"Italic"],
 " package. "
}], "MathCaption",
 CellChangeTimes->{{3.43566408859375*^9, 3.435664090359375*^9}},
 CellTags->"Bonds Overview",
 CellID->217925941],

Cell[BoxData[
 RowBox[{"Needs", "[", "\"\<QuantLib`\>\"", "]"}]], "Input",
 CellChangeTimes->{{3.43566006271875*^9, 3.435660082703125*^9}, {
   3.43566551115625*^9, 3.435665518796875*^9}, 3.435902544084103*^9},
 CellTags->"Bonds Overview",
 CellLabel->"In[2]:=",
 CellID->200187472],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Category", "[", "Bonds", "]"}]], "Input",
 CellChangeTimes->{3.435903019052853*^9},
 CellTags->"Bonds Overview",
 CellLabel->"In[3]:=",
 CellID->510695],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "Bond", ",", "BondAccrualDays", ",", "BondAccrualEndDate", ",", 
   "BondAccrualPeriod", ",", "BondAccrualStartDate", ",", "BondAccruedAmount",
    ",", "BondAccruedDays", ",", "BondAccruedPeriod", ",", 
   "BondAtmRateFromYieldTermStructure", ",", "BondBpsFromYield", ",", 
   "BondBpsFromYieldTermStructure", ",", "BondCalendar", ",", 
   "BondCleanPrice", ",", "BondCleanPriceFromYield", ",", 
   "BondCleanPriceFromYieldTermStructure", ",", "BondCleanPriceFromZSpread", 
   ",", "BondConvexityFromYield", ",", "BondCurrency", ",", "BondDescription",
    ",", "BondDurationFromYield", ",", "BondFlowAnalysis", ",", 
   "BondIsTradable", ",", "BondIssueDate", ",", "BondMaturityDate", ",", 
   "BondNextCashFlowAmount", ",", "BondNextCashFlowDate", ",", 
   "BondNextCouponRate", ",", "BondNotional", ",", "BondNotionals", ",", 
   "BondPreviousCashFlowAmount", ",", "BondPreviousCashFlowDate", ",", 
   "BondPreviousCouponRate", ",", "BondRedemptionAmount", ",", 
   "BondRedemptionDate", ",", "BondReferencePeriodEnd", ",", 
   "BondReferencePeriodStart", ",", "BondSetCouponPricer", ",", 
   "BondSetCouponPricers", ",", "BondSettlementDate", ",", 
   "BondSettlementDays", ",", "BondStartDate", ",", "BondYieldFromCleanPrice",
    ",", "BondZSpreadFromCleanPrice", ",", "CmsRateBond", ",", 
   "FixedRateBond", ",", "FixedRateBond2", ",", "FloatingRateBond", ",", 
   "ZeroCouponBond"}], "}"}]], "Output",
 CellTags->"Bonds Overview",
 CellLabel->"Out[3]=",
 CellID->171485138]
}, Open  ]],

Cell["There are several functions available to construct bonds", "Text",
 CellChangeTimes->{{3.435652644703125*^9, 3.435652663703125*^9}},
 CellTags->"Bonds Overview",
 CellID->38547467],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Select", "[", 
  RowBox[{
   RowBox[{"Category", "[", "Bonds", "]"}], ",", 
   RowBox[{
    RowBox[{"QLConstructor", "[", "#", "]"}], "&"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.435652296953125*^9, 3.43565233153125*^9}, {
  3.435652380375*^9, 3.4356523806875*^9}, {3.43565263409375*^9, 
  3.435652636078125*^9}},
 CellTags->"Bonds Overview",
 CellLabel->"In[4]:=",
 CellID->67846344],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "Bond", ",", "CmsRateBond", ",", "FixedRateBond", ",", "FixedRateBond2", 
   ",", "FloatingRateBond", ",", "ZeroCouponBond"}], "}"}]], "Output",
 CellTags->"Bonds Overview",
 CellLabel->"Out[4]=",
 CellID->27636218]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Select", "[", 
  RowBox[{
   RowBox[{"Category", "[", "Bonds", "]"}], ",", 
   RowBox[{
    RowBox[{"QLMember", "[", "#", "]"}], "&"}]}], "]"}]], "Input",
 CellLabel->"In[5]:=",
 CellID->441156391],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "BondCalendar", ",", "BondCleanPrice", ",", "BondCurrency", ",", 
   "BondDescription", ",", "BondFlowAnalysis", ",", "BondIsTradable", ",", 
   "BondIssueDate", ",", "BondMaturityDate", ",", "BondNotional", ",", 
   "BondNotionals", ",", "BondRedemptionAmount", ",", "BondRedemptionDate", 
   ",", "BondSetCouponPricer", ",", "BondSetCouponPricers", ",", 
   "BondSettlementDate", ",", "BondSettlementDays"}], "}"}]], "Output",
 CellLabel->"Out[5]=",
 CellID->169473680]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Select", "[", 
  RowBox[{
   RowBox[{"Category", "[", "Schedules", "]"}], ",", 
   RowBox[{
    RowBox[{"QLMember", "[", "#", "]"}], "&"}]}], "]"}]], "Input",
 CellLabel->"In[4]:=",
 CellID->314610079],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "ScheduleBDC", ",", "ScheduleCalendar", ",", "ScheduleDates", ",", 
   "ScheduleEmpty", ",", "ScheduleEndDate", ",", "ScheduleEndOfMonth", ",", 
   "ScheduleIsRegular", ",", "ScheduleNextDate", ",", "SchedulePreviousDate", 
   ",", "ScheduleRule", ",", "ScheduleSize", ",", "ScheduleStartDate", ",", 
   "ScheduleTenor", ",", "ScheduleTerminationDateBDC"}], "}"}]], "Output",
 CellLabel->"Out[4]=",
 CellID->446463151]
}, Open  ]],

Cell[CellGroupData[{

Cell["Zero Coupon Bonds", "Section",
 CellChangeTimes->{{3.435905166146603*^9, 3.435905172943478*^9}},
 CellTags->"Create Zero Coupon Bonds",
 CellID->30720178],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"Needs", "[", "\"\<QuantLib`\>\"", "]"}], "\[IndentingNewLine]", 
 RowBox[{"?", "ZeroCouponBond"}], "\[IndentingNewLine]", 
 RowBox[{"Options", "[", "ZeroCouponBond", "]"}]}], "Input",
 CellTags->"Create Zero Coupon Bonds",
 CellLabel->"In[1]:=",
 CellID->259294092],

Cell[BoxData[
 StyleBox["\<\"ZeroCouponBond[ObjecctId_Symbol,Currency_String,SettlementDays_\
Integer,Maturity_?DateQ] Construct an object of class ZeroCouponBond and \
return its id\\n      \\nObjectId: id of object to be created\\nDescription: \
bond description string. Default value = no description \
available.\\nCurrency: bond Currency.\\nSettlementDays: settlement \
days.\\nCalendar: holiday calendar (e.g. TARGET).\\nFaceAmount: Face nominal \
amount. Default value = 100.0.\\nMaturity: maturity date.\\nPaymentBDC: \
payment business day convention. Default value = Following.\\nRedemption: \
Redemption value. Default value = 100.\\nIssueDate: issue date: the bond \
can't be traded until then. Default value = Date[].\\nPermanent: object \
permanent/nonpermanent\"\>", "MSG"]], "Print", "PrintUsage",
 CellTags->{"Create Zero Coupon Bonds", "Info3563172401-7764841"},
 CellID->245154691],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"Description", "\[Rule]", "\<\"ZeroCouponBond\"\>"}], ",", 
   RowBox[{"Calendar", "\[Rule]", "\<\"Target\"\>"}], ",", 
   RowBox[{"FaceAmount", "\[Rule]", "100.`"}], ",", 
   RowBox[{"PaymentBDC", "\[Rule]", "\<\"Following\"\>"}], ",", 
   RowBox[{"Redemption", "\[Rule]", "100.`"}], ",", 
   RowBox[{"IssueDate", "\[RuleDelayed]", 
    RowBox[{"EvaluationDate", "[", "]"}]}], ",", 
   RowBox[{"Permanent", "\[Rule]", "True"}], ",", 
   RowBox[{"Overwrite", "\[Rule]", "True"}]}], "}"}]], "Output",
 CellTags->"Create Zero Coupon Bonds",
 CellLabel->"Out[3]=",
 CellID->102808039]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"zc", "=", 
   RowBox[{"ZeroCouponBond", "[", 
    RowBox[{"\"\<USD\>\"", ",", "1", ",", 
     RowBox[{"{", 
      RowBox[{"2018", ",", "11", ",", "17"}], "}"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"Information", "[", 
  RowBox[{"Evaluate", "[", "zc", "]"}], "]"}]}], "Input",
 CellChangeTimes->{{3.435905255068478*^9, 3.435905288365353*^9}, {
  3.435905520099728*^9, 3.435905529818478*^9}},
 CellTags->"Create Zero Coupon Bonds",
 CellLabel->"In[4]:=",
 CellID->304902811],

Cell[CellGroupData[{

Cell["Cell$$3080`ZeroCouponBond3", "Print", "PrintUsage",
 CellTags->{"Create Zero Coupon Bonds", "Info3563172405-7764841"},
 CellID->172208955],

Cell[BoxData[
 InterpretationBox[GridBox[{
    {GridBox[{
       {
        RowBox[{
         RowBox[{"BaseClass", "[", "ZeroCouponBond3", "]"}], 
         "^=", "\<\"\"\>"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"Calendar", "[", "ZeroCouponBond3", "]"}], "^=", "Target"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"Category", "[", "ZeroCouponBond3", "]"}], 
         "^=", "\<\"Bonds\"\>"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"ClassName", "[", "ZeroCouponBond3", "]"}], "^=", 
         "qlZeroCouponBond"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"Currency", "[", "ZeroCouponBond3", "]"}], "^=", "USD"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"Description", "[", "ZeroCouponBond3", "]"}], "^=", 
         "ZeroCouponBond"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"FaceAmount", "[", "ZeroCouponBond3", "]"}], "^=", "100.`"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"Instrument", "[", "ZeroCouponBond3", "]"}], "^=", "True"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"IsExpired", "[", "ZeroCouponBond3", "]"}], "^=", "False"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"IssueDate", "[", "ZeroCouponBond3", "]"}], "^=", "41242"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"Maturity", "[", "ZeroCouponBond3", "]"}], "^=", "43421"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"Overwrite", "[", "ZeroCouponBond3", "]"}], "^=", "True"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"PaymentBDC", "[", "ZeroCouponBond3", "]"}], "^=", 
         "Following"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"Permanent", "[", "ZeroCouponBond3", "]"}], "^=", "True"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"PrecedentObjects", "[", "ZeroCouponBond3", "]"}], "^=", 
         RowBox[{"{", "}"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"Processor", "[", "ZeroCouponBond3", "]"}], 
         "^=", "\<\"DefaultProcessor\"\>"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"Redemption", "[", "ZeroCouponBond3", "]"}], "^=", "100.`"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"SettlementDays", "[", "ZeroCouponBond3", "]"}], "^=", "1"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"ValueObject", "[", "ZeroCouponBond3", "]"}], "^=", 
         "qlZeroCouponBond"}]}
      },
      BaselinePosition->{Baseline, {1, 1}},
      GridBoxAlignment->{
       "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
        "RowsIndexed" -> {}},
      GridBoxItemSize->{"Columns" -> {{
           Scaled[0.999]}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
        "RowsIndexed" -> {}}]}
   },
   BaselinePosition->{Baseline, {1, 1}},
   GridBoxAlignment->{
    "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
     "RowsIndexed" -> {}}],
  Definition[$CellContext`ZeroCouponBond3],
  Editable->False]], "Print",
 CellTags->{"Create Zero Coupon Bonds", "Info3563172405-7764841"},
 CellID->2689679]
}, Open  ]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Fixed Rate Bond", "Section",
 CellChangeTimes->{{3.435905334068478*^9, 3.435905338287228*^9}},
 CellTags->"Fixed Rate Bonds",
 CellID->148967684],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"Needs", "[", "\"\<QuantLib`\>\"", "]"}], "\[IndentingNewLine]", 
 RowBox[{"?", "FixedRateBond"}], "\[IndentingNewLine]", 
 RowBox[{"Options", "[", "FixedRateBond", "]"}]}], "Input",
 CellLabel->"In[1]:=",
 CellID->65970189],

Cell[BoxData[
 StyleBox["\<\"FixedRateBond[ScheduleID_Symbol,Coupon_?NumberQ]\\\
nFixedRateBond[ObjecctId_Symbol,ScheduleID_Symbol,Coupon_?NumberQ]\\\
nFixedRateBond[ScheduleID_Symbol,Coupons_List]\\nFixedRateBond[ObjecctId_\
Symbol,ScheduleID_Symbol,Coupons_List] Construct an object of class \
FixedRateBond and return its id\\n      \\nObjectId: id of object to be \
created\\nDescription: bond description string. Default value = no \
description available.\\nCurrency: bond Currency.\\nSettlementDays: \
settlement days.\\nFaceAmount: Face nominal amount. Default value = \
100.0.\\nScheduleID: Schedule object ID.\\nCoupons: simple annual compounding \
coupon rates.\\nDayCounter: Payment DayCounter ID.\\nPaymentBDC: payment \
business day convention. Default value = Following.\\nRedemption: Redemption \
value. Default value = 100.0.\\nIssueDate: issue date: the bond can't be \
traded until then. Default value = Date[].\\nPaymentCalendar: payment holiday \
calendar (e.g. TARGET).\\nPermanent: object permanent/nonpermanent\"\>", 
  "MSG"]], "Print", "PrintUsage",
 CellTags->"Info3563172424-7764841",
 CellID->284759728],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"Description", "\[Rule]", "\<\"FixedRateBond\"\>"}], ",", 
   RowBox[{"Currency", "\[Rule]", "\<\"NullCurrency\"\>"}], ",", 
   RowBox[{"SettlementDays", "\[Rule]", "2"}], ",", 
   RowBox[{"FaceAmount", "\[Rule]", "100.`"}], ",", 
   RowBox[{"DayCounter", "\[Rule]", "\<\"Actual/365 (Fixed)\"\>"}], ",", 
   RowBox[{"PaymentBDC", "\[Rule]", "\<\"Following\"\>"}], ",", 
   RowBox[{"Redemption", "\[Rule]", "100.`"}], ",", 
   RowBox[{"IssueDate", "\[RuleDelayed]", 
    RowBox[{"EvaluationDate", "[", "]"}]}], ",", 
   RowBox[{"PaymentCalendar", "\[Rule]", "\<\"Target\"\>"}], ",", 
   RowBox[{"Permanent", "\[Rule]", "True"}], ",", 
   RowBox[{"Overwrite", "\[Rule]", "True"}]}], "}"}]], "Output",
 CellLabel->"Out[3]=",
 CellID->103526098]
}, Open  ]],

Cell["\<\
For the creation of a fixed rate bond a payment schedule is required\
\>", "Text",
 CellChangeTimes->{{3.435920757693478*^9, 3.435920789396603*^9}},
 CellID->100995126],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"sdl", " ", "=", 
  RowBox[{"Schedule", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"2008", ",", "11", ",", "15"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"2018", ",", "11", ",", "18"}], "}"}], ",", "\"\<1Y\>\""}], 
   "]"}]}]], "Input",
 CellLabel->"In[4]:=",
 CellID->270793424],

Cell[BoxData["Schedule4"], "Output",
 CellLabel->"Out[4]=",
 CellID->203184999]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"fixed", " ", "=", 
   RowBox[{"FixedRateBond", "[", 
    RowBox[{"sdl", ",", "0.05"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"Information", "[", 
  RowBox[{"Evaluate", "[", "%", "]"}], "]"}]}], "Input",
 CellLabel->"In[9]:=",
 CellID->279530270],

Cell[CellGroupData[{

Cell["Cell$$3087`FixedRateBond5", "Print", "PrintUsage",
 CellTags->"Info3563172506-7764841",
 CellID->553212542],

Cell[BoxData[
 InterpretationBox[GridBox[{
    {GridBox[{
       {
        RowBox[{
         RowBox[{"Cell$$3080`BaseClass", "[", "FixedRateBond5", "]"}], 
         "^=", "\<\"\"\>"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"Category", "[", "FixedRateBond5", "]"}], 
         "^=", "\<\"Bonds\"\>"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"Cell$$3080`ClassName", "[", "FixedRateBond5", "]"}], "^=", 
         "qlFixedRateBond"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"Currency", "[", "FixedRateBond5", "]"}], "^=", 
         "NullCurrency"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"DayCounter", "[", "FixedRateBond5", "]"}], 
         "^=", "\<\"Actual/365 (Fixed)\"\>"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"Description", "[", "FixedRateBond5", "]"}], "^=", 
         "FixedRateBond"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"FaceAmount", "[", "FixedRateBond5", "]"}], "^=", "100.`"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"Instrument", "[", "FixedRateBond5", "]"}], "^=", "True"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"Cell$$3080`IsExpired", "[", "FixedRateBond5", "]"}], "^=", 
         "False"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"IssueDate", "[", "FixedRateBond5", "]"}], "^=", "41242"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"Overwrite", "[", "FixedRateBond5", "]"}], "^=", "True"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"PaymentBDC", "[", "FixedRateBond5", "]"}], "^=", 
         "Cell$$3080`Following"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"PaymentCalendar", "[", "FixedRateBond5", "]"}], "^=", 
         "Cell$$3080`Target"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"Permanent", "[", "FixedRateBond5", "]"}], "^=", "True"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"PrecedentObjects", "[", "FixedRateBond5", "]"}], "^=", 
         RowBox[{"{", "\<\"Schedule4\"\>", "}"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"Cell$$3080`Processor", "[", "FixedRateBond5", "]"}], 
         "^=", "\<\"DefaultProcessor\"\>"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"Redemption", "[", "FixedRateBond5", "]"}], "^=", "100.`"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"ScheduleID", "[", "FixedRateBond5", "]"}], "^=", 
         "Schedule4"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"SettlementDays", "[", "FixedRateBond5", "]"}], "^=", "2"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"Cell$$3080`ValueObject", "[", "FixedRateBond5", "]"}], "^=",
          "qlFixedRateBond"}]}
      },
      BaselinePosition->{Baseline, {1, 1}},
      GridBoxAlignment->{
       "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
        "RowsIndexed" -> {}},
      GridBoxItemSize->{"Columns" -> {{
           Scaled[0.999]}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
        "RowsIndexed" -> {}}]}
   },
   BaselinePosition->{Baseline, {1, 1}},
   GridBoxAlignment->{
    "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
     "RowsIndexed" -> {}}],
  Definition[$CellContext`FixedRateBond5],
  Editable->False]], "Print",
 CellTags->"Info3563172506-7764841",
 CellID->400843730]
}, Open  ]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["FloatingRateBond", "Section",
 CellChangeTimes->{{3.435921965068478*^9, 3.435921972349728*^9}, {
  3.435922034990353*^9, 3.435922035912228*^9}},
 CellTags->"FloatingRateBond",
 CellID->90586741],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"Needs", "[", "\"\<QuantLib`\>\"", "]"}], "\[IndentingNewLine]", 
 RowBox[{"?", "FloatingRateBond"}], "\[IndentingNewLine]", 
 RowBox[{"Options", "[", "FloatingRateBond", "]"}]}], "Input",
 CellTags->"FloatingRateBond",
 CellLabel->"In[1]:=",
 CellID->57965481],

Cell[BoxData[
 StyleBox["\<\"FloatingRateBond[ObjecctId_Symbol,Currency_String,\
SettlementDays_Integer,ScheduleID_Symbol,DayCounter_String,Floors_List /; \
VectorQ[Floors, NumberQ],Gearings_List /; VectorQ[Gearings, \
NumberQ],IborIndex_Symbol,Spreads_List /; VectorQ[Spreads, NumberQ],Caps_List \
/; VectorQ[Caps, NumberQ]] Construct an object of class FloatingRateBond and \
return its id\\n      \\nObjectId: id of object to be created\\nDescription: \
bond description string. Default value = no description \
available.\\nCurrency: bond Currency.\\nSettlementDays: settlement \
days.\\nPaymentBDC: payment business day convention. Default value = \
Following.\\nFaceAmount: Face nominal amount. Default value = \
100.0.\\nScheduleID: Schedule object ID.\\nFixingDays: fixing days (e.g. 2). \
Default value = QuantLib::Null<QuantLib::Natural>().\\nIsInArrears: TRUE if \
the fixing is in arrears. Default value = false.\\nDayCounter: Payment \
DayCounter ID.\\nFloors: floor strikes. Default value = \
std::vector<QuantLib::Rate>().\\nGearings: floating rate gearings. Default \
value = 1.0.\\nIborIndex: floating rate index.\\nSpreads: floating rate \
spreads. Default value = 0.0.\\nCaps: cap strikes. Default value = \
std::vector<QuantLib::Rate>().\\nRedemption: Redemption value. Default value \
= 100.\\nIssueDate: issue date: the bond can't be traded until then. Default \
value = Date[].\\nPermanent: object permanent/nonpermanent\"\>", 
  "MSG"]], "Print", "PrintUsage",
 CellTags->{"FloatingRateBond", "Info3563172517-7764841"},
 CellID->49376079],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"Description", "\[Rule]", "\<\"FloatingRateBond\"\>"}], ",", 
   RowBox[{"PaymentBDC", "\[Rule]", "\<\"Following\"\>"}], ",", 
   RowBox[{"FaceAmount", "\[Rule]", "100.`"}], ",", 
   RowBox[{"FixingDays", "\[Rule]", "0"}], ",", 
   RowBox[{"IsInArrears", "\[Rule]", "False"}], ",", 
   RowBox[{"DayCounter", "\[Rule]", "\<\"Actual/365 (Fixed)\"\>"}], ",", 
   RowBox[{"Redemption", "\[Rule]", "100.`"}], ",", 
   RowBox[{"IssueDate", "\[RuleDelayed]", 
    RowBox[{"EvaluationDate", "[", "]"}]}], ",", 
   RowBox[{"Permanent", "\[Rule]", "True"}], ",", 
   RowBox[{"Overwrite", "\[Rule]", "True"}]}], "}"}]], "Output",
 CellTags->"FloatingRateBond",
 CellLabel->"Out[3]=",
 CellID->146373087]
}, Open  ]],

Cell["\<\
For the creation of a floating rate bond a payment schedule is required\
\>", "Text",
 CellChangeTimes->{{3.435920757693478*^9, 3.435920789396603*^9}, {
  3.435925573568478*^9, 3.435925577505978*^9}},
 CellID->539697457],

Cell[BoxData[{
 RowBox[{
  RowBox[{"sdl", " ", "=", 
   RowBox[{"Schedule", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"2008", ",", "11", ",", "15"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2018", ",", "11", ",", "18"}], "}"}], ",", "\"\<1Y\>\""}], 
    "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"ibor", "=", " ", 
   RowBox[{"IborIndex", "[", 
    RowBox[{
    "\"\<Test\>\"", ",", "\"\<2D\>\"", ",", "2", ",", "\"\<USD\>\"", ",", 
     "\"\<Following\>\"", ",", "True", ",", "\"\<30/360\>\"", ",", 
     RowBox[{"YieldCurve", "\[Rule]", 
      RowBox[{"FlatForward", "[", "0.04", "]"}]}]}], "]"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"SettlementDays", " ", "=", "2"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Floors", " ", "=", " ", 
   RowBox[{"{", "0.", "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Gearings", " ", "=", 
   RowBox[{"{", "1.", "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Caps", " ", "=", " ", 
   RowBox[{"{", "1.", "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Spreads", " ", "=", " ", 
   RowBox[{"{", "0.", "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Currency", "=", "\"\<USD\>\""}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"DayCounter", " ", "=", " ", "\"\<30/360\>\""}], ";"}]}], "Input",
 CellLabel->"In[4]:=",
 CellID->66020150],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"frb", " ", "=", 
  RowBox[{"FloatingRateBond", "[", 
   RowBox[{
   "Currency", ",", "SettlementDays", ",", "sdl", ",", "DayCounter", ",", 
    "Floors", ",", "Gearings", ",", "ibor", ",", "Spreads", ",", "Caps"}], 
   "]"}], "  "}]], "Input",
 CellChangeTimes->{{3.435928521834103*^9, 3.435928601990353*^9}, {
  3.435928644115353*^9, 3.435928648380978*^9}, {3.435928763130978*^9, 
  3.435928782334103*^9}},
 CellLabel->"In[13]:=",
 CellID->96594688],

Cell[BoxData["FloatingRateBond9"], "Output",
 CellLabel->"Out[13]=",
 CellID->160766169]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"FloatingRateBond", "[", 
   RowBox[{
   "Currency", ",", "SettlementDays", ",", "sdl", ",", "DayCounter", ",", 
    RowBox[{"{", "}"}], ",", 
    RowBox[{"{", "}"}], ",", "ibor", ",", 
    RowBox[{"{", "}"}], ",", 
    RowBox[{"{", "}"}]}], "]"}], "  "}]], "Input",
 CellChangeTimes->{{3.435928805459103*^9, 3.435928828834103*^9}, 
   3.435928861834103*^9},
 CellLabel->"In[14]:=",
 CellID->2121708],

Cell[BoxData["FloatingRateBond10"], "Output",
 CellLabel->"Out[14]=",
 CellID->10820787]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["CMSBond", "Section",
 CellChangeTimes->{{3.435921890490353*^9, 3.435921892662228*^9}},
 CellTags->"CMSBond",
 CellID->378734303],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"Needs", "[", "\"\<QuantLib`\>\"", "]"}], "\[IndentingNewLine]", 
 RowBox[{"?", "CmsRateBond"}], "\[IndentingNewLine]", 
 RowBox[{"Options", "[", "CmsRateBond", "]"}]}], "Input",
 CellTags->"CMSBond",
 CellLabel->"In[1]:=",
 CellID->13163482],

Cell[BoxData[
 StyleBox["\<\"CmsRateBond[ObjecctId_Symbol,Currency_String,SettlementDays_\
Integer,ScheduleID_Symbol,DayCounter_String,Floors_List /; VectorQ[Floors, \
NumberQ],Gearings_List /; VectorQ[Gearings, \
NumberQ],SwapIndex_Symbol,Spreads_List /; VectorQ[Spreads, NumberQ],Caps_List \
/; VectorQ[Caps, NumberQ]] Construct an object of class CmsRateBond and \
return its id\\n      \\nObjectId: id of object to be created\\nDescription: \
bond description string. Default value = no description \
available.\\nCurrency: bond Currency.\\nSettlementDays: settlement \
days.\\nPaymentBDC: payment business day convention. Default value = \
Following.\\nFaceAmount: Face nominal amount. Default value = \
100.0.\\nScheduleID: Schedule object ID.\\nFixingDays: fixing days (e.g. 2). \
Default value = QuantLib::Null<QuantLib::Natural>().\\nIsInArrears: TRUE if \
the fixing is in arrears. Default value = false.\\nDayCounter: Payment \
DayCounter ID.\\nFloors: floor strikes. Default value = \
std::vector<QuantLib::Rate>().\\nGearings: floating rate gearings. Default \
value = 1.0.\\nSwapIndex: floating swap rate index.\\nSpreads: floating rate \
spreads. Default value = 0.0.\\nCaps: cap strikes. Default value = \
std::vector<QuantLib::Rate>().\\nRedemption: Redemption value. Default value \
= 100.\\nIssueDate: issue date: the bond can't be traded until then. Default \
value = Date[].\\nPermanent: object permanent/nonpermanent\"\>", 
  "MSG"]], "Print", "PrintUsage",
 CellTags->{"CMSBond", "Info3563172540-7764841"},
 CellID->26721802],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"Description", "\[Rule]", "\<\"CmsRateBond\"\>"}], ",", 
   RowBox[{"PaymentBDC", "\[Rule]", "\<\"Following\"\>"}], ",", 
   RowBox[{"FaceAmount", "\[Rule]", "100.`"}], ",", 
   RowBox[{"FixingDays", "\[Rule]", "0"}], ",", 
   RowBox[{"IsInArrears", "\[Rule]", "False"}], ",", 
   RowBox[{"\<\"30/360\"\>", "\[Rule]", "\<\"Actual/365 (Fixed)\"\>"}], ",", 
   RowBox[{"Redemption", "\[Rule]", "100.`"}], ",", 
   RowBox[{"IssueDate", "\[RuleDelayed]", 
    RowBox[{"EvaluationDate", "[", "]"}]}], ",", 
   RowBox[{"Permanent", "\[Rule]", "True"}], ",", 
   RowBox[{"Overwrite", "\[Rule]", "True"}]}], "}"}]], "Output",
 CellTags->"CMSBond",
 CellLabel->"Out[3]=",
 CellID->408056151]
}, Open  ]]
}, Open  ]]
}, Open  ]]
},
FileChangeProtection->None,
Editable->True,
WindowToolbars->"EditBar",
WindowSize->{765, 834},
WindowMargins->{{140, Automatic}, {Automatic, -4}},
DockedCells->FEPrivate`FrontEndResource["FEExpressions", "HelpViewerToolbar"],
PageHeaders->{{None, None, None}, {None, None, 
   Cell[
    TextData[{
      Cell[
       TextData[{"Printed from [[YOUR APPLICATION'S NAME]] documentation "}], 
       "PageHeader"], 
      Cell[
       TextData[{
         CounterBox["Page"]}], "PageNumber"]}], 
    CellMargins -> {{Inherited, -29}, {Inherited, Inherited}}]}},
PageFooters->{{None, None, None}, {
   Cell[
    TextData[{"\[Copyright] 2008 Weber & Partner. All rights reserved."}], 
    "PageFooter"], None, None}},
ShowSelection->True,
TaggingRules->{
 "SearchTextTranslated" -> "", "SearchText" -> "", "LinkTrails" -> ""},
CreateCellID->True,
ShowCellTags->False,
FrontEndVersion->"8.0 for Microsoft Windows (32-bit) (October 6, 2011)",
StyleDefinitions->FrontEnd`FileName[{"Wolfram"}, "Reference.nb", 
  CharacterEncoding -> "WindowsANSI"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "Bonds Overview"->{
  Cell[567, 22, 115, 3, 85, "Chapter",
   CellTags->"Bonds Overview",
   CellID->369271790],
  Cell[685, 27, 243, 8, 31, "MathCaption",
   CellTags->"Bonds Overview",
   CellID->217925941],
  Cell[931, 37, 282, 6, 28, "Input",
   CellTags->"Bonds Overview",
   CellID->200187472],
  Cell[1238, 47, 176, 5, 28, "Input",
   CellTags->"Bonds Overview",
   CellID->510695],
  Cell[1417, 54, 1525, 26, 224, "Output",
   CellTags->"Bonds Overview",
   CellID->171485138],
  Cell[2957, 83, 186, 3, 30, "Text",
   CellTags->"Bonds Overview",
   CellID->38547467],
  Cell[3168, 90, 411, 11, 28, "Input",
   CellTags->"Bonds Overview",
   CellID->67846344],
  Cell[3582, 103, 257, 7, 36, "Output",
   CellTags->"Bonds Overview",
   CellID->27636218]},
 "Create Zero Coupon Bonds"->{
  Cell[5375, 162, 160, 3, 51, "Section",
   CellTags->"Create Zero Coupon Bonds",
   CellID->30720178],
  Cell[5560, 169, 290, 6, 65, "Input",
   CellTags->"Create Zero Coupon Bonds",
   CellID->259294092],
  Cell[5853, 177, 900, 13, 236, "Print",
   CellTags->{"Create Zero Coupon Bonds", "Info3563172401-7764841"},
   CellID->245154691],
  Cell[6756, 192, 632, 14, 54, "Output",
   CellTags->"Create Zero Coupon Bonds",
   CellID->102808039],
  Cell[7425, 211, 526, 14, 47, "Input",
   CellTags->"Create Zero Coupon Bonds",
   CellID->304902811],
  Cell[7976, 229, 144, 2, 42, "Print",
   CellTags->{"Create Zero Coupon Bonds", "Info3563172405-7764841"},
   CellID->172208955],
  Cell[8123, 233, 3130, 102, 563, "Print",
   CellTags->{"Create Zero Coupon Bonds", "Info3563172405-7764841"},
   CellID->2689679]},
 "Info3563172401-7764841"->{
  Cell[5853, 177, 900, 13, 236, "Print",
   CellTags->{"Create Zero Coupon Bonds", "Info3563172401-7764841"},
   CellID->245154691]},
 "Info3563172405-7764841"->{
  Cell[7976, 229, 144, 2, 42, "Print",
   CellTags->{"Create Zero Coupon Bonds", "Info3563172405-7764841"},
   CellID->172208955],
  Cell[8123, 233, 3130, 102, 563, "Print",
   CellTags->{"Create Zero Coupon Bonds", "Info3563172405-7764841"},
   CellID->2689679]},
 "Fixed Rate Bonds"->{
  Cell[11314, 342, 151, 3, 51, "Section",
   CellTags->"Fixed Rate Bonds",
   CellID->148967684]},
 "Info3563172424-7764841"->{
  Cell[11741, 356, 1132, 17, 311, "Print",
   CellTags->"Info3563172424-7764841",
   CellID->284759728]},
 "Info3563172506-7764841"->{
  Cell[14635, 433, 113, 2, 42, "Print",
   CellTags->"Info3563172506-7764841",
   CellID->553212542],
  Cell[14751, 437, 3389, 111, 593, "Print",
   CellTags->"Info3563172506-7764841",
   CellID->400843730]},
 "FloatingRateBond"->{
  Cell[18201, 555, 200, 4, 51, "Section",
   CellTags->"FloatingRateBond",
   CellID->90586741],
  Cell[18426, 563, 285, 6, 65, "Input",
   CellTags->"FloatingRateBond",
   CellID->57965481],
  Cell[18714, 571, 1562, 23, 371, "Print",
   CellTags->{"FloatingRateBond", "Info3563172517-7764841"},
   CellID->49376079],
  Cell[20279, 596, 743, 16, 71, "Output",
   CellTags->"FloatingRateBond",
   CellID->146373087]},
 "Info3563172517-7764841"->{
  Cell[18714, 571, 1562, 23, 371, "Print",
   CellTags->{"FloatingRateBond", "Info3563172517-7764841"},
   CellID->49376079]},
 "CMSBond"->{
  Cell[23849, 705, 134, 3, 51, "Section",
   CellTags->"CMSBond",
   CellID->378734303],
  Cell[24008, 712, 266, 6, 65, "Input",
   CellTags->"CMSBond",
   CellID->13163482],
  Cell[24277, 720, 1548, 23, 371, "Print",
   CellTags->{"CMSBond", "Info3563172540-7764841"},
   CellID->26721802],
  Cell[25828, 745, 733, 16, 71, "Output",
   CellTags->"CMSBond",
   CellID->408056151]},
 "Info3563172540-7764841"->{
  Cell[24277, 720, 1548, 23, 371, "Print",
   CellTags->{"CMSBond", "Info3563172540-7764841"},
   CellID->26721802]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"Bonds Overview", 27759, 800},
 {"Create Zero Coupon Bonds", 28532, 825},
 {"Info3563172401-7764841", 29375, 847},
 {"Info3563172405-7764841", 29538, 851},
 {"Fixed Rate Bonds", 29826, 858},
 {"Info3563172424-7764841", 29954, 862},
 {"Info3563172506-7764841", 30089, 866},
 {"FloatingRateBond", 30321, 873},
 {"Info3563172517-7764841", 30767, 886},
 {"CMSBond", 30908, 890},
 {"Info3563172540-7764841", 31319, 903}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[567, 22, 115, 3, 85, "Chapter",
 CellTags->"Bonds Overview",
 CellID->369271790],
Cell[685, 27, 243, 8, 31, "MathCaption",
 CellTags->"Bonds Overview",
 CellID->217925941],
Cell[931, 37, 282, 6, 28, "Input",
 CellTags->"Bonds Overview",
 CellID->200187472],
Cell[CellGroupData[{
Cell[1238, 47, 176, 5, 28, "Input",
 CellTags->"Bonds Overview",
 CellID->510695],
Cell[1417, 54, 1525, 26, 224, "Output",
 CellTags->"Bonds Overview",
 CellID->171485138]
}, Open  ]],
Cell[2957, 83, 186, 3, 30, "Text",
 CellTags->"Bonds Overview",
 CellID->38547467],
Cell[CellGroupData[{
Cell[3168, 90, 411, 11, 28, "Input",
 CellTags->"Bonds Overview",
 CellID->67846344],
Cell[3582, 103, 257, 7, 36, "Output",
 CellTags->"Bonds Overview",
 CellID->27636218]
}, Open  ]],
Cell[CellGroupData[{
Cell[3876, 115, 221, 7, 28, "Input",
 CellID->441156391],
Cell[4100, 124, 513, 10, 88, "Output",
 CellID->169473680]
}, Open  ]],
Cell[CellGroupData[{
Cell[4650, 139, 225, 7, 28, "Input",
 CellID->314610079],
Cell[4878, 148, 460, 9, 71, "Output",
 CellID->446463151]
}, Open  ]],
Cell[CellGroupData[{
Cell[5375, 162, 160, 3, 51, "Section",
 CellTags->"Create Zero Coupon Bonds",
 CellID->30720178],
Cell[CellGroupData[{
Cell[5560, 169, 290, 6, 65, "Input",
 CellTags->"Create Zero Coupon Bonds",
 CellID->259294092],
Cell[5853, 177, 900, 13, 236, "Print",
 CellTags->{"Create Zero Coupon Bonds", "Info3563172401-7764841"},
 CellID->245154691],
Cell[6756, 192, 632, 14, 54, "Output",
 CellTags->"Create Zero Coupon Bonds",
 CellID->102808039]
}, Open  ]],
Cell[CellGroupData[{
Cell[7425, 211, 526, 14, 47, "Input",
 CellTags->"Create Zero Coupon Bonds",
 CellID->304902811],
Cell[CellGroupData[{
Cell[7976, 229, 144, 2, 42, "Print",
 CellTags->{"Create Zero Coupon Bonds", "Info3563172405-7764841"},
 CellID->172208955],
Cell[8123, 233, 3130, 102, 563, "Print",
 CellTags->{"Create Zero Coupon Bonds", "Info3563172405-7764841"},
 CellID->2689679]
}, Open  ]]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[11314, 342, 151, 3, 51, "Section",
 CellTags->"Fixed Rate Bonds",
 CellID->148967684],
Cell[CellGroupData[{
Cell[11490, 349, 248, 5, 65, "Input",
 CellID->65970189],
Cell[11741, 356, 1132, 17, 311, "Print",
 CellTags->"Info3563172424-7764841",
 CellID->284759728],
Cell[12876, 375, 792, 16, 88, "Output",
 CellID->103526098]
}, Open  ]],
Cell[13683, 394, 178, 4, 30, "Text",
 CellID->100995126],
Cell[CellGroupData[{
Cell[13886, 402, 313, 10, 28, "Input",
 CellID->270793424],
Cell[14202, 414, 79, 2, 36, "Output",
 CellID->203184999]
}, Open  ]],
Cell[CellGroupData[{
Cell[14318, 421, 292, 8, 47, "Input",
 CellID->279530270],
Cell[CellGroupData[{
Cell[14635, 433, 113, 2, 42, "Print",
 CellTags->"Info3563172506-7764841",
 CellID->553212542],
Cell[14751, 437, 3389, 111, 593, "Print",
 CellTags->"Info3563172506-7764841",
 CellID->400843730]
}, Open  ]]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[18201, 555, 200, 4, 51, "Section",
 CellTags->"FloatingRateBond",
 CellID->90586741],
Cell[CellGroupData[{
Cell[18426, 563, 285, 6, 65, "Input",
 CellTags->"FloatingRateBond",
 CellID->57965481],
Cell[18714, 571, 1562, 23, 371, "Print",
 CellTags->{"FloatingRateBond", "Info3563172517-7764841"},
 CellID->49376079],
Cell[20279, 596, 743, 16, 71, "Output",
 CellTags->"FloatingRateBond",
 CellID->146373087]
}, Open  ]],
Cell[21037, 615, 230, 5, 30, "Text",
 CellID->539697457],
Cell[21270, 622, 1378, 37, 191, "Input",
 CellID->66020150],
Cell[CellGroupData[{
Cell[22673, 663, 474, 11, 47, "Input",
 CellID->96594688],
Cell[23150, 676, 88, 2, 36, "Output",
 CellID->160766169]
}, Open  ]],
Cell[CellGroupData[{
Cell[23275, 683, 434, 12, 28, "Input",
 CellID->2121708],
Cell[23712, 697, 88, 2, 36, "Output",
 CellID->10820787]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[23849, 705, 134, 3, 51, "Section",
 CellTags->"CMSBond",
 CellID->378734303],
Cell[CellGroupData[{
Cell[24008, 712, 266, 6, 65, "Input",
 CellTags->"CMSBond",
 CellID->13163482],
Cell[24277, 720, 1548, 23, 371, "Print",
 CellTags->{"CMSBond", "Info3563172540-7764841"},
 CellID->26721802],
Cell[25828, 745, 733, 16, 71, "Output",
 CellTags->"CMSBond",
 CellID->408056151]
}, Open  ]]
}, Open  ]]
}, Open  ]]
}
]
*)

(* End of internal cache information *)
