(* Content-type: application/mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 6.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       145,          7]
NotebookDataLength[     44614,       1491]
NotebookOptionsPosition[     32990,       1076]
NotebookOutlinePosition[     38746,       1269]
CellTagsIndexPosition[     38587,       1261]
WindowFrame->Normal
ContainsDynamic->False*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell["CouponVectors", "Chapter",
 CellTags->"Overview",
 CellID->334491741],

Cell["functions to construct and use Leg objects.", "Text",
 CellTags->"Overview",
 CellID->225451695],

Cell["The first step is to load the QuantLib package. ", "MathCaption",
 CellTags->"Overview",
 CellID->41864049],

Cell["Needs[\"QuantLib`\"]", "Input",
 CellTags->"Overview",
 CellID->393945645],

Cell["\<\
Within the CouponVectors part there are several constructors and member \
functions available \
\>", "Text",
 CellTags->"Overview",
 CellID->416398842],

Cell[CellGroupData[{

Cell["Select[Category[CouponVectors],QLConstructor[#]&]", "Input",
 CellTags->"Overview",
 CellLabel->"In[55]:=",
 CellID->185077867],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "CmsCouponPricer", ",", "CmsLeg", ",", "CmsZeroLeg", ",", 
   "ConundrumPricerByNumericalIntegration", ",", "DigitalCmsLeg", ",", 
   "DigitalIborLeg", ",", "DigitalReplication", ",", "FixedRateLeg", ",", 
   "IborCouponPricer", ",", "IborLeg", ",", "RangeAccrualLeg"}], 
  "}"}]], "Output",
 CellChangeTimes->{3.436084610078125*^9},
 CellTags->"Overview",
 CellLabel->"Out[55]=",
 CellID->179145520]
}, Open  ]],

Cell[CellGroupData[{

Cell["Select[Category[CouponVectors],QLMember[#]&]", "Input",
 CellTags->"Overview",
 CellLabel->"In[56]:=",
 CellID->33628607],

Cell[BoxData[
 RowBox[{"{", "ConundrumPricerByNumericalIntegrationUpperLimit", 
  "}"}]], "Output",
 CellChangeTimes->{3.43608461103125*^9},
 CellTags->"Overview",
 CellLabel->"Out[56]=",
 CellID->243791195]
}, Open  ]],

Cell[CellGroupData[{

Cell["Select[Category[CouponVectors],QLProcedure[#]&]", "Input",
 CellTags->"Overview",
 CellLabel->"In[57]:=",
 CellID->138431205],

Cell[BoxData[
 RowBox[{"{", "}"}]], "Output",
 CellChangeTimes->{3.436084611796875*^9},
 CellTags->"Overview",
 CellLabel->"Out[57]=",
 CellID->452121965]
}, Open  ]],

Cell[CellGroupData[{

Cell["Constructors", "Section",
 CellTags->"Constructo",
 CellID->179216037],

Cell[CellGroupData[{

Cell["FixedRateLeg", "Subsubsection",
 CellTags->"Constructor",
 CellID->383350592],

Cell[BoxData[{Cell[BoxData[GridBox[{
    {"Nominals", "1000000", 
     RowBox[{"Nominal", " ", "amount", " ", 
      RowBox[{"vector", "."}]}]},
    {"ScheduleID", "exampleValue", 
     RowBox[{"Schedule", " ", "object", " ", 
      RowBox[{"ID", "."}]}]},
    {"Coupons", "0.04", 
     RowBox[{"coupon", " ", "fixed", " ", 
      RowBox[{"rates", "."}]}]},
    {"DayCounter", 
     RowBox[{
      RowBox[{"Actual", "/", "Actual"}], " ", 
      RowBox[{"(", "ISMA", ")"}]}], 
     RowBox[{"Payment", " ", "DayCounter", " ", 
      RowBox[{"ID", "."}]}]}
   }]], "DefinitionBox3Col",
  CellTags->"Constructor"], "\n", Cell["Calling Parameters", 
  "Caption"]}], "Input",
 CellID->58389112],

Cell[BoxData[{Cell[BoxData[GridBox[{
    {"PaymentBDC", "\"\<Following\>\"", 
     RowBox[{"payment", " ", "business", " ", "day", " ", 
      RowBox[{"convention", "."}]}]}
   }]], "DefinitionBox3Col",
  CellTags->"Constructor"], "\n", Cell["Option Setting", "Caption"]}], "Input",\

 CellID->540170357],

Cell[BoxData[{
 RowBox[{
  RowBox[{"Nominals", "=", 
   RowBox[{"{", "1000000", "}"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"ScheduleID", "=", 
   RowBox[{"Schedule", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"2008", ",", "11", ",", "15"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2018", ",", "11", ",", "17"}], "}"}], ",", "\"\<1Y\>\"", ",", 
     "\"\<Following\>\"", ",", "\"\<Following\>\"", ",", "\"\<Backward\>\"", 
     ",", 
     RowBox[{"FirstDate", "->", 
      RowBox[{"{", 
       RowBox[{"2008", ",", "11", ",", "18"}], "}"}]}]}], "]"}]}], 
  ";"}], "\n", 
 RowBox[{
  RowBox[{"Coupons", "=", 
   RowBox[{"{", "0.04", "}"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"DayCounter", "=", "\"\<Actual/Actual (ISMA)\>\""}], 
  ";"}]}], "Input",
 CellChangeTimes->{{3.436084050890625*^9, 3.4360840605*^9}},
 CellTags->"Constructor",
 CellLabel->"In[50]:=",
 CellID->15632511],

Cell[CellGroupData[{

Cell["obj=FixedRateLeg[Nominals,ScheduleID,Coupons,DayCounter]", "Input",
 CellTags->"Constructor",
 CellLabel->"In[54]:=",
 CellID->59703876],

Cell[BoxData["FixedRateLeg1"], "Output",
 CellChangeTimes->{3.436084605890625*^9},
 CellTags->"Constructor",
 CellLabel->"Out[54]=",
 CellID->222501613]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["IborLeg", "Subsubsection",
 CellTags->"Constructor",
 CellID->20455881],

Cell[BoxData[{Cell[BoxData[GridBox[{
    {"Nominals", "1000000", 
     RowBox[{"Nominal", " ", "amount", " ", 
      RowBox[{"vector", "."}]}]},
    {"ScheduleID", "exampleValue", 
     RowBox[{"Schedule", " ", "object", " ", 
      RowBox[{"ID", "."}]}]},
    {"DayCounter", 
     RowBox[{
      RowBox[{"Actual", "/", "Actual"}], " ", 
      RowBox[{"(", "ISMA", ")"}]}], 
     RowBox[{"Payment", " ", "DayCounter", " ", 
      RowBox[{"ID", "."}]}]},
    {"IborIndexID", "exampleValue", 
     RowBox[{"floating", " ", "rate", " ", 
      RowBox[{"index", "."}]}]}
   }]], "DefinitionBox3Col",
  CellTags->"Constructor"], "\n", Cell["Calling Parameters", 
  "Caption"]}], "Input",
 CellChangeTimes->{{3.436084626*^9, 3.4360846439375*^9}},
 CellID->772852582],

Cell[BoxData[{Cell[BoxData[GridBox[{
    {"PaymentBDC", "\"\<Following\>\"", 
     RowBox[{"payment", " ", "business", " ", "day", " ", 
      RowBox[{"convention", "."}]}]},
    {"FixingDays", 
     RowBox[{
      RowBox[{"std", "::", "vector"}], "<", 
      RowBox[{"QuantLib", "::", "Natural"}], ">", 
      RowBox[{"(", ")"}]}], 
     RowBox[{"fixing", " ", "days", " ", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"e", ".", "g", ".", " ", "2"}], ")"}], "."}]}]},
    {"IsInArrears", "false", 
     RowBox[{
     "TRUE", " ", "if", " ", "the", " ", "fixing", " ", "is", " ", "in", " ", 
      
      RowBox[{"arrears", "."}]}]},
    {"Floors", 
     RowBox[{
      RowBox[{"std", "::", "vector"}], "<", 
      RowBox[{"QuantLib", "::", "Rate"}], ">", 
      RowBox[{"(", ")"}]}], 
     RowBox[{"floor", " ", 
      RowBox[{"strikes", "."}]}]},
    {"Gearings", "1.0", 
     RowBox[{"floating", " ", "rate", " ", 
      RowBox[{"gearings", "."}]}]},
    {"Spreads", "0.0", 
     RowBox[{"floating", " ", "rate", " ", 
      RowBox[{"spreads", "."}]}]},
    {"Caps", 
     RowBox[{
      RowBox[{"std", "::", "vector"}], "<", 
      RowBox[{"QuantLib", "::", "Rate"}], ">", 
      RowBox[{"(", ")"}]}], 
     RowBox[{"cap", " ", 
      RowBox[{"strikes", "."}]}]}
   }]], "DefinitionBox3Col",
  CellTags->"Constructor"], "\n", Cell["Option Setting", "Caption"]}], "Input",\

 CellID->4033323],

Cell[BoxData[{
 RowBox[{
  RowBox[{"Nominals", "=", 
   RowBox[{"{", "1000000", "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"ScheduleID", "=", 
   RowBox[{"Schedule", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"2008", ",", "11", ",", "15"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2018", ",", "11", ",", "17"}], "}"}], ",", "\"\<1Y\>\"", ",", 
     "\"\<Following\>\"", ",", "\"\<Following\>\"", ",", "\"\<Backward\>\"", 
     ",", 
     RowBox[{"FirstDate", "->", 
      RowBox[{"{", 
       RowBox[{"2008", ",", "11", ",", "18"}], "}"}]}]}], "]"}]}], 
  ";"}], "\n", 
 RowBox[{
  RowBox[{"DayCounter", "=", "\"\<Actual/Actual (ISMA)\>\""}], ";"}], "\n", 
 RowBox[{"IborIndexD", "=", 
  RowBox[{"IborIndex", "[", 
   RowBox[{
   "\"\<Test\>\"", ",", "\"\<2D\>\"", ",", "2", ",", "\"\<USD\>\"", ",", 
    "\"\<Following\>\"", ",", "True", ",", "\"\<30/360\>\"", ",", 
    RowBox[{"YieldCurve", "\[Rule]", " ", 
     RowBox[{"FlatForward", "[", 
      RowBox[{"0.04", ",", "\"\<Simple\>\""}], "]"}]}]}], "]"}]}]}], "Input",
 CellChangeTimes->{{3.4360846334375*^9, 3.43608468396875*^9}},
 CellTags->"Constructor",
 CellID->257524537],

Cell["obj=IborLeg[Nominals,ScheduleID,DayCounter,IborIndexID]", "Input",
 CellChangeTimes->{{3.436084654578125*^9, 3.43608465496875*^9}},
 CellTags->"Constructor",
 CellID->63893078]
}, Open  ]],

Cell[CellGroupData[{

Cell["DigitalIborLeg", "Subsubsection",
 CellTags->"Constructor",
 CellID->78339099],

Cell[BoxData[{Cell[BoxData[GridBox[{
    {"Nominals", "1000000", 
     RowBox[{"nominal", " ", "amount", " ", 
      RowBox[{"vector", "."}]}]},
    {"ScheduleID", "exampleValue", 
     RowBox[{"schedule", " ", "object", " ", 
      RowBox[{"ID", "."}]}]},
    {"DayCounter", 
     RowBox[{
      RowBox[{"Actual", "/", "Actual"}], " ", 
      RowBox[{"(", "ISMA", ")"}]}], 
     RowBox[{"Payment", " ", "DayCounter", " ", 
      RowBox[{"ID", "."}]}]},
    {"IborIndex", "exampleValue", 
     RowBox[{"floating", " ", "rate", " ", 
      RowBox[{"index", "."}]}]},
    {"CallSpecs", "exampleValue", 
     RowBox[{"call", " ", "position", " ", 
      RowBox[{"(", 
       RowBox[{"Short", ",", " ", "Long"}], ")"}], " ", "and", " ", "ATM", 
      " ", 
      RowBox[{"inclusion", "."}]}]},
    {"PutSpecs", "exampleValue", 
     RowBox[{"put", " ", "position", " ", 
      RowBox[{"(", 
       RowBox[{"Short", ",", " ", "Long"}], ")"}], " ", "and", " ", "ATM", 
      " ", 
      RowBox[{"inclusion", "."}]}]},
    {"Replication", "exampleValue", 
     RowBox[{"replication", " ", "object", " ", 
      RowBox[{"ID", "."}]}]}
   }]], "DefinitionBox3Col",
  CellTags->"Constructor"], "\n", Cell["Calling Parameters", 
  "Caption"]}], "Input",
 CellID->215566144],

Cell[BoxData[{Cell[BoxData[GridBox[{
    {"PaymentBDC", "\"\<Following\>\"", 
     RowBox[{"payment", " ", "business", " ", "day", " ", 
      RowBox[{"convention", "."}]}]},
    {"FixingDays", 
     RowBox[{
      RowBox[{"std", "::", "vector"}], "<", 
      RowBox[{"QuantLib", "::", "Natural"}], ">", 
      RowBox[{"(", ")"}]}], 
     RowBox[{"fixing", " ", 
      RowBox[{"days", "."}]}]},
    {"IsInArrears", "false", 
     RowBox[{
     "TRUE", " ", "if", " ", "the", " ", "fixing", " ", "is", " ", "in", " ", 
      
      RowBox[{"arrears", "."}]}]},
    {"Gearings", "1.0", 
     RowBox[{"floating", " ", "rate", " ", 
      RowBox[{"gearings", "."}]}]},
    {"Spreads", "0.0", 
     RowBox[{"floating", " ", "rate", " ", 
      RowBox[{"spreads", "."}]}]},
    {"CallStrikes", 
     RowBox[{
      RowBox[{"std", "::", "vector"}], "<", 
      RowBox[{"QuantLib", "::", "Rate"}], ">", 
      RowBox[{"(", ")"}]}], 
     RowBox[{
      RowBox[{"option", " ", 
       RowBox[{"strikes", ".", " ", "If"}], " ", "omitted"}], ",", " ", 
      RowBox[{"no", " ", "call", " ", "is", " ", 
       RowBox[{"assumed", "."}]}]}]},
    {"CallPayoff", 
     RowBox[{
      RowBox[{"std", "::", "vector"}], "<", 
      RowBox[{"QuantLib", "::", "Rate"}], ">", 
      RowBox[{"(", ")"}]}], 
     RowBox[{
      RowBox[{
      "payoff", " ", "if", " ", "the", " ", "call", " ", "ends", " ", 
       RowBox[{"ITM", ".", " ", "If"}], " ", "omitted"}], ",", " ", 
      RowBox[{"asset", "-", "or", "-", 
       RowBox[{"nothing", " ", "option", " ", "is", " ", 
        RowBox[{"assumed", "."}]}]}]}]},
    {"PutStrikes", 
     RowBox[{
      RowBox[{"std", "::", "vector"}], "<", 
      RowBox[{"QuantLib", "::", "Rate"}], ">", 
      RowBox[{"(", ")"}]}], 
     RowBox[{
      RowBox[{"option", " ", 
       RowBox[{"strikes", ".", " ", "If"}], " ", "omitted"}], ",", " ", 
      RowBox[{"no", " ", "put", " ", "is", " ", 
       RowBox[{"assumed", "."}]}]}]},
    {"PutPayoff", 
     RowBox[{
      RowBox[{"std", "::", "vector"}], "<", 
      RowBox[{"QuantLib", "::", "Rate"}], ">", 
      RowBox[{"(", ")"}]}], 
     RowBox[{
      RowBox[{"payoff", " ", "if", " ", "the", " ", "put", " ", "ends", " ", 
       RowBox[{"ITM", ".", " ", "If"}], " ", "omitted"}], ",", " ", 
      RowBox[{"asset", "-", "or", "-", 
       RowBox[{"nothing", " ", "option", " ", "is", " ", 
        RowBox[{"assumed", "."}]}]}]}]}
   }]], "DefinitionBox3Col",
  CellTags->"Constructor"], "\n", Cell["Option Setting", "Caption"]}], "Input",\

 CellID->60057637],

Cell[BoxData[{
 RowBox[{
  RowBox[{"Nominals", "=", 
   RowBox[{"{", "1000000", "}"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"ScheduleID", "=", "exampleValue"}], ";"}], "\n", 
 RowBox[{
  RowBox[{"DayCounter", "=", 
   RowBox[{
    RowBox[{"Actual", "/", "Actual"}], " ", 
    RowBox[{"(", "ISMA", ")"}]}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"IborIndex", "=", "exampleValue"}], ";"}], "\n", 
 RowBox[{
  RowBox[{"CallSpecs", "=", "exampleValue"}], ";"}], "\n", 
 RowBox[{
  RowBox[{"PutSpecs", "=", "exampleValue"}], ";"}], "\n", 
 RowBox[{
  RowBox[{"Replication", "=", "exampleValue"}], ";"}]}], "Input",
 CellTags->"Constructor",
 CellID->177792685],

Cell["\<\
obj=DigitalIborLeg[Nominals,ScheduleID,DayCounter,IborIndex,CallSpecs,\
PutSpecs,Replication]\
\>", "Input",
 CellTags->"Constructor",
 CellID->116832727]
}, Open  ]],

Cell[CellGroupData[{

Cell["CmsLeg", "Subsubsection",
 CellTags->"Constructor",
 CellID->14105925],

Cell[BoxData[{Cell[BoxData[GridBox[{
    {"Nominals", "1000000", 
     RowBox[{"Nominal", " ", "amount", " ", 
      RowBox[{"vector", "."}]}]},
    {"ScheduleID", "exampleValue", 
     RowBox[{"Schedule", " ", "object", " ", 
      RowBox[{"ID", "."}]}]},
    {"DayCounter", 
     RowBox[{
      RowBox[{"Actual", "/", "Actual"}], " ", 
      RowBox[{"(", "ISMA", ")"}]}], 
     RowBox[{"Payment", " ", "DayCounter", " ", 
      RowBox[{"ID", "."}]}]},
    {"SwapIndex", "exampleValue", 
     RowBox[{"underlying", " ", "SwapIndex", " ", "object", " ", 
      RowBox[{"ID", "."}]}]}
   }]], "DefinitionBox3Col",
  CellTags->"Constructor"], "\n", Cell["Calling Parameters", 
  "Caption"]}], "Input",
 CellID->130429618],

Cell[BoxData[{Cell[BoxData[GridBox[{
    {"PaymentBDC", "\"\<Following\>\"", 
     RowBox[{"payment", " ", "business", " ", "day", " ", 
      RowBox[{"convention", "."}]}]},
    {"FixingDays", 
     RowBox[{
      RowBox[{"std", "::", "vector"}], "<", 
      RowBox[{"QuantLib", "::", "Natural"}], ">", 
      RowBox[{"(", ")"}]}], 
     RowBox[{"fixing", " ", "days", " ", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"e", ".", "g", ".", " ", "2"}], ")"}], "."}]}]},
    {"IsInArrears", "false", 
     RowBox[{
     "TRUE", " ", "if", " ", "the", " ", "fixing", " ", "is", " ", "in", " ", 
      
      RowBox[{"arrears", "."}]}]},
    {"Floors", 
     RowBox[{
      RowBox[{"std", "::", "vector"}], "<", 
      RowBox[{"QuantLib", "::", "Rate"}], ">", 
      RowBox[{"(", ")"}]}], 
     RowBox[{"floor", " ", 
      RowBox[{"strikes", "."}]}]},
    {"Gearings", "1.0", 
     RowBox[{"floating", " ", "rate", " ", 
      RowBox[{"gearings", "."}]}]},
    {"Spreads", "0.0", 
     RowBox[{"floating", " ", "rate", " ", 
      RowBox[{"spreads", "."}]}]},
    {"Caps", 
     RowBox[{
      RowBox[{"std", "::", "vector"}], "<", 
      RowBox[{"QuantLib", "::", "Rate"}], ">", 
      RowBox[{"(", ")"}]}], 
     RowBox[{"cap", " ", 
      RowBox[{"strikes", "."}]}]}
   }]], "DefinitionBox3Col",
  CellTags->"Constructor"], "\n", Cell["Option Setting", "Caption"]}], "Input",\

 CellID->341508068],

Cell[BoxData[{
 RowBox[{
  RowBox[{"Nominals", "=", 
   RowBox[{"{", "1000000", "}"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"ScheduleID", "=", "exampleValue"}], ";"}], "\n", 
 RowBox[{
  RowBox[{"DayCounter", "=", 
   RowBox[{
    RowBox[{"Actual", "/", "Actual"}], " ", 
    RowBox[{"(", "ISMA", ")"}]}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"SwapIndex", "=", "exampleValue"}], ";"}]}], "Input",
 CellTags->"Constructor",
 CellID->542763573],

Cell["obj=CmsLeg[Nominals,ScheduleID,DayCounter,SwapIndex]", "Input",
 CellTags->"Constructor",
 CellID->106292329]
}, Open  ]],

Cell[CellGroupData[{

Cell["DigitalCmsLeg", "Subsubsection",
 CellTags->"Constructor",
 CellID->3434806],

Cell[BoxData[{Cell[BoxData[GridBox[{
    {"Nominals", "1000000", 
     RowBox[{"nominal", " ", "amount", " ", 
      RowBox[{"vector", "."}]}]},
    {"ScheduleID", "exampleValue", 
     RowBox[{"schedule", " ", "object", " ", 
      RowBox[{"ID", "."}]}]},
    {"DayCounter", 
     RowBox[{
      RowBox[{"Actual", "/", "Actual"}], " ", 
      RowBox[{"(", "ISMA", ")"}]}], 
     RowBox[{"Payment", " ", "DayCounter", " ", 
      RowBox[{"ID", "."}]}]},
    {"SwapIndex", "exampleValue", 
     RowBox[{"swap", " ", "rate", " ", 
      RowBox[{"index", "."}]}]},
    {"CallSpecs", "exampleValue", 
     RowBox[{"call", " ", "position", " ", 
      RowBox[{"(", 
       RowBox[{"Short", ",", " ", "Long"}], ")"}], " ", "and", " ", "ATM", 
      " ", 
      RowBox[{"inclusion", "."}]}]},
    {"PutSpecs", "exampleValue", 
     RowBox[{"put", " ", "position", " ", 
      RowBox[{"(", 
       RowBox[{"Short", ",", " ", "Long"}], ")"}], " ", "and", " ", "ATM", 
      " ", 
      RowBox[{"inclusion", "."}]}]},
    {"Replication", "exampleValue", 
     RowBox[{"replication", " ", "object", " ", 
      RowBox[{"ID", "."}]}]}
   }]], "DefinitionBox3Col",
  CellTags->"Constructor"], "\n", Cell["Calling Parameters", 
  "Caption"]}], "Input",
 CellID->13934080],

Cell[BoxData[{Cell[BoxData[GridBox[{
    {"PaymentBDC", "\"\<Following\>\"", 
     RowBox[{"payment", " ", "business", " ", "day", " ", 
      RowBox[{"convention", "."}]}]},
    {"FixingDays", 
     RowBox[{
      RowBox[{"std", "::", "vector"}], "<", 
      RowBox[{"QuantLib", "::", "Natural"}], ">", 
      RowBox[{"(", ")"}]}], 
     RowBox[{"fixing", " ", 
      RowBox[{"days", "."}]}]},
    {"IsInArrears", "false", 
     RowBox[{
     "TRUE", " ", "if", " ", "the", " ", "fixing", " ", "is", " ", "in", " ", 
      
      RowBox[{"arrears", "."}]}]},
    {"Gearings", "1.0", 
     RowBox[{"floating", " ", "rate", " ", 
      RowBox[{"gearings", "."}]}]},
    {"Spreads", "0.0", 
     RowBox[{"floating", " ", "rate", " ", 
      RowBox[{"spreads", "."}]}]},
    {"CallStrikes", 
     RowBox[{
      RowBox[{"std", "::", "vector"}], "<", 
      RowBox[{"QuantLib", "::", "Rate"}], ">", 
      RowBox[{"(", ")"}]}], 
     RowBox[{
      RowBox[{"option", " ", 
       RowBox[{"strikes", ".", " ", "If"}], " ", "omitted"}], ",", " ", 
      RowBox[{"no", " ", "call", " ", "is", " ", 
       RowBox[{"assumed", "."}]}]}]},
    {"CallPayoff", 
     RowBox[{
      RowBox[{"std", "::", "vector"}], "<", 
      RowBox[{"QuantLib", "::", "Rate"}], ">", 
      RowBox[{"(", ")"}]}], 
     RowBox[{
      RowBox[{
      "payoff", " ", "if", " ", "the", " ", "call", " ", "ends", " ", 
       RowBox[{"ITM", ".", " ", "If"}], " ", "omitted"}], ",", " ", 
      RowBox[{"asset", "-", "or", "-", 
       RowBox[{"nothing", " ", "option", " ", "is", " ", 
        RowBox[{"assumed", "."}]}]}]}]},
    {"PutStrikes", 
     RowBox[{
      RowBox[{"std", "::", "vector"}], "<", 
      RowBox[{"QuantLib", "::", "Rate"}], ">", 
      RowBox[{"(", ")"}]}], 
     RowBox[{
      RowBox[{"option", " ", 
       RowBox[{"strikes", ".", " ", "If"}], " ", "omitted"}], ",", " ", 
      RowBox[{"no", " ", "put", " ", "is", " ", 
       RowBox[{"assumed", "."}]}]}]},
    {"PutPayoff", 
     RowBox[{
      RowBox[{"std", "::", "vector"}], "<", 
      RowBox[{"QuantLib", "::", "Rate"}], ">", 
      RowBox[{"(", ")"}]}], 
     RowBox[{
      RowBox[{"payoff", " ", "if", " ", "the", " ", "put", " ", "ends", " ", 
       RowBox[{"ITM", ".", " ", "If"}], " ", "omitted"}], ",", " ", 
      RowBox[{"asset", "-", "or", "-", 
       RowBox[{"nothing", " ", "option", " ", "is", " ", 
        RowBox[{"assumed", "."}]}]}]}]}
   }]], "DefinitionBox3Col",
  CellTags->"Constructor"], "\n", Cell["Option Setting", "Caption"]}], "Input",\

 CellID->39233520],

Cell[BoxData[{
 RowBox[{
  RowBox[{"Nominals", "=", 
   RowBox[{"{", "1000000", "}"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"ScheduleID", "=", "exampleValue"}], ";"}], "\n", 
 RowBox[{
  RowBox[{"DayCounter", "=", 
   RowBox[{
    RowBox[{"Actual", "/", "Actual"}], " ", 
    RowBox[{"(", "ISMA", ")"}]}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"SwapIndex", "=", "exampleValue"}], ";"}], "\n", 
 RowBox[{
  RowBox[{"CallSpecs", "=", "exampleValue"}], ";"}], "\n", 
 RowBox[{
  RowBox[{"PutSpecs", "=", "exampleValue"}], ";"}], "\n", 
 RowBox[{
  RowBox[{"Replication", "=", "exampleValue"}], ";"}]}], "Input",
 CellTags->"Constructor",
 CellID->156823971],

Cell["\<\
obj=DigitalCmsLeg[Nominals,ScheduleID,DayCounter,SwapIndex,CallSpecs,PutSpecs,\
Replication]\
\>", "Input",
 CellTags->"Constructor",
 CellID->80523844]
}, Open  ]],

Cell[CellGroupData[{

Cell["RangeAccrualLeg", "Subsubsection",
 CellTags->"Constructor",
 CellID->220496736],

Cell[BoxData[{Cell[BoxData[GridBox[{
    {"Nominals", "1000000", 
     RowBox[{"Nominal", " ", "amount", " ", 
      RowBox[{"vector", "."}]}]},
    {"ScheduleID", "exampleValue", 
     RowBox[{"Schedule", " ", "object", " ", 
      RowBox[{"ID", "."}]}]},
    {"DayCounter", 
     RowBox[{
      RowBox[{"Actual", "/", "Actual"}], " ", 
      RowBox[{"(", "ISMA", ")"}]}], 
     RowBox[{"Payment", " ", "DayCounter", " ", 
      RowBox[{"ID", "."}]}]},
    {"IborIndex", "exampleValue", 
     RowBox[{"underlying", " ", "IborIndex", " ", "object", " ", 
      RowBox[{"ID", "."}]}]},
    {"ObservationsTenor", 
     RowBox[{"1", "d"}], 
     RowBox[{"observations", " ", "tenor", " ", 
      RowBox[{"period", "."}]}]}
   }]], "DefinitionBox3Col",
  CellTags->"Constructor"], "\n", Cell["Calling Parameters", 
  "Caption"]}], "Input",
 CellID->57198692],

Cell[BoxData[{Cell[BoxData[GridBox[{
    {"PaymentBDC", "\"\<Following\>\"", 
     RowBox[{"payment", " ", "business", " ", "day", " ", 
      RowBox[{"convention", "."}]}]},
    {"FixingDays", 
     RowBox[{
      RowBox[{"std", "::", "vector"}], "<", 
      RowBox[{"QuantLib", "::", "Natural"}], ">", 
      RowBox[{"(", ")"}]}], 
     RowBox[{"fixing", " ", "days", " ", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"e", ".", "g", ".", " ", "2"}], ")"}], "."}]}]},
    {"LowerStrikes", 
     RowBox[{
      RowBox[{"std", "::", "vector"}], "<", 
      RowBox[{"QuantLib", "::", "Rate"}], ">", 
      RowBox[{"(", ")"}]}], 
     RowBox[{"lower", " ", 
      RowBox[{"strikes", "."}]}]},
    {"Gearings", "1.0", 
     RowBox[{"floating", " ", "rate", " ", 
      RowBox[{"gearings", "."}]}]},
    {"Spreads", "0.0", 
     RowBox[{"floating", " ", "rate", " ", 
      RowBox[{"spreads", "."}]}]},
    {"UpperStrikes", 
     RowBox[{
      RowBox[{"std", "::", "vector"}], "<", 
      RowBox[{"QuantLib", "::", "Rate"}], ">", 
      RowBox[{"(", ")"}]}], 
     RowBox[{"upper", " ", 
      RowBox[{"strikes", "."}]}]},
    {"ObservationsBDC", "\"\<Modified Following\>\"", 
     RowBox[{"observations", " ", "business", " ", "day", " ", 
      RowBox[{"convention", "."}]}]}
   }]], "DefinitionBox3Col",
  CellTags->"Constructor"], "\n", Cell["Option Setting", "Caption"]}], "Input",\

 CellID->512776194],

Cell[BoxData[{
 RowBox[{
  RowBox[{"Nominals", "=", 
   RowBox[{"{", "1000000", "}"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"ScheduleID", "=", "exampleValue"}], ";"}], "\n", 
 RowBox[{
  RowBox[{"DayCounter", "=", 
   RowBox[{
    RowBox[{"Actual", "/", "Actual"}], " ", 
    RowBox[{"(", "ISMA", ")"}]}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"IborIndex", "=", "exampleValue"}], ";"}], "\n", 
 RowBox[{
  RowBox[{"ObservationsTenor", "=", 
   RowBox[{"1", "d"}]}], ";"}]}], "Input",
 CellTags->"Constructor",
 CellID->232390333],

Cell["\<\
obj=RangeAccrualLeg[Nominals,ScheduleID,DayCounter,IborIndex,\
ObservationsTenor]\
\>", "Input",
 CellTags->"Constructor",
 CellID->116938721]
}, Open  ]],

Cell[CellGroupData[{

Cell["CmsZeroLeg", "Subsubsection",
 CellTags->"Constructor",
 CellID->175606235],

Cell[BoxData[{Cell[BoxData[GridBox[{
    {"Nominals", "1000000", 
     RowBox[{"Nominal", " ", "amount", " ", 
      RowBox[{"vector", "."}]}]},
    {"ScheduleID", "exampleValue", 
     RowBox[{"Schedule", " ", "object", " ", 
      RowBox[{"ID", "."}]}]},
    {"DayCounter", 
     RowBox[{
      RowBox[{"Actual", "/", "Actual"}], " ", 
      RowBox[{"(", "ISMA", ")"}]}], 
     RowBox[{"Payment", " ", "DayCounter", " ", 
      RowBox[{"ID", "."}]}]},
    {"SwapIndex", "exampleValue", 
     RowBox[{"underlying", " ", "SwapIndex", " ", "object", " ", 
      RowBox[{"ID", "."}]}]}
   }]], "DefinitionBox3Col",
  CellTags->"Constructor"], "\n", Cell["Calling Parameters", 
  "Caption"]}], "Input",
 CellID->599536013],

Cell[BoxData[{Cell[BoxData[GridBox[{
    {"PaymentBDC", "\"\<Following\>\"", 
     RowBox[{"payment", " ", "business", " ", "day", " ", 
      RowBox[{"convention", "."}]}]},
    {"FixingDays", 
     RowBox[{
      RowBox[{"std", "::", "vector"}], "<", 
      RowBox[{"QuantLib", "::", "Natural"}], ">", 
      RowBox[{"(", ")"}]}], 
     RowBox[{"fixing", " ", "days", " ", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"e", ".", "g", ".", " ", "2"}], ")"}], "."}]}]},
    {"IsInArrears", "false", 
     RowBox[{
     "TRUE", " ", "if", " ", "the", " ", "fixing", " ", "is", " ", "in", " ", 
      
      RowBox[{"arrears", "."}]}]},
    {"Floors", 
     RowBox[{
      RowBox[{"std", "::", "vector"}], "<", 
      RowBox[{"QuantLib", "::", "Rate"}], ">", 
      RowBox[{"(", ")"}]}], 
     RowBox[{"floor", " ", 
      RowBox[{"strikes", "."}]}]},
    {"Gearings", "1.0", 
     RowBox[{"floating", " ", "rate", " ", 
      RowBox[{"gearings", "."}]}]},
    {"Spreads", "0.0", 
     RowBox[{"floating", " ", "rate", " ", 
      RowBox[{"spreads", "."}]}]},
    {"Caps", 
     RowBox[{
      RowBox[{"std", "::", "vector"}], "<", 
      RowBox[{"QuantLib", "::", "Rate"}], ">", 
      RowBox[{"(", ")"}]}], 
     RowBox[{"cap", " ", 
      RowBox[{"strikes", "."}]}]}
   }]], "DefinitionBox3Col",
  CellTags->"Constructor"], "\n", Cell["Option Setting", "Caption"]}], "Input",\

 CellID->3160813],

Cell[BoxData[{
 RowBox[{
  RowBox[{"Nominals", "=", 
   RowBox[{"{", "1000000", "}"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"ScheduleID", "=", "exampleValue"}], ";"}], "\n", 
 RowBox[{
  RowBox[{"DayCounter", "=", 
   RowBox[{
    RowBox[{"Actual", "/", "Actual"}], " ", 
    RowBox[{"(", "ISMA", ")"}]}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"SwapIndex", "=", "exampleValue"}], ";"}]}], "Input",
 CellTags->"Constructor",
 CellID->89808627],

Cell["obj=CmsZeroLeg[Nominals,ScheduleID,DayCounter,SwapIndex]", "Input",
 CellTags->"Constructor",
 CellID->231402391]
}, Open  ]],

Cell[CellGroupData[{

Cell["IborCouponPricer", "Subsubsection",
 CellTags->"Constructor",
 CellID->111966376],

Cell[BoxData[{Cell[BoxData[GridBox[{
    {"Volatility", "EURCapletVol", 
     RowBox[{
     "Caplet", " ", "Volatility", " ", "Structure", " ", "object", " ", 
      RowBox[{"ID", "."}]}]},
    {"IborCouponPricerType", "IborByBlack", 
     RowBox[{"Ibor", " ", "Coupon", " ", "Pricer", " ", "Type", " ", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"e", ".", "g"}], " ", "IborByBlack"}], ",", " ", ".."}], 
        ")"}], "."}]}]}
   }]], "DefinitionBox3Col",
  CellTags->"Constructor"], "\n", Cell["Calling Parameters", 
  "Caption"]}], "Input",
 CellID->100965200],

Cell[BoxData[{
 RowBox[{
  RowBox[{"Volatility", "=", "EURCapletVol"}], ";"}], "\n", 
 RowBox[{
  RowBox[{"IborCouponPricerType", "=", "IborByBlack"}], ";"}]}], "Input",
 CellTags->"Constructor",
 CellID->542532715],

Cell["obj=IborCouponPricer[Volatility,IborCouponPricerType]", "Input",
 CellTags->"Constructor",
 CellID->396831750]
}, Open  ]],

Cell[CellGroupData[{

Cell["CmsCouponPricer", "Subsubsection",
 CellTags->"Constructor",
 CellID->155833145],

Cell[BoxData[{Cell[BoxData[GridBox[{
    {"Volatility", "EURSwaptionVol", 
     RowBox[{
     "Swaption", " ", "Volatility", " ", "Structure", " ", "object", " ", 
      RowBox[{"ID", "."}]}]},
    {"CmsCouponPricerType", "ConundrumByNumericalIntegration", 
     RowBox[{"Cms", " ", "Coupon", " ", "Pricer", " ", "Type", " ", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"e", ".", "g"}], " ", "ConundrumByBlack"}], ",", " ", 
         "ConundrumByNumericalIntegration", ",", " ", 
         "ClassicalAnaliticalFormula"}], ")"}], "."}]}]},
    {"YieldCurveModel", "exampleValue", 
     RowBox[{
     "model", " ", "of", " ", "the", " ", "yield", " ", "curve", " ", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"e", ".", "g"}], " ", "Standard"}], ",", " ", "ExactYield", 
         ",", " ", "ParallelShifts", ",", " ", "NonParallelShifts"}], ")"}], 
       "."}]}]},
    {"MeanReversion", "0.1", 
     RowBox[{"mean", " ", "reversion", " ", 
      RowBox[{"quote", "."}]}]}
   }]], "DefinitionBox3Col",
  CellTags->"Constructor"], "\n", Cell["Calling Parameters", 
  "Caption"]}], "Input",
 CellID->188619366],

Cell[BoxData[{
 RowBox[{
  RowBox[{"Volatility", "=", "EURSwaptionVol"}], ";"}], "\n", 
 RowBox[{
  RowBox[{"CmsCouponPricerType", "=", "ConundrumByNumericalIntegration"}], 
  ";"}], "\n", 
 RowBox[{
  RowBox[{"YieldCurveModel", "=", "exampleValue"}], ";"}], "\n", 
 RowBox[{
  RowBox[{"MeanReversion", "=", "0.1"}], ";"}]}], "Input",
 CellTags->"Constructor",
 CellID->73428279],

Cell["\<\
obj=CmsCouponPricer[Volatility,CmsCouponPricerType,YieldCurveModel,\
MeanReversion]\
\>", "Input",
 CellTags->"Constructor",
 CellID->17005942]
}, Open  ]],

Cell[CellGroupData[{

Cell["ConundrumPricerByNumericalIntegration", "Subsubsection",
 CellTags->"Constructor",
 CellID->244511973],

Cell[BoxData[{Cell[BoxData[GridBox[{
    {"SwaptionVol", "exampleValue", 
     RowBox[{"Volatility", " ", "Cube", " ", "by", " ", 
      RowBox[{"Sabr", "."}]}]},
    {"YieldCurveModel", "exampleValue", 
     RowBox[{
     "model", " ", "of", " ", "the", " ", "yield", " ", "curve", " ", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"e", ".", "g"}], " ", "Standard"}], ",", " ", "ExactYield", 
         ",", " ", "ParallelShifts", ",", " ", "NonParallelShifts"}], ")"}], 
       "."}]}]},
    {"MeanReversion", "exampleValue", 
     RowBox[{"mean", " ", 
      RowBox[{"reversion", "."}]}]}
   }]], "DefinitionBox3Col",
  CellTags->"Constructor"], "\n", Cell["Calling Parameters", 
  "Caption"]}], "Input",
 CellID->67224752],

Cell[BoxData[{Cell[BoxData[GridBox[{
    {"LowerLimit", "0.0", 
     RowBox[{"lower", " ", 
      RowBox[{"limit", "."}]}]},
    {"UpperLimit", "1.0", 
     RowBox[{"upper", " ", 
      RowBox[{"limit", "."}]}]},
    {"Precision", 
     RowBox[{
      RowBox[{"1.0", "e"}], "-", "6"}], 
     RowBox[{"precision", "."}]}
   }]], "DefinitionBox3Col",
  CellTags->"Constructor"], "\n", Cell["Option Setting", "Caption"]}], "Input",\

 CellID->44254947],

Cell[BoxData[{
 RowBox[{
  RowBox[{"SwaptionVol", "=", "exampleValue"}], ";"}], "\n", 
 RowBox[{
  RowBox[{"YieldCurveModel", "=", "exampleValue"}], ";"}], "\n", 
 RowBox[{
  RowBox[{"MeanReversion", "=", "exampleValue"}], ";"}]}], "Input",
 CellTags->"Constructor",
 CellID->168059851],

Cell["\<\
obj=ConundrumPricerByNumericalIntegration[SwaptionVol,YieldCurveModel,\
MeanReversion]\
\>", "Input",
 CellTags->"Constructor",
 CellID->4983411]
}, Open  ]],

Cell[CellGroupData[{

Cell["DigitalReplication", "Subsubsection",
 CellTags->"Constructor",
 CellID->951837209],

Cell[BoxData[{Cell[BoxData[GridBox[{
    {"Replication", "exampleValue", 
     RowBox[{"Replication", " ", "type", " ", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"Sub", ",", " ", 
         RowBox[{"Central", " ", "or", " ", "Super"}]}], ")"}], "."}]}]}
   }]], "DefinitionBox3Col",
  CellTags->"Constructor"], "\n", Cell["Calling Parameters", 
  "Caption"]}], "Input",
 CellID->236907510],

Cell[BoxData[{Cell[BoxData[GridBox[{
    {"Gap", "0.0001", 
     RowBox[{
     "spread", " ", "in", " ", "strikes", " ", "used", " ", "in", " ", 
      RowBox[{"call", "/", "put"}], " ", 
      RowBox[{"replication", "."}]}]}
   }]], "DefinitionBox3Col",
  CellTags->"Constructor"], "\n", Cell["Option Setting", "Caption"]}], "Input",\

 CellID->185428733],

Cell[BoxData[
 RowBox[{
  RowBox[{"Replication", "=", "exampleValue"}], ";"}]], "Input",
 CellTags->"Constructor",
 CellID->442278014],

Cell["obj=DigitalReplication[Replication]", "Input",
 CellTags->"Constructor",
 CellID->997728910]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Member function", "Section",
 CellTags->"Member",
 CellID->371484373],

Cell[CellGroupData[{

Cell["ConundrumPricerByNumericalIntegrationUpperLimit", "Subsubsection",
 CellTags->"Member",
 CellID->231377526],

Cell["ConundrumPricerByNumericalIntegrationUpperLimit[obj]", "Input",
 CellTags->"Member",
 CellID->69072844]
}, Open  ]]
}, Open  ]]
}, Open  ]]
},
Editable->True,
WindowSize->{616, 750},
WindowMargins->{{363, Automatic}, {90, Automatic}},
DockedCells->FEPrivate`FrontEndResource[
 "FEExpressions", "HelpViewerToolbar"],
PageHeaders->{{None, None, None}, {None, None, 
   Cell[
    TextData[{
      Cell[
       TextData[{"Printed from [[YOUR APPLICATION'S NAME]] documentation "}], 
       "PageHeader"], 
      Cell[
       TextData[{
         CounterBox["Page"]}], "PageNumber"]}], 
    CellMargins -> {{Inherited, -29}, {Inherited, Inherited}}]}},
PageFooters->{{None, None, None}, {
   Cell[
    TextData[{"\[Copyright] 2008 Weber & Partner. All rights reserved."}], 
    "PageFooter"], None, None}},
TaggingRules->{"SearchTextTranslated" -> "", "SearchText" -> ""},
CreateCellID->True,
ShowCellTags->False,
FrontEndVersion->"6.0 for Microsoft Windows (32-bit) (May 21, 2008)",
StyleDefinitions->FrontEnd`FileName[{"Wolfram"}, "Reference.nb", 
  CharacterEncoding -> "WindowsANSI"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "Overview"->{
  Cell[590, 23, 75, 2, 99, "Chapter",
   CellTags->"Overview",
   CellID->334491741],
  Cell[668, 27, 102, 2, 37, "Text",
   CellTags->"Overview",
   CellID->225451695],
  Cell[773, 31, 113, 2, 53, "MathCaption",
   CellTags->"Overview",
   CellID->41864049],
  Cell[889, 35, 80, 2, 41, "Input",
   CellTags->"Overview",
   CellID->393945645],
  Cell[972, 39, 161, 5, 37, "Text",
   CellTags->"Overview",
   CellID->416398842],
  Cell[1158, 48, 133, 3, 41, "Input",
   CellTags->"Overview",
   CellID->185077867],
  Cell[1294, 53, 442, 11, 97, "Output",
   CellTags->"Overview",
   CellID->179145520],
  Cell[1773, 69, 127, 3, 41, "Input",
   CellTags->"Overview",
   CellID->33628607],
  Cell[1903, 74, 207, 6, 39, "Output",
   CellTags->"Overview",
   CellID->243791195],
  Cell[2147, 85, 131, 3, 41, "Input",
   CellTags->"Overview",
   CellID->138431205],
  Cell[2281, 90, 154, 5, 39, "Output",
   CellTags->"Overview",
   CellID->452121965]},
 "Constructo"->{
  Cell[2472, 100, 76, 2, 77, "Section",
   CellTags->"Constructo",
   CellID->179216037]},
 "Constructor"->{
  Cell[2573, 106, 83, 2, 47, "Subsubsection",
   CellTags->"Constructor",
   CellID->383350592],
  Cell[3657, 140, 893, 27, 70, "Input",
   CellTags->"Constructor",
   CellID->15632511],
  Cell[4575, 171, 142, 3, 70, "Input",
   CellTags->"Constructor",
   CellID->59703876],
  Cell[4720, 176, 152, 4, 70, "Output",
   CellTags->"Constructor",
   CellID->222501613],
  Cell[4921, 186, 77, 2, 70, "Subsubsection",
   CellTags->"Constructor",
   CellID->20455881],
  Cell[7170, 255, 1164, 30, 70, "Input",
   CellTags->"Constructor",
   CellID->257524537],
  Cell[8337, 287, 182, 3, 70, "Input",
   CellTags->"Constructor",
   CellID->63893078],
  Cell[8556, 295, 84, 2, 70, "Subsubsection",
   CellTags->"Constructor",
   CellID->78339099],
  Cell[12448, 405, 651, 20, 70, "Input",
   CellTags->"Constructor",
   CellID->177792685],
  Cell[13102, 427, 164, 5, 70, "Input",
   CellTags->"Constructor",
   CellID->116832727],
  Cell[13303, 437, 76, 2, 70, "Subsubsection",
   CellTags->"Constructor",
   CellID->14105925],
  Cell[15512, 505, 440, 14, 70, "Input",
   CellTags->"Constructor",
   CellID->542763573],
  Cell[15955, 521, 115, 2, 70, "Input",
   CellTags->"Constructor",
   CellID->106292329],
  Cell[16107, 528, 82, 2, 70, "Subsubsection",
   CellTags->"Constructor",
   CellID->3434806],
  Cell[19992, 638, 651, 20, 70, "Input",
   CellTags->"Constructor",
   CellID->156823971],
  Cell[20646, 660, 162, 5, 70, "Input",
   CellTags->"Constructor",
   CellID->80523844],
  Cell[20845, 670, 86, 2, 70, "Subsubsection",
   CellTags->"Constructor",
   CellID->220496736],
  Cell[23207, 740, 526, 17, 70, "Input",
   CellTags->"Constructor",
   CellID->232390333],
  Cell[23736, 759, 152, 5, 70, "Input",
   CellTags->"Constructor",
   CellID->116938721],
  Cell[23925, 769, 81, 2, 70, "Subsubsection",
   CellTags->"Constructor",
   CellID->175606235],
  Cell[26137, 837, 439, 14, 70, "Input",
   CellTags->"Constructor",
   CellID->89808627],
  Cell[26579, 853, 119, 2, 70, "Input",
   CellTags->"Constructor",
   CellID->231402391],
  Cell[26735, 860, 87, 2, 70, "Subsubsection",
   CellTags->"Constructor",
   CellID->111966376],
  Cell[27439, 882, 215, 6, 70, "Input",
   CellTags->"Constructor",
   CellID->542532715],
  Cell[27657, 890, 116, 2, 70, "Input",
   CellTags->"Constructor",
   CellID->396831750],
  Cell[27810, 897, 86, 2, 70, "Subsubsection",
   CellTags->"Constructor",
   CellID->155833145],
  Cell[29099, 933, 379, 11, 70, "Input",
   CellTags->"Constructor",
   CellID->73428279],
  Cell[29481, 946, 153, 5, 61, "Input",
   CellTags->"Constructor",
   CellID->17005942],
  Cell[29671, 956, 108, 2, 70, "Subsubsection",
   CellTags->"Constructor",
   CellID->244511973],
  Cell[31007, 998, 286, 8, 65, "Input",
   CellTags->"Constructor",
   CellID->168059851],
  Cell[31296, 1008, 155, 5, 28, "Input",
   CellTags->"Constructor",
   CellID->4983411],
  Cell[31488, 1018, 89, 2, 30, "Subsubsection",
   CellTags->"Constructor",
   CellID->951837209],
  Cell[32341, 1045, 134, 4, 28, "Input",
   CellTags->"Constructor",
   CellID->442278014],
  Cell[32478, 1051, 98, 2, 28, "Input",
   CellTags->"Constructor",
   CellID->997728910]},
 "Member"->{
  Cell[32625, 1059, 75, 2, 51, "Section",
   CellTags->"Member",
   CellID->371484373],
  Cell[32725, 1065, 113, 2, 30, "Subsubsection",
   CellTags->"Member",
   CellID->231377526],
  Cell[32841, 1069, 109, 2, 28, "Input",
   CellTags->"Member",
   CellID->69072844]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"Overview", 34043, 1107},
 {"Constructo", 35008, 1141},
 {"Constructor", 35117, 1145},
 {"Member", 38294, 1248}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[590, 23, 75, 2, 99, "Chapter",
 CellTags->"Overview",
 CellID->334491741],
Cell[668, 27, 102, 2, 37, "Text",
 CellTags->"Overview",
 CellID->225451695],
Cell[773, 31, 113, 2, 53, "MathCaption",
 CellTags->"Overview",
 CellID->41864049],
Cell[889, 35, 80, 2, 41, "Input",
 CellTags->"Overview",
 CellID->393945645],
Cell[972, 39, 161, 5, 37, "Text",
 CellTags->"Overview",
 CellID->416398842],
Cell[CellGroupData[{
Cell[1158, 48, 133, 3, 41, "Input",
 CellTags->"Overview",
 CellID->185077867],
Cell[1294, 53, 442, 11, 97, "Output",
 CellTags->"Overview",
 CellID->179145520]
}, Open  ]],
Cell[CellGroupData[{
Cell[1773, 69, 127, 3, 41, "Input",
 CellTags->"Overview",
 CellID->33628607],
Cell[1903, 74, 207, 6, 39, "Output",
 CellTags->"Overview",
 CellID->243791195]
}, Open  ]],
Cell[CellGroupData[{
Cell[2147, 85, 131, 3, 41, "Input",
 CellTags->"Overview",
 CellID->138431205],
Cell[2281, 90, 154, 5, 39, "Output",
 CellTags->"Overview",
 CellID->452121965]
}, Open  ]],
Cell[CellGroupData[{
Cell[2472, 100, 76, 2, 77, "Section",
 CellTags->"Constructo",
 CellID->179216037],
Cell[CellGroupData[{
Cell[2573, 106, 83, 2, 47, "Subsubsection",
 CellTags->"Constructor",
 CellID->383350592],
Cell[2659, 110, 688, 19, 166, "Input",
 CellID->58389112],
Cell[3350, 131, 304, 7, 70, "Input",
 CellID->540170357],
Cell[3657, 140, 893, 27, 70, "Input",
 CellTags->"Constructor",
 CellID->15632511],
Cell[CellGroupData[{
Cell[4575, 171, 142, 3, 70, "Input",
 CellTags->"Constructor",
 CellID->59703876],
Cell[4720, 176, 152, 4, 70, "Output",
 CellTags->"Constructor",
 CellID->222501613]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[4921, 186, 77, 2, 70, "Subsubsection",
 CellTags->"Constructor",
 CellID->20455881],
Cell[5001, 190, 760, 20, 70, "Input",
 CellID->772852582],
Cell[5764, 212, 1403, 41, 70, "Input",
 CellID->4033323],
Cell[7170, 255, 1164, 30, 70, "Input",
 CellTags->"Constructor",
 CellID->257524537],
Cell[8337, 287, 182, 3, 70, "Input",
 CellTags->"Constructor",
 CellID->63893078]
}, Open  ]],
Cell[CellGroupData[{
Cell[8556, 295, 84, 2, 70, "Subsubsection",
 CellTags->"Constructor",
 CellID->78339099],
Cell[8643, 299, 1262, 34, 70, "Input",
 CellID->215566144],
Cell[9908, 335, 2537, 68, 70, "Input",
 CellID->60057637],
Cell[12448, 405, 651, 20, 70, "Input",
 CellTags->"Constructor",
 CellID->177792685],
Cell[13102, 427, 164, 5, 70, "Input",
 CellTags->"Constructor",
 CellID->116832727]
}, Open  ]],
Cell[CellGroupData[{
Cell[13303, 437, 76, 2, 70, "Subsubsection",
 CellTags->"Constructor",
 CellID->14105925],
Cell[13382, 441, 719, 19, 70, "Input",
 CellID->130429618],
Cell[14104, 462, 1405, 41, 70, "Input",
 CellID->341508068],
Cell[15512, 505, 440, 14, 70, "Input",
 CellTags->"Constructor",
 CellID->542763573],
Cell[15955, 521, 115, 2, 70, "Input",
 CellTags->"Constructor",
 CellID->106292329]
}, Open  ]],
Cell[CellGroupData[{
Cell[16107, 528, 82, 2, 70, "Subsubsection",
 CellTags->"Constructor",
 CellID->3434806],
Cell[16192, 532, 1257, 34, 70, "Input",
 CellID->13934080],
Cell[17452, 568, 2537, 68, 70, "Input",
 CellID->39233520],
Cell[19992, 638, 651, 20, 70, "Input",
 CellTags->"Constructor",
 CellID->156823971],
Cell[20646, 660, 162, 5, 70, "Input",
 CellTags->"Constructor",
 CellID->80523844]
}, Open  ]],
Cell[CellGroupData[{
Cell[20845, 670, 86, 2, 70, "Subsubsection",
 CellTags->"Constructor",
 CellID->220496736],
Cell[20934, 674, 854, 23, 70, "Input",
 CellID->57198692],
Cell[21791, 699, 1413, 39, 70, "Input",
 CellID->512776194],
Cell[23207, 740, 526, 17, 70, "Input",
 CellTags->"Constructor",
 CellID->232390333],
Cell[23736, 759, 152, 5, 70, "Input",
 CellTags->"Constructor",
 CellID->116938721]
}, Open  ]],
Cell[CellGroupData[{
Cell[23925, 769, 81, 2, 70, "Subsubsection",
 CellTags->"Constructor",
 CellID->175606235],
Cell[24009, 773, 719, 19, 70, "Input",
 CellID->599536013],
Cell[24731, 794, 1403, 41, 70, "Input",
 CellID->3160813],
Cell[26137, 837, 439, 14, 70, "Input",
 CellTags->"Constructor",
 CellID->89808627],
Cell[26579, 853, 119, 2, 70, "Input",
 CellTags->"Constructor",
 CellID->231402391]
}, Open  ]],
Cell[CellGroupData[{
Cell[26735, 860, 87, 2, 70, "Subsubsection",
 CellTags->"Constructor",
 CellID->111966376],
Cell[26825, 864, 611, 16, 70, "Input",
 CellID->100965200],
Cell[27439, 882, 215, 6, 70, "Input",
 CellTags->"Constructor",
 CellID->542532715],
Cell[27657, 890, 116, 2, 70, "Input",
 CellTags->"Constructor",
 CellID->396831750]
}, Open  ]],
Cell[CellGroupData[{
Cell[27810, 897, 86, 2, 70, "Subsubsection",
 CellTags->"Constructor",
 CellID->155833145],
Cell[27899, 901, 1197, 30, 70, "Input",
 CellID->188619366],
Cell[29099, 933, 379, 11, 70, "Input",
 CellTags->"Constructor",
 CellID->73428279],
Cell[29481, 946, 153, 5, 61, "Input",
 CellTags->"Constructor",
 CellID->17005942]
}, Open  ]],
Cell[CellGroupData[{
Cell[29671, 956, 108, 2, 70, "Subsubsection",
 CellTags->"Constructor",
 CellID->244511973],
Cell[29782, 960, 770, 20, 147, "Input",
 CellID->67224752],
Cell[30555, 982, 449, 14, 95, "Input",
 CellID->44254947],
Cell[31007, 998, 286, 8, 65, "Input",
 CellTags->"Constructor",
 CellID->168059851],
Cell[31296, 1008, 155, 5, 28, "Input",
 CellTags->"Constructor",
 CellID->4983411]
}, Open  ]],
Cell[CellGroupData[{
Cell[31488, 1018, 89, 2, 30, "Subsubsection",
 CellTags->"Constructor",
 CellID->951837209],
Cell[31580, 1022, 399, 10, 82, "Input",
 CellID->236907510],
Cell[31982, 1034, 356, 9, 82, "Input",
 CellID->185428733],
Cell[32341, 1045, 134, 4, 28, "Input",
 CellTags->"Constructor",
 CellID->442278014],
Cell[32478, 1051, 98, 2, 28, "Input",
 CellTags->"Constructor",
 CellID->997728910]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[32625, 1059, 75, 2, 51, "Section",
 CellTags->"Member",
 CellID->371484373],
Cell[CellGroupData[{
Cell[32725, 1065, 113, 2, 30, "Subsubsection",
 CellTags->"Member",
 CellID->231377526],
Cell[32841, 1069, 109, 2, 28, "Input",
 CellTags->"Member",
 CellID->69072844]
}, Open  ]]
}, Open  ]]
}, Open  ]]
}
]
*)

(* End of internal cache information *)
