(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 8.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       157,          7]
NotebookDataLength[     23772,        855]
NotebookOptionsPosition[     14468,        540]
NotebookOutlinePosition[     19011,        685]
CellTagsIndexPosition[     18821,        676]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell["CurveState", "Chapter",
 CellTags->"Overview"],

Cell["functions to construct and use CurveState objects.", "Text",
 CellTags->"Overview"],

Cell["The first step is to load the QuantLib package. ", "MathCaption",
 CellTags->"Overview"],

Cell["Needs[\"QuantLib`\"]", "Input",
 CellTags->"Overview"],

Cell["\<\
Within the CurveState part there are several constructors and member \
functions available \
\>", "Text",
 CellTags->"Overview"],

Cell["Select[Category[CurveState],QLConstructor[#]&]", "Input",
 CellTags->"Overview"],

Cell["Select[Category[CurveState],QLMember[#]&]", "Input",
 CellTags->"Overview"],

Cell["Select[Category[CurveState],QLProcedure[#]&]", "Input",
 CellTags->"Overview"],

Cell[CellGroupData[{

Cell["Constructors", "Section",
 CellTags->"Constructor"],

Cell[CellGroupData[{

Cell["CMSwapCurveState", "Subsubsection",
 CellTags->"Constructor"],

Cell[BoxData[{Cell[BoxData[GridBox[{
    {"RateTimes", 
     RowBox[{"rate", " ", "fixing", " ", 
      RowBox[{"times", "."}]}]},
    {"SpanningForwards", 
     RowBox[{
     "number", " ", "of", " ", "forwards", " ", "underlying", " ", "the", " ", 
      RowBox[{"CMS", "."}]}]}
   }]], "DefinitionBox",
  CellTags->"Constructor"], "\n", Cell["Calling Parameters", 
  "Caption"]}], "Text"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"RateTimes", "=", 
   RowBox[{"{", 
    RowBox[{
    "0.5", ",", "1.0", ",", "1.5", ",", "2.0", ",", "2.5", ",", "3.0", ",", 
     "3.5", ",", "4.0", ",", "4.5", ",", "5.0", ",", "5.5"}], "}"}]}], 
  ";"}], "\n", 
 RowBox[{
  RowBox[{"SpanningForwards", "=", "5"}], ";"}]}], "Input",
 CellTags->"Constructor"],

Cell["obj=CMSwapCurveState[RateTimes,SpanningForwards]", "Input",
 CellTags->"Constructor"]
}, Open  ]],

Cell[CellGroupData[{

Cell["CoterminalSwapCurveState", "Subsubsection",
 CellTags->"Constructor"],

Cell[BoxData[{Cell[BoxData[GridBox[{
    {"RateTimes", 
     RowBox[{"rate", " ", "fixing", " ", 
      RowBox[{"times", "."}]}]}
   }]], "DefinitionBox",
  CellTags->"Constructor"], "\n", Cell["Calling Parameters", 
  "Caption"]}], "Text"],

Cell[BoxData[
 RowBox[{
  RowBox[{"RateTimes", "=", 
   RowBox[{"{", 
    RowBox[{
    "0.5", ",", "1.0", ",", "1.5", ",", "2.0", ",", "2.5", ",", "3.0", ",", 
     "3.5", ",", "4.0", ",", "4.5", ",", "5.0", ",", "5.5"}], "}"}]}], 
  ";"}]], "Input",
 CellTags->"Constructor"],

Cell["obj=CoterminalSwapCurveState[RateTimes]", "Input",
 CellTags->"Constructor"]
}, Open  ]],

Cell[CellGroupData[{

Cell["LMMCurveState", "Subsubsection",
 CellTags->"Constructor"],

Cell[BoxData[{Cell[BoxData[GridBox[{
    {"RateTimes", 
     RowBox[{"rate", " ", "fixing", " ", 
      RowBox[{"times", "."}]}]}
   }]], "DefinitionBox",
  CellTags->"Constructor"], "\n", Cell["Calling Parameters", 
  "Caption"]}], "Text"],

Cell[BoxData[
 RowBox[{
  RowBox[{"RateTimes", "=", 
   RowBox[{"{", 
    RowBox[{
    "0.5", ",", "1.0", ",", "1.5", ",", "2.0", ",", "2.5", ",", "3.0", ",", 
     "3.5", ",", "4.0", ",", "4.5", ",", "5.0", ",", "5.5"}], "}"}]}], 
  ";"}]], "Input",
 CellTags->"Constructor"],

Cell["obj=LMMCurveState[RateTimes]", "Input",
 CellTags->"Constructor"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Member function", "Section",
 CellTags->"Member"],

Cell[CellGroupData[{

Cell["CurveStateRateTimes", "Subsubsection",
 CellTags->"Member"],

Cell["CurveStateRateTimes[obj]", "Input",
 CellTags->"Member"]
}, Open  ]],

Cell[CellGroupData[{

Cell["CurveStateRateTaus", "Subsubsection",
 CellTags->"Member"],

Cell["CurveStateRateTaus[obj]", "Input",
 CellTags->"Member"]
}, Open  ]],

Cell[CellGroupData[{

Cell["CurveStateForwardRates", "Subsubsection",
 CellTags->"Member"],

Cell["CurveStateForwardRates[obj]", "Input",
 CellTags->"Member"]
}, Open  ]],

Cell[CellGroupData[{

Cell["CurveStateCoterminalSwapRates", "Subsubsection",
 CellTags->"Member"],

Cell["CurveStateCoterminalSwapRates[obj]", "Input",
 CellTags->"Member"]
}, Open  ]],

Cell[CellGroupData[{

Cell["CurveStateCMSwapRates", "Subsubsection",
 CellTags->"Member"],

Cell[BoxData[{Cell[BoxData[GridBox[{
    {"SpanningForwards", 
     RowBox[{
     "number", " ", "of", " ", "forwards", " ", "underlying", " ", "the", " ", 
      RowBox[{"CMS", "."}]}]}
   }]], "DefinitionBox",
  CellTags->"Member"], "\n", Cell["Calling Parameters", "Caption"]}], "Text"],

Cell[BoxData[
 RowBox[{
  RowBox[{"SpanningForwards", "=", "4"}], ";"}]], "Input",
 CellTags->"Member"],

Cell["CurveStateCMSwapRates[obj,SpanningForwards]", "Input",
 CellTags->"Member"]
}, Open  ]],

Cell[CellGroupData[{

Cell["CMSwapCurveStateSetOnCMSwapRates", "Subsubsection",
 CellTags->"Member"],

Cell[BoxData[{Cell[BoxData[GridBox[{
    {"CMSwapRates", 
     RowBox[{"Coterminal", " ", "swap", " ", 
      RowBox[{"rates", "."}]}]}
   }]], "DefinitionBox",
  CellTags->"Member"], "\n", Cell["Calling Parameters", "Caption"]}], "Text"],

Cell[BoxData[
 RowBox[{
  RowBox[{"CMSwapRates", "=", 
   RowBox[{"{", 
    RowBox[{"0.02", ",", "0.02", ",", "0.02", ",", "0.02", ",", "0.02"}], 
    "}"}]}], ";"}]], "Input",
 CellTags->"Member"],

Cell["CMSwapCurveStateSetOnCMSwapRates[obj,CMSwapRates]", "Input",
 CellTags->"Member"]
}, Open  ]],

Cell[CellGroupData[{

Cell["CoterminalSwapCurveStateSetOnCoterminalSwapRates", "Subsubsection",
 CellTags->"Member"],

Cell[BoxData[{Cell[BoxData[GridBox[{
    {"CoterminalSwaps", 
     RowBox[{"Coterminal", " ", "swap", " ", 
      RowBox[{"rates", "."}]}]}
   }]], "DefinitionBox",
  CellTags->"Member"], "\n", Cell["Calling Parameters", "Caption"]}], "Text"],

Cell[BoxData[
 RowBox[{
  RowBox[{"CoterminalSwaps", "=", 
   RowBox[{"{", 
    RowBox[{"0.02", ",", "0.02", ",", "0.02", ",", "0.02", ",", "0.02"}], 
    "}"}]}], ";"}]], "Input",
 CellTags->"Member"],

Cell["\<\
CoterminalSwapCurveStateSetOnCoterminalSwapRates[obj,CoterminalSwaps]\
\>", "Input",
 CellTags->"Member"]
}, Open  ]],

Cell[CellGroupData[{

Cell["LMMCurveStateSetOnForwardRates", "Subsubsection",
 CellTags->"Member"],

Cell[BoxData[{Cell[BoxData[GridBox[{
    {"Rates", 
     RowBox[{"forward", " ", 
      RowBox[{"rates", "."}]}]}
   }]], "DefinitionBox",
  CellTags->"Member"], "\n", Cell["Calling Parameters", "Caption"]}], "Text"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Rates", "=", 
   RowBox[{"{", 
    RowBox[{"0.02", ",", "0.02", ",", "0.02", ",", "0.02", ",", "0.02"}], 
    "}"}]}], ";"}]], "Input",
 CellTags->"Member"],

Cell["LMMCurveStateSetOnForwardRates[obj,Rates]", "Input",
 CellTags->"Member"]
}, Open  ]],

Cell[CellGroupData[{

Cell["LMMCurveStateSetOnDiscountRatios", "Subsubsection",
 CellTags->"Member"],

Cell[BoxData[{Cell[BoxData[GridBox[{
    {"DiscountRatios", 
     RowBox[{"discount", " ", 
      RowBox[{"ratios", "."}]}]}
   }]], "DefinitionBox",
  CellTags->"Member"], "\n", Cell["Calling Parameters", "Caption"]}], "Text"],

Cell[BoxData[
 RowBox[{
  RowBox[{"DiscountRatios", "=", 
   RowBox[{"{", 
    RowBox[{"1.0", ",", "1.0", ",", "1.0", ",", "1.0", ",", "1.0"}], "}"}]}], 
  ";"}]], "Input",
 CellTags->"Member"],

Cell["LMMCurveStateSetOnDiscountRatios[obj,DiscountRatios]", "Input",
 CellTags->"Member"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Procedures", "Section",
 CellTags->"Procedure"],

Cell[CellGroupData[{

Cell["ForwardsFromDiscountRatios", "Subsubsection",
 CellTags->"Procedure"],

Cell[BoxData[{Cell[BoxData[GridBox[{
    {"FirstValidIndex", 
     RowBox[{
     "marks", " ", "the", " ", "first", " ", "non", " ", "expired", " ", 
      "discount", " ", 
      RowBox[{"bond", "."}]}]},
    {"DiscountRatios", 
     RowBox[{"vector", " ", "of", " ", "discount", " ", "bond", " ", 
      RowBox[{"ratios", "."}]}]},
    {"Taus", 
     RowBox[{"rate", " ", "time", " ", 
      RowBox[{"intervals", "."}]}]}
   }]], "DefinitionBox",
  CellTags->"Procedure"], "\n", Cell["Calling Parameters", 
  "Caption"]}], "Text"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"FirstValidIndex", "=", "1"}], ";"}], "\n", 
 RowBox[{
  RowBox[{"DiscountRatios", "=", 
   RowBox[{"{", 
    RowBox[{"1.0", ",", "1.0", ",", "1.0", ",", "1.0", ",", "1.0"}], "}"}]}], 
  ";"}], "\n", 
 RowBox[{
  RowBox[{"Taus", "=", 
   RowBox[{"{", 
    RowBox[{"0.5", ",", "0.5", ",", "0.5", ",", "0.5", ",", "0.5"}], "}"}]}], 
  ";"}]}], "Input",
 CellTags->"Procedure"],

Cell["\<\
ForwardsFromDiscountRatios[FirstValidIndex,DiscountRatios,Taus]\
\>", "Input",
 CellTags->"Procedure"]
}, Open  ]],

Cell[CellGroupData[{

Cell["CoterminalSwapRatesFromDiscountRatios", "Subsubsection",
 CellTags->"Procedure"],

Cell[BoxData[{Cell[BoxData[GridBox[{
    {"FirstValidIndex", 
     RowBox[{
     "marks", " ", "the", " ", "first", " ", "non", " ", "expired", " ", 
      "discount", " ", 
      RowBox[{"bond", "."}]}]},
    {"DiscountRatios", 
     RowBox[{"vector", " ", "of", " ", "discount", " ", "bond", " ", 
      RowBox[{"ratios", "."}]}]},
    {"Taus", 
     RowBox[{"rate", " ", "time", " ", 
      RowBox[{"intervals", "."}]}]}
   }]], "DefinitionBox",
  CellTags->"Procedure"], "\n", Cell["Calling Parameters", 
  "Caption"]}], "Text"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"FirstValidIndex", "=", "1"}], ";"}], "\n", 
 RowBox[{
  RowBox[{"DiscountRatios", "=", 
   RowBox[{"{", 
    RowBox[{"1.0", ",", "1.0", ",", "1.0", ",", "1.0", ",", "1.0"}], "}"}]}], 
  ";"}], "\n", 
 RowBox[{
  RowBox[{"Taus", "=", 
   RowBox[{"{", 
    RowBox[{"0.5", ",", "0.5", ",", "0.5", ",", "0.5", ",", "0.5"}], "}"}]}], 
  ";"}]}], "Input",
 CellTags->"Procedure"],

Cell["\<\
CoterminalSwapRatesFromDiscountRatios[FirstValidIndex,DiscountRatios,Taus]\
\>", "Input",
 CellTags->"Procedure"]
}, Open  ]],

Cell[CellGroupData[{

Cell["CoterminalSwapAnnuitiesFromDiscountRatios", "Subsubsection",
 CellTags->"Procedure"],

Cell[BoxData[{Cell[BoxData[GridBox[{
    {"FirstValidIndex", 
     RowBox[{
     "marks", " ", "the", " ", "first", " ", "non", " ", "expired", " ", 
      "discount", " ", 
      RowBox[{"bond", "."}]}]},
    {"DiscountRatios", 
     RowBox[{"vector", " ", "of", " ", "discount", " ", "bond", " ", 
      RowBox[{"ratios", "."}]}]},
    {"Taus", 
     RowBox[{"rate", " ", "time", " ", 
      RowBox[{"intervals", "."}]}]}
   }]], "DefinitionBox",
  CellTags->"Procedure"], "\n", Cell["Calling Parameters", 
  "Caption"]}], "Text"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"FirstValidIndex", "=", "1"}], ";"}], "\n", 
 RowBox[{
  RowBox[{"DiscountRatios", "=", 
   RowBox[{"{", 
    RowBox[{"1.0", ",", "1.0", ",", "1.0", ",", "1.0", ",", "1.0"}], "}"}]}], 
  ";"}], "\n", 
 RowBox[{
  RowBox[{"Taus", "=", 
   RowBox[{"{", 
    RowBox[{"0.5", ",", "0.5", ",", "0.5", ",", "0.5", ",", "0.5"}], "}"}]}], 
  ";"}]}], "Input",
 CellTags->"Procedure"],

Cell["\<\
CoterminalSwapAnnuitiesFromDiscountRatios[FirstValidIndex,DiscountRatios,Taus]\
\>", "Input",
 CellTags->"Procedure"]
}, Open  ]],

Cell[CellGroupData[{

Cell["ConstantMaturitySwapRatesFromDiscountRatios", "Subsubsection",
 CellTags->"Procedure"],

Cell[BoxData[{Cell[BoxData[GridBox[{
    {"SpanningForwards", 
     RowBox[{
     "number", " ", "of", " ", "forward", " ", "rates", " ", "spanned", " ", 
      "by", " ", "the", " ", "constant", " ", "maturity", " ", 
      RowBox[{"swap", "."}]}]},
    {"FirstValidIndex", 
     RowBox[{
     "marks", " ", "the", " ", "first", " ", "non", " ", "expired", " ", 
      "discount", " ", 
      RowBox[{"bond", "."}]}]},
    {"DiscountRatios", 
     RowBox[{"vector", " ", "of", " ", "discount", " ", "bond", " ", 
      RowBox[{"ratios", "."}]}]},
    {"Taus", 
     RowBox[{"rate", " ", "time", " ", 
      RowBox[{"intervals", "."}]}]}
   }]], "DefinitionBox",
  CellTags->"Procedure"], "\n", Cell["Calling Parameters", 
  "Caption"]}], "Text"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"SpanningForwards", "=", "10"}], ";"}], "\n", 
 RowBox[{
  RowBox[{"FirstValidIndex", "=", "0.001"}], ";"}], "\n", 
 RowBox[{
  RowBox[{"DiscountRatios", "=", 
   RowBox[{"{", 
    RowBox[{"1.0", ",", "1.0", ",", "1.0", ",", "1.0", ",", "1.0"}], "}"}]}], 
  ";"}], "\n", 
 RowBox[{
  RowBox[{"Taus", "=", 
   RowBox[{"{", 
    RowBox[{"0.5", ",", "0.5", ",", "0.5", ",", "0.5", ",", "0.5"}], "}"}]}], 
  ";"}]}], "Input",
 CellTags->"Procedure"],

Cell["\<\
ConstantMaturitySwapRatesFromDiscountRatios[SpanningForwards,FirstValidIndex,\
DiscountRatios,Taus]\
\>", "Input",
 CellTags->"Procedure"]
}, Open  ]],

Cell[CellGroupData[{

Cell["ConstantMaturitySwapAnnuitiesFromDiscountRatios", "Subsubsection",
 CellTags->"Procedure"],

Cell[BoxData[{Cell[BoxData[GridBox[{
    {"SpanningForwards", 
     RowBox[{
     "number", " ", "of", " ", "forward", " ", "rates", " ", "spanned", " ", 
      "by", " ", "the", " ", "constant", " ", "maturity", " ", 
      RowBox[{"swap", "."}]}]},
    {"FirstValidIndex", 
     RowBox[{
     "marks", " ", "the", " ", "first", " ", "non", " ", "expired", " ", 
      "discount", " ", 
      RowBox[{"bond", "."}]}]},
    {"DiscountRatios", 
     RowBox[{"vector", " ", "of", " ", "discount", " ", "bond", " ", 
      RowBox[{"ratios", "."}]}]},
    {"Taus", 
     RowBox[{"rate", " ", "time", " ", 
      RowBox[{"intervals", "."}]}]}
   }]], "DefinitionBox",
  CellTags->"Procedure"], "\n", Cell["Calling Parameters", 
  "Caption"]}], "Text"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"SpanningForwards", "=", "5"}], ";"}], "\n", 
 RowBox[{
  RowBox[{"FirstValidIndex", "=", "1"}], ";"}], "\n", 
 RowBox[{
  RowBox[{"DiscountRatios", "=", 
   RowBox[{"{", 
    RowBox[{"1.0", ",", "1.0", ",", "1.0", ",", "1.0", ",", "1.0"}], "}"}]}], 
  ";"}], "\n", 
 RowBox[{
  RowBox[{"Taus", "=", 
   RowBox[{"{", 
    RowBox[{"0.5", ",", "0.5", ",", "0.5", ",", "0.5", ",", "0.5"}], "}"}]}], 
  ";"}]}], "Input",
 CellTags->"Procedure"],

Cell["\<\
ConstantMaturitySwapAnnuitiesFromDiscountRatios[SpanningForwards,\
FirstValidIndex,DiscountRatios,Taus]\
\>", "Input",
 CellTags->"Procedure"]
}, Open  ]]
}, Open  ]],

Cell["Enumeration Member", "Section",
 CellTags->"EnumerationMember"]
}, Open  ]]
},
WindowSize->{716, 867},
WindowMargins->{{278, Automatic}, {Automatic, 42}},
FrontEndVersion->"8.0 for Microsoft Windows (32-bit) (February 23, 2011)",
StyleDefinitions->"HelpBrowser.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "Overview"->{
  Cell[579, 22, 52, 1, 99, "Chapter",
   CellTags->"Overview"],
  Cell[634, 25, 89, 1, 37, "Text",
   CellTags->"Overview"],
  Cell[726, 28, 94, 1, 53, "MathCaption",
   CellTags->"Overview"],
  Cell[823, 31, 60, 1, 41, "Input",
   CellTags->"Overview"],
  Cell[886, 34, 138, 4, 37, "Text",
   CellTags->"Overview"],
  Cell[1027, 40, 86, 1, 41, "Input",
   CellTags->"Overview"],
  Cell[1116, 43, 81, 1, 41, "Input",
   CellTags->"Overview"],
  Cell[1200, 46, 84, 1, 41, "Input",
   CellTags->"Overview"]},
 "Constructor"->{
  Cell[1309, 51, 57, 1, 77, "Section",
   CellTags->"Constructor"],
  Cell[1391, 56, 67, 1, 47, "Subsubsection",
   CellTags->"Constructor"],
  Cell[1855, 71, 344, 10, 62, "Input",
   CellTags->"Constructor"],
  Cell[2202, 83, 91, 1, 41, "Input",
   CellTags->"Constructor"],
  Cell[2330, 89, 75, 1, 47, "Subsubsection",
   CellTags->"Constructor"],
  Cell[2651, 100, 276, 8, 41, "Input",
   CellTags->"Constructor"],
  Cell[2930, 110, 82, 1, 41, "Input",
   CellTags->"Constructor"],
  Cell[3049, 116, 64, 1, 47, "Subsubsection",
   CellTags->"Constructor"],
  Cell[3359, 127, 276, 8, 41, "Input",
   CellTags->"Constructor"],
  Cell[3638, 137, 71, 1, 41, "Input",
   CellTags->"Constructor"]},
 "Member"->{
  Cell[3758, 144, 55, 1, 77, "Section",
   CellTags->"Member"],
  Cell[3838, 149, 65, 1, 47, "Subsubsection",
   CellTags->"Member"],
  Cell[3906, 152, 62, 1, 41, "Input",
   CellTags->"Member"],
  Cell[4005, 158, 64, 1, 47, "Subsubsection",
   CellTags->"Member"],
  Cell[4072, 161, 61, 1, 41, "Input",
   CellTags->"Member"],
  Cell[4170, 167, 68, 1, 47, "Subsubsection",
   CellTags->"Member"],
  Cell[4241, 170, 65, 1, 41, "Input",
   CellTags->"Member"],
  Cell[4343, 176, 75, 1, 47, "Subsubsection",
   CellTags->"Member"],
  Cell[4421, 179, 72, 1, 41, "Input",
   CellTags->"Member"],
  Cell[4530, 185, 67, 1, 47, "Subsubsection",
   CellTags->"Member"],
  Cell[4892, 196, 103, 3, 41, "Input",
   CellTags->"Member"],
  Cell[4998, 201, 81, 1, 41, "Input",
   CellTags->"Member"],
  Cell[5116, 207, 78, 1, 47, "Subsubsection",
   CellTags->"Member"],
  Cell[5438, 217, 197, 6, 41, "Input",
   CellTags->"Member"],
  Cell[5638, 225, 87, 1, 41, "Input",
   CellTags->"Member"],
  Cell[5762, 231, 94, 1, 47, "Subsubsection",
   CellTags->"Member"],
  Cell[6104, 241, 201, 6, 41, "Input",
   CellTags->"Member"],
  Cell[6308, 249, 115, 3, 41, "Input",
   CellTags->"Member"],
  Cell[6460, 257, 76, 1, 47, "Subsubsection",
   CellTags->"Member"],
  Cell[6758, 267, 191, 6, 41, "Input",
   CellTags->"Member"],
  Cell[6952, 275, 79, 1, 41, "Input",
   CellTags->"Member"],
  Cell[7068, 281, 78, 1, 47, "Subsubsection",
   CellTags->"Member"],
  Cell[7379, 291, 193, 6, 41, "Input",
   CellTags->"Member"],
  Cell[7575, 299, 90, 1, 41, "Input",
   CellTags->"Member"]},
 "Procedure"->{
  Cell[7714, 306, 53, 1, 77, "Section",
   CellTags->"Procedure"],
  Cell[7792, 311, 75, 1, 47, "Subsubsection",
   CellTags->"Procedure"],
  Cell[8405, 330, 409, 13, 82, "Input",
   CellTags->"Procedure"],
  Cell[8817, 345, 112, 3, 41, "Input",
   CellTags->"Procedure"],
  Cell[8966, 353, 86, 1, 47, "Subsubsection",
   CellTags->"Procedure"],
  Cell[9590, 372, 409, 13, 82, "Input",
   CellTags->"Procedure"],
  Cell[10002, 387, 123, 3, 41, "Input",
   CellTags->"Procedure"],
  Cell[10162, 395, 90, 1, 47, "Subsubsection",
   CellTags->"Procedure"],
  Cell[10790, 414, 409, 13, 82, "Input",
   CellTags->"Procedure"],
  Cell[11202, 429, 127, 3, 41, "Input",
   CellTags->"Procedure"],
  Cell[11366, 437, 92, 1, 47, "Subsubsection",
   CellTags->"Procedure"],
  Cell[12210, 461, 480, 15, 102, "Input",
   CellTags->"Procedure"],
  Cell[12693, 478, 148, 4, 61, "Input",
   CellTags->"Procedure"],
  Cell[12878, 487, 96, 1, 47, "Subsubsection",
   CellTags->"Procedure"],
  Cell[13726, 511, 475, 15, 102, "Input",
   CellTags->"Procedure"],
  Cell[14204, 528, 152, 4, 61, "Input",
   CellTags->"Procedure"]},
 "EnumerationMember"->{
  Cell[14383, 536, 69, 1, 77, "Section",
   CellTags->"EnumerationMember"]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"Overview", 14768, 550},
 {"Constructor", 15293, 567},
 {"Member", 16002, 588},
 {"Procedure", 17587, 637},
 {"EnumerationMember", 18721, 670}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[579, 22, 52, 1, 99, "Chapter",
 CellTags->"Overview"],
Cell[634, 25, 89, 1, 37, "Text",
 CellTags->"Overview"],
Cell[726, 28, 94, 1, 53, "MathCaption",
 CellTags->"Overview"],
Cell[823, 31, 60, 1, 41, "Input",
 CellTags->"Overview"],
Cell[886, 34, 138, 4, 37, "Text",
 CellTags->"Overview"],
Cell[1027, 40, 86, 1, 41, "Input",
 CellTags->"Overview"],
Cell[1116, 43, 81, 1, 41, "Input",
 CellTags->"Overview"],
Cell[1200, 46, 84, 1, 41, "Input",
 CellTags->"Overview"],
Cell[CellGroupData[{
Cell[1309, 51, 57, 1, 77, "Section",
 CellTags->"Constructor"],
Cell[CellGroupData[{
Cell[1391, 56, 67, 1, 47, "Subsubsection",
 CellTags->"Constructor"],
Cell[1461, 59, 391, 10, 80, "Text"],
Cell[1855, 71, 344, 10, 62, "Input",
 CellTags->"Constructor"],
Cell[2202, 83, 91, 1, 41, "Input",
 CellTags->"Constructor"]
}, Open  ]],
Cell[CellGroupData[{
Cell[2330, 89, 75, 1, 47, "Subsubsection",
 CellTags->"Constructor"],
Cell[2408, 92, 240, 6, 64, "Text"],
Cell[2651, 100, 276, 8, 41, "Input",
 CellTags->"Constructor"],
Cell[2930, 110, 82, 1, 41, "Input",
 CellTags->"Constructor"]
}, Open  ]],
Cell[CellGroupData[{
Cell[3049, 116, 64, 1, 47, "Subsubsection",
 CellTags->"Constructor"],
Cell[3116, 119, 240, 6, 64, "Text"],
Cell[3359, 127, 276, 8, 41, "Input",
 CellTags->"Constructor"],
Cell[3638, 137, 71, 1, 41, "Input",
 CellTags->"Constructor"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[3758, 144, 55, 1, 77, "Section",
 CellTags->"Member"],
Cell[CellGroupData[{
Cell[3838, 149, 65, 1, 47, "Subsubsection",
 CellTags->"Member"],
Cell[3906, 152, 62, 1, 41, "Input",
 CellTags->"Member"]
}, Open  ]],
Cell[CellGroupData[{
Cell[4005, 158, 64, 1, 47, "Subsubsection",
 CellTags->"Member"],
Cell[4072, 161, 61, 1, 41, "Input",
 CellTags->"Member"]
}, Open  ]],
Cell[CellGroupData[{
Cell[4170, 167, 68, 1, 47, "Subsubsection",
 CellTags->"Member"],
Cell[4241, 170, 65, 1, 41, "Input",
 CellTags->"Member"]
}, Open  ]],
Cell[CellGroupData[{
Cell[4343, 176, 75, 1, 47, "Subsubsection",
 CellTags->"Member"],
Cell[4421, 179, 72, 1, 41, "Input",
 CellTags->"Member"]
}, Open  ]],
Cell[CellGroupData[{
Cell[4530, 185, 67, 1, 47, "Subsubsection",
 CellTags->"Member"],
Cell[4600, 188, 289, 6, 64, "Text"],
Cell[4892, 196, 103, 3, 41, "Input",
 CellTags->"Member"],
Cell[4998, 201, 81, 1, 41, "Input",
 CellTags->"Member"]
}, Open  ]],
Cell[CellGroupData[{
Cell[5116, 207, 78, 1, 47, "Subsubsection",
 CellTags->"Member"],
Cell[5197, 210, 238, 5, 64, "Text"],
Cell[5438, 217, 197, 6, 41, "Input",
 CellTags->"Member"],
Cell[5638, 225, 87, 1, 41, "Input",
 CellTags->"Member"]
}, Open  ]],
Cell[CellGroupData[{
Cell[5762, 231, 94, 1, 47, "Subsubsection",
 CellTags->"Member"],
Cell[5859, 234, 242, 5, 64, "Text"],
Cell[6104, 241, 201, 6, 41, "Input",
 CellTags->"Member"],
Cell[6308, 249, 115, 3, 41, "Input",
 CellTags->"Member"]
}, Open  ]],
Cell[CellGroupData[{
Cell[6460, 257, 76, 1, 47, "Subsubsection",
 CellTags->"Member"],
Cell[6539, 260, 216, 5, 64, "Text"],
Cell[6758, 267, 191, 6, 41, "Input",
 CellTags->"Member"],
Cell[6952, 275, 79, 1, 41, "Input",
 CellTags->"Member"]
}, Open  ]],
Cell[CellGroupData[{
Cell[7068, 281, 78, 1, 47, "Subsubsection",
 CellTags->"Member"],
Cell[7149, 284, 227, 5, 64, "Text"],
Cell[7379, 291, 193, 6, 41, "Input",
 CellTags->"Member"],
Cell[7575, 299, 90, 1, 41, "Input",
 CellTags->"Member"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[7714, 306, 53, 1, 77, "Section",
 CellTags->"Procedure"],
Cell[CellGroupData[{
Cell[7792, 311, 75, 1, 47, "Subsubsection",
 CellTags->"Procedure"],
Cell[7870, 314, 532, 14, 99, "Text"],
Cell[8405, 330, 409, 13, 82, "Input",
 CellTags->"Procedure"],
Cell[8817, 345, 112, 3, 41, "Input",
 CellTags->"Procedure"]
}, Open  ]],
Cell[CellGroupData[{
Cell[8966, 353, 86, 1, 47, "Subsubsection",
 CellTags->"Procedure"],
Cell[9055, 356, 532, 14, 99, "Text"],
Cell[9590, 372, 409, 13, 82, "Input",
 CellTags->"Procedure"],
Cell[10002, 387, 123, 3, 41, "Input",
 CellTags->"Procedure"]
}, Open  ]],
Cell[CellGroupData[{
Cell[10162, 395, 90, 1, 47, "Subsubsection",
 CellTags->"Procedure"],
Cell[10255, 398, 532, 14, 99, "Text"],
Cell[10790, 414, 409, 13, 82, "Input",
 CellTags->"Procedure"],
Cell[11202, 429, 127, 3, 41, "Input",
 CellTags->"Procedure"]
}, Open  ]],
Cell[CellGroupData[{
Cell[11366, 437, 92, 1, 47, "Subsubsection",
 CellTags->"Procedure"],
Cell[11461, 440, 746, 19, 141, "Text"],
Cell[12210, 461, 480, 15, 102, "Input",
 CellTags->"Procedure"],
Cell[12693, 478, 148, 4, 61, "Input",
 CellTags->"Procedure"]
}, Open  ]],
Cell[CellGroupData[{
Cell[12878, 487, 96, 1, 47, "Subsubsection",
 CellTags->"Procedure"],
Cell[12977, 490, 746, 19, 141, "Text"],
Cell[13726, 511, 475, 15, 102, "Input",
 CellTags->"Procedure"],
Cell[14204, 528, 152, 4, 61, "Input",
 CellTags->"Procedure"]
}, Open  ]]
}, Open  ]],
Cell[14383, 536, 69, 1, 77, "Section",
 CellTags->"EnumerationMember"]
}, Open  ]]
}
]
*)

(* End of internal cache information *)

