(* Content-type: application/mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 6.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       145,          7]
NotebookDataLength[     41877,       1352]
NotebookOptionsPosition[     30742,        951]
NotebookOutlinePosition[     34703,       1071]
CellTagsIndexPosition[     33991,       1051]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell["QuantLib", "Subtitle",
 CellChangeTimes->{{3.434947043421875*^9, 3.434947050171875*^9}},
 CellID->809310472],

Cell[CellGroupData[{

Cell["Date", "Title",
 CellChangeTimes->{{3.43494703740625*^9, 3.43494703928125*^9}, 
   3.434951659765625*^9, 3.43503746765625*^9, {3.435308085953125*^9, 
   3.43530808640625*^9}, {3.43531829871875*^9, 3.435318332828125*^9}, {
   3.43531845903125*^9, 3.435318459515625*^9}},
 CellID->67882606],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Category", "[", "Date", "]"}]], "Input",
 CellChangeTimes->{
  3.4350374865*^9, {3.43530809390625*^9, 3.43530809421875*^9}, {
   3.435317821125*^9, 3.43531782203125*^9}, {3.43531834046875*^9, 
   3.43531834803125*^9}, {3.43531846246875*^9, 3.435318462890625*^9}},
 CellID->609720372],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "DateEndOfMonth", ",", "DateIsEndOfMonth", ",", "DateIsLeap", ",", 
   "DateMaxDate", ",", "DateMinDate", ",", "DateNextWeekday", ",", 
   "DateNthWeekday", ",", "FrequencyFromPeriod", ",", "IMMIsIMMcode", ",", 
   "IMMIsIMMdate", ",", "IMMNextCode", ",", "IMMNextCodes", ",", 
   "IMMNextDate", ",", "IMMNextDates", ",", "IMMcode", ",", "IMMdate", ",", 
   "PeriodEquivalent", ",", "PeriodFromFrequency", ",", "PeriodLessThan"}], 
  "}"}]], "Output",
 CellChangeTimes->{3.43503748790625*^9, 3.4350415943125*^9, 
  3.435043991453125*^9, 3.435045711375*^9, 3.4350488741875*^9, 
  3.435048959234375*^9, 3.43504960696875*^9, 3.43504997275*^9, 
  3.43506560309375*^9, 3.435301008140625*^9, 3.435301663984375*^9, 
  3.43530809525*^9, 3.435308442*^9, 3.43530881784375*^9, 3.43531670009375*^9, 
  3.435317824375*^9, 3.43531834896875*^9, 3.4353184640625*^9, 
  3.435319574796875*^9, 3.435323514703125*^9, 3.4354850405625*^9},
 CellID->281027703]
}, Open  ]],

Cell[CellGroupData[{

Cell["DateEndOfMonth, DateIsEndOfMonth, DateIsLeap", "Subsection",
 CellChangeTimes->{3.4353186445*^9},
 CellID->1022593],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"datelist", " ", "=", 
  RowBox[{"Table", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"DatePlus", "[", 
      RowBox[{
       RowBox[{"Date", "[", "]"}], ",", 
       RowBox[{"{", 
        RowBox[{"i", ",", "\"\<Year\>\""}], "}"}]}], "]"}], "[", 
     RowBox[{"[", 
      RowBox[{"1", ";;", "3"}], "]"}], "]"}], ",", 
    RowBox[{"{", 
     RowBox[{"i", ",", "0", ",", "10"}], "}"}]}], "]"}]}]], "Input",
 CellID->1351597],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"2008", ",", "11", ",", "12"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"2009", ",", "11", ",", "12"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"2010", ",", "11", ",", "12"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"2011", ",", "11", ",", "12"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"2012", ",", "11", ",", "12"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"2013", ",", "11", ",", "12"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"2014", ",", "11", ",", "12"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"2015", ",", "11", ",", "12"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"2016", ",", "11", ",", "12"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"2017", ",", "11", ",", "12"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"2018", ",", "11", ",", "12"}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{3.435318506796875*^9, 3.43531957753125*^9, 
  3.43532351615625*^9, 3.435485042265625*^9},
 CellID->373788982]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", "DateEndOfMonth"}]], "Input",
 CellID->150515139],

Cell[BoxData[
 StyleBox["\<\"DateEndOfMonth[Date_List /; VectorQ[Date, DateQ]] returns the \
last day of the month to which the given date belongs.       \\nDate: date.\"\
\>", "MSG"]], "Print", "PrintUsage",
 CellChangeTimes->{3.435485043078125*^9},
 CellTags->"Info3435488642-4052774",
 CellID->61382713]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"endmonthlist", " ", "=", 
  RowBox[{"DateEndOfMonth", "[", "datelist", "]"}]}]], "Input",
 CellChangeTimes->{{3.43531850859375*^9, 3.435318551171875*^9}},
 CellID->80758292],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"2008", ",", "11", ",", "30"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"2009", ",", "11", ",", "30"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"2010", ",", "11", ",", "30"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"2011", ",", "11", ",", "30"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"2012", ",", "11", ",", "30"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"2013", ",", "11", ",", "30"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"2014", ",", "11", ",", "30"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"2015", ",", "11", ",", "30"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"2016", ",", "11", ",", "30"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"2017", ",", "11", ",", "30"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"2018", ",", "11", ",", "30"}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{3.435318521171875*^9, 3.435318552046875*^9, 
  3.43531957928125*^9, 3.435323518671875*^9, 3.4354850438125*^9},
 CellID->415350481]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DateIsEndOfMonth", "[", "datelist", "]"}]], "Input",
 CellChangeTimes->{{3.435318553484375*^9, 3.4353185785625*^9}},
 CellID->260291230],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "False", ",", "False", ",", "False", ",", "False", ",", "False", ",", 
   "False", ",", "False", ",", "False", ",", "False", ",", "False", ",", 
   "False"}], "}"}]], "Output",
 CellChangeTimes->{3.435318579203125*^9, 3.43531958003125*^9, 
  3.435323520359375*^9, 3.435485044453125*^9},
 CellID->290782679]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", "DateIsLeap"}]], "Input",
 CellChangeTimes->{{3.43531869665625*^9, 3.43531869946875*^9}},
 CellID->323055179],

Cell[BoxData[
 StyleBox["\<\"DateIsLeap[Year_List /; VectorQ[Year, IntegerQ]] returns TRUE \
if a year is leap.       \\nYear: year (e.g. 2006).\"\>", "MSG"]], "Print", \
"PrintUsage",
 CellChangeTimes->{3.43548504671875*^9},
 CellTags->"Info3435488646-9389832",
 CellID->85468209]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DateIsLeap", "[", 
  RowBox[{"datelist", "[", 
   RowBox[{"[", 
    RowBox[{"All", ",", "1"}], "]"}], "]"}], "]"}]], "Input",
 CellChangeTimes->{{3.435318553484375*^9, 3.4353185891875*^9}, {
  3.43531867803125*^9, 3.43531871553125*^9}},
 CellID->374058879],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "True", ",", "False", ",", "False", ",", "False", ",", "True", ",", "False",
    ",", "False", ",", "False", ",", "True", ",", "False", ",", "False"}], 
  "}"}]], "Output",
 CellChangeTimes->{3.435318590359375*^9, 3.435318683140625*^9, 
  3.43531871625*^9, 3.435319582125*^9, 3.4353235224375*^9, 
  3.43548504784375*^9},
 CellID->492518817]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["DateMaxDate, DateMinDate", "Subsection",
 CellID->63203798],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", "DateMaxDate"}]], "Input",
 CellChangeTimes->{{3.435318754734375*^9, 3.435318759609375*^9}},
 CellID->397614599],

Cell[BoxData[
 StyleBox["\<\"DateMaxDate[] returns the latest date allowed in QuantLib.     \
  \\n\"\>", "MSG"]], "Print", "PrintUsage",
 CellChangeTimes->{3.435485050265625*^9},
 CellTags->"Info3435488650-8072290",
 CellID->30670660]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"DateMinDate", "[", "]"}], ",", 
   RowBox[{"DateMaxDate", "[", "]"}]}], "}"}]], "Input",
 CellChangeTimes->{{3.435318763671875*^9, 3.4353187825*^9}},
 CellID->340459595],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"1901", ",", "1", ",", "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"2199", ",", "12", ",", "31"}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{3.435318783234375*^9, 3.43531959*^9, 3.435323525390625*^9, 
  3.435485051265625*^9},
 CellID->65597243]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["DateNextWeekday, DateNthWeekday", "Subsection",
 CellID->83908880],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", "DateNextWeekday"}]], "Input",
 CellChangeTimes->{{3.43531887928125*^9, 3.43531888409375*^9}},
 CellID->606867686],

Cell[BoxData[
 StyleBox["\<\"DateNextWeekday[Date_List /; VectorQ[Date, \
DateQ],Weekday_String] Returns the next given weekday following or equal to \
the given date (e.g., the Friday following Tuesday, January 15th, 2002 was \
January 18th, 2002).       \\nDate: date.\\nWeekday: Weekday (e.g. Wednesday, \
or Wed).\"\>", "MSG"]], "Print", "PrintUsage",
 CellChangeTimes->{3.43548505434375*^9},
 CellTags->"Info3435488654-1215600",
 CellID->466122818]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DateNextWeekday", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"{", 
     RowBox[{"2002", ",", "1", ",", "15"}], "}"}], "}"}], ",", 
   "\"\<Friday\>\""}], "]"}]], "Input",
 CellChangeTimes->{{3.43531889490625*^9, 3.43531893140625*^9}},
 CellID->56608582],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"{", 
   RowBox[{"2002", ",", "1", ",", "18"}], "}"}], "}"}]], "Output",
 CellChangeTimes->{3.435318934578125*^9, 3.435319641984375*^9, 
  3.435323534109375*^9, 3.4354850553125*^9},
 CellID->2050765]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", "DateNthWeekday"}]], "Input",
 CellChangeTimes->{3.435318945328125*^9},
 CellID->209692816],

Cell[BoxData[
 StyleBox["\<\"DateNthWeekday[Nth_Integer,Weekday_String,Month_String,Year_\
Integer] Returns the n-th given weekday in the given month and year (e.g., \
the 4th Thursday of March, 1998 was March 26th, 1998).       \\nNth: ordinal \
number (greater than zero, less than 6).\\nWeekday: Weekday (e.g. Wednesday, \
or Wed).\\nMonth: Month (e.g. January, or Jan).\\nYear: year (e.g. \
2006).\"\>", "MSG"]], "Print", "PrintUsage",
 CellChangeTimes->{3.4354850565625*^9},
 CellTags->"Info3435488656-4423637",
 CellID->14608159]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DateNthWeekday", "[", 
  RowBox[{"4", ",", "\"\<Thursday\>\"", ",", "\"\<March\>\"", ",", "1998"}], 
  "]"}]], "Input",
 CellChangeTimes->{{3.435318945328125*^9, 3.4353189859375*^9}},
 CellID->198433951],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"1998", ",", "3", ",", "26"}], "}"}]], "Output",
 CellChangeTimes->{3.435318986765625*^9, 3.435319644046875*^9, 
  3.435323536390625*^9, 3.43548505784375*^9},
 CellID->4783060]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Period and Frequency Functions", "Subsection",
 CellChangeTimes->{{3.4354014140625*^9, 3.435401415375*^9}, {
  3.4354015639375*^9, 3.4354015728125*^9}},
 CellID->248030531],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", "FrequencyFromPeriod"}]], "Input",
 CellChangeTimes->{3.435323554703125*^9},
 CellID->231281697],

Cell[BoxData[
 StyleBox["\<\"FrequencyFromPeriod[Period_List] returns a Frequency from a \
given Period (e.g. SemiAnnual from 6M).       \\nPeriod: period(s) to advance \
(e.g. 2D for two days , 3W for three weeks, 6M for six months, 1Y for one \
year).\"\>", "MSG"]], "Print", "PrintUsage",
 CellChangeTimes->{3.435485060015625*^9},
 CellTags->"Info3435488659-2165934",
 CellID->90074639]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", "PeriodFromFrequency"}]], "Input",
 CellChangeTimes->{3.43540141971875*^9},
 CellID->223885664],

Cell[BoxData[
 StyleBox["\<\"PeriodFromFrequency[Frequency_String] returns a Period from a \
given Frequency (e.g. 6M from SemiAnnual).       \\nFrequency: frequency \
(e.g. Annual, Semiannual, Every4Month, Quarterly, Bimonthly, Monthly).\"\>", 
  "MSG"]], "Print", "PrintUsage",
 CellChangeTimes->{3.43548506109375*^9},
 CellTags->"Info3435488660-4560467",
 CellID->29758861]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"FrequencyFromPeriod", "[", 
  RowBox[{"{", "\"\<6M\>\"", "}"}], "]"}]], "Input",
 CellChangeTimes->{{3.43532357690625*^9, 3.43532358978125*^9}, {
  3.43532362209375*^9, 3.435323628125*^9}, {3.435323706375*^9, 
  3.43532370709375*^9}},
 CellID->30775833],

Cell[BoxData[
 RowBox[{"{", "\<\"Semiannual\"\>", "}"}]], "Output",
 CellChangeTimes->{
  3.435323628921875*^9, 3.4353237079375*^9, 3.435388834203125*^9, 
   3.4353898234375*^9, {3.435390945828125*^9, 3.435390959875*^9}, 
   3.4353950903125*^9, 3.4354013780625*^9, 3.435485062*^9},
 CellID->134173449]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"FrequencyFromPeriod", "[", 
  RowBox[{"{", "\"\<1Y\>\"", "}"}], "]"}]], "Input",
 CellChangeTimes->{{3.435323777359375*^9, 3.435323782078125*^9}, {
  3.435395112609375*^9, 3.435395127203125*^9}},
 CellID->36749801],

Cell[BoxData[
 RowBox[{"{", "\<\"Annual\"\>", "}"}]], "Output",
 CellChangeTimes->{
  3.4353237834375*^9, 3.435389835140625*^9, {3.43539510746875*^9, 
   3.435395131046875*^9}, 3.435401380078125*^9, 3.43548506296875*^9},
 CellID->51078389]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"PeriodFromFrequency", "[", "\"\<SemiAnnual\>\"", "]"}]], "Input",
 CellChangeTimes->{{3.43540141971875*^9, 3.4354014479375*^9}},
 CellID->274743601],

Cell[BoxData["\<\"6M\"\>"], "Output",
 CellChangeTimes->{3.43540144865625*^9, 3.435402581609375*^9, 
  3.435485064328125*^9},
 CellID->850849139]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", "PeriodEquivalent"}]], "Input",
 CellChangeTimes->{{3.435401477953125*^9, 3.435401484203125*^9}},
 CellID->299601555],

Cell[BoxData[
 StyleBox["\<\"PeriodEquivalent[Period_String] Returns the period equivalent \
to the input (e.g. 11M for 1Y-1M).       \\nPeriod: input period (e.g. \
1Y-1M).\"\>", "MSG"]], "Print", "PrintUsage",
 CellChangeTimes->{3.43548506609375*^9},
 CellTags->"Info3435488666-2104727",
 CellID->467512484]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"PeriodEquivalent", "[", "\"\<1Y-1M\>\"", "]"}], ",", 
   RowBox[{"PeriodEquivalent", "[", "\"\<1Y+1M\>\"", "]"}]}], "}"}]], "Input",
 CellChangeTimes->{{3.4354014954375*^9, 3.43540154475*^9}},
 CellID->35083563],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"\<\"11M\"\>", ",", "\<\"1Y1M\"\>"}], "}"}]], "Output",
 CellChangeTimes->{3.435401545328125*^9, 3.43548506728125*^9},
 CellID->305553905]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", "PeriodLessThan"}]], "Input",
 CellChangeTimes->{{3.43540160809375*^9, 3.435401611765625*^9}},
 CellID->62195626],

Cell[BoxData[
 StyleBox["\<\"PeriodLessThan[Period1_String,Period2_String] Returns TRUE if \
the first period is less than the second.       \\nPeriod1: left hand \
side.\\nPeriod2: right hand side.\"\>", "MSG"]], "Print", "PrintUsage",
 CellChangeTimes->{3.4354850684375*^9},
 CellTags->"Info3435488668-2081852",
 CellID->1000851026]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"PeriodLessThan", "[", 
  RowBox[{"\"\<1M\>\"", ",", "\"\<3W\>\""}], "]"}]], "Input",
 CellChangeTimes->{{3.435401477953125*^9, 3.435401484203125*^9}, {
  3.435401550828125*^9, 3.435401596234375*^9}},
 CellID->781038621],

Cell[BoxData["False"], "Output",
 CellChangeTimes->{{3.435401591640625*^9, 3.435401597046875*^9}, 
   3.43540258865625*^9, 3.43548506928125*^9},
 CellID->48009571]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"PeriodLessThan", "[", 
  RowBox[{"\"\<3W\>\"", ",", "\"\<1M\>\""}], "]"}]], "Input",
 CellChangeTimes->{{3.435401477953125*^9, 3.435401484203125*^9}, {
  3.435401550828125*^9, 3.43540163009375*^9}},
 CellID->17088717],

Cell[BoxData["True"], "Output",
 CellChangeTimes->{3.435401630890625*^9, 3.435402591921875*^9, 
  3.435485070140625*^9},
 CellID->290724145]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["IMM functions\t", "Subsection",
 CellChangeTimes->{{3.43540264296875*^9, 3.435402649859375*^9}},
 CellID->282182249],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", "IMMcode"}]], "Input",
 CellChangeTimes->{{3.435402653109375*^9, 3.435402657265625*^9}},
 CellID->331539218],

Cell[BoxData[
 StyleBox["\<\"IMMcode[IMMdate_List /; VectorQ[IMMdate, DateQ]] returns the \
code corresponding to a given IMM date (e.g. H6 for Wednesday, March 15th, \
2006). It fails if the input date is not an IMM date.       \\nIMMdate: IMM \
date.\"\>", "MSG"]], "Print", "PrintUsage",
 CellChangeTimes->{3.435402657875*^9},
 CellTags->"Info3435406257-4955527",
 CellID->200634801]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", "IMMdate"}]], "Input",
 CellChangeTimes->{{3.435402668046875*^9, 3.435402676375*^9}},
 CellID->302973611],

Cell[BoxData[
 StyleBox["\<\"IMMdate[IMMcode_List] returns the IMM date corresponding to \
the given IMM code (e.g. Wednesday, March 15th, 2006 for H6).       \
\\nIMMcode: 2 letter IMM code (e.g. H6).\\nRefDate: date with respect to \
which the calculations are performed. Default value = QuantLib::Date().\"\>", 
  "MSG"]], "Print", "PrintUsage",
 CellChangeTimes->{3.435402677078125*^9},
 CellTags->"Info3435406277-6543440",
 CellID->178815725]
}, Open  ]],

Cell[BoxData[
 RowBox[{"Options", "[", "IMMdate", "]"}]], "Input",
 CellChangeTimes->{{3.435402743671875*^9, 3.4354027639375*^9}},
 CellID->219417704],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"RefDate", "\[Rule]", 
   RowBox[{"{", 
    RowBox[{"2008", ",", "11", ",", "11"}], "}"}]}], "}"}]], "Input",
 CellChangeTimes->{3.435485075765625*^9},
 CellID->384430170],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"RefDate", "\[Rule]", 
   RowBox[{"{", 
    RowBox[{"2008", ",", "11", ",", "11"}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{3.4354850758125*^9},
 CellID->225130405]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"imm", " ", "=", 
  RowBox[{"IMMdate", "[", 
   RowBox[{
    RowBox[{"{", "\"\<H6\>\"", "}"}], ",", 
    RowBox[{"RefDate", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{"2008", ",", "10", ",", "10"}], "}"}]}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.435402687484375*^9, 3.435402716640625*^9}, {
  3.43540277028125*^9, 3.435402781703125*^9}, {3.435402820734375*^9, 
  3.435402821734375*^9}},
 CellID->28722783],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"{", 
   RowBox[{"2016", ",", "3", ",", "16"}], "}"}], "}"}]], "Output",
 CellChangeTimes->{3.435402782140625*^9, 3.435402822375*^9, 
  3.435485076796875*^9},
 CellID->640213504]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"IMMcode", "[", "imm", "]"}]], "Input",
 CellChangeTimes->{{3.43540278865625*^9, 3.435402836921875*^9}},
 CellID->130227532],

Cell[BoxData[
 RowBox[{"{", "\<\"H6\"\>", "}"}]], "Output",
 CellChangeTimes->{{3.435402813046875*^9, 3.435402837375*^9}, 
   3.435485078296875*^9},
 CellID->202334221]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", "IMMNextCode"}]], "Input",
 CellChangeTimes->{{3.4354028704375*^9, 3.43540287715625*^9}},
 CellID->15981299],

Cell[BoxData[
 StyleBox["\<\"IMMNextCode[] returns the code for the first contract listed \
in the International Money Market section of the Chicago Mercantile Exchange. \
      \\nRefDate: date with respect to which the calculations are performed. \
Default value = QuantLib::Date().\\nMainCycle: FALSE to consider all futures \
(serial ones included), not just the main March/June/September/December (H, \
M, U, Z) cycle. Default value = true.\"\>", "MSG"]], "Print", "PrintUsage",
 CellChangeTimes->{3.43548507965625*^9},
 CellTags->"Info3435488679-5368265",
 CellID->879729563]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"Options", "[", "IMMNextCode", "]"}], " "}]], "Input",
 CellChangeTimes->{{3.43540327021875*^9, 3.43540327865625*^9}, {
   3.4354033088125*^9, 3.435403311703125*^9}, 3.435404032015625*^9},
 CellID->454732606],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"RefDate", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"2008", ",", "11", ",", "12"}], "}"}]}], ",", 
   RowBox[{"MainCycle", "\[Rule]", "True"}]}], "}"}]], "Output",
 CellChangeTimes->{3.435403279296875*^9, 3.43540331240625*^9, 
  3.435404159703125*^9, 3.435485080640625*^9},
 CellID->239319358]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"IMMNextCode", "[", "]"}], " "}]], "Input",
 CellChangeTimes->{{3.435402853125*^9, 3.435402891*^9}, 3.43540299153125*^9, {
   3.4354030275625*^9, 3.435403029515625*^9}, {3.435403355375*^9, 
   3.435403355625*^9}, {3.4354033916875*^9, 3.435403404078125*^9}, {
   3.4354041656875*^9, 3.435404167921875*^9}},
 CellID->288517047],

Cell[BoxData["\<\"X8\"\>"], "Output",
 CellChangeTimes->{
  3.435402866875*^9, 3.435402993*^9, {3.435403030203125*^9, 
   3.435403048234375*^9}, {3.43540334365625*^9, 3.435403356625*^9}, {
   3.435403393421875*^9, 3.435403404875*^9}, 3.43540416859375*^9, 
   3.435405056765625*^9, 3.435485081703125*^9},
 CellID->266107444]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", "IMMNextCodes"}]], "Input",
 CellChangeTimes->{{3.435404214953125*^9, 3.4354042209375*^9}},
 CellID->1049741263],

Cell[BoxData[
 StyleBox["\<\"IMMNextCodes[MainCycle_List /; VectorQ[MainCycle, Element[#, \
Booleans] &]] returns the codes for the next contracts listed in the \
International Money Market section of the Chicago Mercantile Exchange.       \
\\nRefDate: date with respect to which the calculations are performed. \
Default value = QuantLib::Date().\\nMainCycle: FALSE to consider all futures \
(serial ones included), not just the main March/June/September/December (H, \
M, U, Z) cycle. If omitted returns the first 40 H, M, U, Z futures. Default \
value = std::vector<bool>(40, true).\"\>", "MSG"]], "Print", "PrintUsage",
 CellChangeTimes->{3.435485082921875*^9},
 CellTags->"Info3435488682-1076657",
 CellID->638889823]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"IMMNextCodes", "[", 
  RowBox[{"Table", "[", 
   RowBox[{"True", ",", 
    RowBox[{"{", "40", "}"}]}], "]"}], "]"}]], "Input",
 CellChangeTimes->{{3.435404235484375*^9, 3.435404245671875*^9}, {
  3.43540686271875*^9, 3.435406874546875*^9}},
 CellID->64006141],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"\<\"X8\"\>", ",", "\<\"Z8\"\>", ",", "\<\"F9\"\>", 
   ",", "\<\"G9\"\>", ",", "\<\"H9\"\>", ",", "\<\"J9\"\>", ",", "\<\"K9\"\>",
    ",", "\<\"M9\"\>", ",", "\<\"N9\"\>", ",", "\<\"Q9\"\>", 
   ",", "\<\"U9\"\>", ",", "\<\"V9\"\>", ",", "\<\"X9\"\>", ",", "\<\"Z9\"\>",
    ",", "\<\"F0\"\>", ",", "\<\"G0\"\>", ",", "\<\"H0\"\>", 
   ",", "\<\"J0\"\>", ",", "\<\"K0\"\>", ",", "\<\"M0\"\>", ",", "\<\"N0\"\>",
    ",", "\<\"Q0\"\>", ",", "\<\"U0\"\>", ",", "\<\"V0\"\>", 
   ",", "\<\"X0\"\>", ",", "\<\"Z0\"\>", ",", "\<\"F1\"\>", ",", "\<\"G1\"\>",
    ",", "\<\"H1\"\>", ",", "\<\"J1\"\>", ",", "\<\"K1\"\>", 
   ",", "\<\"M1\"\>", ",", "\<\"N1\"\>", ",", "\<\"Q1\"\>", ",", "\<\"U1\"\>",
    ",", "\<\"V1\"\>", ",", "\<\"X1\"\>", ",", "\<\"Z1\"\>", 
   ",", "\<\"F2\"\>", ",", "\<\"G2\"\>"}], "}"}]], "Output",
 CellChangeTimes->{
  3.435404246390625*^9, 3.435405275421875*^9, 3.435405755546875*^9, {
   3.4354063721875*^9, 3.435406395171875*^9}, 3.435406494765625*^9, 
   3.435406579359375*^9, 3.435406841*^9, 3.435406878921875*^9, 
   3.4354069869375*^9, 3.435485084109375*^9},
 CellID->164984162]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", "IMMNextDate"}]], "Input",
 CellChangeTimes->{{3.435405110765625*^9, 3.43540511696875*^9}},
 CellID->180960975],

Cell[BoxData[
 StyleBox["\<\"IMMNextDate[] returns the delivery date for the first contract \
listed in the International Money Market section of the Chicago Mercantile \
Exchange.       \\nRefDate: date with respect to which the calculations are \
performed. Default value = QuantLib::Date().\\nMainCycle: FALSE to consider \
all futures (serial ones included), not just the main \
March/June/September/December (H, M, U, Z) cycle. Default value = true.\"\>", 
  "MSG"]], "Print", "PrintUsage",
 CellChangeTimes->{3.435485085875*^9},
 CellTags->"Info3435488685-5245526",
 CellID->398077386]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"IMMNextDate", "[", "]"}]], "Input",
 CellChangeTimes->{{3.435405088859375*^9, 3.43540509471875*^9}},
 CellID->448969824],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"2008", ",", "11", ",", "19"}], "}"}]], "Output",
 CellChangeTimes->{3.435405095453125*^9, 3.435485086953125*^9},
 CellID->24911272]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", "IMMNextDates"}]], "Input",
 CellChangeTimes->{{3.435405121828125*^9, 3.43540513821875*^9}},
 CellID->113246076],

Cell[BoxData[
 StyleBox["\<\"IMMNextDates[MainCycle_List /; VectorQ[MainCycle, Element[#, \
Booleans] &]] returns the delivery dates for the next contracts listed in the \
International Money Market section of the Chicago Mercantile Exchange.       \
\\nRefDate: date with respect to which the calculations are performed. \
Default value = QuantLib::Date().\\nMainCycle: FALSE to consider all futures \
(serial ones included), not just the main March/June/September/December (H, \
M, U, Z) cycle. If omitted returns the first 40 H, M, U, Z futures. Default \
value = std::vector<bool>(40, true).\"\>", "MSG"]], "Print", "PrintUsage",
 CellChangeTimes->{3.435485087921875*^9},
 CellTags->"Info3435488687-8695466",
 CellID->33080833]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"IMMNextDates", "[", 
  RowBox[{"Table", "[", 
   RowBox[{"True", ",", 
    RowBox[{"{", "40", "}"}]}], "]"}], "]"}]], "Input",
 CellChangeTimes->{{3.435405141234375*^9, 3.435405148546875*^9}, 
   3.4354070109375*^9},
 CellID->148370905],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"2008", ",", "11", ",", "19"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"2008", ",", "12", ",", "17"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"2009", ",", "1", ",", "21"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"2009", ",", "2", ",", "18"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"2009", ",", "3", ",", "18"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"2009", ",", "4", ",", "15"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"2009", ",", "5", ",", "20"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"2009", ",", "6", ",", "17"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"2009", ",", "7", ",", "15"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"2009", ",", "8", ",", "19"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"2009", ",", "9", ",", "16"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"2009", ",", "10", ",", "21"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"2009", ",", "11", ",", "18"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"2009", ",", "12", ",", "16"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"2010", ",", "1", ",", "20"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"2010", ",", "2", ",", "17"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"2010", ",", "3", ",", "17"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"2010", ",", "4", ",", "21"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"2010", ",", "5", ",", "19"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"2010", ",", "6", ",", "16"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"2010", ",", "7", ",", "21"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"2010", ",", "8", ",", "18"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"2010", ",", "9", ",", "15"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"2010", ",", "10", ",", "20"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"2010", ",", "11", ",", "17"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"2010", ",", "12", ",", "15"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"2011", ",", "1", ",", "19"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"2011", ",", "2", ",", "16"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"2011", ",", "3", ",", "16"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"2011", ",", "4", ",", "20"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"2011", ",", "5", ",", "18"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"2011", ",", "6", ",", "15"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"2011", ",", "7", ",", "20"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"2011", ",", "8", ",", "17"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"2011", ",", "9", ",", "21"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"2011", ",", "10", ",", "19"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"2011", ",", "11", ",", "16"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"2011", ",", "12", ",", "21"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"2012", ",", "1", ",", "18"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"2012", ",", "2", ",", "15"}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{
  3.435405149234375*^9, {3.435407000109375*^9, 3.4354070124375*^9}, 
   3.435485088984375*^9},
 CellID->52328846]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", "IMMIsIMMcode"}]], "Input",
 CellChangeTimes->{{3.43540705203125*^9, 3.435407056703125*^9}},
 CellID->5267744],

Cell[BoxData[
 StyleBox["\<\"IMMIsIMMcode[Code_List /; VectorQ[Code, StringQ]] returns \
whether or not the given code is an IMM code.       \\nCode: 2 letter string \
(e.g. H6).\\nMainCycle: FALSE to consider all futures (serial ones included), \
not just the main March/June/September/December (H, M, U, Z) cycle. Default \
value = true.\"\>", "MSG"]], "Print", "PrintUsage",
 CellChangeTimes->{3.43548511965625*^9},
 CellTags->"Info3435488719-4475359",
 CellID->979935324]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"IMMIsIMMcode", "[", 
  RowBox[{"{", 
   RowBox[{"\"\<h6\>\"", ",", "\"\<A6\>\""}], "}"}], "]"}]], "Input",
 CellChangeTimes->{{3.435407062515625*^9, 3.435407103984375*^9}},
 CellID->135326984],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"True", ",", "False"}], "}"}]], "Output",
 CellChangeTimes->{{3.43540708790625*^9, 3.4354071050625*^9}, 
   3.4354071966875*^9, 3.435408293625*^9, 3.43540877846875*^9, 
   3.435409491421875*^9, 3.435485120890625*^9},
 CellID->116480330]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"IMMIsIMMdate", "[", 
  RowBox[{"{", 
   RowBox[{"{", 
    RowBox[{"2008", ",", "10", ",", "10"}], "}"}], "}"}], "]"}]], "Input",
 CellChangeTimes->{{3.435407062515625*^9, 3.43540712084375*^9}, {
  3.435407201921875*^9, 3.43540720625*^9}},
 CellID->169432577],

Cell[BoxData[
 RowBox[{"{", "False", "}"}]], "Output",
 CellChangeTimes->{3.435407146765625*^9, 3.435407212484375*^9, 
  3.4354082985*^9, 3.43540877546875*^9, 3.435409492359375*^9, 
  3.435485121828125*^9},
 CellID->537064742]
}, Open  ]]
}, Open  ]]
}, Open  ]]
},
FileChangeProtection->None,
Editable->True,
WindowSize->{616, 749},
WindowMargins->{{Automatic, -2326}, {Automatic, -34}},
DockedCells->FEPrivate`FrontEndResource["FEExpressions", "HelpViewerToolbar"],
PageHeaders->{{None, None, None}, {None, None, 
   Cell[
    TextData[{
      Cell[
       TextData[{"Printed from [[YOUR APPLICATION'S NAME]] documentation "}], 
       "PageHeader"], 
      Cell[
       TextData[{
         CounterBox["Page"]}], "PageNumber"]}], 
    CellMargins -> {{Inherited, -29}, {Inherited, Inherited}}]}},
PageFooters->{{None, None, None}, {
   Cell[
    TextData[{"\[Copyright] 2008 Weber & Partner. All rights reserved."}], 
    "PageFooter"], None, None}},
ShowSelection->True,
TaggingRules->{
 "SearchTextTranslated" -> "", "SearchText" -> "", "LinkTrails" -> ""},
CreateCellID->True,
ShowCellTags->False,
FrontEndVersion->"8.0 for Microsoft Windows (32-bit) (February 23, 2011)",
StyleDefinitions->FrontEnd`FileName[{"Wolfram"}, "Reference.nb", 
  CharacterEncoding -> "WindowsANSI"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "Info3435488642-4052774"->{
  Cell[4036, 123, 306, 6, 71, "Print",
   CellTags->"Info3435488642-4052774",
   CellID->61382713]},
 "Info3435488646-9389832"->{
  Cell[6321, 195, 281, 6, 56, "Print",
   CellTags->"Info3435488646-9389832",
   CellID->85468209]},
 "Info3435488650-8072290"->{
  Cell[7586, 240, 235, 5, 56, "Print",
   CellTags->"Info3435488650-8072290",
   CellID->30670660]},
 "Info3435488654-1215600"->{
  Cell[8695, 283, 453, 8, 101, "Print",
   CellTags->"Info3435488654-1215600",
   CellID->466122818]},
 "Info3435488656-4423637"->{
  Cell[9865, 322, 535, 9, 131, "Print",
   CellTags->"Info3435488656-4423637",
   CellID->14608159]},
 "Info3435488659-2165934"->{
  Cell[11261, 366, 389, 7, 86, "Print",
   CellTags->"Info3435488659-2165934",
   CellID->90074639]},
 "Info3435488660-4560467"->{
  Cell[11813, 383, 376, 7, 86, "Print",
   CellTags->"Info3435488660-4560467",
   CellID->29758861]},
 "Info3435488666-2104727"->{
  Cell[13866, 449, 309, 6, 71, "Print",
   CellTags->"Info3435488666-2104727",
   CellID->467512484]},
 "Info3435488668-2081852"->{
  Cell[14836, 482, 334, 6, 86, "Print",
   CellTags->"Info3435488668-2081852",
   CellID->1000851026]},
 "Info3435406257-4955527"->{
  Cell[16372, 535, 386, 7, 86, "Print",
   CellTags->"Info3435406257-4955527",
   CellID->200634801]},
 "Info3435406277-6543440"->{
  Cell[16931, 552, 447, 8, 101, "Print",
   CellTags->"Info3435406277-6543440",
   CellID->178815725]},
 "Info3435488679-5368265"->{
  Cell[19213, 632, 581, 9, 116, "Print",
   CellTags->"Info3435488679-5368265",
   CellID->879729563]},
 "Info3435488682-1076657"->{
  Cell[21324, 692, 723, 11, 146, "Print",
   CellTags->"Info3435488682-1076657",
   CellID->638889823]},
 "Info3435488685-5245526"->{
  Cell[23695, 746, 591, 10, 116, "Print",
   CellTags->"Info3435488685-5245526",
   CellID->398077386]},
 "Info3435488687-8695466"->{
  Cell[24821, 780, 731, 11, 146, "Print",
   CellTags->"Info3435488687-8695466",
   CellID->33080833]},
 "Info3435488719-4475359"->{
  Cell[29148, 901, 475, 8, 97, "Print",
   CellTags->"Info3435488719-4475359",
   CellID->979935324]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"Info3435488642-4052774", 31886, 984},
 {"Info3435488646-9389832", 32016, 988},
 {"Info3435488650-8072290", 32146, 992},
 {"Info3435488654-1215600", 32276, 996},
 {"Info3435488656-4423637", 32408, 1000},
 {"Info3435488659-2165934", 32539, 1004},
 {"Info3435488660-4560467", 32670, 1008},
 {"Info3435488666-2104727", 32801, 1012},
 {"Info3435488668-2081852", 32933, 1016},
 {"Info3435406257-4955527", 33066, 1020},
 {"Info3435406277-6543440", 33198, 1024},
 {"Info3435488679-5368265", 33331, 1028},
 {"Info3435488682-1076657", 33464, 1032},
 {"Info3435488685-5245526", 33598, 1036},
 {"Info3435488687-8695466", 33732, 1040},
 {"Info3435488719-4475359", 33865, 1044}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[545, 20, 114, 2, 23, "Subtitle",
 CellID->809310472],
Cell[CellGroupData[{
Cell[684, 26, 294, 5, 51, "Title",
 CellID->67882606],
Cell[CellGroupData[{
Cell[1003, 35, 307, 6, 28, "Input",
 CellID->609720372],
Cell[1313, 43, 979, 17, 105, "Output",
 CellID->281027703]
}, Open  ]],
Cell[CellGroupData[{
Cell[2329, 65, 121, 2, 51, "Subsection",
 CellID->1022593],
Cell[CellGroupData[{
Cell[2475, 71, 445, 14, 28, "Input",
 CellID->1351597],
Cell[2923, 87, 996, 27, 71, "Output",
 CellID->373788982]
}, Open  ]],
Cell[CellGroupData[{
Cell[3956, 119, 77, 2, 28, "Input",
 CellID->150515139],
Cell[4036, 123, 306, 6, 71, "Print",
 CellTags->"Info3435488642-4052774",
 CellID->61382713]
}, Open  ]],
Cell[CellGroupData[{
Cell[4379, 134, 197, 4, 28, "Input",
 CellID->80758292],
Cell[4579, 140, 1017, 27, 71, "Output",
 CellID->415350481]
}, Open  ]],
Cell[CellGroupData[{
Cell[5633, 172, 160, 3, 28, "Input",
 CellID->260291230],
Cell[5796, 177, 348, 8, 54, "Output",
 CellID->290782679]
}, Open  ]],
Cell[CellGroupData[{
Cell[6181, 190, 137, 3, 28, "Input",
 CellID->323055179],
Cell[6321, 195, 281, 6, 56, "Print",
 CellTags->"Info3435488646-9389832",
 CellID->85468209]
}, Open  ]],
Cell[CellGroupData[{
Cell[6639, 206, 280, 7, 28, "Input",
 CellID->374058879],
Cell[6922, 215, 382, 9, 54, "Output",
 CellID->492518817]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[7353, 230, 65, 1, 51, "Subsection",
 CellID->63203798],
Cell[CellGroupData[{
Cell[7443, 235, 140, 3, 28, "Input",
 CellID->397614599],
Cell[7586, 240, 235, 5, 56, "Print",
 CellTags->"Info3435488650-8072290",
 CellID->30670660]
}, Open  ]],
Cell[CellGroupData[{
Cell[7858, 250, 221, 6, 28, "Input",
 CellID->340459595],
Cell[8082, 258, 322, 9, 36, "Output",
 CellID->65597243]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[8453, 273, 72, 1, 51, "Subsection",
 CellID->83908880],
Cell[CellGroupData[{
Cell[8550, 278, 142, 3, 28, "Input",
 CellID->606867686],
Cell[8695, 283, 453, 8, 101, "Print",
 CellTags->"Info3435488654-1215600",
 CellID->466122818]
}, Open  ]],
Cell[CellGroupData[{
Cell[9185, 296, 280, 8, 28, "Input",
 CellID->56608582],
Cell[9468, 306, 238, 6, 36, "Output",
 CellID->2050765]
}, Open  ]],
Cell[CellGroupData[{
Cell[9743, 317, 119, 3, 28, "Input",
 CellID->209692816],
Cell[9865, 322, 535, 9, 131, "Print",
 CellTags->"Info3435488656-4423637",
 CellID->14608159]
}, Open  ]],
Cell[CellGroupData[{
Cell[10437, 336, 227, 5, 28, "Input",
 CellID->198433951],
Cell[10667, 343, 215, 5, 36, "Output",
 CellID->4783060]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[10931, 354, 178, 3, 51, "Subsection",
 CellID->248030531],
Cell[CellGroupData[{
Cell[11134, 361, 124, 3, 28, "Input",
 CellID->231281697],
Cell[11261, 366, 389, 7, 86, "Print",
 CellTags->"Info3435488659-2165934",
 CellID->90074639]
}, Open  ]],
Cell[CellGroupData[{
Cell[11687, 378, 123, 3, 28, "Input",
 CellID->223885664],
Cell[11813, 383, 376, 7, 86, "Print",
 CellTags->"Info3435488660-4560467",
 CellID->29758861]
}, Open  ]],
Cell[CellGroupData[{
Cell[12226, 395, 277, 6, 28, "Input",
 CellID->30775833],
Cell[12506, 403, 301, 6, 36, "Output",
 CellID->134173449]
}, Open  ]],
Cell[CellGroupData[{
Cell[12844, 414, 238, 5, 28, "Input",
 CellID->36749801],
Cell[13085, 421, 239, 5, 36, "Output",
 CellID->51078389]
}, Open  ]],
Cell[CellGroupData[{
Cell[13361, 431, 172, 3, 28, "Input",
 CellID->274743601],
Cell[13536, 436, 145, 3, 36, "Output",
 CellID->850849139]
}, Open  ]],
Cell[CellGroupData[{
Cell[13718, 444, 145, 3, 28, "Input",
 CellID->299601555],
Cell[13866, 449, 309, 6, 71, "Print",
 CellTags->"Info3435488666-2104727",
 CellID->467512484]
}, Open  ]],
Cell[CellGroupData[{
Cell[14212, 460, 263, 6, 28, "Input",
 CellID->35083563],
Cell[14478, 468, 177, 4, 36, "Output",
 CellID->305553905]
}, Open  ]],
Cell[CellGroupData[{
Cell[14692, 477, 141, 3, 28, "Input",
 CellID->62195626],
Cell[14836, 482, 334, 6, 86, "Print",
 CellTags->"Info3435488668-2081852",
 CellID->1000851026]
}, Open  ]],
Cell[CellGroupData[{
Cell[15207, 493, 243, 5, 28, "Input",
 CellID->781038621],
Cell[15453, 500, 163, 3, 36, "Output",
 CellID->48009571]
}, Open  ]],
Cell[CellGroupData[{
Cell[15653, 508, 241, 5, 28, "Input",
 CellID->17088717],
Cell[15897, 515, 140, 3, 36, "Output",
 CellID->290724145]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[16086, 524, 122, 2, 51, "Subsection",
 CellID->282182249],
Cell[CellGroupData[{
Cell[16233, 530, 136, 3, 28, "Input",
 CellID->331539218],
Cell[16372, 535, 386, 7, 86, "Print",
 CellTags->"Info3435406257-4955527",
 CellID->200634801]
}, Open  ]],
Cell[CellGroupData[{
Cell[16795, 547, 133, 3, 28, "Input",
 CellID->302973611],
Cell[16931, 552, 447, 8, 101, "Print",
 CellTags->"Info3435406277-6543440",
 CellID->178815725]
}, Open  ]],
Cell[17393, 563, 150, 3, 28, "Input",
 CellID->219417704],
Cell[CellGroupData[{
Cell[17568, 570, 210, 6, 28, "Input",
 CellID->384430170],
Cell[17781, 578, 209, 6, 36, "Output",
 CellID->225130405]
}, Open  ]],
Cell[CellGroupData[{
Cell[18027, 589, 435, 11, 28, "Input",
 CellID->28722783],
Cell[18465, 602, 217, 6, 36, "Output",
 CellID->640213504]
}, Open  ]],
Cell[CellGroupData[{
Cell[18719, 613, 147, 3, 28, "Input",
 CellID->130227532],
Cell[18869, 618, 168, 4, 36, "Output",
 CellID->202334221]
}, Open  ]],
Cell[CellGroupData[{
Cell[19074, 627, 136, 3, 28, "Input",
 CellID->15981299],
Cell[19213, 632, 581, 9, 116, "Print",
 CellTags->"Info3435488679-5368265",
 CellID->879729563]
}, Open  ]],
Cell[CellGroupData[{
Cell[19831, 646, 242, 5, 28, "Input",
 CellID->454732606],
Cell[20076, 653, 346, 9, 36, "Output",
 CellID->239319358]
}, Open  ]],
Cell[CellGroupData[{
Cell[20459, 667, 359, 7, 28, "Input",
 CellID->288517047],
Cell[20821, 676, 323, 6, 36, "Output",
 CellID->266107444]
}, Open  ]],
Cell[CellGroupData[{
Cell[21181, 687, 140, 3, 28, "Input",
 CellID->1049741263],
Cell[21324, 692, 723, 11, 146, "Print",
 CellTags->"Info3435488682-1076657",
 CellID->638889823]
}, Open  ]],
Cell[CellGroupData[{
Cell[22084, 708, 283, 7, 28, "Input",
 CellID->64006141],
Cell[22370, 717, 1146, 19, 71, "Output",
 CellID->164984162]
}, Open  ]],
Cell[CellGroupData[{
Cell[23553, 741, 139, 3, 28, "Input",
 CellID->180960975],
Cell[23695, 746, 591, 10, 116, "Print",
 CellTags->"Info3435488685-5245526",
 CellID->398077386]
}, Open  ]],
Cell[CellGroupData[{
Cell[24323, 761, 144, 3, 28, "Input",
 CellID->448969824],
Cell[24470, 766, 171, 4, 36, "Output",
 CellID->24911272]
}, Open  ]],
Cell[CellGroupData[{
Cell[24678, 775, 140, 3, 28, "Input",
 CellID->113246076],
Cell[24821, 780, 731, 11, 146, "Print",
 CellTags->"Info3435488687-8695466",
 CellID->33080833]
}, Open  ]],
Cell[CellGroupData[{
Cell[25589, 796, 260, 7, 28, "Input",
 CellID->148370905],
Cell[25852, 805, 3118, 86, 190, "Output",
 CellID->52328846]
}, Open  ]],
Cell[CellGroupData[{
Cell[29007, 896, 138, 3, 28, "Input",
 CellID->5267744],
Cell[29148, 901, 475, 8, 97, "Print",
 CellTags->"Info3435488719-4475359",
 CellID->979935324]
}, Open  ]],
Cell[CellGroupData[{
Cell[29660, 914, 216, 5, 28, "Input",
 CellID->135326984],
Cell[29879, 921, 275, 6, 36, "Output",
 CellID->116480330]
}, Open  ]],
Cell[CellGroupData[{
Cell[30191, 932, 282, 7, 28, "Input",
 CellID->169432577],
Cell[30476, 941, 226, 5, 36, "Output",
 CellID->537064742]
}, Open  ]]
}, Open  ]]
}, Open  ]]
}
]
*)

(* End of internal cache information *)
