(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 8.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       157,          7]
NotebookDataLength[      9315,        310]
NotebookOptionsPosition[      6313,        205]
NotebookOutlinePosition[      7959,        261]
CellTagsIndexPosition[      7793,        253]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell["DayCounter", "Chapter",
 CellTags->"Overview"],

Cell["Daycounter related functions.", "Text",
 CellTags->"Overview"],

Cell["The first step is to load the QuantLib package. ", "MathCaption",
 CellTags->"Overview"],

Cell["Needs[\"QuantLib`\"]", "Input",
 CellTags->"Overview",
 CellLabel->"In[6]:="],

Cell[CellGroupData[{

Cell["Enumeration Member", "Section",
 CellTags->"EnumerationMember"],

Cell[CellGroupData[{

Cell["DayCounterName", "Subsubsection",
 CellTags->"EnumertionMember"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"Needs", "[", "\"\<QuantLib`\>\"", "]"}], "\[IndentingNewLine]", 
 RowBox[{"DayCounterName", "[", "]"}]}], "Input",
 CellChangeTimes->{{3.51886839134375*^9, 3.5188684084375*^9}, {
  3.51886858525*^9, 3.518868585984375*^9}, {3.518869582015625*^9, 
  3.51886958796875*^9}},
 CellTags->"EnumertionMember",
 CellLabel->"In[117]:="],

Cell[BoxData["\<\"Actual/365 (Fixed)\"\>"], "Output",
 CellChangeTimes->{3.51886958859375*^9, 3.521361738421875*^9},
 CellTags->"EnumertionMember",
 CellLabel->"Out[118]="]
}, Open  ]],

Cell["\<\
The available day counter types can be retrieved with\
\>", "MathCaption",
 CellChangeTimes->{{3.521361750953125*^9, 3.52136178984375*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"GetEnumerationType", "[", "\"\<DayCounter\>\"", "]"}]], "Input",
 CellChangeTimes->{{3.52136179496875*^9, 3.521361800390625*^9}},
 CellLabel->"In[119]:="],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"\<\"1/1\"\>", ",", "\<\"30/360\"\>", 
   ",", "\<\"30/360 (Bond Basis)\"\>", ",", "\<\"30/360 (Eurobond Basis)\"\>",
    ",", "\<\"30/360 (Italian)\"\>", ",", "\<\"30E/360\"\>", 
   ",", "\<\"30E/360 (Eurobond Basis)\"\>", ",", "\<\"360/360\"\>", 
   ",", "\<\"A/360\"\>", ",", "\<\"A/365\"\>", ",", "\<\"A/365 (Fixed)\"\>", 
   ",", "\<\"A/365F\"\>", ",", "\<\"Act/360\"\>", ",", "\<\"Act/365\"\>", 
   ",", "\<\"Act/365 (Fixed)\"\>", ",", "\<\"Act/Act\"\>", 
   ",", "\<\"Actual/360\"\>", ",", "\<\"Actual/365\"\>", 
   ",", "\<\"Actual/365 (Fixed)\"\>", ",", "\<\"Actual/Actual\"\>", 
   ",", "\<\"Actual/Actual (AFB)\"\>", ",", "\<\"Actual/Actual (Bond)\"\>", 
   ",", "\<\"Actual/Actual (Euro)\"\>", ",", "\<\"Actual/Actual (ISDA)\"\>", 
   ",", "\<\"Actual/Actual (ISMA)\"\>", ",", "\<\"Bond Basis\"\>", 
   ",", "\<\"Business252\"\>", ",", "\<\"Eurobond Basis\"\>", 
   ",", "\<\"LIN 30/360\"\>", ",", "\<\"LIN ACT/360\"\>", 
   ",", "\<\"LIN ACT/365\"\>", ",", "\<\"LIN ACT/ACT\"\>", 
   ",", "\<\"LIN ACTACT ISDA\"\>", ",", "\<\"LIN ACTACT ISMA\"\>", 
   ",", "\<\"Simple\"\>"}], "}"}]], "Output",
 CellChangeTimes->{3.521361800890625*^9},
 CellLabel->"Out[119]="]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["DayCounterDayCount", "Subsubsection",
 CellTags->"EnumertionMember"],

Cell[BoxData[{Cell[BoxData[GridBox[{
    {"StartDate", 
     RowBox[{"start", " ", 
      RowBox[{"date", "."}]}]},
    {"EndDate", 
     RowBox[{"end", " ", 
      RowBox[{"date", "."}]}]}
   }]], "DefinitionBox",
  CellTags->"EnumertionMember"], "\n", Cell["Calling Parameters", 
  "Caption"]}], "Text"],

Cell[BoxData[{
 RowBox[{"Needs", "[", "\"\<QuantLib`\>\"", "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"StartDate", "=", 
   RowBox[{"{", 
    RowBox[{"2005", ",", "1", ",", "1"}], "}"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"EndDate", "=", 
   RowBox[{"{", 
    RowBox[{"2015", ",", "1", ",", "1"}], "}"}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.51886839134375*^9, 3.5188684084375*^9}, {
  3.51886858525*^9, 3.518868585984375*^9}},
 CellTags->"EnumertionMember",
 CellLabel->"In[13]:="],

Cell[CellGroupData[{

Cell["DayCounterDayCount[StartDate,{EndDate}]", "Input",
 CellChangeTimes->{{3.518868445734375*^9, 3.518868448390625*^9}, {
  3.518869604015625*^9, 3.518869619953125*^9}},
 CellTags->"Procedure",
 CellLabel->"In[18]:="],

Cell[BoxData[
 RowBox[{"{", "3652", "}"}]], "Output",
 CellChangeTimes->{
  3.518868411875*^9, 3.518868449265625*^9, {3.51886959875*^9, 
   3.518869620875*^9}},
 CellTags->"Procedure",
 CellLabel->"Out[18]="]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["DayCounterYearFraction", "Subsubsection",
 CellTags->"EnumertionMember"],

Cell[BoxData[{Cell[BoxData[GridBox[{
    {"StartDate", 
     RowBox[{"start", " ", 
      RowBox[{"date", "."}]}]},
    {"EndDate", 
     RowBox[{"end", " ", 
      RowBox[{"date", "."}]}]}
   }]], "DefinitionBox",
  CellTags->"EnumertionMember"], "\n", Cell["Calling Parameters", 
  "Caption"]}], "Text"],

Cell[BoxData[{Cell[BoxData[GridBox[{
    {"RefPeriodStart", 
     RowBox[{
      RowBox[{"QuantLib", "::", "Date"}], 
      RowBox[{"(", ")"}]}], 
     RowBox[{"start", " ", "date", " ", "for", " ", "reference", " ", 
      RowBox[{"period", "."}]}]},
    {"RefPeriodEnd", 
     RowBox[{
      RowBox[{"QuantLib", "::", "Date"}], 
      RowBox[{"(", ")"}]}], 
     RowBox[{"end", " ", "date", " ", "for", " ", "reference", " ", 
      RowBox[{"period", "."}]}]}
   }]], "DefinitionBox3Col",
  CellTags->"EnumertionMember"], "\n", Cell["Option Setting", 
  "Caption"]}], "Text"],

Cell[BoxData[{
 RowBox[{"Needs", "[", "\"\<QuantLib`\>\"", "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"StartDate", "=", 
   RowBox[{"{", 
    RowBox[{"2005", ",", "1", ",", "1"}], "}"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"EndDate", "=", 
   RowBox[{"{", 
    RowBox[{"2015", ",", "1", ",", "1"}], "}"}]}], ";"}]}], "Input",
 CellChangeTimes->{
  3.518868565828125*^9, {3.51886859603125*^9, 3.51886859659375*^9}},
 CellTags->"EnumertionMember",
 CellLabel->"In[19]:="],

Cell["\<\
DayCounterYearFraction[StartDate,{EndDate}]\
\>", "Input",
 CellChangeTimes->{{3.518868569046875*^9, 3.518868571953125*^9}},
 CellTags->"Procedure",
 CellLabel->"In[22]:="]
}, Open  ]]
}, Open  ]]
}, Open  ]]
},
FileChangeProtection->None,
WindowSize->{716, 867},
WindowMargins->{{Automatic, -1069}, {-83, Automatic}},
FrontEndVersion->"8.0 for Microsoft Windows (32-bit) (February 23, 2011)",
StyleDefinitions->"HelpBrowser.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "EnumerationMember"->{
  Cell[910, 37, 69, 1, 77, "Section",
   CellTags->"EnumerationMember"]},
 "EnumertionMember"->{
  Cell[1004, 42, 70, 1, 47, "Subsubsection",
   CellTags->"EnumertionMember"],
  Cell[1099, 47, 351, 7, 62, "Input",
   CellTags->"EnumertionMember"],
  Cell[1453, 56, 172, 3, 39, "Output",
   CellTags->"EnumertionMember"],
  Cell[3257, 100, 74, 1, 47, "Subsubsection",
   CellTags->"EnumertionMember"],
  Cell[3642, 114, 496, 13, 82, "Input",
   CellTags->"EnumertionMember"],
  Cell[4642, 149, 78, 1, 47, "Subsubsection",
   CellTags->"EnumertionMember"],
  Cell[5611, 180, 477, 13, 82, "Input",
   CellTags->"EnumertionMember"]},
 "Overview"->{
  Cell[579, 22, 52, 1, 99, "Chapter",
   CellTags->"Overview"],
  Cell[634, 25, 68, 1, 37, "Text",
   CellTags->"Overview"],
  Cell[705, 28, 94, 1, 53, "MathCaption",
   CellTags->"Overview"],
  Cell[802, 31, 83, 2, 41, "Input",
   CellTags->"Overview"]},
 "Procedure"->{
  Cell[4163, 131, 219, 4, 41, "Input",
   CellTags->"Procedure"],
  Cell[4385, 137, 208, 6, 39, "Output",
   CellTags->"Procedure"],
  Cell[6091, 195, 182, 5, 41, "Input",
   CellTags->"Procedure"]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"EnumerationMember", 6653, 216},
 {"EnumertionMember", 6750, 219},
 {"Overview", 7298, 234},
 {"Procedure", 7570, 243}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[579, 22, 52, 1, 99, "Chapter",
 CellTags->"Overview"],
Cell[634, 25, 68, 1, 37, "Text",
 CellTags->"Overview"],
Cell[705, 28, 94, 1, 53, "MathCaption",
 CellTags->"Overview"],
Cell[802, 31, 83, 2, 41, "Input",
 CellTags->"Overview"],
Cell[CellGroupData[{
Cell[910, 37, 69, 1, 77, "Section",
 CellTags->"EnumerationMember"],
Cell[CellGroupData[{
Cell[1004, 42, 70, 1, 47, "Subsubsection",
 CellTags->"EnumertionMember"],
Cell[CellGroupData[{
Cell[1099, 47, 351, 7, 62, "Input",
 CellTags->"EnumertionMember"],
Cell[1453, 56, 172, 3, 39, "Output",
 CellTags->"EnumertionMember"]
}, Open  ]],
Cell[1640, 62, 149, 3, 39, "MathCaption"],
Cell[CellGroupData[{
Cell[1814, 69, 178, 3, 27, "Input"],
Cell[1995, 74, 1213, 20, 140, "Output"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[3257, 100, 74, 1, 47, "Subsubsection",
 CellTags->"EnumertionMember"],
Cell[3334, 103, 305, 9, 80, "Text"],
Cell[3642, 114, 496, 13, 82, "Input",
 CellTags->"EnumertionMember"],
Cell[CellGroupData[{
Cell[4163, 131, 219, 4, 41, "Input",
 CellTags->"Procedure"],
Cell[4385, 137, 208, 6, 39, "Output",
 CellTags->"Procedure"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[4642, 149, 78, 1, 47, "Subsubsection",
 CellTags->"EnumertionMember"],
Cell[4723, 152, 305, 9, 80, "Text"],
Cell[5031, 163, 577, 15, 80, "Text"],
Cell[5611, 180, 477, 13, 82, "Input",
 CellTags->"EnumertionMember"],
Cell[6091, 195, 182, 5, 41, "Input",
 CellTags->"Procedure"]
}, Open  ]]
}, Open  ]]
}, Open  ]]
}
]
*)

(* End of internal cache information *)
