(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 8.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       157,          7]
NotebookDataLength[     17005,        617]
NotebookOptionsPosition[      9357,        355]
NotebookOutlinePosition[     13160,        478]
CellTagsIndexPosition[     12971,        469]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell["EvolutionDescription", "Chapter",
 CellTags->"Overview"],

Cell["\<\
functions to construct and use evolution description related objects.\
\>", "Text",
 CellTags->"Overview"],

Cell["The first step is to load the QuantLib package. ", "MathCaption",
 CellTags->"Overview"],

Cell["Needs[\"QuantLib`\"]", "Input",
 CellTags->"Overview"],

Cell["\<\
Within the EvolutionDescription part there are several constructors and \
member functions available \
\>", "Text",
 CellTags->"Overview"],

Cell["Select[Category[EvolutionDescription],QLConstructor[#]&]", "Input",
 CellTags->"Overview"],

Cell["Select[Category[EvolutionDescription],QLMember[#]&]", "Input",
 CellTags->"Overview"],

Cell["Select[Category[EvolutionDescription],QLProcedure[#]&]", "Input",
 CellTags->"Overview"],

Cell[CellGroupData[{

Cell["Constructors", "Section",
 CellTags->"Constructor"],

Cell[CellGroupData[{

Cell["EvolutionDescription", "Subsubsection",
 CellTags->"Constructor"],

Cell[BoxData[{Cell[BoxData[GridBox[{
    {"RateTimes", 
     RowBox[{"rate", " ", "fixing", " ", 
      RowBox[{"times", "."}]}]},
    {"EvolutionTimes", 
     RowBox[{"evolution", " ", "times", " ", "in", " ", "the", " ", 
      RowBox[{"simulation", "."}]}]}
   }]], "DefinitionBox",
  CellTags->"Constructor"], "\n", Cell["Calling Parameters", 
  "Caption"]}], "Text"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"RateTimes", "=", 
   RowBox[{"{", 
    RowBox[{
    "0.5", ",", "1.0", ",", "1.5", ",", "2.0", ",", "2.5", ",", "3.0", ",", 
     "3.5", ",", "4.0", ",", "4.5", ",", "5.0", ",", "5.5"}], "}"}]}], 
  ";"}], "\n", 
 RowBox[{
  RowBox[{"EvolutionTimes", "=", 
   RowBox[{"{", 
    RowBox[{
    "0.5", ",", "1.0", ",", "1.5", ",", "2.0", ",", "2.5", ",", "3.0", ",", 
     "3.5", ",", "4.0", ",", "4.5", ",", "5.0", ",", "5.5"}], "}"}]}], 
  ";"}]}], "Input",
 CellTags->"Constructor"],

Cell["obj=EvolutionDescription[RateTimes,EvolutionTimes]", "Input",
 CellTags->"Constructor"]
}, Open  ]],

Cell[CellGroupData[{

Cell["EvolutionDescriptionFromProduct", "Subsubsection",
 CellTags->"Constructor"],

Cell[BoxData[{Cell[BoxData[GridBox[{
    {"Product", 
     RowBox[{"ID", " ", "of", " ", "product", " ", 
      RowBox[{"object", "."}]}]}
   }]], "DefinitionBox",
  CellTags->"Constructor"], "\n", Cell["Calling Parameters", 
  "Caption"]}], "Text"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Product", "=", "exampleValue"}], ";"}]], "Input",
 CellTags->"Constructor"],

Cell["obj=EvolutionDescriptionFromProduct[Product]", "Input",
 CellTags->"Constructor"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Member function", "Section",
 CellTags->"Member"],

Cell[CellGroupData[{

Cell["EvolutionDescriptionRateTimes", "Subsubsection",
 CellTags->"Member"],

Cell["EvolutionDescriptionRateTimes[obj]", "Input",
 CellTags->"Member"]
}, Open  ]],

Cell[CellGroupData[{

Cell["EvolutionDescriptionRateTaus", "Subsubsection",
 CellTags->"Member"],

Cell["EvolutionDescriptionRateTaus[obj]", "Input",
 CellTags->"Member"]
}, Open  ]],

Cell[CellGroupData[{

Cell["EvolutionDescriptionEvolutionTimes", "Subsubsection",
 CellTags->"Member"],

Cell["EvolutionDescriptionEvolutionTimes[obj]", "Input",
 CellTags->"Member"]
}, Open  ]],

Cell[CellGroupData[{

Cell["EvolutionDescriptionFirstAliveRate", "Subsubsection",
 CellTags->"Member"],

Cell["EvolutionDescriptionFirstAliveRate[obj]", "Input",
 CellTags->"Member"]
}, Open  ]],

Cell[CellGroupData[{

Cell["EvolutionDescriptionNumberOfRates", "Subsubsection",
 CellTags->"Member"],

Cell["EvolutionDescriptionNumberOfRates[obj]", "Input",
 CellTags->"Member"]
}, Open  ]],

Cell[CellGroupData[{

Cell["EvolutionDescriptionNumberOfSteps", "Subsubsection",
 CellTags->"Member"],

Cell["EvolutionDescriptionNumberOfSteps[obj]", "Input",
 CellTags->"Member"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Procedures", "Section",
 CellTags->"Procedure"],

Cell[CellGroupData[{

Cell["TerminalMeasure", "Subsubsection",
 CellTags->"Procedure"],

Cell[BoxData[{Cell[BoxData[GridBox[{
    {"EvolutionDescription", 
     RowBox[{"ID", " ", "of", " ", "EvolutionDescription", " ", 
      RowBox[{"object", "."}]}]}
   }]], "DefinitionBox",
  CellTags->"Procedure"], "\n", Cell["Calling Parameters", 
  "Caption"]}], "Text"],

Cell[BoxData[
 RowBox[{
  RowBox[{"EvolutionDescription", "=", "exampleValue"}], ";"}]], "Input",
 CellTags->"Procedure"],

Cell["TerminalMeasure[EvolutionDescription]", "Input",
 CellTags->"Procedure"]
}, Open  ]],

Cell[CellGroupData[{

Cell["MoneyMarketMeasure", "Subsubsection",
 CellTags->"Procedure"],

Cell[BoxData[{Cell[BoxData[GridBox[{
    {"EvolutionDescription", 
     RowBox[{"ID", " ", "of", " ", "EvolutionDescription", " ", 
      RowBox[{"object", "."}]}]}
   }]], "DefinitionBox",
  CellTags->"Procedure"], "\n", Cell["Calling Parameters", 
  "Caption"]}], "Text"],

Cell[BoxData[
 RowBox[{
  RowBox[{"EvolutionDescription", "=", "exampleValue"}], ";"}]], "Input",
 CellTags->"Procedure"],

Cell["MoneyMarketMeasure[EvolutionDescription]", "Input",
 CellTags->"Procedure"]
}, Open  ]],

Cell[CellGroupData[{

Cell["MoneyMarketPlusMeasure", "Subsubsection",
 CellTags->"Procedure"],

Cell[BoxData[{Cell[BoxData[GridBox[{
    {"EvolutionDescription", 
     RowBox[{"ID", " ", "of", " ", "EvolutionDescription", " ", 
      RowBox[{"object", "."}]}]}
   }]], "DefinitionBox",
  CellTags->"Procedure"], "\n", Cell["Calling Parameters", 
  "Caption"]}], "Text"],

Cell[BoxData[{Cell[BoxData[GridBox[{
    {"Offset", "1", 
     RowBox[{
     "offset", " ", "applied", " ", "to", " ", "the", " ", "MoneyMarket", " ", 
      RowBox[{"measure", "."}]}]}
   }]], "DefinitionBox3Col",
  CellTags->"Procedure"], "\n", Cell["Option Setting", "Caption"]}], "Text"],

Cell[BoxData[
 RowBox[{
  RowBox[{"EvolutionDescription", "=", "exampleValue"}], ";"}]], "Input",
 CellTags->"Procedure"],

Cell["MoneyMarketPlusMeasure[EvolutionDescription]", "Input",
 CellTags->"Procedure"]
}, Open  ]],

Cell[CellGroupData[{

Cell["IsInTerminalMeasure", "Subsubsection",
 CellTags->"Procedure"],

Cell[BoxData[{Cell[BoxData[GridBox[{
    {"EvolutionDescription", 
     RowBox[{"ID", " ", "of", " ", "EvolutionDescription", " ", 
      RowBox[{"object", "."}]}]},
    {"Numeraires", 
     RowBox[{"vector", " ", "of", " ", 
      RowBox[{"numeraires", "."}]}]}
   }]], "DefinitionBox",
  CellTags->"Procedure"], "\n", Cell["Calling Parameters", 
  "Caption"]}], "Text"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"EvolutionDescription", "=", "exampleValue"}], ";"}], "\n", 
 RowBox[{
  RowBox[{"Numeraires", "=", 
   RowBox[{"{", 
    RowBox[{"5", ",", "5"}], "}"}]}], ";"}]}], "Input",
 CellTags->"Procedure"],

Cell["IsInTerminalMeasure[EvolutionDescription,Numeraires]", "Input",
 CellTags->"Procedure"]
}, Open  ]],

Cell[CellGroupData[{

Cell["IsInMoneyMarketMeasure", "Subsubsection",
 CellTags->"Procedure"],

Cell[BoxData[{Cell[BoxData[GridBox[{
    {"EvolutionDescription", 
     RowBox[{"ID", " ", "of", " ", "EvolutionDescription", " ", 
      RowBox[{"object", "."}]}]},
    {"Numeraires", 
     RowBox[{"vector", " ", "of", " ", 
      RowBox[{"numeraires", "."}]}]}
   }]], "DefinitionBox",
  CellTags->"Procedure"], "\n", Cell["Calling Parameters", 
  "Caption"]}], "Text"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"EvolutionDescription", "=", "exampleValue"}], ";"}], "\n", 
 RowBox[{
  RowBox[{"Numeraires", "=", 
   RowBox[{"{", 
    RowBox[{"5", ",", "5"}], "}"}]}], ";"}]}], "Input",
 CellTags->"Procedure"],

Cell["IsInMoneyMarketMeasure[EvolutionDescription,Numeraires]", "Input",
 CellTags->"Procedure"]
}, Open  ]],

Cell[CellGroupData[{

Cell["IsInMoneyMarketPlusMeasure", "Subsubsection",
 CellTags->"Procedure"],

Cell[BoxData[{Cell[BoxData[GridBox[{
    {"EvolutionDescription", 
     RowBox[{"ID", " ", "of", " ", "EvolutionDescription", " ", 
      RowBox[{"object", "."}]}]},
    {"Numeraires", 
     RowBox[{"vector", " ", "of", " ", 
      RowBox[{"numeraires", "."}]}]}
   }]], "DefinitionBox",
  CellTags->"Procedure"], "\n", Cell["Calling Parameters", 
  "Caption"]}], "Text"],

Cell[BoxData[{Cell[BoxData[GridBox[{
    {"Offset", "1", 
     RowBox[{
     "offset", " ", "applied", " ", "to", " ", "the", " ", "MoneyMarket", " ", 
      RowBox[{"measure", "."}]}]}
   }]], "DefinitionBox3Col",
  CellTags->"Procedure"], "\n", Cell["Option Setting", "Caption"]}], "Text"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"EvolutionDescription", "=", "exampleValue"}], ";"}], "\n", 
 RowBox[{
  RowBox[{"Numeraires", "=", 
   RowBox[{"{", 
    RowBox[{"5", ",", "5"}], "}"}]}], ";"}]}], "Input",
 CellTags->"Procedure"],

Cell["IsInMoneyMarketPlusMeasure[EvolutionDescription,Numeraires]", "Input",
 CellTags->"Procedure"]
}, Open  ]]
}, Open  ]],

Cell["Enumeration Member", "Section",
 CellTags->"EnumerationMember"]
}, Open  ]]
},
WindowSize->{716, 867},
WindowMargins->{{278, Automatic}, {Automatic, 42}},
FrontEndVersion->"8.0 for Microsoft Windows (32-bit) (February 23, 2011)",
StyleDefinitions->"HelpBrowser.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "Overview"->{
  Cell[579, 22, 62, 1, 99, "Chapter",
   CellTags->"Overview"],
  Cell[644, 25, 116, 3, 37, "Text",
   CellTags->"Overview"],
  Cell[763, 30, 94, 1, 53, "MathCaption",
   CellTags->"Overview"],
  Cell[860, 33, 60, 1, 41, "Input",
   CellTags->"Overview"],
  Cell[923, 36, 148, 4, 37, "Text",
   CellTags->"Overview"],
  Cell[1074, 42, 96, 1, 41, "Input",
   CellTags->"Overview"],
  Cell[1173, 45, 91, 1, 41, "Input",
   CellTags->"Overview"],
  Cell[1267, 48, 94, 1, 41, "Input",
   CellTags->"Overview"]},
 "Constructor"->{
  Cell[1386, 53, 57, 1, 77, "Section",
   CellTags->"Constructor"],
  Cell[1468, 58, 71, 1, 47, "Subsubsection",
   CellTags->"Constructor"],
  Cell[1916, 72, 517, 15, 62, "Input",
   CellTags->"Constructor"],
  Cell[2436, 89, 93, 1, 41, "Input",
   CellTags->"Constructor"],
  Cell[2566, 95, 82, 1, 47, "Subsubsection",
   CellTags->"Constructor"],
  Cell[2903, 106, 110, 3, 41, "Input",
   CellTags->"Constructor"],
  Cell[3016, 111, 87, 1, 41, "Input",
   CellTags->"Constructor"]},
 "Member"->{
  Cell[3152, 118, 55, 1, 77, "Section",
   CellTags->"Member"],
  Cell[3232, 123, 75, 1, 47, "Subsubsection",
   CellTags->"Member"],
  Cell[3310, 126, 72, 1, 41, "Input",
   CellTags->"Member"],
  Cell[3419, 132, 74, 1, 47, "Subsubsection",
   CellTags->"Member"],
  Cell[3496, 135, 71, 1, 41, "Input",
   CellTags->"Member"],
  Cell[3604, 141, 80, 1, 47, "Subsubsection",
   CellTags->"Member"],
  Cell[3687, 144, 77, 1, 41, "Input",
   CellTags->"Member"],
  Cell[3801, 150, 80, 1, 47, "Subsubsection",
   CellTags->"Member"],
  Cell[3884, 153, 77, 1, 41, "Input",
   CellTags->"Member"],
  Cell[3998, 159, 79, 1, 47, "Subsubsection",
   CellTags->"Member"],
  Cell[4080, 162, 76, 1, 41, "Input",
   CellTags->"Member"],
  Cell[4193, 168, 79, 1, 47, "Subsubsection",
   CellTags->"Member"],
  Cell[4275, 171, 76, 1, 41, "Input",
   CellTags->"Member"]},
 "Procedure"->{
  Cell[4400, 178, 53, 1, 77, "Section",
   CellTags->"Procedure"],
  Cell[4478, 183, 64, 1, 47, "Subsubsection",
   CellTags->"Procedure"],
  Cell[4821, 194, 121, 3, 41, "Input",
   CellTags->"Procedure"],
  Cell[4945, 199, 78, 1, 41, "Input",
   CellTags->"Procedure"],
  Cell[5060, 205, 67, 1, 47, "Subsubsection",
   CellTags->"Procedure"],
  Cell[5406, 216, 121, 3, 41, "Input",
   CellTags->"Procedure"],
  Cell[5530, 221, 81, 1, 41, "Input",
   CellTags->"Procedure"],
  Cell[5648, 227, 71, 1, 47, "Subsubsection",
   CellTags->"Procedure"],
  Cell[6292, 246, 121, 3, 41, "Input",
   CellTags->"Procedure"],
  Cell[6416, 251, 85, 1, 41, "Input",
   CellTags->"Procedure"],
  Cell[6538, 257, 68, 1, 47, "Subsubsection",
   CellTags->"Procedure"],
  Cell[6983, 271, 232, 7, 62, "Input",
   CellTags->"Procedure"],
  Cell[7218, 280, 93, 1, 41, "Input",
   CellTags->"Procedure"],
  Cell[7348, 286, 71, 1, 47, "Subsubsection",
   CellTags->"Procedure"],
  Cell[7796, 300, 232, 7, 62, "Input",
   CellTags->"Procedure"],
  Cell[8031, 309, 96, 1, 41, "Input",
   CellTags->"Procedure"],
  Cell[8164, 315, 75, 1, 47, "Subsubsection",
   CellTags->"Procedure"],
  Cell[8910, 337, 232, 7, 62, "Input",
   CellTags->"Procedure"],
  Cell[9145, 346, 100, 1, 41, "Input",
   CellTags->"Procedure"]},
 "EnumerationMember"->{
  Cell[9272, 351, 69, 1, 77, "Section",
   CellTags->"EnumerationMember"]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"Overview", 9657, 365},
 {"Constructor", 10183, 382},
 {"Member", 10682, 397},
 {"Procedure", 11555, 424},
 {"EnumerationMember", 12872, 463}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[579, 22, 62, 1, 99, "Chapter",
 CellTags->"Overview"],
Cell[644, 25, 116, 3, 37, "Text",
 CellTags->"Overview"],
Cell[763, 30, 94, 1, 53, "MathCaption",
 CellTags->"Overview"],
Cell[860, 33, 60, 1, 41, "Input",
 CellTags->"Overview"],
Cell[923, 36, 148, 4, 37, "Text",
 CellTags->"Overview"],
Cell[1074, 42, 96, 1, 41, "Input",
 CellTags->"Overview"],
Cell[1173, 45, 91, 1, 41, "Input",
 CellTags->"Overview"],
Cell[1267, 48, 94, 1, 41, "Input",
 CellTags->"Overview"],
Cell[CellGroupData[{
Cell[1386, 53, 57, 1, 77, "Section",
 CellTags->"Constructor"],
Cell[CellGroupData[{
Cell[1468, 58, 71, 1, 47, "Subsubsection",
 CellTags->"Constructor"],
Cell[1542, 61, 371, 9, 80, "Text"],
Cell[1916, 72, 517, 15, 62, "Input",
 CellTags->"Constructor"],
Cell[2436, 89, 93, 1, 41, "Input",
 CellTags->"Constructor"]
}, Open  ]],
Cell[CellGroupData[{
Cell[2566, 95, 82, 1, 47, "Subsubsection",
 CellTags->"Constructor"],
Cell[2651, 98, 249, 6, 64, "Text"],
Cell[2903, 106, 110, 3, 41, "Input",
 CellTags->"Constructor"],
Cell[3016, 111, 87, 1, 41, "Input",
 CellTags->"Constructor"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[3152, 118, 55, 1, 77, "Section",
 CellTags->"Member"],
Cell[CellGroupData[{
Cell[3232, 123, 75, 1, 47, "Subsubsection",
 CellTags->"Member"],
Cell[3310, 126, 72, 1, 41, "Input",
 CellTags->"Member"]
}, Open  ]],
Cell[CellGroupData[{
Cell[3419, 132, 74, 1, 47, "Subsubsection",
 CellTags->"Member"],
Cell[3496, 135, 71, 1, 41, "Input",
 CellTags->"Member"]
}, Open  ]],
Cell[CellGroupData[{
Cell[3604, 141, 80, 1, 47, "Subsubsection",
 CellTags->"Member"],
Cell[3687, 144, 77, 1, 41, "Input",
 CellTags->"Member"]
}, Open  ]],
Cell[CellGroupData[{
Cell[3801, 150, 80, 1, 47, "Subsubsection",
 CellTags->"Member"],
Cell[3884, 153, 77, 1, 41, "Input",
 CellTags->"Member"]
}, Open  ]],
Cell[CellGroupData[{
Cell[3998, 159, 79, 1, 47, "Subsubsection",
 CellTags->"Member"],
Cell[4080, 162, 76, 1, 41, "Input",
 CellTags->"Member"]
}, Open  ]],
Cell[CellGroupData[{
Cell[4193, 168, 79, 1, 47, "Subsubsection",
 CellTags->"Member"],
Cell[4275, 171, 76, 1, 41, "Input",
 CellTags->"Member"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[4400, 178, 53, 1, 77, "Section",
 CellTags->"Procedure"],
Cell[CellGroupData[{
Cell[4478, 183, 64, 1, 47, "Subsubsection",
 CellTags->"Procedure"],
Cell[4545, 186, 273, 6, 64, "Text"],
Cell[4821, 194, 121, 3, 41, "Input",
 CellTags->"Procedure"],
Cell[4945, 199, 78, 1, 41, "Input",
 CellTags->"Procedure"]
}, Open  ]],
Cell[CellGroupData[{
Cell[5060, 205, 67, 1, 47, "Subsubsection",
 CellTags->"Procedure"],
Cell[5130, 208, 273, 6, 64, "Text"],
Cell[5406, 216, 121, 3, 41, "Input",
 CellTags->"Procedure"],
Cell[5530, 221, 81, 1, 41, "Input",
 CellTags->"Procedure"]
}, Open  ]],
Cell[CellGroupData[{
Cell[5648, 227, 71, 1, 47, "Subsubsection",
 CellTags->"Procedure"],
Cell[5722, 230, 273, 6, 64, "Text"],
Cell[5998, 238, 291, 6, 87, "Text"],
Cell[6292, 246, 121, 3, 41, "Input",
 CellTags->"Procedure"],
Cell[6416, 251, 85, 1, 41, "Input",
 CellTags->"Procedure"]
}, Open  ]],
Cell[CellGroupData[{
Cell[6538, 257, 68, 1, 47, "Subsubsection",
 CellTags->"Procedure"],
Cell[6609, 260, 371, 9, 80, "Text"],
Cell[6983, 271, 232, 7, 62, "Input",
 CellTags->"Procedure"],
Cell[7218, 280, 93, 1, 41, "Input",
 CellTags->"Procedure"]
}, Open  ]],
Cell[CellGroupData[{
Cell[7348, 286, 71, 1, 47, "Subsubsection",
 CellTags->"Procedure"],
Cell[7422, 289, 371, 9, 80, "Text"],
Cell[7796, 300, 232, 7, 62, "Input",
 CellTags->"Procedure"],
Cell[8031, 309, 96, 1, 41, "Input",
 CellTags->"Procedure"]
}, Open  ]],
Cell[CellGroupData[{
Cell[8164, 315, 75, 1, 47, "Subsubsection",
 CellTags->"Procedure"],
Cell[8242, 318, 371, 9, 80, "Text"],
Cell[8616, 329, 291, 6, 87, "Text"],
Cell[8910, 337, 232, 7, 62, "Input",
 CellTags->"Procedure"],
Cell[9145, 346, 100, 1, 41, "Input",
 CellTags->"Procedure"]
}, Open  ]]
}, Open  ]],
Cell[9272, 351, 69, 1, 77, "Section",
 CellTags->"EnumerationMember"]
}, Open  ]]
}
]
*)

(* End of internal cache information *)

