(* Content-type: application/mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 6.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       145,          7]
NotebookDataLength[     14620,        569]
NotebookOptionsPosition[      7745,        312]
NotebookOutlinePosition[     11581,        445]
CellTagsIndexPosition[     11429,        437]
WindowFrame->Normal
ContainsDynamic->False*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell[BoxData["Exercise"], "Chapter",
 CellTags->"Overview",
 CellID->61145424],

Cell["functions to construct and use Exercise objects.", "Text",
 CellTags->"Overview",
 CellID->192091833],

Cell["The first step is to load the QuantLib package. ", "MathCaption",
 CellTags->"Overview",
 CellID->209470672],

Cell["Needs[\"QuantLib`\"]", "Input",
 CellTags->"Overview",
 CellID->368356729],

Cell["\<\
Within the Exercise part there are several constructors and member functions \
available \
\>", "Text",
 CellTags->"Overview",
 CellID->173163492],

Cell[CellGroupData[{

Cell["Select[Category[Exercise],QLConstructor[#]&]", "Input",
 CellTags->"Overview",
 CellLabel->"In[720]:=",
 CellID->58276436],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "AmericanExercise", ",", "BermudanExercise", ",", "EuropeanExercise"}], 
  "}"}]], "Output",
 CellChangeTimes->{3.4360777788125*^9},
 CellTags->"Overview",
 CellLabel->"Out[720]=",
 CellID->17973971]
}, Open  ]],

Cell[CellGroupData[{

Cell["Select[Category[Exercise],QLMember[#]&]", "Input",
 CellTags->"Overview",
 CellLabel->"In[721]:=",
 CellID->530811174],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"ExerciseDates", ",", "ExerciseLastDate"}], "}"}]], "Output",
 CellChangeTimes->{3.436077779859375*^9},
 CellTags->"Overview",
 CellLabel->"Out[721]=",
 CellID->307715948]
}, Open  ]],

Cell[CellGroupData[{

Cell["Constructors", "Section",
 CellTags->"Constructo",
 CellID->250823313],

Cell[CellGroupData[{

Cell["AmericanExercise", "Subsection",
 CellTags->"Constructor",
 CellID->247170299],

Cell[BoxData[{Cell[BoxData[GridBox[{
    {"EarliestDate", 
     RowBox[{"{", 
      RowBox[{"2008", ",", "11", ",", "11"}], "}"}], 
     RowBox[{"earliest", " ", "exercise", " ", 
      RowBox[{"date", "."}]}]},
    {"LatestDate", 
     RowBox[{"{", 
      RowBox[{"2010", ",", "11", ",", "11"}], "}"}], 
     RowBox[{"latest", " ", "exercise", " ", 
      RowBox[{"date", "."}]}]}
   }]], "DefinitionBox3Col",
  CellTags->"Constructor"], "\n", Cell["Calling Parameters", 
  "Caption"]}], "Input",
 CellChangeTimes->{{3.436077926328125*^9, 3.4360779460625*^9}},
 CellID->108119786],

Cell[BoxData[{Cell[BoxData[GridBox[{
    {"PayoffAtExpiry", "False", 
     RowBox[{"payoff", " ", "at", " ", 
      RowBox[{"expiry", "."}]}]}
   }]], "DefinitionBox3Col",
  CellTags->"Constructor"], "\n", Cell["Option Setting", "Caption"]}], "Input",\

 CellChangeTimes->{{3.436077967796875*^9, 3.436077967796875*^9}},
 CellID->36790621],

Cell[BoxData[{
 RowBox[{
  RowBox[{"EarliestDate", "=", 
   RowBox[{"{", 
    RowBox[{"2008", ",", "11", ",", "11"}], "}"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"LatestDate", "=", 
   RowBox[{"{", 
    RowBox[{"2010", ",", "11", ",", "11"}], "}"}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.436077787734375*^9, 3.43607779190625*^9}, {
  3.436077952609375*^9, 3.436077962859375*^9}},
 CellTags->"Constructor",
 CellLabel->"In[726]:=",
 CellID->2489255],

Cell[CellGroupData[{

Cell["obj=AmericanExercise[EarliestDate,LatestDate]", "Input",
 CellTags->"Constructor",
 CellLabel->"In[728]:=",
 CellID->134862495],

Cell[BoxData["AmericanExercise1"], "Output",
 CellChangeTimes->{3.436077794234375*^9, 3.436077974484375*^9},
 CellTags->"Constructor",
 CellLabel->"Out[728]=",
 CellID->13390360]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["EuropeanExercise", "Subsection",
 CellTags->"Constructor",
 CellID->505351663],

Cell[BoxData[{Cell[BoxData[GridBox[{
    {"ExpiryDate", 
     RowBox[{"{", 
      RowBox[{"2010", ",", "11", ",", "11"}], "}"}], 
     RowBox[{"expiry", " ", 
      RowBox[{"date", "."}]}]}
   }]], "DefinitionBox3Col",
  CellTags->"Constructor"], "\n", Cell["Calling Parameters", 
  "Caption"]}], "Input",
 CellChangeTimes->{{3.436077988984375*^9, 3.436077988984375*^9}},
 CellID->402145898],

Cell[BoxData[
 RowBox[{
  RowBox[{"ExpiryDate", "=", 
   RowBox[{"{", 
    RowBox[{"2010", ",", "11", ",", "11"}], "}"}]}], ";"}]], "Input",
 CellChangeTimes->{3.436077991671875*^9},
 CellTags->"Constructor",
 CellLabel->"In[729]:=",
 CellID->35043186],

Cell[CellGroupData[{

Cell["obj=EuropeanExercise[ExpiryDate]", "Input",
 CellTags->"Constructor",
 CellLabel->"In[730]:=",
 CellID->648617250],

Cell[BoxData["EuropeanExercise1"], "Output",
 CellChangeTimes->{3.43607799553125*^9},
 CellTags->"Constructor",
 CellLabel->"Out[730]=",
 CellID->525774222]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["BermudanExercise", "Subsection",
 CellTags->"Constructor",
 CellID->80688673],

Cell[BoxData[{Cell[BoxData[GridBox[{
    {"Dates", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"2008", ",", "11", ",", "11"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"2009", ",", "11", ",", "11"}], "}"}]}], "}"}], 
     RowBox[{"dates", "."}]}
   }]], "DefinitionBox3Col",
  CellTags->"Constructor"], "\n", Cell["Calling Parameters", 
  "Caption"]}], "Input",
 CellChangeTimes->{{3.436078008609375*^9, 3.43607802796875*^9}},
 CellID->535426683],

Cell[BoxData[{Cell[BoxData[GridBox[{
    {"PayoffAtExpiry", "False", 
     RowBox[{"payoff", " ", "at", " ", 
      RowBox[{"expiry", "."}]}]}
   }]], "DefinitionBox3Col",
  CellTags->"Constructor"], "\n", Cell["Option Setting", "Caption"]}], "Input",\

 CellChangeTimes->{{3.43607803203125*^9, 3.43607803203125*^9}},
 CellID->3061385],

Cell[BoxData[
 RowBox[{
  RowBox[{"Dates", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"2008", ",", "11", ",", "11"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2009", ",", "11", ",", "11"}], "}"}]}], "}"}]}], 
  ";"}]], "Input",
 CellChangeTimes->{3.436078041921875*^9},
 CellTags->"Constructor",
 CellLabel->"In[731]:=",
 CellID->701633365],

Cell[CellGroupData[{

Cell["obj=BermudanExercise[Dates]", "Input",
 CellTags->"Constructor",
 CellLabel->"In[732]:=",
 CellID->382390110],

Cell[BoxData["BermudanExercise1"], "Output",
 CellChangeTimes->{3.436078045109375*^9},
 CellTags->"Constructor",
 CellLabel->"Out[732]=",
 CellID->27377551]
}, Open  ]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Member function", "Section",
 CellTags->"Member",
 CellID->99960804],

Cell[CellGroupData[{

Cell["ExerciseDates", "Subsection",
 CellTags->"Member",
 CellID->30474725],

Cell[CellGroupData[{

Cell["ExerciseDates[obj]", "Input",
 CellTags->"Member",
 CellLabel->"In[733]:=",
 CellID->688566803],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"2008", ",", "11", ",", "11"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"2009", ",", "11", ",", "11"}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{3.436078050671875*^9},
 CellTags->"Member",
 CellLabel->"Out[733]=",
 CellID->468983564]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["ExerciseLastDate", "Subsection",
 CellTags->"Member",
 CellID->158860427],

Cell[CellGroupData[{

Cell["ExerciseLastDate[obj]", "Input",
 CellTags->"Member",
 CellLabel->"In[734]:=",
 CellID->669742875],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"2009", ",", "11", ",", "11"}], "}"}]], "Output",
 CellChangeTimes->{3.436078053453125*^9},
 CellTags->"Member",
 CellLabel->"Out[734]=",
 CellID->428591645]
}, Open  ]]
}, Open  ]]
}, Open  ]]
}, Open  ]]
},
Editable->True,
WindowSize->{616, 750},
WindowMargins->{{Automatic, 652}, {Automatic, 99}},
DockedCells->FEPrivate`FrontEndResource[
 "FEExpressions", "HelpViewerToolbar"],
PageHeaders->{{None, None, None}, {None, None, 
   Cell[
    TextData[{
      Cell[
       TextData[{"Printed from [[YOUR APPLICATION'S NAME]] documentation "}], 
       "PageHeader"], 
      Cell[
       TextData[{
         CounterBox["Page"]}], "PageNumber"]}], 
    CellMargins -> {{Inherited, -29}, {Inherited, Inherited}}]}},
PageFooters->{{None, None, None}, {
   Cell[
    TextData[{"\[Copyright] 2008 Weber & Partner. All rights reserved."}], 
    "PageFooter"], None, None}},
TaggingRules->{"SearchTextTranslated" -> "", "SearchText" -> ""},
CreateCellID->True,
ShowCellTags->False,
FrontEndVersion->"6.0 for Microsoft Windows (32-bit) (May 21, 2008)",
StyleDefinitions->FrontEnd`FileName[{"Wolfram"}, "Reference.nb", 
  CharacterEncoding -> "WindowsANSI"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "Overview"->{
  Cell[590, 23, 78, 2, 99, "Chapter",
   CellTags->"Overview",
   CellID->61145424],
  Cell[671, 27, 107, 2, 37, "Text",
   CellTags->"Overview",
   CellID->192091833],
  Cell[781, 31, 114, 2, 53, "MathCaption",
   CellTags->"Overview",
   CellID->209470672],
  Cell[898, 35, 80, 2, 41, "Input",
   CellTags->"Overview",
   CellID->368356729],
  Cell[981, 39, 156, 5, 37, "Text",
   CellTags->"Overview",
   CellID->173163492],
  Cell[1162, 48, 128, 3, 41, "Input",
   CellTags->"Overview",
   CellID->58276436],
  Cell[1293, 53, 241, 8, 39, "Output",
   CellTags->"Overview",
   CellID->17973971],
  Cell[1571, 66, 124, 3, 41, "Input",
   CellTags->"Overview",
   CellID->530811174],
  Cell[1698, 71, 210, 6, 39, "Output",
   CellTags->"Overview",
   CellID->307715948]},
 "Constructo"->{
  Cell[1945, 82, 76, 2, 77, "Section",
   CellTags->"Constructo",
   CellID->250823313]},
 "Constructor"->{
  Cell[2046, 88, 84, 2, 51, "Subsection",
   CellTags->"Constructor",
   CellID->247170299],
  Cell[3058, 119, 451, 13, 62, "Input",
   CellTags->"Constructor",
   CellID->2489255],
  Cell[3534, 136, 133, 3, 70, "Input",
   CellTags->"Constructor",
   CellID->134862495],
  Cell[3670, 141, 178, 4, 70, "Output",
   CellTags->"Constructor",
   CellID->13390360],
  Cell[3897, 151, 84, 2, 51, "Subsection",
   CellTags->"Constructor",
   CellID->505351663],
  Cell[4378, 167, 252, 8, 28, "Input",
   CellTags->"Constructor",
   CellID->35043186],
  Cell[4655, 179, 120, 3, 28, "Input",
   CellTags->"Constructor",
   CellID->648617250],
  Cell[4778, 184, 156, 4, 36, "Output",
   CellTags->"Constructor",
   CellID->525774222],
  Cell[4983, 194, 83, 2, 51, "Subsection",
   CellTags->"Constructor",
   CellID->80688673],
  Cell[5893, 223, 372, 13, 28, "Input",
   CellTags->"Constructor",
   CellID->701633365],
  Cell[6290, 240, 115, 3, 28, "Input",
   CellTags->"Constructor",
   CellID->382390110],
  Cell[6408, 245, 156, 4, 36, "Output",
   CellTags->"Constructor",
   CellID->27377551]},
 "Member"->{
  Cell[6625, 256, 74, 2, 51, "Section",
   CellTags->"Member",
   CellID->99960804],
  Cell[6724, 262, 75, 2, 51, "Subsection",
   CellTags->"Member",
   CellID->30474725],
  Cell[6824, 268, 101, 3, 28, "Input",
   CellTags->"Member",
   CellID->688566803],
  Cell[6928, 273, 309, 10, 36, "Output",
   CellTags->"Member",
   CellID->468983564],
  Cell[7286, 289, 79, 2, 51, "Subsection",
   CellTags->"Member",
   CellID->158860427],
  Cell[7390, 295, 104, 3, 28, "Input",
   CellTags->"Member",
   CellID->669742875],
  Cell[7497, 300, 196, 6, 36, "Output",
   CellTags->"Member",
   CellID->428591645]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"Overview", 8798, 343},
 {"Constructo", 9588, 371},
 {"Constructor", 9696, 375},
 {"Member", 10800, 412}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[590, 23, 78, 2, 99, "Chapter",
 CellTags->"Overview",
 CellID->61145424],
Cell[671, 27, 107, 2, 37, "Text",
 CellTags->"Overview",
 CellID->192091833],
Cell[781, 31, 114, 2, 53, "MathCaption",
 CellTags->"Overview",
 CellID->209470672],
Cell[898, 35, 80, 2, 41, "Input",
 CellTags->"Overview",
 CellID->368356729],
Cell[981, 39, 156, 5, 37, "Text",
 CellTags->"Overview",
 CellID->173163492],
Cell[CellGroupData[{
Cell[1162, 48, 128, 3, 41, "Input",
 CellTags->"Overview",
 CellID->58276436],
Cell[1293, 53, 241, 8, 39, "Output",
 CellTags->"Overview",
 CellID->17973971]
}, Open  ]],
Cell[CellGroupData[{
Cell[1571, 66, 124, 3, 41, "Input",
 CellTags->"Overview",
 CellID->530811174],
Cell[1698, 71, 210, 6, 39, "Output",
 CellTags->"Overview",
 CellID->307715948]
}, Open  ]],
Cell[CellGroupData[{
Cell[1945, 82, 76, 2, 77, "Section",
 CellTags->"Constructo",
 CellID->250823313],
Cell[CellGroupData[{
Cell[2046, 88, 84, 2, 51, "Subsection",
 CellTags->"Constructor",
 CellID->247170299],
Cell[2133, 92, 581, 15, 84, "Input",
 CellID->108119786],
Cell[2717, 109, 338, 8, 68, "Input",
 CellID->36790621],
Cell[3058, 119, 451, 13, 62, "Input",
 CellTags->"Constructor",
 CellID->2489255],
Cell[CellGroupData[{
Cell[3534, 136, 133, 3, 70, "Input",
 CellTags->"Constructor",
 CellID->134862495],
Cell[3670, 141, 178, 4, 70, "Output",
 CellTags->"Constructor",
 CellID->13390360]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[3897, 151, 84, 2, 51, "Subsection",
 CellTags->"Constructor",
 CellID->505351663],
Cell[3984, 155, 391, 10, 65, "Input",
 CellID->402145898],
Cell[4378, 167, 252, 8, 28, "Input",
 CellTags->"Constructor",
 CellID->35043186],
Cell[CellGroupData[{
Cell[4655, 179, 120, 3, 28, "Input",
 CellTags->"Constructor",
 CellID->648617250],
Cell[4778, 184, 156, 4, 36, "Output",
 CellTags->"Constructor",
 CellID->525774222]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[4983, 194, 83, 2, 51, "Subsection",
 CellTags->"Constructor",
 CellID->80688673],
Cell[5069, 198, 483, 13, 113, "Input",
 CellID->535426683],
Cell[5555, 213, 335, 8, 65, "Input",
 CellID->3061385],
Cell[5893, 223, 372, 13, 28, "Input",
 CellTags->"Constructor",
 CellID->701633365],
Cell[CellGroupData[{
Cell[6290, 240, 115, 3, 28, "Input",
 CellTags->"Constructor",
 CellID->382390110],
Cell[6408, 245, 156, 4, 36, "Output",
 CellTags->"Constructor",
 CellID->27377551]
}, Open  ]]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[6625, 256, 74, 2, 51, "Section",
 CellTags->"Member",
 CellID->99960804],
Cell[CellGroupData[{
Cell[6724, 262, 75, 2, 51, "Subsection",
 CellTags->"Member",
 CellID->30474725],
Cell[CellGroupData[{
Cell[6824, 268, 101, 3, 28, "Input",
 CellTags->"Member",
 CellID->688566803],
Cell[6928, 273, 309, 10, 36, "Output",
 CellTags->"Member",
 CellID->468983564]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[7286, 289, 79, 2, 51, "Subsection",
 CellTags->"Member",
 CellID->158860427],
Cell[CellGroupData[{
Cell[7390, 295, 104, 3, 28, "Input",
 CellTags->"Member",
 CellID->669742875],
Cell[7497, 300, 196, 6, 36, "Output",
 CellTags->"Member",
 CellID->428591645]
}, Open  ]]
}, Open  ]]
}, Open  ]]
}, Open  ]]
}
]
*)

(* End of internal cache information *)
