(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 8.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       157,          7]
NotebookDataLength[      5469,        217]
NotebookOptionsPosition[      2637,        112]
NotebookOutlinePosition[      4331,        173]
CellTagsIndexPosition[      4146,        164]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell["Handles", "Chapter",
 CellTags->"Overview"],

Cell["handles.", "Text",
 CellTags->"Overview"],

Cell["The first step is to load the QuantLib package. ", "MathCaption",
 CellTags->"Overview"],

Cell["Needs[\"QuantLib`\"]", "Input",
 CellTags->"Overview",
 CellLabel->"In[1]:="],

Cell["\<\
Within the Handles part there are several constructors and member functions \
available \
\>", "Text",
 CellTags->"Overview"],

Cell[CellGroupData[{

Cell["Select[Category[Handles],QLMember[#]&]", "Input",
 CellTags->"Overview",
 CellLabel->"In[2]:="],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "HandleCurrentLink", ",", "HandleEmpty", ",", "RelinkableHandleLinkTo"}], 
  "}"}]], "Output",
 CellChangeTimes->{3.51885876465625*^9},
 CellTags->"Overview",
 CellLabel->"Out[2]="]
}, Open  ]],

Cell["Constructors", "Section",
 CellTags->"Constructor"],

Cell[CellGroupData[{

Cell["Member function", "Section",
 CellTags->"Member"],

Cell[CellGroupData[{

Cell["HandleCurrentLink", "Subsubsection",
 CellTags->"Member"],

Cell["HandleCurrentLink[obj]", "Input",
 CellTags->"Member"]
}, Open  ]],

Cell[CellGroupData[{

Cell["HandleEmpty", "Subsubsection",
 CellTags->"Member"],

Cell["HandleEmpty[obj]", "Input",
 CellTags->"Member"]
}, Open  ]],

Cell[CellGroupData[{

Cell["RelinkableHandleLinkTo", "Subsubsection",
 CellTags->"Member"],

Cell[BoxData[{Cell[BoxData[GridBox[{
    {"CurrentLink", "\<\"\"\>", 
     RowBox[{
      RowBox[{
      "ID", " ", "of", " ", "Object", " ", "to", " ", "which", " ", "the", 
       " ", "RelinkableHandle", " ", "should", " ", "be", " ", "relinked"}], 
      ",", " ", 
      RowBox[{"or", " ", "empty", " ", "string", " ", "for", " ", "null", " ", 
       RowBox[{"object", "."}]}]}]}
   }]], "DefinitionBox3Col",
  CellTags->"Member"], "\n", Cell["Option Setting", "Caption"]}], "Text"],

Cell["RelinkableHandleLinkTo[obj]", "Input",
 CellTags->"Member"]
}, Open  ]]
}, Open  ]],

Cell["Procedures", "Section",
 CellTags->"Procedure"],

Cell["Enumeration Member", "Section",
 CellTags->"EnumerationMember"]
}, Open  ]]
},
WindowSize->{716, 867},
WindowMargins->{{278, Automatic}, {Automatic, 42}},
FrontEndVersion->"8.0 for Microsoft Windows (32-bit) (February 23, 2011)",
StyleDefinitions->"HelpBrowser.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "Overview"->{
  Cell[579, 22, 49, 1, 99, "Chapter",
   CellTags->"Overview"],
  Cell[631, 25, 47, 1, 37, "Text",
   CellTags->"Overview"],
  Cell[681, 28, 94, 1, 53, "MathCaption",
   CellTags->"Overview"],
  Cell[778, 31, 83, 2, 41, "Input",
   CellTags->"Overview"],
  Cell[864, 35, 135, 4, 37, "Text",
   CellTags->"Overview"],
  Cell[1024, 43, 101, 2, 41, "Input",
   CellTags->"Overview"],
  Cell[1128, 47, 223, 7, 39, "Output",
   CellTags->"Overview"]},
 "Constructor"->{
  Cell[1366, 57, 57, 1, 77, "Section",
   CellTags->"Constructor"]},
 "Member"->{
  Cell[1448, 62, 55, 1, 51, "Section",
   CellTags->"Member"],
  Cell[1528, 67, 63, 1, 47, "Subsubsection",
   CellTags->"Member"],
  Cell[1594, 70, 60, 1, 41, "Input",
   CellTags->"Member"],
  Cell[1691, 76, 57, 1, 47, "Subsubsection",
   CellTags->"Member"],
  Cell[1751, 79, 54, 1, 41, "Input",
   CellTags->"Member"],
  Cell[1842, 85, 68, 1, 47, "Subsubsection",
   CellTags->"Member"],
  Cell[2404, 100, 65, 1, 41, "Input",
   CellTags->"Member"]},
 "Procedure"->{
  Cell[2496, 105, 53, 1, 77, "Section",
   CellTags->"Procedure"]},
 "EnumerationMember"->{
  Cell[2552, 108, 69, 1, 51, "Section",
   CellTags->"EnumerationMember"]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"Overview", 2937, 122},
 {"Constructor", 3402, 137},
 {"Member", 3484, 140},
 {"Procedure", 3955, 155},
 {"EnumerationMember", 4047, 158}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[579, 22, 49, 1, 99, "Chapter",
 CellTags->"Overview"],
Cell[631, 25, 47, 1, 37, "Text",
 CellTags->"Overview"],
Cell[681, 28, 94, 1, 53, "MathCaption",
 CellTags->"Overview"],
Cell[778, 31, 83, 2, 41, "Input",
 CellTags->"Overview"],
Cell[864, 35, 135, 4, 37, "Text",
 CellTags->"Overview"],
Cell[CellGroupData[{
Cell[1024, 43, 101, 2, 41, "Input",
 CellTags->"Overview"],
Cell[1128, 47, 223, 7, 39, "Output",
 CellTags->"Overview"]
}, Open  ]],
Cell[1366, 57, 57, 1, 77, "Section",
 CellTags->"Constructor"],
Cell[CellGroupData[{
Cell[1448, 62, 55, 1, 51, "Section",
 CellTags->"Member"],
Cell[CellGroupData[{
Cell[1528, 67, 63, 1, 47, "Subsubsection",
 CellTags->"Member"],
Cell[1594, 70, 60, 1, 41, "Input",
 CellTags->"Member"]
}, Open  ]],
Cell[CellGroupData[{
Cell[1691, 76, 57, 1, 47, "Subsubsection",
 CellTags->"Member"],
Cell[1751, 79, 54, 1, 41, "Input",
 CellTags->"Member"]
}, Open  ]],
Cell[CellGroupData[{
Cell[1842, 85, 68, 1, 47, "Subsubsection",
 CellTags->"Member"],
Cell[1913, 88, 488, 10, 109, "Text"],
Cell[2404, 100, 65, 1, 41, "Input",
 CellTags->"Member"]
}, Open  ]]
}, Open  ]],
Cell[2496, 105, 53, 1, 77, "Section",
 CellTags->"Procedure"],
Cell[2552, 108, 69, 1, 51, "Section",
 CellTags->"EnumerationMember"]
}, Open  ]]
}
]
*)

(* End of internal cache information *)
