(* Content-type: application/mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 6.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       145,          7]
NotebookDataLength[     38554,       1342]
NotebookOptionsPosition[     22423,        781]
NotebookOutlinePosition[     31791,       1078]
CellTagsIndexPosition[     31384,       1064]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell["Indices", "Chapter",
 CellChangeTimes->{{3.43494703740625*^9, 3.43494703928125*^9}, 
   3.434951659765625*^9, 3.43503746765625*^9, {3.435308085953125*^9, 
   3.43530808640625*^9}, {3.43531829871875*^9, 3.435318332828125*^9}, {
   3.43531845903125*^9, 3.435318459515625*^9}, {3.435409586109375*^9, 
   3.43540958709375*^9}, {3.435472253609375*^9, 3.4354722566875*^9}, {
   3.435472348921875*^9, 3.435472350078125*^9}},
 CellTags->"Overview",
 CellID->374938163],

Cell[BoxData[
 RowBox[{"Needs", "[", "\"\<QuantLib`\>\"", "]"}]], "Input",
 CellTags->"Overview",
 CellLabel->"In[1]:=",
 CellID->200097591],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Select", "[", 
  RowBox[{
   RowBox[{"Category", "[", "Indices", "]"}], ",", 
   RowBox[{
    RowBox[{"QLConstructor", "[", "#", "]"}], "&"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.435922249412228*^9, 3.435922250380978*^9}},
 CellTags->"Overview",
 CellLabel->"In[2]:=",
 CellID->155963278],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "BMAIndex", ",", "Eonia", ",", "Euribor", ",", "Euribor365", ",", 
   "IborIndex", ",", "SwapIndex"}], "}"}]], "Output",
 CellTags->"Overview",
 CellLabel->"Out[2]=",
 CellID->278963300]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Select", "[", 
  RowBox[{
   RowBox[{"Category", "[", "Indices", "]"}], ",", 
   RowBox[{
    RowBox[{"QLMember", "[", "#", "]"}], "&"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.435922261396603*^9, 3.435922262318478*^9}},
 CellTags->"Overview",
 CellLabel->"In[3]:=",
 CellID->506165459],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "IborIndexBusinessDayConv", ",", "IborIndexEndOfMonth", ",", 
   "IndexAddFixings", ",", "IndexClearFixings", ",", "IndexFixing", ",", 
   "IndexFixingCalendar", ",", "IndexIsValidFixingDate", ",", "IndexName", 
   ",", "InterestRateIndexCurrency", ",", "InterestRateIndexDayCounter", ",", 
   "InterestRateIndexFamilyName", ",", "InterestRateIndexFixingDate", ",", 
   "InterestRateIndexFixingDays", ",", "InterestRateIndexMaturity", ",", 
   "InterestRateIndexTenor", ",", "InterestRateIndexValueDate", ",", 
   "SwapIndexFixedLegBDC", ",", "SwapIndexFixedLegTenor"}], "}"}]], "Output",
 CellTags->"Overview",
 CellLabel->"Out[3]=",
 CellID->263684095]
}, Open  ]],

Cell[CellGroupData[{

Cell["Constructing Indices and fleshing them out", "Section",
 CellChangeTimes->{{3.4354871780625*^9, 3.435487188578125*^9}},
 CellTags->"Creating",
 CellID->1024089902],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"Needs", "[", "\"\<QuantLib`\>\"", "]"}], "\[IndentingNewLine]", 
 RowBox[{"?", "BMAIndex"}]}], "Input",
 CellTags->"Creating",
 CellLabel->"In[1]:=",
 CellID->387816073],

Cell[BoxData[
 StyleBox["\<\"BMAIndex[ObjecctId_Symbol] Construct an object of class \
BMAIndex and return its id       \\nObjectId: id of object to be \
created\\nYieldCurve: forecasting yield term structure. Default value = None.\
\\nPermanent: object permanent/nonpermanent\"\>", "MSG"]], "Print", \
"PrintUsage",
 CellTags->{"Creating", "Info3519032956-1550244"},
 CellID->199144126]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Options", "[", "BMAIndex", "]"}]], "Input",
 CellChangeTimes->{{3.43547335371875*^9, 3.435473391484375*^9}},
 CellTags->"Creating",
 CellLabel->"In[3]:=",
 CellID->243079049],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"YieldCurve", "\[Rule]", "None"}], ",", 
   RowBox[{"Permanent", "\[Rule]", "True"}], ",", 
   RowBox[{"Overwrite", "\[Rule]", "True"}]}], "}"}]], "Output",
 CellTags->"Creating",
 CellLabel->"Out[3]=",
 CellID->350521888]
}, Open  ]],

Cell["\<\
The index construction needs a yield curve. These can be constructed with \
functions available in the TermStructure category\
\>", "Text",
 CellChangeTimes->{{3.435473470296875*^9, 3.435473511546875*^9}},
 CellTags->"Creating",
 CellID->163165810],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"r", " ", "=", " ", "0.04"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"ff", "=", 
  RowBox[{"FlatForward", "[", "r", "]"}]}]}], "Input",
 CellTags->"Creating",
 CellLabel->"In[4]:=",
 CellID->69740319],

Cell[BoxData["FlatForward4"], "Output",
 CellTags->"Creating",
 CellLabel->"Out[5]=",
 CellID->476338115]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"bma", "=", 
  RowBox[{"BMAIndex", "[", 
   RowBox[{"YieldCurve", "\[Rule]", " ", "ff"}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{"Information", "[", 
  RowBox[{"Evaluate", "[", "bma", "]"}], "]"}]}], "Input",
 CellTags->"Creating",
 CellLabel->"In[6]:=",
 CellID->503115974],

Cell[BoxData["BMAIndex5"], "Output",
 CellTags->"Creating",
 CellLabel->"Out[6]=",
 CellID->779252348],

Cell[CellGroupData[{

Cell["Cell$$1871`BMAIndex5", "Print", "PrintUsage",
 CellTags->{"Creating", "Info3519032964-1550244"},
 CellID->33651419],

Cell[BoxData[
 InterpretationBox[GridBox[{
    {GridBox[{
       {
        RowBox[{
         RowBox[{"Global`BaseClass", "[", "BMAIndex5", "]"}], 
         "^=", "\<\"IndexProcessor\"\>"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"Category", "[", "BMAIndex5", "]"}], 
         "^=", "\<\"Indices\"\>"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"Overwrite", "[", "BMAIndex5", "]"}], "^=", "True"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"Permanent", "[", "BMAIndex5", "]"}], "^=", "True"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"Properties", "[", "BMAIndex5", "]"}], "^=", "2"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"Global`ValueObject", "[", "BMAIndex5", "]"}], "^=", 
         "qlBMAIndex"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"YieldCurve", "[", "BMAIndex5", "]"}], "^=", "FlatForward4"}]}
      },
      BaselinePosition->{Baseline, {1, 1}},
      GridBoxAlignment->{
       "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
        "RowsIndexed" -> {}},
      GridBoxItemSize->{"Columns" -> {{
           Scaled[0.999]}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
        "RowsIndexed" -> {}}]}
   },
   BaselinePosition->{Baseline, {1, 1}},
   GridBoxAlignment->{
    "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
     "RowsIndexed" -> {}}],
  Definition[$CellContext`BMAIndex5],
  Editable->False]], "Print",
 CellTags->{"Creating", "Info3519032964-1550244"},
 CellID->519987697]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"?", "IndexAddFixings"}], "\[IndentingNewLine]", 
 RowBox[{"Options", "[", "IndexAddFixings", "]"}]}], "Input",
 CellChangeTimes->{{3.435485222078125*^9, 3.435485230375*^9}},
 CellTags->"Creating",
 CellLabel->"In[8]:=",
 CellID->264086532],

Cell[BoxData[
 StyleBox["\<\"IndexAddFixings[ObjecctId_Symbol,FixingDates_List,FixingValues_\
List /; VectorQ[FixingValues, NumberQ]] Adds fixings for the given Index \
object.       \\nObjectId: id of existing QuantLibAddin::Index \
object\\nFixingDates: fixing dates.\\nFixingValues: fixing \
values.\\nForceOverwrite: Set to TRUE to force overwriting of existing \
fixings, if any. Default value = 0.\"\>", "MSG"]], "Print", "PrintUsage",
 CellTags->{"Creating", "Info3519032973-1550244"},
 CellID->253268559],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"ForceOverwrite", "\[Rule]", "True"}], "}"}]], "Output",
 CellTags->"Creating",
 CellLabel->"Out[9]=",
 CellID->102906270]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"n", " ", "=", "3"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"datelist", " ", "=", 
  RowBox[{"Table", "[", 
   RowBox[{
    RowBox[{"DatePlus", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"2007", ",", "10", ",", "10"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"i", ",", "\"\<Week\>\""}], "}"}]}], "]"}], ",", 
    RowBox[{"{", 
     RowBox[{"i", ",", "n"}], "}"}]}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{"fixings", " ", "=", 
  RowBox[{"Table", "[", 
   RowBox[{
    RowBox[{"99", "+", "i"}], ",", 
    RowBox[{"{", 
     RowBox[{"i", ",", "n"}], "}"}]}], "]"}]}]}], "Input",
 CellChangeTimes->{{3.435473959828125*^9, 3.435473960734375*^9}, {
   3.435478484125*^9, 3.4354784879375*^9}, 3.43548518171875*^9, {
   3.435485239421875*^9, 3.435485272609375*^9}},
 CellTags->"Creating",
 CellLabel->"In[10]:=",
 CellID->115479002],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"2007", ",", "10", ",", "17"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"2007", ",", "10", ",", "24"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"2007", ",", "10", ",", "31"}], "}"}]}], "}"}]], "Output",
 CellTags->"Creating",
 CellLabel->"Out[11]=",
 CellID->457066305],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"100", ",", "101", ",", "102"}], "}"}]], "Output",
 CellTags->"Creating",
 CellLabel->"Out[12]=",
 CellID->601634431]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"IndexAddFixings", "[", 
  RowBox[{"bma", ",", "datelist", ",", "fixings"}], "]"}]], "Input",
 CellChangeTimes->{{3.435473932921875*^9, 3.43547394103125*^9}, {
  3.435473978046875*^9, 3.4354739985*^9}, {3.4354740685625*^9, 
  3.435474069578125*^9}},
 CellTags->"Creating",
 CellLabel->"In[13]:=",
 CellID->401941795],

Cell[BoxData["True"], "Output",
 CellTags->"Creating",
 CellLabel->"Out[13]=",
 CellID->374051137]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", "IndexClearFixings"}]], "Input",
 CellChangeTimes->{{3.435487271921875*^9, 3.435487281265625*^9}},
 CellTags->"Creating",
 CellLabel->"In[14]:=",
 CellID->224496766],

Cell[BoxData[
 StyleBox["\<\"IndexClearFixings[ObjecctId_Symbol] Clear all fixings for the \
given Index object.       \\nObjectId: id of existing QuantLib::Index \
object\"\>", "MSG"]], "Print", "PrintUsage",
 CellTags->{"Creating", "Info3519032985-1550244"},
 CellID->123610667]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"IndexClearFixings", "[", "bma", "]"}]], "Input",
 CellChangeTimes->{{3.4354872869375*^9, 3.43548729471875*^9}},
 CellTags->"Creating",
 CellLabel->"In[15]:=",
 CellID->2505142],

Cell[BoxData["True"], "Output",
 CellTags->"Creating",
 CellLabel->"Out[15]=",
 CellID->436515006]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"IndexFixing", "[", 
  RowBox[{"bma", ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"2007", ",", "10", ",", "17"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2007", ",", "10", ",", "24"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2007", ",", "10", ",", "31"}], "}"}]}], "}"}]}], 
  "]"}]], "Input",
 CellChangeTimes->{3.43548738503125*^9},
 CellTags->"Creating",
 CellLabel->"In[16]:=",
 CellID->179721022],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"StringForm", "::", "sfr"}], "MessageName"], 
  RowBox[{
  ":", " "}], "\<\"Item \[NoBreak]\\!\\(2\\)\[NoBreak] requested in \\\"\
\[NoBreak]\\!\\(\\\"\\\\[NoBreak]`1`\\\\[NoBreak] \
\\\\[NoBreak]`2`\\\\[NoBreak]\\\"\\)\[NoBreak]\\\" out of range; \
\[NoBreak]\\!\\(1\\)\[NoBreak] items available. \\!\\(\\*ButtonBox[\\\"\
\[RightSkeleton]\\\", ButtonStyle->\\\"Link\\\", ButtonFrame->None, \
ButtonData:>\\\"paclet:ref/message/StringForm/sfr\\\", ButtonNote -> \
\\\"StringForm::sfr\\\"]\\)\"\>"}]], "Message", "MSG",
 CellTags->"Creating",
 CellLabel->"During evaluation of In[16]:=",
 CellID->255615804],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"QuantLibError", "::", "msg"}], "MessageName"], 
  RowBox[{
  ":", " "}], "\<\"\[NoBreak]\\!\\(\\\"Missing BMA fixing for October 17th, \
2007\\\"\\)\[NoBreak] \[NoBreak]`2`\[NoBreak]\"\>"}]], "Message", "MSG",
 CellTags->"Creating",
 CellLabel->"During evaluation of In[16]:=",
 CellID->375084764],

Cell[BoxData["$Failed"], "Output",
 CellTags->"Creating",
 CellLabel->"Out[16]=",
 CellID->170581934]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"n", " ", "=", "3"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"datelist", " ", "=", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"DatePlus", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"2007", ",", "10", ",", "10"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"i", ",", "\"\<Week\>\""}], "}"}]}], "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"i", ",", "n"}], "}"}]}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"fixings", " ", "=", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"99", "+", "i"}], ",", 
     RowBox[{"{", 
      RowBox[{"i", ",", "n"}], "}"}]}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"IndexAddFixings", "[", 
  RowBox[{"bma", ",", "datelist", ",", "fixings"}], "]"}]}], "Input",
 CellChangeTimes->{{3.435473959828125*^9, 3.435473960734375*^9}, {
   3.435478484125*^9, 3.4354784879375*^9}, 3.43548518171875*^9, {
   3.435485239421875*^9, 3.435485272609375*^9}, {3.435497261046875*^9, 
   3.435497269375*^9}},
 CellTags->"Creating",
 CellLabel->"In[17]:=",
 CellID->64967336],

Cell[BoxData["True"], "Output",
 CellTags->"Creating",
 CellLabel->"Out[20]=",
 CellID->212687526]
}, Open  ]],

Cell[CellGroupData[{

Cell["Ibor Index", "Subsection",
 CellChangeTimes->{{3.435927992568478*^9, 3.435927994693478*^9}},
 CellTags->{"IborIndex", "Creating"},
 CellID->569340876],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"Needs", "[", "\"\<QuantLib`\>\"", "]"}], "\[IndentingNewLine]", 
 RowBox[{"?", "IborIndex"}]}], "Input",
 CellTags->{"IborIndex", "Creating"},
 CellLabel->"In[1]:=",
 CellID->267399379],

Cell[BoxData[
 StyleBox["\<\"IborIndex[ObjecctId_Symbol,FamilyName_String,Tenor_String,\
FixingDays_Integer,Currency_String,BDayConvention_String,EndOfMonth:(True | \
False),DayCounter_String] Construct an object of class IborIndex and return \
its id       \\nObjectId: id of object to be created\\nFamilyName: index \
name.\\nTenor: index tenor (e.g. 2D for two days , 3W for three weeks, 6M for \
six months, 1Y for one year).\\nFixingDays: fixing days (e.g. 2).\\nCurrency: \
Index Currency.\\nCalendar: holiday calendar (e.g. TARGET).\\nBDayConvention: \
business day convention (e.g. Modified Following).\\nEndOfMonth: TRUE if the \
index follow the 'end of month' convention.\\nDayCounter: DayCounter \
ID.\\nYieldCurve: forecasting yield term structure. Default value = \
None.\\nPermanent: object permanent/nonpermanent\"\>", "MSG"]], "Print", \
"PrintUsage",
 CellTags->{"Creating", "IborIndex", "Info3519033068-1550244"},
 CellID->306498587]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"r", " ", "=", " ", "0.04"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"ff", "=", 
   RowBox[{"FlatForward", "[", "r", "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"IborIndex", "[", 
  RowBox[{
  "\"\<Test\>\"", ",", "\"\<2D\>\"", ",", "2", ",", "\"\<USD\>\"", ",", 
   "\"\<Following\>\"", ",", "True", ",", "\"\<30/360\>\"", ",", 
   RowBox[{"YieldCurve", "\[Rule]", " ", "ff"}]}], "]"}]}], "Input",
 CellTags->{"IborIndex", "Creating"},
 CellLabel->"In[6]:=",
 CellID->195145384],

Cell[BoxData["IborIndex10"], "Output",
 CellTags->{"IborIndex", "Creating"},
 CellLabel->"Out[8]=",
 CellID->23833811]
}, Open  ]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Analysing Indices", "Section",
 CellChangeTimes->{{3.4354871780625*^9, 3.43548722434375*^9}},
 CellTags->"Analysing",
 CellID->82944783],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"Needs", "[", "\"\<QuantLib`\>\"", "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"bma", "=", 
   RowBox[{"BMAIndex", "[", 
    RowBox[{"YieldCurve", "\[Rule]", 
     RowBox[{"FlatForward", "[", "0.04", "]"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"IndexName", "[", "bma", "]"}]}], "Input",
 CellTags->"Analysing",
 CellLabel->"In[7]:=",
 CellID->375751064],

Cell[BoxData["\<\"BMA\"\>"], "Output",
 CellTags->"Analysing",
 CellLabel->"Out[9]=",
 CellID->819568143]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"n", " ", "=", "3"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"datelist", " ", "=", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"DatePlus", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"2007", ",", "10", ",", "10"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"i", ",", "\"\<Week\>\""}], "}"}]}], "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"i", ",", "n"}], "}"}]}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"IndexFixing", "[", 
  RowBox[{"bma", ",", "datelist"}], "]"}]}], "Input",
 CellTags->"Analysing",
 CellLabel->"In[11]:=",
 CellID->383620574],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"100.`", ",", "101.`", ",", "102.`"}], "}"}]], "Output",
 CellTags->"Analysing",
 CellLabel->"Out[13]=",
 CellID->447320856]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", "IndexClearFixings"}]], "Input",
 CellChangeTimes->{{3.435487271921875*^9, 3.435487281265625*^9}},
 CellTags->"Analysing",
 CellLabel->"In[27]:=",
 CellID->82200813],

Cell[BoxData[
 StyleBox["\<\"IndexClearFixings[ObjecctId_Symbol] Clear all fixings for the \
given Index object.       \\nObjectId: id of existing QuantLib::Index \
object\"\>", "MSG"]], "Print", "PrintUsage",
 CellChangeTimes->{3.435925391037228*^9},
 CellTags->{"Analysing", "Info3435928990-1438085"},
 CellID->106077422]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"IndexFixing", "[", 
  RowBox[{"bma", ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"2007", ",", "10", ",", "17"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2007", ",", "10", ",", "24"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2007", ",", "10", ",", "31"}], "}"}]}], "}"}]}], 
  "]"}]], "Input",
 CellChangeTimes->{3.43548738503125*^9},
 CellTags->"Analysing",
 CellLabel->"In[14]:=",
 CellID->558159881],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"100.`", ",", "101.`", ",", "102.`"}], "}"}]], "Output",
 CellTags->"Analysing",
 CellLabel->"Out[14]=",
 CellID->202643953]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"IndexFixingCalendar", "[", "bma", "]"}]], "Input",
 CellChangeTimes->{{3.435487316265625*^9, 3.4354873235*^9}},
 CellTags->"Analysing",
 CellLabel->"In[15]:=",
 CellID->365013877],

Cell[BoxData["\<\"New York stock exchange\"\>"], "Output",
 CellTags->"Analysing",
 CellLabel->"Out[15]=",
 CellID->640486157]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"IndexIsValidFixingDate", "[", 
  RowBox[{"bma", ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"2007", ",", "10", ",", "17"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2007", ",", "10", ",", "24"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2007", ",", "10", ",", "31"}], "}"}]}], "}"}]}], 
  "]"}]], "Input",
 CellChangeTimes->{{3.435487346203125*^9, 3.4354873559375*^9}, 
   3.43548739175*^9},
 CellTags->"Analysing",
 CellLabel->"In[16]:=",
 CellID->7377574],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"True", ",", "True", ",", "True"}], "}"}]], "Output",
 CellTags->"Analysing",
 CellLabel->"Out[16]=",
 CellID->184538776]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
InterestRateIndexCurrency, InterestRateIndexDayCounter, \
InterestRateIndexFamilyName, InterestRateIndexFixingDate, \
InterestRateIndexFixingDays, InterestRateIndexMaturity, \
InterestRateIndexTenor, InterestRateIndexValueDate\
\>", "Subsection",
 CellTags->"Analysing",
 CellID->53653811],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"Needs", "[", "\"\<QuantLib`\>\"", "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"bma", "=", 
   RowBox[{"BMAIndex", "[", 
    RowBox[{"YieldCurve", "\[Rule]", 
     RowBox[{"FlatForward", "[", "0.04", "]"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"InterestRateIndexFamilyName", "[", "bma", "]"}]}], "Input",
 CellTags->"Analysing",
 CellLabel->"In[1]:=",
 CellID->231517515],

Cell[BoxData["\<\"BMA\"\>"], "Output",
 CellTags->"Analysing",
 CellLabel->"Out[3]=",
 CellID->30682128]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"InterestRateIndexCurrency", "[", "bma", "]"}]], "Input",
 CellChangeTimes->{{3.435487623953125*^9, 3.43548762503125*^9}},
 CellTags->"Analysing",
 CellLabel->"In[4]:=",
 CellID->93642101],

Cell[BoxData["\<\"USD\"\>"], "Output",
 CellTags->"Analysing",
 CellLabel->"Out[4]=",
 CellID->397411627]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"InterestRateIndexDayCounter", "[", "bma", "]"}]], "Input",
 CellChangeTimes->{{3.435487633546875*^9, 3.4354876371875*^9}},
 CellTags->"Analysing",
 CellLabel->"In[5]:=",
 CellID->40205652],

Cell[BoxData["\<\"Actual/Actual (ISDA)\"\>"], "Output",
 CellTags->"Analysing",
 CellLabel->"Out[5]=",
 CellID->778621303]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"InterestRateIndexFixingDays", "[", "bma", "]"}]], "Input",
 CellChangeTimes->{{3.43548764815625*^9, 3.435487649453125*^9}},
 CellTags->"Analysing",
 CellLabel->"In[6]:=",
 CellID->463662677],

Cell[BoxData["1"], "Output",
 CellTags->"Analysing",
 CellLabel->"Out[6]=",
 CellID->86539319]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"InterestRateIndexTenor", "[", "bma", "]"}]], "Input",
 CellChangeTimes->{{3.435487821671875*^9, 3.4354878286875*^9}},
 CellTags->"Analysing",
 CellLabel->"In[7]:=",
 CellID->422330206],

Cell[BoxData["\<\"1W\"\>"], "Output",
 CellTags->"Analysing",
 CellLabel->"Out[7]=",
 CellID->473757593]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"InterestRateIndexMaturity", "[", 
  RowBox[{"bma", ",", 
   RowBox[{"{", 
    RowBox[{"{", 
     RowBox[{"2008", ",", "10", ",", "10"}], "}"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.43548766321875*^9, 3.4354876703125*^9}, {
  3.43548777871875*^9, 3.43548780371875*^9}},
 CellTags->"Analysing",
 CellLabel->"In[8]:=",
 CellID->269085956],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"{", 
   RowBox[{"2008", ",", "10", ",", "16"}], "}"}], "}"}]], "Output",
 CellTags->"Analysing",
 CellLabel->"Out[8]=",
 CellID->814531561]
}, Open  ]]
}, Open  ]]
}, Open  ]]
}, Open  ]]
},
Editable->True,
WindowToolbars->"EditBar",
WindowSize->{577, 749},
WindowMargins->{{146, Automatic}, {Automatic, 24}},
DockedCells->FEPrivate`FrontEndResource["FEExpressions", "HelpViewerToolbar"],
PageHeaders->{{None, None, None}, {None, None, 
   Cell[
    TextData[{
      Cell[
       TextData[{"Printed from [[YOUR APPLICATION'S NAME]] documentation "}], 
       "PageHeader"], 
      Cell[
       TextData[{
         CounterBox["Page"]}], "PageNumber"]}], 
    CellMargins -> {{Inherited, -29}, {Inherited, Inherited}}]}},
PageFooters->{{None, None, None}, {
   Cell[
    TextData[{"\[Copyright] 2008 Weber & Partner. All rights reserved."}], 
    "PageFooter"], None, None}},
ShowSelection->True,
TaggingRules->{
 "SearchTextTranslated" -> "", "SearchText" -> "", "LinkTrails" -> ""},
CreateCellID->True,
ShowCellTags->False,
FrontEndVersion->"8.0 for Microsoft Windows (32-bit) (February 23, 2011)",
StyleDefinitions->FrontEnd`FileName[{"Wolfram"}, "Reference.nb", 
  CharacterEncoding -> "WindowsANSI"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "Analysing"->{
  Cell[15641, 518, 142, 3, 51, "Section",
   CellTags->"Analysing",
   CellID->82944783],
  Cell[15808, 525, 401, 11, 65, "Input",
   CellTags->"Analysing",
   CellID->375751064],
  Cell[16212, 538, 105, 3, 36, "Output",
   CellTags->"Analysing",
   CellID->819568143],
  Cell[16354, 546, 635, 19, 83, "Input",
   CellTags->"Analysing",
   CellID->383620574],
  Cell[16992, 567, 163, 5, 36, "Output",
   CellTags->"Analysing",
   CellID->447320856],
  Cell[17192, 577, 193, 5, 28, "Input",
   CellTags->"Analysing",
   CellID->82200813],
  Cell[17388, 584, 323, 6, 56, "Print",
   CellTags->{"Analysing", "Info3435928990-1438085"},
   CellID->106077422],
  Cell[17748, 595, 464, 15, 47, "Input",
   CellTags->"Analysing",
   CellID->558159881],
  Cell[18215, 612, 163, 5, 36, "Output",
   CellTags->"Analysing",
   CellID->202643953],
  Cell[18415, 622, 203, 5, 28, "Input",
   CellTags->"Analysing",
   CellID->365013877],
  Cell[18621, 629, 126, 3, 36, "Output",
   CellTags->"Analysing",
   CellID->640486157],
  Cell[18784, 637, 518, 16, 47, "Input",
   CellTags->"Analysing",
   CellID->7377574],
  Cell[19305, 655, 160, 5, 36, "Output",
   CellTags->"Analysing",
   CellID->184538776],
  Cell[19502, 665, 299, 7, 165, "Subsection",
   CellTags->"Analysing",
   CellID->53653811],
  Cell[19826, 676, 419, 11, 65, "Input",
   CellTags->"Analysing",
   CellID->231517515],
  Cell[20248, 689, 104, 3, 36, "Output",
   CellTags->"Analysing",
   CellID->30682128],
  Cell[20389, 697, 211, 5, 28, "Input",
   CellTags->"Analysing",
   CellID->93642101],
  Cell[20603, 704, 105, 3, 36, "Output",
   CellTags->"Analysing",
   CellID->397411627],
  Cell[20745, 712, 212, 5, 28, "Input",
   CellTags->"Analysing",
   CellID->40205652],
  Cell[20960, 719, 122, 3, 36, "Output",
   CellTags->"Analysing",
   CellID->778621303],
  Cell[21119, 727, 214, 5, 28, "Input",
   CellTags->"Analysing",
   CellID->463662677],
  Cell[21336, 734, 94, 3, 36, "Output",
   CellTags->"Analysing",
   CellID->86539319],
  Cell[21467, 742, 208, 5, 28, "Input",
   CellTags->"Analysing",
   CellID->422330206],
  Cell[21678, 749, 104, 3, 36, "Output",
   CellTags->"Analysing",
   CellID->473757593],
  Cell[21819, 757, 370, 10, 28, "Input",
   CellTags->"Analysing",
   CellID->269085956],
  Cell[22192, 769, 179, 6, 36, "Output",
   CellTags->"Analysing",
   CellID->814531561]},
 "Creating"->{
  Cell[2834, 92, 169, 3, 51, "Section",
   CellTags->"Creating",
   CellID->1024089902],
  Cell[3028, 99, 194, 5, 47, "Input",
   CellTags->"Creating",
   CellID->387816073],
  Cell[3225, 106, 387, 7, 101, "Print",
   CellTags->{"Creating", "Info3519032956-1550244"},
   CellID->199144126],
  Cell[3649, 118, 198, 5, 28, "Input",
   CellTags->"Creating",
   CellID->243079049],
  Cell[3850, 125, 273, 8, 36, "Output",
   CellTags->"Creating",
   CellID->350521888],
  Cell[4138, 136, 258, 6, 50, "Text",
   CellTags->"Creating",
   CellID->163165810],
  Cell[4421, 146, 236, 7, 47, "Input",
   CellTags->"Creating",
   CellID->69740319],
  Cell[4660, 155, 105, 3, 36, "Output",
   CellTags->"Creating",
   CellID->476338115],
  Cell[4802, 163, 305, 9, 47, "Input",
   CellTags->"Creating",
   CellID->503115974],
  Cell[5110, 174, 102, 3, 36, "Output",
   CellTags->"Creating",
   CellID->779252348],
  Cell[5237, 181, 121, 2, 42, "Print",
   CellTags->{"Creating", "Info3519032964-1550244"},
   CellID->33651419],
  Cell[5361, 185, 1556, 49, 203, "Print",
   CellTags->{"Creating", "Info3519032964-1550244"},
   CellID->519987697],
  Cell[6966, 240, 264, 6, 47, "Input",
   CellTags->"Creating",
   CellID->264086532],
  Cell[7233, 248, 512, 8, 131, "Print",
   CellTags->{"Creating", "Info3519032973-1550244"},
   CellID->253268559],
  Cell[7748, 258, 161, 5, 36, "Output",
   CellTags->"Creating",
   CellID->102906270],
  Cell[7946, 268, 885, 25, 65, "Input",
   CellTags->"Creating",
   CellID->115479002],
  Cell[8834, 295, 342, 11, 36, "Output",
   CellTags->"Creating",
   CellID->457066305],
  Cell[9179, 308, 156, 5, 36, "Output",
   CellTags->"Creating",
   CellID->601634431],
  Cell[9372, 318, 339, 8, 28, "Input",
   CellTags->"Creating",
   CellID->401941795],
  Cell[9714, 328, 98, 3, 36, "Output",
   CellTags->"Creating",
   CellID->374051137],
  Cell[9849, 336, 193, 5, 28, "Input",
   CellTags->"Creating",
   CellID->224496766],
  Cell[10045, 343, 280, 5, 56, "Print",
   CellTags->{"Creating", "Info3519032985-1550244"},
   CellID->123610667],
  Cell[10362, 353, 200, 5, 28, "Input",
   CellTags->"Creating",
   CellID->2505142],
  Cell[10565, 360, 98, 3, 36, "Output",
   CellTags->"Creating",
   CellID->436515006],
  Cell[10700, 368, 463, 15, 47, "Input",
   CellTags->"Creating",
   CellID->179721022],
  Cell[11166, 385, 653, 14, 19, "Message",
   CellTags->"Creating",
   CellID->255615804],
  Cell[11822, 401, 345, 9, 19, "Message",
   CellTags->"Creating",
   CellID->375084764],
  Cell[12170, 412, 101, 3, 36, "Output",
   CellTags->"Creating",
   CellID->170581934],
  Cell[12308, 420, 1099, 30, 101, "Input",
   CellTags->"Creating",
   CellID->64967336],
  Cell[13410, 452, 98, 3, 36, "Output",
   CellTags->"Creating",
   CellID->212687526],
  Cell[13545, 460, 156, 3, 51, "Subsection",
   CellTags->{"IborIndex", "Creating"},
   CellID->569340876],
  Cell[13726, 467, 210, 5, 47, "Input",
   CellTags->{"IborIndex", "Creating"},
   CellID->267399379],
  Cell[13939, 474, 952, 14, 266, "Print",
   CellTags->{"Creating", "IborIndex", "Info3519033068-1550244"},
   CellID->306498587],
  Cell[14928, 493, 531, 13, 83, "Input",
   CellTags->{"IborIndex", "Creating"},
   CellID->195145384],
  Cell[15462, 508, 118, 3, 36, "Output",
   CellTags->{"IborIndex", "Creating"},
   CellID->23833811]},
 "IborIndex"->{
  Cell[13545, 460, 156, 3, 51, "Subsection",
   CellTags->{"IborIndex", "Creating"},
   CellID->569340876],
  Cell[13726, 467, 210, 5, 47, "Input",
   CellTags->{"IborIndex", "Creating"},
   CellID->267399379],
  Cell[13939, 474, 952, 14, 266, "Print",
   CellTags->{"Creating", "IborIndex", "Info3519033068-1550244"},
   CellID->306498587],
  Cell[14928, 493, 531, 13, 83, "Input",
   CellTags->{"IborIndex", "Creating"},
   CellID->195145384],
  Cell[15462, 508, 118, 3, 36, "Output",
   CellTags->{"IborIndex", "Creating"},
   CellID->23833811]},
 "Info3435928990-1438085"->{
  Cell[17388, 584, 323, 6, 56, "Print",
   CellTags->{"Analysing", "Info3435928990-1438085"},
   CellID->106077422]},
 "Info3519032956-1550244"->{
  Cell[3225, 106, 387, 7, 101, "Print",
   CellTags->{"Creating", "Info3519032956-1550244"},
   CellID->199144126]},
 "Info3519032964-1550244"->{
  Cell[5237, 181, 121, 2, 42, "Print",
   CellTags->{"Creating", "Info3519032964-1550244"},
   CellID->33651419],
  Cell[5361, 185, 1556, 49, 203, "Print",
   CellTags->{"Creating", "Info3519032964-1550244"},
   CellID->519987697]},
 "Info3519032973-1550244"->{
  Cell[7233, 248, 512, 8, 131, "Print",
   CellTags->{"Creating", "Info3519032973-1550244"},
   CellID->253268559]},
 "Info3519032985-1550244"->{
  Cell[10045, 343, 280, 5, 56, "Print",
   CellTags->{"Creating", "Info3519032985-1550244"},
   CellID->123610667]},
 "Info3519033068-1550244"->{
  Cell[13939, 474, 952, 14, 266, "Print",
   CellTags->{"Creating", "IborIndex", "Info3519033068-1550244"},
   CellID->306498587]},
 "Overview"->{
  Cell[567, 22, 466, 8, 85, "Chapter",
   CellTags->"Overview",
   CellID->374938163],
  Cell[1036, 32, 140, 4, 28, "Input",
   CellTags->"Overview",
   CellID->200097591],
  Cell[1201, 40, 317, 9, 28, "Input",
   CellTags->"Overview",
   CellID->155963278],
  Cell[1521, 51, 228, 7, 36, "Output",
   CellTags->"Overview",
   CellID->278963300],
  Cell[1786, 63, 312, 9, 28, "Input",
   CellTags->"Overview",
   CellID->506165459],
  Cell[2101, 74, 696, 13, 156, "Output",
   CellTags->"Overview",
   CellID->263684095]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"Analysing", 23550, 814},
 {"Creating", 25923, 893},
 {"IborIndex", 29266, 999},
 {"Info3435928990-1438085", 29845, 1015},
 {"Info3519032956-1550244", 29992, 1019},
 {"Info3519032964-1550244", 30138, 1023},
 {"Info3519032973-1550244", 30400, 1030},
 {"Info3519032985-1550244", 30546, 1034},
 {"Info3519033068-1550244", 30692, 1038},
 {"Overview", 30839, 1042}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[567, 22, 466, 8, 85, "Chapter",
 CellTags->"Overview",
 CellID->374938163],
Cell[1036, 32, 140, 4, 28, "Input",
 CellTags->"Overview",
 CellID->200097591],
Cell[CellGroupData[{
Cell[1201, 40, 317, 9, 28, "Input",
 CellTags->"Overview",
 CellID->155963278],
Cell[1521, 51, 228, 7, 36, "Output",
 CellTags->"Overview",
 CellID->278963300]
}, Open  ]],
Cell[CellGroupData[{
Cell[1786, 63, 312, 9, 28, "Input",
 CellTags->"Overview",
 CellID->506165459],
Cell[2101, 74, 696, 13, 156, "Output",
 CellTags->"Overview",
 CellID->263684095]
}, Open  ]],
Cell[CellGroupData[{
Cell[2834, 92, 169, 3, 51, "Section",
 CellTags->"Creating",
 CellID->1024089902],
Cell[CellGroupData[{
Cell[3028, 99, 194, 5, 47, "Input",
 CellTags->"Creating",
 CellID->387816073],
Cell[3225, 106, 387, 7, 101, "Print",
 CellTags->{"Creating", "Info3519032956-1550244"},
 CellID->199144126]
}, Open  ]],
Cell[CellGroupData[{
Cell[3649, 118, 198, 5, 28, "Input",
 CellTags->"Creating",
 CellID->243079049],
Cell[3850, 125, 273, 8, 36, "Output",
 CellTags->"Creating",
 CellID->350521888]
}, Open  ]],
Cell[4138, 136, 258, 6, 50, "Text",
 CellTags->"Creating",
 CellID->163165810],
Cell[CellGroupData[{
Cell[4421, 146, 236, 7, 47, "Input",
 CellTags->"Creating",
 CellID->69740319],
Cell[4660, 155, 105, 3, 36, "Output",
 CellTags->"Creating",
 CellID->476338115]
}, Open  ]],
Cell[CellGroupData[{
Cell[4802, 163, 305, 9, 47, "Input",
 CellTags->"Creating",
 CellID->503115974],
Cell[5110, 174, 102, 3, 36, "Output",
 CellTags->"Creating",
 CellID->779252348],
Cell[CellGroupData[{
Cell[5237, 181, 121, 2, 42, "Print",
 CellTags->{"Creating", "Info3519032964-1550244"},
 CellID->33651419],
Cell[5361, 185, 1556, 49, 203, "Print",
 CellTags->{"Creating", "Info3519032964-1550244"},
 CellID->519987697]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[6966, 240, 264, 6, 47, "Input",
 CellTags->"Creating",
 CellID->264086532],
Cell[7233, 248, 512, 8, 131, "Print",
 CellTags->{"Creating", "Info3519032973-1550244"},
 CellID->253268559],
Cell[7748, 258, 161, 5, 36, "Output",
 CellTags->"Creating",
 CellID->102906270]
}, Open  ]],
Cell[CellGroupData[{
Cell[7946, 268, 885, 25, 65, "Input",
 CellTags->"Creating",
 CellID->115479002],
Cell[8834, 295, 342, 11, 36, "Output",
 CellTags->"Creating",
 CellID->457066305],
Cell[9179, 308, 156, 5, 36, "Output",
 CellTags->"Creating",
 CellID->601634431]
}, Open  ]],
Cell[CellGroupData[{
Cell[9372, 318, 339, 8, 28, "Input",
 CellTags->"Creating",
 CellID->401941795],
Cell[9714, 328, 98, 3, 36, "Output",
 CellTags->"Creating",
 CellID->374051137]
}, Open  ]],
Cell[CellGroupData[{
Cell[9849, 336, 193, 5, 28, "Input",
 CellTags->"Creating",
 CellID->224496766],
Cell[10045, 343, 280, 5, 56, "Print",
 CellTags->{"Creating", "Info3519032985-1550244"},
 CellID->123610667]
}, Open  ]],
Cell[CellGroupData[{
Cell[10362, 353, 200, 5, 28, "Input",
 CellTags->"Creating",
 CellID->2505142],
Cell[10565, 360, 98, 3, 36, "Output",
 CellTags->"Creating",
 CellID->436515006]
}, Open  ]],
Cell[CellGroupData[{
Cell[10700, 368, 463, 15, 47, "Input",
 CellTags->"Creating",
 CellID->179721022],
Cell[11166, 385, 653, 14, 19, "Message",
 CellTags->"Creating",
 CellID->255615804],
Cell[11822, 401, 345, 9, 19, "Message",
 CellTags->"Creating",
 CellID->375084764],
Cell[12170, 412, 101, 3, 36, "Output",
 CellTags->"Creating",
 CellID->170581934]
}, Open  ]],
Cell[CellGroupData[{
Cell[12308, 420, 1099, 30, 101, "Input",
 CellTags->"Creating",
 CellID->64967336],
Cell[13410, 452, 98, 3, 36, "Output",
 CellTags->"Creating",
 CellID->212687526]
}, Open  ]],
Cell[CellGroupData[{
Cell[13545, 460, 156, 3, 51, "Subsection",
 CellTags->{"IborIndex", "Creating"},
 CellID->569340876],
Cell[CellGroupData[{
Cell[13726, 467, 210, 5, 47, "Input",
 CellTags->{"IborIndex", "Creating"},
 CellID->267399379],
Cell[13939, 474, 952, 14, 266, "Print",
 CellTags->{"Creating", "IborIndex", "Info3519033068-1550244"},
 CellID->306498587]
}, Open  ]],
Cell[CellGroupData[{
Cell[14928, 493, 531, 13, 83, "Input",
 CellTags->{"IborIndex", "Creating"},
 CellID->195145384],
Cell[15462, 508, 118, 3, 36, "Output",
 CellTags->{"IborIndex", "Creating"},
 CellID->23833811]
}, Open  ]]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[15641, 518, 142, 3, 51, "Section",
 CellTags->"Analysing",
 CellID->82944783],
Cell[CellGroupData[{
Cell[15808, 525, 401, 11, 65, "Input",
 CellTags->"Analysing",
 CellID->375751064],
Cell[16212, 538, 105, 3, 36, "Output",
 CellTags->"Analysing",
 CellID->819568143]
}, Open  ]],
Cell[CellGroupData[{
Cell[16354, 546, 635, 19, 83, "Input",
 CellTags->"Analysing",
 CellID->383620574],
Cell[16992, 567, 163, 5, 36, "Output",
 CellTags->"Analysing",
 CellID->447320856]
}, Open  ]],
Cell[CellGroupData[{
Cell[17192, 577, 193, 5, 28, "Input",
 CellTags->"Analysing",
 CellID->82200813],
Cell[17388, 584, 323, 6, 56, "Print",
 CellTags->{"Analysing", "Info3435928990-1438085"},
 CellID->106077422]
}, Open  ]],
Cell[CellGroupData[{
Cell[17748, 595, 464, 15, 47, "Input",
 CellTags->"Analysing",
 CellID->558159881],
Cell[18215, 612, 163, 5, 36, "Output",
 CellTags->"Analysing",
 CellID->202643953]
}, Open  ]],
Cell[CellGroupData[{
Cell[18415, 622, 203, 5, 28, "Input",
 CellTags->"Analysing",
 CellID->365013877],
Cell[18621, 629, 126, 3, 36, "Output",
 CellTags->"Analysing",
 CellID->640486157]
}, Open  ]],
Cell[CellGroupData[{
Cell[18784, 637, 518, 16, 47, "Input",
 CellTags->"Analysing",
 CellID->7377574],
Cell[19305, 655, 160, 5, 36, "Output",
 CellTags->"Analysing",
 CellID->184538776]
}, Open  ]],
Cell[CellGroupData[{
Cell[19502, 665, 299, 7, 165, "Subsection",
 CellTags->"Analysing",
 CellID->53653811],
Cell[CellGroupData[{
Cell[19826, 676, 419, 11, 65, "Input",
 CellTags->"Analysing",
 CellID->231517515],
Cell[20248, 689, 104, 3, 36, "Output",
 CellTags->"Analysing",
 CellID->30682128]
}, Open  ]],
Cell[CellGroupData[{
Cell[20389, 697, 211, 5, 28, "Input",
 CellTags->"Analysing",
 CellID->93642101],
Cell[20603, 704, 105, 3, 36, "Output",
 CellTags->"Analysing",
 CellID->397411627]
}, Open  ]],
Cell[CellGroupData[{
Cell[20745, 712, 212, 5, 28, "Input",
 CellTags->"Analysing",
 CellID->40205652],
Cell[20960, 719, 122, 3, 36, "Output",
 CellTags->"Analysing",
 CellID->778621303]
}, Open  ]],
Cell[CellGroupData[{
Cell[21119, 727, 214, 5, 28, "Input",
 CellTags->"Analysing",
 CellID->463662677],
Cell[21336, 734, 94, 3, 36, "Output",
 CellTags->"Analysing",
 CellID->86539319]
}, Open  ]],
Cell[CellGroupData[{
Cell[21467, 742, 208, 5, 28, "Input",
 CellTags->"Analysing",
 CellID->422330206],
Cell[21678, 749, 104, 3, 36, "Output",
 CellTags->"Analysing",
 CellID->473757593]
}, Open  ]],
Cell[CellGroupData[{
Cell[21819, 757, 370, 10, 28, "Input",
 CellTags->"Analysing",
 CellID->269085956],
Cell[22192, 769, 179, 6, 36, "Output",
 CellTags->"Analysing",
 CellID->814531561]
}, Open  ]]
}, Open  ]]
}, Open  ]]
}, Open  ]]
}
]
*)

(* End of internal cache information *)
