(* Content-type: application/mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 6.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       145,          7]
NotebookDataLength[      9077,        359]
NotebookOptionsPosition[      4169,        174]
NotebookOutlinePosition[      7153,        279]
CellTagsIndexPosition[      7059,        273]
WindowFrame->Normal
ContainsDynamic->False*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell[BoxData["Instruments"], "Chapter",
 CellTags->"Overview",
 CellID->5636728],

Cell["functions to construct and use Instrument objects.", "Text",
 CellTags->"Overview",
 CellID->265220437],

Cell["The first step is to load the QuantLib package. ", "MathCaption",
 CellTags->"Overview",
 CellID->152218978],

Cell["Needs[\"QuantLib`\"]", "Input",
 CellTags->"Overview",
 CellID->12228118],

Cell["\<\
Within the Instruments part there are no constructors but several functions \
available \
\>", "Text",
 CellChangeTimes->{{3.436078940328125*^9, 3.436078954109375*^9}},
 CellTags->"Overview",
 CellID->138763378],

Cell[CellGroupData[{

Cell["Select[Category[Instruments],QLConstructor[#]&]", "Input",
 CellTags->"Overview",
 CellLabel->"In[842]:=",
 CellID->868520401],

Cell[BoxData[
 RowBox[{"{", "}"}]], "Output",
 CellChangeTimes->{3.4360789281875*^9},
 CellTags->"Overview",
 CellLabel->"Out[842]=",
 CellID->598388393]
}, Open  ]],

Cell[CellGroupData[{

Cell["Select[Category[Instruments],QLMember[#]&]", "Input",
 CellTags->"Overview",
 CellLabel->"In[843]:=",
 CellID->146882960],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "InstrumentErrorEstimate", ",", "InstrumentIsExpired", ",", "InstrumentNPV",
    ",", "InstrumentResults", ",", "InstrumentSetPricingEngine"}], 
  "}"}]], "Output",
 CellChangeTimes->{3.436078929890625*^9},
 CellTags->"Overview",
 CellLabel->"Out[843]=",
 CellID->149004684]
}, Open  ]],

Cell[CellGroupData[{

Cell["InstrumentNPV", "Subsection",
 CellTags->"Member",
 CellID->32772310],

Cell["InstrumentNPV[obj]", "Input",
 CellTags->"Member",
 CellID->16606438]
}, Open  ]],

Cell[CellGroupData[{

Cell["InstrumentResults", "Subsection",
 CellTags->"Member",
 CellID->273974934],

Cell[BoxData[{Cell[BoxData[GridBox[{
    {"ResultType", "vega", 
     RowBox[{"result", " ", "type", " ", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{"e", ".", "g", ".", " ", "'"}], 
         RowBox[{"vega", "'"}]}], ")"}], "."}]}]}
   }]], "DefinitionBox3Col",
  CellTags->"Member"], "\n", Cell["Calling Parameters", "Caption"]}], "Input",\

 CellID->397042631],

Cell[BoxData[
 RowBox[{
  RowBox[{"ResultType", "=", "\"\<vega\>\""}], ";"}]], "Input",
 CellChangeTimes->{{3.436078974578125*^9, 3.436078975890625*^9}},
 CellTags->"Member",
 CellID->685845934],

Cell["InstrumentResults[obj,ResultType]", "Input",
 CellChangeTimes->{3.43607898725*^9},
 CellTags->"Member",
 CellID->4059351]
}, Open  ]],

Cell[CellGroupData[{

Cell["InstrumentErrorEstimate", "Subsection",
 CellTags->"Member",
 CellID->51626480],

Cell["InstrumentErrorEstimate[obj]", "Input",
 CellTags->"Member",
 CellID->2766755]
}, Open  ]],

Cell[CellGroupData[{

Cell["InstrumentIsExpired", "Subsection",
 CellTags->"Member",
 CellID->314083993],

Cell["InstrumentIsExpired[obj]", "Input",
 CellTags->"Member",
 CellID->549767669]
}, Open  ]],

Cell[CellGroupData[{

Cell["InstrumentSetPricingEngine", "Subsection",
 CellTags->"Member",
 CellID->250347999],

Cell[BoxData[{Cell[BoxData[GridBox[{
    {"PricingEngine", "PricingEngineID", 
     RowBox[{"PricingEngine", " ", "object", " ", 
      RowBox[{"ID", "."}]}]}
   }]], "DefinitionBox3Col",
  CellTags->"Member"], "\n", Cell["Calling Parameters", "Caption"]}], "Input",\

 CellID->17423461],

Cell[BoxData[
 RowBox[{
  RowBox[{"PricingEngine", "=", "PricingEngineID"}], ";"}]], "Input",
 CellTags->"Member",
 CellID->785061738],

Cell["InstrumentSetPricingEngine[obj,PricingEngine]", "Input",
 CellChangeTimes->{3.436078996421875*^9},
 CellTags->"Member",
 CellID->210277408]
}, Open  ]]
}, Open  ]]
},
Editable->True,
WindowSize->{616, 750},
WindowMargins->{{Automatic, 501}, {58, Automatic}},
DockedCells->FEPrivate`FrontEndResource[
 "FEExpressions", "HelpViewerToolbar"],
PageHeaders->{{None, None, None}, {None, None, 
   Cell[
    TextData[{
      Cell[
       TextData[{"Printed from [[YOUR APPLICATION'S NAME]] documentation "}], 
       "PageHeader"], 
      Cell[
       TextData[{
         CounterBox["Page"]}], "PageNumber"]}], 
    CellMargins -> {{Inherited, -29}, {Inherited, Inherited}}]}},
PageFooters->{{None, None, None}, {
   Cell[
    TextData[{"\[Copyright] 2008 Weber & Partner. All rights reserved."}], 
    "PageFooter"], None, None}},
TaggingRules->{"SearchTextTranslated" -> "", "SearchText" -> ""},
CreateCellID->True,
ShowCellTags->False,
FrontEndVersion->"6.0 for Microsoft Windows (32-bit) (May 21, 2008)",
StyleDefinitions->FrontEnd`FileName[{"Wolfram"}, "Reference.nb", 
  CharacterEncoding -> "WindowsANSI"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "Overview"->{
  Cell[590, 23, 80, 2, 99, "Chapter",
   CellTags->"Overview",
   CellID->5636728],
  Cell[673, 27, 109, 2, 37, "Text",
   CellTags->"Overview",
   CellID->265220437],
  Cell[785, 31, 114, 2, 53, "MathCaption",
   CellTags->"Overview",
   CellID->152218978],
  Cell[902, 35, 79, 2, 41, "Input",
   CellTags->"Overview",
   CellID->12228118],
  Cell[984, 39, 221, 6, 50, "Text",
   CellTags->"Overview",
   CellID->138763378],
  Cell[1230, 49, 132, 3, 28, "Input",
   CellTags->"Overview",
   CellID->868520401],
  Cell[1365, 54, 153, 5, 36, "Output",
   CellTags->"Overview",
   CellID->598388393],
  Cell[1555, 64, 127, 3, 28, "Input",
   CellTags->"Overview",
   CellID->146882960],
  Cell[1685, 69, 316, 9, 54, "Output",
   CellTags->"Overview",
   CellID->149004684]},
 "Member"->{
  Cell[2038, 83, 75, 2, 51, "Subsection",
   CellTags->"Member",
   CellID->32772310],
  Cell[2116, 87, 75, 2, 28, "Input",
   CellTags->"Member",
   CellID->16606438],
  Cell[2228, 94, 80, 2, 51, "Subsection",
   CellTags->"Member",
   CellID->273974934],
  Cell[2703, 111, 194, 5, 28, "Input",
   CellTags->"Member",
   CellID->685845934],
  Cell[2900, 118, 127, 3, 28, "Input",
   CellTags->"Member",
   CellID->4059351],
  Cell[3064, 126, 85, 2, 51, "Subsection",
   CellTags->"Member",
   CellID->51626480],
  Cell[3152, 130, 84, 2, 28, "Input",
   CellTags->"Member",
   CellID->2766755],
  Cell[3273, 137, 82, 2, 51, "Subsection",
   CellTags->"Member",
   CellID->314083993],
  Cell[3358, 141, 82, 2, 28, "Input",
   CellTags->"Member",
   CellID->549767669],
  Cell[3477, 148, 89, 2, 51, "Subsection",
   CellTags->"Member",
   CellID->250347999],
  Cell[3859, 161, 134, 4, 28, "Input",
   CellTags->"Member",
   CellID->785061738],
  Cell[3996, 167, 145, 3, 28, "Input",
   CellTags->"Member",
   CellID->210277408]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"Overview", 5222, 205},
 {"Member", 6008, 233}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[590, 23, 80, 2, 99, "Chapter",
 CellTags->"Overview",
 CellID->5636728],
Cell[673, 27, 109, 2, 37, "Text",
 CellTags->"Overview",
 CellID->265220437],
Cell[785, 31, 114, 2, 53, "MathCaption",
 CellTags->"Overview",
 CellID->152218978],
Cell[902, 35, 79, 2, 41, "Input",
 CellTags->"Overview",
 CellID->12228118],
Cell[984, 39, 221, 6, 50, "Text",
 CellTags->"Overview",
 CellID->138763378],
Cell[CellGroupData[{
Cell[1230, 49, 132, 3, 28, "Input",
 CellTags->"Overview",
 CellID->868520401],
Cell[1365, 54, 153, 5, 36, "Output",
 CellTags->"Overview",
 CellID->598388393]
}, Open  ]],
Cell[CellGroupData[{
Cell[1555, 64, 127, 3, 28, "Input",
 CellTags->"Overview",
 CellID->146882960],
Cell[1685, 69, 316, 9, 54, "Output",
 CellTags->"Overview",
 CellID->149004684]
}, Open  ]],
Cell[CellGroupData[{
Cell[2038, 83, 75, 2, 51, "Subsection",
 CellTags->"Member",
 CellID->32772310],
Cell[2116, 87, 75, 2, 28, "Input",
 CellTags->"Member",
 CellID->16606438]
}, Open  ]],
Cell[CellGroupData[{
Cell[2228, 94, 80, 2, 51, "Subsection",
 CellTags->"Member",
 CellID->273974934],
Cell[2311, 98, 389, 11, 65, "Input",
 CellID->397042631],
Cell[2703, 111, 194, 5, 28, "Input",
 CellTags->"Member",
 CellID->685845934],
Cell[2900, 118, 127, 3, 28, "Input",
 CellTags->"Member",
 CellID->4059351]
}, Open  ]],
Cell[CellGroupData[{
Cell[3064, 126, 85, 2, 51, "Subsection",
 CellTags->"Member",
 CellID->51626480],
Cell[3152, 130, 84, 2, 28, "Input",
 CellTags->"Member",
 CellID->2766755]
}, Open  ]],
Cell[CellGroupData[{
Cell[3273, 137, 82, 2, 51, "Subsection",
 CellTags->"Member",
 CellID->314083993],
Cell[3358, 141, 82, 2, 28, "Input",
 CellTags->"Member",
 CellID->549767669]
}, Open  ]],
Cell[CellGroupData[{
Cell[3477, 148, 89, 2, 51, "Subsection",
 CellTags->"Member",
 CellID->250347999],
Cell[3569, 152, 287, 7, 82, "Input",
 CellID->17423461],
Cell[3859, 161, 134, 4, 28, "Input",
 CellTags->"Member",
 CellID->785061738],
Cell[3996, 167, 145, 3, 28, "Input",
 CellTags->"Member",
 CellID->210277408]
}, Open  ]]
}, Open  ]]
}
]
*)

(* End of internal cache information *)
