(* Content-type: application/mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 6.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       145,          7]
NotebookDataLength[     61308,       1899]
NotebookOptionsPosition[     48202,       1431]
NotebookOutlinePosition[     52781,       1569]
CellTagsIndexPosition[     51981,       1547]
WindowFrame->Normal
ContainsDynamic->False*)

(* Beginning of Notebook Content *)
Notebook[{
Cell["QuantLib", "Subtitle",
 CellChangeTimes->{{3.434947043421875*^9, 3.434947050171875*^9}},
 CellID->140484240],

Cell[CellGroupData[{

Cell["Math", "Title",
 CellChangeTimes->{{3.43494703740625*^9, 3.43494703928125*^9}, 
   3.434951659765625*^9, 3.43503746765625*^9, {3.43505093046875*^9, 
   3.435050931109375*^9}},
 CellID->1579529],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Category", "[", "Math", "]"}]], "Input",
 CellChangeTimes->{
  3.4350374865*^9, {3.43505093621875*^9, 3.43505093909375*^9}},
 CellID->174546348],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "CholeskyDecomposition", ",", "CovarianceDecomposition", ",", 
   "CovarianceDecompositionCorrelationMatrix", ",", 
   "CovarianceDecompositionStandardDeviations", ",", 
   "CovarianceDecompositionVariances", ",", "GetCovariance", ",", "NormDist", 
   ",", "NormInv", ",", "NormSDist", ",", "NormSInv", ",", "PrimeNumber", ",",
    "PseudoSqrt", ",", "RankReducedSqrt", ",", "SymmetricSchurDecomposition", 
   ",", "SymmetricSchurDecompositionEigenvalues", ",", 
   "SymmetricSchurDecompositionEigenvectors"}], "}"}]], "Output",
 CellChangeTimes->{3.43503748790625*^9, 3.4350415943125*^9, 
  3.435043991453125*^9, 3.435045711375*^9, 3.4350488741875*^9, 
  3.435048959234375*^9, 3.43504960696875*^9, 3.43504997275*^9, 
  3.435050939796875*^9, 3.43505594228125*^9, 3.435065416578125*^9, 
  3.4353020065625*^9, 3.435302483234375*^9, 3.43530309475*^9, 
  3.43530317621875*^9, 3.435303654796875*^9, 3.435303822140625*^9, 
  3.435304120640625*^9, 3.4353044170625*^9, 3.435305848578125*^9, 
  3.43530709078125*^9, 3.435651581109375*^9},
 CellID->217079336]
}, Open  ]],

Cell[CellGroupData[{

Cell["NormDist, NormInv, NormSDist and NormSInv", "Subsection",
 CellChangeTimes->{{3.4353061480625*^9, 3.435306176453125*^9}},
 CellID->197908043],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", "NormDist"}]], "Input",
 CellChangeTimes->{{3.435055957*^9, 3.435055961609375*^9}},
 CellID->237084469],

Cell[BoxData[
 StyleBox["\<\"NormDist[X_?NumberQ] Returns the normal cumulative \
distribution for the specified mean and standard deviation.       \\nX: is \
the value for which you want the distribution.\\nMean: is the arithmetic mean \
of the distribution. Default value = 0.0.\\nStandarddev: is the standard \
deviation of the distribution, a positive number. Default value = \
1.0.\\nCumulative: is a logical value: for the cumulative distribution \
function, use TRUE; for the probability mass function, use FALSE. Default \
value = TRUE.\"\>", "MSG"]], "Print", "PrintUsage",
 CellChangeTimes->{3.435651581234375*^9},
 CellTags->"Info3435655181-5000948",
 CellID->160762845]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Options", "[", "NormDist", "]"}]], "Input",
 CellChangeTimes->{{3.4350559650625*^9, 3.43505597775*^9}},
 CellID->175065542],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"Mean", "\[Rule]", "1.`*^12"}], ",", 
   RowBox[{"Standarddev", "\[Rule]", "1.`*^12"}], ",", 
   RowBox[{"Cumulative", "\[Rule]", "True"}]}], "}"}]], "Output",
 CellChangeTimes->{3.43505597846875*^9, 3.4350654191875*^9, 
  3.4353017818125*^9, 3.4353020144375*^9, 3.43530248584375*^9, 
  3.435303096765625*^9, 3.43530317815625*^9, 3.435303656484375*^9, 
  3.43530382434375*^9, 3.435304122765625*^9, 3.4353044198125*^9, 
  3.43530585046875*^9, 3.4356515813125*^9},
 CellID->471086015]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"x", " ", "=", 
  RowBox[{"NormDist", "[", ".3", "]"}]}]], "Input",
 CellChangeTimes->{{3.435055985*^9, 3.435055991640625*^9}, {
  3.435302593421875*^9, 3.435302594046875*^9}},
 CellID->140879761],

Cell[BoxData["2.4197072451921595`*^-13"], "Output",
 CellChangeTimes->{3.435301782828125*^9, 3.435302488265625*^9, 
  3.435302594640625*^9, 3.4353030979375*^9, 3.435303179140625*^9, 
  3.435303657296875*^9, 3.435303825328125*^9, 3.43530414146875*^9, 
  3.4353044211875*^9, 3.4353058513125*^9, 3.43565158134375*^9},
 CellID->179461327]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Plot", "[", 
  RowBox[{
   RowBox[{"NormDist", "[", 
    RowBox[{"x", ",", 
     RowBox[{"Cumulative", "\[Rule]", "True"}]}], "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"x", ",", 
     RowBox[{"-", "3"}], ",", "3"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.435302515984375*^9, 3.435302530796875*^9}, {
  3.4353027175625*^9, 3.435302731953125*^9}},
 CellID->711241048],

Cell[BoxData[
 GraphicsBox[{{}, {}, 
   {Hue[0.67, 0.6, 0.6], LineBox[CompressedData["
1:eJxN1H8s1HEYB/A7ufuUsDZdm9OE22nY+jWVUX2++qFfZxxXXYucXAiXaoZq
tHRFQnaTQuiHOD+ikLGmz1dKidKwSvplpSUpkziXo2vPZ+WPZ89e/72fPc8e
+33RfvtNOBzOZmP97SFVmT+mpxEr3N7F/cWXrp3/W+joMYlYEfUDrxsBsTrE
ulA7vmto/TaM2HXUX80/Xu/pQ2ww9aGIlfKaZsSWUCeKX7OhyYh1lYBz80Sa
p5aI9fEGF75PiZbO4bPVPuAFz/19nAQ89rsU/NjXf2Ob2JS1lYG3OIljRA6z
2MSdYPfKgOKOpSbsHTlYnxpqtcKJyy7cA/41XnRh72IOGxdI53HQuN5TTZGy
ILAH70SNi3KSmO8DZzGrV3sm6MkmJTjksrz/a6GOxISCO0ps53Bzx0hnONjW
/NZyUjdKUCTYzO5zx0DZCFGpwFGy05e02mHSEg1WNL9vs9UMEd1hsMPaKenD
kwNEHgMuDa/pu1vXTzJjwRE/bwecy+0junjwkkTebr6ol8iOg62Ods/Nzusi
KQngl8oo56qPLWTwBDjumHNG64VK4pgELjvvxhQtu4l3qMEZB06+UCQ9wrVn
wBajEo8KaRceTAF/iGlxjVX3Yt9z4O8N3vfjHvfhinRwcfJVhfJsP357Hiwe
K7eKzxvAWAN+V72o0SN8CMdngXdc/JAymDmMS7LBBTfSGiXZI5iXAzbdoxri
HR3F7nngZ4rSEj/1GM7PB9+xEAaOR+lwTyG9x1z7L0iix2bX6P5j1YZy/0kc
UQQe1NtYat2m8NVi8JWw5G4bEYeZXQrO9GxPsxZzGWU52DK6fH2zwIS5eBN8
b2N9Y51wFjNRBTaoglbttDRlXKvBXNSZ42IwZUJqwau2HLm/jcNnmuponjcV
XwQjfGa8HvzDWtDtrENM4F2wV1e7WGv0XuqCNHWceOK/JdM/hXZ6xARTl37q
DBZMImY/tayp0kw2w5yC1BqN0aHU8l3refMMiAmj5j+5rTWbQkwEdXVxunSr
0ZHUgacO6JNnuHaNvYQ3jZgoaoW1YXSD0Spq87FX+UkzXN9Z69Vk9EFq+l/+
+Q+yAQlK
     "]]}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->True,
  AxesOrigin->{0, 2.4197072451840003`*^-13},
  PlotRange->{{-3, 3}, {2.4197072451841745`*^-13, 2.4197072451986926`*^-13}},
  PlotRangeClipping->True,
  PlotRangePadding->{
    Scaled[0.02], 
    Scaled[0.02]}]], "Output",
 CellChangeTimes->{
  3.435302533046875*^9, {3.43530272325*^9, 3.435302732671875*^9}, 
   3.435303098765625*^9, 3.435303180265625*^9, 3.43530365825*^9, 
   3.435303826328125*^9, 3.435304422625*^9, 3.435305852125*^9, 
   3.43565158178125*^9},
 CellID->427442645]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", "NormInv"}]], "Input",
 CellChangeTimes->{
  3.43530250815625*^9, {3.43530256171875*^9, 3.435302562859375*^9}},
 CellID->357008171],

Cell[BoxData[
 StyleBox["\<\"NormInv[Probability_?NumberQ] Returns the inverse of the \
normal cumulative distribution for the specified mean and standard deviation. \
      \\nProbability: is a probability corresponding to the normal \
distribution, a number between 0 and 1 inclusive.\\nMean: is the arithmetic \
mean of the distribution. Default value = 0.0.\\nStandarddev: is the standard \
deviation of the distribution, a positive number. Default value = 1.0.\"\>", 
  "MSG"]], "Print", "PrintUsage",
 CellChangeTimes->{3.43565158190625*^9},
 CellTags->"Info3435655181-4333920",
 CellID->273885187]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"NormInv", "[", "x", "]"}]], "Input",
 CellChangeTimes->{{3.435302572515625*^9, 3.43530259846875*^9}},
 CellID->711252928],

Cell[BoxData[
 RowBox[{"-", "6.22973385966727`*^12"}]], "Output",
 CellChangeTimes->{{3.4353025776875*^9, 3.435302599*^9}, 3.435303100796875*^9,
    3.435303182359375*^9, 3.43530366015625*^9, 3.435303828609375*^9, 
   3.43530442528125*^9, 3.435305853921875*^9, 3.435651581984375*^9},
 CellID->66017870]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", "NormSDist"}]], "Input",
 CellChangeTimes->{{3.43530262234375*^9, 3.435302626265625*^9}},
 CellID->30440349],

Cell[BoxData[
 StyleBox["\<\"NormSDist[Z_?NumberQ] Returns the standard normal cumulative \
distribution (has a mean of zero and standard deviation of one).       \\nZ: \
is the value for which you want the distribution.\"\>", "MSG"]], "Print", \
"PrintUsage",
 CellChangeTimes->{3.435651582109375*^9},
 CellTags->"Info3435655182-1903207",
 CellID->424979121]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"NormSDist", "[", "0.3", "]"}]], "Input",
 CellChangeTimes->{{3.43530264015625*^9, 3.435302647015625*^9}},
 CellID->205052286],

Cell[BoxData["0.6179114221889527`"], "Output",
 CellChangeTimes->{3.43530264815625*^9, 3.43530310378125*^9, 
  3.435303184109375*^9, 3.435303664015625*^9, 3.435303832140625*^9, 
  3.4353044271875*^9, 3.4353058555*^9, 3.43565158225*^9},
 CellID->30606803]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Plot", "[", 
  RowBox[{
   RowBox[{"NormSDist", "[", "x", "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"x", ",", 
     RowBox[{"-", "3"}], ",", "3"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.4353026713125*^9, 3.43530268609375*^9}},
 CellID->108440766],

Cell[BoxData[
 GraphicsBox[{{}, {}, 
   {Hue[0.67, 0.6, 0.6], LineBox[CompressedData["
1:eJwt2Hk0lN8fB/AZs1iKypIoFIlKpSJJfC5JpU0lLSRblkiRfd8p25Syk61Q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     "]]}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->True,
  AxesOrigin->{0, 0},
  PlotRange->{{-3, 3}, {0., 0.9986501014256945}},
  PlotRangeClipping->True,
  PlotRangePadding->{
    Scaled[0.02], 
    Scaled[0.02]}]], "Output",
 CellChangeTimes->{3.435302687703125*^9, 3.4353031085*^9, 
  3.435303185078125*^9, 3.435303665*^9, 3.435303833109375*^9, 
  3.435304428125*^9, 3.435305856453125*^9, 3.435651582390625*^9},
 CellID->294735206]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"NormSInv", "[", "x", "]"}]], "Input",
 CellChangeTimes->{{3.435306189546875*^9, 3.435306190890625*^9}},
 CellID->376573554],

Cell[BoxData[
 RowBox[{"-", "7.229733859667269`"}]], "Output",
 CellChangeTimes->{3.43530619153125*^9, 3.435651582421875*^9},
 CellID->692554235]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["PrimeNumber", "Subsection",
 CellChangeTimes->{{3.435306208*^9, 3.435306210484375*^9}},
 CellID->248080049],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", "PrimeNumber"}]], "Input",
 CellChangeTimes->{{3.435306212484375*^9, 3.435306214484375*^9}},
 CellID->303132414],

Cell[BoxData[
 StyleBox["\<\"PrimeNumber[N_Integer] returns the N-th prime number.       \
\\nN: index of the prime number (e.g N=2 returns 3).\"\>", "MSG"]], "Print", \
"PrintUsage",
 CellChangeTimes->{3.435651582546875*^9},
 CellTags->"Info3435655182-8613643",
 CellID->96141532]
}, Open  ]],

Cell[TextData[{
 "Comparing with the ",
 StyleBox["Mathematica",
  FontSlant->"Italic"],
 " function Prime:"
}], "Text",
 CellChangeTimes->{{3.435306289953125*^9, 3.43530630521875*^9}},
 CellID->99153574],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Table", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"i", ",", 
     RowBox[{"PrimeNumber", "[", 
      RowBox[{"i", "-", "1"}], "]"}], ",", 
     RowBox[{"Prime", "[", "i", "]"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"i", ",", "1000", ",", "1003"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.435306217640625*^9, 3.435306277203125*^9}},
 CellID->958656803],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"1000", ",", "7919", ",", "7919"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1001", ",", "7927", ",", "7927"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1002", ",", "7933", ",", "7933"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1003", ",", "7937", ",", "7937"}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{{3.435306247171875*^9, 3.4353062780625*^9}, 
   3.435651582625*^9},
 CellID->299403308]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["PseudoSqrt and RankReducedSqrt", "Subsection",
 CellChangeTimes->{{3.43504912403125*^9, 3.435049124640625*^9}, 
   3.43505097271875*^9, {3.43530605928125*^9, 3.435306068453125*^9}, {
   3.435307496515625*^9, 3.43530750053125*^9}},
 CellID->130165928],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", "PseudoSqrt"}]], "Input",
 CellChangeTimes->{{3.435049274359375*^9, 3.43504927528125*^9}, 
   3.4350509746875*^9},
 CellID->6048173],

Cell[BoxData[
 StyleBox["\<\"PseudoSqrt[Matrix_?MatrixQ,SalvagingAlgorithm_String] Returns \
the pseudo square root of a real symmetric matrix.       \\nMatrix: symmetric \
matrix (hopefully positive semi-definite at least).\\nSalvagingAlgorithm: \
Salvaging algorithm for symmetric matrix not positive semi-definite (None, \
Spectral).\"\>", "MSG"]], "Print", "PrintUsage",
 CellChangeTimes->{3.435651582734375*^9},
 CellTags->"Info3435655182-5374334",
 CellID->550150612]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"m", "=", " ", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"2", ",", "1"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "2"}], "}"}]}], "}"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.43530604709375*^9, 3.43530605675*^9}},
 CellID->586417498],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"PseudoSqrt", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"2", ",", "1"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "2"}], "}"}]}], "}"}], ",", "\"\<Spectral\>\""}], 
  "]"}]], "Input",
 CellChangeTimes->{{3.435305972015625*^9, 3.43530600234375*^9}},
 CellID->754291804],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"1.224744871391589`", ",", "0.7071067811865476`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1.2247448713915892`", ",", 
     RowBox[{"-", "0.7071067811865475`"}]}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{{3.435305980609375*^9, 3.4353060036875*^9}, 
   3.4353060734375*^9, 3.435651582859375*^9},
 CellID->586936435]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"PseudoSqrt", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"2", ",", "1"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "2"}], "}"}]}], "}"}], ",", "\"\<None\>\""}], 
  "]"}]], "Input",
 CellChangeTimes->{{3.435305972015625*^9, 3.4353060165625*^9}},
 CellID->120378139],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"1.4142135623730951`", ",", "0.`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0.7071067811865475`", ",", "1.224744871391589`"}], "}"}]}], 
  "}"}]], "Output",
 CellChangeTimes->{3.435306017109375*^9, 3.435306075546875*^9, 
  3.435651582890625*^9},
 CellID->73455073]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", "RankReducedSqrt"}]], "Input",
 CellID->210357520],

Cell[BoxData[
 StyleBox["\<\"RankReducedSqrt[Matrix_?MatrixQ,MaxRank_Integer,\
ComponentPercentage_?NumberQ,SalvagingAlgorithm_String] Returns the rank \
reduced pseudo square root of a real symmetric matrix.       \\nMatrix: \
symmetric matrix (hopefully positive semi-definite at least).\\nMaxRank: \
number of principal components retained, i.e. max rank for the result matrix.\
\\nComponentPercentage: principal components retained as percentage of \
eigenvalues' sum.\\nSalvagingAlgorithm: Salvaging algorithm for symmetric \
matrix not positive semi-definite (None, Spectral).\"\>", "MSG"]], "Print", \
"PrintUsage",
 CellChangeTimes->{3.435651583*^9},
 CellTags->"Info3435655182-7939388",
 CellID->71747120]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"RankReducedSqrt", "[", 
  RowBox[{"m", ",", "2", ",", "0.1", ",", "\"\<Spectral\>\""}], 
  "]"}]], "Input",
 CellChangeTimes->{{3.43530750978125*^9, 3.435307539625*^9}},
 CellID->713247362],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", "1.4142135623730951`", "}"}], ",", 
   RowBox[{"{", "1.4142135623730951`", "}"}]}], "}"}]], "Output",
 CellChangeTimes->{3.43530754034375*^9, 3.4356515830625*^9},
 CellID->323263946]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["CholeskyDecomposition", "Subsection",
 CellID->588697079],

Cell[TextData[{
 "The Quantlib CholeskyDecomposition shaddows the built-in ",
 StyleBox["Mathematica",
  FontSlant->"Italic"],
 " CholeskyDecomposition"
}], "Text",
 CellChangeTimes->{{3.4353063540625*^9, 3.435306387734375*^9}},
 CellID->133637113],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", "CholeskyDecomposition"}]], "Input",
 CellChangeTimes->{
  3.43505554834375*^9, {3.435055628234375*^9, 3.43505563421875*^9}, 
   3.43530604275*^9},
 CellID->80181912],

Cell[BoxData[
 RowBox[{
  StyleBox["\<\"CholeskyDecomposition[Matrix_?MatrixQ] Returns the Cholesky \
decomposition of a real symmetric matrix.       \\nMatrix: symmetric matrix \
(hopefully positive semi-definite at least).\\nFlexible: If TRUE it returns a \
result also for positive semi-definite matrix. Default value = false.\"\>", 
   "MSG"], " ", 
  ButtonBox[
   StyleBox["\[RightSkeleton]", "SR"],
   Active->True,
   BaseStyle->"Link",
   ButtonData->"paclet:ref/CholeskyDecomposition"]}]], "Print", "PrintUsage",
 CellChangeTimes->{3.43565158321875*^9},
 CellTags->"Info3435655183-4643459",
 CellID->126181680]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"CholeskyDecomposition", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"2", ",", "1"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "2"}], "}"}]}], "}"}], ",", 
   RowBox[{"Flexible", "\[Rule]", "False"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.435055674328125*^9, 3.435055677484375*^9}, 
   3.435301884078125*^9, {3.435305895078125*^9, 3.4353059015625*^9}},
 CellID->276117172],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"1.4142135623730951`", ",", "0.`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0.7071067811865475`", ",", "1.224744871391589`"}], "}"}]}], 
  "}"}]], "Output",
 CellChangeTimes->{
  3.435055578171875*^9, 3.435301853328125*^9, 3.435301917390625*^9, 
   3.435302899953125*^9, {3.435303582640625*^9, 3.43530358271875*^9}, 
   3.435303704546875*^9, 3.43530402759375*^9, 3.435304342609375*^9, 
   3.435304504203125*^9, 3.43530586684375*^9, 3.435305909421875*^9, 
   3.43530609175*^9, 3.435651583359375*^9},
 CellID->432287560]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"CholeskyDecomposition", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"2", ",", "1"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "2"}], "}"}]}], "}"}], ",", 
   RowBox[{"Flexible", "\[Rule]", "True"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.435055674328125*^9, 3.435055677484375*^9}, 
   3.435301884078125*^9, {3.435305895078125*^9, 3.43530592175*^9}},
 CellID->48793145],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"1.4142135623730951`", ",", "0.`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0.7071067811865475`", ",", "1.224744871391589`"}], "}"}]}], 
  "}"}]], "Output",
 CellChangeTimes->{3.435305934125*^9, 3.435306097046875*^9, 
  3.435651583390625*^9},
 CellID->483043075]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["CovarianceDecomposition", "Subsection",
 CellID->98323952],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", "CovarianceDecomposition"}]], "Input",
 CellChangeTimes->{{3.435306124140625*^9, 3.4353061251875*^9}},
 CellID->749770165],

Cell[BoxData[
 StyleBox["\<\"CovarianceDecomposition[ObjecctId_Symbol,SymmetricMatrix_?\
MatrixQ,SalvagingAlgorithm_String] Construct an object of class \
CovarianceDecomposition and return its id       \\nObjectId: id of object to \
be created\\nSymmetricMatrix: Symmetrix covariance matrix to be \
decomposed.\\nTolerance: numerical tolerance for non symmetric matrix. \
Default value = 1.0e12.\\nSalvagingAlgorithm: Salvaging algorithm for \
symmetric matrix not positive semi-definite (None, Spectral).\\nPermanent: \
object permanent/nonpermanent\"\>", "MSG"]], "Print", "PrintUsage",
 CellChangeTimes->{3.435651583484375*^9},
 CellTags->"Info3435655183-8842475",
 CellID->383453856]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"CovarianceDecomposition", "[", 
   RowBox[{"cov", ",", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"2", ",", "1"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"1", ",", "2"}], "}"}]}], "}"}], ",", "\"\<Spectral\>\""}], 
   "]"}], ";"}], "\n", 
 RowBox[{"?", "cov"}]}], "Input",
 CellChangeTimes->{{3.435306124140625*^9, 3.4353061251875*^9}, {
   3.43530642928125*^9, 3.43530649809375*^9}, {3.43530710740625*^9, 
   3.435307132125*^9}, 3.435307279609375*^9},
 CellID->601264844],

Cell[CellGroupData[{

Cell["Global`cov", "Print", "PrintUsage",
 CellChangeTimes->{3.43565158365625*^9},
 CellTags->"Info3435655183-2433475",
 CellID->266829409],

Cell[BoxData[
 InterpretationBox[GridBox[{
    {GridBox[{
       {
        RowBox[{
         RowBox[{"BaseClass", "[", "cov", "]"}], "^=", "\<\"\"\>"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"Category", "[", "cov", "]"}], "^=", "\<\"Math\"\>"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"ClassName", "[", "cov", "]"}], "^=", 
         "qlCovarianceDecomposition"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"ObjectId", "[", "cov", "]"}], "^=", "cov"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"Overwrite", "[", "cov", "]"}], "^=", "False"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"Permanent", "[", "cov", "]"}], "^=", "False"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"Properties", "[", "cov", "]"}], "^=", "6"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"SalvagingAlgorithm", "[", "cov", "]"}], "^=", 
         "Spectral"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"Tolerance", "[", "cov", "]"}], "^=", "1.`*^12"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"ValueObject", "[", "cov", "]"}], "^=", 
         "qlCovarianceDecomposition"}]}
      },
      BaselinePosition->{Baseline, {1, 1}},
      GridBoxAlignment->{
       "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
        "RowsIndexed" -> {}},
      GridBoxItemSize->{"Columns" -> {{
           Scaled[0.999]}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
        "RowsIndexed" -> {}}]}
   },
   BaselinePosition->{Baseline, {1, 1}},
   GridBoxAlignment->{
    "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
     "RowsIndexed" -> {}}],
  Definition["cov"],
  Editable->False]], "Print",
 CellChangeTimes->{3.43565158365625*^9},
 CellTags->"Info3435655183-2433475",
 CellID->309330060]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", "GetCovariance"}]], "Input",
 CellChangeTimes->{{3.4353071349375*^9, 3.43530714*^9}},
 CellID->845699383],

Cell[BoxData[
 StyleBox["\<\"GetCovariance[Vols_List /; VectorQ[Vols, \
NumberQ],Matrix_?MatrixQ] Returns the covariance matrix generated using the \
correlation matrix and the standard deviation (i.e. volatility times square \
root of time) array.       \\nVols: volatility vector.\\nMatrix: symmetric \
matrix (hopefully positive semi-definite at least).\\nTolerance: numerical \
tolerance for non symmetric matrix. Default value = 1.0e12.\"\>", 
  "MSG"]], "Print", "PrintUsage",
 CellChangeTimes->{3.43565158378125*^9},
 CellTags->"Info3435655183-9984926",
 CellID->592992035]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", "CovarianceDecomposition"}]], "Input",
 CellChangeTimes->{{3.43530720028125*^9, 3.43530720675*^9}},
 CellID->6843069],

Cell[BoxData[
 StyleBox["\<\"CovarianceDecomposition[ObjecctId_Symbol,SymmetricMatrix_?\
MatrixQ,SalvagingAlgorithm_String] Construct an object of class \
CovarianceDecomposition and return its id       \\nObjectId: id of object to \
be created\\nSymmetricMatrix: Symmetrix covariance matrix to be \
decomposed.\\nTolerance: numerical tolerance for non symmetric matrix. \
Default value = 1.0e12.\\nSalvagingAlgorithm: Salvaging algorithm for \
symmetric matrix not positive semi-definite (None, Spectral).\\nPermanent: \
object permanent/nonpermanent\"\>", "MSG"]], "Print", "PrintUsage",
 CellChangeTimes->{3.435651583890625*^9},
 CellTags->"Info3435655183-9493348",
 CellID->262488517]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"CovarianceDecomposition", "[", 
   RowBox[{"covd", ",", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"2", ",", "1"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"1", ",", "2"}], "}"}]}], "}"}], ",", "\"\<Spectral\>\""}], 
   "]"}], ";"}], "\n", 
 RowBox[{"?", "covd"}]}], "Input",
 CellChangeTimes->{{3.43530721765625*^9, 3.435307276171875*^9}},
 CellID->15645946],

Cell[CellGroupData[{

Cell["Global`covd", "Print", "PrintUsage",
 CellChangeTimes->{3.43565158403125*^9},
 CellTags->"Info3435655183-6806470",
 CellID->743795725],

Cell[BoxData[
 InterpretationBox[GridBox[{
    {GridBox[{
       {
        RowBox[{
         RowBox[{"BaseClass", "[", "covd", "]"}], "^=", "\<\"\"\>"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"Category", "[", "covd", "]"}], "^=", "\<\"Math\"\>"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"ClassName", "[", "covd", "]"}], "^=", 
         "qlCovarianceDecomposition"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"ObjectId", "[", "covd", "]"}], "^=", "covd"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"Overwrite", "[", "covd", "]"}], "^=", "False"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"Permanent", "[", "covd", "]"}], "^=", "False"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"Properties", "[", "covd", "]"}], "^=", "6"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"SalvagingAlgorithm", "[", "covd", "]"}], "^=", 
         "Spectral"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"Tolerance", "[", "covd", "]"}], "^=", "1.`*^12"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"ValueObject", "[", "covd", "]"}], "^=", 
         "qlCovarianceDecomposition"}]}
      },
      BaselinePosition->{Baseline, {1, 1}},
      GridBoxAlignment->{
       "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
        "RowsIndexed" -> {}},
      GridBoxItemSize->{"Columns" -> {{
           Scaled[0.999]}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
        "RowsIndexed" -> {}}]}
   },
   BaselinePosition->{Baseline, {1, 1}},
   GridBoxAlignment->{
    "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
     "RowsIndexed" -> {}}],
  Definition["covd"],
  Editable->False]], "Print",
 CellChangeTimes->{3.43565158403125*^9},
 CellTags->"Info3435655183-6806470",
 CellID->663472391]
}, Open  ]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
CovarianceDecompositionCorrelationMatrix, \
CovarianceDecompositionStandardDeviations, and \
CovarianceDecompositionVariances\
\>", "Subsection",
 CellChangeTimes->{{3.43530737646875*^9, 3.435307377140625*^9}},
 CellID->123729997],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", "CovarianceDecompositionCorrelationMatrix"}]], "Input",
 CellChangeTimes->{{3.43530730253125*^9, 3.435307329046875*^9}},
 CellID->485355042],

Cell[BoxData[
 StyleBox["\<\"CovarianceDecompositionCorrelationMatrix[ObjecctId_Symbol] \
Returns the correlation matrix for the given CovarianceDecomposition object.  \
     \\nObjectId: id of existing QuantLib::CovarianceDecomposition \
object\"\>", "MSG"]], "Print", "PrintUsage",
 CellChangeTimes->{3.4356515841875*^9},
 CellTags->"Info3435655184-8658534",
 CellID->264891987]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"CovarianceDecompositionCorrelationMatrix", "[", "covd", 
  "]"}]], "Input",
 CellChangeTimes->{{3.43530730253125*^9, 3.435307335375*^9}},
 CellID->697007412],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"1.`", ",", "0.4999999999999999`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0.4999999999999999`", ",", "1.`"}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{3.43530733609375*^9, 3.43565158425*^9},
 CellID->171319345]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"CovarianceDecompositionStandardDeviations", "[", "covd", 
  "]"}]], "Input",
 CellChangeTimes->{{3.435307403515625*^9, 3.43530740821875*^9}},
 CellID->664775860],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"1.4142135623730951`", ",", "1.4142135623730951`"}], 
  "}"}]], "Output",
 CellChangeTimes->{3.435307408875*^9, 3.435651584265625*^9},
 CellID->578427440]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"CovarianceDecompositionVariances", "[", "covd", "]"}]], "Input",
 CellChangeTimes->{{3.435307403515625*^9, 3.435307426546875*^9}},
 CellID->123862173],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"2.`", ",", "2.`"}], "}"}]], "Output",
 CellChangeTimes->{3.435307427046875*^9, 3.43565158428125*^9},
 CellID->183042393]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["GetCovariance", "Subsection",
 CellID->347188909],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", "GetCovariance"}]], "Input",
 CellChangeTimes->{3.435307710796875*^9},
 CellID->369668872],

Cell[BoxData[
 StyleBox["\<\"GetCovariance[Vols_List /; VectorQ[Vols, \
NumberQ],Matrix_?MatrixQ] Returns the covariance matrix generated using the \
correlation matrix and the standard deviation (i.e. volatility times square \
root of time) array.       \\nVols: volatility vector.\\nMatrix: symmetric \
matrix (hopefully positive semi-definite at least).\\nTolerance: numerical \
tolerance for non symmetric matrix. Default value = 1.0e12.\"\>", 
  "MSG"]], "Print", "PrintUsage",
 CellChangeTimes->{3.435651584421875*^9},
 CellTags->"Info3435655184-3563836",
 CellID->511223282]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"vols", "=", 
  RowBox[{
  "CovarianceDecompositionStandardDeviations", "[", "covd", "]"}]}]], "Input",\

 CellChangeTimes->{{3.435307731*^9, 3.435307731828125*^9}},
 CellID->246590784],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"1.4142135623730951`", ",", "1.4142135623730951`"}], 
  "}"}]], "Output",
 CellChangeTimes->{3.43530773265625*^9, 3.435651584484375*^9},
 CellID->1007284924]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"corr", " ", "=", " ", 
  RowBox[{
  "CovarianceDecompositionCorrelationMatrix", "[", "covd", "]"}]}]], "Input",
 CellChangeTimes->{{3.435307735140625*^9, 3.435307742953125*^9}},
 CellID->143297951],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"1.`", ",", "0.4999999999999999`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0.4999999999999999`", ",", "1.`"}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{3.435307744109375*^9, 3.4356515845*^9},
 CellID->30513785]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"GetCovariance", "[", 
  RowBox[{"vols", ",", "corr"}], "]"}]], "Input",
 CellChangeTimes->{{3.4353077458125*^9, 3.43530775328125*^9}},
 CellID->113496114],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"2.0000000000000004`", ",", "1.`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1.`", ",", "2.0000000000000004`"}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{3.43530775390625*^9, 3.43565158453125*^9},
 CellID->690136992]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
SymmetricSchurDecomposition, SymmetricSchurDecompositionEigenvalues, \
SymmetricSchurDecompositionEigenvectors\
\>", "Subsection",
 CellID->131529734],

Cell[TextData[{
 "There is a built-in function in ",
 StyleBox["Mathematica",
  FontSlant->"Italic"],
 " for the Schur decomposition"
}], "Text",
 CellChangeTimes->{{3.435307772046875*^9, 3.435307794953125*^9}},
 CellID->20025370],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", "SchurDecomposition"}]], "Input",
 CellChangeTimes->{{3.435307562140625*^9, 3.435307570625*^9}, 
   3.435307768328125*^9, {3.435307801*^9, 3.435307804140625*^9}},
 CellID->677502883],

Cell[BoxData[
 RowBox[{
  StyleBox["\<\"\!\(\*RowBox[{\\\"SchurDecomposition\\\", \\\"[\\\", \
StyleBox[\\\"m\\\", \\\"TI\\\"], \\\"]\\\"}]\) yields the Schur decomposition \
for a numerical matrix \!\(\*StyleBox[\\\"m\\\", \\\"TI\\\"]\), given as a \
list \!\(\*RowBox[{\\\"{\\\", RowBox[{StyleBox[\\\"q\\\", \\\"TI\\\"], \
\\\",\\\", StyleBox[\\\"t\\\", \\\"TI\\\"]}], \\\"}\\\"}]\) where \
\!\(\*StyleBox[\\\"q\\\", \\\"TI\\\"]\) is an orthonormal matrix and \
\!\(\*StyleBox[\\\"t\\\", \\\"TI\\\"]\) is a block upper\[Hyphen]triangular \
matrix. \\n\!\(\*RowBox[{\\\"SchurDecomposition\\\", \\\"[\\\", RowBox[{\\\"{\
\\\", RowBox[{StyleBox[\\\"m\\\", \\\"TI\\\"], \\\",\\\", StyleBox[\\\"a\\\", \
\\\"TI\\\"]}], \\\"}\\\"}], \\\"]\\\"}]\) gives the generalized Schur \
decomposition of \!\(\*StyleBox[\\\"m\\\", \\\"TI\\\"]\) with respect to \!\(\
\*StyleBox[\\\"a\\\", \\\"TI\\\"]\). \"\>", "MSG"], " ", 
  ButtonBox[
   StyleBox["\[RightSkeleton]", "SR"],
   Active->True,
   BaseStyle->"Link",
   ButtonData->"paclet:ref/SchurDecomposition"]}]], "Print", "PrintUsage",
 CellChangeTimes->{3.4356515846875*^9},
 CellTags->"Info3435655184-3046474",
 CellID->354404208]
}, Open  ]],

Cell["Find the Schur decomposition of a real matrix :", "Text",
 CellID->43155942],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"SchurDecomposition", "[", 
  RowBox[{"N", "[", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"27", ",", "48", ",", "81"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "6"}], ",", "0", ",", "0"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "0", ",", "3"}], "}"}]}], "}"}], "]"}], 
  "]"}]], "Input",
 CellID->24498762],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"0.8900427175814679`", ",", 
       RowBox[{"-", "0.45449369086530444`"}], ",", "0.03548867204938381`"}], 
      "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "0.4450213587907339`"}], ",", 
       RowBox[{"-", "0.8493241172926927`"}], ",", "0.2839093763950706`"}], 
      "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
      "0.09889363528682973`", ",", "0.26848468997062386`", ",", 
       "0.9581941453333628`"}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"12.000000000000002`", ",", 
       RowBox[{"-", "29.02973373639596`"}], ",", "82.44410264182909`"}], 
      "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"3.661079685940427`*^-16", ",", "12.000000000000002`", ",", 
       RowBox[{"-", "40.941965008747516`"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.`", ",", "0.`", ",", "6.`"}], "}"}]}], "}"}]}], 
  "}"}]], "Output",
 CellChangeTimes->{3.435307613453125*^9, 3.435651585078125*^9},
 CellID->551228713]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Map", "[", 
  RowBox[{"MatrixForm", ",", "%"}], "]"}]], "Input",
 CellID->62701930],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   TagBox[
    RowBox[{"(", "\[NoBreak]", GridBox[{
       {"0.8900427175814679`", 
        RowBox[{"-", "0.45449369086530444`"}], "0.03548867204938381`"},
       {
        RowBox[{"-", "0.4450213587907339`"}], 
        RowBox[{"-", "0.8493241172926927`"}], "0.2839093763950706`"},
       {"0.09889363528682973`", "0.26848468997062386`", 
        "0.9581941453333628`"}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
    Function[BoxForm`e$, 
     MatrixForm[BoxForm`e$]]], ",", 
   TagBox[
    RowBox[{"(", "\[NoBreak]", GridBox[{
       {"12.000000000000002`", 
        RowBox[{"-", "29.02973373639596`"}], "82.44410264182909`"},
       {"3.661079685940427`*^-16", "12.000000000000002`", 
        RowBox[{"-", "40.941965008747516`"}]},
       {"0.`", "0.`", "6.`"}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
    Function[BoxForm`e$, 
     MatrixForm[BoxForm`e$]]]}], "}"}]], "Output",
 CellChangeTimes->{3.435307621671875*^9, 3.435651585140625*^9},
 CellID->4506475]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", "SymmetricSchurDecomposition"}]], "Input",
 CellChangeTimes->{{3.435307198234375*^9, 3.43530719825*^9}, 
   3.4353072901875*^9, {3.4353074348125*^9, 3.43530744103125*^9}, {
   3.435307661640625*^9, 3.43530766540625*^9}, {3.4353078165625*^9, 
   3.4353078484375*^9}},
 CellID->412778128],

Cell[BoxData[
 StyleBox["\<\"SymmetricSchurDecomposition[ObjecctId_Symbol,SymmetricMatrix_?\
MatrixQ] Construct an object of class SymmetricSchurDecomposition and return \
its id       \\nObjectId: id of object to be created\\nSymmetricMatrix: \
Symmetrix matrix to be decomposed.\\nPermanent: object permanent/nonpermanent\
\"\>", "MSG"]], "Print", "PrintUsage",
 CellChangeTimes->{3.43530784934375*^9},
 CellTags->"Info3435311449-3825067",
 CellID->50566027]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"SymmetricSchurDecomposition", "[", 
   RowBox[{"schur", ",", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"2", ",", "1"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"1", ",", "2"}], "}"}]}], "}"}]}], "]"}], ";"}], "\n", 
 RowBox[{"?", "schur"}]}], "Input",
 CellChangeTimes->{{3.435307198234375*^9, 3.43530719825*^9}, 
   3.4353072901875*^9, {3.4353074348125*^9, 3.43530744103125*^9}, {
   3.435307661640625*^9, 3.43530766540625*^9}, {3.4353078165625*^9, 
   3.435307861921875*^9}, {3.4353078980625*^9, 3.435307899515625*^9}, {
   3.435307955953125*^9, 3.435307958921875*^9}},
 CellID->235025449],

Cell[CellGroupData[{

Cell["Global`schur", "Print", "PrintUsage",
 CellChangeTimes->{3.435651614859375*^9},
 CellTags->"Info3435655214-2649024",
 CellID->27411391],

Cell[BoxData[
 InterpretationBox[GridBox[{
    {GridBox[{
       {
        RowBox[{
         RowBox[{"BaseClass", "[", "schur", "]"}], "^=", "\<\"\"\>"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"Category", "[", "schur", "]"}], "^=", "\<\"Math\"\>"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"ClassName", "[", "schur", "]"}], "^=", 
         "qlSymmetricSchurDecomposition"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"ObjectId", "[", "schur", "]"}], "^=", "schur"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"Overwrite", "[", "schur", "]"}], "^=", "False"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"Permanent", "[", "schur", "]"}], "^=", "False"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"Properties", "[", "schur", "]"}], "^=", "4"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"ValueObject", "[", "schur", "]"}], "^=", 
         "qlSymmetricSchurDecomposition"}]}
      },
      BaselinePosition->{Baseline, {1, 1}},
      GridBoxAlignment->{
       "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
        "RowsIndexed" -> {}},
      GridBoxItemSize->{"Columns" -> {{
           Scaled[0.999]}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
        "RowsIndexed" -> {}}]}
   },
   BaselinePosition->{Baseline, {1, 1}},
   GridBoxAlignment->{
    "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
     "RowsIndexed" -> {}}],
  Definition["schur"],
  Editable->False]], "Print",
 CellChangeTimes->{3.435651614890625*^9},
 CellTags->"Info3435655214-2649024",
 CellID->857880137]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", "SymmetricSchurDecompositionEigenvalues"}]], "Input",
 CellChangeTimes->{3.435307922921875*^9},
 CellID->889325551],

Cell[BoxData[
 StyleBox["\<\"SymmetricSchurDecompositionEigenvalues[ObjecctId_Symbol] \
Returns the eigenvalues for the given SymmetricSchurDecomposition object.     \
  \\nObjectId: id of existing QuantLib::SymmetricSchurDecomposition \
object\"\>", "MSG"]], "Print", "PrintUsage",
 CellChangeTimes->{3.435651616953125*^9},
 CellTags->"Info3435655216-1103671",
 CellID->557604858]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"SymmetricSchurDecompositionEigenvalues", "[", "schur", 
  "]"}]], "Input",
 CellChangeTimes->{{3.435307931015625*^9, 3.435307932546875*^9}},
 CellID->403902392],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"3.`", ",", "1.`"}], "}"}]], "Output",
 CellChangeTimes->{3.43530793484375*^9, 3.435651585453125*^9, 
  3.43565161784375*^9},
 CellID->136352173]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"SymmetricSchurDecompositionEigenvectors", "[", "schur", 
  "]"}]], "Input",
 CellChangeTimes->{{3.435307931015625*^9, 3.435307946484375*^9}},
 CellID->36234523],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"0.7071067811865475`", ",", "0.7071067811865476`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0.7071067811865476`", ",", 
     RowBox[{"-", "0.7071067811865475`"}]}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{3.435307948328125*^9, 3.4356515855625*^9, 
  3.435651618984375*^9},
 CellID->782236654]
}, Open  ]]
}, Open  ]]
}, Open  ]]
},
Editable->True,
WindowSize->{806, 746},
WindowMargins->{{415, Automatic}, {Automatic, 0}},
DockedCells->FEPrivate`FrontEndResource[
 "FEExpressions", "HelpViewerToolbar"],
PageHeaders->{{None, None, None}, {None, None, 
   Cell[
    TextData[{
      Cell[
       TextData[{"Printed from [[YOUR APPLICATION'S NAME]] documentation "}], 
       "PageHeader"], 
      Cell[
       TextData[{
         CounterBox["Page"]}], "PageNumber"]}], 
    CellMargins -> {{Inherited, -29}, {Inherited, Inherited}}]}},
PageFooters->{{None, None, None}, {
   Cell[
    TextData[{"\[Copyright] 2008 Weber & Partner. All rights reserved."}], 
    "PageFooter"], None, None}},
ShowSelection->True,
TaggingRules->{"SearchTextTranslated" -> "", "SearchText" -> ""},
CreateCellID->True,
ShowCellTags->False,
FrontEndVersion->"6.0 for Microsoft Windows (32-bit) (May 21, 2008)",
StyleDefinitions->FrontEnd`FileName[{"Wolfram"}, "Reference.nb", 
  CharacterEncoding -> "WindowsANSI"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "Info3435655181-5000948"->{
  Cell[2536, 76, 681, 11, 140, "Print",
   CellTags->"Info3435655181-5000948",
   CellID->160762845]},
 "Info3435655181-4333920"->{
  Cell[6933, 190, 604, 10, 70, "Print",
   CellTags->"Info3435655181-4333920",
   CellID->273885187]},
 "Info3435655182-1903207"->{
  Cell[8200, 225, 359, 7, 70, "Print",
   CellTags->"Info3435655182-1903207",
   CellID->424979121]},
 "Info3435655182-8613643"->{
  Cell[17009, 413, 281, 6, 70, "Print",
   CellTags->"Info3435655182-8613643",
   CellID->96141532]},
 "Info3435655182-5374334"->{
  Cell[18896, 479, 473, 8, 70, "Print",
   CellTags->"Info3435655182-5374334",
   CellID->550150612]},
 "Info3435655182-7939388"->{
  Cell[21291, 564, 714, 12, 70, "Print",
   CellTags->"Info3435655182-7939388",
   CellID->71747120]},
 "Info3435655183-4643459"->{
  Cell[23081, 621, 620, 14, 70, "Print",
   CellTags->"Info3435655183-4643459",
   CellID->126181680]},
 "Info3435655183-8842475"->{
  Cell[25892, 713, 688, 11, 70, "Print",
   CellTags->"Info3435655183-8842475",
   CellID->383453856]},
 "Info3435655183-2433475"->{
  Cell[27184, 748, 139, 3, 70, "Print",
   CellTags->"Info3435655183-2433475",
   CellID->266829409],
  Cell[27326, 753, 1854, 62, 70, "Print",
   CellTags->"Info3435655183-2433475",
   CellID->309330060]},
 "Info3435655183-9984926"->{
  Cell[29365, 826, 580, 10, 70, "Print",
   CellTags->"Info3435655183-9984926",
   CellID->592992035]},
 "Info3435655183-9493348"->{
  Cell[30130, 846, 688, 11, 70, "Print",
   CellTags->"Info3435655183-9493348",
   CellID->262488517]},
 "Info3435655183-6806470"->{
  Cell[31308, 879, 140, 3, 70, "Print",
   CellTags->"Info3435655183-6806470",
   CellID->743795725],
  Cell[31451, 884, 1866, 62, 70, "Print",
   CellTags->"Info3435655183-6806470",
   CellID->663472391]},
 "Info3435655184-8658534"->{
  Cell[33814, 968, 380, 7, 70, "Print",
   CellTags->"Info3435655184-8658534",
   CellID->264891987]},
 "Info3435655184-3563836"->{
  Cell[35747, 1040, 581, 10, 70, "Print",
   CellTags->"Info3435655184-3563836",
   CellID->511223282]},
 "Info3435655184-3046474"->{
  Cell[38513, 1136, 1172, 21, 70, "Print",
   CellTags->"Info3435655184-3046474",
   CellID->354404208]},
 "Info3435311449-3825067"->{
  Cell[43611, 1280, 460, 8, 97, "Print",
   CellTags->"Info3435311449-3825067",
   CellID->50566027]},
 "Info3435655214-2649024"->{
  Cell[44794, 1313, 141, 3, 42, "Print",
   CellTags->"Info3435655214-2649024",
   CellID->27411391],
  Cell[44938, 1318, 1645, 53, 233, "Print",
   CellTags->"Info3435655214-2649024",
   CellID->857880137]},
 "Info3435655216-1103671"->{
  Cell[46778, 1382, 381, 7, 69, "Print",
   CellTags->"Info3435655216-1103671",
   CellID->557604858]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"Info3435655181-5000948", 49289, 1463},
 {"Info3435655181-4333920", 49421, 1467},
 {"Info3435655182-1903207", 49553, 1471},
 {"Info3435655182-8613643", 49684, 1475},
 {"Info3435655182-5374334", 49815, 1479},
 {"Info3435655182-7939388", 49947, 1483},
 {"Info3435655183-4643459", 50079, 1487},
 {"Info3435655183-8842475", 50212, 1491},
 {"Info3435655183-2433475", 50345, 1495},
 {"Info3435655183-9984926", 50581, 1502},
 {"Info3435655183-9493348", 50714, 1506},
 {"Info3435655183-6806470", 50847, 1510},
 {"Info3435655184-8658534", 51083, 1517},
 {"Info3435655184-3563836", 51215, 1521},
 {"Info3435655184-3046474", 51349, 1525},
 {"Info3435311449-3825067", 51484, 1529},
 {"Info3435655214-2649024", 51616, 1533},
 {"Info3435655216-1103671", 51854, 1540}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[568, 21, 114, 2, 49, "Subtitle",
 CellID->140484240],
Cell[CellGroupData[{
Cell[707, 27, 199, 4, 83, "Title",
 CellID->1579529],
Cell[CellGroupData[{
Cell[931, 35, 168, 4, 31, "Input",
 CellID->174546348],
Cell[1102, 41, 1091, 19, 107, "Output",
 CellID->217079336]
}, Open  ]],
Cell[CellGroupData[{
Cell[2230, 65, 147, 2, 36, "Subsection",
 CellID->197908043],
Cell[CellGroupData[{
Cell[2402, 71, 131, 3, 31, "Input",
 CellID->237084469],
Cell[2536, 76, 681, 11, 140, "Print",
 CellTags->"Info3435655181-5000948",
 CellID->160762845]
}, Open  ]],
Cell[CellGroupData[{
Cell[3254, 92, 147, 3, 31, "Input",
 CellID->175065542],
Cell[3404, 97, 533, 11, 33, "Output",
 CellID->471086015]
}, Open  ]],
Cell[CellGroupData[{
Cell[3974, 113, 219, 5, 31, "Input",
 CellID->140879761],
Cell[4196, 120, 334, 5, 30, "Output",
 CellID->179461327]
}, Open  ]],
Cell[CellGroupData[{
Cell[4567, 130, 398, 11, 31, "Input",
 CellID->711241048],
Cell[4968, 143, 1766, 36, 251, "Output",
 CellID->427442645]
}, Open  ]],
Cell[CellGroupData[{
Cell[6771, 184, 159, 4, 70, "Input",
 CellID->357008171],
Cell[6933, 190, 604, 10, 70, "Print",
 CellTags->"Info3435655181-4333920",
 CellID->273885187]
}, Open  ]],
Cell[CellGroupData[{
Cell[7574, 205, 145, 3, 70, "Input",
 CellID->711252928],
Cell[7722, 210, 302, 5, 70, "Output",
 CellID->66017870]
}, Open  ]],
Cell[CellGroupData[{
Cell[8061, 220, 136, 3, 70, "Input",
 CellID->30440349],
Cell[8200, 225, 359, 7, 70, "Print",
 CellTags->"Info3435655182-1903207",
 CellID->424979121]
}, Open  ]],
Cell[CellGroupData[{
Cell[8596, 237, 149, 3, 70, "Input",
 CellID->205052286],
Cell[8748, 242, 254, 4, 70, "Output",
 CellID->30606803]
}, Open  ]],
Cell[CellGroupData[{
Cell[9039, 251, 280, 8, 70, "Input",
 CellID->108440766],
Cell[9322, 261, 7025, 122, 70, "Output",
 CellID->294735206]
}, Open  ]],
Cell[CellGroupData[{
Cell[16384, 388, 147, 3, 70, "Input",
 CellID->376573554],
Cell[16534, 393, 145, 3, 70, "Output",
 CellID->692554235]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[16728, 402, 113, 2, 70, "Subsection",
 CellID->248080049],
Cell[CellGroupData[{
Cell[16866, 408, 140, 3, 70, "Input",
 CellID->303132414],
Cell[17009, 413, 281, 6, 70, "Print",
 CellTags->"Info3435655182-8613643",
 CellID->96141532]
}, Open  ]],
Cell[17305, 422, 204, 7, 70, "Text",
 CellID->99153574],
Cell[CellGroupData[{
Cell[17534, 433, 394, 11, 70, "Input",
 CellID->958656803],
Cell[17931, 446, 472, 13, 70, "Output",
 CellID->299403308]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[18452, 465, 256, 4, 70, "Subsection",
 CellID->130165928],
Cell[CellGroupData[{
Cell[18733, 473, 160, 4, 70, "Input",
 CellID->6048173],
Cell[18896, 479, 473, 8, 70, "Print",
 CellTags->"Info3435655182-5374334",
 CellID->550150612]
}, Open  ]],
Cell[19384, 490, 308, 10, 70, "Input",
 CellID->586417498],
Cell[CellGroupData[{
Cell[19717, 504, 344, 11, 70, "Input",
 CellID->754291804],
Cell[20064, 517, 393, 10, 70, "Output",
 CellID->586936435]
}, Open  ]],
Cell[CellGroupData[{
Cell[20494, 532, 339, 11, 70, "Input",
 CellID->120378139],
Cell[20836, 545, 337, 10, 70, "Output",
 CellID->73455073]
}, Open  ]],
Cell[CellGroupData[{
Cell[21210, 560, 78, 2, 70, "Input",
 CellID->210357520],
Cell[21291, 564, 714, 12, 70, "Print",
 CellTags->"Info3435655182-7939388",
 CellID->71747120]
}, Open  ]],
Cell[CellGroupData[{
Cell[22042, 581, 213, 5, 70, "Input",
 CellID->713247362],
Cell[22258, 588, 238, 6, 70, "Output",
 CellID->323263946]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[22545, 600, 63, 1, 70, "Subsection",
 CellID->588697079],
Cell[22611, 603, 248, 7, 70, "Text",
 CellID->133637113],
Cell[CellGroupData[{
Cell[22884, 614, 194, 5, 70, "Input",
 CellID->80181912],
Cell[23081, 621, 620, 14, 70, "Print",
 CellTags->"Info3435655183-4643459",
 CellID->126181680]
}, Open  ]],
Cell[CellGroupData[{
Cell[23738, 640, 449, 12, 70, "Input",
 CellID->276117172],
Cell[24190, 654, 591, 14, 70, "Output",
 CellID->432287560]
}, Open  ]],
Cell[CellGroupData[{
Cell[24818, 673, 445, 12, 70, "Input",
 CellID->48793145],
Cell[25266, 687, 335, 10, 70, "Output",
 CellID->483043075]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[25650, 703, 64, 1, 70, "Subsection",
 CellID->98323952],
Cell[CellGroupData[{
Cell[25739, 708, 150, 3, 70, "Input",
 CellID->749770165],
Cell[25892, 713, 688, 11, 70, "Print",
 CellTags->"Info3435655183-8842475",
 CellID->383453856]
}, Open  ]],
Cell[CellGroupData[{
Cell[26617, 729, 542, 15, 70, "Input",
 CellID->601264844],
Cell[CellGroupData[{
Cell[27184, 748, 139, 3, 70, "Print",
 CellTags->"Info3435655183-2433475",
 CellID->266829409],
Cell[27326, 753, 1854, 62, 70, "Print",
 CellTags->"Info3435655183-2433475",
 CellID->309330060]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[29229, 821, 133, 3, 70, "Input",
 CellID->845699383],
Cell[29365, 826, 580, 10, 70, "Print",
 CellTags->"Info3435655183-9984926",
 CellID->592992035]
}, Open  ]],
Cell[CellGroupData[{
Cell[29982, 841, 145, 3, 70, "Input",
 CellID->6843069],
Cell[30130, 846, 688, 11, 70, "Print",
 CellTags->"Info3435655183-9493348",
 CellID->262488517]
}, Open  ]],
Cell[CellGroupData[{
Cell[30855, 862, 428, 13, 70, "Input",
 CellID->15645946],
Cell[CellGroupData[{
Cell[31308, 879, 140, 3, 70, "Print",
 CellTags->"Info3435655183-6806470",
 CellID->743795725],
Cell[31451, 884, 1866, 62, 70, "Print",
 CellTags->"Info3435655183-6806470",
 CellID->663472391]
}, Open  ]]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[33378, 953, 240, 6, 70, "Subsection",
 CellID->123729997],
Cell[CellGroupData[{
Cell[33643, 963, 168, 3, 70, "Input",
 CellID->485355042],
Cell[33814, 968, 380, 7, 70, "Print",
 CellTags->"Info3435655184-8658534",
 CellID->264891987]
}, Open  ]],
Cell[CellGroupData[{
Cell[34231, 980, 181, 4, 70, "Input",
 CellID->697007412],
Cell[34415, 986, 290, 8, 70, "Output",
 CellID->171319345]
}, Open  ]],
Cell[CellGroupData[{
Cell[34742, 999, 185, 4, 70, "Input",
 CellID->664775860],
Cell[34930, 1005, 193, 5, 70, "Output",
 CellID->578427440]
}, Open  ]],
Cell[CellGroupData[{
Cell[35160, 1015, 174, 3, 70, "Input",
 CellID->123862173],
Cell[35337, 1020, 160, 4, 70, "Output",
 CellID->183042393]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[35546, 1030, 55, 1, 70, "Subsection",
 CellID->347188909],
Cell[CellGroupData[{
Cell[35626, 1035, 118, 3, 70, "Input",
 CellID->369668872],
Cell[35747, 1040, 581, 10, 70, "Print",
 CellTags->"Info3435655184-3563836",
 CellID->511223282]
}, Open  ]],
Cell[CellGroupData[{
Cell[36365, 1055, 208, 6, 70, "Input",
 CellID->246590784],
Cell[36576, 1063, 196, 5, 70, "Output",
 CellID->1007284924]
}, Open  ]],
Cell[CellGroupData[{
Cell[36809, 1073, 221, 5, 70, "Input",
 CellID->143297951],
Cell[37033, 1080, 289, 8, 70, "Output",
 CellID->30513785]
}, Open  ]],
Cell[CellGroupData[{
Cell[37359, 1093, 178, 4, 70, "Input",
 CellID->113496114],
Cell[37540, 1099, 293, 8, 70, "Output",
 CellID->690136992]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[37882, 1113, 160, 4, 70, "Subsection",
 CellID->131529734],
Cell[38045, 1119, 230, 7, 70, "Text",
 CellID->20025370],
Cell[CellGroupData[{
Cell[38300, 1130, 210, 4, 70, "Input",
 CellID->677502883],
Cell[38513, 1136, 1172, 21, 70, "Print",
 CellTags->"Info3435655184-3046474",
 CellID->354404208]
}, Open  ]],
Cell[39700, 1160, 82, 1, 70, "Text",
 CellID->43155942],
Cell[CellGroupData[{
Cell[39807, 1165, 395, 13, 70, "Input",
 CellID->24498762],
Cell[40205, 1180, 1089, 31, 73, "Output",
 CellID->551228713]
}, Open  ]],
Cell[CellGroupData[{
Cell[41331, 1216, 107, 3, 28, "Input",
 CellID->62701930],
Cell[41441, 1221, 1816, 46, 66, "Output",
 CellID->4506475]
}, Open  ]],
Cell[CellGroupData[{
Cell[43294, 1272, 314, 6, 28, "Input",
 CellID->412778128],
Cell[43611, 1280, 460, 8, 97, "Print",
 CellTags->"Info3435311449-3825067",
 CellID->50566027]
}, Open  ]],
Cell[CellGroupData[{
Cell[44108, 1293, 661, 16, 47, "Input",
 CellID->235025449],
Cell[CellGroupData[{
Cell[44794, 1313, 141, 3, 42, "Print",
 CellTags->"Info3435655214-2649024",
 CellID->27411391],
Cell[44938, 1318, 1645, 53, 233, "Print",
 CellTags->"Info3435655214-2649024",
 CellID->857880137]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[46632, 1377, 143, 3, 28, "Input",
 CellID->889325551],
Cell[46778, 1382, 381, 7, 69, "Print",
 CellTags->"Info3435655216-1103671",
 CellID->557604858]
}, Open  ]],
Cell[CellGroupData[{
Cell[47196, 1394, 184, 4, 28, "Input",
 CellID->403902392],
Cell[47383, 1400, 184, 5, 36, "Output",
 CellID->136352173]
}, Open  ]],
Cell[CellGroupData[{
Cell[47604, 1410, 184, 4, 28, "Input",
 CellID->36234523],
Cell[47791, 1416, 371, 10, 36, "Output",
 CellID->782236654]
}, Open  ]]
}, Open  ]]
}, Open  ]]
}
]
*)

(* End of internal cache information *)
