(* Content-type: application/mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 6.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       145,          7]
NotebookDataLength[      5237,        152]
NotebookOptionsPosition[      3583,         92]
NotebookOutlinePosition[      4882,        136]
CellTagsIndexPosition[      4798,        131]
WindowFrame->Normal
ContainsDynamic->False*)

(* Beginning of Notebook Content *)
Notebook[{
Cell["QuantLib", "Subtitle",
 CellChangeTimes->{{3.434947043421875*^9, 3.434947050171875*^9}},
 CellID->610735155],

Cell[CellGroupData[{

Cell["PiecewiseYieldCurves", "Title",
 CellChangeTimes->{{3.43494703740625*^9, 3.43494703928125*^9}, 
   3.434951659765625*^9, 3.43503746765625*^9, {3.435308085953125*^9, 
   3.43530808640625*^9}, {3.43531829871875*^9, 3.435318332828125*^9}, {
   3.43531845903125*^9, 3.435318459515625*^9}, {3.435409586109375*^9, 
   3.43540958709375*^9}, 3.435409719609375*^9},
 CellID->807533154],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Category", "[", "PiecewiseYieldCurves", "]"}]], "Input",
 CellChangeTimes->{
  3.4350374865*^9, {3.43530809390625*^9, 3.43530809421875*^9}, {
   3.435317821125*^9, 3.43531782203125*^9}, {3.43531834046875*^9, 
   3.43531834803125*^9}, {3.43531846246875*^9, 3.435318462890625*^9}, {
   3.43540959096875*^9, 3.435409594203125*^9}, 3.435409740921875*^9},
 CellID->92140675],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "PiecewiseYieldCurve", ",", "PiecewiseYieldCurveData", ",", 
   "PiecewiseYieldCurveDates", ",", "PiecewiseYieldCurveTimes"}], 
  "}"}]], "Output",
 CellChangeTimes->{3.43503748790625*^9, 3.4350415943125*^9, 
  3.435043991453125*^9, 3.435045711375*^9, 3.4350488741875*^9, 
  3.435048959234375*^9, 3.43504960696875*^9, 3.43504997275*^9, 
  3.43506560309375*^9, 3.435301008140625*^9, 3.435301663984375*^9, 
  3.43530809525*^9, 3.435308442*^9, 3.43530881784375*^9, 3.43531670009375*^9, 
  3.435317824375*^9, 3.43531834896875*^9, 3.4353184640625*^9, 
  3.435319574796875*^9, 3.435323514703125*^9, 3.435409594890625*^9, 
  3.435409742296875*^9},
 CellID->100547253]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", "PiecewiseYieldCurve"}]], "Input",
 CellChangeTimes->{{3.43540962365625*^9, 3.435409626640625*^9}, 
   3.43540975021875*^9},
 CellID->104859318],

Cell[BoxData[
 StyleBox["\<\"PiecewiseYieldCurve[ObjecctId_Symbol,RateHelpers_List,Jumps_\
List,JumpDates_List /; VectorQ[JumpDates, DateQ]] Construct an object of \
class PiecewiseYieldCurve and return its id       \\nObjectId: id of object \
to be created\\nNDays: number of days to advance from EvaluationDate (usually \
zero or two): it fixes the date at which the discount factor = 1.0. Default \
value = 0.\\nCalendar: holiday calendar (e.g. TARGET) to advance from global \
EvaluationDate.\\nRateHelpers: vector of rate-helpers.\\nDayCounter: \
DayCounter ID. Default value = \\\"Actual/365 (Fixed)\\\".\\nJumps: Jump \
quotes vector.\\nJumpDates: Jump dates vector.\\nAccuracy: Bootstrapping \
accuracy. Default value = 1.0e-12.\\nTraitsID: Discount, ZeroRate, or \
ForwardRate. Default value = \\\"Discount\\\".\\nInterpolatorID: \
BackwardFlat, ForwardFlat, Linear, LogLinear, CubicSpline, or LogCubic. \
Default value = \\\"LogLinear\\\".\\nPermanent: object permanent/nonpermanent\
\"\>", "MSG"]], "Print", "PrintUsage",
 CellChangeTimes->{3.435409751515625*^9},
 CellTags->"Info3435413351-2597745",
 CellID->111287095]
}, Open  ]]
}, Open  ]]
},
Editable->True,
WindowSize->{616, 749},
WindowMargins->{{187, Automatic}, {Automatic, 40}},
DockedCells->FEPrivate`FrontEndResource[
 "FEExpressions", "HelpViewerToolbar"],
PageHeaders->{{None, None, None}, {None, None, 
   Cell[
    TextData[{
      Cell[
       TextData[{"Printed from [[YOUR APPLICATION'S NAME]] documentation "}], 
       "PageHeader"], 
      Cell[
       TextData[{
         CounterBox["Page"]}], "PageNumber"]}], 
    CellMargins -> {{Inherited, -29}, {Inherited, Inherited}}]}},
PageFooters->{{None, None, None}, {
   Cell[
    TextData[{"\[Copyright] 2008 Weber & Partner. All rights reserved."}], 
    "PageFooter"], None, None}},
ShowSelection->True,
TaggingRules->{"SearchTextTranslated" -> "", "SearchText" -> ""},
CreateCellID->True,
ShowCellTags->False,
FrontEndVersion->"6.0 for Microsoft Windows (32-bit) (May 21, 2008)",
StyleDefinitions->FrontEnd`FileName[{"Wolfram"}, "Reference.nb", 
  CharacterEncoding -> "WindowsANSI"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "Info3435413351-2597745"->{
  Cell[2424, 71, 1131, 17, 251, "Print",
   CellTags->"Info3435413351-2597745",
   CellID->111287095]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"Info3435413351-2597745", 4671, 124}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[568, 21, 114, 2, 23, "Subtitle",
 CellID->610735155],
Cell[CellGroupData[{
Cell[707, 27, 382, 6, 51, "Title",
 CellID->807533154],
Cell[CellGroupData[{
Cell[1114, 37, 393, 7, 28, "Input",
 CellID->92140675],
Cell[1510, 46, 702, 14, 54, "Output",
 CellID->100547253]
}, Open  ]],
Cell[CellGroupData[{
Cell[2249, 65, 172, 4, 28, "Input",
 CellID->104859318],
Cell[2424, 71, 1131, 17, 251, "Print",
 CellTags->"Info3435413351-2597745",
 CellID->111287095]
}, Open  ]]
}, Open  ]]
}
]
*)

(* End of internal cache information *)
