(* Content-type: application/mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 6.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       145,          7]
NotebookDataLength[     46474,       1390]
NotebookOptionsPosition[     34864,        974]
NotebookOutlinePosition[     39054,       1101]
CellTagsIndexPosition[     38296,       1080]
WindowFrame->Normal
ContainsDynamic->False*)

(* Beginning of Notebook Content *)
Notebook[{
Cell["QuantLib", "Subtitle",
 CellChangeTimes->{{3.434947043421875*^9, 3.434947050171875*^9}},
 CellID->448260325],

Cell[CellGroupData[{

Cell["PricingEngines", "Title",
 CellChangeTimes->{{3.43494703740625*^9, 3.43494703928125*^9}, 
   3.434951659765625*^9, 3.43503746765625*^9, {3.435308085953125*^9, 
   3.43530808640625*^9}, {3.43531829871875*^9, 3.435318332828125*^9}, {
   3.4353231705*^9, 3.435323174234375*^9}, {3.435323225703125*^9, 
   3.435323232984375*^9}, {3.435323275*^9, 3.435323275609375*^9}, {
   3.435323310703125*^9, 3.435323311484375*^9}, {3.435323371984375*^9, 
   3.43532337584375*^9}, {3.43537974459375*^9, 3.435379746796875*^9}, {
   3.435382106703125*^9, 3.43538211221875*^9}},
 CellID->506652710],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Category", "[", "PricingEngines", "]"}]], "Input",
 CellChangeTimes->{{3.43532315271875*^9, 3.435323157890625*^9}, {
  3.43532323690625*^9, 3.4353232438125*^9}, {3.43532328084375*^9, 
  3.4353232814375*^9}, {3.4353233160625*^9, 3.435323322171875*^9}, {
  3.43532335534375*^9, 3.435323359390625*^9}, {3.435379752078125*^9, 
  3.435379755671875*^9}, {3.4353821170625*^9, 3.435382120140625*^9}},
 CellID->564681269],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "AnalyticCapFloorEngine", ",", "BachelierBlackFormula", ",", 
   "BachelierBlackFormula2", ",", "BinomialPricingEngine", ",", 
   "BlackCalculator", ",", "BlackCalculatorAlpha", ",", "BlackCalculatorBeta",
    ",", "BlackCalculatorDelta", ",", "BlackCalculatorDeltaForward", ",", 
   "BlackCalculatorDividendRho", ",", "BlackCalculatorElasticity", ",", 
   "BlackCalculatorElasticityForward", ",", "BlackCalculatorGamma", ",", 
   "BlackCalculatorGammaForward", ",", "BlackCalculatorItmAssetProbability", 
   ",", "BlackCalculatorItmCashProbability", ",", "BlackCalculatorRho", ",", 
   "BlackCalculatorStrikeSensitivity", ",", "BlackCalculatorTheta", ",", 
   "BlackCalculatorThetaPerDay", ",", "BlackCalculatorValue", ",", 
   "BlackCalculatorVega", ",", "BlackCapFloorEngine", ",", 
   "BlackCapFloorEngine2", ",", "BlackFormula", ",", "BlackFormula2", ",", 
   "BlackFormulaCashItmProbability", ",", "BlackFormulaCashItmProbability2", 
   ",", "BlackFormulaImpliedStdDev3", ",", "BlackFormulaImpliedStdDev4", ",", 
   "BlackFormulaImpliedStdDevApproximation", ",", 
   "BlackFormulaImpliedStdDevApproximation2", ",", 
   "BlackFormulaStdDevDerivative", ",", "BlackFormulaStdDevDerivative2", ",", 
   "BlackScholesCalculator", ",", "BlackScholesCalculatorDelta", ",", 
   "BlackScholesCalculatorElasticity", ",", "BlackScholesCalculatorGamma", 
   ",", "BlackScholesCalculatorTheta", ",", 
   "BlackScholesCalculatorThetaPerDay", ",", "BlackSwaptionEngine", ",", 
   "BlackSwaptionEngine2", ",", "BondEngine", ",", "DiscountingSwapEngine", 
   ",", "PricingEngine"}], "}"}]], "Output",
 CellChangeTimes->{
  3.4353231586875*^9, 3.43532324471875*^9, 3.435323282109375*^9, {
   3.43532331834375*^9, 3.43532332259375*^9}, 3.4353233603125*^9, 
   3.435379756203125*^9, 3.43538212065625*^9},
 CellID->827014673]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
BlackFormula, BlackFormulaImpliedStdDevApproximation, \
BlackFormulaStdDevDerivative\
\>", "Subsubsection",
 CellChangeTimes->{{3.427194427703125*^9, 3.427194438765625*^9}, {
   3.43538225059375*^9, 3.4353822546875*^9}, {3.435384207*^9, 
   3.4353842075625*^9}, {3.435385038171875*^9, 3.435385056375*^9}, 
   3.435385514125*^9},
 CellID->18715733],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", "BlackFormula"}]], "Input",
 CellChangeTimes->{{3.427173443890625*^9, 3.42717345140625*^9}},
 CellID->260435982],

Cell[BoxData[
 StyleBox["\<\"BlackFormula[OptionType_String,Strike_?NumberQ,AtmForwardValue_\
?NumberQ,StdDev_?NumberQ] Black 1976 formula for option pricing, using \
displacement.       \\nOptionType: option type (i.e. Call or Put).\\nStrike: \
option strike.\\nAtmForwardValue: underlying asset at-the-money forward \
value.\\nStdDev: standard deviation, i.e. annualized percentage volatility \
times the square root of time to option expiry.\\nDeflator: Deflator (usually \
the discount factor, or the annuity, etc.). Default value = \
1.0.\\nDisplacement: displacement in a displaced diffusion model. Default \
value = 0.0.\"\>", "MSG"]], "Print", "PrintUsage",
 CellChangeTimes->{3.435382256125*^9},
 CellTags->"Info3435385856-2511410",
 CellID->70120679]
}, Open  ]],

Cell["\<\
With most functions there are options associated. This simplifies the calling \
of functions.\
\>", "Text",
 CellChangeTimes->{{3.42717355640625*^9, 3.42717358815625*^9}},
 CellID->580172473],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Options", "[", "BlackFormula", "]"}]], "Input",
 CellChangeTimes->{{3.427173485765625*^9, 3.427173492375*^9}},
 CellID->12580035],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"Deflator", "\[Rule]", "0.`"}], ",", 
   RowBox[{"Displacement", "\[Rule]", "0.`"}]}], "}"}]], "Output",
 CellChangeTimes->{3.43072865584375*^9, 3.43486179884375*^9, 
  3.43496037371875*^9, 3.43497100471875*^9, 3.435297293203125*^9, 
  3.4352987608125*^9, 3.435298980921875*^9, 3.435299035921875*^9, 
  3.43529934415625*^9, 3.43529955853125*^9, 3.43530085409375*^9, 
  3.435300888609375*^9, 3.435300975796875*^9, 3.435301646703125*^9, 
  3.435382257921875*^9, 3.43538507309375*^9},
 CellID->47515924]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"\[Sigma]", "=", "0.20"}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"S", "=", "36."}], ";"}], "  ", 
  RowBox[{"(*", " ", "Underlying", " ", "*)"}]}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"K", "=", "40."}], ";"}], " ", 
  RowBox[{"(*", " ", "Strike", " ", "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"r", " ", "=", "0.06"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"q", " ", "=", " ", "0.0"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"T", " ", "=", " ", "1"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"price", " ", "=", 
  RowBox[{"BlackFormula", "[", 
   RowBox[{"\"\<Call\>\"", ",", "S", ",", "K", ",", 
    RowBox[{"\[Sigma]", 
     SqrtBox["T"]}], ",", 
    RowBox[{"Deflator", "\[Rule]", "r"}], ",", 
    RowBox[{"Displacement", " ", "\[Rule]", " ", "q"}]}], "]"}]}]}], "Input",
 CellChangeTimes->{{3.42717337009375*^9, 3.42717342690625*^9}, {
  3.427173481375*^9, 3.427173534359375*^9}, {3.4271736365*^9, 
  3.4271736511875*^9}, {3.427180437578125*^9, 3.427180438109375*^9}, {
  3.42718065090625*^9, 3.42718065359375*^9}, {3.427194306828125*^9, 
  3.427194329140625*^9}, {3.43538403815625*^9, 3.435384049390625*^9}, {
  3.43538412728125*^9, 3.435384192796875*^9}, {3.435385184859375*^9, 
  3.43538518678125*^9}},
 CellID->556040499],

Cell[BoxData["0.3261385947853155`"], "Output",
 CellChangeTimes->{
  3.430728655875*^9, 3.4348618*^9, 3.434960374609375*^9, 3.434971006078125*^9,
    3.435297294078125*^9, 3.435298762015625*^9, 3.435298981015625*^9, 
   3.43529903715625*^9, 3.435299344984375*^9, 3.43529955934375*^9, 
   3.4353008541875*^9, 3.43530088865625*^9, 3.435300975828125*^9, 
   3.4353016468125*^9, 3.435382258875*^9, {3.435384039125*^9, 
   3.435384059796875*^9}, {3.435384147*^9, 3.43538419325*^9}, 
   3.435385073953125*^9, 3.435385187375*^9},
 CellID->214884057]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", "BlackFormulaImpliedStdDevApproximation"}]], "Input",
 CellChangeTimes->{{3.435385156703125*^9, 3.43538515884375*^9}},
 CellID->285071838],

Cell[BoxData[
 StyleBox["\<\"BlackFormulaImpliedStdDevApproximation[OptionType_String,\
Strike_?NumberQ,AtmForwardValue_?NumberQ,OptionPrice_?NumberQ] Approximation \
for the standard deviation (annualized percentage volatility times the square \
root of time to option expiry) implied by the Black 1976 formula.       \
\\nOptionType: option type (i.e. Call or Put).\\nStrike: option \
strike.\\nAtmForwardValue: underlying asset at-the-money forward \
value.\\nOptionPrice: option price.\\nDeflator: Deflator (usually the \
discount factor, or the annuity, etc.). Default value = 1.0.\\nDisplacement: \
displacement in a displaced diffusion model. Default value = 0.0.\"\>", 
  "MSG"]], "Print", "PrintUsage",
 CellChangeTimes->{3.435385159625*^9},
 CellTags->"Info3435388759-3264207",
 CellID->36552784]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"BlackFormulaImpliedStdDevApproximation", "[", 
  RowBox[{"\"\<Call\>\"", ",", "S", ",", "K", ",", "price", ",", 
   RowBox[{"Deflator", "\[Rule]", "r"}], ",", 
   RowBox[{"Displacement", " ", "\[Rule]", " ", "q"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.42717337009375*^9, 3.42717342690625*^9}, {
  3.427173481375*^9, 3.427173534359375*^9}, {3.4271736365*^9, 
  3.4271736511875*^9}, {3.427180437578125*^9, 3.427180438109375*^9}, {
  3.42718065090625*^9, 3.42718065359375*^9}, {3.427194306828125*^9, 
  3.427194329140625*^9}, {3.43538403815625*^9, 3.435384049390625*^9}, {
  3.43538412728125*^9, 3.435384192796875*^9}, {3.435385075859375*^9, 
  3.43538508059375*^9}, {3.43538518228125*^9, 3.435385205046875*^9}},
 CellID->89789452],

Cell[BoxData["0.19875393625871604`"], "Output",
 CellChangeTimes->{{3.435385196921875*^9, 3.435385206*^9}, 
   3.4353858125625*^9},
 CellID->89371788]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", "BlackFormulaImpliedStdDev3"}]], "Input",
 CellChangeTimes->{{3.435385686015625*^9, 3.435385686625*^9}},
 CellID->54297795],

Cell[BoxData[
 StyleBox["\<\"BlackFormulaImpliedStdDev3[OptionType_String,Strike_?NumberQ,\
AtmForwardValue_?NumberQ,OptionPrice_?NumberQ] Standard deviation (annualized \
percentage volatility times the square root of time to option expiry) implied \
by the Black 1976 formula with displacement.       \\nOptionType: option type \
(i.e. Call or Put).\\nStrike: option strike.\\nAtmForwardValue: underlying \
asset at-the-money forward value.\\nOptionPrice: option price.\\nDeflator: \
Deflator (usually the discount factor, or the annuity, etc.). Default value = \
1.0.\\nDisplacement: displacement in a displaced diffusion model. Default \
value = 0.0.\\nGuess: standard deviation guess. Default value = \
0.0.\\nAccuracy: solver accuracy. Default value = 1.0e-6.\\nMaxIter: solver \
max iterations. Default value = 100.\"\>", "MSG"]], "Print", "PrintUsage",
 CellChangeTimes->{3.43538568734375*^9},
 CellTags->"Info3435389287-8627628",
 CellID->43876303]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Options", "[", "BlackFormulaImpliedStdDev3", "]"}]], "Input",
 CellChangeTimes->{{3.435385757890625*^9, 3.435385766484375*^9}},
 CellID->89962295],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"Deflator", "\[Rule]", "0.`"}], ",", 
   RowBox[{"Displacement", "\[Rule]", "0.`"}], ",", 
   RowBox[{"Guess", "\[Rule]", "0.`"}], ",", 
   RowBox[{"Accuracy", "\[Rule]", "0.`"}], ",", 
   RowBox[{"MaxIter", "\[Rule]", "0"}]}], "}"}]], "Output",
 CellChangeTimes->{3.435385767078125*^9},
 CellID->671454485]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"BlackFormulaImpliedStdDev3", "[", 
  RowBox[{"\"\<Call\>\"", ",", "S", ",", "K", ",", "price", ",", 
   RowBox[{"Deflator", "\[Rule]", "r"}], ",", 
   RowBox[{"Displacement", " ", "\[Rule]", " ", "q"}], ",", 
   RowBox[{"Guess", "\[Rule]", "0.1"}], ",", 
   RowBox[{"Accuracy", "->", 
    SuperscriptBox["10", 
     RowBox[{"-", "6"}]]}], ",", 
   RowBox[{"MaxIter", "\[Rule]", "100"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.435385686015625*^9, 3.435385686625*^9}, {
  3.43538572728125*^9, 3.435385741234375*^9}, {3.435385772859375*^9, 
  3.4353857878125*^9}, {3.435385823953125*^9, 3.435385829890625*^9}},
 CellID->687481774],

Cell[BoxData[
 RowBox[{
  RowBox[{"Loopback", "::", "\<\"LinkError\"\>"}], ":", 
  " ", "\<\"-- Message text not found -- (\\!\\(\\\"3\\\"\\)) \
(\\!\\(\\\"MLGet out of sequence.\\\"\\))\"\>"}]], "Message", "MSG",
 CellChangeTimes->{
  3.43538574228125*^9, {3.435385789921875*^9, 3.435385796375*^9}, {
   3.435385836703125*^9, 3.43538583934375*^9}},
 CellID->94851958],

Cell[BoxData["$Failed"], "Output",
 CellChangeTimes->{
  3.43538574228125*^9, {3.435385789921875*^9, 3.435385796375*^9}, {
   3.435385836703125*^9, 3.43538583934375*^9}},
 CellID->82879033]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", "BlackFormulaStdDevDerivative"}]], "Input",
 CellChangeTimes->{{3.435385286015625*^9, 3.4353852874375*^9}},
 CellID->519352462],

Cell[BoxData[
 StyleBox["\<\"BlackFormulaStdDevDerivative[Strike_?NumberQ,AtmForwardValue_?\
NumberQ,StdDev_?NumberQ] Black 1976 formula for the derivative with respect \
to the standard deviation (annualized percentage volatility times the square \
root of time to option expiry), with displacement.       \\nStrike: option \
strike.\\nAtmForwardValue: underlying asset at-the-money forward \
value.\\nStdDev: standard deviation, i.e. annualized percentage volatility \
times the square root of time to option expiry.\\nDeflator: Deflator (usually \
the discount factor, or the annuity, etc.). Default value = \
1.0.\\nDisplacement: displacement in a displaced diffusion model. Default \
value = 0.0.\"\>", "MSG"]], "Print", "PrintUsage",
 CellChangeTimes->{3.435385287984375*^9},
 CellTags->"Info3435388887-9482128",
 CellID->614717937]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"BlackFormulaStdDevDerivative", "[", 
   RowBox[{"K", ",", "S", ",", 
    RowBox[{"\[Sigma]", 
     SqrtBox["T"]}], ",", 
    RowBox[{"Deflator", "\[Rule]", "r"}], ",", 
    RowBox[{"Displacement", " ", "\[Rule]", " ", "q"}]}], "]"}], 
  "  "}]], "Input",
 CellChangeTimes->{{3.42717337009375*^9, 3.42717342690625*^9}, {
  3.427173481375*^9, 3.427173534359375*^9}, {3.4271736365*^9, 
  3.4271736511875*^9}, {3.427180437578125*^9, 3.427180438109375*^9}, {
  3.42718065090625*^9, 3.42718065359375*^9}, {3.427194306828125*^9, 
  3.427194329140625*^9}, {3.43538403815625*^9, 3.435384049390625*^9}, {
  3.43538412728125*^9, 3.435384192796875*^9}, {3.435385075859375*^9, 
  3.43538508059375*^9}, {3.43538518228125*^9, 3.435385219828125*^9}, {
  3.435385303578125*^9, 3.435385319828125*^9}, {3.4353854355*^9, 
  3.435385441015625*^9}, {3.435385483609375*^9, 3.4353854861875*^9}},
 CellID->268853542],

Cell[BoxData["0.7866982422948444`"], "Output",
 CellChangeTimes->{3.435385322640625*^9, 3.4353854415625*^9, 
  3.435385486859375*^9},
 CellID->643243936]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", "BlackFormulaCashItmProbability"}]], "Input",
 CellChangeTimes->{{3.435385597109375*^9, 3.4353855979375*^9}},
 CellID->132384298],

Cell[BoxData[
 StyleBox["\<\"BlackFormulaCashItmProbability[OptionType_String,Strike_?\
NumberQ,AtmForwardValue_?NumberQ,StdDev_?NumberQ] Black 1976 probability of \
being in the money (in the bond martingale measure), i.e. N(d2). It is a \
risk-neutral probability, not the real world one.       \\nOptionType: option \
type (i.e. Call or Put).\\nStrike: option strike.\\nAtmForwardValue: \
underlying asset at-the-money forward value.\\nStdDev: standard deviation, \
i.e. annualized percentage volatility times the square root of time to option \
expiry.\\nDisplacement: displacement in a displaced diffusion model. Default \
value = 0.0.\"\>", "MSG"]], "Print", "PrintUsage",
 CellChangeTimes->{3.43538559865625*^9},
 CellTags->"Info3435389198-6142479",
 CellID->121860254]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"BlackFormulaCashItmProbability", "[", 
  RowBox[{"\"\<Call\>\"", ",", "S", ",", "K", ",", 
   RowBox[{"\[Sigma]", 
    SqrtBox["T"]}], ",", 
   RowBox[{"Deflator", "\[Rule]", "r"}], ",", 
   RowBox[{"Displacement", " ", "\[Rule]", " ", "q"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.435385620078125*^9, 3.435385641546875*^9}},
 CellID->618834484],

Cell[BoxData["0.6652384357972312`"], "Output",
 CellChangeTimes->{3.4353856424375*^9},
 CellID->149023742]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["BachelierBlackFormula", "Subsection",
 CellID->83021440],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", "BachelierBlackFormula"}]], "Input",
 CellChangeTimes->{3.43538393784375*^9},
 CellID->40902715],

Cell[BoxData[
 StyleBox["\<\"BachelierBlackFormula[OptionType_String,Strike_?NumberQ,\
AtmForwardValue_?NumberQ,StdDev_?NumberQ] Black style formula when forward is \
normal rather than log-normal, i.e. essentially the model of Bachelier.       \
\\nOptionType: option type (i.e. Call or Put).\\nStrike: option \
strike.\\nAtmForwardValue: underlying asset at-the-money forward \
value.\\nStdDev: standard deviation, i.e. annualized ABSOLUTE volatility \
times the square root of time to option expiry.\\nDeflator: Deflator (usually \
the discount factor, or the annuity, etc.). Default value = 1.0.\"\>", 
  "MSG"]], "Print", "PrintUsage",
 CellChangeTimes->{3.4353839394375*^9},
 CellTags->"Info3435387539-8100545",
 CellID->546823559]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"BachelierBlackFormula", "[", 
  RowBox[{"\"\<Call\>\"", ",", "S", ",", "K", ",", 
   RowBox[{"\[Sigma]", 
    SqrtBox["T"]}], ",", 
   RowBox[{"Deflator", "\[Rule]", "r"}], ",", 
   RowBox[{"Displacement", " ", "\[Rule]", " ", "q"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.435383971859375*^9, 3.435383976234375*^9}},
 CellID->8219548],

Cell[BoxData["3.9999999999999996`"], "Output",
 CellChangeTimes->{3.4353839773125*^9, 3.435384042796875*^9},
 CellID->262297190]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
BlackCalculator, BlackCalculatorAlpha, BlackCalculatorBeta, \
BlackCalculatorDelta, BlackCalculatorDeltaForward, \
BlackCalculatorDividendRho, BlackCalculatorElasticity, \
BlackCalculatorElasticityForward, BlackCalculatorGamma, 
BlackCalculatorGammaForward, BlackCalculatorItmAssetProbability, 
BlackCalculatorItmCashProbability, BlackCalculatorRho, 
BlackCalculatorStrikeSensitivity, BlackCalculatorTheta, 
BlackCalculatorThetaPerDay, BlackCalculatorValue, BlackCalculatorVega\
\>", "Subsection",
 CellChangeTimes->{{3.43538439665625*^9, 3.43538439996875*^9}, {
  3.43538461425*^9, 3.43538463059375*^9}, {3.435384754796875*^9, 
  3.43538475846875*^9}},
 CellID->3380915],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", "BlackCalculator"}]], "Input",
 CellChangeTimes->{{3.4353842595625*^9, 3.435384271734375*^9}},
 CellID->751986782],

Cell[BoxData[
 StyleBox["\<\"BlackCalculator[ObjecctId_Symbol,PayoffID_Symbol,\
AtmForwardValue_?NumberQ,StdDev_?NumberQ] Construct an object of class \
BlackCalculator and return its id       \\nObjectId: id of object to be \
created\\nPayoffID: payoff ID.\\nAtmForwardValue: underlying asset \
at-the-money forward value.\\nStdDev: standard deviation, i.e. annualized \
percentage volatility times the square root of time to option \
expiry.\\nDeflator: Deflator (usually the discount factor, or the annuity, \
etc.). Default value = 1.0.\\nPermanent: object permanent/nonpermanent\"\>", 
  "MSG"]], "Print", "PrintUsage",
 CellChangeTimes->{3.435384272296875*^9},
 CellTags->"Info3435387872-1468815",
 CellID->50436986]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Options", "[", "BlackCalculator", "]"}]], "Input",
 CellChangeTimes->{{3.435384896203125*^9, 3.4353849035625*^9}},
 CellID->757793036],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"Deflator", "\[Rule]", "0.`"}], ",", 
   RowBox[{"Permanent", "\[Rule]", "True"}], ",", 
   RowBox[{"Overwrite", "\[Rule]", "True"}]}], "}"}]], "Output",
 CellChangeTimes->{3.435384904140625*^9},
 CellID->556401592]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"payoff", " ", "=", 
   RowBox[{"StrikedTypePayoff", "[", 
    RowBox[{"Vanilla", ",", "\"\<Call\>\"", ",", "K"}], "]"}]}], 
  ";"}], "\n", 
 RowBox[{"bc", " ", "=", 
  RowBox[{"BlackCalculator", "[", 
   RowBox[{"payoff", ",", 
    RowBox[{"S", " ", 
     SuperscriptBox["\[ExponentialE]", 
      RowBox[{"r", " ", "T"}]]}], ",", "\[Sigma]", ",", 
    RowBox[{"Deflator", "\[Rule]", 
     SuperscriptBox["\[ExponentialE]", 
      RowBox[{
       RowBox[{"-", "r"}], " ", "T"}]]}], ",", 
    RowBox[{"Displacement", " ", "\[Rule]", " ", 
     SuperscriptBox["\[ExponentialE]", 
      RowBox[{
       RowBox[{"-", "q"}], " ", "T"}]]}]}], "]"}]}]}], "Input",
 CellChangeTimes->{
  3.4353844388125*^9, 3.435384502140625*^9, {3.43538482146875*^9, 
   3.4353848684375*^9}, {3.435384957578125*^9, 3.4353849663125*^9}},
 CellID->245491713],

Cell[BoxData["BlackCalculator6"], "Output",
 CellChangeTimes->{
  3.4353844723125*^9, {3.43538482715625*^9, 3.435384869609375*^9}, 
   3.435384967515625*^9},
 CellID->857810752]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", "BlackCalculatorValue"}]], "Input",
 CellChangeTimes->{{3.43538491075*^9, 3.43538492078125*^9}},
 CellID->82534691],

Cell[BoxData[
 StyleBox["\<\"BlackCalculatorValue[ObjecctId_Symbol] returns the option \
value for the given BlackCalculator object.       \\nObjectId: id of existing \
QuantLib::BlackCalculator object\"\>", "MSG"]], "Print", "PrintUsage",
 CellChangeTimes->{3.4353849219375*^9},
 CellTags->"Info3435388521-9596410",
 CellID->59044974]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Options", "[", "BlackCalculatorValue", "]"}]], "Input",
 CellChangeTimes->{{3.435384926890625*^9, 3.4353849361875*^9}},
 CellID->189266391],

Cell[BoxData[
 RowBox[{"{", "}"}]], "Output",
 CellChangeTimes->{3.435384936796875*^9},
 CellID->593230102]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"BlackCalculatorValue", "[", "bc", "]"}]], "Input",
 CellChangeTimes->{{3.435384801390625*^9, 3.43538480234375*^9}},
 CellID->19032341],

Cell[BoxData["2.1737264482268936`"], "Output",
 CellChangeTimes->{
  3.435384803046875*^9, {3.435384836359375*^9, 3.4353848705625*^9}, 
   3.435384971328125*^9},
 CellID->97808664]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"BlackCalculatorAlpha", "[", "bc", "]"}]], "Input",
 CellChangeTimes->{{3.4353845376875*^9, 3.435384562140625*^9}},
 CellID->180851308],

Cell[BoxData["0.334761564202769`"], "Output",
 CellChangeTimes->{3.4353845628125*^9},
 CellID->159969996]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"BlackCalculatorBeta", "[", "bc", "]"}]], "Input",
 CellChangeTimes->{{3.4353845376875*^9, 3.435384570421875*^9}},
 CellID->197979994],

Cell[BoxData[
 RowBox[{"-", "0.26539432662194407`"}]], "Output",
 CellChangeTimes->{3.43538457109375*^9},
 CellID->565254080]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", "BlackCalculatorDelta"}]], "Input",
 CellChangeTimes->{{3.435384664640625*^9, 3.435384670859375*^9}},
 CellID->418526],

Cell[BoxData[
 StyleBox["\<\"BlackCalculatorDelta[ObjecctId_Symbol,Spot_?NumberQ] returns \
the sensitivity to change in the underlying spot price for the given \
BlackCalculator object.       \\nObjectId: id of existing \
QuantLib::BlackCalculator object\\nSpot: spot value.\"\>", "MSG"]], "Print", \
"PrintUsage",
 CellChangeTimes->{3.4353846714375*^9},
 CellTags->"Info3435388271-6962707",
 CellID->1630167]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"BlackCalculatorDelta", "[", 
  RowBox[{"bc", ",", "S"}], "]"}]], "Input",
 CellChangeTimes->{{3.4353845376875*^9, 3.43538457584375*^9}, {
  3.4353846775625*^9, 3.435384678015625*^9}},
 CellID->154646818],

Cell[BoxData["0.020085693852166128`"], "Output",
 CellChangeTimes->{3.43538457721875*^9, 3.43538467890625*^9},
 CellID->74894021]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"BlackCalculatorGamma", "[", 
  RowBox[{"bc", ",", "S"}], "]"}]], "Input",
 CellChangeTimes->{{3.4353845376875*^9, 3.43538457584375*^9}, {
  3.4353846775625*^9, 3.435384678015625*^9}, {3.4353847685*^9, 
  3.43538477328125*^9}},
 CellID->333022363],

Cell[BoxData["0.0030351012434214676`"], "Output",
 CellChangeTimes->{3.435384773921875*^9},
 CellID->300014294]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", "BlackCalculatorDeltaForward"}]], "Input",
 CellChangeTimes->{{3.43538470609375*^9, 3.435384727234375*^9}},
 CellID->77124304],

Cell[BoxData[
 StyleBox["\<\"BlackCalculatorDeltaForward[ObjecctId_Symbol] returns the \
sensitivity to change in the underlying forward price for the given \
BlackCalculator object.       \\nObjectId: id of existing \
QuantLib::BlackCalculator object\"\>", "MSG"]], "Print", "PrintUsage",
 CellChangeTimes->{3.43538472775*^9},
 CellTags->"Info3435388327-2220734",
 CellID->112761867]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"BlackCalculatorDeltaForward", "[", "bc", "]"}]], "Input",
 CellChangeTimes->{{3.435384701171875*^9, 3.435384730640625*^9}},
 CellID->94137841],

Cell[BoxData["0.020085693852166128`"], "Output",
 CellChangeTimes->{3.4353847023125*^9, 3.435384732765625*^9},
 CellID->303070072]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["BlackFormula", "Subsection",
 CellChangeTimes->{{3.43538448584375*^9, 3.43538448990625*^9}},
 CellID->52610637],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", "BlackFormula2"}]], "Input",
 CellChangeTimes->{3.4353822856875*^9},
 CellID->363596359],

Cell[BoxData[
 StyleBox["\<\"BlackFormula2[Payoff_Symbol,AtmForwardValue_?NumberQ,StdDev_?\
NumberQ] Black 1976 formula for option pricing with displacement. It uses a \
PlainVanillaPayoff object as input.       \\nPayoff: PlainVanillaPayoff \
object ID.\\nAtmForwardValue: underlying asset at-the-money forward \
value.\\nStdDev: standard deviation, i.e. annualized percentage volatility \
times the square root of time to option expiry.\\nDeflator: Deflator (usually \
the discount factor, or the annuity, etc.). Default value = \
1.0.\\nDisplacement: displacement in a displaced diffusion model. Default \
value = 0.0.\"\>", "MSG"]], "Print", "PrintUsage",
 CellChangeTimes->{3.435382286375*^9},
 CellTags->"Info3435385886-8359233",
 CellID->193426671]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"StrikedTypePayoff", "[", 
  RowBox[{
  "PlainVanillaPayoff", ",", "Vanilla", ",", "\"\<Call\>\"", ",", "K"}], 
  "]"}]], "Input",
 CellChangeTimes->{{3.435382385703125*^9, 3.43538239328125*^9}},
 CellID->693633342],

Cell[BoxData["PlainVanillaPayoff"], "Output",
 CellChangeTimes->{3.4353823940625*^9},
 CellID->511668182]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"BlackFormula2", "[", 
  RowBox[{"PlainVanillaPayoff", ",", "S", ",", "K", ",", 
   RowBox[{"Deflator", "\[Rule]", "r"}], ",", 
   RowBox[{"Displacement", " ", "\[Rule]", " ", "q"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.43538241046875*^9, 3.435382444875*^9}},
 CellID->62553931],

Cell[BoxData[
 RowBox[{
  RowBox[{"QuantLibError", "::", "\<\"msg\"\>"}], ":", 
  " ", "\<\"\\!\\(\\\"Error retrieving object with id 'PlainVanillaPayoff' - \
unable to convert reference to typ\\\" \[Ellipsis] \
\\\"QuantLibAddin::PlainVanillaPayoff' found instead 'class \
QuantLibAddin::StrikedTypePayoff'\\\"\\)\"\>"}]], "Message", "MSG",
 CellChangeTimes->{3.435382445890625*^9, 3.435382475953125*^9},
 CellID->156018629],

Cell[BoxData["$Failed"], "Output",
 CellChangeTimes->{3.435382445890625*^9, 3.435382475953125*^9},
 CellID->192374450]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", "BlackFormulaImpliedStdDevApproximation2"}]], "Input",
 CellChangeTimes->{{3.435385229921875*^9, 3.435385232421875*^9}},
 CellID->117952378],

Cell[BoxData[
 StyleBox["\<\"BlackFormulaImpliedStdDevApproximation2[Payoff_Symbol,\
AtmForwardValue_?NumberQ,OptionPrice_?NumberQ] Approximation for the standard \
deviation (annualized percentage volatility times the square root of time to \
option expiry) implied by the Black 1976 formula. It uses a \
PlainVanillaPayoff object as input.       \\nPayoff: PlainVanillaPayoff \
object ID.\\nAtmForwardValue: underlying asset at-the-money forward \
value.\\nOptionPrice: option price.\\nDeflator: Deflator (usually the \
discount factor, or the annuity, etc.). Default value = 1.0.\\nDisplacement: \
displacement in a displaced diffusion model. Default value = 0.0.\"\>", 
  "MSG"]], "Print", "PrintUsage",
 CellChangeTimes->{3.4353852344375*^9},
 CellTags->"Info3435388834-9155320",
 CellID->317430210]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", "BlackFormulaImpliedStdDev4"}]], "Input",
 CellChangeTimes->{3.435386034828125*^9},
 CellID->1003214590],

Cell[BoxData[
 StyleBox["\<\"BlackFormulaImpliedStdDev4[PayoffID_Symbol,AtmForwardValue_?\
NumberQ,OptionPrice_?NumberQ] Standard deviation (annualized percentage \
volatility times the square root of time to option expiry) implied by the \
Black 1976 formula. It uses a PlainVanillaPayoff object as input.       \
\\nPayoffID: PlainVanillaPayoff object ID.\\nAtmForwardValue: underlying \
asset at-the-money forward value.\\nOptionPrice: option price.\\nDeflator: \
Deflator (usually the discount factor, or the annuity, etc.). Default value = \
1.0.\\nDisplacement: displacement in a displaced diffusion model. Default \
value = 0.0.\\nGuess: standard deviation guess. Default value = \
0.0.\\nAccuracy: standard deviation accuracy. Default value = \
1.0e-6.\\nMaxIter: solver max iterations. Default value = 100.\"\>", 
  "MSG"]], "Print", "PrintUsage",
 CellChangeTimes->{3.435386035703125*^9},
 CellTags->"Info3435389635-1163190",
 CellID->243728729]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["BlackSwaption", "Subsection",
 CellChangeTimes->{{3.435386190609375*^9, 3.435386193390625*^9}},
 CellID->29737419],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", "BlackSwaptionEngine"}]], "Input",
 CellChangeTimes->{{3.435385686015625*^9, 3.435385686625*^9}, {
  3.435386092984375*^9, 3.435386095375*^9}},
 CellID->539342551],

Cell[BoxData[
 StyleBox["\<\"BlackSwaptionEngine[ObjecctId_Symbol,YieldCurve_Symbol,VolTS_\
Symbol] Construct an object of class BlackSwaptionEngine and return its id    \
   \\nObjectId: id of object to be created\\nYieldCurve: discounting yield \
term structure object ID.\\nVolTS: SwaptionVolatilityStructure object \
ID.\\nPermanent: object permanent/nonpermanent\"\>", "MSG"]], "Print", \
"PrintUsage",
 CellChangeTimes->{3.4353861953125*^9},
 CellTags->"Info3435389795-4410783",
 CellID->419977237]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", "BlackSwaptionEngine2"}]], "Input",
 CellChangeTimes->{{3.435385686015625*^9, 3.435385686625*^9}, {
  3.435386092984375*^9, 3.435386095375*^9}, {3.43538619878125*^9, 
  3.435386199796875*^9}},
 CellID->545969789],

Cell[BoxData[
 StyleBox["\<\"BlackSwaptionEngine2[ObjecctId_Symbol,YieldCurve_Symbol,Vol_\
Symbol] Construct an object of class BlackSwaptionEngine and return its id    \
   \\nObjectId: id of object to be created\\nYieldCurve: discounting yield \
term structure object ID.\\nVol: cap/floor term volatility.\\nDayCounter: \
DayCounter ID. Default value = \\\"Actual/365 (Fixed)\\\".\\nPermanent: \
object permanent/nonpermanent\"\>", "MSG"]], "Print", "PrintUsage",
 CellChangeTimes->{3.435386200515625*^9},
 CellTags->"Info3435389800-7051366",
 CellID->92461416]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["BondEngine", "Subsection",
 CellChangeTimes->{{3.435386226765625*^9, 3.4353862295*^9}},
 CellID->377882837],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", "BondEngine"}]], "Input",
 CellChangeTimes->{{3.435386231765625*^9, 3.435386233890625*^9}},
 CellID->51114645],

Cell[BoxData[
 StyleBox["\<\"BondEngine[ObjecctId_Symbol,YieldCurve_Symbol] Construct an \
object of class BondEngine and return its id       \\nObjectId: id of object \
to be created\\nYieldCurve: discounting yield term structure object \
ID.\\nPermanent: object permanent/nonpermanent\"\>", "MSG"]], "Print", \
"PrintUsage",
 CellChangeTimes->{3.43538623440625*^9},
 CellTags->"Info3435389834-4925816",
 CellID->560772760]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"dc", " ", "=", " ", 
  RowBox[{"DiscountCurve", "[", 
   RowBox[{"datelist", ",", "disclist"}], "]"}]}]], "Input",
 CellID->83626597],

Cell[BoxData["DiscountCurve2"], "Output",
 CellChangeTimes->{3.435387148125*^9},
 CellID->129183961]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"BondEngine", "[", "dc", "]"}]], "Input",
 CellChangeTimes->{{3.43538715065625*^9, 3.435387159671875*^9}},
 CellID->102626736],

Cell[BoxData["BondEngine1"], "Output",
 CellChangeTimes->{3.4353871605625*^9},
 CellID->1993354]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", "BondEngine1"}]], "Input",
 CellChangeTimes->{{3.435387162421875*^9, 3.43538716484375*^9}},
 CellID->26281582],

Cell[CellGroupData[{

Cell["Global`BondEngine1", "Print", "PrintUsage",
 CellChangeTimes->{3.435387165421875*^9},
 CellTags->"Info3435390765-5726407",
 CellID->273292005],

Cell[BoxData[
 InterpretationBox[GridBox[{
    {GridBox[{
       {
        RowBox[{
         RowBox[{"Category", "[", "BondEngine1", "]"}], 
         "^=", "\<\"Pricing Engines\"\>"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"ClassName", "[", "BondEngine1", "]"}], "^=", 
         "qlBondEngine"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"ObjectId", "[", "BondEngine1", "]"}], "^=", 
         "BondEngine1"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"Overwrite", "[", "BondEngine1", "]"}], "^=", "False"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"Permanent", "[", "BondEngine1", "]"}], "^=", "False"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"Properties", "[", "BondEngine1", "]"}], "^=", "4"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"ValueObject", "[", "BondEngine1", "]"}], "^=", 
         "qlBondEngine"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"YieldCurve", "[", "BondEngine1", "]"}], "^=", 
         "DiscountCurve2"}]}
      },
      BaselinePosition->{Baseline, {1, 1}},
      GridBoxAlignment->{
       "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
        "RowsIndexed" -> {}},
      GridBoxItemSize->{"Columns" -> {{
           Scaled[0.999]}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
        "RowsIndexed" -> {}}]}
   },
   BaselinePosition->{Baseline, {1, 1}},
   GridBoxAlignment->{
    "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
     "RowsIndexed" -> {}}],
  Definition["BondEngine1"],
  Editable->False]], "Print",
 CellChangeTimes->{3.435387165453125*^9},
 CellTags->"Info3435390765-5726407",
 CellID->572435754]
}, Open  ]]
}, Open  ]]
}, Open  ]]
}, Open  ]]
},
Editable->True,
WindowSize->{984, 756},
WindowMargins->{{Automatic, 654}, {Automatic, 32}},
DockedCells->FEPrivate`FrontEndResource[
 "FEExpressions", "HelpViewerToolbar"],
PageHeaders->{{None, None, None}, {None, None, 
   Cell[
    TextData[{
      Cell[
       TextData[{"Printed from [[YOUR APPLICATION'S NAME]] documentation "}], 
       "PageHeader"], 
      Cell[
       TextData[{
         CounterBox["Page"]}], "PageNumber"]}], 
    CellMargins -> {{Inherited, -29}, {Inherited, Inherited}}]}},
PageFooters->{{None, None, None}, {
   Cell[
    TextData[{"\[Copyright] 2008 Weber & Partner. All rights reserved."}], 
    "PageFooter"], None, None}},
ShowSelection->True,
TaggingRules->{"SearchTextTranslated" -> "", "SearchText" -> ""},
CreateCellID->True,
ShowCellTags->False,
FrontEndVersion->"6.0 for Microsoft Windows (32-bit) (May 21, 2008)",
StyleDefinitions->FrontEnd`FileName[{"Wolfram"}, "Reference.nb", 
  CharacterEncoding -> "WindowsANSI"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "Info3435385856-2511410"->{
  Cell[4168, 101, 760, 12, 157, "Print",
   CellTags->"Info3435385856-2511410",
   CellID->70120679]},
 "Info3435388759-3264207"->{
  Cell[7976, 198, 806, 13, 70, "Print",
   CellTags->"Info3435388759-3264207",
   CellID->36552784]},
 "Info3435389287-8627628"->{
  Cell[9919, 243, 957, 14, 70, "Print",
   CellTags->"Info3435389287-8627628",
   CellID->43876303]},
 "Info3435388887-9482128"->{
  Cell[12892, 320, 838, 13, 70, "Print",
   CellTags->"Info3435388887-9482128",
   CellID->614717937]},
 "Info3435389198-6142479"->{
  Cell[15046, 371, 776, 12, 70, "Print",
   CellTags->"Info3435389198-6142479",
   CellID->121860254]},
 "Info3435387539-8100545"->{
  Cell[16602, 416, 737, 12, 70, "Print",
   CellTags->"Info3435387539-8100545",
   CellID->546823559]},
 "Info3435387872-1468815"->{
  Cell[18767, 473, 722, 12, 70, "Print",
   CellTags->"Info3435387872-1468815",
   CellID->50436986]},
 "Info3435388521-9596410"->{
  Cell[21220, 546, 335, 6, 70, "Print",
   CellTags->"Info3435388521-9596410",
   CellID->59044974]},
 "Info3435388271-6962707"->{
  Cell[23054, 614, 410, 8, 70, "Print",
   CellTags->"Info3435388271-6962707",
   CellID->1630167]},
 "Info3435388327-2220734"->{
  Cell[24475, 661, 384, 7, 70, "Print",
   CellTags->"Info3435388327-2220734",
   CellID->112761867]},
 "Info3435385886-8359233"->{
  Cell[25505, 697, 755, 12, 70, "Print",
   CellTags->"Info3435385886-8359233",
   CellID->193426671]},
 "Info3435388834-9155320"->{
  Cell[27742, 759, 804, 13, 70, "Print",
   CellTags->"Info3435388834-9155320",
   CellID->317430210]},
 "Info3435389635-1163190"->{
  Cell[28718, 782, 955, 15, 70, "Print",
   CellTags->"Info3435389635-1163190",
   CellID->243728729]},
 "Info3435389795-4410783"->{
  Cell[30061, 815, 504, 9, 97, "Print",
   CellTags->"Info3435389795-4410783",
   CellID->419977237]},
 "Info3435389800-7051366"->{
  Cell[30845, 836, 563, 9, 111, "Print",
   CellTags->"Info3435389800-7051366",
   CellID->92461416]},
 "Info3435389834-4925816"->{
  Cell[31736, 862, 424, 8, 83, "Print",
   CellTags->"Info3435389834-4925816",
   CellID->560772760]},
 "Info3435390765-5726407"->{
  Cell[32942, 907, 148, 3, 42, "Print",
   CellTags->"Info3435390765-5726407",
   CellID->273292005],
  Cell[33093, 912, 1719, 56, 233, "Print",
   CellTags->"Info3435390765-5726407",
   CellID->572435754]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"Info3435385856-2511410", 35952, 1006},
 {"Info3435388759-3264207", 36084, 1010},
 {"Info3435389287-8627628", 36215, 1014},
 {"Info3435388887-9482128", 36346, 1018},
 {"Info3435389198-6142479", 36479, 1022},
 {"Info3435387539-8100545", 36612, 1026},
 {"Info3435387872-1468815", 36745, 1030},
 {"Info3435388521-9596410", 36877, 1034},
 {"Info3435388271-6962707", 37008, 1038},
 {"Info3435388327-2220734", 37138, 1042},
 {"Info3435385886-8359233", 37270, 1046},
 {"Info3435388834-9155320", 37403, 1050},
 {"Info3435389635-1163190", 37536, 1054},
 {"Info3435389795-4410783", 37669, 1058},
 {"Info3435389800-7051366", 37801, 1062},
 {"Info3435389834-4925816", 37933, 1066},
 {"Info3435390765-5726407", 38065, 1070}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[568, 21, 114, 2, 49, "Subtitle",
 CellID->448260325],
Cell[CellGroupData[{
Cell[707, 27, 584, 9, 83, "Title",
 CellID->506652710],
Cell[CellGroupData[{
Cell[1316, 40, 436, 7, 31, "Input",
 CellID->564681269],
Cell[1755, 49, 1851, 30, 221, "Output",
 CellID->827014673]
}, Open  ]],
Cell[CellGroupData[{
Cell[3643, 84, 357, 8, 28, "Subsubsection",
 CellID->18715733],
Cell[CellGroupData[{
Cell[4025, 96, 140, 3, 31, "Input",
 CellID->260435982],
Cell[4168, 101, 760, 12, 157, "Print",
 CellTags->"Info3435385856-2511410",
 CellID->70120679]
}, Open  ]],
Cell[4943, 116, 201, 5, 29, "Text",
 CellID->580172473],
Cell[CellGroupData[{
Cell[5169, 125, 153, 3, 31, "Input",
 CellID->12580035],
Cell[5325, 130, 551, 11, 30, "Output",
 CellID->47515924]
}, Open  ]],
Cell[CellGroupData[{
Cell[5913, 146, 1312, 31, 159, "Input",
 CellID->556040499],
Cell[7228, 179, 542, 9, 70, "Output",
 CellID->214884057]
}, Open  ]],
Cell[CellGroupData[{
Cell[7807, 193, 166, 3, 70, "Input",
 CellID->285071838],
Cell[7976, 198, 806, 13, 70, "Print",
 CellTags->"Info3435388759-3264207",
 CellID->36552784]
}, Open  ]],
Cell[CellGroupData[{
Cell[8819, 216, 756, 12, 70, "Input",
 CellID->89789452],
Cell[9578, 230, 150, 3, 70, "Output",
 CellID->89371788]
}, Open  ]],
Cell[CellGroupData[{
Cell[9765, 238, 151, 3, 70, "Input",
 CellID->54297795],
Cell[9919, 243, 957, 14, 70, "Print",
 CellTags->"Info3435389287-8627628",
 CellID->43876303]
}, Open  ]],
Cell[CellGroupData[{
Cell[10913, 262, 170, 3, 70, "Input",
 CellID->89962295],
Cell[11086, 267, 358, 9, 70, "Output",
 CellID->671454485]
}, Open  ]],
Cell[CellGroupData[{
Cell[11481, 281, 653, 13, 70, "Input",
 CellID->687481774],
Cell[12137, 296, 368, 8, 70, "Message",
 CellID->94851958],
Cell[12508, 306, 189, 4, 70, "Output",
 CellID->82879033]
}, Open  ]],
Cell[CellGroupData[{
Cell[12734, 315, 155, 3, 70, "Input",
 CellID->519352462],
Cell[12892, 320, 838, 13, 70, "Print",
 CellTags->"Info3435388887-9482128",
 CellID->614717937]
}, Open  ]],
Cell[CellGroupData[{
Cell[13767, 338, 926, 18, 70, "Input",
 CellID->268853542],
Cell[14696, 358, 153, 3, 70, "Output",
 CellID->643243936]
}, Open  ]],
Cell[CellGroupData[{
Cell[14886, 366, 157, 3, 70, "Input",
 CellID->132384298],
Cell[15046, 371, 776, 12, 70, "Print",
 CellTags->"Info3435389198-6142479",
 CellID->121860254]
}, Open  ]],
Cell[CellGroupData[{
Cell[15859, 388, 371, 8, 70, "Input",
 CellID->618834484],
Cell[16233, 398, 106, 2, 70, "Output",
 CellID->149023742]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[16388, 406, 62, 1, 70, "Subsection",
 CellID->83021440],
Cell[CellGroupData[{
Cell[16475, 411, 124, 3, 70, "Input",
 CellID->40902715],
Cell[16602, 416, 737, 12, 70, "Print",
 CellTags->"Info3435387539-8100545",
 CellID->546823559]
}, Open  ]],
Cell[CellGroupData[{
Cell[17376, 433, 360, 8, 70, "Input",
 CellID->8219548],
Cell[17739, 443, 128, 2, 70, "Output",
 CellID->262297190]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[17916, 451, 681, 13, 70, "Subsection",
 CellID->3380915],
Cell[CellGroupData[{
Cell[18622, 468, 142, 3, 70, "Input",
 CellID->751986782],
Cell[18767, 473, 722, 12, 70, "Print",
 CellTags->"Info3435387872-1468815",
 CellID->50436986]
}, Open  ]],
Cell[CellGroupData[{
Cell[19526, 490, 158, 3, 70, "Input",
 CellID->757793036],
Cell[19687, 495, 266, 7, 70, "Output",
 CellID->556401592]
}, Open  ]],
Cell[CellGroupData[{
Cell[19990, 507, 867, 23, 70, "Input",
 CellID->245491713],
Cell[20860, 532, 177, 4, 70, "Output",
 CellID->857810752]
}, Open  ]],
Cell[CellGroupData[{
Cell[21074, 541, 143, 3, 70, "Input",
 CellID->82534691],
Cell[21220, 546, 335, 6, 70, "Print",
 CellTags->"Info3435388521-9596410",
 CellID->59044974]
}, Open  ]],
Cell[CellGroupData[{
Cell[21592, 557, 163, 3, 70, "Input",
 CellID->189266391],
Cell[21758, 562, 107, 3, 70, "Output",
 CellID->593230102]
}, Open  ]],
Cell[CellGroupData[{
Cell[21902, 570, 158, 3, 70, "Input",
 CellID->19032341],
Cell[22063, 575, 180, 4, 70, "Output",
 CellID->97808664]
}, Open  ]],
Cell[CellGroupData[{
Cell[22280, 584, 158, 3, 70, "Input",
 CellID->180851308],
Cell[22441, 589, 105, 2, 70, "Output",
 CellID->159969996]
}, Open  ]],
Cell[CellGroupData[{
Cell[22583, 596, 157, 3, 70, "Input",
 CellID->197979994],
Cell[22743, 601, 125, 3, 70, "Output",
 CellID->565254080]
}, Open  ]],
Cell[CellGroupData[{
Cell[22905, 609, 146, 3, 70, "Input",
 CellID->418526],
Cell[23054, 614, 410, 8, 70, "Print",
 CellTags->"Info3435388271-6962707",
 CellID->1630167]
}, Open  ]],
Cell[CellGroupData[{
Cell[23501, 627, 227, 5, 70, "Input",
 CellID->154646818],
Cell[23731, 634, 129, 2, 70, "Output",
 CellID->74894021]
}, Open  ]],
Cell[CellGroupData[{
Cell[23897, 641, 270, 6, 70, "Input",
 CellID->333022363],
Cell[24170, 649, 111, 2, 70, "Output",
 CellID->300014294]
}, Open  ]],
Cell[CellGroupData[{
Cell[24318, 656, 154, 3, 70, "Input",
 CellID->77124304],
Cell[24475, 661, 384, 7, 70, "Print",
 CellTags->"Info3435388327-2220734",
 CellID->112761867]
}, Open  ]],
Cell[CellGroupData[{
Cell[24896, 673, 166, 3, 70, "Input",
 CellID->94137841],
Cell[25065, 678, 130, 2, 70, "Output",
 CellID->303070072]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[25244, 686, 117, 2, 70, "Subsection",
 CellID->52610637],
Cell[CellGroupData[{
Cell[25386, 692, 116, 3, 70, "Input",
 CellID->363596359],
Cell[25505, 697, 755, 12, 70, "Print",
 CellTags->"Info3435385886-8359233",
 CellID->193426671]
}, Open  ]],
Cell[CellGroupData[{
Cell[26297, 714, 238, 6, 70, "Input",
 CellID->693633342],
Cell[26538, 722, 105, 2, 70, "Output",
 CellID->511668182]
}, Open  ]],
Cell[CellGroupData[{
Cell[26680, 729, 305, 6, 70, "Input",
 CellID->62553931],
Cell[26988, 737, 425, 8, 70, "Message",
 CellID->156018629],
Cell[27416, 747, 118, 2, 70, "Output",
 CellID->192374450]
}, Open  ]],
Cell[CellGroupData[{
Cell[27571, 754, 168, 3, 70, "Input",
 CellID->117952378],
Cell[27742, 759, 804, 13, 70, "Print",
 CellTags->"Info3435388834-9155320",
 CellID->317430210]
}, Open  ]],
Cell[CellGroupData[{
Cell[28583, 777, 132, 3, 31, "Input",
 CellID->1003214590],
Cell[28718, 782, 955, 15, 70, "Print",
 CellTags->"Info3435389635-1163190",
 CellID->243728729]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[29722, 803, 120, 2, 36, "Subsection",
 CellID->29737419],
Cell[CellGroupData[{
Cell[29867, 809, 191, 4, 28, "Input",
 CellID->539342551],
Cell[30061, 815, 504, 9, 97, "Print",
 CellTags->"Info3435389795-4410783",
 CellID->419977237]
}, Open  ]],
Cell[CellGroupData[{
Cell[30602, 829, 240, 5, 28, "Input",
 CellID->545969789],
Cell[30845, 836, 563, 9, 111, "Print",
 CellTags->"Info3435389800-7051366",
 CellID->92461416]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[31457, 851, 113, 2, 51, "Subsection",
 CellID->377882837],
Cell[CellGroupData[{
Cell[31595, 857, 138, 3, 28, "Input",
 CellID->51114645],
Cell[31736, 862, 424, 8, 83, "Print",
 CellTags->"Info3435389834-4925816",
 CellID->560772760]
}, Open  ]],
Cell[CellGroupData[{
Cell[32197, 875, 157, 4, 28, "Input",
 CellID->83626597],
Cell[32357, 881, 100, 2, 36, "Output",
 CellID->129183961]
}, Open  ]],
Cell[CellGroupData[{
Cell[32494, 888, 149, 3, 28, "Input",
 CellID->102626736],
Cell[32646, 893, 96, 2, 36, "Output",
 CellID->1993354]
}, Open  ]],
Cell[CellGroupData[{
Cell[32779, 900, 138, 3, 28, "Input",
 CellID->26281582],
Cell[CellGroupData[{
Cell[32942, 907, 148, 3, 42, "Print",
 CellTags->"Info3435390765-5726407",
 CellID->273292005],
Cell[33093, 912, 1719, 56, 233, "Print",
 CellTags->"Info3435390765-5726407",
 CellID->572435754]
}, Open  ]]
}, Open  ]]
}, Open  ]]
}, Open  ]]
}
]
*)

(* End of internal cache information *)
