(* Content-type: application/mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 6.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       145,          7]
NotebookDataLength[      7587,        287]
NotebookOptionsPosition[      3797,        146]
NotebookOutlinePosition[      6297,        234]
CellTagsIndexPosition[      6146,        226]
WindowFrame->Normal
ContainsDynamic->False*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell[BoxData["Processes"], "Chapter",
 CellTags->"Overview",
 CellID->188607145],

Cell["functions to construct and use Process objects.", "Text",
 CellTags->"Overview",
 CellID->2480785],

Cell["The first step is to load the QuantLib package. ", "MathCaption",
 CellTags->"Overview",
 CellID->293534442],

Cell["Needs[\"QuantLib`\"]", "Input",
 CellTags->"Overview",
 CellID->776948147],

Cell["\<\
Within the Processes part there is one constructor and no member functions \
available \
\>", "Text",
 CellChangeTimes->{{3.43607960503125*^9, 3.436079614546875*^9}},
 CellTags->"Overview",
 CellID->516691395],

Cell[CellGroupData[{

Cell["Select[Category[Processes],QLConstructor[#]&]", "Input",
 CellTags->"Overview",
 CellLabel->"In[1001]:=",
 CellID->69745592],

Cell[BoxData[
 RowBox[{"{", "GeneralizedBlackScholesProcess", "}"}]], "Output",
 CellChangeTimes->{3.436079619671875*^9},
 CellTags->"Overview",
 CellLabel->"Out[1001]=",
 CellID->126726630]
}, Open  ]],

Cell[CellGroupData[{

Cell["Select[Category[Processes],QLMember[#]&]", "Input",
 CellTags->"Overview",
 CellLabel->"In[1002]:=",
 CellID->235905639],

Cell[BoxData[
 RowBox[{"{", "}"}]], "Output",
 CellChangeTimes->{3.43607962071875*^9},
 CellTags->"Overview",
 CellLabel->"Out[1002]=",
 CellID->208856092]
}, Open  ]],

Cell[CellGroupData[{

Cell["Constructors", "Section",
 CellTags->"Constructo",
 CellID->574312228],

Cell[CellGroupData[{

Cell["GeneralizedBlackScholesProcess", "Subsection",
 CellTags->"Constructor",
 CellID->13586038],

Cell[BoxData[{Cell[BoxData[GridBox[{
    {"BlackVolID", "exampleValue", 
     RowBox[{"Black", " ", "Vol", " ", "Term", " ", 
      RowBox[{"Structure", "."}]}]},
    {"Underlying", "exampleValue", 
     RowBox[{"underlying", "."}]},
    {"SettlementDate", "exampleValue", 
     RowBox[{"settlement", " ", 
      RowBox[{"date", "."}]}]},
    {"RiskFreeRate", "exampleValue", 
     RowBox[{"risk", " ", "free", " ", 
      RowBox[{"rate", "."}]}]},
    {"DividendYield", "exampleValue", 
     RowBox[{"dividend", " ", 
      RowBox[{"yield", "."}]}]}
   }]], "DefinitionBox3Col",
  CellTags->"Constructor"], "\n", Cell["Calling Parameters", 
  "Caption"]}], "Input",
 CellID->97895361],

Cell[BoxData[{Cell[BoxData[GridBox[{
    {"DayCounter", "\"\<Actual/365 (Fixed)\>\"", 
     RowBox[{"DayCounter", " ", 
      RowBox[{"ID", "."}]}]}
   }]], "DefinitionBox3Col",
  CellTags->"Constructor"], "\n", Cell["Option Setting", "Caption"]}], "Input",\

 CellID->253347509],

Cell[BoxData[{
 RowBox[{
  RowBox[{"BlackVolID", "=", "exampleValue"}], ";"}], "\n", 
 RowBox[{
  RowBox[{"Underlying", "=", "exampleValue"}], ";"}], "\n", 
 RowBox[{
  RowBox[{"SettlementDate", "=", "exampleValue"}], ";"}], "\n", 
 RowBox[{
  RowBox[{"RiskFreeRate", "=", "exampleValue"}], ";"}], "\n", 
 RowBox[{
  RowBox[{"DividendYield", "=", "exampleValue"}], ";"}]}], "Input",
 CellTags->"Constructor",
 CellID->322887570],

Cell["\<\
obj=GeneralizedBlackScholesProcess[BlackVolID,Underlying,SettlementDate,\
RiskFreeRate,DividendYield]\
\>", "Input",
 CellTags->"Constructor",
 CellID->494246994]
}, Open  ]]
}, Open  ]],

Cell["Member function", "Section",
 CellTags->"Member",
 CellID->345013454]
}, Open  ]]
},
Editable->True,
WindowSize->{616, 750},
WindowMargins->{{Automatic, 648}, {Automatic, 95}},
DockedCells->FEPrivate`FrontEndResource[
 "FEExpressions", "HelpViewerToolbar"],
PageHeaders->{{None, None, None}, {None, None, 
   Cell[
    TextData[{
      Cell[
       TextData[{"Printed from [[YOUR APPLICATION'S NAME]] documentation "}], 
       "PageHeader"], 
      Cell[
       TextData[{
         CounterBox["Page"]}], "PageNumber"]}], 
    CellMargins -> {{Inherited, -29}, {Inherited, Inherited}}]}},
PageFooters->{{None, None, None}, {
   Cell[
    TextData[{"\[Copyright] 2008 Weber & Partner. All rights reserved."}], 
    "PageFooter"], None, None}},
TaggingRules->{"SearchTextTranslated" -> "", "SearchText" -> ""},
CreateCellID->True,
ShowCellTags->False,
FrontEndVersion->"6.0 for Microsoft Windows (32-bit) (May 21, 2008)",
StyleDefinitions->FrontEnd`FileName[{"Wolfram"}, "Reference.nb", 
  CharacterEncoding -> "WindowsANSI"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "Overview"->{
  Cell[590, 23, 80, 2, 99, "Chapter",
   CellTags->"Overview",
   CellID->188607145],
  Cell[673, 27, 104, 2, 37, "Text",
   CellTags->"Overview",
   CellID->2480785],
  Cell[780, 31, 114, 2, 31, "MathCaption",
   CellTags->"Overview",
   CellID->293534442],
  Cell[897, 35, 80, 2, 28, "Input",
   CellTags->"Overview",
   CellID->776948147],
  Cell[980, 39, 219, 6, 50, "Text",
   CellTags->"Overview",
   CellID->516691395],
  Cell[1224, 49, 130, 3, 28, "Input",
   CellTags->"Overview",
   CellID->69745592],
  Cell[1357, 54, 190, 5, 36, "Output",
   CellTags->"Overview",
   CellID->126726630],
  Cell[1584, 64, 126, 3, 28, "Input",
   CellTags->"Overview",
   CellID->235905639],
  Cell[1713, 69, 155, 5, 36, "Output",
   CellTags->"Overview",
   CellID->208856092]},
 "Constructo"->{
  Cell[1905, 79, 76, 2, 51, "Section",
   CellTags->"Constructo",
   CellID->574312228]},
 "Constructor"->{
  Cell[2006, 85, 97, 2, 51, "Subsection",
   CellTags->"Constructor",
   CellID->13586038],
  Cell[3076, 118, 428, 12, 101, "Input",
   CellTags->"Constructor",
   CellID->322887570],
  Cell[3507, 132, 172, 5, 28, "Input",
   CellTags->"Constructor",
   CellID->494246994]},
 "Member"->{
  Cell[3706, 141, 75, 2, 51, "Section",
   CellTags->"Member",
   CellID->345013454]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"Overview", 4850, 177},
 {"Constructo", 5640, 205},
 {"Constructor", 5748, 209},
 {"Member", 6036, 219}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[590, 23, 80, 2, 99, "Chapter",
 CellTags->"Overview",
 CellID->188607145],
Cell[673, 27, 104, 2, 37, "Text",
 CellTags->"Overview",
 CellID->2480785],
Cell[780, 31, 114, 2, 31, "MathCaption",
 CellTags->"Overview",
 CellID->293534442],
Cell[897, 35, 80, 2, 28, "Input",
 CellTags->"Overview",
 CellID->776948147],
Cell[980, 39, 219, 6, 50, "Text",
 CellTags->"Overview",
 CellID->516691395],
Cell[CellGroupData[{
Cell[1224, 49, 130, 3, 28, "Input",
 CellTags->"Overview",
 CellID->69745592],
Cell[1357, 54, 190, 5, 36, "Output",
 CellTags->"Overview",
 CellID->126726630]
}, Open  ]],
Cell[CellGroupData[{
Cell[1584, 64, 126, 3, 28, "Input",
 CellTags->"Overview",
 CellID->235905639],
Cell[1713, 69, 155, 5, 36, "Output",
 CellTags->"Overview",
 CellID->208856092]
}, Open  ]],
Cell[CellGroupData[{
Cell[1905, 79, 76, 2, 51, "Section",
 CellTags->"Constructo",
 CellID->574312228],
Cell[CellGroupData[{
Cell[2006, 85, 97, 2, 51, "Subsection",
 CellTags->"Constructor",
 CellID->13586038],
Cell[2106, 89, 685, 18, 128, "Input",
 CellID->97895361],
Cell[2794, 109, 279, 7, 82, "Input",
 CellID->253347509],
Cell[3076, 118, 428, 12, 101, "Input",
 CellTags->"Constructor",
 CellID->322887570],
Cell[3507, 132, 172, 5, 28, "Input",
 CellTags->"Constructor",
 CellID->494246994]
}, Open  ]]
}, Open  ]],
Cell[3706, 141, 75, 2, 51, "Section",
 CellTags->"Member",
 CellID->345013454]
}, Open  ]]
}
]
*)

(* End of internal cache information *)
