(* Content-type: application/mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 6.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       145,          7]
NotebookDataLength[     20518,        753]
NotebookOptionsPosition[     11973,        438]
NotebookOutlinePosition[     16651,        598]
CellTagsIndexPosition[     16496,        590]
WindowFrame->Normal
ContainsDynamic->False*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell[BoxData["Products"], "Chapter",
 CellTags->"Overview",
 CellID->442858697],

Cell["\<\
functions to construct and use Market Models Products objects.\
\>", "Text",
 CellTags->"Overview",
 CellID->78212178],

Cell["The first step is to load the QuantLib package. ", "MathCaption",
 CellTags->"Overview",
 CellID->540930861],

Cell["Needs[\"QuantLib`\"]", "Input",
 CellTags->"Overview",
 CellID->67831088],

Cell["\<\
Within the Products part there are several constructors and member functions \
available \
\>", "Text",
 CellTags->"Overview",
 CellID->673533630],

Cell[CellGroupData[{

Cell["Select[Category[Products],QLConstructor[#]&]", "Input",
 CellTags->"Overview",
 CellLabel->"In[45]:=",
 CellID->108747986],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "MarketModelMultiProductComposite", ",", "MarketModelMultiStepRatchet", ",",
    "MarketModelOneStepForwards", ",", "MarketModelOneStepOptionlets"}], 
  "}"}]], "Output",
 CellChangeTimes->{3.436080431921875*^9},
 CellTags->"Overview",
 CellLabel->"Out[45]=",
 CellID->512333790]
}, Open  ]],

Cell[CellGroupData[{

Cell["Select[Category[Products],QLMember[#]&]", "Input",
 CellTags->"Overview",
 CellLabel->"In[46]:=",
 CellID->883373421],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "MarketModelMultiProductCompositeAdd", ",", 
   "MarketModelMultiProductCompositeFinalize", ",", 
   "MarketModelMultiProductMaxNumberOfCashFlowsPerProductPerStep", ",", 
   "MarketModelMultiProductNumberOfProducts", ",", 
   "MarketModelMultiProductPossibleCashFlowTimes", ",", 
   "MarketModelMultiProductSuggestedNumeraires"}], "}"}]], "Output",
 CellChangeTimes->{3.436080433140625*^9},
 CellTags->"Overview",
 CellLabel->"Out[46]=",
 CellID->309150127]
}, Open  ]],

Cell[CellGroupData[{

Cell["Constructors", "Section",
 CellTags->"Constructo",
 CellID->205884407],

Cell[CellGroupData[{

Cell["MarketModelMultiProductComposite", "Subsubsection",
 CellTags->"Constructor",
 CellID->50381317],

Cell[CellGroupData[{

Cell["obj=MarketModelMultiProductComposite[]", "Input",
 CellTags->"Constructor",
 CellLabel->"In[47]:=",
 CellID->638326370],

Cell[BoxData["MarketModelMultiProductComposite1"], "Output",
 CellChangeTimes->{3.43608043540625*^9},
 CellTags->"Constructor",
 CellLabel->"Out[47]=",
 CellID->34105174]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["MarketModelOneStepForwards", "Subsubsection",
 CellTags->"Constructor",
 CellID->41818622],

Cell[BoxData[{Cell[BoxData[GridBox[{
    {"RateTimes", 
     RowBox[{
     "0.5", ",", "1.0", ",", "1.5", ",", "2.0", ",", "2.5", ",", "3.0", ",", 
      "3.5", ",", "4.0", ",", "4.5", ",", "5.0", ",", "5.5"}], 
     RowBox[{"rate", " ", "fixing", " ", 
      RowBox[{"times", "."}]}]},
    {"Accruals", 
     RowBox[{"1.0", ",", "1.0", ",", "1.0", ",", "1.0", ",", "1.0"}], 
     RowBox[{"accrual", " ", 
      RowBox[{"factors", "."}]}]},
    {"PaymentTimes", 
     RowBox[{"1.0", ",", "2.0", ",", "3.0", ",", "4.0", ",", "5.0"}], 
     RowBox[{"payment", " ", "times", " ", "of", " ", "the", " ", 
      RowBox[{"product", "."}]}]},
    {"Strikes", 
     RowBox[{"0.01", ",", "0.01", ",", "0.01", ",", "0.01", ",", "0.01"}], 
     RowBox[{"forward", " ", 
      RowBox[{"strikes", "."}]}]}
   }]], "DefinitionBox3Col",
  CellTags->"Constructor"], "\n", Cell["Calling Parameters", 
  "Caption"]}], "Input",
 CellID->295508747],

Cell[BoxData[{
 RowBox[{
  RowBox[{"RateTimes", "=", 
   RowBox[{"{", 
    RowBox[{
    "0.5", ",", "1.0", ",", "1.5", ",", "2.0", ",", "2.5", ",", "3.0", ",", 
     "3.5", ",", "4.0", ",", "4.5", ",", "5.0", ",", "5.5"}], "}"}]}], 
  ";"}], "\n", 
 RowBox[{
  RowBox[{"Accruals", "=", 
   RowBox[{"{", 
    RowBox[{"1.0", ",", "1.0", ",", "1.0", ",", "1.0", ",", "1.0"}], "}"}]}], 
  ";"}], "\n", 
 RowBox[{
  RowBox[{"PaymentTimes", "=", 
   RowBox[{"{", 
    RowBox[{"1.0", ",", "2.0", ",", "3.0", ",", "4.0", ",", "5.0"}], "}"}]}], 
  ";"}], "\n", 
 RowBox[{
  RowBox[{"Strikes", "=", 
   RowBox[{"{", 
    RowBox[{"0.01", ",", "0.01", ",", "0.01", ",", "0.01", ",", "0.01"}], 
    "}"}]}], ";"}]}], "Input",
 CellTags->"Constructor",
 CellLabel->"In[48]:=",
 CellID->60421796],

Cell[CellGroupData[{

Cell["\<\
obj=MarketModelOneStepForwards[RateTimes,Accruals,PaymentTimes,Strikes]\
\>", "Input",
 CellTags->"Constructor",
 CellLabel->"In[52]:=",
 CellID->85421646],

Cell[BoxData["MarketModelOneStepForwards1"], "Output",
 CellChangeTimes->{3.436080444140625*^9},
 CellTags->"Constructor",
 CellLabel->"Out[52]=",
 CellID->14145934]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["MarketModelMultiStepRatchet", "Subsubsection",
 CellTags->"Constructor",
 CellID->287922768],

Cell[BoxData[{Cell[BoxData[GridBox[{
    {"RateTimes", 
     RowBox[{
     "0.5", ",", "1.0", ",", "1.5", ",", "2.0", ",", "2.5", ",", "3.0", ",", 
      "3.5", ",", "4.0", ",", "4.5", ",", "5.0", ",", "5.5"}], 
     RowBox[{"rate", " ", "fixing", " ", 
      RowBox[{"times", "."}]}]},
    {"Accruals", 
     RowBox[{"1.0", ",", "1.0", ",", "1.0", ",", "1.0", ",", "1.0"}], 
     RowBox[{
     "accrual", " ", "factors", " ", "between", " ", "rate", " ", "fixing", 
      " ", 
      RowBox[{"times", "."}]}]},
    {"PaymentTimes", 
     RowBox[{"1.0", ",", "2.0", ",", "3.0", ",", "4.0", ",", "5.0"}], 
     RowBox[{"payment", " ", "times", " ", "of", " ", "the", " ", 
      RowBox[{"product", "."}]}]},
    {"GearingOfFloor", "1.0", 
     RowBox[{"gearing", " ", "of", " ", 
      RowBox[{"floor", "."}]}]},
    {"GearingOfFixing", "1.0", 
     RowBox[{"gearing", " ", "of", " ", 
      RowBox[{"fixing", "."}]}]},
    {"SpreadOfFloor", "0.0", 
     RowBox[{"spread", " ", "of", " ", 
      RowBox[{"floor", "."}]}]},
    {"SpreadOfFixing", "0.0", 
     RowBox[{"spread", " ", "of", " ", 
      RowBox[{"fixing", "."}]}]},
    {"InitialFloor", "0.01", 
     RowBox[{"initial", " ", 
      RowBox[{"floor", "."}]}]},
    {"Payer", "true", 
     RowBox[{"payer", " ", "if", " ", 
      RowBox[{"true", "."}]}]}
   }]], "DefinitionBox3Col",
  CellTags->"Constructor"], "\n", Cell["Calling Parameters", 
  "Caption"]}], "Input",
 CellID->596662],

Cell[BoxData[{
 RowBox[{
  RowBox[{"RateTimes", "=", 
   RowBox[{"{", 
    RowBox[{
    "0.5", ",", "1.0", ",", "1.5", ",", "2.0", ",", "2.5", ",", "3.0", ",", 
     "3.5", ",", "4.0", ",", "4.5", ",", "5.0", ",", "5.5"}], "}"}]}], 
  ";"}], "\n", 
 RowBox[{
  RowBox[{"Accruals", "=", 
   RowBox[{"{", 
    RowBox[{"1.0", ",", "1.0", ",", "1.0", ",", "1.0", ",", "1.0"}], "}"}]}], 
  ";"}], "\n", 
 RowBox[{
  RowBox[{"PaymentTimes", "=", 
   RowBox[{"{", 
    RowBox[{"1.0", ",", "2.0", ",", "3.0", ",", "4.0", ",", "5.0"}], "}"}]}], 
  ";"}], "\n", 
 RowBox[{
  RowBox[{"GearingOfFloor", "=", "1.0"}], ";"}], "\n", 
 RowBox[{
  RowBox[{"GearingOfFixing", "=", "1.0"}], ";"}], "\n", 
 RowBox[{
  RowBox[{"SpreadOfFloor", "=", "0.0"}], ";"}], "\n", 
 RowBox[{
  RowBox[{"SpreadOfFixing", "=", "0.0"}], ";"}], "\n", 
 RowBox[{
  RowBox[{"InitialFloor", "=", "0.01"}], ";"}], "\n", 
 RowBox[{
  RowBox[{"Payer", "=", "True"}], ";"}]}], "Input",
 CellChangeTimes->{3.43608045340625*^9},
 CellTags->"Constructor",
 CellLabel->"In[53]:=",
 CellID->309495118],

Cell[CellGroupData[{

Cell["\<\
obj=MarketModelMultiStepRatchet[RateTimes,Accruals,PaymentTimes,\
GearingOfFloor,GearingOfFixing,SpreadOfFloor,SpreadOfFixing,InitialFloor,\
Payer]\
\>", "Input",
 CellTags->"Constructor",
 CellLabel->"In[62]:=",
 CellID->46093528],

Cell[BoxData["MarketModelMultiStepRatchet1"], "Output",
 CellChangeTimes->{3.43608045525*^9},
 CellTags->"Constructor",
 CellLabel->"Out[62]=",
 CellID->196898814]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["MarketModelOneStepOptionlets", "Subsubsection",
 CellTags->"Constructor",
 CellID->51228286],

Cell[BoxData[{Cell[BoxData[GridBox[{
    {"RateTimes", 
     RowBox[{
     "0.5", ",", "1.0", ",", "1.5", ",", "2.0", ",", "2.5", ",", "3.0", ",", 
      "3.5", ",", "4.0", ",", "4.5", ",", "5.0", ",", "5.5"}], 
     RowBox[{"rate", " ", "fixing", " ", 
      RowBox[{"times", "."}]}]},
    {"Accruals", "exampleValue", 
     RowBox[{"accrual", " ", 
      RowBox[{"factors", "."}]}]},
    {"PaymentTimes", "exampleValue", 
     RowBox[{"payment", " ", "times", " ", "of", " ", "the", " ", 
      RowBox[{"product", "."}]}]},
    {"Payoffs", "exampleValue", 
     RowBox[{"striked", " ", "type", " ", "payoff", " ", "object", " ", 
      RowBox[{"IDs", "."}]}]}
   }]], "DefinitionBox3Col",
  CellTags->"Constructor"], "\n", Cell["Calling Parameters", 
  "Caption"]}], "Input",
 CellID->32020181],

Cell[BoxData[{
 RowBox[{
  RowBox[{"RateTimes", "=", 
   RowBox[{"{", 
    RowBox[{
    "0.5", ",", "1.0", ",", "1.5", ",", "2.0", ",", "2.5", ",", "3.0", ",", 
     "3.5", ",", "4.0", ",", "4.5", ",", "5.0", ",", "5.5"}], "}"}]}], 
  ";"}], "\n", 
 RowBox[{
  RowBox[{"Accruals", "=", 
   RowBox[{"{", "exampleValue", "}"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"PaymentTimes", "=", 
   RowBox[{"{", "exampleValue", "}"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"Payoffs", "=", 
   RowBox[{"{", "exampleValue", "}"}]}], ";"}]}], "Input",
 CellTags->"Constructor",
 CellID->511788531],

Cell["\<\
obj=MarketModelOneStepOptionlets[RateTimes,Accruals,PaymentTimes,Payoffs]\
\>", "Input",
 CellTags->"Constructor",
 CellID->193445516]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Member function", "Section",
 CellTags->"Member",
 CellID->89272553],

Cell[CellGroupData[{

Cell["MarketModelMultiProductCompositeAdd", "Subsubsection",
 CellTags->"Member",
 CellID->246159276],

Cell[BoxData[{Cell[BoxData[GridBox[{
    {"Product", "exampleValue", 
     RowBox[{"ID", " ", "of", " ", "product", " ", 
      RowBox[{"object", "."}]}]}
   }]], "DefinitionBox3Col",
  CellTags->"Member"], "\n", Cell["Calling Parameters", "Caption"]}], "Input",\

 CellID->112080960],

Cell[BoxData[
 RowBox[{
  RowBox[{"Product", "=", "exampleValue"}], ";"}]], "Input",
 CellTags->"Member",
 CellID->125701604],

Cell["MarketModelMultiProductCompositeAdd[obj,Product]", "Input",
 CellTags->"Member",
 CellID->47349344]
}, Open  ]],

Cell[CellGroupData[{

Cell["MarketModelMultiProductCompositeFinalize", "Subsubsection",
 CellTags->"Member",
 CellID->58126195],

Cell["MarketModelMultiProductCompositeFinalize[obj]", "Input",
 CellTags->"Member",
 CellLabel->"In[63]:=",
 CellID->204323204]
}, Open  ]],

Cell[CellGroupData[{

Cell["MarketModelMultiProductSuggestedNumeraires", "Subsubsection",
 CellTags->"Member",
 CellID->11702171],

Cell["MarketModelMultiProductSuggestedNumeraires[obj]", "Input",
 CellTags->"Member",
 CellID->428207106]
}, Open  ]],

Cell[CellGroupData[{

Cell["MarketModelMultiProductPossibleCashFlowTimes", "Subsubsection",
 CellTags->"Member",
 CellID->90222779],

Cell["MarketModelMultiProductPossibleCashFlowTimes[obj]", "Input",
 CellTags->"Member",
 CellID->78105633]
}, Open  ]],

Cell[CellGroupData[{

Cell["MarketModelMultiProductNumberOfProducts", "Subsubsection",
 CellTags->"Member",
 CellID->681019404],

Cell["MarketModelMultiProductNumberOfProducts[obj]", "Input",
 CellTags->"Member",
 CellID->8220037]
}, Open  ]],

Cell[CellGroupData[{

Cell["MarketModelMultiProductMaxNumberOfCashFlowsPerProductPerStep", \
"Subsubsection",
 CellTags->"Member",
 CellID->216526515],

Cell["\<\
MarketModelMultiProductMaxNumberOfCashFlowsPerProductPerStep[obj]\
\>", "Input",
 CellTags->"Member",
 CellID->143512846]
}, Open  ]]
}, Open  ]]
}, Open  ]]
},
Editable->True,
WindowSize->{616, 750},
WindowMargins->{{Automatic, 486}, {62, Automatic}},
DockedCells->FEPrivate`FrontEndResource[
 "FEExpressions", "HelpViewerToolbar"],
PageHeaders->{{None, None, None}, {None, None, 
   Cell[
    TextData[{
      Cell[
       TextData[{"Printed from [[YOUR APPLICATION'S NAME]] documentation "}], 
       "PageHeader"], 
      Cell[
       TextData[{
         CounterBox["Page"]}], "PageNumber"]}], 
    CellMargins -> {{Inherited, -29}, {Inherited, Inherited}}]}},
PageFooters->{{None, None, None}, {
   Cell[
    TextData[{"\[Copyright] 2008 Weber & Partner. All rights reserved."}], 
    "PageFooter"], None, None}},
TaggingRules->{"SearchTextTranslated" -> "", "SearchText" -> ""},
CreateCellID->True,
ShowCellTags->False,
FrontEndVersion->"6.0 for Microsoft Windows (32-bit) (May 21, 2008)",
StyleDefinitions->FrontEnd`FileName[{"Wolfram"}, "Reference.nb", 
  CharacterEncoding -> "WindowsANSI"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "Overview"->{
  Cell[590, 23, 79, 2, 99, "Chapter",
   CellTags->"Overview",
   CellID->442858697],
  Cell[672, 27, 128, 4, 37, "Text",
   CellTags->"Overview",
   CellID->78212178],
  Cell[803, 33, 114, 2, 53, "MathCaption",
   CellTags->"Overview",
   CellID->540930861],
  Cell[920, 37, 79, 2, 41, "Input",
   CellTags->"Overview",
   CellID->67831088],
  Cell[1002, 41, 156, 5, 37, "Text",
   CellTags->"Overview",
   CellID->673533630],
  Cell[1183, 50, 128, 3, 41, "Input",
   CellTags->"Overview",
   CellID->108747986],
  Cell[1314, 55, 321, 9, 59, "Output",
   CellTags->"Overview",
   CellID->512333790],
  Cell[1672, 69, 123, 3, 41, "Input",
   CellTags->"Overview",
   CellID->883373421],
  Cell[1798, 74, 499, 12, 135, "Output",
   CellTags->"Overview",
   CellID->309150127]},
 "Constructo"->{
  Cell[2334, 91, 76, 2, 77, "Section",
   CellTags->"Constructo",
   CellID->205884407]},
 "Constructor"->{
  Cell[2435, 97, 102, 2, 47, "Subsubsection",
   CellTags->"Constructor",
   CellID->50381317],
  Cell[2562, 103, 125, 3, 41, "Input",
   CellTags->"Constructor",
   CellID->638326370],
  Cell[2690, 108, 170, 4, 39, "Output",
   CellTags->"Constructor",
   CellID->34105174],
  Cell[2909, 118, 96, 2, 70, "Subsubsection",
   CellTags->"Constructor",
   CellID->41818622],
  Cell[3939, 146, 781, 25, 70, "Input",
   CellTags->"Constructor",
   CellID->60421796],
  Cell[4745, 175, 165, 5, 70, "Input",
   CellTags->"Constructor",
   CellID->85421646],
  Cell[4913, 182, 165, 4, 70, "Output",
   CellTags->"Constructor",
   CellID->14145934],
  Cell[5127, 192, 98, 2, 70, "Subsubsection",
   CellTags->"Constructor",
   CellID->287922768],
  Cell[6676, 236, 1054, 33, 70, "Input",
   CellTags->"Constructor",
   CellID->309495118],
  Cell[7755, 273, 241, 7, 70, "Input",
   CellTags->"Constructor",
   CellID->46093528],
  Cell[7999, 282, 163, 4, 70, "Output",
   CellTags->"Constructor",
   CellID->196898814],
  Cell[8211, 292, 98, 2, 30, "Subsubsection",
   CellTags->"Constructor",
   CellID->51228286],
  Cell[9111, 317, 580, 18, 83, "Input",
   CellTags->"Constructor",
   CellID->511788531],
  Cell[9694, 337, 144, 4, 28, "Input",
   CellTags->"Constructor",
   CellID->193445516]},
 "Member"->{
  Cell[9887, 347, 74, 2, 51, "Section",
   CellTags->"Member",
   CellID->89272553],
  Cell[9986, 353, 101, 2, 30, "Subsubsection",
   CellTags->"Member",
   CellID->246159276],
  Cell[10377, 366, 125, 4, 28, "Input",
   CellTags->"Member",
   CellID->125701604],
  Cell[10505, 372, 105, 2, 28, "Input",
   CellTags->"Member",
   CellID->47349344],
  Cell[10647, 379, 105, 2, 30, "Subsubsection",
   CellTags->"Member",
   CellID->58126195],
  Cell[10755, 383, 127, 3, 28, "Input",
   CellTags->"Member",
   CellID->204323204],
  Cell[10919, 391, 107, 2, 30, "Subsubsection",
   CellTags->"Member",
   CellID->11702171],
  Cell[11029, 395, 105, 2, 28, "Input",
   CellTags->"Member",
   CellID->428207106],
  Cell[11171, 402, 109, 2, 30, "Subsubsection",
   CellTags->"Member",
   CellID->90222779],
  Cell[11283, 406, 106, 2, 28, "Input",
   CellTags->"Member",
   CellID->78105633],
  Cell[11426, 413, 105, 2, 30, "Subsubsection",
   CellTags->"Member",
   CellID->681019404],
  Cell[11534, 417, 100, 2, 28, "Input",
   CellTags->"Member",
   CellID->8220037],
  Cell[11671, 424, 128, 3, 30, "Subsubsection",
   CellTags->"Member",
   CellID->216526515],
  Cell[11802, 429, 131, 4, 28, "Input",
   CellTags->"Member",
   CellID->143512846]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"Overview", 13026, 469},
 {"Constructo", 13820, 497},
 {"Constructor", 13928, 501},
 {"Member", 15229, 544}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[590, 23, 79, 2, 99, "Chapter",
 CellTags->"Overview",
 CellID->442858697],
Cell[672, 27, 128, 4, 37, "Text",
 CellTags->"Overview",
 CellID->78212178],
Cell[803, 33, 114, 2, 53, "MathCaption",
 CellTags->"Overview",
 CellID->540930861],
Cell[920, 37, 79, 2, 41, "Input",
 CellTags->"Overview",
 CellID->67831088],
Cell[1002, 41, 156, 5, 37, "Text",
 CellTags->"Overview",
 CellID->673533630],
Cell[CellGroupData[{
Cell[1183, 50, 128, 3, 41, "Input",
 CellTags->"Overview",
 CellID->108747986],
Cell[1314, 55, 321, 9, 59, "Output",
 CellTags->"Overview",
 CellID->512333790]
}, Open  ]],
Cell[CellGroupData[{
Cell[1672, 69, 123, 3, 41, "Input",
 CellTags->"Overview",
 CellID->883373421],
Cell[1798, 74, 499, 12, 135, "Output",
 CellTags->"Overview",
 CellID->309150127]
}, Open  ]],
Cell[CellGroupData[{
Cell[2334, 91, 76, 2, 77, "Section",
 CellTags->"Constructo",
 CellID->205884407],
Cell[CellGroupData[{
Cell[2435, 97, 102, 2, 47, "Subsubsection",
 CellTags->"Constructor",
 CellID->50381317],
Cell[CellGroupData[{
Cell[2562, 103, 125, 3, 41, "Input",
 CellTags->"Constructor",
 CellID->638326370],
Cell[2690, 108, 170, 4, 39, "Output",
 CellTags->"Constructor",
 CellID->34105174]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[2909, 118, 96, 2, 70, "Subsubsection",
 CellTags->"Constructor",
 CellID->41818622],
Cell[3008, 122, 928, 22, 70, "Input",
 CellID->295508747],
Cell[3939, 146, 781, 25, 70, "Input",
 CellTags->"Constructor",
 CellID->60421796],
Cell[CellGroupData[{
Cell[4745, 175, 165, 5, 70, "Input",
 CellTags->"Constructor",
 CellID->85421646],
Cell[4913, 182, 165, 4, 70, "Output",
 CellTags->"Constructor",
 CellID->14145934]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[5127, 192, 98, 2, 70, "Subsubsection",
 CellTags->"Constructor",
 CellID->287922768],
Cell[5228, 196, 1445, 38, 70, "Input",
 CellID->596662],
Cell[6676, 236, 1054, 33, 70, "Input",
 CellTags->"Constructor",
 CellID->309495118],
Cell[CellGroupData[{
Cell[7755, 273, 241, 7, 70, "Input",
 CellTags->"Constructor",
 CellID->46093528],
Cell[7999, 282, 163, 4, 70, "Output",
 CellTags->"Constructor",
 CellID->196898814]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[8211, 292, 98, 2, 30, "Subsubsection",
 CellTags->"Constructor",
 CellID->51228286],
Cell[8312, 296, 796, 19, 184, "Input",
 CellID->32020181],
Cell[9111, 317, 580, 18, 83, "Input",
 CellTags->"Constructor",
 CellID->511788531],
Cell[9694, 337, 144, 4, 28, "Input",
 CellTags->"Constructor",
 CellID->193445516]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[9887, 347, 74, 2, 51, "Section",
 CellTags->"Member",
 CellID->89272553],
Cell[CellGroupData[{
Cell[9986, 353, 101, 2, 30, "Subsubsection",
 CellTags->"Member",
 CellID->246159276],
Cell[10090, 357, 284, 7, 65, "Input",
 CellID->112080960],
Cell[10377, 366, 125, 4, 28, "Input",
 CellTags->"Member",
 CellID->125701604],
Cell[10505, 372, 105, 2, 28, "Input",
 CellTags->"Member",
 CellID->47349344]
}, Open  ]],
Cell[CellGroupData[{
Cell[10647, 379, 105, 2, 30, "Subsubsection",
 CellTags->"Member",
 CellID->58126195],
Cell[10755, 383, 127, 3, 28, "Input",
 CellTags->"Member",
 CellID->204323204]
}, Open  ]],
Cell[CellGroupData[{
Cell[10919, 391, 107, 2, 30, "Subsubsection",
 CellTags->"Member",
 CellID->11702171],
Cell[11029, 395, 105, 2, 28, "Input",
 CellTags->"Member",
 CellID->428207106]
}, Open  ]],
Cell[CellGroupData[{
Cell[11171, 402, 109, 2, 30, "Subsubsection",
 CellTags->"Member",
 CellID->90222779],
Cell[11283, 406, 106, 2, 28, "Input",
 CellTags->"Member",
 CellID->78105633]
}, Open  ]],
Cell[CellGroupData[{
Cell[11426, 413, 105, 2, 30, "Subsubsection",
 CellTags->"Member",
 CellID->681019404],
Cell[11534, 417, 100, 2, 28, "Input",
 CellTags->"Member",
 CellID->8220037]
}, Open  ]],
Cell[CellGroupData[{
Cell[11671, 424, 128, 3, 30, "Subsubsection",
 CellTags->"Member",
 CellID->216526515],
Cell[11802, 429, 131, 4, 28, "Input",
 CellTags->"Member",
 CellID->143512846]
}, Open  ]]
}, Open  ]]
}, Open  ]]
}
]
*)

(* End of internal cache information *)
