(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 8.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       157,          7]
NotebookDataLength[     38444,       1437]
NotebookOptionsPosition[     21711,        831]
NotebookOutlinePosition[     29952,       1107]
CellTagsIndexPosition[     29719,       1097]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell["Quotes", "Chapter",
 CellTags->"Overview",
 CellID->112781112],

Cell["quotes objects.", "Text",
 CellTags->"Overview",
 CellID->665085246],

Cell["The first step is to load the QuantLib package. ", "MathCaption",
 CellTags->"Overview",
 CellID->573841321],

Cell["Needs[\"QuantLib`\"]", "Input",
 CellTags->"Overview",
 CellLabel->"In[1]:=",
 CellID->42427051],

Cell["\<\
Within the Quotes part there are several constructors and member functions \
available \
\>", "Text",
 CellTags->"Overview",
 CellID->351874184],

Cell[CellGroupData[{

Cell["Select[Category[Quotes],QLConstructor[#]&]", "Input",
 CellTags->"Overview",
 CellLabel->"In[2]:=",
 CellID->164902284],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "CompositeQuote", ",", "EurodollarFuturesImpliedStdDevQuote", ",", 
   "ForwardSwapQuote", ",", "ForwardValueQuote", ",", 
   "FuturesConvAdjustmentQuote", ",", "ImpliedStdDevQuote", ",", 
   "LastFixingQuote", ",", "RelinkableHandleQuote", ",", "SimpleQuote"}], 
  "}"}]], "Output",
 CellTags->"Overview",
 CellLabel->"Out[2]=",
 CellID->325013517]
}, Open  ]],

Cell[CellGroupData[{

Cell["Select[Category[Quotes],QLMember[#]&]", "Input",
 CellTags->"Overview",
 CellLabel->"In[3]:=",
 CellID->156768225],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "FuturesConvAdjustmentQuoteFuturesValue", ",", 
   "FuturesConvAdjustmentQuoteImmDate", ",", 
   "FuturesConvAdjustmentQuoteMeanReversion", ",", 
   "FuturesConvAdjustmentQuoteVolatility", ",", 
   "LastFixingQuoteReferenceDate", ",", "QuoteIsValid", ",", "QuoteValue", 
   ",", "SimpleQuoteReset", ",", "SimpleQuoteSetTickValue", ",", 
   "SimpleQuoteSetValue", ",", "SimpleQuoteTickValue"}], "}"}]], "Output",
 CellTags->"Overview",
 CellLabel->"Out[3]=",
 CellID->670423336]
}, Open  ]],

Cell[CellGroupData[{

Cell["Select[Category[Quotes],QLProcedure[#]&]", "Input",
 CellTags->"Overview",
 CellLabel->"In[4]:=",
 CellID->115309688],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "BucketAnalysis", ",", "BucketAnalysisDelta", ",", "BucketAnalysisDelta2"}],
   "}"}]], "Output",
 CellTags->"Overview",
 CellLabel->"Out[4]=",
 CellID->344441995]
}, Open  ]],

Cell[CellGroupData[{

Cell["Constructors", "Section",
 CellTags->"Constructor",
 CellID->894270452],

Cell[CellGroupData[{

Cell["SimpleQuote", "Subsubsection",
 CellTags->"Constructor",
 CellID->565897010],

Cell[BoxData[{Cell[BoxData[GridBox[{
    {"TickValue", 
     RowBox[{
     "tick", " ", "value", " ", "used", " ", "for", " ", "sensitivity", " ", 
      RowBox[{"analysis", "."}]}]}
   }]], "DefinitionBox",
  CellTags->"Constructor"], "\n", Cell["Calling Parameters", 
  "Caption"]}], "Text",
 CellID->316150892],

Cell[BoxData[{Cell[BoxData[GridBox[{
    {"Value", 
     RowBox[{" ", "quote"}], 
     RowBox[{"The", " ", "default", " ", "is", " ", "0."}]}
   }]], "DefinitionBox3Col",
  CellTags->"Constructor"], "\n", Cell["Option Setting", "Caption"]}], "Text",
 CellChangeTimes->{{3.518854817921875*^9, 3.518854861359375*^9}},
 CellID->765390209],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"Needs", "[", "\"\<QuantLib`\>\"", "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"tickValue", "=", "0.0001"}], ";"}], "\n"}], "\n", 
 RowBox[{"obj", "=", 
  RowBox[{"SimpleQuote", "[", 
   RowBox[{"100", ",", 
    RowBox[{"TickValue", "->", "0.0001"}]}], "]"}]}]}], "Input",
 CellTags->"Constructor",
 CellLabel->"In[4]:=",
 CellID->353265970],

Cell[BoxData["SimpleQuote4"], "Output",
 CellTags->"Constructor",
 CellLabel->"Out[6]=",
 CellID->24444980]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["ForwardValueQuote", "Subsubsection",
 CellTags->"Constructor",
 CellID->9300861],

Cell[BoxData[{Cell[BoxData[GridBox[{
    {"IborIndex", 
     RowBox[{"floating", " ", "IborIndex", " ", "object", " ", 
      RowBox[{"ID", "."}]}]},
    {"FixingDate", 
     RowBox[{"Fixing", " ", 
      RowBox[{"Date", "."}]}]}
   }]], "DefinitionBox",
  CellTags->"Constructor"], "\n", Cell["Calling Parameters", 
  "Caption"]}], "Text",
 CellID->48919969],

Cell[BoxData[{
 RowBox[{
  RowBox[{"IborIndex", "=", "100"}], ";"}], "\n", 
 RowBox[{
  RowBox[{"FixingDate", "=", 
   RowBox[{"DatePlus", "[", 
    RowBox[{"{", 
     RowBox[{"1", ",", " ", "\"\<Week\>\""}], "}"}], "]"}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.518858147484375*^9, 3.518858152625*^9}, 
   3.51885836534375*^9},
 CellTags->"Constructor",
 CellLabel->"In[14]:=",
 CellID->179790153],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", "ForwardValueQuote"}]], "Input",
 CellLabel->"In[2]:=",
 CellID->210161672],

Cell["Cell$$9622`ForwardValueQuote", "Print", "PrintUsage",
 CellTags->"Info3563187862-3660874",
 CellID->72627127]
}, Open  ]],

Cell[CellGroupData[{

Cell["obj=ForwardValueQuote[IborIndex,FixingDate]", "Input",
 CellTags->"Constructor",
 CellLabel->"In[1]:=",
 CellID->265071718],

Cell[BoxData[
 RowBox[{"ForwardValueQuote", "[", 
  RowBox[{"IborIndex", ",", "FixingDate"}], "]"}]], "Output",
 CellTags->"Constructor",
 CellLabel->"Out[1]=",
 CellID->25627474]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["ForwardSwapQuote", "Subsubsection",
 CellTags->"Constructor",
 CellID->247792016],

Cell[BoxData[{Cell[BoxData[GridBox[{
    {"SwapIndex", 
     RowBox[{"floating", " ", "SwapIndex", " ", "object", " ", 
      RowBox[{"ID", "."}]}]},
    {"Spread", 
     RowBox[{"floating", " ", "leg", " ", 
      RowBox[{"spread", "."}]}]},
    {"ForwardStart", 
     RowBox[{"forward", " ", "start", " ", 
      RowBox[{"period", "."}]}]}
   }]], "DefinitionBox",
  CellTags->"Constructor"], "\n", Cell["Calling Parameters", 
  "Caption"]}], "Text",
 CellID->53329682],

Cell[BoxData[{
 RowBox[{
  RowBox[{"SwapIndex", "=", "exampleValue"}], ";"}], "\n", 
 RowBox[{
  RowBox[{"Spread", "=", "0.0"}], ";"}], "\n", 
 RowBox[{
  RowBox[{"ForwardStart", "=", "\"\<0D\>\""}], ";"}]}], "Input",
 CellTags->"Constructor",
 CellID->173642093],

Cell["obj=ForwardSwapQuote[SwapIndex,Spread,ForwardStart]", "Input",
 CellTags->"Constructor",
 CellID->13967106]
}, Open  ]],

Cell[CellGroupData[{

Cell["ImpliedStdDevQuote", "Subsubsection",
 CellTags->"Constructor",
 CellID->222720287],

Cell[BoxData[{Cell[BoxData[GridBox[{
    {"OptionType", 
     RowBox[{"option", " ", "type", " ", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{"i", ".", "e", ".", " ", "Call"}], " ", "or", " ", "Put"}], 
        ")"}], "."}]}]},
    {"AtmForwardValue", 
     RowBox[{
      RowBox[{"underlying", " ", "asset", " ", "at"}], "-", "the", "-", 
      RowBox[{"money", " ", "forward", " ", 
       RowBox[{"value", "."}]}]}]},
    {"OptionPrice", 
     RowBox[{"option", " ", 
      RowBox[{"price", "."}]}]},
    {"Strike", 
     RowBox[{"option", " ", 
      RowBox[{"strike", "."}]}]}
   }]], "DefinitionBox",
  CellTags->"Constructor"], "\n", Cell["Calling Parameters", 
  "Caption"]}], "Text",
 CellID->194981526],

Cell[BoxData[{Cell[BoxData[GridBox[{
    {"Guess", 
     RowBox[{
      RowBox[{"QuantLib", "::", "Null"}], "<", 
      RowBox[{"QuantLib", "::", "Real"}], ">", 
      RowBox[{"(", ")"}]}], 
     RowBox[{"implied", " ", "volatility", " ", 
      RowBox[{"guess", "."}]}]},
    {"Accuracy", 
     RowBox[{
      RowBox[{"1", "e"}], "-", "6"}], 
     RowBox[{"iv", " ", 
      RowBox[{"accuracy", "."}]}]}
   }]], "DefinitionBox3Col",
  CellTags->"Constructor"], "\n", Cell["Option Setting", "Caption"]}], "Text",
 CellID->48842924],

Cell[BoxData[{
 RowBox[{
  RowBox[{"OptionType", "=", "exampleValue"}], ";"}], "\n", 
 RowBox[{
  RowBox[{"AtmForwardValue", "=", "exampleValue"}], ";"}], "\n", 
 RowBox[{
  RowBox[{"OptionPrice", "=", "exampleValue"}], ";"}], "\n", 
 RowBox[{
  RowBox[{"Strike", "=", "exampleValue"}], ";"}]}], "Input",
 CellTags->"Constructor",
 CellID->76320460],

Cell["\<\
obj=ImpliedStdDevQuote[OptionType,AtmForwardValue,OptionPrice,Strike]\
\>", "Input",
 CellTags->"Constructor",
 CellID->71289989]
}, Open  ]],

Cell[CellGroupData[{

Cell["EurodollarFuturesImpliedStdDevQuote", "Subsubsection",
 CellTags->"Constructor",
 CellID->59411065],

Cell[BoxData[{Cell[BoxData[GridBox[{
    {"AtmForwardValue", 
     RowBox[{
      RowBox[{"underlying", " ", "asset", " ", "at"}], "-", "the", "-", 
      RowBox[{"money", " ", "forward", " ", 
       RowBox[{"value", "."}]}]}]},
    {"CallPrice", 
     RowBox[{"call", " ", "option", " ", 
      RowBox[{"price", "."}]}]},
    {"PutPrice", 
     RowBox[{"put", " ", "option", " ", 
      RowBox[{"price", "."}]}]},
    {"Strike", 
     RowBox[{"option", " ", 
      RowBox[{"strike", "."}]}]}
   }]], "DefinitionBox",
  CellTags->"Constructor"], "\n", Cell["Calling Parameters", 
  "Caption"]}], "Text",
 CellID->430873825],

Cell[BoxData[{Cell[BoxData[GridBox[{
    {"Guess", 
     RowBox[{
      RowBox[{"QuantLib", "::", "Null"}], "<", 
      RowBox[{"QuantLib", "::", "Real"}], ">", 
      RowBox[{"(", ")"}]}], 
     RowBox[{"implied", " ", "volatility", " ", 
      RowBox[{"guess", "."}]}]},
    {"Accuracy", 
     RowBox[{
      RowBox[{"1", "e"}], "-", "6"}], 
     RowBox[{"standard", " ", "deviation", " ", 
      RowBox[{"accuracy", "."}]}]}
   }]], "DefinitionBox3Col",
  CellTags->"Constructor"], "\n", Cell["Option Setting", "Caption"]}], "Text",
 CellID->29927949],

Cell[BoxData[{
 RowBox[{
  RowBox[{"AtmForwardValue", "=", "exampleValue"}], ";"}], "\n", 
 RowBox[{
  RowBox[{"CallPrice", "=", "exampleValue"}], ";"}], "\n", 
 RowBox[{
  RowBox[{"PutPrice", "=", "exampleValue"}], ";"}], "\n", 
 RowBox[{
  RowBox[{"Strike", "=", "exampleValue"}], ";"}]}], "Input",
 CellTags->"Constructor",
 CellID->851441258],

Cell["\<\
obj=EurodollarFuturesImpliedStdDevQuote[AtmForwardValue,CallPrice,PutPrice,\
Strike]\
\>", "Input",
 CellTags->"Constructor",
 CellID->219198656]
}, Open  ]],

Cell[CellGroupData[{

Cell["CompositeQuote", "Subsubsection",
 CellTags->"Constructor",
 CellID->298531029],

Cell[BoxData[{Cell[BoxData[GridBox[{
    {"Element1", 
     RowBox[{
      RowBox[{"the", " ", "first"}], ",", " ", 
      RowBox[{"i", ".", "e", ".", " ", "x"}], ",", " ", 
      RowBox[{"value", " ", "in", " ", "the", " ", "f", 
       RowBox[{"(", 
        RowBox[{"x", ",", "y"}], ")"}], " ", 
       RowBox[{"expression", "."}]}]}]},
    {"Element2", 
     RowBox[{
      RowBox[{"the", " ", "second"}], ",", " ", 
      RowBox[{"i", ".", "e", ".", " ", "y"}], ",", " ", 
      RowBox[{"value", " ", "in", " ", "the", " ", "f", 
       RowBox[{"(", 
        RowBox[{"x", ",", "y"}], ")"}], " ", 
       RowBox[{"expression", "."}]}]}]},
    {"Operator", 
     RowBox[{
      RowBox[{"the", " ", "operator", " ", "to", " ", "be", " ", "applied"}], 
      ",", " ", 
      RowBox[{
       RowBox[{"e", ".", "g", ".", " ", "\"\<\>\""}], "+", 
       RowBox[{"\"\<\>\"", " ", "or", " ", "\"\<\>\""}], "-", 
       RowBox[{"\"\<\>\"", "."}]}]}]}
   }]], "DefinitionBox",
  CellTags->"Constructor"], "\n", Cell["Calling Parameters", 
  "Caption"]}], "Text",
 CellID->12011538],

Cell[BoxData[{
 RowBox[{
  RowBox[{"Element1", "=", "exampleValue"}], ";"}], "\n", 
 RowBox[{
  RowBox[{"Element2", "=", "exampleValue"}], ";"}], "\n", 
 RowBox[{
  RowBox[{"Operator", "=", "exampleValue"}], ";"}]}], "Input",
 CellTags->"Constructor",
 CellID->81180960],

Cell["obj=CompositeQuote[Element1,Element2,Operator]", "Input",
 CellTags->"Constructor",
 CellID->1034581037]
}, Open  ]],

Cell[CellGroupData[{

Cell["FuturesConvAdjustmentQuote", "Subsubsection",
 CellTags->"Constructor",
 CellID->132397066],

Cell[BoxData[{Cell[BoxData[GridBox[{
    {"IborIndex", 
     RowBox[{"floating", " ", "IborIndex", " ", "object", " ", 
      RowBox[{"ID", "."}]}]},
    {"ImmCode", 
     RowBox[{"futures", " ", "IMM", " ", "code", " ", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"e", ".", "g", ".", " ", "H9"}], ")"}], "."}]}]},
    {"FuturesQuote", 
     RowBox[{"futures", " ", 
      RowBox[{"quote", "."}]}]},
    {"Volatility", 
     RowBox[{"HullWhite", " ", 
      RowBox[{"volatility", "."}]}]},
    {"MeanReversion", 
     RowBox[{"HullWhite", " ", "mean", " ", 
      RowBox[{"reversion", "."}]}]}
   }]], "DefinitionBox",
  CellTags->"Constructor"], "\n", Cell["Calling Parameters", 
  "Caption"]}], "Text",
 CellID->419453326],

Cell[BoxData[{
 RowBox[{
  RowBox[{"IborIndex", "=", "exampleValue"}], ";"}], "\n", 
 RowBox[{
  RowBox[{"ImmCode", "=", "exampleValue"}], ";"}], "\n", 
 RowBox[{
  RowBox[{"FuturesQuote", "=", "exampleValue"}], ";"}], "\n", 
 RowBox[{
  RowBox[{"Volatility", "=", "exampleValue"}], ";"}], "\n", 
 RowBox[{
  RowBox[{"MeanReversion", "=", "exampleValue"}], ";"}]}], "Input",
 CellTags->"Constructor",
 CellID->616548693],

Cell["\<\
obj=FuturesConvAdjustmentQuote[IborIndex,ImmCode,FuturesQuote,Volatility,\
MeanReversion]\
\>", "Input",
 CellTags->"Constructor",
 CellID->131010601]
}, Open  ]],

Cell[CellGroupData[{

Cell["LastFixingQuote", "Subsubsection",
 CellTags->"Constructor",
 CellID->420845],

Cell[BoxData[{Cell[BoxData[GridBox[{
    {"Index", 
     RowBox[{"Index", " ", "object", " ", 
      RowBox[{"ID", "."}]}]}
   }]], "DefinitionBox",
  CellTags->"Constructor"], "\n", Cell["Calling Parameters", 
  "Caption"]}], "Text",
 CellID->93301309],

Cell[BoxData[
 RowBox[{
  RowBox[{"Index", "=", "exampleValue"}], ";"}]], "Input",
 CellTags->"Constructor",
 CellID->466839275],

Cell["obj=LastFixingQuote[Index]", "Input",
 CellTags->"Constructor",
 CellID->140830782]
}, Open  ]],

Cell[CellGroupData[{

Cell["RelinkableHandleQuote", "Subsubsection",
 CellTags->"Constructor",
 CellID->223250485],

Cell[BoxData[{Cell[BoxData[GridBox[{
    {"CurrentLink", "\"\<\>\"", 
     RowBox[{
      RowBox[{"Quote", " ", "object", " ", 
       RowBox[{"ID", ".", " ", "If"}], " ", "omitted"}], ",", " ", 
      RowBox[{"nothing", " ", "is", " ", "linked", " ", "by", " ", "the", " ", 
       RowBox[{"RelinkableHandle", "."}]}]}]}
   }]], "DefinitionBox3Col",
  CellTags->"Constructor"], "\n", Cell["Option Setting", "Caption"]}], "Text",
 CellID->587164075],

Cell["obj=RelinkableHandleQuote[]", "Input",
 CellTags->"Constructor",
 CellID->411480662]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Member function", "Section",
 CellTags->"Member",
 CellID->168578490],

Cell[CellGroupData[{

Cell["QuoteValue", "Subsubsection",
 CellTags->"Member",
 CellID->260406118],

Cell["QuoteValue[obj]", "Input",
 CellTags->"Member",
 CellID->245024597]
}, Open  ]],

Cell[CellGroupData[{

Cell["QuoteIsValid", "Subsubsection",
 CellTags->"Member",
 CellID->229250533],

Cell["QuoteIsValid[obj]", "Input",
 CellTags->"Member",
 CellID->75987834]
}, Open  ]],

Cell[CellGroupData[{

Cell["SimpleQuoteReset", "Subsubsection",
 CellTags->"Member",
 CellID->79662780],

Cell["SimpleQuoteReset[obj]", "Input",
 CellTags->"Member",
 CellID->416707977]
}, Open  ]],

Cell[CellGroupData[{

Cell["SimpleQuoteSetValue", "Subsubsection",
 CellTags->"Member",
 CellID->553889],

Cell[BoxData[{Cell[BoxData[GridBox[{
    {"Value", 
     RowBox[{
      RowBox[{"QuantLib", "::", "Null"}], "<", 
      RowBox[{"QuantLib", "::", "Real"}], ">", 
      RowBox[{"(", ")"}]}], 
     RowBox[{"the", " ", "new", " ", 
      RowBox[{"value", "."}]}]}
   }]], "DefinitionBox3Col",
  CellTags->"Member"], "\n", Cell["Option Setting", "Caption"]}], "Text",
 CellID->227263235],

Cell["SimpleQuoteSetValue[obj]", "Input",
 CellTags->"Member",
 CellID->632138816]
}, Open  ]],

Cell[CellGroupData[{

Cell["SimpleQuoteSetTickValue", "Subsubsection",
 CellTags->"Member",
 CellID->56139349],

Cell[BoxData[{Cell[BoxData[GridBox[{
    {"Value", 
     RowBox[{"the", " ", "new", " ", "tick", " ", 
      RowBox[{"value", "."}]}]}
   }]], "DefinitionBox",
  CellTags->"Member"], "\n", Cell["Calling Parameters", "Caption"]}], "Text",
 CellID->407646678],

Cell[BoxData[
 RowBox[{
  RowBox[{"Value", "=", "0.0001"}], ";"}]], "Input",
 CellTags->"Member",
 CellID->173254513],

Cell["SimpleQuoteSetTickValue[obj,Value]", "Input",
 CellTags->"Member",
 CellID->6425100]
}, Open  ]],

Cell[CellGroupData[{

Cell["SimpleQuoteTickValue", "Subsubsection",
 CellTags->"Member",
 CellID->124659123],

Cell["SimpleQuoteTickValue[obj]", "Input",
 CellTags->"Member",
 CellID->310791]
}, Open  ]],

Cell[CellGroupData[{

Cell["FuturesConvAdjustmentQuoteVolatility", "Subsubsection",
 CellTags->"Member",
 CellID->149741302],

Cell["FuturesConvAdjustmentQuoteVolatility[obj]", "Input",
 CellTags->"Member",
 CellID->171910343]
}, Open  ]],

Cell[CellGroupData[{

Cell["FuturesConvAdjustmentQuoteMeanReversion", "Subsubsection",
 CellTags->"Member",
 CellID->258719742],

Cell["FuturesConvAdjustmentQuoteMeanReversion[obj]", "Input",
 CellTags->"Member",
 CellID->519067579]
}, Open  ]],

Cell[CellGroupData[{

Cell["FuturesConvAdjustmentQuoteImmDate", "Subsubsection",
 CellTags->"Member",
 CellID->59521104],

Cell["FuturesConvAdjustmentQuoteImmDate[obj]", "Input",
 CellTags->"Member",
 CellID->144107005]
}, Open  ]],

Cell[CellGroupData[{

Cell["FuturesConvAdjustmentQuoteFuturesValue", "Subsubsection",
 CellTags->"Member",
 CellID->10009499],

Cell["FuturesConvAdjustmentQuoteFuturesValue[obj]", "Input",
 CellTags->"Member",
 CellID->128550242]
}, Open  ]],

Cell[CellGroupData[{

Cell["LastFixingQuoteReferenceDate", "Subsubsection",
 CellTags->"Member",
 CellID->256644933],

Cell["LastFixingQuoteReferenceDate[obj]", "Input",
 CellTags->"Member",
 CellID->605447051]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Procedures", "Section",
 CellTags->"Procedure",
 CellID->910063687],

Cell[CellGroupData[{

Cell["BucketAnalysis", "Subsubsection",
 CellTags->"Procedure",
 CellID->236593279],

Cell[BoxData[{Cell[BoxData[GridBox[{
    {"SimpleQuote", 
     RowBox[{"simple", " ", 
      RowBox[{"quotes", "."}]}]},
    {"Instruments", 
     RowBox[{"instruments", "."}]},
    {"Quantities", 
     RowBox[{"quantities", "."}]}
   }]], "DefinitionBox",
  CellTags->"Procedure"], "\n", Cell["Calling Parameters", 
  "Caption"]}], "Text",
 CellID->171557316],

Cell[BoxData[{Cell[BoxData[GridBox[{
    {"Shift", "0.0001", 
     RowBox[{"shift", "."}]},
    {"SensitivityAnalysis", "\"\<Centered\>\"", 
     RowBox[{"SensitivityAnalysis", " ", 
      RowBox[{"type", "."}]}]}
   }]], "DefinitionBox3Col",
  CellTags->"Procedure"], "\n", Cell["Option Setting", "Caption"]}], "Text",
 CellID->857194722],

Cell[BoxData[{
 RowBox[{
  RowBox[{"SimpleQuote", "=", "exampleValue"}], ";"}], "\n", 
 RowBox[{
  RowBox[{"Instruments", "=", 
   RowBox[{"{", "exampleValue", "}"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"Quantities", "=", 
   RowBox[{"{", "exampleValue", "}"}]}], ";"}]}], "Input",
 CellTags->"Procedure",
 CellID->163184306],

Cell["BucketAnalysis[SimpleQuote,Instruments,Quantities]", "Input",
 CellTags->"Procedure",
 CellID->51999652]
}, Open  ]],

Cell[CellGroupData[{

Cell["BucketAnalysisDelta", "Subsubsection",
 CellTags->"Procedure",
 CellID->187010834],

Cell[BoxData[{Cell[BoxData[GridBox[{
    {"SimpleQuote", 
     RowBox[{"simple", " ", 
      RowBox[{"quote", "."}]}]},
    {"Parameters", 
     RowBox[{"parameters", " ", 
      RowBox[{"vector", "."}]}]}
   }]], "DefinitionBox",
  CellTags->"Procedure"], "\n", Cell["Calling Parameters", 
  "Caption"]}], "Text",
 CellID->400695940],

Cell[BoxData[{Cell[BoxData[GridBox[{
    {"Shift", "0.0001", 
     RowBox[{"shift", "."}]},
    {"SensitivityAnalysis", "\"\<Centered\>\"", 
     RowBox[{"SensitivityAnalysis", " ", 
      RowBox[{"type", "."}]}]}
   }]], "DefinitionBox3Col",
  CellTags->"Procedure"], "\n", Cell["Option Setting", "Caption"]}], "Text",
 CellID->109661010],

Cell[BoxData[{
 RowBox[{
  RowBox[{"SimpleQuote", "=", "exampleValue"}], ";"}], "\n", 
 RowBox[{
  RowBox[{"Parameters", "=", 
   RowBox[{"{", "exampleValue", "}"}]}], ";"}]}], "Input",
 CellTags->"Procedure",
 CellID->199430785],

Cell["BucketAnalysisDelta[SimpleQuote,Parameters]", "Input",
 CellTags->"Procedure",
 CellID->132322450]
}, Open  ]],

Cell[CellGroupData[{

Cell["BucketAnalysisDelta2", "Subsubsection",
 CellTags->"Procedure",
 CellID->129578317],

Cell[BoxData[{Cell[BoxData[GridBox[{
    {"SimpleQuote", 
     RowBox[{"simple", " ", 
      RowBox[{"quote", "."}]}]},
    {"Parameters", 
     RowBox[{"parameters", " ", 
      RowBox[{"vector", "."}]}]}
   }]], "DefinitionBox",
  CellTags->"Procedure"], "\n", Cell["Calling Parameters", 
  "Caption"]}], "Text",
 CellID->218984000],

Cell[BoxData[{Cell[BoxData[GridBox[{
    {"Shift", "0.0001", 
     RowBox[{"shift", "."}]},
    {"SensitivityAnalysis", "\"\<Centered\>\"", 
     RowBox[{"SensitivityAnalysis", " ", 
      RowBox[{"type", "."}]}]}
   }]], "DefinitionBox3Col",
  CellTags->"Procedure"], "\n", Cell["Option Setting", "Caption"]}], "Text",
 CellID->658054],

Cell[BoxData[{
 RowBox[{
  RowBox[{"SimpleQuote", "=", 
   RowBox[{"{", "exampleValue", "}"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"Parameters", "=", 
   RowBox[{"{", "exampleValue", "}"}]}], ";"}]}], "Input",
 CellTags->"Procedure",
 CellID->276591539],

Cell["BucketAnalysisDelta2[SimpleQuote,Parameters]", "Input",
 CellTags->"Procedure",
 CellID->436069981]
}, Open  ]]
}, Open  ]],

Cell["Enumeration Member", "Section",
 CellTags->"EnumerationMember",
 CellID->29054627]
}, Open  ]]
},
FileChangeProtection->None,
Editable->True,
WindowSize->{716, 867},
WindowMargins->{{Automatic, -2073}, {-30, Automatic}},
DockedCells->FEPrivate`FrontEndResource["FEExpressions", "HelpViewerToolbar"],
PageHeaders->{{None, None, None}, {None, None, 
   Cell[
    TextData[{
      Cell[
       TextData[{"Printed from [[YOUR APPLICATION'S NAME]] documentation "}], 
       "PageHeader"], 
      Cell[
       TextData[{
         CounterBox["Page"]}], "PageNumber"]}], 
    CellMargins -> {{Inherited, -29}, {Inherited, Inherited}}]}},
PageFooters->{{None, None, None}, {
   Cell[
    TextData[{"\[Copyright] 2008 Weber & Partner. All rights reserved."}], 
    "PageFooter"], None, None}},
ShowSelection->True,
TaggingRules->{"LinkTrails" -> "", "SearchTextTranslated" -> ""},
CreateCellID->True,
ShowCellTags->False,
FrontEndVersion->"8.0 for Microsoft Windows (32-bit) (October 6, 2011)",
StyleDefinitions->FrontEnd`FileName[{"Wolfram"}, "Reference.nb", 
  CharacterEncoding -> "WindowsANSI"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "Overview"->{
  Cell[579, 22, 68, 2, 85, "Chapter",
   CellTags->"Overview",
   CellID->112781112],
  Cell[650, 26, 74, 2, 30, "Text",
   CellTags->"Overview",
   CellID->665085246],
  Cell[727, 30, 114, 2, 31, "MathCaption",
   CellTags->"Overview",
   CellID->573841321],
  Cell[844, 34, 102, 3, 28, "Input",
   CellTags->"Overview",
   CellID->42427051],
  Cell[949, 39, 154, 5, 30, "Text",
   CellTags->"Overview",
   CellID->351874184],
  Cell[1128, 48, 125, 3, 28, "Input",
   CellTags->"Overview",
   CellID->164902284],
  Cell[1256, 53, 391, 10, 71, "Output",
   CellTags->"Overview",
   CellID->325013517],
  Cell[1684, 68, 120, 3, 28, "Input",
   CellTags->"Overview",
   CellID->156768225],
  Cell[1807, 73, 519, 12, 88, "Output",
   CellTags->"Overview",
   CellID->670423336],
  Cell[2363, 90, 123, 3, 28, "Input",
   CellTags->"Overview",
   CellID->115309688],
  Cell[2489, 95, 205, 7, 36, "Output",
   CellTags->"Overview",
   CellID->344441995]},
 "Constructor"->{
  Cell[2731, 107, 77, 2, 51, "Section",
   CellTags->"Constructor",
   CellID->894270452],
  Cell[2833, 113, 82, 2, 30, "Subsubsection",
   CellTags->"Constructor",
   CellID->565897010],
  Cell[3594, 138, 384, 11, 83, "Input",
   CellTags->"Constructor",
   CellID->353265970],
  Cell[3981, 151, 107, 3, 36, "Output",
   CellTags->"Constructor",
   CellID->24444980],
  Cell[4137, 160, 86, 2, 30, "Subsubsection",
   CellTags->"Constructor",
   CellID->9300861],
  Cell[4588, 176, 400, 12, 47, "Input",
   CellTags->"Constructor",
   CellID->179790153],
  Cell[5271, 204, 129, 3, 28, "Input",
   CellTags->"Constructor",
   CellID->265071718],
  Cell[5403, 209, 179, 5, 36, "Output",
   CellTags->"Constructor",
   CellID->25627474],
  Cell[5631, 220, 87, 2, 30, "Subsubsection",
   CellTags->"Constructor",
   CellID->247792016],
  Cell[6195, 239, 263, 8, 65, "Input",
   CellTags->"Constructor",
   CellID->173642093],
  Cell[6461, 249, 113, 2, 28, "Input",
   CellTags->"Constructor",
   CellID->13967106],
  Cell[6611, 256, 89, 2, 30, "Subsubsection",
   CellTags->"Constructor",
   CellID->222720287],
  Cell[7978, 301, 349, 10, 83, "Input",
   CellTags->"Constructor",
   CellID->76320460],
  Cell[8330, 313, 139, 4, 28, "Input",
   CellTags->"Constructor",
   CellID->71289989],
  Cell[8506, 322, 105, 2, 30, "Subsubsection",
   CellTags->"Constructor",
   CellID->59411065],
  Cell[9798, 363, 346, 10, 83, "Input",
   CellTags->"Constructor",
   CellID->851441258],
  Cell[10147, 375, 155, 5, 28, "Input",
   CellTags->"Constructor",
   CellID->219198656],
  Cell[10339, 385, 85, 2, 30, "Subsubsection",
   CellTags->"Constructor",
   CellID->298531029],
  Cell[11505, 419, 270, 8, 65, "Input",
   CellTags->"Constructor",
   CellID->81180960],
  Cell[11778, 429, 110, 2, 28, "Input",
   CellTags->"Constructor",
   CellID->1034581037],
  Cell[11925, 436, 97, 2, 30, "Subsubsection",
   CellTags->"Constructor",
   CellID->132397066],
  Cell[12761, 463, 420, 12, 101, "Input",
   CellTags->"Constructor",
   CellID->616548693],
  Cell[13184, 477, 160, 5, 28, "Input",
   CellTags->"Constructor",
   CellID->131010601],
  Cell[13381, 487, 83, 2, 30, "Subsubsection",
   CellTags->"Constructor",
   CellID->420845],
  Cell[13723, 500, 128, 4, 70, "Input",
   CellTags->"Constructor",
   CellID->466839275],
  Cell[13854, 506, 89, 2, 70, "Input",
   CellTags->"Constructor",
   CellID->140830782],
  Cell[13980, 513, 92, 2, 70, "Subsubsection",
   CellTags->"Constructor",
   CellID->223250485],
  Cell[14527, 528, 90, 2, 70, "Input",
   CellTags->"Constructor",
   CellID->411480662]},
 "Info3563187862-3660874"->{
  Cell[5119, 197, 115, 2, 42, "Print",
   CellTags->"Info3563187862-3660874",
   CellID->72627127]},
 "Member"->{
  Cell[14666, 536, 75, 2, 70, "Section",
   CellTags->"Member",
   CellID->168578490],
  Cell[14766, 542, 76, 2, 70, "Subsubsection",
   CellTags->"Member",
   CellID->260406118],
  Cell[14845, 546, 73, 2, 70, "Input",
   CellTags->"Member",
   CellID->245024597],
  Cell[14955, 553, 78, 2, 70, "Subsubsection",
   CellTags->"Member",
   CellID->229250533],
  Cell[15036, 557, 74, 2, 70, "Input",
   CellTags->"Member",
   CellID->75987834],
  Cell[15147, 564, 81, 2, 70, "Subsubsection",
   CellTags->"Member",
   CellID->79662780],
  Cell[15231, 568, 79, 2, 70, "Input",
   CellTags->"Member",
   CellID->416707977],
  Cell[15347, 575, 82, 2, 70, "Subsubsection",
   CellTags->"Member",
   CellID->553889],
  Cell[15818, 591, 82, 2, 70, "Input",
   CellTags->"Member",
   CellID->632138816],
  Cell[15937, 598, 88, 2, 70, "Subsubsection",
   CellTags->"Member",
   CellID->56139349],
  Cell[16288, 610, 117, 4, 70, "Input",
   CellTags->"Member",
   CellID->173254513],
  Cell[16408, 616, 90, 2, 70, "Input",
   CellTags->"Member",
   CellID->6425100],
  Cell[16535, 623, 86, 2, 70, "Subsubsection",
   CellTags->"Member",
   CellID->124659123],
  Cell[16624, 627, 80, 2, 70, "Input",
   CellTags->"Member",
   CellID->310791],
  Cell[16741, 634, 102, 2, 70, "Subsubsection",
   CellTags->"Member",
   CellID->149741302],
  Cell[16846, 638, 99, 2, 70, "Input",
   CellTags->"Member",
   CellID->171910343],
  Cell[16982, 645, 105, 2, 70, "Subsubsection",
   CellTags->"Member",
   CellID->258719742],
  Cell[17090, 649, 102, 2, 70, "Input",
   CellTags->"Member",
   CellID->519067579],
  Cell[17229, 656, 98, 2, 70, "Subsubsection",
   CellTags->"Member",
   CellID->59521104],
  Cell[17330, 660, 96, 2, 70, "Input",
   CellTags->"Member",
   CellID->144107005],
  Cell[17463, 667, 103, 2, 70, "Subsubsection",
   CellTags->"Member",
   CellID->10009499],
  Cell[17569, 671, 101, 2, 70, "Input",
   CellTags->"Member",
   CellID->128550242],
  Cell[17707, 678, 94, 2, 70, "Subsubsection",
   CellTags->"Member",
   CellID->256644933],
  Cell[17804, 682, 91, 2, 70, "Input",
   CellTags->"Member",
   CellID->605447051]},
 "Procedure"->{
  Cell[17944, 690, 73, 2, 70, "Section",
   CellTags->"Procedure",
   CellID->910063687],
  Cell[18042, 696, 83, 2, 47, "Subsubsection",
   CellTags->"Procedure",
   CellID->236593279],
  Cell[18833, 723, 325, 10, 65, "Input",
   CellTags->"Procedure",
   CellID->163184306],
  Cell[19161, 735, 110, 2, 28, "Input",
   CellTags->"Procedure",
   CellID->51999652],
  Cell[19308, 742, 88, 2, 30, "Subsubsection",
   CellTags->"Procedure",
   CellID->187010834],
  Cell[20078, 768, 229, 7, 47, "Input",
   CellTags->"Procedure",
   CellID->199430785],
  Cell[20310, 777, 104, 2, 28, "Input",
   CellTags->"Procedure",
   CellID->132322450],
  Cell[20451, 784, 89, 2, 30, "Subsubsection",
   CellTags->"Procedure",
   CellID->129578317],
  Cell[21219, 810, 253, 8, 47, "Input",
   CellTags->"Procedure",
   CellID->276591539],
  Cell[21475, 820, 105, 2, 28, "Input",
   CellTags->"Procedure",
   CellID->436069981]},
 "EnumerationMember"->{
  Cell[21607, 826, 88, 2, 51, "Section",
   CellTags->"EnumerationMember",
   CellID->29054627]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"Overview", 22817, 863},
 {"Constructor", 23785, 897},
 {"Info3563187862-3660874", 26407, 982},
 {"Member", 26521, 986},
 {"Procedure", 28661, 1059},
 {"EnumerationMember", 29598, 1090}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[579, 22, 68, 2, 85, "Chapter",
 CellTags->"Overview",
 CellID->112781112],
Cell[650, 26, 74, 2, 30, "Text",
 CellTags->"Overview",
 CellID->665085246],
Cell[727, 30, 114, 2, 31, "MathCaption",
 CellTags->"Overview",
 CellID->573841321],
Cell[844, 34, 102, 3, 28, "Input",
 CellTags->"Overview",
 CellID->42427051],
Cell[949, 39, 154, 5, 30, "Text",
 CellTags->"Overview",
 CellID->351874184],
Cell[CellGroupData[{
Cell[1128, 48, 125, 3, 28, "Input",
 CellTags->"Overview",
 CellID->164902284],
Cell[1256, 53, 391, 10, 71, "Output",
 CellTags->"Overview",
 CellID->325013517]
}, Open  ]],
Cell[CellGroupData[{
Cell[1684, 68, 120, 3, 28, "Input",
 CellTags->"Overview",
 CellID->156768225],
Cell[1807, 73, 519, 12, 88, "Output",
 CellTags->"Overview",
 CellID->670423336]
}, Open  ]],
Cell[CellGroupData[{
Cell[2363, 90, 123, 3, 28, "Input",
 CellTags->"Overview",
 CellID->115309688],
Cell[2489, 95, 205, 7, 36, "Output",
 CellTags->"Overview",
 CellID->344441995]
}, Open  ]],
Cell[CellGroupData[{
Cell[2731, 107, 77, 2, 51, "Section",
 CellTags->"Constructor",
 CellID->894270452],
Cell[CellGroupData[{
Cell[2833, 113, 82, 2, 30, "Subsubsection",
 CellTags->"Constructor",
 CellID->565897010],
Cell[2918, 117, 313, 8, 67, "Text",
 CellID->316150892],
Cell[3234, 127, 335, 7, 84, "Text",
 CellID->765390209],
Cell[CellGroupData[{
Cell[3594, 138, 384, 11, 83, "Input",
 CellTags->"Constructor",
 CellID->353265970],
Cell[3981, 151, 107, 3, 36, "Output",
 CellTags->"Constructor",
 CellID->24444980]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[4137, 160, 86, 2, 30, "Subsubsection",
 CellTags->"Constructor",
 CellID->9300861],
Cell[4226, 164, 359, 10, 81, "Text",
 CellID->48919969],
Cell[4588, 176, 400, 12, 47, "Input",
 CellTags->"Constructor",
 CellID->179790153],
Cell[CellGroupData[{
Cell[5013, 192, 103, 3, 28, "Input",
 CellID->210161672],
Cell[5119, 197, 115, 2, 42, "Print",
 CellTags->"Info3563187862-3660874",
 CellID->72627127]
}, Open  ]],
Cell[CellGroupData[{
Cell[5271, 204, 129, 3, 28, "Input",
 CellTags->"Constructor",
 CellID->265071718],
Cell[5403, 209, 179, 5, 36, "Output",
 CellTags->"Constructor",
 CellID->25627474]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[5631, 220, 87, 2, 30, "Subsubsection",
 CellTags->"Constructor",
 CellID->247792016],
Cell[5721, 224, 471, 13, 98, "Text",
 CellID->53329682],
Cell[6195, 239, 263, 8, 65, "Input",
 CellTags->"Constructor",
 CellID->173642093],
Cell[6461, 249, 113, 2, 28, "Input",
 CellTags->"Constructor",
 CellID->13967106]
}, Open  ]],
Cell[CellGroupData[{
Cell[6611, 256, 89, 2, 30, "Subsubsection",
 CellTags->"Constructor",
 CellID->222720287],
Cell[6703, 260, 739, 22, 114, "Text",
 CellID->194981526],
Cell[7445, 284, 530, 15, 136, "Text",
 CellID->48842924],
Cell[7978, 301, 349, 10, 83, "Input",
 CellTags->"Constructor",
 CellID->76320460],
Cell[8330, 313, 139, 4, 28, "Input",
 CellTags->"Constructor",
 CellID->71289989]
}, Open  ]],
Cell[CellGroupData[{
Cell[8506, 322, 105, 2, 30, "Subsubsection",
 CellTags->"Constructor",
 CellID->59411065],
Cell[8614, 326, 624, 18, 114, "Text",
 CellID->430873825],
Cell[9241, 346, 554, 15, 136, "Text",
 CellID->29927949],
Cell[9798, 363, 346, 10, 83, "Input",
 CellTags->"Constructor",
 CellID->851441258],
Cell[10147, 375, 155, 5, 28, "Input",
 CellTags->"Constructor",
 CellID->219198656]
}, Open  ]],
Cell[CellGroupData[{
Cell[10339, 385, 85, 2, 30, "Subsubsection",
 CellTags->"Constructor",
 CellID->298531029],
Cell[10427, 389, 1075, 28, 141, "Text",
 CellID->12011538],
Cell[11505, 419, 270, 8, 65, "Input",
 CellTags->"Constructor",
 CellID->81180960],
Cell[11778, 429, 110, 2, 28, "Input",
 CellTags->"Constructor",
 CellID->1034581037]
}, Open  ]],
Cell[CellGroupData[{
Cell[11925, 436, 97, 2, 30, "Subsubsection",
 CellTags->"Constructor",
 CellID->132397066],
Cell[12025, 440, 733, 21, 131, "Text",
 CellID->419453326],
Cell[12761, 463, 420, 12, 101, "Input",
 CellTags->"Constructor",
 CellID->616548693],
Cell[13184, 477, 160, 5, 28, "Input",
 CellTags->"Constructor",
 CellID->131010601]
}, Open  ]],
Cell[CellGroupData[{
Cell[13381, 487, 83, 2, 30, "Subsubsection",
 CellTags->"Constructor",
 CellID->420845],
Cell[13467, 491, 253, 7, 70, "Text",
 CellID->93301309],
Cell[13723, 500, 128, 4, 70, "Input",
 CellTags->"Constructor",
 CellID->466839275],
Cell[13854, 506, 89, 2, 70, "Input",
 CellTags->"Constructor",
 CellID->140830782]
}, Open  ]],
Cell[CellGroupData[{
Cell[13980, 513, 92, 2, 70, "Subsubsection",
 CellTags->"Constructor",
 CellID->223250485],
Cell[14075, 517, 449, 9, 70, "Text",
 CellID->587164075],
Cell[14527, 528, 90, 2, 70, "Input",
 CellTags->"Constructor",
 CellID->411480662]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[14666, 536, 75, 2, 70, "Section",
 CellTags->"Member",
 CellID->168578490],
Cell[CellGroupData[{
Cell[14766, 542, 76, 2, 70, "Subsubsection",
 CellTags->"Member",
 CellID->260406118],
Cell[14845, 546, 73, 2, 70, "Input",
 CellTags->"Member",
 CellID->245024597]
}, Open  ]],
Cell[CellGroupData[{
Cell[14955, 553, 78, 2, 70, "Subsubsection",
 CellTags->"Member",
 CellID->229250533],
Cell[15036, 557, 74, 2, 70, "Input",
 CellTags->"Member",
 CellID->75987834]
}, Open  ]],
Cell[CellGroupData[{
Cell[15147, 564, 81, 2, 70, "Subsubsection",
 CellTags->"Member",
 CellID->79662780],
Cell[15231, 568, 79, 2, 70, "Input",
 CellTags->"Member",
 CellID->416707977]
}, Open  ]],
Cell[CellGroupData[{
Cell[15347, 575, 82, 2, 70, "Subsubsection",
 CellTags->"Member",
 CellID->553889],
Cell[15432, 579, 383, 10, 70, "Text",
 CellID->227263235],
Cell[15818, 591, 82, 2, 70, "Input",
 CellTags->"Member",
 CellID->632138816]
}, Open  ]],
Cell[CellGroupData[{
Cell[15937, 598, 88, 2, 70, "Subsubsection",
 CellTags->"Member",
 CellID->56139349],
Cell[16028, 602, 257, 6, 70, "Text",
 CellID->407646678],
Cell[16288, 610, 117, 4, 70, "Input",
 CellTags->"Member",
 CellID->173254513],
Cell[16408, 616, 90, 2, 70, "Input",
 CellTags->"Member",
 CellID->6425100]
}, Open  ]],
Cell[CellGroupData[{
Cell[16535, 623, 86, 2, 70, "Subsubsection",
 CellTags->"Member",
 CellID->124659123],
Cell[16624, 627, 80, 2, 70, "Input",
 CellTags->"Member",
 CellID->310791]
}, Open  ]],
Cell[CellGroupData[{
Cell[16741, 634, 102, 2, 70, "Subsubsection",
 CellTags->"Member",
 CellID->149741302],
Cell[16846, 638, 99, 2, 70, "Input",
 CellTags->"Member",
 CellID->171910343]
}, Open  ]],
Cell[CellGroupData[{
Cell[16982, 645, 105, 2, 70, "Subsubsection",
 CellTags->"Member",
 CellID->258719742],
Cell[17090, 649, 102, 2, 70, "Input",
 CellTags->"Member",
 CellID->519067579]
}, Open  ]],
Cell[CellGroupData[{
Cell[17229, 656, 98, 2, 70, "Subsubsection",
 CellTags->"Member",
 CellID->59521104],
Cell[17330, 660, 96, 2, 70, "Input",
 CellTags->"Member",
 CellID->144107005]
}, Open  ]],
Cell[CellGroupData[{
Cell[17463, 667, 103, 2, 70, "Subsubsection",
 CellTags->"Member",
 CellID->10009499],
Cell[17569, 671, 101, 2, 70, "Input",
 CellTags->"Member",
 CellID->128550242]
}, Open  ]],
Cell[CellGroupData[{
Cell[17707, 678, 94, 2, 70, "Subsubsection",
 CellTags->"Member",
 CellID->256644933],
Cell[17804, 682, 91, 2, 70, "Input",
 CellTags->"Member",
 CellID->605447051]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[17944, 690, 73, 2, 70, "Section",
 CellTags->"Procedure",
 CellID->910063687],
Cell[CellGroupData[{
Cell[18042, 696, 83, 2, 47, "Subsubsection",
 CellTags->"Procedure",
 CellID->236593279],
Cell[18128, 700, 360, 11, 98, "Text",
 CellID->171557316],
Cell[18491, 713, 339, 8, 98, "Text",
 CellID->857194722],
Cell[18833, 723, 325, 10, 65, "Input",
 CellTags->"Procedure",
 CellID->163184306],
Cell[19161, 735, 110, 2, 28, "Input",
 CellTags->"Procedure",
 CellID->51999652]
}, Open  ]],
Cell[CellGroupData[{
Cell[19308, 742, 88, 2, 30, "Subsubsection",
 CellTags->"Procedure",
 CellID->187010834],
Cell[19399, 746, 334, 10, 81, "Text",
 CellID->400695940],
Cell[19736, 758, 339, 8, 98, "Text",
 CellID->109661010],
Cell[20078, 768, 229, 7, 47, "Input",
 CellTags->"Procedure",
 CellID->199430785],
Cell[20310, 777, 104, 2, 28, "Input",
 CellTags->"Procedure",
 CellID->132322450]
}, Open  ]],
Cell[CellGroupData[{
Cell[20451, 784, 89, 2, 30, "Subsubsection",
 CellTags->"Procedure",
 CellID->129578317],
Cell[20543, 788, 334, 10, 81, "Text",
 CellID->218984000],
Cell[20880, 800, 336, 8, 98, "Text",
 CellID->658054],
Cell[21219, 810, 253, 8, 47, "Input",
 CellTags->"Procedure",
 CellID->276591539],
Cell[21475, 820, 105, 2, 28, "Input",
 CellTags->"Procedure",
 CellID->436069981]
}, Open  ]]
}, Open  ]],
Cell[21607, 826, 88, 2, 51, "Section",
 CellTags->"EnumerationMember",
 CellID->29054627]
}, Open  ]]
}
]
*)

(* End of internal cache information *)
