(* Content-type: application/mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 6.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       145,          7]
NotebookDataLength[     14274,        571]
NotebookOptionsPosition[      7004,        302]
NotebookOutlinePosition[     11044,        441]
CellTagsIndexPosition[     10892,        433]
WindowFrame->Normal
ContainsDynamic->False*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell[BoxData["RandomSequenceGenerator"], "Chapter",
 CellTags->"Overview",
 CellID->239531684],

Cell["functions to construct and use random sequences generators.", "Text",
 CellTags->"Overview",
 CellID->148416870],

Cell["The first step is to load the QuantLib package. ", "MathCaption",
 CellTags->"Overview",
 CellID->366772592],

Cell["Needs[\"QuantLib`\"]", "Input",
 CellTags->"Overview",
 CellID->700194112],

Cell["\<\
Within the RandomSequenceGenerator part there are several constructors and \
member functions available \
\>", "Text",
 CellTags->"Overview",
 CellID->470303382],

Cell[CellGroupData[{

Cell["Select[Category[RandomSequenceGenerator],QLConstructor[#]&]", "Input",
 CellTags->"Overview",
 CellLabel->"In[91]:=",
 CellID->504072341],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "FaureRsg", ",", "HaltonRsg", ",", "MersenneTwisterRsg", ",", "SobolRsg"}], 
  "}"}]], "Output",
 CellChangeTimes->{3.436080506453125*^9},
 CellTags->"Overview",
 CellLabel->"Out[91]=",
 CellID->597202300]
}, Open  ]],

Cell[CellGroupData[{

Cell["Select[Category[RandomSequenceGenerator],QLMember[#]&]", "Input",
 CellTags->"Overview",
 CellLabel->"In[92]:=",
 CellID->78276669],

Cell[BoxData[
 RowBox[{"{", "Variates", "}"}]], "Output",
 CellChangeTimes->{3.4360805075*^9},
 CellTags->"Overview",
 CellLabel->"Out[92]=",
 CellID->138481910]
}, Open  ]],

Cell[CellGroupData[{

Cell["Constructors", "Section",
 CellTags->"Constructo",
 CellID->290976781],

Cell[CellGroupData[{

Cell["MersenneTwisterRsg", "Subsubsection",
 CellTags->"Constructor",
 CellID->525358681],

Cell[BoxData[{Cell[BoxData[GridBox[{
    {"Dimension", "3", 
     RowBox[{"dimension", "."}]},
    {"Seed", "2", 
     RowBox[{"seed", "."}]}
   }]], "DefinitionBox3Col",
  CellTags->"Constructor"], "\n", Cell["Calling Parameters", 
  "Caption"]}], "Input",
 CellID->149226550],

Cell[BoxData[{
 RowBox[{
  RowBox[{"Dimension", "=", "3"}], ";"}], "\n", 
 RowBox[{
  RowBox[{"Seed", "=", "2"}], ";"}]}], "Input",
 CellTags->"Constructor",
 CellLabel->"In[93]:=",
 CellID->114379857],

Cell[CellGroupData[{

Cell["obj=MersenneTwisterRsg[Dimension,Seed]", "Input",
 CellTags->"Constructor",
 CellLabel->"In[95]:=",
 CellID->2672587],

Cell[BoxData["MersenneTwisterRsg1"], "Output",
 CellChangeTimes->{3.436080512046875*^9},
 CellTags->"Constructor",
 CellLabel->"Out[95]=",
 CellID->68283670]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["FaureRsg", "Subsubsection",
 CellTags->"Constructor",
 CellID->46875049],

Cell[BoxData[{Cell[BoxData[GridBox[{
    {"Dimension", "2", 
     RowBox[{"dimension", "."}]}
   }]], "DefinitionBox3Col",
  CellTags->"Constructor"], "\n", Cell["Calling Parameters", 
  "Caption"]}], "Input",
 CellID->605096492],

Cell[BoxData[
 RowBox[{
  RowBox[{"Dimension", "=", "2"}], ";"}]], "Input",
 CellTags->"Constructor",
 CellLabel->"In[96]:=",
 CellID->38859808],

Cell[CellGroupData[{

Cell["obj=FaureRsg[Dimension]", "Input",
 CellTags->"Constructor",
 CellLabel->"In[97]:=",
 CellID->463130054],

Cell[BoxData["FaureRsg1"], "Output",
 CellChangeTimes->{3.436080516625*^9},
 CellTags->"Constructor",
 CellLabel->"Out[97]=",
 CellID->416750620]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["HaltonRsg", "Subsubsection",
 CellTags->"Constructor",
 CellID->62054429],

Cell[BoxData[{Cell[BoxData[GridBox[{
    {"Dimension", "2", 
     RowBox[{"dimension", "."}]},
    {"Seed", "2", 
     RowBox[{"seed", "."}]}
   }]], "DefinitionBox3Col",
  CellTags->"Constructor"], "\n", Cell["Calling Parameters", 
  "Caption"]}], "Input",
 CellID->169458985],

Cell[BoxData[{
 RowBox[{
  RowBox[{"Dimension", "=", "2"}], ";"}], "\n", 
 RowBox[{
  RowBox[{"Seed", "=", "2"}], ";"}]}], "Input",
 CellTags->"Constructor",
 CellLabel->"In[98]:=",
 CellID->134727261],

Cell[CellGroupData[{

Cell["obj=HaltonRsg[Dimension,Seed]", "Input",
 CellTags->"Constructor",
 CellLabel->"In[100]:=",
 CellID->667093438],

Cell[BoxData["HaltonRsg1"], "Output",
 CellChangeTimes->{3.436080523421875*^9},
 CellTags->"Constructor",
 CellLabel->"Out[100]=",
 CellID->58796001]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["SobolRsg", "Subsubsection",
 CellTags->"Constructor",
 CellID->13424199],

Cell[BoxData[{Cell[BoxData[GridBox[{
    {"Dimension", "3", 
     RowBox[{"dimension", "."}]},
    {"Seed", "2", 
     RowBox[{"seed", "."}]}
   }]], "DefinitionBox3Col",
  CellTags->"Constructor"], "\n", Cell["Calling Parameters", 
  "Caption"]}], "Input",
 EmphasizeSyntaxErrors->True,
 CellLabel->"In[101]:=",
 CellID->22424220],

Cell[BoxData[{
 RowBox[{
  RowBox[{"Dimension", "=", "3"}], ";"}], "\n", 
 RowBox[{
  RowBox[{"Seed", "=", "2"}], ";"}]}], "Input",
 CellTags->"Constructor",
 CellLabel->"In[101]:=",
 CellID->410286046],

Cell[CellGroupData[{

Cell["obj=SobolRsg[Dimension,Seed]", "Input",
 CellTags->"Constructor",
 CellLabel->"In[103]:=",
 CellID->468360174],

Cell[BoxData["SobolRsg1"], "Output",
 CellChangeTimes->{3.436080531328125*^9},
 CellTags->"Constructor",
 CellLabel->"Out[103]=",
 CellID->17591987]
}, Open  ]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Member function", "Section",
 CellTags->"Member",
 CellID->128439969],

Cell[CellGroupData[{

Cell["Variates", "Subsubsection",
 CellTags->"Member",
 CellID->171887313],

Cell[BoxData[{Cell[BoxData[GridBox[{
    {"Samples", "5", 
     RowBox[{"number", " ", "of", " ", 
      RowBox[{"samples", "."}]}]}
   }]], "DefinitionBox3Col",
  CellTags->"Member"], "\n", Cell["Calling Parameters", "Caption"]}], "Input",\

 CellID->259318236],

Cell[BoxData[
 RowBox[{
  RowBox[{"Samples", "=", "5"}], ";"}]], "Input",
 CellTags->"Member",
 CellLabel->"In[104]:=",
 CellID->239353828],

Cell[CellGroupData[{

Cell["Variates[obj,Samples]", "Input",
 CellTags->"Member",
 CellLabel->"In[105]:=",
 CellID->74614875],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"0.5`", ",", "0.5`", ",", "0.5`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0.75`", ",", "0.25`", ",", "0.75`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0.25`", ",", "0.75`", ",", "0.25`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0.375`", ",", "0.375`", ",", "0.625`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0.875`", ",", "0.875`", ",", "0.125`"}], "}"}]}], 
  "}"}]], "Output",
 CellChangeTimes->{3.436080537609375*^9},
 CellTags->"Member",
 CellLabel->"Out[105]=",
 CellID->161091544]
}, Open  ]]
}, Open  ]]
}, Open  ]]
}, Open  ]]
},
Editable->True,
WindowSize->{616, 750},
WindowMargins->{{Automatic, 543}, {Automatic, 80}},
DockedCells->FEPrivate`FrontEndResource[
 "FEExpressions", "HelpViewerToolbar"],
PageHeaders->{{None, None, None}, {None, None, 
   Cell[
    TextData[{
      Cell[
       TextData[{"Printed from [[YOUR APPLICATION'S NAME]] documentation "}], 
       "PageHeader"], 
      Cell[
       TextData[{
         CounterBox["Page"]}], "PageNumber"]}], 
    CellMargins -> {{Inherited, -29}, {Inherited, Inherited}}]}},
PageFooters->{{None, None, None}, {
   Cell[
    TextData[{"\[Copyright] 2008 Weber & Partner. All rights reserved."}], 
    "PageFooter"], None, None}},
TaggingRules->{"SearchTextTranslated" -> "", "SearchText" -> ""},
CreateCellID->True,
ShowCellTags->False,
FrontEndVersion->"6.0 for Microsoft Windows (32-bit) (May 21, 2008)",
StyleDefinitions->FrontEnd`FileName[{"Wolfram"}, "Reference.nb", 
  CharacterEncoding -> "WindowsANSI"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "Overview"->{
  Cell[590, 23, 94, 2, 99, "Chapter",
   CellTags->"Overview",
   CellID->239531684],
  Cell[687, 27, 118, 2, 37, "Text",
   CellTags->"Overview",
   CellID->148416870],
  Cell[808, 31, 114, 2, 53, "MathCaption",
   CellTags->"Overview",
   CellID->366772592],
  Cell[925, 35, 80, 2, 41, "Input",
   CellTags->"Overview",
   CellID->700194112],
  Cell[1008, 39, 171, 5, 37, "Text",
   CellTags->"Overview",
   CellID->470303382],
  Cell[1204, 48, 143, 3, 41, "Input",
   CellTags->"Overview",
   CellID->504072341],
  Cell[1350, 53, 247, 8, 39, "Output",
   CellTags->"Overview",
   CellID->597202300],
  Cell[1634, 66, 137, 3, 41, "Input",
   CellTags->"Overview",
   CellID->78276669],
  Cell[1774, 71, 161, 5, 39, "Output",
   CellTags->"Overview",
   CellID->138481910]},
 "Constructo"->{
  Cell[1972, 81, 76, 2, 77, "Section",
   CellTags->"Constructo",
   CellID->290976781]},
 "Constructor"->{
  Cell[2073, 87, 89, 2, 47, "Subsubsection",
   CellTags->"Constructor",
   CellID->525358681],
  Cell[2445, 101, 201, 7, 62, "Input",
   CellTags->"Constructor",
   CellID->114379857],
  Cell[2671, 112, 123, 3, 41, "Input",
   CellTags->"Constructor",
   CellID->2672587],
  Cell[2797, 117, 157, 4, 70, "Output",
   CellTags->"Constructor",
   CellID->68283670],
  Cell[3003, 127, 78, 2, 70, "Subsubsection",
   CellTags->"Constructor",
   CellID->46875049],
  Cell[3316, 139, 144, 5, 70, "Input",
   CellTags->"Constructor",
   CellID->38859808],
  Cell[3485, 148, 110, 3, 70, "Input",
   CellTags->"Constructor",
   CellID->463130054],
  Cell[3598, 153, 145, 4, 36, "Output",
   CellTags->"Constructor",
   CellID->416750620],
  Cell[3792, 163, 79, 2, 30, "Subsubsection",
   CellTags->"Constructor",
   CellID->62054429],
  Cell[4154, 177, 201, 7, 47, "Input",
   CellTags->"Constructor",
   CellID->134727261],
  Cell[4380, 188, 117, 3, 28, "Input",
   CellTags->"Constructor",
   CellID->667093438],
  Cell[4500, 193, 149, 4, 36, "Output",
   CellTags->"Constructor",
   CellID->58796001],
  Cell[4698, 203, 78, 2, 30, "Subsubsection",
   CellTags->"Constructor",
   CellID->13424199],
  Cell[5113, 219, 202, 7, 47, "Input",
   CellTags->"Constructor",
   CellID->410286046],
  Cell[5340, 230, 116, 3, 28, "Input",
   CellTags->"Constructor",
   CellID->468360174],
  Cell[5459, 235, 148, 4, 36, "Output",
   CellTags->"Constructor",
   CellID->17591987]},
 "Member"->{
  Cell[5668, 246, 75, 2, 51, "Section",
   CellTags->"Member",
   CellID->128439969],
  Cell[5768, 252, 74, 2, 30, "Subsubsection",
   CellTags->"Member",
   CellID->171887313],
  Cell[6110, 265, 139, 5, 28, "Input",
   CellTags->"Member",
   CellID->239353828],
  Cell[6274, 274, 103, 3, 28, "Input",
   CellTags->"Member",
   CellID->74614875],
  Cell[6380, 279, 572, 17, 54, "Output",
   CellTags->"Member",
   CellID->161091544]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"Overview", 8057, 333},
 {"Constructo", 8850, 361},
 {"Constructor", 8958, 365},
 {"Member", 10434, 414}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[590, 23, 94, 2, 99, "Chapter",
 CellTags->"Overview",
 CellID->239531684],
Cell[687, 27, 118, 2, 37, "Text",
 CellTags->"Overview",
 CellID->148416870],
Cell[808, 31, 114, 2, 53, "MathCaption",
 CellTags->"Overview",
 CellID->366772592],
Cell[925, 35, 80, 2, 41, "Input",
 CellTags->"Overview",
 CellID->700194112],
Cell[1008, 39, 171, 5, 37, "Text",
 CellTags->"Overview",
 CellID->470303382],
Cell[CellGroupData[{
Cell[1204, 48, 143, 3, 41, "Input",
 CellTags->"Overview",
 CellID->504072341],
Cell[1350, 53, 247, 8, 39, "Output",
 CellTags->"Overview",
 CellID->597202300]
}, Open  ]],
Cell[CellGroupData[{
Cell[1634, 66, 137, 3, 41, "Input",
 CellTags->"Overview",
 CellID->78276669],
Cell[1774, 71, 161, 5, 39, "Output",
 CellTags->"Overview",
 CellID->138481910]
}, Open  ]],
Cell[CellGroupData[{
Cell[1972, 81, 76, 2, 77, "Section",
 CellTags->"Constructo",
 CellID->290976781],
Cell[CellGroupData[{
Cell[2073, 87, 89, 2, 47, "Subsubsection",
 CellTags->"Constructor",
 CellID->525358681],
Cell[2165, 91, 277, 8, 84, "Input",
 CellID->149226550],
Cell[2445, 101, 201, 7, 62, "Input",
 CellTags->"Constructor",
 CellID->114379857],
Cell[CellGroupData[{
Cell[2671, 112, 123, 3, 41, "Input",
 CellTags->"Constructor",
 CellID->2672587],
Cell[2797, 117, 157, 4, 70, "Output",
 CellTags->"Constructor",
 CellID->68283670]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[3003, 127, 78, 2, 70, "Subsubsection",
 CellTags->"Constructor",
 CellID->46875049],
Cell[3084, 131, 229, 6, 70, "Input",
 CellID->605096492],
Cell[3316, 139, 144, 5, 70, "Input",
 CellTags->"Constructor",
 CellID->38859808],
Cell[CellGroupData[{
Cell[3485, 148, 110, 3, 70, "Input",
 CellTags->"Constructor",
 CellID->463130054],
Cell[3598, 153, 145, 4, 36, "Output",
 CellTags->"Constructor",
 CellID->416750620]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[3792, 163, 79, 2, 30, "Subsubsection",
 CellTags->"Constructor",
 CellID->62054429],
Cell[3874, 167, 277, 8, 78, "Input",
 CellID->169458985],
Cell[4154, 177, 201, 7, 47, "Input",
 CellTags->"Constructor",
 CellID->134727261],
Cell[CellGroupData[{
Cell[4380, 188, 117, 3, 28, "Input",
 CellTags->"Constructor",
 CellID->667093438],
Cell[4500, 193, 149, 4, 36, "Output",
 CellTags->"Constructor",
 CellID->58796001]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[4698, 203, 78, 2, 30, "Subsubsection",
 CellTags->"Constructor",
 CellID->13424199],
Cell[4779, 207, 331, 10, 78, "Input",
 CellID->22424220],
Cell[5113, 219, 202, 7, 47, "Input",
 CellTags->"Constructor",
 CellID->410286046],
Cell[CellGroupData[{
Cell[5340, 230, 116, 3, 28, "Input",
 CellTags->"Constructor",
 CellID->468360174],
Cell[5459, 235, 148, 4, 36, "Output",
 CellTags->"Constructor",
 CellID->17591987]
}, Open  ]]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[5668, 246, 75, 2, 51, "Section",
 CellTags->"Member",
 CellID->128439969],
Cell[CellGroupData[{
Cell[5768, 252, 74, 2, 30, "Subsubsection",
 CellTags->"Member",
 CellID->171887313],
Cell[5845, 256, 262, 7, 65, "Input",
 CellID->259318236],
Cell[6110, 265, 139, 5, 28, "Input",
 CellTags->"Member",
 CellID->239353828],
Cell[CellGroupData[{
Cell[6274, 274, 103, 3, 28, "Input",
 CellTags->"Member",
 CellID->74614875],
Cell[6380, 279, 572, 17, 54, "Output",
 CellTags->"Member",
 CellID->161091544]
}, Open  ]]
}, Open  ]]
}, Open  ]]
}, Open  ]]
}
]
*)

(* End of internal cache information *)
