(* Content-type: application/mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 6.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       145,          7]
NotebookDataLength[      7275,        247]
NotebookOptionsPosition[      4919,        160]
NotebookOutlinePosition[      6268,        205]
CellTagsIndexPosition[      6184,        200]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell["QuantLib", "Subtitle",
 CellChangeTimes->{{3.434947043421875*^9, 3.434947050171875*^9}},
 CellID->283986436],

Cell[CellGroupData[{

Cell["RateHelper", "Title",
 CellChangeTimes->{{3.43494703740625*^9, 3.43494703928125*^9}, 
   3.434951659765625*^9, 3.43503746765625*^9, {3.435308085953125*^9, 
   3.43530808640625*^9}, {3.43531829871875*^9, 3.435318332828125*^9}, {
   3.43531845903125*^9, 3.435318459515625*^9}, {3.435409586109375*^9, 
   3.43540958709375*^9}, {3.435472253609375*^9, 3.4354722566875*^9}},
 CellID->322447628],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"Needs", "[", "\"\<QuantLib`\>\"", "]"}], "\[IndentingNewLine]", 
 RowBox[{"Category", "[", "RateHelper", "]"}]}], "Input",
 CellLabel->"In[1]:=",
 CellID->64596263],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "BondHelper", ",", "DatedOISRateHelper", ",", "DepositRateHelper", ",", 
   "FixedRateBondHelper", ",", "FraRateHelper", ",", "FraRateHelper2", ",", 
   "FuturesRateHelper", ",", "FuturesRateHelper2", ",", 
   "FuturesRateHelperConvexityAdjustment", ",", "OISRateHelper", ",", 
   "RateHelperEarliestDate", ",", "RateHelperImpliedQuote", ",", 
   "RateHelperLatestDate", ",", "RateHelperQuoteError", ",", 
   "RateHelperQuoteIsValid", ",", "RateHelperQuoteValue", ",", 
   "RateHelperRate", ",", "RateHelperSelection", ",", "SwapRateHelper", ",", 
   "SwapRateHelper2", ",", "SwapRateHelperForwardStart", ",", 
   "SwapRateHelperSpread"}], "}"}]], "Output",
 CellLabel->"Out[2]=",
 CellID->46580260]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Select", "[", 
  RowBox[{
   RowBox[{"Category", "[", "RateHelper", "]"}], ",", 
   RowBox[{
    RowBox[{"QLConstructor", "[", "#", "]"}], "&"}]}], "]"}]], "Input",
 CellLabel->"In[3]:=",
 CellID->172591737],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "BondHelper", ",", "DatedOISRateHelper", ",", "DepositRateHelper", ",", 
   "FixedRateBondHelper", ",", "FraRateHelper", ",", "FraRateHelper2", ",", 
   "FuturesRateHelper", ",", "OISRateHelper", ",", "SwapRateHelper"}], 
  "}"}]], "Output",
 CellLabel->"Out[3]=",
 CellID->650489674]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Select", "[", 
  RowBox[{
   RowBox[{"Category", "[", "RateHelper", "]"}], ",", 
   RowBox[{
    RowBox[{"QLMember", "[", "#", "]"}], "&"}]}], "]"}]], "Input",
 CellLabel->"In[4]:=",
 CellID->125000790],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "FuturesRateHelperConvexityAdjustment", ",", "RateHelperEarliestDate", ",", 
   "RateHelperImpliedQuote", ",", "RateHelperLatestDate", ",", 
   "RateHelperQuoteError", ",", "RateHelperQuoteIsValid", ",", 
   "RateHelperQuoteValue", ",", "SwapRateHelperForwardStart", ",", 
   "SwapRateHelperSpread"}], "}"}]], "Output",
 CellLabel->"Out[4]=",
 CellID->488766824]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", "BMAIndex"}]], "Input",
 CellChangeTimes->{{3.43540962365625*^9, 3.435409626640625*^9}},
 CellID->191592520],

Cell[BoxData[
 StyleBox["\<\"BMAIndex[ObjecctId_Symbol] Construct an object of class \
BMAIndex and return its id       \\nObjectId: id of object to be \
created\\nYieldCurve: forecasting yield term structure. Default value = None.\
\\nPermanent: object permanent/nonpermanent\"\>", "MSG"]], "Print", \
"PrintUsage",
 CellChangeTimes->{3.435409627375*^9},
 CellTags->"Info3435413227-3902892",
 CellID->109196895]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"BMAIndex", "[", "]"}]], "Input",
 CellChangeTimes->{{3.435409630953125*^9, 3.4354096355*^9}},
 CellID->22430112],

Cell[BoxData[
 RowBox[{
  RowBox[{"QuantLibError", "::", "\<\"msg\"\>"}], ":", 
  " ", "\<\"\\!\\(\\\"ObjectHandler error: attempt to retrieve object with \
unknown ID 'None'\\\"\\)\"\>"}]], "Message", "MSG",
 CellChangeTimes->{3.43540964484375*^9},
 CellID->193052041],

Cell[BoxData["$Failed"], "Output",
 CellChangeTimes->{3.43540964484375*^9},
 CellID->194472125]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Options", "[", "BMAIndex", "]"}]], "Input",
 CellChangeTimes->{{3.4354096574375*^9, 3.43540966578125*^9}},
 CellID->20761351],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"YieldCurve", "\[Rule]", "None"}], ",", 
   RowBox[{"Permanent", "\[Rule]", "True"}], ",", 
   RowBox[{"Overwrite", "\[Rule]", "True"}]}], "}"}]], "Output",
 CellChangeTimes->{3.43540966640625*^9},
 CellID->165195479]
}, Open  ]]
}, Open  ]]
},
FileChangeProtection->None,
Editable->True,
WindowSize->{616, 749},
WindowMargins->{{Automatic, -586}, {34, Automatic}},
DockedCells->FEPrivate`FrontEndResource["FEExpressions", "HelpViewerToolbar"],
PageHeaders->{{None, None, None}, {None, None, 
   Cell[
    TextData[{
      Cell[
       TextData[{"Printed from [[YOUR APPLICATION'S NAME]] documentation "}], 
       "PageHeader"], 
      Cell[
       TextData[{
         CounterBox["Page"]}], "PageNumber"]}], 
    CellMargins -> {{Inherited, -29}, {Inherited, Inherited}}]}},
PageFooters->{{None, None, None}, {
   Cell[
    TextData[{"\[Copyright] 2008 Weber & Partner. All rights reserved."}], 
    "PageFooter"], None, None}},
ShowSelection->True,
TaggingRules->{
 "SearchTextTranslated" -> "", "SearchText" -> "", "LinkTrails" -> ""},
CreateCellID->True,
ShowCellTags->False,
FrontEndVersion->"8.0 for Microsoft Windows (32-bit) (October 6, 2011)",
StyleDefinitions->FrontEnd`FileName[{"Wolfram"}, "Reference.nb", 
  CharacterEncoding -> "WindowsANSI"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "Info3435413227-3902892"->{
  Cell[3479, 111, 412, 8, 86, "Print",
   CellTags->"Info3435413227-3902892",
   CellID->109196895]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"Info3435413227-3902892", 6059, 193}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[545, 20, 114, 2, 23, "Subtitle",
 CellID->283986436],
Cell[CellGroupData[{
Cell[684, 26, 394, 6, 51, "Title",
 CellID->322447628],
Cell[CellGroupData[{
Cell[1103, 36, 189, 4, 47, "Input",
 CellID->64596263],
Cell[1295, 42, 741, 14, 173, "Output",
 CellID->46580260]
}, Open  ]],
Cell[CellGroupData[{
Cell[2073, 61, 231, 7, 28, "Input",
 CellID->172591737],
Cell[2307, 70, 326, 8, 71, "Output",
 CellID->650489674]
}, Open  ]],
Cell[CellGroupData[{
Cell[2670, 83, 226, 7, 28, "Input",
 CellID->125000790],
Cell[2899, 92, 404, 9, 88, "Output",
 CellID->488766824]
}, Open  ]],
Cell[CellGroupData[{
Cell[3340, 106, 136, 3, 28, "Input",
 CellID->191592520],
Cell[3479, 111, 412, 8, 86, "Print",
 CellTags->"Info3435413227-3902892",
 CellID->109196895]
}, Open  ]],
Cell[CellGroupData[{
Cell[3928, 124, 136, 3, 28, "Input",
 CellID->22430112],
Cell[4067, 129, 269, 6, 19, "Message",
 CellID->193052041],
Cell[4339, 137, 95, 2, 36, "Output",
 CellID->194472125]
}, Open  ]],
Cell[CellGroupData[{
Cell[4471, 144, 149, 3, 28, "Input",
 CellID->20761351],
Cell[4623, 149, 268, 7, 36, "Output",
 CellID->165195479]
}, Open  ]]
}, Open  ]]
}
]
*)

(* End of internal cache information *)
