(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 8.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       157,          7]
NotebookDataLength[     24597,        951]
NotebookOptionsPosition[     11569,        502]
NotebookOutlinePosition[     17764,        699]
CellTagsIndexPosition[     17574,        690]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell["SequenceStatistics", "Chapter",
 CellTags->"Overview"],

Cell["\<\
QuantLib statistics analysis of N-dimensional (sequence) data.\
\>", "Text",
 CellTags->"Overview"],

Cell["The first step is to load the QuantLib package. ", "MathCaption",
 CellTags->"Overview"],

Cell["Needs[\"QuantLib`\"]", "Input",
 CellTags->"Overview"],

Cell["\<\
Within the Settings part there are several constructors and member functions \
available \
\>", "Text",
 CellTags->"Overview"],

Cell["Select[Category[Settings],QLProcedure[#]&]", "Input",
 CellTags->"Overview"],

Cell[CellGroupData[{

Cell["Constructors", "Section",
 CellTags->"Constructor"],

Cell[CellGroupData[{

Cell["SequenceStatistics", "Subsubsection",
 CellTags->"Constructor"],

Cell[BoxData[
 $CellContext`PrintOptions["Parameters", "Constructor"]], "Input"],

Cell["obj=SequenceStatistics[]", "Input",
 CellTags->"Constructor"]
}, Open  ]],

Cell[CellGroupData[{

Cell["SequenceStatistics2", "Subsubsection",
 CellTags->"Constructor"],

Cell[BoxData[
 $CellContext`PrintOptions["Parameters", "Constructor"]], "Input"],

Cell["obj=SequenceStatistics2[]", "Input",
 CellTags->"Constructor"]
}, Open  ]],

Cell[CellGroupData[{

Cell["SequenceStatisticsInc", "Subsubsection",
 CellTags->"Constructor"],

Cell[BoxData[
 $CellContext`PrintOptions["Parameters", "Constructor"]], "Input"],

Cell["obj=SequenceStatisticsInc[]", "Input",
 CellTags->"Constructor"]
}, Open  ]],

Cell[CellGroupData[{

Cell["SequenceStatisticsInc2", "Subsubsection",
 CellTags->"Constructor"],

Cell[BoxData[
 $CellContext`PrintOptions["Parameters", "Constructor"]], "Input"],

Cell["obj=SequenceStatisticsInc2[]", "Input",
 CellTags->"Constructor"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Member function", "Section",
 CellTags->"Member"],

Cell[CellGroupData[{

Cell["SequenceStatisticsSamples", "Subsubsection",
 CellTags->"Member"],

Cell["SequenceStatisticsSamples[obj]", "Input",
 CellTags->"Member"]
}, Open  ]],

Cell[CellGroupData[{

Cell["SequenceStatisticsWeightSum", "Subsubsection",
 CellTags->"Member"],

Cell["SequenceStatisticsWeightSum[obj]", "Input",
 CellTags->"Member"]
}, Open  ]],

Cell[CellGroupData[{

Cell["SequenceStatisticsMean", "Subsubsection",
 CellTags->"Member"],

Cell["SequenceStatisticsMean[obj]", "Input",
 CellTags->"Member"]
}, Open  ]],

Cell[CellGroupData[{

Cell["SequenceStatisticsVariance", "Subsubsection",
 CellTags->"Member"],

Cell["SequenceStatisticsVariance[obj]", "Input",
 CellTags->"Member"]
}, Open  ]],

Cell[CellGroupData[{

Cell["SequenceStatisticsStandardDeviation", "Subsubsection",
 CellTags->"Member"],

Cell["SequenceStatisticsStandardDeviation[obj]", "Input",
 CellTags->"Member"]
}, Open  ]],

Cell[CellGroupData[{

Cell["SequenceStatisticsDownsideVariance", "Subsubsection",
 CellTags->"Member"],

Cell["SequenceStatisticsDownsideVariance[obj]", "Input",
 CellTags->"Member"]
}, Open  ]],

Cell[CellGroupData[{

Cell["SequenceStatisticsDownsideDeviation", "Subsubsection",
 CellTags->"Member"],

Cell["SequenceStatisticsDownsideDeviation[obj]", "Input",
 CellTags->"Member"]
}, Open  ]],

Cell[CellGroupData[{

Cell["SequenceStatisticsSemiVariance", "Subsubsection",
 CellTags->"Member"],

Cell["SequenceStatisticsSemiVariance[obj]", "Input",
 CellTags->"Member"]
}, Open  ]],

Cell[CellGroupData[{

Cell["SequenceStatisticsSemiDeviation", "Subsubsection",
 CellTags->"Member"],

Cell["SequenceStatisticsSemiDeviation[obj]", "Input",
 CellTags->"Member"]
}, Open  ]],

Cell[CellGroupData[{

Cell["SequenceStatisticsErrorEstimate", "Subsubsection",
 CellTags->"Member"],

Cell["SequenceStatisticsErrorEstimate[obj]", "Input",
 CellTags->"Member"]
}, Open  ]],

Cell[CellGroupData[{

Cell["SequenceStatisticsSkewness", "Subsubsection",
 CellTags->"Member"],

Cell["SequenceStatisticsSkewness[obj]", "Input",
 CellTags->"Member"]
}, Open  ]],

Cell[CellGroupData[{

Cell["SequenceStatisticsKurtosis", "Subsubsection",
 CellTags->"Member"],

Cell["SequenceStatisticsKurtosis[obj]", "Input",
 CellTags->"Member"]
}, Open  ]],

Cell[CellGroupData[{

Cell["SequenceStatisticsMin", "Subsubsection",
 CellTags->"Member"],

Cell["SequenceStatisticsMin[obj]", "Input",
 CellTags->"Member"]
}, Open  ]],

Cell[CellGroupData[{

Cell["SequenceStatisticsMax", "Subsubsection",
 CellTags->"Member"],

Cell["SequenceStatisticsMax[obj]", "Input",
 CellTags->"Member"]
}, Open  ]],

Cell[CellGroupData[{

Cell["SequenceStatisticsGaussianPercentile", "Subsubsection",
 CellTags->"Member"],

Cell[BoxData[{Cell[BoxData[GridBox[{
    {"X", 
     RowBox[{
      RowBox[{
       RowBox[{"Must", " ", "be", " ", "in", " ", "the", " ", "range", " ", 
        RowBox[{"(", 
         RowBox[{"0", ",", "1"}]}]}], "]"}], "."}]}
   }]], "DefinitionBox",
  CellTags->"Member"], "\n", Cell["Calling Parameters", "Caption"]}], "Text"],

Cell[BoxData[
 RowBox[{
  RowBox[{"X", "=", "0.5"}], ";"}]], "Input",
 CellTags->"Member"],

Cell["SequenceStatisticsGaussianPercentile[obj,X]", "Input",
 CellTags->"Member"]
}, Open  ]],

Cell[CellGroupData[{

Cell["SequenceStatisticsPercentile", "Subsubsection",
 CellTags->"Member"],

Cell[BoxData[{Cell[BoxData[GridBox[{
    {"X", 
     RowBox[{
      RowBox[{
       RowBox[{"Must", " ", "be", " ", "in", " ", "the", " ", "range", " ", 
        RowBox[{"(", 
         RowBox[{"0", ",", "1"}]}]}], "]"}], "."}]}
   }]], "DefinitionBox",
  CellTags->"Member"], "\n", Cell["Calling Parameters", "Caption"]}], "Text"],

Cell[BoxData[
 RowBox[{
  RowBox[{"X", "=", "0.5"}], ";"}]], "Input",
 CellTags->"Member"],

Cell["SequenceStatisticsPercentile[obj,X]", "Input",
 CellTags->"Member"]
}, Open  ]],

Cell[CellGroupData[{

Cell["SequenceStatisticsGaussianPotentialUpside", "Subsubsection",
 CellTags->"Member"],

Cell[BoxData[{Cell[BoxData[GridBox[{
    {"Target", 
     RowBox[{"the", " ", 
      RowBox[{"percentile", "."}]}]}
   }]], "DefinitionBox",
  CellTags->"Member"], "\n", Cell["Calling Parameters", "Caption"]}], "Text"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Target", "=", "0.5"}], ";"}]], "Input",
 CellTags->"Member"],

Cell["SequenceStatisticsGaussianPotentialUpside[obj,Target]", "Input",
 CellTags->"Member"]
}, Open  ]],

Cell[CellGroupData[{

Cell["SequenceStatisticsPotentialUpside", "Subsubsection",
 CellTags->"Member"],

Cell[BoxData[{Cell[BoxData[GridBox[{
    {"Centile", 
     RowBox[{"the", " ", 
      RowBox[{"centile", "."}]}]}
   }]], "DefinitionBox",
  CellTags->"Member"], "\n", Cell["Calling Parameters", "Caption"]}], "Text"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Centile", "=", "0.5"}], ";"}]], "Input",
 CellTags->"Member"],

Cell["SequenceStatisticsPotentialUpside[obj,Centile]", "Input",
 CellTags->"Member"]
}, Open  ]],

Cell[CellGroupData[{

Cell["SequenceStatisticsGaussianValueAtRisk", "Subsubsection",
 CellTags->"Member"],

Cell[BoxData[{Cell[BoxData[GridBox[{
    {"Target", 
     RowBox[{"the", " ", 
      RowBox[{"percentile", "."}]}]}
   }]], "DefinitionBox",
  CellTags->"Member"], "\n", Cell["Calling Parameters", "Caption"]}], "Text"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Target", "=", "0.5"}], ";"}]], "Input",
 CellTags->"Member"],

Cell["SequenceStatisticsGaussianValueAtRisk[obj,Target]", "Input",
 CellTags->"Member"]
}, Open  ]],

Cell[CellGroupData[{

Cell["SequenceStatisticsValueAtRisk", "Subsubsection",
 CellTags->"Member"],

Cell[BoxData[{Cell[BoxData[GridBox[{
    {"Target", 
     RowBox[{"the", " ", 
      RowBox[{"percentile", "."}]}]}
   }]], "DefinitionBox",
  CellTags->"Member"], "\n", Cell["Calling Parameters", "Caption"]}], "Text"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Target", "=", "0.5"}], ";"}]], "Input",
 CellTags->"Member"],

Cell["SequenceStatisticsValueAtRisk[obj,Target]", "Input",
 CellTags->"Member"]
}, Open  ]],

Cell[CellGroupData[{

Cell["SequenceStatisticsRegret", "Subsubsection",
 CellTags->"Member"],

Cell[BoxData[{Cell[BoxData[GridBox[{
    {"Target", 
     RowBox[{"the", " ", 
      RowBox[{"target", "."}]}]}
   }]], "DefinitionBox",
  CellTags->"Member"], "\n", Cell["Calling Parameters", "Caption"]}], "Text"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Target", "=", "0.5"}], ";"}]], "Input",
 CellTags->"Member"],

Cell["SequenceStatisticsRegret[obj,Target]", "Input",
 CellTags->"Member"]
}, Open  ]],

Cell[CellGroupData[{

Cell["SequenceStatisticsGaussianShortfall", "Subsubsection",
 CellTags->"Member"],

Cell[BoxData[{Cell[BoxData[GridBox[{
    {"Target", 
     RowBox[{"the", " ", 
      RowBox[{"target", "."}]}]}
   }]], "DefinitionBox",
  CellTags->"Member"], "\n", Cell["Calling Parameters", "Caption"]}], "Text"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Target", "=", "0.5"}], ";"}]], "Input",
 CellTags->"Member"],

Cell["SequenceStatisticsGaussianShortfall[obj,Target]", "Input",
 CellTags->"Member"]
}, Open  ]],

Cell[CellGroupData[{

Cell["SequenceStatisticsShortfall", "Subsubsection",
 CellTags->"Member"],

Cell[BoxData[{Cell[BoxData[GridBox[{
    {"Target", 
     RowBox[{"the", " ", 
      RowBox[{"target", "."}]}]}
   }]], "DefinitionBox",
  CellTags->"Member"], "\n", Cell["Calling Parameters", "Caption"]}], "Text"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Target", "=", "0.5"}], ";"}]], "Input",
 CellTags->"Member"],

Cell["SequenceStatisticsShortfall[obj,Target]", "Input",
 CellTags->"Member"]
}, Open  ]],

Cell[CellGroupData[{

Cell["SequenceStatisticsGaussianAverageShortfall", "Subsubsection",
 CellTags->"Member"],

Cell[BoxData[{Cell[BoxData[GridBox[{
    {"Target", 
     RowBox[{"the", " ", 
      RowBox[{"target", "."}]}]}
   }]], "DefinitionBox",
  CellTags->"Member"], "\n", Cell["Calling Parameters", "Caption"]}], "Text"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Target", "=", "0.5"}], ";"}]], "Input",
 CellTags->"Member"],

Cell["SequenceStatisticsGaussianAverageShortfall[obj,Target]", "Input",
 CellTags->"Member"]
}, Open  ]],

Cell[CellGroupData[{

Cell["SequenceStatisticsAverageShortfall", "Subsubsection",
 CellTags->"Member"],

Cell[BoxData[{Cell[BoxData[GridBox[{
    {"Target", 
     RowBox[{"the", " ", 
      RowBox[{"target", "."}]}]}
   }]], "DefinitionBox",
  CellTags->"Member"], "\n", Cell["Calling Parameters", "Caption"]}], "Text"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Target", "=", "0.5"}], ";"}]], "Input",
 CellTags->"Member"],

Cell["SequenceStatisticsAverageShortfall[obj,Target]", "Input",
 CellTags->"Member"]
}, Open  ]],

Cell[CellGroupData[{

Cell["SequenceStatisticsSize", "Subsubsection",
 CellTags->"Member"],

Cell["SequenceStatisticsSize[obj]", "Input",
 CellTags->"Member"]
}, Open  ]],

Cell[CellGroupData[{

Cell["SequenceStatisticsCovariance", "Subsubsection",
 CellTags->"Member"],

Cell["SequenceStatisticsCovariance[obj]", "Input",
 CellTags->"Member"]
}, Open  ]],

Cell[CellGroupData[{

Cell["SequenceStatisticsCorrelation", "Subsubsection",
 CellTags->"Member"],

Cell["SequenceStatisticsCorrelation[obj]", "Input",
 CellTags->"Member"]
}, Open  ]]
}, Open  ]],

Cell["Procedures", "Section",
 CellTags->"Procedure"],

Cell["Enumeration Member", "Section",
 CellTags->"EnumerationMember"]
}, Open  ]]
},
WindowSize->{716, 867},
WindowMargins->{{278, Automatic}, {Automatic, 42}},
FrontEndVersion->"8.0 for Microsoft Windows (32-bit) (February 23, 2011)",
StyleDefinitions->"HelpBrowser.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "Overview"->{
  Cell[579, 22, 60, 1, 99, "Chapter",
   CellTags->"Overview"],
  Cell[642, 25, 109, 3, 37, "Text",
   CellTags->"Overview"],
  Cell[754, 30, 94, 1, 53, "MathCaption",
   CellTags->"Overview"],
  Cell[851, 33, 60, 1, 41, "Input",
   CellTags->"Overview"],
  Cell[914, 36, 136, 4, 37, "Text",
   CellTags->"Overview"],
  Cell[1053, 42, 82, 1, 41, "Input",
   CellTags->"Overview"]},
 "Constructor"->{
  Cell[1160, 47, 57, 1, 77, "Section",
   CellTags->"Constructor"],
  Cell[1242, 52, 69, 1, 47, "Subsubsection",
   CellTags->"Constructor"],
  Cell[1397, 58, 67, 1, 41, "Input",
   CellTags->"Constructor"],
  Cell[1501, 64, 70, 1, 47, "Subsubsection",
   CellTags->"Constructor"],
  Cell[1657, 70, 68, 1, 41, "Input",
   CellTags->"Constructor"],
  Cell[1762, 76, 72, 1, 47, "Subsubsection",
   CellTags->"Constructor"],
  Cell[1920, 82, 70, 1, 41, "Input",
   CellTags->"Constructor"],
  Cell[2027, 88, 73, 1, 47, "Subsubsection",
   CellTags->"Constructor"],
  Cell[2186, 94, 71, 1, 41, "Input",
   CellTags->"Constructor"]},
 "Member"->{
  Cell[2306, 101, 55, 1, 77, "Section",
   CellTags->"Member"],
  Cell[2386, 106, 71, 1, 47, "Subsubsection",
   CellTags->"Member"],
  Cell[2460, 109, 68, 1, 41, "Input",
   CellTags->"Member"],
  Cell[2565, 115, 73, 1, 47, "Subsubsection",
   CellTags->"Member"],
  Cell[2641, 118, 70, 1, 41, "Input",
   CellTags->"Member"],
  Cell[2748, 124, 68, 1, 47, "Subsubsection",
   CellTags->"Member"],
  Cell[2819, 127, 65, 1, 41, "Input",
   CellTags->"Member"],
  Cell[2921, 133, 72, 1, 47, "Subsubsection",
   CellTags->"Member"],
  Cell[2996, 136, 69, 1, 41, "Input",
   CellTags->"Member"],
  Cell[3102, 142, 81, 1, 47, "Subsubsection",
   CellTags->"Member"],
  Cell[3186, 145, 78, 1, 41, "Input",
   CellTags->"Member"],
  Cell[3301, 151, 80, 1, 47, "Subsubsection",
   CellTags->"Member"],
  Cell[3384, 154, 77, 1, 41, "Input",
   CellTags->"Member"],
  Cell[3498, 160, 81, 1, 47, "Subsubsection",
   CellTags->"Member"],
  Cell[3582, 163, 78, 1, 41, "Input",
   CellTags->"Member"],
  Cell[3697, 169, 76, 1, 47, "Subsubsection",
   CellTags->"Member"],
  Cell[3776, 172, 73, 1, 41, "Input",
   CellTags->"Member"],
  Cell[3886, 178, 77, 1, 47, "Subsubsection",
   CellTags->"Member"],
  Cell[3966, 181, 74, 1, 41, "Input",
   CellTags->"Member"],
  Cell[4077, 187, 77, 1, 47, "Subsubsection",
   CellTags->"Member"],
  Cell[4157, 190, 74, 1, 41, "Input",
   CellTags->"Member"],
  Cell[4268, 196, 72, 1, 47, "Subsubsection",
   CellTags->"Member"],
  Cell[4343, 199, 69, 1, 41, "Input",
   CellTags->"Member"],
  Cell[4449, 205, 72, 1, 47, "Subsubsection",
   CellTags->"Member"],
  Cell[4524, 208, 69, 1, 41, "Input",
   CellTags->"Member"],
  Cell[4630, 214, 67, 1, 47, "Subsubsection",
   CellTags->"Member"],
  Cell[4700, 217, 64, 1, 41, "Input",
   CellTags->"Member"],
  Cell[4801, 223, 67, 1, 47, "Subsubsection",
   CellTags->"Member"],
  Cell[4871, 226, 64, 1, 41, "Input",
   CellTags->"Member"],
  Cell[4972, 232, 82, 1, 47, "Subsubsection",
   CellTags->"Member"],
  Cell[5390, 245, 90, 3, 41, "Input",
   CellTags->"Member"],
  Cell[5483, 250, 81, 1, 41, "Input",
   CellTags->"Member"],
  Cell[5601, 256, 74, 1, 47, "Subsubsection",
   CellTags->"Member"],
  Cell[6011, 269, 90, 3, 41, "Input",
   CellTags->"Member"],
  Cell[6104, 274, 73, 1, 41, "Input",
   CellTags->"Member"],
  Cell[6214, 280, 87, 1, 47, "Subsubsection",
   CellTags->"Member"],
  Cell[6525, 290, 95, 3, 41, "Input",
   CellTags->"Member"],
  Cell[6623, 295, 91, 1, 41, "Input",
   CellTags->"Member"],
  Cell[6751, 301, 79, 1, 47, "Subsubsection",
   CellTags->"Member"],
  Cell[7052, 311, 96, 3, 41, "Input",
   CellTags->"Member"],
  Cell[7151, 316, 84, 1, 41, "Input",
   CellTags->"Member"],
  Cell[7272, 322, 83, 1, 47, "Subsubsection",
   CellTags->"Member"],
  Cell[7579, 332, 95, 3, 41, "Input",
   CellTags->"Member"],
  Cell[7677, 337, 87, 1, 41, "Input",
   CellTags->"Member"],
  Cell[7801, 343, 75, 1, 47, "Subsubsection",
   CellTags->"Member"],
  Cell[8100, 353, 95, 3, 41, "Input",
   CellTags->"Member"],
  Cell[8198, 358, 79, 1, 41, "Input",
   CellTags->"Member"],
  Cell[8314, 364, 70, 1, 47, "Subsubsection",
   CellTags->"Member"],
  Cell[8604, 374, 95, 3, 41, "Input",
   CellTags->"Member"],
  Cell[8702, 379, 74, 1, 41, "Input",
   CellTags->"Member"],
  Cell[8813, 385, 81, 1, 47, "Subsubsection",
   CellTags->"Member"],
  Cell[9114, 395, 95, 3, 41, "Input",
   CellTags->"Member"],
  Cell[9212, 400, 85, 1, 41, "Input",
   CellTags->"Member"],
  Cell[9334, 406, 73, 1, 47, "Subsubsection",
   CellTags->"Member"],
  Cell[9627, 416, 95, 3, 41, "Input",
   CellTags->"Member"],
  Cell[9725, 421, 77, 1, 41, "Input",
   CellTags->"Member"],
  Cell[9839, 427, 88, 1, 47, "Subsubsection",
   CellTags->"Member"],
  Cell[10147, 437, 95, 3, 41, "Input",
   CellTags->"Member"],
  Cell[10245, 442, 92, 1, 41, "Input",
   CellTags->"Member"],
  Cell[10374, 448, 80, 1, 47, "Subsubsection",
   CellTags->"Member"],
  Cell[10674, 458, 95, 3, 41, "Input",
   CellTags->"Member"],
  Cell[10772, 463, 84, 1, 41, "Input",
   CellTags->"Member"],
  Cell[10893, 469, 68, 1, 47, "Subsubsection",
   CellTags->"Member"],
  Cell[10964, 472, 65, 1, 41, "Input",
   CellTags->"Member"],
  Cell[11066, 478, 74, 1, 47, "Subsubsection",
   CellTags->"Member"],
  Cell[11143, 481, 71, 1, 41, "Input",
   CellTags->"Member"],
  Cell[11251, 487, 75, 1, 47, "Subsubsection",
   CellTags->"Member"],
  Cell[11329, 490, 72, 1, 41, "Input",
   CellTags->"Member"]},
 "Procedure"->{
  Cell[11428, 495, 53, 1, 77, "Section",
   CellTags->"Procedure"]},
 "EnumerationMember"->{
  Cell[11484, 498, 69, 1, 51, "Section",
   CellTags->"EnumerationMember"]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"Overview", 11869, 512},
 {"Constructor", 12269, 525},
 {"Member", 12911, 544},
 {"Procedure", 17381, 681},
 {"EnumerationMember", 17474, 684}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[579, 22, 60, 1, 99, "Chapter",
 CellTags->"Overview"],
Cell[642, 25, 109, 3, 37, "Text",
 CellTags->"Overview"],
Cell[754, 30, 94, 1, 53, "MathCaption",
 CellTags->"Overview"],
Cell[851, 33, 60, 1, 41, "Input",
 CellTags->"Overview"],
Cell[914, 36, 136, 4, 37, "Text",
 CellTags->"Overview"],
Cell[1053, 42, 82, 1, 41, "Input",
 CellTags->"Overview"],
Cell[CellGroupData[{
Cell[1160, 47, 57, 1, 77, "Section",
 CellTags->"Constructor"],
Cell[CellGroupData[{
Cell[1242, 52, 69, 1, 47, "Subsubsection",
 CellTags->"Constructor"],
Cell[1314, 55, 80, 1, 30, "Input"],
Cell[1397, 58, 67, 1, 41, "Input",
 CellTags->"Constructor"]
}, Open  ]],
Cell[CellGroupData[{
Cell[1501, 64, 70, 1, 47, "Subsubsection",
 CellTags->"Constructor"],
Cell[1574, 67, 80, 1, 30, "Input"],
Cell[1657, 70, 68, 1, 41, "Input",
 CellTags->"Constructor"]
}, Open  ]],
Cell[CellGroupData[{
Cell[1762, 76, 72, 1, 47, "Subsubsection",
 CellTags->"Constructor"],
Cell[1837, 79, 80, 1, 30, "Input"],
Cell[1920, 82, 70, 1, 41, "Input",
 CellTags->"Constructor"]
}, Open  ]],
Cell[CellGroupData[{
Cell[2027, 88, 73, 1, 47, "Subsubsection",
 CellTags->"Constructor"],
Cell[2103, 91, 80, 1, 30, "Input"],
Cell[2186, 94, 71, 1, 41, "Input",
 CellTags->"Constructor"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[2306, 101, 55, 1, 77, "Section",
 CellTags->"Member"],
Cell[CellGroupData[{
Cell[2386, 106, 71, 1, 47, "Subsubsection",
 CellTags->"Member"],
Cell[2460, 109, 68, 1, 41, "Input",
 CellTags->"Member"]
}, Open  ]],
Cell[CellGroupData[{
Cell[2565, 115, 73, 1, 47, "Subsubsection",
 CellTags->"Member"],
Cell[2641, 118, 70, 1, 41, "Input",
 CellTags->"Member"]
}, Open  ]],
Cell[CellGroupData[{
Cell[2748, 124, 68, 1, 47, "Subsubsection",
 CellTags->"Member"],
Cell[2819, 127, 65, 1, 41, "Input",
 CellTags->"Member"]
}, Open  ]],
Cell[CellGroupData[{
Cell[2921, 133, 72, 1, 47, "Subsubsection",
 CellTags->"Member"],
Cell[2996, 136, 69, 1, 41, "Input",
 CellTags->"Member"]
}, Open  ]],
Cell[CellGroupData[{
Cell[3102, 142, 81, 1, 47, "Subsubsection",
 CellTags->"Member"],
Cell[3186, 145, 78, 1, 41, "Input",
 CellTags->"Member"]
}, Open  ]],
Cell[CellGroupData[{
Cell[3301, 151, 80, 1, 47, "Subsubsection",
 CellTags->"Member"],
Cell[3384, 154, 77, 1, 41, "Input",
 CellTags->"Member"]
}, Open  ]],
Cell[CellGroupData[{
Cell[3498, 160, 81, 1, 47, "Subsubsection",
 CellTags->"Member"],
Cell[3582, 163, 78, 1, 41, "Input",
 CellTags->"Member"]
}, Open  ]],
Cell[CellGroupData[{
Cell[3697, 169, 76, 1, 47, "Subsubsection",
 CellTags->"Member"],
Cell[3776, 172, 73, 1, 41, "Input",
 CellTags->"Member"]
}, Open  ]],
Cell[CellGroupData[{
Cell[3886, 178, 77, 1, 47, "Subsubsection",
 CellTags->"Member"],
Cell[3966, 181, 74, 1, 41, "Input",
 CellTags->"Member"]
}, Open  ]],
Cell[CellGroupData[{
Cell[4077, 187, 77, 1, 47, "Subsubsection",
 CellTags->"Member"],
Cell[4157, 190, 74, 1, 41, "Input",
 CellTags->"Member"]
}, Open  ]],
Cell[CellGroupData[{
Cell[4268, 196, 72, 1, 47, "Subsubsection",
 CellTags->"Member"],
Cell[4343, 199, 69, 1, 41, "Input",
 CellTags->"Member"]
}, Open  ]],
Cell[CellGroupData[{
Cell[4449, 205, 72, 1, 47, "Subsubsection",
 CellTags->"Member"],
Cell[4524, 208, 69, 1, 41, "Input",
 CellTags->"Member"]
}, Open  ]],
Cell[CellGroupData[{
Cell[4630, 214, 67, 1, 47, "Subsubsection",
 CellTags->"Member"],
Cell[4700, 217, 64, 1, 41, "Input",
 CellTags->"Member"]
}, Open  ]],
Cell[CellGroupData[{
Cell[4801, 223, 67, 1, 47, "Subsubsection",
 CellTags->"Member"],
Cell[4871, 226, 64, 1, 41, "Input",
 CellTags->"Member"]
}, Open  ]],
Cell[CellGroupData[{
Cell[4972, 232, 82, 1, 47, "Subsubsection",
 CellTags->"Member"],
Cell[5057, 235, 330, 8, 64, "Text"],
Cell[5390, 245, 90, 3, 41, "Input",
 CellTags->"Member"],
Cell[5483, 250, 81, 1, 41, "Input",
 CellTags->"Member"]
}, Open  ]],
Cell[CellGroupData[{
Cell[5601, 256, 74, 1, 47, "Subsubsection",
 CellTags->"Member"],
Cell[5678, 259, 330, 8, 64, "Text"],
Cell[6011, 269, 90, 3, 41, "Input",
 CellTags->"Member"],
Cell[6104, 274, 73, 1, 41, "Input",
 CellTags->"Member"]
}, Open  ]],
Cell[CellGroupData[{
Cell[6214, 280, 87, 1, 47, "Subsubsection",
 CellTags->"Member"],
Cell[6304, 283, 218, 5, 64, "Text"],
Cell[6525, 290, 95, 3, 41, "Input",
 CellTags->"Member"],
Cell[6623, 295, 91, 1, 41, "Input",
 CellTags->"Member"]
}, Open  ]],
Cell[CellGroupData[{
Cell[6751, 301, 79, 1, 47, "Subsubsection",
 CellTags->"Member"],
Cell[6833, 304, 216, 5, 64, "Text"],
Cell[7052, 311, 96, 3, 41, "Input",
 CellTags->"Member"],
Cell[7151, 316, 84, 1, 41, "Input",
 CellTags->"Member"]
}, Open  ]],
Cell[CellGroupData[{
Cell[7272, 322, 83, 1, 47, "Subsubsection",
 CellTags->"Member"],
Cell[7358, 325, 218, 5, 64, "Text"],
Cell[7579, 332, 95, 3, 41, "Input",
 CellTags->"Member"],
Cell[7677, 337, 87, 1, 41, "Input",
 CellTags->"Member"]
}, Open  ]],
Cell[CellGroupData[{
Cell[7801, 343, 75, 1, 47, "Subsubsection",
 CellTags->"Member"],
Cell[7879, 346, 218, 5, 64, "Text"],
Cell[8100, 353, 95, 3, 41, "Input",
 CellTags->"Member"],
Cell[8198, 358, 79, 1, 41, "Input",
 CellTags->"Member"]
}, Open  ]],
Cell[CellGroupData[{
Cell[8314, 364, 70, 1, 47, "Subsubsection",
 CellTags->"Member"],
Cell[8387, 367, 214, 5, 64, "Text"],
Cell[8604, 374, 95, 3, 41, "Input",
 CellTags->"Member"],
Cell[8702, 379, 74, 1, 41, "Input",
 CellTags->"Member"]
}, Open  ]],
Cell[CellGroupData[{
Cell[8813, 385, 81, 1, 47, "Subsubsection",
 CellTags->"Member"],
Cell[8897, 388, 214, 5, 64, "Text"],
Cell[9114, 395, 95, 3, 41, "Input",
 CellTags->"Member"],
Cell[9212, 400, 85, 1, 41, "Input",
 CellTags->"Member"]
}, Open  ]],
Cell[CellGroupData[{
Cell[9334, 406, 73, 1, 47, "Subsubsection",
 CellTags->"Member"],
Cell[9410, 409, 214, 5, 64, "Text"],
Cell[9627, 416, 95, 3, 41, "Input",
 CellTags->"Member"],
Cell[9725, 421, 77, 1, 41, "Input",
 CellTags->"Member"]
}, Open  ]],
Cell[CellGroupData[{
Cell[9839, 427, 88, 1, 47, "Subsubsection",
 CellTags->"Member"],
Cell[9930, 430, 214, 5, 64, "Text"],
Cell[10147, 437, 95, 3, 41, "Input",
 CellTags->"Member"],
Cell[10245, 442, 92, 1, 41, "Input",
 CellTags->"Member"]
}, Open  ]],
Cell[CellGroupData[{
Cell[10374, 448, 80, 1, 47, "Subsubsection",
 CellTags->"Member"],
Cell[10457, 451, 214, 5, 64, "Text"],
Cell[10674, 458, 95, 3, 41, "Input",
 CellTags->"Member"],
Cell[10772, 463, 84, 1, 41, "Input",
 CellTags->"Member"]
}, Open  ]],
Cell[CellGroupData[{
Cell[10893, 469, 68, 1, 47, "Subsubsection",
 CellTags->"Member"],
Cell[10964, 472, 65, 1, 41, "Input",
 CellTags->"Member"]
}, Open  ]],
Cell[CellGroupData[{
Cell[11066, 478, 74, 1, 47, "Subsubsection",
 CellTags->"Member"],
Cell[11143, 481, 71, 1, 41, "Input",
 CellTags->"Member"]
}, Open  ]],
Cell[CellGroupData[{
Cell[11251, 487, 75, 1, 47, "Subsubsection",
 CellTags->"Member"],
Cell[11329, 490, 72, 1, 41, "Input",
 CellTags->"Member"]
}, Open  ]]
}, Open  ]],
Cell[11428, 495, 53, 1, 77, "Section",
 CellTags->"Procedure"],
Cell[11484, 498, 69, 1, 51, "Section",
 CellTags->"EnumerationMember"]
}, Open  ]]
}
]
*)

(* End of internal cache information *)

