(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 8.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       157,          7]
NotebookDataLength[      6200,        235]
NotebookOptionsPosition[      3038,        121]
NotebookOutlinePosition[      4883,        186]
CellTagsIndexPosition[      4698,        177]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell["Settings", "Chapter",
 CellTags->"Overview"],

Cell["global settings functions.", "Text",
 CellTags->"Overview"],

Cell["The first step is to load the QuantLib package. ", "MathCaption",
 CellTags->"Overview"],

Cell["Needs[\"QuantLib`\"]", "Input",
 CellTags->"Overview"],

Cell["\<\
Within the Settings part there are several constructors and member functions \
available \
\>", "Text",
 CellTags->"Overview"],

Cell["Select[Category[Settings],QLProcedure[#]&]", "Input",
 CellTags->"Overview"],

Cell["Constructors", "Section",
 CellTags->"Constructor"],

Cell["Member function", "Section",
 CellTags->"Member"],

Cell[CellGroupData[{

Cell["Procedures", "Section",
 CellTags->"Procedure"],

Cell[CellGroupData[{

Cell["SettingsEvaluationDate", "Subsubsection",
 CellTags->"Procedure"],

Cell["SettingsEvaluationDate[]", "Input",
 CellTags->"Procedure"]
}, Open  ]],

Cell[CellGroupData[{

Cell["SettingsSetEvaluationDate", "Subsubsection",
 CellTags->"Procedure"],

Cell[BoxData[{Cell[BoxData[GridBox[{
    {"EvalDate", 
     RowBox[{
     "new", " ", "value", " ", "for", " ", "the", " ", "evaluation", " ", 
      RowBox[{"date", "."}]}]}
   }]], "DefinitionBox",
  CellTags->"Procedure"], "\n", Cell["Calling Parameters", 
  "Caption"]}], "Text"],

Cell[BoxData[
 RowBox[{
  RowBox[{"EvalDate", "=", 
   RowBox[{"13", "-", "Feb", "-", "2007"}]}], ";"}]], "Input",
 CellTags->"Procedure"],

Cell["SettingsSetEvaluationDate[EvalDate]", "Input",
 CellTags->"Procedure"]
}, Open  ]],

Cell[CellGroupData[{

Cell["SettingsEnforceTodaysHistoricFixings", "Subsubsection",
 CellTags->"Procedure"],

Cell["SettingsEnforceTodaysHistoricFixings[]", "Input",
 CellTags->"Procedure"]
}, Open  ]],

Cell[CellGroupData[{

Cell["SettingsSetEnforceTodaysHistoricFixings", "Subsubsection",
 CellTags->"Procedure"],

Cell[BoxData[{Cell[BoxData[GridBox[{
    {"Boolean", "true", 
     RowBox[{
     "new", " ", "value", " ", "for", " ", "the", " ", "boolean", " ", 
      "which", " ", "enforce", " ", "the", " ", "usage", " ", "of", " ", 
      "historic", " ", "fixings", " ", "for", " ", 
      RowBox[{"today", "'"}], "s", " ", 
      RowBox[{"date", "."}]}]}
   }]], "DefinitionBox3Col",
  CellTags->"Procedure"], "\n", Cell["Option Setting", "Caption"]}], "Text"],

Cell["SettingsSetEnforceTodaysHistoricFixings[]", "Input",
 CellTags->"Procedure"]
}, Open  ]]
}, Open  ]],

Cell["Enumeration Member", "Section",
 CellTags->"EnumerationMember"]
}, Open  ]]
},
WindowSize->{716, 867},
WindowMargins->{{278, Automatic}, {Automatic, 42}},
FrontEndVersion->"8.0 for Microsoft Windows (32-bit) (February 23, 2011)",
StyleDefinitions->"HelpBrowser.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "Overview"->{
  Cell[579, 22, 50, 1, 99, "Chapter",
   CellTags->"Overview"],
  Cell[632, 25, 65, 1, 37, "Text",
   CellTags->"Overview"],
  Cell[700, 28, 94, 1, 53, "MathCaption",
   CellTags->"Overview"],
  Cell[797, 31, 60, 1, 41, "Input",
   CellTags->"Overview"],
  Cell[860, 34, 136, 4, 37, "Text",
   CellTags->"Overview"],
  Cell[999, 40, 82, 1, 41, "Input",
   CellTags->"Overview"]},
 "Constructor"->{
  Cell[1084, 43, 57, 1, 77, "Section",
   CellTags->"Constructor"]},
 "Member"->{
  Cell[1144, 46, 55, 1, 51, "Section",
   CellTags->"Member"]},
 "Procedure"->{
  Cell[1224, 51, 53, 1, 51, "Section",
   CellTags->"Procedure"],
  Cell[1302, 56, 71, 1, 47, "Subsubsection",
   CellTags->"Procedure"],
  Cell[1376, 59, 65, 1, 41, "Input",
   CellTags->"Procedure"],
  Cell[1478, 65, 74, 1, 47, "Subsubsection",
   CellTags->"Procedure"],
  Cell[1841, 77, 138, 4, 41, "Input",
   CellTags->"Procedure"],
  Cell[1982, 83, 76, 1, 41, "Input",
   CellTags->"Procedure"],
  Cell[2095, 89, 85, 1, 47, "Subsubsection",
   CellTags->"Procedure"],
  Cell[2183, 92, 79, 1, 41, "Input",
   CellTags->"Procedure"],
  Cell[2299, 98, 88, 1, 47, "Subsubsection",
   CellTags->"Procedure"],
  Cell[2844, 112, 82, 1, 41, "Input",
   CellTags->"Procedure"]},
 "EnumerationMember"->{
  Cell[2953, 117, 69, 1, 77, "Section",
   CellTags->"EnumerationMember"]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"Overview", 3338, 131},
 {"Constructor", 3736, 144},
 {"Member", 3818, 147},
 {"Procedure", 3898, 150},
 {"EnumerationMember", 4599, 171}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[579, 22, 50, 1, 99, "Chapter",
 CellTags->"Overview"],
Cell[632, 25, 65, 1, 37, "Text",
 CellTags->"Overview"],
Cell[700, 28, 94, 1, 53, "MathCaption",
 CellTags->"Overview"],
Cell[797, 31, 60, 1, 41, "Input",
 CellTags->"Overview"],
Cell[860, 34, 136, 4, 37, "Text",
 CellTags->"Overview"],
Cell[999, 40, 82, 1, 41, "Input",
 CellTags->"Overview"],
Cell[1084, 43, 57, 1, 77, "Section",
 CellTags->"Constructor"],
Cell[1144, 46, 55, 1, 51, "Section",
 CellTags->"Member"],
Cell[CellGroupData[{
Cell[1224, 51, 53, 1, 51, "Section",
 CellTags->"Procedure"],
Cell[CellGroupData[{
Cell[1302, 56, 71, 1, 47, "Subsubsection",
 CellTags->"Procedure"],
Cell[1376, 59, 65, 1, 41, "Input",
 CellTags->"Procedure"]
}, Open  ]],
Cell[CellGroupData[{
Cell[1478, 65, 74, 1, 47, "Subsubsection",
 CellTags->"Procedure"],
Cell[1555, 68, 283, 7, 64, "Text"],
Cell[1841, 77, 138, 4, 41, "Input",
 CellTags->"Procedure"],
Cell[1982, 83, 76, 1, 41, "Input",
 CellTags->"Procedure"]
}, Open  ]],
Cell[CellGroupData[{
Cell[2095, 89, 85, 1, 47, "Subsubsection",
 CellTags->"Procedure"],
Cell[2183, 92, 79, 1, 41, "Input",
 CellTags->"Procedure"]
}, Open  ]],
Cell[CellGroupData[{
Cell[2299, 98, 88, 1, 47, "Subsubsection",
 CellTags->"Procedure"],
Cell[2390, 101, 451, 9, 109, "Text"],
Cell[2844, 112, 82, 1, 41, "Input",
 CellTags->"Procedure"]
}, Open  ]]
}, Open  ]],
Cell[2953, 117, 69, 1, 77, "Section",
 CellTags->"EnumerationMember"]
}, Open  ]]
}
]
*)

(* End of internal cache information *)

