(* Content-type: application/mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 6.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       145,          7]
NotebookDataLength[      6445,        245]
NotebookOptionsPosition[      3066,        120]
NotebookOutlinePosition[      5365,        200]
CellTagsIndexPosition[      5238,        193]
WindowFrame->Normal
ContainsDynamic->False*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell["SimpleCashFlow", "Chapter",
 CellTags->"Overview",
 CellID->189629185],

Cell["functions to construct and use CashFlow objects.", "Text",
 CellTags->"Overview",
 CellID->497034662],

Cell["The first step is to load the QuantLib package. ", "MathCaption",
 CellTags->"Overview",
 CellID->560317196],

Cell["Needs[\"QuantLib`\"]", "Input",
 CellTags->"Overview",
 CellID->184342212],

Cell["Within the SimpleCashFlow part there is one constructor.", "Text",
 CellChangeTimes->{{3.436085535453125*^9, 3.436085542015625*^9}},
 CellTags->"Overview",
 CellID->109277967],

Cell[CellGroupData[{

Cell["Select[Category[SimpleCashFlow],QLConstructor[#]&]", "Input",
 CellTags->"Overview",
 CellLabel->"In[54]:=",
 CellID->244698752],

Cell[BoxData[
 RowBox[{"{", "SimpleCashFlowVector", "}"}]], "Output",
 CellChangeTimes->{3.436085526765625*^9},
 CellTags->"Overview",
 CellLabel->"Out[54]=",
 CellID->500625359]
}, Open  ]],

Cell[CellGroupData[{

Cell["Constructors", "Section",
 CellTags->"Constructo",
 CellID->367890349],

Cell[CellGroupData[{

Cell["SimpleCashFlowVector", "Subsubsection",
 CellTags->"Constructor",
 CellID->689301814],

Cell[BoxData[{Cell[BoxData[GridBox[{
    {"Amounts", 
     RowBox[{"list", " ", "of", " ", "cash", " ", "to", " ", "be", " ", 
      RowBox[{"received", "/", 
       RowBox[{"paid", "."}]}]}]},
    {"Dates", 
     RowBox[{"payment", " ", "dates", " ", "corresponding", " ", "to", " ", 
      RowBox[{"amounts", "."}]}]}
   }]], "DefinitionBox",
  CellTags->"Constructor"], "\n", Cell["Calling Parameters", 
  "Caption"]}], "Input",
 CellID->82165318],

Cell[BoxData[{
 RowBox[{
  RowBox[{"Amounts", "=", 
   RowBox[{"{", 
    RowBox[{"1000000.0", ",", "500000.0"}], "}"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"Dates", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"2009", ",", "3", ",", "11"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2010", ",", "3", ",", "11"}], "}"}]}], "}"}]}], 
  ";"}]}], "Input",
 CellChangeTimes->{{3.436085561078125*^9, 3.43608558215625*^9}},
 CellTags->"Constructor",
 CellLabel->"In[57]:=",
 CellID->515042817],

Cell[CellGroupData[{

Cell["obj=SimpleCashFlowVector[Amounts,Dates]", "Input",
 CellTags->"Constructor",
 CellLabel->"In[59]:=",
 CellID->294461645],

Cell[BoxData["SimpleCashFlowVector1"], "Output",
 CellChangeTimes->{3.436085584390625*^9},
 CellTags->"Constructor",
 CellLabel->"Out[59]=",
 CellID->264533382]
}, Open  ]]
}, Open  ]]
}, Open  ]]
}, Open  ]]
},
Editable->True,
WindowSize->{616, 750},
WindowMargins->{{Automatic, 522}, {55, Automatic}},
DockedCells->FEPrivate`FrontEndResource[
 "FEExpressions", "HelpViewerToolbar"],
PageHeaders->{{None, None, None}, {None, None, 
   Cell[
    TextData[{
      Cell[
       TextData[{"Printed from [[YOUR APPLICATION'S NAME]] documentation "}], 
       "PageHeader"], 
      Cell[
       TextData[{
         CounterBox["Page"]}], "PageNumber"]}], 
    CellMargins -> {{Inherited, -29}, {Inherited, Inherited}}]}},
PageFooters->{{None, None, None}, {
   Cell[
    TextData[{"\[Copyright] 2008 Weber & Partner. All rights reserved."}], 
    "PageFooter"], None, None}},
TaggingRules->{"SearchTextTranslated" -> "", "SearchText" -> ""},
CreateCellID->True,
ShowCellTags->False,
FrontEndVersion->"6.0 for Microsoft Windows (32-bit) (May 21, 2008)",
StyleDefinitions->FrontEnd`FileName[{"Wolfram"}, "Reference.nb", 
  CharacterEncoding -> "WindowsANSI"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "Overview"->{
  Cell[590, 23, 76, 2, 85, "Chapter",
   CellTags->"Overview",
   CellID->189629185],
  Cell[669, 27, 107, 2, 30, "Text",
   CellTags->"Overview",
   CellID->497034662],
  Cell[779, 31, 114, 2, 31, "MathCaption",
   CellTags->"Overview",
   CellID->560317196],
  Cell[896, 35, 80, 2, 28, "Input",
   CellTags->"Overview",
   CellID->184342212],
  Cell[979, 39, 181, 3, 30, "Text",
   CellTags->"Overview",
   CellID->109277967],
  Cell[1185, 46, 134, 3, 28, "Input",
   CellTags->"Overview",
   CellID->244698752],
  Cell[1322, 51, 178, 5, 36, "Output",
   CellTags->"Overview",
   CellID->500625359]},
 "Constructo"->{
  Cell[1537, 61, 76, 2, 51, "Section",
   CellTags->"Constructo",
   CellID->367890349]},
 "Constructor"->{
  Cell[1638, 67, 91, 2, 30, "Subsubsection",
   CellTags->"Constructor",
   CellID->689301814],
  Cell[2185, 84, 515, 17, 47, "Input",
   CellTags->"Constructor",
   CellID->515042817],
  Cell[2725, 105, 126, 3, 28, "Input",
   CellTags->"Constructor",
   CellID->294461645],
  Cell[2854, 110, 160, 4, 36, "Output",
   CellTags->"Constructor",
   CellID->264533382]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"Overview", 4119, 151},
 {"Constructo", 4739, 173},
 {"Constructor", 4847, 177}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[590, 23, 76, 2, 85, "Chapter",
 CellTags->"Overview",
 CellID->189629185],
Cell[669, 27, 107, 2, 30, "Text",
 CellTags->"Overview",
 CellID->497034662],
Cell[779, 31, 114, 2, 31, "MathCaption",
 CellTags->"Overview",
 CellID->560317196],
Cell[896, 35, 80, 2, 28, "Input",
 CellTags->"Overview",
 CellID->184342212],
Cell[979, 39, 181, 3, 30, "Text",
 CellTags->"Overview",
 CellID->109277967],
Cell[CellGroupData[{
Cell[1185, 46, 134, 3, 28, "Input",
 CellTags->"Overview",
 CellID->244698752],
Cell[1322, 51, 178, 5, 36, "Output",
 CellTags->"Overview",
 CellID->500625359]
}, Open  ]],
Cell[CellGroupData[{
Cell[1537, 61, 76, 2, 51, "Section",
 CellTags->"Constructo",
 CellID->367890349],
Cell[CellGroupData[{
Cell[1638, 67, 91, 2, 30, "Subsubsection",
 CellTags->"Constructor",
 CellID->689301814],
Cell[1732, 71, 450, 11, 78, "Input",
 CellID->82165318],
Cell[2185, 84, 515, 17, 47, "Input",
 CellTags->"Constructor",
 CellID->515042817],
Cell[CellGroupData[{
Cell[2725, 105, 126, 3, 28, "Input",
 CellTags->"Constructor",
 CellID->294461645],
Cell[2854, 110, 160, 4, 36, "Output",
 CellTags->"Constructor",
 CellID->264533382]
}, Open  ]]
}, Open  ]]
}, Open  ]]
}, Open  ]]
}
]
*)

(* End of internal cache information *)
