(* Content-type: application/mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 6.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       145,          7]
NotebookDataLength[     74542,       2972]
NotebookOptionsPosition[     38834,       1644]
NotebookOutlinePosition[     55337,       2206]
CellTagsIndexPosition[     55149,       2197]
WindowFrame->Normal
ContainsDynamic->False*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell["Statistics", "Chapter",
 CellTags->"Overview",
 CellID->626366002],

Cell["functions to construct and use Statistics objects.", "Text",
 CellTags->"Overview",
 CellID->377256512],

Cell["The first step is to load the QuantLib package. ", "MathCaption",
 CellTags->"Overview",
 CellID->243918148],

Cell["Needs[\"QuantLib`\"]", "Input",
 CellTags->"Overview",
 CellID->253869002],

Cell["\<\
Within the Statistics part there are several constructors and member \
functions available \
\>", "Text",
 CellTags->"Overview",
 CellID->214786468],

Cell["Select[Category[Statistics],QLConstructor[#]&]", "Input",
 CellTags->"Overview",
 CellID->137033669],

Cell["Select[Category[Statistics],QLMember[#]&]", "Input",
 CellTags->"Overview",
 CellID->32418618],

Cell["Select[Category[Statistics],QLProcedure[#]&]", "Input",
 CellTags->"Overview",
 CellID->228584494],

Cell[CellGroupData[{

Cell["Constructors", "Section",
 CellTags->"Constructo",
 CellID->152364931],

Cell[CellGroupData[{

Cell["Statistics", "Subsubsection",
 CellTags->"Constructor",
 CellID->479877809],

Cell[BoxData[{Cell[BoxData[GridBox[{
    {"Values", 
     RowBox[{
      RowBox[{"std", "::", "vector"}], "<", 
      RowBox[{"QuantLib", "::", "Real"}], ">", 
      RowBox[{"(", ")"}]}], 
     RowBox[{
      RowBox[{"Sampled", " ", 
       RowBox[{"values", ".", " ", "If"}], " ", "omitted"}], ",", " ", 
      RowBox[{"an", " ", "empty", " ", "statistics", " ", "is", " ", 
       RowBox[{"created", "."}]}]}]},
    {"Weights", 
     RowBox[{
      RowBox[{"std", "::", "vector"}], "<", 
      RowBox[{"QuantLib", "::", "Real"}], ">", 
      RowBox[{"(", ")"}]}], 
     RowBox[{
      RowBox[{
       RowBox[{"Weights", ".", " ", "If"}], " ", "omitted"}], ",", " ", 
      RowBox[{
      "all", " ", "sampled", " ", "values", " ", "have", " ", "the", " ", 
       "same", " ", 
       RowBox[{"weight", "."}]}]}]}
   }]], "DefinitionBox3Col",
  CellTags->"Constructor"], "\n", Cell["Option Setting", "Caption"]}], "Input",\

 CellID->291852842],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Values", " ", "=", " ", 
  RowBox[{"Range", "[", "10", "]"}]}]], "Input",
 CellChangeTimes->{{3.436086412796875*^9, 3.43608643746875*^9}},
 CellLabel->"In[126]:=",
 CellID->359750369],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "1", ",", "2", ",", "3", ",", "4", ",", "5", ",", "6", ",", "7", ",", "8", 
   ",", "9", ",", "10"}], "}"}]], "Output",
 CellChangeTimes->{3.436086439671875*^9},
 CellLabel->"Out[126]=",
 CellID->791361024]
}, Open  ]],

Cell[CellGroupData[{

Cell["obj=Statistics[Values,{}]", "Input",
 CellChangeTimes->{{3.436086443578125*^9, 3.436086446921875*^9}},
 CellTags->"Constructor",
 CellLabel->"In[127]:=",
 CellID->379841598],

Cell[BoxData["Statistics1"], "Output",
 CellChangeTimes->{3.436086343984375*^9, 3.43608644803125*^9},
 CellTags->"Constructor",
 CellLabel->"Out[127]=",
 CellID->541876522]
}, Open  ]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Member function", "Section",
 CellTags->"Member",
 CellID->201827991],

Cell[CellGroupData[{

Cell["StatisticsSamples", "Subsubsection",
 CellTags->"Member",
 CellID->500185165],

Cell[CellGroupData[{

Cell["StatisticsSamples[obj]", "Input",
 CellTags->"Member",
 CellLabel->"In[128]:=",
 CellID->40577162],

Cell[BoxData["10"], "Output",
 CellChangeTimes->{3.43608645821875*^9},
 CellTags->"Member",
 CellLabel->"Out[128]=",
 CellID->19670572]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["StatisticsWeightSum", "Subsubsection",
 CellTags->"Member",
 CellID->378404582],

Cell[CellGroupData[{

Cell["StatisticsWeightSum[obj]", "Input",
 CellTags->"Member",
 CellLabel->"In[129]:=",
 CellID->308372909],

Cell[BoxData["10.`"], "Output",
 CellChangeTimes->{3.43608646065625*^9},
 CellTags->"Member",
 CellLabel->"Out[129]=",
 CellID->1343060]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["StatisticsMean", "Subsubsection",
 CellTags->"Member",
 CellID->902404314],

Cell[CellGroupData[{

Cell["StatisticsMean[obj]", "Input",
 CellTags->"Member",
 CellLabel->"In[130]:=",
 CellID->14893235],

Cell[BoxData["5.5`"], "Output",
 CellChangeTimes->{3.4360864626875*^9},
 CellTags->"Member",
 CellLabel->"Out[130]=",
 CellID->267384206]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["StatisticsVariance", "Subsubsection",
 CellTags->"Member",
 CellID->4799900],

Cell[CellGroupData[{

Cell["StatisticsVariance[obj]", "Input",
 CellTags->"Member",
 CellLabel->"In[131]:=",
 CellID->43793812],

Cell[BoxData["9.166666666666666`"], "Output",
 CellChangeTimes->{3.436086464625*^9},
 CellTags->"Member",
 CellLabel->"Out[131]=",
 CellID->12645674]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["StatisticsStandardDeviation", "Subsubsection",
 CellTags->"Member",
 CellID->625912002],

Cell[CellGroupData[{

Cell["StatisticsStandardDeviation[obj]", "Input",
 CellTags->"Member",
 CellLabel->"In[132]:=",
 CellID->448258712],

Cell[BoxData["3.0276503540974917`"], "Output",
 CellChangeTimes->{3.43608646684375*^9},
 CellTags->"Member",
 CellLabel->"Out[132]=",
 CellID->787739905]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["StatisticsErrorEstimate", "Subsubsection",
 CellTags->"Member",
 CellID->352575329],

Cell[CellGroupData[{

Cell["StatisticsErrorEstimate[obj]", "Input",
 CellTags->"Member",
 CellLabel->"In[133]:=",
 CellID->86605596],

Cell[BoxData["0.9574271077563381`"], "Output",
 CellChangeTimes->{3.43608646925*^9},
 CellTags->"Member",
 CellLabel->"Out[133]=",
 CellID->259484756]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["StatisticsSkewness", "Subsubsection",
 CellTags->"Member",
 CellID->4024695],

Cell[CellGroupData[{

Cell["StatisticsSkewness[obj]", "Input",
 CellTags->"Member",
 CellLabel->"In[134]:=",
 CellID->546421928],

Cell[BoxData["0.`"], "Output",
 CellChangeTimes->{3.4360864708125*^9},
 CellTags->"Member",
 CellLabel->"Out[134]=",
 CellID->479874997]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["StatisticsKurtosis", "Subsubsection",
 CellTags->"Member",
 CellID->29993973],

Cell[CellGroupData[{

Cell["StatisticsKurtosis[obj]", "Input",
 CellTags->"Member",
 CellLabel->"In[135]:=",
 CellID->374208277],

Cell[BoxData[
 RowBox[{"-", "1.2000000000000002`"}]], "Output",
 CellChangeTimes->{3.436086472109375*^9},
 CellTags->"Member",
 CellLabel->"Out[135]=",
 CellID->1593296]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["StatisticsMin", "Subsubsection",
 CellTags->"Member",
 CellID->25581109],

Cell[CellGroupData[{

Cell["StatisticsMin[obj]", "Input",
 CellTags->"Member",
 CellLabel->"In[136]:=",
 CellID->53886505],

Cell[BoxData["1.`"], "Output",
 CellChangeTimes->{3.436086473453125*^9},
 CellTags->"Member",
 CellLabel->"Out[136]=",
 CellID->8144689]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["StatisticsMax", "Subsubsection",
 CellTags->"Member",
 CellID->957490258],

Cell[CellGroupData[{

Cell["StatisticsMax[obj]", "Input",
 CellTags->"Member",
 CellLabel->"In[137]:=",
 CellID->78708669],

Cell[BoxData["10.`"], "Output",
 CellChangeTimes->{3.4360864748125*^9},
 CellTags->"Member",
 CellLabel->"Out[137]=",
 CellID->557061542]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["StatisticsPercentile", "Subsubsection",
 CellTags->"Member",
 CellID->29546040],

Cell[BoxData[{Cell[BoxData[GridBox[{
    {"X", 
     RowBox[{
      RowBox[{
       RowBox[{"Must", " ", "be", " ", "in", " ", "the", " ", "range", " ", 
        RowBox[{"(", 
         RowBox[{"0", ",", "1"}]}]}], "]"}], "."}]}
   }]], "DefinitionBox",
  CellTags->"Member"], "\n", Cell["Calling Parameters", "Caption"]}], "Input",\

 CellID->616694574],

Cell[BoxData[
 RowBox[{
  RowBox[{"X", "=", "0.5"}], ";"}]], "Input",
 CellTags->"Member",
 CellLabel->"In[138]:=",
 CellID->640810871],

Cell[CellGroupData[{

Cell["StatisticsPercentile[obj,X]", "Input",
 CellTags->"Member",
 CellLabel->"In[139]:=",
 CellID->13030901],

Cell[BoxData["5.`"], "Output",
 CellChangeTimes->{3.436086479625*^9},
 CellTags->"Member",
 CellLabel->"Out[139]=",
 CellID->402315871]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["StatisticsTopPercentile", "Subsubsection",
 CellTags->"Member",
 CellID->24796822],

Cell[BoxData[{Cell[BoxData[GridBox[{
    {"X", 
     RowBox[{
      RowBox[{
       RowBox[{"Must", " ", "be", " ", "in", " ", "the", " ", "range", " ", 
        RowBox[{"(", 
         RowBox[{"0", ",", "1"}]}]}], "]"}], "."}]}
   }]], "DefinitionBox",
  CellTags->"Member"], "\n", Cell["Calling Parameters", "Caption"]}], "Input",\

 CellID->445936453],

Cell[BoxData[
 RowBox[{
  RowBox[{"X", "=", "0.5"}], ";"}]], "Input",
 CellTags->"Member",
 CellLabel->"In[140]:=",
 CellID->17943723],

Cell[CellGroupData[{

Cell["StatisticsTopPercentile[obj,X]", "Input",
 CellTags->"Member",
 CellLabel->"In[141]:=",
 CellID->600767044],

Cell[BoxData["6.`"], "Output",
 CellChangeTimes->{3.43608648415625*^9},
 CellTags->"Member",
 CellLabel->"Out[141]=",
 CellID->276139660]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["StatisticsGaussianDownsideVariance", "Subsubsection",
 CellTags->"Member",
 CellID->142647087],

Cell[CellGroupData[{

Cell["StatisticsGaussianDownsideVariance[obj]", "Input",
 CellTags->"Member",
 CellLabel->"In[142]:=",
 CellID->537198770],

Cell[BoxData["2.585504018229327`"], "Output",
 CellChangeTimes->{3.43608648590625*^9},
 CellTags->"Member",
 CellLabel->"Out[142]=",
 CellID->128116644]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["StatisticsGaussianDownsideDeviation", "Subsubsection",
 CellTags->"Member",
 CellID->469384492],

Cell[CellGroupData[{

Cell["StatisticsGaussianDownsideDeviation[obj]", "Input",
 CellTags->"Member",
 CellLabel->"In[143]:=",
 CellID->112932101],

Cell[BoxData["1.607950253655046`"], "Output",
 CellChangeTimes->{3.436086487703125*^9},
 CellTags->"Member",
 CellLabel->"Out[143]=",
 CellID->4619820]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["StatisticsGaussianRegret", "Subsubsection",
 CellTags->"Member",
 CellID->53131412],

Cell[BoxData[{Cell[BoxData[GridBox[{
    {"Target", 
     RowBox[{"the", " ", 
      RowBox[{"target", "."}]}]}
   }]], "DefinitionBox",
  CellTags->"Member"], "\n", Cell["Calling Parameters", "Caption"]}], "Input",\

 CellID->949178043],

Cell[BoxData[
 RowBox[{
  RowBox[{"Target", "=", "0.5"}], ";"}]], "Input",
 CellTags->"Member",
 CellLabel->"In[144]:=",
 CellID->246212192],

Cell[CellGroupData[{

Cell["StatisticsGaussianRegret[obj,Target]", "Input",
 CellTags->"Member",
 CellLabel->"In[145]:=",
 CellID->226416796],

Cell[BoxData["2.854763325971764`"], "Output",
 CellChangeTimes->{3.4360864910625*^9},
 CellTags->"Member",
 CellLabel->"Out[145]=",
 CellID->1053840019]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["StatisticsGaussianPercentile", "Subsubsection",
 CellTags->"Member",
 CellID->844850076],

Cell[BoxData[{Cell[BoxData[GridBox[{
    {"X", 
     RowBox[{
      RowBox[{
       RowBox[{"Must", " ", "be", " ", "in", " ", "the", " ", "range", " ", 
        RowBox[{"(", 
         RowBox[{"0", ",", "1"}]}]}], "]"}], "."}]}
   }]], "DefinitionBox",
  CellTags->"Member"], "\n", Cell["Calling Parameters", "Caption"]}], "Input",\

 CellID->182612699],

Cell[BoxData[
 RowBox[{
  RowBox[{"X", "=", "0.5"}], ";"}]], "Input",
 CellTags->"Member",
 CellLabel->"In[146]:=",
 CellID->430412787],

Cell[CellGroupData[{

Cell["StatisticsGaussianPercentile[obj,X]", "Input",
 CellTags->"Member",
 CellLabel->"In[147]:=",
 CellID->633809633],

Cell[BoxData["5.5`"], "Output",
 CellChangeTimes->{3.43608649490625*^9},
 CellTags->"Member",
 CellLabel->"Out[147]=",
 CellID->25004227]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["StatisticsGaussianTopPercentile", "Subsubsection",
 CellTags->"Member",
 CellID->352788960],

Cell[BoxData[{Cell[BoxData[GridBox[{
    {"X", 
     RowBox[{
      RowBox[{
       RowBox[{"Must", " ", "be", " ", "in", " ", "the", " ", "range", " ", 
        RowBox[{"(", 
         RowBox[{"0", ",", "1"}]}]}], "]"}], "."}]}
   }]], "DefinitionBox",
  CellTags->"Member"], "\n", Cell["Calling Parameters", "Caption"]}], "Input",\

 CellID->169388691],

Cell[BoxData[
 RowBox[{
  RowBox[{"X", "=", "0.5"}], ";"}]], "Input",
 CellTags->"Member",
 CellLabel->"In[148]:=",
 CellID->14316719],

Cell[CellGroupData[{

Cell["StatisticsGaussianTopPercentile[obj,X]", "Input",
 CellTags->"Member",
 CellLabel->"In[149]:=",
 CellID->160717574],

Cell[BoxData["5.5`"], "Output",
 CellChangeTimes->{3.436086498859375*^9},
 CellTags->"Member",
 CellLabel->"Out[149]=",
 CellID->269756270]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["StatisticsGaussianPotentialUpside", "Subsubsection",
 CellTags->"Member",
 CellID->71503756],

Cell[BoxData[{Cell[BoxData[GridBox[{
    {"Target", 
     RowBox[{"the", " ", 
      RowBox[{"percentile", "."}]}]}
   }]], "DefinitionBox",
  CellTags->"Member"], "\n", Cell["Calling Parameters", "Caption"]}], "Input",\

 CellID->348575341],

Cell[BoxData[
 RowBox[{
  RowBox[{"Target", "=", "0.95"}], ";"}]], "Input",
 CellChangeTimes->{{3.436086523390625*^9, 3.43608653440625*^9}},
 CellTags->"Member",
 CellLabel->"In[153]:=",
 CellID->37765247],

Cell[CellGroupData[{

Cell["StatisticsGaussianPotentialUpside[obj,Target]", "Input",
 CellTags->"Member",
 CellLabel->"In[154]:=",
 CellID->8734658],

Cell[BoxData["10.480041660574585`"], "Output",
 CellChangeTimes->{{3.4360865019375*^9, 3.43608653571875*^9}},
 CellTags->"Member",
 CellLabel->"Out[154]=",
 CellID->307992160]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["StatisticsGaussianValueAtRisk", "Subsubsection",
 CellTags->"Member",
 CellID->516217763],

Cell[BoxData[{Cell[BoxData[GridBox[{
    {"Target", 
     RowBox[{"the", " ", 
      RowBox[{"percentile", "."}]}]}
   }]], "DefinitionBox",
  CellTags->"Member"], "\n", Cell["Calling Parameters", "Caption"]}], "Input",\

 CellID->738734109],

Cell[BoxData[
 RowBox[{
  RowBox[{"Target", "=", "0.95"}], ";"}]], "Input",
 CellChangeTimes->{3.4360865485*^9},
 CellTags->"Member",
 CellLabel->"In[157]:=",
 CellID->81624199],

Cell[CellGroupData[{

Cell["StatisticsGaussianValueAtRisk[obj,Target]", "Input",
 CellTags->"Member",
 CellLabel->"In[158]:=",
 CellID->184586412],

Cell[BoxData["0.`"], "Output",
 CellChangeTimes->{{3.43608654359375*^9, 3.43608654984375*^9}},
 CellTags->"Member",
 CellLabel->"Out[158]=",
 CellID->87844561]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["StatisticsGaussianExpectedShortfall", "Subsubsection",
 CellTags->"Member",
 CellID->178252162],

Cell[BoxData[{Cell[BoxData[GridBox[{
    {"Target", 
     RowBox[{"the", " ", 
      RowBox[{"percentile", "."}]}]}
   }]], "DefinitionBox",
  CellTags->"Member"], "\n", Cell["Calling Parameters", "Caption"]}], "Input",\

 CellID->50425871],

Cell[BoxData[
 RowBox[{
  RowBox[{"Target", "=", "0.95"}], ";"}]], "Input",
 CellChangeTimes->{{3.436086570015625*^9, 3.436086588625*^9}},
 CellTags->"Member",
 CellLabel->"In[163]:=",
 CellID->516457525],

Cell[CellGroupData[{

Cell["StatisticsGaussianExpectedShortfall[obj,Target]", "Input",
 CellTags->"Member",
 CellLabel->"In[166]:=",
 CellID->164766266],

Cell[BoxData["0.7451731807241799`"], "Output",
 CellChangeTimes->{{3.436086583015625*^9, 3.43608660103125*^9}},
 CellTags->"Member",
 CellLabel->"Out[166]=",
 CellID->188864809]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["StatisticsGaussianShortfall", "Subsubsection",
 CellTags->"Member",
 CellID->26380621],

Cell[BoxData[{Cell[BoxData[GridBox[{
    {"Target", 
     RowBox[{"the", " ", 
      RowBox[{"target", "."}]}]}
   }]], "DefinitionBox",
  CellTags->"Member"], "\n", Cell["Calling Parameters", "Caption"]}], "Input",\

 CellID->309696174],

Cell[BoxData[
 RowBox[{
  RowBox[{"Target", "=", "0.95"}], ";"}]], "Input",
 CellChangeTimes->{3.436086593359375*^9},
 CellTags->"Member",
 CellLabel->"In[164]:=",
 CellID->368551041],

Cell[CellGroupData[{

Cell["StatisticsGaussianShortfall[obj,Target]", "Input",
 CellTags->"Member",
 CellLabel->"In[165]:=",
 CellID->52508693],

Cell[BoxData["0.06644330881291466`"], "Output",
 CellChangeTimes->{3.43608656378125*^9, 3.436086596609375*^9},
 CellTags->"Member",
 CellLabel->"Out[165]=",
 CellID->215163986]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["StatisticsGaussianAverageShortfall", "Subsubsection",
 CellTags->"Member",
 CellID->499400871],

Cell[BoxData[{Cell[BoxData[GridBox[{
    {"Target", 
     RowBox[{"the", " ", 
      RowBox[{"target", "."}]}]}
   }]], "DefinitionBox",
  CellTags->"Member"], "\n", Cell["Calling Parameters", "Caption"]}], "Input",\

 CellID->97022675],

Cell[BoxData[
 RowBox[{
  RowBox[{"Target", "=", "0.95"}], ";"}]], "Input",
 CellChangeTimes->{3.436086606921875*^9},
 CellTags->"Member",
 CellLabel->"In[167]:=",
 CellID->512452781],

Cell[CellGroupData[{

Cell["StatisticsGaussianAverageShortfall[obj,Target]", "Input",
 CellTags->"Member",
 CellLabel->"In[168]:=",
 CellID->486843316],

Cell[BoxData["1.3268872708059938`"], "Output",
 CellChangeTimes->{3.436086608203125*^9},
 CellTags->"Member",
 CellLabel->"Out[168]=",
 CellID->120168306]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["StatisticsSemiVariance", "Subsubsection",
 CellTags->"Member",
 CellID->158663759],

Cell[CellGroupData[{

Cell["StatisticsSemiVariance[obj]", "Input",
 CellTags->"Member",
 CellLabel->"In[169]:=",
 CellID->767513546],

Cell[BoxData["10.3125`"], "Output",
 CellChangeTimes->{3.436086610625*^9},
 CellTags->"Member",
 CellLabel->"Out[169]=",
 CellID->191870919]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["StatisticsSemiDeviation", "Subsubsection",
 CellTags->"Member",
 CellID->384277363],

Cell[CellGroupData[{

Cell["StatisticsSemiDeviation[obj]", "Input",
 CellTags->"Member",
 CellLabel->"In[170]:=",
 CellID->209932226],

Cell[BoxData["3.2113081446662823`"], "Output",
 CellChangeTimes->{3.43608661246875*^9},
 CellTags->"Member",
 CellLabel->"Out[170]=",
 CellID->55026977]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["StatisticsDownsideVariance", "Subsubsection",
 CellTags->"Member",
 CellID->153635770],

Cell[CellGroupData[{

Cell["StatisticsDownsideVariance[obj]", "Input",
 CellTags->"Member",
 CellLabel->"In[171]:=",
 CellID->30983652],

Cell[BoxData[
 RowBox[{
  RowBox[{"QuantLibError", "::", "\<\"msg\"\>"}], ":", 
  " ", "\<\"\\!\\(\\\"samples under target <= 1, unsufficient\\\"\\)\"\>"}]], \
"Message", "MSG",
 CellChangeTimes->{3.43608661396875*^9},
 CellTags->"Member",
 CellLabel->"During evaluation of In[171]:=",
 CellID->76686361],

Cell[BoxData["$Failed"], "Output",
 CellChangeTimes->{3.436086613984375*^9},
 CellTags->"Member",
 CellLabel->"Out[171]=",
 CellID->100123745]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["StatisticsDownsideDeviation", "Subsubsection",
 CellTags->"Member",
 CellID->826962936],

Cell[CellGroupData[{

Cell["StatisticsDownsideDeviation[obj]", "Input",
 CellTags->"Member",
 CellLabel->"In[172]:=",
 CellID->416472925],

Cell[BoxData[
 RowBox[{
  RowBox[{"QuantLibError", "::", "\<\"msg\"\>"}], ":", 
  " ", "\<\"\\!\\(\\\"samples under target <= 1, unsufficient\\\"\\)\"\>"}]], \
"Message", "MSG",
 CellChangeTimes->{3.43608662196875*^9},
 CellTags->"Member",
 CellLabel->"During evaluation of In[172]:=",
 CellID->439009572],

Cell[BoxData["$Failed"], "Output",
 CellChangeTimes->{3.436086621984375*^9},
 CellTags->"Member",
 CellLabel->"Out[172]=",
 CellID->12736562]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["StatisticsRegret", "Subsubsection",
 CellTags->"Member",
 CellID->481826594],

Cell[BoxData[{Cell[BoxData[GridBox[{
    {"Target", 
     RowBox[{"the", " ", 
      RowBox[{"target", "."}]}]}
   }]], "DefinitionBox",
  CellTags->"Member"], "\n", Cell["Calling Parameters", "Caption"]}], "Input",\

 CellID->106872543],

Cell[BoxData[
 RowBox[{
  RowBox[{"Target", "=", "0.5"}], ";"}]], "Input",
 CellTags->"Member",
 CellLabel->"In[173]:=",
 CellID->237620033],

Cell[CellGroupData[{

Cell["StatisticsRegret[obj,Target]", "Input",
 CellTags->"Member",
 CellLabel->"In[174]:=",
 CellID->107124004],

Cell[BoxData[
 RowBox[{
  RowBox[{"QuantLibError", "::", "\<\"msg\"\>"}], ":", 
  " ", "\<\"\\!\\(\\\"samples under target <= 1, unsufficient\\\"\\)\"\>"}]], \
"Message", "MSG",
 CellChangeTimes->{3.436086631671875*^9},
 CellTags->"Member",
 CellLabel->"During evaluation of In[174]:=",
 CellID->97653356],

Cell[BoxData["$Failed"], "Output",
 CellChangeTimes->{3.4360866316875*^9},
 CellTags->"Member",
 CellLabel->"Out[174]=",
 CellID->232088972]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["StatisticsPotentialUpside", "Subsubsection",
 CellTags->"Member",
 CellID->2979311],

Cell[BoxData[{Cell[BoxData[GridBox[{
    {"Centile", 
     RowBox[{"the", " ", 
      RowBox[{"centile", "."}]}]}
   }]], "DefinitionBox",
  CellTags->"Member"], "\n", Cell["Calling Parameters", "Caption"]}], "Input",\

 CellID->578594262],

Cell[BoxData[
 RowBox[{
  RowBox[{"Centile", "=", "0.5"}], ";"}]], "Input",
 CellTags->"Member",
 CellLabel->"In[175]:=",
 CellID->741463188],

Cell[CellGroupData[{

Cell["StatisticsPotentialUpside[obj,Centile]", "Input",
 CellTags->"Member",
 CellLabel->"In[176]:=",
 CellID->18282660],

Cell[BoxData[
 RowBox[{
  RowBox[{"QuantLibError", "::", "\<\"msg\"\>"}], ":", 
  " ", "\<\"\\!\\(\\\"percentile (0.5) out of range [0.9, \
1.0)\\\"\\)\"\>"}]], "Message", "MSG",
 CellChangeTimes->{3.43608664353125*^9},
 CellTags->"Member",
 CellLabel->"During evaluation of In[176]:=",
 CellID->2208071],

Cell[BoxData["$Failed"], "Output",
 CellChangeTimes->{3.436086643546875*^9},
 CellTags->"Member",
 CellLabel->"Out[176]=",
 CellID->242222203]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["StatisticsValueAtRisk", "Subsubsection",
 CellTags->"Member",
 CellID->226044189],

Cell[BoxData[{Cell[BoxData[GridBox[{
    {"Target", 
     RowBox[{"the", " ", 
      RowBox[{"percentile", "."}]}]}
   }]], "DefinitionBox",
  CellTags->"Member"], "\n", Cell["Calling Parameters", "Caption"]}], "Input",\

 CellID->376671617],

Cell[BoxData[
 RowBox[{
  RowBox[{"Target", "=", "0.5"}], ";"}]], "Input",
 CellTags->"Member",
 CellLabel->"In[177]:=",
 CellID->58036674],

Cell[CellGroupData[{

Cell["StatisticsValueAtRisk[obj,Target]", "Input",
 CellTags->"Member",
 CellLabel->"In[178]:=",
 CellID->28874662],

Cell[BoxData[
 RowBox[{
  RowBox[{"QuantLibError", "::", "\<\"msg\"\>"}], ":", 
  " ", "\<\"\\!\\(\\\"percentile (0.5) out of range [0.9, \
1.0)\\\"\\)\"\>"}]], "Message", "MSG",
 CellChangeTimes->{3.4360866485625*^9},
 CellTags->"Member",
 CellLabel->"During evaluation of In[178]:=",
 CellID->901476598],

Cell[BoxData["$Failed"], "Output",
 CellChangeTimes->{3.436086648578125*^9},
 CellTags->"Member",
 CellLabel->"Out[178]=",
 CellID->101596764]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["StatisticsExpectedShortfall", "Subsubsection",
 CellTags->"Member",
 CellID->229437303],

Cell[BoxData[{Cell[BoxData[GridBox[{
    {"Centile", 
     RowBox[{"the", " ", 
      RowBox[{"centile", "."}]}]}
   }]], "DefinitionBox",
  CellTags->"Member"], "\n", Cell["Calling Parameters", "Caption"]}], "Input",\

 CellID->695266541],

Cell[BoxData[
 RowBox[{
  RowBox[{"Centile", "=", "0.5"}], ";"}]], "Input",
 CellTags->"Member",
 CellLabel->"In[179]:=",
 CellID->105579656],

Cell[CellGroupData[{

Cell["StatisticsExpectedShortfall[obj,Centile]", "Input",
 CellTags->"Member",
 CellLabel->"In[180]:=",
 CellID->390052965],

Cell[BoxData[
 RowBox[{
  RowBox[{"QuantLibError", "::", "\<\"msg\"\>"}], ":", 
  " ", "\<\"\\!\\(\\\"percentile (0.5) out of range [0.9, \
1.0)\\\"\\)\"\>"}]], "Message", "MSG",
 CellChangeTimes->{3.43608665221875*^9},
 CellTags->"Member",
 CellLabel->"During evaluation of In[180]:=",
 CellID->183330544],

Cell[BoxData["$Failed"], "Output",
 CellChangeTimes->{3.436086652234375*^9},
 CellTags->"Member",
 CellLabel->"Out[180]=",
 CellID->105342509]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["StatisticsShortfall", "Subsubsection",
 CellTags->"Member",
 CellID->79259139],

Cell[BoxData[{Cell[BoxData[GridBox[{
    {"Target", 
     RowBox[{"the", " ", 
      RowBox[{"target", "."}]}]}
   }]], "DefinitionBox",
  CellTags->"Member"], "\n", Cell["Calling Parameters", "Caption"]}], "Input",\

 CellID->314173332],

Cell[BoxData[
 RowBox[{
  RowBox[{"Target", "=", "0.5"}], ";"}]], "Input",
 CellTags->"Member",
 CellLabel->"In[181]:=",
 CellID->338389182],

Cell[CellGroupData[{

Cell["StatisticsShortfall[obj,Target]", "Input",
 CellTags->"Member",
 CellLabel->"In[182]:=",
 CellID->636284404],

Cell[BoxData["0.`"], "Output",
 CellChangeTimes->{3.436086656171875*^9},
 CellTags->"Member",
 CellLabel->"Out[182]=",
 CellID->61092181]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["StatisticsAverageShortfall", "Subsubsection",
 CellTags->"Member",
 CellID->298889765],

Cell[BoxData[{Cell[BoxData[GridBox[{
    {"Target", 
     RowBox[{"the", " ", 
      RowBox[{"target", "."}]}]}
   }]], "DefinitionBox",
  CellTags->"Member"], "\n", Cell["Calling Parameters", "Caption"]}], "Input",\

 CellID->176629465],

Cell[BoxData[
 RowBox[{
  RowBox[{"Target", "=", "0.5"}], ";"}]], "Input",
 CellTags->"Member",
 CellLabel->"In[183]:=",
 CellID->105469837],

Cell[CellGroupData[{

Cell["StatisticsAverageShortfall[obj,Target]", "Input",
 CellTags->"Member",
 CellLabel->"In[184]:=",
 CellID->673152259],

Cell[BoxData[
 RowBox[{
  RowBox[{"QuantLibError", "::", "\<\"msg\"\>"}], ":", 
  " ", "\<\"\\!\\(\\\"no data below the target\\\"\\)\"\>"}]], "Message", \
"MSG",
 CellChangeTimes->{3.43608665959375*^9},
 CellTags->"Member",
 CellLabel->"During evaluation of In[184]:=",
 CellID->3603873],

Cell[BoxData["$Failed"], "Output",
 CellChangeTimes->{3.436086659609375*^9},
 CellTags->"Member",
 CellLabel->"Out[184]=",
 CellID->502190852]
}, Open  ]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Procedures", "Section",
 CellTags->"Procedure",
 CellID->615423947],

Cell[CellGroupData[{

Cell["GaussianDownsideVariance", "Subsubsection",
 CellTags->"Procedure",
 CellID->36916584],

Cell[BoxData[{Cell[BoxData[GridBox[{
    {"Mean", "0.0", 
     RowBox[{
     "the", " ", "mean", " ", "of", " ", "the", " ", "gaussian", " ", 
      RowBox[{"distribution", "."}]}]},
    {"StdDev", "1.0", 
     RowBox[{
     "standard", " ", "deviation", " ", "of", " ", "the", " ", "gaussian", 
      " ", 
      RowBox[{"distribution", "."}]}]}
   }]], "DefinitionBox3Col",
  CellTags->"Procedure"], "\n", Cell["Option Setting", "Caption"]}], "Input",
 CellID->91660687],

Cell[CellGroupData[{

Cell["GaussianDownsideVariance[]", "Input",
 CellTags->"Procedure",
 CellLabel->"In[185]:=",
 CellID->457352685],

Cell[BoxData["1.`"], "Output",
 CellChangeTimes->{3.436086663671875*^9},
 CellTags->"Procedure",
 CellLabel->"Out[185]=",
 CellID->527141367]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["GaussianDownsideDeviation", "Subsubsection",
 CellTags->"Procedure",
 CellID->187245089],

Cell[BoxData[{Cell[BoxData[GridBox[{
    {"Mean", "0.0", 
     RowBox[{"mean", " ", "of", " ", "the", " ", "gaussian", " ", 
      RowBox[{"distribution", "."}]}]},
    {"StdDev", "1.0", 
     RowBox[{
     "standard", " ", "deviation", " ", "of", " ", "the", " ", "gaussian", 
      " ", 
      RowBox[{"distribution", "."}]}]}
   }]], "DefinitionBox3Col",
  CellTags->"Procedure"], "\n", Cell["Option Setting", "Caption"]}], "Input",
 CellID->271420834],

Cell[CellGroupData[{

Cell["GaussianDownsideDeviation[]", "Input",
 CellTags->"Procedure",
 CellLabel->"In[186]:=",
 CellID->3636573],

Cell[BoxData["1.`"], "Output",
 CellChangeTimes->{3.43608666796875*^9},
 CellTags->"Procedure",
 CellLabel->"Out[186]=",
 CellID->40154696]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["GaussianRegret", "Subsubsection",
 CellTags->"Procedure",
 CellID->16112220],

Cell[BoxData[{Cell[BoxData[GridBox[{
    {"Target", 
     RowBox[{"the", " ", 
      RowBox[{"target", "."}]}]}
   }]], "DefinitionBox",
  CellTags->"Procedure"], "\n", Cell["Calling Parameters", 
  "Caption"]}], "Input",
 CellID->7648200],

Cell[BoxData[{Cell[BoxData[GridBox[{
    {"Mean", "0.0", 
     RowBox[{"mean", " ", "of", " ", "the", " ", "gaussian", " ", 
      RowBox[{"distribution", "."}]}]},
    {"StdDev", "1.0", 
     RowBox[{
     "standard", " ", "deviation", " ", "of", " ", "the", " ", "gaussian", 
      " ", 
      RowBox[{"distribution", "."}]}]}
   }]], "DefinitionBox3Col",
  CellTags->"Procedure"], "\n", Cell["Option Setting", "Caption"]}], "Input",
 CellID->370514643],

Cell[BoxData[
 RowBox[{
  RowBox[{"Target", "=", "0.5"}], ";"}]], "Input",
 CellTags->"Procedure",
 CellLabel->"In[187]:=",
 CellID->24119014],

Cell[CellGroupData[{

Cell["GaussianRegret[Target]", "Input",
 CellTags->"Procedure",
 CellLabel->"In[188]:=",
 CellID->199329438],

Cell[BoxData["1.5045802169185167`"], "Output",
 CellChangeTimes->{3.43608667384375*^9},
 CellTags->"Procedure",
 CellLabel->"Out[188]=",
 CellID->432389325]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["GaussianPercentile", "Subsubsection",
 CellTags->"Procedure",
 CellID->218819320],

Cell[BoxData[{Cell[BoxData[GridBox[{
    {"X", 
     RowBox[{"the", " ", 
      RowBox[{"percentile", "."}]}]}
   }]], "DefinitionBox",
  CellTags->"Procedure"], "\n", Cell["Calling Parameters", 
  "Caption"]}], "Input",
 CellID->274627375],

Cell[BoxData[{Cell[BoxData[GridBox[{
    {"Mean", "0.0", 
     RowBox[{"mean", " ", "of", " ", "the", " ", "gaussian", " ", 
      RowBox[{"distribution", "."}]}]},
    {"StdDev", "1.0", 
     RowBox[{
     "standard", " ", "deviation", " ", "of", " ", "the", " ", "gaussian", 
      " ", 
      RowBox[{"distribution", "."}]}]}
   }]], "DefinitionBox3Col",
  CellTags->"Procedure"], "\n", Cell["Option Setting", "Caption"]}], "Input",
 CellID->87955023],

Cell[BoxData[
 RowBox[{
  RowBox[{"X", "=", "0.5"}], ";"}]], "Input",
 CellTags->"Procedure",
 CellID->240825574],

Cell[CellGroupData[{

Cell["GaussianPercentile[X]", "Input",
 CellTags->"Procedure",
 CellLabel->"In[189]:=",
 CellID->296692529],

Cell[BoxData["0.`"], "Output",
 CellChangeTimes->{3.43608667803125*^9},
 CellTags->"Procedure",
 CellLabel->"Out[189]=",
 CellID->362187079]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["GaussianTopPercentile", "Subsubsection",
 CellTags->"Procedure",
 CellID->123366856],

Cell[BoxData[{Cell[BoxData[GridBox[{
    {"X", 
     RowBox[{"the", " ", 
      RowBox[{"percentile", "."}]}]}
   }]], "DefinitionBox",
  CellTags->"Procedure"], "\n", Cell["Calling Parameters", 
  "Caption"]}], "Input",
 CellID->288862644],

Cell[BoxData[{Cell[BoxData[GridBox[{
    {"Mean", "0.0", 
     RowBox[{
     "The", " ", "mean", " ", "of", " ", "the", " ", "gaussian", " ", 
      RowBox[{"distribution", "."}]}]},
    {"StdDev", "1.0", 
     RowBox[{
     "The", " ", "standard", " ", "deviation", " ", "of", " ", "the", " ", 
      "gaussian", " ", 
      RowBox[{"distribution", "."}]}]}
   }]], "DefinitionBox3Col",
  CellTags->"Procedure"], "\n", Cell["Option Setting", "Caption"]}], "Input",
 CellID->450304086],

Cell[BoxData[
 RowBox[{
  RowBox[{"X", "=", "0.5"}], ";"}]], "Input",
 CellTags->"Procedure",
 CellLabel->"In[190]:=",
 CellID->312027442],

Cell[CellGroupData[{

Cell["GaussianTopPercentile[X]", "Input",
 CellTags->"Procedure",
 CellLabel->"In[191]:=",
 CellID->70870879],

Cell[BoxData["0.`"], "Output",
 CellChangeTimes->{3.43608668215625*^9},
 CellTags->"Procedure",
 CellLabel->"Out[191]=",
 CellID->419969933]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["GaussianPotentialUpside", "Subsubsection",
 CellTags->"Procedure",
 CellID->230801332],

Cell[BoxData[{Cell[BoxData[GridBox[{
    {"Target", 
     RowBox[{"the", " ", 
      RowBox[{"percentile", "."}]}]}
   }]], "DefinitionBox",
  CellTags->"Procedure"], "\n", Cell["Calling Parameters", 
  "Caption"]}], "Input",
 CellID->216218012],

Cell[BoxData[{Cell[BoxData[GridBox[{
    {"Mean", "0.0", 
     RowBox[{
     "The", " ", "mean", " ", "of", " ", "the", " ", "gaussian", " ", 
      RowBox[{"distribution", "."}]}]},
    {"StdDev", "1.0", 
     RowBox[{
     "The", " ", "standard", " ", "deviation", " ", "of", " ", "the", " ", 
      "gaussian", " ", 
      RowBox[{"distribution", "."}]}]}
   }]], "DefinitionBox3Col",
  CellTags->"Procedure"], "\n", Cell["Option Setting", "Caption"]}], "Input",
 CellID->751281594],

Cell[BoxData[
 RowBox[{
  RowBox[{"Target", "=", "0.95"}], ";"}]], "Input",
 CellChangeTimes->{3.436086691375*^9},
 CellTags->"Procedure",
 CellLabel->"In[194]:=",
 CellID->30677055],

Cell[CellGroupData[{

Cell["GaussianPotentialUpside[Target]", "Input",
 CellTags->"Procedure",
 CellLabel->"In[195]:=",
 CellID->100051382],

Cell[BoxData["1.644853625133699`"], "Output",
 CellChangeTimes->{{3.436086686546875*^9, 3.436086693734375*^9}},
 CellTags->"Procedure",
 CellLabel->"Out[195]=",
 CellID->598183302]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["GaussianValueAtRisk", "Subsubsection",
 CellTags->"Procedure",
 CellID->405897896],

Cell[BoxData[{Cell[BoxData[GridBox[{
    {"Target", 
     RowBox[{"the", " ", 
      RowBox[{"percentile", "."}]}]}
   }]], "DefinitionBox",
  CellTags->"Procedure"], "\n", Cell["Calling Parameters", 
  "Caption"]}], "Input",
 CellID->107679691],

Cell[BoxData[{Cell[BoxData[GridBox[{
    {"Mean", "0.0", 
     RowBox[{
     "The", " ", "mean", " ", "of", " ", "the", " ", "gaussian", " ", 
      RowBox[{"distribution", "."}]}]},
    {"StdDev", "1.0", 
     RowBox[{
     "The", " ", "standard", " ", "deviation", " ", "of", " ", "the", " ", 
      "gaussian", " ", 
      RowBox[{"distribution", "."}]}]}
   }]], "DefinitionBox3Col",
  CellTags->"Procedure"], "\n", Cell["Option Setting", "Caption"]}], "Input",
 CellID->2028199],

Cell[BoxData[
 RowBox[{
  RowBox[{"Target", "=", "0.95"}], ";"}]], "Input",
 CellChangeTimes->{3.436086700703125*^9},
 CellTags->"Procedure",
 CellLabel->"In[198]:=",
 CellID->139239770],

Cell[CellGroupData[{

Cell["GaussianValueAtRisk[Target]", "Input",
 CellTags->"Procedure",
 CellLabel->"In[199]:=",
 CellID->14546114],

Cell[BoxData["1.644853625133699`"], "Output",
 CellChangeTimes->{{3.43608669771875*^9, 3.436086701953125*^9}},
 CellTags->"Procedure",
 CellLabel->"Out[199]=",
 CellID->499874541]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["GaussianExpectedShortfall", "Subsubsection",
 CellTags->"Procedure",
 CellID->202614716],

Cell[BoxData[{Cell[BoxData[GridBox[{
    {"Target", 
     RowBox[{"the", " ", 
      RowBox[{"percentile", "."}]}]}
   }]], "DefinitionBox",
  CellTags->"Procedure"], "\n", Cell["Calling Parameters", 
  "Caption"]}], "Input",
 CellID->755448577],

Cell[BoxData[{Cell[BoxData[GridBox[{
    {"Mean", "0.0", 
     RowBox[{
     "The", " ", "mean", " ", "of", " ", "the", " ", "gaussian", " ", 
      RowBox[{"distribution", "."}]}]},
    {"StdDev", "1.0", 
     RowBox[{
     "The", " ", "standard", " ", "deviation", " ", "of", " ", "the", " ", 
      "gaussian", " ", 
      RowBox[{"distribution", "."}]}]}
   }]], "DefinitionBox3Col",
  CellTags->"Procedure"], "\n", Cell["Option Setting", "Caption"]}], "Input",
 CellID->43734118],

Cell[BoxData[
 RowBox[{
  RowBox[{"Target", "=", "0.95"}], ";"}]], "Input",
 CellChangeTimes->{3.436086706734375*^9},
 CellTags->"Procedure",
 CellLabel->"In[200]:=",
 CellID->59875533],

Cell[CellGroupData[{

Cell["GaussianExpectedShortfall[Target]", "Input",
 CellTags->"Procedure",
 CellLabel->"In[201]:=",
 CellID->35300732],

Cell[BoxData["2.062712813674877`"], "Output",
 CellChangeTimes->{3.436086708109375*^9},
 CellTags->"Procedure",
 CellLabel->"Out[201]=",
 CellID->230423087]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["GaussianShortfall", "Subsubsection",
 CellTags->"Procedure",
 CellID->248011418],

Cell[BoxData[{Cell[BoxData[GridBox[{
    {"Target", 
     RowBox[{"the", " ", 
      RowBox[{"target", "."}]}]}
   }]], "DefinitionBox",
  CellTags->"Procedure"], "\n", Cell["Calling Parameters", 
  "Caption"]}], "Input",
 CellID->114371291],

Cell[BoxData[{Cell[BoxData[GridBox[{
    {"Mean", "0.0", 
     RowBox[{
     "The", " ", "mean", " ", "of", " ", "the", " ", "gaussian", " ", 
      RowBox[{"distribution", "."}]}]},
    {"StdDev", "1.0", 
     RowBox[{
     "The", " ", "standard", " ", "deviation", " ", "of", " ", "the", " ", 
      "gaussian", " ", 
      RowBox[{"distribution", "."}]}]}
   }]], "DefinitionBox3Col",
  CellTags->"Procedure"], "\n", Cell["Option Setting", "Caption"]}], "Input",
 CellID->36661960],

Cell[BoxData[
 RowBox[{
  RowBox[{"Target", "=", "0.95"}], ";"}]], "Input",
 CellChangeTimes->{3.43608671378125*^9},
 CellTags->"Procedure",
 CellLabel->"In[202]:=",
 CellID->631963381],

Cell[CellGroupData[{

Cell["GaussianShortfall[Target]", "Input",
 CellTags->"Procedure",
 CellLabel->"In[203]:=",
 CellID->579373328],

Cell[BoxData["0.8289438736915182`"], "Output",
 CellChangeTimes->{3.43608671496875*^9},
 CellTags->"Procedure",
 CellLabel->"Out[203]=",
 CellID->626933585]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["GaussianAverageShortfall", "Subsubsection",
 CellTags->"Procedure",
 CellID->143195415],

Cell[BoxData[{Cell[BoxData[GridBox[{
    {"Target", 
     RowBox[{"the", " ", 
      RowBox[{"target", "."}]}]}
   }]], "DefinitionBox",
  CellTags->"Procedure"], "\n", Cell["Calling Parameters", 
  "Caption"]}], "Input",
 CellID->488330561],

Cell[BoxData[{Cell[BoxData[GridBox[{
    {"Mean", "0.0", 
     RowBox[{
     "The", " ", "mean", " ", "of", " ", "the", " ", "gaussian", " ", 
      RowBox[{"distribution", "."}]}]},
    {"StdDev", "1.0", 
     RowBox[{
     "The", " ", "standard", " ", "deviation", " ", "of", " ", "the", " ", 
      "gaussian", " ", 
      RowBox[{"distribution", "."}]}]}
   }]], "DefinitionBox3Col",
  CellTags->"Procedure"], "\n", Cell["Option Setting", "Caption"]}], "Input",
 CellID->753264919],

Cell[BoxData[
 RowBox[{
  RowBox[{"Target", "=", "0.95"}], ";"}]], "Input",
 CellChangeTimes->{3.43608671834375*^9},
 CellTags->"Procedure",
 CellLabel->"In[204]:=",
 CellID->173834368],

Cell[CellGroupData[{

Cell["GaussianAverageShortfall[Target]", "Input",
 CellTags->"Procedure",
 CellLabel->"In[205]:=",
 CellID->38290861],

Cell[BoxData["1.2564852332375571`"], "Output",
 CellChangeTimes->{3.436086720046875*^9},
 CellTags->"Procedure",
 CellLabel->"Out[205]=",
 CellID->296937794]
}, Open  ]]
}, Open  ]]
}, Open  ]]
}, Open  ]]
},
Editable->True,
WindowSize->{616, 750},
WindowMargins->{{Automatic, 502}, {25, Automatic}},
DockedCells->FEPrivate`FrontEndResource[
 "FEExpressions", "HelpViewerToolbar"],
PageHeaders->{{None, None, None}, {None, None, 
   Cell[
    TextData[{
      Cell[
       TextData[{"Printed from [[YOUR APPLICATION'S NAME]] documentation "}], 
       "PageHeader"], 
      Cell[
       TextData[{
         CounterBox["Page"]}], "PageNumber"]}], 
    CellMargins -> {{Inherited, -29}, {Inherited, Inherited}}]}},
PageFooters->{{None, None, None}, {
   Cell[
    TextData[{"\[Copyright] 2008 Weber & Partner. All rights reserved."}], 
    "PageFooter"], None, None}},
ShowSelection->True,
TaggingRules->{"SearchTextTranslated" -> "", "SearchText" -> ""},
CreateCellID->True,
ShowCellTags->False,
FrontEndVersion->"6.0 for Microsoft Windows (32-bit) (May 21, 2008)",
StyleDefinitions->FrontEnd`FileName[{"Wolfram"}, "Reference.nb", 
  CharacterEncoding -> "WindowsANSI"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "Overview"->{
  Cell[590, 23, 72, 2, 99, "Chapter",
   CellTags->"Overview",
   CellID->626366002],
  Cell[665, 27, 109, 2, 37, "Text",
   CellTags->"Overview",
   CellID->377256512],
  Cell[777, 31, 114, 2, 53, "MathCaption",
   CellTags->"Overview",
   CellID->243918148],
  Cell[894, 35, 80, 2, 41, "Input",
   CellTags->"Overview",
   CellID->253869002],
  Cell[977, 39, 158, 5, 37, "Text",
   CellTags->"Overview",
   CellID->214786468],
  Cell[1138, 46, 106, 2, 41, "Input",
   CellTags->"Overview",
   CellID->137033669],
  Cell[1247, 50, 100, 2, 41, "Input",
   CellTags->"Overview",
   CellID->32418618],
  Cell[1350, 54, 104, 2, 41, "Input",
   CellTags->"Overview",
   CellID->228584494]},
 "Constructo"->{
  Cell[1479, 60, 76, 2, 77, "Section",
   CellTags->"Constructo",
   CellID->152364931]},
 "Constructor"->{
  Cell[1580, 66, 81, 2, 47, "Subsubsection",
   CellTags->"Constructor",
   CellID->479877809],
  Cell[3130, 119, 179, 4, 70, "Input",
   CellTags->"Constructor",
   CellID->379841598],
  Cell[3312, 125, 172, 4, 70, "Output",
   CellTags->"Constructor",
   CellID->541876522]},
 "Member"->{
  Cell[3545, 136, 75, 2, 70, "Section",
   CellTags->"Member",
   CellID->201827991],
  Cell[3645, 142, 83, 2, 70, "Subsubsection",
   CellTags->"Member",
   CellID->500185165],
  Cell[3753, 148, 104, 3, 70, "Input",
   CellTags->"Member",
   CellID->40577162],
  Cell[3860, 153, 135, 4, 70, "Output",
   CellTags->"Member",
   CellID->19670572],
  Cell[4044, 163, 85, 2, 70, "Subsubsection",
   CellTags->"Member",
   CellID->378404582],
  Cell[4154, 169, 107, 3, 70, "Input",
   CellTags->"Member",
   CellID->308372909],
  Cell[4264, 174, 136, 4, 70, "Output",
   CellTags->"Member",
   CellID->1343060],
  Cell[4449, 184, 80, 2, 70, "Subsubsection",
   CellTags->"Member",
   CellID->902404314],
  Cell[4554, 190, 101, 3, 70, "Input",
   CellTags->"Member",
   CellID->14893235],
  Cell[4658, 195, 137, 4, 70, "Output",
   CellTags->"Member",
   CellID->267384206],
  Cell[4844, 205, 82, 2, 70, "Subsubsection",
   CellTags->"Member",
   CellID->4799900],
  Cell[4951, 211, 105, 3, 70, "Input",
   CellTags->"Member",
   CellID->43793812],
  Cell[5059, 216, 149, 4, 70, "Output",
   CellTags->"Member",
   CellID->12645674],
  Cell[5257, 226, 93, 2, 70, "Subsubsection",
   CellTags->"Member",
   CellID->625912002],
  Cell[5375, 232, 115, 3, 70, "Input",
   CellTags->"Member",
   CellID->448258712],
  Cell[5493, 237, 153, 4, 70, "Output",
   CellTags->"Member",
   CellID->787739905],
  Cell[5695, 247, 89, 2, 70, "Subsubsection",
   CellTags->"Member",
   CellID->352575329],
  Cell[5809, 253, 110, 3, 70, "Input",
   CellTags->"Member",
   CellID->86605596],
  Cell[5922, 258, 150, 4, 70, "Output",
   CellTags->"Member",
   CellID->259484756],
  Cell[6121, 268, 82, 2, 70, "Subsubsection",
   CellTags->"Member",
   CellID->4024695],
  Cell[6228, 274, 106, 3, 70, "Input",
   CellTags->"Member",
   CellID->546421928],
  Cell[6337, 279, 136, 4, 70, "Output",
   CellTags->"Member",
   CellID->479874997],
  Cell[6522, 289, 83, 2, 70, "Subsubsection",
   CellTags->"Member",
   CellID->29993973],
  Cell[6630, 295, 106, 3, 70, "Input",
   CellTags->"Member",
   CellID->374208277],
  Cell[6739, 300, 169, 5, 70, "Output",
   CellTags->"Member",
   CellID->1593296],
  Cell[6957, 311, 78, 2, 70, "Subsubsection",
   CellTags->"Member",
   CellID->25581109],
  Cell[7060, 317, 100, 3, 70, "Input",
   CellTags->"Member",
   CellID->53886505],
  Cell[7163, 322, 136, 4, 70, "Output",
   CellTags->"Member",
   CellID->8144689],
  Cell[7348, 332, 79, 2, 70, "Subsubsection",
   CellTags->"Member",
   CellID->957490258],
  Cell[7452, 338, 100, 3, 70, "Input",
   CellTags->"Member",
   CellID->78708669],
  Cell[7555, 343, 137, 4, 70, "Output",
   CellTags->"Member",
   CellID->557061542],
  Cell[7741, 353, 85, 2, 70, "Subsubsection",
   CellTags->"Member",
   CellID->29546040],
  Cell[8185, 369, 135, 5, 70, "Input",
   CellTags->"Member",
   CellID->640810871],
  Cell[8345, 378, 109, 3, 70, "Input",
   CellTags->"Member",
   CellID->13030901],
  Cell[8457, 383, 135, 4, 70, "Output",
   CellTags->"Member",
   CellID->402315871],
  Cell[8641, 393, 88, 2, 70, "Subsubsection",
   CellTags->"Member",
   CellID->24796822],
  Cell[9088, 409, 134, 5, 70, "Input",
   CellTags->"Member",
   CellID->17943723],
  Cell[9247, 418, 113, 3, 70, "Input",
   CellTags->"Member",
   CellID->600767044],
  Cell[9363, 423, 137, 4, 70, "Output",
   CellTags->"Member",
   CellID->276139660],
  Cell[9549, 433, 100, 2, 70, "Subsubsection",
   CellTags->"Member",
   CellID->142647087],
  Cell[9674, 439, 122, 3, 70, "Input",
   CellTags->"Member",
   CellID->537198770],
  Cell[9799, 444, 152, 4, 70, "Output",
   CellTags->"Member",
   CellID->128116644],
  Cell[10000, 454, 101, 2, 70, "Subsubsection",
   CellTags->"Member",
   CellID->469384492],
  Cell[10126, 460, 123, 3, 70, "Input",
   CellTags->"Member",
   CellID->112932101],
  Cell[10252, 465, 151, 4, 70, "Output",
   CellTags->"Member",
   CellID->4619820],
  Cell[10452, 475, 89, 2, 70, "Subsubsection",
   CellTags->"Member",
   CellID->53131412],
  Cell[10784, 488, 140, 5, 70, "Input",
   CellTags->"Member",
   CellID->246212192],
  Cell[10949, 497, 119, 3, 70, "Input",
   CellTags->"Member",
   CellID->226416796],
  Cell[11071, 502, 152, 4, 70, "Output",
   CellTags->"Member",
   CellID->1053840019],
  Cell[11272, 512, 94, 2, 70, "Subsubsection",
   CellTags->"Member",
   CellID->844850076],
  Cell[11725, 528, 135, 5, 70, "Input",
   CellTags->"Member",
   CellID->430412787],
  Cell[11885, 537, 118, 3, 70, "Input",
   CellTags->"Member",
   CellID->633809633],
  Cell[12006, 542, 137, 4, 70, "Output",
   CellTags->"Member",
   CellID->25004227],
  Cell[12192, 552, 97, 2, 70, "Subsubsection",
   CellTags->"Member",
   CellID->352788960],
  Cell[12648, 568, 134, 5, 70, "Input",
   CellTags->"Member",
   CellID->14316719],
  Cell[12807, 577, 121, 3, 70, "Input",
   CellTags->"Member",
   CellID->160717574],
  Cell[12931, 582, 139, 4, 70, "Output",
   CellTags->"Member",
   CellID->269756270],
  Cell[13119, 592, 98, 2, 70, "Subsubsection",
   CellTags->"Member",
   CellID->71503756],
  Cell[13464, 605, 205, 6, 70, "Input",
   CellTags->"Member",
   CellID->37765247],
  Cell[13694, 615, 126, 3, 70, "Input",
   CellTags->"Member",
   CellID->8734658],
  Cell[13823, 620, 175, 4, 70, "Output",
   CellTags->"Member",
   CellID->307992160],
  Cell[14047, 630, 95, 2, 70, "Subsubsection",
   CellTags->"Member",
   CellID->516217763],
  Cell[14389, 643, 177, 6, 70, "Input",
   CellTags->"Member",
   CellID->81624199],
  Cell[14591, 653, 124, 3, 70, "Input",
   CellTags->"Member",
   CellID->184586412],
  Cell[14718, 658, 159, 4, 70, "Output",
   CellTags->"Member",
   CellID->87844561],
  Cell[14926, 668, 101, 2, 70, "Subsubsection",
   CellTags->"Member",
   CellID->178252162],
  Cell[15273, 681, 204, 6, 70, "Input",
   CellTags->"Member",
   CellID->516457525],
  Cell[15502, 691, 130, 3, 70, "Input",
   CellTags->"Member",
   CellID->164766266],
  Cell[15635, 696, 177, 4, 70, "Output",
   CellTags->"Member",
   CellID->188864809],
  Cell[15861, 706, 92, 2, 70, "Subsubsection",
   CellTags->"Member",
   CellID->26380621],
  Cell[16196, 719, 183, 6, 70, "Input",
   CellTags->"Member",
   CellID->368551041],
  Cell[16404, 729, 121, 3, 70, "Input",
   CellTags->"Member",
   CellID->52508693],
  Cell[16528, 734, 176, 4, 70, "Output",
   CellTags->"Member",
   CellID->215163986],
  Cell[16753, 744, 100, 2, 70, "Subsubsection",
   CellTags->"Member",
   CellID->499400871],
  Cell[17095, 757, 183, 6, 70, "Input",
   CellTags->"Member",
   CellID->512452781],
  Cell[17303, 767, 129, 3, 70, "Input",
   CellTags->"Member",
   CellID->486843316],
  Cell[17435, 772, 154, 4, 70, "Output",
   CellTags->"Member",
   CellID->120168306],
  Cell[17638, 782, 88, 2, 70, "Subsubsection",
   CellTags->"Member",
   CellID->158663759],
  Cell[17751, 788, 110, 3, 70, "Input",
   CellTags->"Member",
   CellID->767513546],
  Cell[17864, 793, 140, 4, 70, "Output",
   CellTags->"Member",
   CellID->191870919],
  Cell[18053, 803, 89, 2, 70, "Subsubsection",
   CellTags->"Member",
   CellID->384277363],
  Cell[18167, 809, 111, 3, 70, "Input",
   CellTags->"Member",
   CellID->209932226],
  Cell[18281, 814, 152, 4, 70, "Output",
   CellTags->"Member",
   CellID->55026977],
  Cell[18482, 824, 92, 2, 70, "Subsubsection",
   CellTags->"Member",
   CellID->153635770],
  Cell[18599, 830, 113, 3, 70, "Input",
   CellTags->"Member",
   CellID->30983652],
  Cell[18715, 835, 304, 8, 70, "Message",
   CellTags->"Member",
   CellID->76686361],
  Cell[19022, 845, 142, 4, 70, "Output",
   CellTags->"Member",
   CellID->100123745],
  Cell[19213, 855, 93, 2, 70, "Subsubsection",
   CellTags->"Member",
   CellID->826962936],
  Cell[19331, 861, 115, 3, 70, "Input",
   CellTags->"Member",
   CellID->416472925],
  Cell[19449, 866, 305, 8, 70, "Message",
   CellTags->"Member",
   CellID->439009572],
  Cell[19757, 876, 141, 4, 70, "Output",
   CellTags->"Member",
   CellID->12736562],
  Cell[19947, 886, 82, 2, 70, "Subsubsection",
   CellTags->"Member",
   CellID->481826594],
  Cell[20272, 899, 140, 5, 70, "Input",
   CellTags->"Member",
   CellID->237620033],
  Cell[20437, 908, 111, 3, 70, "Input",
   CellTags->"Member",
   CellID->107124004],
  Cell[20551, 913, 305, 8, 70, "Message",
   CellTags->"Member",
   CellID->97653356],
  Cell[20859, 923, 140, 4, 70, "Output",
   CellTags->"Member",
   CellID->232088972],
  Cell[21048, 933, 89, 2, 70, "Subsubsection",
   CellTags->"Member",
   CellID->2979311],
  Cell[21382, 946, 141, 5, 70, "Input",
   CellTags->"Member",
   CellID->741463188],
  Cell[21548, 955, 120, 3, 70, "Input",
   CellTags->"Member",
   CellID->18282660],
  Cell[21671, 960, 304, 8, 70, "Message",
   CellTags->"Member",
   CellID->2208071],
  Cell[21978, 970, 142, 4, 70, "Output",
   CellTags->"Member",
   CellID->242222203],
  Cell[22169, 980, 87, 2, 70, "Subsubsection",
   CellTags->"Member",
   CellID->226044189],
  Cell[22503, 993, 139, 5, 70, "Input",
   CellTags->"Member",
   CellID->58036674],
  Cell[22667, 1002, 115, 3, 70, "Input",
   CellTags->"Member",
   CellID->28874662],
  Cell[22785, 1007, 305, 8, 70, "Message",
   CellTags->"Member",
   CellID->901476598],
  Cell[23093, 1017, 142, 4, 70, "Output",
   CellTags->"Member",
   CellID->101596764],
  Cell[23284, 1027, 93, 2, 70, "Subsubsection",
   CellTags->"Member",
   CellID->229437303],
  Cell[23622, 1040, 141, 5, 70, "Input",
   CellTags->"Member",
   CellID->105579656],
  Cell[23788, 1049, 123, 3, 70, "Input",
   CellTags->"Member",
   CellID->390052965],
  Cell[23914, 1054, 306, 8, 70, "Message",
   CellTags->"Member",
   CellID->183330544],
  Cell[24223, 1064, 142, 4, 70, "Output",
   CellTags->"Member",
   CellID->105342509],
  Cell[24414, 1074, 84, 2, 70, "Subsubsection",
   CellTags->"Member",
   CellID->79259139],
  Cell[24741, 1087, 140, 5, 70, "Input",
   CellTags->"Member",
   CellID->338389182],
  Cell[24906, 1096, 114, 3, 70, "Input",
   CellTags->"Member",
   CellID->636284404],
  Cell[25023, 1101, 137, 4, 70, "Output",
   CellTags->"Member",
   CellID->61092181],
  Cell[25209, 1111, 92, 2, 70, "Subsubsection",
   CellTags->"Member",
   CellID->298889765],
  Cell[25544, 1124, 140, 5, 70, "Input",
   CellTags->"Member",
   CellID->105469837],
  Cell[25709, 1133, 121, 3, 70, "Input",
   CellTags->"Member",
   CellID->673152259],
  Cell[25833, 1138, 288, 8, 70, "Message",
   CellTags->"Member",
   CellID->3603873],
  Cell[26124, 1148, 142, 4, 70, "Output",
   CellTags->"Member",
   CellID->502190852]},
 "Procedure"->{
  Cell[26327, 1159, 73, 2, 70, "Section",
   CellTags->"Procedure",
   CellID->615423947],
  Cell[26425, 1165, 92, 2, 70, "Subsubsection",
   CellTags->"Procedure",
   CellID->36916584],
  Cell[27017, 1185, 112, 3, 70, "Input",
   CellTags->"Procedure",
   CellID->457352685],
  Cell[27132, 1190, 141, 4, 70, "Output",
   CellTags->"Procedure",
   CellID->527141367],
  Cell[27322, 1200, 94, 2, 70, "Subsubsection",
   CellTags->"Procedure",
   CellID->187245089],
  Cell[27899, 1219, 111, 3, 70, "Input",
   CellTags->"Procedure",
   CellID->3636573],
  Cell[28013, 1224, 139, 4, 70, "Output",
   CellTags->"Procedure",
   CellID->40154696],
  Cell[28201, 1234, 82, 2, 70, "Subsubsection",
   CellTags->"Procedure",
   CellID->16112220],
  Cell[28986, 1260, 142, 5, 70, "Input",
   CellTags->"Procedure",
   CellID->24119014],
  Cell[29153, 1269, 108, 3, 70, "Input",
   CellTags->"Procedure",
   CellID->199329438],
  Cell[29264, 1274, 156, 4, 70, "Output",
   CellTags->"Procedure",
   CellID->432389325],
  Cell[29469, 1284, 87, 2, 70, "Subsubsection",
   CellTags->"Procedure",
   CellID->218819320],
  Cell[30259, 1310, 113, 4, 70, "Input",
   CellTags->"Procedure",
   CellID->240825574],
  Cell[30397, 1318, 107, 3, 70, "Input",
   CellTags->"Procedure",
   CellID->296692529],
  Cell[30507, 1323, 140, 4, 70, "Output",
   CellTags->"Procedure",
   CellID->362187079],
  Cell[30696, 1333, 90, 2, 70, "Subsubsection",
   CellTags->"Procedure",
   CellID->123366856],
  Cell[31520, 1360, 138, 5, 70, "Input",
   CellTags->"Procedure",
   CellID->312027442],
  Cell[31683, 1369, 109, 3, 70, "Input",
   CellTags->"Procedure",
   CellID->70870879],
  Cell[31795, 1374, 140, 4, 70, "Output",
   CellTags->"Procedure",
   CellID->419969933],
  Cell[31984, 1384, 92, 2, 70, "Subsubsection",
   CellTags->"Procedure",
   CellID->230801332],
  Cell[32815, 1411, 182, 6, 70, "Input",
   CellTags->"Procedure",
   CellID->30677055],
  Cell[33022, 1421, 117, 3, 70, "Input",
   CellTags->"Procedure",
   CellID->100051382],
  Cell[33142, 1426, 180, 4, 70, "Output",
   CellTags->"Procedure",
   CellID->598183302],
  Cell[33371, 1436, 88, 2, 70, "Subsubsection",
   CellTags->"Procedure",
   CellID->405897896],
  Cell[34196, 1463, 186, 6, 70, "Input",
   CellTags->"Procedure",
   CellID->139239770],
  Cell[34407, 1473, 112, 3, 70, "Input",
   CellTags->"Procedure",
   CellID->14546114],
  Cell[34522, 1478, 179, 4, 70, "Output",
   CellTags->"Procedure",
   CellID->499874541],
  Cell[34750, 1488, 94, 2, 70, "Subsubsection",
   CellTags->"Procedure",
   CellID->202614716],
  Cell[35582, 1515, 185, 6, 28, "Input",
   CellTags->"Procedure",
   CellID->59875533],
  Cell[35792, 1525, 118, 3, 28, "Input",
   CellTags->"Procedure",
   CellID->35300732],
  Cell[35913, 1530, 156, 4, 36, "Output",
   CellTags->"Procedure",
   CellID->230423087],
  Cell[36118, 1540, 86, 2, 30, "Subsubsection",
   CellTags->"Procedure",
   CellID->248011418],
  Cell[36938, 1567, 185, 6, 28, "Input",
   CellTags->"Procedure",
   CellID->631963381],
  Cell[37148, 1577, 111, 3, 28, "Input",
   CellTags->"Procedure",
   CellID->579373328],
  Cell[37262, 1582, 156, 4, 36, "Output",
   CellTags->"Procedure",
   CellID->626933585],
  Cell[37467, 1592, 93, 2, 30, "Subsubsection",
   CellTags->"Procedure",
   CellID->143195415],
  Cell[38295, 1619, 185, 6, 28, "Input",
   CellTags->"Procedure",
   CellID->173834368],
  Cell[38505, 1629, 117, 3, 28, "Input",
   CellTags->"Procedure",
   CellID->38290861],
  Cell[38625, 1634, 157, 4, 36, "Output",
   CellTags->"Procedure",
   CellID->296937794]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"Overview", 39908, 1676},
 {"Constructo", 40612, 1701},
 {"Constructor", 40720, 1705},
 {"Member", 41011, 1715},
 {"Procedure", 51546, 2076}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[590, 23, 72, 2, 99, "Chapter",
 CellTags->"Overview",
 CellID->626366002],
Cell[665, 27, 109, 2, 37, "Text",
 CellTags->"Overview",
 CellID->377256512],
Cell[777, 31, 114, 2, 53, "MathCaption",
 CellTags->"Overview",
 CellID->243918148],
Cell[894, 35, 80, 2, 41, "Input",
 CellTags->"Overview",
 CellID->253869002],
Cell[977, 39, 158, 5, 37, "Text",
 CellTags->"Overview",
 CellID->214786468],
Cell[1138, 46, 106, 2, 41, "Input",
 CellTags->"Overview",
 CellID->137033669],
Cell[1247, 50, 100, 2, 41, "Input",
 CellTags->"Overview",
 CellID->32418618],
Cell[1350, 54, 104, 2, 41, "Input",
 CellTags->"Overview",
 CellID->228584494],
Cell[CellGroupData[{
Cell[1479, 60, 76, 2, 77, "Section",
 CellTags->"Constructo",
 CellID->152364931],
Cell[CellGroupData[{
Cell[1580, 66, 81, 2, 47, "Subsubsection",
 CellTags->"Constructor",
 CellID->479877809],
Cell[1664, 70, 946, 26, 174, "Input",
 CellID->291852842],
Cell[CellGroupData[{
Cell[2635, 100, 207, 5, 27, "Input",
 CellID->359750369],
Cell[2845, 107, 248, 7, 25, "Output",
 CellID->791361024]
}, Open  ]],
Cell[CellGroupData[{
Cell[3130, 119, 179, 4, 70, "Input",
 CellTags->"Constructor",
 CellID->379841598],
Cell[3312, 125, 172, 4, 70, "Output",
 CellTags->"Constructor",
 CellID->541876522]
}, Open  ]]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[3545, 136, 75, 2, 70, "Section",
 CellTags->"Member",
 CellID->201827991],
Cell[CellGroupData[{
Cell[3645, 142, 83, 2, 70, "Subsubsection",
 CellTags->"Member",
 CellID->500185165],
Cell[CellGroupData[{
Cell[3753, 148, 104, 3, 70, "Input",
 CellTags->"Member",
 CellID->40577162],
Cell[3860, 153, 135, 4, 70, "Output",
 CellTags->"Member",
 CellID->19670572]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[4044, 163, 85, 2, 70, "Subsubsection",
 CellTags->"Member",
 CellID->378404582],
Cell[CellGroupData[{
Cell[4154, 169, 107, 3, 70, "Input",
 CellTags->"Member",
 CellID->308372909],
Cell[4264, 174, 136, 4, 70, "Output",
 CellTags->"Member",
 CellID->1343060]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[4449, 184, 80, 2, 70, "Subsubsection",
 CellTags->"Member",
 CellID->902404314],
Cell[CellGroupData[{
Cell[4554, 190, 101, 3, 70, "Input",
 CellTags->"Member",
 CellID->14893235],
Cell[4658, 195, 137, 4, 70, "Output",
 CellTags->"Member",
 CellID->267384206]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[4844, 205, 82, 2, 70, "Subsubsection",
 CellTags->"Member",
 CellID->4799900],
Cell[CellGroupData[{
Cell[4951, 211, 105, 3, 70, "Input",
 CellTags->"Member",
 CellID->43793812],
Cell[5059, 216, 149, 4, 70, "Output",
 CellTags->"Member",
 CellID->12645674]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[5257, 226, 93, 2, 70, "Subsubsection",
 CellTags->"Member",
 CellID->625912002],
Cell[CellGroupData[{
Cell[5375, 232, 115, 3, 70, "Input",
 CellTags->"Member",
 CellID->448258712],
Cell[5493, 237, 153, 4, 70, "Output",
 CellTags->"Member",
 CellID->787739905]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[5695, 247, 89, 2, 70, "Subsubsection",
 CellTags->"Member",
 CellID->352575329],
Cell[CellGroupData[{
Cell[5809, 253, 110, 3, 70, "Input",
 CellTags->"Member",
 CellID->86605596],
Cell[5922, 258, 150, 4, 70, "Output",
 CellTags->"Member",
 CellID->259484756]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[6121, 268, 82, 2, 70, "Subsubsection",
 CellTags->"Member",
 CellID->4024695],
Cell[CellGroupData[{
Cell[6228, 274, 106, 3, 70, "Input",
 CellTags->"Member",
 CellID->546421928],
Cell[6337, 279, 136, 4, 70, "Output",
 CellTags->"Member",
 CellID->479874997]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[6522, 289, 83, 2, 70, "Subsubsection",
 CellTags->"Member",
 CellID->29993973],
Cell[CellGroupData[{
Cell[6630, 295, 106, 3, 70, "Input",
 CellTags->"Member",
 CellID->374208277],
Cell[6739, 300, 169, 5, 70, "Output",
 CellTags->"Member",
 CellID->1593296]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[6957, 311, 78, 2, 70, "Subsubsection",
 CellTags->"Member",
 CellID->25581109],
Cell[CellGroupData[{
Cell[7060, 317, 100, 3, 70, "Input",
 CellTags->"Member",
 CellID->53886505],
Cell[7163, 322, 136, 4, 70, "Output",
 CellTags->"Member",
 CellID->8144689]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[7348, 332, 79, 2, 70, "Subsubsection",
 CellTags->"Member",
 CellID->957490258],
Cell[CellGroupData[{
Cell[7452, 338, 100, 3, 70, "Input",
 CellTags->"Member",
 CellID->78708669],
Cell[7555, 343, 137, 4, 70, "Output",
 CellTags->"Member",
 CellID->557061542]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[7741, 353, 85, 2, 70, "Subsubsection",
 CellTags->"Member",
 CellID->29546040],
Cell[7829, 357, 353, 10, 70, "Input",
 CellID->616694574],
Cell[8185, 369, 135, 5, 70, "Input",
 CellTags->"Member",
 CellID->640810871],
Cell[CellGroupData[{
Cell[8345, 378, 109, 3, 70, "Input",
 CellTags->"Member",
 CellID->13030901],
Cell[8457, 383, 135, 4, 70, "Output",
 CellTags->"Member",
 CellID->402315871]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[8641, 393, 88, 2, 70, "Subsubsection",
 CellTags->"Member",
 CellID->24796822],
Cell[8732, 397, 353, 10, 70, "Input",
 CellID->445936453],
Cell[9088, 409, 134, 5, 70, "Input",
 CellTags->"Member",
 CellID->17943723],
Cell[CellGroupData[{
Cell[9247, 418, 113, 3, 70, "Input",
 CellTags->"Member",
 CellID->600767044],
Cell[9363, 423, 137, 4, 70, "Output",
 CellTags->"Member",
 CellID->276139660]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[9549, 433, 100, 2, 70, "Subsubsection",
 CellTags->"Member",
 CellID->142647087],
Cell[CellGroupData[{
Cell[9674, 439, 122, 3, 70, "Input",
 CellTags->"Member",
 CellID->537198770],
Cell[9799, 444, 152, 4, 70, "Output",
 CellTags->"Member",
 CellID->128116644]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[10000, 454, 101, 2, 70, "Subsubsection",
 CellTags->"Member",
 CellID->469384492],
Cell[CellGroupData[{
Cell[10126, 460, 123, 3, 70, "Input",
 CellTags->"Member",
 CellID->112932101],
Cell[10252, 465, 151, 4, 70, "Output",
 CellTags->"Member",
 CellID->4619820]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[10452, 475, 89, 2, 70, "Subsubsection",
 CellTags->"Member",
 CellID->53131412],
Cell[10544, 479, 237, 7, 70, "Input",
 CellID->949178043],
Cell[10784, 488, 140, 5, 70, "Input",
 CellTags->"Member",
 CellID->246212192],
Cell[CellGroupData[{
Cell[10949, 497, 119, 3, 70, "Input",
 CellTags->"Member",
 CellID->226416796],
Cell[11071, 502, 152, 4, 70, "Output",
 CellTags->"Member",
 CellID->1053840019]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[11272, 512, 94, 2, 70, "Subsubsection",
 CellTags->"Member",
 CellID->844850076],
Cell[11369, 516, 353, 10, 70, "Input",
 CellID->182612699],
Cell[11725, 528, 135, 5, 70, "Input",
 CellTags->"Member",
 CellID->430412787],
Cell[CellGroupData[{
Cell[11885, 537, 118, 3, 70, "Input",
 CellTags->"Member",
 CellID->633809633],
Cell[12006, 542, 137, 4, 70, "Output",
 CellTags->"Member",
 CellID->25004227]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[12192, 552, 97, 2, 70, "Subsubsection",
 CellTags->"Member",
 CellID->352788960],
Cell[12292, 556, 353, 10, 70, "Input",
 CellID->169388691],
Cell[12648, 568, 134, 5, 70, "Input",
 CellTags->"Member",
 CellID->14316719],
Cell[CellGroupData[{
Cell[12807, 577, 121, 3, 70, "Input",
 CellTags->"Member",
 CellID->160717574],
Cell[12931, 582, 139, 4, 70, "Output",
 CellTags->"Member",
 CellID->269756270]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[13119, 592, 98, 2, 70, "Subsubsection",
 CellTags->"Member",
 CellID->71503756],
Cell[13220, 596, 241, 7, 70, "Input",
 CellID->348575341],
Cell[13464, 605, 205, 6, 70, "Input",
 CellTags->"Member",
 CellID->37765247],
Cell[CellGroupData[{
Cell[13694, 615, 126, 3, 70, "Input",
 CellTags->"Member",
 CellID->8734658],
Cell[13823, 620, 175, 4, 70, "Output",
 CellTags->"Member",
 CellID->307992160]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[14047, 630, 95, 2, 70, "Subsubsection",
 CellTags->"Member",
 CellID->516217763],
Cell[14145, 634, 241, 7, 70, "Input",
 CellID->738734109],
Cell[14389, 643, 177, 6, 70, "Input",
 CellTags->"Member",
 CellID->81624199],
Cell[CellGroupData[{
Cell[14591, 653, 124, 3, 70, "Input",
 CellTags->"Member",
 CellID->184586412],
Cell[14718, 658, 159, 4, 70, "Output",
 CellTags->"Member",
 CellID->87844561]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[14926, 668, 101, 2, 70, "Subsubsection",
 CellTags->"Member",
 CellID->178252162],
Cell[15030, 672, 240, 7, 70, "Input",
 CellID->50425871],
Cell[15273, 681, 204, 6, 70, "Input",
 CellTags->"Member",
 CellID->516457525],
Cell[CellGroupData[{
Cell[15502, 691, 130, 3, 70, "Input",
 CellTags->"Member",
 CellID->164766266],
Cell[15635, 696, 177, 4, 70, "Output",
 CellTags->"Member",
 CellID->188864809]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[15861, 706, 92, 2, 70, "Subsubsection",
 CellTags->"Member",
 CellID->26380621],
Cell[15956, 710, 237, 7, 70, "Input",
 CellID->309696174],
Cell[16196, 719, 183, 6, 70, "Input",
 CellTags->"Member",
 CellID->368551041],
Cell[CellGroupData[{
Cell[16404, 729, 121, 3, 70, "Input",
 CellTags->"Member",
 CellID->52508693],
Cell[16528, 734, 176, 4, 70, "Output",
 CellTags->"Member",
 CellID->215163986]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[16753, 744, 100, 2, 70, "Subsubsection",
 CellTags->"Member",
 CellID->499400871],
Cell[16856, 748, 236, 7, 70, "Input",
 CellID->97022675],
Cell[17095, 757, 183, 6, 70, "Input",
 CellTags->"Member",
 CellID->512452781],
Cell[CellGroupData[{
Cell[17303, 767, 129, 3, 70, "Input",
 CellTags->"Member",
 CellID->486843316],
Cell[17435, 772, 154, 4, 70, "Output",
 CellTags->"Member",
 CellID->120168306]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[17638, 782, 88, 2, 70, "Subsubsection",
 CellTags->"Member",
 CellID->158663759],
Cell[CellGroupData[{
Cell[17751, 788, 110, 3, 70, "Input",
 CellTags->"Member",
 CellID->767513546],
Cell[17864, 793, 140, 4, 70, "Output",
 CellTags->"Member",
 CellID->191870919]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[18053, 803, 89, 2, 70, "Subsubsection",
 CellTags->"Member",
 CellID->384277363],
Cell[CellGroupData[{
Cell[18167, 809, 111, 3, 70, "Input",
 CellTags->"Member",
 CellID->209932226],
Cell[18281, 814, 152, 4, 70, "Output",
 CellTags->"Member",
 CellID->55026977]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[18482, 824, 92, 2, 70, "Subsubsection",
 CellTags->"Member",
 CellID->153635770],
Cell[CellGroupData[{
Cell[18599, 830, 113, 3, 70, "Input",
 CellTags->"Member",
 CellID->30983652],
Cell[18715, 835, 304, 8, 70, "Message",
 CellTags->"Member",
 CellID->76686361],
Cell[19022, 845, 142, 4, 70, "Output",
 CellTags->"Member",
 CellID->100123745]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[19213, 855, 93, 2, 70, "Subsubsection",
 CellTags->"Member",
 CellID->826962936],
Cell[CellGroupData[{
Cell[19331, 861, 115, 3, 70, "Input",
 CellTags->"Member",
 CellID->416472925],
Cell[19449, 866, 305, 8, 70, "Message",
 CellTags->"Member",
 CellID->439009572],
Cell[19757, 876, 141, 4, 70, "Output",
 CellTags->"Member",
 CellID->12736562]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[19947, 886, 82, 2, 70, "Subsubsection",
 CellTags->"Member",
 CellID->481826594],
Cell[20032, 890, 237, 7, 70, "Input",
 CellID->106872543],
Cell[20272, 899, 140, 5, 70, "Input",
 CellTags->"Member",
 CellID->237620033],
Cell[CellGroupData[{
Cell[20437, 908, 111, 3, 70, "Input",
 CellTags->"Member",
 CellID->107124004],
Cell[20551, 913, 305, 8, 70, "Message",
 CellTags->"Member",
 CellID->97653356],
Cell[20859, 923, 140, 4, 70, "Output",
 CellTags->"Member",
 CellID->232088972]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[21048, 933, 89, 2, 70, "Subsubsection",
 CellTags->"Member",
 CellID->2979311],
Cell[21140, 937, 239, 7, 70, "Input",
 CellID->578594262],
Cell[21382, 946, 141, 5, 70, "Input",
 CellTags->"Member",
 CellID->741463188],
Cell[CellGroupData[{
Cell[21548, 955, 120, 3, 70, "Input",
 CellTags->"Member",
 CellID->18282660],
Cell[21671, 960, 304, 8, 70, "Message",
 CellTags->"Member",
 CellID->2208071],
Cell[21978, 970, 142, 4, 70, "Output",
 CellTags->"Member",
 CellID->242222203]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[22169, 980, 87, 2, 70, "Subsubsection",
 CellTags->"Member",
 CellID->226044189],
Cell[22259, 984, 241, 7, 70, "Input",
 CellID->376671617],
Cell[22503, 993, 139, 5, 70, "Input",
 CellTags->"Member",
 CellID->58036674],
Cell[CellGroupData[{
Cell[22667, 1002, 115, 3, 70, "Input",
 CellTags->"Member",
 CellID->28874662],
Cell[22785, 1007, 305, 8, 70, "Message",
 CellTags->"Member",
 CellID->901476598],
Cell[23093, 1017, 142, 4, 70, "Output",
 CellTags->"Member",
 CellID->101596764]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[23284, 1027, 93, 2, 70, "Subsubsection",
 CellTags->"Member",
 CellID->229437303],
Cell[23380, 1031, 239, 7, 70, "Input",
 CellID->695266541],
Cell[23622, 1040, 141, 5, 70, "Input",
 CellTags->"Member",
 CellID->105579656],
Cell[CellGroupData[{
Cell[23788, 1049, 123, 3, 70, "Input",
 CellTags->"Member",
 CellID->390052965],
Cell[23914, 1054, 306, 8, 70, "Message",
 CellTags->"Member",
 CellID->183330544],
Cell[24223, 1064, 142, 4, 70, "Output",
 CellTags->"Member",
 CellID->105342509]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[24414, 1074, 84, 2, 70, "Subsubsection",
 CellTags->"Member",
 CellID->79259139],
Cell[24501, 1078, 237, 7, 70, "Input",
 CellID->314173332],
Cell[24741, 1087, 140, 5, 70, "Input",
 CellTags->"Member",
 CellID->338389182],
Cell[CellGroupData[{
Cell[24906, 1096, 114, 3, 70, "Input",
 CellTags->"Member",
 CellID->636284404],
Cell[25023, 1101, 137, 4, 70, "Output",
 CellTags->"Member",
 CellID->61092181]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[25209, 1111, 92, 2, 70, "Subsubsection",
 CellTags->"Member",
 CellID->298889765],
Cell[25304, 1115, 237, 7, 70, "Input",
 CellID->176629465],
Cell[25544, 1124, 140, 5, 70, "Input",
 CellTags->"Member",
 CellID->105469837],
Cell[CellGroupData[{
Cell[25709, 1133, 121, 3, 70, "Input",
 CellTags->"Member",
 CellID->673152259],
Cell[25833, 1138, 288, 8, 70, "Message",
 CellTags->"Member",
 CellID->3603873],
Cell[26124, 1148, 142, 4, 70, "Output",
 CellTags->"Member",
 CellID->502190852]
}, Open  ]]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[26327, 1159, 73, 2, 70, "Section",
 CellTags->"Procedure",
 CellID->615423947],
Cell[CellGroupData[{
Cell[26425, 1165, 92, 2, 70, "Subsubsection",
 CellTags->"Procedure",
 CellID->36916584],
Cell[26520, 1169, 472, 12, 70, "Input",
 CellID->91660687],
Cell[CellGroupData[{
Cell[27017, 1185, 112, 3, 70, "Input",
 CellTags->"Procedure",
 CellID->457352685],
Cell[27132, 1190, 141, 4, 70, "Output",
 CellTags->"Procedure",
 CellID->527141367]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[27322, 1200, 94, 2, 70, "Subsubsection",
 CellTags->"Procedure",
 CellID->187245089],
Cell[27419, 1204, 455, 11, 70, "Input",
 CellID->271420834],
Cell[CellGroupData[{
Cell[27899, 1219, 111, 3, 70, "Input",
 CellTags->"Procedure",
 CellID->3636573],
Cell[28013, 1224, 139, 4, 70, "Output",
 CellTags->"Procedure",
 CellID->40154696]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[28201, 1234, 82, 2, 70, "Subsubsection",
 CellTags->"Procedure",
 CellID->16112220],
Cell[28286, 1238, 239, 7, 70, "Input",
 CellID->7648200],
Cell[28528, 1247, 455, 11, 70, "Input",
 CellID->370514643],
Cell[28986, 1260, 142, 5, 70, "Input",
 CellTags->"Procedure",
 CellID->24119014],
Cell[CellGroupData[{
Cell[29153, 1269, 108, 3, 70, "Input",
 CellTags->"Procedure",
 CellID->199329438],
Cell[29264, 1274, 156, 4, 70, "Output",
 CellTags->"Procedure",
 CellID->432389325]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[29469, 1284, 87, 2, 70, "Subsubsection",
 CellTags->"Procedure",
 CellID->218819320],
Cell[29559, 1288, 240, 7, 70, "Input",
 CellID->274627375],
Cell[29802, 1297, 454, 11, 70, "Input",
 CellID->87955023],
Cell[30259, 1310, 113, 4, 70, "Input",
 CellTags->"Procedure",
 CellID->240825574],
Cell[CellGroupData[{
Cell[30397, 1318, 107, 3, 70, "Input",
 CellTags->"Procedure",
 CellID->296692529],
Cell[30507, 1323, 140, 4, 70, "Output",
 CellTags->"Procedure",
 CellID->362187079]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[30696, 1333, 90, 2, 70, "Subsubsection",
 CellTags->"Procedure",
 CellID->123366856],
Cell[30789, 1337, 240, 7, 70, "Input",
 CellID->288862644],
Cell[31032, 1346, 485, 12, 70, "Input",
 CellID->450304086],
Cell[31520, 1360, 138, 5, 70, "Input",
 CellTags->"Procedure",
 CellID->312027442],
Cell[CellGroupData[{
Cell[31683, 1369, 109, 3, 70, "Input",
 CellTags->"Procedure",
 CellID->70870879],
Cell[31795, 1374, 140, 4, 70, "Output",
 CellTags->"Procedure",
 CellID->419969933]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[31984, 1384, 92, 2, 70, "Subsubsection",
 CellTags->"Procedure",
 CellID->230801332],
Cell[32079, 1388, 245, 7, 70, "Input",
 CellID->216218012],
Cell[32327, 1397, 485, 12, 70, "Input",
 CellID->751281594],
Cell[32815, 1411, 182, 6, 70, "Input",
 CellTags->"Procedure",
 CellID->30677055],
Cell[CellGroupData[{
Cell[33022, 1421, 117, 3, 70, "Input",
 CellTags->"Procedure",
 CellID->100051382],
Cell[33142, 1426, 180, 4, 70, "Output",
 CellTags->"Procedure",
 CellID->598183302]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[33371, 1436, 88, 2, 70, "Subsubsection",
 CellTags->"Procedure",
 CellID->405897896],
Cell[33462, 1440, 245, 7, 70, "Input",
 CellID->107679691],
Cell[33710, 1449, 483, 12, 70, "Input",
 CellID->2028199],
Cell[34196, 1463, 186, 6, 70, "Input",
 CellTags->"Procedure",
 CellID->139239770],
Cell[CellGroupData[{
Cell[34407, 1473, 112, 3, 70, "Input",
 CellTags->"Procedure",
 CellID->14546114],
Cell[34522, 1478, 179, 4, 70, "Output",
 CellTags->"Procedure",
 CellID->499874541]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[34750, 1488, 94, 2, 70, "Subsubsection",
 CellTags->"Procedure",
 CellID->202614716],
Cell[34847, 1492, 245, 7, 70, "Input",
 CellID->755448577],
Cell[35095, 1501, 484, 12, 70, "Input",
 CellID->43734118],
Cell[35582, 1515, 185, 6, 28, "Input",
 CellTags->"Procedure",
 CellID->59875533],
Cell[CellGroupData[{
Cell[35792, 1525, 118, 3, 28, "Input",
 CellTags->"Procedure",
 CellID->35300732],
Cell[35913, 1530, 156, 4, 36, "Output",
 CellTags->"Procedure",
 CellID->230423087]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[36118, 1540, 86, 2, 30, "Subsubsection",
 CellTags->"Procedure",
 CellID->248011418],
Cell[36207, 1544, 241, 7, 65, "Input",
 CellID->114371291],
Cell[36451, 1553, 484, 12, 119, "Input",
 CellID->36661960],
Cell[36938, 1567, 185, 6, 28, "Input",
 CellTags->"Procedure",
 CellID->631963381],
Cell[CellGroupData[{
Cell[37148, 1577, 111, 3, 28, "Input",
 CellTags->"Procedure",
 CellID->579373328],
Cell[37262, 1582, 156, 4, 36, "Output",
 CellTags->"Procedure",
 CellID->626933585]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[37467, 1592, 93, 2, 30, "Subsubsection",
 CellTags->"Procedure",
 CellID->143195415],
Cell[37563, 1596, 241, 7, 65, "Input",
 CellID->488330561],
Cell[37807, 1605, 485, 12, 119, "Input",
 CellID->753264919],
Cell[38295, 1619, 185, 6, 28, "Input",
 CellTags->"Procedure",
 CellID->173834368],
Cell[CellGroupData[{
Cell[38505, 1629, 117, 3, 28, "Input",
 CellTags->"Procedure",
 CellID->38290861],
Cell[38625, 1634, 157, 4, 36, "Output",
 CellTags->"Procedure",
 CellID->296937794]
}, Open  ]]
}, Open  ]]
}, Open  ]]
}, Open  ]]
}
]
*)

(* End of internal cache information *)
