(* Content-type: application/mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 6.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       145,          7]
NotebookDataLength[     18645,        753]
NotebookOptionsPosition[      9434,        406]
NotebookOutlinePosition[     14365,        576]
CellTagsIndexPosition[     14239,        569]
WindowFrame->Normal
ContainsDynamic->False*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell["TimeSeries", "Chapter",
 CellTags->"Overview",
 CellID->892145726],

Cell["functions to construct and use TimeSeries objects.", "Text",
 CellTags->"Overview",
 CellID->633035831],

Cell["The first step is to load the QuantLib package. ", "MathCaption",
 CellTags->"Overview",
 CellID->132295213],

Cell["Needs[\"QuantLib`\"]", "Input",
 CellTags->"Overview",
 CellID->256139150],

Cell["\<\
Within the TimeSeries part there are several constructors and member \
functions available \
\>", "Text",
 CellTags->"Overview",
 CellID->124038282],

Cell[CellGroupData[{

Cell["Select[Category[TimeSeries],QLConstructor[#]&]", "Input",
 CellTags->"Overview",
 CellLabel->"In[303]:=",
 CellID->69162440],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"TimeSeries", ",", "TimeSeriesFromIndex"}], "}"}]], "Output",
 CellChangeTimes->{3.43609097175*^9},
 CellTags->"Overview",
 CellLabel->"Out[303]=",
 CellID->226202990]
}, Open  ]],

Cell[CellGroupData[{

Cell["Select[Category[TimeSeries],QLMember[#]&]", "Input",
 CellTags->"Overview",
 CellLabel->"In[304]:=",
 CellID->109773394],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "TimeSeriesDates", ",", "TimeSeriesEmpty", ",", "TimeSeriesFirstDate", ",", 
   "TimeSeriesLastDate", ",", "TimeSeriesSize", ",", "TimeSeriesValue", ",", 
   "TimeSeriesValues"}], "}"}]], "Output",
 CellChangeTimes->{3.436090972640625*^9},
 CellTags->"Overview",
 CellLabel->"Out[304]=",
 CellID->8343553]
}, Open  ]],

Cell[CellGroupData[{

Cell["Constructors", "Section",
 CellTags->"Constructor",
 CellID->59611703],

Cell[CellGroupData[{

Cell["TimeSeries", "Subsubsection",
 CellTags->"Constructor",
 CellID->602920606],

Cell[BoxData[{Cell[BoxData[GridBox[{
    {"Dates", 
     RowBox[{"dates", "."}]},
    {"Values", 
     RowBox[{"values", "."}]}
   }]], "DefinitionBox",
  CellTags->"Constructor"], "\n", Cell["Calling Parameters", 
  "Caption"]}], "Input",
 CellID->157972445],

Cell[BoxData[{
 RowBox[{
  RowBox[{"Dates", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"2009", ",", "3", ",", "11"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2010", ",", "3", ",", "11"}], "}"}]}], "}"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"Values", "=", 
   RowBox[{"{", 
    RowBox[{"99.", ",", "102."}], "}"}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.43609099021875*^9, 3.43609101528125*^9}},
 CellTags->"Constructor",
 CellLabel->"In[305]:=",
 CellID->174919411],

Cell[CellGroupData[{

Cell["obj=TimeSeries[Dates,Values]", "Input",
 CellTags->"Constructor",
 CellLabel->"In[307]:=",
 CellID->33354526],

Cell[BoxData["TimeSeries1"], "Output",
 CellChangeTimes->{3.436091017640625*^9},
 CellTags->"Constructor",
 CellLabel->"Out[307]=",
 CellID->501658044]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["TimeSeriesFromIndex", "Subsubsection",
 CellTags->"Constructor",
 CellID->496847166],

Cell[BoxData[{Cell[BoxData[GridBox[{
    {"Index", 
     RowBox[{"Index", " ", "object", " ", 
      RowBox[{"ID", "."}]}]}
   }]], "DefinitionBox",
  CellTags->"Constructor"], "\n", Cell["Calling Parameters", 
  "Caption"]}], "Input",
 CellID->312125023],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"IndexID", "=", 
   RowBox[{"BMAIndex", "[", 
    RowBox[{"YieldCurve", "\[Rule]", " ", 
     RowBox[{"FlatForward", "[", 
      RowBox[{"0.04", ",", "\"\<Simple\>\""}], "]"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"n", " ", "=", "3"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"datelist", " ", "=", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"DatePlus", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"2007", ",", "10", ",", "10"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"i", ",", "\"\<Week\>\""}], "}"}]}], "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"i", ",", "n"}], "}"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"fixings", " ", "=", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"99", "+", "i"}], ",", 
     RowBox[{"{", 
      RowBox[{"i", ",", "n"}], "}"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"IndexAddFixings", "[", 
  RowBox[{"IndexID", ",", "datelist", ",", "fixings"}], "]"}]}], "Input",
 CellChangeTimes->{{3.43609106340625*^9, 3.436091140296875*^9}},
 CellTags->"Constructor",
 CellLabel->"In[308]:=",
 CellID->204565809],

Cell[BoxData["True"], "Output",
 CellChangeTimes->{3.436091145453125*^9},
 CellTags->"Constructor",
 CellLabel->"Out[312]=",
 CellID->133256667]
}, Open  ]],

Cell[CellGroupData[{

Cell["obj=TimeSeriesFromIndex[IndexID]", "Input",
 CellChangeTimes->{{3.43609114275*^9, 3.43609114290625*^9}},
 CellTags->"Constructor",
 CellLabel->"In[313]:=",
 CellID->807647606],

Cell[BoxData["TimeSeriesFromIndex1"], "Output",
 CellChangeTimes->{3.436091147203125*^9},
 CellTags->"Constructor",
 CellLabel->"Out[313]=",
 CellID->889723525]
}, Open  ]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Member function", "Section",
 CellTags->"Member",
 CellID->696625673],

Cell[CellGroupData[{

Cell["TimeSeriesFirstDate", "Subsubsection",
 CellTags->"Member",
 CellID->275147031],

Cell[CellGroupData[{

Cell["TimeSeriesFirstDate[obj]", "Input",
 CellTags->"Member",
 CellLabel->"In[314]:=",
 CellID->716277132],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"2007", ",", "10", ",", "17"}], "}"}]], "Output",
 CellChangeTimes->{3.436091168125*^9},
 CellTags->"Member",
 CellLabel->"Out[314]=",
 CellID->291338285]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["TimeSeriesLastDate", "Subsubsection",
 CellTags->"Member",
 CellID->277095680],

Cell[CellGroupData[{

Cell["TimeSeriesLastDate[obj]", "Input",
 CellTags->"Member",
 CellLabel->"In[315]:=",
 CellID->424422729],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"2007", ",", "10", ",", "31"}], "}"}]], "Output",
 CellChangeTimes->{3.436091169421875*^9},
 CellTags->"Member",
 CellLabel->"Out[315]=",
 CellID->351209065]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["TimeSeriesSize", "Subsubsection",
 CellTags->"Member",
 CellID->23885818],

Cell[CellGroupData[{

Cell["TimeSeriesSize[obj]", "Input",
 CellTags->"Member",
 CellLabel->"In[316]:=",
 CellID->133997564],

Cell[BoxData["3"], "Output",
 CellChangeTimes->{3.436091171890625*^9},
 CellTags->"Member",
 CellLabel->"Out[316]=",
 CellID->24971472]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["TimeSeriesEmpty", "Subsubsection",
 CellTags->"Member",
 CellID->272713074],

Cell[CellGroupData[{

Cell["TimeSeriesEmpty[obj]", "Input",
 CellTags->"Member",
 CellLabel->"In[317]:=",
 CellID->336806262],

Cell[BoxData["False"], "Output",
 CellChangeTimes->{3.43609117334375*^9},
 CellTags->"Member",
 CellLabel->"Out[317]=",
 CellID->106764273]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["TimeSeriesDates", "Subsubsection",
 CellTags->"Member",
 CellID->12287929],

Cell[CellGroupData[{

Cell["TimeSeriesDates[obj]", "Input",
 CellTags->"Member",
 CellLabel->"In[318]:=",
 CellID->583783888],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"2007", ",", "10", ",", "17"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"2007", ",", "10", ",", "24"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"2007", ",", "10", ",", "31"}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{3.436091174875*^9},
 CellTags->"Member",
 CellLabel->"Out[318]=",
 CellID->541117822]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["TimeSeriesValues", "Subsubsection",
 CellTags->"Member",
 CellID->18246703],

Cell[CellGroupData[{

Cell["TimeSeriesValues[obj]", "Input",
 CellTags->"Member",
 CellLabel->"In[319]:=",
 CellID->275071510],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"100.`", ",", "101.`", ",", "102.`"}], "}"}]], "Output",
 CellChangeTimes->{3.436091177828125*^9},
 CellTags->"Member",
 CellLabel->"Out[319]=",
 CellID->392858769]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["TimeSeriesValue", "Subsubsection",
 CellTags->"Member",
 CellID->503038650],

Cell[BoxData[{Cell[BoxData[GridBox[{
    {"Dates", 
     RowBox[{"fixing", " ", "date", 
      RowBox[{
       RowBox[{"(", "s", ")"}], "."}]}]}
   }]], "DefinitionBox",
  CellTags->"Member"], "\n", Cell["Calling Parameters", "Caption"]}], "Input",\

 CellID->347664690],

Cell[BoxData[
 RowBox[{
  RowBox[{"Dates", "=", 
   RowBox[{"{", 
    RowBox[{"{", 
     RowBox[{"2007", ",", "10", ",", "24"}], "}"}], "}"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.4360911970625*^9, 3.4360912100625*^9}},
 CellTags->"Member",
 CellLabel->"In[322]:=",
 CellID->250617827],

Cell[CellGroupData[{

Cell["TimeSeriesValue[obj,Dates]", "Input",
 CellTags->"Member",
 CellLabel->"In[323]:=",
 CellID->246994],

Cell[BoxData[
 RowBox[{"{", "101.`", "}"}]], "Output",
 CellChangeTimes->{{3.436091199328125*^9, 3.43609121159375*^9}},
 CellTags->"Member",
 CellLabel->"Out[323]=",
 CellID->121968793]
}, Open  ]]
}, Open  ]]
}, Open  ]]
}, Open  ]]
},
Editable->True,
WindowSize->{616, 750},
WindowMargins->{{Automatic, 644}, {Automatic, 71}},
DockedCells->FEPrivate`FrontEndResource[
 "FEExpressions", "HelpViewerToolbar"],
PageHeaders->{{None, None, None}, {None, None, 
   Cell[
    TextData[{
      Cell[
       TextData[{"Printed from [[YOUR APPLICATION'S NAME]] documentation "}], 
       "PageHeader"], 
      Cell[
       TextData[{
         CounterBox["Page"]}], "PageNumber"]}], 
    CellMargins -> {{Inherited, -29}, {Inherited, Inherited}}]}},
PageFooters->{{None, None, None}, {
   Cell[
    TextData[{"\[Copyright] 2008 Weber & Partner. All rights reserved."}], 
    "PageFooter"], None, None}},
TaggingRules->{"SearchTextTranslated" -> "", "SearchText" -> ""},
CreateCellID->True,
ShowCellTags->False,
FrontEndVersion->"6.0 for Microsoft Windows (32-bit) (May 21, 2008)",
StyleDefinitions->FrontEnd`FileName[{"Wolfram"}, "Reference.nb", 
  CharacterEncoding -> "WindowsANSI"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "Overview"->{
  Cell[590, 23, 72, 2, 99, "Chapter",
   CellTags->"Overview",
   CellID->892145726],
  Cell[665, 27, 109, 2, 37, "Text",
   CellTags->"Overview",
   CellID->633035831],
  Cell[777, 31, 114, 2, 53, "MathCaption",
   CellTags->"Overview",
   CellID->132295213],
  Cell[894, 35, 80, 2, 41, "Input",
   CellTags->"Overview",
   CellID->256139150],
  Cell[977, 39, 158, 5, 37, "Text",
   CellTags->"Overview",
   CellID->124038282],
  Cell[1160, 48, 130, 3, 41, "Input",
   CellTags->"Overview",
   CellID->69162440],
  Cell[1293, 53, 206, 6, 39, "Output",
   CellTags->"Overview",
   CellID->226202990],
  Cell[1536, 64, 126, 3, 41, "Input",
   CellTags->"Overview",
   CellID->109773394],
  Cell[1665, 69, 347, 9, 59, "Output",
   CellTags->"Overview",
   CellID->8343553]},
 "Constructor"->{
  Cell[2049, 83, 76, 2, 77, "Section",
   CellTags->"Constructor",
   CellID->59611703],
  Cell[2150, 89, 81, 2, 47, "Subsubsection",
   CellTags->"Constructor",
   CellID->602920606],
  Cell[2496, 103, 501, 16, 62, "Input",
   CellTags->"Constructor",
   CellID->174919411],
  Cell[3022, 123, 115, 3, 41, "Input",
   CellTags->"Constructor",
   CellID->33354526],
  Cell[3140, 128, 151, 4, 70, "Output",
   CellTags->"Constructor",
   CellID->501658044],
  Cell[3340, 138, 90, 2, 70, "Subsubsection",
   CellTags->"Constructor",
   CellID->496847166],
  Cell[3713, 153, 1192, 36, 70, "Input",
   CellTags->"Constructor",
   CellID->204565809],
  Cell[4908, 191, 144, 4, 70, "Output",
   CellTags->"Constructor",
   CellID->133256667],
  Cell[5089, 200, 181, 4, 70, "Input",
   CellTags->"Constructor",
   CellID->807647606],
  Cell[5273, 206, 160, 4, 70, "Output",
   CellTags->"Constructor",
   CellID->889723525]},
 "Member"->{
  Cell[5494, 217, 75, 2, 70, "Section",
   CellTags->"Member",
   CellID->696625673],
  Cell[5594, 223, 85, 2, 70, "Subsubsection",
   CellTags->"Member",
   CellID->275147031],
  Cell[5704, 229, 107, 3, 28, "Input",
   CellTags->"Member",
   CellID->716277132],
  Cell[5814, 234, 193, 6, 36, "Output",
   CellTags->"Member",
   CellID->291338285],
  Cell[6056, 246, 84, 2, 30, "Subsubsection",
   CellTags->"Member",
   CellID->277095680],
  Cell[6165, 252, 106, 3, 28, "Input",
   CellTags->"Member",
   CellID->424422729],
  Cell[6274, 257, 196, 6, 36, "Output",
   CellTags->"Member",
   CellID->351209065],
  Cell[6519, 269, 79, 2, 30, "Subsubsection",
   CellTags->"Member",
   CellID->23885818],
  Cell[6623, 275, 102, 3, 28, "Input",
   CellTags->"Member",
   CellID->133997564],
  Cell[6728, 280, 135, 4, 36, "Output",
   CellTags->"Member",
   CellID->24971472],
  Cell[6912, 290, 81, 2, 30, "Subsubsection",
   CellTags->"Member",
   CellID->272713074],
  Cell[7018, 296, 103, 3, 28, "Input",
   CellTags->"Member",
   CellID->336806262],
  Cell[7124, 301, 139, 4, 36, "Output",
   CellTags->"Member",
   CellID->106764273],
  Cell[7312, 311, 80, 2, 30, "Subsubsection",
   CellTags->"Member",
   CellID->12287929],
  Cell[7417, 317, 103, 3, 28, "Input",
   CellTags->"Member",
   CellID->583783888],
  Cell[7523, 322, 380, 12, 36, "Output",
   CellTags->"Member",
   CellID->541117822],
  Cell[7952, 340, 81, 2, 30, "Subsubsection",
   CellTags->"Member",
   CellID->18246703],
  Cell[8058, 346, 104, 3, 28, "Input",
   CellTags->"Member",
   CellID->275071510],
  Cell[8165, 351, 203, 6, 36, "Output",
   CellTags->"Member",
   CellID->392858769],
  Cell[8417, 363, 81, 2, 30, "Subsubsection",
   CellTags->"Member",
   CellID->503038650],
  Cell[8774, 377, 289, 9, 28, "Input",
   CellTags->"Member",
   CellID->250617827],
  Cell[9088, 390, 106, 3, 28, "Input",
   CellTags->"Member",
   CellID->246994],
  Cell[9197, 395, 185, 5, 36, "Output",
   CellTags->"Member",
   CellID->121968793]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"Overview", 10487, 437},
 {"Constructor", 11278, 465},
 {"Member", 12209, 496}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[590, 23, 72, 2, 99, "Chapter",
 CellTags->"Overview",
 CellID->892145726],
Cell[665, 27, 109, 2, 37, "Text",
 CellTags->"Overview",
 CellID->633035831],
Cell[777, 31, 114, 2, 53, "MathCaption",
 CellTags->"Overview",
 CellID->132295213],
Cell[894, 35, 80, 2, 41, "Input",
 CellTags->"Overview",
 CellID->256139150],
Cell[977, 39, 158, 5, 37, "Text",
 CellTags->"Overview",
 CellID->124038282],
Cell[CellGroupData[{
Cell[1160, 48, 130, 3, 41, "Input",
 CellTags->"Overview",
 CellID->69162440],
Cell[1293, 53, 206, 6, 39, "Output",
 CellTags->"Overview",
 CellID->226202990]
}, Open  ]],
Cell[CellGroupData[{
Cell[1536, 64, 126, 3, 41, "Input",
 CellTags->"Overview",
 CellID->109773394],
Cell[1665, 69, 347, 9, 59, "Output",
 CellTags->"Overview",
 CellID->8343553]
}, Open  ]],
Cell[CellGroupData[{
Cell[2049, 83, 76, 2, 77, "Section",
 CellTags->"Constructor",
 CellID->59611703],
Cell[CellGroupData[{
Cell[2150, 89, 81, 2, 47, "Subsubsection",
 CellTags->"Constructor",
 CellID->602920606],
Cell[2234, 93, 259, 8, 84, "Input",
 CellID->157972445],
Cell[2496, 103, 501, 16, 62, "Input",
 CellTags->"Constructor",
 CellID->174919411],
Cell[CellGroupData[{
Cell[3022, 123, 115, 3, 41, "Input",
 CellTags->"Constructor",
 CellID->33354526],
Cell[3140, 128, 151, 4, 70, "Output",
 CellTags->"Constructor",
 CellID->501658044]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[3340, 138, 90, 2, 70, "Subsubsection",
 CellTags->"Constructor",
 CellID->496847166],
Cell[3433, 142, 255, 7, 70, "Input",
 CellID->312125023],
Cell[CellGroupData[{
Cell[3713, 153, 1192, 36, 70, "Input",
 CellTags->"Constructor",
 CellID->204565809],
Cell[4908, 191, 144, 4, 70, "Output",
 CellTags->"Constructor",
 CellID->133256667]
}, Open  ]],
Cell[CellGroupData[{
Cell[5089, 200, 181, 4, 70, "Input",
 CellTags->"Constructor",
 CellID->807647606],
Cell[5273, 206, 160, 4, 70, "Output",
 CellTags->"Constructor",
 CellID->889723525]
}, Open  ]]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[5494, 217, 75, 2, 70, "Section",
 CellTags->"Member",
 CellID->696625673],
Cell[CellGroupData[{
Cell[5594, 223, 85, 2, 70, "Subsubsection",
 CellTags->"Member",
 CellID->275147031],
Cell[CellGroupData[{
Cell[5704, 229, 107, 3, 28, "Input",
 CellTags->"Member",
 CellID->716277132],
Cell[5814, 234, 193, 6, 36, "Output",
 CellTags->"Member",
 CellID->291338285]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[6056, 246, 84, 2, 30, "Subsubsection",
 CellTags->"Member",
 CellID->277095680],
Cell[CellGroupData[{
Cell[6165, 252, 106, 3, 28, "Input",
 CellTags->"Member",
 CellID->424422729],
Cell[6274, 257, 196, 6, 36, "Output",
 CellTags->"Member",
 CellID->351209065]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[6519, 269, 79, 2, 30, "Subsubsection",
 CellTags->"Member",
 CellID->23885818],
Cell[CellGroupData[{
Cell[6623, 275, 102, 3, 28, "Input",
 CellTags->"Member",
 CellID->133997564],
Cell[6728, 280, 135, 4, 36, "Output",
 CellTags->"Member",
 CellID->24971472]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[6912, 290, 81, 2, 30, "Subsubsection",
 CellTags->"Member",
 CellID->272713074],
Cell[CellGroupData[{
Cell[7018, 296, 103, 3, 28, "Input",
 CellTags->"Member",
 CellID->336806262],
Cell[7124, 301, 139, 4, 36, "Output",
 CellTags->"Member",
 CellID->106764273]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[7312, 311, 80, 2, 30, "Subsubsection",
 CellTags->"Member",
 CellID->12287929],
Cell[CellGroupData[{
Cell[7417, 317, 103, 3, 28, "Input",
 CellTags->"Member",
 CellID->583783888],
Cell[7523, 322, 380, 12, 36, "Output",
 CellTags->"Member",
 CellID->541117822]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[7952, 340, 81, 2, 30, "Subsubsection",
 CellTags->"Member",
 CellID->18246703],
Cell[CellGroupData[{
Cell[8058, 346, 104, 3, 28, "Input",
 CellTags->"Member",
 CellID->275071510],
Cell[8165, 351, 203, 6, 36, "Output",
 CellTags->"Member",
 CellID->392858769]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[8417, 363, 81, 2, 30, "Subsubsection",
 CellTags->"Member",
 CellID->503038650],
Cell[8501, 367, 270, 8, 65, "Input",
 CellID->347664690],
Cell[8774, 377, 289, 9, 28, "Input",
 CellTags->"Member",
 CellID->250617827],
Cell[CellGroupData[{
Cell[9088, 390, 106, 3, 28, "Input",
 CellTags->"Member",
 CellID->246994],
Cell[9197, 395, 185, 5, 36, "Output",
 CellTags->"Member",
 CellID->121968793]
}, Open  ]]
}, Open  ]]
}, Open  ]]
}, Open  ]]
}
]
*)

(* End of internal cache information *)
