(* Content-type: application/mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 6.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       145,          7]
NotebookDataLength[      8634,        354]
NotebookOptionsPosition[      3661,        167]
NotebookOutlinePosition[      6687,        273]
CellTagsIndexPosition[      6538,        265]
WindowFrame->Normal
ContainsDynamic->False*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell["utilities", "Chapter",
 CellTags->"Overview",
 CellID->147392540],

Cell["diagnostic and utility functions.", "Text",
 CellTags->"Overview",
 CellID->245369454],

Cell["The first step is to load the QuantLib package. ", "MathCaption",
 CellTags->"Overview",
 CellID->359047450],

Cell["Needs[\"QuantLib`\"]", "Input",
 CellTags->"Overview",
 CellID->194748926],

Cell["\<\
Within the utilities part there are several constructors procedures available \
\
\>", "Text",
 CellChangeTimes->{{3.436091269078125*^9, 3.436091272421875*^9}},
 CellTags->"Overview",
 CellID->628819156],

Cell[CellGroupData[{

Cell["Select[Category[utilities],QLConstructor[#]&]", "Input",
 CellTags->"Overview",
 CellLabel->"In[355]:=",
 CellID->500403261],

Cell[BoxData[
 RowBox[{"{", "}"}]], "Output",
 CellChangeTimes->{3.436091276375*^9},
 CellTags->"Overview",
 CellLabel->"Out[355]=",
 CellID->263417834]
}, Open  ]],

Cell[CellGroupData[{

Cell["Select[Category[utilities],QLMember[#]&]", "Input",
 CellTags->"Overview",
 CellLabel->"In[356]:=",
 CellID->486433858],

Cell[BoxData[
 RowBox[{"{", "}"}]], "Output",
 CellChangeTimes->{3.43609127715625*^9},
 CellTags->"Overview",
 CellLabel->"Out[356]=",
 CellID->23856460]
}, Open  ]],

Cell[CellGroupData[{

Cell["Select[Category[utilities],QLProcedure[#]&]", "Input",
 CellTags->"Overview",
 CellLabel->"In[357]:=",
 CellID->151757847],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"AddinVersion", ",", "Version"}], "}"}]], "Output",
 CellChangeTimes->{3.436091277765625*^9},
 CellTags->"Overview",
 CellLabel->"Out[357]=",
 CellID->941591991]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Category", "[", "utilities", "]"}]], "Input",
 CellChangeTimes->{{3.436091280921875*^9, 3.436091288421875*^9}},
 CellLabel->"In[358]:=",
 CellID->94142270],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"AddinVersion", ",", "Version"}], "}"}]], "Output",
 CellChangeTimes->{3.43609128896875*^9},
 CellLabel->"Out[358]=",
 CellID->37833767]
}, Open  ]],

Cell["Constructors", "Section",
 CellTags->"Constructo",
 CellID->124517662],

Cell["Member function", "Section",
 CellTags->"Member",
 CellID->56529738],

Cell[CellGroupData[{

Cell["Procedures", "Section",
 CellTags->"Procedure",
 CellID->636745527],

Cell[CellGroupData[{

Cell["AddinVersion", "Subsubsection",
 CellTags->"Procedure",
 CellID->141694044],

Cell[CellGroupData[{

Cell["AddinVersion[]", "Input",
 CellTags->"Procedure",
 CellLabel->"In[360]:=",
 CellID->42287110],

Cell[BoxData["\<\"0.9.5\"\>"], "Output",
 CellChangeTimes->{3.436091317140625*^9},
 CellTags->"Procedure",
 CellLabel->"Out[360]=",
 CellID->287480975]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Version", "Subsubsection",
 CellTags->"Procedure",
 CellID->363896932],

Cell[CellGroupData[{

Cell["Version[]", "Input",
 CellTags->"Procedure",
 CellLabel->"In[361]:=",
 CellID->352798407],

Cell[BoxData["\<\"0.9.7\"\>"], "Output",
 CellChangeTimes->{3.4360913194375*^9},
 CellTags->"Procedure",
 CellLabel->"Out[361]=",
 CellID->312701686]
}, Open  ]]
}, Open  ]]
}, Open  ]]
}, Open  ]]
},
Editable->True,
WindowSize->{616, 750},
WindowMargins->{{Automatic, 526}, {81, Automatic}},
DockedCells->FEPrivate`FrontEndResource[
 "FEExpressions", "HelpViewerToolbar"],
PageHeaders->{{None, None, None}, {None, None, 
   Cell[
    TextData[{
      Cell[
       TextData[{"Printed from [[YOUR APPLICATION'S NAME]] documentation "}], 
       "PageHeader"], 
      Cell[
       TextData[{
         CounterBox["Page"]}], "PageNumber"]}], 
    CellMargins -> {{Inherited, -29}, {Inherited, Inherited}}]}},
PageFooters->{{None, None, None}, {
   Cell[
    TextData[{"\[Copyright] 2008 Weber & Partner. All rights reserved."}], 
    "PageFooter"], None, None}},
TaggingRules->{"SearchTextTranslated" -> "", "SearchText" -> ""},
CreateCellID->True,
ShowCellTags->False,
FrontEndVersion->"6.0 for Microsoft Windows (32-bit) (May 21, 2008)",
StyleDefinitions->FrontEnd`FileName[{"Wolfram"}, "Reference.nb", 
  CharacterEncoding -> "WindowsANSI"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "Overview"->{
  Cell[590, 23, 71, 2, 85, "Chapter",
   CellTags->"Overview",
   CellID->147392540],
  Cell[664, 27, 92, 2, 30, "Text",
   CellTags->"Overview",
   CellID->245369454],
  Cell[759, 31, 114, 2, 31, "MathCaption",
   CellTags->"Overview",
   CellID->359047450],
  Cell[876, 35, 80, 2, 28, "Input",
   CellTags->"Overview",
   CellID->194748926],
  Cell[959, 39, 213, 6, 30, "Text",
   CellTags->"Overview",
   CellID->628819156],
  Cell[1197, 49, 130, 3, 28, "Input",
   CellTags->"Overview",
   CellID->500403261],
  Cell[1330, 54, 152, 5, 36, "Output",
   CellTags->"Overview",
   CellID->263417834],
  Cell[1519, 64, 125, 3, 28, "Input",
   CellTags->"Overview",
   CellID->486433858],
  Cell[1647, 69, 153, 5, 36, "Output",
   CellTags->"Overview",
   CellID->23856460],
  Cell[1837, 79, 128, 3, 28, "Input",
   CellTags->"Overview",
   CellID->151757847],
  Cell[1968, 84, 200, 6, 36, "Output",
   CellTags->"Overview",
   CellID->941591991]},
 "Constructo"->{
  Cell[2577, 109, 76, 2, 51, "Section",
   CellTags->"Constructo",
   CellID->124517662]},
 "Member"->{
  Cell[2656, 113, 74, 2, 31, "Section",
   CellTags->"Member",
   CellID->56529738]},
 "Procedure"->{
  Cell[2755, 119, 73, 2, 31, "Section",
   CellTags->"Procedure",
   CellID->636745527],
  Cell[2853, 125, 81, 2, 30, "Subsubsection",
   CellTags->"Procedure",
   CellID->141694044],
  Cell[2959, 131, 99, 3, 28, "Input",
   CellTags->"Procedure",
   CellID->42287110],
  Cell[3061, 136, 151, 4, 36, "Output",
   CellTags->"Procedure",
   CellID->287480975],
  Cell[3261, 146, 76, 2, 30, "Subsubsection",
   CellTags->"Procedure",
   CellID->363896932],
  Cell[3362, 152, 95, 3, 28, "Input",
   CellTags->"Procedure",
   CellID->352798407],
  Cell[3460, 157, 149, 4, 36, "Output",
   CellTags->"Procedure",
   CellID->312701686]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"Overview", 4714, 198},
 {"Constructo", 5678, 232},
 {"Member", 5782, 236},
 {"Procedure", 5884, 240}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[590, 23, 71, 2, 85, "Chapter",
 CellTags->"Overview",
 CellID->147392540],
Cell[664, 27, 92, 2, 30, "Text",
 CellTags->"Overview",
 CellID->245369454],
Cell[759, 31, 114, 2, 31, "MathCaption",
 CellTags->"Overview",
 CellID->359047450],
Cell[876, 35, 80, 2, 28, "Input",
 CellTags->"Overview",
 CellID->194748926],
Cell[959, 39, 213, 6, 30, "Text",
 CellTags->"Overview",
 CellID->628819156],
Cell[CellGroupData[{
Cell[1197, 49, 130, 3, 28, "Input",
 CellTags->"Overview",
 CellID->500403261],
Cell[1330, 54, 152, 5, 36, "Output",
 CellTags->"Overview",
 CellID->263417834]
}, Open  ]],
Cell[CellGroupData[{
Cell[1519, 64, 125, 3, 28, "Input",
 CellTags->"Overview",
 CellID->486433858],
Cell[1647, 69, 153, 5, 36, "Output",
 CellTags->"Overview",
 CellID->23856460]
}, Open  ]],
Cell[CellGroupData[{
Cell[1837, 79, 128, 3, 28, "Input",
 CellTags->"Overview",
 CellID->151757847],
Cell[1968, 84, 200, 6, 36, "Output",
 CellTags->"Overview",
 CellID->941591991]
}, Open  ]],
Cell[CellGroupData[{
Cell[2205, 95, 179, 4, 28, "Input",
 CellID->94142270],
Cell[2387, 101, 175, 5, 36, "Output",
 CellID->37833767]
}, Open  ]],
Cell[2577, 109, 76, 2, 51, "Section",
 CellTags->"Constructo",
 CellID->124517662],
Cell[2656, 113, 74, 2, 31, "Section",
 CellTags->"Member",
 CellID->56529738],
Cell[CellGroupData[{
Cell[2755, 119, 73, 2, 31, "Section",
 CellTags->"Procedure",
 CellID->636745527],
Cell[CellGroupData[{
Cell[2853, 125, 81, 2, 30, "Subsubsection",
 CellTags->"Procedure",
 CellID->141694044],
Cell[CellGroupData[{
Cell[2959, 131, 99, 3, 28, "Input",
 CellTags->"Procedure",
 CellID->42287110],
Cell[3061, 136, 151, 4, 36, "Output",
 CellTags->"Procedure",
 CellID->287480975]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[3261, 146, 76, 2, 30, "Subsubsection",
 CellTags->"Procedure",
 CellID->363896932],
Cell[CellGroupData[{
Cell[3362, 152, 95, 3, 28, "Input",
 CellTags->"Procedure",
 CellID->352798407],
Cell[3460, 157, 149, 4, 36, "Output",
 CellTags->"Procedure",
 CellID->312701686]
}, Open  ]]
}, Open  ]]
}, Open  ]]
}, Open  ]]
}
]
*)

(* End of internal cache information *)
