(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 8.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       157,          7]
NotebookDataLength[     17087,        463]
NotebookOptionsPosition[     15401,        399]
NotebookOutlinePosition[     15919,        421]
CellTagsIndexPosition[     15834,        416]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell[BoxData[
 RowBox[{"<<", "QuantLib`"}]], "Input",
 CellChangeTimes->{{3.5631686869375*^9, 3.56316869284375*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   TagBox[
    ButtonBox[
     PaneSelectorBox[{False->"\<\"QuantLib\"\>", True->
      StyleBox["\<\"QuantLib\"\>", "HyperlinkActive"]}, Dynamic[
       CurrentValue["MouseOver"]],
      BaseStyle->{"Hyperlink"},
      BaselinePosition->Baseline,
      FrameMargins->0,
      ImageSize->Automatic],
     BaseStyle->"Hyperlink",
     ButtonData->{
       URL["http://quantlib.org"], None},
     ButtonNote->"http://quantlib.org"],
    Annotation[#, "http://quantlib.org", "Hyperlink"]& ], 
   "\[InvisibleSpace]", "\<\" for Mathematica installed, Version \
0.2.6\\n\"\>", "\[InvisibleSpace]", "\<\"for \"\>", 
   "\[InvisibleSpace]", "\<\"Windows\"\>", 
   "\[InvisibleSpace]", "\<\" system \"\>", 
   "\[InvisibleSpace]", "\<\"Microsoft Windows (32-bit)\"\>", 
   "\[InvisibleSpace]", "\<\"\\n\"\>", 
   "\[InvisibleSpace]", "\<\"Mathematica Interface \[Copyright] by \"\>", 
   "\[InvisibleSpace]", 
   TagBox[
    ButtonBox[
     PaneSelectorBox[{False->"\<\"Weber & Partner\"\>", True->
      StyleBox["\<\"Weber & Partner\"\>", "HyperlinkActive"]}, Dynamic[
       CurrentValue["MouseOver"]],
      BaseStyle->{"Hyperlink"},
      BaselinePosition->Baseline,
      FrameMargins->0,
      ImageSize->Automatic],
     BaseStyle->"Hyperlink",
     ButtonData->{
       URL["http://www.weber-und-partner.com"], None},
     ButtonNote->"http://www.weber-und-partner.com"],
    Annotation[#, "http://www.weber-und-partner.com", "Hyperlink"]& ], 
   "\[InvisibleSpace]", "\<\" 2012\"\>"}],
  SequenceForm[
   Hyperlink["QuantLib", "http://quantlib.org"], 
   " for Mathematica installed, Version 0.2.6\n", "for ", "Windows", 
   " system ", "Microsoft Windows (32-bit)", "\n", 
   "Mathematica Interface \[Copyright] by ", 
   Hyperlink["Weber & Partner", "http://www.weber-und-partner.com"], " 2012"],
  Editable->False]], "Print",
 CellChangeTimes->{3.5631687359375*^9, 3.563172491875*^9, 3.56317263103125*^9,
   3.56317328871875*^9, 3.563173527265625*^9, 3.563173660796875*^9, 
  3.5631737311875*^9, 3.563174026140625*^9, 3.56317597928125*^9, 
  3.563177304234375*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Visit \"\>", "\[InvisibleSpace]", 
   TagBox[
    ButtonBox[
     PaneSelectorBox[{
      False->"\<\"http://www.weber-und-partner.com/QuantLib/Mathematica\"\>", 
      True->
      StyleBox["\<\"http://www.weber-und-partner.com/QuantLib/Mathematica\"\>\
", "HyperlinkActive"]}, Dynamic[
       CurrentValue["MouseOver"]],
      BaseStyle->{"Hyperlink"},
      BaselinePosition->Baseline,
      FrameMargins->0,
      ImageSize->Automatic],
     BaseStyle->"Hyperlink",
     ButtonData->{
       URL["http://www.weber-und-partner.com/QuantLib/mma"], None},
     ButtonNote->"http://www.weber-und-partner.com/QuantLib/mma"],
    Annotation[#, "http://www.weber-und-partner.com/QuantLib/mma", 
     "Hyperlink"]& ], 
   "\[InvisibleSpace]", "\<\" for the latest version.\\nVisit \"\>", 
   "\[InvisibleSpace]", 
   TagBox[
    ButtonBox[
     PaneSelectorBox[{False->"\<\"http://quantlib.org/license.shtml\"\>", 
      True->
      StyleBox["\<\"http://quantlib.org/license.shtml\"\>", 
       "HyperlinkActive"]}, Dynamic[
       CurrentValue["MouseOver"]],
      BaseStyle->{"Hyperlink"},
      BaselinePosition->Baseline,
      FrameMargins->0,
      ImageSize->Automatic],
     BaseStyle->"Hyperlink",
     ButtonData->{
       URL["http://quantlib.org/license.shtml"], None},
     ButtonNote->"http://quantlib.org/license.shtml"],
    Annotation[#, "http://quantlib.org/license.shtml", "Hyperlink"]& ], 
   "\[InvisibleSpace]", "\<\" for the QuantLib license.\\nFor questions, \
support issues and enquiries mail to \"\>", "\[InvisibleSpace]", 
   TagBox[
    ButtonBox[
     PaneSelectorBox[{False->"\<\"quantLib@weber-und-partner.com\"\>", True->
      StyleBox["\<\"quantLib@weber-und-partner.com\"\>", "HyperlinkActive"]}, 
      Dynamic[
       CurrentValue["MouseOver"]],
      BaseStyle->{"Hyperlink"},
      BaselinePosition->Baseline,
      FrameMargins->0,
      ImageSize->Automatic],
     BaseStyle->"Hyperlink",
     ButtonData->{
       URL["mailto:quantLib@weber-und-partner.com"], None},
     ButtonNote->"mailto:quantLib@weber-und-partner.com"],
    Annotation[#, "mailto:quantLib@weber-und-partner.com", "Hyperlink"]& ], 
   "\[InvisibleSpace]", "\<\"\\n\"\>"}],
  SequenceForm["Visit ", 
   Hyperlink[
   "http://www.weber-und-partner.com/QuantLib/Mathematica", 
    "http://www.weber-und-partner.com/QuantLib/mma"], 
   " for the latest version.\nVisit ", 
   Hyperlink[
   "http://quantlib.org/license.shtml", "http://quantlib.org/license.shtml"], 
   " for the QuantLib license.\nFor questions, support issues and enquiries \
mail to ", 
   Hyperlink[
   "quantLib@weber-und-partner.com", "mailto:quantLib@weber-und-partner.com"],
    "\n"],
  Editable->False]], "Print",
 CellChangeTimes->{3.5631687359375*^9, 3.563172491875*^9, 3.56317263103125*^9,
   3.56317328871875*^9, 3.563173527265625*^9, 3.563173660796875*^9, 
  3.5631737311875*^9, 3.563174026140625*^9, 3.56317597928125*^9, 
  3.563177304234375*^9}],

Cell[BoxData["\<\"THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND \
CONTRIBUTORS 'AS IS' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT \
NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A \
PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDERS OR \
CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, \
EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, \
PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; \
OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, \
WHETHER IN CONTRACT, STRICT LIABILITY OR TORT (INCLUDING NEGLIGENCE OR \
OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF \
ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.\\n\"\>"], "Print",
 CellChangeTimes->{3.5631687359375*^9, 3.563172491875*^9, 3.56317263103125*^9,
   3.56317328871875*^9, 3.563173527265625*^9, 3.563173660796875*^9, 
  3.5631737311875*^9, 3.563174026140625*^9, 3.56317597928125*^9, 
  3.56317730425*^9}],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"How", " ", "to", " ", "get", " ", "started"}], "MSG"], " ", 
  ButtonBox[
   StyleBox[">>", "SR"],
   Active->True,
   BaseStyle->"Link",
   ButtonData->"paclet:QuantLib/tutorial/Getting Started"]}]], "Print", \
"PrintUsage",
 CellChangeTimes->{3.56317730425*^9}],

Cell[BoxData["\<\"Setting default values:\"\>"], "Print",
 CellChangeTimes->{3.5631687359375*^9, 3.563172491875*^9, 3.56317263103125*^9,
   3.56317328871875*^9, 3.563173527265625*^9, 3.563173660796875*^9, 
  3.5631737311875*^9, 3.563174026140625*^9, 3.56317597928125*^9, 
  3.563177310359375*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"  Setting Valuation Date = \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{"2012", ",", "11", ",", "29"}], "}"}]}],
  SequenceForm["  Setting Valuation Date = ", {2012, 11, 29}],
  Editable->False]], "Print",
 CellChangeTimes->{3.5631687359375*^9, 3.563172491875*^9, 3.56317263103125*^9,
   3.56317328871875*^9, 3.563173527265625*^9, 3.563173660796875*^9, 
  3.5631737311875*^9, 3.563174026140625*^9, 3.56317597928125*^9, 
  3.5631773104375*^9}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"sdl", " ", "=", 
  RowBox[{"Schedule", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"2008", ",", "09", ",", "01"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"2012", ",", "09", ",", "01"}], "}"}], ",", "\"\<1Y\>\""}], 
   "]"}]}]], "Input",
 CellChangeTimes->{{3.563169870921875*^9, 3.563169903609375*^9}}],

Cell[BoxData["Schedule3"], "Output",
 CellChangeTimes->{3.563169906546875*^9, 3.56317250546875*^9, 
  3.56317268275*^9, 3.563173303359375*^9, 3.56317355590625*^9, 
  3.5631736809375*^9, 3.563173737625*^9, 3.563174032890625*^9, 
  3.563175997015625*^9, 3.563177314390625*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"amb", " ", "=", 
  RowBox[{"AmortizingFixedRateBond", "[", 
   RowBox[{"sdl", ",", "100000", ",", "0.05"}], "]"}], " "}]], "Input",
 CellChangeTimes->{{3.563169919296875*^9, 3.5631699618125*^9}, {
   3.563173313734375*^9, 3.563173316171875*^9}, 3.563173762296875*^9, {
   3.56317405121875*^9, 3.563174053796875*^9}, {3.56317733971875*^9, 
   3.56317734065625*^9}, {3.56317746278125*^9, 3.563177463734375*^9}}],

Cell[BoxData["AmortizingFixedRateBond8"], "Output",
 CellChangeTimes->{
  3.563169962859375*^9, 3.56317250696875*^9, 3.563172683953125*^9, {
   3.5631733045625*^9, 3.563173317046875*^9}, 3.563173557328125*^9, 
   3.563173682296875*^9, {3.563173738*^9, 3.563173763046875*^9}, {
   3.563174033203125*^9, 3.56317405446875*^9}, 3.56317599815625*^9, {
   3.56317731578125*^9, 3.56317734134375*^9}, 3.563177464546875*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"BondFlowAnalysis", "[", "amb", "]"}], " ", "//", " ", 
  "TableForm"}]], "Input",
 CellChangeTimes->{{3.563177466515625*^9, 3.563177488171875*^9}}],

Cell[BoxData[
 TagBox[GridBox[{
    {"\<\"Payment Date\"\>", "\<\"Amount\"\>", "\<\"Nominal\"\>", \
"\<\"Accrual Start Date\"\>", "\<\"Accrual End Date\"\>", "\<\"Accrual Days\"\
\>", "\<\"Index\"\>", "\<\"Fixing Days\"\>", "\<\"Fixing Dates\"\>", "\<\"Day \
Counter\"\>", "\<\"Accrual Period\"\>", "\<\"Effective Rate\"\>", \
"\<\"Floor\"\>", "\<\"Gearing\"\>", "\<\"Index Fixing\"\>", "\<\"Conv. Adj.\"\
\>", "\<\"Spread\"\>", "\<\"Cap\"\>", "\<\"Call Digital Payoff\"\>", "\<\"Put \
Digital Payoff\"\>"},
    {"40057", "5000.000000000005`", "100000.`", "39692", "40057", 
     "365", "\<\"#N/A\"\>", "\<\"#N/A\"\>", "\<\"#N/A\"\>", "\<\"Actual/365 \
(Fixed)\"\>", "1.`", 
     "0.05`", "\<\"#N/A\"\>", "\<\"#N/A\"\>", "\<\"#N/A\"\>", "\<\"#N/A\"\>", \
"\<\"#N/A\"\>", "\<\"#N/A\"\>", "\<\"#N/A\"\>", "\<\"#N/A\"\>"},
    {"40422", "5000.000000000005`", "100000.`", "40057", "40422", 
     "365", "\<\"#N/A\"\>", "\<\"#N/A\"\>", "\<\"#N/A\"\>", "\<\"Actual/365 \
(Fixed)\"\>", "1.`", 
     "0.05`", "\<\"#N/A\"\>", "\<\"#N/A\"\>", "\<\"#N/A\"\>", "\<\"#N/A\"\>", \
"\<\"#N/A\"\>", "\<\"#N/A\"\>", "\<\"#N/A\"\>", "\<\"#N/A\"\>"},
    {"40787", "5000.000000000005`", "100000.`", "40422", "40787", 
     "365", "\<\"#N/A\"\>", "\<\"#N/A\"\>", "\<\"#N/A\"\>", "\<\"Actual/365 \
(Fixed)\"\>", "1.`", 
     "0.05`", "\<\"#N/A\"\>", "\<\"#N/A\"\>", "\<\"#N/A\"\>", "\<\"#N/A\"\>", \
"\<\"#N/A\"\>", "\<\"#N/A\"\>", "\<\"#N/A\"\>", "\<\"#N/A\"\>"},
    {"41155", "5013.698630136987`", "100000.`", "40787", "41153", 
     "366", "\<\"#N/A\"\>", "\<\"#N/A\"\>", "\<\"#N/A\"\>", "\<\"Actual/365 \
(Fixed)\"\>", "1.0027397260273974`", 
     "0.05`", "\<\"#N/A\"\>", "\<\"#N/A\"\>", "\<\"#N/A\"\>", "\<\"#N/A\"\>", \
"\<\"#N/A\"\>", "\<\"#N/A\"\>", "\<\"#N/A\"\>", "\<\"#N/A\"\>"},
    {"41155", 
     "100000.`", "\<\"#N/A\"\>", "\<\"#N/A\"\>", "\<\"#N/A\"\>", \
"\<\"#N/A\"\>", "\<\"#N/A\"\>", "\<\"#N/A\"\>", "\<\"#N/A\"\>", \
"\<\"#N/A\"\>", "\<\"#N/A\"\>", "\<\"#N/A\"\>", "\<\"#N/A\"\>", \
"\<\"#N/A\"\>", "\<\"#N/A\"\>", "\<\"#N/A\"\>", "\<\"#N/A\"\>", \
"\<\"#N/A\"\>", "\<\"#N/A\"\>", "\<\"#N/A\"\>"}
   },
   GridBoxAlignment->{
    "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
     "RowsIndexed" -> {}},
   GridBoxSpacings->{"Columns" -> {
       Offset[0.27999999999999997`], {
        Offset[2.0999999999999996`]}, 
       Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
       Offset[0.2], {
        Offset[0.4]}, 
       Offset[0.2]}, "RowsIndexed" -> {}}],
  Function[BoxForm`e$, 
   TableForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{{3.563177480546875*^9, 3.563177488890625*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"amb", " ", "=", 
  RowBox[{"AmortizingFixedRateBond", "[", 
   RowBox[{"sdl", ",", "100000", ",", "0.05"}], "]"}], " "}]], "Input",
 CellChangeTimes->{{3.5631785555625*^9, 3.563178560984375*^9}}],

Cell[BoxData["AmortizingFixedRateBond10"], "Output",
 CellChangeTimes->{3.563178665171875*^9, 3.563179327046875*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", "AmortizingFixedRateBond"}]], "Input",
 CellChangeTimes->{3.563178539578125*^9}],

Cell[BoxData[
 StyleBox["\<\"AmortizingFixedRateBond[ScheduleID_Symbol,Notionals_List /; \
VectorQ[Notionals, NumberQ],Coupons_List /; VectorQ[Coupons, \
NumberQ],opts___?OptionQ]\"\>", "MSG"]], "Print", "PrintUsage",
 CellChangeTimes->{3.563178540546875*^9},
 CellTags->"Info3563182140-2091669"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", "annuity*"}]], "Input",
 CellChangeTimes->{{3.56317809796875*^9, 3.563178103484375*^9}}],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"Information", "::", "nomatch"}], "MessageName"], 
  RowBox[{
  ":", " "}], "\<\"No symbol matching \[NoBreak]\\!\\(\\\"annuity*\\\"\\)\
\[NoBreak] found. \\!\\(\\*ButtonBox[\\\"\[RightSkeleton]\\\", \
ButtonStyle->\\\"Link\\\", ButtonFrame->None, \
ButtonData:>\\\"paclet:ref/message/Information/nomatch\\\", ButtonNote -> \
\\\"Information::nomatch\\\"]\\)\"\>"}]], "Message", "MSG",
 CellChangeTimes->{3.56317810446875*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  TagBox[
   RowBox[{"VectorQ", "[", 
    RowBox[{"{", 
     RowBox[{"0.5`", ",", "0.5`", ",", "0.5`", ",", "0.5`", ",", "0.5`"}], 
     "}"}], "]"}],
   HoldForm], " ", "//", " ", "FullForm"}]], "Input",
 CellChangeTimes->{{3.5631748028125*^9, 3.56317481421875*^9}, 
   3.563174866078125*^9, {3.563174976*^9, 3.563174979984375*^9}}],

Cell[BoxData[
 TagBox[
  StyleBox[
   RowBox[{"HoldForm", "[", 
    RowBox[{"VectorQ", "[", 
     RowBox[{"List", "[", 
      RowBox[{"0.5`", ",", "0.5`", ",", "0.5`", ",", "0.5`", ",", "0.5`"}], 
      "]"}], "]"}], "]"}],
   ShowSpecialCharacters->False,
   ShowStringCharacters->True,
   NumberMarks->True],
  FullForm]], "Output",
 CellChangeTimes->{3.563174815453125*^9, 3.56317486678125*^9, 
  3.56317493609375*^9, 3.56317498078125*^9, 3.563177319390625*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"{", 
   RowBox[{"0.5`", ",", "0.5`", ",", "0.5`", ",", "0.5`", ",", "0.5`"}], 
   "}"}], " "}], "\[IndentingNewLine]", 
 RowBox[{"VectorQ", "[", 
  RowBox[{"%", ",", "NumericQ"}], "]"}]}], "Input",
 CellChangeTimes->{{3.563175019609375*^9, 3.5631750519375*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0.5`", ",", "0.5`", ",", "0.5`", ",", "0.5`", ",", "0.5`"}], 
  "}"}]], "Output",
 CellChangeTimes->{{3.563175023484375*^9, 3.563175053046875*^9}, 
   3.563177319515625*^9}],

Cell[BoxData["True"], "Output",
 CellChangeTimes->{{3.563175023484375*^9, 3.563175053046875*^9}, 
   3.563177319515625*^9}]
}, Open  ]]
},
WindowSize->{1118, 812},
WindowMargins->{{49, Automatic}, {Automatic, 14}},
ShowSelection->True,
FrontEndVersion->"8.0 for Microsoft Windows (32-bit) (October 6, 2011)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "Info3563182140-2091669"->{
  Cell[12923, 320, 296, 5, 54, "Print",
   CellTags->"Info3563182140-2091669"]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"Info3563182140-2091669", 15730, 410}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[579, 22, 116, 2, 31, "Input"],
Cell[CellGroupData[{
Cell[720, 28, 2114, 50, 62, "Print"],
Cell[2837, 80, 2984, 73, 81, "Print"],
Cell[5824, 155, 1047, 14, 138, "Print"],
Cell[6874, 171, 311, 10, 42, "Print"],
Cell[7188, 183, 296, 4, 23, "Print"],
Cell[7487, 189, 504, 10, 23, "Print"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[8040, 205, 336, 9, 31, "Input"],
Cell[8379, 216, 274, 4, 30, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[8690, 225, 433, 7, 31, "Input"],
Cell[9126, 234, 415, 6, 30, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[9578, 245, 182, 4, 31, "Input"],
Cell[9763, 251, 2637, 48, 116, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[12437, 304, 219, 4, 31, "Input"],
Cell[12659, 310, 116, 1, 30, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[12812, 316, 108, 2, 31, "Input"],
Cell[12923, 320, 296, 5, 54, "Print",
 CellTags->"Info3563182140-2091669"]
}, Open  ]],
Cell[CellGroupData[{
Cell[13256, 330, 116, 2, 31, "Input"],
Cell[13375, 334, 473, 10, 21, "Message"]
}, Open  ]],
Cell[CellGroupData[{
Cell[13885, 349, 357, 9, 31, "Input"],
Cell[14245, 360, 464, 13, 44, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[14746, 378, 297, 7, 52, "Input"],
Cell[15046, 387, 213, 5, 30, "Output"],
Cell[15262, 394, 123, 2, 30, "Output"]
}, Open  ]]
}
]
*)

(* End of internal cache information *)

