(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 8.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       157,          7]
NotebookDataLength[     59117,       1390]
NotebookOptionsPosition[     55348,       1257]
NotebookOutlinePosition[     55714,       1273]
CellTagsIndexPosition[     55671,       1270]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell["Pricing Bermudan Swaption", "Title",
 CellChangeTimes->{{3.526267847265625*^9, 3.5262678714375*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Needs", "[", "\"\<QuantLib`\>\"", "]"}]], "Input",
 CellChangeTimes->{{3.52626721628125*^9, 3.526267224125*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   TagBox[
    ButtonBox[
     PaneSelectorBox[{False->"\<\"QuantLib\"\>", True->
      StyleBox["\<\"QuantLib\"\>", "HyperlinkActive"]}, Dynamic[
       CurrentValue["MouseOver"]],
      BaseStyle->{"Hyperlink"},
      BaselinePosition->Baseline,
      FrameMargins->0,
      ImageSize->Automatic],
     BaseStyle->"Hyperlink",
     ButtonData->{
       URL["http://quantlib.org"], None},
     ButtonNote->"http://quantlib.org"],
    Annotation[#, "http://quantlib.org", "Hyperlink"]& ], 
   "\[InvisibleSpace]", "\<\" for Mathematica installed, Version \
0.2.5\\n\"\>", "\[InvisibleSpace]", "\<\"for \"\>", 
   "\[InvisibleSpace]", "\<\"Windows\"\>", 
   "\[InvisibleSpace]", "\<\" system \"\>", 
   "\[InvisibleSpace]", "\<\"Microsoft Windows (32-bit)\"\>", 
   "\[InvisibleSpace]", "\<\"\\n\"\>", 
   "\[InvisibleSpace]", "\<\"Mathematica Interface \[Copyright] by \"\>", 
   "\[InvisibleSpace]", 
   TagBox[
    ButtonBox[
     PaneSelectorBox[{False->"\<\"Weber & Partner\"\>", True->
      StyleBox["\<\"Weber & Partner\"\>", "HyperlinkActive"]}, Dynamic[
       CurrentValue["MouseOver"]],
      BaseStyle->{"Hyperlink"},
      BaselinePosition->Baseline,
      FrameMargins->0,
      ImageSize->Automatic],
     BaseStyle->"Hyperlink",
     ButtonData->{
       URL["http://www.weber-und-partner.com"], None},
     ButtonNote->"http://www.weber-und-partner.com"],
    Annotation[#, "http://www.weber-und-partner.com", "Hyperlink"]& ], 
   "\[InvisibleSpace]", "\<\" 2011\"\>"}],
  SequenceForm[
   Hyperlink["QuantLib", "http://quantlib.org"], 
   " for Mathematica installed, Version 0.2.5\n", "for ", "Windows", 
   " system ", "Microsoft Windows (32-bit)", "\n", 
   "Mathematica Interface \[Copyright] by ", 
   Hyperlink["Weber & Partner", "http://www.weber-und-partner.com"], " 2011"],
  Editable->False]], "Print",
 CellChangeTimes->{3.527591126953125*^9, 3.527594432828125*^9, 
  3.5275962211875*^9, 3.527596321828125*^9, 3.527596355859375*^9, 
  3.52759653115625*^9, 3.5275967015625*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Visit \"\>", "\[InvisibleSpace]", 
   TagBox[
    ButtonBox[
     PaneSelectorBox[{
      False->"\<\"http://www.weber-und-partner.com/QuantLib/Mathematica\"\>", 
      True->
      StyleBox["\<\"http://www.weber-und-partner.com/QuantLib/Mathematica\"\>\
", "HyperlinkActive"]}, Dynamic[
       CurrentValue["MouseOver"]],
      BaseStyle->{"Hyperlink"},
      BaselinePosition->Baseline,
      FrameMargins->0,
      ImageSize->Automatic],
     BaseStyle->"Hyperlink",
     ButtonData->{
       URL["http://www.weber-und-partner.com/QuantLib/mma"], None},
     ButtonNote->"http://www.weber-und-partner.com/QuantLib/mma"],
    Annotation[#, "http://www.weber-und-partner.com/QuantLib/mma", 
     "Hyperlink"]& ], 
   "\[InvisibleSpace]", "\<\" for the latest version.\\nVisit \"\>", 
   "\[InvisibleSpace]", 
   TagBox[
    ButtonBox[
     PaneSelectorBox[{False->"\<\"http://quantlib.org/license.shtml\"\>", 
      True->
      StyleBox["\<\"http://quantlib.org/license.shtml\"\>", 
       "HyperlinkActive"]}, Dynamic[
       CurrentValue["MouseOver"]],
      BaseStyle->{"Hyperlink"},
      BaselinePosition->Baseline,
      FrameMargins->0,
      ImageSize->Automatic],
     BaseStyle->"Hyperlink",
     ButtonData->{
       URL["http://quantlib.org/license.shtml"], None},
     ButtonNote->"http://quantlib.org/license.shtml"],
    Annotation[#, "http://quantlib.org/license.shtml", "Hyperlink"]& ], 
   "\[InvisibleSpace]", "\<\" for the QuantLib license.\\nFor questions, \
support issues and enquiries mail to \"\>", "\[InvisibleSpace]", 
   TagBox[
    ButtonBox[
     PaneSelectorBox[{False->"\<\"quantLib@weber-und-partner.com\"\>", True->
      StyleBox["\<\"quantLib@weber-und-partner.com\"\>", "HyperlinkActive"]}, 
      Dynamic[
       CurrentValue["MouseOver"]],
      BaseStyle->{"Hyperlink"},
      BaselinePosition->Baseline,
      FrameMargins->0,
      ImageSize->Automatic],
     BaseStyle->"Hyperlink",
     ButtonData->{
       URL["mailto:quantLib@weber-und-partner.com"], None},
     ButtonNote->"mailto:quantLib@weber-und-partner.com"],
    Annotation[#, "mailto:quantLib@weber-und-partner.com", "Hyperlink"]& ], 
   "\[InvisibleSpace]", "\<\"\\n\"\>"}],
  SequenceForm["Visit ", 
   Hyperlink[
   "http://www.weber-und-partner.com/QuantLib/Mathematica", 
    "http://www.weber-und-partner.com/QuantLib/mma"], 
   " for the latest version.\nVisit ", 
   Hyperlink[
   "http://quantlib.org/license.shtml", "http://quantlib.org/license.shtml"], 
   " for the QuantLib license.\nFor questions, support issues and enquiries \
mail to ", 
   Hyperlink[
   "quantLib@weber-und-partner.com", "mailto:quantLib@weber-und-partner.com"],
    "\n"],
  Editable->False]], "Print",
 CellChangeTimes->{3.527591126953125*^9, 3.527594432828125*^9, 
  3.5275962211875*^9, 3.527596321828125*^9, 3.527596355859375*^9, 
  3.52759653115625*^9, 3.527596701578125*^9}],

Cell[BoxData["\<\"THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND \
CONTRIBUTORS 'AS IS' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT \
NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A \
PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDERS OR \
CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, \
EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, \
PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; \
OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, \
WHETHER IN CONTRACT, STRICT LIABILITY OR TORT (INCLUDING NEGLIGENCE OR \
OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF \
ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.\\n\"\>"], "Print",
 CellChangeTimes->{3.527591126953125*^9, 3.527594432828125*^9, 
  3.5275962211875*^9, 3.527596321828125*^9, 3.527596355859375*^9, 
  3.52759653115625*^9, 3.527596701578125*^9}],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"How", " ", "to", " ", "get", " ", "started"}], "MSG"], " ", 
  ButtonBox[
   StyleBox[">>", "SR"],
   Active->True,
   BaseStyle->"Link",
   ButtonData->"paclet:QuantLib/tutorial/Getting Started"]}]], "Print", \
"PrintUsage",
 CellChangeTimes->{3.52759670159375*^9}],

Cell[BoxData["\<\"Setting default values:\"\>"], "Print",
 CellChangeTimes->{3.527591126953125*^9, 3.527594432828125*^9, 
  3.5275962211875*^9, 3.527596321828125*^9, 3.527596355859375*^9, 
  3.52759653115625*^9, 3.527596707203125*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"  Setting Valuation Date = \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{"2011", ",", "10", ",", "14"}], "}"}]}],
  SequenceForm["  Setting Valuation Date = ", {2011, 10, 14}],
  Editable->False]], "Print",
 CellChangeTimes->{3.527591126953125*^9, 3.527594432828125*^9, 
  3.5275962211875*^9, 3.527596321828125*^9, 3.527596355859375*^9, 
  3.52759653115625*^9, 3.527596707265625*^9}]
}, Open  ]]
}, Open  ]],

Cell[BoxData[{
 RowBox[{
  RowBox[{"today", " ", "=", " ", 
   RowBox[{"{", 
    RowBox[{"2002", ",", "2", ",", "15"}], "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SetEvaluationDate", "[", "today", "]"}], ";"}]}], "Input",
 CellChangeTimes->{{3.52626747078125*^9, 3.526267503546875*^9}, {
  3.52629203728125*^9, 3.52629204484375*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"settlementDate", " ", "=", " ", 
   RowBox[{"{", 
    RowBox[{"2002", ",", "2", ",", "19"}], "}"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.52626807953125*^9, 3.526268098484375*^9}}],

Cell["flat yield term structure impling 1x5 swap at 5%", "Text",
 CellChangeTimes->{{3.526267520609375*^9, 3.526267549890625*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"yc", " ", "=", 
  RowBox[{"FlatForward", "[", 
   RowBox[{"settlementDate", ",", "0.04875825", ",", 
    RowBox[{"DayCounter", "\[Rule]", "\"\<Actual/365 (Fixed)\>\""}]}], 
   "]"}]}]], "Input",
 CellChangeTimes->{{3.52626761275*^9, 3.5262676563125*^9}, {
  3.52697972221875*^9, 3.52697973165625*^9}}],

Cell[BoxData["FlatForward3"], "Output",
 CellChangeTimes->{
  3.52626766103125*^9, 3.52626909915625*^9, 3.5262693865625*^9, 
   3.526272547296875*^9, 3.526277889796875*^9, 3.526290114046875*^9, 
   3.526291405671875*^9, 3.526292069625*^9, 3.52629332471875*^9, 
   3.526293891796875*^9, 3.52629401303125*^9, 3.526294281421875*^9, 
   3.526708204*^9, 3.526708665578125*^9, 3.526709767890625*^9, 
   3.526712206453125*^9, {3.52671229290625*^9, 3.526712315390625*^9}, 
   3.526712560171875*^9, 3.526714745765625*^9, 3.526715855234375*^9, 
   3.5267164323125*^9, 3.526720111578125*^9, 3.526722415890625*^9, 
   3.526722712859375*^9, 3.52672286453125*^9, 3.52672446771875*^9, 
   3.526724590734375*^9, 3.52679173998679*^9, 3.5267949172498465`*^9, 
   3.526795280221161*^9, 3.5267955617277775`*^9, 3.5267958565308437`*^9, 
   3.526795954699577*^9, 3.5267984511736217`*^9, 3.5267988534002733`*^9, 
   3.5267989963194046`*^9, 3.5267993438915267`*^9, 3.5267994948427196`*^9, 
   3.526800036804532*^9, 3.5268070620929537`*^9, 3.5268072389523287`*^9, 
   3.5268074430929537`*^9, 3.5268096820617037`*^9, 3.5268101769679537`*^9, 
   3.5268108223429537`*^9, 3.5268117184679537`*^9, 3.5268119529835787`*^9, 
   3.5268121325460787`*^9, 3.526815933578125*^9, 3.526884116234375*^9, 
   3.526884466578125*^9, 3.526897533484375*^9, 3.52689765234375*^9, 
   3.526898038578125*^9, 3.52689924159375*^9, 3.526899337625*^9, 
   3.52690167534375*^9, 3.526973655859375*^9, 3.526974391765625*^9, 
   3.526984446390625*^9, 3.52698620203125*^9, 3.52730703446875*^9, 
   3.5273344145625*^9, 3.52733486834375*^9, 3.52733584409375*^9, 
   3.527336178828125*^9, 3.527392949359375*^9, 3.527478141421875*^9, 
   3.527483821359375*^9, 3.527484844296875*^9, 3.52748626609375*^9, 
   3.527487626984375*^9, 3.52748794075*^9, 3.52749172634375*^9, 
   3.527499742640625*^9, 3.527500111015625*^9, {3.527501237078125*^9, 
   3.527501256234375*^9}, 3.527501292734375*^9, 3.527501343625*^9, 
   3.527501472796875*^9, 3.5275025298125*^9, 3.52750356959375*^9, 
   3.52758607134375*^9, 3.527590423921875*^9, 3.52759087265625*^9, 
   3.527591135859375*^9, 3.527594445609375*^9, 3.527596229421875*^9, 
   3.527596329234375*^9, 3.527596362828125*^9, 3.52759653215625*^9, 
   3.527596709109375*^9}]
}, Open  ]],

Cell[BoxData[{
 RowBox[{
  RowBox[{"floatlegConvention", " ", "=", " ", "\"\<Modified Following\>\""}],
   ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"fixedlegConvention", " ", "=", " ", "\"\<Unadjusted\>\""}], 
  ";"}]}], "Input",
 CellChangeTimes->{{3.526268113453125*^9, 3.5262681251875*^9}, {
  3.526268281421875*^9, 3.526268296421875*^9}, {3.526268606828125*^9, 
  3.52626863703125*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"indexSixMonths", " ", "=", " ", 
   RowBox[{"Euribor", "[", 
    RowBox[{"\"\<6M\>\"", ",", 
     RowBox[{"YieldCurve", "\[Rule]", "yc"}]}], "]"}]}], ";"}]], "Input",
 CellChangeTimes->{3.526268053421875*^9}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"startDate", " ", "=", " ", 
  RowBox[{"CalendarAdvance", "[", 
   RowBox[{"settlementDate", ",", 
    RowBox[{"{", 
     RowBox[{"1", ",", "\"\<Year\>\""}], "}"}], ",", 
    RowBox[{"BusinessDayConvention", "\[Rule]", " ", "floatlegConvention"}]}],
    "]"}]}]], "Input",
 CellChangeTimes->{{3.526268058625*^9, 3.526268068890625*^9}, {
  3.526268142359375*^9, 3.526268197078125*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"2003", ",", "2", ",", "19"}], "}"}]], "Output",
 CellChangeTimes->{
  3.52626819890625*^9, {3.526268289953125*^9, 3.5262683005*^9}, 
   3.526269099515625*^9, 3.526269386953125*^9, 3.5262701130625*^9, 
   3.526272548171875*^9, 3.52627789121875*^9, 3.52629012128125*^9, 
   3.52629141625*^9, 3.526292082453125*^9, 3.52629332640625*^9, 
   3.526293891875*^9, 3.526294013109375*^9, 3.5262942816875*^9, 
   3.52670820421875*^9, 3.526708665671875*^9, 3.52670976821875*^9, 
   3.526712206765625*^9, {3.52671229296875*^9, 3.52671231559375*^9}, 
   3.526712560484375*^9, 3.526714746875*^9, 3.5267158553125*^9, 
   3.526716432390625*^9, 3.526720112546875*^9, 3.526722416296875*^9, 
   3.5267227136875*^9, 3.5267228650625*^9, 3.52672446859375*^9, 
   3.5267245909375*^9, 3.5267917402367725`*^9, 3.5267949177810764`*^9, 
   3.526795280330532*^9, 3.5267955618059*^9, 3.526795856608966*^9, 
   3.5267959547776995`*^9, 3.5267984519548564`*^9, 3.5267988535096464`*^9, 
   3.526798996522526*^9, 3.5267993440946493`*^9, 3.5267994950614667`*^9, 
   3.5268000373045263`*^9, 3.5268070624679537`*^9, 3.5268072390617037`*^9, 
   3.5268074432023287`*^9, 3.5268096826242037`*^9, 3.5268101774679537`*^9, 
   3.5268108224210787`*^9, 3.5268117189367037`*^9, 3.5268119530617037`*^9, 
   3.5268121326554537`*^9, 3.52681593453125*^9, 3.52688411671875*^9, 
   3.526884467140625*^9, 3.52689753371875*^9, 3.526897652546875*^9, 
   3.526898038671875*^9, 3.526899242046875*^9, 3.52689933775*^9, 
   3.526901675890625*^9, 3.52697365675*^9, 3.526974392703125*^9, 
   3.526984447609375*^9, 3.526986202140625*^9, 3.5273070350625*^9, 
   3.527334415*^9, 3.52733486846875*^9, 3.527335844390625*^9, 
   3.527336179140625*^9, 3.527392950328125*^9, 3.5274781420625*^9, 
   3.527483822140625*^9, 3.5274848448125*^9, 3.52748626628125*^9, 
   3.527487627609375*^9, 3.52748794084375*^9, 3.52749172678125*^9, 
   3.52749974275*^9, 3.52750011375*^9, {3.52750123740625*^9, 3.5275012565*^9},
    3.52750129290625*^9, 3.527501343875*^9, 3.527501475046875*^9, 
   3.527502529890625*^9, 3.527503569671875*^9, 3.52758607159375*^9, 
   3.527590424375*^9, 3.52759087275*^9, 3.527591138421875*^9, 
   3.527594446140625*^9, 3.52759622996875*^9, 3.5275963293125*^9, 
   3.5275963638125*^9, 3.527596532484375*^9, 3.52759670965625*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"maturity", " ", "=", 
  RowBox[{"CalendarAdvance", "[", 
   RowBox[{"startDate", ",", 
    RowBox[{"{", 
     RowBox[{"5", ",", "\"\<Year\>\""}], "}"}], ",", 
    RowBox[{"BusinessDayConvention", "\[Rule]", " ", "floatlegConvention"}]}],
    "]"}]}]], "Input",
 CellChangeTimes->{{3.52626821778125*^9, 3.52626824175*^9}, {
  3.52626831828125*^9, 3.526268319859375*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"2008", ",", "2", ",", "19"}], "}"}]], "Output",
 CellChangeTimes->{
  3.526268242421875*^9, {3.5262683029375*^9, 3.52626832059375*^9}, 
   3.5262690995625*^9, 3.526269387015625*^9, 3.526270114*^9, 
   3.52627254821875*^9, 3.526277891625*^9, 3.526290122765625*^9, 
   3.526291417234375*^9, 3.5262920835*^9, 3.526293326453125*^9, 
   3.52629389190625*^9, 3.52629401315625*^9, 3.52629428175*^9, 
   3.526708204265625*^9, 3.526708665734375*^9, 3.526709768265625*^9, 
   3.5267122068125*^9, {3.526712293015625*^9, 3.52671231565625*^9}, 
   3.52671256053125*^9, 3.526714746921875*^9, 3.526715855359375*^9, 
   3.5267164324375*^9, 3.526720112640625*^9, 3.526722416359375*^9, 
   3.526722713765625*^9, 3.526722865125*^9, 3.526724468640625*^9, 
   3.52672459096875*^9, 3.5267917402836447`*^9, 3.526794917843574*^9, 
   3.52679528039303*^9, 3.526795562024643*^9, 3.5267958566558394`*^9, 
   3.5267959548245726`*^9, 3.526798452017355*^9, 3.5267988535721455`*^9, 
   3.5267989965694*^9, 3.5267993441415234`*^9, 3.526799495108341*^9, 
   3.5268000373514004`*^9, 3.5268070625148287`*^9, 3.5268072391398287`*^9, 
   3.5268074432648287`*^9, 3.5268096826710787`*^9, 3.5268101775460787`*^9, 
   3.5268108224992037`*^9, 3.5268117189992037`*^9, 3.5268119531242037`*^9, 
   3.5268121327335787`*^9, 3.526815934578125*^9, 3.52688411675*^9, 
   3.526884467171875*^9, 3.526897533859375*^9, 3.526897652625*^9, 
   3.526898038734375*^9, 3.526899242125*^9, 3.526899337828125*^9, 
   3.526901675953125*^9, 3.526973656828125*^9, 3.526974392796875*^9, 
   3.526984447671875*^9, 3.526986202234375*^9, 3.52730703515625*^9, 
   3.5273344150625*^9, 3.5273348685625*^9, 3.52733584446875*^9, 
   3.52733617921875*^9, 3.52739295040625*^9, 3.527478142140625*^9, 
   3.527483822203125*^9, 3.527484844859375*^9, 3.52748626634375*^9, 
   3.52748762771875*^9, 3.527487940890625*^9, 3.527491726875*^9, 
   3.527499742828125*^9, 3.5275001144375*^9, {3.527501237453125*^9, 
   3.5275012565625*^9}, 3.527501292953125*^9, 3.527501343890625*^9, 
   3.5275014759375*^9, 3.5275025299375*^9, 3.527503569859375*^9, 
   3.527586071640625*^9, 3.527590424421875*^9, 3.527590872828125*^9, 
   3.527591139203125*^9, 3.527594446203125*^9, 3.52759623003125*^9, 
   3.527596329375*^9, 3.527596363875*^9, 3.52759653259375*^9, 
   3.5275967096875*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"fixedSchedule", " ", "=", " ", 
   RowBox[{"Schedule", "[", 
    RowBox[{"startDate", ",", "maturity", ",", "\"\<1Y\>\"", ",", 
     RowBox[{"GenRule", "\[Rule]", "\"\<Forward\>\""}], ",", 
     RowBox[{"Calendar", "\[Rule]", " ", "\"\<Target\>\""}], ",", 
     RowBox[{"Convention", "\[Rule]", " ", "fixedlegConvention"}]}], "]"}]}], 
  ";"}], "\n", 
 RowBox[{
  RowBox[{"floatSchedule", " ", "=", " ", 
   RowBox[{"Schedule", "[", 
    RowBox[{"startDate", ",", "maturity", ",", "\"\<6M\>\"", ",", 
     RowBox[{"GenRule", "\[Rule]", "\"\<Forward\>\""}], ",", 
     RowBox[{"Calendar", "\[Rule]", " ", "\"\<Target\>\""}], ",", 
     RowBox[{"Convention", "\[Rule]", " ", "floatlegConvention"}]}], "]"}]}], 
  ";"}], "\n", 
 RowBox[{"swap", " ", "=", " ", 
  RowBox[{"VanillaSwap", "[", 
   RowBox[{
   "1000.", " ", ",", "fixedSchedule", ",", "0.03", ",", "floatSchedule", ",",
     "indexSixMonths", ",", "\"\<Payer\>\"", ",", 
    RowBox[{"FixedLegDayCounter", "\[Rule]", "\"\<Actual/360\>\""}]}], 
   "]"}]}]}], "Input",
 CellChangeTimes->{{3.52626833621875*^9, 3.5262684370625*^9}, {
  3.526268477921875*^9, 3.526268478921875*^9}, {3.52626858028125*^9, 
  3.526268580890625*^9}, {3.52626864384375*^9, 3.526268648765625*^9}, {
  3.5275001200625*^9, 3.52750013746875*^9}}],

Cell[BoxData["VanillaSwap7"], "Output",
 CellChangeTimes->{
  3.526269100484375*^9, 3.526269387203125*^9, 3.526269645125*^9, 
   3.52626982884375*^9, 3.526270118859375*^9, 3.526270168703125*^9, 
   3.526272549015625*^9, 3.52627789246875*^9, 3.526290126109375*^9, 
   3.52629142028125*^9, 3.526292089484375*^9, 3.52629332809375*^9, 
   3.526293892140625*^9, 3.526294013390625*^9, 3.52629428246875*^9, 
   3.52670820478125*^9, 3.526708665953125*^9, 3.526709768796875*^9, 
   3.526712207453125*^9, {3.526712293171875*^9, 3.526712315875*^9}, 
   3.5267125610625*^9, 3.5267147474375*^9, 3.526715855609375*^9, 
   3.52671643259375*^9, 3.526720114046875*^9, 3.526722416953125*^9, 
   3.526722715453125*^9, 3.526722866828125*^9, 3.526724469515625*^9, 
   3.52672459109375*^9, 3.5267917408461046`*^9, 3.526794918702916*^9, 
   3.5267952805805244`*^9, 3.5267955622433863`*^9, 3.526795856812084*^9, 
   3.5267959550901895`*^9, 3.5267984527360916`*^9, 3.526798853790891*^9, 
   3.526798996725647*^9, 3.5267993442977715`*^9, 3.5267994952802143`*^9, 
   3.5268000379920173`*^9, 3.5268070630617037`*^9, 3.5268072394054537`*^9, 
   3.5268074435148287`*^9, 3.5268096833273287`*^9, 3.5268101781867037`*^9, 
   3.5268108227804537`*^9, 3.5268117196867037`*^9, 3.5268119533273287`*^9, 
   3.5268121329210787`*^9, 3.5268159360625*^9, 3.52688411753125*^9, 
   3.526884467828125*^9, 3.5268975345625*^9, 3.526897652828125*^9, 
   3.526898038890625*^9, 3.5268992428125*^9, 3.52689933815625*^9, 
   3.526901676578125*^9, 3.526973658234375*^9, 3.526974394046875*^9, 
   3.52698444846875*^9, 3.5269862025*^9, 3.52730703590625*^9, 
   3.527334415578125*^9, 3.527334868828125*^9, 3.527335845125*^9, 
   3.52733617996875*^9, 3.52739295153125*^9, 3.527478142921875*^9, 
   3.52748382328125*^9, 3.5274848455*^9, 3.5274862665625*^9, 
   3.527487628734375*^9, 3.527487941140625*^9, 3.527491727640625*^9, 
   3.52749974309375*^9, 3.527500138421875*^9, {3.527501237546875*^9, 
   3.52750125665625*^9}, 3.527501293015625*^9, 3.52750134396875*^9, 
   3.527501476875*^9, 3.527502530125*^9, 3.5275035699375*^9, 
   3.527586071953125*^9, 3.527590424984375*^9, 3.527590872921875*^9, 
   3.52759114003125*^9, 3.527594446828125*^9, 3.527596230765625*^9, 
   3.527596329515625*^9, 3.52759636553125*^9, 3.527596532796875*^9, 
   3.52759671021875*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"InstrumentSetPricingEngine", "[", 
   RowBox[{"swap", ",", 
    RowBox[{"DiscountingSwapEngine", "[", "yc", "]"}]}], "]"}], ";"}], "\n", 
 RowBox[{"fixedATMRate", " ", "=", 
  RowBox[{"VanillaSwapFairRate", "[", "swap", "]"}]}]}], "Input",
 CellChangeTimes->{
  3.526269807796875*^9, {3.5262698429375*^9, 3.526269843609375*^9}, 
   3.52627028096875*^9, {3.52750014815625*^9, 3.52750015178125*^9}}],

Cell[BoxData["0.04928679179209221`"], "Output",
 CellChangeTimes->{
  3.526294013609375*^9, 3.526294282671875*^9, 3.5267082055*^9, 
   3.52670866609375*^9, 3.526709769015625*^9, 3.526712207625*^9, {
   3.52671229328125*^9, 3.526712316*^9}, 3.52671256128125*^9, 
   3.526714747671875*^9, 3.526715855703125*^9, 3.526716432765625*^9, 
   3.52672011509375*^9, 3.526722417296875*^9, 3.5267227163125*^9, 
   3.526722867796875*^9, 3.526724469765625*^9, 3.526724591171875*^9, 
   3.5267917411898303`*^9, 3.526794919531009*^9, 3.5267952807367697`*^9, 
   3.5267955623527575`*^9, 3.5267958570308275`*^9, 3.526795955183936*^9, 
   3.5267984535798254`*^9, 3.5267988539315133`*^9, 3.5267989968350196`*^9, 
   3.5267993444071455`*^9, 3.5267994953895874`*^9, 3.5268000382107644`*^9, 
   3.5268070632804537`*^9, 3.5268072397804537`*^9, 3.5268074436710787`*^9, 
   3.5268096836554537`*^9, 3.5268101786085787`*^9, 3.5268108234210787`*^9, 
   3.5268117202492037`*^9, 3.5268119536242037`*^9, 3.5268121330460787`*^9, 
   3.526815936734375*^9, 3.526884117890625*^9, 3.52688446809375*^9, 
   3.526897534734375*^9, 3.52689765296875*^9, 3.52689803909375*^9, 
   3.526899243234375*^9, 3.526899338296875*^9, 3.52690167703125*^9, 
   3.5269736589375*^9, 3.526974394640625*^9, 3.526984448828125*^9, 
   3.52698620265625*^9, 3.52730703640625*^9, 3.52733441603125*^9, 
   3.527334869*^9, 3.527335845390625*^9, 3.527336180390625*^9, 
   3.527392951921875*^9, 3.52747814340625*^9, 3.527483823671875*^9, 
   3.52748484578125*^9, 3.527486266703125*^9, 3.527487629*^9, 
   3.527487941234375*^9, 3.527491728171875*^9, 3.5274997431875*^9, {
   3.527500148859375*^9, 3.527500152421875*^9}, {3.527501237609375*^9, 
   3.527501256734375*^9}, 3.527501293078125*^9, 3.527501344015625*^9, 
   3.527501478640625*^9, 3.5275025301875*^9, 3.52750357*^9, 
   3.527586072109375*^9, 3.527590425234375*^9, 3.527590872984375*^9, 
   3.527591140921875*^9, 3.527594447796875*^9, 3.52759623096875*^9, 
   3.527596329578125*^9, 3.527596366515625*^9, 3.527596533015625*^9, 
   3.527596710625*^9}]
}, Open  ]],

Cell[BoxData[{
 RowBox[{
  RowBox[{"fixedOTMRate", " ", "=", " ", 
   RowBox[{"fixedATMRate", " ", "1.2"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"fixedITMRate", " ", "=", " ", 
   RowBox[{"fixedATMRate", "  ", "0.8"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"atmSwap", " ", "=", " ", 
   RowBox[{"VanillaSwap", "[", 
    RowBox[{
    "1000.", " ", ",", "fixedSchedule", ",", "fixedATMRate", ",", 
     "floatSchedule", ",", "indexSixMonths", ",", "\"\<Payer\>\"", ",", 
     RowBox[{"FixedLegDayCounter", "\[Rule]", "\"\<Actual/360\>\""}]}], 
    "]"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"itmSwap", " ", "=", " ", 
   RowBox[{"VanillaSwap", "[", 
    RowBox[{
    "1000.", " ", ",", "fixedSchedule", ",", "fixedITMRate", ",", 
     "floatSchedule", ",", "indexSixMonths", ",", "\"\<Payer\>\"", ",", 
     RowBox[{"FixedLegDayCounter", "\[Rule]", "\"\<Actual/360\>\""}]}], 
    "]"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"otmSwap", " ", "=", " ", 
   RowBox[{"VanillaSwap", "[", 
    RowBox[{
    "1000.", " ", ",", "fixedSchedule", ",", "fixedOTMRate", ",", 
     "floatSchedule", ",", "indexSixMonths", ",", "\"\<Payer\>\"", ",", 
     RowBox[{"FixedLegDayCounter", "\[Rule]", "\"\<Actual/360\>\""}]}], 
    "]"}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.526292955578125*^9, 3.526292957125*^9}, {
   3.526293008484375*^9, 3.52629300859375*^9}, {3.526293055203125*^9, 
   3.526293088921875*^9}, 3.52629334659375*^9, {3.527500179578125*^9, 
   3.527500186984375*^9}}],

Cell[BoxData[
 RowBox[{" ", 
  RowBox[{
   RowBox[{
    RowBox[{"swapLengths", "=", 
     RowBox[{"{", 
      RowBox[{"1", ",", "2", ",", "3", ",", "4", ",", "5"}], "}"}]}], ";"}], 
   "\n", 
   RowBox[{
    RowBox[{"swaptionVols", " ", "=", 
     TagBox[
      RowBox[{"(", "\[NoBreak]", GridBox[{
         {"0.1490", "0.1340", "0.1228", "0.1189", "0.1148"},
         {"0.1290", "0.1201", "0.1146", "0.1108", "0.1040"},
         {"0.1149", "0.1112", "0.1070", "0.1010", "0.0957"},
         {"0.1047", "0.1021", "0.0980", "0.0951", "0.1270"},
         {"0.1000", "0.0950", "0.0999", "0.1230", "0.1160"}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.7]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
      Function[BoxForm`e$, 
       MatrixForm[BoxForm`e$]]]}], ";"}]}]}]], "Input",
 CellChangeTimes->{{3.526708470015625*^9, 3.526708492296875*^9}, {
   3.52671651425*^9, 3.526716523984375*^9}, {3.526716845375*^9, 
   3.52671684653125*^9}, 3.527499650171875*^9, {3.527500203921875*^9, 
   3.5275002465625*^9}, {3.5275015188125*^9, 3.527501522421875*^9}, {
   3.52750309115625*^9, 3.527503115515625*^9}, {3.527503145921875*^9, 
   3.5275032858125*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"swaptions", "=", " ", 
  RowBox[{"Table", "[", 
   RowBox[{
    RowBox[{"SwaptionHelper", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"swapLengths", "[", 
         RowBox[{"[", "i", "]"}], "]"}], ",", "\"\<Year\>\""}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"swapLengths", "[", 
         RowBox[{"[", 
          RowBox[{"-", "i"}], "]"}], "]"}], ",", "\"\<Year\>\""}], "}"}], ",", 
      RowBox[{"swaptionVols", "[", 
       RowBox[{"[", 
        RowBox[{"i", ",", 
         RowBox[{"-", "i"}]}], "]"}], "]"}], ",", "indexSixMonths", ",", 
      "yc"}], "]"}], ",", 
    RowBox[{"{", 
     RowBox[{"i", ",", 
      RowBox[{"Length", "[", "swapLengths", "]"}]}], "}"}]}], "]"}], 
  " "}]], "Input",
 CellChangeTimes->{{3.52671696234375*^9, 3.526717134390625*^9}, {
   3.52671731234375*^9, 3.526717313078125*^9}, {3.52672245828125*^9, 
   3.52672246109375*^9}, 3.527499606359375*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "SwaptionHelper12", ",", "SwaptionHelper14", ",", "SwaptionHelper16", ",", 
   "SwaptionHelper18", ",", "SwaptionHelper20"}], "}"}]], "Output",
 CellChangeTimes->{{3.5267170874375*^9, 3.52671713590625*^9}, 
   3.526717314953125*^9, 3.5267201169375*^9, 3.526722419296875*^9, 
   3.52672246246875*^9, 3.5267227188125*^9, 3.526722871296875*^9, 
   3.526724471921875*^9, 3.526724593375*^9, 3.5267917434084244`*^9, 
   3.526794922827758*^9, 3.5267952833460608`*^9, 3.5267955641651993`*^9, 
   3.5267958587807713`*^9, 3.526795957043252*^9, 3.526798456251649*^9, 
   3.5267988566502113`*^9, 3.52679899863186*^9, 3.5267993462352467`*^9, 
   3.5267994972176895`*^9, 3.526800040445111*^9, 3.5268070658429537`*^9, 
   3.5268072428742037`*^9, 3.5268074463585787`*^9, 3.5268096858273287`*^9, 
   3.5268101818898287`*^9, 3.5268108262960787`*^9, 3.5268117227960787`*^9, 
   3.5268119558429537`*^9, 3.5268121353898287`*^9, 3.52681594015625*^9, 
   3.5268841215625*^9, 3.5268844705625*^9, 3.52689753715625*^9, 
   3.5268976546875*^9, 3.5268980405*^9, 3.5268992458125*^9, 
   3.52689934046875*^9, 3.52690168025*^9, 3.526973672625*^9, 
   3.526974397390625*^9, 3.5269844506875*^9, 3.52698620475*^9, 
   3.527307039171875*^9, 3.527334417828125*^9, 3.527334871140625*^9, 
   3.527335847625*^9, 3.5273361821875*^9, 3.527392954046875*^9, 
   3.52747814578125*^9, 3.52748382534375*^9, 3.527484847390625*^9, 
   3.52748626875*^9, 3.527487630828125*^9, 3.527487942515625*^9, 
   3.527491730859375*^9, 3.527499743875*^9, 3.527500261078125*^9, {
   3.52750123784375*^9, 3.52750125696875*^9}, 3.52750129321875*^9, 
   3.527501344203125*^9, 3.5275015244375*^9, 3.52750253046875*^9, 
   3.527503289625*^9, 3.5275034751875*^9, 3.527503570265625*^9, 
   3.527586072390625*^9, 3.527590425796875*^9, 3.5275908733125*^9, 
   3.527591144453125*^9, 3.527594448453125*^9, 3.527596231359375*^9, 
   3.52759632978125*^9, 3.52759636778125*^9, 3.52759653378125*^9, 
   3.527596710875*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"times", " ", "=", " ", 
   RowBox[{
    RowBox[{"Map", "[", 
     RowBox[{"CalibrationHelperTimes", ",", "swaptions"}], "]"}], " ", "//", 
    " ", "Flatten"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"timeGrid", "=", 
  RowBox[{"TimeGrid", "[", 
   RowBox[{"times", ",", "30"}], "]"}]}]}], "Input",
 CellChangeTimes->{{3.527500505078125*^9, 3.527500513203125*^9}, {
  3.5275005506875*^9, 3.52750055709375*^9}}],

Cell[BoxData["TimeGrid22"], "Output",
 CellChangeTimes->{{3.527500501046875*^9, 3.527500515296875*^9}, 
   3.527500557765625*^9, {3.527501237890625*^9, 3.52750125703125*^9}, 
   3.527501293296875*^9, 3.52750134425*^9, 3.5275015258125*^9, 
   3.527502530546875*^9, 3.5275032919375*^9, 3.52750357034375*^9, 
   3.5275860725625*^9, 3.5275904260625*^9, 3.52759087340625*^9, 
   3.527591145546875*^9, 3.527594448734375*^9, 3.527596231421875*^9, 
   3.52759632984375*^9, 3.527596368453125*^9, 3.527596533890625*^9, 
   3.52759671103125*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Map", "[", 
  RowBox[{"CalibrationHelperMarketValue", " ", ",", "swaptions"}], 
  "]"}]], "Input",
 CellChangeTimes->{{3.52671734334375*^9, 3.526717424125*^9}, {
  3.527500279890625*^9, 3.527500280765625*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "0.009485292983138868`", ",", "0.010078004096968454`", ",", 
   "0.008716174158974202`", ",", "0.006226445078943897`", ",", 
   "0.0033230344781331068`"}], "}"}]], "Output",
 CellChangeTimes->{{3.526717372375*^9, 3.52671742475*^9}, 
   3.526720117015625*^9, 3.52672241934375*^9, 3.526722463828125*^9, 
   3.526722718875*^9, 3.526722871484375*^9, 3.52672447196875*^9, 
   3.526724593515625*^9, 3.52679174347092*^9, 3.526794922999626*^9, 
   3.5267952835179305`*^9, 3.5267955643526936`*^9, 3.526795858827645*^9, 
   3.5267959572151213`*^9, 3.526798456439145*^9, 3.5267988569002066`*^9, 
   3.526798998803732*^9, 3.5267993464071198`*^9, 3.5267994974051867`*^9, 
   3.5268000404919853`*^9, 3.5268070660617037`*^9, 3.5268072431710787`*^9, 
   3.5268074465929537`*^9, 3.5268096860148287`*^9, 3.5268101821710787`*^9, 
   3.5268108264992037`*^9, 3.5268117230148287`*^9, 3.5268119560460787`*^9, 
   3.5268121356085787`*^9, 3.526815940203125*^9, 3.526884121625*^9, 
   3.52688447071875*^9, 3.526897537359375*^9, 3.52689765475*^9, 
   3.526898040546875*^9, 3.52689924596875*^9, 3.526899340671875*^9, 
   3.526901680421875*^9, 3.526973672828125*^9, 3.526974397671875*^9, 
   3.526984450765625*^9, 3.526986204984375*^9, 3.527307039359375*^9, 
   3.527334417890625*^9, 3.52733487134375*^9, 3.52733584778125*^9, 
   3.527336182359375*^9, 3.527392954125*^9, 3.527478145984375*^9, 
   3.527483825484375*^9, 3.527484847546875*^9, 3.527486268921875*^9, 
   3.52748763096875*^9, 3.527487942671875*^9, 3.527491731125*^9, 
   3.527499743921875*^9, {3.52750026271875*^9, 3.52750028125*^9}, {
   3.527501237953125*^9, 3.527501257109375*^9}, 3.527501293359375*^9, 
   3.527501344296875*^9, 3.527501530453125*^9, 3.52750253059375*^9, 
   3.527503293125*^9, 3.527503570390625*^9, 3.527586072625*^9, 
   3.527590426109375*^9, 3.527590873453125*^9, 3.527591146765625*^9, 
   3.52759444878125*^9, 3.52759623146875*^9, 3.527596329890625*^9, 
   3.527596368484375*^9, 3.527596533953125*^9, 3.5275967110625*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"modelG2", " ", "=", " ", 
   RowBox[{"G2", "[", "yc", "]"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"modelHW", " ", "=", 
   RowBox[{"HullWhite", "[", "yc", "]"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"modelHW2", " ", "=", 
   RowBox[{"HullWhite", "[", "yc", "]"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"modelBK", " ", "=", " ", 
   RowBox[{"BlackKarasinski", "[", "yc", "]"}]}], ";"}], "\n", 
 RowBox[{"modelCIR", " ", "=", " ", 
  RowBox[{"ExtendedCoxIngersollRoss", "[", "yc", "]"}]}]}], "Input",
 CellChangeTimes->{{3.5267986037019424`*^9, 3.5267986120455327`*^9}, {
   3.527500294453125*^9, 3.52750032396875*^9}, 3.527591169984375*^9}],

Cell[BoxData["ExtendedCoxIngersollRoss27"], "Output",
 CellChangeTimes->{
  3.52749859840625*^9, 3.52749974525*^9, {3.527501238578125*^9, 
   3.527501257546875*^9}, 3.52750129371875*^9, 3.527501344890625*^9, 
   3.5275015349375*^9, 3.527502530921875*^9, 3.52750357084375*^9, 
   3.52758607371875*^9, 3.52759042709375*^9, 3.52759087409375*^9, 
   3.52759115346875*^9, 3.527594448984375*^9, 3.527596231546875*^9, 
   3.527596330140625*^9, 3.52759636878125*^9, 3.52759653428125*^9, 
   3.527596711171875*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"Map", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"CalibrationHelperSetPricingEngine", "[", 
      RowBox[{"#", ",", 
       RowBox[{"G2SwaptionEngine", "[", 
        RowBox[{"modelG2", ",", "6.", ",", "16"}], "]"}]}], "]"}], "&"}], ",",
     "swaptions"}], "]"}], ";"}], "\n", 
 RowBox[{"CalibrateModel", "[", 
  RowBox[{"modelG2", ",", "swaptions"}], "]"}]}], "Input",
 CellChangeTimes->{{3.52750038953125*^9, 3.527500394359375*^9}, {
  3.527500451265625*^9, 3.527500452296875*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "0.04999271597620449`", ",", "0.019980151116270627`", ",", 
   "0.049981926047971685`", ",", "0.020605523582752226`", ",", 
   RowBox[{"-", "0.9491704499957634`"}]}], "}"}]], "Output",
 CellChangeTimes->{
  3.526884521015625*^9, 3.526897541921875*^9, 3.526897659390625*^9, 
   3.526898044140625*^9, 3.526899280265625*^9, 3.526899376015625*^9, 
   3.526901715859375*^9, 3.526973715703125*^9, 3.526974447171875*^9, 
   3.5269844820625*^9, 3.526986244328125*^9, 3.527307078515625*^9, 
   3.527334457859375*^9, 3.52733491228125*^9, 3.527335890109375*^9, 
   3.5273362249375*^9, 3.52739299659375*^9, 3.5274782108125*^9, 
   3.52748387490625*^9, 3.527484890640625*^9, 3.527486312484375*^9, 
   3.52748767434375*^9, 3.527487984578125*^9, 3.52749180328125*^9, 
   3.527499745796875*^9, 3.527500411640625*^9, {3.527501243453125*^9, 
   3.527501257625*^9}, 3.527501293796875*^9, 3.527501353140625*^9, 
   3.527501552796875*^9, 3.52750244521875*^9, 3.527502545171875*^9, 
   3.527503314*^9, 3.527503488015625*^9, 3.527503584984375*^9, 
   3.52758607484375*^9, 3.527590441140625*^9, 3.527590889171875*^9, 
   3.527594462375*^9, 3.527596231609375*^9, 3.52759633021875*^9, 
   3.527596369328125*^9, 3.5275965346875*^9, 3.527596712671875*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"Map", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"CalibrationHelperSetPricingEngine", "[", 
      RowBox[{"#", ",", 
       RowBox[{"JamshidianSwaptionEngine", "[", "modelHW", "]"}]}], "]"}], 
     "&"}], ",", "swaptions"}], "]"}], ";"}], "\n", 
 RowBox[{"CalibrateModel", "[", 
  RowBox[{"modelHW", ",", "swaptions"}], "]"}]}], "Input",
 CellChangeTimes->{{3.5268103427804537`*^9, 3.5268103634210787`*^9}, {
  3.5268105273273287`*^9, 3.5268105908742037`*^9}, {3.5268122518429537`*^9, 
  3.5268122576242037`*^9}, {3.52681598578125*^9, 3.526816008734375*^9}, {
  3.527500350640625*^9, 3.527500366953125*^9}, {3.52750045921875*^9, 
  3.52750045965625*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0.04887080431304541`", ",", "0.006008244270990034`"}], 
  "}"}]], "Output",
 CellChangeTimes->{
  3.526816011171875*^9, 3.52688415196875*^9, 3.526884503296875*^9, 
   3.52689754128125*^9, 3.526897658734375*^9, 3.526898043671875*^9, 
   3.5268992746875*^9, 3.526899370359375*^9, 3.526901710234375*^9, 
   3.52697370690625*^9, 3.52697443903125*^9, 3.526984477609375*^9, 
   3.526986240515625*^9, 3.52730707465625*^9, 3.527334453953125*^9, 
   3.52733490840625*^9, 3.5273358851875*^9, 3.527336220890625*^9, 
   3.52739299228125*^9, 3.527478203796875*^9, 3.527483869390625*^9, 
   3.52748488653125*^9, 3.5274863085*^9, 3.52748767025*^9, 
   3.52748798040625*^9, 3.52749179575*^9, 3.52749974575*^9, 
   3.527500353578125*^9, {3.52750124375*^9, 3.5275012576875*^9}, 
   3.527501293859375*^9, 3.5275013536875*^9, 3.527501556*^9, 
   3.5275025461875*^9, 3.52750358596875*^9, 3.52758607503125*^9, 
   3.527590442125*^9, 3.527590890265625*^9, 3.52759446334375*^9, 
   3.5275962316875*^9, 3.527596330296875*^9, 3.527596369640625*^9, 
   3.527596535515625*^9, 3.52759671290625*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"Map", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"CalibrationHelperSetPricingEngine", "[", 
      RowBox[{"#", ",", 
       RowBox[{"TreeSwaptionEngine", "[", 
        RowBox[{"modelHW2", ",", "timeGrid"}], "]"}]}], "]"}], "&"}], ",", 
    "swaptions"}], "]"}], ";"}], "\n", 
 RowBox[{"CalibrateModel", "[", 
  RowBox[{"modelHW2", ",", "swaptions"}], "]"}]}], "Input",
 CellChangeTimes->{{3.5268103427804537`*^9, 3.5268103634210787`*^9}, {
   3.5268105273273287`*^9, 3.5268105908742037`*^9}, {3.5268122518429537`*^9, 
   3.5268122576242037`*^9}, {3.52681598578125*^9, 3.526816008734375*^9}, {
   3.527500350640625*^9, 3.527500366953125*^9}, {3.52750045921875*^9, 
   3.52750047375*^9}, {3.52750054340625*^9, 3.527500573859375*^9}, 
   3.5275015755625*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0.05522887357628303`", ",", "0.006106275468869613`"}], 
  "}"}]], "Output",
 CellChangeTimes->{
  3.5275005768125*^9, {3.527501244171875*^9, 3.527501258140625*^9}, 
   3.527501294296875*^9, 3.527501354140625*^9, 3.527501743359375*^9, 
   3.527502698703125*^9, 3.52750373584375*^9, 3.5275860771875*^9, 
   3.5275906190625*^9, 3.527594624640625*^9, 3.52759623175*^9, 
   3.527596330359375*^9, 3.527596371171875*^9, 3.527596535640625*^9, 
   3.52759671578125*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"Map", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"CalibrationHelperSetPricingEngine", "[", 
      RowBox[{"#", ",", 
       RowBox[{"TreeSwaptionEngine", "[", 
        RowBox[{"modelBK", ",", "timeGrid"}], "]"}]}], "]"}], "&"}], ",", 
    "swaptions"}], "]"}], ";"}], "\n", 
 RowBox[{"CalibrateModel", "[", 
  RowBox[{"modelBK", ",", "swaptions"}], "]"}]}], "Input",
 CellChangeTimes->{{3.52750160028125*^9, 3.527501621890625*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0.043389405009921236`", ",", "0.12074595689401779`"}], 
  "}"}]], "Output",
 CellChangeTimes->{{3.527501244234375*^9, 3.527501258234375*^9}, 
   3.527501294359375*^9, 3.5275013541875*^9, 3.5275019069375*^9, 
   3.52750286525*^9, 3.527503897390625*^9, 3.52758608328125*^9, 
   3.52759079971875*^9, 3.5275947876875*^9, 3.5275962318125*^9, 
   3.5275963304375*^9, 3.527596372890625*^9, 3.5275965356875*^9, 
   3.527596720921875*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"Map", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"CalibrationHelperSetPricingEngine", "[", 
     RowBox[{"#", ",", 
      RowBox[{"JamshidianSwaptionEngine", "[", "modelCIR", "]"}]}], "]"}], 
    "&"}], ",", "swaptions"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"CalibrateModel", "[", 
  RowBox[{"modelCIR", ",", "swaptions"}], "]"}]}], "Input",
 CellChangeTimes->{{3.527591204671875*^9, 3.5275912341875*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"True", ",", "True", ",", "True", ",", "True", ",", "True"}], 
  "}"}]], "Output",
 CellChangeTimes->{{3.52759121090625*^9, 3.527591223859375*^9}, 
   3.527594787953125*^9, 3.52759623203125*^9, 3.52759633053125*^9, 
   3.527596373109375*^9, 3.527596536265625*^9, 3.527596721140625*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "0.1478090508156395`", ",", "0.068212419813534`", ",", 
   "0.042841672917784575`", ",", "0.024901115303240316`"}], "}"}]], "Output",
 CellChangeTimes->{{3.52759121090625*^9, 3.527591223859375*^9}, 
   3.527594787953125*^9, 3.52759623203125*^9, 3.52759633053125*^9, 
   3.527596373109375*^9, 3.527596536265625*^9, 3.527596721375*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"TreeSwaptionEngine", "[", 
  RowBox[{"modelCIR", ",", "timeGrid"}], "]"}]], "Input",
 CellChangeTimes->{{3.52759131028125*^9, 3.527591343046875*^9}}],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"QuantLibError", "::", "msg"}], "MessageName"], 
  RowBox[{
  ":", " "}], "\<\"Error: \
\[NoBreak]\\!\\(\\\"MLqlTreeSwaptionEngine::store4\\\"\\)\[NoBreak] \
\[NoBreak]\\!\\(\\\"Boost assertion failed: px != 0\\\"\\)\[NoBreak]\"\>"}]], \
"Message", "MSG",
 CellChangeTimes->{3.5275967216875*^9}],

Cell[BoxData["$Failed"], "Output",
 CellChangeTimes->{{3.527591310890625*^9, 3.527591344140625*^9}, 
   3.527591534359375*^9, 3.52759186053125*^9, 3.527592042859375*^9, 
   3.52759479096875*^9, 3.52759623209375*^9, 3.527596330625*^9, 
   3.527596373359375*^9, 3.527596536390625*^9, 3.5275967216875*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"Map", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"CalibrationHelperSetPricingEngine", "[", 
      RowBox[{"#", ",", 
       RowBox[{"G2SwaptionEngine", "[", 
        RowBox[{"modelG2", ",", "6.", ",", "16"}], "]"}]}], "]"}], "&"}], ",",
     "swaptions"}], "]"}], ";"}], "\n", 
 RowBox[{"CalibrateModel", "[", 
  RowBox[{"modelG2", ",", "swaptions"}], "]"}]}], "Input"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "0.049983234642897396`", ",", "0.019980093251806302`", ",", 
   "0.049983182737013625`", ",", "0.020605508783359493`", ",", 
   RowBox[{"-", "0.9491705017989854`"}]}], "}"}]], "Output",
 CellChangeTimes->{3.527594792640625*^9, 3.527596232140625*^9, 
  3.527596330703125*^9, 3.527596373453125*^9, 3.527596536734375*^9, 
  3.527596721828125*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Map", "[", 
  RowBox[{"CalibrationHelperMarketValue", " ", ",", "swaptions"}], 
  "]"}]], "Input",
 CellChangeTimes->{{3.52688448640625*^9, 3.526884500671875*^9}, {
  3.527501980265625*^9, 3.527501984203125*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "0.009485292983138868`", ",", "0.010078004096968454`", ",", 
   "0.008716174158974202`", ",", "0.006226445078943897`", ",", 
   "0.0033230344781331068`"}], "}"}]], "Output",
 CellChangeTimes->{
  3.526884524140625*^9, 3.526897542171875*^9, 3.526897659640625*^9, 
   3.526898044234375*^9, 3.526899280390625*^9, 3.52689937615625*^9, 
   3.526901716*^9, 3.526973715875*^9, 3.526974447359375*^9, 
   3.52698448221875*^9, 3.526986244625*^9, 3.527307078796875*^9, 
   3.527334458203125*^9, 3.527334912546875*^9, 3.5273358905*^9, 
   3.527336225234375*^9, 3.52739299696875*^9, 3.52747821165625*^9, 
   3.52748387528125*^9, 3.527484890859375*^9, 3.527486312765625*^9, 
   3.5274876745625*^9, 3.5274879848125*^9, 3.52749180375*^9, 3.527499746*^9, {
   3.52750124453125*^9, 3.52750125846875*^9}, 3.52750129459375*^9, 
   3.527501354484375*^9, {3.527501973703125*^9, 3.5275019846875*^9}, 
   3.5275028799375*^9, 3.5275038975625*^9, 3.527586083421875*^9, 
   3.52759080003125*^9, 3.52759479284375*^9, 3.527596232203125*^9, 
   3.52759633078125*^9, 3.5275963735*^9, 3.5275965368125*^9, 
   3.527596721859375*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"Map", "[", 
   RowBox[{"CalibrationHelperModelValue", " ", ",", "swaptions"}], "]"}], 
  " "}]], "Input",
 CellChangeTimes->{{3.52688450753125*^9, 3.5268845080625*^9}, {
  3.52750199140625*^9, 3.52750199525*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "0.008300436115666686`", ",", "0.009562054227325518`", ",", 
   "0.008718962328258166`", ",", "0.00660807364553779`", ",", 
   "0.0036351685784404685`"}], "}"}]], "Output",
 CellChangeTimes->{
  3.526884525625*^9, 3.526897542265625*^9, 3.52689765971875*^9, 
   3.526898044296875*^9, 3.526899280671875*^9, 3.526899376390625*^9, 
   3.52690171625*^9, 3.52697371625*^9, 3.526974447703125*^9, 
   3.526984482484375*^9, 3.526986244859375*^9, 3.52730707903125*^9, 
   3.527334458453125*^9, 3.52733491278125*^9, 3.52733589071875*^9, 
   3.52733622546875*^9, 3.527392997234375*^9, 3.527478212078125*^9, 
   3.527483875625*^9, 3.52748489109375*^9, 3.527486312984375*^9, 
   3.527487674828125*^9, 3.527487985046875*^9, 3.527491804140625*^9, 
   3.527499746046875*^9, {3.52750124478125*^9, 3.5275012585*^9}, 
   3.52750129465625*^9, 3.527501354625*^9, 3.527501998515625*^9, 
   3.52750288290625*^9, 3.527503900265625*^9, 3.5275860835*^9, 
   3.527590804390625*^9, 3.5275947929375*^9, 3.527596232265625*^9, 
   3.527596330859375*^9, 3.52759637365625*^9, 3.527596536921875*^9, 
   3.52759672190625*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"MapThread", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"CalibrationHelperImpliedVolatility", "[", 
      RowBox[{"#1", ",", "#2"}], "]"}], "&"}], " ", ",", 
    RowBox[{"{", 
     RowBox[{"swaptions", ",", 
      RowBox[{"Map", "[", 
       RowBox[{"CalibrationHelperModelValue", " ", ",", "swaptions"}], 
       "]"}]}], "}"}]}], "]"}], " "}]], "Input",
 CellChangeTimes->{{3.5268845455*^9, 3.52688456790625*^9}, {3.526884654*^9, 
  3.526884766125*^9}, {3.527500049546875*^9, 3.52750005375*^9}, {
  3.5275020223125*^9, 3.527502046046875*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "0.10044752794543142`", ",", "0.10512061068403618`", ",", 
   "0.10704361114398399`", ",", "0.1083989375044767`", ",", 
   "0.10941572476086975`"}], "}"}]], "Output",
 CellChangeTimes->{{3.526884687921875*^9, 3.526884700453125*^9}, {
   3.52688473128125*^9, 3.526884768890625*^9}, 3.526897542671875*^9, 
   3.526897659875*^9, 3.5268980444375*^9, 3.526899282078125*^9, 
   3.526899377765625*^9, 3.52690171759375*^9, 3.526973718203125*^9, 
   3.52697444975*^9, 3.526984483859375*^9, 3.52698624609375*^9, 
   3.52730708046875*^9, 3.52733445978125*^9, 3.5273349140625*^9, 
   3.527335892078125*^9, 3.5273362266875*^9, 3.527392998703125*^9, 
   3.527478214546875*^9, 3.52748387703125*^9, 3.5274848925625*^9, 
   3.52748631434375*^9, 3.527487676203125*^9, 3.527487986375*^9, 
   3.52749180621875*^9, 3.52749974621875*^9, 3.52750005525*^9, {
   3.52750124484375*^9, 3.527501258578125*^9}, 3.52750129471875*^9, 
   3.527501354671875*^9, {3.527502037078125*^9, 3.5275020495*^9}, 
   3.52750288590625*^9, 3.527503903453125*^9, 3.527586083609375*^9, 
   3.52759080790625*^9, 3.52759479328125*^9, 3.5275962323125*^9, 
   3.527596330921875*^9, 3.527596373984375*^9, 3.527596537015625*^9, 
   3.527596722*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"VanillaSwapFixedLegAnalysis", "[", "swap", "]"}], " ", "//", " ", 
  "TableForm"}]], "Input",
 CellChangeTimes->{{3.527485005375*^9, 3.527485031515625*^9}}],

Cell[BoxData[
 TagBox[GridBox[{
    {"\<\"Payment Date\"\>", "\<\"Amount\"\>", "\<\"Nominal\"\>", \
"\<\"Accrual Start Date\"\>", "\<\"Accrual End Date\"\>", "\<\"Accrual Days\"\
\>", "\<\"Index\"\>", "\<\"Fixing Days\"\>", "\<\"Fixing Dates\"\>", "\<\"Day \
Counter\"\>", "\<\"Accrual Period\"\>", "\<\"Effective Rate\"\>", \
"\<\"Floor\"\>", "\<\"Gearing\"\>", "\<\"Index Fixing\"\>", "\<\"Conv. Adj.\"\
\>", "\<\"Spread\"\>", "\<\"Cap\"\>", "\<\"Call Digital Payoff\"\>", "\<\"Put \
Digital Payoff\"\>"},
    {"38036", "30.416666666666757`", "1000.`", "37671", "38036", 
     "365", "\<\"#N/A\"\>", "\<\"#N/A\"\>", "\<\"#N/A\"\>", "\<\"Actual/360\"\
\>", "1.0138888888888888`", 
     "0.03`", "\<\"#N/A\"\>", "\<\"#N/A\"\>", "\<\"#N/A\"\>", "\<\"#N/A\"\>", \
"\<\"#N/A\"\>", "\<\"#N/A\"\>", "\<\"#N/A\"\>", "\<\"#N/A\"\>"},
    {"38404", "30.49999999999997`", "1000.`", "38036", "38402", 
     "366", "\<\"#N/A\"\>", "\<\"#N/A\"\>", "\<\"#N/A\"\>", "\<\"Actual/360\"\
\>", "1.0166666666666666`", 
     "0.03`", "\<\"#N/A\"\>", "\<\"#N/A\"\>", "\<\"#N/A\"\>", "\<\"#N/A\"\>", \
"\<\"#N/A\"\>", "\<\"#N/A\"\>", "\<\"#N/A\"\>", "\<\"#N/A\"\>"},
    {"38768", "30.416666666666757`", "1000.`", "38402", "38767", 
     "365", "\<\"#N/A\"\>", "\<\"#N/A\"\>", "\<\"#N/A\"\>", "\<\"Actual/360\"\
\>", "1.0138888888888888`", 
     "0.03`", "\<\"#N/A\"\>", "\<\"#N/A\"\>", "\<\"#N/A\"\>", "\<\"#N/A\"\>", \
"\<\"#N/A\"\>", "\<\"#N/A\"\>", "\<\"#N/A\"\>", "\<\"#N/A\"\>"},
    {"39132", "30.416666666666757`", "1000.`", "38767", "39132", 
     "365", "\<\"#N/A\"\>", "\<\"#N/A\"\>", "\<\"#N/A\"\>", "\<\"Actual/360\"\
\>", "1.0138888888888888`", 
     "0.03`", "\<\"#N/A\"\>", "\<\"#N/A\"\>", "\<\"#N/A\"\>", "\<\"#N/A\"\>", \
"\<\"#N/A\"\>", "\<\"#N/A\"\>", "\<\"#N/A\"\>", "\<\"#N/A\"\>"},
    {"39497", "30.416666666666757`", "1000.`", "39132", "39497", 
     "365", "\<\"#N/A\"\>", "\<\"#N/A\"\>", "\<\"#N/A\"\>", "\<\"Actual/360\"\
\>", "1.0138888888888888`", 
     "0.03`", "\<\"#N/A\"\>", "\<\"#N/A\"\>", "\<\"#N/A\"\>", "\<\"#N/A\"\>", \
"\<\"#N/A\"\>", "\<\"#N/A\"\>", "\<\"#N/A\"\>", "\<\"#N/A\"\>"}
   },
   GridBoxAlignment->{
    "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
     "RowsIndexed" -> {}},
   GridBoxSpacings->{"Columns" -> {
       Offset[0.27999999999999997`], {
        Offset[2.0999999999999996`]}, 
       Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
       Offset[0.2], {
        Offset[0.4]}, 
       Offset[0.2]}, "RowsIndexed" -> {}}],
  Function[BoxForm`e$, 
   TableForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{{3.527485024546875*^9, 3.527485032390625*^9}, 
   3.527486318328125*^9, 3.527487680421875*^9, 3.52748799040625*^9, 
   3.5274918126875*^9, 3.52749974734375*^9, {3.527501245875*^9, 
   3.527501259390625*^9}, 3.527501295515625*^9, 3.527501355625*^9, 
   3.527502182609375*^9, 3.527502885984375*^9, 3.527503903546875*^9, 
   3.52758608378125*^9, 3.527590808375*^9, 3.5275947935*^9, 
   3.52759623246875*^9, 3.527596331203125*^9, 3.527596374265625*^9, 
   3.5275965371875*^9, 3.527596722359375*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"accrualDates", " ", "=", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"VanillaSwapFixedLegAnalysis", "[", "swap", "]"}], "[", 
     RowBox[{"[", 
      RowBox[{"All", ",", "4"}], "]"}], "]"}], " ", "//", " ", "Rest"}], " ", 
   "//", " ", "ToCalendar"}]}]], "Input",
 CellChangeTimes->{{3.527485075890625*^9, 3.52748509428125*^9}, {
  3.527485243109375*^9, 3.527485253640625*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"2003", ",", "2", ",", "19"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"2004", ",", "2", ",", "19"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"2005", ",", "2", ",", "19"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"2006", ",", "2", ",", "19"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"2007", ",", "2", ",", "19"}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{{3.527485081234375*^9, 3.5274850951875*^9}, 
   3.52748525434375*^9, 3.527486318578125*^9, 3.5274876805625*^9, 
   3.527487990671875*^9, 3.52749181296875*^9, 3.5274997474375*^9, {
   3.527501246171875*^9, 3.527501259453125*^9}, 3.527501295578125*^9, 
   3.52750135584375*^9, 3.527502184296875*^9, 3.527502886078125*^9, 
   3.52750390359375*^9, 3.527586083859375*^9, 3.5275908085*^9, 
   3.527594793609375*^9, 3.527596233171875*^9, 3.527596331359375*^9, 
   3.527596374359375*^9, 3.527596537484375*^9, 3.5275967224375*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"bermudanSwaption", " ", "=", " ", 
   RowBox[{"Swaption", "[", 
    RowBox[{"atmSwap", ",", 
     RowBox[{"BermudanExercise", "[", "accrualDates", "]"}]}], "]"}]}], 
  ";"}]], "Input",
 CellChangeTimes->{{3.527485322765625*^9, 3.527485352625*^9}, 
   3.527502198609375*^9, 3.527596124421875*^9}],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"InstrumentSetPricingEngine", "[", 
   RowBox[{"bermudanSwaption", ",", 
    RowBox[{"TreeSwaptionEngine", "[", 
     RowBox[{"modelG2", ",", "50"}], "]"}]}], "]"}], " ", ";"}], "\n", 
 RowBox[{"InstrumentNPV", "[", "bermudanSwaption", "]"}]}], "Input",
 CellChangeTimes->{{3.52748773009375*^9, 3.527487780984375*^9}, {
   3.5274879218125*^9, 3.527487928109375*^9}, {3.527491853203125*^9, 
   3.527491855015625*^9}, 3.52749841178125*^9, 3.52750221415625*^9}],

Cell[BoxData["12.019477080468059`"], "Output",
 CellChangeTimes->{
  3.5274919583125*^9, 3.527499747578125*^9, {3.52750124634375*^9, 
   3.527501259640625*^9}, 3.527501295734375*^9, 3.527501356046875*^9, 
   3.527502207984375*^9, 3.527502940015625*^9, 3.52750395778125*^9, 
   3.52758608803125*^9, 3.52759086715625*^9, 3.527594853*^9, 
   3.527596233421875*^9, 3.527596331515625*^9, 3.5275964573125*^9, 
   3.527596538078125*^9, 3.5275967273125*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"InstrumentSetPricingEngine", "[", 
   RowBox[{"bermudanSwaption", ",", 
    RowBox[{"TreeSwaptionEngine", "[", 
     RowBox[{"modelHW", ",", "50"}], "]"}]}], "]"}], " ", ";"}], "\n", 
 RowBox[{"InstrumentNPV", "[", "bermudanSwaption", "]"}]}], "Input",
 CellChangeTimes->{{3.52748773009375*^9, 3.527487780984375*^9}, {
   3.5274879218125*^9, 3.527487928109375*^9}, {3.527491853203125*^9, 
   3.527491855015625*^9}, {3.52749841178125*^9, 3.527498431265625*^9}, 
   3.527502219375*^9}],

Cell[BoxData["13.140936614765776`"], "Output",
 CellChangeTimes->{
  3.527499810359375*^9, {3.527501246421875*^9, 3.52750125971875*^9}, 
   3.527501295828125*^9, 3.527501356125*^9, 3.527502351109375*^9, 
   3.527502940890625*^9, 3.52750395871875*^9, 3.527586088203125*^9, 
   3.527590868765625*^9, 3.527594854*^9, 3.52759623346875*^9, 
   3.527596331578125*^9, 3.527596458796875*^9, 3.5275965383125*^9, 
   3.527596727515625*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"InstrumentSetPricingEngine", "[", 
   RowBox[{"bermudanSwaption", ",", 
    RowBox[{"TreeSwaptionEngine", "[", 
     RowBox[{"modelBK", ",", "50"}], "]"}]}], "]"}], " ", 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"InstrumentNPV", "[", "bermudanSwaption", "]"}]}], "Input",
 CellChangeTimes->{{3.52750237665625*^9, 3.5275023863125*^9}}],

Cell[BoxData["13.014944440658281`"], "Output",
 CellChangeTimes->{3.527502387828125*^9, 3.5275029416875*^9, 
  3.52750395971875*^9, 3.52758608828125*^9, 3.5275908698125*^9, 
  3.527594854890625*^9, 3.52759623353125*^9, 3.52759633165625*^9, 
  3.527596460265625*^9, 3.527596538546875*^9, 3.527596727609375*^9}]
}, Open  ]]
}, Open  ]]
},
WindowSize->{1080, 715},
WindowMargins->{{Automatic, 83}, {Automatic, 4}},
ShowSelection->True,
FrontEndVersion->"8.0 for Microsoft Windows (32-bit) (February 23, 2011)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[579, 22, 106, 1, 83, "Title"],
Cell[CellGroupData[{
Cell[710, 27, 136, 2, 31, "Input"],
Cell[CellGroupData[{
Cell[871, 33, 2050, 49, 62, "Print"],
Cell[2924, 84, 2922, 72, 81, "Print"],
Cell[5849, 158, 989, 13, 138, "Print"],
Cell[6841, 173, 314, 10, 42, "Print"],
Cell[7158, 185, 234, 3, 23, "Print"],
Cell[7395, 190, 444, 9, 23, "Print"]
}, Open  ]]
}, Open  ]],
Cell[7866, 203, 354, 9, 52, "Input"],
Cell[8223, 214, 218, 5, 31, "Input"],
Cell[8444, 221, 130, 1, 29, "Text"],
Cell[CellGroupData[{
Cell[8599, 226, 325, 7, 31, "Input"],
Cell[8927, 235, 2244, 33, 30, "Output"]
}, Open  ]],
Cell[11186, 271, 400, 9, 52, "Input"],
Cell[11589, 282, 243, 6, 31, "Input"],
Cell[CellGroupData[{
Cell[11857, 292, 407, 9, 31, "Input"],
Cell[12267, 303, 2311, 35, 30, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[14615, 343, 393, 9, 31, "Input"],
Cell[15011, 354, 2328, 36, 30, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[17376, 395, 1312, 27, 72, "Input"],
Cell[18691, 424, 2302, 34, 30, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[21030, 463, 433, 9, 52, "Input"],
Cell[21466, 474, 2038, 30, 30, "Output"]
}, Open  ]],
Cell[23519, 507, 1483, 34, 112, "Input"],
Cell[25005, 543, 1526, 35, 114, "Input"],
Cell[CellGroupData[{
Cell[26556, 582, 959, 26, 52, "Input"],
Cell[27518, 610, 1987, 31, 30, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[29542, 646, 449, 11, 52, "Input"],
Cell[29994, 659, 534, 8, 30, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[30565, 672, 233, 5, 31, "Input"],
Cell[30801, 679, 2020, 31, 30, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[32858, 715, 671, 16, 112, "Input"],
Cell[33532, 733, 505, 8, 30, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[34074, 746, 520, 13, 52, "Input"],
Cell[34597, 761, 1269, 21, 30, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[35903, 787, 691, 15, 52, "Input"],
Cell[36597, 804, 1109, 19, 30, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[37743, 828, 792, 17, 52, "Input"],
Cell[38538, 847, 500, 10, 30, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[39075, 862, 468, 12, 52, "Input"],
Cell[39546, 876, 469, 9, 30, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[40052, 890, 433, 10, 52, "Input"],
Cell[40488, 902, 324, 6, 30, "Output"],
Cell[40815, 910, 375, 7, 30, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[41227, 922, 173, 3, 31, "Input"],
Cell[41403, 927, 342, 9, 21, "Message"],
Cell[41748, 938, 302, 4, 30, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[42087, 947, 406, 11, 52, "Input"],
Cell[42496, 960, 385, 8, 30, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[42918, 973, 236, 5, 31, "Input"],
Cell[43157, 980, 1141, 20, 30, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[44335, 1005, 247, 6, 31, "Input"],
Cell[44585, 1013, 1131, 20, 30, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[45753, 1038, 579, 14, 31, "Input"],
Cell[46335, 1054, 1237, 21, 30, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[47609, 1080, 191, 4, 31, "Input"],
Cell[47803, 1086, 3086, 54, 116, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[50926, 1145, 409, 10, 31, "Input"],
Cell[51338, 1157, 959, 20, 30, "Output"]
}, Open  ]],
Cell[52312, 1180, 330, 8, 31, "Input"],
Cell[CellGroupData[{
Cell[52667, 1192, 493, 9, 52, "Input"],
Cell[53163, 1203, 449, 7, 30, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[53649, 1215, 519, 10, 52, "Input"],
Cell[54171, 1227, 429, 7, 30, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[54637, 1239, 371, 8, 52, "Input"],
Cell[55011, 1249, 309, 4, 30, "Output"]
}, Open  ]]
}, Open  ]]
}
]
*)

(* End of internal cache information *)
