(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 8.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       157,          7]
NotebookDataLength[    244512,       4551]
NotebookOptionsPosition[    239954,       4391]
NotebookOutlinePosition[    240630,       4417]
CellTagsIndexPosition[    240500,       4411]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell["Pricing Bermudan Swaption", "Title",
 CellChangeTimes->{{3.526267847265625*^9, 3.5262678714375*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Needs", "[", "\"\<QuantLib`\>\"", "]"}]], "Input",
 CellChangeTimes->{{3.5285238351567497`*^9, 3.5285238452817497`*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   TagBox[
    ButtonBox[
     PaneSelectorBox[{False->"\<\"QuantLib\"\>", True->
      StyleBox["\<\"QuantLib\"\>", "HyperlinkActive"]}, Dynamic[
       CurrentValue["MouseOver"]],
      BaseStyle->{"Hyperlink"},
      BaselinePosition->Baseline,
      FrameMargins->0,
      ImageSize->Automatic],
     BaseStyle->"Hyperlink",
     ButtonData->{
       URL["http://quantlib.org"], None},
     ButtonNote->"http://quantlib.org"],
    Annotation[#, "http://quantlib.org", "Hyperlink"]& ], 
   "\[InvisibleSpace]", "\<\" for Mathematica installed, Version \
0.2.5\\n\"\>", "\[InvisibleSpace]", "\<\"for \"\>", 
   "\[InvisibleSpace]", "\<\"Windows\"\>", 
   "\[InvisibleSpace]", "\<\" system \"\>", 
   "\[InvisibleSpace]", "\<\"Microsoft Windows (32-bit)\"\>", 
   "\[InvisibleSpace]", "\<\"\\n\"\>", 
   "\[InvisibleSpace]", "\<\"Mathematica Interface \[Copyright] by \"\>", 
   "\[InvisibleSpace]", 
   TagBox[
    ButtonBox[
     PaneSelectorBox[{False->"\<\"Weber & Partner\"\>", True->
      StyleBox["\<\"Weber & Partner\"\>", "HyperlinkActive"]}, Dynamic[
       CurrentValue["MouseOver"]],
      BaseStyle->{"Hyperlink"},
      BaselinePosition->Baseline,
      FrameMargins->0,
      ImageSize->Automatic],
     BaseStyle->"Hyperlink",
     ButtonData->{
       URL["http://www.weber-und-partner.com"], None},
     ButtonNote->"http://www.weber-und-partner.com"],
    Annotation[#, "http://www.weber-und-partner.com", "Hyperlink"]& ], 
   "\[InvisibleSpace]", "\<\" 2011\"\>"}],
  SequenceForm[
   Hyperlink["QuantLib", "http://quantlib.org"], 
   " for Mathematica installed, Version 0.2.5\n", "for ", "Windows", 
   " system ", "Microsoft Windows (32-bit)", "\n", 
   "Mathematica Interface \[Copyright] by ", 
   Hyperlink["Weber & Partner", "http://www.weber-und-partner.com"], " 2011"],
  Editable->False]], "Print",
 CellChangeTimes->{3.528697496890625*^9, 3.5286978573125*^9, 
  3.528699156234375*^9, 3.528699950296875*^9, 3.528700281*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Visit \"\>", "\[InvisibleSpace]", 
   TagBox[
    ButtonBox[
     PaneSelectorBox[{
      False->"\<\"http://www.weber-und-partner.com/QuantLib/Mathematica\"\>", 
      True->
      StyleBox["\<\"http://www.weber-und-partner.com/QuantLib/Mathematica\"\>\
", "HyperlinkActive"]}, Dynamic[
       CurrentValue["MouseOver"]],
      BaseStyle->{"Hyperlink"},
      BaselinePosition->Baseline,
      FrameMargins->0,
      ImageSize->Automatic],
     BaseStyle->"Hyperlink",
     ButtonData->{
       URL["http://www.weber-und-partner.com/QuantLib/mma"], None},
     ButtonNote->"http://www.weber-und-partner.com/QuantLib/mma"],
    Annotation[#, "http://www.weber-und-partner.com/QuantLib/mma", 
     "Hyperlink"]& ], 
   "\[InvisibleSpace]", "\<\" for the latest version.\\nVisit \"\>", 
   "\[InvisibleSpace]", 
   TagBox[
    ButtonBox[
     PaneSelectorBox[{False->"\<\"http://quantlib.org/license.shtml\"\>", 
      True->
      StyleBox["\<\"http://quantlib.org/license.shtml\"\>", 
       "HyperlinkActive"]}, Dynamic[
       CurrentValue["MouseOver"]],
      BaseStyle->{"Hyperlink"},
      BaselinePosition->Baseline,
      FrameMargins->0,
      ImageSize->Automatic],
     BaseStyle->"Hyperlink",
     ButtonData->{
       URL["http://quantlib.org/license.shtml"], None},
     ButtonNote->"http://quantlib.org/license.shtml"],
    Annotation[#, "http://quantlib.org/license.shtml", "Hyperlink"]& ], 
   "\[InvisibleSpace]", "\<\" for the QuantLib license.\\nFor questions, \
support issues and enquiries mail to \"\>", "\[InvisibleSpace]", 
   TagBox[
    ButtonBox[
     PaneSelectorBox[{False->"\<\"quantLib@weber-und-partner.com\"\>", True->
      StyleBox["\<\"quantLib@weber-und-partner.com\"\>", "HyperlinkActive"]}, 
      Dynamic[
       CurrentValue["MouseOver"]],
      BaseStyle->{"Hyperlink"},
      BaselinePosition->Baseline,
      FrameMargins->0,
      ImageSize->Automatic],
     BaseStyle->"Hyperlink",
     ButtonData->{
       URL["mailto:quantLib@weber-und-partner.com"], None},
     ButtonNote->"mailto:quantLib@weber-und-partner.com"],
    Annotation[#, "mailto:quantLib@weber-und-partner.com", "Hyperlink"]& ], 
   "\[InvisibleSpace]", "\<\"\\n\"\>"}],
  SequenceForm["Visit ", 
   Hyperlink[
   "http://www.weber-und-partner.com/QuantLib/Mathematica", 
    "http://www.weber-und-partner.com/QuantLib/mma"], 
   " for the latest version.\nVisit ", 
   Hyperlink[
   "http://quantlib.org/license.shtml", "http://quantlib.org/license.shtml"], 
   " for the QuantLib license.\nFor questions, support issues and enquiries \
mail to ", 
   Hyperlink[
   "quantLib@weber-und-partner.com", "mailto:quantLib@weber-und-partner.com"],
    "\n"],
  Editable->False]], "Print",
 CellChangeTimes->{3.528697496890625*^9, 3.5286978573125*^9, 
  3.528699156234375*^9, 3.528699950296875*^9, 3.528700281*^9}],

Cell[BoxData["\<\"THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND \
CONTRIBUTORS 'AS IS' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT \
NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A \
PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDERS OR \
CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, \
EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, \
PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; \
OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, \
WHETHER IN CONTRACT, STRICT LIABILITY OR TORT (INCLUDING NEGLIGENCE OR \
OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF \
ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.\\n\"\>"], "Print",
 CellChangeTimes->{3.528697496890625*^9, 3.5286978573125*^9, 
  3.528699156234375*^9, 3.528699950296875*^9, 3.528700281015625*^9}],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"How", " ", "to", " ", "get", " ", "started"}], "MSG"], " ", 
  ButtonBox[
   StyleBox[">>", "SR"],
   Active->True,
   BaseStyle->"Link",
   ButtonData->"paclet:QuantLib/tutorial/Getting Started"]}]], "Print", \
"PrintUsage",
 CellChangeTimes->{3.528700281015625*^9}],

Cell[BoxData["\<\"Setting default values:\"\>"], "Print",
 CellChangeTimes->{3.528697496890625*^9, 3.5286978573125*^9, 
  3.528699156234375*^9, 3.528699950296875*^9, 3.528700286875*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"  Setting Valuation Date = \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{"2011", ",", "10", ",", "27"}], "}"}]}],
  SequenceForm["  Setting Valuation Date = ", {2011, 10, 27}],
  Editable->False]], "Print",
 CellChangeTimes->{3.528697496890625*^9, 3.5286978573125*^9, 
  3.528699156234375*^9, 3.528699950296875*^9, 3.52870028690625*^9}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Describing the market conditions", "Section",
 CellChangeTimes->{{3.5281012946231794`*^9, 3.528101354889838*^9}}],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"settlementDate", "=", 
  RowBox[{"CalendarAdvance", "[", 
   RowBox[{
    RowBox[{"EvaluationDate", "[", "]"}], ",", 
    RowBox[{"{", 
     RowBox[{"2", ",", "\"\<Day\>\""}], "}"}]}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"yieldcurve", " ", "=", 
   RowBox[{"FlatForward", "[", 
    RowBox[{"settlementDate", ",", "0.05", ",", 
     RowBox[{"DayCounter", "\[Rule]", "\"\<Actual/365 (Fixed)\>\""}]}], 
    "]"}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.52626761275*^9, 3.5262676563125*^9}, {
   3.52697972221875*^9, 3.52697973165625*^9}, {3.5279732550735826`*^9, 
   3.527973260321128*^9}, {3.527973517711237*^9, 3.5279735201447363`*^9}, 
   3.5279745848657293`*^9, {3.5281031863733826`*^9, 3.528103187464952*^9}, {
   3.5281033587212067`*^9, 3.5281033764667234`*^9}, {3.528103409434128*^9, 
   3.5281034168547983`*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"2011", ",", "10", ",", "31"}], "}"}]], "Output",
 CellChangeTimes->{{3.528103261641613*^9, 3.5281032687918944`*^9}, 
   3.528103377918811*^9, 3.5281034179363537`*^9, 3.528112234660821*^9, 
   3.5285240704848747`*^9, 3.5285251018129997`*^9, 3.5285264568598747`*^9, 
   3.5285271517973747`*^9, 3.5285425494848747`*^9, 3.5285427325004997`*^9, 
   3.528696888953125*^9, 3.52869704728125*^9, 3.5286975088125*^9, 
   3.528697867015625*^9, 3.52869927184375*^9, 3.528700310234375*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{" ", 
  RowBox[{
   RowBox[{
    RowBox[{"swapLengths", "=", 
     RowBox[{"{", 
      RowBox[{"1", ",", "2", ",", "3", ",", "4", ",", "5"}], "}"}]}], ";"}], 
   "\n", 
   RowBox[{
    RowBox[{"swaptionVols", " ", "=", 
     TagBox[
      RowBox[{"(", "\[NoBreak]", GridBox[{
         {"0.1490", "0.1340", "0.1228", "0.1189", "0.1148"},
         {"0.1290", "0.1201", "0.1146", "0.1108", "0.1040"},
         {"0.1149", "0.1112", "0.1070", "0.1010", "0.0957"},
         {"0.1047", "0.1021", "0.0980", "0.0951", "0.1270"},
         {"0.1000", "0.0950", "0.0999", "0.1230", "0.1160"}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.7]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
      Function[BoxForm`e$, 
       MatrixForm[BoxForm`e$]]]}], ";"}]}]}]], "Input",
 CellChangeTimes->{{3.526708470015625*^9, 3.526708492296875*^9}, {
   3.52671651425*^9, 3.526716523984375*^9}, {3.526716845375*^9, 
   3.52671684653125*^9}, 3.527499650171875*^9, {3.527500203921875*^9, 
   3.5275002465625*^9}, {3.5275015188125*^9, 3.527501522421875*^9}, {
   3.52750309115625*^9, 3.527503115515625*^9}, {3.527503145921875*^9, 
   3.5275032858125*^9}, {3.5281018035349584`*^9, 3.5281018561406016`*^9}, {
   3.5281018873855295`*^9, 3.528101956875451*^9}, {3.5281020065268464`*^9, 
   3.5281020331451216`*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ListPointPlot3D", "[", 
  RowBox[{"swaptionVols", ",", 
   RowBox[{"ColorFunction", "\[Rule]", "\"\<Rainbow\>\""}], ",", 
   RowBox[{"PlotStyle", "\[Rule]", 
    RowBox[{"PointSize", "[", "Large", "]"}]}], ",", 
   RowBox[{"Filling", "\[Rule]", "Bottom"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.528071009778768*^9, 3.5280710250407133`*^9}, {
  3.528102174758752*^9, 3.5281021760906672`*^9}, {3.5281022360568943`*^9, 
  3.528102243127061*^9}, {3.5281023581023874`*^9, 3.5281023834488335`*^9}, {
  3.528102454130469*^9, 3.528102493967752*^9}, {3.528102532352947*^9, 
  3.5281025429782257`*^9}, {3.528102573702405*^9, 3.5281025782088847`*^9}}],

Cell[BoxData[
 Graphics3DBox[{
   {Hue[0.67, 0.6, 0.6], PointSize[Large], 
    {RGBColor[0.857359, 0.131106, 0.132128], Point3DBox[{1., 1., 0.149}]}, 
    {RGBColor[0.7116684444444447, 0.7410033703703703, 0.2963271481481481], 
     Point3DBox[{1., 2., 0.129}]}, 
    {RGBColor[0.35482182222222236`, 0.6484806592592594, 0.6554374518518518], 
     Point3DBox[{1., 3., 0.1149}]}, 
    {RGBColor[0.24491715555555554`, 0.3441342074074075, 0.8101740444444445], 
     Point3DBox[{1., 4., 0.1047}]}, 
    {RGBColor[0.2820112592592592, 0.16948659259259277`, 0.7148719259259261], 
     Point3DBox[{1., 5., 0.1}]}, 
    {RGBColor[0.832861777777778, 0.693165222222222, 0.24734844444444432`], 
     Point3DBox[{2., 1., 0.134}]}, 
    {RGBColor[0.4663673703703704, 0.7141170666666666, 0.49677506666666665`], 
     Point3DBox[{2., 2., 0.1201}]}, 
    {RGBColor[0.29795959999999994`, 0.5657927999999999, 0.7522386000000001], 
     Point3DBox[{2., 3., 0.1112}]}, 
    {RGBColor[0.25003857777777777`, 0.23947477037037024`, 0.7740190222222222],
      Point3DBox[{2., 4., 0.1021}]}, 
    {RGBColor[0.471412, 0.108766, 0.527016], Point3DBox[{2., 5., 0.095}]}, 
    {RGBColor[0.5357539481481486, 0.7331906370370371, 0.4212226814814812], 
     Point3DBox[{3., 1., 0.1228}]}, 
    {RGBColor[0.3499719555555555, 0.6422420814814813, 0.6637906962962965], 
     Point3DBox[{3., 2., 0.1146}]}, 
    {RGBColor[0.2563255555555556, 0.43092088888888885`, 0.8085534444444444], 
     Point3DBox[{3., 3., 0.107}]}, 
    {RGBColor[0.3288768888888887, 0.11660066666666667`, 0.6491964444444446], 
     Point3DBox[{3., 4., 0.098}]}, 
    {RGBColor[0.28379887407407406`, 0.1662923407407408, 0.7117702074074075], 
     Point3DBox[{3., 5., 0.0999}]}, 
    {RGBColor[0.436651814814815, 0.7041362666666667, 0.5322022666666665], 
     Point3DBox[{4., 1., 0.1189}]}, 
    {RGBColor[0.2932429185185185, 0.5540700148148148, 0.7596890296296297], 
     Point3DBox[{4., 2., 0.1108}]}, 
    {RGBColor[0.264135111111111, 0.2014291111111113, 0.7458891111111112], 
     Point3DBox[{4., 3., 0.101}]}, 
    {RGBColor[0.4666608296296295, 0.10902715555555556`, 0.5310886814814816], 
     Point3DBox[{4., 4., 0.0951}]}, 
    {RGBColor[0.5413381851851853, 0.7340082962962963, 0.41635785185185176`], 
     Point3DBox[{4., 5., 0.123}]}, 
    {RGBColor[0.35320520000000005`, 0.6464011333333334, 0.6582218666666667], 
     Point3DBox[{5., 1., 0.1148}]}, 
    {RGBColor[0.24629600000000001`, 0.31595666666666655`, 0.8004399999999999],
      Point3DBox[{5., 2., 0.104}]}, 
    {RGBColor[0.4381538074074078, 0.11059408888888887`, 0.5555247703703701], 
     Point3DBox[{5., 3., 0.0957}]}, 
    {RGBColor[0.6545410370370374, 0.7431753703703704, 0.32997788888888874`], 
     Point3DBox[{5., 4., 0.127}]}, 
    {RGBColor[0.375893777777778, 0.6660012222222224, 0.622276222222222], 
     Point3DBox[{5., 5., 0.116}]}}, {
    {RGBColor[0.6236, 0.62, 0.8]}, 
    {RGBColor[0.6236, 0.62, 0.8], 
     {RGBColor[0.857359, 0.131106, 0.132128], 
      Line3DBox[{{1., 1., 0.149}, {1., 1., 0.095}}]}, 
     {RGBColor[0.7116684444444447, 0.7410033703703703, 0.2963271481481481], 
      Line3DBox[{{1., 2., 0.129}, {1., 2., 0.095}}]}, 
     {RGBColor[0.35482182222222236`, 0.6484806592592594, 0.6554374518518518], 
      Line3DBox[{{1., 3., 0.1149}, {1., 3., 0.095}}]}, 
     {RGBColor[0.24491715555555554`, 0.3441342074074075, 0.8101740444444445], 
      Line3DBox[{{1., 4., 0.1047}, {1., 4., 0.095}}]}, 
     {RGBColor[0.2820112592592592, 0.16948659259259277`, 0.7148719259259261], 
      Line3DBox[{{1., 5., 0.1}, {1., 5., 0.095}}]}, 
     {RGBColor[0.832861777777778, 0.693165222222222, 0.24734844444444432`], 
      Line3DBox[{{2., 1., 0.134}, {2., 1., 0.095}}]}, 
     {RGBColor[0.4663673703703704, 0.7141170666666666, 0.49677506666666665`], 
      Line3DBox[{{2., 2., 0.1201}, {2., 2., 0.095}}]}, 
     {RGBColor[0.29795959999999994`, 0.5657927999999999, 0.7522386000000001], 
      Line3DBox[{{2., 3., 0.1112}, {2., 3., 0.095}}]}, 
     {RGBColor[
      0.25003857777777777`, 0.23947477037037024`, 0.7740190222222222], 
      Line3DBox[{{2., 4., 0.1021}, {2., 4., 0.095}}]}, 
     {RGBColor[0.471412, 0.108766, 0.527016], 
      Line3DBox[{{2., 5., 0.095}, {2., 5., 0.095}}]}, 
     {RGBColor[0.5357539481481486, 0.7331906370370371, 0.4212226814814812], 
      Line3DBox[{{3., 1., 0.1228}, {3., 1., 0.095}}]}, 
     {RGBColor[0.3499719555555555, 0.6422420814814813, 0.6637906962962965], 
      Line3DBox[{{3., 2., 0.1146}, {3., 2., 0.095}}]}, 
     {RGBColor[0.2563255555555556, 0.43092088888888885`, 0.8085534444444444], 
      Line3DBox[{{3., 3., 0.107}, {3., 3., 0.095}}]}, 
     {RGBColor[0.3288768888888887, 0.11660066666666667`, 0.6491964444444446], 
      Line3DBox[{{3., 4., 0.098}, {3., 4., 0.095}}]}, 
     {RGBColor[0.28379887407407406`, 0.1662923407407408, 0.7117702074074075], 
      Line3DBox[{{3., 5., 0.0999}, {3., 5., 0.095}}]}, 
     {RGBColor[0.436651814814815, 0.7041362666666667, 0.5322022666666665], 
      Line3DBox[{{4., 1., 0.1189}, {4., 1., 0.095}}]}, 
     {RGBColor[0.2932429185185185, 0.5540700148148148, 0.7596890296296297], 
      Line3DBox[{{4., 2., 0.1108}, {4., 2., 0.095}}]}, 
     {RGBColor[0.264135111111111, 0.2014291111111113, 0.7458891111111112], 
      Line3DBox[{{4., 3., 0.101}, {4., 3., 0.095}}]}, 
     {RGBColor[0.4666608296296295, 0.10902715555555556`, 0.5310886814814816], 
      Line3DBox[{{4., 4., 0.0951}, {4., 4., 0.095}}]}, 
     {RGBColor[0.5413381851851853, 0.7340082962962963, 0.41635785185185176`], 
      Line3DBox[{{4., 5., 0.123}, {4., 5., 0.095}}]}, 
     {RGBColor[0.35320520000000005`, 0.6464011333333334, 0.6582218666666667], 
      Line3DBox[{{5., 1., 0.1148}, {5., 1., 0.095}}]}, 
     {RGBColor[
      0.24629600000000001`, 0.31595666666666655`, 0.8004399999999999], 
      Line3DBox[{{5., 2., 0.104}, {5., 2., 0.095}}]}, 
     {RGBColor[0.4381538074074078, 0.11059408888888887`, 0.5555247703703701], 
      Line3DBox[{{5., 3., 0.0957}, {5., 3., 0.095}}]}, 
     {RGBColor[0.6545410370370374, 0.7431753703703704, 0.32997788888888874`], 
      Line3DBox[{{5., 4., 0.127}, {5., 4., 0.095}}]}, 
     {RGBColor[0.375893777777778, 0.6660012222222224, 0.622276222222222], 
      Line3DBox[{{5., 5., 0.116}, {5., 5., 0.095}}]}}}},
  AutomaticImageSize->True,
  Axes->True,
  BoxRatios->{1, 1, 0.4},
  ImageSize->{371.4928250444737, 208.00791190419662`},
  PlotRange->{{1., 5.}, {1., 5.}, Automatic},
  PlotRangePadding->{{
     Scaled[0.02], 
     Scaled[0.02]}, {
     Scaled[0.02], 
     Scaled[0.02]}, {Automatic, Automatic}},
  ViewPoint->{2.4252951650451693`, -2.1120110623833432`, 1.0523082413337388`},
  ViewVertical->{0.30580317975129717`, -0.12556321007446497`, 
   2.3594468307341017`}]], "Output",
 CellChangeTimes->{
  3.528071025982067*^9, 3.528072053609723*^9, 3.528074058672862*^9, 
   3.528074188599688*^9, 3.528074407584573*^9, 3.5280749339814944`*^9, 
   3.528101499868307*^9, 3.528102177001978*^9, 3.5281022438581123`*^9, 
   3.528102365933648*^9, {3.528102462832982*^9, 3.5281024946687603`*^9}, 
   3.528102543719291*^9, 3.528102579140224*^9, 3.5281028763676157`*^9, 
   3.528103269653133*^9, 3.528112235702318*^9, 3.5285240711879997`*^9, 
   3.5285251034848747`*^9, 3.5285264578442497`*^9, 3.5285271522661247`*^9, 
   3.5285425511723747`*^9, 3.5285427331567497`*^9, 3.528696893203125*^9, 
   3.528697512375*^9, 3.528697869828125*^9, 3.5286992749375*^9, 
   3.528700313359375*^9}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Constructing the swaptions for the calibration", "Section",
 CellChangeTimes->{{3.5281012946231794`*^9, 3.5281013164645853`*^9}, {
  3.52810271582677*^9, 3.5281027166179075`*^9}, {3.5285430531567497`*^9, 
  3.5285430560161247`*^9}}],

Cell["\<\
With the buildin QuantLib calibration functionality it is possible to \
calibrate in respect to different error types. The list of possible settings \
can be retrieved with\
\>", "Text",
 CellChangeTimes->{{3.528697723171875*^9, 3.528697790375*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"GetEnumerationType", "[", 
  "\"\<CalibrationHelper::CalibrationErrorType\>\"", "]"}]], "Input",
 CellChangeTimes->{{3.528697196203125*^9, 3.52869720784375*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"\<\"ImpliedVolError\"\>", ",", "\<\"PriceError\"\>", 
   ",", "\<\"RelativePriceError\"\>"}], "}"}]], "Output",
 CellChangeTimes->{3.528697209*^9, 3.528697522328125*^9, 3.52869787246875*^9, 
  3.528699278921875*^9, 3.52870031603125*^9}]
}, Open  ]],

Cell["\<\
The default error type is provided with the option setting for a swaption or \
cap helper.\
\>", "Text",
 CellChangeTimes->{{3.52869779903125*^9, 3.52869782353125*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Options", "[", "SwaptionHelper", "]"}]], "Input",
 CellChangeTimes->{{3.528697825328125*^9, 3.528697835609375*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"FixedLegTenor", "\[Rule]", "Automatic"}], ",", 
   RowBox[{"FixedLegDayCounter", "\[Rule]", "Automatic"}], ",", 
   RowBox[{"FloatingLegDayCounter", "\[Rule]", "Automatic"}], ",", 
   RowBox[{"ErrorType", "\[Rule]", "\<\"RelativePriceError\"\>"}], ",", 
   RowBox[{"Permanent", "\[Rule]", "True"}], ",", 
   RowBox[{"Overwrite", "\[Rule]", "True"}]}], "}"}]], "Output",
 CellChangeTimes->{3.5286978381875*^9, 3.528697874265625*^9, 
  3.528699304984375*^9, 3.5287003210625*^9}]
}, Open  ]],

Cell[BoxData[{
 RowBox[{
  RowBox[{"indexSixMonths", " ", "=", " ", 
   RowBox[{"Euribor", "[", 
    RowBox[{"\"\<6M\>\"", ",", 
     RowBox[{"YieldCurve", "\[Rule]", "yieldcurve"}]}], "]"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"swaptions", "=", " ", 
    RowBox[{"Table", "[", 
     RowBox[{
      RowBox[{"SwaptionHelper", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"swapLengths", "[", 
           RowBox[{"[", "i", "]"}], "]"}], ",", "\"\<Year\>\""}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"swapLengths", "[", 
           RowBox[{"[", 
            RowBox[{"-", "i"}], "]"}], "]"}], ",", "\"\<Year\>\""}], "}"}], 
        ",", 
        RowBox[{"swaptionVols", "[", 
         RowBox[{"[", 
          RowBox[{"i", ",", 
           RowBox[{"-", "i"}]}], "]"}], "]"}], ",", "indexSixMonths", ",", 
        "yieldcurve"}], "]"}], ",", 
      RowBox[{"{", 
       RowBox[{"i", ",", 
        RowBox[{"Length", "[", "swapLengths", "]"}]}], "}"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"{", 
       RowBox[{"j", ",", 
        RowBox[{"Length", "[", "swapLengths", "]"}], ",", "1", ",", 
        RowBox[{"-", "1"}]}], "}"}]}], "]"}]}], " ", ";"}], " "}]}], "Input",
 CellChangeTimes->{{3.528102747081712*^9, 3.528102755613981*^9}, 
   3.5281028920902243`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Defining Short Rate Models", "Section",
 CellChangeTimes->{{3.5280169128740063`*^9, 3.5280169217167215`*^9}}],

Cell[CellGroupData[{

Cell["One Factor Hull/White Model", "Subsection",
 CellChangeTimes->{{3.528076306805518*^9, 3.5280763164694147`*^9}}],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"modelHW", " ", "=", 
   RowBox[{"HullWhite", "[", "yieldcurve", "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Map", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"CalibrationHelperSetPricingEngine", "[", 
      RowBox[{"#", ",", 
       RowBox[{"JamshidianSwaptionEngine", "[", "modelHW", "]"}]}], "]"}], 
     "&"}], ",", "swaptions", ",", 
    RowBox[{"{", "2", "}"}]}], "]"}], ";"}], "\n", 
 RowBox[{"CalibrateModel", "[", 
  RowBox[{"modelHW", ",", 
   RowBox[{"swaptions", " ", "//", " ", "Flatten"}]}], "]"}]}], "Input",
 CellChangeTimes->{{3.5268103427804537`*^9, 3.5268103634210787`*^9}, {
   3.5268105273273287`*^9, 3.5268105908742037`*^9}, {3.5268122518429537`*^9, 
   3.5268122576242037`*^9}, {3.52681598578125*^9, 3.526816008734375*^9}, {
   3.527500350640625*^9, 3.527500366953125*^9}, {3.52750045921875*^9, 
   3.52750045965625*^9}, {3.528072710994997*^9, 3.5280727278792753`*^9}, {
   3.528073035211197*^9, 3.528073037023803*^9}, 3.52807632121624*^9, {
   3.5285431378598747`*^9, 3.5285431383442497`*^9}, 3.528697577015625*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0.04655397716901905`", ",", "0.006150054193014876`"}], 
  "}"}]], "Output",
 CellChangeTimes->{
  3.526816011171875*^9, 3.52688415196875*^9, 3.526884503296875*^9, 
   3.52689754128125*^9, 3.526897658734375*^9, 3.526898043671875*^9, 
   3.5268992746875*^9, 3.526899370359375*^9, 3.526901710234375*^9, 
   3.52697370690625*^9, 3.52697443903125*^9, 3.526984477609375*^9, 
   3.526986240515625*^9, 3.52730707465625*^9, 3.527334453953125*^9, 
   3.52733490840625*^9, 3.5273358851875*^9, 3.527336220890625*^9, 
   3.52739299228125*^9, 3.527478203796875*^9, 3.527483869390625*^9, 
   3.52748488653125*^9, 3.5274863085*^9, 3.52748767025*^9, 
   3.52748798040625*^9, 3.52749179575*^9, 3.52749974575*^9, 
   3.527500353578125*^9, {3.52750124375*^9, 3.5275012576875*^9}, 
   3.527501293859375*^9, 3.5275013536875*^9, 3.527501556*^9, 
   3.5275025461875*^9, 3.52750358596875*^9, 3.52758607503125*^9, 
   3.527590442125*^9, 3.527590890265625*^9, 3.52759446334375*^9, 
   3.5275962316875*^9, 3.527596330296875*^9, 3.527596369640625*^9, 
   3.527596535515625*^9, 3.52759671290625*^9, 3.527974262251834*^9, 
   3.5279745064730062`*^9, 3.528016824767315*^9, 3.5280169558858547`*^9, 
   3.528069835159749*^9, 3.5280700756054926`*^9, 3.5280704858253603`*^9, 
   3.528070897967992*^9, 3.528072064925995*^9, {3.528072718605941*^9, 
   3.528072729000888*^9}, 3.528073449867443*^9, 3.5280740593338127`*^9, 
   3.5280741898114305`*^9, 3.5280744081553936`*^9, 3.528074934622416*^9, 
   3.528075120860213*^9, 3.528075614900608*^9, 3.528101503323275*^9, 
   3.5281028786308703`*^9, 3.528103272757597*^9, 3.5281033041527405`*^9, 
   3.528103429292683*^9, 3.5281122376951838`*^9, 3.5285240771098747`*^9, 
   3.5285251098286247`*^9, 3.5285264640942497`*^9, 3.5285271569223747`*^9, 
   3.5285278610004997`*^9, 3.5285425526567497`*^9, 3.5285427336098747`*^9, 
   3.5285431399379997`*^9, {3.528697569625*^9, 3.52869757778125*^9}, 
   3.528700340984375*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"error", " ", "=", " ", 
   RowBox[{
    RowBox[{
     RowBox[{"Map", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"CalibrationHelperImpliedVolatility", "[", 
         RowBox[{"#", ",", 
          RowBox[{"CalibrationHelperModelValue", "[", "#", "]"}]}], "]"}], 
        "&"}], ",", "swaptions", ",", 
       RowBox[{"{", "2", "}"}]}], "]"}], "-", "swaptionVols"}], " ", "//", 
    " ", "Abs"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"Total", "[", 
  RowBox[{"error", "//", " ", "Flatten"}], "]"}]}], "Input",
 CellChangeTimes->{{3.5280730686793213`*^9, 3.528073070121395*^9}, {
  3.5280758998703747`*^9, 3.528075939617528*^9}}],

Cell[BoxData["0.2805292466727717`"], "Output",
 CellChangeTimes->{
  3.528072752795102*^9, 3.528073077752368*^9, 3.52807345149979*^9, 
   3.528074059664288*^9, 3.5280741901519203`*^9, 3.528074408545955*^9, 
   3.5280749348227043`*^9, 3.52807512265279*^9, 3.5280756163727245`*^9, {
   3.5280759096544433`*^9, 3.5280759434630575`*^9}, 3.528101503813981*^9, 
   3.528102878891245*^9, 3.528103272887784*^9, 3.5281034307247424`*^9, 
   3.5281122379555583`*^9, 3.5285240784067497`*^9, 3.5285251112661247`*^9, 
   3.5285264652817497`*^9, 3.5285271584536247`*^9, 3.5285425530786247`*^9, 
   3.5285427337192497`*^9, 3.528700346703125*^9}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["One Factor Black/Karasinski Model", "Subsection",
 CellChangeTimes->{{3.528076306805518*^9, 3.5280763164694147`*^9}, 
   3.5280763755143166`*^9}],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"modelBK", " ", "=", " ", 
   RowBox[{"BlackKarasinski", "[", "yieldcurve", "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"times", " ", "=", " ", 
   RowBox[{
    RowBox[{"Map", "[", 
     RowBox[{"CalibrationHelperTimes", ",", "swaptions", ",", 
      RowBox[{"{", "2", "}"}]}], "]"}], " ", "//", " ", "Flatten"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"timeGrid", "=", 
   RowBox[{"TimeGrid", "[", 
    RowBox[{"times", ",", "30"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Map", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"CalibrationHelperSetPricingEngine", "[", 
      RowBox[{"#", ",", 
       RowBox[{"TreeSwaptionEngine", "[", 
        RowBox[{"modelBK", ",", "timeGrid"}], "]"}]}], "]"}], "&"}], ",", 
    "swaptions", ",", 
    RowBox[{"{", "2", "}"}]}], "]"}], ";"}], "\n", 
 RowBox[{"CalibrateModel", "[", 
  RowBox[{"modelBK", ",", 
   RowBox[{"swaptions", " ", "//", " ", "Flatten"}]}], 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"Map", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"CalibrationHelperImpliedVolatility", "[", 
         RowBox[{"#", ",", 
          RowBox[{"CalibrationHelperModelValue", "[", "#", "]"}]}], "]"}], 
        "&"}], ",", "swaptions", ",", 
       RowBox[{"{", "2", "}"}]}], "]"}], "-", "swaptionVols"}], " ", "//", 
    " ", "Abs"}], " ", "//", " ", "Flatten"}], " ", "//", " ", 
  "Total"}]}], "Input",
 CellChangeTimes->{{3.52750160028125*^9, 3.527501621890625*^9}, {
  3.527974282981642*^9, 3.5279742848443203`*^9}, {3.5280728961211953`*^9, 
  3.5280729400042963`*^9}, {3.5280731051417522`*^9, 3.5280731108299313`*^9}, {
  3.5280733532384977`*^9, 3.528073362031141*^9}, {3.52807340251936*^9, 
  3.5280734142762656`*^9}, {3.5280759631914253`*^9, 3.5280760193922386`*^9}, {
  3.5285431519379997`*^9, 3.5285431525317497`*^9}, {3.528700372734375*^9, 
  3.528700401140625*^9}}],

Cell[BoxData[
 RowBox[{"CalibrateModel", "[", 
  RowBox[{"BlackKarasinski81", ",", 
   RowBox[{"{", 
    RowBox[{
    "SwaptionHelper5", ",", "SwaptionHelper7", ",", "SwaptionHelper9", ",", 
     "SwaptionHelper11", ",", "SwaptionHelper13", ",", "SwaptionHelper15", 
     ",", "SwaptionHelper17", ",", "SwaptionHelper19", ",", 
     "SwaptionHelper21", ",", "SwaptionHelper23", ",", "SwaptionHelper25", 
     ",", "SwaptionHelper27", ",", "SwaptionHelper29", ",", 
     "SwaptionHelper31", ",", "SwaptionHelper33", ",", "SwaptionHelper35", 
     ",", "SwaptionHelper37", ",", "SwaptionHelper39", ",", 
     "SwaptionHelper41", ",", "SwaptionHelper43", ",", "SwaptionHelper45", 
     ",", "SwaptionHelper47", ",", "SwaptionHelper49", ",", 
     "SwaptionHelper51", ",", "SwaptionHelper53"}], "}"}], ",", "lm"}], 
  "]"}]], "Output",
 CellChangeTimes->{{3.527501244234375*^9, 3.527501258234375*^9}, 
   3.527501294359375*^9, 3.5275013541875*^9, 3.5275019069375*^9, 
   3.52750286525*^9, 3.527503897390625*^9, 3.52758608328125*^9, 
   3.52759079971875*^9, 3.5275947876875*^9, 3.5275962318125*^9, 
   3.5275963304375*^9, 3.527596372890625*^9, 3.5275965356875*^9, 
   3.527596720921875*^9, 3.5279742871676607`*^9, 3.5279745135131297`*^9, 
   3.5280168253281217`*^9, 3.528016961914523*^9, 3.528069841128331*^9, 
   3.5280700821849537`*^9, 3.528070491763899*^9, 3.5280709024244003`*^9, 
   3.528072065727147*^9, {3.5280729026405697`*^9, 3.528072913215776*^9}, 
   3.5280729800118237`*^9, 3.528073132000373*^9, 3.528073383221611*^9, 
   3.5280734349259586`*^9, 3.5280734776273603`*^9, 3.5280740807546144`*^9, 
   3.5280742135756016`*^9, 3.528074428374467*^9, 3.5280749575453777`*^9, {
   3.5280760127026196`*^9, 3.528076039831629*^9}, 3.528101524473688*^9, 
   3.528102896216157*^9, 3.5281032901325808`*^9, 3.52810345004252*^9, 
   3.5281122577339983`*^9, 3.5285244268598747`*^9, 3.5285255266723747`*^9, 
   3.5285267889223747`*^9, 3.5285274778286247`*^9, 3.5285425535629997`*^9, 
   3.5285427341723747`*^9, 3.5285431635629997`*^9, 3.5287003646875*^9}],

Cell[BoxData["0.925926799201468`"], "Output",
 CellChangeTimes->{{3.527501244234375*^9, 3.527501258234375*^9}, 
   3.527501294359375*^9, 3.5275013541875*^9, 3.5275019069375*^9, 
   3.52750286525*^9, 3.527503897390625*^9, 3.52758608328125*^9, 
   3.52759079971875*^9, 3.5275947876875*^9, 3.5275962318125*^9, 
   3.5275963304375*^9, 3.527596372890625*^9, 3.5275965356875*^9, 
   3.527596720921875*^9, 3.5279742871676607`*^9, 3.5279745135131297`*^9, 
   3.5280168253281217`*^9, 3.528016961914523*^9, 3.528069841128331*^9, 
   3.5280700821849537`*^9, 3.528070491763899*^9, 3.5280709024244003`*^9, 
   3.528072065727147*^9, {3.5280729026405697`*^9, 3.528072913215776*^9}, 
   3.5280729800118237`*^9, 3.528073132000373*^9, 3.528073383221611*^9, 
   3.5280734349259586`*^9, 3.5280734776273603`*^9, 3.5280740807546144`*^9, 
   3.5280742135756016`*^9, 3.528074428374467*^9, 3.5280749575453777`*^9, {
   3.5280760127026196`*^9, 3.528076039831629*^9}, 3.528101524473688*^9, 
   3.528102896216157*^9, 3.5281032901325808`*^9, 3.52810345004252*^9, 
   3.5281122577339983`*^9, 3.5285244268598747`*^9, 3.5285255266723747`*^9, 
   3.5285267889223747`*^9, 3.5285274778286247`*^9, 3.5285425535629997`*^9, 
   3.5285427341723747`*^9, 3.5285431635629997`*^9, 3.52870037784375*^9}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Gaussian two-factor Model", "Subsection",
 CellChangeTimes->{{3.528076306805518*^9, 3.5280763164694147`*^9}, {
  3.5280763755143166`*^9, 3.5280764022127075`*^9}}],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"modelG2", " ", "=", " ", 
    RowBox[{"G2", "[", "yieldcurve", "]"}]}], ";"}], 
  " "}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Map", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"CalibrationHelperSetPricingEngine", "[", 
      RowBox[{"#", ",", 
       RowBox[{"G2SwaptionEngine", "[", 
        RowBox[{"modelG2", ",", "6", ",", "20"}], "]"}]}], "]"}], "&"}], ",", 
    "swaptions", ",", 
    RowBox[{"{", "2", "}"}]}], "]"}], ";"}], "\n", 
 RowBox[{"CalibrateModel", "[", 
  RowBox[{"modelG2", ",", 
   RowBox[{"swaptions", " ", "//", " ", "Flatten"}]}], 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"Map", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"CalibrationHelperImpliedVolatility", "[", 
         RowBox[{"#", ",", 
          RowBox[{"CalibrationHelperModelValue", "[", "#", "]"}]}], "]"}], 
        "&"}], ",", "swaptions", ",", 
       RowBox[{"{", "2", "}"}]}], "]"}], "-", "swaptionVols"}], " ", "//", 
    " ", "Abs"}], " ", "//", " ", "Flatten"}], " ", "//", " ", 
  "Total"}]}], "Input",
 CellChangeTimes->{{3.52750038953125*^9, 3.527500394359375*^9}, {
   3.527500451265625*^9, 3.527500452296875*^9}, {3.528071256203109*^9, 
   3.52807126128041*^9}, {3.528071370267125*^9, 3.5280713862400928`*^9}, {
   3.5280716986593294`*^9, 3.5280717013532033`*^9}, {3.528073183324173*^9, 
   3.528073185056664*^9}, {3.52807351026429*^9, 3.5280735891176753`*^9}, 
   3.528076072658832*^9, {3.5285431616567497`*^9, 3.5285431620942497`*^9}, {
   3.528700418046875*^9, 3.528700424*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "0.05146407754692309`", ",", "0.020563868715301706`", ",", 
   "0.051461227388040126`", ",", "0.02089411181717132`", ",", 
   RowBox[{"-", "0.9481340711839642`"}]}], "}"}]], "Output",
 CellChangeTimes->{
  3.526884521015625*^9, 3.526897541921875*^9, 3.526897659390625*^9, 
   3.526898044140625*^9, 3.526899280265625*^9, 3.526899376015625*^9, 
   3.526901715859375*^9, 3.526973715703125*^9, 3.526974447171875*^9, 
   3.5269844820625*^9, 3.526986244328125*^9, 3.527307078515625*^9, 
   3.527334457859375*^9, 3.52733491228125*^9, 3.527335890109375*^9, 
   3.5273362249375*^9, 3.52739299659375*^9, 3.5274782108125*^9, 
   3.52748387490625*^9, 3.527484890640625*^9, 3.527486312484375*^9, 
   3.52748767434375*^9, 3.527487984578125*^9, 3.52749180328125*^9, 
   3.527499745796875*^9, 3.527500411640625*^9, {3.527501243453125*^9, 
   3.527501257625*^9}, 3.527501293796875*^9, 3.527501353140625*^9, 
   3.527501552796875*^9, 3.52750244521875*^9, 3.527502545171875*^9, 
   3.527503314*^9, 3.527503488015625*^9, 3.527503584984375*^9, 
   3.52758607484375*^9, 3.527590441140625*^9, 3.527590889171875*^9, 
   3.527594462375*^9, 3.527596231609375*^9, 3.52759633021875*^9, 
   3.527596369328125*^9, 3.5275965346875*^9, 3.527596712671875*^9, {
   3.527974249613661*^9, 3.5279742607396593`*^9}, 3.527974503779133*^9, 
   3.5280168244969263`*^9, 3.528016955545365*^9, 3.528069834759173*^9, 
   3.528070075265003*^9, 3.5280704855449567`*^9, 3.5280708976875887`*^9, {
   3.5280711881452465`*^9, 3.52807119860028*^9}, 3.5280712669585743`*^9, 
   3.5280716708293123`*^9, 3.5280717029855504`*^9, 3.5280720592077727`*^9, 
   3.5280722746776032`*^9, 3.5280728492437887`*^9, 3.5280734943413935`*^9, {
   3.5280735363818445`*^9, 3.528073595276531*^9}, 3.5280740863426495`*^9, 
   3.5280742190334496`*^9, 3.52807443425292*^9, 3.528074964365184*^9, 
   3.528076079298379*^9, 3.528101530362155*^9, 3.528102903977317*^9, 
   3.5281032978036113`*^9, 3.528103463331629*^9, 3.528112268269147*^9, 
   3.5285244524536247`*^9, 3.5285255740317497`*^9, 3.5285268180786247`*^9, 
   3.5285275014067497`*^9, 3.5285425538598747`*^9, 3.5285427345317497`*^9, 
   3.5285431672504997`*^9}],

Cell[BoxData["0.3266997620074309`"], "Output",
 CellChangeTimes->{
  3.526884521015625*^9, 3.526897541921875*^9, 3.526897659390625*^9, 
   3.526898044140625*^9, 3.526899280265625*^9, 3.526899376015625*^9, 
   3.526901715859375*^9, 3.526973715703125*^9, 3.526974447171875*^9, 
   3.5269844820625*^9, 3.526986244328125*^9, 3.527307078515625*^9, 
   3.527334457859375*^9, 3.52733491228125*^9, 3.527335890109375*^9, 
   3.5273362249375*^9, 3.52739299659375*^9, 3.5274782108125*^9, 
   3.52748387490625*^9, 3.527484890640625*^9, 3.527486312484375*^9, 
   3.52748767434375*^9, 3.527487984578125*^9, 3.52749180328125*^9, 
   3.527499745796875*^9, 3.527500411640625*^9, {3.527501243453125*^9, 
   3.527501257625*^9}, 3.527501293796875*^9, 3.527501353140625*^9, 
   3.527501552796875*^9, 3.52750244521875*^9, 3.527502545171875*^9, 
   3.527503314*^9, 3.527503488015625*^9, 3.527503584984375*^9, 
   3.52758607484375*^9, 3.527590441140625*^9, 3.527590889171875*^9, 
   3.527594462375*^9, 3.527596231609375*^9, 3.52759633021875*^9, 
   3.527596369328125*^9, 3.5275965346875*^9, 3.527596712671875*^9, {
   3.527974249613661*^9, 3.5279742607396593`*^9}, 3.527974503779133*^9, 
   3.5280168244969263`*^9, 3.528016955545365*^9, 3.528069834759173*^9, 
   3.528070075265003*^9, 3.5280704855449567`*^9, 3.5280708976875887`*^9, {
   3.5280711881452465`*^9, 3.52807119860028*^9}, 3.5280712669585743`*^9, 
   3.5280716708293123`*^9, 3.5280717029855504`*^9, 3.5280720592077727`*^9, 
   3.5280722746776032`*^9, 3.5280728492437887`*^9, 3.5280734943413935`*^9, {
   3.5280735363818445`*^9, 3.528073595276531*^9}, 3.5280740863426495`*^9, 
   3.5280742190334496`*^9, 3.52807443425292*^9, 3.528074964365184*^9, 
   3.528076079298379*^9, 3.528101530362155*^9, 3.528102903977317*^9, 
   3.5281032978036113`*^9, 3.528103463331629*^9, 3.528112268269147*^9, 
   3.5285244524536247`*^9, 3.5285255740317497`*^9, 3.5285268180786247`*^9, 
   3.5285275014067497`*^9, 3.5285425538598747`*^9, 3.5285427345317497`*^9, 
   3.5285431673129997`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Constructing the bermudan swaption", "Subsubsection",
 CellChangeTimes->{{3.5281012946231794`*^9, 3.5281013164645853`*^9}, {
  3.5281035425154896`*^9, 3.528103546210803*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"startDate", " ", "=", " ", 
   RowBox[{"CalendarAdvance", "[", 
    RowBox[{"settlementDate", ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "\"\<Year\>\""}], "}"}], ",", 
     RowBox[{
     "BusinessDayConvention", "\[Rule]", " ", 
      "\"\<Modified Following\>\""}]}], "]"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"maturityDate", " ", "=", 
   RowBox[{"CalendarAdvance", "[", 
    RowBox[{"startDate", ",", 
     RowBox[{"{", 
      RowBox[{"5", ",", "\"\<Year\>\""}], "}"}], ",", 
     RowBox[{
     "BusinessDayConvention", "\[Rule]", " ", 
      "\"\<Modified Following\>\""}]}], "]"}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.526268058625*^9, 3.526268068890625*^9}, {
   3.526268142359375*^9, 3.526268197078125*^9}, 3.5279735729106092`*^9, {
   3.528103036547944*^9, 3.528103049035901*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"fixedSchedule", " ", "=", " ", 
   RowBox[{"Schedule", "[", 
    RowBox[{"startDate", ",", "maturityDate", ",", "\"\<1Y\>\"", ",", 
     RowBox[{"GenRule", "\[Rule]", "\"\<Forward\>\""}], ",", 
     RowBox[{
     "BusinessDayConvention", "\[Rule]", "  ", "\"\<Unadjusted\>\""}]}], 
    "]"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"floatSchedule", " ", "=", " ", 
   RowBox[{"Schedule", "[", 
    RowBox[{"startDate", ",", "maturityDate", ",", "\"\<6M\>\"", ",", 
     RowBox[{"GenRule", "\[Rule]", "\"\<Forward\>\""}], ",", 
     RowBox[{
     "BusinessDayConvention", "\[Rule]", "  ", 
      "\"\<Modified Following\>\""}]}], "]"}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.52626833621875*^9, 3.5262684370625*^9}, {
   3.526268477921875*^9, 3.526268478921875*^9}, {3.52626858028125*^9, 
   3.526268580890625*^9}, {3.52626864384375*^9, 3.526268648765625*^9}, {
   3.5275001200625*^9, 3.52750013746875*^9}, 3.5279736147107153`*^9, {
   3.5279738040830193`*^9, 3.5279738134665117`*^9}, 3.5279738773784127`*^9, {
   3.527973937274539*^9, 3.5279739831505055`*^9}, 3.5280168640337777`*^9, {
   3.5280702114107714`*^9, 3.528070262834715*^9}, 3.528070345293285*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"swap", " ", "=", " ", 
   RowBox[{"VanillaSwap", "[", 
    RowBox[{
    "1000", " ", ",", "fixedSchedule", ",", "0.05", ",", "floatSchedule", ",",
      "indexSixMonths", ",", "\"\<Payer\>\"", ",", 
     RowBox[{"FixedLegDayCounter", "\[Rule]", "\"\<Actual/360\>\""}]}], 
    "]"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.52626833621875*^9, 3.5262684370625*^9}, {
   3.526268477921875*^9, 3.526268478921875*^9}, {3.52626858028125*^9, 
   3.526268580890625*^9}, {3.52626864384375*^9, 3.526268648765625*^9}, {
   3.5275001200625*^9, 3.52750013746875*^9}, 3.5279736147107153`*^9, {
   3.5279738040830193`*^9, 3.5279738134665117`*^9}, 3.5279738773784127`*^9, {
   3.527973937274539*^9, 3.5279739831505055`*^9}, 3.5280168640337777`*^9, {
   3.5280702114107714`*^9, 3.528070262834715*^9}, 3.528070345293285*^9, 
   3.528070976561003*^9, {3.5281033343361425`*^9, 3.5281033365693536`*^9}, {
   3.528103482969867*^9, 3.5281034879269953`*^9}}],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"InstrumentSetPricingEngine", "[", 
   RowBox[{"swap", ",", 
    RowBox[{"DiscountingSwapEngine", "[", "yieldcurve", "]"}]}], "]"}], 
  ";"}], "\n", 
 RowBox[{"fixedATMRate", " ", "=", 
  RowBox[{"VanillaSwapFairRate", "[", "swap", "]"}]}]}], "Input",
 CellChangeTimes->{
  3.526269807796875*^9, {3.5262698429375*^9, 3.526269843609375*^9}, 
   3.52627028096875*^9, {3.52750014815625*^9, 3.52750015178125*^9}, 
   3.527974490219635*^9}],

Cell[BoxData["0.05057268131899159`"], "Output",
 CellChangeTimes->{
  3.526294013609375*^9, 3.526294282671875*^9, 3.5267082055*^9, 
   3.52670866609375*^9, 3.526709769015625*^9, 3.526712207625*^9, {
   3.52671229328125*^9, 3.526712316*^9}, 3.52671256128125*^9, 
   3.526714747671875*^9, 3.526715855703125*^9, 3.526716432765625*^9, 
   3.52672011509375*^9, 3.526722417296875*^9, 3.5267227163125*^9, 
   3.526722867796875*^9, 3.526724469765625*^9, 3.526724591171875*^9, 
   3.5267917411898303`*^9, 3.526794919531009*^9, 3.5267952807367697`*^9, 
   3.5267955623527575`*^9, 3.5267958570308275`*^9, 3.526795955183936*^9, 
   3.5267984535798254`*^9, 3.5267988539315133`*^9, 3.5267989968350196`*^9, 
   3.5267993444071455`*^9, 3.5267994953895874`*^9, 3.5268000382107644`*^9, 
   3.5268070632804537`*^9, 3.5268072397804537`*^9, 3.5268074436710787`*^9, 
   3.5268096836554537`*^9, 3.5268101786085787`*^9, 3.5268108234210787`*^9, 
   3.5268117202492037`*^9, 3.5268119536242037`*^9, 3.5268121330460787`*^9, 
   3.526815936734375*^9, 3.526884117890625*^9, 3.52688446809375*^9, 
   3.526897534734375*^9, 3.52689765296875*^9, 3.52689803909375*^9, 
   3.526899243234375*^9, 3.526899338296875*^9, 3.52690167703125*^9, 
   3.5269736589375*^9, 3.526974394640625*^9, 3.526984448828125*^9, 
   3.52698620265625*^9, 3.52730703640625*^9, 3.52733441603125*^9, 
   3.527334869*^9, 3.527335845390625*^9, 3.527336180390625*^9, 
   3.527392951921875*^9, 3.52747814340625*^9, 3.527483823671875*^9, 
   3.52748484578125*^9, 3.527486266703125*^9, 3.527487629*^9, 
   3.527487941234375*^9, 3.527491728171875*^9, 3.5274997431875*^9, {
   3.527500148859375*^9, 3.527500152421875*^9}, {3.527501237609375*^9, 
   3.527501256734375*^9}, 3.527501293078125*^9, 3.527501344015625*^9, 
   3.527501478640625*^9, 3.5275025301875*^9, 3.52750357*^9, 
   3.527586072109375*^9, 3.527590425234375*^9, 3.527590872984375*^9, 
   3.527591140921875*^9, 3.527594447796875*^9, 3.52759623096875*^9, 
   3.527596329578125*^9, 3.527596366515625*^9, 3.527596533015625*^9, 
   3.527596710625*^9, 3.5279740027086287`*^9, {3.5279744784627295`*^9, 
   3.5279744914313774`*^9}, 3.5280168220133553`*^9, 3.5280169534323263`*^9, 
   3.528069832415803*^9, 3.5280700720804243`*^9, 3.528070483622192*^9, 
   3.5280708962254868`*^9, 3.5280720530589314`*^9, 3.528074058512632*^9, 
   3.52807418814904*^9, 3.5280744073742704`*^9, 3.5280749337010913`*^9, 
   3.528101498416219*^9, 3.5281021312862415`*^9, 3.528102907181925*^9, 
   3.5281032990153537`*^9, 3.528103490180235*^9, 3.5281122690602846`*^9, 
   3.5285244545473747`*^9, 3.5285255768129997`*^9, 3.5285268197661247`*^9, 
   3.5285275027348747`*^9, 3.5285425548754997`*^9, 3.5285427347817497`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"VanillaSwapFixedLegAnalysis", "[", "swap", "]"}], " ", "/.", 
   RowBox[{
    RowBox[{"(", " ", 
     RowBox[{"x_", "/;", " ", 
      RowBox[{
       RowBox[{"IntegerQ", "[", "x", "]"}], " ", "&&", " ", 
       RowBox[{"30000", " ", "<", " ", "x", " ", "<", " ", "60000"}]}]}], 
     ")"}], "  ", "\[RuleDelayed]", "  ", 
    RowBox[{"DateString", "[", " ", 
     RowBox[{
      RowBox[{"ToCalendar", "[", "x", "]"}], ",", "\"\<DateShort\>\""}], 
     "]"}]}]}], "  ", "//", "  ", "TableForm"}]], "Input",
 CellChangeTimes->{{3.527485005375*^9, 3.527485031515625*^9}, {
  3.528076189817298*^9, 3.528076194754397*^9}}],

Cell[BoxData[
 TagBox[GridBox[{
    {"\<\"Payment Date\"\>", "\<\"Amount\"\>", "\<\"Nominal\"\>", \
"\<\"Accrual Start Date\"\>", "\<\"Accrual End Date\"\>", "\<\"Accrual Days\"\
\>", "\<\"Index\"\>", "\<\"Fixing Days\"\>", "\<\"Fixing Dates\"\>", "\<\"Day \
Counter\"\>", "\<\"Accrual Period\"\>", "\<\"Effective Rate\"\>", \
"\<\"Floor\"\>", "\<\"Gearing\"\>", "\<\"Index Fixing\"\>", "\<\"Conv. Adj.\"\
\>", "\<\"Spread\"\>", "\<\"Cap\"\>", "\<\"Call Digital Payoff\"\>", "\<\"Put \
Digital Payoff\"\>"},
    {"\<\"Tue 29 Oct 2013\"\>", "50.69444444444437`", 
     "1000.`", "\<\"Mon 29 Oct 2012\"\>", "\<\"Tue 29 Oct 2013\"\>", 
     "365", "\<\"#N/A\"\>", "\<\"#N/A\"\>", "\<\"#N/A\"\>", "\<\"Actual/360\"\
\>", "1.0138888888888888`", 
     "0.05`", "\<\"#N/A\"\>", "\<\"#N/A\"\>", "\<\"#N/A\"\>", "\<\"#N/A\"\>", \
"\<\"#N/A\"\>", "\<\"#N/A\"\>", "\<\"#N/A\"\>", "\<\"#N/A\"\>"},
    {"\<\"Wed 29 Oct 2014\"\>", "50.69444444444437`", 
     "1000.`", "\<\"Tue 29 Oct 2013\"\>", "\<\"Wed 29 Oct 2014\"\>", 
     "365", "\<\"#N/A\"\>", "\<\"#N/A\"\>", "\<\"#N/A\"\>", "\<\"Actual/360\"\
\>", "1.0138888888888888`", 
     "0.05`", "\<\"#N/A\"\>", "\<\"#N/A\"\>", "\<\"#N/A\"\>", "\<\"#N/A\"\>", \
"\<\"#N/A\"\>", "\<\"#N/A\"\>", "\<\"#N/A\"\>", "\<\"#N/A\"\>"},
    {"\<\"Thu 29 Oct 2015\"\>", "50.69444444444437`", 
     "1000.`", "\<\"Wed 29 Oct 2014\"\>", "\<\"Thu 29 Oct 2015\"\>", 
     "365", "\<\"#N/A\"\>", "\<\"#N/A\"\>", "\<\"#N/A\"\>", "\<\"Actual/360\"\
\>", "1.0138888888888888`", 
     "0.05`", "\<\"#N/A\"\>", "\<\"#N/A\"\>", "\<\"#N/A\"\>", "\<\"#N/A\"\>", \
"\<\"#N/A\"\>", "\<\"#N/A\"\>", "\<\"#N/A\"\>", "\<\"#N/A\"\>"},
    {"\<\"Mon 31 Oct 2016\"\>", "50.833333333333286`", 
     "1000.`", "\<\"Thu 29 Oct 2015\"\>", "\<\"Sat 29 Oct 2016\"\>", 
     "366", "\<\"#N/A\"\>", "\<\"#N/A\"\>", "\<\"#N/A\"\>", "\<\"Actual/360\"\
\>", "1.0166666666666666`", 
     "0.05`", "\<\"#N/A\"\>", "\<\"#N/A\"\>", "\<\"#N/A\"\>", "\<\"#N/A\"\>", \
"\<\"#N/A\"\>", "\<\"#N/A\"\>", "\<\"#N/A\"\>", "\<\"#N/A\"\>"},
    {"\<\"Mon 30 Oct 2017\"\>", "50.69444444444437`", 
     "1000.`", "\<\"Sat 29 Oct 2016\"\>", "\<\"Sun 29 Oct 2017\"\>", 
     "365", "\<\"#N/A\"\>", "\<\"#N/A\"\>", "\<\"#N/A\"\>", "\<\"Actual/360\"\
\>", "1.0138888888888888`", 
     "0.05`", "\<\"#N/A\"\>", "\<\"#N/A\"\>", "\<\"#N/A\"\>", "\<\"#N/A\"\>", \
"\<\"#N/A\"\>", "\<\"#N/A\"\>", "\<\"#N/A\"\>", "\<\"#N/A\"\>"},
    {"\<\"Mon 30 Oct 2017\"\>", "0.1388888888889106`", 
     "1000.`", "\<\"Sun 29 Oct 2017\"\>", "\<\"Mon 30 Oct 2017\"\>", 
     "1", "\<\"#N/A\"\>", "\<\"#N/A\"\>", "\<\"#N/A\"\>", \
"\<\"Actual/360\"\>", "0.002777777777777778`", 
     "0.05`", "\<\"#N/A\"\>", "\<\"#N/A\"\>", "\<\"#N/A\"\>", "\<\"#N/A\"\>", \
"\<\"#N/A\"\>", "\<\"#N/A\"\>", "\<\"#N/A\"\>", "\<\"#N/A\"\>"}
   },
   GridBoxAlignment->{
    "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
     "RowsIndexed" -> {}},
   GridBoxSpacings->{"Columns" -> {
       Offset[0.27999999999999997`], {
        Offset[2.0999999999999996`]}, 
       Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
       Offset[0.2], {
        Offset[0.4]}, 
       Offset[0.2]}, "RowsIndexed" -> {}}],
  Function[BoxForm`e$, 
   TableForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{{3.527485024546875*^9, 3.527485032390625*^9}, 
   3.527486318328125*^9, 3.527487680421875*^9, 3.52748799040625*^9, 
   3.5274918126875*^9, 3.52749974734375*^9, {3.527501245875*^9, 
   3.527501259390625*^9}, 3.527501295515625*^9, 3.527501355625*^9, 
   3.527502182609375*^9, 3.527502885984375*^9, 3.527503903546875*^9, 
   3.52758608378125*^9, 3.527590808375*^9, 3.5275947935*^9, 
   3.52759623246875*^9, 3.527596331203125*^9, 3.527596374265625*^9, 
   3.5275965371875*^9, 3.527596722359375*^9, 3.5279743870613008`*^9, 
   3.5279745163872623`*^9, 3.528016825808813*^9, 3.5280169620547247`*^9, 
   3.5280698415289073`*^9, 3.5280700826255875`*^9, 3.528070491964187*^9, 
   3.528070902885062*^9, 3.5280720663981123`*^9, 3.5280736143840065`*^9, 
   3.5280740869034557`*^9, 3.528074219564213*^9, 3.528074434703568*^9, 
   3.5280749647757745`*^9, 3.5280761955555487`*^9, 3.528101531163307*^9, 
   3.528102905239131*^9, 3.5281030810919952`*^9, 3.5281032997063475`*^9, 
   3.528103496829797*^9, 3.528112269621091*^9, 3.5285244547661247`*^9, 
   3.5285255769692497`*^9, 3.5285268199379997`*^9, 3.5285275027817497`*^9, 
   3.5285425550786247`*^9, 3.5285427348598747`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"accrualDates", " ", "=", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"VanillaSwapFixedLegAnalysis", "[", "swap", "]"}], "[", 
     RowBox[{"[", 
      RowBox[{"All", ",", "4"}], "]"}], "]"}], " ", "//", " ", "Rest"}], " ", 
   "//", " ", "ToCalendar"}]}]], "Input",
 CellChangeTimes->{{3.527485075890625*^9, 3.52748509428125*^9}, {
  3.527485243109375*^9, 3.527485253640625*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"2012", ",", "10", ",", "29"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"2013", ",", "10", ",", "29"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"2014", ",", "10", ",", "29"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"2015", ",", "10", ",", "29"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"2016", ",", "10", ",", "29"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"2017", ",", "10", ",", "29"}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{{3.527485081234375*^9, 3.5274850951875*^9}, 
   3.52748525434375*^9, 3.527486318578125*^9, 3.5274876805625*^9, 
   3.527487990671875*^9, 3.52749181296875*^9, 3.5274997474375*^9, {
   3.527501246171875*^9, 3.527501259453125*^9}, 3.527501295578125*^9, 
   3.52750135584375*^9, 3.527502184296875*^9, 3.527502886078125*^9, 
   3.52750390359375*^9, 3.527586083859375*^9, 3.5275908085*^9, 
   3.527594793609375*^9, 3.527596233171875*^9, 3.527596331359375*^9, 
   3.527596374359375*^9, 3.527596537484375*^9, 3.5275967224375*^9, 
   3.5279743956035843`*^9, 3.5279745203429503`*^9, 3.528016826109245*^9, 
   3.528016962114811*^9, 3.5280698418093104`*^9, 3.528070082926019*^9, 
   3.5280704921744895`*^9, 3.5280709031153936`*^9, 3.5280720668487597`*^9, 
   3.5280736172681537`*^9, 3.5280740873140464`*^9, 3.528074219974803*^9, 
   3.5280744350941296`*^9, 3.5280749650061054`*^9, 3.528101533336432*^9, 
   3.5281029063006573`*^9, 3.528103090926136*^9, 3.5281032997764482`*^9, 
   3.528103498942835*^9, 3.528112270071739*^9, 3.5285244549692497`*^9, 
   3.5285255770629997`*^9, 3.5285268199848747`*^9, 3.5285275028129997`*^9, 
   3.5285425552348747`*^9, 3.5285427349223747`*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"bermudanSwaption", " ", "=", " ", 
   RowBox[{"Swaption", "[", 
    RowBox[{"swap", ",", 
     RowBox[{"BermudanExercise", "[", "accrualDates", "]"}]}], "]"}]}], 
  ";"}]], "Input",
 CellChangeTimes->{{3.527485322765625*^9, 3.527485352625*^9}, 
   3.527502198609375*^9, 3.527596124421875*^9, 3.528103100559989*^9}],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"InstrumentSetPricingEngine", "[", 
   RowBox[{"bermudanSwaption", ",", 
    RowBox[{"TreeSwaptionEngine", "[", 
     RowBox[{"modelHW", ",", "50"}], "]"}]}], "]"}], " ", ";"}], "\n", 
 RowBox[{"InstrumentNPV", "[", "bermudanSwaption", "]"}]}], "Input",
 CellChangeTimes->{{3.52748773009375*^9, 3.527487780984375*^9}, {
   3.5274879218125*^9, 3.527487928109375*^9}, {3.527491853203125*^9, 
   3.527491855015625*^9}, {3.52749841178125*^9, 3.527498431265625*^9}, 
   3.527502219375*^9}],

Cell[BoxData["20.623179628291094`"], "Output",
 CellChangeTimes->{
  3.528101533837152*^9, 3.528102907712688*^9, {3.528103126627472*^9, 
   3.5281031407978477`*^9}, 3.5281032999867506`*^9, 3.528103501266176*^9, 
   3.5281122703020706`*^9, 3.5285244558442497`*^9, 3.5285255785786247`*^9, 
   3.5285268207348747`*^9, 3.5285275035161247`*^9, 3.5285425553129997`*^9, 
   3.5285427349848747`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"InstrumentSetPricingEngine", "[", 
   RowBox[{"bermudanSwaption", ",", 
    RowBox[{"TreeSwaptionEngine", "[", 
     RowBox[{"modelBK", ",", "50"}], "]"}]}], "]"}], " ", 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"InstrumentNPV", "[", "bermudanSwaption", "]"}]}], "Input",
 CellChangeTimes->{{3.52750237665625*^9, 3.5275023863125*^9}}],

Cell[BoxData["10.794344521989935`"], "Output",
 CellChangeTimes->{3.528101533937296*^9, 3.528102907872918*^9, 
  3.528103142199864*^9, 3.5281033000568514`*^9, 3.5281035026281347`*^9, 
  3.5281122704322577`*^9, 3.5285244567973747`*^9, 3.5285255802661247`*^9, 
  3.5285268215942497`*^9, 3.5285275042348747`*^9, 3.5285425553911247`*^9, 
  3.5285427350317497`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"InstrumentSetPricingEngine", "[", 
   RowBox[{"bermudanSwaption", ",", 
    RowBox[{"TreeSwaptionEngine", "[", 
     RowBox[{"modelG2", ",", "50"}], "]"}]}], "]"}], " ", ";"}], "\n", 
 RowBox[{"InstrumentNPV", "[", "bermudanSwaption", "]"}]}], "Input",
 CellChangeTimes->{{3.52748773009375*^9, 3.527487780984375*^9}, {
   3.5274879218125*^9, 3.527487928109375*^9}, {3.527491853203125*^9, 
   3.527491855015625*^9}, 3.52749841178125*^9, 3.52750221415625*^9}],

Cell[BoxData["142.33088031735173`"], "Output",
 CellChangeTimes->{3.5281015340073967`*^9, 3.528102907993091*^9, 
  3.5281031467964735`*^9, 3.528103303461747*^9, 3.528103507745493*^9, 
  3.5281122741576147`*^9, 3.5285256538129997`*^9, 3.5285268724536247`*^9, 
  3.5285275456098747`*^9, 3.5285425596098747`*^9, 3.5285427380473747`*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"Map", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"CalibrationHelperSetPricingEngine", "[", 
      RowBox[{"#", ",", 
       RowBox[{"G2SwaptionEngine", "[", 
        RowBox[{"modelG2", ",", "6", ",", "20"}], "]"}]}], "]"}], "&"}], ",", 
    "swaptions", ",", 
    RowBox[{"{", "2", "}"}]}], "]"}], ";"}]], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"{", 
   RowBox[{
   "\[Alpha]", ",", "\[Sigma]", ",", "\[Beta]", ",", "\[Eta]", ",", 
    "\[Rho]"}], "}"}], " ", "=", 
  RowBox[{"CalibratedModelParams", "[", "modelG2", "]"}]}]], "Input",
 CellChangeTimes->{{3.5280737017095747`*^9, 3.5280737202662573`*^9}, {
   3.52807649972292*^9, 3.5280765009847345`*^9}, {3.528076536545869*^9, 
   3.528076557265662*^9}, {3.5280766853298097`*^9, 3.52807668674184*^9}, 
   3.5280771210263104`*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0.1`", ",", "0.1`", ",", "0.1`", ",", "0.1`", ",", 
   RowBox[{"-", "0.75`"}]}], "}"}]], "Output",
 CellChangeTimes->{{3.528073712565184*^9, 3.5280737273163953`*^9}, 
   3.52807409276188*^9, 3.5280742259133425`*^9, 3.528074440732237*^9, 
   3.528074970594141*^9, 3.5280765593887153`*^9, 3.5280766883040867`*^9, 
   3.5280769887861586`*^9, 3.528101534337872*^9, 3.5281029083035374`*^9, 
   3.5281033036319923`*^9, 3.5281035152763214`*^9, 3.528112274528147*^9, 
   3.5285256549848747`*^9, 3.5285268731098747`*^9, 3.5285275461723747`*^9, 
   3.5285425599223747`*^9, 3.5285427382661247`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"CalibratedModelValue", "[", 
  RowBox[{"modelG2", ",", 
   RowBox[{"{", 
    RowBox[{
    "\[Alpha]", ",", "\[Sigma]", ",", "\[Beta]", ",", "\[Eta]", ",", 
     "\[Rho]"}], "}"}], " ", ",", 
   RowBox[{"swaptions", " ", "//", " ", "Flatten"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.5285269228286247`*^9, 3.5285270138754997`*^9}}],

Cell[BoxData["45.123131740935136`"], "Output",
 CellChangeTimes->{{3.5285269737036247`*^9, 3.5285269839692497`*^9}, 
   3.5285270144067497`*^9, 3.5285275464536247`*^9, 3.5285425600004997`*^9, 
   3.5285427383286247`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", "CalibratedModelValue"}]], "Input",
 CellChangeTimes->{{3.5285269905942497`*^9, 3.5285269966567497`*^9}}],

Cell[BoxData[
 StyleBox["\<\"CalibratedModelValue[ObjectId_Symbol,Params_List /; \
Vector[Params,NumberQ],CalibrationHelpers_List]\"\>", "MSG"]], "Print", \
"PrintUsage",
 CellChangeTimes->{3.5285427385317497`*^9},
 CellTags->"Info3528549938-6176860"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Plot3D", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"CalibratedModelSetParams", "[", 
     RowBox[{"modelG2", ",", 
      RowBox[{"{", 
       RowBox[{
       "\[Alpha]", ",", "\[Sigma]", ",", "\[Beta]", ",", "\[Eta]", ",", 
        "\[Rho]"}], "}"}]}], "]"}], ";", 
    RowBox[{
     RowBox[{
      RowBox[{"Abs", "[", 
       RowBox[{
        RowBox[{"Map", "[", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{
           RowBox[{"CalibrationHelperImpliedVolatility", "[", 
            RowBox[{"#", ",", 
             RowBox[{"CalibrationHelperModelValue", "[", "#", "]"}]}], "]"}], 
           "&"}], ",", "swaptions", ",", 
          RowBox[{"{", "2", "}"}]}], "]"}], "-", "swaptionVols"}], "]"}], " ",
       "//", " ", "Flatten"}], " ", "//", " ", "Total"}]}], ",", 
   RowBox[{"{", 
    RowBox[{"\[Sigma]", ",", "0.01", ",", "0.1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"\[Eta]", ",", "0.01", ",", "0.1"}], "}"}]}], "]"}]], "Input",
 Evaluatable->False,
 CellChangeTimes->{{3.5280750644891553`*^9, 3.5280750782088833`*^9}, {
   3.5280764576724544`*^9, 3.528076491340867*^9}, {3.528076714802189*^9, 
   3.528076808987621*^9}, 3.5280770349325137`*^9}],

Cell[BoxData[
 Graphics3DBox[GraphicsComplex3DBox[CompressedData["
1:eJxkfXVcVs3zNkp3N2KBhd2BnoMBNopYCCqKiq2IKLaCBSgKBigqAlKCSApK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   "], {{
     {EdgeForm[None], GraphicsGroup3DBox[{Polygon3DBox[CompressedData["
1:eJxNnAccV9P7x+84937taJlRIbuQHYokIVI2JckI2SJEKHvPZGXvmZWM0LBJ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         "]], Polygon3DBox[CompressedData["
1:eJwtm3f8V9Mfx+/93HvOJyUtlBZtq4REgwYhIqOFIkoSysqKqOyRvckeZWaV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         "]], Polygon3DBox[CompressedData["
1:eJwl011oz1Ecx/Gz5+cN2zyGTVktSVZbwjBt48I8jNGIcLFyY2pRNrtRFBfu
pMSF1qKxmWyZPNXaSpO5GKIWauRhZi3MUsrr1y4+ne/n/f18z/mds//yD9dX
H40NIRRRAs1JCiFPsZjq+AvWLhqPC+FpfAiV2Fn+IKWpy6wbab65Q9Z0LN+6
hOZiHdbN2GLzu9TFWCqV2us6DcWEcBU/kDB9/lKsgJJk3ieG0IcV8iWaH/hM
vIvvpg16zfgpWq/+6owePEvmhOwsF3sZnUE5WBOWiy2Sf4U18qfVFWZHzT7G
Zsp9w2rlxvkKSsO+yCbLbNKrpM98wFdh+2Un5LbxK/AGd2rkiyg52g8rEL8t
W2V2lB+L3hi7hS2X+8Gfx4vtNcKnUoLZn1ieXLvcNplf/F4adsZNmb/4E7wV
O252KnormsR2UL1+Kb23Rw3eI3dRLkUvKfrb8ln0Vr9bbqdMJv8xuh+/TqYf
O8J/j94fu0v3sDo+m0ZFy7GT9If/TfPUdyjefCd/zrpdbsDcM8p2txb8mG+5
LLeHJqNz5XrlqmS2ULrcPvyd+3bw7ZSBNciVyH0yt1W9ANstNyjXKlNOgW+K
3gzLsWbTbLk4em2ulZ7r1cid0Ssz8sDcQ5ohM4I9CtP/GDGUi8XThLkBiqVP
Zq9Fvyd1i7le+1VjQ/TS3ZbpZeCJ5trVC23XJtuG1UbvhK/BC2lQ/gXWqR6L
fo9x098Ufdtw9M76g9gbs838FL5a/Y+a9G5g/bRSfV8uV7+Pv2S9gmVY18qm
OPM//yl6mA==
         "]], 
        Polygon3DBox[{{1793, 831, 622, 1271, 1219, 1810}, {1694, 606, 825, 
         1362, 1264, 1693}}]}]}, {}, {}, {}, {}}, {
     {GrayLevel[0], Line3DBox[CompressedData["
1:eJwl1ElsTlEUwPHXVkkES5uW6iCUEvNMFVUtVTqh1aLUULSoqZN5Hosai4jY
2IpIDJGIWBBbohKJtY0IYqiW343F//3Pu/eec+5333tfclVdYW1MFEVxLvkI
cYbLY66Ij6JeXBQbRS+4wPgKY/3Er1El7s/VnMTd3MnpqJHznlviomgPCrEB
U9BhfCr/6hlFCWoW94iiD8YSxQnGS9Up5YFoxQxcQQauIhMxNnaai0NvXopB
OIfteo/g++r91eOg+CSSUYYU7Ec5tgarcZPjrL3By+1lW3CohXqMwk7sQh5m
q13BS+Rmh3MRz8JujMYftRp4DuaH9RhqXSKvRKL9l8hNFV9ANvba9xh+aN0h
PoU0rMJgdKmZbm5A2JvcRl6AHGNVnMtz+Yv9vxE3cpaz7eImZIq/8ltzzeF5
ud+v53dxubEWzuNv/I5v6dEgTrXmM7e7r+c/aBNv4g5zn/hAOFs5lbyMc3kH
ftvzXfMpxsrkbAnzOI4TOIYH5kaGc1Yri89jJmKdUXs4Y1zDR3WSrN0nnofp
qAv11B3OtZiGkvA+WNetd3HIF+fwZmzCMNRgI4rCuWOs2tdDXWfSKu6Uu979
YqzDWizCERzF4ZCr7z2108MztfezvIIL+BImIXxAF8P7b+1kvhzeA7RhIs5g
Avqq01vPV1L6iJ/zT/fV5oZgTfhNaoznhWhCM/KxGuPwTM4dlhb9wG1xfHjO
9uRnRWkuT8O3jkrxCH2eiF9ybHhGxh5F//8H/gHk93G2
       "]]}, {
      Line3DBox[{1373, 1470, 1569, 1623, 980, 1568, 1706, 1707, 1570, 1617, 
       1624, 1858, 1441, 1618, 1559, 1561, 1560, 1507, 1813, 1842, 1442, 1709,
        1708, 1710, 1443, 1374, 1799, 1821, 1444, 1620, 1749, 1882, 1750, 
       1738, 1758, 1445, 1508, 1804, 1850, 1541, 1784}], 
      Line3DBox[{1375, 1542, 1705, 1543, 1533, 1572, 1621, 1795, 1852, 1571, 
       1600, 1601, 1511, 1535, 983, 1510, 1544, 1562, 1545, 1512, 1849, 1536, 
       1622, 1446, 1619, 1608, 1609, 1602, 1447, 1376, 1818, 1822, 1766, 1448,
        1377, 1816, 1823, 1449, 1739, 1881, 1471, 1626, 1688, 1450, 1689, 
       1690, 1546}], 
      Line3DBox[{1378, 1509, 1740, 1759, 1760, 1883, 1513, 1547, 1563, 1472, 
       1566, 1537, 1838, 1803, 1514, 1610, 1473, 1516, 1094, 1538, 1515, 1548,
        1611, 1474, 1691, 1628, 1629, 1627, 1805, 1824, 1711, 1451, 1379, 
       1885, 1767, 1768, 1452, 1380, 1859, 1625, 1453, 1665, 1475, 1630, 1692,
        1694, 1693, 1871, 1792}], 
      Line3DBox[{1381, 713, 1328, 730, 206, 1169, 405, 708, 137, 1268, 611, 
       210, 313, 138, 314, 211, 1068, 139, 485, 1201, 484, 1382, 1886, 778, 
       1383, 480, 1243, 551, 140, 434}], 
      Line3DBox[{1428, 1763, 1529, 1704, 1528, 1847, 1427, 1502, 1683, 1501, 
       1841, 1684, 1426, 1500, 1594, 1048, 1605, 1425, 1499, 1593, 1498, 1682,
        1424, 1737, 1879, 1658, 1659, 1657, 1423, 1866, 1661, 1756, 1660, 
       1757, 1422, 1815, 1880, 1497, 1721, 1496, 1722, 1421, 1555, 1783, 
       1788}], Line3DBox[{1435, 763, 1606, 416, 1857, 1434, 1504, 1596, 414, 
       1433, 1503, 1595, 1870, 592, 1432, 706, 1663, 1662, 1431, 1801, 1837, 
       1530, 1430, 1051, 1685, 590, 1429, 1848, 1820}], 
      Line3DBox[{1440, 1615, 1664, 1616, 1599, 1607, 1178, 1439, 1506, 1598, 
       1687, 1856, 1686, 1438, 1532, 1597, 1855, 1802, 1437, 1505, 1723, 1725,
        1724, 1436, 1558, 1117, 1531, 1557, 1614, 1556, 1789}], 
      Line3DBox[{618, 617, 1697, 735, 1873, 1393, 794, 1781, 1712, 1872, 1394,
        1773, 1832, 1819, 1395, 1633, 1634, 680, 1396, 556, 1867, 1575, 1482, 
       1397, 407, 1576, 1483, 1398, 1868, 558, 1668, 684, 1399, 783, 1772, 
       1638, 1861, 1400, 1741, 1319, 1401, 717, 1521, 1833, 281, 342, 895}], 
      Line3DBox[{234, 637, 174, 761, 1274, 632, 535, 1239, 536, 173, 1153, 
       383, 172, 382, 1152, 171, 581, 1256, 526, 1420, 1875, 663, 664, 170, 
       1081, 232, 324, 886}], 
      Line3DBox[{1534, 1517, 1518, 1843, 1384, 1779, 1780, 1888, 1385, 1631, 
       1632, 1199, 1726, 1386, 1695, 1761, 1476, 1696, 1477, 1612, 1387, 1603,
        1023, 1573, 1478, 1388, 1667, 1839, 1479, 1666, 1480, 1728, 1389, 
       1356, 1635, 1769, 1636, 1390, 1770, 1771, 1887, 1391, 1519, 1574, 1520,
        1876, 1727, 1392, 1549, 1481, 1787}], 
      Line3DBox[{1539, 1613, 1540, 1524, 1554, 1851, 1491, 1525, 1718, 1719, 
       1717, 1874, 1716, 1720, 1468, 1418, 1648, 1765, 1796, 1864, 1679, 1492,
        1652, 1735, 1840, 1736, 1589, 1493, 1591, 1232, 1653, 1590, 1494, 
       1592, 1655, 1656, 1654, 1812, 1831, 1681, 1469, 1419, 1846, 1526, 1701,
        1702, 1703, 1527, 1114, 1564, 1495, 1565, 1786}], 
      Line3DBox[{795, 956, 62, 563, 957, 63, 788, 64, 958, 65, 1213, 503, 66, 
       1144, 365, 67, 366, 959, 68, 567, 960, 69, 741, 961, 70, 723, 71, 1072,
        223, 896}], 
      Line3DBox[{1785, 1551, 1550, 1844, 1402, 1714, 1715, 1713, 1731, 1877, 
       1814, 1403, 1775, 1776, 1774, 1834, 1807, 1404, 1777, 1835, 1778, 1405,
        1806, 1860, 1637, 1730, 1729, 1406, 1669, 1853, 1670, 1577, 1484, 
       1407, 1171, 1604, 1578, 1485, 1408, 1672, 1673, 1671, 1733, 1732, 1862,
        1409, 1752, 1753, 1751, 1836, 1809, 1410, 1742, 1743, 1817, 1884, 
       1762, 1411, 1744, 1745, 1522, 1553, 1567, 1552, 1790}], 
      Line3DBox[{1791, 372, 1583, 1800, 1829, 1523, 1463, 1415, 1326, 1748, 
       1464, 1416, 1863, 1641, 1764, 1465, 1676, 1488, 1649, 694, 1878, 1584, 
       1489, 1586, 521, 1585, 1490, 1587, 1865, 524, 1651, 1650, 1680, 1466, 
       1417, 1811, 1830, 1755, 1467, 1678, 1041, 1588, 437, 906}], 
      Line3DBox[{1793, 1810, 1845, 1454, 1640, 1639, 1675, 1455, 1412, 1825, 
       1456, 1413, 1808, 1826, 1457, 1674, 1797, 1827, 1642, 1734, 1458, 1579,
        1486, 1581, 1643, 1006, 1580, 1487, 1582, 1646, 1854, 1459, 1645, 
       1644, 1677, 1869, 1460, 1414, 1746, 1754, 1461, 1747, 1798, 1828, 1647,
        1698, 1462, 1699, 1782, 1700, 1794}]}, {
      Line3DBox[{766, 646, 1710, 649, 200, 1602, 403, 135, 1691, 603, 209, 
       312, 138, 315, 212, 614, 1696, 141, 488, 1634, 487, 952, 1835, 787, 
       788, 508, 1675, 569, 160, 436}], 
      Line3DBox[{930, 1061, 1062, 1821, 931, 1345, 1346, 1822, 1347, 1348, 
       1196, 1198, 1197, 1824, 1282, 1283, 1021, 1068, 1022, 1183, 1134, 1170,
        1023, 1135, 1024, 1137, 1246, 1867, 1026, 1245, 1027, 1206, 1860, 
       1204, 1205, 958, 1005, 1825, 962, 1073, 1146, 1074, 1829, 1075, 1110, 
       1042, 1371}], 
      Line3DBox[{932, 460, 734, 733, 1882, 1315, 1313, 1314, 1823, 935, 1349, 
       1885, 1350, 1351, 777, 1201, 1200, 1244, 554, 1839, 1136, 1025, 1138, 
       407, 1139, 1028, 1141, 1853, 560, 1250, 1031, 1213, 1211, 1212, 1826, 
       963, 1325, 1326, 1327, 728, 1076, 1851, 289, 319, 882}], 
      Line3DBox[{1058, 1015, 1131, 1192, 980, 927, 1016, 1132, 1133, 1852, 
       982, 933, 1120, 1127, 1121, 1065, 1334, 1883, 984, 936, 1335, 1336, 
       1328, 987, 940, 1069, 1843, 990, 944, 1330, 1873, 1331, 1285, 1286, 
       995, 949, 1107, 1844, 1108}], 
      Line3DBox[{1060, 1329, 1059, 1279, 1280, 1281, 1842, 929, 1102, 1119, 
       1017, 1125, 1091, 1849, 1092, 1189, 1126, 1019, 1067, 1094, 1095, 1129,
        1105, 1182, 1020, 1268, 1266, 1267, 942, 1298, 1199, 1269, 992, 946, 
       1832, 1358, 997, 951, 1834, 1208, 1001, 957, 1303, 1033, 1217, 1218, 
       1271, 1219, 1845, 1364}], 
      Line3DBox[{241, 640, 183, 1723, 670, 541, 1663, 542, 176, 1593, 384, 
       172, 381, 1592, 168, 579, 1680, 522, 743, 1754, 722, 723, 154, 1522, 
       220, 317, 876}], 
      Line3DBox[{1087, 1057, 1177, 593, 1856, 1164, 1054, 1161, 414, 1159, 
       1050, 1156, 1841, 588, 1260, 1238, 1239, 703, 1272, 1078, 1846, 1077, 
       1149, 1041, 1254, 576, 626, 1700, 923}], 
      Line3DBox[{1089, 1086, 1191, 1085, 1855, 1162, 1053, 1261, 1052, 1870, 
       1262, 1157, 1049, 1155, 1048, 1173, 1154, 1047, 1153, 1046, 1258, 1257,
        1831, 1235, 1236, 1234, 1333, 1332, 1830, 1227, 1226, 1228, 1828, 
       1037, 1323, 1036, 1324, 1072, 1109, 1361, 1369}], 
      Line3DBox[{1096, 1270, 1097, 1130, 1106, 1833, 1030, 1071, 1337, 1338, 
       955, 1884, 1339, 1321, 1322, 1004, 961, 1224, 1007, 1869, 966, 1307, 
       1040, 1229, 1230, 1865, 1231, 969, 1044, 1151, 1232, 1233, 972, 1045, 
       1152, 1308, 1309, 975, 1310, 1237, 1879, 1259, 1014, 978, 1837, 1084, 
       1293, 1294, 1295, 979, 1117, 1123, 1056, 1124, 1372}], 
      Line3DBox[{202, 597, 1689, 21, 549, 1665, 29, 1383, 38, 1390, 48, 1399, 
       497, 58, 1408, 364, 67, 367, 1579, 76, 571, 1676, 85, 1418, 94, 664, 
       101, 1421, 235, 835}], 
      Line3DBox[{1118, 1098, 1188, 1099, 1088, 1186, 1187, 981, 1858, 928, 
       1167, 1168, 1064, 1090, 983, 934, 1103, 1128, 1104, 1066, 1838, 1093, 
       1263, 985, 937, 1180, 1181, 1169, 988, 941, 1359, 1888, 991, 945, 1284,
        1872, 996, 950, 1877, 1299, 1300, 1209, 1210, 1000, 956, 1366}], 
      Line3DBox[{1278, 1184, 1185, 1166, 1179, 1178, 1165, 1055, 1163, 1176, 
       1857, 1175, 1174, 1083, 1158, 1847, 1082, 1277, 1340, 1341, 1274, 1276,
        1275, 1080, 1113, 1273, 1114, 1079, 1112, 1190, 1111, 1370}], 
      Line3DBox[{1362, 1264, 1871, 1265, 986, 939, 1296, 1297, 1243, 989, 943,
        1357, 1887, 993, 947, 1207, 1861, 998, 953, 1301, 1862, 1302, 1215, 
       1216, 1002, 959, 1035, 1145, 1223, 1006, 964, 1038, 1147, 1304, 1878, 
       1008, 967, 1305, 1306, 1255, 1864, 1009, 970, 1292, 1875, 1010, 973, 
       1311, 1312, 1880, 1241, 1242, 1012, 976, 1360, 1848, 1365}], 
      Line3DBox[{1363, 433, 738, 678, 1876, 1070, 994, 948, 1319, 1320, 999, 
       954, 1836, 1214, 1003, 960, 692, 1225, 516, 1854, 965, 1039, 1148, 521,
        968, 1043, 1150, 1840, 697, 971, 698, 1256, 1011, 974, 1240, 1866, 
       1013, 977, 1051, 1160, 392, 908}], 
      Line3DBox[{1367, 1115, 1122, 1116, 1081, 1291, 1290, 1289, 1287, 1874, 
       1288, 1344, 1343, 1342, 1221, 1863, 1220, 1222, 1827, 1034, 1251, 1253,
        1252, 1144, 1032, 1143, 1172, 1171, 1142, 1029, 1140, 1249, 1868, 
       1248, 1247, 1202, 1203, 1356, 1355, 1354, 1353, 1886, 1352, 938, 1194, 
       1859, 1193, 1195, 1018, 1881, 1316, 1318, 1317, 1063, 1850, 1100, 1101,
        1368}]}, {}, {}}},
   VertexNormals->CompressedData["
1:eJwUWnc81n8QLyNSovKjSCiyK0XK6JKtojKSrOy9N2VG9kwhqYxShKyi+th7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    "]],
  AutomaticImageSize->True,
  Axes->True,
  BoxRatios->{1, 1, 0.4},
  ImageSize->{391.7192602331265, 254.85345697232992`},
  Method->{"RotationControl" -> "Globe"},
  PlotRange->{{0.01, 0.1}, {0.01, 0.1}, {0., 7.104105169166462}},
  PlotRangePadding->{
    Scaled[0.02], 
    Scaled[0.02], 
    Scaled[0.02]},
  ViewPoint->{-1.6175436830164887`, -2.7660241197943067`, 1.0875031044781427`},
  ViewVertical->{0., 0., 1.}]], "Output",
 CellChangeTimes->{3.5280750803219213`*^9, 3.528076865809326*^9, 
  3.5280777863930607`*^9},
 ImageCache->GraphicsData["CompressedBitmap", "\<\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\
\>"]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", "*Type"}]], "Input",
 CellChangeTimes->{{3.5285442364067497`*^9, 3.5285442380786247`*^9}}],

Cell[CellGroupData[{

Cell[BoxData[{
 DynamicModuleBox[{Typeset`open$$ = True}, 
  PaneSelectorBox[{False->
   RowBox[{
    OpenerBox[Dynamic[Typeset`open$$],
     ImageSize->Small], 
    StyleBox["System`", "InfoHeading"]}], True->GridBox[{
     {
      RowBox[{
       OpenerBox[Dynamic[Typeset`open$$],
        ImageSize->Small], 
       StyleBox["System`", "InfoHeading"]}]},
     {GridBox[{
        {
         ButtonBox["ControlType",
          BaseStyle->"InformationLink",
          ButtonData:>{"Info3528551439-6176860", {"ControlType", "System`"}},
          ButtonNote->"System`"], 
         ButtonBox["FormatType",
          BaseStyle->"InformationLink",
          ButtonData:>{"Info3528551439-6176860", {"FormatType", "System`"}},
          ButtonNote->"System`"]},
        {
         ButtonBox["DefaultFormatType",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3528551439-6176860", {"DefaultFormatType", "System`"}},
          ButtonNote->"System`"], 
         ButtonBox["ImageType",
          BaseStyle->"InformationLink",
          ButtonData:>{"Info3528551439-6176860", {"ImageType", "System`"}},
          ButtonNote->"System`"]},
        {
         ButtonBox["DefaultInlineFormatType",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3528551439-6176860", {"DefaultInlineFormatType", "System`"}},
          ButtonNote->"System`"], 
         ButtonBox["LegendreType",
          BaseStyle->"InformationLink",
          ButtonData:>{"Info3528551439-6176860", {"LegendreType", "System`"}},
          ButtonNote->"System`"]},
        {
         ButtonBox["DefaultInputFormatType",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3528551439-6176860", {"DefaultInputFormatType", "System`"}},
          ButtonNote->"System`"], 
         ButtonBox["TextClipboardType",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3528551439-6176860", {"TextClipboardType", "System`"}},
          ButtonNote->"System`"]},
        {
         ButtonBox["DefaultOutputFormatType",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3528551439-6176860", {"DefaultOutputFormatType", "System`"}},
          ButtonNote->"System`"], 
         ButtonBox["$FormatType",
          BaseStyle->"InformationLink",
          ButtonData:>{"Info3528551439-6176860", {"$FormatType", "System`"}},
          ButtonNote->"System`"]},
        {
         ButtonBox["DefaultTextFormatType",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3528551439-6176860", {"DefaultTextFormatType", "System`"}},
          ButtonNote->"System`"], 
         ButtonBox["$LicenseType",
          BaseStyle->"InformationLink",
          ButtonData:>{"Info3528551439-6176860", {"$LicenseType", "System`"}},
          ButtonNote->"System`"]},
        {
         ButtonBox["DefaultTextInlineFormatType",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3528551439-6176860", {
            "DefaultTextInlineFormatType", "System`"}},
          ButtonNote->"System`"], 
         ButtonBox["$MachineType",
          BaseStyle->"InformationLink",
          ButtonData:>{"Info3528551439-6176860", {"$MachineType", "System`"}},
          ButtonNote->"System`"]},
        {
         ButtonBox["FeedbackType",
          BaseStyle->"InformationLink",
          ButtonData:>{"Info3528551439-6176860", {"FeedbackType", "System`"}},
          ButtonNote->"System`"], 
         ButtonBox["$ProcessorType",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3528551439-6176860", {"$ProcessorType", "System`"}},
          ButtonNote->"System`"]},
        {
         ButtonBox["FileType",
          BaseStyle->"InformationLink",
          ButtonData:>{"Info3528551439-6176860", {"FileType", "System`"}},
          ButtonNote->"System`"], ""}
       },
       DefaultBaseStyle->"InfoGrid",
       GridBoxItemSize->{"Columns" -> {{
            Scaled[0.475]}}}]}
    },
    GridBoxAlignment->{"Columns" -> {{Left}}, "Rows" -> {{Baseline}}}]}, 
   Dynamic[Typeset`open$$],
   ImageSize->Automatic]], "\n", 
 DynamicModuleBox[{Typeset`open$$ = True}, 
  PaneSelectorBox[{False->
   RowBox[{
    OpenerBox[Dynamic[Typeset`open$$],
     ImageSize->Small], 
    StyleBox["QuantLib`", "InfoHeading"]}], True->GridBox[{
     {
      RowBox[{
       OpenerBox[Dynamic[Typeset`open$$],
        ImageSize->Small], 
       StyleBox["QuantLib`", "InfoHeading"]}]},
     {GridBox[{
        {
         ButtonBox["CapFloorType",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3528551439-6176860", {"CapFloorType", "QuantLib`"}},
          ButtonNote->"QuantLib`"], 
         ButtonBox["LeftConditionType",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3528551439-6176860", {"LeftConditionType", "QuantLib`"}},
          ButtonNote->"QuantLib`"], 
         ButtonBox["RightConditionType",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3528551439-6176860", {"RightConditionType", "QuantLib`"}},
          ButtonNote->"QuantLib`"]},
        {
         ButtonBox["CmsCouponPricerType",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3528551439-6176860", {"CmsCouponPricerType", "QuantLib`"}},
          ButtonNote->"QuantLib`"], 
         ButtonBox["OvernightIndexedSwapType",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3528551439-6176860", {
            "OvernightIndexedSwapType", "QuantLib`"}},
          ButtonNote->"QuantLib`"], 
         ButtonBox["SettlementType",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3528551439-6176860", {"SettlementType", "QuantLib`"}},
          ButtonNote->"QuantLib`"]},
        {
         ButtonBox["DurationType",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3528551439-6176860", {"DurationType", "QuantLib`"}},
          ButtonNote->"QuantLib`"], 
         ButtonBox["PayoffOptionType",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3528551439-6176860", {"PayoffOptionType", "QuantLib`"}},
          ButtonNote->"QuantLib`"], 
         ButtonBox["SwaptionSettlementType",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3528551439-6176860", {"SwaptionSettlementType", "QuantLib`"}},
          ButtonNote->"QuantLib`"]},
        {
         ButtonBox["GetEnumerationType",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3528551439-6176860", {"GetEnumerationType", "QuantLib`"}},
          ButtonNote->"QuantLib`"], 
         ButtonBox["PriceType",
          BaseStyle->"InformationLink",
          ButtonData:>{"Info3528551439-6176860", {"PriceType", "QuantLib`"}},
          ButtonNote->"QuantLib`"], 
         ButtonBox["SwaptionType",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3528551439-6176860", {"SwaptionType", "QuantLib`"}},
          ButtonNote->"QuantLib`"]},
        {
         ButtonBox["InterpolationType",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3528551439-6176860", {"InterpolationType", "QuantLib`"}},
          ButtonNote->"QuantLib`"], 
         ButtonBox["QLType",
          BaseStyle->"InformationLink",
          ButtonData:>{"Info3528551439-6176860", {"QLType", "QuantLib`"}},
          ButtonNote->"QuantLib`"], 
         ButtonBox["VanillaSwapType",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3528551439-6176860", {"VanillaSwapType", "QuantLib`"}},
          ButtonNote->"QuantLib`"]}
       },
       DefaultBaseStyle->"InfoGrid",
       GridBoxItemSize->{"Columns" -> {{
            Scaled[0.31666666666666665`]}}}]}
    },
    GridBoxAlignment->{"Columns" -> {{Left}}, "Rows" -> {{Baseline}}}]}, 
   Dynamic[Typeset`open$$],
   ImageSize->Automatic]]}], "Print", "InfoCell",
 CellChangeTimes->{3.5285442394379997`*^9}],

Cell[BoxData[
 StyleBox["\<\"GetEnumerationType[enumeration] returns the values for a \
QuantLib enumeration.\"\>", "MSG"]], "Print", "PrintUsage",
 CellTags->"Info3528551439-6176860"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"GetEnumerationTypes", "[", "]"}]], "Input",
 CellChangeTimes->{{3.5285442814692497`*^9, 3.5285442983442497`*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"\<\"Calendar\"\>", ",", "\<\"Currency\"\>", 
   ",", "\<\"DayCounter\"\>", ",", "\<\"Average::Type\"\>", 
   ",", "\<\"Barrier::Type\"\>", ",", "\<\"BusinessDayConvention\"\>", 
   ",", "\<\"Callability::Price::Type\"\>", ",", "\<\"Callability::Type\"\>", 
   ",", "\<\"CapFloor::Type\"\>", 
   ",", "\<\"CmsMarketCalibration::CalibrationType\"\>", 
   ",", "\<\"Compounding\"\>", 
   ",", "\<\"CubicInterpolation::BoundaryCondition\"\>", 
   ",", "\<\"CubicInterpolation::DerivativeApprox\"\>", 
   ",", "\<\"DateGeneration::Rule\"\>", ",", "\<\"Duration::Type\"\>", 
   ",", "\<\"EndCriteria::Type\"\>", ",", "\<\"Frequency\"\>", 
   ",", "\<\"GFunctionFactory::YieldCurveModel\"\>", ",", "\<\"Month\"\>", 
   ",", "\<\"Option::Type\"\>", ",", "\<\"OvernightIndexedSwap::Type\"\>", 
   ",", "\<\"Position::Type\"\>", ",", "\<\"PriceType\"\>", 
   ",", "\<\"Protection::Side\"\>", ",", "\<\"Replication::Type\"\>", 
   ",", "\<\"SalvagingAlgorithm::Type\"\>", 
   ",", "\<\"SensitivityAnalysis\"\>", ",", "\<\"Settlement::Type\"\>", 
   ",", "\<\"TimeUnit\"\>", ",", "\<\"VanillaSwap::Type\"\>", 
   ",", "\<\"Weekday\"\>", 
   ",", "\<\"InterpolatedDefaultCurve::Interpolator\"\>", 
   ",", "\<\"InterpolatedDefaultCurve::Traits\"\>", 
   ",", "\<\"InterpolatedYieldCurve::Interpolator\"\>", 
   ",", "\<\"InterpolatedYieldCurve::Traits\"\>", 
   ",", "\<\"RateHelper::DepoInclusionCriteria\"\>", 
   ",", "\<\"SwapIndex::FixingType\"\>"}], "}"}]], "Output",
 CellChangeTimes->{{3.5285442871567497`*^9, 3.5285442989536247`*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"QLType", "[", "]"}]], "Input",
 CellChangeTimes->{{3.5285442655161247`*^9, 3.5285442692504997`*^9}}],

Cell[BoxData[
 RowBox[{"QLType", "[", "]"}]], "Output",
 CellChangeTimes->{3.5285442701098747`*^9}]
}, Open  ]]
}, Open  ]]
}, Open  ]]
}, Open  ]]
}, Open  ]]
},
WindowSize->{716, 867},
WindowMargins->{{Automatic, 62}, {Automatic, 0}},
ShowSelection->True,
FrontEndVersion->"8.0 for Microsoft Windows (32-bit) (February 23, 2011)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "Info3528549938-6176860"->{
  Cell[57386, 1265, 251, 5, 54, "Print",
   CellTags->"Info3528549938-6176860"]},
 "Info3528551439-6176860"->{
  Cell[237684, 4333, 184, 3, 54, "Print",
   CellTags->"Info3528551439-6176860"]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"Info3528549938-6176860", 240283, 4402},
 {"Info3528551439-6176860", 240394, 4405}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[579, 22, 106, 1, 83, "Title"],
Cell[CellGroupData[{
Cell[710, 27, 144, 2, 31, "Input"],
Cell[CellGroupData[{
Cell[879, 33, 2000, 48, 62, "Print"],
Cell[2882, 83, 2870, 71, 100, "Print"],
Cell[5755, 156, 943, 12, 214, "Print"],
Cell[6701, 170, 315, 10, 42, "Print"],
Cell[7019, 182, 185, 2, 23, "Print"],
Cell[7207, 186, 397, 8, 23, "Print"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[7653, 200, 119, 1, 71, "Section"],
Cell[CellGroupData[{
Cell[7797, 205, 866, 19, 52, "Input"],
Cell[8666, 226, 516, 8, 30, "Output"]
}, Open  ]],
Cell[9197, 237, 1682, 37, 114, "Input"],
Cell[CellGroupData[{
Cell[10904, 278, 667, 11, 52, "Input"],
Cell[11574, 291, 7383, 128, 223, "Output"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[19006, 425, 238, 3, 71, "Section"],
Cell[19247, 430, 259, 5, 47, "Text"],
Cell[CellGroupData[{
Cell[19531, 439, 185, 3, 31, "Input"],
Cell[19719, 444, 276, 5, 30, "Output"]
}, Open  ]],
Cell[20010, 452, 178, 4, 29, "Text"],
Cell[CellGroupData[{
Cell[20213, 460, 139, 2, 31, "Input"],
Cell[20355, 464, 528, 10, 69, "Output"]
}, Open  ]],
Cell[20898, 477, 1345, 37, 112, "Input"]
}, Open  ]],
Cell[CellGroupData[{
Cell[22280, 519, 115, 1, 71, "Section"],
Cell[CellGroupData[{
Cell[22420, 524, 117, 1, 36, "Subsection"],
Cell[CellGroupData[{
Cell[22562, 529, 1094, 23, 92, "Input"],
Cell[23659, 554, 1963, 31, 30, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[25659, 590, 675, 17, 92, "Input"],
Cell[26337, 609, 629, 9, 30, "Output"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[27015, 624, 151, 2, 36, "Subsection"],
Cell[CellGroupData[{
Cell[27191, 630, 1967, 50, 192, "Input"],
Cell[29161, 682, 2044, 32, 164, "Output"],
Cell[31208, 716, 1259, 17, 30, "Output"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[32516, 739, 168, 2, 36, "Subsection"],
Cell[CellGroupData[{
Cell[32709, 745, 1596, 40, 132, "Input"],
Cell[34308, 787, 2184, 34, 30, "Output"],
Cell[36495, 823, 2005, 29, 30, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[38537, 857, 180, 2, 27, "Subsubsection"],
Cell[38720, 861, 836, 21, 92, "Input"],
Cell[39559, 884, 1194, 23, 92, "Input"],
Cell[40756, 909, 970, 17, 52, "Input"],
Cell[CellGroupData[{
Cell[41751, 930, 470, 11, 52, "Input"],
Cell[42224, 943, 2681, 38, 30, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[44942, 986, 664, 16, 72, "Input"],
Cell[45609, 1004, 4428, 74, 117, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[50074, 1083, 409, 10, 31, "Input"],
Cell[50486, 1095, 1682, 31, 50, "Output"]
}, Open  ]],
Cell[52183, 1129, 349, 8, 31, "Input"],
Cell[CellGroupData[{
Cell[52557, 1141, 519, 10, 52, "Input"],
Cell[53079, 1153, 391, 6, 30, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[53507, 1164, 371, 8, 52, "Input"],
Cell[53881, 1174, 360, 5, 30, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[54278, 1184, 493, 9, 52, "Input"],
Cell[54774, 1195, 333, 4, 30, "Output"]
}, Open  ]],
Cell[55122, 1202, 350, 10, 52, "Input"],
Cell[CellGroupData[{
Cell[55497, 1216, 470, 10, 31, "Input"],
Cell[55970, 1228, 627, 10, 30, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[56634, 1243, 356, 8, 31, "Input"],
Cell[56993, 1253, 220, 3, 30, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[57250, 1261, 133, 2, 31, "Input"],
Cell[57386, 1265, 251, 5, 54, "Print",
 CellTags->"Info3528549938-6176860"]
}, Open  ]],
Cell[CellGroupData[{
Cell[57674, 1275, 1197, 30, 92, "Input",
 Evaluatable->False],
Cell[58874, 1307, 170317, 2786, 270, 121805, 1989, "CachedBoxData", \
"BoxData", "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[229228, 4098, 118, 2, 31, "Input"],
Cell[CellGroupData[{
Cell[229371, 4104, 8310, 227, 402, "Print"],
Cell[237684, 4333, 184, 3, 54, "Print",
 CellTags->"Info3528551439-6176860"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[237917, 4342, 137, 2, 31, "Input"],
Cell[238057, 4346, 1570, 27, 240, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[239664, 4378, 124, 2, 31, "Input"],
Cell[239791, 4382, 99, 2, 30, "Output"]
}, Open  ]]
}, Open  ]]
}, Open  ]]
}, Open  ]]
}, Open  ]]
}
]
*)

(* End of internal cache information *)
