(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 8.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       157,          7]
NotebookDataLength[     21550,        699]
NotebookOptionsPosition[     17550,        548]
NotebookOutlinePosition[     19027,        598]
CellTagsIndexPosition[     18901,        592]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell["BondCurve", "Title",
 CellChangeTimes->{{3.51938206425*^9, 3.51938206646875*^9}},
 CellID->197610336],

Cell[BoxData[
 RowBox[{"Needs", "[", "\"\<QuantLib`\>\"", "]"}]], "Input",
 CellChangeTimes->{{3.519362707421875*^9, 3.519362718953125*^9}, 
   3.519362842390625*^9},
 CellLabel->"In[1]:=",
 CellID->619650180],

Cell[CellGroupData[{

Cell["Defining a bond portfolio", "Section",
 CellChangeTimes->{{3.519382812453125*^9, 3.519382821125*^9}},
 CellID->410327521],

Cell[BoxData[
 RowBox[{
  RowBox[{"pfo", " ", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"1990", ",", "12", ",", "22"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"2010", ",", "12", ",", "22"}], "}"}], ",", "\"\<1Y\>\""}], 
      "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"1991", ",", "12", ",", "18"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"2011", ",", "12", ",", "18"}], "}"}], ",", "\"\<6M\>\""}], 
      "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"1994", ",", "9", ",", "16"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"2014", ",", "9", ",", "16"}], "}"}], ",", "\"\<3M\>\""}], 
      "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"1997", ",", "12", ",", "5"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"2017", ",", "12", ",", "5"}], "}"}], ",", "\"\<1Y\>\""}], 
      "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"2000", ",", "2", ",", "1"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"2020", ",", "2", ",", "1"}], "}"}], ",", "\"\<1Y\>\""}], 
      "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"2003", ",", "6", ",", "20"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"2023", ",", "6", ",", "20"}], "}"}], ",", "\"\<1Y\>\""}], 
      "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"2004", ",", "12", ",", "19"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"2024", ",", "12", ",", "19"}], "}"}], ",", "\"\<1Y\>\""}], 
      "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"2009", ",", "7", ",", "18"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"2029", ",", "7", ",", "18"}], "}"}], ",", "\"\<1Y\>\""}], 
      "}"}]}], "}"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.519382245875*^9, 3.51938228428125*^9}},
 CellLabel->"In[2]:=",
 CellID->16860690],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"sdl", " ", "=", " ", 
  RowBox[{"Apply", "[", 
   RowBox[{"Schedule", ",", "pfo", ",", 
    RowBox[{"{", "1", "}"}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.51938236328125*^9, 3.51938239121875*^9}, {
  3.519382434484375*^9, 3.51938243621875*^9}, {3.519390417578125*^9, 
  3.51939041896875*^9}},
 CellLabel->"In[3]:=",
 CellID->673045251],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "Schedule3", ",", "Schedule4", ",", "Schedule5", ",", "Schedule6", ",", 
   "Schedule7", ",", "Schedule8", ",", "Schedule9", ",", "Schedule10"}], 
  "}"}]], "Output",
 CellChangeTimes->{3.51938239209375*^9, 3.51938243696875*^9, 
  3.5193903118125*^9, 3.519390419875*^9, 3.519444217234375*^9, 
  3.519445459921875*^9, 3.521362190328125*^9, 3.528705852078125*^9, 
  3.528705976515625*^9, 3.52870636746875*^9, 3.52870661571875*^9},
 CellLabel->"Out[3]=",
 CellID->86016014]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"coupons", "=", " ", 
  RowBox[{"{", 
   RowBox[{
   "0.0525`", ",", "0.055`", ",", "0.0675`", ",", "0.045`", ",", "0.03`", ",",
     "0.0375`", ",", "0.0425`", ",", "0.05`"}], "}"}]}]], "Input",
 CellChangeTimes->{{3.519390658390625*^9, 3.5193906638125*^9}, 
   3.519390710578125*^9},
 CellLabel->"In[4]:=",
 CellID->319389866],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "0.0525`", ",", "0.055`", ",", "0.0675`", ",", "0.045`", ",", "0.03`", ",", 
   "0.0375`", ",", "0.0425`", ",", "0.05`"}], "}"}]], "Output",
 CellChangeTimes->{3.5193907115625*^9, 3.519444217703125*^9, 
  3.5194454601875*^9, 3.5213621904375*^9, 3.52870585221875*^9, 
  3.5287060528125*^9, 3.528706390984375*^9, 3.52870661653125*^9},
 CellLabel->"Out[4]=",
 CellID->355562889]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"bonds", " ", "=", 
  RowBox[{"MapThread", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"FixedRateBond", "[", 
      RowBox[{"#1", ",", 
       RowBox[{"{", "#2", "}"}]}], "]"}], "&"}], ",", 
    RowBox[{"{", 
     RowBox[{"sdl", ",", "coupons"}], "}"}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.519390670375*^9, 3.5193907146875*^9}, {
  3.5193907941875*^9, 3.519390797015625*^9}, {3.528706043734375*^9, 
  3.528706047984375*^9}},
 CellLabel->"In[5]:=",
 CellID->391031642],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "FixedRateBond11", ",", "FixedRateBond12", ",", "FixedRateBond13", ",", 
   "FixedRateBond14", ",", "FixedRateBond15", ",", "FixedRateBond16", ",", 
   "FixedRateBond17", ",", "FixedRateBond18"}], "}"}]], "Output",
 CellChangeTimes->{3.519390717390625*^9, 3.5193907976875*^9, 
  3.519444217859375*^9, 3.519445460328125*^9, 3.5213621905*^9, 
  3.52870585240625*^9, 3.52870605378125*^9, 3.528706392140625*^9, 
  3.528706617359375*^9},
 CellLabel->"Out[5]=",
 CellID->807319460]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"cleanprice", " ", "=", 
  RowBox[{"{", 
   RowBox[{
   "0.`", ",", "100.16837277243683`", ",", "104.97889859152706`", ",", 
    "96.58949207769449`", ",", "85.49715807896186`", ",", 
    "87.88962679928586`", ",", "91.55798995459685`", ",", 
    "98.48035550720611`"}], "}"}]}]], "Input",
 CellChangeTimes->{{3.519390760890625*^9, 3.51939076403125*^9}},
 CellLabel->"In[6]:=",
 CellID->394883208],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "0.`", ",", "100.16837277243683`", ",", "104.97889859152706`", ",", 
   "96.58949207769449`", ",", "85.49715807896186`", ",", "87.88962679928586`",
    ",", "91.55798995459685`", ",", "98.48035550720611`"}], "}"}]], "Output",
 CellChangeTimes->{3.519390764703125*^9, 3.51944421790625*^9, 
  3.519445460359375*^9, 3.521362190546875*^9, 3.528705852453125*^9, 
  3.528706056671875*^9, 3.5287063930625*^9, 3.528706619125*^9},
 CellLabel->"Out[6]=",
 CellID->586134178]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", "BondHelper"}]], "Input",
 CellChangeTimes->{{3.519390778859375*^9, 3.519390782953125*^9}},
 CellLabel->"In[12]:=",
 CellID->1598093],

Cell[BoxData[
 StyleBox["\<\"BondHelper[ObjecctId_Symbol,CleanPrice_,Bond_Symbol] Construct \
an object of class BondHelper and return its id\\n      \\nObjectId: id of \
object to be created\\nCleanPrice: cleanPrice.\\nBond: Bond object \
ID.\\nPermanent: object permanent/nonpermanent\"\>", "MSG"]], "Print", \
"PrintUsage",
 CellChangeTimes->{3.528706058984375*^9},
 CellTags->"Info3528713258-8747372",
 CellID->324244739]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"bondhelper", " ", "=", 
  RowBox[{"MapThread", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"BondHelper", "[", 
      RowBox[{"#1", ",", "#2"}], "]"}], "&"}], ",", 
    RowBox[{"{", 
     RowBox[{"cleanprice", ",", "bonds"}], "}"}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.519390790109375*^9, 3.519390834984375*^9}, {
  3.519391021234375*^9, 3.519391024875*^9}},
 CellLabel->"In[7]:=",
 CellID->393725571],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "BondHelper19", ",", "BondHelper20", ",", "BondHelper21", ",", 
   "BondHelper22", ",", "BondHelper23", ",", "BondHelper24", ",", 
   "BondHelper25", ",", "BondHelper26"}], "}"}]], "Output",
 CellChangeTimes->{3.51939083675*^9, 3.51939102546875*^9, 3.51944421865625*^9,
   3.519445460671875*^9, 3.521362190921875*^9, 3.528705852984375*^9, 
  3.528706067421875*^9, 3.52870639759375*^9, 3.528706623515625*^9},
 CellLabel->"Out[7]=",
 CellID->61887551]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", "PiecewiseYieldCurve*"}]], "Input",
 CellChangeTimes->{{3.51939092746875*^9, 3.519390946703125*^9}, 
   3.519390989828125*^9},
 CellLabel->"In[8]:=",
 CellID->515639080],

Cell[BoxData[
 DynamicModuleBox[{Typeset`open$$ = True}, 
  PaneSelectorBox[{False->
   RowBox[{
    OpenerBox[Dynamic[Typeset`open$$],
     ImageSize->Small], 
    StyleBox["QuantLib`", "InfoHeading"]}], True->GridBox[{
     {
      RowBox[{
       OpenerBox[Dynamic[Typeset`open$$],
        ImageSize->Small], 
       StyleBox["QuantLib`", "InfoHeading"]}]},
     {GridBox[{
        {
         ButtonBox["PiecewiseYieldCurve",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3528713825-3718181", {"PiecewiseYieldCurve", "QuantLib`"}},
          ButtonNote->"QuantLib`"], 
         ButtonBox["PiecewiseYieldCurveJumpTimes",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3528713825-3718181", {
            "PiecewiseYieldCurveJumpTimes", "QuantLib`"}},
          ButtonNote->"QuantLib`"]},
        {
         ButtonBox["PiecewiseYieldCurveData",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3528713825-3718181", {"PiecewiseYieldCurveData", "QuantLib`"}},
          ButtonNote->"QuantLib`"], 
         ButtonBox["PiecewiseYieldCurves",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3528713825-3718181", {"PiecewiseYieldCurves", "QuantLib`"}},
          ButtonNote->"QuantLib`"]},
        {
         ButtonBox["PiecewiseYieldCurveDates",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3528713825-3718181", {
            "PiecewiseYieldCurveDates", "QuantLib`"}},
          ButtonNote->"QuantLib`"], 
         ButtonBox["PiecewiseYieldCurveTimes",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3528713825-3718181", {
            "PiecewiseYieldCurveTimes", "QuantLib`"}},
          ButtonNote->"QuantLib`"]},
        {
         ButtonBox["PiecewiseYieldCurveJumpDates",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3528713825-3718181", {
            "PiecewiseYieldCurveJumpDates", "QuantLib`"}},
          ButtonNote->"QuantLib`"], ""}
       },
       DefaultBaseStyle->"InfoGrid",
       GridBoxItemSize->{"Columns" -> {{
            Scaled[0.475]}}}]}
    },
    GridBoxAlignment->{"Columns" -> {{Left}}, "Rows" -> {{Baseline}}}]}, 
   Dynamic[Typeset`open$$],
   ImageSize->Automatic]]], "Print", "InfoCell",
 CellChangeTimes->{3.528706625328125*^9},
 CellID->816616492]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"yc", " ", "=", 
   RowBox[{"PiecewiseYieldCurve", "[", 
    RowBox[{"bondhelper", ",", 
     RowBox[{"Calendar", "\[Rule]", "\"\<Target\>\""}]}], "]"}]}], 
  ";"}]], "Input",
 CellChangeTimes->{{3.519391009078125*^9, 3.51939104534375*^9}, 
   3.51944418353125*^9, {3.519444371375*^9, 3.51944438690625*^9}, {
   3.519444611859375*^9, 3.51944462196875*^9}, {3.519444656375*^9, 
   3.519444663171875*^9}, 3.5287066339375*^9},
 CellLabel->"In[9]:=",
 CellID->66551678],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"BondSettlementDate", "[", 
  RowBox[{"bonds", "[", 
   RowBox[{"[", "1", "]"}], "]"}], "]"}]], "Input",
 CellChangeTimes->{{3.519445283921875*^9, 3.519445299625*^9}},
 CellLabel->"In[10]:=",
 CellID->126374711],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"2011", ",", "10", ",", "31"}], "}"}]], "Output",
 CellChangeTimes->{3.519445300390625*^9, 3.51944546096875*^9, 
  3.52136219125*^9, 3.528706072609375*^9, 3.528706417578125*^9, 
  3.52870663571875*^9},
 CellLabel->"Out[10]=",
 CellID->76300609]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"BondSettlementDate", "[", 
  RowBox[{"bonds", "[", 
   RowBox[{"[", 
    RowBox[{"-", "1"}], "]"}], "]"}], "]"}]], "Input",
 CellLabel->"In[11]:=",
 CellID->52910670],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"2011", ",", "10", ",", "31"}], "}"}]], "Output",
 CellChangeTimes->{3.519445333609375*^9, 3.519445461015625*^9, 
  3.521362191296875*^9, 3.528706073546875*^9, 3.528706418609375*^9, 
  3.5287066366875*^9},
 CellLabel->"Out[11]=",
 CellID->539528636]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"BondSettlementDate", " ", "/@", " ", "bonds"}]], "Input",
 CellChangeTimes->{{3.51944534003125*^9, 3.519445357609375*^9}},
 CellLabel->"In[12]:=",
 CellID->452845979],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"2011", ",", "10", ",", "31"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"2011", ",", "10", ",", "31"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"2011", ",", "10", ",", "31"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"2011", ",", "10", ",", "31"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"2011", ",", "10", ",", "31"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"2011", ",", "10", ",", "31"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"2011", ",", "10", ",", "31"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"2011", ",", "10", ",", "31"}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{3.51944535825*^9, 3.5194454610625*^9, 3.5213621915*^9, 
  3.528706075*^9, 3.5287064195625*^9, 3.528706637421875*^9},
 CellLabel->"Out[12]=",
 CellID->410461055]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"YieldTSDiscount", "[", 
  RowBox[{"yc", ",", 
   RowBox[{"BondSettlementDate", "[", 
    RowBox[{"bonds", "[", 
     RowBox[{"[", "1", "]"}], "]"}], "]"}]}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"YieldTSDiscount", "[", 
  RowBox[{"yc", ",", 
   RowBox[{"BondMaturityDate", "[", 
    RowBox[{"bonds", "[", 
     RowBox[{"[", 
      RowBox[{"-", "1"}], "]"}], "]"}], "]"}]}], "]"}]}], "Input",
 CellChangeTimes->{{3.519444439234375*^9, 3.519444520359375*^9}, {
  3.519445086453125*^9, 3.519445105453125*^9}, {3.5194453085625*^9, 
  3.519445321296875*^9}, {3.51944539859375*^9, 3.519445407203125*^9}},
 CellLabel->"In[13]:=",
 CellID->640576275],

Cell[BoxData["1.`"], "Output",
 CellChangeTimes->{
  3.519444474796875*^9, 3.519444520921875*^9, 3.519444628515625*^9, 
   3.519444701328125*^9, {3.5194450979375*^9, 3.519445105921875*^9}, 
   3.51944532178125*^9, 3.51944540871875*^9, 3.51944546128125*^9, 
   3.52136219159375*^9, 3.528706076609375*^9, 3.528706420703125*^9, 
   3.52870663834375*^9},
 CellLabel->"Out[13]=",
 CellID->24118185],

Cell[BoxData["0.4125177942924868`"], "Output",
 CellChangeTimes->{
  3.519444474796875*^9, 3.519444520921875*^9, 3.519444628515625*^9, 
   3.519444701328125*^9, {3.5194450979375*^9, 3.519445105921875*^9}, 
   3.51944532178125*^9, 3.51944540871875*^9, 3.51944546128125*^9, 
   3.52136219159375*^9, 3.528706076609375*^9, 3.528706420703125*^9, 
   3.52870663834375*^9},
 CellLabel->"Out[14]=",
 CellID->321980119]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", "BondEngine"}]], "Input",
 CellChangeTimes->{{3.519390894984375*^9, 3.519390897046875*^9}},
 CellLabel->"In[15]:=",
 CellID->46039928],

Cell[BoxData[
 StyleBox["\<\"BondEngine[ObjecctId_Symbol,YieldCurve_Symbol] Construct an \
object of class BondEngine and return its id\\n      \\nObjectId: id of \
object to be created\\nYieldCurve: discounting yield term structure object \
ID.\\nPermanent: object permanent/nonpermanent\"\>", "MSG"]], "Print", \
"PrintUsage",
 CellChangeTimes->{3.52870664334375*^9},
 CellTags->"Info3528713843-3718181",
 CellID->430932266]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"be", " ", "=", " ", 
   RowBox[{"BondEngine", "[", "yc", "]"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.51944436421875*^9, 3.51944439815625*^9}},
 CellLabel->"In[16]:=",
 CellID->57679046],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Map", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"InstrumentSetPricingEngine", "[", 
     RowBox[{"#", ",", "be"}], "]"}], "&"}], ",", "bonds"}], "]"}]], "Input",
 CellChangeTimes->{{3.51944514546875*^9, 3.519445190421875*^9}},
 CellLabel->"In[17]:=",
 CellID->122293742],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "True", ",", "True", ",", "True", ",", "True", ",", "True", ",", "True", 
   ",", "True", ",", "True"}], "}"}]], "Output",
 CellChangeTimes->{3.519445191359375*^9, 3.519445461671875*^9, 
  3.521362191953125*^9, 3.528706094109375*^9, 3.52870664628125*^9},
 CellLabel->"Out[17]=",
 CellID->266249996]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Map", "[", 
  RowBox[{"BondCleanPrice", " ", ",", "bonds"}], "]"}]], "Input",
 CellChangeTimes->{{3.519445216890625*^9, 3.519445250765625*^9}},
 CellLabel->"In[18]:=",
 CellID->174983830],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "0.`", ",", "100.16837277243681`", ",", "104.97889859154176`", ",", 
   "96.58949207768086`", ",", "85.49715807896195`", ",", "87.8896267992946`", 
   ",", "91.55798995459683`", ",", "98.48035550720611`"}], "}"}]], "Output",
 CellChangeTimes->{3.519445251453125*^9, 3.51944546175*^9, 3.521362192*^9, 
  3.52870609528125*^9, 3.52870664725*^9},
 CellLabel->"Out[18]=",
 CellID->235671450]
}, Open  ]]
}, Open  ]]
}, Open  ]]
},
FileChangeProtection->None,
Editable->True,
WindowSize->{717, 748},
WindowMargins->{{Automatic, 168}, {89, Automatic}},
WindowFrame->"Normal",
DockedCells->FEPrivate`FrontEndResource["FEExpressions", "HelpViewerToolbar"],
PageHeaders->{{None, None, None}, {None, None, 
   Cell[
    TextData[{
      Cell[
       TextData[{"Printed from [[YOUR APPLICATION'S NAME]] documentation "}], 
       "PageHeader"], 
      Cell[
       TextData[{
         CounterBox["Page"]}], "PageNumber"]}], 
    CellMargins -> {{Inherited, -29}, {Inherited, Inherited}}]}},
PageFooters->{{None, None, None}, {
   Cell[
    TextData[{"\[Copyright] 2008 Weber & Partner. All rights reserved."}], 
    "PageFooter"], None, None}},
ShowSelection->True,
TaggingRules->{"LinkTrails" -> "", "SearchTextTranslated" -> ""},
CreateCellID->True,
ShowCellTags->False,
Magnification->1.,
FrontEndVersion->"8.0 for Microsoft Windows (32-bit) (February 23, 2011)",
StyleDefinitions->"HelpBrowser.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "Info3528713258-8747372"->{
  Cell[7045, 223, 425, 8, 124, "Print",
   CellTags->"Info3528713258-8747372",
   CellID->324244739]},
 "Info3528713843-3718181"->{
  Cell[15505, 483, 426, 8, 107, "Print",
   CellTags->"Info3528713843-3718181",
   CellID->430932266]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"Info3528713258-8747372", 18642, 581},
 {"Info3528713843-3718181", 18774, 585}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[579, 22, 107, 2, 103, "Title",
 CellID->197610336],
Cell[689, 26, 209, 5, 27, "Input",
 CellID->619650180],
Cell[CellGroupData[{
Cell[923, 35, 127, 2, 63, "Section",
 CellID->410327521],
Cell[1053, 39, 2059, 63, 88, "Input",
 CellID->16860690],
Cell[CellGroupData[{
Cell[3137, 106, 364, 9, 27, "Input",
 CellID->673045251],
Cell[3504, 117, 512, 11, 45, "Output",
 CellID->86016014]
}, Open  ]],
Cell[CellGroupData[{
Cell[4053, 133, 351, 9, 27, "Input",
 CellID->319389866],
Cell[4407, 144, 417, 9, 25, "Output",
 CellID->355562889]
}, Open  ]],
Cell[CellGroupData[{
Cell[4861, 158, 497, 14, 27, "Input",
 CellID->391031642],
Cell[5361, 174, 517, 11, 45, "Output",
 CellID->807319460]
}, Open  ]],
Cell[CellGroupData[{
Cell[5915, 190, 420, 10, 48, "Input",
 CellID->394883208],
Cell[6338, 202, 506, 10, 25, "Output",
 CellID->586134178]
}, Open  ]],
Cell[CellGroupData[{
Cell[6881, 217, 161, 4, 27, "Input",
 CellID->1598093],
Cell[7045, 223, 425, 8, 124, "Print",
 CellTags->"Info3528713258-8747372",
 CellID->324244739]
}, Open  ]],
Cell[CellGroupData[{
Cell[7507, 236, 431, 12, 27, "Input",
 CellID->393725571],
Cell[7941, 250, 491, 10, 45, "Output",
 CellID->61887551]
}, Open  ]],
Cell[CellGroupData[{
Cell[8469, 265, 197, 5, 27, "Input",
 CellID->515639080],
Cell[8669, 272, 2486, 72, 121, "Print",
 CellID->816616492]
}, Open  ]],
Cell[11170, 347, 499, 12, 27, "Input",
 CellID->66551678],
Cell[CellGroupData[{
Cell[11694, 363, 234, 6, 27, "Input",
 CellID->126374711],
Cell[11931, 371, 283, 7, 25, "Output",
 CellID->76300609]
}, Open  ]],
Cell[CellGroupData[{
Cell[12251, 383, 190, 6, 27, "Input",
 CellID->52910670],
Cell[12444, 391, 288, 7, 25, "Output",
 CellID->539528636]
}, Open  ]],
Cell[CellGroupData[{
Cell[12769, 403, 190, 4, 27, "Input",
 CellID->452845979],
Cell[12962, 409, 825, 22, 45, "Output",
 CellID->410461055]
}, Open  ]],
Cell[CellGroupData[{
Cell[13824, 436, 670, 16, 48, "Input",
 CellID->640576275],
Cell[14497, 454, 393, 8, 25, "Output",
 CellID->24118185],
Cell[14893, 464, 410, 8, 25, "Output",
 CellID->321980119]
}, Open  ]],
Cell[CellGroupData[{
Cell[15340, 477, 162, 4, 27, "Input",
 CellID->46039928],
Cell[15505, 483, 426, 8, 107, "Print",
 CellTags->"Info3528713843-3718181",
 CellID->430932266]
}, Open  ]],
Cell[15946, 494, 224, 6, 27, "Input",
 CellID->57679046],
Cell[CellGroupData[{
Cell[16195, 504, 293, 8, 27, "Input",
 CellID->122293742],
Cell[16491, 514, 340, 8, 25, "Output",
 CellID->266249996]
}, Open  ]],
Cell[CellGroupData[{
Cell[16868, 527, 211, 5, 27, "Input",
 CellID->174983830],
Cell[17082, 534, 428, 9, 25, "Output",
 CellID->235671450]
}, Open  ]]
}, Open  ]]
}, Open  ]]
}
]
*)

(* End of internal cache information *)
