(* Content-type: application/mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 6.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       145,          7]
NotebookDataLength[     89574,       2554]
NotebookOptionsPosition[     64783,       1761]
NotebookOutlinePosition[     78433,       2158]
CellTagsIndexPosition[     77745,       2138]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell["Getting Started", "Chapter"],

Cell[CellGroupData[{

Cell["Setting up the link to QuantLib", "SectionFirst",
 CellChangeTimes->{{3.435664033015625*^9, 3.435664042359375*^9}},
 CellTags->"Installing"],

Cell[TextData[{
 "The first step is to load the ",
 StyleBox["QuantLib",
  FontSlant->"Italic"],
 " package. "
}], "MathCaption",
 CellChangeTimes->{{3.43566408859375*^9, 3.435664090359375*^9}},
 CellTags->"Installing"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Needs", "[", "\"\<QuantLib`\>\"", "]"}]], "Input",
 CellChangeTimes->{{3.43566006271875*^9, 3.435660082703125*^9}, {
  3.43566551115625*^9, 3.435665518796875*^9}},
 CellTags->"Installing",
 CellLabel->"In[1]:="],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   TagBox[
    ButtonBox[
     PaneSelectorBox[{False->"\<\"QuantLib\"\>", True->
      StyleBox["\<\"QuantLib\"\>", "HyperlinkActive"]}, Dynamic[
       CurrentValue["MouseOver"]],
      BaseStyle->{"Hyperlink"},
      BaselinePosition->Baseline,
      FrameMargins->0,
      ImageSize->Automatic],
     BaseStyle->"Hyperlink",
     ButtonData->{
       URL["http://quantlib.org"], None},
     ButtonNote->"http://quantlib.org"],
    Annotation[#, "http://quantlib.org", "Hyperlink"]& ], 
   "\[InvisibleSpace]", "\<\" for Mathematica installed, Version \
0.2.6\\n\"\>", "\[InvisibleSpace]", "\<\"for \"\>", 
   "\[InvisibleSpace]", "\<\"Windows\"\>", 
   "\[InvisibleSpace]", "\<\" system \"\>", 
   "\[InvisibleSpace]", "\<\"Microsoft Windows (32-bit)\"\>", 
   "\[InvisibleSpace]", "\<\"\\n\"\>", 
   "\[InvisibleSpace]", "\<\"Mathematica Interface \[Copyright] by \"\>", 
   "\[InvisibleSpace]", 
   TagBox[
    ButtonBox[
     PaneSelectorBox[{False->"\<\"Weber & Partner\"\>", True->
      StyleBox["\<\"Weber & Partner\"\>", "HyperlinkActive"]}, Dynamic[
       CurrentValue["MouseOver"]],
      BaseStyle->{"Hyperlink"},
      BaselinePosition->Baseline,
      FrameMargins->0,
      ImageSize->Automatic],
     BaseStyle->"Hyperlink",
     ButtonData->{
       URL["http://www.weber-und-partner.com"], None},
     ButtonNote->"http://www.weber-und-partner.com"],
    Annotation[#, "http://www.weber-und-partner.com", "Hyperlink"]& ], 
   "\[InvisibleSpace]", "\<\" 2012\"\>"}],
  SequenceForm[
   Hyperlink["QuantLib", "http://quantlib.org"], 
   " for Mathematica installed, Version 0.2.6\n", "for ", "Windows", 
   " system ", "Microsoft Windows (32-bit)", "\n", 
   "Mathematica Interface \[Copyright] by ", 
   Hyperlink["Weber & Partner", "http://www.weber-und-partner.com"], " 2012"],
  Editable->False]], "Print",
 CellChangeTimes->{3.550318238901375*^9, 3.55031840113575*^9, 
  3.550318450057625*^9, 3.550318498995125*^9, 3.550318556526375*^9, 
  3.550318625120125*^9},
 CellTags->"Installing",
 CellLabel->"During evaluation of In[1]:=",
 CellID->384280253],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Visit \"\>", "\[InvisibleSpace]", 
   TagBox[
    ButtonBox[
     PaneSelectorBox[{
      False->"\<\"http://www.weber-und-partner.com/QuantLib/Mathematica\"\>", 
      True->
      StyleBox["\<\"http://www.weber-und-partner.com/QuantLib/Mathematica\"\>\
", "HyperlinkActive"]}, Dynamic[
       CurrentValue["MouseOver"]],
      BaseStyle->{"Hyperlink"},
      BaselinePosition->Baseline,
      FrameMargins->0,
      ImageSize->Automatic],
     BaseStyle->"Hyperlink",
     ButtonData->{
       URL["http://www.weber-und-partner.com/QuantLib/mma"], None},
     ButtonNote->"http://www.weber-und-partner.com/QuantLib/mma"],
    Annotation[#, "http://www.weber-und-partner.com/QuantLib/mma", 
     "Hyperlink"]& ], 
   "\[InvisibleSpace]", "\<\" for the latest version.\\nVisit \"\>", 
   "\[InvisibleSpace]", 
   TagBox[
    ButtonBox[
     PaneSelectorBox[{False->"\<\"http://quantlib.org/license.shtml\"\>", 
      True->
      StyleBox["\<\"http://quantlib.org/license.shtml\"\>", 
       "HyperlinkActive"]}, Dynamic[
       CurrentValue["MouseOver"]],
      BaseStyle->{"Hyperlink"},
      BaselinePosition->Baseline,
      FrameMargins->0,
      ImageSize->Automatic],
     BaseStyle->"Hyperlink",
     ButtonData->{
       URL["http://quantlib.org/license.shtml"], None},
     ButtonNote->"http://quantlib.org/license.shtml"],
    Annotation[#, "http://quantlib.org/license.shtml", "Hyperlink"]& ], 
   "\[InvisibleSpace]", "\<\" for the QuantLib license.\\nFor questions, \
support issues and enquiries mail to \"\>", "\[InvisibleSpace]", 
   TagBox[
    ButtonBox[
     PaneSelectorBox[{False->"\<\"quantLib@weber-und-partner.com\"\>", True->
      StyleBox["\<\"quantLib@weber-und-partner.com\"\>", "HyperlinkActive"]}, 
      Dynamic[
       CurrentValue["MouseOver"]],
      BaseStyle->{"Hyperlink"},
      BaselinePosition->Baseline,
      FrameMargins->0,
      ImageSize->Automatic],
     BaseStyle->"Hyperlink",
     ButtonData->{
       URL["mailto:quantLib@weber-und-partner.com"], None},
     ButtonNote->"mailto:quantLib@weber-und-partner.com"],
    Annotation[#, "mailto:quantLib@weber-und-partner.com", "Hyperlink"]& ], 
   "\[InvisibleSpace]", "\<\"\\n\"\>"}],
  SequenceForm["Visit ", 
   Hyperlink[
   "http://www.weber-und-partner.com/QuantLib/Mathematica", 
    "http://www.weber-und-partner.com/QuantLib/mma"], 
   " for the latest version.\nVisit ", 
   Hyperlink[
   "http://quantlib.org/license.shtml", "http://quantlib.org/license.shtml"], 
   " for the QuantLib license.\nFor questions, support issues and enquiries \
mail to ", 
   Hyperlink[
   "quantLib@weber-und-partner.com", "mailto:quantLib@weber-und-partner.com"],
    "\n"],
  Editable->False]], "Print",
 CellChangeTimes->{3.550318238901375*^9, 3.55031840113575*^9, 
  3.550318450057625*^9, 3.550318498995125*^9, 3.550318556526375*^9, 
  3.550318625182625*^9},
 CellTags->"Installing",
 CellLabel->"During evaluation of In[1]:=",
 CellID->155040551],

Cell[BoxData["\<\"THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND \
CONTRIBUTORS 'AS IS' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT \
NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A \
PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDERS OR \
CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, \
EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, \
PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; \
OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, \
WHETHER IN CONTRACT, STRICT LIABILITY OR TORT (INCLUDING NEGLIGENCE OR \
OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF \
ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.\\n\"\>"], "Print",
 CellChangeTimes->{3.550318238901375*^9, 3.55031840113575*^9, 
  3.550318450057625*^9, 3.550318498995125*^9, 3.550318556526375*^9, 
  3.550318625182625*^9},
 CellTags->"Installing",
 CellLabel->"During evaluation of In[1]:=",
 CellID->607534092],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"How", " ", "to", " ", "get", " ", "started"}], "MSG"], " ", 
  ButtonBox[
   StyleBox[">>", "SR"],
   Active->True,
   BaseStyle->"Link",
   ButtonData->"paclet:QuantLib/tutorial/Getting Started"]}]], "Print", \
"PrintUsage",
 CellChangeTimes->{3.550318625182625*^9},
 CellTags->"Installing",
 CellID->629518575],

Cell[BoxData["\<\"Setting default values:\"\>"], "Print",
 CellChangeTimes->{3.550318238901375*^9, 3.55031840113575*^9, 
  3.550318450057625*^9, 3.550318498995125*^9, 3.550318556526375*^9, 
  3.550318631057625*^9},
 CellTags->"Installing",
 CellLabel->"During evaluation of In[1]:=",
 CellID->56890738],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"  Setting Valuation Date = \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{"2012", ",", "7", ",", "3"}], "}"}]}],
  SequenceForm["  Setting Valuation Date = ", {2012, 7, 3}],
  Editable->False]], "Print",
 CellChangeTimes->{3.550318238901375*^9, 3.55031840113575*^9, 
  3.550318450057625*^9, 3.550318498995125*^9, 3.550318556526375*^9, 
  3.550318631120125*^9},
 CellTags->"Installing",
 CellLabel->"During evaluation of In[1]:=",
 CellID->9367767]
}, Open  ]],

Cell["The current version of Quantlib can be retrieved", "MathCaption",
 CellChangeTimes->{{3.435664135109375*^9, 3.43566417228125*^9}},
 CellTags->"Installing"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"QLVersion", "[", "]"}]], "Input",
 CellChangeTimes->{{3.427019691421875*^9, 3.427019696359375*^9}, {
  3.427192148875*^9, 3.42719215153125*^9}, {3.4354971245*^9, 
  3.435497130203125*^9}, {3.43566267321875*^9, 3.435662674046875*^9}, {
  3.550318256307625*^9, 3.5503182568545*^9}},
 CellTags->"Installing",
 CellLabel->"In[2]:="],

Cell[BoxData["\<\"1.3-debug\"\>"], "Output",
 CellChangeTimes->{
  3.430728655265625*^9, 3.43486177290625*^9, 3.4348871609375*^9, 
   3.4348876605625*^9, 3.43489209575*^9, 3.434954592828125*^9, 
   3.434958820359375*^9, 3.434958894484375*^9, 3.43496034521875*^9, 
   3.43496091278125*^9, 3.43496901578125*^9, 3.4349709519375*^9, 
   3.43497228253125*^9, 3.43497238465625*^9, 3.434973851421875*^9, 
   3.434976515609375*^9, 3.435036843953125*^9, 3.435041583625*^9, 
   3.435045706171875*^9, 3.43504886709375*^9, 3.435048951390625*^9, 
   3.43504960284375*^9, 3.435049969984375*^9, 3.435050813453125*^9, 
   3.435055936625*^9, 3.435064788890625*^9, 3.435065413234375*^9, 
   3.435295185484375*^9, 3.435297236109375*^9, 3.435298737296875*^9, 
   3.435298980171875*^9, 3.43529901465625*^9, 3.43529932525*^9, 
   3.43529953790625*^9, 3.43530085334375*^9, 3.43530088703125*^9, 
   3.4353009751875*^9, 3.435301646125*^9, 3.43531560271875*^9, 
   3.435317797203125*^9, 3.435319564109375*^9, 3.43532311915625*^9, 
   3.435401371859375*^9, 3.435472195390625*^9, 3.43547837996875*^9, 
   3.4354804841875*^9, 3.435485025578125*^9, 3.435497126953125*^9, 
   3.4354981245*^9, 3.435498167203125*^9, 3.4355539764375*^9, 
   3.435576443703125*^9, 3.43564369675*^9, 3.4356509786875*^9, 3.435651213*^9,
    3.435662520984375*^9, 3.4356625936875*^9, 3.435662628*^9, 
   3.435664107828125*^9, 3.43566552640625*^9, 3.43566628071875*^9, 
   3.435668065828125*^9, 3.435912769755978*^9, 3.436167696296875*^9, 
   3.436178621171875*^9, 3.4966553020071936`*^9, 3.5066789495625*^9, 
   3.50667953796875*^9, {3.5066836908125*^9, 3.506683694109375*^9}, 
   3.506749066140625*^9, 3.519095918859375*^9, 3.52136152446875*^9, 
   3.52136223115625*^9, 3.52783147046875*^9, {3.5503182539795*^9, 
   3.550318259995125*^9}, 3.550318570276375*^9, 3.55031863276075*^9},
 CellTags->"Installing",
 CellLabel->"Out[2]=",
 CellID->254741371]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Getting around", "Section",
 CellChangeTimes->{{3.413200946609375*^9, 3.413200950828125*^9}, {
  3.42719398759375*^9, 3.427193989953125*^9}},
 CellTags->"Getting Around"],

Cell["\<\
A list of available QuantLib categories is set up during installation and can \
be retrieved as\
\>", "Text",
 CellChangeTimes->{{3.427194029203125*^9, 3.4271940640625*^9}},
 CellTags->"Getting Around"],

Cell[CellGroupData[{

Cell[BoxData["QLCategories"], "Input",
 CellChangeTimes->{{3.427193994453125*^9, 3.427193998609375*^9}},
 CellTags->"Getting Around",
 CellLabel->"In[3]:="],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "Abcd", ",", "AccountingEngines", ",", "AlphaForm", ",", "AmortizingBonds", 
   ",", "AssetSwap", ",", "Bonds", ",", "BrownianGenerator", ",", "Calendar", 
   ",", "CalibrationHelpers", ",", "CapsFloors", ",", 
   "CapletVolatilityTermStructures", ",", "CmsMarket", ",", 
   "CmsMarketCalibration", ",", "Correlation", ",", "CouponVectors", ",", 
   "Credit", ",", "PiecewiseDefaultCurves", ",", "Ctsmmcapletcalibration", 
   ",", "CurveState", ",", "QLDate", ",", "Daycounter", ",", 
   "DefaultProbabilityTermStructures", ",", "Driftcalculators", ",", 
   "EvolutionDescription", ",", "Exercise", ",", "ForwardRateAgreement", ",", 
   "Handles", ",", "Indices", ",", "Instruments", ",", "QLInterpolations", 
   ",", "Leg", ",", "MarketModelEvolvers", ",", "MarketModels", ",", "Math", 
   ",", "Optimization", ",", "Options", ",", "OvernightIndexedSwap", ",", 
   "Payoffs", ",", "PiecewiseYieldCurves", ",", "Prices", ",", 
   "PricingEngines", ",", "Processes", ",", "Products", ",", "Quotes", ",", 
   "RandomSequenceGenerator", ",", "RangeAccrual", ",", "RateHelper", ",", 
   "Schedules", ",", "SequenceStatistics", ",", "Settings", ",", 
   "CalibratedModels", ",", "ShortRateModels", ",", "SmileSectionStructures", 
   ",", "Statistics", ",", "Swaps", ",", "Swaptions", ",", 
   "SwaptionVolatilityTermStructures", ",", "YieldTermStructures", ",", 
   "TimeGrids", ",", "TimeSeries", ",", "Utilities", ",", "VanillaSwap", ",", 
   "Volatilities", ",", "MarketModelVolatility", ",", "FittingMethods"}], 
  "}"}]], "Output",
 CellChangeTimes->{3.43565098153125*^9, 3.435651214859375*^9, 
  3.435662678125*^9, 3.435665530375*^9, 3.4356662843125*^9, 
  3.435668069546875*^9, 3.435912773755978*^9, 3.436167696359375*^9, 
  3.43617862121875*^9, 3.4966553081790686`*^9, 3.5066789554375*^9, 
  3.506679541640625*^9, 3.506683698921875*^9, 3.50674906621875*^9, 
  3.5190959223125*^9, 3.521362231234375*^9, 3.527831470546875*^9, 
  3.550318600307625*^9, 3.550318633417*^9},
 CellTags->"Getting Around",
 CellLabel->"Out[3]=",
 CellID->189936670]
}, Open  ]],

Cell["There is same basic information available on each category", "Text",
 CellChangeTimes->{{3.435651266390625*^9, 3.43565128978125*^9}},
 CellTags->"Getting Around"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", "Exercise"}]], "Input",
 CellTags->"Getting Around",
 CellLabel->"In[4]:="],

Cell[BoxData[
 RowBox[{
  StyleBox["\<\"functions to construct and use Exercise objects.\"\>", "MSG"],
   "\[NonBreakingSpace]", 
  ButtonBox[
   StyleBox["\[RightSkeleton]", "SR"],
   Active->True,
   BaseStyle->"Link",
   ButtonData->"paclet:QuantLib/ref/Exercise"]}]], "Print", "PrintUsage",
 CellChangeTimes->{3.550318633792*^9},
 CellTags->{"Getting Around", "Info3550325833-5601359"},
 CellID->327663261]
}, Open  ]],

Cell["\<\
The functions available in each category can be retrieved with the Category \
command\
\>", "Text",
 CellChangeTimes->{{3.427194067515625*^9, 3.4271941160625*^9}, {
  3.435651302328125*^9, 3.435651318046875*^9}},
 CellTags->"Getting Around"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Category", "[", "Exercise", "]"}]], "Input",
 CellChangeTimes->{{3.427194007953125*^9, 3.427194013453125*^9}},
 CellTags->"Getting Around",
 CellLabel->"In[5]:="],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "AmericanExercise", ",", "BermudanExercise", ",", "EuropeanExercise", ",", 
   "ExerciseDates", ",", "ExerciseLastDate"}], "}"}]], "Output",
 CellChangeTimes->CompressedData["
1:eJxTTMoPSmVkYGBQA2KGhleVM/pfOjI06M6qmg6kGX7atoNpIY5VYHrhbghd
/XY9iG6ws/efAeJf+AamG9pFAsD8cEkw3aDsAOHvi4LQa/9B6MdMgWD6OS+Y
bjiaCOEzXtsApvnu/wDTRV9/g+Wdhf+A6fdyENp9NeNMkLxgJROYXs7PDKbv
5oLpBiFfFiD9c0P4yWqwuJLTD7D4tul/gfQ7KymrcN5XQHHbmaUKQLpB7T6E
vvWsHEwHXpwOohlm96tYgOiPauU2IPG3X896vHIUiHBn3VT8yhEAimSCZg==

  "],
 CellTags->"Getting Around",
 CellLabel->"Out[5]=",
 CellID->571048658]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Category", "[", "PricingEngines", "]"}]], "Input",
 CellChangeTimes->{{3.42719402290625*^9, 3.4271940255*^9}, {
  3.427194123484375*^9, 3.42719412934375*^9}},
 CellTags->"Getting Around",
 CellLabel->"In[6]:="],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "AnalyticCapFloorEngine", ",", "BachelierBlackFormula", ",", 
   "BachelierBlackFormula2", ",", "BinomialPricingEngine", ",", 
   "BlackCalculator", ",", "BlackCalculator2", ",", "BlackCalculatorAlpha", 
   ",", "BlackCalculatorBeta", ",", "BlackCalculatorDelta", ",", 
   "BlackCalculatorDeltaForward", ",", "BlackCalculatorDividendRho", ",", 
   "BlackCalculatorElasticity", ",", "BlackCalculatorElasticityForward", ",", 
   "BlackCalculatorGamma", ",", "BlackCalculatorGammaForward", ",", 
   "BlackCalculatorItmAssetProbability", ",", 
   "BlackCalculatorItmCashProbability", ",", "BlackCalculatorRho", ",", 
   "BlackCalculatorStrikeSensitivity", ",", "BlackCalculatorTheta", ",", 
   "BlackCalculatorThetaPerDay", ",", "BlackCalculatorValue", ",", 
   "BlackCalculatorVega", ",", "BlackCapFloorEngine", ",", 
   "BlackCapFloorEngine2", ",", "BlackFormula", ",", "BlackFormula2", ",", 
   "BlackFormulaCashItmProbability", ",", "BlackFormulaCashItmProbability2", 
   ",", "BlackFormulaImpliedStdDev", ",", "BlackFormulaImpliedStdDev2", ",", 
   "BlackFormulaImpliedStdDevApproximation", ",", 
   "BlackFormulaImpliedStdDevApproximation2", ",", 
   "BlackFormulaStdDevDerivative", ",", "BlackFormulaStdDevDerivative2", ",", 
   "BlackScholesCalculator", ",", "BlackScholesCalculator2", ",", 
   "BlackScholesCalculatorDelta", ",", "BlackScholesCalculatorElasticity", 
   ",", "BlackScholesCalculatorGamma", ",", "BlackScholesCalculatorTheta", 
   ",", "BlackScholesCalculatorThetaPerDay", ",", "BlackSwaptionEngine", ",", 
   "BlackSwaptionEngine2", ",", "BondEngine", ",", "DiscountingSwapEngine", 
   ",", "PricingEngine", ",", "TreeCallableFixedRateBondEngine"}], 
  "}"}]], "Output",
 CellChangeTimes->{3.430728655359375*^9, 3.43486177878125*^9, 
  3.434887664734375*^9, 3.43495891359375*^9, 3.4349603504375*^9, 
  3.4349709886875*^9, 3.435297275328125*^9, 3.435298743515625*^9, 
  3.435298980265625*^9, 3.435299019640625*^9, 3.435299330171875*^9, 
  3.435299543578125*^9, 3.435300853421875*^9, 3.435300887140625*^9, 
  3.435300975234375*^9, 3.435301646203125*^9, 3.435497136875*^9, 
  3.43565122715625*^9, 3.435651320359375*^9, 3.435662683015625*^9, 
  3.435664329421875*^9, 3.4356655339375*^9, 3.435666287796875*^9, 
  3.435668073828125*^9, 3.435912779693478*^9, 3.43616769709375*^9, 
  3.43617862171875*^9, 3.4966553137728186`*^9, 3.50667898709375*^9, 
  3.506679546703125*^9, 3.506683703921875*^9, 3.50674906659375*^9, 
  3.519095936875*^9, 3.52136223159375*^9, 3.52783147146875*^9, 
  3.550318634307625*^9},
 CellTags->"Getting Around",
 CellLabel->"Out[6]=",
 CellID->65352055]
}, Open  ]],

Cell["\<\
To each function the type is attached. This allows to select the constructors \
and member functions\
\>", "Text",
 CellChangeTimes->{{3.435912673130978*^9, 3.435912723927853*^9}},
 CellTags->"Getting Around"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Select", "[", 
  RowBox[{
   RowBox[{"Category", "[", "PricingEngines", "]"}], ",", 
   RowBox[{
    RowBox[{"QLConstructor", "[", "#", "]"}], "&"}]}], "]"}]], "Input",
 CellChangeTimes->{3.435912739865353*^9},
 CellTags->"Getting Around",
 CellLabel->"In[7]:="],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "AnalyticCapFloorEngine", ",", "BinomialPricingEngine", ",", 
   "BlackCalculator", ",", "BlackCalculator2", ",", "BlackCapFloorEngine", 
   ",", "BlackCapFloorEngine2", ",", "BlackScholesCalculator", ",", 
   "BlackScholesCalculator2", ",", "BlackSwaptionEngine", ",", 
   "BlackSwaptionEngine2", ",", "BondEngine", ",", "DiscountingSwapEngine", 
   ",", "PricingEngine", ",", "TreeCallableFixedRateBondEngine"}], 
  "}"}]], "Output",
 CellChangeTimes->{3.435912788443478*^9, 3.436167697109375*^9, 
  3.43617862175*^9, 3.4966553152103186`*^9, 3.506679007671875*^9, 
  3.506679548578125*^9, 3.506683705734375*^9, 3.506749066625*^9, 
  3.5190959390625*^9, 3.521362231625*^9, 3.527831471515625*^9, 
  3.550318634401375*^9},
 CellTags->"Getting Around",
 CellLabel->"Out[7]=",
 CellID->289322088]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Select", "[", 
  RowBox[{
   RowBox[{"Category", "[", "PricingEngines", "]"}], ",", 
   RowBox[{
    RowBox[{"QLMember", "[", "#", "]"}], "&"}]}], "]"}]], "Input",
 CellChangeTimes->{
  3.435912739865353*^9, {3.435912791115353*^9, 3.435912798224728*^9}},
 CellTags->"Getting Around",
 CellLabel->"In[8]:="],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "BlackCalculatorAlpha", ",", "BlackCalculatorBeta", ",", 
   "BlackCalculatorDelta", ",", "BlackCalculatorDeltaForward", ",", 
   "BlackCalculatorDividendRho", ",", "BlackCalculatorElasticity", ",", 
   "BlackCalculatorElasticityForward", ",", "BlackCalculatorGamma", ",", 
   "BlackCalculatorGammaForward", ",", "BlackCalculatorItmAssetProbability", 
   ",", "BlackCalculatorItmCashProbability", ",", "BlackCalculatorRho", ",", 
   "BlackCalculatorStrikeSensitivity", ",", "BlackCalculatorTheta", ",", 
   "BlackCalculatorThetaPerDay", ",", "BlackCalculatorValue", ",", 
   "BlackCalculatorVega", ",", "BlackScholesCalculatorDelta", ",", 
   "BlackScholesCalculatorElasticity", ",", "BlackScholesCalculatorGamma", 
   ",", "BlackScholesCalculatorTheta", ",", 
   "BlackScholesCalculatorThetaPerDay"}], "}"}]], "Output",
 CellChangeTimes->{3.435912798787228*^9, 3.436167697140625*^9, 
  3.436178621765625*^9, 3.4966553160228186`*^9, 3.5066790130625*^9, 
  3.50667955121875*^9, 3.506683707796875*^9, 3.50674906665625*^9, 
  3.519095941265625*^9, 3.521362231671875*^9, 3.527831471546875*^9, 
  3.550318634495125*^9},
 CellTags->"Getting Around",
 CellLabel->"Out[8]=",
 CellID->774717833]
}, Open  ]],

Cell["Also for each function usage information is available", "Text",
 CellChangeTimes->{{3.427194175109375*^9, 3.427194185234375*^9}, {
  3.4356513245*^9, 3.435651345390625*^9}, {3.435912810459103*^9, 
  3.435912811552853*^9}},
 CellTags->"Getting Around"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", "PricingEngine"}]], "Input",
 CellChangeTimes->{{3.42719414121875*^9, 3.4271941445*^9}, 
   3.4966553998353186`*^9, 3.50667932721875*^9},
 CellTags->"Getting Around",
 CellLabel->"In[9]:="],

Cell[BoxData[
 StyleBox["\<\"PricingEngine[ObjecctId_Symbol,EngineID_String,ProcessID_\
Symbol] Construct an object of class PricingEngine and return its id\\n      \
\\nObjectId: id of object to be created\\nEngineID: engine type.\\nProcessID: \
GeneralizedBlackScholesProcess object ID.\\nPermanent: object \
permanent/nonpermanent\"\>", "MSG"]], "Print", "PrintUsage",
 CellChangeTimes->{3.550318634995125*^9},
 CellTags->{"Getting Around", "Info3550325834-5601359"},
 CellID->830330486]
}, Open  ]],

Cell["\<\
In most cases there are additional options set up for a function\
\>", "Text",
 CellChangeTimes->{{3.427194203953125*^9, 3.42719422884375*^9}},
 CellTags->"Getting Around"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Options", "[", "PricingEngine", "]"}]], "Input",
 CellChangeTimes->{{3.4271942308125*^9, 3.42719423678125*^9}, 
   3.4966554043196936`*^9, 3.506679331234375*^9},
 CellTags->"Getting Around",
 CellLabel->"In[10]:="],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"Permanent", "\[Rule]", "True"}], ",", 
   RowBox[{"Overwrite", "\[Rule]", "True"}]}], "}"}]], "Output",
 CellChangeTimes->{3.430728655546875*^9, 3.434861782609375*^9, 
  3.434958917171875*^9, 3.43496035421875*^9, 3.434970991515625*^9, 
  3.435297280375*^9, 3.435298746234375*^9, 3.435298980421875*^9, 
  3.43529902275*^9, 3.435299333046875*^9, 3.43529954721875*^9, 
  3.435300853578125*^9, 3.435300888328125*^9, 3.435300975390625*^9, 
  3.43530164634375*^9, 3.4356513504375*^9, 3.43566268590625*^9, 
  3.435664332921875*^9, 3.435665536921875*^9, 3.43566629121875*^9, 
  3.4356680799375*^9, 3.435912817599728*^9, 3.436167697609375*^9, 
  3.436178622140625*^9, 3.4966554048196936`*^9, 3.506679331765625*^9, 
  3.50667955540625*^9, 3.5066837118125*^9, 3.506749066921875*^9, 
  3.519095946375*^9, 3.52136223196875*^9, 3.527831472*^9, 3.550318635292*^9},
 CellTags->"Getting Around",
 CellLabel->"Out[10]=",
 CellID->308547081]
}, Open  ]],

Cell[CellGroupData[{

Cell["Retrieving QuantLib Values", "Subsection",
 CellChangeTimes->{{3.5190968468957376`*^9, 3.5190968847863626`*^9}},
 CellID->51701265],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"GetEnumerationTypes", "[", "]"}]], "Input",
 CellChangeTimes->{{3.5190968862863626`*^9, 3.5190968863019876`*^9}, {
  3.5191003360988626`*^9, 3.5191003393488626`*^9}, {3.5191003821613626`*^9, 
  3.5191004159113626`*^9}},
 CellLabel->"In[11]:=",
 CellID->315960191],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"\<\"Calendar\"\>", ",", "\<\"Currency\"\>", 
   ",", "\<\"DayCounter\"\>", ",", "\<\"Average::Type\"\>", 
   ",", "\<\"Barrier::Type\"\>", ",", "\<\"BusinessDayConvention\"\>", 
   ",", "\<\"CalibrationHelper::CalibrationErrorType\"\>", 
   ",", "\<\"Callability::Price::Type\"\>", ",", "\<\"Callability::Type\"\>", 
   ",", "\<\"CapFloor::Type\"\>", 
   ",", "\<\"CmsMarketCalibration::CalibrationType\"\>", 
   ",", "\<\"Compounding\"\>", 
   ",", "\<\"CubicInterpolation::BoundaryCondition\"\>", 
   ",", "\<\"CubicInterpolation::DerivativeApprox\"\>", 
   ",", "\<\"DateGeneration::Rule\"\>", ",", "\<\"Duration::Type\"\>", 
   ",", "\<\"EndCriteria::Type\"\>", ",", "\<\"Frequency\"\>", 
   ",", "\<\"GFunctionFactory::YieldCurveModel\"\>", ",", "\<\"Month\"\>", 
   ",", "\<\"Option::Type\"\>", ",", "\<\"OvernightIndexedSwap::Type\"\>", 
   ",", "\<\"Position::Type\"\>", ",", "\<\"PriceType\"\>", 
   ",", "\<\"Protection::Side\"\>", ",", "\<\"Replication::Type\"\>", 
   ",", "\<\"SalvagingAlgorithm::Type\"\>", 
   ",", "\<\"SensitivityAnalysis\"\>", ",", "\<\"Settlement::Type\"\>", 
   ",", "\<\"TimeUnit\"\>", ",", "\<\"VanillaSwap::Type\"\>", 
   ",", "\<\"Weekday\"\>", 
   ",", "\<\"InterpolatedDefaultCurve::Interpolator\"\>", 
   ",", "\<\"InterpolatedDefaultCurve::Traits\"\>", 
   ",", "\<\"InterpolatedYieldCurve::Interpolator\"\>", 
   ",", "\<\"InterpolatedYieldCurve::Traits\"\>", 
   ",", "\<\"RateHelper::DepoInclusionCriteria\"\>", 
   ",", "\<\"SwapIndex::FixingType\"\>"}], "}"}]], "Output",
 CellChangeTimes->{
  3.5190968869894876`*^9, 3.5190979723957376`*^9, 3.5190983616926126`*^9, 
   3.5191000358176126`*^9, 3.5191001664582376`*^9, {3.5191002656926126`*^9, 
   3.5191003398332376`*^9}, {3.5191003828332376`*^9, 3.5191004452394876`*^9}, 
   3.521362232015625*^9, 3.527831472046875*^9, 3.550318635557625*^9},
 CellLabel->"Out[11]=",
 CellID->472215261]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"GetEnumerationType", "[", "\"\<Compounding\>\"", "]"}]], "Input",
 CellChangeTimes->{{3.5190969596769876`*^9, 3.5190970100832376`*^9}},
 CellLabel->"In[12]:=",
 CellID->233331078],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"\<\"Compounded\"\>", ",", "\<\"Continuous\"\>", 
   ",", "\<\"Simple\"\>", ",", "\<\"SimpleThenCompounded\"\>"}], 
  "}"}]], "Output",
 CellChangeTimes->{
  3.5190969670676126`*^9, {3.5190969978332376`*^9, 3.5190970107863626`*^9}, 
   3.5190979768488626`*^9, 3.5190983628332376`*^9, 3.5191004642238626`*^9, 
   3.521362232046875*^9, 3.527831472078125*^9, 3.55031863563575*^9},
 CellLabel->"Out[12]=",
 CellID->189598539]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"GetEnumerationClasses", "[", "]"}]], "Input",
 CellChangeTimes->{{3.5190970671457376`*^9, 3.5190970690207376`*^9}},
 CellLabel->"In[13]:=",
 CellID->77070868],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"\<\"CmsCouponPricer\"\>", ",", "\<\"IborCouponPricer\"\>", 
   ",", "\<\"Interpolation\"\>", ",", "\<\"Interpolation2D\"\>", 
   ",", "\<\"Payoff\"\>", 
   ",", "\<\"shared_ptr<class QuantLib::PricingEngine> (__cdecl*)(class \
boost::shared_ptr<class QuantLib::GeneralizedBlackScholesProcess> const \
&)\"\>", ",", "\<\"shared_ptr<class QuantLib::PricingEngine> (__cdecl*)(class \
boost::shared_ptr<class QuantLib::GeneralizedBlackScholesProcess> const \
&,long const &)\"\>"}], "}"}]], "Output",
 CellChangeTimes->{
  3.5190970695832376`*^9, 3.5190979854582376`*^9, 3.5190983645832376`*^9, 
   3.5191004682863626`*^9, {3.5191005335832376`*^9, 3.5191005439426126`*^9}, 
   3.521362232078125*^9, 3.527831472203125*^9, 3.550318635713875*^9},
 CellLabel->"Out[13]=",
 CellID->182695354]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"GetEnumerationClass", "[", "\"\<CmsCouponPricer\>\"", 
  "]"}]], "Input",
 CellChangeTimes->{3.5190977146457376`*^9},
 CellLabel->"In[14]:=",
 CellID->8560030],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"\<\"ConundrumByBlack\"\>", 
   ",", "\<\"ConundrumByNumericalIntegration\"\>"}], "}"}]], "Output",
 CellChangeTimes->{{3.5190977072863626`*^9, 3.5190977153801126`*^9}, 
   3.5190979997238626`*^9, 3.5190983766457376`*^9, 3.5191005603176126`*^9, 
   3.52136223215625*^9, 3.52783147225*^9, 3.550318635807625*^9},
 CellLabel->"Out[14]=",
 CellID->6938629]
}, Open  ]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["A simple option pricing example as a starter", "Section",
 CellChangeTimes->{{3.42717273265625*^9, 3.42717273740625*^9}},
 CellTags->"Simple Example"],

Cell["\<\
This simple example demonstrates the valuation of  a plain vanilla option \
using the different object available in QuantLib. Alternatively you also can \
use the well known formula which is also available in QuantLib.\
\>", "Text",
 CellChangeTimes->{{3.4271726915*^9, 3.427172698015625*^9}, 
   3.42717272978125*^9, {3.427173162859375*^9, 3.42717318203125*^9}, {
   3.427173244734375*^9, 3.427173316171875*^9}},
 CellTags->"Simple Example"],

Cell[CellGroupData[{

Cell["Just using a formula", "Subsection",
 CellChangeTimes->{{3.427194427703125*^9, 3.427194438765625*^9}},
 CellTags->"Simple Example"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", "BlackFormula"}]], "Input",
 CellChangeTimes->{{3.427173443890625*^9, 3.42717345140625*^9}},
 CellTags->"Simple Example",
 CellLabel->"In[15]:="],

Cell[BoxData[
 StyleBox["\<\"BlackFormula[OptionType_String,Strike_?NumberQ,AtmForwardValue_\
?NumberQ,StdDev_?NumberQ] Black 1976 formula for option pricing, using \
displacement.\\n      \\nOptionType: option type (i.e. Call or \
Put).\\nStrike: option strike.\\nAtmForwardValue: underlying asset \
at-the-money forward value.\\nStdDev: standard deviation, i.e. annualized \
percentage volatility times the square root of time to option \
expiry.\\nDeflator: Deflator (usually the discount factor, or the annuity, \
etc.). Default value = 1.0.\\nDisplacement: displacement in a displaced \
diffusion model. Default value = 0.0.\"\>", "MSG"]], "Print", "PrintUsage",
 CellChangeTimes->{3.550318636307625*^9},
 CellTags->{"Info3550325835-5601359", "Simple Example"},
 CellID->872258241]
}, Open  ]],

Cell["\<\
\[LineSeparator]With most functions there are options associated. This \
simplifies the calling of functions.\
\>", "Text",
 CellChangeTimes->{{3.42717355640625*^9, 3.42717358815625*^9}, 
   3.4966554092259436`*^9},
 CellTags->"Simple Example"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Options", "[", "BlackFormula", "]"}]], "Input",
 CellChangeTimes->{{3.427173485765625*^9, 3.427173492375*^9}},
 CellTags->"Simple Example",
 CellLabel->"In[16]:="],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"Deflator", "\[Rule]", "1.`"}], ",", 
   RowBox[{"Displacement", "\[Rule]", "0.`"}]}], "}"}]], "Output",
 CellChangeTimes->{3.43072865584375*^9, 3.43486179884375*^9, 
  3.43496037371875*^9, 3.43497100471875*^9, 3.435297293203125*^9, 
  3.4352987608125*^9, 3.435298980921875*^9, 3.435299035921875*^9, 
  3.43529934415625*^9, 3.43529955853125*^9, 3.43530085409375*^9, 
  3.435300888609375*^9, 3.435300975796875*^9, 3.435301646703125*^9, 
  3.43565136540625*^9, 3.435664362578125*^9, 3.435665548078125*^9, 
  3.43566630171875*^9, 3.435668131796875*^9, 3.43616769821875*^9, 
  3.43617862253125*^9, 3.4966554109446936`*^9, 3.506679339921875*^9, 
  3.506679561171875*^9, 3.506683717515625*^9, 3.5067490671875*^9, 
  3.519095958140625*^9, 3.521362232484375*^9, 3.527831472671875*^9, 
  3.5503186366045*^9},
 CellTags->"Simple Example",
 CellLabel->"Out[16]=",
 CellID->63080394]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"\[Sigma]", "=", "0.20"}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"S", "=", "36"}], ";"}], "  ", 
  RowBox[{"(*", " ", "Underlying", " ", "*)"}]}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"K", "=", "40"}], ";"}], " ", 
  RowBox[{"(*", " ", "Strike", " ", "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"r", " ", "=", "0.06"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"q", " ", "=", " ", "0.0"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"T", " ", "=", " ", "1"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"BlackFormula", "[", 
  RowBox[{"\"\<Call\>\"", ",", "S", ",", "K", ",", 
   RowBox[{"\[Sigma]", 
    SqrtBox["T"]}], ",", 
   RowBox[{"Deflator", "\[Rule]", "r"}], ",", 
   RowBox[{"Displacement", " ", "\[Rule]", " ", "q"}]}], "]"}]}], "Input",
 CellChangeTimes->{{3.42717337009375*^9, 3.42717342690625*^9}, {
  3.427173481375*^9, 3.427173534359375*^9}, {3.4271736365*^9, 
  3.4271736511875*^9}, {3.427180437578125*^9, 3.427180438109375*^9}, {
  3.42718065090625*^9, 3.42718065359375*^9}, {3.427194306828125*^9, 
  3.427194329140625*^9}},
 CellTags->"Simple Example",
 CellLabel->"In[17]:="],

Cell[BoxData["0.3261385947853155`"], "Output",
 CellChangeTimes->{3.430728655875*^9, 3.4348618*^9, 3.434960374609375*^9, 
  3.434971006078125*^9, 3.435297294078125*^9, 3.435298762015625*^9, 
  3.435298981015625*^9, 3.43529903715625*^9, 3.435299344984375*^9, 
  3.43529955934375*^9, 3.4353008541875*^9, 3.43530088865625*^9, 
  3.435300975828125*^9, 3.4353016468125*^9, 3.435651366390625*^9, 
  3.435664364046875*^9, 3.435665549140625*^9, 3.4356663059375*^9, 
  3.43566813284375*^9, 3.436167698296875*^9, 3.4361786225625*^9, 
  3.4966554125228186`*^9, 3.50668371853125*^9, 3.50674906734375*^9, 
  3.51909595965625*^9, 3.52136223253125*^9, 3.527831472703125*^9, 
  3.550318636995125*^9},
 CellTags->"Simple Example",
 CellLabel->"Out[23]=",
 CellID->131388257]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Working with objects", "Subsection",
 CellChangeTimes->{{3.427194427703125*^9, 3.427194438765625*^9}, {
  3.435664380796875*^9, 3.435664385875*^9}},
 CellTags->"Simple Example"],

Cell[CellGroupData[{

Cell["Defining an instrument", "Subsubsection",
 CellChangeTimes->{{3.4271944120625*^9, 3.427194418140625*^9}},
 CellTags->"Simple Example"],

Cell["\<\
The exericise function is one part of the instrument description\
\>", "Text",
 CellChangeTimes->{{3.4271726915*^9, 3.427172698015625*^9}, 
   3.42717272978125*^9, {3.427173162859375*^9, 3.42717318203125*^9}, {
   3.427173244734375*^9, 3.427173316171875*^9}, 3.42719438940625*^9, {
   3.42719469978125*^9, 3.427194722765625*^9}},
 CellTags->"Simple Example"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"exerciseDate", " ", "=", 
   RowBox[{"{", 
    RowBox[{"1999", ",", "5", ",", "17"}], "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"EuropeanExercise", "[", 
  RowBox[{"Ex1", ",", "exerciseDate"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"?", "Ex1"}]}], "Input",
 CellChangeTimes->{{3.427194684828125*^9, 3.427194685390625*^9}, {
  3.430548394890625*^9, 3.43054839953125*^9}},
 CellTags->"Simple Example",
 CellLabel->"In[24]:="],

Cell[BoxData["Ex1"], "Output",
 CellChangeTimes->{3.435666315140625*^9, 3.43566813578125*^9, 
  3.436167698546875*^9, 3.43617862259375*^9, 3.4966554166009436`*^9, 
  3.506683722703125*^9, 3.50674906753125*^9, 3.519095962890625*^9, 
  3.521362232625*^9, 3.527831472796875*^9, 3.550318637588875*^9},
 CellTags->"Simple Example",
 CellLabel->"Out[25]=",
 CellID->715045043],

Cell["Global`Ex1", "Print", "PrintUsage",
 CellChangeTimes->{3.550318638213875*^9},
 CellTags->{"Info3550325837-5601359", "Simple Example"},
 CellID->64334317],

Cell[BoxData[
 InterpretationBox[GridBox[{
    {GridBox[{
       {
        RowBox[{
         RowBox[{"BaseClass", "[", "Ex1", "]"}], "^=", "\<\"\"\>"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"Category", "[", "Ex1", "]"}], "^=", "\<\"Exercise\"\>"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"ClassName", "[", "Ex1", "]"}], "^=", "qlEuropeanExercise"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"ExpiryDate", "[", "Ex1", "]"}], "^=", "36297"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"Overwrite", "[", "Ex1", "]"}], "^=", "True"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"Permanent", "[", "Ex1", "]"}], "^=", "True"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"PrecedentObjects", "[", "Ex1", "]"}], "^=", 
         RowBox[{"{", "}"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"Processor", "[", "Ex1", "]"}], 
         "^=", "\<\"DefaultProcessor\"\>"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"ValueObject", "[", "Ex1", "]"}], "^=", 
         "qlEuropeanExercise"}]}
      },
      BaselinePosition->{Baseline, {1, 1}},
      GridBoxAlignment->{
       "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
        "RowsIndexed" -> {}},
      GridBoxItemSize->{"Columns" -> {{
           Scaled[0.999]}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
        "RowsIndexed" -> {}}]}
   },
   BaselinePosition->{Baseline, {1, 1}},
   GridBoxAlignment->{
    "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
     "RowsIndexed" -> {}}],
  Definition[$CellContext`Ex1],
  Editable->False]], "Print",
 CellChangeTimes->{3.550318638292*^9},
 CellTags->{"Info3550325837-5601359", "Simple Example"},
 CellID->17801710]
}, Open  ]],

Cell["\<\
When looking at the ExpiryDate properity it is noticable that internally \
dates a represnted as julian numbers. The transformation from date to julian \
number is most of the times done automatically. But there is also a function \
available to do it manually.\
\>", "Text",
 CellChangeTimes->{{3.4271726915*^9, 3.427172698015625*^9}, 
   3.42717272978125*^9, {3.427173162859375*^9, 3.42717318203125*^9}, {
   3.427173244734375*^9, 3.427173316171875*^9}, 3.42719438940625*^9, {
   3.42719469978125*^9, 3.427194722765625*^9}, {3.435666368953125*^9, 
   3.4356664615625*^9}},
 CellTags->"Simple Example"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", "ToJulian"}]], "Input",
 CellChangeTimes->{{3.43566646425*^9, 3.435666470078125*^9}},
 CellTags->"Simple Example",
 CellLabel->"In[27]:="],

Cell[BoxData[
 StyleBox["\<\"ToJulian[date] returns a julian representation of a date.\"\>",
   "MSG"]], "Print", "PrintUsage",
 CellChangeTimes->{3.55031863901075*^9},
 CellTags->{"Info3550325838-5601359", "Simple Example"},
 CellID->150779459]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", "StrikedTypePayoff"}]], "Input",
 CellChangeTimes->{{3.427194753609375*^9, 3.4271947684375*^9}},
 CellTags->"Simple Example",
 CellLabel->"In[28]:="],

Cell[BoxData[
 StyleBox["\<\"StrikedTypePayoff[ObjecctId_Symbol,PayoffID_String,OptionType_\
String,Strike_?NumberQ] Construct an payoff object of class StrikedTypePayoff \
and return its id\\n      \\nObjectId: id of object to be created\\nPayoffID: \
payoff ID (e.g. Vanilla, PercentageStrike, AssetOrNothing, CashOrNothing, \
Gap, SuperShare).\\nOptionType: option type.\\nStrike: \
strike.\\nThirdParameter: the 3rd paramenter for the payoff definition of \
CashOrNothing (cash), Gap (determines the size of the payoff), SuperFund \
(second strike). Default value = 0.\\nPermanent: object \
permanent/nonpermanent\"\>", "MSG"]], "Print", "PrintUsage",
 CellChangeTimes->{3.550318639542*^9},
 CellTags->{"Info3550325839-5601359", "Simple Example"},
 CellID->541692868]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"StrikedTypePayoff", "[", 
  RowBox[{"MyStrike1", ",", "\"\<Vanilla\>\"", ",", "\"\<Put\>\"", ",", "K"}],
   "]"}]], "Input",
 CellChangeTimes->{{3.427176752765625*^9, 3.427176757125*^9}, 
   3.427194832*^9, {3.43566648859375*^9, 3.43566650334375*^9}, {
   3.435668151328125*^9, 3.43566815353125*^9}},
 CellTags->"Simple Example",
 CellLabel->"In[29]:="],

Cell[BoxData["MyStrike1"], "Output",
 CellChangeTimes->{
  3.430728656296875*^9, 3.434861811046875*^9, 3.4349603928125*^9, 
   3.434971018625*^9, 3.435298981671875*^9, 3.43529935965625*^9, 
   3.4353008546875*^9, 3.43530088890625*^9, 3.435300976171875*^9, 
   3.435301647328125*^9, 3.43565137415625*^9, {3.4356664843125*^9, 
   3.43566650378125*^9}, {3.4356681409375*^9, 3.43566815425*^9}, 
   3.436167699890625*^9, 3.436178623640625*^9, 3.4966554261009436`*^9, 
   3.50668373284375*^9, 3.506749068984375*^9, 3.51909599146875*^9, 
   3.52136223490625*^9, 3.527831474453125*^9, 3.550318640167*^9},
 CellTags->"Simple Example",
 CellLabel->"Out[29]=",
 CellID->214921087]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"VanillaOption", "[", 
  RowBox[{"MyVanilla", ",", "MyStrike1", ",", "Ex1"}], "]"}]], "Input",
 CellChangeTimes->{{3.427177112171875*^9, 3.42717714203125*^9}},
 CellTags->"Simple Example",
 CellLabel->"In[30]:="],

Cell[BoxData["MyVanilla"], "Output",
 CellChangeTimes->{3.4307286563125*^9, 3.4348618119375*^9, 3.43496039425*^9, 
  3.434971019625*^9, 3.435298981703125*^9, 3.435299361015625*^9, 
  3.435300854796875*^9, 3.43530088896875*^9, 3.435300976234375*^9, 
  3.4353016474375*^9, 3.435651376640625*^9, 3.4356681685*^9, 
  3.436167699953125*^9, 3.436178623671875*^9, 3.4966554275384436`*^9, 
  3.506683734390625*^9, 3.50674906909375*^9, 3.519095992625*^9, 
  3.5213622349375*^9, 3.527831474484375*^9, 3.55031864082325*^9},
 CellTags->"Simple Example",
 CellLabel->"Out[30]=",
 CellID->366913013]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", "MyVanilla"}]], "Input",
 CellChangeTimes->{{3.427196078703125*^9, 3.4271960884375*^9}},
 CellTags->"Simple Example",
 CellLabel->"In[31]:="],

Cell["Global`MyVanilla", "Print", "PrintUsage",
 CellChangeTimes->{3.550318641620125*^9},
 CellTags->{"Info3550325841-5601359", "Simple Example"},
 CellID->46853144],

Cell[BoxData[
 InterpretationBox[GridBox[{
    {GridBox[{
       {
        RowBox[{
         RowBox[{"BaseClass", "[", "MyVanilla", "]"}], "^=", "\<\"\"\>"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"Category", "[", "MyVanilla", "]"}], 
         "^=", "\<\"Options\"\>"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"ClassName", "[", "MyVanilla", "]"}], "^=", 
         "qlVanillaOption"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"Exercise", "[", "MyVanilla", "]"}], "^=", "Ex1"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"Instrument", "[", "MyVanilla", "]"}], "^=", "True"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"IsExpired", "[", "MyVanilla", "]"}], "^=", "True"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"OneAssetOption", "[", "MyVanilla", "]"}], "^=", "True"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"Overwrite", "[", "MyVanilla", "]"}], "^=", "True"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"Payoff", "[", "MyVanilla", "]"}], "^=", "MyStrike1"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"Permanent", "[", "MyVanilla", "]"}], "^=", "True"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"PrecedentObjects", "[", "MyVanilla", "]"}], "^=", 
         RowBox[{"{", 
          RowBox[{"\<\"Ex1\"\>", ",", "\<\"MyStrike1\"\>"}], "}"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"Processor", "[", "MyVanilla", "]"}], 
         "^=", "\<\"DefaultProcessor\"\>"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"ValueObject", "[", "MyVanilla", "]"}], "^=", 
         "qlVanillaOption"}]}
      },
      BaselinePosition->{Baseline, {1, 1}},
      GridBoxAlignment->{
       "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
        "RowsIndexed" -> {}},
      GridBoxItemSize->{"Columns" -> {{
           Scaled[0.999]}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
        "RowsIndexed" -> {}}]}
   },
   BaselinePosition->{Baseline, {1, 1}},
   GridBoxAlignment->{
    "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
     "RowsIndexed" -> {}}],
  Definition[$CellContext`MyVanilla],
  Editable->False]], "Print",
 CellChangeTimes->{3.550318641667*^9},
 CellTags->{"Info3550325841-5601359", "Simple Example"},
 CellID->214824038]
}, Open  ]],

Cell["So far we have generated three objects.", "Text",
 CellChangeTimes->{{3.4271740549375*^9, 3.427174065796875*^9}, {
  3.427196312015625*^9, 3.427196312625*^9}},
 CellTags->"Simple Example"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"QLListObjects", "[", "]"}]], "Input",
 CellChangeTimes->{{3.427174044484375*^9, 3.427174048390625*^9}, {
  3.52783144246875*^9, 3.527831442671875*^9}},
 CellTags->"Simple Example",
 CellLabel->"In[32]:="],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"Ex1", ",", "MyStrike1", ",", "MyVanilla"}], "}"}]], "Output",
 CellChangeTimes->{3.430728656484375*^9, 3.43486181459375*^9, 
  3.434960402015625*^9, 3.434971022859375*^9, 3.435298981859375*^9, 
  3.435299364734375*^9, 3.435300854984375*^9, 3.43530088915625*^9, 
  3.4353009764375*^9, 3.435301647625*^9, 3.435651382453125*^9, 
  3.435668173609375*^9, 3.436167700453125*^9, 3.436178624046875*^9, 
  3.4966554311946936`*^9, 3.5066837395*^9, 3.5067490696875*^9, 
  3.51909599628125*^9, 3.52136223565625*^9, 3.527831475046875*^9, 
  3.55031864194825*^9},
 CellTags->"Simple Example",
 CellLabel->"Out[32]=",
 CellID->236098151]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Defining the driving process", "Subsubsection",
 CellChangeTimes->{{3.427194427703125*^9, 3.427194438765625*^9}, 
   3.42719633209375*^9, {3.4271963765*^9, 3.427196380609375*^9}},
 CellTags->"Simple Example"],

Cell["\<\
Here a Black-Scholes process is assumed which is driven by a scalar \
volatility parameter\
\>", "Text",
 CellChangeTimes->{{3.4271960433125*^9, 3.42719607484375*^9}, {
  3.4271961050625*^9, 3.42719611503125*^9}, {3.4271963351875*^9, 
  3.427196338234375*^9}},
 CellTags->"Simple Example"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", "BlackConstantVol"}]], "Input",
 CellChangeTimes->{{3.42717295571875*^9, 3.427172960078125*^9}},
 CellTags->"Simple Example",
 CellLabel->"In[33]:="],

Cell[BoxData[
 StyleBox["\<\"BlackConstantVol[ObjecctId_Symbol,SettlementDate_?DateQ,\
Volatility_?NumberQ] Construct an object of class BlackConstantVol and return \
its id\\n      \\nObjectId: id of object to be created\\nSettlementDate: \
settlement date.\\nCalendar: holiday calendar (e.g. TARGET).\\nVolatility: \
volatility.\\nDayCounter: DayCounter ID. Default value = Actual/365 \
(Fixed).\\nPermanent: object permanent/nonpermanent\"\>", "MSG"]], "Print", \
"PrintUsage",
 CellChangeTimes->{3.550318642370125*^9},
 CellTags->{"Info3550325842-5601359", "Simple Example"},
 CellID->84788527]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"settlementDate", " ", "=", " ", 
   RowBox[{"{", 
    RowBox[{"1998", ",", "5", ",", "17"}], "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"BlackConstantVol", "[", 
  RowBox[{"vol1", ",", "settlementDate", ",", "\[Sigma]"}], "]"}]}], "Input",
 CellChangeTimes->{{3.413264321046875*^9, 3.413264342203125*^9}, {
  3.427088508984375*^9, 3.42708851334375*^9}, {3.42717398590625*^9, 
  3.427173988125*^9}, {3.4274358761116896`*^9, 3.4274358766741896`*^9}},
 CellTags->"Simple Example",
 CellLabel->"In[34]:="],

Cell[BoxData["vol1"], "Output",
 CellChangeTimes->{3.430728656609375*^9, 3.434861818484375*^9, 
  3.4349604065625*^9, 3.434971026421875*^9, 3.435298982015625*^9, 
  3.43529936790625*^9, 3.43529958340625*^9, 3.4353008551875*^9, 
  3.43530088921875*^9, 3.435300976609375*^9, 3.4353016478125*^9, 
  3.43565142125*^9, 3.43566817725*^9, 3.436167700859375*^9, 
  3.4361786244375*^9, 3.4966554348196936`*^9, 3.506683745046875*^9, 
  3.50674907003125*^9, 3.519096001046875*^9, 3.521362236015625*^9, 
  3.527831475703125*^9, 3.550318642901375*^9},
 CellTags->"Simple Example",
 CellLabel->"Out[35]=",
 CellID->186414414]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", "QLListObjects"}]], "Input",
 CellChangeTimes->{{3.5190959835051126`*^9, 3.5190959863019876`*^9}, {
  3.527831381015625*^9, 3.52783138128125*^9}},
 CellLabel->"In[36]:=",
 CellID->120464415],

Cell[BoxData[
 StyleBox["\<\"List IDs of all objects in repository. Returns empty list if \
repository is empty.\"\>", "MSG"]], "Print", "PrintUsage",
 CellChangeTimes->{3.55031864332325*^9},
 CellTags->"Info3550325842-5601359",
 CellID->46510895]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"QLListObjects", "[", "]"}]], "Input",
 CellChangeTimes->{{3.527831384828125*^9, 3.527831385015625*^9}},
 CellTags->"Simple Example",
 CellLabel->"In[37]:="],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "Ex1", ",", "MyStrike1", ",", "MyVanilla", ",", "SimpleQuote3", ",", 
   "vol1"}], "}"}]], "Output",
 CellChangeTimes->{3.435299404140625*^9, 3.43529958571875*^9, 
  3.435300855203125*^9, 3.435300889234375*^9, 3.435300976625*^9, 
  3.435301647828125*^9, 3.435651422359375*^9, 3.435668178625*^9, 
  3.436167700875*^9, 3.436178624453125*^9, 3.4966554366009436`*^9, 
  3.506683746203125*^9, 3.5067490700625*^9, 3.51909600215625*^9, 
  3.521362236671875*^9, 3.527831385546875*^9, 3.527831476046875*^9, 
  3.550318643776375*^9},
 CellTags->"Simple Example",
 CellLabel->"Out[37]=",
 CellID->74980725]
}, Open  ]],

Cell["\<\
Now an symbol/object vol1 exists with a number of attributes. To see the \
details use\
\>", "Text",
 CellChangeTimes->{{3.427172891734375*^9, 3.427172933140625*^9}},
 CellTags->"Simple Example"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", "vol1"}]], "Input",
 CellChangeTimes->{{3.427172262015625*^9, 3.42717226290625*^9}},
 CellTags->"Simple Example",
 CellLabel->"In[38]:="],

Cell["Global`vol1", "Print", "PrintUsage",
 CellChangeTimes->{3.550318644307625*^9},
 CellTags->{"Info3550325843-5601359", "Simple Example"},
 CellID->204066966],

Cell[BoxData[
 InterpretationBox[GridBox[{
    {GridBox[{
       {
        RowBox[{
         RowBox[{"BaseClass", "[", "vol1", "]"}], "^=", "\<\"\"\>"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"Calendar", "[", "vol1", "]"}], "^=", "Target"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"Category", "[", "vol1", "]"}], 
         "^=", "\<\"Volatilities\"\>"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"ClassName", "[", "vol1", "]"}], "^=", 
         "qlBlackConstantVol"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"DayCounter", "[", "vol1", "]"}], 
         "^=", "\<\"Actual/365 (Fixed)\"\>"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"Overwrite", "[", "vol1", "]"}], "^=", "True"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"Permanent", "[", "vol1", "]"}], "^=", "True"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"PrecedentObjects", "[", "vol1", "]"}], "^=", 
         RowBox[{"{", "}"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"Processor", "[", "vol1", "]"}], 
         "^=", "\<\"DefaultProcessor\"\>"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"SettlementDate", "[", "vol1", "]"}], "^=", "35932"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"ValueObject", "[", "vol1", "]"}], "^=", 
         "qlBlackConstantVol"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"Volatility", "[", "vol1", "]"}], "^=", "SimpleQuote3"}]}
      },
      BaselinePosition->{Baseline, {1, 1}},
      GridBoxAlignment->{
       "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
        "RowsIndexed" -> {}},
      GridBoxItemSize->{"Columns" -> {{
           Scaled[0.999]}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
        "RowsIndexed" -> {}}]}
   },
   BaselinePosition->{Baseline, {1, 1}},
   GridBoxAlignment->{
    "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
     "RowsIndexed" -> {}}],
  Definition[$CellContext`vol1],
  Editable->False]], "Print",
 CellChangeTimes->{3.5503186443545*^9},
 CellTags->{"Info3550325843-5601359", "Simple Example"},
 CellID->792742662]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"?", "GeneralizedBlackScholesProcess"}], "\[IndentingNewLine]", 
 RowBox[{"Options", "[", "GeneralizedBlackScholesProcess", "]"}]}], "Input",
 CellChangeTimes->{{3.427173687515625*^9, 3.42717370159375*^9}, 
   3.427173835671875*^9, {3.42717400503125*^9, 3.42717402309375*^9}},
 CellTags->"Simple Example",
 CellLabel->"In[39]:="],

Cell[BoxData[
 StyleBox["\<\"GeneralizedBlackScholesProcess[ObjecctId_Symbol,BlackVolID_\
Symbol,Underlying_?NumberQ,SettlementDate_?DateQ,RiskFreeRate_?NumberQ,\
DividendYield_?NumberQ] Construct an object of class \
GeneralizedBlackScholesProcess and return its id\\n      \\nObjectId: id of \
object to be created\\nBlackVolID: Black Vol Term Structure.\\nUnderlying: \
underlying.\\nDayCounter: DayCounter ID. Default value = Actual/365 \
(Fixed).\\nSettlementDate: settlement date.\\nRiskFreeRate: risk free \
rate.\\nDividendYield: dividend yield.\\nPermanent: object \
permanent/nonpermanent\"\>", "MSG"]], "Print", "PrintUsage",
 CellChangeTimes->{3.550318644963875*^9},
 CellTags->{"Info3550325844-5601359", "Simple Example"},
 CellID->28281282],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"DayCounter", "\[Rule]", "\<\"Actual/365 (Fixed)\"\>"}], ",", 
   RowBox[{"Permanent", "\[Rule]", "True"}], ",", 
   RowBox[{"Overwrite", "\[Rule]", "True"}]}], "}"}]], "Output",
 CellChangeTimes->{3.430728656859375*^9, 3.4348618220625*^9, 
  3.434960411515625*^9, 3.434971029265625*^9, 3.435298982484375*^9, 
  3.435299453109375*^9, 3.43529959434375*^9, 3.435300855671875*^9, 
  3.435300889453125*^9, 3.435300976921875*^9, 3.435301648109375*^9, 
  3.4356514266875*^9, 3.435668181578125*^9, 3.436167701703125*^9, 
  3.436178625109375*^9, 3.4966554408196936`*^9, 3.5066837545625*^9, 
  3.50674907071875*^9, 3.52136223740625*^9, 3.52783147721875*^9, 
  3.550318645151375*^9},
 CellTags->"Simple Example",
 CellLabel->"Out[40]=",
 CellID->9458628]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"settlementDate", " ", "=", " ", 
   RowBox[{"{", 
    RowBox[{"1998", ",", "5", ",", "17"}], "}"}]}], ";"}], "\n", 
 RowBox[{"GeneralizedBlackScholesProcess", "[", 
  RowBox[{
  "GBSP", ",", "vol1", ",", "S", ",", "settlementDate", ",", "r", ",", "q", 
   ",", 
   RowBox[{"DayCounter", "\[Rule]", "\"\<Actual/Actual\>\""}]}], 
  "]"}]}], "Input",
 CellChangeTimes->{{3.42719625409375*^9, 3.42719625984375*^9}, 
   3.427196345078125*^9},
 CellTags->"Simple Example",
 CellLabel->"In[41]:="],

Cell[BoxData["GBSP"], "Output",
 CellChangeTimes->{3.430728656890625*^9, 3.434861825375*^9, 
  3.434960415015625*^9, 3.43497103028125*^9, 3.435298982609375*^9, 
  3.435299458*^9, 3.435299597703125*^9, 3.435300855828125*^9, 
  3.43530088946875*^9, 3.435300976953125*^9, 3.435301648203125*^9, 
  3.435651427765625*^9, 3.435668182984375*^9, 3.43616770178125*^9, 
  3.4361786251875*^9, 3.4966554421946936`*^9, 3.50668375728125*^9, 
  3.506749071140625*^9, 3.5190959985207376`*^9, 3.5213622374375*^9, 
  3.52783147740625*^9, 3.550318645432625*^9},
 CellTags->"Simple Example",
 CellLabel->"Out[42]=",
 CellID->182357516]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", "GBSP"}]], "Input",
 CellChangeTimes->{{3.4274358905804396`*^9, 3.4274358931741896`*^9}},
 CellTags->"Simple Example",
 CellLabel->"In[43]:="],

Cell["Global`GBSP", "Print", "PrintUsage",
 CellChangeTimes->{3.55031864601075*^9},
 CellTags->{"Info3550325845-5601359", "Simple Example"},
 CellID->165114475],

Cell[BoxData[
 InterpretationBox[GridBox[{
    {GridBox[{
       {
        RowBox[{
         RowBox[{"BlackVolID", "[", "GBSP", "]"}], "^=", "vol1"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"Category", "[", "GBSP", "]"}], "^=", "\<\"Processes\"\>"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"Classes", "[", "GBSP", "]"}], "^=", 
         RowBox[{"{", 
          
          RowBox[{"\<\"GeneralizedBlackScholesProcess\"\>", 
           ",", "\<\"StochasticProcess\"\>", 
           ",", "\<\"StochasticProcess1D\"\>"}], "}"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"ClassName", "[", "GBSP", "]"}], "^=", 
         "qlGeneralizedBlackScholesProcess"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"DayCounter", "[", "GBSP", "]"}], 
         "^=", "\<\"Actual/Actual\"\>"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"DividendYield", "[", "GBSP", "]"}], "^=", "0.`"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"Overwrite", "[", "GBSP", "]"}], "^=", "True"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"Permanent", "[", "GBSP", "]"}], "^=", "True"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"PrecedentObjects", "[", "GBSP", "]"}], "^=", 
         RowBox[{"{", "\<\"vol1\"\>", "}"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"Processor", "[", "GBSP", "]"}], 
         "^=", "\<\"DefaultProcessor\"\>"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"RiskFreeRate", "[", "GBSP", "]"}], "^=", "0.06`"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"SettlementDate", "[", "GBSP", "]"}], "^=", "35932"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"Underlying", "[", "GBSP", "]"}], "^=", "36.`"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"ValueObject", "[", "GBSP", "]"}], "^=", 
         "qlGeneralizedBlackScholesProcess"}]}
      },
      BaselinePosition->{Baseline, {1, 1}},
      GridBoxAlignment->{
       "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
        "RowsIndexed" -> {}},
      GridBoxItemSize->{"Columns" -> {{
           Scaled[0.999]}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
        "RowsIndexed" -> {}}]}
   },
   BaselinePosition->{Baseline, {1, 1}},
   GridBoxAlignment->{
    "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
     "RowsIndexed" -> {}}],
  Definition[$CellContext`GBSP],
  Editable->False]], "Print",
 CellChangeTimes->{3.550318646057625*^9},
 CellTags->{"Info3550325845-5601359", "Simple Example"},
 CellID->79533666]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Defining the valuation method", "Subsubsection",
 CellChangeTimes->{{3.427194427703125*^9, 3.427194438765625*^9}, 
   3.42719633209375*^9, {3.4271963765*^9, 3.4271963991875*^9}},
 CellTags->"Simple Example"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", "PricingEngine"}]], "Input",
 CellChangeTimes->{{3.4274359940023146`*^9, 3.4274360047679396`*^9}, 
   3.4966554480071936`*^9, 3.506683765296875*^9},
 CellTags->"Simple Example",
 CellLabel->"In[44]:="],

Cell[BoxData[
 StyleBox["\<\"PricingEngine[ObjecctId_Symbol,EngineID_String,ProcessID_\
Symbol] Construct an object of class PricingEngine and return its id\\n      \
\\nObjectId: id of object to be created\\nEngineID: engine type.\\nProcessID: \
GeneralizedBlackScholesProcess object ID.\\nPermanent: object \
permanent/nonpermanent\"\>", "MSG"]], "Print", "PrintUsage",
 CellChangeTimes->{3.5503186467295*^9},
 CellTags->{"Info3550325846-5601359", "Simple Example"},
 CellID->200963766]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"PricingEngine", "[", 
  RowBox[{"MyEngine", ",", "\"\<AE\>\"", ",", "GBSP"}], "]"}]], "Input",
 CellChangeTimes->{{3.427176882578125*^9, 3.427176884375*^9}, {
   3.42717698590625*^9, 3.427176997296875*^9}, {3.435668192046875*^9, 
   3.435668192828125*^9}, 3.4966554534290686`*^9, 3.5066837720625*^9},
 CellTags->"Simple Example",
 CellLabel->"In[45]:="],

Cell[BoxData["MyEngine"], "Output",
 CellChangeTimes->{
  3.430728657125*^9, 3.434861830765625*^9, 3.434960424046875*^9, 
   3.434971034921875*^9, 3.43529898296875*^9, 3.435299466*^9, 
   3.435300856203125*^9, 3.435300889765625*^9, 3.43530097746875*^9, 
   3.4353016485*^9, 3.4356514338125*^9, {3.435668187703125*^9, 
   3.4356681934375*^9}, 3.436167702609375*^9, 3.43617862590625*^9, 
   3.4966554539915686`*^9, {3.5066837679375*^9, 3.50668377275*^9}, 
   3.506749071984375*^9, 3.5190960080363626`*^9, 3.521362238375*^9, 
   3.52783147859375*^9, 3.550318647120125*^9},
 CellTags->"Simple Example",
 CellLabel->"Out[45]=",
 CellID->783229541]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", "MyEngine"}]], "Input",
 CellChangeTimes->{{3.430549084796875*^9, 3.4305490898125*^9}},
 CellTags->"Simple Example",
 CellLabel->"In[46]:="],

Cell["Global`MyEngine", "Print", "PrintUsage",
 CellChangeTimes->{3.550318647667*^9},
 CellTags->{"Info3550325847-5601359", "Simple Example"},
 CellID->720213913],

Cell[BoxData[
 InterpretationBox[GridBox[{
    {GridBox[{
       {
        RowBox[{
         RowBox[{"BaseClass", "[", "MyEngine", "]"}], "^=", "\<\"\"\>"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"Category", "[", "MyEngine", "]"}], 
         "^=", "\<\"Pricing Engines\"\>"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"ClassName", "[", "MyEngine", "]"}], "^=", 
         "qlPricingEngine"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"EngineID", "[", "MyEngine", "]"}], "^=", "AE"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"Overwrite", "[", "MyEngine", "]"}], "^=", "True"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"Permanent", "[", "MyEngine", "]"}], "^=", "True"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"PrecedentObjects", "[", "MyEngine", "]"}], "^=", 
         RowBox[{"{", "\<\"GBSP\"\>", "}"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"PricingEngine", "[", "MyEngine", "]"}], "^=", "True"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"ProcessID", "[", "MyEngine", "]"}], "^=", "GBSP"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"Processor", "[", "MyEngine", "]"}], 
         "^=", "\<\"DefaultProcessor\"\>"}]},
       {" "},
       {
        RowBox[{
         RowBox[{"ValueObject", "[", "MyEngine", "]"}], "^=", 
         "qlPricingEngine"}]}
      },
      BaselinePosition->{Baseline, {1, 1}},
      GridBoxAlignment->{
       "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
        "RowsIndexed" -> {}},
      GridBoxItemSize->{"Columns" -> {{
           Scaled[0.999]}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
        "RowsIndexed" -> {}}]}
   },
   BaselinePosition->{Baseline, {1, 1}},
   GridBoxAlignment->{
    "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
     "RowsIndexed" -> {}}],
  Definition[$CellContext`MyEngine],
  Editable->False]], "Print",
 CellChangeTimes->{3.550318647713875*^9},
 CellTags->{"Info3550325847-5601359", "Simple Example"},
 CellID->83274273]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Doing the valuation", "Subsubsection",
 CellChangeTimes->{{3.42719642565625*^9, 3.42719642996875*^9}},
 CellTags->"Simple Example"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"evaluationDate", " ", "=", " ", 
   RowBox[{"{", 
    RowBox[{"1998", ",", "5", ",", "15"}], "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"SetEvaluationDate", "[", "evaluationDate", 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{"NPV", "[", 
  RowBox[{"MyVanilla", ",", "MyEngine"}], "]"}]}], "Input",
 CellChangeTimes->{{3.427180701765625*^9, 3.427180719953125*^9}, {
   3.42719464834375*^9, 3.427194667171875*^9}, 3.4271961989375*^9, {
   3.42719641575*^9, 3.427196416109375*^9}},
 CellTags->"Simple Example",
 CellLabel->"In[47]:="],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"1998", ",", "5", ",", "15"}], "}"}]], "Output",
 CellChangeTimes->{3.4307286575*^9, 3.434861834671875*^9, 
  3.434960435453125*^9, 3.4349710418125*^9, 3.435298983125*^9, 
  3.435300856390625*^9, 3.435300889921875*^9, 3.435300977765625*^9, 
  3.435301648671875*^9, 3.435651436515625*^9, 3.43566819934375*^9, 
  3.43616770303125*^9, 3.43617862625*^9, 3.4966554580071936`*^9, 
  3.506683777046875*^9, 3.506749072421875*^9, 3.5190960126301126`*^9, 
  3.521362238859375*^9, 3.52783147940625*^9, 3.550318648151375*^9},
 CellTags->"Simple Example",
 CellLabel->"Out[48]=",
 CellID->55962281],

Cell[BoxData["3.8443077915968398`"], "Output",
 CellChangeTimes->{3.4307286575*^9, 3.434861834671875*^9, 
  3.434960435453125*^9, 3.4349710418125*^9, 3.435298983125*^9, 
  3.435300856390625*^9, 3.435300889921875*^9, 3.435300977765625*^9, 
  3.435301648671875*^9, 3.435651436515625*^9, 3.43566819934375*^9, 
  3.43616770303125*^9, 3.43617862625*^9, 3.4966554580071936`*^9, 
  3.506683777046875*^9, 3.506749072421875*^9, 3.5190960126301126`*^9, 
  3.521362238859375*^9, 3.52783147940625*^9, 3.550318648401375*^9},
 CellTags->"Simple Example",
 CellLabel->"Out[49]=",
 CellID->6331066]
}, Open  ]]
}, Open  ]]
}, Open  ]]
}, Open  ]]
}, Open  ]]
},
FileChangeProtection->None,
WindowSize->{717, 748},
WindowMargins->{{Automatic, -1963}, {67, Automatic}},
WindowFrame->"Normal",
DockedCells->FEPrivate`FrontEndResource["FEExpressions", "HelpViewerToolbar"],
ShowSelection->True,
TaggingRules->{
 "SearchTextTranslated" -> "", "SearchText" -> "", "LinkTrails" -> ""},
CreateCellID->True,
CellLabelAutoDelete->False,
ShowCellTags->False,
Magnification->1.,
FrontEndVersion->"8.0 for Microsoft Windows (32-bit) (October 6, 2011)",
StyleDefinitions->"HelpBrowser.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "Installing"->{
  Cell[626, 26, 146, 2, 54, "SectionFirst",
   CellTags->"Installing"],
  Cell[775, 30, 219, 7, 39, "MathCaption",
   CellTags->"Installing"],
  Cell[1019, 41, 235, 5, 27, "Input",
   CellTags->"Installing"],
  Cell[1257, 48, 2121, 52, 75, "Print",
   CellTags->"Installing",
   CellID->384280253],
  Cell[3381, 102, 2991, 75, 122, "Print",
   CellTags->"Installing",
   CellID->155040551],
  Cell[6375, 179, 1058, 16, 212, "Print",
   CellTags->"Installing",
   CellID->607534092],
  Cell[7436, 197, 360, 12, 40, "Print",
   CellTags->"Installing",
   CellID->629518575],
  Cell[7799, 211, 302, 6, 21, "Print",
   CellTags->"Installing",
   CellID->56890738],
  Cell[8104, 219, 507, 12, 21, "Print",
   CellTags->"Installing",
   CellID->9367767],
  Cell[8626, 234, 161, 2, 39, "MathCaption",
   CellTags->"Installing"],
  Cell[8812, 240, 352, 7, 27, "Input",
   CellTags->"Installing"],
  Cell[9167, 249, 1897, 30, 25, "Output",
   CellTags->"Installing",
   CellID->254741371]},
 "Getting Around"->{
  Cell[11113, 285, 176, 3, 63, "Section",
   CellTags->"Getting Around"],
  Cell[11292, 290, 212, 5, 23, "Text",
   CellTags->"Getting Around"],
  Cell[11529, 299, 156, 3, 27, "Input",
   CellTags->"Getting Around"],
  Cell[11688, 304, 2085, 34, 254, "Output",
   CellTags->"Getting Around",
   CellID->189936670],
  Cell[13788, 341, 168, 2, 23, "Text",
   CellTags->"Getting Around"],
  Cell[13981, 347, 103, 3, 27, "Input",
   CellTags->"Getting Around"],
  Cell[14087, 352, 410, 11, 40, "Print",
   CellTags->{"Getting Around", "Info3550325833-5601359"},
   CellID->327663261],
  Cell[14512, 366, 251, 6, 23, "Text",
   CellTags->"Getting Around"],
  Cell[14788, 376, 186, 4, 27, "Input",
   CellTags->"Getting Around"],
  Cell[14977, 382, 603, 15, 45, "Output",
   CellTags->"Getting Around",
   CellID->571048658],
  Cell[15617, 402, 234, 5, 27, "Input",
   CellTags->"Getting Around"],
  Cell[15854, 409, 2633, 43, 349, "Output",
   CellTags->"Getting Around",
   CellID->65352055],
  Cell[18502, 455, 219, 5, 23, "Text",
   CellTags->"Getting Around"],
  Cell[18746, 464, 286, 8, 27, "Input",
   CellTags->"Getting Around"],
  Cell[19035, 474, 835, 17, 83, "Output",
   CellTags->"Getting Around",
   CellID->289322088],
  Cell[19907, 496, 330, 9, 27, "Input",
   CellTags->"Getting Around"],
  Cell[20240, 507, 1228, 22, 178, "Output",
   CellTags->"Getting Around",
   CellID->774717833],
  Cell[21483, 532, 257, 4, 23, "Text",
   CellTags->"Getting Around",
   CellID->784984969],
  Cell[21765, 540, 217, 5, 27, "Input",
   CellTags->"Getting Around",
   CellID->76658636],
  Cell[21985, 547, 490, 8, 141, "Print",
   CellTags->{"Getting Around", "Info3550325834-5601359"},
   CellID->830330486],
  Cell[22490, 558, 182, 4, 23, "Text",
   CellTags->"Getting Around",
   CellID->503063432],
  Cell[22697, 566, 238, 5, 27, "Input",
   CellTags->"Getting Around",
   CellID->136765052],
  Cell[22938, 573, 974, 18, 25, "Output",
   CellTags->"Getting Around",
   CellID->308547081]},
 "Info3550325833-5601359"->{
  Cell[14087, 352, 410, 11, 40, "Print",
   CellTags->{"Getting Around", "Info3550325833-5601359"},
   CellID->327663261]},
 "Info3550325834-5601359"->{
  Cell[21985, 547, 490, 8, 141, "Print",
   CellTags->{"Getting Around", "Info3550325834-5601359"},
   CellID->830330486]},
 "Simple Example"->{
  Cell[28749, 718, 156, 2, 63, "Section",
   CellTags->"Simple Example",
   CellID->401107822],
  Cell[28908, 722, 452, 8, 39, "Text",
   CellTags->"Simple Example",
   CellID->524069249],
  Cell[29385, 734, 137, 2, 37, "Subsection",
   CellTags->"Simple Example",
   CellID->162143847],
  Cell[29547, 740, 173, 4, 27, "Input",
   CellTags->"Simple Example",
   CellID->62993114],
  Cell[29723, 746, 786, 12, 175, "Print",
   CellTags->{"Info3550325835-5601359", "Simple Example"},
   CellID->872258241],
  Cell[30524, 761, 254, 6, 39, "Text",
   CellTags->"Simple Example",
   CellID->125504343],
  Cell[30803, 771, 187, 4, 27, "Input",
   CellTags->"Simple Example",
   CellID->275013696],
  Cell[30993, 777, 922, 18, 25, "Output",
   CellTags->"Simple Example",
   CellID->63080394],
  Cell[31952, 800, 1165, 29, 155, "Input",
   CellTags->"Simple Example",
   CellID->465103082],
  Cell[33120, 831, 757, 13, 25, "Output",
   CellTags->"Simple Example",
   CellID->131388257],
  Cell[33926, 850, 183, 3, 37, "Subsection",
   CellTags->"Simple Example",
   CellID->280859728],
  Cell[34134, 857, 140, 2, 33, "Subsubsection",
   CellTags->"Simple Example",
   CellID->144243980],
  Cell[34277, 861, 368, 7, 23, "Text",
   CellTags->"Simple Example",
   CellID->674100896],
  Cell[34670, 872, 471, 12, 68, "Input",
   CellTags->"Simple Example",
   CellID->48627316],
  Cell[35144, 886, 370, 7, 25, "Output",
   CellTags->"Simple Example",
   CellID->715045043],
  Cell[35517, 895, 159, 3, 40, "Print",
   CellTags->{"Info3550325837-5601359", "Simple Example"},
   CellID->64334317],
  Cell[35679, 900, 1793, 58, 261, "Print",
   CellTags->{"Info3550325837-5601359", "Simple Example"},
   CellID->17801710],
  Cell[37487, 961, 613, 11, 39, "Text",
   CellTags->"Simple Example",
   CellID->216555574],
  Cell[38125, 976, 166, 4, 27, "Input",
   CellTags->"Simple Example",
   CellID->330312047],
  Cell[38294, 982, 245, 5, 38, "Print",
   CellTags->{"Info3550325838-5601359", "Simple Example"},
   CellID->150779459],
  Cell[38576, 992, 177, 4, 27, "Input",
   CellTags->"Simple Example",
   CellID->635996284],
  Cell[38756, 998, 771, 12, 192, "Print",
   CellTags->{"Info3550325839-5601359", "Simple Example"},
   CellID->541692868],
  Cell[39564, 1015, 377, 8, 27, "Input",
   CellTags->"Simple Example",
   CellID->416919154],
  Cell[39944, 1025, 669, 12, 25, "Output",
   CellTags->"Simple Example",
   CellID->214921087],
  Cell[40650, 1042, 235, 5, 27, "Input",
   CellTags->"Simple Example",
   CellID->217395728],
  Cell[40888, 1049, 585, 10, 25, "Output",
   CellTags->"Simple Example",
   CellID->366913013],
  Cell[41510, 1064, 169, 4, 27, "Input",
   CellTags->"Simple Example",
   CellID->427107593],
  Cell[41682, 1070, 165, 3, 40, "Print",
   CellTags->{"Info3550325841-5601359", "Simple Example"},
   CellID->46853144],
  Cell[41850, 1075, 2381, 77, 381, "Print",
   CellTags->{"Info3550325841-5601359", "Simple Example"},
   CellID->214824038],
  Cell[44246, 1155, 194, 3, 23, "Text",
   CellTags->"Simple Example",
   CellID->683547521],
  Cell[44465, 1162, 228, 5, 27, "Input",
   CellTags->"Simple Example",
   CellID->14548466],
  Cell[44696, 1169, 662, 13, 25, "Output",
   CellTags->"Simple Example",
   CellID->236098151],
  Cell[45407, 1188, 214, 3, 33, "Subsubsection",
   CellTags->"Simple Example",
   CellID->265634480],
  Cell[45624, 1193, 299, 7, 23, "Text",
   CellTags->"Simple Example",
   CellID->278308035],
  Cell[45948, 1204, 177, 4, 27, "Input",
   CellTags->"Simple Example",
   CellID->50457915],
  Cell[46128, 1210, 598, 10, 175, "Print",
   CellTags->{"Info3550325842-5601359", "Simple Example"},
   CellID->84788527],
  Cell[46763, 1225, 546, 12, 48, "Input",
   CellTags->"Simple Example",
   CellID->61170476],
  Cell[47312, 1239, 611, 11, 25, "Output",
   CellTags->"Simple Example",
   CellID->186414414],
  Cell[48465, 1272, 180, 4, 27, "Input",
   CellTags->"Simple Example",
   CellID->8604292],
  Cell[48648, 1278, 637, 14, 25, "Output",
   CellTags->"Simple Example",
   CellID->74980725],
  Cell[49300, 1295, 205, 5, 23, "Text",
   CellTags->"Simple Example",
   CellID->505763221],
  Cell[49530, 1304, 165, 4, 27, "Input",
   CellTags->"Simple Example",
   CellID->508000126],
  Cell[49698, 1310, 161, 3, 40, "Print",
   CellTags->{"Info3550325843-5601359", "Simple Example"},
   CellID->204066966],
  Cell[49862, 1315, 2197, 73, 351, "Print",
   CellTags->{"Info3550325843-5601359", "Simple Example"},
   CellID->792742662],
  Cell[52096, 1393, 353, 6, 48, "Input",
   CellTags->"Simple Example",
   CellID->53466449],
  Cell[52452, 1401, 754, 12, 226, "Print",
   CellTags->{"Info3550325844-5601359", "Simple Example"},
   CellID->28281282],
  Cell[53209, 1415, 795, 16, 25, "Output",
   CellTags->"Simple Example",
   CellID->9458628],
  Cell[54041, 1436, 526, 14, 68, "Input",
   CellTags->"Simple Example",
   CellID->232463650],
  Cell[54570, 1452, 615, 11, 25, "Output",
   CellTags->"Simple Example",
   CellID->182357516],
  Cell[55222, 1468, 170, 4, 27, "Input",
   CellTags->"Simple Example",
   CellID->758460177],
  Cell[55395, 1474, 160, 3, 40, "Print",
   CellTags->{"Info3550325845-5601359", "Simple Example"},
   CellID->165114475],
  Cell[55558, 1479, 2621, 85, 435, "Print",
   CellTags->{"Info3550325845-5601359", "Simple Example"},
   CellID->79533666],
  Cell[58228, 1570, 213, 3, 33, "Subsubsection",
   CellTags->"Simple Example",
   CellID->12505917],
  Cell[58466, 1577, 229, 5, 27, "Input",
   CellTags->"Simple Example",
   CellID->218592762],
  Cell[58698, 1584, 488, 8, 141, "Print",
   CellTags->{"Info3550325846-5601359", "Simple Example"},
   CellID->200963766],
  Cell[59223, 1597, 377, 7, 27, "Input",
   CellTags->"Simple Example",
   CellID->60304576],
  Cell[59603, 1606, 642, 12, 25, "Output",
   CellTags->"Simple Example",
   CellID->783229541],
  Cell[60282, 1623, 168, 4, 27, "Input",
   CellTags->"Simple Example",
   CellID->317798579],
  Cell[60453, 1629, 162, 3, 40, "Print",
   CellTags->{"Info3550325847-5601359", "Simple Example"},
   CellID->720213913],
  Cell[60618, 1634, 2104, 68, 321, "Print",
   CellTags->{"Info3550325847-5601359", "Simple Example"},
   CellID->83274273],
  Cell[62771, 1708, 137, 2, 33, "Subsubsection",
   CellTags->"Simple Example",
   CellID->225212895],
  Cell[62933, 1714, 574, 14, 68, "Input",
   CellTags->"Simple Example",
   CellID->603248867],
  Cell[63510, 1730, 624, 12, 25, "Output",
   CellTags->"Simple Example",
   CellID->55962281],
  Cell[64137, 1744, 582, 10, 25, "Output",
   CellTags->"Simple Example",
   CellID->6331066]},
 "Info3550325835-5601359"->{
  Cell[29723, 746, 786, 12, 175, "Print",
   CellTags->{"Info3550325835-5601359", "Simple Example"},
   CellID->872258241]},
 "Info3550325837-5601359"->{
  Cell[35517, 895, 159, 3, 40, "Print",
   CellTags->{"Info3550325837-5601359", "Simple Example"},
   CellID->64334317],
  Cell[35679, 900, 1793, 58, 261, "Print",
   CellTags->{"Info3550325837-5601359", "Simple Example"},
   CellID->17801710]},
 "Info3550325838-5601359"->{
  Cell[38294, 982, 245, 5, 38, "Print",
   CellTags->{"Info3550325838-5601359", "Simple Example"},
   CellID->150779459]},
 "Info3550325839-5601359"->{
  Cell[38756, 998, 771, 12, 192, "Print",
   CellTags->{"Info3550325839-5601359", "Simple Example"},
   CellID->541692868]},
 "Info3550325841-5601359"->{
  Cell[41682, 1070, 165, 3, 40, "Print",
   CellTags->{"Info3550325841-5601359", "Simple Example"},
   CellID->46853144],
  Cell[41850, 1075, 2381, 77, 381, "Print",
   CellTags->{"Info3550325841-5601359", "Simple Example"},
   CellID->214824038]},
 "Info3550325842-5601359"->{
  Cell[46128, 1210, 598, 10, 175, "Print",
   CellTags->{"Info3550325842-5601359", "Simple Example"},
   CellID->84788527],
  Cell[48181, 1262, 247, 5, 38, "Print",
   CellTags->"Info3550325842-5601359",
   CellID->46510895]},
 "Info3550325843-5601359"->{
  Cell[49698, 1310, 161, 3, 40, "Print",
   CellTags->{"Info3550325843-5601359", "Simple Example"},
   CellID->204066966],
  Cell[49862, 1315, 2197, 73, 351, "Print",
   CellTags->{"Info3550325843-5601359", "Simple Example"},
   CellID->792742662]},
 "Info3550325844-5601359"->{
  Cell[52452, 1401, 754, 12, 226, "Print",
   CellTags->{"Info3550325844-5601359", "Simple Example"},
   CellID->28281282]},
 "Info3550325845-5601359"->{
  Cell[55395, 1474, 160, 3, 40, "Print",
   CellTags->{"Info3550325845-5601359", "Simple Example"},
   CellID->165114475],
  Cell[55558, 1479, 2621, 85, 435, "Print",
   CellTags->{"Info3550325845-5601359", "Simple Example"},
   CellID->79533666]},
 "Info3550325846-5601359"->{
  Cell[58698, 1584, 488, 8, 141, "Print",
   CellTags->{"Info3550325846-5601359", "Simple Example"},
   CellID->200963766]},
 "Info3550325847-5601359"->{
  Cell[60453, 1629, 162, 3, 40, "Print",
   CellTags->{"Info3550325847-5601359", "Simple Example"},
   CellID->720213913],
  Cell[60618, 1634, 2104, 68, 321, "Print",
   CellTags->{"Info3550325847-5601359", "Simple Example"},
   CellID->83274273]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"Installing", 65412, 1781},
 {"Getting Around", 66415, 1813},
 {"Info3550325833-5601359", 68435, 1872},
 {"Info3550325834-5601359", 68588, 1876},
 {"Simple Example", 68733, 1880},
 {"Info3550325835-5601359", 75339, 2073},
 {"Info3550325837-5601359", 75493, 2077},
 {"Info3550325838-5601359", 75768, 2084},
 {"Info3550325839-5601359", 75920, 2088},
 {"Info3550325841-5601359", 76074, 2092},
 {"Info3550325842-5601359", 76352, 2099},
 {"Info3550325843-5601359", 76608, 2106},
 {"Info3550325844-5601359", 76887, 2113},
 {"Info3550325845-5601359", 77041, 2117},
 {"Info3550325846-5601359", 77319, 2124},
 {"Info3550325847-5601359", 77473, 2128}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[567, 22, 34, 0, 85, "Chapter"],
Cell[CellGroupData[{
Cell[626, 26, 146, 2, 54, "SectionFirst",
 CellTags->"Installing"],
Cell[775, 30, 219, 7, 39, "MathCaption",
 CellTags->"Installing"],
Cell[CellGroupData[{
Cell[1019, 41, 235, 5, 27, "Input",
 CellTags->"Installing"],
Cell[1257, 48, 2121, 52, 75, "Print",
 CellTags->"Installing",
 CellID->384280253],
Cell[3381, 102, 2991, 75, 122, "Print",
 CellTags->"Installing",
 CellID->155040551],
Cell[6375, 179, 1058, 16, 212, "Print",
 CellTags->"Installing",
 CellID->607534092],
Cell[7436, 197, 360, 12, 40, "Print",
 CellTags->"Installing",
 CellID->629518575],
Cell[7799, 211, 302, 6, 21, "Print",
 CellTags->"Installing",
 CellID->56890738],
Cell[8104, 219, 507, 12, 21, "Print",
 CellTags->"Installing",
 CellID->9367767]
}, Open  ]],
Cell[8626, 234, 161, 2, 39, "MathCaption",
 CellTags->"Installing"],
Cell[CellGroupData[{
Cell[8812, 240, 352, 7, 27, "Input",
 CellTags->"Installing"],
Cell[9167, 249, 1897, 30, 25, "Output",
 CellTags->"Installing",
 CellID->254741371]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[11113, 285, 176, 3, 63, "Section",
 CellTags->"Getting Around"],
Cell[11292, 290, 212, 5, 23, "Text",
 CellTags->"Getting Around"],
Cell[CellGroupData[{
Cell[11529, 299, 156, 3, 27, "Input",
 CellTags->"Getting Around"],
Cell[11688, 304, 2085, 34, 254, "Output",
 CellTags->"Getting Around",
 CellID->189936670]
}, Open  ]],
Cell[13788, 341, 168, 2, 23, "Text",
 CellTags->"Getting Around"],
Cell[CellGroupData[{
Cell[13981, 347, 103, 3, 27, "Input",
 CellTags->"Getting Around"],
Cell[14087, 352, 410, 11, 40, "Print",
 CellTags->{"Getting Around", "Info3550325833-5601359"},
 CellID->327663261]
}, Open  ]],
Cell[14512, 366, 251, 6, 23, "Text",
 CellTags->"Getting Around"],
Cell[CellGroupData[{
Cell[14788, 376, 186, 4, 27, "Input",
 CellTags->"Getting Around"],
Cell[14977, 382, 603, 15, 45, "Output",
 CellTags->"Getting Around",
 CellID->571048658]
}, Open  ]],
Cell[CellGroupData[{
Cell[15617, 402, 234, 5, 27, "Input",
 CellTags->"Getting Around"],
Cell[15854, 409, 2633, 43, 349, "Output",
 CellTags->"Getting Around",
 CellID->65352055]
}, Open  ]],
Cell[18502, 455, 219, 5, 23, "Text",
 CellTags->"Getting Around"],
Cell[CellGroupData[{
Cell[18746, 464, 286, 8, 27, "Input",
 CellTags->"Getting Around"],
Cell[19035, 474, 835, 17, 83, "Output",
 CellTags->"Getting Around",
 CellID->289322088]
}, Open  ]],
Cell[CellGroupData[{
Cell[19907, 496, 330, 9, 27, "Input",
 CellTags->"Getting Around"],
Cell[20240, 507, 1228, 22, 178, "Output",
 CellTags->"Getting Around",
 CellID->774717833]
}, Open  ]],
Cell[21483, 532, 257, 4, 23, "Text",
 CellTags->"Getting Around",
 CellID->784984969],
Cell[CellGroupData[{
Cell[21765, 540, 217, 5, 27, "Input",
 CellTags->"Getting Around",
 CellID->76658636],
Cell[21985, 547, 490, 8, 141, "Print",
 CellTags->{"Getting Around", "Info3550325834-5601359"},
 CellID->830330486]
}, Open  ]],
Cell[22490, 558, 182, 4, 23, "Text",
 CellTags->"Getting Around",
 CellID->503063432],
Cell[CellGroupData[{
Cell[22697, 566, 238, 5, 27, "Input",
 CellTags->"Getting Around",
 CellID->136765052],
Cell[22938, 573, 974, 18, 25, "Output",
 CellTags->"Getting Around",
 CellID->308547081]
}, Open  ]],
Cell[CellGroupData[{
Cell[23949, 596, 137, 2, 37, "Subsection",
 CellID->51701265],
Cell[CellGroupData[{
Cell[24111, 602, 287, 6, 27, "Input",
 CellID->315960191],
Cell[24401, 610, 1925, 34, 235, "Output",
 CellID->472215261]
}, Open  ]],
Cell[CellGroupData[{
Cell[26363, 649, 203, 4, 27, "Input",
 CellID->233331078],
Cell[26569, 655, 460, 10, 25, "Output",
 CellID->189598539]
}, Open  ]],
Cell[CellGroupData[{
Cell[27066, 670, 182, 4, 27, "Input",
 CellID->77070868],
Cell[27251, 676, 823, 15, 121, "Output",
 CellID->182695354]
}, Open  ]],
Cell[CellGroupData[{
Cell[28111, 696, 183, 5, 27, "Input",
 CellID->8560030],
Cell[28297, 703, 391, 8, 25, "Output",
 CellID->6938629]
}, Open  ]]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[28749, 718, 156, 2, 63, "Section",
 CellTags->"Simple Example",
 CellID->401107822],
Cell[28908, 722, 452, 8, 39, "Text",
 CellTags->"Simple Example",
 CellID->524069249],
Cell[CellGroupData[{
Cell[29385, 734, 137, 2, 37, "Subsection",
 CellTags->"Simple Example",
 CellID->162143847],
Cell[CellGroupData[{
Cell[29547, 740, 173, 4, 27, "Input",
 CellTags->"Simple Example",
 CellID->62993114],
Cell[29723, 746, 786, 12, 175, "Print",
 CellTags->{"Info3550325835-5601359", "Simple Example"},
 CellID->872258241]
}, Open  ]],
Cell[30524, 761, 254, 6, 39, "Text",
 CellTags->"Simple Example",
 CellID->125504343],
Cell[CellGroupData[{
Cell[30803, 771, 187, 4, 27, "Input",
 CellTags->"Simple Example",
 CellID->275013696],
Cell[30993, 777, 922, 18, 25, "Output",
 CellTags->"Simple Example",
 CellID->63080394]
}, Open  ]],
Cell[CellGroupData[{
Cell[31952, 800, 1165, 29, 155, "Input",
 CellTags->"Simple Example",
 CellID->465103082],
Cell[33120, 831, 757, 13, 25, "Output",
 CellTags->"Simple Example",
 CellID->131388257]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[33926, 850, 183, 3, 37, "Subsection",
 CellTags->"Simple Example",
 CellID->280859728],
Cell[CellGroupData[{
Cell[34134, 857, 140, 2, 33, "Subsubsection",
 CellTags->"Simple Example",
 CellID->144243980],
Cell[34277, 861, 368, 7, 23, "Text",
 CellTags->"Simple Example",
 CellID->674100896],
Cell[CellGroupData[{
Cell[34670, 872, 471, 12, 68, "Input",
 CellTags->"Simple Example",
 CellID->48627316],
Cell[35144, 886, 370, 7, 25, "Output",
 CellTags->"Simple Example",
 CellID->715045043],
Cell[35517, 895, 159, 3, 40, "Print",
 CellTags->{"Info3550325837-5601359", "Simple Example"},
 CellID->64334317],
Cell[35679, 900, 1793, 58, 261, "Print",
 CellTags->{"Info3550325837-5601359", "Simple Example"},
 CellID->17801710]
}, Open  ]],
Cell[37487, 961, 613, 11, 39, "Text",
 CellTags->"Simple Example",
 CellID->216555574],
Cell[CellGroupData[{
Cell[38125, 976, 166, 4, 27, "Input",
 CellTags->"Simple Example",
 CellID->330312047],
Cell[38294, 982, 245, 5, 38, "Print",
 CellTags->{"Info3550325838-5601359", "Simple Example"},
 CellID->150779459]
}, Open  ]],
Cell[CellGroupData[{
Cell[38576, 992, 177, 4, 27, "Input",
 CellTags->"Simple Example",
 CellID->635996284],
Cell[38756, 998, 771, 12, 192, "Print",
 CellTags->{"Info3550325839-5601359", "Simple Example"},
 CellID->541692868]
}, Open  ]],
Cell[CellGroupData[{
Cell[39564, 1015, 377, 8, 27, "Input",
 CellTags->"Simple Example",
 CellID->416919154],
Cell[39944, 1025, 669, 12, 25, "Output",
 CellTags->"Simple Example",
 CellID->214921087]
}, Open  ]],
Cell[CellGroupData[{
Cell[40650, 1042, 235, 5, 27, "Input",
 CellTags->"Simple Example",
 CellID->217395728],
Cell[40888, 1049, 585, 10, 25, "Output",
 CellTags->"Simple Example",
 CellID->366913013]
}, Open  ]],
Cell[CellGroupData[{
Cell[41510, 1064, 169, 4, 27, "Input",
 CellTags->"Simple Example",
 CellID->427107593],
Cell[41682, 1070, 165, 3, 40, "Print",
 CellTags->{"Info3550325841-5601359", "Simple Example"},
 CellID->46853144],
Cell[41850, 1075, 2381, 77, 381, "Print",
 CellTags->{"Info3550325841-5601359", "Simple Example"},
 CellID->214824038]
}, Open  ]],
Cell[44246, 1155, 194, 3, 23, "Text",
 CellTags->"Simple Example",
 CellID->683547521],
Cell[CellGroupData[{
Cell[44465, 1162, 228, 5, 27, "Input",
 CellTags->"Simple Example",
 CellID->14548466],
Cell[44696, 1169, 662, 13, 25, "Output",
 CellTags->"Simple Example",
 CellID->236098151]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[45407, 1188, 214, 3, 33, "Subsubsection",
 CellTags->"Simple Example",
 CellID->265634480],
Cell[45624, 1193, 299, 7, 23, "Text",
 CellTags->"Simple Example",
 CellID->278308035],
Cell[CellGroupData[{
Cell[45948, 1204, 177, 4, 27, "Input",
 CellTags->"Simple Example",
 CellID->50457915],
Cell[46128, 1210, 598, 10, 175, "Print",
 CellTags->{"Info3550325842-5601359", "Simple Example"},
 CellID->84788527]
}, Open  ]],
Cell[CellGroupData[{
Cell[46763, 1225, 546, 12, 48, "Input",
 CellTags->"Simple Example",
 CellID->61170476],
Cell[47312, 1239, 611, 11, 25, "Output",
 CellTags->"Simple Example",
 CellID->186414414]
}, Open  ]],
Cell[CellGroupData[{
Cell[47960, 1255, 218, 5, 27, "Input",
 CellID->120464415],
Cell[48181, 1262, 247, 5, 38, "Print",
 CellTags->"Info3550325842-5601359",
 CellID->46510895]
}, Open  ]],
Cell[CellGroupData[{
Cell[48465, 1272, 180, 4, 27, "Input",
 CellTags->"Simple Example",
 CellID->8604292],
Cell[48648, 1278, 637, 14, 25, "Output",
 CellTags->"Simple Example",
 CellID->74980725]
}, Open  ]],
Cell[49300, 1295, 205, 5, 23, "Text",
 CellTags->"Simple Example",
 CellID->505763221],
Cell[CellGroupData[{
Cell[49530, 1304, 165, 4, 27, "Input",
 CellTags->"Simple Example",
 CellID->508000126],
Cell[49698, 1310, 161, 3, 40, "Print",
 CellTags->{"Info3550325843-5601359", "Simple Example"},
 CellID->204066966],
Cell[49862, 1315, 2197, 73, 351, "Print",
 CellTags->{"Info3550325843-5601359", "Simple Example"},
 CellID->792742662]
}, Open  ]],
Cell[CellGroupData[{
Cell[52096, 1393, 353, 6, 48, "Input",
 CellTags->"Simple Example",
 CellID->53466449],
Cell[52452, 1401, 754, 12, 226, "Print",
 CellTags->{"Info3550325844-5601359", "Simple Example"},
 CellID->28281282],
Cell[53209, 1415, 795, 16, 25, "Output",
 CellTags->"Simple Example",
 CellID->9458628]
}, Open  ]],
Cell[CellGroupData[{
Cell[54041, 1436, 526, 14, 68, "Input",
 CellTags->"Simple Example",
 CellID->232463650],
Cell[54570, 1452, 615, 11, 25, "Output",
 CellTags->"Simple Example",
 CellID->182357516]
}, Open  ]],
Cell[CellGroupData[{
Cell[55222, 1468, 170, 4, 27, "Input",
 CellTags->"Simple Example",
 CellID->758460177],
Cell[55395, 1474, 160, 3, 40, "Print",
 CellTags->{"Info3550325845-5601359", "Simple Example"},
 CellID->165114475],
Cell[55558, 1479, 2621, 85, 435, "Print",
 CellTags->{"Info3550325845-5601359", "Simple Example"},
 CellID->79533666]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[58228, 1570, 213, 3, 33, "Subsubsection",
 CellTags->"Simple Example",
 CellID->12505917],
Cell[CellGroupData[{
Cell[58466, 1577, 229, 5, 27, "Input",
 CellTags->"Simple Example",
 CellID->218592762],
Cell[58698, 1584, 488, 8, 141, "Print",
 CellTags->{"Info3550325846-5601359", "Simple Example"},
 CellID->200963766]
}, Open  ]],
Cell[CellGroupData[{
Cell[59223, 1597, 377, 7, 27, "Input",
 CellTags->"Simple Example",
 CellID->60304576],
Cell[59603, 1606, 642, 12, 25, "Output",
 CellTags->"Simple Example",
 CellID->783229541]
}, Open  ]],
Cell[CellGroupData[{
Cell[60282, 1623, 168, 4, 27, "Input",
 CellTags->"Simple Example",
 CellID->317798579],
Cell[60453, 1629, 162, 3, 40, "Print",
 CellTags->{"Info3550325847-5601359", "Simple Example"},
 CellID->720213913],
Cell[60618, 1634, 2104, 68, 321, "Print",
 CellTags->{"Info3550325847-5601359", "Simple Example"},
 CellID->83274273]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[62771, 1708, 137, 2, 33, "Subsubsection",
 CellTags->"Simple Example",
 CellID->225212895],
Cell[CellGroupData[{
Cell[62933, 1714, 574, 14, 68, "Input",
 CellTags->"Simple Example",
 CellID->603248867],
Cell[63510, 1730, 624, 12, 25, "Output",
 CellTags->"Simple Example",
 CellID->55962281],
Cell[64137, 1744, 582, 10, 25, "Output",
 CellTags->"Simple Example",
 CellID->6331066]
}, Open  ]]
}, Open  ]]
}, Open  ]]
}, Open  ]]
}, Open  ]]
}
]
*)

(* End of internal cache information *)
