(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 8.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       157,          7]
NotebookDataLength[     85154,       1750]
NotebookOptionsPosition[     80815,       1589]
NotebookOutlinePosition[     82498,       1645]
CellTagsIndexPosition[     82340,       1638]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell[TextData[StyleBox["QuantLib example: Mixed Interpolation", "Notebook"]], \
"Title",
 CellChangeTimes->{{3.5194578514375*^9, 3.51945785446875*^9}, {
  3.519475196609375*^9, 3.51947520525*^9}},
 CellID->187417374],

Cell[CellGroupData[{

Cell["Setting up the link to QuantLib", "Section",
 CellChangeTimes->{{3.435664033015625*^9, 3.435664042359375*^9}},
 CellTags->"Installing",
 CellID->576010267],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Needs", "[", "\"\<QuantLib`\>\"", "]"}]], "Input",
 CellChangeTimes->{{3.519362707421875*^9, 3.519362718953125*^9}, 
   3.519362842390625*^9},
 CellLabel->"In[1]:=",
 CellID->59490525],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   TagBox[
    ButtonBox[
     PaneSelectorBox[{False->"\<\"QuantLib\"\>", True->
      StyleBox["\<\"QuantLib\"\>", "HyperlinkActive"]}, Dynamic[
       CurrentValue["MouseOver"]],
      BaseStyle->{"Hyperlink"},
      BaselinePosition->Baseline,
      FrameMargins->0,
      ImageSize->Automatic],
     BaseStyle->"Hyperlink",
     ButtonData->{
       URL["http://quantlib.org"], None},
     ButtonNote->"http://quantlib.org"],
    Annotation[#, "http://quantlib.org", "Hyperlink"]& ], 
   "\[InvisibleSpace]", "\<\" for Mathematica installed, Version \
0.2.5\\n\"\>", "\[InvisibleSpace]", "\<\"for \"\>", 
   "\[InvisibleSpace]", "\<\"Windows\"\>", 
   "\[InvisibleSpace]", "\<\" system \"\>", 
   "\[InvisibleSpace]", "\<\"Microsoft Windows (32-bit)\"\>", 
   "\[InvisibleSpace]", "\<\"\\n\"\>", 
   "\[InvisibleSpace]", "\<\"Mathematica Interface \[Copyright] by \"\>", 
   "\[InvisibleSpace]", 
   TagBox[
    ButtonBox[
     PaneSelectorBox[{False->"\<\"Weber & Partner\"\>", True->
      StyleBox["\<\"Weber & Partner\"\>", "HyperlinkActive"]}, Dynamic[
       CurrentValue["MouseOver"]],
      BaseStyle->{"Hyperlink"},
      BaselinePosition->Baseline,
      FrameMargins->0,
      ImageSize->Automatic],
     BaseStyle->"Hyperlink",
     ButtonData->{
       URL["http://www.weber-und-partner.com"], None},
     ButtonNote->"http://www.weber-und-partner.com"],
    Annotation[#, "http://www.weber-und-partner.com", "Hyperlink"]& ], 
   "\[InvisibleSpace]", "\<\" 2011\"\>"}],
  SequenceForm[
   Hyperlink["QuantLib", "http://quantlib.org"], 
   " for Mathematica installed, Version 0.2.5\n", "for ", "Windows", 
   " system ", "Microsoft Windows (32-bit)", "\n", 
   "Mathematica Interface \[Copyright] by ", 
   Hyperlink["Weber & Partner", "http://www.weber-und-partner.com"], " 2011"],
  Editable->False]], "Print",
 CellChangeTimes->{3.528708134171875*^9},
 CellLabel->"During evaluation of In[1]:=",
 CellID->489191079],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Visit \"\>", "\[InvisibleSpace]", 
   TagBox[
    ButtonBox[
     PaneSelectorBox[{
      False->"\<\"http://www.weber-und-partner.com/QuantLib/Mathematica\"\>", 
      True->
      StyleBox["\<\"http://www.weber-und-partner.com/QuantLib/Mathematica\"\>\
", "HyperlinkActive"]}, Dynamic[
       CurrentValue["MouseOver"]],
      BaseStyle->{"Hyperlink"},
      BaselinePosition->Baseline,
      FrameMargins->0,
      ImageSize->Automatic],
     BaseStyle->"Hyperlink",
     ButtonData->{
       URL["http://www.weber-und-partner.com/QuantLib/mma"], None},
     ButtonNote->"http://www.weber-und-partner.com/QuantLib/mma"],
    Annotation[#, "http://www.weber-und-partner.com/QuantLib/mma", 
     "Hyperlink"]& ], 
   "\[InvisibleSpace]", "\<\" for the latest version.\\nVisit \"\>", 
   "\[InvisibleSpace]", 
   TagBox[
    ButtonBox[
     PaneSelectorBox[{False->"\<\"http://quantlib.org/license.shtml\"\>", 
      True->
      StyleBox["\<\"http://quantlib.org/license.shtml\"\>", 
       "HyperlinkActive"]}, Dynamic[
       CurrentValue["MouseOver"]],
      BaseStyle->{"Hyperlink"},
      BaselinePosition->Baseline,
      FrameMargins->0,
      ImageSize->Automatic],
     BaseStyle->"Hyperlink",
     ButtonData->{
       URL["http://quantlib.org/license.shtml"], None},
     ButtonNote->"http://quantlib.org/license.shtml"],
    Annotation[#, "http://quantlib.org/license.shtml", "Hyperlink"]& ], 
   "\[InvisibleSpace]", "\<\" for the QuantLib license.\\nFor questions, \
support issues and enquiries mail to \"\>", "\[InvisibleSpace]", 
   TagBox[
    ButtonBox[
     PaneSelectorBox[{False->"\<\"quantLib@weber-und-partner.com\"\>", True->
      StyleBox["\<\"quantLib@weber-und-partner.com\"\>", "HyperlinkActive"]}, 
      Dynamic[
       CurrentValue["MouseOver"]],
      BaseStyle->{"Hyperlink"},
      BaselinePosition->Baseline,
      FrameMargins->0,
      ImageSize->Automatic],
     BaseStyle->"Hyperlink",
     ButtonData->{
       URL["mailto:quantLib@weber-und-partner.com"], None},
     ButtonNote->"mailto:quantLib@weber-und-partner.com"],
    Annotation[#, "mailto:quantLib@weber-und-partner.com", "Hyperlink"]& ], 
   "\[InvisibleSpace]", "\<\"\\n\"\>"}],
  SequenceForm["Visit ", 
   Hyperlink[
   "http://www.weber-und-partner.com/QuantLib/Mathematica", 
    "http://www.weber-und-partner.com/QuantLib/mma"], 
   " for the latest version.\nVisit ", 
   Hyperlink[
   "http://quantlib.org/license.shtml", "http://quantlib.org/license.shtml"], 
   " for the QuantLib license.\nFor questions, support issues and enquiries \
mail to ", 
   Hyperlink[
   "quantLib@weber-und-partner.com", "mailto:quantLib@weber-und-partner.com"],
    "\n"],
  Editable->False]], "Print",
 CellChangeTimes->{3.528708134171875*^9},
 CellLabel->"During evaluation of In[1]:=",
 CellID->412576558],

Cell[BoxData["\<\"THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND \
CONTRIBUTORS 'AS IS' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT \
NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A \
PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDERS OR \
CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, \
EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, \
PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; \
OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, \
WHETHER IN CONTRACT, STRICT LIABILITY OR TORT (INCLUDING NEGLIGENCE OR \
OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF \
ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.\\n\"\>"], "Print",
 CellChangeTimes->{3.5287081341875*^9},
 CellLabel->"During evaluation of In[1]:=",
 CellID->4281850],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"How", " ", "to", " ", "get", " ", "started"}], "MSG"], " ", 
  ButtonBox[
   StyleBox[">>", "SR"],
   Active->True,
   BaseStyle->"Link",
   ButtonData->"paclet:QuantLib/tutorial/Getting Started"]}]], "Print", \
"PrintUsage",
 CellChangeTimes->{3.528708134203125*^9},
 CellID->87002682],

Cell[BoxData["\<\"Setting default values:\"\>"], "Print",
 CellChangeTimes->{3.528708138578125*^9},
 CellLabel->"During evaluation of In[1]:=",
 CellID->776283697],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"  Setting Valuation Date = \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{"2011", ",", "10", ",", "27"}], "}"}]}],
  SequenceForm["  Setting Valuation Date = ", {2011, 10, 27}],
  Editable->False]], "Print",
 CellChangeTimes->{3.528708138578125*^9},
 CellLabel->"During evaluation of In[1]:=",
 CellID->495672]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"X", " ", "=", 
  RowBox[{"Range", "[", 
   RowBox[{
    RowBox[{"-", "10"}], ",", "10"}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{"Y", " ", "=", " ", 
  SuperscriptBox["X", "3"]}]}], "Input",
 CellChangeTimes->{{3.519457899828125*^9, 3.519457907078125*^9}, {
  3.519458007890625*^9, 3.519458022859375*^9}, {3.519462596109375*^9, 
  3.5194625973125*^9}},
 CellLabel->"In[2]:=",
 CellID->395385998],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"-", "10"}], ",", 
   RowBox[{"-", "9"}], ",", 
   RowBox[{"-", "8"}], ",", 
   RowBox[{"-", "7"}], ",", 
   RowBox[{"-", "6"}], ",", 
   RowBox[{"-", "5"}], ",", 
   RowBox[{"-", "4"}], ",", 
   RowBox[{"-", "3"}], ",", 
   RowBox[{"-", "2"}], ",", 
   RowBox[{"-", "1"}], ",", "0", ",", "1", ",", "2", ",", "3", ",", "4", ",", 
   "5", ",", "6", ",", "7", ",", "8", ",", "9", ",", "10"}], "}"}]], "Output",
 CellChangeTimes->{
  3.51945802584375*^9, 3.519459333171875*^9, 3.519459936078125*^9, 
   3.519461688265625*^9, 3.519462610953125*^9, 3.519463439296875*^9, 
   3.521362328578125*^9, {3.528708101875*^9, 3.528708139484375*^9}},
 CellLabel->"Out[2]=",
 CellID->657060515],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"-", "1000"}], ",", 
   RowBox[{"-", "729"}], ",", 
   RowBox[{"-", "512"}], ",", 
   RowBox[{"-", "343"}], ",", 
   RowBox[{"-", "216"}], ",", 
   RowBox[{"-", "125"}], ",", 
   RowBox[{"-", "64"}], ",", 
   RowBox[{"-", "27"}], ",", 
   RowBox[{"-", "8"}], ",", 
   RowBox[{"-", "1"}], ",", "0", ",", "1", ",", "8", ",", "27", ",", "64", 
   ",", "125", ",", "216", ",", "343", ",", "512", ",", "729", ",", "1000"}], 
  "}"}]], "Output",
 CellChangeTimes->{
  3.51945802584375*^9, 3.519459333171875*^9, 3.519459936078125*^9, 
   3.519461688265625*^9, 3.519462610953125*^9, 3.519463439296875*^9, 
   3.521362328578125*^9, {3.528708101875*^9, 3.528708139484375*^9}},
 CellLabel->"Out[3]=",
 CellID->92789188]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", "MixedLinearCubicInterpolation"}]], "Input",
 CellChangeTimes->{{3.519458254875*^9, 3.51945825759375*^9}, 
   3.51945934203125*^9},
 CellLabel->"In[4]:=",
 CellID->30754719],

Cell[BoxData[
 StyleBox["\<\"MixedLinearCubicInterpolation[ObjecctId_Symbol,XArray_List /; \
VectorQ[XArray, NumberQ],YArray_List,SwitchIndex_Integer] Construct an object \
of class MixedLinearCubicInterpolation and return its id\\n      \\nObjectId: \
id of object to be created\\nXArray: x array.\\nYArray: y \
array.\\nSwitchIndex: zero based knot index at which interpolation switches \
from linear to cubic.\\nDerApprox: Derivative Approximation (). Default value \
= Kruger.\\nMonotonic: monotonicity constraint flag. Default value = \
true.\\nLeftConditionType: left boundary condition (NotAKnot, \
FirstDerivative, SecondDerivative, Periodic, Lagrange). Default value = \
SecondDerivative.\\nLeftConditionValue: left condition value. Default value = \
0.0.\\nRightConditionType: right boundary condition (NotAKnot, \
FirstDerivative, SecondDerivative, Periodic, Lagrange). Default value = \
SecondDerivative.\\nRightConditionValue: right condition value. Default value \
= 0.0.\\nPermanent: object permanent/nonpermanent\"\>", "MSG"]], "Print", \
"PrintUsage",
 CellChangeTimes->{3.52870813975*^9},
 CellTags->"Info3528715339-1965606",
 CellID->577454949]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"Options", "[", "MixedLinearCubicInterpolation", "]"}], "=", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"DerApprox", "\[Rule]", "\"\<Kruger\>\""}], ",", 
    RowBox[{"Monotonic", "\[Rule]", "True"}], ",", 
    RowBox[{"LeftConditionType", "\[Rule]", "\"\<SecondDerivative\>\""}], ",", 
    RowBox[{"LeftConditionValue", "\[Rule]", "0."}], ",", 
    RowBox[{"RightConditionType", "\[Rule]", "\"\<SecondDerivative\>\""}], 
    ",", 
    RowBox[{"RightConditionValue", "\[Rule]", "0."}], ",", 
    RowBox[{"Permanent", "\[Rule]", "True"}], ",", 
    RowBox[{"Overwrite", "\[Rule]", "True"}]}], "}"}]}]], "Input",
 CellChangeTimes->{{3.51945881990625*^9, 3.519458821171875*^9}},
 CellLabel->"In[5]:=",
 CellID->553707825],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"DerApprox", "\[Rule]", "\<\"Kruger\"\>"}], ",", 
   RowBox[{"Monotonic", "\[Rule]", "True"}], ",", 
   RowBox[{"LeftConditionType", "\[Rule]", "\<\"SecondDerivative\"\>"}], ",", 
   RowBox[{"LeftConditionValue", "\[Rule]", "0.`"}], ",", 
   RowBox[{"RightConditionType", "\[Rule]", "\<\"SecondDerivative\"\>"}], ",", 
   RowBox[{"RightConditionValue", "\[Rule]", "0.`"}], ",", 
   RowBox[{"Permanent", "\[Rule]", "True"}], ",", 
   RowBox[{"Overwrite", "\[Rule]", "True"}]}], "}"}]], "Output",
 CellChangeTimes->{
  3.5194588230625*^9, 3.519459348828125*^9, 3.519459946296875*^9, 
   3.5194616955625*^9, 3.519462619921875*^9, 3.51946344525*^9, 
   3.52136232884375*^9, {3.52870810221875*^9, 3.528708140125*^9}},
 CellLabel->"Out[5]=",
 CellID->63203076]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"MixedLinearCubicInterpolation", "[", 
   RowBox[{"mixed", ",", "X", ",", "Y", ",", "10", ",", 
    RowBox[{"DerApprox", "\[Rule]", "\"\<Spline\>\""}]}], "]"}], 
  "  "}]], "Input",
 CellChangeTimes->{{3.51945807190625*^9, 3.51945807446875*^9}, {
  3.519458213640625*^9, 3.519458230453125*^9}, {3.519458310921875*^9, 
  3.519458313390625*^9}, {3.5194593983125*^9, 3.5194594014375*^9}, {
  3.51945997184375*^9, 3.519459972640625*^9}, {3.519461308609375*^9, 
  3.519461311515625*^9}, {3.519461700953125*^9, 3.51946173353125*^9}, {
  3.519462657171875*^9, 3.51946267690625*^9}},
 CellLabel->"In[6]:=",
 CellID->244101078],

Cell[BoxData["mixed"], "Output",
 CellChangeTimes->{
  3.5194583170625*^9, 3.51945882465625*^9, 3.519459365421875*^9, 
   3.519459402203125*^9, {3.51945997409375*^9, 3.5194599918125*^9}, {
   3.51946127775*^9, 3.519461312453125*^9}, 3.519461703171875*^9, 
   3.51946173421875*^9, 3.519462622265625*^9, 3.51946267978125*^9, 
   3.5194634471875*^9, 3.52136232890625*^9, {3.528708102296875*^9, 
   3.52870814015625*^9}},
 CellLabel->"Out[6]=",
 CellID->87461870]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"InterpolationInterpolate", "[", 
  RowBox[{"mixed", ",", "X"}], "]"}]], "Input",
 CellChangeTimes->{3.5194627328125*^9},
 CellLabel->"In[7]:=",
 CellID->335260195],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"-", "1000.`"}], ",", 
   RowBox[{"-", "729.`"}], ",", 
   RowBox[{"-", "512.`"}], ",", 
   RowBox[{"-", "343.`"}], ",", 
   RowBox[{"-", "216.`"}], ",", 
   RowBox[{"-", "125.`"}], ",", 
   RowBox[{"-", "64.`"}], ",", 
   RowBox[{"-", "27.`"}], ",", 
   RowBox[{"-", "8.`"}], ",", 
   RowBox[{"-", "1.`"}], ",", "0.`", ",", "1.`", ",", "8.`", ",", "27.`", ",",
    "64.`", ",", "125.`", ",", "216.`", ",", "343.`", ",", "512.`", ",", 
   "729.`", ",", "1000.`"}], "}"}]], "Output",
 CellChangeTimes->{
  3.51946273465625*^9, 3.519463448515625*^9, 3.5213623289375*^9, {
   3.528708102328125*^9, 3.528708140203125*^9}},
 CellLabel->"Out[7]=",
 CellID->479545664]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"InterpolationInterpolate", "[", 
  RowBox[{"mixed", ",", "0.5"}], "]"}]], "Input",
 CellChangeTimes->{{3.519463468140625*^9, 3.51946346953125*^9}},
 CellLabel->"In[8]:=",
 CellID->325163962],

Cell[BoxData["0.125`"], "Output",
 CellChangeTimes->{
  3.51946347034375*^9, 3.52136232896875*^9, {3.528708102359375*^9, 
   3.528708140234375*^9}},
 CellLabel->"Out[8]=",
 CellID->42988772]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", "QLInterpolation"}]], "Input",
 CellChangeTimes->{{3.51946175875*^9, 3.51946176696875*^9}},
 CellLabel->"In[9]:=",
 CellID->534114878],

Cell[BoxData[
 StyleBox["\<\"QLInterpolation[ObjecctId_Symbol,XArray_List /; \
VectorQ[XArray, NumberQ],YArray_List] Construct an object of class \
GenericInterp and return its id\\n      \\nObjectId: id of object to be \
created\\nInterpolationType: interpolation type (e.g BackwardFlat, \
ForwardFlat, Linear, LogLinear, NaturalCubicSpline, NaturalLogCubic, \
MonotonicNaturalCubicSpline, MonotonicNaturalLogCubic, KrugerCubic, \
KrugerLogCubic). Default value = MonotonicNaturalCubicSpline.\\nXArray: x \
array.\\nYArray: y array.\\nPermanent: object permanent/nonpermanent\"\>", 
  "MSG"]], "Print", "PrintUsage",
 CellChangeTimes->{3.52870814040625*^9},
 CellTags->"Info3528715340-1965606",
 CellID->944997335]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"QLInterpolation", "[", 
  RowBox[{"linear", ",", "X", ",", "Y", ",", 
   RowBox[{"InterpolationType", " ", "\[Rule]", " ", "\"\<Linear\>\""}]}], 
  "]"}]], "Input",
 CellChangeTimes->{{3.519462878609375*^9, 3.519462936109375*^9}},
 CellLabel->"In[10]:=",
 CellID->602904985],

Cell[BoxData["linear"], "Output",
 CellChangeTimes->{
  3.519462940375*^9, 3.519463481765625*^9, 3.521362329296875*^9, {
   3.52870810278125*^9, 3.528708140546875*^9}},
 CellLabel->"Out[10]=",
 CellID->365616394]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"InterpolationInterpolate", "[", 
  RowBox[{"linear", ",", "X"}], "]"}]], "Input",
 CellChangeTimes->{{3.519463493421875*^9, 3.51946349415625*^9}},
 CellLabel->"In[11]:=",
 CellID->161775376],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"-", "1000.`"}], ",", 
   RowBox[{"-", "729.`"}], ",", 
   RowBox[{"-", "512.`"}], ",", 
   RowBox[{"-", "343.`"}], ",", 
   RowBox[{"-", "216.`"}], ",", 
   RowBox[{"-", "125.`"}], ",", 
   RowBox[{"-", "64.`"}], ",", 
   RowBox[{"-", "27.`"}], ",", 
   RowBox[{"-", "8.`"}], ",", 
   RowBox[{"-", "1.`"}], ",", "0.`", ",", "1.`", ",", "8.`", ",", "27.`", ",",
    "64.`", ",", "125.`", ",", "216.`", ",", "343.`", ",", "512.`", ",", 
   "729.`", ",", "1000.`"}], "}"}]], "Output",
 CellChangeTimes->{
  3.519463494765625*^9, 3.521362329328125*^9, {3.528708102828125*^9, 
   3.52870814059375*^9}},
 CellLabel->"Out[11]=",
 CellID->253604127]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", "CubicInterpolation"}]], "Input",
 CellChangeTimes->{{3.519461883171875*^9, 3.519461885234375*^9}, {
   3.51946191609375*^9, 3.519461924515625*^9}, 3.51946352503125*^9},
 CellLabel->"In[12]:=",
 CellID->327747985],

Cell[BoxData[
 StyleBox["\<\"CubicInterpolation[ObjecctId_Symbol,XArray_List /; \
VectorQ[XArray, NumberQ],YArray_List] Construct an object of class \
CubicInterpolation and return its id\\n      \\nObjectId: id of object to be \
created\\nXArray: x array.\\nYArray: y array.\\nDerApprox: Derivative \
Approximation (). Default value = Kruger.\\nMonotonic: monotonicity \
constraint flag. Default value = true.\\nLeftConditionType: left boundary \
condition (NotAKnot, FirstDerivative, SecondDerivative, Periodic, Lagrange). \
Default value = SecondDerivative.\\nLeftConditionValue: left condition value. \
Default value = 0.0.\\nRightConditionType: right boundary condition \
(NotAKnot, FirstDerivative, SecondDerivative, Periodic, Lagrange). Default \
value = SecondDerivative.\\nRightConditionValue: right condition value. \
Default value = 0.0.\\nPermanent: object permanent/nonpermanent\"\>", 
  "MSG"]], "Print", "PrintUsage",
 CellChangeTimes->{3.528708140765625*^9},
 CellTags->"Info3528715340-1965606",
 CellID->145363296]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"CubicInterpolation", "[", 
  RowBox[{"cubic", ",", "X", ",", "Y", ",", 
   RowBox[{"DerApprox", "\[Rule]", "\"\<Spline\>\""}], ",", 
   RowBox[{"Monotonic", "\[Rule]", "False"}], ",", 
   RowBox[{"LeftConditionValue", "\[Rule]", "300"}], ",", 
   RowBox[{"RightConditionValue", "\[Rule]", "300"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.519463548703125*^9, 3.519463637265625*^9}},
 CellLabel->"In[13]:=",
 CellID->97509876],

Cell[BoxData["cubic"], "Output",
 CellChangeTimes->{
  3.51946363803125*^9, 3.52136232975*^9, {3.528708103390625*^9, 
   3.52870814090625*^9}},
 CellLabel->"Out[13]=",
 CellID->562154486]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"InterpolationInterpolate", "[", 
  RowBox[{"cubic", ",", "X"}], "]"}]], "Input",
 CellChangeTimes->{{3.519463647*^9, 3.519463647796875*^9}},
 CellLabel->"In[14]:=",
 CellID->99361],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"-", "1000.`"}], ",", 
   RowBox[{"-", "729.`"}], ",", 
   RowBox[{"-", "512.`"}], ",", 
   RowBox[{"-", "343.`"}], ",", 
   RowBox[{"-", "216.`"}], ",", 
   RowBox[{"-", "125.`"}], ",", 
   RowBox[{"-", "64.`"}], ",", 
   RowBox[{"-", "27.`"}], ",", 
   RowBox[{"-", "8.`"}], ",", 
   RowBox[{"-", "1.`"}], ",", "0.`", ",", "1.`", ",", "8.`", ",", "27.`", ",",
    "64.`", ",", "125.`", ",", "216.`", ",", "343.`", ",", "512.`", ",", 
   "729.`", ",", "1000.`"}], "}"}]], "Output",
 CellChangeTimes->{
  3.51946364846875*^9, 3.52136232978125*^9, {3.528708103421875*^9, 
   3.52870814115625*^9}},
 CellLabel->"Out[14]=",
 CellID->146908957]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Plot", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"Tooltip", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"InterpolationInterpolate", "[", 
         RowBox[{"linear", ",", "X"}], "]"}], "-", 
        RowBox[{"InterpolationInterpolate", "[", 
         RowBox[{"mixed", ",", "X"}], "]"}]}], ",", "\"\<linear-mixed\>\""}], 
      "]"}], ",", 
     RowBox[{"Tooltip", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"InterpolationInterpolate", "[", 
         RowBox[{"cubic", ",", "X"}], "]"}], "-", 
        RowBox[{"InterpolationInterpolate", "[", 
         RowBox[{"mixed", ",", "X"}], "]"}]}], ",", "\"\<cubic-mixed\>\""}], 
      "]"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"X", ",", 
     RowBox[{"-", "10"}], ",", "10"}], "}"}], ",", 
   RowBox[{"PlotRange", "\[Rule]", "All"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.519463663765625*^9, 3.519463710125*^9}, {
  3.519464072140625*^9, 3.5194642298125*^9}, {3.51946431540625*^9, 
  3.519464396265625*^9}},
 CellLabel->"In[15]:=",
 CellID->46527029],

Cell[BoxData[
 GraphicsBox[{{}, {}, 
   TagBox[
    TooltipBox[
     {Hue[0.67, 0.6, 0.6], LineBox[CompressedData["
1:eJxF3Hc8lu/7P/Abt733llJSSYokyXmQojSkoWRlJYRURiRKKEKRCpWVpJRR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       "]]},
     "\"linear-mixed\"",
     TooltipStyle->"TextStyling"],
    Annotation[#, "linear-mixed", "Tooltip"]& ], 
   TagBox[
    TooltipBox[
     {Hue[0.9060679774997897, 0.6, 0.6], LineBox[CompressedData["
1:eJwU2nc8lV8cB/CLa6+LS0b2KDMiETmnn0pU0qJBSUglSUIZSRJCilJGiZJV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       "]]},
     "\"cubic-mixed\"",
     TooltipStyle->"TextStyling"],
    Annotation[#, "cubic-mixed", "Tooltip"]& ]},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->True,
  AxesOrigin->{0, 0},
  PlotRange->{All, All},
  PlotRangeClipping->True,
  PlotRangePadding->{Automatic, Automatic}]], "Output",
 CellChangeTimes->{{3.519463701234375*^9, 3.51946371196875*^9}, {
   3.51946410665625*^9, 3.51946412546875*^9}, 3.519464187328125*^9, 
   3.51946423303125*^9, 3.519464344828125*^9, 3.519464399984375*^9, 
   3.521362330984375*^9, {3.528708104734375*^9, 3.528708142375*^9}},
 CellLabel->"Out[15]=",
 CellID->12914510]
}, Open  ]]
}, Open  ]]
}, Open  ]]
},
FileChangeProtection->None,
Editable->True,
WindowSize->{716, 820},
WindowMargins->{{232, Automatic}, {Automatic, 57}},
DockedCells->FEPrivate`FrontEndResource["FEExpressions", "HelpViewerToolbar"],
PageHeaders->{{None, None, None}, {None, None, 
   Cell[
    TextData[{
      Cell[
       TextData[{"Printed from [[YOUR APPLICATION'S NAME]] documentation "}], 
       "PageHeader"], 
      Cell[
       TextData[{
         CounterBox["Page"]}], "PageNumber"]}], 
    CellMargins -> {{Inherited, -29}, {Inherited, Inherited}}]}},
PageFooters->{{None, None, None}, {
   Cell[
    TextData[{"\[Copyright] 2008 Weber & Partner. All rights reserved."}], 
    "PageFooter"], None, None}},
ShowSelection->True,
TaggingRules->{"LinkTrails" -> "", "SearchTextTranslated" -> ""},
CreateCellID->True,
ShowCellTags->False,
FrontEndVersion->"8.0 for Microsoft Windows (32-bit) (February 23, 2011)",
StyleDefinitions->"HelpBrowser.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "Installing"->{
  Cell[820, 30, 161, 3, 63, "Section",
   CellTags->"Installing",
   CellID->576010267]},
 "Info3528715339-1965606"->{
  Cell[10040, 282, 1163, 18, 311, "Print",
   CellTags->"Info3528715339-1965606",
   CellID->577454949]},
 "Info3528715340-1965606"->{
  Cell[15533, 427, 715, 12, 192, "Print",
   CellTags->"Info3528715340-1965606",
   CellID->944997335],
  Cell[18026, 501, 1031, 16, 277, "Print",
   CellTags->"Info3528715340-1965606",
   CellID->145363296]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"Installing", 81853, 1620},
 {"Info3528715339-1965606", 81972, 1624},
 {"Info3528715340-1965606", 82107, 1628}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[579, 22, 216, 4, 103, "Title",
 CellID->187417374],
Cell[CellGroupData[{
Cell[820, 30, 161, 3, 63, "Section",
 CellTags->"Installing",
 CellID->576010267],
Cell[CellGroupData[{
Cell[1006, 37, 208, 5, 27, "Input",
 CellID->59490525],
Cell[1217, 44, 1981, 49, 75, "Print",
 CellID->489191079],
Cell[3201, 95, 2851, 72, 122, "Print",
 CellID->412576558],
Cell[6055, 169, 914, 13, 212, "Print",
 CellID->4281850],
Cell[6972, 184, 334, 11, 40, "Print",
 CellID->87002682],
Cell[7309, 197, 163, 3, 21, "Print",
 CellID->776283697],
Cell[7475, 202, 370, 9, 21, "Print",
 CellID->495672]
}, Open  ]],
Cell[CellGroupData[{
Cell[7882, 216, 423, 11, 48, "Input",
 CellID->395385998],
Cell[8308, 229, 729, 19, 25, "Output",
 CellID->657060515],
Cell[9040, 250, 759, 20, 45, "Output",
 CellID->92789188]
}, Open  ]],
Cell[CellGroupData[{
Cell[9836, 275, 201, 5, 27, "Input",
 CellID->30754719],
Cell[10040, 282, 1163, 18, 311, "Print",
 CellTags->"Info3528715339-1965606",
 CellID->577454949]
}, Open  ]],
Cell[CellGroupData[{
Cell[11240, 305, 749, 16, 88, "Input",
 CellID->553707825],
Cell[11992, 323, 805, 16, 64, "Output",
 CellID->63203076]
}, Open  ]],
Cell[CellGroupData[{
Cell[12834, 344, 652, 13, 27, "Input",
 CellID->244101078],
Cell[13489, 359, 459, 9, 25, "Output",
 CellID->87461870]
}, Open  ]],
Cell[CellGroupData[{
Cell[13985, 373, 187, 5, 27, "Input",
 CellID->335260195],
Cell[14175, 380, 712, 19, 45, "Output",
 CellID->479545664]
}, Open  ]],
Cell[CellGroupData[{
Cell[14924, 404, 214, 5, 27, "Input",
 CellID->325163962],
Cell[15141, 411, 190, 5, 25, "Output",
 CellID->42988772]
}, Open  ]],
Cell[CellGroupData[{
Cell[15368, 421, 162, 4, 27, "Input",
 CellID->534114878],
Cell[15533, 427, 715, 12, 192, "Print",
 CellTags->"Info3528715340-1965606",
 CellID->944997335]
}, Open  ]],
Cell[CellGroupData[{
Cell[16285, 444, 298, 7, 27, "Input",
 CellID->602904985],
Cell[16586, 453, 212, 5, 25, "Output",
 CellID->365616394]
}, Open  ]],
Cell[CellGroupData[{
Cell[16835, 463, 214, 5, 27, "Input",
 CellID->161775376],
Cell[17052, 470, 693, 19, 45, "Output",
 CellID->253604127]
}, Open  ]],
Cell[CellGroupData[{
Cell[17782, 494, 241, 5, 27, "Input",
 CellID->327747985],
Cell[18026, 501, 1031, 16, 277, "Print",
 CellTags->"Info3528715340-1965606",
 CellID->145363296]
}, Open  ]],
Cell[CellGroupData[{
Cell[19094, 522, 449, 9, 48, "Input",
 CellID->97509876],
Cell[19546, 533, 187, 5, 25, "Output",
 CellID->562154486]
}, Open  ]],
Cell[CellGroupData[{
Cell[19770, 543, 204, 5, 27, "Input",
 CellID->99361],
Cell[19977, 550, 691, 19, 45, "Output",
 CellID->146908957]
}, Open  ]],
Cell[CellGroupData[{
Cell[20705, 574, 1062, 29, 108, "Input",
 CellID->46527029],
Cell[21770, 605, 59005, 979, 234, "Output",
 CellID->12914510]
}, Open  ]]
}, Open  ]]
}, Open  ]]
}
]
*)

(* End of internal cache information *)
