(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 8.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       157,          7]
NotebookDataLength[    143012,       3663]
NotebookOptionsPosition[    132580,       3349]
NotebookOutlinePosition[    133130,       3372]
CellTagsIndexPosition[    133043,       3367]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell["\<\
This example shows how to set up a Term Structure and then price a simple \
swap.\
\>", "Title",
 CellChangeTimes->{
  3.56318271946875*^9, {3.563522419125*^9, 3.563522420296875*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Needs", "[", "\"\<QuantLib`\>\"", "]"}]], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   TagBox[
    ButtonBox[
     PaneSelectorBox[{False->"\<\"QuantLib\"\>", True->
      StyleBox["\<\"QuantLib\"\>", "HyperlinkActive"]}, Dynamic[
       CurrentValue["MouseOver"]],
      BaseStyle->{"Hyperlink"},
      BaselinePosition->Baseline,
      FrameMargins->0,
      ImageSize->Automatic],
     BaseStyle->"Hyperlink",
     ButtonData->{
       URL["http://quantlib.org"], None},
     ButtonNote->"http://quantlib.org"],
    Annotation[#, "http://quantlib.org", "Hyperlink"]& ], 
   "\[InvisibleSpace]", "\<\" for Mathematica installed, Version \
0.2.7\\n\"\>", "\[InvisibleSpace]", "\<\"for \"\>", 
   "\[InvisibleSpace]", "\<\"Windows\"\>", 
   "\[InvisibleSpace]", "\<\" system \"\>", 
   "\[InvisibleSpace]", "\<\"Microsoft Windows (64-bit)\"\>", 
   "\[InvisibleSpace]", "\<\"\\n\"\>", 
   "\[InvisibleSpace]", "\<\"Mathematica Interface \[Copyright] by \"\>", 
   "\[InvisibleSpace]", 
   TagBox[
    ButtonBox[
     PaneSelectorBox[{False->"\<\"Weber & Partner\"\>", True->
      StyleBox["\<\"Weber & Partner\"\>", "HyperlinkActive"]}, Dynamic[
       CurrentValue["MouseOver"]],
      BaseStyle->{"Hyperlink"},
      BaselinePosition->Baseline,
      FrameMargins->0,
      ImageSize->Automatic],
     BaseStyle->"Hyperlink",
     ButtonData->{
       URL["http://www.weber-und-partner.com"], None},
     ButtonNote->"http://www.weber-und-partner.com"],
    Annotation[#, "http://www.weber-und-partner.com", "Hyperlink"]& ], 
   "\[InvisibleSpace]", "\<\" 2012\"\>"}],
  SequenceForm[
   Hyperlink["QuantLib", "http://quantlib.org"], 
   " for Mathematica installed, Version 0.2.7\n", "for ", "Windows", 
   " system ", "Microsoft Windows (64-bit)", "\n", 
   "Mathematica Interface \[Copyright] by ", 
   Hyperlink["Weber & Partner", "http://www.weber-und-partner.com"], " 2012"],
  Editable->False]], "Print",
 CellChangeTimes->{3.563381922606496*^9, 3.5633830197522492`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Visit \"\>", "\[InvisibleSpace]", 
   TagBox[
    ButtonBox[
     PaneSelectorBox[{
      False->"\<\"http://www.weber-und-partner.com/QuantLib/Mathematica\"\>", 
      True->
      StyleBox["\<\"http://www.weber-und-partner.com/QuantLib/Mathematica\"\>\
", "HyperlinkActive"]}, Dynamic[
       CurrentValue["MouseOver"]],
      BaseStyle->{"Hyperlink"},
      BaselinePosition->Baseline,
      FrameMargins->0,
      ImageSize->Automatic],
     BaseStyle->"Hyperlink",
     ButtonData->{
       URL["http://www.weber-und-partner.com/QuantLib/mma"], None},
     ButtonNote->"http://www.weber-und-partner.com/QuantLib/mma"],
    Annotation[#, "http://www.weber-und-partner.com/QuantLib/mma", 
     "Hyperlink"]& ], 
   "\[InvisibleSpace]", "\<\" for the latest version.\\nVisit \"\>", 
   "\[InvisibleSpace]", 
   TagBox[
    ButtonBox[
     PaneSelectorBox[{False->"\<\"http://quantlib.org/license.shtml\"\>", 
      True->
      StyleBox["\<\"http://quantlib.org/license.shtml\"\>", 
       "HyperlinkActive"]}, Dynamic[
       CurrentValue["MouseOver"]],
      BaseStyle->{"Hyperlink"},
      BaselinePosition->Baseline,
      FrameMargins->0,
      ImageSize->Automatic],
     BaseStyle->"Hyperlink",
     ButtonData->{
       URL["http://quantlib.org/license.shtml"], None},
     ButtonNote->"http://quantlib.org/license.shtml"],
    Annotation[#, "http://quantlib.org/license.shtml", "Hyperlink"]& ], 
   "\[InvisibleSpace]", "\<\" for the QuantLib license.\\nFor questions, \
support issues and enquiries mail to \"\>", "\[InvisibleSpace]", 
   TagBox[
    ButtonBox[
     PaneSelectorBox[{False->"\<\"quantLib@weber-und-partner.com\"\>", True->
      StyleBox["\<\"quantLib@weber-und-partner.com\"\>", "HyperlinkActive"]}, 
      Dynamic[
       CurrentValue["MouseOver"]],
      BaseStyle->{"Hyperlink"},
      BaselinePosition->Baseline,
      FrameMargins->0,
      ImageSize->Automatic],
     BaseStyle->"Hyperlink",
     ButtonData->{
       URL["mailto:quantLib@weber-und-partner.com"], None},
     ButtonNote->"mailto:quantLib@weber-und-partner.com"],
    Annotation[#, "mailto:quantLib@weber-und-partner.com", "Hyperlink"]& ], 
   "\[InvisibleSpace]", "\<\"\\n\"\>"}],
  SequenceForm["Visit ", 
   Hyperlink[
   "http://www.weber-und-partner.com/QuantLib/Mathematica", 
    "http://www.weber-und-partner.com/QuantLib/mma"], 
   " for the latest version.\nVisit ", 
   Hyperlink[
   "http://quantlib.org/license.shtml", "http://quantlib.org/license.shtml"], 
   " for the QuantLib license.\nFor questions, support issues and enquiries \
mail to ", 
   Hyperlink[
   "quantLib@weber-und-partner.com", "mailto:quantLib@weber-und-partner.com"],
    "\n"],
  Editable->False]], "Print",
 CellChangeTimes->{3.563381922606496*^9, 3.56338301975725*^9}],

Cell[BoxData["\<\"THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND \
CONTRIBUTORS 'AS IS' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT \
NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A \
PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDERS OR \
CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, \
EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, \
PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; \
OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, \
WHETHER IN CONTRACT, STRICT LIABILITY OR TORT (INCLUDING NEGLIGENCE OR \
OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF \
ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.\\n\"\>"], "Print",
 CellChangeTimes->{3.563381922606496*^9, 3.5633830197692504`*^9}],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"How", " ", "to", " ", "get", " ", "started"}], "MSG"], " ", 
  ButtonBox[
   StyleBox[">>", "SR"],
   Active->True,
   BaseStyle->"Link",
   ButtonData->"paclet:QuantLib/tutorial/Getting Started"]}]], "Print", \
"PrintUsage",
 CellChangeTimes->{3.5633830197742505`*^9}],

Cell[BoxData["\<\"Setting default values:\"\>"], "Print",
 CellChangeTimes->{3.563381922606496*^9, 3.563383022309396*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"  Setting Valuation Date = \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{"2012", ",", "12", ",", "1"}], "}"}]}],
  SequenceForm["  Setting Valuation Date = ", {2012, 12, 1}],
  Editable->False]], "Print",
 CellChangeTimes->{3.563381922606496*^9, 3.5633830223133955`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   TagBox[
    ButtonBox[
     PaneSelectorBox[{False->"\<\"QuantLib\"\>", True->
      StyleBox["\<\"QuantLib\"\>", "HyperlinkActive"]}, Dynamic[
       CurrentValue["MouseOver"]],
      BaseStyle->{"Hyperlink"},
      BaselinePosition->Baseline,
      FrameMargins->0,
      ImageSize->Automatic],
     BaseStyle->"Hyperlink",
     ButtonData->{
       URL["http://quantlib.org"], None},
     ButtonNote->"http://quantlib.org"],
    Annotation[#, "http://quantlib.org", "Hyperlink"]& ], 
   "\[InvisibleSpace]", "\<\" for Mathematica installed, Version \
0.2.7\\n\"\>", "\[InvisibleSpace]", "\<\"for \"\>", 
   "\[InvisibleSpace]", "\<\"Windows\"\>", 
   "\[InvisibleSpace]", "\<\" system \"\>", 
   "\[InvisibleSpace]", "\<\"Microsoft Windows (64-bit)\"\>", 
   "\[InvisibleSpace]", "\<\"\\n\"\>", 
   "\[InvisibleSpace]", "\<\"Mathematica Interface \[Copyright] by \"\>", 
   "\[InvisibleSpace]", 
   TagBox[
    ButtonBox[
     PaneSelectorBox[{False->"\<\"Weber & Partner\"\>", True->
      StyleBox["\<\"Weber & Partner\"\>", "HyperlinkActive"]}, Dynamic[
       CurrentValue["MouseOver"]],
      BaseStyle->{"Hyperlink"},
      BaselinePosition->Baseline,
      FrameMargins->0,
      ImageSize->Automatic],
     BaseStyle->"Hyperlink",
     ButtonData->{
       URL["http://www.weber-und-partner.com"], None},
     ButtonNote->"http://www.weber-und-partner.com"],
    Annotation[#, "http://www.weber-und-partner.com", "Hyperlink"]& ], 
   "\[InvisibleSpace]", "\<\" 2012\"\>"}],
  SequenceForm[
   Hyperlink["QuantLib", "http://quantlib.org"], 
   " for Mathematica installed, Version 0.2.7\n", "for ", "Windows", 
   " system ", "Microsoft Windows (64-bit)", "\n", 
   "Mathematica Interface \[Copyright] by ", 
   Hyperlink["Weber & Partner", "http://www.weber-und-partner.com"], " 2012"],
  Editable->False]], "Print",
 CellChangeTimes->{3.563383279605112*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Visit \"\>", "\[InvisibleSpace]", 
   TagBox[
    ButtonBox[
     PaneSelectorBox[{
      False->"\<\"http://www.weber-und-partner.com/QuantLib/Mathematica\"\>", 
      True->
      StyleBox["\<\"http://www.weber-und-partner.com/QuantLib/Mathematica\"\>\
", "HyperlinkActive"]}, Dynamic[
       CurrentValue["MouseOver"]],
      BaseStyle->{"Hyperlink"},
      BaselinePosition->Baseline,
      FrameMargins->0,
      ImageSize->Automatic],
     BaseStyle->"Hyperlink",
     ButtonData->{
       URL["http://www.weber-und-partner.com/QuantLib/mma"], None},
     ButtonNote->"http://www.weber-und-partner.com/QuantLib/mma"],
    Annotation[#, "http://www.weber-und-partner.com/QuantLib/mma", 
     "Hyperlink"]& ], 
   "\[InvisibleSpace]", "\<\" for the latest version.\\nVisit \"\>", 
   "\[InvisibleSpace]", 
   TagBox[
    ButtonBox[
     PaneSelectorBox[{False->"\<\"http://quantlib.org/license.shtml\"\>", 
      True->
      StyleBox["\<\"http://quantlib.org/license.shtml\"\>", 
       "HyperlinkActive"]}, Dynamic[
       CurrentValue["MouseOver"]],
      BaseStyle->{"Hyperlink"},
      BaselinePosition->Baseline,
      FrameMargins->0,
      ImageSize->Automatic],
     BaseStyle->"Hyperlink",
     ButtonData->{
       URL["http://quantlib.org/license.shtml"], None},
     ButtonNote->"http://quantlib.org/license.shtml"],
    Annotation[#, "http://quantlib.org/license.shtml", "Hyperlink"]& ], 
   "\[InvisibleSpace]", "\<\" for the QuantLib license.\\nFor questions, \
support issues and enquiries mail to \"\>", "\[InvisibleSpace]", 
   TagBox[
    ButtonBox[
     PaneSelectorBox[{False->"\<\"quantLib@weber-und-partner.com\"\>", True->
      StyleBox["\<\"quantLib@weber-und-partner.com\"\>", "HyperlinkActive"]}, 
      Dynamic[
       CurrentValue["MouseOver"]],
      BaseStyle->{"Hyperlink"},
      BaselinePosition->Baseline,
      FrameMargins->0,
      ImageSize->Automatic],
     BaseStyle->"Hyperlink",
     ButtonData->{
       URL["mailto:quantLib@weber-und-partner.com"], None},
     ButtonNote->"mailto:quantLib@weber-und-partner.com"],
    Annotation[#, "mailto:quantLib@weber-und-partner.com", "Hyperlink"]& ], 
   "\[InvisibleSpace]", "\<\"\\n\"\>"}],
  SequenceForm["Visit ", 
   Hyperlink[
   "http://www.weber-und-partner.com/QuantLib/Mathematica", 
    "http://www.weber-und-partner.com/QuantLib/mma"], 
   " for the latest version.\nVisit ", 
   Hyperlink[
   "http://quantlib.org/license.shtml", "http://quantlib.org/license.shtml"], 
   " for the QuantLib license.\nFor questions, support issues and enquiries \
mail to ", 
   Hyperlink[
   "quantLib@weber-und-partner.com", "mailto:quantLib@weber-und-partner.com"],
    "\n"],
  Editable->False]], "Print",
 CellChangeTimes->{3.5633832796091127`*^9}],

Cell[BoxData["\<\"THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND \
CONTRIBUTORS 'AS IS' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT \
NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A \
PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDERS OR \
CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, \
EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, \
PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; \
OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, \
WHETHER IN CONTRACT, STRICT LIABILITY OR TORT (INCLUDING NEGLIGENCE OR \
OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF \
ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.\\n\"\>"], "Print",
 CellChangeTimes->{3.563383279614113*^9}],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"How", " ", "to", " ", "get", " ", "started"}], "MSG"], " ", 
  ButtonBox[
   StyleBox[">>", "SR"],
   Active->True,
   BaseStyle->"Link",
   ButtonData->"paclet:QuantLib/tutorial/Getting Started"]}]], "Print", \
"PrintUsage",
 CellChangeTimes->{3.563383279622113*^9}],

Cell[BoxData["\<\"Setting default values:\"\>"], "Print",
 CellChangeTimes->{3.563383281874242*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"  Setting Valuation Date = \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{"2012", ",", "12", ",", "1"}], "}"}]}],
  SequenceForm["  Setting Valuation Date = ", {2012, 12, 1}],
  Editable->False]], "Print",
 CellChangeTimes->{3.563383281877242*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   TagBox[
    ButtonBox[
     PaneSelectorBox[{False->"\<\"QuantLib\"\>", True->
      StyleBox["\<\"QuantLib\"\>", "HyperlinkActive"]}, Dynamic[
       CurrentValue["MouseOver"]],
      BaseStyle->{"Hyperlink"},
      BaselinePosition->Baseline,
      FrameMargins->0,
      ImageSize->Automatic],
     BaseStyle->"Hyperlink",
     ButtonData->{
       URL["http://quantlib.org"], None},
     ButtonNote->"http://quantlib.org"],
    Annotation[#, "http://quantlib.org", "Hyperlink"]& ], 
   "\[InvisibleSpace]", "\<\" for Mathematica installed, Version \
0.2.7\\n\"\>", "\[InvisibleSpace]", "\<\"for \"\>", 
   "\[InvisibleSpace]", "\<\"Windows\"\>", 
   "\[InvisibleSpace]", "\<\" system \"\>", 
   "\[InvisibleSpace]", "\<\"Microsoft Windows (64-bit)\"\>", 
   "\[InvisibleSpace]", "\<\"\\n\"\>", 
   "\[InvisibleSpace]", "\<\"Mathematica Interface \[Copyright] by \"\>", 
   "\[InvisibleSpace]", 
   TagBox[
    ButtonBox[
     PaneSelectorBox[{False->"\<\"Weber & Partner\"\>", True->
      StyleBox["\<\"Weber & Partner\"\>", "HyperlinkActive"]}, Dynamic[
       CurrentValue["MouseOver"]],
      BaseStyle->{"Hyperlink"},
      BaselinePosition->Baseline,
      FrameMargins->0,
      ImageSize->Automatic],
     BaseStyle->"Hyperlink",
     ButtonData->{
       URL["http://www.weber-und-partner.com"], None},
     ButtonNote->"http://www.weber-und-partner.com"],
    Annotation[#, "http://www.weber-und-partner.com", "Hyperlink"]& ], 
   "\[InvisibleSpace]", "\<\" 2012\"\>"}],
  SequenceForm[
   Hyperlink["QuantLib", "http://quantlib.org"], 
   " for Mathematica installed, Version 0.2.7\n", "for ", "Windows", 
   " system ", "Microsoft Windows (64-bit)", "\n", 
   "Mathematica Interface \[Copyright] by ", 
   Hyperlink["Weber & Partner", "http://www.weber-und-partner.com"], " 2012"],
  Editable->False]], "Print",
 CellChangeTimes->{3.5633833703022995`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Visit \"\>", "\[InvisibleSpace]", 
   TagBox[
    ButtonBox[
     PaneSelectorBox[{
      False->"\<\"http://www.weber-und-partner.com/QuantLib/Mathematica\"\>", 
      True->
      StyleBox["\<\"http://www.weber-und-partner.com/QuantLib/Mathematica\"\>\
", "HyperlinkActive"]}, Dynamic[
       CurrentValue["MouseOver"]],
      BaseStyle->{"Hyperlink"},
      BaselinePosition->Baseline,
      FrameMargins->0,
      ImageSize->Automatic],
     BaseStyle->"Hyperlink",
     ButtonData->{
       URL["http://www.weber-und-partner.com/QuantLib/mma"], None},
     ButtonNote->"http://www.weber-und-partner.com/QuantLib/mma"],
    Annotation[#, "http://www.weber-und-partner.com/QuantLib/mma", 
     "Hyperlink"]& ], 
   "\[InvisibleSpace]", "\<\" for the latest version.\\nVisit \"\>", 
   "\[InvisibleSpace]", 
   TagBox[
    ButtonBox[
     PaneSelectorBox[{False->"\<\"http://quantlib.org/license.shtml\"\>", 
      True->
      StyleBox["\<\"http://quantlib.org/license.shtml\"\>", 
       "HyperlinkActive"]}, Dynamic[
       CurrentValue["MouseOver"]],
      BaseStyle->{"Hyperlink"},
      BaselinePosition->Baseline,
      FrameMargins->0,
      ImageSize->Automatic],
     BaseStyle->"Hyperlink",
     ButtonData->{
       URL["http://quantlib.org/license.shtml"], None},
     ButtonNote->"http://quantlib.org/license.shtml"],
    Annotation[#, "http://quantlib.org/license.shtml", "Hyperlink"]& ], 
   "\[InvisibleSpace]", "\<\" for the QuantLib license.\\nFor questions, \
support issues and enquiries mail to \"\>", "\[InvisibleSpace]", 
   TagBox[
    ButtonBox[
     PaneSelectorBox[{False->"\<\"quantLib@weber-und-partner.com\"\>", True->
      StyleBox["\<\"quantLib@weber-und-partner.com\"\>", "HyperlinkActive"]}, 
      Dynamic[
       CurrentValue["MouseOver"]],
      BaseStyle->{"Hyperlink"},
      BaselinePosition->Baseline,
      FrameMargins->0,
      ImageSize->Automatic],
     BaseStyle->"Hyperlink",
     ButtonData->{
       URL["mailto:quantLib@weber-und-partner.com"], None},
     ButtonNote->"mailto:quantLib@weber-und-partner.com"],
    Annotation[#, "mailto:quantLib@weber-und-partner.com", "Hyperlink"]& ], 
   "\[InvisibleSpace]", "\<\"\\n\"\>"}],
  SequenceForm["Visit ", 
   Hyperlink[
   "http://www.weber-und-partner.com/QuantLib/Mathematica", 
    "http://www.weber-und-partner.com/QuantLib/mma"], 
   " for the latest version.\nVisit ", 
   Hyperlink[
   "http://quantlib.org/license.shtml", "http://quantlib.org/license.shtml"], 
   " for the QuantLib license.\nFor questions, support issues and enquiries \
mail to ", 
   Hyperlink[
   "quantLib@weber-und-partner.com", "mailto:quantLib@weber-und-partner.com"],
    "\n"],
  Editable->False]], "Print",
 CellChangeTimes->{3.5633833703052998`*^9}],

Cell[BoxData["\<\"THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND \
CONTRIBUTORS 'AS IS' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT \
NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A \
PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDERS OR \
CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, \
EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, \
PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; \
OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, \
WHETHER IN CONTRACT, STRICT LIABILITY OR TORT (INCLUDING NEGLIGENCE OR \
OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF \
ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.\\n\"\>"], "Print",
 CellChangeTimes->{3.5633833703103*^9}],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"How", " ", "to", " ", "get", " ", "started"}], "MSG"], " ", 
  ButtonBox[
   StyleBox[">>", "SR"],
   Active->True,
   BaseStyle->"Link",
   ButtonData->"paclet:QuantLib/tutorial/Getting Started"]}]], "Print", \
"PrintUsage",
 CellChangeTimes->{3.5633833703163004`*^9}],

Cell[BoxData["\<\"Setting default values:\"\>"], "Print",
 CellChangeTimes->{3.563383372509426*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"  Setting Valuation Date = \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{"2012", ",", "12", ",", "1"}], "}"}]}],
  SequenceForm["  Setting Valuation Date = ", {2012, 12, 1}],
  Editable->False]], "Print",
 CellChangeTimes->{3.563383372512426*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   TagBox[
    ButtonBox[
     PaneSelectorBox[{False->"\<\"QuantLib\"\>", True->
      StyleBox["\<\"QuantLib\"\>", "HyperlinkActive"]}, Dynamic[
       CurrentValue["MouseOver"]],
      BaseStyle->{"Hyperlink"},
      BaselinePosition->Baseline,
      FrameMargins->0,
      ImageSize->Automatic],
     BaseStyle->"Hyperlink",
     ButtonData->{
       URL["http://quantlib.org"], None},
     ButtonNote->"http://quantlib.org"],
    Annotation[#, "http://quantlib.org", "Hyperlink"]& ], 
   "\[InvisibleSpace]", "\<\" for Mathematica installed, Version \
0.2.7\\n\"\>", "\[InvisibleSpace]", "\<\"for \"\>", 
   "\[InvisibleSpace]", "\<\"Windows\"\>", 
   "\[InvisibleSpace]", "\<\" system \"\>", 
   "\[InvisibleSpace]", "\<\"Microsoft Windows (32-bit)\"\>", 
   "\[InvisibleSpace]", "\<\"\\n\"\>", 
   "\[InvisibleSpace]", "\<\"Mathematica Interface \[Copyright] by \"\>", 
   "\[InvisibleSpace]", 
   TagBox[
    ButtonBox[
     PaneSelectorBox[{False->"\<\"Weber & Partner\"\>", True->
      StyleBox["\<\"Weber & Partner\"\>", "HyperlinkActive"]}, Dynamic[
       CurrentValue["MouseOver"]],
      BaseStyle->{"Hyperlink"},
      BaselinePosition->Baseline,
      FrameMargins->0,
      ImageSize->Automatic],
     BaseStyle->"Hyperlink",
     ButtonData->{
       URL["http://www.weber-und-partner.com"], None},
     ButtonNote->"http://www.weber-und-partner.com"],
    Annotation[#, "http://www.weber-und-partner.com", "Hyperlink"]& ], 
   "\[InvisibleSpace]", "\<\" 2012\"\>"}],
  SequenceForm[
   Hyperlink["QuantLib", "http://quantlib.org"], 
   " for Mathematica installed, Version 0.2.7\n", "for ", "Windows", 
   " system ", "Microsoft Windows (32-bit)", "\n", 
   "Mathematica Interface \[Copyright] by ", 
   Hyperlink["Weber & Partner", "http://www.weber-und-partner.com"], " 2012"],
  Editable->False]], "Print",
 CellChangeTimes->{3.563513821453125*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Visit \"\>", "\[InvisibleSpace]", 
   TagBox[
    ButtonBox[
     PaneSelectorBox[{
      False->"\<\"http://www.weber-und-partner.com/QuantLib/Mathematica\"\>", 
      True->
      StyleBox["\<\"http://www.weber-und-partner.com/QuantLib/Mathematica\"\>\
", "HyperlinkActive"]}, Dynamic[
       CurrentValue["MouseOver"]],
      BaseStyle->{"Hyperlink"},
      BaselinePosition->Baseline,
      FrameMargins->0,
      ImageSize->Automatic],
     BaseStyle->"Hyperlink",
     ButtonData->{
       URL["http://www.weber-und-partner.com/QuantLib/mma"], None},
     ButtonNote->"http://www.weber-und-partner.com/QuantLib/mma"],
    Annotation[#, "http://www.weber-und-partner.com/QuantLib/mma", 
     "Hyperlink"]& ], 
   "\[InvisibleSpace]", "\<\" for the latest version.\\nVisit \"\>", 
   "\[InvisibleSpace]", 
   TagBox[
    ButtonBox[
     PaneSelectorBox[{False->"\<\"http://quantlib.org/license.shtml\"\>", 
      True->
      StyleBox["\<\"http://quantlib.org/license.shtml\"\>", 
       "HyperlinkActive"]}, Dynamic[
       CurrentValue["MouseOver"]],
      BaseStyle->{"Hyperlink"},
      BaselinePosition->Baseline,
      FrameMargins->0,
      ImageSize->Automatic],
     BaseStyle->"Hyperlink",
     ButtonData->{
       URL["http://quantlib.org/license.shtml"], None},
     ButtonNote->"http://quantlib.org/license.shtml"],
    Annotation[#, "http://quantlib.org/license.shtml", "Hyperlink"]& ], 
   "\[InvisibleSpace]", "\<\" for the QuantLib license.\\nFor questions, \
support issues and enquiries mail to \"\>", "\[InvisibleSpace]", 
   TagBox[
    ButtonBox[
     PaneSelectorBox[{False->"\<\"quantLib@weber-und-partner.com\"\>", True->
      StyleBox["\<\"quantLib@weber-und-partner.com\"\>", "HyperlinkActive"]}, 
      Dynamic[
       CurrentValue["MouseOver"]],
      BaseStyle->{"Hyperlink"},
      BaselinePosition->Baseline,
      FrameMargins->0,
      ImageSize->Automatic],
     BaseStyle->"Hyperlink",
     ButtonData->{
       URL["mailto:quantLib@weber-und-partner.com"], None},
     ButtonNote->"mailto:quantLib@weber-und-partner.com"],
    Annotation[#, "mailto:quantLib@weber-und-partner.com", "Hyperlink"]& ], 
   "\[InvisibleSpace]", "\<\"\\n\"\>"}],
  SequenceForm["Visit ", 
   Hyperlink[
   "http://www.weber-und-partner.com/QuantLib/Mathematica", 
    "http://www.weber-und-partner.com/QuantLib/mma"], 
   " for the latest version.\nVisit ", 
   Hyperlink[
   "http://quantlib.org/license.shtml", "http://quantlib.org/license.shtml"], 
   " for the QuantLib license.\nFor questions, support issues and enquiries \
mail to ", 
   Hyperlink[
   "quantLib@weber-und-partner.com", "mailto:quantLib@weber-und-partner.com"],
    "\n"],
  Editable->False]], "Print",
 CellChangeTimes->{3.563513821453125*^9}],

Cell[BoxData["\<\"THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND \
CONTRIBUTORS 'AS IS' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT \
NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A \
PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDERS OR \
CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, \
EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, \
PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; \
OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, \
WHETHER IN CONTRACT, STRICT LIABILITY OR TORT (INCLUDING NEGLIGENCE OR \
OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF \
ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.\\n\"\>"], "Print",
 CellChangeTimes->{3.563513821453125*^9}],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"How", " ", "to", " ", "get", " ", "started"}], "MSG"], " ", 
  ButtonBox[
   StyleBox[">>", "SR"],
   Active->True,
   BaseStyle->"Link",
   ButtonData->"paclet:QuantLib/tutorial/Getting Started"]}]], "Print", \
"PrintUsage",
 CellChangeTimes->{3.56351382146875*^9}],

Cell[BoxData["\<\"Setting default values:\"\>"], "Print",
 CellChangeTimes->{3.563513827375*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"  Setting Valuation Date = \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{"2012", ",", "12", ",", "3"}], "}"}]}],
  SequenceForm["  Setting Valuation Date = ", {2012, 12, 3}],
  Editable->False]], "Print",
 CellChangeTimes->{3.5635138274375*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   TagBox[
    ButtonBox[
     PaneSelectorBox[{False->"\<\"QuantLib\"\>", True->
      StyleBox["\<\"QuantLib\"\>", "HyperlinkActive"]}, Dynamic[
       CurrentValue["MouseOver"]],
      BaseStyle->{"Hyperlink"},
      BaselinePosition->Baseline,
      FrameMargins->0,
      ImageSize->Automatic],
     BaseStyle->"Hyperlink",
     ButtonData->{
       URL["http://quantlib.org"], None},
     ButtonNote->"http://quantlib.org"],
    Annotation[#, "http://quantlib.org", "Hyperlink"]& ], 
   "\[InvisibleSpace]", "\<\" for Mathematica installed, Version \
0.2.7\\n\"\>", "\[InvisibleSpace]", "\<\"for \"\>", 
   "\[InvisibleSpace]", "\<\"Windows\"\>", 
   "\[InvisibleSpace]", "\<\" system \"\>", 
   "\[InvisibleSpace]", "\<\"Microsoft Windows (32-bit)\"\>", 
   "\[InvisibleSpace]", "\<\"\\n\"\>", 
   "\[InvisibleSpace]", "\<\"Mathematica Interface \[Copyright] by \"\>", 
   "\[InvisibleSpace]", 
   TagBox[
    ButtonBox[
     PaneSelectorBox[{False->"\<\"Weber & Partner\"\>", True->
      StyleBox["\<\"Weber & Partner\"\>", "HyperlinkActive"]}, Dynamic[
       CurrentValue["MouseOver"]],
      BaseStyle->{"Hyperlink"},
      BaselinePosition->Baseline,
      FrameMargins->0,
      ImageSize->Automatic],
     BaseStyle->"Hyperlink",
     ButtonData->{
       URL["http://www.weber-und-partner.com"], None},
     ButtonNote->"http://www.weber-und-partner.com"],
    Annotation[#, "http://www.weber-und-partner.com", "Hyperlink"]& ], 
   "\[InvisibleSpace]", "\<\" 2012\"\>"}],
  SequenceForm[
   Hyperlink["QuantLib", "http://quantlib.org"], 
   " for Mathematica installed, Version 0.2.7\n", "for ", "Windows", 
   " system ", "Microsoft Windows (32-bit)", "\n", 
   "Mathematica Interface \[Copyright] by ", 
   Hyperlink["Weber & Partner", "http://www.weber-und-partner.com"], " 2012"],
  Editable->False]], "Print",
 CellChangeTimes->{3.563519262515625*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Visit \"\>", "\[InvisibleSpace]", 
   TagBox[
    ButtonBox[
     PaneSelectorBox[{
      False->"\<\"http://www.weber-und-partner.com/QuantLib/Mathematica\"\>", 
      True->
      StyleBox["\<\"http://www.weber-und-partner.com/QuantLib/Mathematica\"\>\
", "HyperlinkActive"]}, Dynamic[
       CurrentValue["MouseOver"]],
      BaseStyle->{"Hyperlink"},
      BaselinePosition->Baseline,
      FrameMargins->0,
      ImageSize->Automatic],
     BaseStyle->"Hyperlink",
     ButtonData->{
       URL["http://www.weber-und-partner.com/QuantLib/mma"], None},
     ButtonNote->"http://www.weber-und-partner.com/QuantLib/mma"],
    Annotation[#, "http://www.weber-und-partner.com/QuantLib/mma", 
     "Hyperlink"]& ], 
   "\[InvisibleSpace]", "\<\" for the latest version.\\nVisit \"\>", 
   "\[InvisibleSpace]", 
   TagBox[
    ButtonBox[
     PaneSelectorBox[{False->"\<\"http://quantlib.org/license.shtml\"\>", 
      True->
      StyleBox["\<\"http://quantlib.org/license.shtml\"\>", 
       "HyperlinkActive"]}, Dynamic[
       CurrentValue["MouseOver"]],
      BaseStyle->{"Hyperlink"},
      BaselinePosition->Baseline,
      FrameMargins->0,
      ImageSize->Automatic],
     BaseStyle->"Hyperlink",
     ButtonData->{
       URL["http://quantlib.org/license.shtml"], None},
     ButtonNote->"http://quantlib.org/license.shtml"],
    Annotation[#, "http://quantlib.org/license.shtml", "Hyperlink"]& ], 
   "\[InvisibleSpace]", "\<\" for the QuantLib license.\\nFor questions, \
support issues and enquiries mail to \"\>", "\[InvisibleSpace]", 
   TagBox[
    ButtonBox[
     PaneSelectorBox[{False->"\<\"quantLib@weber-und-partner.com\"\>", True->
      StyleBox["\<\"quantLib@weber-und-partner.com\"\>", "HyperlinkActive"]}, 
      Dynamic[
       CurrentValue["MouseOver"]],
      BaseStyle->{"Hyperlink"},
      BaselinePosition->Baseline,
      FrameMargins->0,
      ImageSize->Automatic],
     BaseStyle->"Hyperlink",
     ButtonData->{
       URL["mailto:quantLib@weber-und-partner.com"], None},
     ButtonNote->"mailto:quantLib@weber-und-partner.com"],
    Annotation[#, "mailto:quantLib@weber-und-partner.com", "Hyperlink"]& ], 
   "\[InvisibleSpace]", "\<\"\\n\"\>"}],
  SequenceForm["Visit ", 
   Hyperlink[
   "http://www.weber-und-partner.com/QuantLib/Mathematica", 
    "http://www.weber-und-partner.com/QuantLib/mma"], 
   " for the latest version.\nVisit ", 
   Hyperlink[
   "http://quantlib.org/license.shtml", "http://quantlib.org/license.shtml"], 
   " for the QuantLib license.\nFor questions, support issues and enquiries \
mail to ", 
   Hyperlink[
   "quantLib@weber-und-partner.com", "mailto:quantLib@weber-und-partner.com"],
    "\n"],
  Editable->False]], "Print",
 CellChangeTimes->{3.56351926253125*^9}],

Cell[BoxData["\<\"THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND \
CONTRIBUTORS 'AS IS' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT \
NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A \
PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDERS OR \
CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, \
EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, \
PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; \
OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, \
WHETHER IN CONTRACT, STRICT LIABILITY OR TORT (INCLUDING NEGLIGENCE OR \
OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF \
ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.\\n\"\>"], "Print",
 CellChangeTimes->{3.56351926253125*^9}],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"How", " ", "to", " ", "get", " ", "started"}], "MSG"], " ", 
  ButtonBox[
   StyleBox[">>", "SR"],
   Active->True,
   BaseStyle->"Link",
   ButtonData->"paclet:QuantLib/tutorial/Getting Started"]}]], "Print", \
"PrintUsage",
 CellChangeTimes->{3.563519262640625*^9}],

Cell[BoxData["\<\"Setting default values:\"\>"], "Print",
 CellChangeTimes->{3.563519269265625*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"  Setting Valuation Date = \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{"2012", ",", "12", ",", "3"}], "}"}]}],
  SequenceForm["  Setting Valuation Date = ", {2012, 12, 3}],
  Editable->False]], "Print",
 CellChangeTimes->{3.5635192693125*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   TagBox[
    ButtonBox[
     PaneSelectorBox[{False->"\<\"QuantLib\"\>", True->
      StyleBox["\<\"QuantLib\"\>", "HyperlinkActive"]}, Dynamic[
       CurrentValue["MouseOver"]],
      BaseStyle->{"Hyperlink"},
      BaselinePosition->Baseline,
      FrameMargins->0,
      ImageSize->Automatic],
     BaseStyle->"Hyperlink",
     ButtonData->{
       URL["http://quantlib.org"], None},
     ButtonNote->"http://quantlib.org"],
    Annotation[#, "http://quantlib.org", "Hyperlink"]& ], 
   "\[InvisibleSpace]", "\<\" for Mathematica installed, Version \
0.2.7\\n\"\>", "\[InvisibleSpace]", "\<\"for \"\>", 
   "\[InvisibleSpace]", "\<\"Windows\"\>", 
   "\[InvisibleSpace]", "\<\" system \"\>", 
   "\[InvisibleSpace]", "\<\"Microsoft Windows (32-bit)\"\>", 
   "\[InvisibleSpace]", "\<\"\\n\"\>", 
   "\[InvisibleSpace]", "\<\"Mathematica Interface \[Copyright] by \"\>", 
   "\[InvisibleSpace]", 
   TagBox[
    ButtonBox[
     PaneSelectorBox[{False->"\<\"Weber & Partner\"\>", True->
      StyleBox["\<\"Weber & Partner\"\>", "HyperlinkActive"]}, Dynamic[
       CurrentValue["MouseOver"]],
      BaseStyle->{"Hyperlink"},
      BaselinePosition->Baseline,
      FrameMargins->0,
      ImageSize->Automatic],
     BaseStyle->"Hyperlink",
     ButtonData->{
       URL["http://www.weber-und-partner.com"], None},
     ButtonNote->"http://www.weber-und-partner.com"],
    Annotation[#, "http://www.weber-und-partner.com", "Hyperlink"]& ], 
   "\[InvisibleSpace]", "\<\" 2012\"\>"}],
  SequenceForm[
   Hyperlink["QuantLib", "http://quantlib.org"], 
   " for Mathematica installed, Version 0.2.7\n", "for ", "Windows", 
   " system ", "Microsoft Windows (32-bit)", "\n", 
   "Mathematica Interface \[Copyright] by ", 
   Hyperlink["Weber & Partner", "http://www.weber-und-partner.com"], " 2012"],
  Editable->False]], "Print",
 CellChangeTimes->{3.56352241375*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Visit \"\>", "\[InvisibleSpace]", 
   TagBox[
    ButtonBox[
     PaneSelectorBox[{
      False->"\<\"http://www.weber-und-partner.com/QuantLib/Mathematica\"\>", 
      True->
      StyleBox["\<\"http://www.weber-und-partner.com/QuantLib/Mathematica\"\>\
", "HyperlinkActive"]}, Dynamic[
       CurrentValue["MouseOver"]],
      BaseStyle->{"Hyperlink"},
      BaselinePosition->Baseline,
      FrameMargins->0,
      ImageSize->Automatic],
     BaseStyle->"Hyperlink",
     ButtonData->{
       URL["http://www.weber-und-partner.com/QuantLib/mma"], None},
     ButtonNote->"http://www.weber-und-partner.com/QuantLib/mma"],
    Annotation[#, "http://www.weber-und-partner.com/QuantLib/mma", 
     "Hyperlink"]& ], 
   "\[InvisibleSpace]", "\<\" for the latest version.\\nVisit \"\>", 
   "\[InvisibleSpace]", 
   TagBox[
    ButtonBox[
     PaneSelectorBox[{False->"\<\"http://quantlib.org/license.shtml\"\>", 
      True->
      StyleBox["\<\"http://quantlib.org/license.shtml\"\>", 
       "HyperlinkActive"]}, Dynamic[
       CurrentValue["MouseOver"]],
      BaseStyle->{"Hyperlink"},
      BaselinePosition->Baseline,
      FrameMargins->0,
      ImageSize->Automatic],
     BaseStyle->"Hyperlink",
     ButtonData->{
       URL["http://quantlib.org/license.shtml"], None},
     ButtonNote->"http://quantlib.org/license.shtml"],
    Annotation[#, "http://quantlib.org/license.shtml", "Hyperlink"]& ], 
   "\[InvisibleSpace]", "\<\" for the QuantLib license.\\nFor questions, \
support issues and enquiries mail to \"\>", "\[InvisibleSpace]", 
   TagBox[
    ButtonBox[
     PaneSelectorBox[{False->"\<\"quantLib@weber-und-partner.com\"\>", True->
      StyleBox["\<\"quantLib@weber-und-partner.com\"\>", "HyperlinkActive"]}, 
      Dynamic[
       CurrentValue["MouseOver"]],
      BaseStyle->{"Hyperlink"},
      BaselinePosition->Baseline,
      FrameMargins->0,
      ImageSize->Automatic],
     BaseStyle->"Hyperlink",
     ButtonData->{
       URL["mailto:quantLib@weber-und-partner.com"], None},
     ButtonNote->"mailto:quantLib@weber-und-partner.com"],
    Annotation[#, "mailto:quantLib@weber-und-partner.com", "Hyperlink"]& ], 
   "\[InvisibleSpace]", "\<\"\\n\"\>"}],
  SequenceForm["Visit ", 
   Hyperlink[
   "http://www.weber-und-partner.com/QuantLib/Mathematica", 
    "http://www.weber-und-partner.com/QuantLib/mma"], 
   " for the latest version.\nVisit ", 
   Hyperlink[
   "http://quantlib.org/license.shtml", "http://quantlib.org/license.shtml"], 
   " for the QuantLib license.\nFor questions, support issues and enquiries \
mail to ", 
   Hyperlink[
   "quantLib@weber-und-partner.com", "mailto:quantLib@weber-und-partner.com"],
    "\n"],
  Editable->False]], "Print",
 CellChangeTimes->{3.563522413765625*^9}],

Cell[BoxData["\<\"THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND \
CONTRIBUTORS 'AS IS' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT \
NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A \
PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDERS OR \
CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, \
EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, \
PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; \
OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, \
WHETHER IN CONTRACT, STRICT LIABILITY OR TORT (INCLUDING NEGLIGENCE OR \
OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF \
ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.\\n\"\>"], "Print",
 CellChangeTimes->{3.563522413765625*^9}],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"How", " ", "to", " ", "get", " ", "started"}], "MSG"], " ", 
  ButtonBox[
   StyleBox[">>", "SR"],
   Active->True,
   BaseStyle->"Link",
   ButtonData->"paclet:QuantLib/tutorial/Getting Started"]}]], "Print", \
"PrintUsage",
 CellChangeTimes->{3.563522413765625*^9}],

Cell[BoxData["\<\"Setting default values:\"\>"], "Print",
 CellChangeTimes->{3.56352241975*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"  Setting Valuation Date = \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{"2012", ",", "12", ",", "3"}], "}"}]}],
  SequenceForm["  Setting Valuation Date = ", {2012, 12, 3}],
  Editable->False]], "Print",
 CellChangeTimes->{3.563522419796875*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   TagBox[
    ButtonBox[
     PaneSelectorBox[{False->"\<\"QuantLib\"\>", True->
      StyleBox["\<\"QuantLib\"\>", "HyperlinkActive"]}, Dynamic[
       CurrentValue["MouseOver"]],
      BaseStyle->{"Hyperlink"},
      BaselinePosition->Baseline,
      FrameMargins->0,
      ImageSize->Automatic],
     BaseStyle->"Hyperlink",
     ButtonData->{
       URL["http://quantlib.org"], None},
     ButtonNote->"http://quantlib.org"],
    Annotation[#, "http://quantlib.org", "Hyperlink"]& ], 
   "\[InvisibleSpace]", "\<\" for Mathematica installed, Version \
0.2.7\\n\"\>", "\[InvisibleSpace]", "\<\"for \"\>", 
   "\[InvisibleSpace]", "\<\"Windows\"\>", 
   "\[InvisibleSpace]", "\<\" system \"\>", 
   "\[InvisibleSpace]", "\<\"Microsoft Windows (32-bit)\"\>", 
   "\[InvisibleSpace]", "\<\"\\n\"\>", 
   "\[InvisibleSpace]", "\<\"Mathematica Interface \[Copyright] by \"\>", 
   "\[InvisibleSpace]", 
   TagBox[
    ButtonBox[
     PaneSelectorBox[{False->"\<\"Weber & Partner\"\>", True->
      StyleBox["\<\"Weber & Partner\"\>", "HyperlinkActive"]}, Dynamic[
       CurrentValue["MouseOver"]],
      BaseStyle->{"Hyperlink"},
      BaselinePosition->Baseline,
      FrameMargins->0,
      ImageSize->Automatic],
     BaseStyle->"Hyperlink",
     ButtonData->{
       URL["http://www.weber-und-partner.com"], None},
     ButtonNote->"http://www.weber-und-partner.com"],
    Annotation[#, "http://www.weber-und-partner.com", "Hyperlink"]& ], 
   "\[InvisibleSpace]", "\<\" 2012\"\>"}],
  SequenceForm[
   Hyperlink["QuantLib", "http://quantlib.org"], 
   " for Mathematica installed, Version 0.2.7\n", "for ", "Windows", 
   " system ", "Microsoft Windows (32-bit)", "\n", 
   "Mathematica Interface \[Copyright] by ", 
   Hyperlink["Weber & Partner", "http://www.weber-und-partner.com"], " 2012"],
  Editable->False]], "Print",
 CellChangeTimes->{3.563523521765625*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Visit \"\>", "\[InvisibleSpace]", 
   TagBox[
    ButtonBox[
     PaneSelectorBox[{
      False->"\<\"http://www.weber-und-partner.com/QuantLib/Mathematica\"\>", 
      True->
      StyleBox["\<\"http://www.weber-und-partner.com/QuantLib/Mathematica\"\>\
", "HyperlinkActive"]}, Dynamic[
       CurrentValue["MouseOver"]],
      BaseStyle->{"Hyperlink"},
      BaselinePosition->Baseline,
      FrameMargins->0,
      ImageSize->Automatic],
     BaseStyle->"Hyperlink",
     ButtonData->{
       URL["http://www.weber-und-partner.com/QuantLib/mma"], None},
     ButtonNote->"http://www.weber-und-partner.com/QuantLib/mma"],
    Annotation[#, "http://www.weber-und-partner.com/QuantLib/mma", 
     "Hyperlink"]& ], 
   "\[InvisibleSpace]", "\<\" for the latest version.\\nVisit \"\>", 
   "\[InvisibleSpace]", 
   TagBox[
    ButtonBox[
     PaneSelectorBox[{False->"\<\"http://quantlib.org/license.shtml\"\>", 
      True->
      StyleBox["\<\"http://quantlib.org/license.shtml\"\>", 
       "HyperlinkActive"]}, Dynamic[
       CurrentValue["MouseOver"]],
      BaseStyle->{"Hyperlink"},
      BaselinePosition->Baseline,
      FrameMargins->0,
      ImageSize->Automatic],
     BaseStyle->"Hyperlink",
     ButtonData->{
       URL["http://quantlib.org/license.shtml"], None},
     ButtonNote->"http://quantlib.org/license.shtml"],
    Annotation[#, "http://quantlib.org/license.shtml", "Hyperlink"]& ], 
   "\[InvisibleSpace]", "\<\" for the QuantLib license.\\nFor questions, \
support issues and enquiries mail to \"\>", "\[InvisibleSpace]", 
   TagBox[
    ButtonBox[
     PaneSelectorBox[{False->"\<\"quantLib@weber-und-partner.com\"\>", True->
      StyleBox["\<\"quantLib@weber-und-partner.com\"\>", "HyperlinkActive"]}, 
      Dynamic[
       CurrentValue["MouseOver"]],
      BaseStyle->{"Hyperlink"},
      BaselinePosition->Baseline,
      FrameMargins->0,
      ImageSize->Automatic],
     BaseStyle->"Hyperlink",
     ButtonData->{
       URL["mailto:quantLib@weber-und-partner.com"], None},
     ButtonNote->"mailto:quantLib@weber-und-partner.com"],
    Annotation[#, "mailto:quantLib@weber-und-partner.com", "Hyperlink"]& ], 
   "\[InvisibleSpace]", "\<\"\\n\"\>"}],
  SequenceForm["Visit ", 
   Hyperlink[
   "http://www.weber-und-partner.com/QuantLib/Mathematica", 
    "http://www.weber-und-partner.com/QuantLib/mma"], 
   " for the latest version.\nVisit ", 
   Hyperlink[
   "http://quantlib.org/license.shtml", "http://quantlib.org/license.shtml"], 
   " for the QuantLib license.\nFor questions, support issues and enquiries \
mail to ", 
   Hyperlink[
   "quantLib@weber-und-partner.com", "mailto:quantLib@weber-und-partner.com"],
    "\n"],
  Editable->False]], "Print",
 CellChangeTimes->{3.563523521828125*^9}],

Cell[BoxData["\<\"THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND \
CONTRIBUTORS 'AS IS' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT \
NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A \
PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDERS OR \
CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, \
EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, \
PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; \
OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, \
WHETHER IN CONTRACT, STRICT LIABILITY OR TORT (INCLUDING NEGLIGENCE OR \
OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF \
ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.\\n\"\>"], "Print",
 CellChangeTimes->{3.563523521828125*^9}],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"How", " ", "to", " ", "get", " ", "started"}], "MSG"], " ", 
  ButtonBox[
   StyleBox[">>", "SR"],
   Active->True,
   BaseStyle->"Link",
   ButtonData->"paclet:QuantLib/tutorial/Getting Started"]}]], "Print", \
"PrintUsage",
 CellChangeTimes->{3.56352352184375*^9}],

Cell[BoxData["\<\"Setting default values:\"\>"], "Print",
 CellChangeTimes->{3.563523527078125*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"  Setting Valuation Date = \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{"2012", ",", "12", ",", "3"}], "}"}]}],
  SequenceForm["  Setting Valuation Date = ", {2012, 12, 3}],
  Editable->False]], "Print",
 CellChangeTimes->{3.56352352709375*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   TagBox[
    ButtonBox[
     PaneSelectorBox[{False->"\<\"QuantLib\"\>", True->
      StyleBox["\<\"QuantLib\"\>", "HyperlinkActive"]}, Dynamic[
       CurrentValue["MouseOver"]],
      BaseStyle->{"Hyperlink"},
      BaselinePosition->Baseline,
      FrameMargins->0,
      ImageSize->Automatic],
     BaseStyle->"Hyperlink",
     ButtonData->{
       URL["http://quantlib.org"], None},
     ButtonNote->"http://quantlib.org"],
    Annotation[#, "http://quantlib.org", "Hyperlink"]& ], 
   "\[InvisibleSpace]", "\<\" for Mathematica installed, Version \
0.2.7\\n\"\>", "\[InvisibleSpace]", "\<\"for \"\>", 
   "\[InvisibleSpace]", "\<\"Windows\"\>", 
   "\[InvisibleSpace]", "\<\" system \"\>", 
   "\[InvisibleSpace]", "\<\"Microsoft Windows (32-bit)\"\>", 
   "\[InvisibleSpace]", "\<\"\\n\"\>", 
   "\[InvisibleSpace]", "\<\"Mathematica Interface \[Copyright] by \"\>", 
   "\[InvisibleSpace]", 
   TagBox[
    ButtonBox[
     PaneSelectorBox[{False->"\<\"Weber & Partner\"\>", True->
      StyleBox["\<\"Weber & Partner\"\>", "HyperlinkActive"]}, Dynamic[
       CurrentValue["MouseOver"]],
      BaseStyle->{"Hyperlink"},
      BaselinePosition->Baseline,
      FrameMargins->0,
      ImageSize->Automatic],
     BaseStyle->"Hyperlink",
     ButtonData->{
       URL["http://www.weber-und-partner.com"], None},
     ButtonNote->"http://www.weber-und-partner.com"],
    Annotation[#, "http://www.weber-und-partner.com", "Hyperlink"]& ], 
   "\[InvisibleSpace]", "\<\" 2012\"\>"}],
  SequenceForm[
   Hyperlink["QuantLib", "http://quantlib.org"], 
   " for Mathematica installed, Version 0.2.7\n", "for ", "Windows", 
   " system ", "Microsoft Windows (32-bit)", "\n", 
   "Mathematica Interface \[Copyright] by ", 
   Hyperlink["Weber & Partner", "http://www.weber-und-partner.com"], " 2012"],
  Editable->False]], "Print",
 CellChangeTimes->{3.563525262828125*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Visit \"\>", "\[InvisibleSpace]", 
   TagBox[
    ButtonBox[
     PaneSelectorBox[{
      False->"\<\"http://www.weber-und-partner.com/QuantLib/Mathematica\"\>", 
      True->
      StyleBox["\<\"http://www.weber-und-partner.com/QuantLib/Mathematica\"\>\
", "HyperlinkActive"]}, Dynamic[
       CurrentValue["MouseOver"]],
      BaseStyle->{"Hyperlink"},
      BaselinePosition->Baseline,
      FrameMargins->0,
      ImageSize->Automatic],
     BaseStyle->"Hyperlink",
     ButtonData->{
       URL["http://www.weber-und-partner.com/QuantLib/mma"], None},
     ButtonNote->"http://www.weber-und-partner.com/QuantLib/mma"],
    Annotation[#, "http://www.weber-und-partner.com/QuantLib/mma", 
     "Hyperlink"]& ], 
   "\[InvisibleSpace]", "\<\" for the latest version.\\nVisit \"\>", 
   "\[InvisibleSpace]", 
   TagBox[
    ButtonBox[
     PaneSelectorBox[{False->"\<\"http://quantlib.org/license.shtml\"\>", 
      True->
      StyleBox["\<\"http://quantlib.org/license.shtml\"\>", 
       "HyperlinkActive"]}, Dynamic[
       CurrentValue["MouseOver"]],
      BaseStyle->{"Hyperlink"},
      BaselinePosition->Baseline,
      FrameMargins->0,
      ImageSize->Automatic],
     BaseStyle->"Hyperlink",
     ButtonData->{
       URL["http://quantlib.org/license.shtml"], None},
     ButtonNote->"http://quantlib.org/license.shtml"],
    Annotation[#, "http://quantlib.org/license.shtml", "Hyperlink"]& ], 
   "\[InvisibleSpace]", "\<\" for the QuantLib license.\\nFor questions, \
support issues and enquiries mail to \"\>", "\[InvisibleSpace]", 
   TagBox[
    ButtonBox[
     PaneSelectorBox[{False->"\<\"quantLib@weber-und-partner.com\"\>", True->
      StyleBox["\<\"quantLib@weber-und-partner.com\"\>", "HyperlinkActive"]}, 
      Dynamic[
       CurrentValue["MouseOver"]],
      BaseStyle->{"Hyperlink"},
      BaselinePosition->Baseline,
      FrameMargins->0,
      ImageSize->Automatic],
     BaseStyle->"Hyperlink",
     ButtonData->{
       URL["mailto:quantLib@weber-und-partner.com"], None},
     ButtonNote->"mailto:quantLib@weber-und-partner.com"],
    Annotation[#, "mailto:quantLib@weber-und-partner.com", "Hyperlink"]& ], 
   "\[InvisibleSpace]", "\<\"\\n\"\>"}],
  SequenceForm["Visit ", 
   Hyperlink[
   "http://www.weber-und-partner.com/QuantLib/Mathematica", 
    "http://www.weber-und-partner.com/QuantLib/mma"], 
   " for the latest version.\nVisit ", 
   Hyperlink[
   "http://quantlib.org/license.shtml", "http://quantlib.org/license.shtml"], 
   " for the QuantLib license.\nFor questions, support issues and enquiries \
mail to ", 
   Hyperlink[
   "quantLib@weber-und-partner.com", "mailto:quantLib@weber-und-partner.com"],
    "\n"],
  Editable->False]], "Print",
 CellChangeTimes->{3.563525262828125*^9}],

Cell[BoxData["\<\"THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND \
CONTRIBUTORS 'AS IS' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT \
NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A \
PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDERS OR \
CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, \
EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, \
PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; \
OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, \
WHETHER IN CONTRACT, STRICT LIABILITY OR TORT (INCLUDING NEGLIGENCE OR \
OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF \
ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.\\n\"\>"], "Print",
 CellChangeTimes->{3.56352526284375*^9}],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"How", " ", "to", " ", "get", " ", "started"}], "MSG"], " ", 
  ButtonBox[
   StyleBox[">>", "SR"],
   Active->True,
   BaseStyle->"Link",
   ButtonData->"paclet:QuantLib/tutorial/Getting Started"]}]], "Print", \
"PrintUsage",
 CellChangeTimes->{3.563525262859375*^9}],

Cell[BoxData["\<\"Setting default values:\"\>"], "Print",
 CellChangeTimes->{3.563525267828125*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"  Setting Valuation Date = \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{"2012", ",", "12", ",", "3"}], "}"}]}],
  SequenceForm["  Setting Valuation Date = ", {2012, 12, 3}],
  Editable->False]], "Print",
 CellChangeTimes->{3.56352526784375*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"  Setting Valuation Date = \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{"2012", ",", "12", ",", "1"}], "}"}]}],
  SequenceForm["  Setting Valuation Date = ", {2012, 12, 1}],
  Editable->False]], "Print",
 GeneratedCell->False,
 CellAutoOverwrite->False,
 CellChangeTimes->{
  3.5633790042405753`*^9, 3.5633794410885615`*^9, 3.5633796577139516`*^9, 
   3.563380943362487*^9, {3.5633819191692996`*^9, 3.563381925066637*^9}}],

Cell[BoxData["\<\"Setting default values:\"\>"], "Print",
 GeneratedCell->False,
 CellAutoOverwrite->False,
 CellChangeTimes->{
  3.5633790042405753`*^9, 3.5633794410885615`*^9, 3.5633796577139516`*^9, 
   3.563380943362487*^9, {3.5633819191692996`*^9, 3.5633819250646367`*^9}}],

Cell[BoxData["\<\"THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND \
CONTRIBUTORS 'AS IS' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT \
NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A \
PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDERS OR \
CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, \
EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, \
PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; \
OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, \
WHETHER IN CONTRACT, STRICT LIABILITY OR TORT (INCLUDING NEGLIGENCE OR \
OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF \
ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.\\n\"\>"], "Print",
 GeneratedCell->False,
 CellAutoOverwrite->False,
 CellChangeTimes->{
  3.5633790042405753`*^9, 3.5633794410885615`*^9, 3.5633796577139516`*^9, 
   3.563380943362487*^9, {3.5633819191692996`*^9, 3.563381922603496*^9}}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Visit \"\>", "\[InvisibleSpace]", 
   TagBox[
    ButtonBox[
     PaneSelectorBox[{
      False->"\<\"http://www.weber-und-partner.com/QuantLib/Mathematica\"\>", 
      True->
      StyleBox["\<\"http://www.weber-und-partner.com/QuantLib/Mathematica\"\>\
", "HyperlinkActive"]}, Dynamic[
       CurrentValue["MouseOver"]],
      BaseStyle->{"Hyperlink"},
      BaselinePosition->Baseline,
      FrameMargins->0,
      ImageSize->Automatic],
     BaseStyle->"Hyperlink",
     ButtonData->{
       URL["http://www.weber-und-partner.com/QuantLib/mma"], None},
     ButtonNote->"http://www.weber-und-partner.com/QuantLib/mma"],
    Annotation[#, "http://www.weber-und-partner.com/QuantLib/mma", 
     "Hyperlink"]& ], 
   "\[InvisibleSpace]", "\<\" for the latest version.\\nVisit \"\>", 
   "\[InvisibleSpace]", 
   TagBox[
    ButtonBox[
     PaneSelectorBox[{False->"\<\"http://quantlib.org/license.shtml\"\>", 
      True->
      StyleBox["\<\"http://quantlib.org/license.shtml\"\>", 
       "HyperlinkActive"]}, Dynamic[
       CurrentValue["MouseOver"]],
      BaseStyle->{"Hyperlink"},
      BaselinePosition->Baseline,
      FrameMargins->0,
      ImageSize->Automatic],
     BaseStyle->"Hyperlink",
     ButtonData->{
       URL["http://quantlib.org/license.shtml"], None},
     ButtonNote->"http://quantlib.org/license.shtml"],
    Annotation[#, "http://quantlib.org/license.shtml", "Hyperlink"]& ], 
   "\[InvisibleSpace]", "\<\" for the QuantLib license.\\nFor questions, \
support issues and enquiries mail to \"\>", "\[InvisibleSpace]", 
   TagBox[
    ButtonBox[
     PaneSelectorBox[{False->"\<\"quantLib@weber-und-partner.com\"\>", True->
      StyleBox["\<\"quantLib@weber-und-partner.com\"\>", "HyperlinkActive"]}, 
      Dynamic[
       CurrentValue["MouseOver"]],
      BaseStyle->{"Hyperlink"},
      BaselinePosition->Baseline,
      FrameMargins->0,
      ImageSize->Automatic],
     BaseStyle->"Hyperlink",
     ButtonData->{
       URL["mailto:quantLib@weber-und-partner.com"], None},
     ButtonNote->"mailto:quantLib@weber-und-partner.com"],
    Annotation[#, "mailto:quantLib@weber-und-partner.com", "Hyperlink"]& ], 
   "\[InvisibleSpace]", "\<\"\\n\"\>"}],
  SequenceForm["Visit ", 
   Hyperlink[
   "http://www.weber-und-partner.com/QuantLib/Mathematica", 
    "http://www.weber-und-partner.com/QuantLib/mma"], 
   " for the latest version.\nVisit ", 
   Hyperlink[
   "http://quantlib.org/license.shtml", "http://quantlib.org/license.shtml"], 
   " for the QuantLib license.\nFor questions, support issues and enquiries \
mail to ", 
   Hyperlink[
   "quantLib@weber-und-partner.com", "mailto:quantLib@weber-und-partner.com"],
    "\n"],
  Editable->False]], "Print",
 GeneratedCell->False,
 CellAutoOverwrite->False,
 CellChangeTimes->{
  3.5633790042405753`*^9, 3.5633794410885615`*^9, 3.5633796577139516`*^9, 
   3.563380943362487*^9, {3.5633819191692996`*^9, 3.5633819225984955`*^9}}],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"How", " ", "to", " ", "get", " ", "started"}], "MSG"], " ", 
  ButtonBox[
   StyleBox[">>", "SR"],
   Active->True,
   BaseStyle->"Link",
   ButtonData->"paclet:QuantLib/tutorial/Getting Started"]}]], "Print", \
"PrintUsage",
 CellChangeTimes->{3.5633809433774877`*^9}],

Cell[BoxData["\<\"Setting default values:\"\>"], "Print",
 CellChangeTimes->{3.5633790042405753`*^9, 3.5633794410885615`*^9, 
  3.5633796577139516`*^9, 3.563380946351658*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"  Setting Valuation Date = \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{"2012", ",", "12", ",", "1"}], "}"}]}],
  SequenceForm["  Setting Valuation Date = ", {2012, 12, 1}],
  Editable->False]], "Print",
 CellChangeTimes->{3.5633790042405753`*^9, 3.5633794410885615`*^9, 
  3.5633796577139516`*^9, 3.563380946356658*^9}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Market data", "Subsection",
 CellChangeTimes->{{3.56318298709375*^9, 3.563182989328125*^9}}],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"settlementDate", " ", "=", 
   RowBox[{"{", 
    RowBox[{"2004", ",", "9", ",", "22"}], "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"fixingDays", "=", "2"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"todaysDate", "=", " ", 
   RowBox[{"CalendarAdvance", " ", "[", 
    RowBox[{"settlementDate", ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "fixingDays"}], ",", "\"\<Days\>\""}], "}"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"SetEvaluationDate", "[", "todaysDate", "]"}]}], "Input",
 CellChangeTimes->{{3.56318279578125*^9, 3.563182879515625*^9}, {
  3.56318295234375*^9, 3.56318297984375*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"2004", ",", "9", ",", "20"}], "}"}]], "Output",
 CellChangeTimes->{
  3.5631828815625*^9, {3.56318296021875*^9, 3.5631829805*^9}, 
   3.563184542171875*^9, 3.563186033796875*^9, 3.56318798284375*^9, 
   3.563188483328125*^9, 3.56319033340625*^9, 3.563343507361703*^9, 
   3.5633766056613846`*^9, 3.5633778543068027`*^9, 3.563379023296665*^9, 
   3.5633794658119755`*^9, 3.563379663504283*^9, 3.563380949065813*^9, 
   3.563381936383284*^9, 3.563383022459404*^9, 3.56338328201325*^9, 
   3.5633833726384335`*^9, 3.5635138280625*^9, 3.563519270109375*^9, 
   3.563522422*^9, 3.56352352815625*^9, 3.563525268453125*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", "deposits", "   ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"d1wQuote", "=", "0.0382"}], ";"}], "\[IndentingNewLine]", " ", 
   RowBox[{
    RowBox[{"d1mQuote", "=", "0.0372"}], ";"}], "\[IndentingNewLine]", " ", 
   RowBox[{
    RowBox[{"d3mQuote", "=", "0.0363"}], ";"}], "\[IndentingNewLine]", " ", 
   RowBox[{
    RowBox[{"d6mQuote", "=", "0.0353"}], ";"}], "\[IndentingNewLine]", " ", 
   RowBox[{
    RowBox[{"d9mQuote", "=", "0.0348"}], ";"}], "\[IndentingNewLine]", " ", 
   RowBox[{
    RowBox[{"d1yQuote", "=", "0.0345"}], ";"}], "\[IndentingNewLine]", 
   RowBox[{"(*", "FRAs", "  ", "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"fra3x6Quote", "=", "0.037125"}], ";"}], " ", 
   "\[IndentingNewLine]", " ", 
   RowBox[{
    RowBox[{"fra6x9Quote", "=", "0.037125"}], ";"}], "\[IndentingNewLine]", 
   " ", 
   RowBox[{
    RowBox[{"fra6x12Quote", "=", "0.037125"}], ";"}], "\[IndentingNewLine]", 
   RowBox[{"(*", "futures", " ", "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"fut1Quote", "=", "96.2875"}], ";"}], "\[IndentingNewLine]", " ", 
   RowBox[{
    RowBox[{"fut2Quote", "=", "96.7875"}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"fut3Quote", "=", "96.9875"}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"fut4Quote", "=", "96.6875"}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"fut5Quote", "=", "96.4875"}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"fut6Quote", "=", "96.3875"}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"fut7Quote", "=", "96.2875"}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"fut8Quote", "=", "96.0875"}], ";"}], "\[IndentingNewLine]", 
   RowBox[{"(*", "swaps", " ", "*)"}], "\[IndentingNewLine]", "  ", 
   RowBox[{
    RowBox[{"s2yQuote", "=", "0.037125"}], ";"}], "\[IndentingNewLine]", " ", 
   RowBox[{
    RowBox[{"s3yQuote", "=", "0.0398"}], ";"}], "\[IndentingNewLine]", " ", 
   RowBox[{
    RowBox[{"s5yQuote", "=", "0.0443"}], ";"}], "\[IndentingNewLine]", " ", 
   RowBox[{
    RowBox[{"s10yQuote", "=", "0.05165"}], ";"}], "\[IndentingNewLine]", " ", 
   RowBox[{
    RowBox[{"s15yQuote", "=", "0.055175"}], ";"}]}]}]], "Input",
 CellChangeTimes->{{3.563183070625*^9, 3.56318309234375*^9}, {
  3.56318313078125*^9, 3.563183194859375*^9}, {3.56318327196875*^9, 
  3.56318330234375*^9}}],

Cell["\<\
** *QUOTES ***
  ** ** ** ** ** ** ** ** ** **/
// SimpleQuote stores a value which can be manually changed;
// other Quote subclasses could read the value from a database
// or some kind of data feed.
   (*deposits*\
\>", "Text",
 CellChangeTimes->{{3.563182668609375*^9, 3.563182668609375*^9}, {
   3.5631827475625*^9, 3.56318276153125*^9}, {3.56318305440625*^9, 
   3.5631830564375*^9}, 3.563183208234375*^9, {3.563183272328125*^9, 
   3.56318328375*^9}, {3.563183314*^9, 3.563183355640625*^9}, 
   3.563343542524165*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", "deposits", "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"d1wRate", "=", 
     RowBox[{"SimpleQuote", "[", "d1wQuote", "]"}]}], ";"}], "\n", 
   RowBox[{
    RowBox[{"d1mRate", "=", 
     RowBox[{"SimpleQuote", "[", "d1mQuote", "]"}]}], ";"}], "\n", 
   RowBox[{
    RowBox[{"d3mRate", "=", 
     RowBox[{"SimpleQuote", "[", "d3mQuote", "]"}]}], ";"}], "\n", 
   RowBox[{
    RowBox[{"d6mRate", "=", 
     RowBox[{"SimpleQuote", "[", "d6mQuote", "]"}]}], ";"}], "\n", 
   RowBox[{
    RowBox[{"d9mRate", "=", 
     RowBox[{"SimpleQuote", "[", "d9mQuote", "]"}]}], ";"}], "\n", 
   RowBox[{
    RowBox[{"d1yRate", "=", 
     RowBox[{"SimpleQuote", "[", "d1yQuote", "]"}]}], ";"}], "\n", 
   RowBox[{"(*", "FRAs", "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"fra3x6Rate", "=", 
     RowBox[{"SimpleQuote", "[", "fra3x6Quote", "]"}]}], ";"}], "\n", 
   RowBox[{
    RowBox[{"fra6x9Rate", "=", 
     RowBox[{"SimpleQuote", "[", "fra6x9Quote", "]"}]}], ";"}], "\n", 
   RowBox[{
    RowBox[{"fra6x12Rate", "=", 
     RowBox[{"SimpleQuote", "[", "fra6x12Quote", "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{"(*", " ", "futures", " ", "*)"}], "\n", 
   RowBox[{
    RowBox[{"fut1Price", "=", 
     RowBox[{"SimpleQuote", "[", "fut1Quote", "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"fut2Price", "=", 
     RowBox[{"SimpleQuote", "[", "fut2Quote", "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"fut3Price", "=", 
     RowBox[{"SimpleQuote", "[", "fut3Quote", "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"fut4Price", "=", 
     RowBox[{"SimpleQuote", "[", "fut4Quote", "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"fut5Price", "=", 
     RowBox[{"SimpleQuote", "[", "fut5Quote", "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"fut6Price", "=", 
     RowBox[{"SimpleQuote", "[", "fut6Quote", "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"fut7Price", "=", 
     RowBox[{"SimpleQuote", "[", "fut7Quote", "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"fut8Price", "=", 
     RowBox[{"SimpleQuote", "[", "fut8Quote", "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{"(*", "swaps", "*)"}], 
   RowBox[{
    RowBox[{"s2yRate", "=", 
     RowBox[{"SimpleQuote", "[", "s2yQuote", "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"s3yRate", "=", 
     RowBox[{"SimpleQuote", "[", "s3yQuote", "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"s5yRate", "=", 
     RowBox[{"SimpleQuote", "[", "s5yQuote", "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"s10yRate", "=", 
     RowBox[{"SimpleQuote", "[", "s10yQuote", "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"s15yRate", "=", 
     RowBox[{"SimpleQuote", "[", "s15yQuote", "]"}]}], ";"}]}]}]], "Input",
 CellChangeTimes->{{3.563184552875*^9, 3.56318458265625*^9}, 
   3.5631851485625*^9}],

Cell["** *RATE HELPERS ***", "Text",
 CellChangeTimes->{{3.563182668609375*^9, 3.563182668609375*^9}, {
   3.5631827475625*^9, 3.56318276153125*^9}, {3.56318305440625*^9, 
   3.5631830564375*^9}, 3.563183208234375*^9, {3.563183272328125*^9, 
   3.56318328375*^9}, {3.563183314*^9, 3.563183355640625*^9}, {
   3.563183853203125*^9, 3.563183855671875*^9}, 3.5633769689031606`*^9}],

Cell["\<\
** ** ** ** ** ** ** ** ** ***/
  // Helpers are built from the above quotes together with // other \
instrument dependant infos.Quotes are passed in // relinkable handles which \
could be relinked to some other // data source later.
// deposits \
\>", "Text",
 CellChangeTimes->{{3.563182668609375*^9, 3.563182668609375*^9}, {
   3.5631827475625*^9, 3.56318276153125*^9}, {3.56318305440625*^9, 
   3.5631830564375*^9}, 3.563183208234375*^9, {3.563183272328125*^9, 
   3.56318328375*^9}, {3.563183314*^9, 3.563183355640625*^9}, 
   3.563183853203125*^9, {3.56318461484375*^9, 3.563184616609375*^9}, 
   3.563376982288926*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"depositDayCounter", " ", "=", " ", "\"\<Actual/360\>\""}], 
  ";"}]], "Input",
 CellChangeTimes->{{3.563182668609375*^9, 3.563182668609375*^9}, {
   3.5631827475625*^9, 3.56318276153125*^9}, {3.56318305440625*^9, 
   3.5631830564375*^9}, 3.563183208234375*^9, {3.563183272328125*^9, 
   3.56318328375*^9}, {3.563183314*^9, 3.563183355640625*^9}, 
   3.563183853203125*^9, {3.56318461484375*^9, 3.563184659875*^9}, 
   3.5633781945902658`*^9}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"d1w", " ", "=", " ", 
   RowBox[{"DepositRateHelper", "[", 
    RowBox[{"d1wRate", ",", "\"\<1W\>\"", ",", 
     RowBox[{"FixingDays", "\[Rule]", "fixingDays"}], ",", 
     RowBox[{
     "BusinessDayConvention", "\[Rule]", "\"\<Modified Following\>\""}], ",", 
     RowBox[{"DayCounter", "\[Rule]", "depositDayCounter"}]}], "]"}]}], 
  ";"}], "\n", 
 RowBox[{
  RowBox[{"d1m", " ", "=", " ", 
   RowBox[{"DepositRateHelper", "[", 
    RowBox[{"d1mRate", ",", "\"\<1M\>\"", ",", 
     RowBox[{"FixingDays", "\[Rule]", "fixingDays"}], ",", 
     RowBox[{
     "BusinessDayConvention", "\[Rule]", "\"\<Modified Following\>\""}], ",", 
     RowBox[{"DayCounter", "\[Rule]", "depositDayCounter"}]}], "]"}]}], 
  ";"}], "\n", 
 RowBox[{
  RowBox[{"d3m", "=", 
   RowBox[{"DepositRateHelper", "[", 
    RowBox[{"d3mRate", ",", "\"\<3M\>\"", ",", 
     RowBox[{"FixingDays", "->", "fixingDays"}], ",", 
     RowBox[{
     "BusinessDayConvention", " ", "->", "\"\<Modified Following\>\""}], ",", 
     RowBox[{"DayCounter", "->", "depositDayCounter"}]}], "]"}]}], 
  ";"}], "\n", 
 RowBox[{
  RowBox[{"d6m", " ", "=", " ", 
   RowBox[{"DepositRateHelper", "[", 
    RowBox[{"d6mRate", ",", "\"\<6M\>\"", ",", 
     RowBox[{"FixingDays", "\[Rule]", "fixingDays"}], ",", 
     RowBox[{
     "BusinessDayConvention", "\[Rule]", "\"\<Modified Following\>\""}], ",", 
     RowBox[{"DayCounter", "\[Rule]", "depositDayCounter"}]}], "]"}]}], 
  ";"}], "\n", 
 RowBox[{
  RowBox[{"d9m", "=", 
   RowBox[{"DepositRateHelper", "[", 
    RowBox[{"d9mRate", ",", "\"\<9M\>\"", ",", 
     RowBox[{"FixingDays", "->", "fixingDays"}], ",", 
     RowBox[{
     "BusinessDayConvention", " ", "->", "\"\<Modified Following\>\""}], ",", 
     RowBox[{"DayCounter", "->", "depositDayCounter"}]}], "]"}]}], 
  ";"}], "\n", 
 RowBox[{
  RowBox[{"d1y", " ", "=", " ", 
   RowBox[{"DepositRateHelper", "[", 
    RowBox[{"d1yRate", ",", "\"\<1Y\>\"", ",", 
     RowBox[{"FixingDays", "\[Rule]", "fixingDays"}], ",", 
     RowBox[{
     "BusinessDayConvention", "\[Rule]", "\"\<Modified Following\>\""}], ",", 
     RowBox[{"DayCounter", "\[Rule]", "depositDayCounter"}]}], "]"}]}], 
  ";"}]}], "Input",
 CellChangeTimes->{{3.563377753459035*^9, 3.563377834817688*^9}, {
  3.563377897495273*^9, 3.5633779152182865`*^9}, {3.5633782195436935`*^9, 
  3.56337831652824*^9}, {3.5634730052728524`*^9, 3.563473022300826*^9}}],

Cell["// setup FRAs ", "Text",
 CellChangeTimes->{{3.563377753459035*^9, 3.563377834817688*^9}, 
   3.5633783247197084`*^9, 3.563383268251463*^9},
 EmphasizeSyntaxErrors->True],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"fra3x6", "=", 
    RowBox[{"FraRateHelper", "[", 
     RowBox[{"fra3x6Rate", ",", "\"\<3M\>\"", ",", "6", ",", 
      RowBox[{"FixingDays", "->", "fixingDays"}], ",", 
      RowBox[{
      "BusinessDayConvention", " ", "->", "\"\<Modified Following\>\""}], ",", 
      RowBox[{"DayCounter", "->", "depositDayCounter"}]}], "]"}]}], ";"}], 
  " "}], "\n", 
 RowBox[{
  RowBox[{"fra6x9", " ", "=", " ", 
   RowBox[{"FraRateHelper", "[", 
    RowBox[{"fra6x9Rate", ",", "\"\<6M\>\"", ",", "9", ",", 
     RowBox[{"FixingDays", "\[Rule]", "fixingDays"}], ",", 
     RowBox[{
     "BusinessDayConvention", "\[Rule]", "\"\<Modified Following\>\""}], ",", 
     RowBox[{"DayCounter", "\[Rule]", "depositDayCounter"}]}], "]"}]}], 
  ";"}], "\n", 
 RowBox[{
  RowBox[{"fra6x12", "=", 
   RowBox[{"FraRateHelper", "[", 
    RowBox[{"fra6x12Rate", ",", "\"\<6M\>\"", ",", "12", ",", 
     RowBox[{"FixingDays", "->", "fixingDays"}], ",", 
     RowBox[{
     "BusinessDayConvention", " ", "->", "\"\<Modified Following\>\""}], ",", 
     RowBox[{"DayCounter", "->", "depositDayCounter"}]}], "]"}]}], 
  ";"}]}], "Input",
 CellChangeTimes->{{3.563377753459035*^9, 3.563377834817688*^9}, {
   3.5633783247197084`*^9, 3.563378389901437*^9}, {3.5633784404513283`*^9, 
   3.5633784450195894`*^9}, {3.563378671038517*^9, 3.5633786724946003`*^9}, 
   3.5633788873568897`*^9, {3.5633791052283516`*^9, 3.563379167126892*^9}, {
   3.563379323369828*^9, 3.5633793303432274`*^9}, 3.5633797061017194`*^9, {
   3.5633817421421742`*^9, 3.563381753165805*^9}}],

Cell["// setup futures // ", "Text",
 CellChangeTimes->{{3.563377753459035*^9, 3.563377834817688*^9}, {
   3.5633783247197084`*^9, 3.563378389901437*^9}, 3.5633784404513283`*^9, {
   3.5633809814796667`*^9, 3.5633810660465035`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"convexityAdjustment", "=", "0.0"}], ";"}]], "Input",
 CellChangeTimes->{{3.563377753459035*^9, 3.563377834817688*^9}, {
   3.5633783247197084`*^9, 3.563378389901437*^9}, 3.5633784404513283`*^9, {
   3.5633809814796667`*^9, 3.5633810774261546`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"futMonths", " ", "=", " ", "3"}], ";"}]], "Input",
 CellChangeTimes->{{3.563182668609375*^9, 3.563182668609375*^9}, {
   3.5631827475625*^9, 3.56318276153125*^9}, {3.56318305440625*^9, 
   3.5631830564375*^9}, 3.563183208234375*^9, {3.563183272328125*^9, 
   3.56318328375*^9}, {3.563183314*^9, 3.563183355640625*^9}, 
   3.563183853203125*^9, {3.56318461484375*^9, 3.563184652921875*^9}, {
   3.5633810907269154`*^9, 3.563381112104138*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", "*IMM*"}]], "Input",
 CellChangeTimes->{{3.563381128610082*^9, 3.563381131688258*^9}}],

Cell[BoxData[
 DynamicModuleBox[{Typeset`open$$ = True}, 
  PaneSelectorBox[{False->
   RowBox[{
    OpenerBox[Dynamic[Typeset`open$$],
     ImageSize->Small], 
    StyleBox["QuantLib`", "InfoHeading"]}], True->GridBox[{
     {
      RowBox[{
       OpenerBox[Dynamic[Typeset`open$$],
        ImageSize->Small], 
       StyleBox["QuantLib`", "InfoHeading"]}]},
     {GridBox[{
        {
         ButtonBox["IMMcode",
          BaseStyle->"InformationLink",
          ButtonData:>{"Info3563528869-9178190", {"IMMcode", "QuantLib`"}},
          ButtonNote->"QuantLib`"], 
         ButtonBox["IMMdate",
          BaseStyle->"InformationLink",
          ButtonData:>{"Info3563528869-9178190", {"IMMdate", "QuantLib`"}},
          ButtonNote->"QuantLib`"], 
         ButtonBox["IMMIsIMMcode",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3563528869-9178190", {"IMMIsIMMcode", "QuantLib`"}},
          ButtonNote->"QuantLib`"], 
         ButtonBox["IMMIsIMMdate",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3563528869-9178190", {"IMMIsIMMdate", "QuantLib`"}},
          ButtonNote->"QuantLib`"], 
         ButtonBox["IMMNextCode",
          BaseStyle->"InformationLink",
          ButtonData:>{"Info3563528869-9178190", {"IMMNextCode", "QuantLib`"}},
          ButtonNote->"QuantLib`"], 
         ButtonBox["IMMNextCodes",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3563528869-9178190", {"IMMNextCodes", "QuantLib`"}},
          ButtonNote->"QuantLib`"], 
         ButtonBox["IMMNextDate",
          BaseStyle->"InformationLink",
          ButtonData:>{"Info3563528869-9178190", {"IMMNextDate", "QuantLib`"}},
          ButtonNote->"QuantLib`"], 
         ButtonBox["IMMNextDates",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3563528869-9178190", {"IMMNextDates", "QuantLib`"}},
          ButtonNote->"QuantLib`"], 
         ButtonBox["MakeIMMSwap",
          BaseStyle->"InformationLink",
          ButtonData:>{"Info3563528869-9178190", {"MakeIMMSwap", "QuantLib`"}},
          ButtonNote->"QuantLib`"]}
       },
       DefaultBaseStyle->"InfoGrid",
       GridBoxItemSize->{"Columns" -> {{
            Scaled[0.10555555555555554`]}}}]}
    },
    GridBoxAlignment->{"Columns" -> {{Left}}, "Rows" -> {{Baseline}}}]}, 
   Dynamic[Typeset`open$$],
   ImageSize->Automatic]]], "Print", "InfoCell",
 CellChangeTimes->{3.5635252693125*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", "IMMCode"}]], "Input",
 CellChangeTimes->{{3.5633817674736233`*^9, 3.5633817705197973`*^9}}],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"Information", "::", "notfound"}], "MessageName"], 
  RowBox[{
  ":", " "}], "\<\"Symbol \[NoBreak]\\!\\(\\\"IMMCode\\\"\\)\[NoBreak] not \
found. \\!\\(\\*ButtonBox[\\\"\[RightSkeleton]\\\", \
ButtonStyle->\\\"Link\\\", ButtonFrame->None, \
ButtonData:>\\\"paclet:ref/message/General/notfound\\\", ButtonNote -> \
\\\"Information::notfound\\\"]\\)\"\>"}]], "Message", "MSG",
 CellChangeTimes->{3.5633817711688347`*^9, 3.563383023692475*^9, 
  3.563383282684288*^9, 3.5633833733054714`*^9, 3.5635138309375*^9, 
  3.563519274453125*^9, 3.56352242425*^9, 3.56352352959375*^9, 
  3.563525269640625*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"imm", " ", "=", " ", 
  RowBox[{"IMMNextDate", "[", 
   RowBox[{"RefDate", " ", "->", "settlementDate"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.56338113801562*^9, 3.563381196252951*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"2004", ",", "12", ",", "15"}], "}"}]], "Output",
 CellChangeTimes->{3.563381196889988*^9, 3.563381960895686*^9, 
  3.5633830237474775`*^9, 3.5633832828062954`*^9, 3.5633833734054775`*^9, 
  3.5633837946095686`*^9, 3.5633839216918373`*^9, 3.5635138311875*^9, 
  3.56351927459375*^9, 3.56352242434375*^9, 3.563523529671875*^9, 
  3.563525269703125*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"fut1", "=", 
   RowBox[{"FuturesRateHelper", "[", 
    RowBox[{"fut1Price", ",", 
     RowBox[{"IMMNextCode", "[", 
      RowBox[{"RefDate", "->", "imm"}], "]"}], ",", "futMonths", ",", 
     RowBox[{
     "BusinessDayConvention", "\[Rule]", "\"\<Modified Following\>\""}], ",", 
     RowBox[{"DayCounter", "\[Rule]", "depositDayCounter"}]}], "]"}]}], 
  ";"}], "\n", 
 RowBox[{"imm", "=", 
  RowBox[{"IMMNextDate", "[", 
   RowBox[{"RefDate", "->", 
    RowBox[{"DatePlus", "[", 
     RowBox[{"imm", ",", "1"}], "]"}]}], "]"}]}], "\n", 
 RowBox[{
  RowBox[{"fut2", "=", 
   RowBox[{"FuturesRateHelper", "[", 
    RowBox[{"fut2Price", ",", 
     RowBox[{"IMMNextCode", "[", 
      RowBox[{"RefDate", "->", "imm"}], "]"}], ",", "futMonths", ",", 
     RowBox[{
     "BusinessDayConvention", "\[Rule]", "\"\<Modified Following\>\""}], ",", 
     RowBox[{"DayCounter", "\[Rule]", "depositDayCounter"}]}], "]"}]}], 
  ";"}], "\n", 
 RowBox[{
  RowBox[{"imm", "=", 
   RowBox[{"IMMNextDate", "[", 
    RowBox[{"RefDate", "->", 
     RowBox[{"DatePlus", "[", 
      RowBox[{"imm", ",", "1"}], "]"}]}], "]"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"fut3", "=", 
   RowBox[{"FuturesRateHelper", "[", 
    RowBox[{"fut3Price", ",", 
     RowBox[{"IMMNextCode", "[", 
      RowBox[{"RefDate", "->", "imm"}], "]"}], ",", "futMonths", ",", 
     RowBox[{
     "BusinessDayConvention", "\[Rule]", "\"\<Modified Following\>\""}], ",", 
     RowBox[{"DayCounter", "\[Rule]", "depositDayCounter"}]}], "]"}]}], 
  ";"}], "\n", 
 RowBox[{
  RowBox[{"imm", "=", 
   RowBox[{"IMMNextDate", "[", 
    RowBox[{"RefDate", "->", 
     RowBox[{"DatePlus", "[", 
      RowBox[{"imm", ",", "1"}], "]"}]}], "]"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"fut4", "=", 
   RowBox[{"FuturesRateHelper", "[", 
    RowBox[{"fut4Price", ",", 
     RowBox[{"IMMNextCode", "[", 
      RowBox[{"RefDate", "->", "imm"}], "]"}], ",", "futMonths", ",", 
     RowBox[{
     "BusinessDayConvention", "\[Rule]", "\"\<Modified Following\>\""}], ",", 
     RowBox[{"DayCounter", "\[Rule]", "depositDayCounter"}]}], "]"}]}], 
  ";"}], "\n", 
 RowBox[{
  RowBox[{"imm", "=", 
   RowBox[{"IMMNextDate", "[", 
    RowBox[{"RefDate", "->", 
     RowBox[{"DatePlus", "[", 
      RowBox[{"imm", ",", "1"}], "]"}]}], "]"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"fut5", "=", 
   RowBox[{"FuturesRateHelper", "[", 
    RowBox[{"fut5Price", ",", 
     RowBox[{"IMMNextCode", "[", 
      RowBox[{"RefDate", "->", "imm"}], "]"}], ",", "futMonths", ",", 
     RowBox[{
     "BusinessDayConvention", "\[Rule]", "\"\<Modified Following\>\""}], ",", 
     RowBox[{"DayCounter", "\[Rule]", "depositDayCounter"}]}], "]"}]}], 
  ";"}], "\n", 
 RowBox[{
  RowBox[{"imm", "=", 
   RowBox[{"IMMNextDate", "[", 
    RowBox[{"RefDate", "->", 
     RowBox[{"DatePlus", "[", 
      RowBox[{"imm", ",", "1"}], "]"}]}], "]"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"fut6", "=", 
   RowBox[{"FuturesRateHelper", "[", 
    RowBox[{"fut6Price", ",", 
     RowBox[{"IMMNextCode", "[", 
      RowBox[{"RefDate", "->", "imm"}], "]"}], ",", "futMonths", ",", 
     RowBox[{
     "BusinessDayConvention", "\[Rule]", "\"\<Modified Following\>\""}], ",", 
     RowBox[{"DayCounter", "\[Rule]", "depositDayCounter"}]}], "]"}]}], 
  ";"}], "\n", 
 RowBox[{
  RowBox[{"imm", "=", 
   RowBox[{"IMMNextDate", "[", 
    RowBox[{"RefDate", "->", 
     RowBox[{"DatePlus", "[", 
      RowBox[{"imm", ",", "1"}], "]"}]}], "]"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"fut7", "=", 
   RowBox[{"FuturesRateHelper", "[", 
    RowBox[{"fut7Price", ",", 
     RowBox[{"IMMNextCode", "[", 
      RowBox[{"RefDate", "->", "imm"}], "]"}], ",", "futMonths", ",", 
     RowBox[{
     "BusinessDayConvention", "\[Rule]", "\"\<Modified Following\>\""}], ",", 
     RowBox[{"DayCounter", "\[Rule]", "depositDayCounter"}]}], "]"}]}], 
  ";"}], "\n", 
 RowBox[{
  RowBox[{"imm", "=", 
   RowBox[{"IMMNextDate", "[", 
    RowBox[{"RefDate", "->", 
     RowBox[{"DatePlus", "[", 
      RowBox[{"imm", ",", "1"}], "]"}]}], "]"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"fut8", "=", 
   RowBox[{"FuturesRateHelper", "[", 
    RowBox[{"fut8Price", ",", 
     RowBox[{"IMMNextCode", "[", 
      RowBox[{"RefDate", "->", "imm"}], "]"}], ",", "futMonths", ",", 
     RowBox[{
     "BusinessDayConvention", "\[Rule]", "\"\<Modified Following\>\""}], ",", 
     RowBox[{"DayCounter", "\[Rule]", "depositDayCounter"}]}], "]"}]}], 
  ";"}], "\n"}], "Input",
 CellChangeTimes->{{3.5633836091639614`*^9, 3.563383609164962*^9}, {
   3.5633837211213655`*^9, 3.5633838930712004`*^9}, 3.5633840020334325`*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"2005", ",", "3", ",", "16"}], "}"}]], "Output",
 CellChangeTimes->{3.56351383140625*^9, 3.563519274953125*^9, 
  3.563522424625*^9, 3.56352352978125*^9, 3.5635252698125*^9}]
}, Open  ]],

Cell["\<\
    // setup swaps Frequency swFixedLegFrequency = Annual;\
\>", "Text",
 CellChangeTimes->{{3.563182668609375*^9, 3.563182668609375*^9}, {
   3.5631827475625*^9, 3.56318276153125*^9}, {3.56318305440625*^9, 
   3.5631830564375*^9}, 3.563183208234375*^9, {3.563183272328125*^9, 
   3.56318328375*^9}, {3.563183314*^9, 3.563183355640625*^9}, 
   3.563183853203125*^9, {3.56318461484375*^9, 3.563184652921875*^9}, {
   3.5633810907269154`*^9, 3.563381124460845*^9}, {3.5633812624927397`*^9, 
   3.5633813122415853`*^9}, {3.5634712893037047`*^9, 3.56347129253889*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"swFixedLegConvention", " ", "=", " ", "\"\<Unadjusted\>\""}], 
  ";"}], "\n", 
 RowBox[{" ", 
  RowBox[{
   RowBox[{
   "swFixedLegDayCounter", " ", "=", " ", "\"\<30/360 (Eurobond Basis)\>\""}],
    ";"}]}], "\n", 
 RowBox[{
  RowBox[{"swFixedLegFrequency", "=", "\"\<Annual\>\""}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"swFloatingLegIndex", "  ", "=", " ", 
   RowBox[{"Euribor", "[", "\"\<6M\>\"", "]"}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.563182668609375*^9, 3.563182668609375*^9}, {
   3.5631827475625*^9, 3.56318276153125*^9}, {3.56318305440625*^9, 
   3.5631830564375*^9}, 3.563183208234375*^9, {3.563183272328125*^9, 
   3.56318328375*^9}, {3.563183314*^9, 3.563183355640625*^9}, 
   3.563183853203125*^9, {3.56318461484375*^9, 3.563184652921875*^9}, {
   3.5633810907269154`*^9, 3.563381124460845*^9}, {3.5633812624927397`*^9, 
   3.5633813122415853`*^9}, {3.5634712893037047`*^9, 
   3.5634714049813213`*^9}, {3.5634721427735205`*^9, 3.563472144186601*^9}, {
   3.563472457261508*^9, 3.563472471915346*^9}, 3.5634726063750367`*^9}],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"s2y", "=", 
   RowBox[{"SwapRateHelper", "[", 
    RowBox[{
    "s2yRate", ",", "\"\<2Y\>\"", ",", "swFixedLegFrequency", ",", 
     "swFloatingLegIndex", ",", 
     RowBox[{"FixedLegConvention", "\[Rule]", "swFixedLegConvention"}], ",", 
     RowBox[{"FixedLegDayCounter", "\[Rule]", "swFixedLegDayCounter"}]}], 
    "]"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"s3y", "=", 
   RowBox[{"SwapRateHelper", "[", 
    RowBox[{
    "s3yRate", ",", "\"\<3Y\>\"", ",", "swFixedLegFrequency", ",", 
     "swFloatingLegIndex", ",", 
     RowBox[{"FixedLegConvention", "\[Rule]", "swFixedLegConvention"}], ",", 
     RowBox[{"FixedLegDayCounter", "\[Rule]", "swFixedLegDayCounter"}]}], 
    "]"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"s5y", "=", 
   RowBox[{"SwapRateHelper", "[", 
    RowBox[{
    "s5yRate", ",", "\"\<5Y\>\"", ",", "swFixedLegFrequency", ",", 
     "swFloatingLegIndex", ",", 
     RowBox[{"FixedLegConvention", "\[Rule]", "swFixedLegConvention"}], ",", 
     RowBox[{"FixedLegDayCounter", "\[Rule]", "swFixedLegDayCounter"}]}], 
    "]"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"s10y", "=", 
   RowBox[{"SwapRateHelper", "[", 
    RowBox[{
    "s10yRate", ",", "\"\<10Y\>\"", ",", "swFixedLegFrequency", ",", 
     "swFloatingLegIndex", ",", 
     RowBox[{"FixedLegConvention", "\[Rule]", "swFixedLegConvention"}], ",", 
     RowBox[{"FixedLegDayCounter", "\[Rule]", "swFixedLegDayCounter"}]}], 
    "]"}]}], ";"}], "\n", 
 RowBox[{"s15y", "=", 
  RowBox[{"SwapRateHelper", "[", 
   RowBox[{
   "s15yRate", ",", "\"\<15Y\>\"", ",", "swFixedLegFrequency", ",", 
    "swFloatingLegIndex", ",", 
    RowBox[{"FixedLegConvention", "\[Rule]", "swFixedLegConvention"}], ",", 
    RowBox[{"FixedLegDayCounter", "\[Rule]", "swFixedLegDayCounter"}]}], 
   "]"}]}]}], "Input",
 CellChangeTimes->{{3.5634721847419205`*^9, 3.5634721847449207`*^9}, {
   3.5634722507516966`*^9, 3.563472251845759*^9}, 3.563472342903967*^9, {
   3.5634723916907578`*^9, 3.5634724295899253`*^9}, {3.5634724812568803`*^9, 
   3.563472553777028*^9}, {3.563472639952957*^9, 3.563472668286578*^9}}],

Cell[BoxData["SwapRateHelper47"], "Output",
 CellChangeTimes->{3.563472669354639*^9, 3.5635138329375*^9, 
  3.563519276640625*^9, 3.56352242559375*^9, 3.563523530171875*^9, 
  3.563525270265625*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", "d*"}]], "Input",
 CellChangeTimes->{{3.5634728260926037`*^9, 3.5634728280017133`*^9}, {
  3.5634728726762686`*^9, 3.5634728738483353`*^9}, {3.563472909714387*^9, 
  3.563472911205472*^9}, {3.5634729478375673`*^9, 3.563472948040579*^9}}],

Cell[BoxData[
 DynamicModuleBox[{Typeset`open$$ = True}, 
  PaneSelectorBox[{False->
   RowBox[{
    OpenerBox[Dynamic[Typeset`open$$],
     ImageSize->Small], 
    StyleBox["Global`", "InfoHeading"]}], True->GridBox[{
     {
      RowBox[{
       OpenerBox[Dynamic[Typeset`open$$],
        ImageSize->Small], 
       StyleBox["Global`", "InfoHeading"]}]},
     {GridBox[{
        {
         ButtonBox["d1m",
          BaseStyle->"InformationLink",
          ButtonData:>{"Info3563528870-9178190", {"d1m", "Global`"}},
          ButtonNote->"Global`"], 
         ButtonBox["d1w",
          BaseStyle->"InformationLink",
          ButtonData:>{"Info3563528870-9178190", {"d1w", "Global`"}},
          ButtonNote->"Global`"], 
         ButtonBox["d1y",
          BaseStyle->"InformationLink",
          ButtonData:>{"Info3563528870-9178190", {"d1y", "Global`"}},
          ButtonNote->"Global`"], 
         ButtonBox["d3m",
          BaseStyle->"InformationLink",
          ButtonData:>{"Info3563528870-9178190", {"d3m", "Global`"}},
          ButtonNote->"Global`"], 
         ButtonBox["d6m",
          BaseStyle->"InformationLink",
          ButtonData:>{"Info3563528870-9178190", {"d6m", "Global`"}},
          ButtonNote->"Global`"], 
         ButtonBox["d9m",
          BaseStyle->"InformationLink",
          ButtonData:>{"Info3563528870-9178190", {"d9m", "Global`"}},
          ButtonNote->"Global`"], 
         ButtonBox["depositDayCounter",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3563528870-9178190", {"depositDayCounter", "Global`"}},
          ButtonNote->"Global`"]},
        {
         ButtonBox["d1mQuote",
          BaseStyle->"InformationLink",
          ButtonData:>{"Info3563528870-9178190", {"d1mQuote", "Global`"}},
          ButtonNote->"Global`"], 
         ButtonBox["d1wQuote",
          BaseStyle->"InformationLink",
          ButtonData:>{"Info3563528870-9178190", {"d1wQuote", "Global`"}},
          ButtonNote->"Global`"], 
         ButtonBox["d1yQuote",
          BaseStyle->"InformationLink",
          ButtonData:>{"Info3563528870-9178190", {"d1yQuote", "Global`"}},
          ButtonNote->"Global`"], 
         ButtonBox["d3mQuote",
          BaseStyle->"InformationLink",
          ButtonData:>{"Info3563528870-9178190", {"d3mQuote", "Global`"}},
          ButtonNote->"Global`"], 
         ButtonBox["d6mQuote",
          BaseStyle->"InformationLink",
          ButtonData:>{"Info3563528870-9178190", {"d6mQuote", "Global`"}},
          ButtonNote->"Global`"], 
         ButtonBox["d9mQuote",
          BaseStyle->"InformationLink",
          ButtonData:>{"Info3563528870-9178190", {"d9mQuote", "Global`"}},
          ButtonNote->"Global`"], ""},
        {
         ButtonBox["d1mRate",
          BaseStyle->"InformationLink",
          ButtonData:>{"Info3563528870-9178190", {"d1mRate", "Global`"}},
          ButtonNote->"Global`"], 
         ButtonBox["d1wRate",
          BaseStyle->"InformationLink",
          ButtonData:>{"Info3563528870-9178190", {"d1wRate", "Global`"}},
          ButtonNote->"Global`"], 
         ButtonBox["d1yRate",
          BaseStyle->"InformationLink",
          ButtonData:>{"Info3563528870-9178190", {"d1yRate", "Global`"}},
          ButtonNote->"Global`"], 
         ButtonBox["d3mRate",
          BaseStyle->"InformationLink",
          ButtonData:>{"Info3563528870-9178190", {"d3mRate", "Global`"}},
          ButtonNote->"Global`"], 
         ButtonBox["d6mRate",
          BaseStyle->"InformationLink",
          ButtonData:>{"Info3563528870-9178190", {"d6mRate", "Global`"}},
          ButtonNote->"Global`"], 
         ButtonBox["d9mRate",
          BaseStyle->"InformationLink",
          ButtonData:>{"Info3563528870-9178190", {"d9mRate", "Global`"}},
          ButtonNote->"Global`"], ""}
       },
       DefaultBaseStyle->"InfoGrid",
       GridBoxItemSize->{"Columns" -> {{
            Scaled[0.1357142857142857]}}}]}
    },
    GridBoxAlignment->{"Columns" -> {{Left}}, "Rows" -> {{Baseline}}}]}, 
   Dynamic[Typeset`open$$],
   ImageSize->Automatic]]], "Print", "InfoCell",
 CellChangeTimes->{3.56352527053125*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"depoSwapInstruments", " ", "=", " ", 
   RowBox[{"{", 
    RowBox[{
    "d1w", ",", "d1m", ",", "d3m", ",", "d6m", ",", "d9m", ",", "d1y", ",", 
     "s2y", ",", "s3y", ",", "s5y", ",", "s10y", ",", "s15y"}], "}"}]}], 
  ";"}]], "Input",
 CellChangeTimes->{{3.5634727675492554`*^9, 3.563472903111009*^9}, {
   3.563473041855945*^9, 3.5634730647122526`*^9}, 3.5634731721513977`*^9}],

Cell[BoxData[""], "Input",
 CellChangeTimes->{{3.5634727032115755`*^9, 3.563472705888729*^9}}],

Cell["\<\
    ** CURVE BUILDING **
     ** ** ** ** ** ** ** ** ** ***/
   // Any DayCounter would be fine.
       // ActualActual::ISDA ensures that 30 years is 30.0 DayCounter \
termStructureDayCounter = ActualActual (ActualActual::ISDA);
   double tolerance = 1.0 e - 15; // A depo - swap curve std::vector < \
boost::shared_ptr < Helper > > depoSwapInstruments;
   depoSwapInstruments.push_back (d1w);
   depoSwapInstruments.push_back (d1m);
   depoSwapInstruments.push_back (d3m);
   depoSwapInstruments.push_back (d6m);
   depoSwapInstruments.push_back (d9m);
   depoSwapInstruments.push_back (d1y);
   depoSwapInstruments.push_back (s2y);
   depoSwapInstruments.push_back (s3y);
   depoSwapInstruments.push_back (s5y);
   depoSwapInstruments.push_back (s10y);
   depoSwapInstruments.push_back (s15y);\
\>", "Text",
 CellChangeTimes->{{3.563182668609375*^9, 3.563182668609375*^9}, {
   3.5631827475625*^9, 3.56318276153125*^9}, {3.56318305440625*^9, 
   3.5631830564375*^9}, 3.563183208234375*^9, {3.563183272328125*^9, 
   3.56318328375*^9}, {3.563183314*^9, 3.563183355640625*^9}, 
   3.563183853203125*^9, {3.56318461484375*^9, 3.563184652921875*^9}, {
   3.5633810907269154`*^9, 3.563381124460845*^9}, 3.5633812624927397`*^9, 
   3.563384063308937*^9, 3.5634727635290256`*^9, {3.5634731398045473`*^9, 
   3.563473142316691*^9}, 3.5634731963137794`*^9}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", "PiecewiseYieldCurve"}]], "Input",
 CellChangeTimes->{3.5634732417213764`*^9}],

Cell[BoxData[
 StyleBox["\<\"PiecewiseYieldCurve[ObjecctId_Symbol,RateHelpers_List] \
Construct an object of class PiecewiseYieldCurve and return its id\\n      \
\\nObjectId: id of object to be created\\nNDays: number of days to advance \
from EvaluationDate (usually zero or two): it fixes the date at which the \
discount factor = 1.0. Default value = 0.\\nCalendar: holiday calendar (e.g. \
TARGET) to advance from global EvaluationDate.\\nRateHelpers: vector of \
rate-helpers.\\nDayCounter: DayCounter ID. Default value = Actual/365 \
(Fixed).\\nAccuracy: Bootstrapping accuracy. Default value = \
1.0e-12.\\nTraitsID: Discount, ZeroRate, or ForwardRate. Default value = \
Discount.\\nInterpolatorID: BackwardFlat, ForwardFlat, Linear, LogLinear, \
CubicSpline, or LogCubic. Default value = LogLinear.\\nPermanent: object \
permanent/nonpermanent\"\>", "MSG"]], "Print", "PrintUsage",
 CellChangeTimes->{3.56352527090625*^9},
 CellTags->"Info3563528870-9178190"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"\n", 
  RowBox[{"depoSwapTermStructure", " ", "=", " ", 
   RowBox[{
   "PiecewiseYieldCurve", "[", "depoSwapInstruments", "]"}]}]}]], "Input",
 CellChangeTimes->{{3.563182668609375*^9, 3.563182668609375*^9}, {
   3.5631827475625*^9, 3.56318276153125*^9}, {3.56318305440625*^9, 
   3.5631830564375*^9}, 3.563183208234375*^9, {3.563183272328125*^9, 
   3.56318328375*^9}, {3.563183314*^9, 3.563183355640625*^9}, 
   3.563183853203125*^9, {3.56318461484375*^9, 3.563184652921875*^9}, {
   3.5633810907269154`*^9, 3.563381124460845*^9}, 3.5633812624927397`*^9, 
   3.563384063308937*^9, 3.5634727635290256`*^9, {3.5634731398045473`*^9, 
   3.563473142316691*^9}, {3.5634731963137794`*^9, 3.563473223562338*^9}, {
   3.563473285764896*^9, 3.5634732874819937`*^9}, {3.563473347141406*^9, 
   3.563473358853076*^9}}],

Cell[BoxData["PiecewiseYieldCurve48"], "Output",
 CellChangeTimes->{{3.5634733552398696`*^9, 3.563473359997142*^9}, 
   3.563513834921875*^9, 3.563519278515625*^9, 3.56352242709375*^9, 
   3.563523531140625*^9, 3.56352527115625*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"depoFutSwapInstruments", " ", "=", " ", 
   RowBox[{"{", 
    RowBox[{
    "d1w", ",", "d1m", ",", "fut1", ",", "fut2", ",", "fut3", ",", "fut4", 
     ",", "fut5", ",", "fut6", ",", "fut7", ",", "fut8", ",", "s3y", ",", 
     "s5y", ",", "s10y", ",", "s15y"}], "}"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.563473374075947*^9, 3.563473413841221*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"depoFutSwapTermStructure", "  ", "=", " ", 
  RowBox[{
  "PiecewiseYieldCurve", "[", "depoFutSwapInstruments", "]"}]}]], "Input",
 CellChangeTimes->{{3.563182668609375*^9, 3.563182668609375*^9}, {
   3.5631827475625*^9, 3.56318276153125*^9}, {3.56318305440625*^9, 
   3.5631830564375*^9}, 3.563183208234375*^9, {3.563183272328125*^9, 
   3.56318328375*^9}, {3.563183314*^9, 3.563183355640625*^9}, 
   3.563183853203125*^9, {3.56318461484375*^9, 3.563184652921875*^9}, {
   3.5633810907269154`*^9, 3.563381124460845*^9}, 3.5633812624927397`*^9, 
   3.563384063308937*^9, 3.5634727635290256`*^9, {3.5634731398045473`*^9, 
   3.563473142316691*^9}, {3.5634734222827044`*^9, 3.563473518437204*^9}, 
   3.5634736244012647`*^9}],

Cell[BoxData["PiecewiseYieldCurve49"], "Output",
 CellChangeTimes->{3.5634735193052535`*^9, 3.5634736033020577`*^9, 
  3.56351383509375*^9, 3.563519278671875*^9, 3.56352242725*^9, 
  3.563523531546875*^9, 3.56352527128125*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"depoFRASwapInstruments", " ", "=", " ", 
   RowBox[{"{", 
    RowBox[{
    "d1w", ",", "d1m", ",", "d3m", ",", "fra3x6", ",", "fra6x9", ",", 
     "fra6x12", ",", "s2y", ",", "s3y", ",", "s5y", ",", "s10y", ",", 
     "s15y"}], "}"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.563182668609375*^9, 3.563182668609375*^9}, {
   3.5631827475625*^9, 3.56318276153125*^9}, {3.56318305440625*^9, 
   3.5631830564375*^9}, 3.563183208234375*^9, {3.563183272328125*^9, 
   3.56318328375*^9}, {3.563183314*^9, 3.563183355640625*^9}, 
   3.563183853203125*^9, {3.56318461484375*^9, 3.563184652921875*^9}, {
   3.5633810907269154`*^9, 3.563381124460845*^9}, 3.5633812624927397`*^9, 
   3.563384063308937*^9, 3.5634727635290256`*^9, {3.5634731398045473`*^9, 
   3.563473142316691*^9}, {3.5634734222827044`*^9, 3.5634734558936267`*^9}, {
   3.563473516250079*^9, 3.563473581048785*^9}, {3.5634736124615817`*^9, 
   3.5634736127785997`*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"depoFRASwapTermStructure", "  ", "=", " ", 
  RowBox[{
  "PiecewiseYieldCurve", "[", "depoFRASwapInstruments", "]"}]}]], "Input",
 CellChangeTimes->{{3.563473634773858*^9, 3.563473641466241*^9}}],

Cell[BoxData["PiecewiseYieldCurve50"], "Output",
 CellChangeTimes->{3.5634736423152895`*^9, 3.56351383525*^9, 
  3.563519278828125*^9, 3.563522427375*^9, 3.563523531875*^9, 
  3.56352527140625*^9}]
}, Open  ]],

Cell["\<\

   // Term structures that will be used for pricing :
   // the one used for discounting cash flows \
\>", "Text",
 CellChangeTimes->{{3.563182668609375*^9, 3.563182668609375*^9}, {
   3.5631827475625*^9, 3.56318276153125*^9}, {3.56318305440625*^9, 
   3.5631830564375*^9}, 3.563183208234375*^9, {3.563183272328125*^9, 
   3.56318328375*^9}, {3.563183314*^9, 3.563183355640625*^9}, 
   3.563183853203125*^9, {3.56318461484375*^9, 3.563184652921875*^9}, {
   3.5633810907269154`*^9, 3.563381124460845*^9}, 3.5633812624927397`*^9, 
   3.563384063308937*^9, 3.5634727635290256`*^9, {3.5634731398045473`*^9, 
   3.563473142316691*^9}, {3.5634734222827044`*^9, 3.5634734286950707`*^9}, {
   3.5634736658646364`*^9, 3.563473732770463*^9}, {3.563513988875*^9, 
   3.56351399178125*^9}, {3.563519840515625*^9, 3.5635198479375*^9}, 
   3.56352001015625*^9}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"discountingTermStructure", "=", " ", 
  RowBox[{"RelinkableHandleYieldTermStructure", "[", "]"}]}]], "Input",
 CellChangeTimes->{{3.5635200263125*^9, 3.56352007890625*^9}}],

Cell[BoxData["RelinkableHandleYieldTermStructure51"], "Output",
 CellChangeTimes->{{3.563520058640625*^9, 3.563520079671875*^9}, 
   3.56352242746875*^9, 3.5635235319375*^9, 3.56352527146875*^9}]
}, Open  ]],

Cell["\<\

   RelinkableHandle < YieldTermStructure > discountingTermStructure;
   // the one used for forward rate forecasting 
   RelinkableHandle < YieldTermStructure > forecastingTermStructure\
\>", "Text",
 CellChangeTimes->{{3.563182668609375*^9, 3.563182668609375*^9}, {
   3.5631827475625*^9, 3.56318276153125*^9}, {3.56318305440625*^9, 
   3.5631830564375*^9}, 3.563183208234375*^9, {3.563183272328125*^9, 
   3.56318328375*^9}, {3.563183314*^9, 3.563183355640625*^9}, 
   3.563183853203125*^9, {3.56318461484375*^9, 3.563184652921875*^9}, {
   3.5633810907269154`*^9, 3.563381124460845*^9}, 3.5633812624927397`*^9, 
   3.563384063308937*^9, 3.5634727635290256`*^9, {3.5634731398045473`*^9, 
   3.563473142316691*^9}, {3.5634734222827044`*^9, 3.5634734286950707`*^9}, {
   3.5634736658646364`*^9, 3.563473732770463*^9}, {3.563513988875*^9, 
   3.56351399178125*^9}, {3.563519840515625*^9, 3.5635198479375*^9}, 
   3.56352001015625*^9, {3.563520151234375*^9, 3.563520155625*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"forecastingTermStructure", "=", " ", 
  RowBox[{"RelinkableHandleYieldTermStructure", "[", "]"}]}]], "Input",
 CellChangeTimes->{3.563520127171875*^9}],

Cell[BoxData["RelinkableHandleYieldTermStructure52"], "Output",
 CellChangeTimes->{3.563520131375*^9, 3.563522427546875*^9, 
  3.563523532015625*^9, 3.56352527153125*^9}]
}, Open  ]],

Cell["\<\
   /** ** ** ** ** ** ** ** ** ***
       *SWAPS TO BE PRICED*
       ** ** ** ** ** ** ** ** ** ** **/
        // constant nominal 1, 000, 000 Euro Real\
\>", "Text",
 CellChangeTimes->{{3.563182668609375*^9, 3.563182668609375*^9}, {
   3.5631827475625*^9, 3.56318276153125*^9}, {3.56318305440625*^9, 
   3.5631830564375*^9}, 3.563183208234375*^9, {3.563183272328125*^9, 
   3.56318328375*^9}, {3.563183314*^9, 3.563183355640625*^9}, 
   3.563183853203125*^9, {3.56318461484375*^9, 3.563184652921875*^9}, {
   3.5633810907269154`*^9, 3.563381124460845*^9}, 3.5633812624927397`*^9, 
   3.563384063308937*^9, 3.5634727635290256`*^9, {3.5634731398045473`*^9, 
   3.563473142316691*^9}, {3.5634734222827044`*^9, 3.5634734286950707`*^9}, {
   3.5634736658646364`*^9, 3.563473732770463*^9}, {3.563513988875*^9, 
   3.56351399178125*^9}, {3.563519840515625*^9, 3.5635198479375*^9}, 
   3.56352001015625*^9, {3.563520159953125*^9, 3.563520161015625*^9}}],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"nominal", " ", "=", " ", "1000000.0"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"fixedLegFrequency", " ", "=", " ", "\"\<Annual\>\""}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"fixedLegConvention", "=", "\"\<Unadjusted\>\""}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"floatingLegFrequency", "=", 
  "\"\<Semiannual\>\""}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"floatingLegConvention", "=", "\"\<Modified Following\>\""}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
  "fixedLegDayCounter", " ", "=", "  ", "\"\<30/360 (Eurobond Basis)\>\""}], 
  ";"}], "\n", 
 RowBox[{
  RowBox[{"fixedRate", " ", "=", " ", "0.04"}], ";"}], "\n", 
 RowBox[{
  RowBox[{"floatingLegDayCounter", " ", "=", " ", "\"\<Actual/360\>\""}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"euriborIndex", " ", "=", "  ", 
   RowBox[{"Euribor", "[", 
    RowBox[{"\"\<6M\>\"", ",", 
     RowBox[{"YieldCurve", "->", "forecastingTermStructure"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"spread", "=", "0.0"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"lenghtInYears", "=", "5"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"swapType", "=", "\"\<Payer\>\""}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"maturity", "=", 
   RowBox[{"CalendarAdvance", " ", "[", 
    RowBox[{"settlementDate", ",", 
     RowBox[{"{", 
      RowBox[{"lenghtInYears", ",", "\"\<Years\>\""}], "}"}]}], "]"}]}], 
  ";"}]}], "Input",
 CellChangeTimes->{{3.563182668609375*^9, 3.563182668609375*^9}, {
   3.5631827475625*^9, 3.56318276153125*^9}, {3.56318305440625*^9, 
   3.5631830564375*^9}, 3.563183208234375*^9, {3.563183272328125*^9, 
   3.56318328375*^9}, {3.563183314*^9, 3.563183355640625*^9}, 
   3.563183853203125*^9, {3.56318461484375*^9, 3.563184652921875*^9}, {
   3.5633810907269154`*^9, 3.563381124460845*^9}, 3.5633812624927397`*^9, 
   3.563384063308937*^9, 3.5634727635290256`*^9, {3.5634731398045473`*^9, 
   3.563473142316691*^9}, {3.5634734222827044`*^9, 3.5634734286950707`*^9}, {
   3.5634736658646364`*^9, 3.563473732770463*^9}, {3.563513988875*^9, 
   3.563514021484375*^9}, {3.563519424015625*^9, 3.563519497671875*^9}, {
   3.563519579703125*^9, 3.56351967003125*^9}, {3.563519793109375*^9, 
   3.56351980965625*^9}, {3.563520174921875*^9, 3.56352029209375*^9}, {
   3.56352054296875*^9, 3.5635205479375*^9}, {3.5635214553125*^9, 
   3.563521456203125*^9}, {3.563523937046875*^9, 3.563523950953125*^9}}],

Cell[BoxData["\<\"Semiannual\"\>"], "Output",
 CellChangeTimes->{3.563520549015625*^9, 3.563521457265625*^9, 
  3.563522427640625*^9, 3.56352353209375*^9, 3.563523952453125*^9, 
  3.56352527159375*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Options", "[", "Schedule", "]"}]], "Input",
 CellChangeTimes->{{3.563520407421875*^9, 3.563520411140625*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"EffectiveDate", "\[RuleDelayed]", 
    RowBox[{"EvaluationDate", "[", "]"}]}], ",", 
   RowBox[{"Calendar", "\[Rule]", "\<\"Target\"\>"}], ",", 
   RowBox[{"BusinessDayConvention", "\[Rule]", "\<\"Unadjusted\"\>"}], ",", 
   RowBox[{"TermDateConv", "\[Rule]", "\<\"Unadjusted\"\>"}], ",", 
   RowBox[{"GenRule", "\[Rule]", "\<\"Backward\"\>"}], ",", 
   RowBox[{"EndOfMonth", "\[Rule]", "True"}], ",", 
   RowBox[{"FirstDate", "\[Rule]", "Automatic"}], ",", 
   RowBox[{"NextToLastDate", "\[Rule]", "Automatic"}], ",", 
   RowBox[{"Permanent", "\[Rule]", "True"}], ",", 
   RowBox[{"Overwrite", "\[Rule]", "True"}]}], "}"}]], "Output",
 CellChangeTimes->{3.56352041184375*^9, 3.56352242771875*^9, 
  3.56352353215625*^9, 3.563523953953125*^9, 3.56352527165625*^9}]
}, Open  ]],

Cell[BoxData[{
 RowBox[{
  RowBox[{"fixedSchedule", " ", "=", " ", 
   RowBox[{"Schedule", "[", 
    RowBox[{"settlementDate", ",", "maturity", ",", 
     RowBox[{"PeriodFromFrequency", "[", "fixedLegFrequency", "]"}], ",", 
     RowBox[{"BusinessDayConvention", "->", "fixedLegConvention"}], ",", 
     RowBox[{"TermDateConv", "\[Rule]", "fixedLegConvention"}], ",", 
     RowBox[{"GenRule", "\[Rule]", "\"\<Forward\>\""}], ",", 
     RowBox[{"EndOfMonth", "\[Rule]", "False"}]}], "]"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"floatSchedule", "=", " ", 
   RowBox[{"Schedule", "[", 
    RowBox[{"settlementDate", ",", "maturity", ",", 
     RowBox[{"PeriodFromFrequency", "[", "floatingLegFrequency", "]"}], ",", 
     RowBox[{"BusinessDayConvention", "->", "floatingLegConvention"}], ",", 
     RowBox[{"TermDateConv", "\[Rule]", "floatingLegConvention"}], ",", 
     RowBox[{"GenRule", "\[Rule]", "\"\<Forward\>\""}], ",", 
     RowBox[{"EndOfMonth", "\[Rule]", "False"}]}], "]"}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.563182668609375*^9, 3.563182668609375*^9}, {
   3.5631827475625*^9, 3.56318276153125*^9}, {3.56318305440625*^9, 
   3.5631830564375*^9}, 3.563183208234375*^9, {3.563183272328125*^9, 
   3.56318328375*^9}, {3.563183314*^9, 3.563183355640625*^9}, 
   3.563183853203125*^9, {3.56318461484375*^9, 3.563184652921875*^9}, {
   3.5633810907269154`*^9, 3.563381124460845*^9}, 3.5633812624927397`*^9, 
   3.563384063308937*^9, 3.5634727635290256`*^9, {3.5634731398045473`*^9, 
   3.563473142316691*^9}, {3.5634734222827044`*^9, 3.5634734286950707`*^9}, {
   3.5634736658646364`*^9, 3.563473732770463*^9}, {3.563513988875*^9, 
   3.563514021484375*^9}, {3.563519424015625*^9, 3.563519497671875*^9}, {
   3.563519579703125*^9, 3.56351967003125*^9}, {3.563519793109375*^9, 
   3.56351980965625*^9}, {3.563520174921875*^9, 3.563520353296875*^9}, {
   3.563520383578125*^9, 3.56352039221875*^9}, {3.56352042253125*^9, 
   3.563520510109375*^9}, 3.5635205616875*^9}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Options", "[", "VanillaSwap", "]"}]], "Input",
 CellChangeTimes->{{3.56352071484375*^9, 3.563520721796875*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"FixedLegDayCounter", "\[Rule]", "\<\"Actual/365 (Fixed)\"\>"}], 
   ",", 
   RowBox[{"Spread", "\[Rule]", "0.`"}], ",", 
   RowBox[{"FloatingLegDayCounter", "\[Rule]", "Automatic"}], ",", 
   RowBox[{"PaymentConvention", "\[Rule]", "\<\"Following\"\>"}], ",", 
   RowBox[{"Permanent", "\[Rule]", "True"}], ",", 
   RowBox[{"Overwrite", "\[Rule]", "True"}]}], "}"}]], "Output",
 CellChangeTimes->{3.56352072246875*^9, 3.563522428078125*^9, 
  3.563523532328125*^9, 3.563525271765625*^9}]
}, Open  ]],

Cell["\<\
VanillaSwap spot5YearSwap (swapType, nominal, fixedSchedule, fixed, \
fixedLegDayCounter, floatSchedule, euriborIndex, spread, \
floatingLegDayCounter);\
\>", "Text",
 CellChangeTimes->{{3.563520823640625*^9, 3.563520837890625*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{" ", 
  RowBox[{"spot5YearSwap", " ", "=", " ", 
   RowBox[{"VanillaSwap", "[", " ", 
    RowBox[{
    "nominal", ",", " ", "fixedSchedule", ",", " ", "fixedRate", ",", " ", 
     "floatSchedule", ",", " ", "euriborIndex", ",", "swapType", ",", 
     RowBox[{"FixedLegDayCounter", "->", "fixedLegDayCounter"}], ",", 
     RowBox[{"FloatingLegDayCounter", "\[Rule]", "floatingLegDayCounter"}]}], 
    "]"}]}]}]], "Input",
 CellChangeTimes->{{3.56352062996875*^9, 3.563520712046875*^9}, {
   3.5635207436875*^9, 3.56352078825*^9}, 3.563521468890625*^9}],

Cell[BoxData["VanillaSwap56"], "Output",
 CellChangeTimes->{3.56352068315625*^9, 3.56352078496875*^9, 
  3.56352242834375*^9, 3.563523532421875*^9, 3.563523959296875*^9, 
  3.56352527184375*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"fwdStart", " ", "=", " ", 
  RowBox[{"CalendarAdvance", "[", 
   RowBox[{"settlementDate", ",", 
    RowBox[{"{", 
     RowBox[{"1", ",", "\"\<Year\>\""}], "}"}]}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{"fwdMaturity", "=", 
  RowBox[{"CalendarAdvance", "[", 
   RowBox[{"fwdStart", ",", 
    RowBox[{"{", 
     RowBox[{"lenghtInYears", ",", "\"\<Years\>\""}], "}"}]}], 
   "]"}]}]}], "Input",
 CellChangeTimes->{{3.563520845921875*^9, 3.56352091815625*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"2005", ",", "9", ",", "22"}], "}"}]], "Output",
 CellChangeTimes->{
  3.563520872375*^9, {3.563520914875*^9, 3.56352091865625*^9}, 
   3.5635224284375*^9, 3.5635235325*^9, 3.563523960359375*^9, 
   3.56352527190625*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"2010", ",", "9", ",", "22"}], "}"}]], "Output",
 CellChangeTimes->{
  3.563520872375*^9, {3.563520914875*^9, 3.56352091865625*^9}, 
   3.5635224284375*^9, 3.5635235325*^9, 3.563523960359375*^9, 
   3.56352527190625*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{" ", 
  RowBox[{
   RowBox[{"fwdFixedSchedule", "=", "  ", 
    RowBox[{"Schedule", "[", 
     RowBox[{"fwdStart", ",", " ", "fwdMaturity", ",", " ", 
      RowBox[{"PeriodFromFrequency", "[", "fixedLegFrequency", "]"}], ",", 
      " ", 
      RowBox[{"BusinessDayConvention", "->", "fixedLegConvention"}], ",", 
      RowBox[{"TermDateConv", "\[Rule]", "fixedLegConvention"}], ",", 
      RowBox[{"GenRule", "\[Rule]", "\"\<Forward\>\""}], ",", 
      RowBox[{"EndOfMonth", "\[Rule]", "False"}]}], "]"}]}], "\n", "   ", 
   RowBox[{"fwdFloatSchedule", " ", "=", " ", 
    RowBox[{"Schedule", "[", 
     RowBox[{"fwdStart", ",", " ", "fwdMaturity", ",", " ", 
      RowBox[{"PeriodFromFrequency", " ", "[", "floatingLegFrequency", "]"}], 
      ",", 
      RowBox[{"BusinessDayConvention", "->", "floatingLegConvention"}], ",", 
      RowBox[{"TermDateConv", "\[Rule]", "floatingLegConvention"}], ",", 
      RowBox[{"GenRule", "\[Rule]", "\"\<Forward\>\""}], ",", 
      RowBox[{"EndOfMonth", "\[Rule]", "False"}]}], "]"}]}], 
   "\n"}]}]], "Input",
 CellChangeTimes->{{3.56352093490625*^9, 3.56352093490625*^9}, {
  3.5635209668125*^9, 3.56352108975*^9}}],

Cell[BoxData["Schedule57"], "Output",
 CellChangeTimes->{{3.563521086453125*^9, 3.56352109028125*^9}, 
   3.56352242853125*^9, 3.563523532578125*^9, 3.563523961765625*^9, 
   3.563525271984375*^9}],

Cell[BoxData["Schedule58"], "Output",
 CellChangeTimes->{{3.563521086453125*^9, 3.56352109028125*^9}, 
   3.56352242853125*^9, 3.563523532578125*^9, 3.563523961765625*^9, 
   3.563525272015625*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{" ", 
  RowBox[{"oneYearForward5YearSwap", " ", "=", " ", 
   RowBox[{"VanillaSwap", "[", " ", 
    RowBox[{
    "nominal", ",", " ", "fwdFixedSchedule", ",", " ", "fixedRate", ",", " ", 
     "fwdFloatSchedule", ",", " ", "euriborIndex", ",", "swapType", ",", 
     RowBox[{"FixedLegDayCounter", "->", "fixedLegDayCounter"}], ",", 
     RowBox[{"FloatingLegDayCounter", "\[Rule]", "floatingLegDayCounter"}]}], 
    "]"}]}]}]], "Input",
 CellChangeTimes->{{3.5635211186875*^9, 3.563521136375*^9}, 
   3.563521480015625*^9}],

Cell[BoxData["VanillaSwap59"], "Output",
 CellChangeTimes->{3.5635211394375*^9, 3.563522428671875*^9, 
  3.563523532703125*^9, 3.563523963765625*^9, 3.56352527209375*^9}]
}, Open  ]],

Cell["\<\
     Schedule fwdFixedSchedule (fwdStart, fwdMaturity, Period \
(fixedLegFrequency), calendar, fixedLegConvention, fixedLegConvention, \
DateGeneration::Forward, false);
   Schedule fwdFloatSchedule (fwdStart, fwdMaturity, Period \
(floatingLegFrequency), calendar, floatingLegConvention, \
floatingLegConvention, DateGeneration::Forward, false);
   VanillaSwap oneYearForward5YearSwap (swapType, nominal, fwdFixedSchedule, \
fixed, fixedLegDayCounter, fwdFloatSchedule, euriborIndex, spread, \
floatingLegDayCounter);\
\>", "Text",
 CellChangeTimes->{{3.563182668609375*^9, 3.563182668609375*^9}, {
   3.5631827475625*^9, 3.56318276153125*^9}, {3.56318305440625*^9, 
   3.5631830564375*^9}, 3.563183208234375*^9, {3.563183272328125*^9, 
   3.56318328375*^9}, {3.563183314*^9, 3.563183355640625*^9}, 
   3.563183853203125*^9, {3.56318461484375*^9, 3.563184652921875*^9}, {
   3.5633810907269154`*^9, 3.563381124460845*^9}, 3.5633812624927397`*^9, 
   3.563384063308937*^9, 3.5634727635290256`*^9, {3.5634731398045473`*^9, 
   3.563473142316691*^9}, {3.5634734222827044`*^9, 3.5634734286950707`*^9}, {
   3.5634736658646364`*^9, 3.563473732770463*^9}, {3.563513988875*^9, 
   3.563514002171875*^9}, 3.5635207395625*^9, 3.563520818796875*^9, {
   3.56352092609375*^9, 3.56352092953125*^9}, 3.563521144515625*^9}],

Cell["\<\

   /** ** ** ** ** ** ***
     *SWAP PRICING*
     ** ** ** ** ** ** ** **/
      // utilities for reporting std::vector < std::string > headers (4);
   Real NPV;
    fair;
   Spread fairSpread;
   boost::shared_ptr < PricingEngine > swapEngine (new DiscountingSwapEngine \
(discountingTermStructure));
   spot5YearSwap.setPricingEngine (swapEngine);
   oneYearForward5YearSwap.setPricingEngine (swapEngine); // Of course, you' \
re not forced to really use different curves forecastingTermStructure.linkTo \
(depoSwapTermStructure);
   discountingTermStructure.linkTo (depoSwapTermStructure);
   NPV = spot5YearSwap.NPV ();
 \
\>", "Text",
 CellChangeTimes->{{3.563182668609375*^9, 3.563182668609375*^9}, {
   3.5631827475625*^9, 3.56318276153125*^9}, {3.56318305440625*^9, 
   3.5631830564375*^9}, 3.563183208234375*^9, {3.563183272328125*^9, 
   3.56318328375*^9}, {3.563183314*^9, 3.563183355640625*^9}, 
   3.563183853203125*^9, {3.56318461484375*^9, 3.563184652921875*^9}, {
   3.5633810907269154`*^9, 3.563381124460845*^9}, 3.5633812624927397`*^9, 
   3.563384063308937*^9, 3.5634727635290256`*^9, {3.5634731398045473`*^9, 
   3.563473142316691*^9}, {3.5634734222827044`*^9, 3.5634734286950707`*^9}, {
   3.5634736658646364`*^9, 3.563473732770463*^9}, {3.563513988875*^9, 
   3.563514002171875*^9}, 3.5635207395625*^9, 3.563520818796875*^9, {
   3.56352092609375*^9, 3.56352092953125*^9}, {3.563521144515625*^9, 
   3.563521166140625*^9}, {3.56352152878125*^9, 3.563521561203125*^9}, {
   3.563521597203125*^9, 3.563521597890625*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"RateHelperQuoteValue", "[", "s5y", "]"}]], "Input",
 CellChangeTimes->{{3.563521334578125*^9, 3.56352133578125*^9}, {
  3.56352139571875*^9, 3.563521405859375*^9}}],

Cell[BoxData["0.0443`"], "Output",
 CellChangeTimes->{3.5635213369375*^9, 3.563521406609375*^9, 
  3.563522429375*^9, 3.5635235331875*^9, 3.563523969375*^9, 3.56352527225*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData["fixedRate"], "Input",
 CellChangeTimes->{{3.56352143625*^9, 3.5635214406875*^9}, {
  3.563521499359375*^9, 3.563521499828125*^9}}],

Cell[BoxData["0.04`"], "Output",
 CellChangeTimes->{3.563521441328125*^9, 3.56352150059375*^9, 
  3.56352242946875*^9, 3.563523533265625*^9, 3.5635239703125*^9, 
  3.5635252723125*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"swapEngine", " ", "=", " ", 
  RowBox[{
  "DiscountingSwapEngine", " ", "[", "discountingTermStructure", 
   "]"}]}]], "Input",
 CellChangeTimes->{{3.563521654296875*^9, 3.563521670265625*^9}}],

Cell[BoxData["DiscountingSwapEngine60"], "Output",
 CellChangeTimes->{3.56352167175*^9, 3.563522429578125*^9, 
  3.563523533359375*^9, 3.56352397125*^9, 3.56352527240625*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"InstrumentSetPricingEngine", "[", 
  RowBox[{"spot5YearSwap", ",", "swapEngine"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"InstrumentSetPricingEngine", "[", 
  RowBox[{"oneYearForward5YearSwap", ",", "swapEngine"}], "]"}]}], "Input",
 CellChangeTimes->{{3.5635217435*^9, 3.563521774453125*^9}}],

Cell[BoxData["True"], "Output",
 CellChangeTimes->{3.5635217766875*^9, 3.563522429671875*^9, 
  3.563523533453125*^9, 3.563523972515625*^9, 3.563525272484375*^9}],

Cell[BoxData["True"], "Output",
 CellChangeTimes->{3.5635217766875*^9, 3.563522429671875*^9, 
  3.563523533453125*^9, 3.563523972515625*^9, 3.563525272484375*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"RelinkableHandleLinkTo", "[", 
  RowBox[{"discountingTermStructure", ",", "depoSwapTermStructure"}], 
  "]"}], "\n", 
 RowBox[{
  RowBox[{"RelinkableHandleLinkTo", "[", 
   RowBox[{"forecastingTermStructure", ",", "depoSwapTermStructure"}], "]"}], 
  " "}], "\n", 
 RowBox[{"NPV", "[", 
  RowBox[{"spot5YearSwap", ",", "swapEngine"}], "]"}], "\n", 
 RowBox[{"VanillaSwapFairSpread", "[", "spot5YearSwap", "]"}], "\n", 
 RowBox[{"VanillaSwapFairRate", "[", "spot5YearSwap", "]"}]}], "Input",
 CellChangeTimes->{{3.563521887578125*^9, 3.5635218925*^9}, {
  3.56352249309375*^9, 3.563522533359375*^9}, {3.56352357828125*^9, 
  3.5635235803125*^9}, {3.563524444453125*^9, 3.563524454703125*^9}}],

Cell[BoxData["True"], "Output",
 CellChangeTimes->{3.563524190828125*^9, 3.5635252725625*^9}],

Cell[BoxData["True"], "Output",
 CellChangeTimes->{3.563524190828125*^9, 3.5635252725625*^9}],

Cell[BoxData["19065.774539024773`"], "Output",
 CellChangeTimes->{3.563524190828125*^9, 3.563525272859375*^9}],

Cell[BoxData[
 RowBox[{"-", "0.004192983284273966`"}]], "Output",
 CellChangeTimes->{3.563524190828125*^9, 3.563525272859375*^9}],

Cell[BoxData["0.04430000000012044`"], "Output",
 CellChangeTimes->{3.563524190828125*^9, 3.563525272859375*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"RelinkableHandleLinkTo", "[", 
   RowBox[{"discountingTermStructure", ",", "depoFutSwapTermStructure"}], 
   "]"}], " "}], "\n", 
 RowBox[{
  RowBox[{"RelinkableHandleLinkTo", "[", 
   RowBox[{"forecastingTermStructure", ",", "depoFutSwapTermStructure"}], 
   "]"}], " "}], "\[IndentingNewLine]", 
 RowBox[{"NPV", "[", 
  RowBox[{"spot5YearSwap", ",", "swapEngine"}], "]"}], "\n", 
 RowBox[{"VanillaSwapFairSpread", "[", "spot5YearSwap", "]"}], "\n", 
 RowBox[{"VanillaSwapFairRate", "[", "spot5YearSwap", "]"}]}], "Input",
 CellChangeTimes->{{3.563521887578125*^9, 3.5635218925*^9}, {
  3.56352249309375*^9, 3.563522533359375*^9}, {3.56352357828125*^9, 
  3.5635235803125*^9}, {3.56352420478125*^9, 3.56352422134375*^9}}],

Cell[BoxData["True"], "Output",
 CellChangeTimes->{3.563524222140625*^9, 3.563525272921875*^9}],

Cell[BoxData["True"], "Output",
 CellChangeTimes->{3.563524222140625*^9, 3.5635252729375*^9}],

Cell[BoxData["19069.7264201683`"], "Output",
 CellChangeTimes->{3.563524222140625*^9, 3.563525273203125*^9}],

Cell[BoxData[
 RowBox[{"-", "0.004190823730532861`"}]], "Output",
 CellChangeTimes->{3.563524222140625*^9, 3.563525273203125*^9}],

Cell[BoxData["0.04430000000012045`"], "Output",
 CellChangeTimes->{3.563524222140625*^9, 3.563525273203125*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"RelinkableHandleLinkTo", "[", 
   RowBox[{"discountingTermStructure", ",", "depoFRASwapTermStructure"}], 
   "]"}], " "}], "\n", 
 RowBox[{
  RowBox[{"RelinkableHandleLinkTo", "[", 
   RowBox[{"forecastingTermStructure", ",", "depoFRASwapTermStructure"}], 
   "]"}], " "}], "\[IndentingNewLine]", 
 RowBox[{"NPV", "[", 
  RowBox[{"spot5YearSwap", ",", "swapEngine"}], "]"}], "\n", 
 RowBox[{"VanillaSwapFairSpread", "[", "spot5YearSwap", "]"}], "\n", 
 RowBox[{"VanillaSwapFairRate", "[", "spot5YearSwap", "]"}]}], "Input",
 CellChangeTimes->{{3.563524387484375*^9, 3.563524391640625*^9}}],

Cell[BoxData["True"], "Output",
 CellChangeTimes->{3.563524393625*^9, 3.5635252734375*^9}],

Cell[BoxData["True"], "Output",
 CellChangeTimes->{3.563524393625*^9, 3.5635252734375*^9}],

Cell[BoxData["19056.296226404724`"], "Output",
 CellChangeTimes->{3.563524393625*^9, 3.56352527365625*^9}],

Cell[BoxData[
 RowBox[{"-", "0.004192910586873534`"}]], "Output",
 CellChangeTimes->{3.563524393625*^9, 3.56352527365625*^9}],

Cell[BoxData["0.04429999999987944`"], "Output",
 CellChangeTimes->{3.563524393625*^9, 3.563525273671875*^9}]
}, Open  ]],

Cell["", "Text",
 CellChangeTimes->{{3.563182668609375*^9, 3.563182668609375*^9}, {
   3.5631827475625*^9, 3.56318276153125*^9}, {3.56318305440625*^9, 
   3.5631830564375*^9}, 3.563183208234375*^9, {3.563183272328125*^9, 
   3.56318328375*^9}, {3.563183314*^9, 3.563183355640625*^9}, 
   3.563183853203125*^9, {3.56318461484375*^9, 3.563184652921875*^9}, {
   3.5633810907269154`*^9, 3.563381124460845*^9}, 3.5633812624927397`*^9, 
   3.563384063308937*^9, 3.5634727635290256`*^9, {3.5634731398045473`*^9, 
   3.563473142316691*^9}, {3.5634734222827044`*^9, 3.5634734286950707`*^9}, {
   3.5634736658646364`*^9, 3.563473732770463*^9}, {3.563513988875*^9, 
   3.563514002171875*^9}, 3.5635207395625*^9, 3.563520818796875*^9, {
   3.56352092609375*^9, 3.56352092953125*^9}, {3.563521144515625*^9, 
   3.563521166140625*^9}, {3.56352152878125*^9, 3.56352158790625*^9}}],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"RelinkableHandleLinkTo", "[", 
  RowBox[{"discountingTermStructure", ",", "depoSwapTermStructure"}], 
  "]"}], "\n", 
 RowBox[{
  RowBox[{"RelinkableHandleLinkTo", "[", 
   RowBox[{"forecastingTermStructure", ",", "depoSwapTermStructure"}], "]"}], 
  " "}], "\n", 
 RowBox[{"NPV", "[", 
  RowBox[{"oneYearForward5YearSwap", ",", "swapEngine"}], "]"}], "\n", 
 RowBox[{"VanillaSwapFairSpread", "[", "oneYearForward5YearSwap", "]"}], "\n", 
 RowBox[{"VanillaSwapFairRate", "[", "oneYearForward5YearSwap", 
  "]"}]}], "Input",
 CellChangeTimes->{{3.563521887578125*^9, 3.5635218925*^9}, {
  3.56352249309375*^9, 3.563522533359375*^9}, {3.56352357828125*^9, 
  3.5635235803125*^9}, {3.563524444453125*^9, 3.56352447715625*^9}}],

Cell[BoxData["True"], "Output",
 CellChangeTimes->{3.563524480265625*^9, 3.563525273734375*^9}],

Cell[BoxData["True"], "Output",
 CellChangeTimes->{3.563524480265625*^9, 3.563525273734375*^9}],

Cell[BoxData["40024.088566618855`"], "Output",
 CellChangeTimes->{3.563524480265625*^9, 3.563525273734375*^9}],

Cell[BoxData[
 RowBox[{"-", "0.009225317736068371`"}]], "Output",
 CellChangeTimes->{3.563524480265625*^9, 3.563525273734375*^9}],

Cell[BoxData["0.04947342231539219`"], "Output",
 CellChangeTimes->{3.563524480265625*^9, 3.563525273734375*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"termStructure", " ", "=", " ", "depoFutSwapTermStructure"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"RelinkableHandleLinkTo", "[", 
  RowBox[{"discountingTermStructure", ",", "termStructure"}], "]"}], "\n", 
 RowBox[{
  RowBox[{"RelinkableHandleLinkTo", "[", 
   RowBox[{"forecastingTermStructure", ",", "termStructure"}], "]"}], 
  " "}], "\n", 
 RowBox[{"NPV", "[", 
  RowBox[{"oneYearForward5YearSwap", ",", "swapEngine"}], "]"}], "\n", 
 RowBox[{"VanillaSwapFairSpread", "[", "oneYearForward5YearSwap", "]"}], "\n", 
 RowBox[{"VanillaSwapFairRate", "[", "oneYearForward5YearSwap", 
  "]"}]}], "Input",
 CellChangeTimes->{{3.563524518671875*^9, 3.563524547453125*^9}}],

Cell[BoxData["True"], "Output",
 CellChangeTimes->{3.563524550015625*^9, 3.5635252738125*^9}],

Cell[BoxData["True"], "Output",
 CellChangeTimes->{3.563524550015625*^9, 3.5635252738125*^9}],

Cell[BoxData["38325.90573520519`"], "Output",
 CellChangeTimes->{3.563524550015625*^9, 3.5635252738125*^9}],

Cell[BoxData[
 RowBox[{"-", "0.00882458752838895`"}]], "Output",
 CellChangeTimes->{3.563524550015625*^9, 3.5635252738125*^9}],

Cell[BoxData["0.04906607406384488`"], "Output",
 CellChangeTimes->{3.563524550015625*^9, 3.5635252738125*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"termStructure", " ", "=", " ", "depoFRASwapTermStructure"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"RelinkableHandleLinkTo", "[", 
  RowBox[{"discountingTermStructure", ",", "termStructure"}], "]"}], "\n", 
 RowBox[{
  RowBox[{"RelinkableHandleLinkTo", "[", 
   RowBox[{"forecastingTermStructure", ",", "termStructure"}], "]"}], 
  " "}], "\n", 
 RowBox[{"NPV", "[", 
  RowBox[{"oneYearForward5YearSwap", ",", "swapEngine"}], "]"}], "\n", 
 RowBox[{"VanillaSwapFairSpread", "[", "oneYearForward5YearSwap", "]"}], "\n", 
 RowBox[{"VanillaSwapFairRate", "[", "oneYearForward5YearSwap", 
  "]"}]}], "Input",
 CellChangeTimes->{{3.563524591875*^9, 3.56352459215625*^9}}],

Cell[BoxData["True"], "Output",
 CellChangeTimes->{3.563524593875*^9, 3.563525273875*^9}],

Cell[BoxData["True"], "Output",
 CellChangeTimes->{3.563524593875*^9, 3.563525273890625*^9}],

Cell[BoxData["37321.84628812474`"], "Output",
 CellChangeTimes->{3.563524593875*^9, 3.563525273890625*^9}],

Cell[BoxData[
 RowBox[{"-", "0.00860325538830512`"}]], "Output",
 CellChangeTimes->{3.563524593875*^9, 3.563525273890625*^9}],

Cell[BoxData["0.048832819360053153`"], "Output",
 CellChangeTimes->{3.563524593875*^9, 3.563525273890625*^9}]
}, Open  ]],

Cell["\<\
// now let' s say that the 5 - years swap rate goes up to 4.60 %.
 // A smarter market element-- say, connected to a data source-- would
        // notice the change itself.Since we' re using SimpleQuotes,
// we' ll have to change the value manually-- which forces us to
        // downcast the handle and use the SimpleQuote
        // interface.In any case, the point here is that a change in the
        // value contained in the Quote triggers a new bootstrapping
        // of the curve and a repricing of the swap.\
\>", "Text",
 CellChangeTimes->{{3.563524627984375*^9, 3.563524632859375*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"SimpleQuoteSetValue", "[", 
   RowBox[{"s5yRate", ",", 
    RowBox[{"Value", "\[Rule]", "0.0460"}]}], "]"}], " "}]], "Input",
 CellChangeTimes->{{3.563524748921875*^9, 3.56352482146875*^9}}],

Cell[BoxData["0.0017000000000000001`"], "Output",
 CellChangeTimes->{{3.56352479084375*^9, 3.56352482240625*^9}, 
   3.563525273953125*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"QuoteValue", "[", "s5yRate", "]"}]], "Input",
 CellChangeTimes->{{3.56352485084375*^9, 3.563524861203125*^9}}],

Cell[BoxData["0.046`"], "Output",
 CellChangeTimes->{3.56352486175*^9, 3.563525274015625*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"swap", " ", "=", " ", "spot5YearSwap"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"termStructure", " ", "=", " ", "depoSwapTermStructure"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"RelinkableHandleLinkTo", "[", 
  RowBox[{"discountingTermStructure", ",", "termStructure"}], "]"}], "\n", 
 RowBox[{
  RowBox[{"RelinkableHandleLinkTo", "[", 
   RowBox[{"forecastingTermStructure", ",", "termStructure"}], "]"}], 
  " "}], "\n", 
 RowBox[{"NPV", "[", 
  RowBox[{"swap", ",", "swapEngine"}], "]"}], "\n", 
 RowBox[{"VanillaSwapFairSpread", "[", "swap", "]"}], "\n", 
 RowBox[{"VanillaSwapFairRate", "[", "swap", "]"}]}], "Input",
 CellChangeTimes->{
  3.563524949734375*^9, {3.563524980125*^9, 3.563524992953125*^9}}],

Cell[BoxData["True"], "Output",
 CellChangeTimes->{3.563524995046875*^9, 3.56352527409375*^9}],

Cell[BoxData["True"], "Output",
 CellChangeTimes->{3.563524995046875*^9, 3.56352527409375*^9}],

Cell[BoxData["26538.90182935985`"], "Output",
 CellChangeTimes->{3.563524995046875*^9, 3.563525274296875*^9}],

Cell[BoxData[
 RowBox[{"-", "0.0058482639231334215`"}]], "Output",
 CellChangeTimes->{3.563524995046875*^9, 3.563525274296875*^9}],

Cell[BoxData["0.04599999999999996`"], "Output",
 CellChangeTimes->{3.563524995046875*^9, 3.563525274296875*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"swap", " ", "=", " ", "spot5YearSwap"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"termStructure", " ", "=", " ", "depoFutSwapTermStructure"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"RelinkableHandleLinkTo", "[", 
   RowBox[{"discountingTermStructure", ",", "termStructure"}], "]"}], 
  ";"}], "\n", 
 RowBox[{
  RowBox[{"RelinkableHandleLinkTo", "[", 
   RowBox[{"forecastingTermStructure", ",", "termStructure"}], "]"}], 
  ";"}], "\n", 
 RowBox[{"NPV", "[", 
  RowBox[{"swap", ",", "swapEngine"}], "]"}], "\n", 
 RowBox[{"VanillaSwapFairSpread", "[", "swap", "]"}], "\n", 
 RowBox[{"VanillaSwapFairRate", "[", "swap", "]"}]}], "Input",
 CellChangeTimes->{{3.56352507965625*^9, 3.56352509003125*^9}}],

Cell[BoxData["26544.40263860929`"], "Output",
 CellChangeTimes->{{3.56352508159375*^9, 3.56352509184375*^9}, 
   3.563525274671875*^9}],

Cell[BoxData[
 RowBox[{"-", "0.005845245764042721`"}]], "Output",
 CellChangeTimes->{{3.56352508159375*^9, 3.56352509184375*^9}, 
   3.563525274671875*^9}],

Cell[BoxData["0.04599999999999995`"], "Output",
 CellChangeTimes->{{3.56352508159375*^9, 3.56352509184375*^9}, 
   3.563525274671875*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"swap", " ", "=", " ", "spot5YearSwap"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"termStructure", " ", "=", " ", "depoFRASwapTermStructure"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"RelinkableHandleLinkTo", "[", 
   RowBox[{"discountingTermStructure", ",", "termStructure"}], "]"}], 
  ";"}], "\n", 
 RowBox[{
  RowBox[{"RelinkableHandleLinkTo", "[", 
   RowBox[{"forecastingTermStructure", ",", "termStructure"}], "]"}], 
  ";"}], "\n", 
 RowBox[{"NPV", "[", 
  RowBox[{"swap", ",", "swapEngine"}], "]"}], "\n", 
 RowBox[{"VanillaSwapFairSpread", "[", "swap", "]"}], "\n", 
 RowBox[{"VanillaSwapFairRate", "[", "swap", "]"}]}], "Input",
 CellChangeTimes->{{3.56352507965625*^9, 3.5635251146875*^9}}],

Cell[BoxData["26525.70852151327`"], "Output",
 CellChangeTimes->{3.5635251165625*^9, 3.563525274921875*^9}],

Cell[BoxData[
 RowBox[{"-", "0.00584816231231411`"}]], "Output",
 CellChangeTimes->{3.5635251165625*^9, 3.5635252749375*^9}],

Cell[BoxData["0.045999999999999874`"], "Output",
 CellChangeTimes->{3.5635251165625*^9, 3.5635252749375*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"swap", " ", "=", " ", "oneYearForward5YearSwap"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"termStructure", " ", "=", " ", "depoSwapTermStructure"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"RelinkableHandleLinkTo", "[", 
  RowBox[{"discountingTermStructure", ",", "termStructure"}], "]"}], "\n", 
 RowBox[{
  RowBox[{"RelinkableHandleLinkTo", "[", 
   RowBox[{"forecastingTermStructure", ",", "termStructure"}], "]"}], 
  " "}], "\n", 
 RowBox[{"NPV", "[", 
  RowBox[{"swap", ",", "swapEngine"}], "]"}], "\n", 
 RowBox[{"VanillaSwapFairSpread", "[", "swap", "]"}], "\n", 
 RowBox[{"VanillaSwapFairRate", "[", "swap", "]"}]}], "Input",
 CellChangeTimes->{3.56352516484375*^9}],

Cell[BoxData["True"], "Output",
 CellChangeTimes->{3.56352516840625*^9, 3.563525275*^9}],

Cell[BoxData["True"], "Output",
 CellChangeTimes->{3.56352516840625*^9, 3.563525275*^9}],

Cell[BoxData["45711.676882548054`"], "Output",
 CellChangeTimes->{3.56352516840625*^9, 3.563525275015625*^9}],

Cell[BoxData[
 RowBox[{"-", "0.01057226966647642`"}]], "Output",
 CellChangeTimes->{3.56352516840625*^9, 3.563525275015625*^9}],

Cell[BoxData["0.050860265099696746`"], "Output",
 CellChangeTimes->{3.56352516840625*^9, 3.563525275015625*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"swap", " ", "=", " ", "oneYearForward5YearSwap"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"termStructure", " ", "=", " ", "depoFutSwapTermStructure"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"RelinkableHandleLinkTo", "[", 
  RowBox[{"discountingTermStructure", ",", "termStructure"}], "]"}], "\n", 
 RowBox[{
  RowBox[{"RelinkableHandleLinkTo", "[", 
   RowBox[{"forecastingTermStructure", ",", "termStructure"}], "]"}], 
  " "}], "\n", 
 RowBox[{"NPV", "[", 
  RowBox[{"swap", ",", "swapEngine"}], "]"}], "\n", 
 RowBox[{"VanillaSwapFairSpread", "[", "swap", "]"}], "\n", 
 RowBox[{"VanillaSwapFairRate", "[", "swap", "]"}]}], "Input",
 CellChangeTimes->{{3.56352516484375*^9, 3.56352518365625*^9}}],

Cell[BoxData["True"], "Output",
 CellChangeTimes->{3.563525185*^9, 3.563525275078125*^9}],

Cell[BoxData["True"], "Output",
 CellChangeTimes->{3.563525185*^9, 3.563525275078125*^9}],

Cell[BoxData["44014.65946495306`"], "Output",
 CellChangeTimes->{3.563525185*^9, 3.563525275078125*^9}],

Cell[BoxData[
 RowBox[{"-", "0.01016902406767699`"}]], "Output",
 CellChangeTimes->{3.563525185*^9, 3.56352527509375*^9}],

Cell[BoxData["0.05045084423023693`"], "Output",
 CellChangeTimes->{3.563525185*^9, 3.56352527509375*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"swap", " ", "=", " ", "oneYearForward5YearSwap"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"termStructure", " ", "=", " ", "depoFRASwapTermStructure"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"RelinkableHandleLinkTo", "[", 
  RowBox[{"discountingTermStructure", ",", "termStructure"}], "]"}], "\n", 
 RowBox[{
  RowBox[{"RelinkableHandleLinkTo", "[", 
   RowBox[{"forecastingTermStructure", ",", "termStructure"}], "]"}], 
  " "}], "\n", 
 RowBox[{"NPV", "[", 
  RowBox[{"swap", ",", "swapEngine"}], "]"}], "\n", 
 RowBox[{"VanillaSwapFairSpread", "[", "swap", "]"}], "\n", 
 RowBox[{"VanillaSwapFairRate", "[", "swap", "]"}]}], "Input",
 CellChangeTimes->{{3.56352516484375*^9, 3.563525203609375*^9}}],

Cell[BoxData["True"], "Output",
 CellChangeTimes->{3.563525205078125*^9, 3.56352527515625*^9}],

Cell[BoxData["True"], "Output",
 CellChangeTimes->{3.563525205078125*^9, 3.56352527515625*^9}],

Cell[BoxData["43006.639412683406`"], "Output",
 CellChangeTimes->{3.563525205078125*^9, 3.56352527515625*^9}],

Cell[BoxData[
 RowBox[{"-", "0.0099475423542027`"}]], "Output",
 CellChangeTimes->{3.563525205078125*^9, 3.56352527515625*^9}],

Cell[BoxData["0.05021641597329897`"], "Output",
 CellChangeTimes->{3.563525205078125*^9, 3.56352527515625*^9}]
}, Open  ]]
}, Open  ]]
}, Open  ]]
},
WindowToolbars->"EditBar",
WindowSize->{1345, 633},
WindowMargins->{{51, Automatic}, {Automatic, 41}},
ShowSelection->True,
FrontEndVersion->"8.0 for Microsoft Windows (32-bit) (October 6, 2011)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "Info3563528870-9178190"->{
  Cell[90714, 2301, 968, 14, 225, "Print",
   CellTags->"Info3563528870-9178190"]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"Info3563528870-9178190", 132936, 3361}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[579, 22, 193, 5, 137, "Title"],
Cell[CellGroupData[{
Cell[797, 31, 74, 1, 31, "Input"],
Cell[CellGroupData[{
Cell[896, 36, 1941, 47, 62, "Print"],
Cell[2840, 85, 2808, 70, 81, "Print"],
Cell[5651, 157, 878, 11, 119, "Print"],
Cell[6532, 170, 317, 10, 42, "Print"],
Cell[6852, 182, 121, 1, 23, "Print"],
Cell[6976, 185, 331, 7, 23, "Print"],
Cell[7310, 194, 1917, 47, 62, "Print"],
Cell[9230, 243, 2789, 70, 81, "Print"],
Cell[12022, 315, 854, 11, 138, "Print"],
Cell[12879, 328, 315, 10, 42, "Print"],
Cell[13197, 340, 99, 1, 23, "Print"],
Cell[13299, 343, 307, 7, 23, "Print"],
Cell[13609, 352, 1919, 47, 62, "Print"],
Cell[15531, 401, 2789, 70, 81, "Print"],
Cell[18323, 473, 852, 11, 138, "Print"],
Cell[19178, 486, 317, 10, 42, "Print"],
Cell[19498, 498, 99, 1, 23, "Print"],
Cell[19600, 501, 307, 7, 23, "Print"],
Cell[19910, 510, 1917, 47, 62, "Print"],
Cell[21830, 559, 2787, 70, 81, "Print"],
Cell[24620, 631, 854, 11, 138, "Print"],
Cell[25477, 644, 314, 10, 42, "Print"],
Cell[25794, 656, 96, 1, 23, "Print"],
Cell[25893, 659, 305, 7, 23, "Print"],
Cell[26201, 668, 1917, 47, 62, "Print"],
Cell[28121, 717, 2786, 70, 81, "Print"],
Cell[30910, 789, 853, 11, 138, "Print"],
Cell[31766, 802, 315, 10, 42, "Print"],
Cell[32084, 814, 99, 1, 23, "Print"],
Cell[32186, 817, 305, 7, 23, "Print"],
Cell[32494, 826, 1913, 47, 62, "Print"],
Cell[34410, 875, 2787, 70, 81, "Print"],
Cell[37200, 947, 854, 11, 138, "Print"],
Cell[38057, 960, 315, 10, 42, "Print"],
Cell[38375, 972, 95, 1, 23, "Print"],
Cell[38473, 975, 307, 7, 23, "Print"],
Cell[38783, 984, 1917, 47, 62, "Print"],
Cell[40703, 1033, 2787, 70, 81, "Print"],
Cell[43493, 1105, 854, 11, 119, "Print"],
Cell[44350, 1118, 314, 10, 42, "Print"],
Cell[44667, 1130, 99, 1, 23, "Print"],
Cell[44769, 1133, 306, 7, 23, "Print"],
Cell[45078, 1142, 1917, 47, 62, "Print"],
Cell[46998, 1191, 2787, 70, 81, "Print"],
Cell[49788, 1263, 853, 11, 119, "Print"],
Cell[50644, 1276, 315, 10, 42, "Print"],
Cell[50962, 1288, 99, 1, 23, "Print"],
Cell[51064, 1291, 306, 7, 23, "Print"],
Cell[51373, 1300, 484, 11, 23, "Print"],
Cell[51860, 1313, 278, 5, 23, "Print"],
Cell[52141, 1320, 1031, 15, 138, "Print"],
Cell[53175, 1337, 2966, 74, 81, "Print"],
Cell[56144, 1413, 317, 10, 42, "Print"],
Cell[56464, 1425, 174, 2, 23, "Print"],
Cell[56641, 1429, 382, 8, 23, "Print"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[57072, 1443, 98, 1, 36, "Subsection"],
Cell[CellGroupData[{
Cell[57195, 1448, 689, 18, 92, "Input"],
Cell[57887, 1468, 656, 11, 30, "Output"]
}, Open  ]],
Cell[58558, 1482, 2410, 55, 552, "Input"],
Cell[60971, 1539, 534, 12, 119, "Text"],
Cell[61508, 1553, 3051, 87, 512, "Input"],
Cell[64562, 1642, 378, 5, 29, "Text"],
Cell[64943, 1649, 635, 12, 65, "Text"],
Cell[65581, 1663, 477, 9, 31, "Input"],
Cell[66061, 1674, 2419, 57, 132, "Input"],
Cell[68483, 1733, 176, 3, 29, "Text"],
Cell[68662, 1738, 1579, 34, 72, "Input"],
Cell[70244, 1774, 232, 3, 29, "Text"],
Cell[70479, 1779, 283, 5, 31, "Input"],
Cell[70765, 1786, 476, 8, 31, "Input"],
Cell[CellGroupData[{
Cell[71266, 1798, 114, 2, 31, "Input"],
Cell[71383, 1802, 2520, 66, 53, "Print"]
}, Open  ]],
Cell[CellGroupData[{
Cell[73940, 1873, 120, 2, 31, "Input"],
Cell[74063, 1877, 646, 13, 21, "Message"]
}, Open  ]],
Cell[CellGroupData[{
Cell[74746, 1895, 213, 4, 31, "Input"],
Cell[74962, 1901, 390, 7, 30, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[75389, 1913, 4605, 123, 332, "Input"],
Cell[79997, 2038, 213, 4, 30, "Output"]
}, Open  ]],
Cell[80225, 2045, 574, 9, 29, "Text"],
Cell[80802, 2056, 1101, 23, 92, "Input"],
Cell[CellGroupData[{
Cell[81928, 2083, 2105, 48, 112, "Input"],
Cell[84036, 2133, 198, 3, 30, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[84271, 2141, 265, 4, 31, "Input"],
Cell[84539, 2147, 4148, 102, 99, "Print"]
}, Open  ]],
Cell[88702, 2252, 416, 9, 31, "Input"],
Cell[89121, 2263, 94, 1, 31, "Input"],
Cell[89218, 2266, 1362, 27, 299, "Text"],
Cell[CellGroupData[{
Cell[90605, 2297, 106, 2, 31, "Input"],
Cell[90714, 2301, 968, 14, 225, "Print",
 CellTags->"Info3563528870-9178190"]
}, Open  ]],
Cell[CellGroupData[{
Cell[91719, 2320, 834, 14, 52, "Input"],
Cell[92556, 2336, 232, 3, 30, "Output"]
}, Open  ]],
Cell[92803, 2342, 388, 8, 31, "Input"],
Cell[CellGroupData[{
Cell[93216, 2354, 746, 12, 31, "Input"],
Cell[93965, 2368, 226, 3, 30, "Output"]
}, Open  ]],
Cell[94206, 2374, 959, 17, 31, "Input"],
Cell[CellGroupData[{
Cell[95190, 2395, 219, 4, 31, "Input"],
Cell[95412, 2401, 197, 3, 30, "Output"]
}, Open  ]],
Cell[95624, 2407, 859, 15, 65, "Text"],
Cell[CellGroupData[{
Cell[96508, 2426, 196, 3, 31, "Input"],
Cell[96707, 2431, 195, 2, 30, "Output"]
}, Open  ]],
Cell[96917, 2436, 987, 16, 83, "Text"],
Cell[CellGroupData[{
Cell[97929, 2456, 175, 3, 31, "Input"],
Cell[98107, 2461, 170, 2, 30, "Output"]
}, Open  ]],
Cell[98292, 2466, 957, 16, 83, "Text"],
Cell[CellGroupData[{
Cell[99274, 2486, 2521, 56, 272, "Input"],
Cell[101798, 2544, 201, 3, 30, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[102036, 2552, 133, 2, 31, "Input"],
Cell[102172, 2556, 816, 15, 50, "Output"]
}, Open  ]],
Cell[103003, 2574, 1976, 32, 92, "Input"],
Cell[CellGroupData[{
Cell[105004, 2610, 135, 2, 31, "Input"],
Cell[105142, 2614, 538, 11, 30, "Output"]
}, Open  ]],
Cell[105695, 2628, 242, 5, 29, "Text"],
Cell[CellGroupData[{
Cell[105962, 2637, 574, 11, 52, "Input"],
Cell[106539, 2650, 194, 3, 30, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[106770, 2658, 490, 13, 52, "Input"],
Cell[107263, 2673, 259, 6, 30, "Output"],
Cell[107525, 2681, 259, 6, 30, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[107821, 2692, 1181, 23, 112, "Input"],
Cell[109005, 2717, 197, 3, 30, "Output"],
Cell[109205, 2722, 197, 3, 30, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[109439, 2730, 546, 11, 52, "Input"],
Cell[109988, 2743, 170, 2, 30, "Output"]
}, Open  ]],
Cell[110173, 2748, 1320, 21, 65, "Text"],
Cell[111496, 2771, 1552, 31, 263, "Text"],
Cell[CellGroupData[{
Cell[113073, 2806, 188, 3, 31, "Input"],
Cell[113264, 2811, 175, 2, 30, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[113476, 2818, 144, 2, 31, "Input"],
Cell[113623, 2822, 184, 3, 30, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[113844, 2830, 217, 5, 31, "Input"],
Cell[114064, 2837, 174, 2, 30, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[114275, 2844, 320, 5, 52, "Input"],
Cell[114598, 2851, 162, 2, 30, "Output"],
Cell[114763, 2855, 162, 2, 30, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[114962, 2862, 716, 14, 112, "Input"],
Cell[115681, 2878, 93, 1, 30, "Output"],
Cell[115777, 2881, 93, 1, 30, "Output"],
Cell[115873, 2884, 110, 1, 30, "Output"],
Cell[115986, 2887, 129, 2, 30, "Output"],
Cell[116118, 2891, 111, 1, 30, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[116266, 2897, 758, 15, 112, "Input"],
Cell[117027, 2914, 95, 1, 30, "Output"],
Cell[117125, 2917, 93, 1, 30, "Output"],
Cell[117221, 2920, 108, 1, 30, "Output"],
Cell[117332, 2923, 129, 2, 30, "Output"],
Cell[117464, 2927, 111, 1, 30, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[117612, 2933, 625, 13, 112, "Input"],
Cell[118240, 2948, 90, 1, 30, "Output"],
Cell[118333, 2951, 90, 1, 30, "Output"],
Cell[118426, 2954, 106, 1, 30, "Output"],
Cell[118535, 2957, 125, 2, 30, "Output"],
Cell[118663, 2961, 108, 1, 30, "Output"]
}, Open  ]],
Cell[118786, 2965, 866, 12, 29, "Text"],
Cell[CellGroupData[{
Cell[119677, 2981, 748, 15, 112, "Input"],
Cell[120428, 2998, 95, 1, 30, "Output"],
Cell[120526, 3001, 95, 1, 30, "Output"],
Cell[120624, 3004, 110, 1, 30, "Output"],
Cell[120737, 3007, 129, 2, 30, "Output"],
Cell[120869, 3011, 111, 1, 30, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[121017, 3017, 711, 15, 132, "Input"],
Cell[121731, 3034, 93, 1, 30, "Output"],
Cell[121827, 3037, 93, 1, 30, "Output"],
Cell[121923, 3040, 107, 1, 30, "Output"],
Cell[122033, 3043, 126, 2, 30, "Output"],
Cell[122162, 3047, 109, 1, 30, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[122308, 3053, 707, 15, 132, "Input"],
Cell[123018, 3070, 89, 1, 30, "Output"],
Cell[123110, 3073, 92, 1, 30, "Output"],
Cell[123205, 3076, 106, 1, 30, "Output"],
Cell[123314, 3079, 125, 2, 30, "Output"],
Cell[123442, 3083, 109, 1, 30, "Output"]
}, Open  ]],
Cell[123566, 3087, 610, 10, 155, "Text"],
Cell[CellGroupData[{
Cell[124201, 3101, 225, 5, 31, "Input"],
Cell[124429, 3108, 139, 2, 30, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[124605, 3115, 134, 2, 31, "Input"],
Cell[124742, 3119, 93, 1, 30, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[124872, 3125, 766, 18, 152, "Input"],
Cell[125641, 3145, 94, 1, 30, "Output"],
Cell[125738, 3148, 94, 1, 30, "Output"],
Cell[125835, 3151, 109, 1, 30, "Output"],
Cell[125947, 3154, 130, 2, 30, "Output"],
Cell[126080, 3158, 111, 1, 30, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[126228, 3164, 767, 19, 152, "Input"],
Cell[126998, 3185, 135, 2, 30, "Output"],
Cell[127136, 3189, 155, 3, 30, "Output"],
Cell[127294, 3194, 137, 2, 30, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[127468, 3201, 766, 19, 152, "Input"],
Cell[128237, 3222, 107, 1, 30, "Output"],
Cell[128347, 3225, 124, 2, 30, "Output"],
Cell[128474, 3229, 108, 1, 30, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[128619, 3235, 729, 17, 152, "Input"],
Cell[129351, 3254, 88, 1, 30, "Output"],
Cell[129442, 3257, 88, 1, 30, "Output"],
Cell[129533, 3260, 109, 1, 30, "Output"],
Cell[129645, 3263, 127, 2, 30, "Output"],
Cell[129775, 3267, 111, 1, 30, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[129923, 3273, 755, 17, 152, "Input"],
Cell[130681, 3292, 89, 1, 30, "Output"],
Cell[130773, 3295, 89, 1, 30, "Output"],
Cell[130865, 3298, 103, 1, 30, "Output"],
Cell[130971, 3301, 121, 2, 30, "Output"],
Cell[131095, 3305, 104, 1, 30, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[131236, 3311, 756, 17, 152, "Input"],
Cell[131995, 3330, 94, 1, 30, "Output"],
Cell[132092, 3333, 94, 1, 30, "Output"],
Cell[132189, 3336, 109, 1, 30, "Output"],
Cell[132301, 3339, 126, 2, 30, "Output"],
Cell[132430, 3343, 110, 1, 30, "Output"]
}, Open  ]]
}, Open  ]]
}, Open  ]]
}
]
*)

(* End of internal cache information *)
