(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 8.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       157,          7]
NotebookDataLength[     11781,        333]
NotebookOptionsPosition[     10734,        292]
NotebookOutlinePosition[     11101,        308]
CellTagsIndexPosition[     11058,        305]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell[BoxData[
 RowBox[{"Needs", "[", "\"\<QuantLib`\>\"", "]"}]], "Input",
 CellChangeTimes->{{3.522736979765625*^9, 3.5227369798125*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   TagBox[
    ButtonBox[
     PaneSelectorBox[{False->"\<\"QuantLib\"\>", True->
      StyleBox["\<\"QuantLib\"\>", "HyperlinkActive"]}, Dynamic[
       CurrentValue["MouseOver"]],
      BaseStyle->{"Hyperlink"},
      BaselinePosition->Baseline,
      FrameMargins->0,
      ImageSize->Automatic],
     BaseStyle->"Hyperlink",
     ButtonData->{
       URL["http://quantlib.org"], None},
     ButtonNote->"http://quantlib.org"],
    Annotation[#, "http://quantlib.org", "Hyperlink"]& ], 
   "\[InvisibleSpace]", "\<\" for Mathematica installed, Version \
0.2.1\\n\"\>", "\[InvisibleSpace]", "\<\"for \"\>", 
   "\[InvisibleSpace]", "\<\"Windows\"\>", 
   "\[InvisibleSpace]", "\<\" system \"\>", 
   "\[InvisibleSpace]", "\<\"Microsoft Windows (32-bit)\"\>", 
   "\[InvisibleSpace]", "\<\"\\n\"\>", 
   "\[InvisibleSpace]", "\<\"Mathematica Interface \[Copyright] by \"\>", 
   "\[InvisibleSpace]", 
   TagBox[
    ButtonBox[
     PaneSelectorBox[{False->"\<\"Weber & Partner\"\>", True->
      StyleBox["\<\"Weber & Partner\"\>", "HyperlinkActive"]}, Dynamic[
       CurrentValue["MouseOver"]],
      BaseStyle->{"Hyperlink"},
      BaselinePosition->Baseline,
      FrameMargins->0,
      ImageSize->Automatic],
     BaseStyle->"Hyperlink",
     ButtonData->{
       URL["http://www.weber-und-partner.com"], None},
     ButtonNote->"http://www.weber-und-partner.com"],
    Annotation[#, "http://www.weber-und-partner.com", "Hyperlink"]& ], 
   "\[InvisibleSpace]", "\<\" 2011\"\>"}],
  SequenceForm[
   Hyperlink["QuantLib", "http://quantlib.org"], 
   " for Mathematica installed, Version 0.2.1\n", "for ", "Windows", 
   " system ", "Microsoft Windows (32-bit)", "\n", 
   "Mathematica Interface \[Copyright] by ", 
   Hyperlink["Weber & Partner", "http://www.weber-und-partner.com"], " 2011"],
  Editable->False]], "Print",
 CellChangeTimes->{3.522742718265625*^9, 3.522742917875*^9, 
  3.522752551234375*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Visit \"\>", "\[InvisibleSpace]", 
   TagBox[
    ButtonBox[
     PaneSelectorBox[{
      False->"\<\"http://www.weber-und-partner.com/QuantLib/Mathematica\"\>", 
      True->
      StyleBox["\<\"http://www.weber-und-partner.com/QuantLib/Mathematica\"\>\
", "HyperlinkActive"]}, Dynamic[
       CurrentValue["MouseOver"]],
      BaseStyle->{"Hyperlink"},
      BaselinePosition->Baseline,
      FrameMargins->0,
      ImageSize->Automatic],
     BaseStyle->"Hyperlink",
     ButtonData->{
       URL["http://www.weber-und-partner.com/QuantLib/mma"], None},
     ButtonNote->"http://www.weber-und-partner.com/QuantLib/mma"],
    Annotation[#, "http://www.weber-und-partner.com/QuantLib/mma", 
     "Hyperlink"]& ], 
   "\[InvisibleSpace]", "\<\" for the latest version.\\nVisit \"\>", 
   "\[InvisibleSpace]", 
   TagBox[
    ButtonBox[
     PaneSelectorBox[{False->"\<\"http://quantlib.org/license.shtml\"\>", 
      True->
      StyleBox["\<\"http://quantlib.org/license.shtml\"\>", 
       "HyperlinkActive"]}, Dynamic[
       CurrentValue["MouseOver"]],
      BaseStyle->{"Hyperlink"},
      BaselinePosition->Baseline,
      FrameMargins->0,
      ImageSize->Automatic],
     BaseStyle->"Hyperlink",
     ButtonData->{
       URL["http://quantlib.org/license.shtml"], None},
     ButtonNote->"http://quantlib.org/license.shtml"],
    Annotation[#, "http://quantlib.org/license.shtml", "Hyperlink"]& ], 
   "\[InvisibleSpace]", "\<\" for the QuantLib license.\\n\"\>"}],
  SequenceForm["Visit ", 
   Hyperlink[
   "http://www.weber-und-partner.com/QuantLib/Mathematica", 
    "http://www.weber-und-partner.com/QuantLib/mma"], 
   " for the latest version.\nVisit ", 
   Hyperlink[
   "http://quantlib.org/license.shtml", "http://quantlib.org/license.shtml"], 
   " for the QuantLib license.\n"],
  Editable->False]], "Print",
 CellChangeTimes->{3.522742718265625*^9, 3.522742917875*^9, 
  3.52275255140625*^9}],

Cell[BoxData["\<\"THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND \
CONTRIBUTORS 'AS IS' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT \
NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A \
PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDERS OR \
CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, \
EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, \
PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; \
OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, \
WHETHER IN CONTRACT, STRICT LIABILITY OR TORT (INCLUDING NEGLIGENCE OR \
OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF \
ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.\\n\"\>"], "Print",
 CellChangeTimes->{3.522742718265625*^9, 3.522742917875*^9, 3.5227525515*^9}],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"How", " ", "to", " ", "get", " ", "started"}], "MSG"], " ", 
  ButtonBox[
   StyleBox[">>", "SR"],
   Active->True,
   BaseStyle->"Link",
   ButtonData->"paclet:QuantLib/tutorial/Getting Started"]}]], "Print", \
"PrintUsage",
 CellChangeTimes->{3.522752551984375*^9}],

Cell[BoxData["\<\"Setting default values:\"\>"], "Print",
 CellChangeTimes->{3.522742718265625*^9, 3.522742917875*^9, 
  3.522752557171875*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"  Setting Valuation Date = \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{"2011", ",", "8", ",", "19"}], "}"}]}],
  SequenceForm["  Setting Valuation Date = ", {2011, 8, 19}],
  Editable->False]], "Print",
 CellChangeTimes->{3.522742718265625*^9, 3.522742917875*^9, 3.52275255725*^9}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"yc", " ", "=", 
   RowBox[{"FlatForward", "[", 
    RowBox[{"0.044", ",", 
     RowBox[{"Calendar", "\[Rule]", "\"\<NullCalendar\>\""}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"IborIndex", "=", 
   RowBox[{"Euribor", "[", 
    RowBox[{"\"\<6M\>\"", ",", 
     RowBox[{"YieldCurve", "\[Rule]", "yc"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"swapIndex", "=", 
   RowBox[{"SwapIndex", "[", 
    RowBox[{
    "\"\<Libor\>\"", ",", "\"\<1Y\>\"", ",", "2", ",", "\"\<10Y\>\"", ",", 
     "\"\<Following\>\"", ",", "\"\<30/360 (Bond Basis)\>\"", ",", 
     "IborIndex"}], "]"}]}], " ", ";"}], "\[IndentingNewLine]", 
 RowBox[{"svol", " ", "=", " ", 
  RowBox[{
  "ConstantSwaptionVolatility", "[", "0.15", "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"BlackSwaptionEngine", "[", 
   RowBox[{"swaptionE", ",", "yc", ",", "svol"}], "]"}], ";"}]}], "Input",
 CellChangeTimes->{{3.522741210609375*^9, 3.52274125365625*^9}, {
  3.522741542828125*^9, 3.522741557921875*^9}}],

Cell[BoxData["ConstantSwaptionVolatility15"], "Output",
 CellChangeTimes->{3.52274125434375*^9, 3.52274155875*^9, 
  3.522742722796875*^9, 3.52274295296875*^9, 3.522752561890625*^9, 
  3.52275265334375*^9, 3.522752788375*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"swaption", " ", "=", 
   RowBox[{"MakeSwaption", "[", 
    RowBox[{"swapIndex", ",", "\"\<1Y\>\"", ",", "swaptionE", ",", 
     RowBox[{"Strike", "\[Rule]", "0.05"}]}], "]"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.522741270953125*^9, 3.522741293*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"InstrumentNPV", "[", "swaption", "]"}]], "Input",
 CellChangeTimes->{{3.52274125815625*^9, 3.52274126684375*^9}}],

Cell[BoxData["0.0009265182489717165`"], "Output",
 CellChangeTimes->{{3.5227412674375*^9, 3.522741294484375*^9}, 
   3.52274156084375*^9, 3.522742723109375*^9, 3.522742957125*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"settlementDate", "=", 
   RowBox[{"EvaluationDate", "[", "]"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"dates", "=", 
   RowBox[{"CalendarAdvance", "[", 
    RowBox[{"settlementDate", ",", 
     RowBox[{"{", 
      RowBox[{"\"\<1D\>\"", ",", "\"\<1W\>\"", ",", "\"\<1M\>\""}], "}"}]}], 
    "]"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"strikes", "=", 
   RowBox[{"{", 
    RowBox[{"0.03", ",", " ", "0.05", ",", " ", "0.10"}], "}"}]}], 
  ";"}], "\n", 
 RowBox[{
  RowBox[{"volatilities", "=", 
   RowBox[{"Table", "[", 
    RowBox[{"0.2", ",", 
     RowBox[{"{", 
      RowBox[{"Length", "[", "dates", "]"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"Length", "[", "strikes", "]"}], "}"}]}], "]"}]}], ";"}], "\n", 
 RowBox[{"surface", " ", "=", " ", 
  RowBox[{"BlackVarianceSurface", "[", 
   RowBox[{
   "settlementDate", ",", "dates", ",", "strikes", ",", "volatilities"}], 
   "]"}]}]}], "Input",
 CellChangeTimes->{{3.52274140825*^9, 3.522741441703125*^9}, {
  3.522741479140625*^9, 3.52274151034375*^9}, {3.522741858015625*^9, 
  3.522741862890625*^9}}],

Cell[BoxData["BlackVarianceSurface11"], "Output",
 CellChangeTimes->{3.522741521046875*^9, 3.522741566125*^9, 
  3.52274272315625*^9, 3.522742958125*^9, 3.522752682328125*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"BlackSwaptionEngine", "[", 
   RowBox[{"swaptionE", ",", "yc", ",", "surface"}], "]"}], ";"}]], "Input",
 CellChangeTimes->{{3.522741577578125*^9, 3.522741578859375*^9}, 
   3.52274165353125*^9, {3.5227526985625*^9, 3.522752701078125*^9}}],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"QuantLibError", "::", "msg"}], "MessageName"], 
  RowBox[{
  ":", " "}], "\<\"Error: \[NoBreak]\\!\\(\\\"qlBlackSwaptionEngine\\\"\\)\
\[NoBreak] \[NoBreak]\\!\\(\\\"Unable to coerce value from type 'class \
boost::shared_ptr<class ObjectHandler::Object>' to type 'class \
QuantLib::Handle<class QuantLib::SwaptionVolatilityStructure>' - all \
conversions failed\\\"\\)\[NoBreak]\"\>"}]], "Message", "MSG",
 CellChangeTimes->{3.522741579703125*^9, 3.522741654234375*^9, 
  3.522742723234375*^9, 3.5227526855625*^9, 3.5227527841875*^9, 
  3.5227542436875*^9, 3.52275514825*^9, 3.52275519078125*^9, 
  3.52275549084375*^9, 3.522755870609375*^9, 3.52275598446875*^9, 
  3.522756226453125*^9}]
}, Open  ]]
},
WindowSize->{716, 821},
WindowMargins->{{204, Automatic}, {46, Automatic}},
ShowSelection->True,
FrontEndVersion->"8.0 for Microsoft Windows (32-bit) (February 23, 2011)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[579, 22, 138, 2, 31, "Input"],
Cell[CellGroupData[{
Cell[742, 28, 1961, 48, 62, "Print"],
Cell[2706, 78, 1962, 50, 62, "Print"],
Cell[4671, 130, 890, 11, 214, "Print"],
Cell[5564, 143, 315, 10, 42, "Print"],
Cell[5882, 155, 143, 2, 23, "Print"],
Cell[6028, 159, 344, 7, 23, "Print"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[6421, 172, 1058, 27, 132, "Input"],
Cell[7482, 201, 225, 3, 30, "Output"]
}, Open  ]],
Cell[7722, 207, 289, 6, 31, "Input"],
Cell[CellGroupData[{
Cell[8036, 217, 137, 2, 31, "Input"],
Cell[8176, 221, 179, 2, 30, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[8392, 228, 1097, 31, 112, "Input"],
Cell[9492, 261, 175, 2, 30, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[9704, 268, 274, 5, 31, "Input"],
Cell[9981, 275, 737, 14, 56, "Message"]
}, Open  ]]
}
]
*)

(* End of internal cache information *)

