(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 8.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       157,          7]
NotebookDataLength[     43849,       1153]
NotebookOptionsPosition[     38647,        959]
NotebookOutlinePosition[     40013,       1000]
CellTagsIndexPosition[     39970,        997]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell["Yield Term Structures", "Chapter",
 CellChangeTimes->{{3.519362459796875*^9, 3.519362471984375*^9}},
 CellID->671663841],

Cell[BoxData[
 RowBox[{"Needs", "[", "\"\<QuantLib`\>\"", "]"}]], "Input",
 CellChangeTimes->{{3.519362707421875*^9, 3.519362718953125*^9}, 
   3.519362842390625*^9},
 CellID->39897184],

Cell[CellGroupData[{

Cell["Defining a yield curve", "Section",
 CellChangeTimes->{{3.5193737318125*^9, 3.519373740578125*^9}},
 CellID->256995324],

Cell[BoxData[
 RowBox[{
  RowBox[{"offset", " ", "=", 
   RowBox[{"{", 
    RowBox[{
    "\"\<2D\>\"", ",", "\"\<3M\>\"", ",", "\"\<6M\>\"", ",", "\"\<9M\>\"", 
     ",", "\"\<12M\>\"", ",", "\"\<15M\>\"", ",", "\"\<18M\>\"", ",", 
     "\"\<21M\>\"", ",", "\"\<2Y\>\"", ",", "\"\<3Y\>\"", ",", "\"\<4Y\>\"", 
     ",", "\"\<5Y\>\"", ",", "\"\<6Y\>\"", ",", "\"\<7Y\>\"", ",", 
     "\"\<8Y\>\"", ",", "\"\<9Y\>\"", ",", "\"\<10Y\>\"", ",", "\"\<15Y\>\"", 
     ",", "\"\<20Y\>\"", ",", "\"\<25Y\>\"", ",", "\"\<30Y\>\"", ",", 
     "\"\<31Y\>\"", ",", "\"\<35Y\>\"", ",", "\"\<40Y\>\"", ",", 
     "\"\<50Y\>\"", ",", "\"\<60Y\>\""}], "}"}]}], ";"}]], "Input",
 CellID->10224813],

Cell[BoxData[
 RowBox[{
  RowBox[{"forwardRate", " ", "=", 
   RowBox[{"{", 
    RowBox[{
    "0.04`", ",", "0.04`", ",", "0.03`", ",", "0.035`", ",", "0.038`", ",", 
     "0.04`", ",", "0.042`", ",", "0.044`", ",", "0.046`", ",", "0.048`", ",",
      "0.049`", ",", "0.0495`", ",", "0.0498`", ",", "0.0499`", ",", "0.05`", 
     ",", "0.05`", ",", "0.05`", ",", "0.05`", ",", "0.04`", ",", "0.03`", 
     ",", "0.02`"}], "}"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.519364801046875*^9, 3.51936480834375*^9}},
 CellID->474572391],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"first", " ", "=", 
  RowBox[{"CalendarAdvance", "[", 
   RowBox[{
    RowBox[{"Date", "[", "]"}], ",", "\"\<2D\>\""}], "]"}]}]], "Input",
 CellChangeTimes->{{3.5193644075*^9, 3.519364411234375*^9}, {
  3.5193645948125*^9, 3.519364597171875*^9}},
 CellID->543573995],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"2011", ",", "10", ",", "31"}], "}"}]], "Output",
 CellChangeTimes->{
  3.51936441190625*^9, 3.519364597796875*^9, 3.519367835703125*^9, 
   3.51936833209375*^9, 3.519368751140625*^9, 3.519369221265625*^9, 
   3.519369601609375*^9, 3.519371611515625*^9, 3.519373019796875*^9, 
   3.51937381709375*^9, 3.519374367140625*^9, 3.51937529796875*^9, 
   3.519376291796875*^9, 3.519376681109375*^9, 3.51937788575*^9, 
   3.51937796496875*^9, 3.51937858303125*^9, 3.519378628078125*^9, 
   3.519379337046875*^9, 3.519380326234375*^9, {3.519380798171875*^9, 
   3.519380826*^9}, 3.519381429921875*^9, 3.51938187765625*^9, 
   3.5213623885*^9, 3.528705788546875*^9},
 CellID->971922902]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"dates", " ", "=", " ", 
  RowBox[{"CalendarAdvance", "[", 
   RowBox[{"first", ",", 
    RowBox[{"Rest", "[", "offset", "]"}]}], "]"}], "  "}]], "Input",
 CellChangeTimes->{{3.519364327234375*^9, 3.5193643945*^9}, {3.5193644465*^9, 
  3.5193644763125*^9}, {3.5193645799375*^9, 3.519364609*^9}},
 CellID->485057045],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"2012", ",", "1", ",", "31"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"2012", ",", "4", ",", "30"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"2012", ",", "7", ",", "31"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"2012", ",", "10", ",", "31"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"2013", ",", "1", ",", "31"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"2013", ",", "4", ",", "30"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"2013", ",", "7", ",", "31"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"2013", ",", "10", ",", "31"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"2014", ",", "10", ",", "31"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"2015", ",", "10", ",", "30"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"2016", ",", "10", ",", "31"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"2017", ",", "10", ",", "31"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"2018", ",", "10", ",", "31"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"2019", ",", "10", ",", "31"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"2020", ",", "10", ",", "30"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"2021", ",", "10", ",", "29"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"2026", ",", "10", ",", "30"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"2031", ",", "10", ",", "31"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"2036", ",", "10", ",", "31"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"2041", ",", "10", ",", "31"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"2042", ",", "10", ",", "31"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"2046", ",", "10", ",", "31"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"2051", ",", "10", ",", "31"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"2061", ",", "10", ",", "31"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"2071", ",", "10", ",", "30"}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{
  3.519363343203125*^9, 3.519364212703125*^9, {3.51936432934375*^9, 
   3.51936433834375*^9}, {3.51936445171875*^9, 3.51936447684375*^9}, {
   3.519364585890625*^9, 3.519364610171875*^9}, 3.51936783575*^9, 
   3.519368332140625*^9, 3.519368751203125*^9, 3.519369221328125*^9, 
   3.519369601765625*^9, 3.5193716115625*^9, 3.51937301984375*^9, 
   3.519373817328125*^9, 3.5193743671875*^9, 3.51937529803125*^9, 
   3.5193762918125*^9, 3.51937668209375*^9, 3.519377885796875*^9, 
   3.51937796603125*^9, 3.519378583078125*^9, 3.519378628125*^9, 
   3.5193793430625*^9, 3.519380326359375*^9, {3.51938079821875*^9, 
   3.5193808260625*^9}, 3.519381429953125*^9, 3.519381877703125*^9, 
   3.521362388546875*^9, 3.52870578859375*^9},
 CellID->306557217]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"allDates", " ", "=", " ", 
   RowBox[{"Take", "[", 
    RowBox[{
     RowBox[{"Join", "[", 
      RowBox[{
       RowBox[{"{", "first", "}"}], ",", "dates"}], "]"}], ",", 
     RowBox[{"Length", "[", "forwardRate", "]"}]}], "]"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.519364960875*^9, 3.51936499640625*^9}},
 CellID->806122494],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DateListPlot", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"{", 
     RowBox[{"allDates", ",", "forwardRate"}], "}"}], "\[Transpose]"}], ",", 
   RowBox[{"Joined", "\[Rule]", "True"}], ",", 
   RowBox[{"PlotRange", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"0", ",", "0.06"}], "}"}]}]}], "]"}]], "Input",
 CellChangeTimes->{{3.519364835703125*^9, 3.519364863765625*^9}, {
   3.519364897953125*^9, 3.5193649445625*^9}, {3.51936500728125*^9, 
   3.519365080765625*^9}, 3.519373782421875*^9},
 CellID->290961461],

Cell[BoxData[
 GraphicsBox[{{}, {}, 
   {Hue[0.67, 0.6, 0.6], LineBox[CompressedData["
1:eJxTTMoPSmViYGAQBWIQDQQFPN6vHKtF1rk/rFpiD+RvMI1C4U/gynzluEOu
9XXgjnkg/gXjileObwJBIgtBfIHY9leOt3/WZe0pWQziB7RNQ9HPYLj0laO0
/l0VtsalIL5D1JZXjrs8eZi025eB+A3Nh185RqVY3/fvXQ7if1j5/5XjL5Bx
k1eA+AbLrF87eoGUi60Em6dY8drx0yXfJIEIML/Afctrx7DadduS6sH8B7kf
XjtWcKto1PWA+QFTdN44zpoJAmD+gV0ZKHyG7UtQ+BNOX3yLzFd48O8dsn8i
fol+QA6Pjvw1H6DyU+wBQiyI7w==
     "]]}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  AxesOrigin->{3.55*^9, 0},
  Frame->True,
  FrameTicks->{{Automatic, Automatic}, {{{
       NCache[3471292800, 3.4712928*^9], 
       FormBox["\"2010\"", TraditionalForm]}, {
       NCache[3786825600, 3.7868256*^9], 
       FormBox["\"2020\"", TraditionalForm]}, {
       NCache[4102444800, 4.1024448*^9], 
       FormBox["\"2030\"", TraditionalForm]}, {
       NCache[4417977600, 4.4179776*^9], 
       FormBox["\"2040\"", TraditionalForm]}, {
       NCache[4733596800, 4.7335968*^9], 
       FormBox["\"2050\"", TraditionalForm]}, {
       NCache[3534364800, 3.5343648*^9], 
       FormBox["\"\"", TraditionalForm]}, {
       NCache[3597523200, 3.5975232*^9], 
       FormBox["\"\"", TraditionalForm]}, {
       NCache[3660595200, 3.6605952*^9], 
       FormBox["\"\"", TraditionalForm]}, {
       NCache[3723753600, 3.7237536*^9], 
       FormBox["\"\"", TraditionalForm]}, {
       NCache[3849984000, 3.849984*^9], 
       FormBox["\"\"", TraditionalForm]}, {
       NCache[3913056000, 3.913056*^9], 
       FormBox["\"\"", TraditionalForm]}, {
       NCache[3976214400, 3.9762144*^9], 
       FormBox["\"\"", TraditionalForm]}, {
       NCache[4039286400, 4.0392864*^9], 
       FormBox["\"\"", TraditionalForm]}, {
       NCache[4165516800, 4.1655168*^9], 
       FormBox["\"\"", TraditionalForm]}, {
       NCache[4228675200, 4.2286752*^9], 
       FormBox["\"\"", TraditionalForm]}, {
       NCache[4291747200, 4.2917472*^9], 
       FormBox["\"\"", TraditionalForm]}, {
       NCache[4354905600, 4.3549056*^9], 
       FormBox["\"\"", TraditionalForm]}}, {{
       NCache[3471292800, 3.4712928*^9], 
       FormBox["\"\"", TraditionalForm]}, {
       NCache[3786825600, 3.7868256*^9], 
       FormBox["\"\"", TraditionalForm]}, {
       NCache[4102444800, 4.1024448*^9], 
       FormBox["\"\"", TraditionalForm]}, {
       NCache[4417977600, 4.4179776*^9], 
       FormBox["\"\"", TraditionalForm]}, {
       NCache[4733596800, 4.7335968*^9], 
       FormBox["\"\"", TraditionalForm]}, {
       NCache[3534364800, 3.5343648*^9], 
       FormBox["\"\"", TraditionalForm]}, {
       NCache[3597523200, 3.5975232*^9], 
       FormBox["\"\"", TraditionalForm]}, {
       NCache[3660595200, 3.6605952*^9], 
       FormBox["\"\"", TraditionalForm]}, {
       NCache[3723753600, 3.7237536*^9], 
       FormBox["\"\"", TraditionalForm]}, {
       NCache[3849984000, 3.849984*^9], 
       FormBox["\"\"", TraditionalForm]}, {
       NCache[3913056000, 3.913056*^9], 
       FormBox["\"\"", TraditionalForm]}, {
       NCache[3976214400, 3.9762144*^9], 
       FormBox["\"\"", TraditionalForm]}, {
       NCache[4039286400, 4.0392864*^9], 
       FormBox["\"\"", TraditionalForm]}, {
       NCache[4165516800, 4.1655168*^9], 
       FormBox["\"\"", TraditionalForm]}, {
       NCache[4228675200, 4.2286752*^9], 
       FormBox["\"\"", TraditionalForm]}, {
       NCache[4291747200, 4.2917472*^9], 
       FormBox["\"\"", TraditionalForm]}, {
       NCache[4354905600, 4.3549056*^9], 
       FormBox["\"\"", TraditionalForm]}}}},
  GridLines->NCache[{{{3471292800, 
       GrayLevel[0.8]}, {3786825600, 
       GrayLevel[0.8]}, {4102444800, 
       GrayLevel[0.8]}, {4417977600, 
       GrayLevel[0.8]}, {4733596800, 
       GrayLevel[0.8]}}, None}, {{{3.4712928*^9, 
       GrayLevel[0.8]}, {3.7868256*^9, 
       GrayLevel[0.8]}, {4.1024448*^9, 
       GrayLevel[0.8]}, {4.4179776*^9, 
       GrayLevel[0.8]}, {4.7335968*^9, 
       GrayLevel[0.8]}}, None}],
  PlotRange->{{3.529008*^9, 4.4757792*^9}, {0, 0.06}},
  PlotRangeClipping->True,
  PlotRangePadding->{
    Scaled[0.02], Automatic},
  Ticks->None]], "Output",
 CellChangeTimes->{
  3.51936486484375*^9, {3.519364902328125*^9, 3.519364945640625*^9}, {
   3.519365017046875*^9, 3.519365030546875*^9}, {3.51936506459375*^9, 
   3.5193650816875*^9}, 3.519367836046875*^9, 3.519368332296875*^9, 
   3.519368751359375*^9, 3.519369222265625*^9, 3.519369601890625*^9, 
   3.519371612234375*^9, 3.519373020109375*^9, 3.51937381796875*^9, 
   3.51937436771875*^9, 3.5193752984375*^9, 3.519376292296875*^9, 
   3.519376686328125*^9, 3.51937788615625*^9, 3.51937796971875*^9, 
   3.51937858321875*^9, 3.519378628328125*^9, 3.519379343296875*^9, 
   3.5193803265*^9, {3.519380798359375*^9, 3.51938082621875*^9}, 
   3.51938143009375*^9, 3.5193818779375*^9, 3.5213623886875*^9, 
   3.528705788859375*^9},
 CellID->114020012]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"yf", " ", "=", " ", 
  RowBox[{"DayCounterYearFraction", "[", 
   RowBox[{"first", ",", "allDates"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.519364488375*^9, 3.519364495890625*^9}, {
  3.519364615140625*^9, 3.519364621640625*^9}, {3.519365117765625*^9, 
  3.5193651295*^9}},
 CellID->201071272],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "0.`", ",", "0.25205479452054796`", ",", "0.4986301369863014`", ",", 
   "0.7506849315068493`", ",", "1.0027397260273974`", ",", 
   "1.2547945205479452`", ",", "1.4986301369863013`", ",", 
   "1.7506849315068493`", ",", "2.0027397260273974`", ",", 
   "3.0027397260273974`", ",", "4.`", ",", "5.005479452054795`", ",", 
   "6.005479452054795`", ",", "7.005479452054795`", ",", "8.005479452054795`",
    ",", "9.005479452054795`", ",", "10.002739726027396`", ",", 
   "15.008219178082191`", ",", "20.013698630136986`", ",", 
   "25.019178082191782`", ",", "30.02191780821918`"}], "}"}]], "Output",
 CellChangeTimes->{
  3.519364497984375*^9, {3.5193646169375*^9, 3.51936462215625*^9}, 
   3.51936513015625*^9, 3.51936783615625*^9, 3.5193683325625*^9, 
   3.519368751640625*^9, 3.519369222578125*^9, 3.519369602015625*^9, 
   3.51937161246875*^9, 3.51937302034375*^9, 3.51937381815625*^9, 
   3.51937436784375*^9, 3.51937529875*^9, 3.5193762925625*^9, 
   3.519376687234375*^9, 3.51937788659375*^9, 3.519377971234375*^9, 
   3.5193785833125*^9, 3.519378628515625*^9, 3.519379343421875*^9, 
   3.519380326609375*^9, {3.5193807985*^9, 3.5193808263125*^9}, 
   3.519381430171875*^9, 3.5193818780625*^9, 3.52136238878125*^9, 
   3.52870578896875*^9},
 CellID->589788355]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"MapThread", "[", 
  RowBox[{
   RowBox[{
    SuperscriptBox["\[ExponentialE]", 
     RowBox[{
      RowBox[{"-", "#1"}], " ", "#2"}]], "&"}], ",", 
   RowBox[{"{", 
    RowBox[{"yf", ",", "forwardRate"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.519365153765625*^9, 3.519365214484375*^9}},
 CellID->96144827],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "1.`", ",", "0.9899684631342734`", ",", "0.9851524244872506`", ",", 
   "0.9740681850522461`", ",", "0.9626127184597074`", ",", 
   "0.9510470144317864`", ",", "0.938997496648539`", ",", 
   "0.9258619504971206`", ",", "0.9119902065502009`", ",", 
   "0.8657738853766226`", ",", "0.8220122346781865`", ",", 
   "0.7805384843987775`", ",", "0.7415053689924233`", ",", 
   "0.704988756405855`", ",", "0.6701364218631031`", ",", 
   "0.6374534829058073`", ",", "0.6064475790114809`", ",", 
   "0.4721724693830358`", ",", "0.44908282390748294`", ",", 
   "0.4720948583699706`", ",", "0.5485711138513145`"}], "}"}]], "Output",
 CellChangeTimes->{{3.519365210484375*^9, 3.519365215234375*^9}, 
   3.519367836578125*^9, 3.519368332609375*^9, 3.5193687516875*^9, 
   3.519369222625*^9, 3.5193696020625*^9, 3.51937161253125*^9, 
   3.519373020390625*^9, 3.5193738183125*^9, 3.519374367875*^9, 
   3.5193752988125*^9, 3.519376292578125*^9, 3.5193766875625*^9, 
   3.519377886640625*^9, 3.519377972125*^9, 3.519378583359375*^9, 
   3.5193786285625*^9, 3.51937934346875*^9, 3.51938032665625*^9, {
   3.519380798546875*^9, 3.51938082634375*^9}, 3.51938143021875*^9, 
   3.519381878109375*^9, 3.521362388859375*^9, 3.5287057890625*^9},
 CellID->4773495]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"zeroYield", " ", "=", 
  RowBox[{"Join", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"First", "[", "forwardRate", "]"}], "}"}], ",", 
    RowBox[{
     RowBox[{"Accumulate", "[", 
      RowBox[{
       RowBox[{"Differences", "[", "yf", "]"}], " ", 
       RowBox[{"Rest", "[", "forwardRate", "]"}]}], "]"}], "/", 
     RowBox[{"Rest", "[", "yf", "]"}]}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.51936544515625*^9, 3.519365545515625*^9}, {
  3.519365607390625*^9, 3.519365624359375*^9}, {3.5193657490625*^9, 
  3.519365836046875*^9}},
 CellID->5519936],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "0.04`", ",", "0.04`", ",", "0.03505494505494505`", ",", 
   "0.03503649635036496`", ",", "0.03578142076502732`", ",", 
   "0.03662882096069869`", ",", "0.037502742230347344`", ",", 
   "0.03843818466353678`", ",", "0.039389876880984956`", ",", 
   "0.04225729927007299`", ",", "0.04393835616438356`", ",", 
   "0.04505555555555556`", ",", "0.04584557481751824`", ",", 
   "0.04642432538130622`", ",", "0.0468709787816564`", ",", 
   "0.047218436264070573`", ",", "0.04749575458778417`", ",", 
   "0.04833096020445418`", ",", "0.04624736481861739`", ",", 
   "0.04299682435392028`", ",", "0.03916471983938675`"}], "}"}]], "Output",
 CellChangeTimes->{{3.519365455328125*^9, 3.519365483046875*^9}, 
   3.51936551571875*^9, 3.519365546234375*^9, {3.519365612171875*^9, 
   3.51936562540625*^9}, 3.519365756296875*^9, {3.519365807953125*^9, 
   3.51936583671875*^9}, 3.519367836625*^9, 3.519368332671875*^9, 
   3.519368751734375*^9, 3.519369222671875*^9, 3.519369602109375*^9, 
   3.519371612609375*^9, 3.519373020453125*^9, 3.519373818625*^9, 
   3.519374367890625*^9, 3.519375298890625*^9, 3.51937629259375*^9, 
   3.5193766876875*^9, 3.519377886671875*^9, 3.519377973296875*^9, 
   3.51937858340625*^9, 3.519378628609375*^9, 3.5193793435*^9, 
   3.5193803266875*^9, {3.51938079859375*^9, 3.519380826390625*^9}, 
   3.519381430265625*^9, 3.51938187815625*^9, 3.52136238890625*^9, 
   3.528705789125*^9},
 CellID->408914710]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"discount", " ", "=", 
  RowBox[{"MapThread", "[", 
   RowBox[{
    RowBox[{
     SuperscriptBox["\[ExponentialE]", 
      RowBox[{
       RowBox[{"-", "#1"}], " ", "#2"}]], "&"}], ",", 
    RowBox[{"{", 
     RowBox[{"yf", ",", "zeroYield"}], "}"}]}], "]"}]}]], "Input",
 CellChangeTimes->{
  3.5193658533125*^9, {3.519365942546875*^9, 3.519365945125*^9}},
 CellID->158342628],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "1.`", ",", "0.9899684631342734`", ",", "0.9826724273568158`", ",", 
   "0.9740414986182249`", ",", "0.9647565858976298`", ",", 
   "0.9550785946397452`", ",", "0.9453474569761595`", ",", 
   "0.9349210884031202`", ",", "0.924143726540444`", ",", 
   "0.8808326098814113`", ",", "0.8388247913493437`", ",", 
   "0.7980973810917634`", ",", "0.759325562438434`", ",", 
   "0.7223650506603537`", ",", "0.6871348914190774`", ",", 
   "0.6536229273189296`", ",", "0.6218305374253228`", ",", 
   "0.484149447628245`", ",", "0.3963011718084969`", ",", "0.34104351308673`",
    ",", "0.30857202329999567`"}], "}"}]], "Output",
 CellChangeTimes->{
  3.51936585440625*^9, 3.519365947171875*^9, 3.519367836671875*^9, 
   3.51936833271875*^9, 3.51936875178125*^9, 3.51936922271875*^9, 
   3.519369602140625*^9, 3.519371612671875*^9, 3.5193730205*^9, 
   3.51937381871875*^9, 3.519374367921875*^9, 3.519375298953125*^9, 
   3.519376292609375*^9, 3.51937668771875*^9, 3.519377886703125*^9, 
   3.5193779749375*^9, 3.519378583453125*^9, 3.51937862865625*^9, 
   3.519379343546875*^9, 3.519380326734375*^9, {3.519380798640625*^9, 
   3.5193808264375*^9}, 3.5193814303125*^9, 3.519381878203125*^9, 
   3.52136238896875*^9, 3.528705789203125*^9},
 CellID->335797383]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"yieldcurve", " ", "=", " ", 
  RowBox[{"InterpolatedYieldCurve", "[", 
   RowBox[{"allDates", ",", "forwardRate", ",", 
    RowBox[{"TraitsID", "\[Rule]", "\"\<ForwardRate\>\""}], ",", 
    RowBox[{"InterpolatorID", "\[Rule]", "\"\<ForwardFlat\>\""}]}], 
   "]"}]}]], "Input",
 CellChangeTimes->{{3.519365884609375*^9, 3.51936589484375*^9}, {
   3.51936596428125*^9, 3.5193659655625*^9}, {3.519366138453125*^9, 
   3.5193661455625*^9}, {3.51936631296875*^9, 3.5193663134375*^9}, {
   3.519366351296875*^9, 3.51936637*^9}, {3.519366492296875*^9, 
   3.519366495765625*^9}, {3.5193682148125*^9, 3.51936822*^9}, 
   3.5193694205625*^9, {3.51937673896875*^9, 3.519376748859375*^9}},
 CellID->83685140],

Cell[BoxData["InterpolatedYieldCurve4"], "Output",
 CellChangeTimes->{3.5193767494375*^9, 3.5193778971875*^9, 3.5193785965625*^9,
   3.51937972321875*^9, 3.51938043771875*^9, 3.5193808053125*^9, 
  3.519381460328125*^9, 3.519381878578125*^9, 3.521362389078125*^9, 
  3.528705789265625*^9},
 CellID->950736302]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Analysing a yield curve", "Section",
 CellChangeTimes->{{3.51937500528125*^9, 3.519375016421875*^9}},
 CellID->269887506],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"InterpolatedYieldCurveDates", "[", "yieldcurve", "]"}]], "Input",
 CellChangeTimes->{{3.51936978928125*^9, 3.5193697933125*^9}},
 CellID->80407335],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"2011", ",", "10", ",", "31"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"2012", ",", "1", ",", "31"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"2012", ",", "4", ",", "30"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"2012", ",", "7", ",", "31"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"2012", ",", "10", ",", "31"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"2013", ",", "1", ",", "31"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"2013", ",", "4", ",", "30"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"2013", ",", "7", ",", "31"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"2013", ",", "10", ",", "31"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"2014", ",", "10", ",", "31"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"2015", ",", "10", ",", "30"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"2016", ",", "10", ",", "31"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"2017", ",", "10", ",", "31"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"2018", ",", "10", ",", "31"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"2019", ",", "10", ",", "31"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"2020", ",", "10", ",", "30"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"2021", ",", "10", ",", "29"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"2026", ",", "10", ",", "30"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"2031", ",", "10", ",", "31"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"2036", ",", "10", ",", "31"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"2041", ",", "10", ",", "31"}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{3.519369794328125*^9, 3.519370741484375*^9, 
  3.519371613078125*^9, 3.5193730209375*^9, 3.5193738189375*^9, 
  3.51937436840625*^9, 3.519375299375*^9, 3.519376293375*^9, 
  3.51937669190625*^9, 3.519377897359375*^9, 3.519381470640625*^9, 
  3.5193818786875*^9, 3.521362389140625*^9, 3.528705789359375*^9},
 CellID->437888635]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"InterpolatedYieldCurveData", "[", "yieldcurve", "]"}]], "Input",
 CellChangeTimes->{{3.51936978928125*^9, 3.5193697933125*^9}, {
  3.51937074309375*^9, 3.51937074734375*^9}},
 CellID->73390169],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "0.04`", ",", "0.04`", ",", "0.03`", ",", "0.035`", ",", "0.038`", ",", 
   "0.04`", ",", "0.042`", ",", "0.044`", ",", "0.046`", ",", "0.048`", ",", 
   "0.049`", ",", "0.0495`", ",", "0.0498`", ",", "0.0499`", ",", "0.05`", 
   ",", "0.05`", ",", "0.05`", ",", "0.05`", ",", "0.04`", ",", "0.03`", ",", 
   "0.02`"}], "}"}]], "Output",
 CellChangeTimes->{3.519370747984375*^9, 3.519371613140625*^9, 
  3.519373020984375*^9, 3.519373819015625*^9, 3.5193743684375*^9, 
  3.519375299453125*^9, 3.519376293453125*^9, 3.51937670459375*^9, 
  3.519377897390625*^9, 3.519381471796875*^9, 3.519381878734375*^9, 
  3.5213623891875*^9, 3.52870578940625*^9},
 CellID->71546160]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"TermStructureMaxDate", "[", "yieldcurve", "]"}]], "Input",
 CellChangeTimes->{{3.519374459828125*^9, 3.519374464765625*^9}},
 CellID->213750667],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"2041", ",", "10", ",", "31"}], "}"}]], "Output",
 CellChangeTimes->{3.519374465390625*^9, 3.519375299515625*^9, 
  3.519376293453125*^9, 3.519376704734375*^9, 3.519377897421875*^9, 
  3.5193814728125*^9, 3.5193818788125*^9, 3.521362389234375*^9, 
  3.52870578946875*^9},
 CellID->695549501]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"TermStructureCalendar", "[", "yieldcurve", "]"}]], "Input",
 CellChangeTimes->{{3.519374475703125*^9, 3.519374486859375*^9}},
 CellID->89532938],

Cell[BoxData["\<\"TARGET\"\>"], "Output",
 CellChangeTimes->{3.519374487484375*^9, 3.519375299578125*^9, 
  3.51937629346875*^9, 3.519376704765625*^9, 3.519377897453125*^9, 
  3.51938147384375*^9, 3.519381878953125*^9, 3.52136238928125*^9, 
  3.52870578953125*^9},
 CellID->480156843]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"TermStructureDayCounter", "[", "yieldcurve", "]"}]], "Input",
 CellChangeTimes->{{3.519374503515625*^9, 3.51937450965625*^9}},
 CellID->44611933],

Cell[BoxData["\<\"Actual/365 (Fixed)\"\>"], "Output",
 CellChangeTimes->{3.5193745103125*^9, 3.51937529978125*^9, 
  3.519376293484375*^9, 3.5193767048125*^9, 3.5193778975*^9, 
  3.5193814748125*^9, 3.519381879*^9, 3.521362389328125*^9, 
  3.528705789796875*^9},
 CellID->160654066]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"TermStructureReferenceDate", "[", "yieldcurve", "]"}]], "Input",
 CellChangeTimes->{{3.519374533765625*^9, 3.519374541609375*^9}},
 CellID->232506578],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"2011", ",", "10", ",", "31"}], "}"}]], "Output",
 CellChangeTimes->{3.519374542328125*^9, 3.519375299859375*^9, 
  3.519376293484375*^9, 3.519376704859375*^9, 3.51937789753125*^9, 
  3.519381475859375*^9, 3.519381879046875*^9, 3.521362389375*^9, 
  3.528705789859375*^9},
 CellID->144629621]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"TermStructureSettlementDays", "[", "yieldcurve", "]"}]], "Input",
 CellChangeTimes->{{3.5193745588125*^9, 3.519374566546875*^9}},
 CellID->241099876],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"QuantLibError", "::", "msg"}], "MessageName"], 
  RowBox[{
  ":", " "}], "\<\"Error: \[NoBreak]\\!\\(\\\"TermStructureSettlementDays\\\"\
\\)\[NoBreak] \[NoBreak]\\!\\(\\\"settlement days not provided for this \
instance\\\"\\)\[NoBreak]\"\>"}]], "Message", "MSG",
 CellChangeTimes->{3.528705790015625*^9},
 CellID->764356107],

Cell[BoxData["$Failed"], "Output",
 CellChangeTimes->{3.519374567890625*^9, 3.519375300265625*^9, 
  3.519376293890625*^9, 3.519376710609375*^9, 3.519377897578125*^9, 
  3.5193814770625*^9, 3.519381879375*^9, 3.5213623894375*^9, 
  3.528705790015625*^9},
 CellID->78645543]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"TermStructureTimeFromReference", "[", 
  RowBox[{"yieldcurve", ",", "allDates"}], "]"}]], "Input",
 CellChangeTimes->{{3.5193746153125*^9, 3.5193746381875*^9}},
 CellID->670354889],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "0.`", ",", "0.25205479452054796`", ",", "0.4986301369863014`", ",", 
   "0.7506849315068493`", ",", "1.0027397260273974`", ",", 
   "1.2547945205479452`", ",", "1.4986301369863013`", ",", 
   "1.7506849315068493`", ",", "2.0027397260273974`", ",", 
   "3.0027397260273974`", ",", "4.`", ",", "5.005479452054795`", ",", 
   "6.005479452054795`", ",", "7.005479452054795`", ",", "8.005479452054795`",
    ",", "9.005479452054795`", ",", "10.002739726027396`", ",", 
   "15.008219178082191`", ",", "20.013698630136986`", ",", 
   "25.019178082191782`", ",", "30.02191780821918`"}], "}"}]], "Output",
 CellChangeTimes->{3.51937463915625*^9, 3.5193753005*^9, 3.51937629403125*^9, 
  3.5193767108125*^9, 3.519377897609375*^9, 3.5193814795625*^9, 
  3.519381879421875*^9, 3.5213623895625*^9, 3.528705790078125*^9},
 CellID->243531119]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Working with a yield curve", "Section",
 CellChangeTimes->{{3.51937500528125*^9, 3.519375043328125*^9}},
 CellID->242618320],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"YieldTSZeroRate", "[", 
   RowBox[{"yieldcurve", ",", "first"}], "]"}], " "}]], "Input",
 CellChangeTimes->{{3.5193752604375*^9, 3.519375261171875*^9}},
 CellID->435288658],

Cell[BoxData["0.039999999999273825`"], "Output",
 CellChangeTimes->{
  3.5193753006875*^9, {3.51937533934375*^9, 3.51937535196875*^9}, 
   3.519375467734375*^9, 3.519375567625*^9, 3.519376294171875*^9, 
   3.5193767111875*^9, 3.519377897953125*^9, 3.519381493984375*^9, 
   3.519381879515625*^9, 3.521362389609375*^9, 3.528705790140625*^9},
 CellID->17546676]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"YieldTSForwardRate", "[", 
  RowBox[{"yieldcurve", ",", "first", " ", ",", "first"}], "]"}]], "Input",
 CellChangeTimes->{{3.5193698700625*^9, 3.519369870609375*^9}},
 CellID->440046200],

Cell[BoxData["0.039999999999273825`"], "Output",
 CellChangeTimes->{3.51936994984375*^9, 3.5193700749375*^9, 3.519370335125*^9,
   3.51937161328125*^9, 3.519373021109375*^9, 3.5193738191875*^9, 
  3.5193743685625*^9, 3.51937530075*^9, 3.5193762941875*^9, 
  3.51937671140625*^9, 3.519377898109375*^9, 3.51938150340625*^9, 
  3.519381879578125*^9, 3.52136238965625*^9, 3.528705790203125*^9},
 CellID->84919346]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"YieldTSDiscount", "[", 
  RowBox[{"yieldcurve", ",", 
   RowBox[{"InterpolatedYieldCurveDates", "[", "yieldcurve", "]"}]}], 
  "]"}]], "Input",
 CellChangeTimes->{{3.519370809265625*^9, 3.519370811296875*^9}, {
   3.51937100559375*^9, 3.51937101384375*^9}, {3.51937166296875*^9, 
   3.519371664921875*^9}, 3.519373275375*^9},
 CellID->67673483],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "1.`", ",", "0.9899684631342734`", ",", "0.9802523842946214`", ",", 
   "0.9728680190510512`", ",", "0.9643232035960483`", ",", 
   "0.9551309291472332`", ",", "0.9458604147150803`", ",", 
   "0.9359000659589217`", ",", "0.9255778939752659`", ",", 
   "0.8839657280224873`", ",", "0.8426484087480286`", ",", 
   "0.8021385161677559`", ",", "0.7633993633767812`", ",", 
   "0.7263131852008519`", ",", "0.690959565667771`", ",", 
   "0.657261070003417`", ",", "0.6252917198994513`", ",", 
   "0.48684428083783327`", ",", "0.37905084337694434`", ",", 
   "0.3102725700528474`", ",", "0.26703212716232916`"}], "}"}]], "Output",
 CellChangeTimes->{3.519370812421875*^9, 3.519371014765625*^9, 
  3.519371613921875*^9, 3.51937166653125*^9, 3.5193730215625*^9, 
  3.519373276921875*^9, 3.519373819234375*^9, 3.51937436859375*^9, 
  3.519375300828125*^9, 3.519376294203125*^9, 3.519376711453125*^9, 
  3.519377898203125*^9, 3.51938151546875*^9, 3.519381879625*^9, 
  3.52136238971875*^9, 3.528705790265625*^9},
 CellID->745426]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"YieldTSZeroRate", "[", 
   RowBox[{"yieldcurve", ",", 
    RowBox[{"InterpolatedYieldCurveDates", "[", "yieldcurve", "]"}]}], "]"}], 
  " "}]], "Input",
 CellChangeTimes->{{3.519370830484375*^9, 3.519370846421875*^9}, 
   3.51937102825*^9, {3.519371646015625*^9, 3.519371648671875*^9}, {
   3.519371761328125*^9, 3.51937176178125*^9}, {3.519372059234375*^9, 
   3.51937206296875*^9}, {3.51937212159375*^9, 3.519372126359375*^9}, 
   3.51937329084375*^9},
 CellID->3120534],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "0.039999999999273825`", ",", "0.04000000000000011`", ",", 
   "0.039999999999999786`", ",", "0.036642335766423256`", ",", 
   "0.03622950819672139`", ",", "0.0365851528384279`", ",", 
   "0.03714076782449724`", ",", "0.03784037558685443`", ",", 
   "0.038615595075239435`", ",", "0.041074817518248166`", ",", 
   "0.04280136986301371`", ",", "0.04404652435686918`", ",", 
   "0.0449546076642336`", ",", "0.0456462651544779`", ",", 
   "0.0461776180698152`", ",", "0.046602068755704294`", ",", 
   "0.04694083812654068`", ",", "0.04796111719605696`", ",", 
   "0.048471047227926084`", ",", "0.046776281208935615`", ",", 
   "0.043980744661434576`"}], "}"}]], "Output",
 CellChangeTimes->{
  3.519370847140625*^9, 3.5193710299375*^9, 3.51937161396875*^9, 
   3.519371649453125*^9, 3.519371763015625*^9, {3.519372054484375*^9, 
   3.51937206365625*^9}, 3.519373021609375*^9, 3.519373292125*^9, 
   3.519373819296875*^9, 3.519374368625*^9, 3.519375300890625*^9, 
   3.51937629421875*^9, 3.519376711515625*^9, 3.51937789825*^9, 
   3.519381517828125*^9, 3.519381879671875*^9, 3.521362389796875*^9, 
   3.528705790328125*^9},
 CellID->324975300]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"YieldTSForwardRate", "[", 
  RowBox[{"yieldcurve", ",", "first", " ", ",", "allDates"}], "]"}]], "Input",
 CellChangeTimes->{{3.519369632765625*^9, 3.51936964315625*^9}, 
   3.51936967409375*^9, {3.519369825078125*^9, 3.5193698279375*^9}},
 CellID->391997264],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "0.039999999999273825`", ",", "0.04000000000000011`", ",", 
   "0.039999999999999786`", ",", "0.036642335766423256`", ",", 
   "0.03622950819672139`", ",", "0.0365851528384279`", ",", 
   "0.03714076782449724`", ",", "0.03784037558685443`", ",", 
   "0.038615595075239435`", ",", "0.041074817518248166`", ",", 
   "0.04280136986301371`", ",", "0.04404652435686918`", ",", 
   "0.0449546076642336`", ",", "0.0456462651544779`", ",", 
   "0.0461776180698152`", ",", "0.046602068755704294`", ",", 
   "0.04694083812654068`", ",", "0.04796111719605696`", ",", 
   "0.048471047227926084`", ",", "0.046776281208935615`", ",", 
   "0.043980744661434576`"}], "}"}]], "Output",
 CellChangeTimes->{3.519369602484375*^9, 3.51936964409375*^9, 
  3.51936982859375*^9, 3.5193716140625*^9, 3.51937302303125*^9, 
  3.519373819359375*^9, 3.519374368640625*^9, 3.51937530096875*^9, 
  3.51937629425*^9, 3.5193767115625*^9, 3.519377898296875*^9, 
  3.519381519296875*^9, 3.51938187971875*^9, 3.52136238984375*^9, 
  3.528705790390625*^9},
 CellID->14682370]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ListPlot", "[", 
  RowBox[{
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"YieldTSZeroRate", "[", 
      RowBox[{"yieldcurve", ",", 
       RowBox[{"CalendarAdvance", "[", 
        RowBox[{"first", ",", 
         RowBox[{"{", 
          RowBox[{"i", ",", "\"\<Days\>\""}], "}"}]}], "]"}]}], " ", "]"}], 
     ",", 
     RowBox[{"{", 
      RowBox[{"i", ",", "365"}], "}"}]}], "]"}], ",", 
   RowBox[{"Joined", "\[Rule]", "True"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.5193815638125*^9, 3.519381600875*^9}, {
  3.519381637921875*^9, 3.5193816695*^9}},
 CellID->572867597],

Cell[BoxData[
 GraphicsBox[{{}, {}, 
   {Hue[0.67, 0.6, 0.6], LineBox[CompressedData["
1:eJxdlnlczPkfx8fNWgzJubVjtX6O2ISUo145xm6uqTTpno6pppnmnkHtZhwh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     "]]}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->True,
  AxesOrigin->{0, 0.0362},
  PlotRange->{{0., 365.}, {0.0362, 0.04000000000000588}},
  PlotRangeClipping->True,
  PlotRangePadding->{
    Scaled[0.02], 
    Scaled[0.02]}]], "Output",
 CellChangeTimes->{3.519381672890625*^9, 3.519381882828125*^9, 
  3.52136239034375*^9, 3.528705790859375*^9},
 CellID->39015684]
}, Open  ]]
}, Open  ]]
},
FileChangeProtection->None,
Editable->True,
WindowSize->{716, 820},
WindowMargins->{{102, Automatic}, {14, Automatic}},
DockedCells->FEPrivate`FrontEndResource["FEExpressions", "HelpViewerToolbar"],
PageHeaders->{{None, None, None}, {None, None, 
   Cell[
    TextData[{
      Cell[
       TextData[{"Printed from [[YOUR APPLICATION'S NAME]] documentation "}], 
       "PageHeader"], 
      Cell[
       TextData[{
         CounterBox["Page"]}], "PageNumber"]}], 
    CellMargins -> {{Inherited, -29}, {Inherited, Inherited}}]}},
PageFooters->{{None, None, None}, {
   Cell[
    TextData[{"\[Copyright] 2008 Weber & Partner. All rights reserved."}], 
    "PageFooter"], None, None}},
ShowSelection->True,
TaggingRules->{"LinkTrails" -> "", "SearchTextTranslated" -> ""},
CreateCellID->True,
ShowCellTags->False,
FrontEndVersion->"8.0 for Microsoft Windows (32-bit) (February 23, 2011)",
StyleDefinitions->Notebook[{
   Cell[
    RawData["Cell[StyleData[StyleDefinitions -> \"HelpBrowser.nb\"]]"], 
    CellChangeTimes -> {3.519474538484375*^9}]}, Visible -> False, 
  FrontEndVersion -> "8.0 for Microsoft Windows (32-bit) (February 23, 2011)",
   StyleDefinitions -> "PrivateStylesheetFormatting.nb"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[557, 20, 126, 2, 23, "Chapter",
 CellID->671663841],
Cell[686, 24, 185, 4, 31, "Input",
 CellID->39897184],
Cell[CellGroupData[{
Cell[896, 32, 125, 2, 71, "Section",
 CellID->256995324],
Cell[1024, 36, 680, 13, 72, "Input",
 CellID->10224813],
Cell[1707, 51, 532, 11, 72, "Input",
 CellID->474572391],
Cell[CellGroupData[{
Cell[2264, 66, 289, 7, 31, "Input",
 CellID->543573995],
Cell[2556, 75, 715, 13, 30, "Output",
 CellID->971922902]
}, Open  ]],
Cell[CellGroupData[{
Cell[3308, 93, 338, 7, 31, "Input",
 CellID->485057045],
Cell[3649, 102, 2665, 65, 107, "Output",
 CellID->306557217]
}, Open  ]],
Cell[6329, 170, 366, 10, 31, "Input",
 CellID->806122494],
Cell[CellGroupData[{
Cell[6720, 184, 531, 13, 31, "Input",
 CellID->290961461],
Cell[7254, 199, 4867, 110, 255, "Output",
 CellID->114020012]
}, Open  ]],
Cell[CellGroupData[{
Cell[12158, 314, 320, 7, 31, "Input",
 CellID->201071272],
Cell[12481, 323, 1307, 23, 69, "Output",
 CellID->589788355]
}, Open  ]],
Cell[CellGroupData[{
Cell[13825, 351, 339, 10, 33, "Input",
 CellID->96144827],
Cell[14167, 363, 1281, 22, 69, "Output",
 CellID->4773495]
}, Open  ]],
Cell[CellGroupData[{
Cell[15485, 390, 583, 15, 52, "Input",
 CellID->5519936],
Cell[16071, 407, 1465, 25, 69, "Output",
 CellID->408914710]
}, Open  ]],
Cell[CellGroupData[{
Cell[17573, 437, 400, 12, 33, "Input",
 CellID->158342628],
Cell[17976, 451, 1290, 23, 69, "Output",
 CellID->335797383]
}, Open  ]],
Cell[CellGroupData[{
Cell[19303, 479, 721, 13, 52, "Input",
 CellID->83685140],
Cell[20027, 494, 309, 5, 30, "Output",
 CellID->950736302]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[20385, 505, 127, 2, 71, "Section",
 CellID->269887506],
Cell[CellGroupData[{
Cell[20537, 511, 171, 3, 31, "Input",
 CellID->80407335],
Cell[20711, 516, 1947, 50, 88, "Output",
 CellID->437888635]
}, Open  ]],
Cell[CellGroupData[{
Cell[22695, 571, 217, 4, 31, "Input",
 CellID->73390169],
Cell[22915, 577, 710, 13, 50, "Output",
 CellID->71546160]
}, Open  ]],
Cell[CellGroupData[{
Cell[23662, 595, 168, 3, 31, "Input",
 CellID->213750667],
Cell[23833, 600, 330, 7, 30, "Output",
 CellID->695549501]
}, Open  ]],
Cell[CellGroupData[{
Cell[24200, 612, 168, 3, 31, "Input",
 CellID->89532938],
Cell[24371, 617, 284, 5, 30, "Output",
 CellID->480156843]
}, Open  ]],
Cell[CellGroupData[{
Cell[24692, 627, 169, 3, 31, "Input",
 CellID->44611933],
Cell[24864, 632, 282, 5, 30, "Output",
 CellID->160654066]
}, Open  ]],
Cell[CellGroupData[{
Cell[25183, 642, 174, 3, 31, "Input",
 CellID->232506578],
Cell[25360, 647, 331, 7, 30, "Output",
 CellID->144629621]
}, Open  ]],
Cell[CellGroupData[{
Cell[25728, 659, 173, 3, 31, "Input",
 CellID->241099876],
Cell[25904, 664, 374, 9, 21, "Message",
 CellID->764356107],
Cell[26281, 675, 273, 5, 30, "Output",
 CellID->78645543]
}, Open  ]],
Cell[CellGroupData[{
Cell[26591, 685, 204, 4, 31, "Input",
 CellID->670354889],
Cell[26798, 691, 870, 15, 69, "Output",
 CellID->243531119]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[27717, 712, 130, 2, 71, "Section",
 CellID->242618320],
Cell[CellGroupData[{
Cell[27872, 718, 207, 5, 31, "Input",
 CellID->435288658],
Cell[28082, 725, 359, 6, 30, "Output",
 CellID->17546676]
}, Open  ]],
Cell[CellGroupData[{
Cell[28478, 736, 210, 4, 31, "Input",
 CellID->440046200],
Cell[28691, 742, 409, 6, 30, "Output",
 CellID->84919346]
}, Open  ]],
Cell[CellGroupData[{
Cell[29137, 753, 368, 8, 31, "Input",
 CellID->67673483],
Cell[29508, 763, 1060, 19, 69, "Output",
 CellID->745426]
}, Open  ]],
Cell[CellGroupData[{
Cell[30605, 787, 507, 11, 31, "Input",
 CellID->3120534],
Cell[31115, 800, 1182, 22, 69, "Output",
 CellID->324975300]
}, Open  ]],
Cell[CellGroupData[{
Cell[32334, 827, 283, 5, 31, "Input",
 CellID->391997264],
Cell[32620, 834, 1080, 20, 69, "Output",
 CellID->14682370]
}, Open  ]],
Cell[CellGroupData[{
Cell[33737, 859, 604, 17, 52, "Input",
 CellID->572867597],
Cell[34344, 878, 4275, 77, 236, "Output",
 CellID->39015684]
}, Open  ]]
}, Open  ]]
}
]
*)

(* End of internal cache information *)
