
QuantLib::usage = "A free/open-source library for quantitative finance."



DayOfWeek::usage = 
"DayOfWeek[date_?DateQ||jul_Integer] returns the day of the week as a string."

Unprotect[CholeskyDecomposition]
Unprotect[InterestRate]



BondCurveFitting::usage="Fits a curve to a portfolio of bonds"
QLUninstall::usage = "QLUninstall[] closes the MathLink to QuantLib and terminates the external program."
GetEnumerationClass::usage="GetEnumerationClass[enumeration] returns the values for a QuantLib enumeration class.";

QLCategories = {}

FindCategory::usage ="FindCategory[s_String] seraches for the category of 's' in the QuantLib library"

MMAToQLPeriod::usage = "Converts a Mathematica time unit to a unit suitable for QuantLib"

QLClasses::usage="QLClasses for a symbol"
(* Lazy Object *)

LazyObjectUpdate::usage=""

(* Abcd *)

Abcd::usage = "functions to construct and use Abcd objects."

AbcdCalibration::usage = "AbcdCalibration[ObjecctId_Symbol,Times_List /; VectorQ[Times, NumberQ],BlackVols_List /; VectorQ[BlackVols, NumberQ]] Construct an object of class AbcdCalibration and return its id
      \nObjectId: id of object to be created\nTimes: times.\nBlackVols: Black Volatilities.\nA: the a coefficient in the abcd vol parametrization. Used as guess if the object is later calibrated. Default value = -0.06.\nB: the b coefficient in the abcd vol parametrization. Used as guess if the object is later calibrated. Default value = 0.17.\nC: the c coefficient in the abcd vol parametrization. Used as guess if the object is later calibrated. Default value = 0.54.\nD: the d coefficient in the abcd vol parametrization. Used as guess if the object is later calibrated. Default value = 0.17.\nAIsFixed: TRUE if the a coefficient must be kept fixed in later calibrations. Default value = false.\nBIsFixed: TRUE if the a coefficient must be kept fixed in later calibrations. Default value = false.\nCIsFixed: TRUE if the a coefficient must be kept fixed in later calibrations. Default value = false.\nDIsFixed: TRUE if the a coefficient must be kept fixed in later calibrations. Default value = false.\nVegaWeighted: TRUE if the interpolation is weighted using options Vega. Default value = false.\nEndCriteria: EndCriteria object ID. Default value = .\nMethod: OptimizationMethod object ID. Default value = .\nPermanent: object permanent/nonpermanent"
AbcdCalibrationA::usage = "AbcdCalibrationA[ObjecctId_Symbol] Returns the a coefficient in the abcd vol parametrization.
      \nObjectId: id of existing QuantLib::AbcdCalibration object"
AbcdCalibrationB::usage = "AbcdCalibrationB[ObjecctId_Symbol] Returns the a coefficient in the abcd vol parametrization.
      \nObjectId: id of existing QuantLib::AbcdCalibration object"
AbcdCalibrationC::usage = "AbcdCalibrationC[ObjecctId_Symbol] Returns the a coefficient in the abcd vol parametrization.
      \nObjectId: id of existing QuantLib::AbcdCalibration object"
AbcdCalibrationCompute::usage = "AbcdCalibrationCompute[ObjecctId_Symbol] compute calibration.
      \nObjectId: id of existing QuantLib::AbcdCalibration object"
AbcdCalibrationD::usage = "AbcdCalibrationD[ObjecctId_Symbol] Returns the a coefficient in the abcd vol parametrization.
      \nObjectId: id of existing QuantLib::AbcdCalibration object"
AbcdCalibrationEndCriteria::usage = "AbcdCalibrationEndCriteria[ObjecctId_Symbol] Calibrates the a, b, c, d parameters of the vol parametrization.
      \nObjectId: id of existing QuantLib::AbcdCalibration object"
AbcdCalibrationError::usage = "AbcdCalibrationError[ObjecctId_Symbol] Returns the root mean squared error between the abdc implied Black vols and a given Black vol vector.
      \nObjectId: id of existing QuantLib::AbcdCalibration object"
AbcdCalibrationK::usage = "AbcdCalibrationK[ObjecctId_Symbol,Times_List /; VectorQ[Times, NumberQ],BlackVols_List /; VectorQ[BlackVols, NumberQ]] Returns the 'k' adjustment factors needed to match Black vols.
      \nObjectId: id of existing QuantLib::AbcdCalibration object\nTimes: times.\nBlackVols: Black Volatilities."
AbcdCalibrationMaxError::usage = "AbcdCalibrationMaxError[ObjecctId_Symbol] Returs the max error between the abdc implied Black vols and a given Black vol vector.
      \nObjectId: id of existing QuantLib::AbcdCalibration object"
AbcdDFunction::usage = "AbcdDFunction[ObjecctId_Symbol] Returns the a coefficient in the abcd vol parametrization.
      \nObjectId: id of existing QuantLib::AbcdFunction object"
AbcdFunction::usage = "AbcdFunction[ObjecctId_Symbol] Construct an object of class AbcdFunction and return its id
      \nObjectId: id of object to be created\nA: the a coefficient in the abcd vol parametrization. Used as guess if the object is later calibrated. Default value = -0.06.\nB: the b coefficient in the abcd vol parametrization. Used as guess if the object is later calibrated. Default value = 0.17.\nC: the c coefficient in the abcd vol parametrization. Used as guess if the object is later calibrated. Default value = 0.54.\nD: the d coefficient in the abcd vol parametrization. Used as guess if the object is later calibrated. Default value = 0.17.\nPermanent: object permanent/nonpermanent"
AbcdFunctionA::usage = "AbcdFunctionA[ObjecctId_Symbol] Returns the a coefficient in the abcd vol parametrization.
      \nObjectId: id of existing QuantLib::AbcdFunction object"
AbcdFunctionB::usage = "AbcdFunctionB[ObjecctId_Symbol] Returns the b coefficient in the abcd vol parametrization.
      \nObjectId: id of existing QuantLib::AbcdFunction object"
AbcdFunctionC::usage = "AbcdFunctionC[ObjecctId_Symbol] Returns the c coefficient in the abcd vol parametrization.
      \nObjectId: id of existing QuantLib::AbcdFunction object"
AbcdFunctionCovariance::usage = "AbcdFunctionCovariance[ObjecctId_Symbol,TMin_?NumberQ,TMax_List /; VectorQ[TMax, NumberQ],T_?NumberQ,S_?NumberQ] Returns covariance(s) in [tMin,tMax] between T and S rate fixing times.
      \nObjectId: id of existing QuantLib::AbcdFunction object\nTMin: lower bound of the covariance integral.\nTMax: upper bound(s) of the covariance integral(s).\nT: fixing calendar time of first rate.\nS: fixing calendar time of second rate."
AbcdFunctionD::usage = "AbcdFunctionD[ObjecctId_Symbol] Returns the d coefficient in the abcd vol parametrization.
      \nObjectId: id of existing QuantLib::AbcdFunction object"
AbcdFunctionInstantaneousCovariance::usage = "AbcdFunctionInstantaneousCovariance[ObjecctId_Symbol,U_List /; VectorQ[U, NumberQ],T_?NumberQ,S_?NumberQ] Returns covariance at calendar time u between T and S rates fixing times.
      \nObjectId: id of existing QuantLib::AbcdFunction object\nU: calendar time(s).\nT: fixing time of first rate.\nS: fixing time of second rate."
AbcdFunctionInstantaneousValue::usage = "AbcdFunctionInstantaneousValue[ObjecctId_Symbol,U_List /; VectorQ[U, NumberQ]] Returns the instantaneous volatility as function of residual time to maturity u=T-t: [a + b*u] * e^{-c*u} + d.
      \nObjectId: id of existing QuantLib::AbcdFunction object\nU: residual time(s) to maturity."
AbcdFunctionInstantaneousVariance::usage = "AbcdFunctionInstantaneousVariance[ObjecctId_Symbol,U_List /; VectorQ[U, NumberQ],T_?NumberQ] Returns variance at calendar time(s) u of T-fixing rate.
      \nObjectId: id of existing QuantLib::AbcdFunction object\nU: calendar time(s).\nT: fixing time of the rate."
AbcdFunctionInstantaneousVolatility::usage = "AbcdFunctionInstantaneousVolatility[ObjecctId_Symbol,U_List /; VectorQ[U, NumberQ],T_?NumberQ] Returns volatility/ies at calendar time(s) u of T-fixing rate.
      \nObjectId: id of existing QuantLib::AbcdFunction object\nU: calendar time(s).\nT: fixing calendar time of the rate."
AbcdFunctionLongTermVolatility::usage = "AbcdFunctionLongTermVolatility[ObjecctId_Symbol] Returns the long term volatility implied by Abcd volatility.
      \nObjectId: id of existing QuantLib::AbcdFunction object"
AbcdFunctionMaximumLocation::usage = "AbcdFunctionMaximumLocation[ObjecctId_Symbol] Returns, if b is positive, the location of the Abcd volatility maximum.
      \nObjectId: id of existing QuantLib::AbcdFunction object"
AbcdFunctionMaximumVolatility::usage = "AbcdFunctionMaximumVolatility[ObjecctId_Symbol] Returns, if b is positive, the maximum of the Abcd volatility.
      \nObjectId: id of existing QuantLib::AbcdFunction object"
AbcdFunctionShortTermVolatility::usage = "AbcdFunctionShortTermVolatility[ObjecctId_Symbol] Returns the short term volatility implied by Abcd volatility.
      \nObjectId: id of existing QuantLib::AbcdFunction object"
AbcdFunctionVariance::usage = "AbcdFunctionVariance[ObjecctId_Symbol,TMin_?NumberQ,TMax_List /; VectorQ[TMax, NumberQ],T_?NumberQ] Returns variance(s) in [tMin,tMax] of T rate fixing time.
      \nObjectId: id of existing QuantLib::AbcdFunction object\nTMin: lower bound of the covariance integral.\nTMax: upper bound of the covariance integral.\nT: fixing calendar time of the rate."
AbcdFunctionVolatility::usage = "AbcdFunctionVolatility[ObjecctId_Symbol,TMin_?NumberQ,TMax_List /; VectorQ[TMax, NumberQ],T_?NumberQ] Returns volatility/ies in [tMin,tMax] of T rate fixing time.
      \nObjectId: id of existing QuantLib::AbcdFunction object\nTMin: lower bound of the covariance integral.\nTMax: upper bound(s) of the covariance integral(s).\nT: fixing calendar time of the rate."
Category[Abcd] = {AbcdCalibration,AbcdCalibrationA,AbcdCalibrationB,AbcdCalibrationC,AbcdCalibrationCompute,AbcdCalibrationD,AbcdCalibrationEndCriteria,AbcdCalibrationError,AbcdCalibrationK,AbcdCalibrationMaxError,AbcdDFunction,AbcdFunction,AbcdFunctionA,AbcdFunctionB,AbcdFunctionC,AbcdFunctionCovariance,AbcdFunctionD,AbcdFunctionInstantaneousCovariance,AbcdFunctionInstantaneousValue,AbcdFunctionInstantaneousVariance,AbcdFunctionInstantaneousVolatility,AbcdFunctionLongTermVolatility,AbcdFunctionMaximumLocation,AbcdFunctionMaximumVolatility,AbcdFunctionShortTermVolatility,AbcdFunctionVariance,AbcdFunctionVolatility};
AppendTo[QLCategories,Abcd]


(* Accounting Engines *)

AccountingEngines::usage = "functions to construct and use Accounting Engines objects."

AccountingEngine::usage = "AccountingEngine[ObjecctId_Symbol,MarketModelEvolver_Symbol,ProductId_Symbol,InitialNumeraireValue_?NumberQ] Construct an object of class AccountingEngine and return its id
      \nObjectId: id of object to be created\nMarketModelEvolver: MarketModelEvolver object ID.\nProduct: MarketModelMultiProduct object ID.\nInitialNumeraireValue: initial numeraire value.\nPermanent: object permanent/nonpermanent"
AccountingEngineMultiplePathValues::usage = "AccountingEngineMultiplePathValues[ObjecctId_Symbol,SequenceStatsId_Symbol,Paths_Integer] return multiple path values.
      \nObjectId: id of existing QuantLib::AccountingEngine object\nSequenceStats: Sequence Statistics object ID.\nPaths: number of paths."
Category[AccountingEngines] = {AccountingEngine,AccountingEngineMultiplePathValues};
AppendTo[QLCategories,AccountingEngines]


(* AlphaForm *)

AlphaForm::usage = "functions to construct and use AlphaForm objects."

AlphaFormInverseLinear::usage = "AlphaFormInverseLinear[ObjecctId_Symbol,RateTimes_List /; VectorQ[RateTimes, NumberQ],Alpha_?NumberQ] Construct an object of class AlphaFormInverseLinear and return its id
      \nObjectId: id of object to be created\nRateTimes: rate fixing times.\nAlpha: alpha coefficient.\nPermanent: object permanent/nonpermanent"
AlphaFormLinearHyperbolic::usage = "AlphaFormLinearHyperbolic[ObjecctId_Symbol,RateTimes_List /; VectorQ[RateTimes, NumberQ],Alpha_?NumberQ] Construct an object of class AlphaFormLinearHyperbolic and return its id
      \nObjectId: id of object to be created\nRateTimes: rate fixing times.\nAlpha: alpha coefficient.\nPermanent: object permanent/nonpermanent"
AlphaFormOperator::usage = "AlphaFormOperator[ObjecctId_Symbol,Time_Integer] returns the Alpha Form value at time i.
      \nObjectId: id of existing QuantLib::AlphaForm object\nTime: integer corresponding to i-th time."
AlphaFormSetAlpha::usage = "AlphaFormSetAlpha[ObjecctId_Symbol,Alpha_?NumberQ] set the Alpha parameter value to Alpha Form.
      \nObjectId: id of existing QuantLib::AlphaForm object\nAlpha: Alpha parameter value for Alpha Form."
Category[AlphaForm] = {AlphaFormInverseLinear,AlphaFormLinearHyperbolic,AlphaFormOperator,AlphaFormSetAlpha};
AppendTo[QLCategories,AlphaForm]

(* Amortizing Bonds *)
AmortizingFixedRateBond::usage = "AmortizingFixedRateBond[ScheduleID_Symbol,Notionals_List /; VectorQ[Notionals, NumberQ],Coupons_List /; VectorQ[Coupons, NumberQ],opts___?OptionQ]" 
Category[AmortizingBonds] = {AmortizingFixedRateBond};
AppendTo[QLCategories,AmortizingBonds]

(* Asset Swap *)

AssetSwap::usage = "functions to construct and use AssetSwap objects."

AssetSwap::usage = "AssetSwap[ObjecctId_Symbol,Bond_Symbol,CleanPrice_?NumberQ,IborIndex_Symbol,FloatingLegDayCounter_String] Construct an object of class AssetSwap and return its id
      \nObjectId: id of object to be created\nPayBondCoupon: TRUE to pay the bond's coupons and receive floating. Default value = false.\nBond: underlying bond object ID.\nCleanPrice: market price of the underlying bond.\nIborIndex: floating leg Index object ID.\nSpread: Floating leg spread. Default value = 0.0.\nFloatingLegSchedule: floating leg schedule object ID. Default value = .\nFloatingLegDayCounter: floating day counter (e.g. Actual/360).\nParAssetSwap: TRUE for par asset swap, FALSE for market asset swap. Default value = true.\nPermanent: object permanent/nonpermanent"
AssetSwapBondLegAnalysis::usage = "AssetSwapBondLegAnalysis[ObjecctId_Symbol] The bond leg cash flow analysis.
      \nObjectId: id of existing QuantLibAddin::AssetSwap object"
AssetSwapFairCleanPrice::usage = "AssetSwapFairCleanPrice[ObjecctId_Symbol] the fair price of the bond in the asset swap.
      \nObjectId: id of existing QuantLib::AssetSwap object"
AssetSwapFairSpread::usage = "AssetSwapFairSpread[ObjecctId_Symbol] the fair rate of the asset swap, i.e. the asset swap spread.
      \nObjectId: id of existing QuantLib::AssetSwap object"
AssetSwapFloatingLegAnalysis::usage = "AssetSwapFloatingLegAnalysis[ObjecctId_Symbol] The floating leg cash flow analysis.
      \nObjectId: id of existing QuantLibAddin::AssetSwap object"
AssetSwapFloatingLegBPS::usage = "AssetSwapFloatingLegBPS[ObjecctId_Symbol] the BPS of the floating leg.
      \nObjectId: id of existing QuantLib::AssetSwap object"
AssetSwapParSwap::usage = "AssetSwapParSwap[ObjecctId_Symbol] Returns TRUE if par swap
      \nObjectId: id of existing QuantLib::AssetSwap object"
AssetSwapPayBondCoupon::usage = "AssetSwapPayBondCoupon[ObjecctId_Symbol] Returns TRUE if it is a fixed rate payer swap
      \nObjectId: id of existing QuantLib::AssetSwap object"
Category[AssetSwap] = {AssetSwap,AssetSwapBondLegAnalysis,AssetSwapFairCleanPrice,AssetSwapFairSpread,AssetSwapFloatingLegAnalysis,AssetSwapFloatingLegBPS,AssetSwapParSwap,AssetSwapPayFixedRate};
AppendTo[QLCategories,AssetSwap]


(* Bonds *)

Bonds::usage = "functions to construct and use Bond objects."

Bond::usage = "Bond[ObjecctId_Symbol,LegIDId_Symbol] Construct an object of class Bond and return its id
      \nObjectId: id of object to be created\nDescription: bond description string. Default value = no description available.\nCurrency: bond Currency. Default value = NullCurrency.\nSettlementDays: settlement days. Default value = 3.\nCalendar: holiday calendar (e.g. TARGET). Default value = NullCalendar.\nFaceAmount: Face nominal amount. Default value = 100.0.\nMaturityDate: maturity date. Default value = Date[].\nIssueDate: issue date: the bond can't be traded until then. Default value = Date[].\nLegID: coupon vector Leg object ID.\nPermanent: object permanent/nonpermanent"
BondAccrualDays::usage = "BondAccrualDays[ObjectIdId_Symbol] Returns the total number of accrual days for the current coupon of the given bond. The current bond settlement is used if no date is given.
      \nObjectId: id of existing QuantLib::Bond object\nSettlementDate: The current bond settlement date is used if no specific date is given. Default value = Date[]."
BondAccrualEndDate::usage = "BondAccrualEndDate[ObjectIdId_Symbol] Returns the accrual end date for the current coupon of the given bond.
      \nObjectId: id of existing QuantLib::Bond object\nSettlementDate: The current bond settlement date is used if no specific date is given. Default value = Date[]."
BondAccrualPeriod::usage = "BondAccrualPeriod[ObjectIdId_Symbol] Returns the total accrual period for the current coupon of the given bond. The current bond settlement is used if no date is given.
      \nObjectId: id of existing QuantLib::Bond object\nSettlementDate: The current bond settlement date is used if no specific date is given. Default value = Date[]."
BondAccrualStartDate::usage = "BondAccrualStartDate[ObjectIdId_Symbol] Returns the accrual start date for the current coupon of the given bond.
      \nObjectId: id of existing QuantLib::Bond object\nSettlementDate: The current bond settlement date is used if no specific date is given. Default value = Date[]."
BondAccruedAmount::usage = "BondAccruedAmount[ObjectIdId_Symbol] Returns the accrued amount for the given bond. The current bond settlement is used if no date is given.
      \nObjectId: id of existing QuantLib::Bond object\nSettlementDate: The current bond settlement date is used if no specific date is given. Default value = Date[]."
BondAccruedDays::usage = "BondAccruedDays[ObjectIdId_Symbol] Returns the accrued days for the current coupon of the given bond. The current bond settlement is used if no date is given.
      \nObjectId: id of existing QuantLib::Bond object\nSettlementDate: The current bond settlement date is used if no specific date is given. Default value = Date[]."
BondAccruedPeriod::usage = "BondAccruedPeriod[ObjectIdId_Symbol] Returns the accrued period for the current coupon of the given bond. The current bond settlement is used if no date is given.
      \nObjectId: id of existing QuantLib::Bond object\nSettlementDate: The current bond settlement date is used if no specific date is given. Default value = Date[]."
BondAtmRateFromYieldTermStructure::usage = "BondAtmRateFromYieldTermStructure[ObjectIdId_Symbol,YieldCurveId_Symbol,CleanPrice_?NumberQ] Returns the ATM rate implied by the given YieldTermStructure, settlement date, and clean price.
      \nObjectId: id of existing QuantLib::Bond object\nYieldCurve: discounting YieldTermStructure object ID.\nSettlementDate: The current bond settlement date is used if no specific date is given. Default value = Date[].\nCleanPrice: clean price."
BondBpsFromYield::usage = "BondBpsFromYield[ObjectIdId_Symbol,Yield_?NumberQ] Returns the basis point sensitivity implied by the given yield and settlement date.
      \nObjectId: id of existing QuantLib::Bond object\nYield: bond yield.\nDayCounter: Yield DayCounter ID. Default value = Actual/Actual (ISDA).\nCompounding: Interest rate coumpounding rule (Simple:1+rt, Compounded:(1+r)^t, Continuous:e^{rt}). Default value = Compounded.\nFrequency: frequency (e.g. Annual, Semiannual, Every4Month, Quarterly, Bimonthly, Monthly). Default value = Annual.\nSettlementDate: The current bond settlement date is used if no specific date is given. Default value = Date[]."
BondBpsFromYieldTermStructure::usage = "BondBpsFromYieldTermStructure[ObjectIdId_Symbol,YieldCurveId_Symbol] Returns the basis point sensitivity implied by the given YieldTermStructure and settlement date.
      \nObjectId: id of existing QuantLib::Bond object\nYieldCurve: discounting YieldTermStructure object ID.\nSettlementDate: The current bond settlement date is used if no specific date is given. Default value = Date[]."
BondCalendar::usage = "BondCalendar[ObjecctId_Symbol] Returns the calendar of the bond, e.g. TARGET.
      \nObjectId: id of existing QuantLib::Bond object"
BondCleanPrice::usage = "BondCleanPrice[ObjecctId_Symbol] Returns the clean price for the given bond.
      \nObjectId: id of existing QuantLib::Bond object"
BondDirtyPrice::usage = "BondDirtyPrice[ObjecctId_Symbol] Returns the dirty price (NPV) for the given bond.
      \nObjectId: id of existing QuantLib::Bond object"
BondCleanPriceFromYield::usage = "BondCleanPriceFromYield[ObjectIdId_Symbol,Yield_?NumberQ] Returns the bond clean price implied by the given yield and settlement date.
      \nObjectId: id of existing QuantLib::Bond object\nYield: bond yield.\nDayCounter: Yield DayCounter ID. Default value = Actual/Actual (ISDA).\nCompounding: Interest rate coumpounding rule (Simple:1+rt, Compounded:(1+r)^t, Continuous:e^{rt}). Default value = Compounded.\nFrequency: frequency (e.g. Annual, Semiannual, Every4Month, Quarterly, Bimonthly, Monthly). Default value = Annual.\nSettlementDate: The current bond settlement date is used if no specific date is given. Default value = Date[]."
BondCleanPriceFromYieldTermStructure::usage = "BondCleanPriceFromYieldTermStructure[ObjectIdId_Symbol,YieldCurveId_Symbol] Returns the bond clean price implied by the given YieldTermStructure and settlement date.
      \nObjectId: id of existing QuantLib::Bond object\nYieldCurve: discounting YieldTermStructure object ID.\nSettlementDate: The current bond settlement date is used if no specific date is given. Default value = Date[]."
BondCleanPriceFromZSpread::usage = "BondCleanPriceFromZSpread[ObjectIdId_Symbol,YieldCurve_Symbol,ZSpread_?NumberQ] Returns the bond clean price implied by the given Z-Spread, discount curve, and settlement date.
      \nObjectId: id of existing QuantLib::Bond object\nYieldCurve: discounting YieldTermStructure object ID.\nZSpread: the Z-spread.\nDayCounter: Yield DayCounter ID. Default value = Actual/Actual (ISDA).\nCompounding: Interest rate coumpounding rule (Simple:1+rt, Compounded:(1+r)^t, Continuous:e^{rt}). Default value = Compounded.\nFrequency: frequency (e.g. Annual, Semiannual, Every4Month, Quarterly, Bimonthly, Monthly). Default value = Annual.\nSettlementDate: The current bond settlement date is used if no specific date is given. Default value = Date[]."
BondConvexityFromYield::usage = "BondConvexityFromYield[ObjectIdId_Symbol,Yield_?NumberQ] Returns the convexity implied by the given yield and settlement date.
      \nObjectId: id of existing QuantLib::Bond object\nYield: bond yield.\nDayCounter: Yield DayCounter ID. Default value = Actual/Actual (ISDA).\nCompounding: Interest rate coumpounding rule (Simple:1+rt, Compounded:(1+r)^t, Continuous:e^{rt}). Default value = Compounded.\nFrequency: frequency (e.g. Annual, Semiannual, Every4Month, Quarterly, Bimonthly, Monthly). Default value = Annual.\nSettlementDate: The current bond settlement date is used if no specific date is given. Default value = Date[]."
BondCurrency::usage = "BondCurrency[ObjecctId_Symbol] Returns the bond currency.
      \nObjectId: id of existing QuantLibAddin::Bond object"
BondDescription::usage = "BondDescription[ObjecctId_Symbol] Returns the bond description string.
      \nObjectId: id of existing QuantLibAddin::Bond object"
BondDurationFromYield::usage = "BondDurationFromYield[ObjectIdId_Symbol,Yield_?NumberQ] Returns the duration implied by the given yield and settlement date.
      \nObjectId: id of existing QuantLib::Bond object\nYield: bond yield.\nDayCounter: Yield DayCounter ID. Default value = Actual/Actual (ISDA).\nCompounding: Interest rate coumpounding rule (Simple:1+rt, Compounded:(1+r)^t, Continuous:e^{rt}). Default value = Compounded.\nFrequency: frequency (e.g. Annual, Semiannual, Every4Month, Quarterly, Bimonthly, Monthly). Default value = Annual.\nDurationType: Duration type (Simple, Macaulay, or Modified). Default value = Modified.\nSettlementDate: The current bond settlement date is used if no specific date is given. Default value = Date[]."
BondFlowAnalysis::usage = "BondFlowAnalysis[ObjecctId_Symbol] Returns the bond cash flow analysis.
      \nObjectId: id of existing QuantLibAddin::Bond object"
BondIsTradable::usage = "BondIsTradable[ObjecctId_Symbol] Returns TRUE if the given Bond is tradable at the given settlement date. The current bond settlement is used if no date is given.
      \nObjectId: id of existing QuantLib::Bond object\nSettlementDate: The current bond settlement date is used if no specific date is given. Default value = Date[]."
BondIssueDate::usage = "BondIssueDate[ObjecctId_Symbol] Returns the issue date of the bond.
      \nObjectId: id of existing QuantLib::Bond object"
BondMaturityDate::usage = "BondMaturityDate[ObjecctId_Symbol] Returns the maturity date of the bond.
      \nObjectId: id of existing QuantLib::Bond object"
BondNextCashFlowAmount::usage = "BondNextCashFlowAmount[ObjectIdId_Symbol] Returns the next cash flow date.
      \nObjectId: id of existing QuantLib::Bond object\nSettlementDate: The current bond settlement date is used if no specific date is given. Default value = Date[]."
BondNextCashFlowDate::usage = "BondNextCashFlowDate[ObjectIdId_Symbol] Returns the next cash flow amount.
      \nObjectId: id of existing QuantLib::Bond object\nSettlementDate: The current bond settlement date is used if no specific date is given. Default value = Date[]."
BondNextCouponRate::usage = "BondNextCouponRate[ObjectIdId_Symbol] Returns the next coupon rate. Depending on (the Bond and) the given date it can be historic, deterministic or expected in a stochastic sense. When the bond settlement date is used the coupon is the already-fixed not-yet-paid one.
      \nObjectId: id of existing QuantLib::Bond object\nSettlementDate: The current bond settlement date is used if no specific date is given. Default value = Date[]."
BondNotional::usage = "BondNotional[ObjecctId_Symbol] Returns the notional of the bond at a given date.
      \nObjectId: id of existing QuantLib::Bond object\nSettlementDate: The current bond settlement date is used if no specific date is given. Default value = Date[]."
BondNotionals::usage = "BondNotionals[ObjecctId_Symbol] Returns the notionals of the bond.
      \nObjectId: id of existing QuantLib::Bond object"
BondPreviousCashFlowAmount::usage = "BondPreviousCashFlowAmount[ObjectIdId_Symbol] Returns the previous cash flow amount.
      \nObjectId: id of existing QuantLib::Bond object\nSettlementDate: The current bond settlement date is used if no specific date is given. Default value = Date[]."
BondPreviousCashFlowDate::usage = "BondPreviousCashFlowDate[ObjectIdId_Symbol] Returns the previous cash flow date.
      \nObjectId: id of existing QuantLib::Bond object\nSettlementDate: The current bond settlement date is used if no specific date is given. Default value = Date[]."
BondPreviousCouponRate::usage = "BondPreviousCouponRate[ObjectIdId_Symbol] Returns the previous coupon rate. Depending on (the Bond and) the given date it can be historic, deterministic or expected in a stochastic sense. When the bond settlement date is used the coupon is the last paid one.
      \nObjectId: id of existing QuantLib::Bond object\nSettlementDate: The current bond settlement date is used if no specific date is given. Default value = Date[]."
BondRedemptionAmount::usage = "BondRedemptionAmount[ObjecctId_Symbol] Returns the redemption amount of the bond.
      \nObjectId: id of existing QuantLibAddin::Bond object"
BondRedemptionDate::usage = "BondRedemptionDate[ObjecctId_Symbol] Returns the redemption payment date of the bond.
      \nObjectId: id of existing QuantLibAddin::Bond object"
BondReferencePeriodEnd::usage = "BondReferencePeriodEnd[ObjectIdId_Symbol] Returns the reference period end date for the current coupon of the given bond.
      \nObjectId: id of existing QuantLib::Bond object\nSettlementDate: The current bond settlement date is used if no specific date is given. Default value = Date[]."
BondReferencePeriodStart::usage = "BondReferencePeriodStart[ObjectIdId_Symbol] Returns the reference period start date for the current coupon of the given bond.
      \nObjectId: id of existing QuantLib::Bond object\nSettlementDate: The current bond settlement date is used if no specific date is given. Default value = Date[]."
BondSetCouponPricer::usage = "BondSetCouponPricer[ObjecctId_Symbol,FloatingRateCouponPricer_Symbol] Set the coupon pricer at the given Bond object.
      \nObjectId: id of existing QuantLibAddin::Bond object\nFloatingRateCouponPricer: FloatingRate coupon pricer object ID."
BondSetCouponPricers::usage = "BondSetCouponPricers[ObjecctId_Symbol,FloatingRateCouponPricer_List] Set the coupon pricer at the given Bond object.
      \nObjectId: id of existing QuantLibAddin::Bond object\nFloatingRateCouponPricer: FloatingRate coupon pricer object ID."
BondSettlementDate::usage = "BondSettlementDate[ObjecctId_Symbol] Returns the settlement date of the bond.
      \nObjectId: id of existing QuantLib::Bond object\nEvaluationDate: The current global Settings::EvaluationDate is used if no specific date is given. Default value = Date[]."
BondSettlementDays::usage = "BondSettlementDays[ObjecctId_Symbol] Returns the number of settlement days of the bond.
      \nObjectId: id of existing QuantLib::Bond object"
BondStartDate::usage = "BondStartDate[ObjectIdId_Symbol] Returns the start (i.e. first accrual) date for the given Bond object.
      \nObjectId: id of existing QuantLib::Bond object"
BondYieldFromCleanPrice::usage = "BondYieldFromCleanPrice[ObjectIdId_Symbol,CleanPrice_?NumberQ] Returns the yield for the given bond corresponding to the given clean price and settlement date.
      \nObjectId: id of existing QuantLib::Bond object\nCleanPrice: clean price.\nDayCounter: Yield DayCounter ID. Default value = Actual/Actual (ISDA).\nCompounding: Interest rate coumpounding rule (Simple:1+rt, Compounded:(1+r)^t, Continuous:e^{rt}). Default value = Compounded.\nFrequency: frequency (e.g. Annual, Semiannual, Every4Month, Quarterly, Bimonthly, Monthly). Default value = Annual.\nSettlementDate: The current bond settlement date is used if no specific date is given. Default value = Date[].\nAccuracy: tolerance. Default value = 1.0e-10.\nMaxIterations: max number of iterations. Default value = 100.\nGuess: guess. Default value = 0.05."
BondZSpreadFromCleanPrice::usage = "BondZSpreadFromCleanPrice[ObjectIdId_Symbol,CleanPrice_?NumberQ,YieldCurve_Symbol] Returns the z-spread for the given bond corresponding to the given clean price and settlement date.
      \nObjectId: id of existing QuantLib::Bond object\nCleanPrice: clean price.\nYieldCurve: discounting YieldTermStructure object ID.\nDayCounter: Yield DayCounter ID. Default value = Actual/Actual (ISDA).\nCompounding: Interest rate coumpounding rule (Simple:1+rt, Compounded:(1+r)^t, Continuous:e^{rt}). Default value = Compounded.\nFrequency: frequency (e.g. Annual, Semiannual, Every4Month, Quarterly, Bimonthly, Monthly). Default value = Annual.\nSettlementDate: The current bond settlement date is used if no specific date is given. Default value = Date[].\nAccuracy: tolerance. Default value = 1.0e-10.\nMaxIterations: max number of iterations. Default value = 100.\nGuess: guess. Default value = 0.0."
CmsRateBond::usage = "CmsRateBond[ObjecctId_Symbol,Currency_String,SettlementDays_Integer,ScheduleID_Symbol,DayCounter_String,Floors_List /; VectorQ[Floors, NumberQ],Gearings_List /; VectorQ[Gearings, NumberQ],SwapIndex_Symbol,Spreads_List /; VectorQ[Spreads, NumberQ],Caps_List /; VectorQ[Caps, NumberQ]] Construct an object of class CmsRateBond and return its id
      \nObjectId: id of object to be created\nDescription: bond description string. Default value = no description available.\nCurrency: bond Currency.\nSettlementDays: settlement days.\nPaymentBDC: payment business day convention. Default value = Following.\nFaceAmount: Face nominal amount. Default value = 100.0.\nScheduleID: Schedule object ID.\nFixingDays: fixing days (e.g. 2). Default value = QuantLib::Null<QuantLib::Natural>().\nIsInArrears: TRUE if the fixing is in arrears. Default value = false.\nDayCounter: Payment DayCounter ID.\nFloors: floor strikes. Default value = std::vector<QuantLib::Rate>().\nGearings: floating rate gearings. Default value = 1.0.\nSwapIndex: floating swap rate index.\nSpreads: floating rate spreads. Default value = 0.0.\nCaps: cap strikes. Default value = std::vector<QuantLib::Rate>().\nRedemption: Redemption value. Default value = 100.\nIssueDate: issue date: the bond can't be traded until then. Default value = Date[].\nPermanent: object permanent/nonpermanent"
FixedRateBond::usage = "FixedRateBond[ScheduleID_Symbol,Coupon_?NumberQ]\nFixedRateBond[ObjecctId_Symbol,ScheduleID_Symbol,Coupon_?NumberQ]\nFixedRateBond[ScheduleID_Symbol,Coupons_List]\nFixedRateBond[ObjecctId_Symbol,ScheduleID_Symbol,Coupons_List] Construct an object of class FixedRateBond and return its id
      \nObjectId: id of object to be created\nDescription: bond description string. Default value = no description available.\nCurrency: bond Currency.\nSettlementDays: settlement days.\nFaceAmount: Face nominal amount. Default value = 100.0.\nScheduleID: Schedule object ID.\nCoupons: simple annual compounding coupon rates.\nDayCounter: Payment DayCounter ID.\nPaymentBDC: payment business day convention. Default value = Following.\nRedemption: Redemption value. Default value = 100.0.\nIssueDate: issue date: the bond can't be traded until then. Default value = Date[].\nPaymentCalendar: payment holiday calendar (e.g. TARGET).\nPermanent: object permanent/nonpermanent"
FixedRateBond2::usage = "FixedRateBond2[ObjecctId_Symbol,Currency_String,SettlementDays_Integer,ScheduleID_Symbol,Coupons_List] Construct an object of class FixedRateBond and return its id
      \nObjectId: id of object to be created\nDescription: bond description string. Default value = no description available.\nCurrency: bond Currency.\nSettlementDays: settlement days.\nFaceAmount: Face nominal amount. Default value = 100.0.\nScheduleID: Schedule object ID.\nCoupons: coupon InterestRate IDs.\nPaymentBDC: payment business day convention. Default value = Following.\nRedemption: Redemption value. Default value = 100.0.\nIssueDate: issue date: the bond can't be traded until then. Default value = Date[].\nPaymentCalendar: payment holiday calendar (e.g. TARGET).\nPermanent: object permanent/nonpermanent"
FloatingRateBond::usage = "FloatingRateBond[ObjecctId_Symbol,Currency_String,SettlementDays_Integer,ScheduleID_Symbol,DayCounter_String,Floors_List /; VectorQ[Floors, NumberQ],Gearings_List /; VectorQ[Gearings, NumberQ],IborIndex_Symbol,Spreads_List /; VectorQ[Spreads, NumberQ],Caps_List /; VectorQ[Caps, NumberQ]] Construct an object of class FloatingRateBond and return its id
      \nObjectId: id of object to be created\nDescription: bond description string. Default value = no description available.\nCurrency: bond Currency.\nSettlementDays: settlement days.\nPaymentBDC: payment business day convention. Default value = Following.\nFaceAmount: Face nominal amount. Default value = 100.0.\nScheduleID: Schedule object ID.\nFixingDays: fixing days (e.g. 2). Default value = QuantLib::Null<QuantLib::Natural>().\nIsInArrears: TRUE if the fixing is in arrears. Default value = false.\nDayCounter: Payment DayCounter ID.\nFloors: floor strikes. Default value = std::vector<QuantLib::Rate>().\nGearings: floating rate gearings. Default value = 1.0.\nIborIndex: floating rate index.\nSpreads: floating rate spreads. Default value = 0.0.\nCaps: cap strikes. Default value = std::vector<QuantLib::Rate>().\nRedemption: Redemption value. Default value = 100.\nIssueDate: issue date: the bond can't be traded until then. Default value = Date[].\nPermanent: object permanent/nonpermanent"
ZeroCouponBond::usage = "ZeroCouponBond[ObjecctId_Symbol,Currency_String,SettlementDays_Integer,Maturity_?DateQ] Construct an object of class ZeroCouponBond and return its id
      \nObjectId: id of object to be created\nDescription: bond description string. Default value = no description available.\nCurrency: bond Currency.\nSettlementDays: settlement days.\nCalendar: holiday calendar (e.g. TARGET).\nFaceAmount: Face nominal amount. Default value = 100.0.\nMaturity: maturity date.\nPaymentBDC: payment business day convention. Default value = Following.\nRedemption: Redemption value. Default value = 100.\nIssueDate: issue date: the bond can't be traded until then. Default value = Date[].\nPermanent: object permanent/nonpermanent"

Category[Bonds] = {Bond,BondAccrualDays,BondAccrualEndDate,BondAccrualPeriod,BondAccrualStartDate,BondAccruedAmount,BondAccruedDays,BondAccruedPeriod,BondAtmRateFromYieldTermStructure,BondBpsFromYield,BondBpsFromYieldTermStructure,BondCalendar,BondCleanPrice,BondCleanPriceFromYield,BondCleanPriceFromYieldTermStructure,BondCleanPriceFromZSpread,BondConvexityFromYield,BondCurrency,BondDescription,BondDurationFromYield,BondFlowAnalysis,BondIsTradable,BondIssueDate,BondMaturityDate,BondNextCashFlowAmount,BondNextCashFlowDate,BondNextCouponRate,BondNotional,BondNotionals,BondPreviousCashFlowAmount,BondPreviousCashFlowDate,BondPreviousCouponRate,BondRedemptionAmount,BondRedemptionDate,BondReferencePeriodEnd,BondReferencePeriodStart,BondSetCouponPricer,BondSetCouponPricers,BondSettlementDate,BondSettlementDays,BondStartDate,BondYieldFromCleanPrice,BondZSpreadFromCleanPrice,CmsRateBond,FixedRateBond,FixedRateBond2,FloatingRateBond,ZeroCouponBond};
AppendTo[QLCategories,Bonds]

(* Forwards *)

FixedRateBondForward::usage = "FixedRateBondForward[ScheduleID_Symbol,Coupon_?NumberQ]\nFixedRateBond[ObjecctId_Symbol,ScheduleID_Symbol,Coupon_?NumberQ]\nFixedRateBond[ScheduleID_Symbol,Coupons_List]\nFixedRateBond[ObjecctId_Symbol,ScheduleID_Symbol,Coupons_List] Construct an object of class FixedRateBondForward and return its id
      \nObjectId: id of object to be created\nDescription: bond description string. Default value = no description available.\nCurrency: bond Currency.\nSettlementDays: settlement days.\nFaceAmount: Face nominal amount. Default value = 100.0.\nScheduleID: Schedule object ID.\nCoupons: simple annual compounding coupon rates.\nDayCounter: Payment DayCounter ID.\nPaymentBDC: payment business day convention. Default value = Following.\nRedemption: Redemption value. Default value = 100.0.\nIssueDate: issue date: the bond can't be traded until then. Default value = Date[].\nPaymentCalendar: payment holiday calendar (e.g. TARGET).\nPermanent: object permanent/nonpermanent"
ForwardIsExpired::usage="returns whether the instrument is still tradable."
ForwardSpotValue::usage=" returns spot value/price of an underlying financial instrument."
ForwardSpotIncome::usage="NPV of income/dividends/storage-costs etc. of underlying instrument."
ForwardForwardValue::usage="Forward value/price of underlying, discounting income/dividends."
ForwardImpliedYield::usage="Simple yield calculation based on underlying spot and forward values, taking into account underlying income.\n
            When t>0, call with:\n
            underlyingSpotValue=spotValue(t),\n
            forwardValue=strikePrice, to get current yield. For a\n
            repo, if t=0, impliedYield should reproduce the\n
            spot repo rate. For FRA's, this should reproduce the\n
            relevant zero rate at the FRA's maturityDate"
FixedRateBondForwardForwardPrice::usage="";
FixedRateBondForwardCleanForwardPrice::usage ="";
FixedRateBondForwardCleanSpotValue::usage="";
FixedRateBondForwardCleanSpotIncome::usage="";


Category[Forwards] = {FixedRateBondForward,FixedRateBondForwardForwardPrice,FixedRateBondForwardCleanForwardPrice,FixedRateBondForwardCleanSpotValue,FixedRateBondForwardCleanSpotIncome};
AppendTo[QLCategories,Forwards]
      

(* Brownian Generator *)

BrownianGenerator::usage = "functions to construct and use Brownian Generators objects."

MTBrownianGeneratorFactory::usage = "MTBrownianGeneratorFactory[ObjecctId_Symbol] Construct an object of class MTBrownianGeneratorFactory and return its id
      \nObjectId: id of object to be created\nSeed: seed for random sequence generator. Default value = 0.\nPermanent: object permanent/nonpermanent"
Category[BrownianGenerator] = {MTBrownianGeneratorFactory};
AppendTo[QLCategories,BrownianGenerator]


(* Calendar *)

Calendar::usage = "Calendar related functions."

CalendarAddHoliday::usage = "CalendarAddHoliday[ObjecctId_Symbol,Date_?DateQ] adds an holiday to the given calendar.
      \ncalendar: ID of Enumeration of class QuantLib::Calendar\nDate: date."
CalendarAdjust::usage = "CalendarAdjust[Date_List] Adjusts a non-business day to the appropriate near business day according to a given calendar with respect to the given convention.
      \nCalendar: ID of Enumeration of class QuantLib::Calendar\nDate: date to be adjusted.\nBusinessDayConvention: rolling convention. Default value = Following."
CalendarAdvance::usage = "CalendarAdvance[StartDate_?DateQ,Period_List] advances a date according to a given calendar.
      \ncalendar: ID of Enumeration of class QuantLib::Calendar\nStartDate: start date to be advanced.\nPeriod: period(s) to advance (e.g. 2D for two days , 3W for three weeks, 6M for six months, 1Y for one year).\nBusinessDayConvention: rolling convention. Default value = Following.\nEndOfMonth: flag to enforce end of month convention. Default value = false."
CalendarBusinessDaysBetween::usage = "CalendarBusinessDaysBetween[FirstDate_List,LastDate_?DateQ] Returns the number of business days between two dates.
      \ncalendar: ID of Enumeration of class QuantLib::Calendar\nFirstDate: first date of the period.\nLastDate: last date of the period.\nIncludeFirst: include the first date when counting business days. Default value = false.\nIncludeLast: include the last date when counting business days. Default value = false."
CalendarEndOfMonth::usage = "CalendarEndOfMonth[Date_List] returns the last business day in the given calendar of the month to which the given date belongs.
      \ncalendar: ID of Enumeration of class QuantLib::Calendar\nDate: date."
CalendarHolidayList::usage = "CalendarHolidayList[FromDate_?DateQ,ToDate_?DateQ] returns the holidays in a period between two dates according to a given holiday calendar.
      \nCalendar: Calendar to use for holiday determination.\nFromDate: first date of the period.\nToDate: last date of the period.\nIncludeWeekEnds: include week-end as holidays. Default value = false."
CalendarIsBusinessDay::usage = "CalendarIsBusinessDay[Date_List] Returns TRUE if the date is a business day for the given calendar.
      \ncalendar: ID of Enumeration of class QuantLib::Calendar\nDate: date."
CalendarIsEndOfMonth::usage = "CalendarIsEndOfMonth[Date_List] returns TRUE if the date is last business day for the month in the given calendar.
      \ncalendar: ID of Enumeration of class QuantLib::Calendar\nDate: date."
CalendarIsHoliday::usage = "CalendarIsHoliday[Date_List] returns TRUE if the date is a holiday for the given calendar.
      \ncalendar: ID of Enumeration of class QuantLib::Calendar\nDate: date."
CalendarName::usage = "CalendarName[ObjecctId_Symbol] Returns the name of the given calendar.
      \ncalendar: ID of Enumeration of class QuantLib::Calendar"
CalendarRemoveHoliday::usage = "CalendarRemoveHoliday[ObjecctId_Symbol,Date_?DateQ] removes an holiday from the given calendar.
      \ncalendar: ID of Enumeration of class QuantLib::Calendar\nDate: date."
Category[Calendar] = {CalendarAddHoliday,CalendarAdjust,CalendarAdvance,CalendarBusinessDaysBetween,CalendarEndOfMonth,CalendarHolidayList,CalendarIsBusinessDay,CalendarIsEndOfMonth,CalendarIsHoliday,CalendarName,CalendarRemoveHoliday};
AppendTo[QLCategories,Calendar]

(* Calibration Helpers *)


SwaptionHelper::usage = "SwaptionHelper[...]"
CalibrationHelperSetPricingEngine::usage = "CalibrationHelperSetPricingEngine[...]"
CalibrationHelperMarketValue::usage = "CalibrationHelperMarketValue[...]"
CalibrationHelperModelValue::usage = "CalibrationHelperModelValue[...]"
CalibrationHelperCalibrationError::usage = "CalibrationHelperCalibrationError[...]"
CalibrationHelperImpliedVolatility::usage = "CalibrationHelperImpliedVolatility[...]"
CalibrationHelperTimes::usage = "CalibrationHelperTimes[...]"
Category[CalibrationHelpers] = {SwaptionHelper,CalibrationHelperMarketValue,CalibrationHelperModelValue,CalibrationHelperCalibrationError,CalibrationHelperSetPricingEngine,CalibrationHelperTimes}
AppendTo[QLCategories,CalibrationHelpers]

(* Caps/Floors *)

CapsFloors::usage = "functions to construct and use CapFloor objects."

CapFloor::usage = "CapFloor[ObjecctId_Symbol,OptionType_String,LegID_Symbol,Strikes_List /; VectorQ[Strikes, NumberQ]] Construct an object of class CapFloor and return its id
      \nObjectId: id of object to be created\nOptionType: option type (cap or floor).\nLegID: coupon vector.\nStrikes: strikes.\nPermanent: object permanent/nonpermanent"
CapFloorAtmRate::usage = "CapFloorAtmRate[ObjecctId_Symbol,YieldCurveId_Symbol] Returns the at-the-money rate for the given CapFloor object.
      \nObjectId: id of existing QuantLib::CapFloor object\nYieldCurve: discounting YieldTermStructure object ID."
CapFloorCapRates::usage = "CapFloorCapRates[ObjecctId_Symbol] Returns the cap rates for the given CapFloor object.
      \nObjectId: id of existing QuantLib::CapFloor object"
CapFloorFloorRates::usage = "CapFloorFloorRates[ObjecctId_Symbol] Returns the floor rates for the given CapFloor object.
      \nObjectId: id of existing QuantLib::CapFloor object"
CapFloorImpliedVolatility::usage = "CapFloorImpliedVolatility[ObjecctId_Symbol,Price_?NumberQ,YieldCurve_Symbol] Returns the volatility implied by the given price for the given CapFloor object.
      \nObjectId: id of existing QuantLib::CapFloor object\nPrice: Price used to infer the implied volatility.\nYieldCurve: discounting YieldTermStructure object ID.\nGuess: Volatility guess. Default value = 0.10.\nAccuracy: solver accuracy. Default value = 1.0e-6.\nMaxIter: solver max iterations. Default value = 100."
CapFloorLegAnalysis::usage = "CapFloorLegAnalysis[ObjecctId_Symbol] Returns the cash flow analysis for the given CapFloor object.
      \nObjectId: id of existing QuantLibAddin::CapFloor object"
CapFloorMaturityDate::usage = "CapFloorMaturityDate[ObjecctId_Symbol] Returns the maturity (i.e. last payment) date for the given CapFloor object.
      \nObjectId: id of existing QuantLib::CapFloor object"
CapFloorStartDate::usage = "CapFloorStartDate[ObjecctId_Symbol] Returns the start (i.e. first accrual) date for the given CapFloor object.
      \nObjectId: id of existing QuantLib::CapFloor object"
CapFloorType::usage = "CapFloorType[ObjecctId_Symbol] Returns the type (e.g. Cap, Floor) for the given CapFloor object.
      \nObjectId: id of existing QuantLib::CapFloor object"
MakeCapFloor::usage = "MakeCapFloor[ObjecctId_Symbol,OptionType_String,Length_String,IborIndex_Symbol,ForwardStart_String,PricingEngineID_Symbol] Construct an object of class CapFloor and return its id
      \nObjectId: id of object to be created\nOptionType: option type (Cap or Floor).\nLength: as period (e.g. 10Y).\nIborIndex: floating IborIndex object ID.\nStrike: strike. Default value = 0.\nForwardStart: as period (if zero days the first caplet is removed).\nPricingEngineID: CapFloor PricingEngine object ID.\nPermanent: object permanent/nonpermanent"
Category[Caps/Floors] = {CapFloor,CapFloorAtmRate,CapFloorCapRates,CapFloorFloorRates,CapFloorImpliedVolatility,CapFloorLegAnalysis,CapFloorMaturityDate,CapFloorStartDate,CapFloorType,MakeCapFloor};
AppendTo[QLCategories,CapsFloors]

(* Caplet Volatility Term Structures *)

CapletVolatilityTermStructures::usage = "functions to construct and use OptionletVolatilityStructure objects."

CapFloorTermVTSVolatility::usage = "CapFloorTermVTSVolatility[ObjecctId_Symbol,OptionDate_?DateQ,Strike_List /; VectorQ[Strike, NumberQ]] Returns volatility from the given CapFloorTermVolatilityStructure object.
      \nObjectId: id of existing QuantLib::CapFloorTermVolatilityStructure object\nOptionDate: caplet/floorlet expiry date.\nStrike: caplet/floorlet strike.\nAllowExtrapolation: Extrapolation Flag (TRUE allows extrapolation). Default value = false."
CapFloorTermVTSVolatility2::usage = "CapFloorTermVTSVolatility2[ObjecctId_Symbol,OptionTenor_String,Strike_List /; VectorQ[Strike, NumberQ]] Returns volatility from the given CapFloorTermVolatilityStructure object.
      \nObjectId: id of existing QuantLib::CapFloorTermVolatilityStructure object\nOptionTenor: caplet/floorlet option tenor.\nStrike: caplet/floorlet strike.\nAllowExtrapolation: Extrapolation Flag (TRUE allows extrapolation). Default value = false."
ConstantOptionletVolatility::usage = "ConstantOptionletVolatility[ObjecctId_Symbol,Volatility_] Construct an object of class ConstantOptionletVolatility and return its id
      \nObjectId: id of object to be created\nNDays: number of days to advance from EvaluationDate: it fixes the date at which the variance = 0.0. Default value = 0.\nCalendar: holiday calendar (e.g. TARGET) used for calculating the exercise dates from the expiries.\nBusinessDayConvention: Business day convention used for calculating the exercise dates from the expiries.\nVolatility: cap/floor constant volatility Quote.\nDayCounter: DayCounter ID. Default value = Actual/365 (Fixed).\nPermanent: object permanent/nonpermanent"
OptionletStripper1::usage = "OptionletStripper1[ObjecctId_Symbol,TermVolSurface_Symbol,IborIndex_Symbol] Construct an object of class OptionletStripper1 and return its id
      \nObjectId: id of object to be created\nTermVolSurface: CapFloorTermVolSurface object ID.\nIborIndex: cap index object ID.\nSwitchStrike: switch strike. Default value = 0.\nAccuracy: solver accuracy. Default value = 1.0e-6.\nMaxIter: solver max iterations. Default value = 100.\nPermanent: object permanent/nonpermanent"
OptionletStripper2::usage = "OptionletStripper2[ObjecctId_Symbol,OptionletStripper1_Symbol,TermVolCurve_Symbol] Construct an object of class OptionletStripper2 and return its id
      \nObjectId: id of object to be created\nOptionletStripper1: OptionletStripper1 object id.\nTermVolCurve: CapFloorTermVolCurve object id.\nPermanent: object permanent/nonpermanent"
OptionletVTSBlackVariance::usage = "OptionletVTSBlackVariance[ObjecctId_Symbol,OptionDate_List,Strike_?NumberQ,AllowExtrapolation:(True | False)] Returns the black variance corresponding to a given strike for a given exercise date.
      \nObjectId: id of existing QuantLib::OptionletVolatilityStructure object\nOptionDate: cap/floor expiry date.\nStrike: cap/floor strike vector.\nAllowExtrapolation: Extrapolation Flag (TRUE allows extrapolation)."
OptionletVTSBlackVariance2::usage = "OptionletVTSBlackVariance2[ObjecctId_Symbol,OptionTenor_List,Strike_?NumberQ,AllowExtrapolation:(True | False)] Returns the black variance corresponding to a given strike for a given exercise date.
      \nObjectId: id of existing QuantLib::OptionletVolatilityStructure object\nOptionTenor: cap/floor expiry date.\nStrike: cap/floor strike vector.\nAllowExtrapolation: Extrapolation Flag (TRUE allows extrapolation)."
OptionletVTSVolatility::usage = "OptionletVTSVolatility[ObjecctId_Symbol,OptionDate_?DateQ,Strike_List /; VectorQ[Strike, NumberQ]] Returns volatility from the given OptionletVolatilityStructure object.
      \nObjectId: id of existing QuantLib::OptionletVolatilityStructure object\nOptionDate: caplet/floorlet expiry date.\nStrike: caplet/floorlet strike.\nAllowExtrapolation: Extrapolation Flag (TRUE allows extrapolation). Default value = false."
OptionletVTSVolatility2::usage = "OptionletVTSVolatility2[ObjecctId_Symbol,OptionTenor_String,Strike_List /; VectorQ[Strike, NumberQ]] Returns volatility from the given OptionletVolatilityStructure object.
      \nObjectId: id of existing QuantLib::OptionletVolatilityStructure object\nOptionTenor: caplet/floorlet option tenor.\nStrike: caplet/floorlet strike.\nAllowExtrapolation: Extrapolation Flag (TRUE allows extrapolation). Default value = false."
RelinkableHandleOptionletVolatilityStructure::usage = "RelinkableHandleOptionletVolatilityStructure[ObjecctId_Symbol] Construct an object of class RelinkableHandleImpl<QuantLibAddin::OptionletVolatilityStructure, QuantLib::OptionletVolatilityStructure> and return its id
      \nObjectId: id of object to be created\nCurrentLink: OptionletVolatilityStructure object ID. If omitted, nothing is linked by the RelinkableHandle. Default value = .\nPermanent: object permanent/nonpermanent"
SpreadedOptionletVolatility::usage = "SpreadedOptionletVolatility[ObjecctId_Symbol,BaseVolStructure_Symbol,Spread_] Construct an object of class SpreadedOptionletVolatility and return its id
      \nObjectId: id of object to be created\nBaseVolStructure: Base OptionletVolatilityStructure object ID.\nSpread: spread.\nPermanent: object permanent/nonpermanent"
StrippedOptionletBaseBusinessDayConvention::usage = "StrippedOptionletBaseBusinessDayConvention[ObjecctId_Symbol] Returns the business day convention used in tenor to date conversion.
      \nObjectId: id of existing QuantLib::StrippedOptionletBase object"
StrippedOptionletBaseCalendar::usage = "StrippedOptionletBaseCalendar[ObjecctId_Symbol] Returns the calendar used by the given StrippedOptionletBase object.
      \nObjectId: id of existing QuantLib::StrippedOptionletBase object"
StrippedOptionletBaseDayCounter::usage = "StrippedOptionletBaseDayCounter[ObjecctId_Symbol] Returns the DayCounter used by the given StrippedOptionletBase object.
      \nObjectId: id of existing QuantLib::StrippedOptionletBase object"
StrippedOptionletBaseSettlementDays::usage = "StrippedOptionletBaseSettlementDays[ObjecctId_Symbol] Returns the number of settlement days for the given StrippedOptionletBase object.
      \nObjectId: id of existing QuantLib::StrippedOptionletBase object"
Category[CapletVolatilityTermStructures] = {CapFloorTermVTSVolatility,CapFloorTermVTSVolatility2,ConstantOptionletVolatility,OptionletStripper1,OptionletStripper2,OptionletVTSBlackVariance,OptionletVTSBlackVariance2,OptionletVTSVolatility,OptionletVTSVolatility2,RelinkableHandleOptionletVolatilityStructure,SpreadedOptionletVolatility,StrippedOptionletBaseBusinessDayConvention,StrippedOptionletBaseCalendar,StrippedOptionletBaseDayCounter,StrippedOptionletBaseSettlementDays};
AppendTo[QLCategories,CapletVolatilityTermStructures]


(* Cms Market *)

CmsMarket::usage = "functions to construct and use CmsMarket objects."

BrowseCmsMarket::usage = "BrowseCmsMarket[ObjecctId_Symbol] return the market and implied spreads matrix.
      \nObjectId: id of existing QuantLibAddin::CmsMarket object"
CmsMarket::usage = "CmsMarket[ObjecctId_Symbol,SwapLengths_List,SwapIndexes_List,IborIndex_Symbol,BidAskSpreads_?MatrixQ,CmsCouponPricers_List,YieldCurve_Symbol] Construct an object of class CmsMarket and return its id
      \nObjectId: id of object to be created\nSwapLengths: vector of swap lengths.\nSwapIndexes: vector of SwapIndex object IDs.\nIborIndex: IborIndex object ID.\nBidAskSpreads: matrix of bid/ask cms quotes (spread over ibor leg).\nCmsCouponPricers: vector of HaganPricer object IDs.\nYieldCurve: discounting YieldTermStructure object ID.\nPermanent: object permanent/nonpermanent"
Category[CmsMarket] = {BrowseCmsMarket,CmsMarket};
AppendTo[QLCategories,CmsMarket]

(* Cms Market Calibration *)

CmsMarketCalibration::usage = "functions to construct and use CmsMarketCalibration objects."

CmsMarketCalibration::usage = "CmsMarketCalibration[ObjecctId_Symbol,VolCube_Symbol,CmsMarket_Symbol,Weights_?MatrixQ,CalibrationType_String] Construct an object of class CmsMarketCalibration and return its id
      \nObjectId: id of object to be created\nVolCube: Volatility Cube by Sabr.\nCmsMarket: CmsMarket object ID.\nWeights: weights for cms market calibration.\nCalibrationType: calibration type (e.g. OnSpread, OnPrice, OnForwardPrice).\nPermanent: object permanent/nonpermanent"
CmsMarketCalibrationCompute::usage = "CmsMarketCalibrationCompute[ObjecctId_Symbol,Guess_List /; VectorQ[Guess, NumberQ],IsMeanRevFixed:(True | False)] Return the best beta and mean reversion.
      \nObjectId: id of existing QuantLibAddin::CmsMarketCalibration object\nEndCriteria: EndCriteria object ID. Default value = .\nOptimizationMethod: OptimizationMethod object ID. Default value = .\nGuess: guess.\nIsMeanRevFixed: if TRUE mean reversion parameter is not calibrated, the guess is used."
CmsMarketCalibrationDenseSabrParameters::usage = "CmsMarketCalibrationDenseSabrParameters[ObjecctId_Symbol] returns results of Sabr calibration.
      \nObjectId: id of existing QuantLibAddin::CmsMarketCalibration object"
CmsMarketCalibrationElapsed::usage = "CmsMarketCalibrationElapsed[ObjecctId_Symbol] Returns the elapsed time of the simultaneous calibration.
      \nObjectId: id of existing QuantLibAddin::CmsMarketCalibration object"
CmsMarketCalibrationEndCriteria::usage = "CmsMarketCalibrationEndCriteria[ObjecctId_Symbol] Returns the optimization end criteria of the simultaneous calibration.
      \nObjectId: id of existing QuantLib::CmsMarketCalibration object"
CmsMarketCalibrationError::usage = "CmsMarketCalibrationError[ObjecctId_Symbol] Returns the error of the simultaneous calibration.
      \nObjectId: id of existing QuantLib::CmsMarketCalibration object"
CmsMarketCalibrationSparseSabrParameters::usage = "CmsMarketCalibrationSparseSabrParameters[ObjecctId_Symbol] returns results of Sabr calibration.
      \nObjectId: id of existing QuantLibAddin::CmsMarketCalibration object"
SimultaneousCalibrationBrowseCmsMarket::usage = "SimultaneousCalibrationBrowseCmsMarket[ObjecctId_Symbol] return the market and implied spreads matrix.
      \nObjectId: id of existing QuantLibAddin::CmsMarketCalibration object"
Category[CmsMarketCalibration] = {CmsMarketCalibration,CmsMarketCalibrationCompute,CmsMarketCalibrationDenseSabrParameters,CmsMarketCalibrationElapsed,CmsMarketCalibrationEndCriteria,CmsMarketCalibrationError,CmsMarketCalibrationSparseSabrParameters,SimultaneousCalibrationBrowseCmsMarket};
AppendTo[QLCategories,CmsMarketCalibration]


(* Correlation *)

Correlation::usage = "functions to construct and use Correlation objects."

CotSwapFromFwdCorrelation::usage = "CotSwapFromFwdCorrelation[ObjecctId_Symbol,FwdCorr_Symbol,CurveStateId_Symbol] Construct an object of class CotSwapFromFwdCorrelation and return its id
      \nObjectId: id of object to be created\nFwdCorr: Forward rates correlation (i.e. PiecewiseConstantCorrelation object ID).\nCurveState: curveState.\nDisplacement: displacement. Default value = 0.0.\nPermanent: object permanent/nonpermanent"
ExponentialCorrelations::usage = "ExponentialCorrelations[RateTimes_List /; VectorQ[RateTimes, NumberQ],Time_?NumberQ] Returns the correlation matrix (time dependent long term + beta + gamma exponential functional form).
      \nRateTimes: rate fixing times.\nLongTermCorr: Long term correlation . Default value = 0.0.\nBeta: exponential decay factor. Default value = 0.24.\nGamma: exponent for time to go. Default value = 0.333.\nTime: time t ."
ExponentialForwardCorrelation::usage = "ExponentialForwardCorrelation[ObjecctId_Symbol,RateTimes_List /; VectorQ[RateTimes, NumberQ],LongTermCorr_?NumberQ,Beta_?NumberQ,Gamma_?NumberQ,Times_List /; VectorQ[Times, NumberQ]] Construct an object of class ExponentialForwardCorrelation and return its id
      \nObjectId: id of object to be created\nRateTimes: rate times.\nLongTermCorr: Long term correlation .\nBeta: exponential decay factor.\nGamma: exponent for time to go.\nTimes: times.\nPermanent: object permanent/nonpermanent"
HistoricalForwardRatesAnalysisFailedDates::usage = "HistoricalForwardRatesAnalysisFailedDates[ObjecctId_Symbol] Returns vector of dates for which forward rates could not be calculated.
      \nObjectId: id of existing QuantLib::HistoricalForwardRatesAnalysis object"
HistoricalForwardRatesAnalysisFailedDatesErrorMessage::usage = "HistoricalForwardRatesAnalysisFailedDatesErrorMessage[ObjecctId_Symbol] Returns vector of error messages for dates on which forward rates could not be calculated.
      \nObjectId: id of existing QuantLib::HistoricalForwardRatesAnalysis object"
HistoricalForwardRatesAnalysisFixingPeriods::usage = "HistoricalForwardRatesAnalysisFixingPeriods[ObjecctId_Symbol] Returns the forward rates time grid.
      \nObjectId: id of existing QuantLib::HistoricalForwardRatesAnalysis object"
HistoricalForwardRatesAnalysisSkippedDates::usage = "HistoricalForwardRatesAnalysisSkippedDates[ObjecctId_Symbol] Returns vector of historic dates for which some fixing is missing.
      \nObjectId: id of existing QuantLib::HistoricalForwardRatesAnalysis object"
HistoricalForwardRatesAnalysisSkippedDatesErrorMessage::usage = "HistoricalForwardRatesAnalysisSkippedDatesErrorMessage[ObjecctId_Symbol] Returns vector of error messages for historic dates with missing fixing.
      \nObjectId: id of existing QuantLib::HistoricalForwardRatesAnalysis object"
HistoricalRatesAnalysisSkippedDates::usage = "HistoricalRatesAnalysisSkippedDates[ObjecctId_Symbol] Returns vector of historic dates for which some fixing is missing.
      \nObjectId: id of existing QuantLib::HistoricalRatesAnalysis object"
HistoricalRatesAnalysisSkippedDatesErrorMessage::usage = "HistoricalRatesAnalysisSkippedDatesErrorMessage[ObjecctId_Symbol] Returns vector of error messages for historic dates with missing fixing.
      \nObjectId: id of existing QuantLib::HistoricalRatesAnalysis object"
MarketModelLmLinearExponentialCorrelationModel::usage = "MarketModelLmLinearExponentialCorrelationModel[ObjecctId_Symbol,Size_Integer,Rho_?NumberQ,Beta_?NumberQ] Construct an object of class LmLinearExponentialCorrelationModel and return its id
      \nObjectId: id of object to be created\nSize: size.\nRho: rho.\nBeta: beta.\nFactors: factors. Default value = QuantLib::Null<QuantLib::Size>().\nPermanent: object permanent/nonpermanent"
PiecewiseConstantCorrelationCorrelation::usage = "PiecewiseConstantCorrelationCorrelation[ObjecctId_Symbol,TimeIndex_Integer] Returns the pseudo-root of the equivalent covariance swap rates matrix.
      \nObjectId: id of existing QuantLib::PiecewiseConstantCorrelation object\nTimeIndex: time index."
PiecewiseConstantCorrelationNumberOfRates::usage = "PiecewiseConstantCorrelationNumberOfRates[ObjecctId_Symbol] Piecewise Constant Correlation Number of Rates.
      \nObjectId: id of existing QuantLib::PiecewiseConstantCorrelation object"
PiecewiseConstantCorrelationTimes::usage = "PiecewiseConstantCorrelationTimes[ObjecctId_Symbol] Piecewise Constant Correlation Times.
      \nObjectId: id of existing QuantLib::PiecewiseConstantCorrelation object"
TimeHomogeneousForwardCorrelation::usage = "TimeHomogeneousForwardCorrelation[ObjecctId_Symbol,FwdCorrMatrix_?MatrixQ,RateTimes_List /; VectorQ[RateTimes, NumberQ]] Construct an object of class TimeHomogeneousForwardCorrelation and return its id
      \nObjectId: id of object to be created\nFwdCorrMatrix: forward correlation matrix.\nRateTimes: rate times.\nPermanent: object permanent/nonpermanent"
Category[Correlation] = {CotSwapFromFwdCorrelation,ExponentialCorrelations,ExponentialForwardCorrelation,HistoricalForwardRatesAnalysisFailedDates,HistoricalForwardRatesAnalysisFailedDatesErrorMessage,HistoricalForwardRatesAnalysisFixingPeriods,HistoricalForwardRatesAnalysisSkippedDates,HistoricalForwardRatesAnalysisSkippedDatesErrorMessage,HistoricalRatesAnalysisSkippedDates,HistoricalRatesAnalysisSkippedDatesErrorMessage,MarketModelLmLinearExponentialCorrelationModel,PiecewiseConstantCorrelationCorrelation,PiecewiseConstantCorrelationNumberOfRates,PiecewiseConstantCorrelationTimes,TimeHomogeneousForwardCorrelation};
AppendTo[QLCategories,Correlation]

(* Coupon Vectors *)

CouponVectors::usage = "functions to construct and use Leg objects."

CmsCouponPricer::usage = "CouponPricer[ObjecctId_Symbol,Volatility_Symbol,MeanReversion_] Construct an object of class CmsCouponPricer and return its id
      \nObjectId: id of object to be created\nVolatility: Swaption Volatility Structure object ID.\nCmsCouponPricerType: Cms Coupon Pricer Type (e.g ConundrumByBlack, ConundrumByNumericalIntegration, ClassicalAnaliticalFormula).\nYieldCurveModel: model of the yield curve (e.g Standard, ExactYield, ParallelShifts, NonParallelShifts).\nMeanReversion: mean reversion quote.\nPermanent: object permanent/nonpermanent"
CmsLeg::usage = "CmsLeg[ObjecctId_Symbol,Nominals_,ScheduleID_Symbol,SwapIndex_Symbol] Construct an object of class CmsLeg and return its id
      \nObjectId: id of object to be created\nPaymentBDC: payment business day convention. Default value = Following.\nNominals: Nominal amount vector.\nScheduleID: Schedule object ID.\nFixingDays: fixing days (e.g. 2). Default value = {}.\nIsInArrears: TRUE if the fixing is in arrears. Default value = false.\nDayCounter: Payment DayCounter ID.\nFloors: floor strikes. Default value = std::vector<QuantLib::Rate>().\nGearings: floating rate gearings. Default value = 1.0.\nSwapIndex: underlying SwapIndex object ID.\nSpreads: floating rate spreads. Default value = 0.0.\nCaps: cap strikes. Default value = {}.\nPermanent: object permanent/nonpermanent"
CmsZeroLeg::usage = "CmsZeroLeg[ObjecctId_Symbol,Nominals_List /; VectorQ[Nominals, NumberQ],ScheduleID_Symbol,FixingDays_List /; VectorQ[FixingDays, IntegerQ],DayCounter_String,Floors_List /; VectorQ[Floors, NumberQ],Gearings_List /; VectorQ[Gearings, NumberQ],SwapIndex_Symbol,Spreads_List /; VectorQ[Spreads, NumberQ],Caps_List /; VectorQ[Caps, NumberQ]] Construct an object of class CmsZeroLeg and return its id
      \nObjectId: id of object to be created\nPaymentBDC: payment business day convention. Default value = Following.\nNominals: Nominal amount vector.\nScheduleID: Schedule object ID.\nFixingDays: fixing days (e.g. 2). Default value = std::vector<QuantLib::Natural>().\nIsInArrears: TRUE if the fixing is in arrears. Default value = false.\nDayCounter: Payment DayCounter ID.\nFloors: floor strikes. Default value = std::vector<QuantLib::Rate>().\nGearings: floating rate gearings. Default value = 1.0.\nSwapIndex: underlying SwapIndex object ID.\nSpreads: floating rate spreads. Default value = 0.0.\nCaps: cap strikes. Default value = {}.\nPermanent: object permanent/nonpermanent"
ConundrumPricerByNumericalIntegration::usage = "ConundrumPricerByNumericalIntegration[ObjecctId_Symbol,SwaptionVol_Symbol,YieldCurveModel_String,MeanReversion_] Construct an object of class NumericHaganPricer and return its id
      \nObjectId: id of object to be created\nSwaptionVol: Volatility Cube by Sabr.\nYieldCurveModel: model of the yield curve (e.g Standard, ExactYield, ParallelShifts, NonParallelShifts).\nMeanReversion: mean reversion.\nLowerLimit: lower limit. Default value = 0.0.\nUpperLimit: upper limit. Default value = 1.0.\nPrecision: precision. Default value = 1.0e-6.\nPermanent: object permanent/nonpermanent"
ConundrumPricerByNumericalIntegrationUpperLimit::usage = "ConundrumPricerByNumericalIntegrationUpperLimit[ObjecctId_Symbol] Returns the upper limit of the integral.
      \nObjectId: id of existing QuantLib::NumericHaganPricer object"
DigitalCmsLeg::usage = "DigitalCmsLeg[ObjecctId_Symbol,Nominals_List /; VectorQ[Nominals, NumberQ],ScheduleID_Symbol,FixingDays_List /; VectorQ[FixingDays, IntegerQ],DayCounter_String,Gearings_List /; VectorQ[Gearings, NumberQ],SwapIndex_Symbol,Spreads_List /; VectorQ[Spreads, NumberQ],CallStrikes_List /; VectorQ[CallStrikes, NumberQ],CallSpecs_String,CallPayoff_List /; VectorQ[CallPayoff, NumberQ],PutStrikes_List /; VectorQ[PutStrikes, NumberQ],PutSpecs_String,PutPayoff_List /; VectorQ[PutPayoff, NumberQ],Replication_Symbol] Construct an object of class DigitalCmsLeg and return its id
      \nObjectId: id of object to be created\nPaymentBDC: payment business day convention. Default value = Following.\nNominals: nominal amount vector.\nScheduleID: schedule object ID.\nFixingDays: fixing days. Default value = std::vector<QuantLib::Natural>().\nIsInArrears: TRUE if the fixing is in arrears. Default value = false.\nDayCounter: Payment DayCounter ID.\nGearings: floating rate gearings. Default value = 1.0.\nSwapIndex: swap rate index.\nSpreads: floating rate spreads. Default value = 0.0.\nCallStrikes: option strikes. If omitted, no call is assumed. Default value = std::vector<QuantLib::Rate>().\nCallSpecs: call position (Short, Long) and ATM inclusion.\nCallPayoff: payoff if the call ends ITM. If omitted, asset-or-nothing option is assumed. Default value = std::vector<QuantLib::Rate>().\nPutStrikes: option strikes. If omitted, no put is assumed. Default value = std::vector<QuantLib::Rate>().\nPutSpecs: put position (Short, Long) and ATM inclusion.\nPutPayoff: payoff if the put ends ITM. If omitted, asset-or-nothing option is assumed. Default value = std::vector<QuantLib::Rate>().\nReplication: replication object ID.\nPermanent: object permanent/nonpermanent"
DigitalIborLeg::usage = "DigitalIborLeg[ObjecctId_Symbol,Nominals_List /; VectorQ[Nominals, NumberQ],ScheduleID_Symbol,FixingDays_List /; VectorQ[FixingDays, IntegerQ],DayCounter_String,Gearings_List /; VectorQ[Gearings, NumberQ],IborIndex_Symbol,Spreads_List /; VectorQ[Spreads, NumberQ],CallStrikes_List /; VectorQ[CallStrikes, NumberQ],CallSpecs_String,CallPayoff_List /; VectorQ[CallPayoff, NumberQ],PutStrikes_List /; VectorQ[PutStrikes, NumberQ],PutSpecs_String,PutPayoff_List /; VectorQ[PutPayoff, NumberQ],Replication_Symbol] Construct an object of class DigitalIborLeg and return its id
      \nObjectId: id of object to be created\nPaymentBDC: payment business day convention. Default value = Following.\nNominals: nominal amount vector.\nScheduleID: schedule object ID.\nFixingDays: fixing days. Default value = std::vector<QuantLib::Natural>().\nIsInArrears: TRUE if the fixing is in arrears. Default value = false.\nDayCounter: Payment DayCounter ID.\nGearings: floating rate gearings. Default value = 1.0.\nIborIndex: floating rate index.\nSpreads: floating rate spreads. Default value = 0.0.\nCallStrikes: option strikes. If omitted, no call is assumed. Default value = std::vector<QuantLib::Rate>().\nCallSpecs: call position (Short, Long) and ATM inclusion.\nCallPayoff: payoff if the call ends ITM. If omitted, asset-or-nothing option is assumed. Default value = std::vector<QuantLib::Rate>().\nPutStrikes: option strikes. If omitted, no put is assumed. Default value = std::vector<QuantLib::Rate>().\nPutSpecs: put position (Short, Long) and ATM inclusion.\nPutPayoff: payoff if the put ends ITM. If omitted, asset-or-nothing option is assumed. Default value = std::vector<QuantLib::Rate>().\nReplication: replication object ID.\nPermanent: object permanent/nonpermanent"
DigitalReplication::usage = "DigitalReplication[ObjecctId_Symbol,Replication_String] Construct an object of class DigitalReplication and return its id
      \nObjectId: id of object to be created\nReplication: Replication type (Sub, Central or Super).\nGap: spread in strikes used in call/put replication. Default value = 0.0001.\nPermanent: object permanent/nonpermanent"
FixedRateLeg::usage = "FixedRateLeg[ObjecctId_Symbol,Nominals_,ScheduleID_Symbol,Coupons_List /; VectorQ[Coupons, NumberQ],DayCounter_String] Construct an object of class FixedRateLeg and return its id
      \nObjectId: id of object to be created\nPaymentBDC: payment business day convention. Default value = Following.\nNominals: Nominal amount vector.\nScheduleID: Schedule object ID.\nCoupons: coupon fixed rates.\nDayCounter: Payment DayCounter ID.\nPermanent: object permanent/nonpermanent"
FixedRateLeg2::usage = "FixedRateLeg2[ObjecctId_Symbol,Nominals_List /; VectorQ[Nominals, NumberQ],ScheduleID_Symbol,Coupons_List] Construct an object of class FixedRateLeg and return its id
      \nObjectId: id of object to be created\nPaymentBDC: payment business day convention. Default value = Following.\nNominals: Nominal amount vector.\nScheduleID: Schedule object ID.\nCoupons: coupon InterestRate IDs.\nPermanent: object permanent/nonpermanent"
IborCouponPricer::usage = "IborCouponPricer[ObjecctId_Symbol,Volatility_Symbol,IborCouponPricerType_String] Construct an object of class IborCouponPricer and return its id
      \nObjectId: id of object to be created\nVolatility: Caplet Volatility Structure object ID.\nIborCouponPricerType: Ibor Coupon Pricer Type (e.g IborByBlack, ..).\nPermanent: object permanent/nonpermanent"
IborLeg::usage = "IborLeg[ObjecctId_Symbol,Nominals_List /; VectorQ[Nominals, NumberQ],ScheduleID_Symbol,FixingDays_List /; VectorQ[FixingDays, IntegerQ],DayCounter_String,Floors_List /; VectorQ[Floors, NumberQ],Gearings_List /; VectorQ[Gearings, NumberQ],IborIndex_Symbol,Spreads_List /; VectorQ[Spreads, NumberQ],Caps_List /; VectorQ[Caps, NumberQ]] Construct an object of class IborLeg and return its id
      \nObjectId: id of object to be created\nPaymentBDC: payment business day convention. Default value = Following.\nNominals: Nominal amount vector.\nScheduleID: Schedule object ID.\nFixingDays: fixing days (e.g. 2). Default value = std::vector<QuantLib::Natural>().\nIsInArrears: TRUE if the fixing is in arrears. Default value = false.\nDayCounter: Payment DayCounter ID.\nFloors: floor strikes. Default value = {}.\nGearings: floating rate gearings. Default value = {}.\nIborIndex: floating rate index.\nSpreads: floating rate spreads. Default value = 0.0.\nCaps: cap strikes. Default value = {}.\nPermanent: object permanent/nonpermanent"
RangeAccrualLeg::usage = "RangeAccrualLeg[ObjecctId_Symbol,Nominals_List /; VectorQ[Nominals, NumberQ],ScheduleID_Symbol,FixingDays_List /; VectorQ[FixingDays, IntegerQ],DayCounter_String,LowerStrikes_List /; VectorQ[LowerStrikes, NumberQ],Gearings_List /; VectorQ[Gearings, NumberQ],IborIndex_Symbol,Spreads_List /; VectorQ[Spreads, NumberQ],UpperStrikes_List /; VectorQ[UpperStrikes, NumberQ],ObservationsTenor_String] Construct an object of class RangeAccrualLeg and return its id
      \nObjectId: id of object to be created\nPaymentBDC: payment business day convention. Default value = Following.\nNominals: Nominal amount vector.\nScheduleID: Schedule object ID.\nFixingDays: fixing days (e.g. 2). Default value = std::vector<QuantLib::Natural>().\nDayCounter: Payment DayCounter ID.\nLowerStrikes: lower strikes. Default value = std::vector<QuantLib::Rate>().\nGearings: floating rate gearings. Default value = 1.0.\nIborIndex: underlying IborIndex object ID.\nSpreads: floating rate spreads. Default value = 0.0.\nUpperStrikes: upper strikes. Default value = std::vector<QuantLib::Rate>().\nObservationsTenor: observations tenor period.\nObservationsBDC: observations business day convention. Default value = Modified Following.\nPermanent: object permanent/nonpermanent"
Category[CouponVectors] = {CmsCouponPricer,CmsLeg,CmsZeroLeg,ConundrumPricerByNumericalIntegration,ConundrumPricerByNumericalIntegrationUpperLimit,DigitalCmsLeg,DigitalIborLeg,DigitalReplication,FixedRateLeg,FixedRateLeg2,IborCouponPricer,IborLeg,RangeAccrualLeg};
AppendTo[QLCategories,CouponVectors]

(* QuantLib Credit *)

Credit::usage = "QuantLib Credit"

CreditDefaultSwap::usage = "CreditDefaultSwap[ObjecctId_Symbol,Notional_?NumberQ,Spread_?NumberQ,PremiumSchedule_Symbol] Construct an object of class CreditDefaultSwap and return its id
      \nObjectId: id of object to be created\nBuyerSeller: BUYER for bought, SELLER for sold protection. Default value = Buyer.\nNotional: Nominal amount\nUpfront: upfront in fractional units\nSpread: running spread in fractional units\nPremiumSchedule: premium leg Schedule object ID.\nPaymentConvention: Payment dates' business day convention. Default value = Following.\nDayCounter: premium leg day counter (e.g. Actual/360).\nSettlesAccrual: TRUE ensures settlement of accural. Default value = true.\nPayAtDefault: TRUE ensures payment at default time Default value = true.\nProtectionStart: protection start date. Default value = Date[].\nUpfrontDate: upfront date. Default value = Date[].\nPermanent: object permanent/nonpermanent"
CreditDefaultSwapFairSpread::usage = "CreditDefaultSwapFairSpread[ObjecctId_Symbol] returns the running spread that, given the quoted recovery rate, will make the running-only CDS have an NPV of 0.\nThis calculation does not take any upfront into account, even if one was given."
CreditDefaultSwapFairUpfront::usage = "CreditDefaultSwapFairUpfront[ObjecctId_Symbol] returns the upfront spread that, given the running spread and the quoted recovery rate, will make the instrument have an NPV of 0."
CreditDefaultSwapCouponLegNPV::usage = "CreditDefaultSwapCouponLegNPV[ObjecctId_Symbol] returns the NPV of the coupon leg."
CreditDefaultSwapDefaultLegNPV::usage = "CreditDefaultSwapDefaultLegNPV[ObjecctId_Symbol] returns the NPV of the default leg."
CreditDefaultSwapCoupons::usage = "CreditDefaultSwapCoupons[ObjecctId_Symbol] returns a detailed analysis of the coupons leg."
CreditDefaultSwapImpliedHazardRate::usage = "Implied hazard rate calculation"
CreditDefaultSwapConventionalSpread::usage = "Conventional/standard upfront-to-spread conversion."

HazardRateCurve::usage = "HazardRateCurve[ObjecctId_Symbol,CurveDates_List,CurveRates_List /; VectorQ[CurveRates, NumberQ]] Construct an object of class HazardRateCurve and return its id
      \nObjectId: id of object to be created\nCurveDates: dates of the curve.\nCurveRates: hazard rates for the above dates.\nDayCounter: DayCounter ID. Default value = Actual/365 (Fixed).\nPermanent: object permanent/nonpermanent"
MidPointCdsEngine::usage = "MidPointCdsEngine[ObjecctId_Symbol,DefaultCurve_Symbol,RecoveryRate_?NumberQ,YieldCurve_Symbol] Construct an object of class MidPointCdsEngine and return its id
      \nObjectId: id of object to be created\nDefaultCurve: default term structure object ID.\nRecoveryRate: constant recovery rate\nYieldCurve: discounting yield term structure object ID.\nPermanent: object permanent/nonpermanent"
PiecewiseFlatForwardCurve::usage = "PiecewiseFlatForwardCurve[ObjecctId_Symbol,RateHelpers_List] Construct an object of class PiecewiseFlatForwardCurve and return its id
      \nObjectId: id of object to be created\nReferenceDate: term structure reference date. Default value = Date[].\nRateHelpers: vector of rate-helpers.\nDayCounter: DayCounter ID. Default value = Actual/365 (Fixed).\nAccuracy: Bootstrapping accuracy. Default value = 1.0e-12.\nPermanent: object permanent/nonpermanent"
PiecewiseFlatHazardRateCurve::usage = "PiecewiseFlatHazardRateCurve[ObjecctId_Symbol,Helpers_List] Construct an object of class PiecewiseFlatHazardRateCurve and return its id
      \nObjectId: id of object to be created\nReferenceDate: term structure reference date. Default value = Date[].\nHelpers: vector of default probability helpers.\nDayCounter: DayCounter ID. Default value = Actual/365 (Fixed).\nAccuracy: Bootstrapping accuracy. Default value = 1.0e-12.\nPermanent: object permanent/nonpermanent"
SpreadCdsHelper::usage = "SpreadCdsHelper[ObjecctId_Symbol,RunningSpread_,Tenor_String,Frequency_String,PaymentConvention_String,GenRule_String,DayCounter_String,RecoveryRate_?NumberQ,DiscountingCurve_Symbol] Construct an object of class SpreadCdsHelper and return its id
      \nObjectId: id of object to be created\nRunningSpread: quote.\nTenor: CDS length (e.g. 5Y for five years).\nSettlementDays: settlement days Default value = 0.\nCalendar: holiday calendar (e.g. TARGET).\nFrequency: payment frequency (e.g. Annual, Semiannual, Every4Month, Quarterly, Bimonthly, Monthly).\nPaymentConvention: payment leg convention (e.g. Unadjusted).\nGenRule: Date generation rule (Backward, Forward, ThirdWednesday, Twentieth, TwentiethIMM, Zero).\nDayCounter: day counter (e.g. Actual/360).\nRecoveryRate: recovery rate\nDiscountingCurve: discounting YieldTermStructure object ID.\nSettleAccrual: TRUE ensures settlement of accural. Default value = true.\nPayAtDefault: TRUE ensures payment at default time Default value = true.\nPermanent: object permanent/nonpermanent"
UpfrontCdsHelper::usage = "UpfrontCdsHelper[ObjecctId_Symbol,UpfrontSpread_,RunningSpread_?NumberQ,Tenor_String,Frequency_String,PaymentConvention_String,GenRule_String,DayCounter_String,RecoveryRate_?NumberQ,DiscountingCurve_Symbol,UpfrontSettlementDays_Integer] Construct an object of class UpfrontCdsHelper and return its id
      \nObjectId: id of object to be created\nUpfrontSpread: upfront spread quote.\nRunningSpread: running spread.\nTenor: CDS length (e.g. 5Y for five years).\nSettlementDays: settlement days Default value = 0.\nCalendar: holiday calendar (e.g. TARGET).\nFrequency: payment frequency (e.g. Annual, Semiannual, Every4Month, Quarterly, Bimonthly, Monthly).\nPaymentConvention: payment leg convention (e.g. Unadjusted).\nGenRule: Date generation rule (Backward, Forward, ThirdWednesday, Twentieth, TwentiethIMM, Zero).\nDayCounter: day counter (e.g. Actual/360).\nRecoveryRate: recovery rate\nDiscountingCurve: discounting YieldTermStructure object ID.\nUpfrontSettlementDays: upfront settlement days\nSettleAccrual: TRUE ensures settlement of accural. Default value = true.\nPayAtDefault: TRUE ensures payment at default time Default value = true.\nPermanent: object permanent/nonpermanent"
Category[Credit] = {CreditDefaultSwap,CreditDefaultSwapFairSpread,CreditDefaultSwapFairUpfront,CreditDefaultSwapCouponLegNPV,CreditDefaultSwapDefaultLegNPV,
                    CreditDefaultSwapImpliedHazardRate,CreditDefaultSwapConventionalSpread,
                    HazardRateCurve,MidPointCdsEngine,PiecewiseFlatHazardRateCurve,SpreadCdsHelper,UpfrontCdsHelper};
AppendTo[QLCategories,Credit]

(* Piecewise Yield Curves *)

PiecewiseDefaultCurves::usage = "functions to construct and use PiecewiseDefaultCurve objects."

PiecewiseDefaultCurve::usage = "PiecewiseDefaultCurve[ObjecctId_Symbol,RateHelpers_List] Construct an object of class PiecewiseDefaultCurve and return its id
      \nObjectId: id of object to be created\nNDays: number of days to advance from EvaluationDate (usually zero or two). Default value = 0.\nCalendar: holiday calendar (e.g. TARGET) to advance from global EvaluationDate.\nRateHelpers: vector of rate-helpers.\nDayCounter: DayCounter ID. Default value = Actual/365 (Fixed).\nAccuracy: Bootstrapping accuracy. Default value = 1.0e-12.\nTraitsID: SurvivalPorperty, HazardRate, or DefaultDensity. Default value = HazardRate.\nInterpolatorID: BackwardFlat, ForwardFlat, Linear, LogLinear, CubicSpline, or LogCubic. Default value = LogLinear.\nPermanent: object permanent/nonpermanent"
PiecewiseDefaultCurveData::usage = "PiecewiseDefaultCurveData[ObjecctId_Symbol] Retrieve Data for the given PiecewiseDefaultCurve<Traits, Interpolator>.
      \nObjectId: id of existing QuantLibAddin::PiecewiseDefaultCurve object"
PiecewiseDefaultCurveDates::usage = "PiecewiseDefaultCurveDates[ObjecctId_Symbol] Retrieve list of Dates for the given PiecewiseDefaultCurve<Traits, Interpolator>.
      \nObjectId: id of existing QuantLibAddin::PiecewiseDefaultCurve object"
PiecewiseDefaultCurveJumpDates::usage = "PiecewiseDefaultCurveJumpDates[ObjecctId_Symbol] Retrieve list of jump dates for the given PiecewiseDefaultCurve<Traits, Interpolator>.
      \nObjectId: id of existing QuantLibAddin::PiecewiseDefaultCurve object"
PiecewiseDefaultCurveJumpTimes::usage = "PiecewiseDefaultCurveJumpTimes[ObjecctId_Symbol] Retrieve list of jump times for the given PiecewiseDefaultCurve<Traits, Interpolator>.
      \nObjectId: id of existing QuantLibAddin::PiecewiseDefaultCurve object"
PiecewiseDefaultCurveTimes::usage = "PiecewiseDefaultCurveTimes[ObjecctId_Symbol] Retrieve list of Times for the given PiecewiseDefaultCurve<Traits, Interpolator>.
      \nObjectId: id of existing QuantLibAddin::PiecewiseDefaultCurve object"
Category[PiecewiseDefaultCurves] = {PiecewiseDefaultCurve,PiecewiseDefaultCurveData,PiecewiseDefaultCurveDates,PiecewiseDefaultCurveJumpDates,PiecewiseDefaultCurveJumpTimes,PiecewiseDefaultCurveTimes};
AppendTo[QLCategories,PiecewiseDefaultCurves]


(* Ctsmmcapletcalibration *)

Ctsmmcapletcalibration::usage = "functions to construct and use ctsmmcapletcalibration objects."

CTSMMCapletAlphaFormCalibration::usage = "CTSMMCapletAlphaFormCalibration[ObjecctId_Symbol,EvolutionId_Symbol,Correlations_Symbol,SwapPiecewiseConstantVariances_List,CapletVols_List /; VectorQ[CapletVols, NumberQ],CurveState_Symbol,AlphaInitial_List /; VectorQ[AlphaInitial, NumberQ],AlphaMax_List /; VectorQ[AlphaMax, NumberQ],AlphaMin_List /; VectorQ[AlphaMin, NumberQ]] Construct an object of class CTSMMCapletAlphaFormCalibration and return its id
      \nObjectId: id of object to be created\nEvolution: Evolution Description.\nCorrelations: PiecewiseConstantCorrelation object ID.\nSwapPiecewiseConstantVariances: PiecewiseConstantVariance IDs.\nCapletVols: caplet volatilities.\nCurveState: CurveState object ID.\nDisplacement: displacement. Default value = 0.0.\nAlphaInitial: alphaInitial.\nAlphaMax: alphaMax. Default value = 1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0.\nAlphaMin: alphaMin. Default value = -1.0,-1.0,-1.0,-1.0,-1.0,-1.0,-1.0,-1.0,-1.0,-1.0.\nMaximizeHomogeneity: TRUE for maximizing homogeneity. Default value = true.\nAlphaForm: alpha form ID. Default value = .\nPermanent: object permanent/nonpermanent"
CTSMMCapletAlphaFormCalibrationAlpha::usage = "CTSMMCapletAlphaFormCalibrationAlpha[ObjecctId_Symbol] alpha.
      \nObjectId: id of existing QuantLib::CTSMMCapletAlphaFormCalibration object"
CTSMMCapletCalibrationCalibrate::usage = "CTSMMCapletCalibrationCalibrate[ObjecctId_Symbol,NumberOfFactors_Integer] calibrate.
      \nObjectId: id of existing QuantLib::CTSMMCapletCalibration object\nNumberOfFactors: number of factors.\nMaxIter: maximum number of iterations. Default value = 2.\nTol: caplet vol tolerance. Default value = 0.0001.\nInnerMaxIter: innerMaxIter. Default value = 100.\nInnerTol: caplet vol tolerance. Default value = 1e-8."
CTSMMCapletCalibrationCapletMaxError::usage = "CTSMMCapletCalibrationCapletMaxError[ObjecctId_Symbol] capletMaxError.
      \nObjectId: id of existing QuantLib::CTSMMCapletCalibration object"
CTSMMCapletCalibrationCapletRmsError::usage = "CTSMMCapletCalibrationCapletRmsError[ObjecctId_Symbol] capletRmsError.
      \nObjectId: id of existing QuantLib::CTSMMCapletCalibration object"
CTSMMCapletCalibrationDeformationSize::usage = "CTSMMCapletCalibrationDeformationSize[ObjecctId_Symbol] deformationSize.
      \nObjectId: id of existing QuantLib::CTSMMCapletCalibration object"
CTSMMCapletCalibrationFailures::usage = "CTSMMCapletCalibrationFailures[ObjecctId_Symbol] failures.
      \nObjectId: id of existing QuantLib::CTSMMCapletCalibration object"
CTSMMCapletCalibrationMarketCapletVols::usage = "CTSMMCapletCalibrationMarketCapletVols[ObjecctId_Symbol] market caplet volalitilies.
      \nObjectId: id of existing QuantLib::CTSMMCapletCalibration object"
CTSMMCapletCalibrationMarketSwaptionVols::usage = "CTSMMCapletCalibrationMarketSwaptionVols[ObjecctId_Symbol] market swaption volalitilies.
      \nObjectId: id of existing QuantLib::CTSMMCapletCalibration object"
CTSMMCapletCalibrationModelCapletVols::usage = "CTSMMCapletCalibrationModelCapletVols[ObjecctId_Symbol] model caplet volalitilies.
      \nObjectId: id of existing QuantLib::CTSMMCapletCalibration object"
CTSMMCapletCalibrationModelSwaptionVols::usage = "CTSMMCapletCalibrationModelSwaptionVols[ObjecctId_Symbol] model swaption volalitilies.
      \nObjectId: id of existing QuantLib::CTSMMCapletCalibration object"
CTSMMCapletCalibrationSwapPseudoRoot::usage = "CTSMMCapletCalibrationSwapPseudoRoot[ObjecctId_Symbol,Index_Integer] swapPseudoRoot.
      \nObjectId: id of existing QuantLib::CTSMMCapletCalibration object\nIndex: index."
CTSMMCapletCalibrationSwaptionMaxError::usage = "CTSMMCapletCalibrationSwaptionMaxError[ObjecctId_Symbol] swaptionMaxError.
      \nObjectId: id of existing QuantLib::CTSMMCapletCalibration object"
CTSMMCapletCalibrationSwaptionRmsError::usage = "CTSMMCapletCalibrationSwaptionRmsError[ObjecctId_Symbol] swaptionRmsError.
      \nObjectId: id of existing QuantLib::CTSMMCapletCalibration object"
CTSMMCapletCalibrationTimeDependentCalibratedSwaptionVols::usage = "CTSMMCapletCalibrationTimeDependentCalibratedSwaptionVols[ObjecctId_Symbol,Index_Integer] timeDependentCalibratedSwaptionVols.
      \nObjectId: id of existing QuantLib::CTSMMCapletCalibration object\nIndex: index."
CTSMMCapletCalibrationTimeDependentUnCalibratedSwaptionVols::usage = "CTSMMCapletCalibrationTimeDependentUnCalibratedSwaptionVols[ObjecctId_Symbol,Index_Integer] timeDependentUnCalibratedSwaptionVols.
      \nObjectId: id of existing QuantLib::CTSMMCapletCalibration object\nIndex: index."
CTSMMCapletMaxHomogeneityCalibration::usage = "CTSMMCapletMaxHomogeneityCalibration[ObjecctId_Symbol,EvolutionId_Symbol,Correlations_Symbol,SwapPiecewiseConstantVariances_List,CapletVols_List /; VectorQ[CapletVols, NumberQ],CurveState_Symbol] Construct an object of class CTSMMCapletMaxHomogeneityCalibration and return its id
      \nObjectId: id of object to be created\nEvolution: Evolution Description.\nCorrelations: PiecewiseConstantCorrelation object ID.\nSwapPiecewiseConstantVariances: PiecewiseConstantVariance IDs.\nCapletVols: caplet volatilities.\nCurveState: CurveState object ID.\nDisplacement: displacement. Default value = 0.0.\nCaplet0Swaption1Priority: caplet0Swaption1Priority. Default value = 1.0.\nPermanent: object permanent/nonpermanent"
CTSMMCapletOriginalCalibration::usage = "CTSMMCapletOriginalCalibration[ObjecctId_Symbol,EvolutionId_Symbol,Correlations_Symbol,SwapPiecewiseConstantVariances_List,CapletVols_List /; VectorQ[CapletVols, NumberQ],CurveState_Symbol,Alphas_List /; VectorQ[Alphas, NumberQ],UseFullApprox:(True | False)] Construct an object of class CTSMMCapletOriginalCalibration and return its id
      \nObjectId: id of object to be created\nEvolution: Evolution Description.\nCorrelations: PiecewiseConstantCorrelation object ID.\nSwapPiecewiseConstantVariances: PiecewiseConstantVariance IDs.\nCapletVols: caplet volatilities.\nCurveState: CurveState object ID.\nDisplacement: displacement. Default value = 0.0.\nAlphas: alphas.\nLowestRoot: TRUE for lowest root, FALSE for the root nearest to 1.0. Default value = true.\nUseFullApprox: TRUE for using Full Approximation.\nPermanent: object permanent/nonpermanent"
Category[Ctsmmcapletcalibration] = {CTSMMCapletAlphaFormCalibration,CTSMMCapletAlphaFormCalibrationAlpha,CTSMMCapletCalibrationCalibrate,CTSMMCapletCalibrationCapletMaxError,CTSMMCapletCalibrationCapletRmsError,CTSMMCapletCalibrationDeformationSize,CTSMMCapletCalibrationFailures,CTSMMCapletCalibrationMarketCapletVols,CTSMMCapletCalibrationMarketSwaptionVols,CTSMMCapletCalibrationModelCapletVols,CTSMMCapletCalibrationModelSwaptionVols,CTSMMCapletCalibrationSwapPseudoRoot,CTSMMCapletCalibrationSwaptionMaxError,CTSMMCapletCalibrationSwaptionRmsError,CTSMMCapletCalibrationTimeDependentCalibratedSwaptionVols,CTSMMCapletCalibrationTimeDependentUnCalibratedSwaptionVols,CTSMMCapletMaxHomogeneityCalibration,CTSMMCapletOriginalCalibration};
AppendTo[QLCategories,Ctsmmcapletcalibration]


(* CurveState *)

CurveState::usage = "functions to construct and use CurveState objects."

CMSwapCurveState::usage = "CMSwapCurveState[ObjecctId_Symbol,RateTimes_List /; VectorQ[RateTimes, NumberQ],SpanningForwards_Integer] Construct an object of class CMSwapCurveState and return its id
      \nObjectId: id of object to be created\nRateTimes: rate fixing times.\nSpanningForwards: number of forwards underlying the CMS.\nPermanent: object permanent/nonpermanent"
CMSwapCurveStateSetOnCMSwapRates::usage = "CMSwapCurveStateSetOnCMSwapRates[ObjecctId_Symbol,CMSwapRates_List /; VectorQ[CMSwapRates, NumberQ]] set the CurveState object on given vector of coterminal swaps.
      \nObjectId: id of existing QuantLib::CMSwapCurveState object\nCMSwapRates: Coterminal swap rates."
ConstantMaturitySwapAnnuitiesFromDiscountRatios::usage = "ConstantMaturitySwapAnnuitiesFromDiscountRatios[SpanningForwards_Integer,FirstValidIndex_Integer,DiscountRatios_List /; VectorQ[DiscountRatios, NumberQ],Taus_List /; VectorQ[Taus, NumberQ]] Returns constant maturity swap annuities from discount ratios.
      \nSpanningForwards: number of forward rates spanned by the constant maturity swap.\nFirstValidIndex: marks the first non expired discount bond.\nDiscountRatios: vector of discount bond ratios.\nTaus: rate time intervals."
ConstantMaturitySwapRatesFromDiscountRatios::usage = "ConstantMaturitySwapRatesFromDiscountRatios[SpanningForwards_Integer,FirstValidIndex_Integer,DiscountRatios_List /; VectorQ[DiscountRatios, NumberQ],Taus_List /; VectorQ[Taus, NumberQ]] Returns constant maturity swap rates from discount ratios.
      \nSpanningForwards: number of forward rates spanned by the constant maturity swap.\nFirstValidIndex: marks the first non expired discount bond.\nDiscountRatios: vector of discount bond ratios.\nTaus: rate time intervals."
CoterminalSwapAnnuitiesFromDiscountRatios::usage = "CoterminalSwapAnnuitiesFromDiscountRatios[FirstValidIndex_Integer,DiscountRatios_List /; VectorQ[DiscountRatios, NumberQ],Taus_List /; VectorQ[Taus, NumberQ]] Returns the coterminal swap annuities implied from discount bond ratios.
      \nFirstValidIndex: marks the first non expired discount bond.\nDiscountRatios: vector of discount bond ratios.\nTaus: rate time intervals."
CoterminalSwapCurveState::usage = "CoterminalSwapCurveState[ObjecctId_Symbol,RateTimes_List /; VectorQ[RateTimes, NumberQ]] Construct an object of class CoterminalSwapCurveState and return its id
      \nObjectId: id of object to be created\nRateTimes: rate fixing times.\nPermanent: object permanent/nonpermanent"
CoterminalSwapCurveStateSetOnCoterminalSwapRates::usage = "CoterminalSwapCurveStateSetOnCoterminalSwapRates[ObjecctId_Symbol,CoterminalSwaps_List /; VectorQ[CoterminalSwaps, NumberQ]] set the CurveState object on given vector of coterminal swaps.
      \nObjectId: id of existing QuantLib::CoterminalSwapCurveState object\nCoterminalSwaps: Coterminal swap rates."
CoterminalSwapRatesFromDiscountRatios::usage = "CoterminalSwapRatesFromDiscountRatios[FirstValidIndex_Integer,DiscountRatios_List /; VectorQ[DiscountRatios, NumberQ],Taus_List /; VectorQ[Taus, NumberQ]] Returns the coterminal swap rates implied from discount bond ratios.
      \nFirstValidIndex: marks the first non expired discount bond.\nDiscountRatios: vector of discount bond ratios.\nTaus: rate time intervals."
CurveStateCMSwapRates::usage = "CurveStateCMSwapRates[ObjecctId_Symbol,SpanningForwards_Integer] Returns the current swap rates of the CurveState object.
      \nObjectId: id of existing QuantLib::CurveState object\nSpanningForwards: number of forwards underlying the CMS."
CurveStateCoterminalSwapRates::usage = "CurveStateCoterminalSwapRates[ObjecctId_Symbol] Returns the current swap rates of the CurveState object.
      \nObjectId: id of existing QuantLib::CurveState object"
CurveStateForwardRates::usage = "CurveStateForwardRates[ObjecctId_Symbol] Returns the current forward rates of the CurveState object.
      \nObjectId: id of existing QuantLib::CurveState object"
CurveStateRateTaus::usage = "CurveStateRateTaus[ObjecctId_Symbol] return the rate taus of the CurveState object.
      \nObjectId: id of existing QuantLib::CurveState object"
CurveStateRateTimes::usage = "CurveStateRateTimes[ObjecctId_Symbol] return the rate times of the CurveState object.
      \nObjectId: id of existing QuantLib::CurveState object"
ForwardsFromDiscountRatios::usage = "ForwardsFromDiscountRatios[FirstValidIndex_Integer,DiscountRatios_List /; VectorQ[DiscountRatios, NumberQ],Taus_List /; VectorQ[Taus, NumberQ]] Returns the forward rates implied from discount bond ratios.
      \nFirstValidIndex: marks the first non expired discount bond.\nDiscountRatios: vector of discount bond ratios.\nTaus: rate time intervals."
LMMCurveState::usage = "LMMCurveState[ObjecctId_Symbol,RateTimes_List /; VectorQ[RateTimes, NumberQ]] Construct an object of class LMMCurveState and return its id
      \nObjectId: id of object to be created\nRateTimes: rate fixing times.\nPermanent: object permanent/nonpermanent"
LMMCurveStateSetOnDiscountRatios::usage = "LMMCurveStateSetOnDiscountRatios[ObjecctId_Symbol,DiscountRatios_List /; VectorQ[DiscountRatios, NumberQ]] set the CurveState object on given vector of discount ratios.
      \nObjectId: id of existing QuantLib::LMMCurveState object\nDiscountRatios: discount ratios."
LMMCurveStateSetOnForwardRates::usage = "LMMCurveStateSetOnForwardRates[ObjecctId_Symbol,Rates_List /; VectorQ[Rates, NumberQ]] set the CurveState object on given vector of forward rates.
      \nObjectId: id of existing QuantLib::LMMCurveState object\nRates: forward rates."
Category[CurveState] = {CMSwapCurveState,CMSwapCurveStateSetOnCMSwapRates,ConstantMaturitySwapAnnuitiesFromDiscountRatios,ConstantMaturitySwapRatesFromDiscountRatios,CoterminalSwapAnnuitiesFromDiscountRatios,CoterminalSwapCurveState,CoterminalSwapCurveStateSetOnCoterminalSwapRates,CoterminalSwapRatesFromDiscountRatios,CurveStateCMSwapRates,CurveStateCoterminalSwapRates,CurveStateForwardRates,CurveStateRateTaus,CurveStateRateTimes,ForwardsFromDiscountRatios,LMMCurveState,LMMCurveStateSetOnDiscountRatios,LMMCurveStateSetOnForwardRates};
AppendTo[QLCategories,CurveState]

(* Date *)

QLDate::usage = "Date- and Period-related QuantLib functions."

DateEndOfMonth::usage = "DateEndOfMonth[Date_List] returns the last day of the month to which the given date belongs.
      \nDate: date."
DateIsEndOfMonth::usage = "DateIsEndOfMonth[Date_List] returns TRUE if a date is the last day of its month.
      \nDate: date."
DateIsLeap::usage = "DateIsLeap[Year_List /; VectorQ[Year, IntegerQ]] returns TRUE if a year is leap.
      \nYear: year (e.g. 2006)."
DateMaxDate::usage = "DateMaxDate[] returns the latest date allowed in QuantLib.
      \n"
DateMinDate::usage = "DateMinDate[] returns the earliest date allowed in QuantLib.
      \n"
DateNextWeekday::usage = "DateNextWeekday[Date_List,Weekday_String] Returns the next given weekday following or equal to the given date (e.g., the Friday following Tuesday, January 15th, 2002 was January 18th, 2002).
      \nDate: date.\nWeekday: Weekday (e.g. Wednesday, or Wed)."
DateNthWeekday::usage = "DateNthWeekday[Nth_Integer,Weekday_String,Month_String,Year_Integer] Returns the n-th given weekday in the given month and year (e.g., the 4th Thursday of March, 1998 was March 26th, 1998).
      \nNth: ordinal number (greater than zero, less than 6).\nWeekday: Weekday (e.g. Wednesday, or Wed).\nMonth: Month (e.g. January, or Jan, or '1').\nYear: year (e.g. 2007)."
ECBAddDate::usage = "ECBAddDate[Date_?DateQ] add an ECB date to the list of known ECB dates.
      \nDate: to be added to the list of known ECB dates."
ECBIsECBcode::usage = "ECBIsECBcode[Code_List /; VectorQ[Code, StringQ]] returns whether or not the given code is an ECB code.
      \nCode: 5 letter ECB code (e.g. MAR10)."
ECBIsECBdate::usage = "ECBIsECBdate[Date_List] returns whether or not the given date is an ECB maintenance period start date.
      \nDate: date."
ECBKnownDates::usage = "ECBKnownDates[] returns all the known ECB maintenance period start dates.
      \n"
ECBNextCode::usage = "ECBNextCode[] returns the code for the first ECB date.
      \nRefDate: date with respect to which the calculations are performed. Default value = Date[]."
ECBNextCode2::usage = "ECBNextCode2[Code_String] returns the code for the next ECB date.
      \nCode: 5 letter ECB code (e.g. MAR10)."
ECBNextDate::usage = "ECBNextDate[] returns the next ECB maintenance period start date following the given date.
      \nDate: date with respect to which the calculations are performed. Default value = Date[]."
ECBNextDate2::usage = "ECBNextDate2[Code_String] returns the next ECB maintenance period start date following the given date.
      \nCode: 5 letter ECB code (e.g. MAR10)."
ECBNextDates::usage = "ECBNextDates[] returns all the known ECB maintenance period start dates following the given date.
      \nDate: date with respect to which the calculations are performed. Default value = Date[]."
ECBRemoveDate::usage = "ECBRemoveDate[Date_?DateQ] remove an ECB date from the list of known ECB dates.
      \nDate: to be removed from the list of known ECB dates."
ECBcode::usage = "ECBcode[ECBdate_?DateQ] returns the code corresponding to a given ECB date (e.g. MAR10 for Wednesday, March xxth, 2010). It fails if the input date is not an ECB date.
      \nECBdate: ECB date."
ECBdate::usage = "ECBdate[ECBcode_String] returns the ECB maintenance period start date for the given ECB code.
      \nECBcode: 5 letter ECB code (e.g. MAR10).\nRefDate: date with respect to which the calculations are performed. Default value = Date[]."
ECBdate2::usage = "ECBdate2[Month_String,Year_Integer] returns the ECB maintenance period start date in the given month/year.
      \nMonth: month (e.g. January, or Jan, or '1').\nYear: year (e.g. 2010)."
FrequencyFromPeriod::usage = "FrequencyFromPeriod[Period_List] returns a Frequency from a given Period (e.g. SemiAnnual from 6M).
      \nPeriod: period(s) to advance (e.g. 2D for two days , 3W for three weeks, 6M for six months, 1Y for one year)."
IMMIsIMMcode::usage = "IMMIsIMMcode[Code_List /; VectorQ[Code, StringQ]] returns whether or not the given code is an IMM code.
      \nCode: 2 letter string (e.g. H6).\nMainCycle: FALSE to consider all futures (serial ones included), not just the main March/June/September/December (H, M, U, Z) cycle. Default value = true."
IMMIsIMMdate::usage = "IMMIsIMMdate[Date_List] returns whether or not the given date is an IMM date.
      \nDate: date.\nMainCycle: TRUE to consider the main March/June/September/December (H, M, U, Z) cycle only. Default value = true."
IMMNextCode::usage = "IMMNextCode[] returns the code for the first contract listed in the International Money Market section of the Chicago Mercantile Exchange.
      \nRefDate: date with respect to which the calculations are performed. Default value = Date[].\nMainCycle: TRUE to consider the main March/June/September/December (H, M, U, Z) cycle only. Default value = true."
IMMNextCodes::usage = "IMMNextCodes[MainCycle_List /; VectorQ[MainCycle, Element[#, Booleans] &]] returns the codes for the next contracts listed in the International Money Market section of the Chicago Mercantile Exchange.
      \nRefDate: date with respect to which the calculations are performed. Default value = Date[].\nMainCycle: TRUE to consider the main March/June/September/December (H, M, U, Z) cycle only. Default value = std::vector<bool>(40, true)."
IMMNextDate::usage = "IMMNextDate[] returns the delivery date for the first contract listed in the International Money Market section of the Chicago Mercantile Exchange.
      \nRefDate: date with respect to which the calculations are performed. Default value = Date[].\nMainCycle: TRUE to consider the main March/June/September/December (H, M, U, Z) cycle only. Default value = true."
IMMNextDates::usage = "IMMNextDates[MainCycle_List /; VectorQ[MainCycle, Element[#, Booleans] &]] returns the delivery dates for the next contracts listed in the International Money Market section of the Chicago Mercantile Exchange.
      \nRefDate: date with respect to which the calculations are performed. Default value = Date[].\nMainCycle: TRUE to consider the main March/June/September/December (H, M, U, Z) cycle only. Default value = std::vector<bool>(40, true)."
IMMcode::usage = "IMMcode[IMMdate_List] returns the code corresponding to a given IMM date (e.g. H6 for Wednesday, March 15th, 2006). It fails if the input date is not an IMM date.
      \nIMMdate: IMM date."
IMMdate::usage = "IMMdate[IMMcode_List /; VectorQ[IMMcode, StringQ]] returns the IMM date corresponding to the given IMM code (e.g. Wednesday, March 15th, 2006 for H6).
      \nIMMcode: 2 letter IMM code (e.g. H6).\nRefDate: date with respect to which the calculations are performed. Default value = Date[]."
PeriodEquivalent::usage = "PeriodEquivalent[Period_String] Returns the period equivalent to the input (e.g. 11M for 1Y-1M).
      \nPeriod: input period (e.g. 1Y-1M)."
PeriodFromFrequency::usage = "PeriodFromFrequency[Frequency_String] returns a Period from a given Frequency (e.g. 6M from SemiAnnual).
      \nFrequency: frequency (e.g. Annual, Semiannual, Every4Month, Quarterly, Bimonthly, Monthly)."
PeriodLessThan::usage = "PeriodLessThan[Period1_String,Period2_String] Returns TRUE if the first period is less than the second.
      \nPeriod1: left hand side.\nPeriod2: right hand side."
Category[QLDate] = {DateEndOfMonth,DateIsEndOfMonth,DateIsLeap,DateMaxDate,DateMinDate,DateNextWeekday,DateNthWeekday,ECBAddDate,ECBIsECBcode,ECBIsECBdate,ECBKnownDates,ECBNextCode,ECBNextCode2,ECBNextDate,ECBNextDate2,ECBNextDates,ECBRemoveDate,ECBcode,ECBdate,ECBdate2,FrequencyFromPeriod,IMMIsIMMcode,IMMIsIMMdate,IMMNextCode,IMMNextCodes,IMMNextDate,IMMNextDates,IMMcode,IMMdate,PeriodEquivalent,PeriodFromFrequency,PeriodLessThan};
AppendTo[QLCategories,QLDate]

(* Daycounter *)

Daycounter::usage = "Daycounter related functions."

DayCounterDayCount::usage = "DayCounterDayCount[StartDate_?DateQ,EndDate_List] calculate the number of days in a period according to a given day count convention.
      \ndaycounter: ID of Enumeration of class QuantLib::DayCounter\nStartDate: start date.\nEndDate: end date."
DayCounterName::usage = "DayCounterName[ObjecctId_Symbol] returns the name of the given DayCounter.
      \ndaycounter: ID of Enumeration of class QuantLib::DayCounter"
YearFraction::usage = "DayCounterYearFraction[StartDate_?DateQ,EndDate_List] calculate a year fraction.
      \nStartDate: start date.\nEndDate: end date.\nRefPeriodStart: start date for reference period. Default value = Date[].\nRefPeriodEnd: end date for reference period. Default value = Date[]."
Category[Daycounter] = {DayCounterDayCount,DayCounterName,YearFraction};
AppendTo[QLCategories,Daycounter]

(* Default Probability Term Structures *)

DefaultProbabilityTermStructures::usage = "functions to construct and use DefaultProbabilityTermStructure objects."

DefaultTSDefaultProbability::usage = "DefaultTSDefaultProbability[ObjecctId_Symbol,Dates_List] Returns the probability of default between the reference date and the given date from the given DefaultProbabilityTermStructure object.
      \nObjectId: id of existing QuantLib::DefaultProbabilityTermStructure object\nDates: vector of dates.\nAllowExtrapolation: TRUE allows extrapolation. Default value = false."
DefaultTSSurvivalProbability::usage = "DefaultTSSurvivalProbability[ObjecctId_Symbol,Dates_List] Returns the probability of survival between the reference date and the given date from the given DefaultProbabilityTermStructure object.
      \nObjectId: id of existing QuantLib::DefaultProbabilityTermStructure object\nDates: vector of dates.\nAllowExtrapolation: TRUE allows extrapolation. Default value = false."
DefaultTSDefaultDensity::usage = "DefaultTSDefaultDensity[ObjecctId_Symbol,Dates_List] Returns the default density between the reference date and the given date from the given DefaultProbabilityTermStructure object.
      \nObjectId: id of existing QuantLib::DefaultProbabilityTermStructure object\nDates: vector of dates.\nAllowExtrapolation: TRUE allows extrapolation. Default value = false."


FlatHazardRate::usage = "FlatHazardRate[ObjecctId_Symbol,Rate_] Construct an object of class FlatHazardRate and return its id
      \nObjectId: id of object to be created\nNDays: number of days to advance from EvaluationDate (usually zero or two): it fixes the date at which the discount factor = 1.0. Default value = 0.\nCalendar: holiday calendar (e.g. TARGET) to advance from global EvaluationDate. Default value = NullCalendar.\nRate: the curve level.\nDayCounter: DayCounter ID. Default value = Actual/365 (Fixed).\nPermanent: object permanent/nonpermanent"
RelinkableHandleDefaultProbabilityTermStructure::usage = "RelinkableHandleDefaultProbabilityTermStructure[ObjecctId_Symbol] Construct an object of class RelinkableHandleImpl<QuantLibAddin::DefaultProbabilityTermStructure, QuantLib::DefaultProbabilityTermStructure> and return its id
      \nObjectId: id of object to be created\nCurrentLink: DefaultProbabilityTermStructure object ID. If omitted, nothing is linked by the RelinkableHandle. Default value = .\nPermanent: object permanent/nonpermanent"
Category[DefaultProbabilityTermStructures] = {DefaultTSDefaultProbability,DefaultTSSurvivalProbability,DefaultTSDefaultDensity,FlatHazardRate,RelinkableHandleDefaultProbabilityTermStructure};
AppendTo[QLCategories,DefaultProbabilityTermStructures]


(* Driftcalculators *)

Driftcalculators::usage = "functions to construct and use Driftcalculators objects."

CMSMMDriftCalculator::usage = "CMSMMDriftCalculator[ObjecctId_Symbol,PseudoSquareRoot_?MatrixQ,Displacements_List /; VectorQ[Displacements, NumberQ],Taus_List /; VectorQ[Taus, NumberQ],Numeraire_Integer,Alive_Integer,SpanningFwds_Integer] Construct an object of class CMSMMDriftCalculator and return its id
      \nObjectId: id of object to be created\nPseudoSquareRoot: Pseudo square root of the covariance matrix.\nDisplacements: displacements.\nTaus: taus.\nNumeraire: numeraire.\nAlive: index of the first rates still alive.\nSpanningFwds: number of forwards to be spanned.\nPermanent: object permanent/nonpermanent"
CMSMMDriftCalculatorCompute::usage = "CMSMMDriftCalculatorCompute[ObjecctId_Symbol,CurveStateId_Symbol] Full factor drift computation using the CMSMMDriftCalculator object.
      \nObjectId: id of existing QuantLibAddin::CMSMMDriftCalculator object\nCurveState: CMSwapCurveState object ID."
LMMDriftCalculator::usage = "LMMDriftCalculator[ObjecctId_Symbol,PseudoSquareRoot_?MatrixQ,Displacements_List /; VectorQ[Displacements, NumberQ],Taus_List /; VectorQ[Taus, NumberQ],Numeraire_Integer,Alive_Integer] Construct an object of class LMMDriftCalculator and return its id
      \nObjectId: id of object to be created\nPseudoSquareRoot: Pseudo square root of the covariance matrix.\nDisplacements: displacements.\nTaus: taus.\nNumeraire: numeraire.\nAlive: index of the first rates still alive.\nPermanent: object permanent/nonpermanent"
LMMDriftCalculatorCompute::usage = "LMMDriftCalculatorCompute[ObjecctId_Symbol,CurveStateId_Symbol] Reduced factor (Joshi algorithm) drift computation using the LMMDriftCalculator object.
      \nObjectId: id of existing QuantLibAddin::LMMDriftCalculator object\nCurveState: LMMCurveState object ID."
LMMDriftCalculatorComputePlain::usage = "LMMDriftCalculatorComputePlain[ObjecctId_Symbol,CurveStateId_Symbol] Full factor drift computation using the LMMDriftCalculator object.
      \nObjectId: id of existing QuantLibAddin::LMMDriftCalculator object\nCurveState: LMMCurveState object ID."
LMMDriftCalculatorComputeReduced::usage = "LMMDriftCalculatorComputeReduced[ObjecctId_Symbol,CurveStateId_Symbol] Reduced factor (Joshi algorithm) drift computation using the LMMDriftCalculator object.
      \nObjectId: id of existing QuantLibAddin::LMMDriftCalculator object\nCurveState: LMMCurveState object ID."
LMMNormalDriftCalculator::usage = "LMMNormalDriftCalculator[ObjecctId_Symbol,PseudoSquareRoot_?MatrixQ,Taus_List /; VectorQ[Taus, NumberQ],Numeraire_Integer,Alive_Integer] Construct an object of class LMMNormalDriftCalculator and return its id
      \nObjectId: id of object to be created\nPseudoSquareRoot: Pseudo square root of the covariance matrix.\nTaus: taus.\nNumeraire: numeraire.\nAlive: index of the first rates still alive.\nPermanent: object permanent/nonpermanent"
LMMNormalDriftCalculatorCompute::usage = "LMMNormalDriftCalculatorCompute[ObjecctId_Symbol,CurveStateId_Symbol] Reduced factor (Joshi algorithm) drift computation using the LMMNormalDriftCalculator object.
      \nObjectId: id of existing QuantLibAddin::LMMNormalDriftCalculator object\nCurveState: LMMCurveState object ID."
LMMNormalDriftCalculatorComputePlain::usage = "LMMNormalDriftCalculatorComputePlain[ObjecctId_Symbol,CurveStateId_Symbol] Full factor drift computation using the LMMNormalDriftCalculator object.
      \nObjectId: id of existing QuantLibAddin::LMMNormalDriftCalculator object\nCurveState: LMMCurveState object ID."
LMMNormalDriftCalculatorComputeReduced::usage = "LMMNormalDriftCalculatorComputeReduced[ObjecctId_Symbol,CurveStateId_Symbol] Reduced factor (Joshi algorithm) drift computation using the LMMNormalDriftCalculator object.
      \nObjectId: id of existing QuantLibAddin::LMMNormalDriftCalculator object\nCurveState: LMMCurveState object ID."
SMMDriftCalculator::usage = "SMMDriftCalculator[ObjecctId_Symbol,PseudoSquareRoot_?MatrixQ,Displacements_List /; VectorQ[Displacements, NumberQ],Taus_List /; VectorQ[Taus, NumberQ],Numeraire_Integer,Alive_Integer] Construct an object of class SMMDriftCalculator and return its id
      \nObjectId: id of object to be created\nPseudoSquareRoot: Pseudo square root of the covariance matrix.\nDisplacements: displacements.\nTaus: taus.\nNumeraire: numeraire.\nAlive: index of the first rates still alive.\nPermanent: object permanent/nonpermanent"
SMMDriftCalculatorCompute::usage = "SMMDriftCalculatorCompute[ObjecctId_Symbol,CurveStateId_Symbol] Full factor drift computation using the SMMDriftCalculator object.
      \nObjectId: id of existing QuantLibAddin::SMMDriftCalculator object\nCurveState: CoterminalSwapCurveState object ID."
Category[Driftcalculators] = {CMSMMDriftCalculator,CMSMMDriftCalculatorCompute,LMMDriftCalculator,LMMDriftCalculatorCompute,LMMDriftCalculatorComputePlain,LMMDriftCalculatorComputeReduced,LMMNormalDriftCalculator,LMMNormalDriftCalculatorCompute,LMMNormalDriftCalculatorComputePlain,LMMNormalDriftCalculatorComputeReduced,SMMDriftCalculator,SMMDriftCalculatorCompute};
AppendTo[QLCategories,Driftcalculators]

(* Evolution Description *)

EvolutionDescription::usage = "functions to construct and use evolution description related objects."

EvolutionDescription::usage = "EvolutionDescription[ObjecctId_Symbol,RateTimes_List /; VectorQ[RateTimes, NumberQ],EvolutionTimes_List /; VectorQ[EvolutionTimes, NumberQ]] Construct an object of class EvolutionDescription and return its id
      \nObjectId: id of object to be created\nRateTimes: rate fixing times.\nEvolutionTimes: evolution times in the simulation.\nPermanent: object permanent/nonpermanent"
EvolutionDescriptionEvolutionTimes::usage = "EvolutionDescriptionEvolutionTimes[ObjecctId_Symbol] evolution times for the EvolutionDescription object.
      \nObjectId: id of existing QuantLib::EvolutionDescription object"
EvolutionDescriptionFirstAliveRate::usage = "EvolutionDescriptionFirstAliveRate[ObjecctId_Symbol] first alive rate at each evolution time for the EvolutionDescription object.
      \nObjectId: id of existing QuantLib::EvolutionDescription object"
EvolutionDescriptionFromProduct::usage = "EvolutionDescriptionFromProduct[ObjecctId_Symbol,ProductId_Symbol] Construct an object of class EvolutionDescription and return its id
      \nObjectId: id of object to be created\nProduct: ID of product object.\nPermanent: object permanent/nonpermanent"
EvolutionDescriptionNumberOfRates::usage = "EvolutionDescriptionNumberOfRates[ObjecctId_Symbol] number of rates for the EvolutionDescription object.
      \nObjectId: id of existing QuantLib::EvolutionDescription object"
EvolutionDescriptionNumberOfSteps::usage = "EvolutionDescriptionNumberOfSteps[ObjecctId_Symbol] number of steps for the EvolutionDescription object.
      \nObjectId: id of existing QuantLib::EvolutionDescription object"
EvolutionDescriptionRateTaus::usage = "EvolutionDescriptionRateTaus[ObjecctId_Symbol] rate taus for the EvolutionDescription object.
      \nObjectId: id of existing QuantLib::EvolutionDescription object"
EvolutionDescriptionRateTimes::usage = "EvolutionDescriptionRateTimes[ObjecctId_Symbol] rates fixing times for the EvolutionDescription object.
      \nObjectId: id of existing QuantLib::EvolutionDescription object"
IsInMoneyMarketMeasure::usage = "IsInMoneyMarketMeasure[EvolutionDescriptionId_Symbol,Numeraires_List /; VectorQ[Numeraires, IntegerQ]] Returns TRUE if the numeraire vector is money market measure for the given EvolutionDescription object.
      \nEvolutionDescription: ID of EvolutionDescription object.\nNumeraires: vector of numeraires."
IsInMoneyMarketPlusMeasure::usage = "IsInMoneyMarketPlusMeasure[EvolutionDescriptionId_Symbol,Numeraires_List /; VectorQ[Numeraires, IntegerQ]] Returns TRUE if the numeraire vector is money market measure plus for the given EvolutionDescription object.
      \nEvolutionDescription: ID of EvolutionDescription object.\nNumeraires: vector of numeraires.\nOffset: offset applied to the MoneyMarket measure. Default value = 1."
IsInTerminalMeasure::usage = "IsInTerminalMeasure[EvolutionDescriptionId_Symbol,Numeraires_List /; VectorQ[Numeraires, IntegerQ]] Returns TRUE if the numeraire vector is Terminal measure for the given EvolutionDescription object.
      \nEvolutionDescription: ID of EvolutionDescription object.\nNumeraires: vector of numeraires."
MoneyMarketMeasure::usage = "MoneyMarketMeasure[EvolutionDescriptionId_Symbol] Returns the discretely compounded money market measure for the given EvolutionDescription object.
      \nEvolutionDescription: ID of EvolutionDescription object."
MoneyMarketPlusMeasure::usage = "MoneyMarketPlusMeasure[EvolutionDescriptionId_Symbol] Returns the discretely compounded money market measure for the given EvolutionDescription object.
      \nEvolutionDescription: ID of EvolutionDescription object.\nOffset: offset applied to the MoneyMarket measure. Default value = 1."
TerminalMeasure::usage = "TerminalMeasure[EvolutionDescriptionId_Symbol] Returns the terminal measure for the given EvolutionDescription object.
      \nEvolutionDescription: ID of EvolutionDescription object."
Category[EvolutionDescription] = {EvolutionDescription,EvolutionDescriptionEvolutionTimes,EvolutionDescriptionFirstAliveRate,EvolutionDescriptionFromProduct,EvolutionDescriptionNumberOfRates,EvolutionDescriptionNumberOfSteps,EvolutionDescriptionRateTaus,EvolutionDescriptionRateTimes,IsInMoneyMarketMeasure,IsInMoneyMarketPlusMeasure,IsInTerminalMeasure,MoneyMarketMeasure,MoneyMarketPlusMeasure,TerminalMeasure};
AppendTo[QLCategories,EvolutionDescription]

(* Exercise *)

Exercise::usage = "functions to construct and use Exercise objects."

AmericanExercise::usage = "AmericanExercise[ObjecctId_Symbol,EarliestDate_?DateQ,LatestDate_?DateQ] Construct an object of class AmericanExercise and return its id
      \nObjectId: id of object to be created\nEarliestDate: earliest exercise date.\nLatestDate: latest exercise date.\nPayoffAtExpiry: payoff at expiry. Default value = false.\nPermanent: object permanent/nonpermanent"
BermudanExercise::usage = "BermudanExercise[ObjecctId_Symbol,Dates_List] Construct an object of class BermudanExercise and return its id
      \nObjectId: id of object to be created\nDates: dates.\nPayoffAtExpiry: payoff at expiry. Default value = false.\nPermanent: object permanent/nonpermanent"
EuropeanExercise::usage = "EuropeanExercise[ObjecctId_Symbol,ExpiryDate_?DateQ] Construct an object of class EuropeanExercise and return its id
      \nObjectId: id of object to be created\nExpiryDate: expiry date.\nPermanent: object permanent/nonpermanent"
ExerciseDates::usage = "ExerciseDates[ObjecctId_Symbol] Returns all exercise dates.
      \nObjectId: id of existing QuantLib::Exercise object"
ExerciseLastDate::usage = "ExerciseLastDate[ObjecctId_Symbol] Returns last exercise date.
      \nObjectId: id of existing QuantLib::Exercise object"
Category[Exercise] = {AmericanExercise,BermudanExercise,EuropeanExercise,ExerciseDates,ExerciseLastDate};
AppendTo[QLCategories,Exercise]

(* Forward Rate Agreement *)

ForwardRateAgreement::usage = "Functions to construct and use ForwardRateAgreement objects."

FRA::usage = "FRA[ObjecctId_Symbol,ValueDate_?DateQ,MaturityDate_?DateQ,Position_String,Strike_?NumberQ,Notional_?NumberQ,IborIndex_Symbol,YieldCurve_Symbol] Construct an object of class ForwardRateAgreement and return its id
      \nObjectId: id of object to be created\nValueDate: Value date.\nMaturityDate: Maturity date.\nPosition: Instrument position (Long = purchase, Short = sale).\nStrike: Strike rate.\nNotional: Notional amount.\nIborIndex: Underlying index object ID.\nYieldCurve: discounting YieldTermStructure object ID.\nPermanent: object permanent/nonpermanent"
FRAforwardRate::usage = "FRAforwardRate[ObjecctId_Symbol] Returns the relevant forward rate associated with the FRA term.
      \nObjectId: id of existing QuantLib::ForwardRateAgreement object"
FRAforwardValue::usage = "FRAforwardValue[ObjecctId_Symbol] Returns the forward value of the FRA.
      \nObjectId: id of existing QuantLib::ForwardRateAgreement object"
FRAspotValue::usage = "FRAspotValue[ObjecctId_Symbol] Returns the spot value of the FRA.
      \nObjectId: id of existing QuantLib::ForwardRateAgreement object"
Category[ForwardRateAgreement] = {FRA,FRAforwardRate,FRAforwardValue,FRAspotValue};
AppendTo[QLCategories,ForwardRateAgreement]

(* Handles *)

Handles::usage = "handles."

HandleCurrentLink::usage = "HandleCurrentLink[ObjecctId_Symbol] ID of object to which this handle is linked - empty string if none.
      \nObjectId: id of existing QuantLibAddin::Handle object"
HandleEmpty::usage = "HandleEmpty[ObjecctId_Symbol] True if handle is empty, False if not.
      \nObjectId: id of existing QuantLibAddin::Handle object"
RelinkableHandleLinkTo::usage = "RelinkableHandleLinkTo[ObjecctId_Symbol] Relink the RelinkableHandle to the given object.
      \nObjectId: id of existing QuantLibAddin::RelinkableHandle object\nCurrentLink: ID of Object to which the RelinkableHandle should be relinked, or empty string for null object. Default value = ."
Category[Handles] = {HandleCurrentLink,HandleEmpty,RelinkableHandleLinkTo};
AppendTo[QLCategories,Handles]

(* Indices *)

Indices::usage = "functions to construct and use Index objects."
IndexQ::usage = "IndexQ[expr] gives True if expr is an index, and False otherwise." 
InterestIndexQ::usage = "InterestIndexQ[expr] gives True if expr is an interest index, and False otherwise." 

BMAIndex::usage = "BMAIndex[ObjecctId_Symbol] Construct an object of class BMAIndex and return its id
      \nObjectId: id of object to be created\nYieldCurve: forecasting yield term structure. Default value = None.\nPermanent: object permanent/nonpermanent"
Eonia::usage = "Eonia[ObjecctId_Symbol,Tenor_String] Construct an object of class Eonia and return its id
      \nObjectId: id of object to be created\nTenor: index tenor: ON (1D), TN, SN, SW (1W), 2W, 3W, 1M, 2M, 3M, 4M, 5M, 6M, 7M, 8M, 9M, 10M, 11M, 12M (1Y).\nYieldCurve: forecasting yield term structure. Default value = None.\nPermanent: object permanent/nonpermanent"
Euribor::usage = "Euribor[ObjecctId_Symbol,Tenor_String] Construct an object of class Euribor and return its id
      \nObjectId: id of object to be created\nTenor: index tenor: ON (1D), TN, SN, SW (1W), 2W, 3W, 1M, 2M, 3M, 4M, 5M, 6M, 7M, 8M, 9M, 10M, 11M, 12M (1Y).\nYieldCurve: forecasting yield term structure. Default value = None.\nPermanent: object permanent/nonpermanent"
EuriborSwapIsdaFixA::usage = "EuriborSwapIsdaFixA[ObjecctId_Symbol,Tenor_String] Construct an object of class EuriborSwapIsdaFixA and return its id
      \nObjectId: id of object to be created\nTenor: index tenor: ON (1D), TN, SN, SW (1W), 2W, 3W, 1M, 2M, 3M, 4M, 5M, 6M, 7M, 8M, 9M, 10M, 11M, 12M (1Y).\nYieldCurve: forecasting yield term structure. Default value = None.\nPermanent: object permanent/nonpermanent"
Euribor365::usage = "Euribor365[ObjecctId_Symbol,Tenor_String] Construct an object of class Euribor365 and return its id
      \nObjectId: id of object to be created\nTenor: index tenor: ON (1D), TN, SN, SW (1W), 2W, 3W, 1M, 2M, 3M, 4M, 5M, 6M, 7M, 8M, 9M, 10M, 11M, 12M (1Y).\nYieldCurve: forecasting yield term structure. Default value = None.\nPermanent: object permanent/nonpermanent"
IborIndex::usage = "IborIndex[ObjecctId_Symbol,FamilyName_String,Tenor_String,FixingDays_Integer,Currency_String,BDayConvention_String,EndOfMonth:(True | False),DayCounter_String] Construct an object of class IborIndex and return its id
      \nObjectId: id of object to be created\nFamilyName: index name.\nTenor: index tenor (e.g. 2D for two days , 3W for three weeks, 6M for six months, 1Y for one year).\nFixingDays: fixing days (e.g. 2).\nCurrency: Index Currency.\nCalendar: holiday calendar (e.g. \"TARGET\").\nBDayConvention: business day convention (e.g.\"Modified Following\").\nEndOfMonth: TRUE if the index follow the 'end of month' convention.\nDayCounter: DayCounter ID.\nYieldCurve: forecasting yield term structure. Default value = None.\nPermanent: object permanent/nonpermanent"
IborIndexBusinessDayConv::usage = "IborIndexBusinessDayConv[ObjecctId_Symbol] Returns the business day convention (e.g. Modified Following) for the given IborIndex object.
      \nObjectId: id of existing QuantLib::IborIndex object"
IborIndexEndOfMonth::usage = "IborIndexEndOfMonth[ObjecctId_Symbol] Returns TRUE if the given IborIndex object follows the 'end of month' convention.
      \nObjectId: id of existing QuantLib::IborIndex object"
AddFixings::usage = "AddFixings[ObjecctId_?IndexQ,FixingDates_List,FixingValues_List /; VectorQ[FixingValues, NumberQ]] Adds fixings for the given Index object.
      \nObjectId: id of existing QuantLibAddin::Index object\nFixingDates: fixing dates.\nFixingValues: fixing values.\nForceOverwrite: Set to TRUE to force overwriting of existing fixings, if any. Default value = 0."
ClearFixings::usage = "ClearFixings[ObjecctId_Symbol] Clear all fixings for the given Index object.
      \nObjectId: id of existing QuantLib::Index object"
IndexFixings::usage = "IndexFixing[ObjecctId_Symbol,FixingDate_List] Returns the fixing for the given Index object. The fixing is retrieved from the time series if available, otherways it is forecasted.
      \nObjectId: id of existing QuantLib::Index object\nFixingDate: fixing date(s).\nForecastToday: If set to TRUE it forces the forecasting of today's fixing even if the actual fixing is already available in the time series. Default value = 0."
FixingCalendar::usage = "IndexFixingCalendar[ObjecctId_Symbol] Returns the calendar (e.g. TARGET) for the given Index object.
      \nObjectId: id of existing QuantLib::Index object"
IsValidFixingDate::usage = "IsValidFixingDate[ObjecctId_Symbol,FixingDate_List] Returns TRUE if the fixing date is a valid one for the given Index object.
      \nObjectId: id of existing QuantLib::Index object\nFixingDate: fixing date(s)."
IndexName::usage = "IndexName[ObjecctId_Symbol] Returns the name for the given Index object.
      \nObjectId: id of existing QuantLib::Index object"
IndexCurrency::usage = "InterestRateIndexCurrency[ObjecctId_Symbol] Returns the currency (e.g. EUR) for the given InterestRateIndex object.
      \nObjectId: id of existing QuantLib::InterestRateIndex object"
IndexDayCounter::usage = "InterestRateIndexDayCounter[ObjecctId_Symbol] Returns the DayCounter (e.g. Actual/360) for the given InterestRateIndex object.
      \nObjectId: id of existing QuantLib::InterestRateIndex object"
IndexFamilyName::usage = "IndexFamilyName[ObjecctId_Symbol] Returns the family name (e.g. EURIBOR) for the given InterestRateIndex object.
      \nObjectId: id of existing QuantLib::InterestRateIndex object"
IndexFixingDate::usage = "IndexFixingDate[ObjecctId_Symbol,ValueDate_List] Returns the fixing date for the given value date for the given InterestRateIndex object.
      \nObjectId: id of existing QuantLib::InterestRateIndex object\nValueDate: value date."
IndexFixingDays::usage = "IndexFixingDays[ObjecctId_Symbol] Returns the fixing days (e.g. 2) for the given InterestRateIndex object.
      \nObjectId: id of existing QuantLib::InterestRateIndex object"
IndexMaturity::usage = "IndexMaturity[ObjecctId_Symbol,ValueDate_List] Returns the maturity date for the given value date for the given InterestRateIndex object.
      \nObjectId: id of existing QuantLib::InterestRateIndex object\nValueDate: value date."
IndexTenor::usage = "IndexTenor[ObjecctId_Symbol] Returns the tenor (i.e. length, e.g. 6M, 10Y) for the given InterestRateIndex object.
      \nObjectId: id of existing QuantLib::InterestRateIndex object"
IndexValueDate::usage = "IndexValueDate[ObjecctId_Symbol,FixingDate_List] Returns the value date for the given fixing date for the given InterestRateIndex object.
      \nObjectId: id of existing QuantLib::InterestRateIndex object\nFixingDate: fixing date."
PastFixing::usage = "PastFixing[ObjectId_?InterestIndexQ,FixingDate_List] Returns the past fixings fot the given fixing dates"
SwapIndex::usage = "SwapIndex[ObjecctId_Symbol,FamilyName_String,Tenor_String,FixingDays_Integer,FixedLegTenor_String,FixedLegBDC_String,FixedLegDayCounter_String,IborIndex_Symbol] Construct an object of class SwapIndex and return its id
      \nObjectId: id of object to be created\nFamilyName: index name.\nTenor: index tenor (e.g. 2D for two days, 3W for three weeks, 6M for six months, 1Y for one year).\nFixingDays: swap rate fixing days (e.g. 2).\nCurrency: Default is Index Currency.\nCalendar: holiday calendar (e.g. TARGET).\nFixedLegTenor: tenor of the underlying swap's fixed leg (e.g. 6M, 1Y, 3M).\nFixedLegBDC: business day convention of the underlying swap's fixed leg (e.g. \"Modified Following\").\nFixedLegDayCounter: day counter of the underlying swap's fixed leg (e.g. \"30/360 (BondBasis)\").\nDiscountCurve: discounting YieldTermStructure object ID. Default value = None.\nIborIndex: swap's floating ibor index object ID.\nPermanent: object permanent/nonpermanent"
SwapIndexFixedLegBDC::usage = "SwapIndexFixedLegBDC[ObjecctId_Symbol] Returns the business day convention (e.g. Modified Following) for the given SwapIndex object.
      \nObjectId: id of existing QuantLib::SwapIndex object"
SwapIndexFixedLegTenor::usage = "SwapIndexFixedLegTenor[ObjecctId_Symbol] Returns the fixed leg tenor (e.g. 1Y) for the given SwapIndex object.
      \nObjectId: id of existing QuantLib::SwapIndex object"
SwapIndexUnderlyingSwap::usage = "SwapIndexUnderlyingSwap[ObjectId_Symbol,SwapIndexID_Symbol,FixingDate_?DateQ] Returns an underlying swap for the swap index.
      \nObjectId: name of the swap (optional)
      \nSwapIndexId: id of existing QuantLib::SwapIndex object
      \nFixingDate: Date when the swap is fixed.
      \nPermanent: object permanent/nonpermanent"
Category[Indices] = {BMAIndex,Eonia,EuriborSwapIsdaFixA,EurLiborSwapFixA,EurLiborSwapFixB,EurLiborSwapFixIFR,Euribor,Euribor365,EuriborSwapFixA,EuriborSwapFixB,EuriborSwapFixIFR,IborIndex,IborIndexBusinessDayConv,IborIndexEndOfMonth,IndexAddFixings,IndexClearFixings,IndexFixing,IndexFixingCalendar,IndexIsValidFixingDate,IndexName,InterestRateIndexCurrency,InterestRateIndexDayCounter,InterestRateIndexFamilyName,InterestRateIndexFixingDate,InterestRateIndexFixingDays,InterestRateIndexMaturity,InterestRateIndexTenor,InterestRateIndexValueDate,SwapIndex,SwapIndexFixedLegBDC,SwapIndexFixedLegTenor};
AppendTo[QLCategories,Indices]


(* Instruments *)

Instruments::usage = "functions to construct and use Instrument objects."

InstrumentErrorEstimate::usage = "InstrumentErrorEstimate[ObjecctId_Symbol] Returns the NPV error estimation (for e.g. Monte Carlo simulation) for the given Instrument object.
      \nObjectId: id of existing QuantLib::Instrument object"
InstrumentIsExpired::usage = "InstrumentIsExpired[ObjecctId_Symbol] Returns TRUE if the given Instrument object is expired.
      \nObjectId: id of existing QuantLib::Instrument object"
InstrumentNPV::usage = "InstrumentNPV[ObjecctId_Symbol] Returns the NPV for the given Instrument object.
      \nObjectId: id of existing QuantLib::Instrument object"
InstrumentResults::usage = "InstrumentResults[ObjecctId_Symbol,ResultType_String] Returns the required result (if available) for the given Instrument object.
      \nObjectId: id of existing QuantLib::Instrument object\nResultType: result type (e.g. 'vega')."
InstrumentSetPricingEngine::usage = "InstrumentSetPricingEngine[ObjecctId_Symbol,PricingEngine_Symbol] Sets a new pricing engine to the given Instrument pbject.
      \nObjectId: id of existing QuantLibAddin::Instrument object\nPricingEngine: PricingEngine object ID."
InstrumentValuationDate::usage = "InstrumentValuationDate[ObjecctId_Symbol] Returns the valuation date for the given Instrument object.
      \nObjectId: id of existing QuantLib::Instrument object"
InstrumentAdditionalResults::usage = "InstrumentAdditionalResults[ObjecctId_Symbol] Returns additional result values for the given Instrument object.
      \nObjectId: id of existing QuantLib::Instrument object" 
      
Category[Instruments] = {InstrumentErrorEstimate,InstrumentIsExpired,InstrumentNPV,InstrumentResults,InstrumentSetPricingEngine,InstrumentValuationDate(*, InstrumentAdditionalResults*)};
AppendTo[QLCategories,Instruments]

(* Interpolation *)

QLInterpolations::usage = "functions to construct and use Interpolation and Interpolation2D objects."

AbcdQLInterpolation::usage = "AbcdInterpolation[ObjecctId_Symbol,XArray_List /; VectorQ[XArray, NumberQ],YArray_List] Construct an object of class AbcdInterpolation and return its id
      \nObjectId: id of object to be created\nXArray: x array.\nYArray: y array.\nA: The a in { y = (a + b*x) e^(-c*x) + d }. It can be a fixed value or just a guess. Default value = 0.\nB: The b in { y = (a + b*x) e^(-c*x) + d }. It can be a fixed value or just a guess. Default value = 0.\nC: The c in { y = (a + b*x) e^(-c*x) + d }. It can be a fixed value or just a guess. Default value = 0.\nD: The d in { y = (a + b*x) e^(-c*x) + d }. It can be a fixed value or just a guess. Default value = 0.\nAIsFixed: TRUE if the A value provided is to be kept fixed, FALSE if it is just a guess. Default value = false.\nBIsFixed: TRUE if the B value provided is to be kept fixed, FALSE if it is just a guess. Default value = false.\nCIsFixed: TRUE if the C value provided is to be kept fixed, FALSE if it is just a guess. Default value = false.\nDIsFixed: TRUE if the D value provided is to be kept fixed, FALSE if it is just a guess. Default value = false.\nVegaWeighted: TRUE if the interpolation is weighted using options Vega. Default value = true.\nEndCriteria: EndCriteria object ID. Default value = .\nOptimizationMeth: OptimizationMethod object ID. Default value = .\nPermanent: object permanent/nonpermanent"
AbcdInterpolationA::usage = "AbcdInterpolationA[ObjecctId_Symbol] Returns the a in the { y = (a + b*x) e^(-c*x) + d } fit for the given AbcdInterpolation object.
      \nObjectId: id of existing QuantLibAddin::AbcdInterpolation object"
AbcdInterpolationB::usage = "AbcdInterpolationB[ObjecctId_Symbol] Returns the b in the { y = (a + b*x) e^(-c*x) + d } fit for the given AbcdInterpolation object.
      \nObjectId: id of existing QuantLibAddin::AbcdInterpolation object"
AbcdInterpolationC::usage = "AbcdInterpolationC[ObjecctId_Symbol] Returns the c in the { y = (a + b*x) e^(-c*x) + d } fit for the given AbcdInterpolation object.
      \nObjectId: id of existing QuantLibAddin::AbcdInterpolation object"
AbcdInterpolationD::usage = "AbcdInterpolationD[ObjecctId_Symbol] Returns the d in the { y = (a + b*x) e^(-c*x) + d } fit for the given AbcdInterpolation object.
      \nObjectId: id of existing QuantLibAddin::AbcdInterpolation object"
AbcdInterpolationEndCriteria::usage = "AbcdInterpolationEndCriteria[ObjecctId_Symbol] Returns the optimization end criteria of the fit for the given AbcdInterpolation object.
      \nObjectId: id of existing QuantLibAddin::AbcdInterpolation object"
AbcdInterpolationMaxError::usage = "AbcdInterpolationMaxError[ObjecctId_Symbol] Returns the max error of the fit for the given AbcdInterpolation object.
      \nObjectId: id of existing QuantLibAddin::AbcdInterpolation object"
AbcdInterpolationRmsError::usage = "AbcdInterpolationRmsError[ObjecctId_Symbol] Returns the error of the fit for the given AbcdInterpolation object.
      \nObjectId: id of existing QuantLibAddin::AbcdInterpolation object"
CubicInterpolation::usage = "CubicInterpolation[ObjecctId_Symbol,XArray_List /; VectorQ[XArray, NumberQ],YArray_List] Construct an object of class CubicInterpolation and return its id
      \nObjectId: id of object to be created\nXArray: x array.\nYArray: y array.\nDerApprox: Derivative Approximation (). Default value = Kruger.\nMonotonic: monotonicity constraint flag. Default value = true.\nLeftConditionType: left boundary condition (NotAKnot, FirstDerivative, SecondDerivative, Periodic, Lagrange). Default value = SecondDerivative.\nLeftConditionValue: left condition value. Default value = 0.0.\nRightConditionType: right boundary condition (NotAKnot, FirstDerivative, SecondDerivative, Periodic, Lagrange). Default value = SecondDerivative.\nRightConditionValue: right condition value. Default value = 0.0.\nPermanent: object permanent/nonpermanent"
CubicInterpolationACoefficients::usage = "CubicInterpolationACoefficients[ObjecctId_Symbol] Returns the constant terms in the primitive of the cubic interpolants for the given CubicSplineInterpolation object.
      \nObjectId: id of existing QuantLibAddin::CubicInterpolation object"
CubicInterpolationBCoefficients::usage = "CubicInterpolationBCoefficients[ObjecctId_Symbol] Returns the constant terms in the primitive of the cubic interpolants for the given CubicSplineInterpolation object.
      \nObjectId: id of existing QuantLibAddin::CubicInterpolation object"
CubicInterpolationCCoefficients::usage = "CubicInterpolationCCoefficients[ObjecctId_Symbol] Returns the constant terms in the primitive of the cubic interpolants for the given CubicSplineInterpolation object.
      \nObjectId: id of existing QuantLibAddin::CubicInterpolation object"
CubicInterpolationMonotonicityAdjustments::usage = "CubicInterpolationMonotonicityAdjustments[ObjecctId_Symbol] Returns a vector of bool (one per cubic) indicating if there has been a monotonicity adjustment.
      \nObjectId: id of existing QuantLibAddin::CubicInterpolation object"
CubicInterpolationPrimitiveConstants::usage = "CubicInterpolationPrimitiveConstants[ObjecctId_Symbol] Returns the constant terms in the primitive of the cubic interpolants for the given CubicSplineInterpolation object.
      \nObjectId: id of existing QuantLibAddin::CubicInterpolation object"
ExtrapolatorEnableExtrapolation::usage = "ExtrapolatorEnableExtrapolation[ObjecctId_Symbol] Sets the enable extrapolation flag to the given Extrapolator object.
      \nObjectId: id of existing QuantLibAddin::Extrapolator object\nExtrapolationFlag: global extrapolation flag. Default value = true."
QLInterpolation::usage = "QLInterpolation[ObjecctId_Symbol,XArray_List /; VectorQ[XArray, NumberQ],YArray_List] Construct an object of class GenericInterp and return its id
      \nObjectId: id of object to be created\nInterpolationType: interpolation type (e.g BackwardFlat, ForwardFlat, Linear, LogLinear, NaturalCubicSpline, NaturalLogCubic, MonotonicNaturalCubicSpline, MonotonicNaturalLogCubic, KrugerCubic, KrugerLogCubic). Default value = MonotonicNaturalCubicSpline.\nXArray: x array.\nYArray: y array.\nPermanent: object permanent/nonpermanent"
Interpolation2D::usage = "Interpolation2D[ObjecctId_Symbol,XArray_List /; VectorQ[XArray, NumberQ],YArray_List /; VectorQ[YArray, NumberQ],ZMatrix_?MatrixQ] Construct an object of class Interpolation2D and return its id
      \nObjectId: id of object to be created\nInterpolationType: 2D-interpolation type (e.g BiLinear, BiCubic). Default value = BiLinear.\nXArray: x array.\nYArray: y array.\nZMatrix: z-matrix values.\nPermanent: object permanent/nonpermanent"
Interpolation2DInterpolate::usage = "Interpolation2DInterpolate[ObjecctId_Symbol,XValue_List /; VectorQ[XValue, NumberQ],YValue_?NumberQ] Returns interpolated values for the (x,y) input for the given Interpolation2D object.
      \nObjectId: id of existing QuantLib::Interpolation2D object\nXValue: x value(s).\nYValue: y value.\nAllowExtrapolation: allow extrapolation flag. Default value = false."
Interpolation2DIsInRange::usage = "Interpolation2DIsInRange[ObjecctId_Symbol,XValues_List /; VectorQ[XValues, NumberQ],YValue_?NumberQ] Returns TRUE if the (x,y) input value is in the allowed interpolation range for the given Interpolation2D object.
      \nObjectId: id of existing QuantLib::Interpolation2D object\nXValues: x values.\nYValue: y value."
Interpolation2DXmax::usage = "Interpolation2DXmax[ObjecctId_Symbol] Returns the maximum value of the x array for the given Interpolation2D object.
      \nObjectId: id of existing QuantLib::Interpolation2D object"
Interpolation2DXmin::usage = "Interpolation2DXmin[ObjecctId_Symbol] Returns the minimum value of the x array for the given Interpolation2D object.
      \nObjectId: id of existing QuantLib::Interpolation2D object"
Interpolation2DXvalues::usage = "Interpolation2DXvalues[ObjecctId_Symbol] Returns the x array grid for the given Interpolation2D object.
      \nObjectId: id of existing QuantLib::Interpolation2D object"
Interpolation2DYmax::usage = "Interpolation2DYmax[ObjecctId_Symbol] Returns the maximum value of the y array for the given Interpolation2D object.
      \nObjectId: id of existing QuantLib::Interpolation2D object"
Interpolation2DYmin::usage = "Interpolation2DYmin[ObjecctId_Symbol] Returns the minimum value of the y array for the given Interpolation2D object.
      \nObjectId: id of existing QuantLib::Interpolation2D object"
Interpolation2DYvalues::usage = "Interpolation2DYvalues[ObjecctId_Symbol] Returns the y array grid for the given Interpolation2D object.
      \nObjectId: id of existing QuantLib::Interpolation2D object"
Interpolation2DzData::usage = "Interpolation2DzData[ObjecctId_Symbol] Returns the z data matrix grid for the given Interpolation2D object.
      \nObjectId: id of existing QuantLib::Interpolation2D object"
InterpolationDerivative::usage = "InterpolationDerivative[ObjecctId_Symbol,XValues_List /; VectorQ[XValues, NumberQ]] Returns the first derivative function values using the given Interpolation object.
      \nObjectId: id of existing QuantLibAddin::Interpolation object\nXValues: x values.\nAllowExtrapolation: allow extrapolation flag. Default value = false."
InterpolationInterpolate::usage = "InterpolationInterpolate[ObjecctId_Symbol,XValues_List /; VectorQ[XValues, NumberQ]] Returns interpolated values using the given Interpolation object.
      \nObjectId: id of existing QuantLibAddin::Interpolation object\nXValues: x values.\nAllowExtrapolation: allow extrapolation flag. Default value = false."
InterpolationIsInRange::usage = "InterpolationIsInRange[ObjecctId_Symbol,XValues_List /; VectorQ[XValues, NumberQ]] Returns TRUE if the input value is in the allowed interpolation range for the given Interpolation object.
      \nObjectId: id of existing QuantLib::Interpolation object\nXValues: x values."
InterpolationPrimitive::usage = "InterpolationPrimitive[ObjecctId_Symbol,XValues_List /; VectorQ[XValues, NumberQ]] Returns the primitive function values using the given Interpolation object.
      \nObjectId: id of existing QuantLibAddin::Interpolation object\nXValues: x values.\nAllowExtrapolation: allow extrapolation flag. Default value = false."
InterpolationSecondDerivative::usage = "InterpolationSecondDerivative[ObjecctId_Symbol,XValues_List /; VectorQ[XValues, NumberQ]] Returns the second derivative function values using the given Interpolation object.
      \nObjectId: id of existing QuantLibAddin::Interpolation object\nXValues: x values.\nAllowExtrapolation: allow extrapolation flag. Default value = false."
InterpolationXmax::usage = "InterpolationXmax[ObjecctId_Symbol] Returns the maximum value of the x array for the given Interpolation object.
      \nObjectId: id of existing QuantLib::Interpolation object"
InterpolationXmin::usage = "InterpolationXmin[ObjecctId_Symbol] Returns the minimum value of the x array for the given Interpolation object.
      \nObjectId: id of existing QuantLib::Interpolation object"
MixedLinearCubicInterpolation::usage = "MixedLinearCubicInterpolation[ObjecctId_Symbol,XArray_List /; VectorQ[XArray, NumberQ],YArray_List,SwitchIndex_Integer] Construct an object of class MixedLinearCubicInterpolation and return its id
      \nObjectId: id of object to be created\nXArray: x array.\nYArray: y array.\nSwitchIndex: zero based knot index at which interpolation switches from linear to cubic.\nDerApprox: Derivative Approximation (). Default value = Kruger.\nMonotonic: monotonicity constraint flag. Default value = true.\nLeftConditionType: left boundary condition (NotAKnot, FirstDerivative, SecondDerivative, Periodic, Lagrange). Default value = SecondDerivative.\nLeftConditionValue: left condition value. Default value = 0.0.\nRightConditionType: right boundary condition (NotAKnot, FirstDerivative, SecondDerivative, Periodic, Lagrange). Default value = SecondDerivative.\nRightConditionValue: right condition value. Default value = 0.0.\nPermanent: object permanent/nonpermanent"
SABRInterpolation::usage = "SABRInterpolation[ObjecctId_Symbol,XArray_List /; VectorQ[XArray, NumberQ],YArray_List,Expiry_?NumberQ,Forward_] Construct an object of class SABRInterpolation and return its id
      \nObjectId: id of object to be created\nXArray: x array.\nYArray: y array.\nExpiry: expiry time in years.\nForward: at-the-money forward rate.\nAlpha: alpha (fixed value or guess). Default value = 0.\nBeta: beta (fixed value or guess). Default value = 0.\nNu: nu (fixed value or guess). Default value = 0.\nRho: rho (fixed value or guess). Default value = 0.\nAlphaIsFixed: TRUE if the alpha value provided is to be kept fixed, FALSE if it is just a guess. Default value = false.\nBetaIsFixed: TRUE if the beta value provided is to be kept fixed, FALSE if it is just a guess. Default value = false.\nNuIsFixed: TRUE if the nu value provided is to be kept fixed, FALSE if it is just a guess. Default value = false.\nRhoIsFixed: TRUE if the rho value provided is to be kept fixed, FALSE if it is just a guess. Default value = false.\nVegaWeighted: TRUE if the interpolation is weighted using options Vega. Default value = true.\nEndCriteria: EndCriteria object ID. Default value = .\nOptimizationMeth: OptimizationMethod object ID. Default value = .\nPermanent: object permanent/nonpermanent"
SABRInterpolationAlpha::usage = "SABRInterpolationAlpha[ObjecctId_Symbol] Returns the alpha of the fit for the given SABRInterpolation object.
      \nObjectId: id of existing QuantLibAddin::SABRInterpolation object"
SABRInterpolationBeta::usage = "SABRInterpolationBeta[ObjecctId_Symbol] Returns the alpha of the fit for the given SABRInterpolation object.
      \nObjectId: id of existing QuantLibAddin::SABRInterpolation object"
SABRInterpolationEndCriteria::usage = "SABRInterpolationEndCriteria[ObjecctId_Symbol] Returns the optimization end criteria of the fit for the given SABRInterpolation object.
      \nObjectId: id of existing QuantLibAddin::SABRInterpolation object"
SABRInterpolationExpiry::usage = "SABRInterpolationExpiry[ObjecctId_Symbol] Returns the expiry time in years for the given SABRInterpolation object.
      \nObjectId: id of existing QuantLib::SABRInterpolation object"
SABRInterpolationForward::usage = "SABRInterpolationForward[ObjecctId_Symbol] Returns the forward  for the given SABRInterpolation object.
      \nObjectId: id of existing QuantLib::SABRInterpolation object"
SABRInterpolationMaxError::usage = "SABRInterpolationMaxError[ObjecctId_Symbol] Returns the max error of the fit for the given SABRInterpolation object.
      \nObjectId: id of existing QuantLibAddin::SABRInterpolation object"
SABRInterpolationNu::usage = "SABRInterpolationNu[ObjecctId_Symbol] Returns the nu of the fit for the given SABRInterpolation object.
      \nObjectId: id of existing QuantLibAddin::SABRInterpolation object"
SABRInterpolationRho::usage = "SABRInterpolationRho[ObjecctId_Symbol] Returns the rho of the fit for the given SABRInterpolation object.
      \nObjectId: id of existing QuantLibAddin::SABRInterpolation object"
SABRInterpolationRmsError::usage = "SABRInterpolationRmsError[ObjecctId_Symbol] Returns the error of the fit for the given SABRInterpolation object.
      \nObjectId: id of existing QuantLibAddin::SABRInterpolation object"
SABRInterpolationWeights::usage = "SABRInterpolationWeights[ObjecctId_Symbol] Returns the weights of the fit for the given SABRInterpolation object.
      \nObjectId: id of existing QuantLibAddin::SABRInterpolation object"
Category[QLInterpolations] = {AbcdInterpolation,AbcdInterpolationA,AbcdInterpolationB,AbcdInterpolationC,AbcdInterpolationD,AbcdInterpolationEndCriteria,AbcdInterpolationMaxError,
                           AbcdInterpolationRmsError,CubicInterpolation,CubicInterpolationACoefficients,CubicInterpolationBCoefficients,CubicInterpolationCCoefficients,CubicInterpolationMonotonicityAdjustments,CubicInterpolationPrimitiveConstants,ExtrapolatorEnableExtrapolation,Interpolation,Interpolation2D,Interpolation2DInterpolate,Interpolation2DIsInRange,Interpolation2DXmax,Interpolation2DXmin,Interpolation2DXvalues,Interpolation2DYmax,Interpolation2DYmin,Interpolation2DYvalues,Interpolation2DzData,InterpolationDerivative,InterpolationInterpolate,InterpolationIsInRange,InterpolationPrimitive,InterpolationSecondDerivative,InterpolationXmax,InterpolationXmin,MixedLinearCubicInterpolation,SABRInterpolation,SABRInterpolationAlpha,SABRInterpolationBeta,SABRInterpolationEndCriteria,SABRInterpolationExpiry,SABRInterpolationForward,SABRInterpolationMaxError,SABRInterpolationNu,SABRInterpolationRho,SABRInterpolationRmsError,SABRInterpolationWeights};
AppendTo[QLCategories,QLInterpolations]


InterestRate::usage = "InterestRate[ObjecctId_Symbol,Rate_?NumberQ,DayCounter_String,Compounding_String] Construct an object of class InterestRate and return its id
      \nObjectId: id of object to be created\nRate: rate.\nDayCounter: Irr DayCounter ID.\nCompounding: Interest rate coumpounding rule (Simple:1+rt, Compounded:(1+r)^t, Continuous:e^{rt}).\nFrequency: frequency (e.g. Annual, Semiannual, Every4Month, Quarterly, Bimonthly, Monthly). Default value = Annual.\nPermanent: object permanent/nonpermanent"
InterestRateCompoundFactor::usage = "InterestRateCompoundFactor[ObjecctId_Symbol,StartDate_?DateQ,EndDate_?DateQ] Returns the compound factor between two dates based on the given InterestRate object.
      \nObjectId: id of existing QuantLib::InterestRate object\nStartDate: compounding period start.\nEndDate: compounding period end.\nRefPeriodStart: reference period start date needed by some daycounter. Default value = Date[].\nRefPeriodEnd: reference period end date needed by some daycounter. Default value = Date[]."
InterestRateCompounding::usage = "InterestRateCompounding[ObjecctId_Symbol] Returns the Compounding in the given InterestRate object.
      \nObjectId: id of existing QuantLib::InterestRate object"
InterestRateDayCounter::usage = "InterestRateDayCounter[ObjecctId_Symbol] Returns the DayCounter in the given InterestRate object.
      \nObjectId: id of existing QuantLib::InterestRate object"
InterestRateDiscountFactor::usage = "InterestRateDiscountFactor[ObjecctId_Symbol,StartDate_?DateQ,EndDate_?DateQ] Returns the discount factor between two dates based on the given InterestRate object.
      \nObjectId: id of existing QuantLib::InterestRate object\nStartDate: compounding period start.\nEndDate: compounding period end.\nRefPeriodStart: reference period start date needed by some daycounter. Default value = Date[].\nRefPeriodEnd: reference period end date needed by some daycounter. Default value = Date[]."
InterestRateEquivalentRate::usage = "InterestRateEquivalentRate[ObjecctId_Symbol,DayCounter_String,Compounding_String,StartDate_?DateQ,EndDate_?DateQ] Returns the equivalent rate for a compounding period between two dates based on the given InterestRate object.
      \nObjectId: id of existing QuantLib::InterestRate object\nDayCounter: rate DayCounter ID.\nCompounding: interest rate coumpounding rule (Simple:1+rt, Compounded:(1+r)^t, Continuous:e^{rt}).\nFrequency: frequency (e.g. Annual, Semiannual, Every4Month, Quarterly, Bimonthly, Monthly). Default value = Annual.\nStartDate: compounding period start.\nEndDate: compounding period end.\nRefPeriodStart: reference period start date needed by some daycounter. Default value = Date[].\nRefPeriodEnd: reference period end date needed by some daycounter. Default value = Date[]."
InterestRateFrequency::usage = "InterestRateFrequency[ObjecctId_Symbol] Returns the Frequency in the given InterestRate object.
      \nObjectId: id of existing QuantLib::InterestRate object"
InterestRateImpliedRate::usage = "InterestRateImpliedRate[Compound_?NumberQ,DayCounter_String,Compounding_String,StartDate_?DateQ,EndDate_?DateQ] Returns the implied rate between two dates based on the given a compound factor.
      \nCompound: compound factor used to calculate the implicit rate.\nDayCounter: rate DayCounter ID.\nCompounding: interest rate coumpounding rule (Simple:1+rt, Compounded:(1+r)^t, Continuous:e^{rt}).\nFrequency: frequency (e.g. Annual, Semiannual, Every4Month, Quarterly, Bimonthly, Monthly). Default value = Annual.\nStartDate: compounding period start.\nEndDate: compounding period end.\nRefPeriodStart: reference period start date needed by some daycounter. Default value = Date[].\nRefPeriodEnd: reference period end date needed by some daycounter. Default value = Date[]."
InterestRateRate::usage = "InterestRateRate[ObjecctId_Symbol] Returns the rate in the given InterestRate object.
      \nObjectId: id of existing QuantLib::InterestRate object"

Category[QLIntrestRate] = {InterestRate,InterestRateCompoundFactor,InterestRateCompounding,InterestRateDayCounter,InterestRateDiscountFactor,InterestRateEquivalentRate,InterestRateFrequency,InterestRateImpliedRate,InterestRateRate};
AppendTo[QLCategories,QLInterestRate]


(* Leg *)

QLLeg::usage = "functions to construct and use Leg objects."

Leg::usage = "Leg[ObjecctId_Symbol,Amounts_List /; VectorQ[Amounts, NumberQ],Dates_List] Construct an object of class Leg and return its id
      \nObjectId: id of object to be created\nAmounts: list of cash to be received/paid.\nDates: payment dates corresponding to amounts.\nToBeSorted: TRUE if the CashFlows must be sorted by ascending dates. Default value = true.\nPermanent: object permanent/nonpermanent"
LegAccrualDays::usage = "LegAccrualDays[ObjectIdId_Symbol] Returns the total number of accrual days for the current coupon of the given Leg.
      \nObjectId: id of existing QuantLib::Leg object\nIncludeSettlDate: TRUE if cashflows paid at the settlement date must be taken into account. Default value = true.\nSettlementDate: cashflows before this date are not taken into account. Default value = Date[]."
LegAccrualEndDate::usage = "LegAccrualEndDate[ObjectIdId_Symbol] Returns the accrual end date for the current coupon of the given Leg.
      \nObjectId: id of existing QuantLib::Leg object\nIncludeSettlDate: TRUE if cashflows paid at the settlement date must be taken into account. Default value = true.\nSettlementDate: cashflows before this date are not taken into account. Default value = Date[]."
LegAccrualPeriod::usage = "LegAccrualPeriod[ObjectIdId_Symbol] Returns the total accrual period for the current coupon of the given Leg.
      \nObjectId: id of existing QuantLib::Leg object\nIncludeSettlDate: TRUE if cashflows paid at the settlement date must be taken into account. Default value = true.\nSettlementDate: cashflows before this date are not taken into account. Default value = Date[]."
LegAccrualStartDate::usage = "LegAccrualStartDate[ObjectIdId_Symbol] Returns the accrual start date for the current coupon of the given Leg.
      \nObjectId: id of existing QuantLib::Leg object\nIncludeSettlDate: TRUE if cashflows paid at the settlement date must be taken into account. Default value = true.\nSettlementDate: cashflows before this date are not taken into account. Default value = Date[]."
LegAccruedAmount::usage = "LegAccruedAmount[ObjectIdId_Symbol] Returns the accrued amount for the given Leg.
      \nObjectId: id of existing QuantLib::Leg object\nIncludeSettlDate: TRUE if cashflows paid at the settlement date must be taken into account. Default value = true.\nSettlementDate: cashflows before this date are not taken into account. Default value = Date[]."
LegAccruedDays::usage = "LegAccruedDays[ObjectIdId_Symbol] Returns the accrued days for the current coupon of the given Leg.
      \nObjectId: id of existing QuantLib::Leg object\nIncludeSettlDate: TRUE if cashflows paid at the settlement date must be taken into account. Default value = true.\nSettlementDate: cashflows before this date are not taken into account. Default value = Date[]."
LegAccruedPeriod::usage = "LegAccruedPeriod[ObjectIdId_Symbol] Returns the accrued period for the current coupon of the given Leg.
      \nObjectId: id of existing QuantLib::Leg object\nIncludeSettlDate: TRUE if cashflows paid at the settlement date must be taken into account. Default value = true.\nSettlementDate: cashflows before this date are not taken into account. Default value = Date[]."
LegAtmRate::usage = "LegAtmRate[ObjectIdId_Symbol,DiscountCurveId_Symbol] Returns the at-the-money rate for the given Leg object, i.e. the fixed rate for which an equivalent vector of fixed-rate cash flows would have the same NPV.
      \nObjectId: id of existing QuantLib::Leg object\nDiscountCurve: discounting YieldTermStructure object ID.\nIncludeSettlDate: TRUE if cashflows paid at the settlement date must be taken into account. Default value = true.\nSettlementDate: cashflows before this date are not taken into account. Default value = Date[].\nNpvDate: all cashflows are discounted to this date. If missing it is assumed equal to the settlement date Default value = Date[].\nNPV: target net present value. If missing the NPV is calculated using the provided discount curve Default value = 0."
LegBPS::usage = "LegBPS[ObjectIdId_Symbol,DiscountCurveId_Symbol] Returns the basis point sensitivity for the given Leg object.
      \nObjectId: id of existing QuantLib::Leg object\nDiscountCurve: discounting YieldTermStructure object ID.\nIncludeSettlDate: TRUE if cashflows paid at the settlement date must be taken into account. Default value = true.\nSettlementDate: cashflows before this date are not taken into account. Default value = Date[].\nNpvDate: all cashflows are discounted to this date. If missing it is assumed equal to the settlement date Default value = Date[]."
LegBPSFromYield::usage = "LegBPSFromYield[ObjectIdId_Symbol,Yield_?NumberQ] Returns the basis point sensitivity for the given Leg object.
      \nObjectId: id of existing QuantLib::Leg object\nYield: Yield (a.k.a. IRR).\nDayCounter: Yield DayCounter ID. Default value = Actual/Actual (ISDA).\nCompounding: Interest rate coumpounding rule (Simple:1+rt, Compounded:(1+r)^t, Continuous:e^{rt}). Default value = Compounded.\nFrequency: frequency (e.g. Annual, Semiannual, Every4Month, Quarterly, Bimonthly, Monthly). Default value = Annual.\nIncludeSettlDate: TRUE if cashflows paid at the settlement date must be taken into account. Default value = true.\nSettlementDate: cashflows before this date are not taken into account. Default value = Date[].\nNpvDate: all cashflows are discounted to this date. If missing it is assumed equal to the settlement date Default value = Date[]."
LegBasisPointValue::usage = "LegBasisPointValue[ObjectIdId_Symbol,Yield_?NumberQ] Returns the basisPointValue for the given Leg object.
      \nObjectId: id of existing QuantLib::Leg object\nYield: Yield (a.k.a. IRR).\nDayCounter: Yield DayCounter ID. Default value = Actual/Actual (ISDA).\nCompounding: Interest rate coumpounding rule (Simple:1+rt, Compounded:(1+r)^t, Continuous:e^{rt}). Default value = Compounded.\nFrequency: frequency (e.g. Annual, Semiannual, Every4Month, Quarterly, Bimonthly, Monthly). Default value = Annual.\nIncludeSettlDate: TRUE if cashflows paid at the settlement date must be taken into account. Default value = true.\nSettlementDate: cashflows before this date are not taken into account. Default value = Date[].\nNpvDate: all cashflows are discounted to this date. If missing it is assumed equal to the settlement date Default value = Date[]."
LegConvexity::usage = "LegConvexity[ObjectIdId_Symbol,Yield_?NumberQ] Returns the Cash-flow convexity for the given Leg object.
      \nObjectId: id of existing QuantLib::Leg object\nYield: Yield (a.k.a. IRR).\nDayCounter: Yield DayCounter ID. Default value = Actual/Actual (ISDA).\nCompounding: Interest rate coumpounding rule (Simple:1+rt, Compounded:(1+r)^t, Continuous:e^{rt}). Default value = Compounded.\nFrequency: frequency (e.g. Annual, Semiannual, Every4Month, Quarterly, Bimonthly, Monthly). Default value = Annual.\nIncludeSettlDate: TRUE if cashflows paid at the settlement date must be taken into account. Default value = true.\nSettlementDate: cashflows before this date are not taken into account. Default value = Date[].\nNpvDate: all cashflows are discounted to this date. If missing it is assumed equal to the settlement date Default value = Date[]."
LegDuration::usage = "LegDuration[ObjectIdId_Symbol,Yield_?NumberQ] Returns the Cash-flow duration for the given Leg object.
      \nObjectId: id of existing QuantLib::Leg object\nYield: Yield (a.k.a. IRR).\nDayCounter: Yield DayCounter ID. Default value = Actual/Actual (ISDA).\nCompounding: Interest rate coumpounding rule (Simple:1+rt, Compounded:(1+r)^t, Continuous:e^{rt}). Default value = Compounded.\nFrequency: frequency (e.g. Annual, Semiannual, Every4Month, Quarterly, Bimonthly, Monthly). Default value = Annual.\nDurationType: Duration type (Simple, Macaulay, or Modified). Default value = Modified.\nIncludeSettlDate: TRUE if cashflows paid at the settlement date must be taken into account. Default value = true.\nSettlementDate: cashflows before this date are not taken into account. Default value = Date[].\nNpvDate: all cashflows are discounted to this date. If missing it is assumed equal to the settlement date Default value = Date[]."
LegFlowAnalysis::usage = "LegFlowAnalysis[ObjecctId_Symbol] Returns the flow analysis for the given Leg object.
      \nObjectId: id of existing QuantLibAddin::Leg object"
LegFromCapFloor::usage = "LegFromCapFloor[ObjecctId_Symbol,CapFloor_Symbol] Construct an object of class Leg and return its id
      \nObjectId: id of object to be created\nCapFloor: CapFloor object ID.\nPermanent: object permanent/nonpermanent"
LegIsExpired::usage = "LegIsExpired[ObjectIdId_Symbol] Returns TRUE is the Leg is expired
      \nObjectId: id of existing QuantLib::Leg object\nIncludeSettlDate: TRUE if cashflows paid at the settlement date must be taken into account. Default value = true.\nSettlementDate: cashflows before this date are not taken into account. Default value = Date[]."
LegMaturityDate::usage = "LegMaturityDate[ObjectIdId_Symbol] Returns the maturity (i.e. last payment) date for the given Leg object.
      \nObjectId: id of existing QuantLib::Leg object"
LegNPV::usage = "LegNPV[ObjectIdId_Symbol,DiscountCurveId_Symbol] Returns the net present value for the given Leg object.
      \nObjectId: id of existing QuantLib::Leg object\nDiscountCurve: discounting YieldTermStructure object ID.\nIncludeSettlDate: TRUE if cashflows paid at the settlement date must be taken into account. Default value = true.\nSettlementDate: cashflows before this date are not taken into account. Default value = Date[].\nNpvDate: all cashflows are discounted to this date. If missing it is assumed equal to the settlement date Default value = Date[]."
LegNPVFromYield::usage = "LegNPVFromYield[ObjectIdId_Symbol,Yield_?NumberQ] Returns the net present value for the given Leg object.
      \nObjectId: id of existing QuantLib::Leg object\nYield: Yield (a.k.a. IRR).\nDayCounter: Yield DayCounter ID. Default value = Actual/Actual (ISDA).\nCompounding: Interest rate coumpounding rule (Simple:1+rt, Compounded:(1+r)^t, Continuous:e^{rt}). Default value = Compounded.\nFrequency: frequency (e.g. Annual, Semiannual, Every4Month, Quarterly, Bimonthly, Monthly). Default value = Annual.\nIncludeSettlDate: TRUE if cashflows paid at the settlement date must be taken into account. Default value = true.\nSettlementDate: cashflows before this date are not taken into account. Default value = Date[].\nNpvDate: all cashflows are discounted to this date. If missing it is assumed equal to the settlement date Default value = Date[]."
LegNPVFromZSpread::usage = "LegNPVFromZSpread[ObjectIdId_Symbol,DiscountCurve_Symbol,ZSpread_?NumberQ] Returns the net present value for the given Leg object.
      \nObjectId: id of existing QuantLib::Leg object\nDiscountCurve: discounting YieldTermStructure object ID.\nZSpread: Z-spread.\nDayCounter: Yield DayCounter ID. Default value = Actual/Actual (ISDA).\nCompounding: Interest rate coumpounding rule (Simple:1+rt, Compounded:(1+r)^t, Continuous:e^{rt}). Default value = Compounded.\nFrequency: frequency (e.g. Annual, Semiannual, Every4Month, Quarterly, Bimonthly, Monthly). Default value = Annual.\nIncludeSettlDate: TRUE if cashflows paid at the settlement date must be taken into account. Default value = true.\nSettlementDate: cashflows before this date are not taken into account. Default value = Date[].\nNpvDate: all cashflows are discounted to this date. If missing it is assumed equal to the settlement date Default value = Date[]."
LegNextCashFlowAmount::usage = "LegNextCashFlowAmount[ObjectIdId_Symbol] Returns the next cash flow amount.
      \nObjectId: id of existing QuantLib::Leg object\nIncludeSettlDate: TRUE if cashflows paid at the settlement date must be taken into account. Default value = true.\nSettlementDate: cashflows before this date are not taken into account. Default value = Date[]."
LegNextCashFlowDate::usage = "LegNextCashFlowDate[ObjectIdId_Symbol] Returns the next cash flow date.
      \nObjectId: id of existing QuantLib::Leg object\nIncludeSettlDate: TRUE if cashflows paid at the settlement date must be taken into account. Default value = true.\nSettlementDate: cashflows before this date are not taken into account. Default value = Date[]."
LegNextCouponRate::usage = "LegNextCouponRate[ObjectIdId_Symbol] Returns the next coupon rate. Depending on (the Leg and) the given date it can be historic, deterministic or expected in a stochastic sense. When the current date is used the coupon is the already-fixed not-yet-paid one.
      \nObjectId: id of existing QuantLib::Leg object\nIncludeSettlDate: TRUE if cashflows paid at the settlement date must be taken into account. Default value = true.\nSettlementDate: cashflows before this date are not taken into account. Default value = Date[]."
LegPreviousCashFlowAmount::usage = "LegPreviousCashFlowAmount[ObjectIdId_Symbol] Returns the previous cash flow amount.
      \nObjectId: id of existing QuantLib::Leg object\nIncludeSettlDate: TRUE if cashflows paid at the settlement date must be taken into account. Default value = true.\nSettlementDate: cashflows before this date are not taken into account. Default value = Date[]."
LegPreviousCashFlowDate::usage = "LegPreviousCashFlowDate[ObjectIdId_Symbol] Returns the previous cash flow date.
      \nObjectId: id of existing QuantLib::Leg object\nIncludeSettlDate: TRUE if cashflows paid at the settlement date must be taken into account. Default value = true.\nSettlementDate: cashflows before this date are not taken into account. Default value = Date[]."
LegPreviousCouponRate::usage = "LegPreviousCouponRate[ObjectIdId_Symbol] Returns the previous coupon rate. Depending on (the Leg and) the given date it can be historic, deterministic or expected in a stochastic sense. When the current date is used the coupon is the last paid one.
      \nObjectId: id of existing QuantLib::Leg object\nIncludeSettlDate: TRUE if cashflows paid at the settlement date must be taken into account. Default value = true.\nSettlementDate: cashflows before this date are not taken into account. Default value = Date[]."
LegReferencePeriodEnd::usage = "LegReferencePeriodEnd[ObjectIdId_Symbol] Returns the reference period end date for the current coupon of the given Leg.
      \nObjectId: id of existing QuantLib::Leg object\nIncludeSettlDate: TRUE if cashflows paid at the settlement date must be taken into account. Default value = true.\nSettlementDate: cashflows before this date are not taken into account. Default value = Date[]."
LegReferencePeriodStart::usage = "LegReferencePeriodStart[ObjectIdId_Symbol] Returns the reference period start date for the current coupon of the given Leg.
      \nObjectId: id of existing QuantLib::Leg object\nIncludeSettlDate: TRUE if cashflows paid at the settlement date must be taken into account. Default value = true.\nSettlementDate: cashflows before this date are not taken into account. Default value = Date[]."
LegSetCouponPricers::usage = "LegSetCouponPricers[ObjecctId_Symbol,FloatingRateCouponPricer_] Set the coupon pricer at the given Leg object.
      \nObjectId: id of existing QuantLibAddin::Leg object\nFloatingRateCouponPricer: FloatingRate coupon pricer object ID."
LegStartDate::usage = "LegStartDate[ObjectIdId_Symbol] Returns the start (i.e. first accrual) date for the given Leg object.
      \nObjectId: id of existing QuantLib::Leg object"
LegYield::usage = "LegYield[ObjectIdId_Symbol,NPV_?NumberQ,DayCounter_String] Returns the Internal rate of return for the given Leg object.
      \nObjectId: id of existing QuantLib::Leg object\nNPV: Net present (dirty) value.\nDayCounter: Irr DayCounter ID.\nCompounding: Interest rate coumpounding rule (Simple:1+rt, Compounded:(1+r)^t, Continuous:e^{rt}). Default value = Continuous.\nFrequency: frequency (e.g. Annual, Semiannual, Every4Month, Quarterly, Bimonthly, Monthly). Default value = Annual.\nIncludeSettlDate: TRUE if cashflows paid at the settlement date must be taken into account. Default value = true.\nSettlementDate: cashflows before this date are not taken into account. Default value = Date[].\nNpvDate: all cashflows are discounted to this date. If missing it is assumed equal to the settlement date Default value = Date[].\nAccuracy: tolerance. Default value = 1.0e-10.\nMaxIterations: max number of iterations. Default value = 100.\nGuess: guess. Default value = 0.05."
LegYieldValueBasisPoint::usage = "LegYieldValueBasisPoint[ObjectIdId_Symbol,Yield_?NumberQ] Returns the yieldValueBasisPoint for the given Leg object.
      \nObjectId: id of existing QuantLib::Leg object\nYield: Yield (a.k.a. IRR).\nDayCounter: Yield DayCounter ID. Default value = Actual/Actual (ISDA).\nCompounding: Interest rate coumpounding rule (Simple:1+rt, Compounded:(1+r)^t, Continuous:e^{rt}). Default value = Compounded.\nFrequency: frequency (e.g. Annual, Semiannual, Every4Month, Quarterly, Bimonthly, Monthly). Default value = Annual.\nIncludeSettlDate: TRUE if cashflows paid at the settlement date must be taken into account. Default value = true.\nSettlementDate: cashflows before this date are not taken into account. Default value = Date[].\nNpvDate: all cashflows are discounted to this date. If missing it is assumed equal to the settlement date Default value = Date[]."
LegZSpread::usage = "LegZSpread[ObjectIdId_Symbol,NPV_?NumberQ,DiscountCurve_Symbol,DayCounter_String] Returns the z-spread for the given Leg object.
      \nObjectId: id of existing QuantLib::Leg object\nNPV: Net present (dirty) value.\nDiscountCurve: discounting YieldTermStructure object ID.\nDayCounter: Irr DayCounter ID.\nCompounding: Interest rate coumpounding rule (Simple:1+rt, Compounded:(1+r)^t, Continuous:e^{rt}). Default value = Continuous.\nFrequency: frequency (e.g. Annual, Semiannual, Every4Month, Quarterly, Bimonthly, Monthly). Default value = Annual.\nIncludeSettlDate: TRUE if cashflows paid at the settlement date must be taken into account. Default value = true.\nSettlementDate: cashflows before this date are not taken into account. If missing it defaults to the current evaluation date. Default value = Date[].\nNpvDate: all cashflows are discounted to this date. If missing it is assumed equal to the settlement date Default value = Date[].\nAccuracy: tolerance. Default value = 1.0e-10.\nMaxIterations: max number of iterations. Default value = 100.\nGuess: guess. Default value = 0.0."
MultiPhaseLeg::usage = "MultiPhaseLeg[ObjecctId_Symbol,LegIDs_List] Construct an object of class MultiPhaseLeg and return its id
      \nObjectId: id of object to be created\nLegIDs: leg object IDs, one for each phase.\nToBeSorted: TRUE if the CashFlows must be sorted by ascending dates. Default value = true.\nPermanent: object permanent/nonpermanent"
Category[QLLeg] = {InterestRate,InterestRateCompoundFactor,InterestRateCompounding,InterestRateDayCounter,InterestRateDiscountFactor,InterestRateEquivalentRate,InterestRateFrequency,InterestRateImpliedRate,InterestRateRate,Leg,LegAccrualDays,LegAccrualEndDate,LegAccrualPeriod,LegAccrualStartDate,LegAccruedAmount,LegAccruedDays,LegAccruedPeriod,LegAtmRate,LegBPS,LegBPSFromYield,LegBasisPointValue,LegConvexity,LegDuration,LegFlowAnalysis,LegFromCapFloor,LegIsExpired,LegMaturityDate,LegNPV,LegNPVFromYield,LegNPVFromZSpread,LegNextCashFlowAmount,LegNextCashFlowDate,LegNextCouponRate,LegPreviousCashFlowAmount,LegPreviousCashFlowDate,LegPreviousCouponRate,LegReferencePeriodEnd,LegReferencePeriodStart,LegSetCouponPricers,LegStartDate,LegYield,LegYieldValueBasisPoint,LegZSpread,MultiPhaseLeg};
AppendTo[QLCategories,Leg]

(* Market Model Evolvers *)

MarketModelEvolvers::usage = "functions to construct and use Market Model Evolvers objects."

ForwardRateIpc::usage = "ForwardRateIpc[ObjecctId_Symbol,MarketModel_Symbol,BrownianGeneratorFactoryId_Symbol,Numeraires_List /; VectorQ[Numeraires, IntegerQ]] Construct an object of class LogNormalFwdRateIpc and return its id
      \nObjectId: id of object to be created\nMarketModel: MarketModel object ID.\nBrownianGeneratorFactory: Brownian generator factory.\nNumeraires: numeraire vector.\nPermanent: object permanent/nonpermanent"
ForwardRateNormalPc::usage = "ForwardRateNormalPc[ObjecctId_Symbol,MarketModel_Symbol,BrownianGeneratorFactoryId_Symbol,Numeraires_List /; VectorQ[Numeraires, IntegerQ]] Construct an object of class NormalFwdRatePc and return its id
      \nObjectId: id of object to be created\nMarketModel: MarketModel object ID.\nBrownianGeneratorFactory: Brownian generator factory.\nNumeraires: numeraire vector.\nPermanent: object permanent/nonpermanent"
ForwardRatePc::usage = "ForwardRatePc[ObjecctId_Symbol,MarketModel_Symbol,BrownianGeneratorFactoryId_Symbol,Numeraires_List /; VectorQ[Numeraires, IntegerQ]] Construct an object of class LogNormalFwdRatePc and return its id
      \nObjectId: id of object to be created\nMarketModel: MarketModel object ID.\nBrownianGeneratorFactory: Brownian generator factory.\nNumeraires: numeraire vector.\nPermanent: object permanent/nonpermanent"
MarketModelEvolverAdvanceStep::usage = "MarketModelEvolverAdvanceStep[ObjecctId_Symbol] advance a single step in the current path for the MarketModelEvolver object.
      \nObjectId: id of existing QuantLib::MarketModelEvolver object"
MarketModelEvolverCurrentStep::usage = "MarketModelEvolverCurrentStep[ObjecctId_Symbol] returns the current step index in the current path for the MarketModelEvolver object.
      \nObjectId: id of existing QuantLib::MarketModelEvolver object"
MarketModelEvolverNumeraires::usage = "MarketModelEvolverNumeraires[ObjecctId_Symbol] returns the current step index in the current path for the MarketModelEvolver object.
      \nObjectId: id of existing QuantLib::MarketModelEvolver object"
MarketModelEvolverStartNewPath::usage = "MarketModelEvolverStartNewPath[ObjecctId_Symbol] start a new path for the MarketModelEvolver object.
      \nObjectId: id of existing QuantLib::MarketModelEvolver object"
Category[MarketModelEvolvers] = {ForwardRateIpc,ForwardRateNormalPc,ForwardRatePc,MarketModelEvolverAdvanceStep,MarketModelEvolverCurrentStep,MarketModelEvolverNumeraires,MarketModelEvolverStartNewPath};
AppendTo[QLCategories,MarketModelEvolvers]

(* MarketModels *)

MarketModels::usage = "functions to construct and use Market Models related objects."

AbcdVol::usage = "AbcdVol[ObjecctId_Symbol,A_?NumberQ,B_?NumberQ,C_?NumberQ,D_?NumberQ,Ks_List /; VectorQ[Ks, NumberQ],Correlations_Symbol,EvolutionDescriptionId_Symbol,Factors_Integer,InitialRates_List /; VectorQ[InitialRates, NumberQ],Displacements_List /; VectorQ[Displacements, NumberQ]] Construct an object of class AbcdVol and return its id
      \nObjectId: id of object to be created\nA: the a coefficient in the abcd vol parametrization.\nB: the b coefficient in the abcd vol parametrization.\nC: the c coefficient in the abcd vol parametrization.\nD: the d coefficient in the abcd vol parametrization.\nKs: K_i adjustment factors in the abcd vol parametrization.\nCorrelations: PiecewiseConstantCorrelation object ID.\nEvolutionDescription: EvolutionDescription object.\nFactors: number of factors to be retained in the simulation.\nInitialRates: initial rates.\nDisplacements: displacements.\nPermanent: object permanent/nonpermanent"
QLAnnuity::usage = "QLAnnuity[CurveStateId_Symbol,StartIndex_Integer,EndIndex_Integer] returns annuity of arbitrary swap-rate.
      \nCurveState: CurveState object ID.\nStartIndex: start index.\nEndIndex: end index.\nNumeraireIndex: numeraire index. Default value = 0."
CmSwapForwardJacobian::usage = "CmSwapForwardJacobian[CurveStateId_Symbol,SpanningForwards_Integer] Returns the jacobian between constant maturity swap rates and forward rates.
      \nCurveState: CurveState object ID.\nSpanningForwards: number of forwards underlying the CMS."
CmSwapZedMatrix::usage = "CmSwapZedMatrix[CurveStateId_Symbol,SpanningForwards_Integer] Returns the Z matrix to switch base from forward to constant maturity swap rates.
      \nCurveState: CurveState object ID.\nSpanningForwards: number of forwards underlying the CMS.\nDisplacement: displacement. Default value = 0.0."
CoinitialSwapForwardJacobian::usage = "CoinitialSwapForwardJacobian[CurveStateId_Symbol] Returns the jacobian between coinitial swap rates and forward rates.
      \nCurveState: CurveState object ID."
CoinitialSwapZedMatrix::usage = "CoinitialSwapZedMatrix[CurveStateId_Symbol] Returns the Z matrix to switch base from forward to coinitial swap rates.
      \nCurveState: CurveState object ID.\nDisplacement: displacement. Default value = 0.0."
CotSwapToFwdAdapter::usage = "CotSwapToFwdAdapter[ObjecctId_Symbol,CoterminalModel_Symbol] Construct an object of class CotSwapToFwdAdapter and return its id
      \nObjectId: id of object to be created\nCoterminalModel: CoTerminal Swap Market Model ID.\nPermanent: object permanent/nonpermanent"
CoterminalSwapForwardJacobian::usage = "CoterminalSwapForwardJacobian[CurveStateId_Symbol] Returns the jacobian between coterminal swap rates and forward rates.
      \nCurveState: CurveState object ID."
CoterminalSwapZedMatrix::usage = "CoterminalSwapZedMatrix[CurveStateId_Symbol] Returns the Z matrix to switch base from forward to coterminal swap rates.
      \nCurveState: CurveState object ID.\nDisplacement: displacement. Default value = 0.0."
FlatVol::usage = "FlatVol[ObjecctId_Symbol,Volatilities_List /; VectorQ[Volatilities, NumberQ],Correlations_Symbol,EvolutionDescriptionId_Symbol,Factors_Integer,InitialRates_List /; VectorQ[InitialRates, NumberQ],Displacements_List /; VectorQ[Displacements, NumberQ]] Construct an object of class FlatVol and return its id
      \nObjectId: id of object to be created\nVolatilities: volatilities.\nCorrelations: PiecewiseConstantCorrelation object ID.\nEvolutionDescription: EvolutionDescription object.\nFactors: number of factors to be retained in the simulation.\nInitialRates: initial rates.\nDisplacements: displacements.\nPermanent: object permanent/nonpermanent"
FlatVolFactory::usage = "FlatVolFactory[ObjecctId_Symbol,LongTermCorr_?NumberQ,Beta_?NumberQ,Times_List /; VectorQ[Times, NumberQ],Volatilities_List /; VectorQ[Volatilities, NumberQ],YieldCurve_Symbol] Construct an object of class FlatVolFactory and return its id
      \nObjectId: id of object to be created\nLongTermCorr: Long term correlation L in rho=L+(1-L)*exp(-beta*abs(Ti-Tj)).\nBeta: beta in rho=L+(1-L)*exp(-beta*abs(Ti-Tj)).\nTimes: times.\nVolatilities: volatilities.\nYieldCurve: discounting yield term structure object ID.\nDisplacement: displacement. Default value = 0.0.\nPermanent: object permanent/nonpermanent"
FwdPeriodAdapter::usage = "FwdPeriodAdapter[ObjecctId_Symbol,LargeModel_Symbol,Period_Integer,Offset_Integer,Displacements_List /; VectorQ[Displacements, NumberQ]] Construct an object of class FwdPeriodAdapter and return its id
      \nObjectId: id of object to be created\nLargeModel: large MarketModel ID.\nPeriod: target period (e.g. 2 if going from semiannual LMM to annual LMM).\nOffset: rate index offset, in order to pin down swaption coterminal to the last rate time.\nDisplacements: displacements.\nPermanent: object permanent/nonpermanent"
FwdToCotSwapAdapter::usage = "FwdToCotSwapAdapter[ObjecctId_Symbol,ForwardModel_Symbol] Construct an object of class FwdToCotSwapAdapter and return its id
      \nObjectId: id of object to be created\nForwardModel: Forward Rate Market Model ID.\nPermanent: object permanent/nonpermanent"
MarketModelCovariance::usage = "MarketModelCovariance[ObjecctId_Symbol,Index_Integer] Returns the covariance matrix for the i-th step.
      \nObjectId: id of existing QuantLib::MarketModel object\nIndex: evolution step index."
MarketModelDisplacements::usage = "MarketModelDisplacements[ObjecctId_Symbol] rates' displacemets for the MarketModel object.
      \nObjectId: id of existing QuantLib::MarketModel object"
MarketModelInitialRates::usage = "MarketModelInitialRates[ObjecctId_Symbol] initial rates for the MarketModel object.
      \nObjectId: id of existing QuantLib::MarketModel object"
MarketModelNumberOfFactors::usage = "MarketModelNumberOfFactors[ObjecctId_Symbol] number of factors for the MarketModel object.
      \nObjectId: id of existing QuantLib::MarketModel object"
MarketModelNumberOfRates::usage = "MarketModelNumberOfRates[ObjecctId_Symbol] number of rates for the MarketModel object.
      \nObjectId: id of existing QuantLib::MarketModel object"
MarketModelNumberOfSteps::usage = "MarketModelNumberOfSteps[ObjecctId_Symbol] number of steps for the MarketModel object.
      \nObjectId: id of existing QuantLib::MarketModel object"
MarketModelPseudoRoot::usage = "MarketModelPseudoRoot[ObjecctId_Symbol,Index_Integer] Returns the pseudo root for the i-th step.
      \nObjectId: id of existing QuantLib::MarketModel object\nIndex: evolution step index."
MarketModelTimeDependentVolatility::usage = "MarketModelTimeDependentVolatility[ObjecctId_Symbol,Index_Integer] Returns the time dependent vol for rate i.
      \nObjectId: id of existing QuantLib::MarketModel object\nIndex: rate index."
MarketModelTotalCovariance::usage = "MarketModelTotalCovariance[ObjecctId_Symbol,Index_Integer] Returns the covariance matrix from start up to the i-th step.
      \nObjectId: id of existing QuantLib::MarketModel object\nIndex: evolution step index."
PseudoRootFacade::usage = "PseudoRootFacade[ObjecctId_Symbol,Calibrator_Symbol] Construct an object of class PseudoRootFacade and return its id
      \nObjectId: id of object to be created\nCalibrator: CTSMMCapletCalibration ID.\nPermanent: object permanent/nonpermanent"
RateInstVolDifferences::usage = "RateInstVolDifferences[MarketModel1Id_Symbol,MarketModel2Id_Symbol,Index_Integer] Compute the differences between volatilities at each evolution step.
      \nMarketModel1: First Market Model.\nMarketModel2: Second Market Model.\nIndex: Forward Rate index."
RateVolDifferences::usage = "RateVolDifferences[MarketModel1Id_Symbol,MarketModel2Id_Symbol] Compute the differences between all implied forwards volatilities.
      \nMarketModel1: First Market Model.\nMarketModel2: Second Market Model."
SwapDerivative::usage = "SwapDerivative[CurveStateId_Symbol,StartIndex_Integer,EndIndex_Integer] returns derivative of swap-rate to underlying forward rate.
      \nCurveState: CurveState object ID.\nStartIndex: start index.\nEndIndex: end index.\nFwdRateIndex: forward rate index. Default value = 0."
Category[MarketModels] = {AbcdVol,QLAnnuity,CmSwapForwardJacobian,CmSwapZedMatrix,CoinitialSwapForwardJacobian,CoinitialSwapZedMatrix,CotSwapToFwdAdapter,CoterminalSwapForwardJacobian,CoterminalSwapZedMatrix,FlatVol,FlatVolFactory,FwdPeriodAdapter,FwdToCotSwapAdapter,MarketModelCovariance,MarketModelDisplacements,MarketModelInitialRates,MarketModelNumberOfFactors,MarketModelNumberOfRates,MarketModelNumberOfSteps,MarketModelPseudoRoot,MarketModelTimeDependentVolatility,MarketModelTotalCovariance,PseudoRootFacade,RateInstVolDifferences,RateVolDifferences,SwapDerivative};
AppendTo[QLCategories,MarketModels]

(* Math *)

Math::usage = "Math utility functions."

CholeskyDecomposition::usage = "CholeskyDecomposition[Matrix_?MatrixQ] Returns the Cholesky decomposition of a real symmetric matrix.
      \nMatrix: symmetric matrix (hopefully positive semi-definite at least).\nFlexible: If TRUE it returns a result also for positive semi-definite matrix. Default value = false."
CovarianceDecomposition::usage = "CovarianceDecomposition[ObjecctId_Symbol,SymmetricMatrix_?MatrixQ] Construct an object of class CovarianceDecomposition and return its id
      \nObjectId: id of object to be created\nSymmetricMatrix: Symmetrix covariance matrix to be decomposed.\nTolerance: numerical tolerance for non symmetric matrix. Default value = 1.0e12.\nPermanent: object permanent/nonpermanent"
CovarianceDecompositionCorrelationMatrix::usage = "CovarianceDecompositionCorrelationMatrix[ObjecctId_Symbol] Returns the correlation matrix for the given CovarianceDecomposition object.
      \nObjectId: id of existing QuantLib::CovarianceDecomposition object"
CovarianceDecompositionStandardDeviations::usage = "CovarianceDecompositionStandardDeviations[ObjecctId_Symbol] Returns the standard deviation (i.e. volatility times square root of time) vector for the given CovarianceDecomposition object.
      \nObjectId: id of existing QuantLib::CovarianceDecomposition object"
CovarianceDecompositionVariances::usage = "CovarianceDecompositionVariances[ObjecctId_Symbol] Returns the variance vector for the given CovarianceDecomposition object.
      \nObjectId: id of existing QuantLib::CovarianceDecomposition object"
GetCovariance::usage = "GetCovariance[Vols_List /; VectorQ[Vols, NumberQ],Matrix_?MatrixQ] Returns the covariance matrix generated using the correlation matrix and the standard deviation (i.e. volatility times square root of time) array.
      \nVols: volatility vector.\nMatrix: symmetric matrix (hopefully positive semi-definite at least).\nTolerance: numerical tolerance for non symmetric matrix. Default value = 1.0e12."
NormDist::usage = "NormDist[X_?NumberQ] Returns the normal cumulative distribution for the specified mean and standard deviation.
      \nX: is the value for which you want the distribution.\nMean: is the arithmetic mean of the distribution. Default value = 0.0.\nStandardDev: is the standard deviation of the distribution, a positive number. Default value = 1.0.\nCumulative: is a logical value: for the cumulative distribution function, use TRUE; for the probability mass function, use FALSE. Default value = TRUE."
NormInv::usage = "NormInv[Probability_?NumberQ] Returns the inverse of the normal cumulative distribution for the specified mean and standard deviation.
      \nProbability: is a probability corresponding to the normal distribution, a number between 0 and 1 inclusive.\nMean: is the arithmetic mean of the distribution. Default value = 0.0.\nStandardDev: is the standard deviation of the distribution, a positive number. Default value = 1.0."
NormSDist::usage = "NormSDist[Z_?NumberQ] Returns the standard normal cumulative distribution (has a mean of zero and standard deviation of one).
      \nZ: is the value for which you want the distribution."
NormSInv::usage = "NormSInv[Probability_?NumberQ] Returns the inverse of the standard normal cumulative distribution (has a mean of zero and standard deviation of one).
      \nProbability: is a probability corresponding to the normal distribution, a number between 0 and 1 inclusive."
PrimeNumber::usage = "PrimeNumber[N_Integer] returns the N-th prime number.
      \nN: index of the prime number (e.g N=2 returns 3)."
PseudoSqrt::usage = "PseudoSqrt[Matrix_?MatrixQ,SalvagingAlgorithm_String] Returns the pseudo square root of a real symmetric matrix.
      \nMatrix: symmetric matrix (hopefully positive semi-definite at least).\nSalvagingAlgorithm: Salvaging algorithm for symmetric matrix not positive semi-definite (None, Spectral)."
RankReducedSqrt::usage = "RankReducedSqrt[Matrix_?MatrixQ,MaxRank_Integer,ComponentPercentage_?NumberQ,SalvagingAlgorithm_String] Returns the rank reduced pseudo square root of a real symmetric matrix.
      \nMatrix: symmetric matrix (hopefully positive semi-definite at least).\nMaxRank: number of principal components retained, i.e. max rank for the result matrix.\nComponentPercentage: principal components retained as percentage of eigenvalues' sum.\nSalvagingAlgorithm: Salvaging algorithm for symmetric matrix not positive semi-definite (None, Spectral)."
SymmetricSchurDecomposition::usage = "SymmetricSchurDecomposition[ObjecctId_Symbol,SymmetricMatrix_?MatrixQ] Construct an object of class SymmetricSchurDecomposition and return its id
      \nObjectId: id of object to be created\nSymmetricMatrix: Symmetrix matrix to be decomposed.\nPermanent: object permanent/nonpermanent"
SymmetricSchurDecompositionEigenvalues::usage = "SymmetricSchurDecompositionEigenvalues[ObjecctId_Symbol] Returns the eigenvalues for the given SymmetricSchurDecomposition object.
      \nObjectId: id of existing QuantLib::SymmetricSchurDecomposition object"
SymmetricSchurDecompositionEigenvectors::usage = "SymmetricSchurDecompositionEigenvectors[ObjecctId_Symbol] Returns the eigenvectors  for the given SymmetricSchurDecomposition object. Eigenvectors are returned columnwise.
      \nObjectId: id of existing QuantLib::SymmetricSchurDecomposition object"
Category[Math] = {CholeskyDecomposition,CovarianceDecomposition,CovarianceDecompositionCorrelationMatrix,CovarianceDecompositionStandardDeviations,CovarianceDecompositionVariances,GetCovariance,NormDist,NormInv,NormSDist,NormSInv,PrimeNumber,PseudoSqrt,RankReducedSqrt,SymmetricSchurDecomposition,SymmetricSchurDecompositionEigenvalues,SymmetricSchurDecompositionEigenvectors};
AppendTo[QLCategories,Math]

(* Optimization *)

Optimization::usage = "functions to construct and use Optimization objects."

ArmijoLineSearch::usage = "ArmijoLineSearch[ObjecctId_Symbol] Construct an object of class ArmijoLineSearch and return its id
      \nObjectId: id of object to be created\nEpsilon: epsilon. Default value = 1e-8.\nAlpha: alpha. Default value = 0.05.\nBeta: beta. Default value = 0.65.\nPermanent: object permanent/nonpermanent"
ConjugateGradient::usage = "ConjugateGradient[ObjecctId_Symbol] Construct an object of class ConjugateGradient and return its id
      \nObjectId: id of object to be created\nLineSearch: LineSearch object ID. Default value = .\nPermanent: object permanent/nonpermanent"
EndCriteria::usage = "EndCriteria[ObjecctId_Symbol,MaxIterations_Integer,MaxStationaryStateIterations_Integer,RootEpsilon_?NumberQ,FunctionEpsilon_?NumberQ,GradientNormEpsilon_?NumberQ] Construct an object of class EndCriteria and return its id
      \nObjectId: id of object to be created\nMaxIterations: max number of iterations.\nMaxStationaryStateIterations: max number of iterations in a stationary state.\nRootEpsilon: tolerance on the root value.\nFunctionEpsilon: tolerance on the function value.\nGradientNormEpsilon: tolerance on the function gradient norm value.\nPermanent: object permanent/nonpermanent"
EndCriteriaFunctionEpsilon::usage = "EndCriteriaFunctionEpsilon[ObjecctId_Symbol] Returns the function epsilon for the given EndCriteria object.
      \nObjectId: id of existing QuantLib::EndCriteria object"
EndCriteriaGradientNormEpsilon::usage = "EndCriteriaGradientNormEpsilon[ObjecctId_Symbol] Returns the gradient norm epsilon for the given EndCriteria object.
      \nObjectId: id of existing QuantLib::EndCriteria object"
EndCriteriaMaxIterations::usage = "EndCriteriaMaxIterations[ObjecctId_Symbol] Returns the number of max interation for the given EndCriteria object.
      \nObjectId: id of existing QuantLib::EndCriteria object"
EndCriteriaMaxStationaryStateIterations::usage = "EndCriteriaMaxStationaryStateIterations[ObjecctId_Symbol] Returns the number of max interation in a stationary state for the given EndCriteria object.
      \nObjectId: id of existing QuantLib::EndCriteria object"
LevenbergMarquardt::usage = "LevenbergMarquardt[ObjecctId_Symbol] Construct an object of class LevenbergMarquardt and return its id
      \nObjectId: id of object to be created\nEpsfcn: epsfcn. Default value = 1.0e-8.\nXtol: xtol. Default value = 1.0e-8.\nGtol: gtol. Default value = 1.0e-8.\nPermanent: object permanent/nonpermanent"
SecondsToString::usage = "SecondsToString[Seconds_?NumberQ] returns a hh:mm:ss string from the number of seconds provided as input.
      \nSeconds: number of seconds."
Simplex::usage = "Simplex[ObjecctId_Symbol,Lambda_?NumberQ] Construct an object of class Simplex and return its id
      \nObjectId: id of object to be created\nLambda: lambda (typical scale length of the problem).\nPermanent: object permanent/nonpermanent"
SphereCylinderOptimizerClosest::usage = "SphereCylinderOptimizerClosest[R_?NumberQ,S_?NumberQ,Alpha_?NumberQ,Z1_?NumberQ,Z2_?NumberQ,Z3_?NumberQ,MaxIter_Integer,Tol_?NumberQ] Sphere Cylinder Optimizer Closest.
      \nR: r.\nS: s.\nAlpha: alpha.\nZ1: z1.\nZ2: z2.\nZ3: z3.\nMaxIter: maxIter.\nTol: tolerance."
SteepestDescent::usage = "SteepestDescent[ObjecctId_Symbol] Construct an object of class SteepestDescent and return its id
      \nObjectId: id of object to be created\nLineSearch: LineSearch object ID. Default value = .\nPermanent: object permanent/nonpermanent"
Category[Optimization] = {ArmijoLineSearch,ConjugateGradient,EndCriteria,EndCriteriaFunctionEpsilon,EndCriteriaGradientNormEpsilon,EndCriteriaMaxIterations,EndCriteriaMaxStationaryStateIterations,LevenbergMarquardt,SecondsToString,Simplex,SphereCylinderOptimizerClosest,SteepestDescent};
AppendTo[QLCategories,Optimization]

(* Options *)

Options::usage = "functions to construct and use Option objects."

BarrierOption::usage = "BarrierOption[ObjecctId_Symbol,BarrierType_String,Barrier_?NumberQ,Rebate_?NumberQ,Payoff_Symbol,Exercise_Symbol] Construct an object of class BarrierOption and return its id
      \nObjectId: id of object to be created\nBarrierType: barrier type.\nBarrier: barrier.\nRebate: rebate.\nPayoff: StrikedTypePayoff object ID.\nExercise: Exercise object ID.\nPermanent: object permanent/nonpermanent"
CaAsianOption::usage = "CaAsianOption[ObjecctId_Symbol,AverageType_String,Payoff_Symbol,Exercise_Symbol] Construct an object of class ContinuousAveragingAsianOption and return its id
      \nObjectId: id of object to be created\nAverageType: average type.\nPayoff: StrikedTypePayoff object ID.\nExercise: Exercise object ID.\nPermanent: object permanent/nonpermanent"
DaAsianOption::usage = "DaAsianOption[ObjecctId_Symbol,AverageType_String,RunningAccumulator_?NumberQ,PastFixings_Integer,FixingDates_List,Payoff_Symbol,Exercise_Symbol] Construct an object of class DiscreteAveragingAsianOption and return its id
      \nObjectId: id of object to be created\nAverageType: average type.\nRunningAccumulator: running accumulator.\nPastFixings: past fixings.\nFixingDates: fixing dates.\nPayoff: StrikedTypePayoff object ID.\nExercise: Exercise object ID.\nPermanent: object permanent/nonpermanent"
Delta::usage = "Delta[ObjecctId_Symbol] delta of an option.
      \nObjectId: id of existing QuantLib::OneAssetOption object"
DeltaForward::usage = "DeltaForward[ObjecctId_Symbol] delta forward of an option.
      \nObjectId: id of existing QuantLib::OneAssetOption object"
DividendRho::usage = "DividendRho[ObjecctId_Symbol] dividend rho of an option.
      \nObjectId: id of existing QuantLib::OneAssetOption object"
DividendVanillaOption::usage = "DividendVanillaOption[ObjecctId_Symbol,Payoff_Symbol,Exercise_Symbol,DividendDates_List,Dividends_List /; VectorQ[Dividends, NumberQ]] Construct an object of class DividendVanillaOption and return its id
      \nObjectId: id of object to be created\nPayoff: StrikedTypePayoff object ID.\nExercise: Exercise object ID.\nDividendDates: vector of dividend dates.\nDividends: vector of dividends.\nPermanent: object permanent/nonpermanent"
Elasticity::usage = "Elasticity[ObjecctId_Symbol] elasticity of an option.
      \nObjectId: id of existing QuantLib::OneAssetOption object"
EuropeanOption::usage = "EuropeanOption[ObjecctId_Symbol,Payoff_Symbol,Exercise_Symbol] Construct an object of class EuropeanOption and return its id
      \nObjectId: id of object to be created\nPayoff: StrikedTypePayoff object ID.\nExercise: Exercise object ID.\nPermanent: object permanent/nonpermanent"
ForwardVanillaOption::usage = "ForwardVanillaOption[ObjecctId_Symbol,Moneyness_?NumberQ,ResetDate_?DateQ,Payoff_Symbol,Exercise_Symbol] Construct an object of class ForwardVanillaOption and return its id
      \nObjectId: id of object to be created\nMoneyness: moneyness.\nResetDate: reset date.\nPayoff: StrikedTypePayoff object ID.\nExercise: Exercise object ID.\nPermanent: object permanent/nonpermanent"
QLGamma::usage = "QLGamma[ObjecctId_Symbol] gamma of an option.
      \nObjectId: id of existing QuantLib::OneAssetOption object"
ItmCashProbability::usage = "ItmCashProbability[ObjecctId_Symbol] itm cash probability of an option.
      \nObjectId: id of existing QuantLib::OneAssetOption object"
QuantoForwardVanillaOption::usage = "QuantoForwardVanillaOption[ObjecctId_Symbol,Moneyness_?NumberQ,ResetDate_?DateQ,Payoff_Symbol,Exercise_Symbol] Construct an object of class QuantoForwardVanillaOption and return its id
      \nObjectId: id of object to be created\nMoneyness: moneyness.\nResetDate: reset date.\nPayoff: StrikedTypePayoff object ID.\nExercise: Exercise object ID.\nPermanent: object permanent/nonpermanent"
QuantoVanillaOption::usage = "QuantoVanillaOption[ObjecctId_Symbol,Payoff_Symbol,Exercise_Symbol] Construct an object of class QuantoVanillaOption and return its id
      \nObjectId: id of object to be created\nPayoff: StrikedTypePayoff object ID.\nExercise: Exercise object ID.\nPermanent: object permanent/nonpermanent"
Rho::usage = "Rho[ObjecctId_Symbol] rho of an option.
      \nObjectId: id of existing QuantLib::OneAssetOption object"
Theta::usage = "Theta[ObjecctId_Symbol] theta of an option.
      \nObjectId: id of existing QuantLib::OneAssetOption object"
ThetaPerDay::usage = "ThetaPerDay[ObjecctId_Symbol] theta per day of an option.
      \nObjectId: id of existing QuantLib::OneAssetOption object"
VanillaOption::usage = "VanillaOption[ObjecctId_Symbol,Payoff_Symbol,Exercise_Symbol] Construct an object of class VanillaOption and return its id
      \nObjectId: id of object to be created\nPayoff: StrikedTypePayoff object ID.\nExercise: Exercise object ID.\nPermanent: object permanent/nonpermanent"
Vega::usage = "Vega[ObjecctId_Symbol] vega of an option.
      \nObjectId: id of existing QuantLib::OneAssetOption object"
Category[Options] = {BarrierOption,CaAsianOption,DaAsianOption,Delta,DeltaForward,DividendRho,DividendVanillaOption,Elasticity,EuropeanOption,ForwardVanillaOption,QLGamma,ItmCashProbability,QuantoForwardVanillaOption,QuantoVanillaOption,Rho,Theta,ThetaPerDay,VanillaOption,Vega};
AppendTo[QLCategories,Options]

(* Overnight Indexed Swap *)

OvernightIndexedSwap::usage = "functions to construct and use OvernightIndexedSwap objects."

MakeDatedOIS::usage = "MakeDatedOIS[ObjecctId_Symbol,OvernightIndex_Symbol] Construct an object of class OvernightIndexedSwap and return its id
      \nObjectId: id of object to be created\nStartDate: ois start date. If missing first ECB date is used. Default value = Date[].\nEndDate: ois end date. If missing first ECB date after start date is used. Default value = Date[].\nOvernightIndex: OvernightIndex object ID.\nFixedRate: the fixed leg rate. If missing atm rate is used. Default value = 0.\nFixDayCounter: fixed leg day counter. Default value = Actual/360.\nSpread: the spread in the overnight leg rate. Default value = 0.0.\nPermanent: object permanent/nonpermanent"
MakeOIS::usage = "MakeOIS[ObjecctId_Symbol,SwapTenor_String,OvernightIndex_Symbol,ForwardStart_String] Construct an object of class OvernightIndexedSwap and return its id
      \nObjectId: id of object to be created\nSwapTenor: swap tenor period (e.g. 5Y).\nOvernightIndex: OvernightIndex object ID.\nFixedRate: the fixed leg rate. If missing atm rate is used. Default value = 0.\nForwardStart: forward start period.\nFixDayCounter: fixed leg day counter. Default value = Actual/360.\nSpread: the spread in the overnight leg rate. Default value = 0.0.\nPermanent: object permanent/nonpermanent"
OvernightIndexedSwap::usage = "OvernightIndexedSwap[ObjecctId_Symbol,Nominal_List /; VectorQ[Nominal, NumberQ],Schedule_Symbol,FixDayCounter_String,OvernightIndex_Symbol] Construct an object of class OvernightIndexedSwap and return its id
      \nObjectId: id of object to be created\nPayerReceiver: PAYER to pay the fixed rate, RECEIVER to receive it. Default value = Payer.\nNominal: Notional Amount. Default value = 100.\nSchedule: Schedule object ID.\nFixedRate: the fixed leg rate. Default value = 0.0.\nFixDayCounter: fixed leg day counter (e.g. Actual/360).\nOvernightIndex: overnight leg OvernightIndex object ID.\nSpread: overnight leg spread. Default value = 0.0.\nPermanent: object permanent/nonpermanent"
OvernightIndexedSwapFairRate::usage = "OvernightIndexedSwapFairRate[ObjecctId_Symbol] returns the fair fixed leg rate which would zero the swap NPV for the given OvernightIndexedSwap object.
      \nObjectId: id of existing QuantLib::OvernightIndexedSwap object"
OvernightIndexedSwapFairSpread::usage = "OvernightIndexedSwapFairSpread[ObjecctId_Symbol] returns the fair spread over the overnight rate which would zero the swap NPV for the given OvernightIndexedSwap object.
      \nObjectId: id of existing QuantLib::OvernightIndexedSwap object"
OvernightIndexedSwapFixedDayCount::usage = "OvernightIndexedSwapFixedDayCount[ObjecctId_Symbol] returns the fixed rate day count convention for the given OvernightIndexedSwap object.
      \nObjectId: id of existing QuantLib::OvernightIndexedSwap object"
OvernightIndexedSwapFixedLegAnalysis::usage = "OvernightIndexedSwapFixedLegAnalysis[ObjecctId_Symbol] returns the fixed rate leg cash flow analysis of the given OvernightIndexedSwap object.
      \nObjectId: id of existing QuantLibAddin::OvernightIndexedSwap object"
OvernightIndexedSwapFixedLegBPS::usage = "OvernightIndexedSwapFixedLegBPS[ObjecctId_Symbol] returns the BPS of the fixed rate leg for the given OvernightIndexedSwap object.
      \nObjectId: id of existing QuantLib::OvernightIndexedSwap object"
OvernightIndexedSwapFixedLegNPV::usage = "OvernightIndexedSwapFixedLegNPV[ObjecctId_Symbol] returns the NPV of the fixed rate leg for the given OvernightIndexedSwap object.
      \nObjectId: id of existing QuantLib::OvernightIndexedSwap object"
OvernightIndexedSwapFixedRate::usage = "OvernightIndexedSwapFixedRate[ObjecctId_Symbol] returns the fixed rate for the given OvernightIndexedSwap object.
      \nObjectId: id of existing QuantLib::OvernightIndexedSwap object"
OvernightIndexedSwapFromOISRateHelper::usage = "OvernightIndexedSwapFromOISRateHelper[ObjecctId_Symbol,OISRateHelper_Symbol] Construct an object of class OvernightIndexedSwap and return its id
      \nObjectId: id of object to be created\nOISRateHelper: OISRateHelper object ID.\nPermanent: object permanent/nonpermanent"
OvernightIndexedSwapNominal::usage = "OvernightIndexedSwapNominal[ObjecctId_Symbol] returns the swap nominal for the given OvernightIndexedSwap object.
      \nObjectId: id of existing QuantLib::OvernightIndexedSwap object"
OvernightIndexedSwapOvernightLegAnalysis::usage = "OvernightIndexedSwapOvernightLegAnalysis[ObjecctId_Symbol] returns the overnight rate leg cash flow analysis.
      \nObjectId: id of existing QuantLibAddin::OvernightIndexedSwap object"
OvernightIndexedSwapOvernightLegBPS::usage = "OvernightIndexedSwapOvernightLegBPS[ObjecctId_Symbol] returns the BPS of the overnight rate leg for the given OvernightIndexedSwap object.
      \nObjectId: id of existing QuantLib::OvernightIndexedSwap object"
OvernightIndexedSwapOvernightLegNPV::usage = "OvernightIndexedSwapOvernightLegNPV[ObjecctId_Symbol] returns the NPV of the overnight rate leg for the given OvernightIndexedSwap object.
      \nObjectId: id of existing QuantLib::OvernightIndexedSwap object"
OvernightIndexedSwapSpread::usage = "OvernightIndexedSwapSpread[ObjecctId_Symbol] returns the spread over overnight rate for the given OvernightIndexedSwap object.
      \nObjectId: id of existing QuantLib::OvernightIndexedSwap object"
OvernightIndexedSwapType::usage = "OvernightIndexedSwapType[ObjecctId_Symbol] returns the swap type (Payer or Receiver) of the given OvernightIndexedSwap object.
      \nObjectId: id of existing QuantLib::OvernightIndexedSwap object"
Category[OvernightIndexedSwap] = {MakeDatedOIS,MakeOIS,OvernightIndexedSwap,OvernightIndexedSwapFairRate,OvernightIndexedSwapFairSpread,OvernightIndexedSwapFixedDayCount,OvernightIndexedSwapFixedLegAnalysis,OvernightIndexedSwapFixedLegBPS,OvernightIndexedSwapFixedLegNPV,OvernightIndexedSwapFixedRate,OvernightIndexedSwapFromOISRateHelper,OvernightIndexedSwapNominal,OvernightIndexedSwapOvernightLegAnalysis,OvernightIndexedSwapOvernightLegBPS,OvernightIndexedSwapOvernightLegNPV,OvernightIndexedSwapSpread,OvernightIndexedSwapType};
AppendTo[QLCategories,OvernightIndexedSwap]

(* Payoffs *)

Payoffs::usage = "functions to construct and use StrikedTypePayoff and DoubleStickyRatchetPayoff objects."

DoubleStickyRatchetPayoff::usage = "DoubleStickyRatchetPayoff[ObjecctId_Symbol,Type1_?NumberQ,Type2_?NumberQ,Gearing1_?NumberQ,Gearing2_?NumberQ,Gearing3_?NumberQ,Spread1_?NumberQ,Spread2_?NumberQ,Spread3_?NumberQ,InitialValue1_?NumberQ,InitialValue2_?NumberQ,AccrualFactor_?NumberQ] Construct an object of class DoubleStickyRatchetPayoff and return its id
      \nObjectId: id of object to be created\nType1:  Sticky (type1=1) or Ratchet (type1=-1) payoff .\nType2:  Strike type (type2=1 for Min, type2=-1 for Max, type2=0 for single sticky/ratchet) .\nGearing1: gearing 1 (for strike 1).\nGearing2: gearing 2 (for strike 2).\nGearing3: gearing 3 (for forward rate 3).\nSpread1: spread 1 (for strike 1).\nSpread2: spread 2 (for strike 2).\nSpread3: spread 3 (for forward rate 3).\nInitialValue1: initial value for strike 1 (forward rate or coupon/accrualFactor).\nInitialValue2: initial value for strike 2 (forward rate or coupon/accrualFactor).\nAccrualFactor: accrual factor.\nPermanent: object permanent/nonpermanent"
PayoffDescription::usage = "PayoffDescription[ObjecctId_Symbol] returns the description (e.g. CashOrNothing, strike 32.2, cash payoff 2.5) for the given Payoff object.
      \nObjectId: id of existing QuantLib::Payoff object"
PayoffName::usage = "PayoffName[ObjecctId_Symbol] returns the type (e.g. Vanilla, CashOrNothing, etc.) for the given Payoff object.
      \nObjectId: id of existing QuantLib::Payoff object"
PayoffOptionType::usage = "PayoffOptionType[ObjecctId_Symbol] returns the option-type (e.g. Call, Put) for the given Payoff object.
      \nObjectId: id of existing QuantLib::TypePayoff object"
PayoffStrike::usage = "PayoffStrike[ObjecctId_Symbol] returns the strike for the given Payoff object.
      \nObjectId: id of existing QuantLib::StrikedTypePayoff object"
PayoffThirdParameter::usage = "PayoffThirdParameter[ObjecctId_Symbol] returns the third parameter of a StrikedType payoff.
      \nObjectId: id of existing QuantLibAddin::StrikedTypePayoff object"
PayoffValue::usage = "PayoffValue[ObjecctId_Symbol,Underlying_?NumberQ] returns the payoff value given an underlying reference level for the given Payoff object.
      \nObjectId: id of existing QuantLib::Payoff object\nUnderlying: underlying reference level."
RatchetMaxPayoff::usage = "RatchetMaxPayoff[ObjecctId_Symbol,Gearing1_?NumberQ,Gearing2_?NumberQ,Gearing3_?NumberQ,Spread1_?NumberQ,Spread2_?NumberQ,Spread3_?NumberQ,InitialValue1_?NumberQ,InitialValue2_?NumberQ,AccrualFactor_?NumberQ] Construct an object of class RatchetMaxPayoff and return its id
      \nObjectId: id of object to be created\nGearing1: gearing 1 (for strike 1).\nGearing2: gearing 2 (for strike 2).\nGearing3: gearing 3 (for forward rate 3).\nSpread1: spread 1 (for strike 1).\nSpread2: spread 2 (for strike 2).\nSpread3: spread 3 (for forward rate 3).\nInitialValue1: initial value for strike 1 (forward rate or coupon/accrualFactor).\nInitialValue2: initial value for strike 2 (forward rate or coupon/accrualFactor).\nAccrualFactor: accrual factor.\nPermanent: object permanent/nonpermanent"
RatchetMinPayoff::usage = "RatchetMinPayoff[ObjecctId_Symbol,Gearing1_?NumberQ,Gearing2_?NumberQ,Gearing3_?NumberQ,Spread1_?NumberQ,Spread2_?NumberQ,Spread3_?NumberQ,InitialValue1_?NumberQ,InitialValue2_?NumberQ,AccrualFactor_?NumberQ] Construct an object of class RatchetMinPayoff and return its id
      \nObjectId: id of object to be created\nGearing1: gearing 1 (for strike 1).\nGearing2: gearing 2 (for strike 2).\nGearing3: gearing 3 (for forward rate 3).\nSpread1: spread 1 (for strike 1).\nSpread2: spread 2 (for strike 2).\nSpread3: spread 3 (for forward rate 3).\nInitialValue1: initial value for strike 1 (forward rate or coupon/accrualFactor).\nInitialValue2: initial value for strike 2 (forward rate or coupon/accrualFactor).\nAccrualFactor: accrual factor.\nPermanent: object permanent/nonpermanent"
RatchetPayoff::usage = "RatchetPayoff[ObjecctId_Symbol,Gearing1_?NumberQ,Gearing2_?NumberQ,Spread1_?NumberQ,Spread2_?NumberQ,InitialValue_?NumberQ,AccrualFactor_?NumberQ] Construct an object of class RatchetPayoff and return its id
      \nObjectId: id of object to be created\nGearing1: gearing 1 (for strike 1).\nGearing2: gearing 2 (for strike 2).\nSpread1: spread 1 (for strike 1).\nSpread2: spread 2 (for strike 2).\nInitialValue: initial value for strike (forward rate or coupon/accrualFactor).\nAccrualFactor: accrual factor.\nPermanent: object permanent/nonpermanent"
StickyMaxPayoff::usage = "StickyMaxPayoff[ObjecctId_Symbol,Gearing1_?NumberQ,Gearing2_?NumberQ,Gearing3_?NumberQ,Spread1_?NumberQ,Spread2_?NumberQ,Spread3_?NumberQ,InitialValue1_?NumberQ,InitialValue2_?NumberQ,AccrualFactor_?NumberQ] Construct an object of class StickyMaxPayoff and return its id
      \nObjectId: id of object to be created\nGearing1: gearing 1 (for strike 1).\nGearing2: gearing 2 (for strike 2).\nGearing3: gearing 3 (for forward rate 3).\nSpread1: spread 1 (for strike 1).\nSpread2: spread 2 (for strike 2).\nSpread3: spread 3 (for forward rate 3).\nInitialValue1: initial value for strike 1 (forward rate or coupon/accrualFactor).\nInitialValue2: initial value for strike 2 (forward rate or coupon/accrualFactor).\nAccrualFactor: accrual factor.\nPermanent: object permanent/nonpermanent"
StickyMinPayoff::usage = "StickyMinPayoff[ObjecctId_Symbol,Gearing1_?NumberQ,Gearing2_?NumberQ,Gearing3_?NumberQ,Spread1_?NumberQ,Spread2_?NumberQ,Spread3_?NumberQ,InitialValue1_?NumberQ,InitialValue2_?NumberQ,AccrualFactor_?NumberQ] Construct an object of class StickyMinPayoff and return its id
      \nObjectId: id of object to be created\nGearing1: gearing 1 (for strike 1).\nGearing2: gearing 2 (for strike 2).\nGearing3: gearing 3 (for forward rate 3).\nSpread1: spread 1 (for strike 1).\nSpread2: spread 2 (for strike 2).\nSpread3: spread 3 (for forward rate 3).\nInitialValue1: initial value for strike 1 (forward rate or coupon/accrualFactor).\nInitialValue2: initial value for strike 2 (forward rate or coupon/accrualFactor).\nAccrualFactor: accrual factor.\nPermanent: object permanent/nonpermanent"
StickyPayoff::usage = "StickyPayoff[ObjecctId_Symbol,Gearing1_?NumberQ,Gearing2_?NumberQ,Spread1_?NumberQ,Spread2_?NumberQ,InitialValue_?NumberQ,AccrualFactor_?NumberQ] Construct an object of class StickyPayoff and return its id
      \nObjectId: id of object to be created\nGearing1: gearing 1 (for strike 1).\nGearing2: gearing 2 (for strike 2).\nSpread1: spread 1 (for strike 1).\nSpread2: spread 2 (for strike 2).\nInitialValue: initial value for strike (forward rate or coupon/accrualFactor).\nAccrualFactor: accrual factor.\nPermanent: object permanent/nonpermanent"
StrikedTypePayoff::usage = "StrikedTypePayoff[ObjecctId_Symbol,PayoffID_String,OptionType_String,Strike_?NumberQ] Construct an payoff object of class StrikedTypePayoff and return its id
      \nObjectId: id of object to be created\nPayoffID: payoff ID (e.g. Vanilla, PercentageStrike, AssetOrNothing, CashOrNothing, Gap, SuperShare).\nOptionType: option type.\nStrike: strike.\nThirdParameter: the 3rd paramenter for the payoff definition of CashOrNothing (cash), Gap (determines the size of the payoff), SuperFund (second strike). Default value = 0.\nPermanent: object permanent/nonpermanent"
PlainVanillaPayoff::usage = "PlainVanillaPayoff[ObjecctId_Symbol,OptionType_String,Strike_?NumberQ] Construct an payoff object of class PlainVanillaPayoff and return its id
      \nObjectId: id of object to be created\nOptionType: option type.\nStrike: strike.\nPermanent: object permanent/nonpermanent"
Category[Payoffs] = {DoubleStickyRatchetPayoff,PayoffDescription,PayoffName,PayoffOptionType,PayoffStrike,PayoffThirdParameter,PayoffValue,RatchetMaxPayoff,RatchetMinPayoff,RatchetPayoff,StickyMaxPayoff,StickyMinPayoff,StickyPayoff,StrikedTypePayoff,PlainVanillaPayoff};
AppendTo[QLCategories,Payoffs]

(* Piecewise Yield Curves *)

PiecewiseYieldCurves::usage = "functions to construct and use PiecewiseYieldCurve objects."

PiecewiseYieldCurve::usage = "PiecewiseYieldCurve[ObjecctId_Symbol,RateHelpers_List] Construct an object of class PiecewiseYieldCurve and return its id
      \nObjectId: id of object to be created\nNDays: number of days to advance from EvaluationDate (usually zero or two): it fixes the date at which the discount factor = 1.0. Default value = 0.\nCalendar: holiday calendar (e.g. TARGET) to advance from global EvaluationDate.\nRateHelpers: vector of rate-helpers.\nDayCounter: DayCounter ID. Default value = Actual/365 (Fixed).\nAccuracy: Bootstrapping accuracy. Default value = 1.0e-12.\nTraitsID: Discount, ZeroRate, or ForwardRate. Default value = Discount.\nInterpolatorID: BackwardFlat, ForwardFlat, Linear, LogLinear, CubicSpline, or LogCubic. Default value = LogLinear.\nPermanent: object permanent/nonpermanent"
PiecewiseYieldCurveData::usage = "PiecewiseYieldCurveData[ObjecctId_Symbol] Retrieve Data for the given PiecewiseYieldCurve<Traits, Interpolator>.
      \nObjectId: id of existing QuantLibAddin::PiecewiseYieldCurve object"
PiecewiseYieldCurveDates::usage = "PiecewiseYieldCurveDates[ObjecctId_Symbol] Retrieve list of Dates for the given PiecewiseYieldCurve<Traits, Interpolator>.
      \nObjectId: id of existing QuantLibAddin::PiecewiseYieldCurve object"
PiecewiseYieldCurveJumpDates::usage = "PiecewiseYieldCurveJumpDates[ObjecctId_Symbol] Retrieve list of jump dates for the given PiecewiseYieldCurve<Traits, Interpolator>.
      \nObjectId: id of existing QuantLibAddin::PiecewiseYieldCurve object"
PiecewiseYieldCurveJumpTimes::usage = "PiecewiseYieldCurveJumpTimes[ObjecctId_Symbol] Retrieve list of jump times for the given PiecewiseYieldCurve<Traits, Interpolator>.
      \nObjectId: id of existing QuantLibAddin::PiecewiseYieldCurve object"
PiecewiseYieldCurveTimes::usage = "PiecewiseYieldCurveTimes[ObjecctId_Symbol] Retrieve list of Times for the given PiecewiseYieldCurve<Traits, Interpolator>.
      \nObjectId: id of existing QuantLibAddin::PiecewiseYieldCurve object"
Category[PiecewiseYieldCurves] = {PiecewiseYieldCurve,PiecewiseYieldCurveData,PiecewiseYieldCurveDates,PiecewiseYieldCurveJumpDates,PiecewiseYieldCurveJumpTimes,PiecewiseYieldCurveTimes};
AppendTo[QLCategories,PiecewiseYieldCurves]

ShortRateModelYieldCurve::usage = "ShortRateModelYieldCurve[ShortRateModel_Symbol,SpotRate_] constructs a yield curve using the short rate model"
ShortRateModelYieldCurveSetReferenceDate::usage = "ShortRateModelYieldCurveSetReferenceDate"

(* Prices *)

Prices::usage = "Price utility functions."

MidEquivalent::usage = "MidEquivalent[] returns the mid price if available, or a suitable substitute otherwise.
      \nBid: bid price. Default value = 0.\nAsk: ask price. Default value = 0.\nLast: last price. Default value = 0.\nClose: close price. Default value = 0."
MidSafe::usage = "MidSafe[] returns the mid price only if both bid and ask are available.
      \nBid: bid price. Default value = 0.\nAsk: ask price. Default value = 0."
Category[Prices] = {MidEquivalent,MidSafe};
AppendTo[QLCategories,Prices]

(* Pricing Engines *)
Get[ToFileName["QuantLib","QLPricingEnginesUsage.m"]]

(* Processes *)

Processes::usage = "functions to construct and use Process objects."

GeneralizedBlackScholesProcess::usage = "GeneralizedBlackScholesProcess[ObjecctId_Symbol,BlackVolID_Symbol,Underlying_?NumberQ,SettlementDate_?DateQ,RiskFreeRate_?NumberQ,DividendYield_?NumberQ] Construct an object of class GeneralizedBlackScholesProcess and return its id
      \nObjectId: id of object to be created\nBlackVolID: Black Vol Term Structure.\nUnderlying: underlying.\nDayCounter: DayCounter ID. Default value = Actual/365 (Fixed).\nSettlementDate: settlement date.\nRiskFreeRate: risk free rate.\nDividendYield: dividend yield.\nPermanent: object permanent/nonpermanent"
BlackScholesProcess::usage = "BlackScholesProcess[ObjecctId_Symbol,Underlying_?NumberQ,YieldCurveID_Symbol,BlackVolID_Symbol] Construct an object of class BlackScholesProcess and return its id
      \nObjectId: id of object to be created\n\nUnderlying: underlying.\nYieldCurveID: risk free yield curve.\nBlack Vol Term Structure.\nBlackVolID: Black Vol Term Structure.\nPermanent: object permanent/nonpermanent"
BlackProcess::usage = "BlackProcess[ObjecctId_Symbol,Underlying_?NumberQ,YieldCurveID_Symbol,BlackVolID_Symbol] Construct an object of class BlackProcess and return its id
      \nObjectId: id of object to be created\n\nUnderlying: underlying.\nYieldCurveID: risk free yield curve.\nBlack Vol Term Structure.\nBlackVolID: Black Vol Term Structure.\nPermanent: object permanent/nonpermanent"
BlackScholesMertonProcess::usage = "BlackScholesMertonProcess[ObjecctId_Symbol,Underlying_?NumberQ,DividendCurveID_Symbol,YieldCurveID_Symbol,BlackVolID_Symbol] Construct an object of class BlackScholesMertonProcess and return its id
      \nObjectId: id of object to be created\n\nUnderlying: underlying.\nDividendCurveID: dividend yield curve.\nYieldCurveID: risk free yield curve.\nBlack Vol Term Structure.\nBlackVolID: Black Vol Term Structure.\nPermanent: object permanent/nonpermanent"
GarmanKohlagenProcess::usage = "GarmanKohlagenProcess[ObjecctId_Symbol,Underlying_?NumberQ,ForeignYieldCurveID_Symbol,DomesticYieldCurveID_Symbol,BlackVolID_Symbol] Construct an object of class GarmanKohlagenProcess and return its id
      \nObjectId: id of object to be created\n\nUnderlying: underlying.\nForeignYieldCurveID: risk free foreign yield curve.\nDomesticYieldCurveID: risk free domestic yield curve.\nBlack Vol Term Structure.\nBlackVolID: Black Vol Term Structure.\nPermanent: object permanent/nonpermanent"

Category[Processes] = {GeneralizedBlackScholesProcess,BlackScholesProcess,BlackScholesMertonProcess,BlackProcess,GarmanKohlagenProcess};
AppendTo[QLCategories,Processes]

(* Products *)

Products::usage = "functions to construct and use Market Models Products objects."

MarketModelMultiProductComposite::usage = "MarketModelMultiProductComposite[ObjecctId_Symbol] Construct an object of class MultiProductComposite and return its id
      \nObjectId: id of object to be created\nPermanent: object permanent/nonpermanent"
MarketModelMultiProductCompositeAdd::usage = "MarketModelMultiProductCompositeAdd[ObjecctId_Symbol,ProductId_Symbol] Add new product to MarketModelComposite object.
      \nObjectId: id of existing QuantLib::MultiProductComposite object\nProduct: ID of product object."
MarketModelMultiProductCompositeFinalize::usage = "MarketModelMultiProductCompositeFinalize[ObjecctId_Symbol] finalize the MarketModelComposite object.
      \nObjectId: id of existing QuantLib::MultiProductComposite object"
MarketModelMultiProductMaxNumberOfCashFlowsPerProductPerStep::usage = "MarketModelMultiProductMaxNumberOfCashFlowsPerProductPerStep[ObjecctId_Symbol] Max number of cashflows per product per step for the MarketModelMultiProduct object.
      \nObjectId: id of existing QuantLib::MarketModelMultiProduct object"
MarketModelMultiProductNumberOfProducts::usage = "MarketModelMultiProductNumberOfProducts[ObjecctId_Symbol] number of products in the MarketModelMultiProduct object.
      \nObjectId: id of existing QuantLib::MarketModelMultiProduct object"
MarketModelMultiProductPossibleCashFlowTimes::usage = "MarketModelMultiProductPossibleCashFlowTimes[ObjecctId_Symbol] possible cash flow times for the MarketModelMultiProduct object.
      \nObjectId: id of existing QuantLib::MarketModelMultiProduct object"
MarketModelMultiProductSuggestedNumeraires::usage = "MarketModelMultiProductSuggestedNumeraires[ObjecctId_Symbol] suggested Numeraires for the MarketModelMultiProduct object.
      \nObjectId: id of existing QuantLib::MarketModelMultiProduct object"
MarketModelMultiStepRatchet::usage = "MarketModelMultiStepRatchet[ObjecctId_Symbol,RateTimes_List /; VectorQ[RateTimes, NumberQ],Accruals_List /; VectorQ[Accruals, NumberQ],PaymentTimes_List /; VectorQ[PaymentTimes, NumberQ],GearingOfFloor_?NumberQ,GearingOfFixing_?NumberQ,SpreadOfFloor_?NumberQ,SpreadOfFixing_?NumberQ,InitialFloor_?NumberQ,Payer:(True | False)] Construct an object of class MultiStepRatchet and return its id
      \nObjectId: id of object to be created\nRateTimes: rate fixing times.\nAccruals: accrual factors between rate fixing times.\nPaymentTimes: payment times of the product.\nGearingOfFloor: gearing of floor.\nGearingOfFixing: gearing of fixing.\nSpreadOfFloor: spread of floor.\nSpreadOfFixing: spread of fixing.\nInitialFloor: initial floor.\nPayer: payer if true.\nPermanent: object permanent/nonpermanent"
MarketModelOneStepForwards::usage = "MarketModelOneStepForwards[ObjecctId_Symbol,RateTimes_List /; VectorQ[RateTimes, NumberQ],Accruals_List /; VectorQ[Accruals, NumberQ],PaymentTimes_List /; VectorQ[PaymentTimes, NumberQ],Strikes_List /; VectorQ[Strikes, NumberQ]] Construct an object of class OneStepForwards and return its id
      \nObjectId: id of object to be created\nRateTimes: rate fixing times.\nAccruals: accrual factors.\nPaymentTimes: payment times of the product.\nStrikes: forward strikes.\nPermanent: object permanent/nonpermanent"
MarketModelOneStepOptionlets::usage = "MarketModelOneStepOptionlets[ObjecctId_Symbol,RateTimes_List /; VectorQ[RateTimes, NumberQ],Accruals_List /; VectorQ[Accruals, NumberQ],PaymentTimes_List /; VectorQ[PaymentTimes, NumberQ],Payoffs_List] Construct an object of class OneStepOptionlets and return its id
      \nObjectId: id of object to be created\nRateTimes: rate fixing times.\nAccruals: accrual factors.\nPaymentTimes: payment times of the product.\nPayoffs: striked type payoff object IDs.\nPermanent: object permanent/nonpermanent"
Category[Products] = {MarketModelMultiProductComposite,MarketModelMultiProductCompositeAdd,MarketModelMultiProductCompositeFinalize,MarketModelMultiProductMaxNumberOfCashFlowsPerProductPerStep,MarketModelMultiProductNumberOfProducts,MarketModelMultiProductPossibleCashFlowTimes,MarketModelMultiProductSuggestedNumeraires,MarketModelMultiStepRatchet,MarketModelOneStepForwards,MarketModelOneStepOptionlets};
AppendTo[QLCategories,Products]

(* Quotes *)

Quotes::usage = "quotes objects."
QuoteQ::usage = "QuoteQ[expr] gives True if expr is a quote, and False otherwise." 
BucketAnalysis::usage = "BucketAnalysis[SimpleQuote_?MatrixQ,Instruments_List,Quantities_List /; VectorQ[Quantities, NumberQ]] bucket sensitivity analysis for a (single/vector/matrix) SimpleQuote.
      \nSimpleQuote: simple quotes.\nInstruments: instruments.\nQuantities: quantities.\nShift: shift. Default value = 0.0001.\nSensitivityAnalysis: SensitivityAnalysis type. Default value = Centered."
BucketAnalysisDelta::usage = "BucketAnalysisDelta[SimpleQuote_Symbol,Parameters_List] 
      \nSimpleQuote: simple quote.\nParameters: parameters vector.\nShift: shift. Default value = 0.0001.\nSensitivityAnalysis: SensitivityAnalysis type. Default value = Centered."
BucketAnalysisDelta2::usage = "BucketAnalysisDelta2[SimpleQuote_List,Parameters_List] 
      \nSimpleQuote: simple quote.\nParameters: parameters vector.\nShift: shift. Default value = 0.0001.\nSensitivityAnalysis: SensitivityAnalysis type. Default value = Centered."
CompositeQuote::usage = "CompositeQuote[ObjecctId_Symbol,Element1_,Element2_,Operator_String] Construct an object of class CompositeQuote and return its id
      \nObjectId: id of object to be created\nElement1: the first, i.e. x, value in the f(x,y) expression.\nElement2: the second, i.e. y, value in the f(x,y) expression.\nOperator: the operator to be applied, e.g. '+' or '-'.\nPermanent: object permanent/nonpermanent"
EurodollarFuturesImpliedStdDevQuote::usage = "EurodollarFuturesImpliedStdDevQuote[ObjecctId_Symbol,AtmForwardValue_,CallPrice_,PutPrice_,Strike_?NumberQ] Construct an object of class EurodollarFuturesImpliedStdDevQuote and return its id
      \nObjectId: id of object to be created\nAtmForwardValue: underlying asset at-the-money forward value.\nCallPrice: call option price.\nPutPrice: put option price.\nStrike: option strike.\nGuess: implied volatility guess. Default value = 0.\nAccuracy: standard deviation accuracy. Default value = 1e-6.\nPermanent: object permanent/nonpermanent"
ForwardSwapQuote::usage = "ForwardSwapQuote[ObjecctId_Symbol,SwapIndex_Symbol,Spread_,ForwardStart_String] Construct an object of class ForwardSwapQuote and return its id
      \nObjectId: id of object to be created\nSwapIndex: floating SwapIndex object ID.\nSpread: floating leg spread.\nForwardStart: forward start period.\nPermanent: object permanent/nonpermanent"
ForwardValueQuote::usage = "ForwardValueQuote[ObjecctId_Symbol,IborIndex_Symbol,FixingDate_?DateQ] Construct an object of class ForwardValueQuote and return its id
      \nObjectId: id of object to be created\nIborIndex: floating IborIndex object ID.\nFixingDate: Fixing Date.\nPermanent: object permanent/nonpermanent"
FuturesConvAdjustmentQuote::usage = "FuturesConvAdjustmentQuote[ObjecctId_Symbol,IborIndex_Symbol,ImmCode_String,FuturesQuote_,Volatility_,MeanReversion_] Construct an object of class FuturesConvAdjustmentQuote and return its id
      \nObjectId: id of object to be created\nIborIndex: floating IborIndex object ID.\nImmCode: futures IMM code (e.g. H9).\nFuturesQuote: futures quote.\nVolatility: HullWhite volatility.\nMeanReversion: HullWhite mean reversion.\nPermanent: object permanent/nonpermanent"
FuturesConvAdjustmentQuoteFuturesValue::usage = "FuturesConvAdjustmentQuoteFuturesValue[ObjecctId_Symbol] Return the value of futures underlying.
      \nObjectId: id of existing QuantLib::FuturesConvAdjustmentQuote object"
FuturesConvAdjustmentQuoteImmDate::usage = "FuturesConvAdjustmentQuoteImmDate[ObjecctId_Symbol] Return the IMM date of futures.
      \nObjectId: id of existing QuantLib::FuturesConvAdjustmentQuote object"
FuturesConvAdjustmentQuoteMeanReversion::usage = "FuturesConvAdjustmentQuoteMeanReversion[ObjecctId_Symbol] Return the value of HW mean reversion.
      \nObjectId: id of existing QuantLib::FuturesConvAdjustmentQuote object"
FuturesConvAdjustmentQuoteVolatility::usage = "FuturesConvAdjustmentQuoteVolatility[ObjecctId_Symbol] Return the value of HW volatility.
      \nObjectId: id of existing QuantLib::FuturesConvAdjustmentQuote object"
ImpliedStdDevQuote::usage = "ImpliedStdDevQuote[ObjecctId_Symbol,OptionType_String,AtmForwardValue_,OptionPrice_,Strike_?NumberQ] Construct an object of class ImpliedStdDevQuote and return its id
      \nObjectId: id of object to be created\nOptionType: option type (i.e. Call or Put).\nAtmForwardValue: underlying asset at-the-money forward value.\nOptionPrice: option price.\nStrike: option strike.\nGuess: implied volatility guess. Default value = 0.\nAccuracy: iv accuracy. Default value = 1e-6.\nPermanent: object permanent/nonpermanent"
LastFixingQuote::usage = "LastFixingQuote[ObjecctId_Symbol,Index_Symbol] Construct an object of class LastFixingQuote and return its id
      \nObjectId: id of object to be created\nIndex: Index object ID.\nPermanent: object permanent/nonpermanent"
LastFixingQuoteReferenceDate::usage = "LastFixingQuoteReferenceDate[ObjecctId_Symbol] Return the date of the last fixing
      \nObjectId: id of existing QuantLib::LastFixingQuote object"
QuoteIsValid::usage = "QuoteIsValid[ObjecctId_Symbol] Returns TRUE if the given Quote object has a valid value.
      \nObjectId: id of existing QuantLib::Quote object"
QuoteValue::usage = "QuoteValue[ObjecctId_Symbol] Returns the current value of the given Quote object.
      \nObjectId: id of existing QuantLib::Quote object"
RelinkableHandleQuote::usage = "RelinkableHandleQuote[ObjecctId_Symbol] Construct an object of class RelinkableHandleImpl<QuantLibAddin::Quote, QuantLib::Quote> and return its id
      \nObjectId: id of object to be created\nCurrentLink: Quote object ID. If omitted, nothing is linked by the RelinkableHandle. Default value = .\nPermanent: object permanent/nonpermanent"
SimpleQuote::usage = "SimpleQuote[ObjecctId_Symbol,TickValue_?NumberQ] Construct an object of class SimpleQuote and return its id
      \nObjectId: id of object to be created\nValue: quote. Default value = 0.\nTickValue: tick value used for sensitivity analysis.\nPermanent: object permanent/nonpermanent"
SimpleQuoteReset::usage = "SimpleQuoteReset[ObjecctId_Symbol] resets the given SimpleQuote object to the uninitialized state.
      \nObjectId: id of existing QuantLib::SimpleQuote object"
SimpleQuoteSetTickValue::usage = "SimpleQuoteSetTickValue[ObjecctId_Symbol,Value_?NumberQ] sets the tick value of the given SimpleQuote object.
      \nObjectId: id of existing QuantLibAddin::SimpleQuote object\nValue: the new tick value."
SimpleQuoteSetValue::usage = "SimpleQuoteSetValue[ObjecctId_Symbol] sets a new value to the given SimpleQuote object and returns the difference with the previous value.
      \nObjectId: id of existing QuantLibAddin::SimpleQuote object\nValue: the new value. Default value = 0."
SimpleQuoteTickValue::usage = "SimpleQuoteTickValue[ObjecctId_Symbol] returns the tick value of the given SimpleQuote object.
      \nObjectId: id of existing QuantLibAddin::SimpleQuote object"
Category[Quotes] = {BucketAnalysis,BucketAnalysisDelta,BucketAnalysisDelta2,CompositeQuote,EurodollarFuturesImpliedStdDevQuote,ForwardSwapQuote,ForwardValueQuote,FuturesConvAdjustmentQuote,FuturesConvAdjustmentQuoteFuturesValue,FuturesConvAdjustmentQuoteImmDate,FuturesConvAdjustmentQuoteMeanReversion,FuturesConvAdjustmentQuoteVolatility,ImpliedStdDevQuote,LastFixingQuote,LastFixingQuoteReferenceDate,QuoteIsValid,QuoteValue,RelinkableHandleQuote,SimpleQuote,SimpleQuoteReset,SimpleQuoteSetTickValue,SimpleQuoteSetValue,SimpleQuoteTickValue};
AppendTo[QLCategories,Quotes]

(* Random Sequence Generator *)

RandomSequenceGenerator::usage = "functions to construct and use random sequences generators."

FaureRsg::usage = "FaureRsg[ObjecctId_Symbol,Dimension_Integer] Construct an object of class FaureRsg and return its id
      \nObjectId: id of object to be created\nDimension: dimension.\nPermanent: object permanent/nonpermanent"
HaltonRsg::usage = "HaltonRsg[ObjecctId_Symbol,Dimension_Integer,Seed_Integer] Construct an object of class HaltonRsg and return its id
      \nObjectId: id of object to be created\nDimension: dimension.\nSeed: seed.\nPermanent: object permanent/nonpermanent"
MersenneTwisterRsg::usage = "MersenneTwisterRsg[ObjecctId_Symbol,Dimension_Integer,Seed_Integer] Construct an object of class MersenneTwisterRsg and return its id
      \nObjectId: id of object to be created\nDimension: dimension.\nSeed: seed.\nPermanent: object permanent/nonpermanent"
Rand::usage = "Rand[] returns a random number between 0 and 1.
      \n"
Randomize::usage = "Randomize[Seed_Integer] initialize with the given seed the random number generator used by qlRand().
      \nSeed: the seed used to initialize the random number generator."
SobolRsg::usage = "SobolRsg[ObjecctId_Symbol,Dimension_Integer,Seed_Integer] Construct an object of class SobolRsg and return its id
      \nObjectId: id of object to be created\nDimension: dimension.\nSeed: seed.\nPermanent: object permanent/nonpermanent"
Variates::usage = "Variates[ObjecctId_Symbol,Samples_Integer] generate variates.
      \nObjectId: id of existing QuantLibAddin::RandomSequenceGenerator object\nSamples: number of samples."
Category[RandomSequenceGenerator] = {FaureRsg,HaltonRsg,MersenneTwisterRsg,Rand,Randomize,SobolRsg,Variates};
AppendTo[QLCategories,RandomSequenceGenerator]

(* Range Accrual *)

RangeAccrual::usage = "functions to construct and use Range Accrual objects."

RangeAccrualFloatersCoupon::usage = "RangeAccrualFloatersCoupon[ObjecctId_Symbol,Nominal_?NumberQ,PaymentDate_?DateQ,IborIndex_Symbol,StartDate_?DateQ,EndDate_?DateQ,FixingDays_Integer,DayCountID_String,Gearings_?NumberQ,Spreads_?NumberQ,RefPeriodStart_?DateQ,RefPeriodEnd_?DateQ,ObserSchedID_Symbol,LowerTrigger_?NumberQ,UpperTrigger_?NumberQ] Construct an object of class RangeAccrualFloatersCoupon and return its id
      \nObjectId: id of object to be created\nNominal: coupon nominal.\nPaymentDate: payment Date.\nIborIndex: underlying ibor index.\nStartDate: start Date.\nEndDate: end Date.\nFixingDays: fixingDays.\nDayCountID: day counter.\nGearings: gearings.\nSpreads: spreads.\nRefPeriodStart: refPeriodStart.\nRefPeriodEnd: refPeriodEnd.\nObserSchedID: observations schedule.\nLowerTrigger: lowerTrigger.\nUpperTrigger: upperTrigger.\nPermanent: object permanent/nonpermanent"
RangeAccrualFloatersCouponEndDate::usage = "RangeAccrualFloatersCouponEndDate[ObjecctId_Symbol] Return the accrual end Date.
      \nObjectId: id of existing QuantLib::RangeAccrualFloatersCoupon object"
RangeAccrualFloatersCouponFromLeg::usage = "RangeAccrualFloatersCouponFromLeg[ObjecctId_Symbol,RangeAccrualLegId_Symbol,Position_Integer] Construct an object of class RangeAccrualFloatersCoupon and return its id
      \nObjectId: id of object to be created\nRangeAccrualLeg: range accrual leg object ID.\nPosition: position.\nPermanent: object permanent/nonpermanent"
RangeAccrualFloatersCouponObservationDates::usage = "RangeAccrualFloatersCouponObservationDates[ObjecctId_Symbol] Return the observation Dates.
      \nObjectId: id of existing QuantLib::RangeAccrualFloatersCoupon object"
RangeAccrualFloatersCouponObservationsNo::usage = "RangeAccrualFloatersCouponObservationsNo[ObjecctId_Symbol] Return the observations number.
      \nObjectId: id of existing QuantLib::RangeAccrualFloatersCoupon object"
RangeAccrualFloatersCouponSetPricer::usage = "RangeAccrualFloatersCouponSetPricer[ObjecctId_Symbol,RangeAccrualPricer_Symbol] Set the coupon pricer at the given coupon object.
      \nObjectId: id of existing QuantLib::RangeAccrualFloatersCoupon object\nRangeAccrualPricer: RangeAccrual coupon pricer object ID."
RangeAccrualFloatersCouponStarDate::usage = "RangeAccrualFloatersCouponStarDate[ObjecctId_Symbol] Return the accrual start Date.
      \nObjectId: id of existing QuantLib::RangeAccrualFloatersCoupon object"
RangeAccrualFloatersPrice::usage = "RangeAccrualFloatersPrice[ObjecctId_Symbol,YieldCurve_Symbol] return the price of Range Accrual Floater Coupon.
      \nObjectId: id of existing QuantLib::RangeAccrualFloatersCoupon object\nYieldCurve: yield curve."
RangeAccrualPricerByBgm::usage = "RangeAccrualPricerByBgm[ObjecctId_Symbol,Correlation_?NumberQ,SmileOnStartDateID_Symbol,SmileOnEndDateID_Symbol,WithSmile:(True | False),ByCallSpread:(True | False)] Construct an object of class RangeAccrualPricerByBgm and return its id
      \nObjectId: id of object to be created\nCorrelation: correlation.\nSmileOnStartDateID: ID of the smile on start date object.\nSmileOnEndDateID: ID of the smile on end date object.\nWithSmile: with Smile?.\nByCallSpread: replicated by Call spread?.\nPermanent: object permanent/nonpermanent"
SimpleFloaterPrice::usage = "SimpleFloaterPrice[ObjecctId_Symbol,YieldCurve_Symbol] return the price of Simple Floater Coupon.
      \nObjectId: id of existing QuantLib::RangeAccrualFloatersCoupon object\nYieldCurve: yield curve."
Category[RangeAccrual] = {RangeAccrualFloatersCoupon,RangeAccrualFloatersCouponEndDate,RangeAccrualFloatersCouponFromLeg,RangeAccrualFloatersCouponObservationDates,RangeAccrualFloatersCouponObservationsNo,RangeAccrualFloatersCouponSetPricer,RangeAccrualFloatersCouponStarDate,RangeAccrualFloatersPrice,RangeAccrualPricerByBgm,SimpleFloaterPrice};
AppendTo[QLCategories,RangeAccrual]

(* RateHelper *)

RateHelper::usage = "functions to construct and use RateHelper objects."

BondHelper::usage = "BondHelper[ObjecctId_Symbol,CleanPrice_,Bond_Symbol] Construct an object of class BondHelper and return its id
      \nObjectId: id of object to be created\nCleanPrice: cleanPrice.\nBond: Bond object ID.\nPermanent: object permanent/nonpermanent"
DatedOISRateHelper::usage = "DatedOISRateHelper[ObjecctId_Symbol,StartDate_?DateQ,EndDate_?DateQ,FixedRate_,ONIndex_Symbol] Construct an object of class DatedOISRateHelper and return its id
      \nObjectId: id of object to be created\nStartDate: swap start date.\nEndDate: swap end date.\nFixedRate: quote.\nONIndex: floating leg OvernightIndex object ID.\nPermanent: object permanent/nonpermanent"
DepositRateHelper::usage = "DepositRateHelper[Rate_,IborIndex_Symbol] Construct an object of class DepositRateHelper and return its id\nDepositRateHelper[ObjecctId_Symbol,Rate_,IborIndex_Symbol] Construct an object of class DepositRateHelper and return its id\nDepositRateHelper[Rate_,Tenor_String] Construct an object of class DepositRateHelper and return its id\nDepositRateHelper[ObjecctId_Symbol,Rate_,Tenor_String] Construct an object of class DepositRateHelper and return its id
      \nObjectId: id of object to be created\nRate: deposit quote.\nIborIndex: IborIndex object ID.\nPermanent: object permanent/nonpermanent"
FixedRateBondHelper::usage = "FixedRateBondHelper[ObjecctId_Symbol,CleanPrice_,SettlementDays_Integer,ScheduleID_Symbol,Coupons_List /; VectorQ[Coupons, NumberQ],DayCounter_String] Construct an object of class FixedRateBondHelper and return its id
      \nObjectId: id of object to be created\nCleanPrice: cleanPrice.\nSettlementDays: settlement days.\nFaceAmount: Face nominal amount. Default value = 100.0.\nScheduleID: Schedule object ID.\nCoupons: coupon fixed rates.\nDayCounter: Payment DayCounter ID.\nPaymentBDC: payment business day convention. Default value = Following.\nRedemption: redemption value. Default value = 100.0.\nIssueDate: issue date: the bond can't be traded until then. Default value = Date[].\nPermanent: object permanent/nonpermanent"
FraRateHelper::usage = "FraRateHelper[ObjecctId_Symbol,Rate_,PeriodToStart_String,IborIndex_Symbol] Construct an object of class FraRateHelper and return its id
      \nObjectId: id of object to be created\nRate: quote.\nPeriodToStart: Period to start date.\nIborIndex: IborIndex object ID.\nPermanent: object permanent/nonpermanent"
FraRateHelper2::usage = "FraRateHelper2[ObjecctId_Symbol,Rate_,PeriodToStart_String,LengthInMonths_Integer,FixingDays_Integer,Convention_String,EndOfMonth:(True | False),DayCounter_String] Construct an object of class FraRateHelper and return its id
      \nObjectId: id of object to be created\nRate: quote.\nPeriodToStart: Period to start date.\nLengthInMonths: months to end.\nFixingDays: fixing days (e.g. 2).\nCalendar: holiday calendar (e.g. TARGET).\nConvention: business day convention (e.g. Modified Following).\nEndOfMonth: End of Month rule (TRUE for end of month to end of month termination date, FALSE otherwise).\nDayCounter: DayCounter ID.\nPermanent: object permanent/nonpermanent"
FuturesRateHelper::usage = "FuturesRateHelper[ObjecctId_Symbol,Price_,IMM_?DateQ,IborIndex_Symbol,ConvexityAdjQuote_]\n
       FuturesRateHelper2[ObjecctId_Symbol,Price_,IMM_String,LengthInMonths_Integer]\n
       Construct an object of class FuturesRateHelper and return its id
      \nObjectId: id of object to be created\nPrice: price quote.\nIMM: IMM date (or code).\nIborIndex: IborIndex object ID.\nConvexityAdjQuote: convexity adjustment quote (i.e. Forward rate = Futures rate - convexity adjustment).\nPermanent: object permanent/nonpermanent
      \nLengthInMonths: future contract length in months.\nCalendar: holiday calendar (e.g. TARGET).\nBusinessDayConvention: business day convention (e.g. Modified Following).\nEndOfMonth: End of Month rule (TRUE for end of month to end of month termination date, FALSE otherwise).\nDayCounter: DayCounter ID.\nPermanent: object permanent/nonpermanent"
FuturesRateHelperConvexityAdjustment::usage = "FuturesRateHelperConvexityAdjustment[ObjecctId_Symbol] returns the convexity adjustment for the given FuturesRateHelper object.
      \nObjectId: id of existing QuantLib::FuturesRateHelper object"
OISRateHelper::usage = "OISRateHelper[ObjecctId_Symbol,SettlDays_Integer,Tenor_String,FixedRate_,ONIndex_Symbol] Construct an object of class OISRateHelper and return its id
      \nObjectId: id of object to be created\nSettlDays: swap settlement days.\nTenor: swap length (e.g. 5Y for five years).\nFixedRate: quote.\nONIndex: floating leg OvernightIndex object ID.\nPermanent: object permanent/nonpermanent"
RateHelperEarliestDate::usage = "RateHelperEarliestDate[ObjecctId_Symbol] returns the earliest date for the given RateHelper object.
      \nObjectId: id of existing QuantLib::RateHelper object"
RateHelperImpliedQuote::usage = "RateHelperImpliedQuote[ObjecctId_Symbol] returns the curve implied quote of the given RateHelper object.
      \nObjectId: id of existing QuantLib::RateHelper object"
RateHelperLatestDate::usage = "RateHelperLatestDate[ObjecctId_Symbol] returns the latest date for the given RateHelper object.
      \nObjectId: id of existing QuantLib::RateHelper object"
RateHelperQuoteError::usage = "RateHelperQuoteError[ObjecctId_Symbol] returns the error between the curve implied quote and the value of the Quote wrapped in the given RateHelper object.
      \nObjectId: id of existing QuantLib::RateHelper object"
RateHelperQuoteIsValid::usage = "RateHelperQuoteIsValid[ObjecctId_Symbol] returns the isValid boolean of the Quote wrapped in the given RateHelper object.
      \nObjectId: id of existing QuantLib::RateHelper object"
RateHelperQuoteValue::usage = "RateHelperQuoteValue[ObjecctId_Symbol] returns the value of the Quote wrapped in the given RateHelper object.
      \nObjectId: id of existing QuantLib::RateHelper object"
RateHelperRate::usage = "RateHelperRate[RateHelper_Symbol] returns the rate (if any) associated to a rate helper.
      \nRateHelper: RateHelper ID."
RateHelperSelection::usage = "RateHelperSelection[RateHelpers_List,Priority_List /; VectorQ[Priority, IntegerQ],NImmFutures_Integer,NSerialFutures_Integer,MinDistance_List /; VectorQ[MinDistance, IntegerQ]] selects rate helpers for bootstrapping.
      \nRateHelpers: vector of RateHelper IDs.\nPriority: vector of priority integers (higher number for higher priority).\nNImmFutures: max number of IMM (March, June, September, December) Futures to be included.\nNSerialFutures: max number of Serial (January, February, April, May, July, August, October, November) Futures to be included.\nFutureRollDays: discard the front Futures the given number of (positive) days before its expiry (e.g zero implies the use of the front Futures during its expiry day). Default value = 2.\nDepoInclusion: Depo inclusion criteria. Default value = AllDepos.\nMinDistance: minimum distance in (positive) days from near instruments. Default value = 1."
SwapRateHelper::usage = "SwapRateHelper[ObjecctId_Symbol,Rate_?NumberQ,SwapIndex_Symbol,Spread_,ForwardStart_String]\nSwapRateHelper[ObjecctId_Symbol,Rate_?QuoteQ,SwapIndex_Symbol,Spread_,ForwardStart_String]\nSwapRateHelper[Rate_?NumberQ,SwapIndex_Symbol,Spread_,ForwardStart_String]\nSwapRateHelper[Rate_?Quote,SwapIndex_Symbol,Spread_,ForwardStart_String] Construct an object of class SwapRateHelper and return its id
      \nObjectId: id of object to be created\nRate: quote.\nSwapIndex: SwapIndex object ID.\nSpread: floating leg spread.\nForwardStart: forward start period.\nDiscountingCurve: discounting YieldTermStructure object ID. Default value = .\nPermanent: object permanent/nonpermanent\n
SwapRateHelper[ObjecctId_Symbol,Rate_?NumberQ|QuoteQ,Tenor_String,FixedLegFrequency_String,IborIndex_Symbol] Construct an object of class SwapRateHelper and return its id
      \nObjectId: id of object to be created\nRate: quote.\nTenor: swap length (e.g. 5Y for five years).\nCalendar: holiday calendar (e.g. TARGET).\nFixedLegFrequency: fixed leg frequency (e.g. Annual, Semiannual, Every4Month, Quarterly, Bimonthly, Monthly).\nFixedLegConvention: fixed leg convention (e.g. Unadjusted).\nFixedLegDayCounter: day counter (e.g. Actual/360).\nIborIndex: floating leg IborIndex object ID.\nSpread: floating leg spread.\nForwardStart: forward start period.\nDiscountingCurve: discounting YieldTermStructure object ID. Default value = .\nPermanent: object permanent/nonpermanent"
SwapRateHelperForwardStart::usage = "SwapRateHelperForwardStart[ObjecctId_Symbol] returns the forward start period for the given SwapRateHelper object.
      \nObjectId: id of existing QuantLib::SwapRateHelper object"
SwapRateHelperSpread::usage = "SwapRateHelperSpread[ObjecctId_Symbol] returns the spread for the given SwapRateHelper object.
      \nObjectId: id of existing QuantLib::SwapRateHelper object"
Category[RateHelper] = {BondHelper,DatedOISRateHelper,DepositRateHelper,FixedRateBondHelper,FraRateHelper,FraRateHelper2,FuturesRateHelper,FuturesRateHelper2,FuturesRateHelperConvexityAdjustment,OISRateHelper,RateHelperEarliestDate,RateHelperImpliedQuote,RateHelperLatestDate,RateHelperQuoteError,RateHelperQuoteIsValid,RateHelperQuoteValue,RateHelperRate,RateHelperSelection,SwapRateHelper,SwapRateHelper2,SwapRateHelperForwardStart,SwapRateHelperSpread};
AppendTo[QLCategories,RateHelper]

(* Schedules *)

Schedules::usage = "functions to construct and use Schedule objects."

Schedule::usage = 
"Schedule[ObjecctId_Symbol,TerminationDate_?DateQ,Tenor_String] Construct an object of class Schedule named ObjecctId and return its id
 Schedule[TerminationDate_?DateQ,Tenor_String] Construct an object of class Schedule and return its id
 Schedule[EffectiveDate_?DateQ,TerminationDate_?DateQ,Tenor_String] Construct an object of class Schedule with effective date EffectiveDate and return its id
      \nObjectId: id of object to be created\nEffectiveDate: effective date. Default value = Date[].
      \nTerminationDate: termination date.\nTenor: tenor (e.g. 2D for two days , 3W for three weeks, 6M for six months, 1Y for one year).
      \nCalendar: holiday calendar (e.g. TARGET). Default value = NullCalendar.\nConvention: accrual dates business day convention. Default value = Unadjusted.\nTermDateConv: termination date business day convention. Default value = Unadjusted.\nGenRule: Date generation rule (Backward, Forward, ThirdWednesday, Twentieth, TwentiethIMM, Zero). Default value = Backward.\nEndOfMonth: end of month convention. Default value = True.\nFirstDate: stub date, if there is an irregular starting period. Default value = Automatic.\nNextToLastDate: stub date, if there an irregular final period. Default value = Automatic.\nPermanent: object permanent/nonpermanent"
ScheduleBDC::usage = "ScheduleBDC[ObjecctId_Symbol] returns the business day convention used to calculate the given Schedule object.
      \nObjectId: id of existing QuantLib::Schedule object"
ScheduleCalendar::usage = "ScheduleCalendar[ObjecctId_Symbol] returns the Calendar used to calculate the given Schedule object.
      \nObjectId: id of existing QuantLib::Schedule object"
ScheduleDates::usage = "ScheduleDates[ObjecctId_Symbol] returns the dates for the given Schedule object.
      \nObjectId: id of existing QuantLib::Schedule object"
ScheduleEmpty::usage = "ScheduleEmpty[ObjecctId_Symbol] returns TRUE if the given Schedule object is empty.
      \nObjectId: id of existing QuantLib::Schedule object"
ScheduleEndDate::usage = "ScheduleEndDate[ObjecctId_Symbol] returns the end date of the given Schedule object.
      \nObjectId: id of existing QuantLib::Schedule object"
ScheduleEndOfMonth::usage = "ScheduleEndOfMonth[ObjecctId_Symbol] returns TRUE if end-of-month convention has been used to calculate the given Schedule object.
      \nObjectId: id of existing QuantLib::Schedule object"
ScheduleIsRegular::usage = "ScheduleIsRegular[ObjecctId_Symbol] returns TRUE if the selected period in the given Schedule object is regular.
      \nObjectId: id of existing QuantLib::Schedule object\nIndex: one based period index. Default value = 1."
ScheduleNextDate::usage = "ScheduleNextDate[ObjecctId_Symbol] returns the lowest date in the given Schedule object following the input reference date.
      \nObjectId: id of existing QuantLib::Schedule object\nRefDate: reference date. Default value = Date[]."
SchedulePreviousDate::usage = "SchedulePreviousDate[ObjecctId_Symbol] returns the highest date in the given Schedule object preceding the input reference date.
      \nObjectId: id of existing QuantLib::Schedule object\nRefDate: reference date. Default value = Date[]."
ScheduleRule::usage = "ScheduleRule[ObjecctId_Symbol] returns the DateGeneration::Rule of the given Schedule object.
      \nObjectId: id of existing QuantLib::Schedule object"
ScheduleSize::usage = "ScheduleSize[ObjecctId_Symbol] returns the number of dates in the given Schedule object.
      \nObjectId: id of existing QuantLib::Schedule object"
ScheduleStartDate::usage = "ScheduleStartDate[ObjecctId_Symbol] returns the start date of the given Schedule object.
      \nObjectId: id of existing QuantLib::Schedule object"
ScheduleTenor::usage = "ScheduleTenor[ObjecctId_Symbol] returns the tenor used to calculate the given Schedule object.
      \nObjectId: id of existing QuantLib::Schedule object"
ScheduleTerminationDateBDC::usage = "ScheduleTerminationDateBDC[ObjecctId_Symbol] returns the business day convention used to calculate the termination date of the given Schedule object.
      \nObjectId: id of existing QuantLib::Schedule object"
      
Callability::usage ="Callability[CallAmount_,CallType_,CallDate_] Construct an object of class callability."  
CallabilitySchedule::usage ="CallabilitySchedule[{{CallAmount_,CallType_,CallDate_}..}] Construct an object of class callability schedule."    
CallableFixedRateBond::usage = "CallableFixedRateBond[ObjecctId_Symbol,ScheduleID_Symbol,Coupons_List /; VectorQ[Coupons, NumberQ],CallScheduleID_Symbol] Construct an object of class CallableFixedRateBond and return its id
      \nObjectId: id of object to be created\nDescription: bond description string. Default value = no description available.\nCurrency: bond Currency.\nSettlementDays: settlement days.\nFaceAmount: Face nominal amount. Default value = 100.0.\nScheduleID: Schedule object ID.\nCoupons: simple annual compounding coupon rates.\nDayCounter: Payment DayCounter ID.\nPaymentBDC: payment business day convention. Default value = Following.\nRedemption: Redemption value. Default value = 100.0.\nIssueDate: issue date: the bond can't be traded until then. Default value = Date[].\nCallScheduleID: call schedule object.\nPermanent: object permanent/nonpermanent"

Category[Schedules] = {Schedule,ScheduleBDC,ScheduleCalendar,ScheduleDates,ScheduleEmpty,ScheduleEndDate,ScheduleEndOfMonth,ScheduleIsRegular,ScheduleNextDate,SchedulePreviousDate,ScheduleRule,ScheduleSize,ScheduleStartDate,ScheduleTenor,ScheduleTerminationDateBDC};
AppendTo[QLCategories,Schedules]

(* SequenceStatistics *)

SequenceStatistics::usage = "QuantLib statistics analysis of N-dimensional (sequence) data."

SequenceStatistics::usage = "SequenceStatistics[ObjecctId_Symbol] Construct an object of class SequenceStatistics and return its id
      \nObjectId: id of object to be created\nDimension: sample dimensionality. Default value = 0.\nPermanent: object permanent/nonpermanent"
SequenceStatistics2::usage = "SequenceStatistics2[ObjecctId_Symbol,Values_?MatrixQ,Weights_List /; VectorQ[Weights, NumberQ]] Construct an object of class SequenceStatistics and return its id
      \nObjectId: id of object to be created\nDimension: sample dimensionality. Default value = 0.\nValues: Sampled values. If omitted, an empty statistics is created.\nWeights: If omitted, all sampled values have the same weight. Default value = std::vector<QuantLib::Real>().\nPermanent: object permanent/nonpermanent"
SequenceStatisticsAverageShortfall::usage = "SequenceStatisticsAverageShortfall[ObjecctId_Symbol,Target_?NumberQ] Returns the averaged shortfallness for the given SequenceStatistics object.
      \nObjectId: id of existing QuantLib::SequenceStatistics object\nTarget: the target."
SequenceStatisticsCorrelation::usage = "SequenceStatisticsCorrelation[ObjecctId_Symbol] Returns the correlation Matrix for the given SequenceStatistics object.
      \nObjectId: id of existing QuantLib::SequenceStatistics object"
SequenceStatisticsCovariance::usage = "SequenceStatisticsCovariance[ObjecctId_Symbol] Returns the covariance Matrix for the given SequenceStatistics object.
      \nObjectId: id of existing QuantLib::SequenceStatistics object"
SequenceStatisticsDownsideDeviation::usage = "SequenceStatisticsDownsideDeviation[ObjecctId_Symbol] Returns the square root of the downside variance for the given SequenceStatistics object.
      \nObjectId: id of existing QuantLib::SequenceStatistics object"
SequenceStatisticsDownsideVariance::usage = "SequenceStatisticsDownsideVariance[ObjecctId_Symbol] Returns the variance of observations below zero for the given SequenceStatistics object.
      \nObjectId: id of existing QuantLib::SequenceStatistics object"
SequenceStatisticsErrorEstimate::usage = "SequenceStatisticsErrorEstimate[ObjecctId_Symbol] Returns the error estimate on the mean value for the given SequenceStatistics object.
      \nObjectId: id of existing QuantLib::SequenceStatistics object"
SequenceStatisticsGaussianAverageShortfall::usage = "SequenceStatisticsGaussianAverageShortfall[ObjecctId_Symbol,Target_?NumberQ] Returns the averaged shortfallness for the given SequenceStatistics object.
      \nObjectId: id of existing QuantLib::SequenceStatistics object\nTarget: the target."
SequenceStatisticsGaussianPercentile::usage = "SequenceStatisticsGaussianPercentile[ObjecctId_Symbol,X_?NumberQ] Returns the x-th percentile for the given SequenceStatistics object.
      \nObjectId: id of existing QuantLib::SequenceStatistics object\nX: Must be in the range (0,1]."
SequenceStatisticsGaussianPotentialUpside::usage = "SequenceStatisticsGaussianPotentialUpside[ObjecctId_Symbol,Target_?NumberQ] Returns the reciprocal of VAR at a given percentile for the given SequenceStatistics object.
      \nObjectId: id of existing QuantLib::SequenceStatistics object\nTarget: the percentile."
SequenceStatisticsGaussianShortfall::usage = "SequenceStatisticsGaussianShortfall[ObjecctId_Symbol,Target_?NumberQ] Returns the probability of missing the given target for the given SequenceStatistics object.
      \nObjectId: id of existing QuantLib::SequenceStatistics object\nTarget: the target."
SequenceStatisticsGaussianValueAtRisk::usage = "SequenceStatisticsGaussianValueAtRisk[ObjecctId_Symbol,Target_?NumberQ] Returns the value-at-risk at a given percentile for the given SequenceStatistics object.
      \nObjectId: id of existing QuantLib::SequenceStatistics object\nTarget: the percentile."
SequenceStatisticsInc::usage = "SequenceStatisticsInc[ObjecctId_Symbol] Construct an object of class SequenceStatisticsInc and return its id
      \nObjectId: id of object to be created\nDimension: sample dimensionality. Default value = 0.\nPermanent: object permanent/nonpermanent"
SequenceStatisticsInc2::usage = "SequenceStatisticsInc2[ObjecctId_Symbol,Values_?MatrixQ,Weights_List /; VectorQ[Weights, NumberQ]] Construct an object of class SequenceStatisticsInc and return its id
      \nObjectId: id of object to be created\nDimension: sample dimensionality. Default value = 0.\nValues: Sampled values. If omitted, an empty statistics is created.\nWeights: If omitted, all sampled values have the same weight. Default value = std::vector<QuantLib::Real>().\nPermanent: object permanent/nonpermanent"
SequenceStatisticsKurtosis::usage = "SequenceStatisticsKurtosis[ObjecctId_Symbol] Returns the excess kurtosis for the given SequenceStatistics object.
      \nObjectId: id of existing QuantLib::SequenceStatistics object"
SequenceStatisticsMax::usage = "SequenceStatisticsMax[ObjecctId_Symbol] Returns the maximum sample value for the given SequenceStatistics object.
      \nObjectId: id of existing QuantLib::SequenceStatistics object"
SequenceStatisticsMean::usage = "SequenceStatisticsMean[ObjecctId_Symbol] Returns the mean for the given SequenceStatistics object.
      \nObjectId: id of existing QuantLib::SequenceStatistics object"
SequenceStatisticsMin::usage = "SequenceStatisticsMin[ObjecctId_Symbol] Returns the minimum sample value for the given SequenceStatistics object.
      \nObjectId: id of existing QuantLib::SequenceStatistics object"
SequenceStatisticsPercentile::usage = "SequenceStatisticsPercentile[ObjecctId_Symbol,X_?NumberQ] Returns the x-th percentile for the given SequenceStatistics object.
      \nObjectId: id of existing QuantLib::SequenceStatistics object\nX: Must be in the range (0,1]."
SequenceStatisticsPotentialUpside::usage = "SequenceStatisticsPotentialUpside[ObjecctId_Symbol,Centile_?NumberQ] Returns the reciprocal of VAR at a given percentile for the given SequenceStatistics object.
      \nObjectId: id of existing QuantLib::SequenceStatistics object\nCentile: the centile."
SequenceStatisticsRegret::usage = "SequenceStatisticsRegret[ObjecctId_Symbol,Target_?NumberQ] Returns the variance of observations below target for the given SequenceStatistics object.
      \nObjectId: id of existing QuantLib::SequenceStatistics object\nTarget: the target."
SequenceStatisticsSamples::usage = "SequenceStatisticsSamples[ObjecctId_Symbol] Returns the number of samples collected for the given SequenceStatistics object.
      \nObjectId: id of existing QuantLib::SequenceStatistics object"
SequenceStatisticsSemiDeviation::usage = "SequenceStatisticsSemiDeviation[ObjecctId_Symbol] Returns the square root of the semivariance for the given SequenceStatistics object.
      \nObjectId: id of existing QuantLib::SequenceStatistics object"
SequenceStatisticsSemiVariance::usage = "SequenceStatisticsSemiVariance[ObjecctId_Symbol] Returns the variance of observations below the mean for the given SequenceStatistics object.
      \nObjectId: id of existing QuantLib::SequenceStatistics object"
SequenceStatisticsShortfall::usage = "SequenceStatisticsShortfall[ObjecctId_Symbol,Target_?NumberQ] Returns the probability of missing the given target for the given SequenceStatistics object.
      \nObjectId: id of existing QuantLib::SequenceStatistics object\nTarget: the target."
SequenceStatisticsSize::usage = "SequenceStatisticsSize[ObjecctId_Symbol] Returns the size (sample dimensionality) for the given SequenceStatistics object.
      \nObjectId: id of existing QuantLib::SequenceStatistics object"
SequenceStatisticsSkewness::usage = "SequenceStatisticsSkewness[ObjecctId_Symbol] Returns the skewness for the given SequenceStatistics object.
      \nObjectId: id of existing QuantLib::SequenceStatistics object"
SequenceStatisticsStandardDeviation::usage = "SequenceStatisticsStandardDeviation[ObjecctId_Symbol] Returns the the standard deviation for the given SequenceStatistics object.
      \nObjectId: id of existing QuantLib::SequenceStatistics object"
SequenceStatisticsValueAtRisk::usage = "SequenceStatisticsValueAtRisk[ObjecctId_Symbol,Target_?NumberQ] Returns the value-at-risk at a given percentile for the given SequenceStatistics object.
      \nObjectId: id of existing QuantLib::SequenceStatistics object\nTarget: the percentile."
SequenceStatisticsVariance::usage = "SequenceStatisticsVariance[ObjecctId_Symbol] Returns the variance for the given SequenceStatistics object.
      \nObjectId: id of existing QuantLib::SequenceStatistics object"
SequenceStatisticsWeightSum::usage = "SequenceStatisticsWeightSum[ObjecctId_Symbol] Returns the sum of data weights for the given SequenceStatistics object.
      \nObjectId: id of existing QuantLib::SequenceStatistics object"
Category[SequenceStatistics] = {SequenceStatistics,SequenceStatistics2,SequenceStatisticsAverageShortfall,SequenceStatisticsCorrelation,SequenceStatisticsCovariance,SequenceStatisticsDownsideDeviation,SequenceStatisticsDownsideVariance,SequenceStatisticsErrorEstimate,SequenceStatisticsGaussianAverageShortfall,SequenceStatisticsGaussianPercentile,SequenceStatisticsGaussianPotentialUpside,SequenceStatisticsGaussianShortfall,SequenceStatisticsGaussianValueAtRisk,SequenceStatisticsInc,SequenceStatisticsInc2,SequenceStatisticsKurtosis,SequenceStatisticsMax,SequenceStatisticsMean,SequenceStatisticsMin,SequenceStatisticsPercentile,SequenceStatisticsPotentialUpside,SequenceStatisticsRegret,SequenceStatisticsSamples,SequenceStatisticsSemiDeviation,SequenceStatisticsSemiVariance,SequenceStatisticsShortfall,SequenceStatisticsSize,SequenceStatisticsSkewness,SequenceStatisticsStandardDeviation,SequenceStatisticsValueAtRisk,SequenceStatisticsVariance,SequenceStatisticsWeightSum};
AppendTo[QLCategories,SequenceStatistics]

(* Settings *)

Settings::usage = "global settings functions."

EnforceTodaysHistoricFixings::usage = "EnforceTodaysHistoricFixings[] returns the current value of the boolean which enforce the usage of historic fixings for today's date.
      \n EnforceTodaysHistoricFixings[True] sets it to true and requires fixings for the calculation"
SettingsEvaluationDate::usage = "SettingsEvaluationDate[] returns the current value of the Evaluation Date.
      \n"
SettingsSetEvaluationDate::usage = "SettingsSetEvaluationDate[EvalDate_?DateQ] sets the value of the Evaluation Date.
      \nEvalDate: new value for the evaluation date."
Category[Settings] = {EnforceTodaysHistoricFixings,SettingsEvaluationDate,SettingsSetEvaluationDate};
AppendTo[QLCategories,Settings]

(* Calibrated Models *)
CalibrateModel::usage = "CalibrateModel[ModelId_Symbol,CalibrationHelpers_List]"
CalibratedModelParams::usage = "CalibrateModelParams[ObjectId_Symbol]"
CalibratedModelSetParams::usage = "CalibratedModelSetParams[ObjectId_Symbol,Params_List /; Vector[Params,NumberQ]]"
CalibratedModelValue::usage = "CalibratedModelValue[ObjectId_Symbol,Params_List /; Vector[Params,NumberQ],CalibrationHelpers_List]"
Category[CalibratedModels] = {CalibratedModels,CalibrateModelParams,CalibratedModelSetParams,CalibrateModelValue}
AppendTo[QLCategories,CalibratedModels]

(* Short Rate Models *)

ShortRateModels::usage = "functions to construct and use short-rate model objects."

DiscountBond::usage = "DiscountBond[OneFactorAffineModel_Symbol,Now_?NumberQ,Maturity_?NumberQ,Rate_?NumberQ]"
DiscountBondOption::usage = "DiscountBondOption[OneFactorAffineModel_Symbol,OptionType_String,Strike_?NumberQ,Maturity_?NumberQ,BondMaturity_?NumberQ]"
FuturesConvexityBias::usage = "FuturesConvexityBias[FuturesPrice_?NumberQ,T1_?NumberQ,T2_?NumberQ,Sigma_?NumberQ] Returns Futures convexity bias (ForwardRate = FuturesImpliedRate - ConvexityBias) calculated as in G. Kirikos, D. Novak, 'Convexity Conundrums', Risk Magazine, March 1997.
      \nFuturesPrice: Futures price (e.g. 94.56).\nT1: Maturity date of the futures contract in years(e.g. 5.0).\nT2: Maturity of the underlying Libor deposit in years (e.g. 5.25).\nSigma: Hull-White volatility (e.g. 0.015).\nA: Hull-White mean reversion. Default value = 0.03."
HullWhite::usage = "HullWhite[ObjecctId_Symbol,YieldCurve_Symbol,A_?NumberQ,Sigma_?NumberQ] Construct an object of class HullWhite and return its id
      \nObjectId: id of object to be created\nYieldCurve: YieldTermStructure object ID.\nA: a.\nSigma: volatility.\nPermanent: object permanent/nonpermanent"
Vasicek::usage = "Vasicek[ObjecctId_Symbol,A_?NumberQ,B_?NumberQ,Sigma_?NumberQ,Lambda_?NumberQ] Construct an object of class Vasicek and return its id
      \nObjectId: id of object to be created\nA: mean reverting speed.\nB: short-rate limit value.\nLambda: risk premium.\nSigma: volatility.\nPermanent: object permanent/nonpermanent"
G2::usage ="G2[...]"      
BlackKarasinsiki::usage ="BlackKarasinski[ObjecctId_Symbol,YieldCurve_Symbol,A_?NumberQ,Sigma_?NumberQ]\nBlackKarasinski[YieldCurve_Symbol,A_?NumberQ,Sigma_?NumberQ]"      
CoxIngersollRoss::usage ="CoxIngersollRoss[...]"
ExtendedCoxIngersollRoss::usage ="ExtendedCoxIngersollRoss[...]"           
Category[ShortRateModels] = {FuturesConvexityBias,HullWhite,Vasicek,G2,BlackKarasinski,CoxIngersollRoss,ExtendedCoxIngersollRoss};
AppendTo[QLCategories,ShortRateModels]

(* Smile Section Structures *)

SmileSectionStructures::usage = "functions to construct and use SmileSection objects."

FlatSmileSection::usage = "FlatSmileSection[ObjecctId_Symbol,OptionDate_?DateQ,Volatility_?NumberQ,RefDate_?DateQ,AtmValue_?NumberQ] Construct an object of class FlatSmileSection and return its id
      \nObjectId: id of object to be created\nOptionDate: smile's expiry as date.\nVolatility: volatilities.\nDayCounter: DayCounter ID. Default value = Actual/365 (Fixed).\nRefDate: ref date.\nAtmValue: Current value of the underlying.\nPermanent: object permanent/nonpermanent"
InterpolatedSmileSection::usage = "InterpolatedSmileSection[ObjecctId_Symbol,OptionDate_?DateQ,Strikes_List /; VectorQ[Strikes, NumberQ],StdDevs_List,AtmLevel_] Construct an object of class InterpolatedSmileSection and return its id
      \nObjectId: id of object to be created\nOptionDate: smile's expiry as date.\nStrikes: strikes.\nStdDevs: standard deviations (i.e. volatilities times square root of time to option expiry).\nAtmLevel: Current value of the underlying.\nDayCounter: DayCounter ID. Default value = Actual/365 (Fixed).\nPermanent: object permanent/nonpermanent"
SabrInterpolatedSmileSection::usage = "SabrInterpolatedSmileSection[ObjecctId_Symbol,OptionDate_?DateQ,ForwardRate_?NumberQ,Strike_List /; VectorQ[Strike, NumberQ],FloatingStrike:(True | False),AtmVolatility_?NumberQ,VolatilitySpreads_List /; VectorQ[VolatilitySpreads, NumberQ]] Construct an object of class SabrInterpolatedSmileSection and return its id
      \nObjectId: id of object to be created\nOptionDate: smile's expiry as Date.\nForwardRate: Atm forward rate.\nStrike: strikes.\nFloatingStrike: Strikes are floating or fixed.\nAtmVolatility: atm volatility.\nVolatilitySpreads: volatilities spread at option expiries.\nAlpha: alpha (fixed value or guess). Default value = 0.\nBeta: beta (fixed value or guess). Default value = 0.\nNu: nu (fixed value or guess). Default value = 0.\nRho: rho (fixed value or guess). Default value = 0.\nAlphaIsFixed: TRUE if the alpha value provided is to be kept fixed, FALSE if it is just a guess. Default value = false.\nBetaIsFixed: TRUE if the beta value provided is to be kept fixed, FALSE if it is just a guess. Default value = false.\nNuIsFixed: TRUE if the nu value provided is to be kept fixed, FALSE if it is just a guess. Default value = false.\nRhoIsFixed: TRUE if the rho value provided is to be kept fixed, FALSE if it is just a guess. Default value = false.\nVegaWeighted: TRUE if the interpolation is weighted using options Vega. Default value = false.\nEndCriteria: EndCriteria object ID. Default value = .\nMethod: OptimizationMethod object ID. Default value = .\nDayCounter: DayCounter ID. Default value = Actual/365 (Fixed).\nPermanent: object permanent/nonpermanent"
SabrInterpolatedSmileSection1::usage = "SabrInterpolatedSmileSection1[ObjecctId_Symbol,OptionDate_?DateQ,ForwardRate_,Strike_List /; VectorQ[Strike, NumberQ],FloatingStrike:(True | False),AtmVolatility_,VolatilitySpreads_List] Construct an object of class SabrInterpolatedSmileSection and return its id
      \nObjectId: id of object to be created\nOptionDate: smile's expiry as Date.\nForwardRate: Atm forward rate quote.\nStrike: strikes.\nFloatingStrike: Strikes are floating or fixed.\nAtmVolatility: atm volatility quote.\nVolatilitySpreads: volatilities spread quotes at option expiries.\nAlpha: alpha (fixed value or guess). Default value = 0.\nBeta: beta (fixed value or guess). Default value = 0.\nNu: nu (fixed value or guess). Default value = 0.\nRho: rho (fixed value or guess). Default value = 0.\nAlphaIsFixed: TRUE if the alpha value provided is to be kept fixed, FALSE if it is just a guess. Default value = false.\nBetaIsFixed: TRUE if the beta value provided is to be kept fixed, FALSE if it is just a guess. Default value = false.\nNuIsFixed: TRUE if the nu value provided is to be kept fixed, FALSE if it is just a guess. Default value = false.\nRhoIsFixed: TRUE if the rho value provided is to be kept fixed, FALSE if it is just a guess. Default value = false.\nVegaWeighted: TRUE if the interpolation is weighted using options Vega. Default value = false.\nEndCriteria: EndCriteria object ID. Default value = .\nMethod: OptimizationMethod object ID. Default value = .\nDayCounter: DayCounter ID. Default value = Actual/365 (Fixed).\nPermanent: object permanent/nonpermanent"
SabrInterpolatedSmileSectionAlpha::usage = "SabrInterpolatedSmileSectionAlpha[ObjecctId_Symbol] Returns the alpha of the SABR fit for the given SabrInterpolatedSmileSection object.
      \nObjectId: id of existing QuantLib::SabrInterpolatedSmileSection object"
SabrInterpolatedSmileSectionBeta::usage = "SabrInterpolatedSmileSectionBeta[ObjecctId_Symbol] Returns the beta of the SABR fit.
      \nObjectId: id of existing QuantLib::SabrInterpolatedSmileSection object"
SabrInterpolatedSmileSectionEndCriteria::usage = "SabrInterpolatedSmileSectionEndCriteria[ObjecctId_Symbol] Returns the optimization end criteria of the SABR fit for the given SabrInterpolatedSmileSection object.
      \nObjectId: id of existing QuantLib::SabrInterpolatedSmileSection object"
SabrInterpolatedSmileSectionError::usage = "SabrInterpolatedSmileSectionError[ObjecctId_Symbol] Returns the error of the SABR fit for the given SabrInterpolatedSmileSection object.
      \nObjectId: id of existing QuantLib::SabrInterpolatedSmileSection object"
SabrInterpolatedSmileSectionMaxError::usage = "SabrInterpolatedSmileSectionMaxError[ObjecctId_Symbol] Returns the max error of the SABR fit for the given SabrInterpolatedSmileSection object.
      \nObjectId: id of existing QuantLib::SabrInterpolatedSmileSection object"
SabrInterpolatedSmileSectionNu::usage = "SabrInterpolatedSmileSectionNu[ObjecctId_Symbol] Returns the nu of the SABR fit for the given SabrInterpolatedSmileSection object.
      \nObjectId: id of existing QuantLib::SabrInterpolatedSmileSection object"
SabrInterpolatedSmileSectionRho::usage = "SabrInterpolatedSmileSectionRho[ObjecctId_Symbol] Returns the rho of the SABR fit for the given SabrInterpolatedSmileSection object.
      \nObjectId: id of existing QuantLib::SabrInterpolatedSmileSection object"
SabrSmileSection::usage = "SabrSmileSection[ObjecctId_Symbol,OptionTime_?NumberQ,Strikes_List /; VectorQ[Strikes, NumberQ],StdDevs_List,Forward_] Construct an object of class SabrSmileSection and return its id
      \nObjectId: id of object to be created\nOptionTime: smile's expiry as time.\nStrikes: strikes.\nStdDevs: standard deviations (i.e. volatilities times square root of time to option expiry).\nForward: atm rate.\nAlpha: alpha (fixed value or guess). Default value = 0.\nBeta: beta (fixed value or guess). Default value = 0.\nNu: nu (fixed value or guess). Default value = 0.\nRho: rho (fixed value or guess). Default value = 0.\nAlphaIsFixed: TRUE if the alpha value provided is to be kept fixed, FALSE if it is just a guess. Default value = false.\nBetaIsFixed: TRUE if the beta value provided is to be kept fixed, FALSE if it is just a guess. Default value = false.\nNuIsFixed: TRUE if the nu value provided is to be kept fixed, FALSE if it is just a guess. Default value = false.\nRhoIsFixed: TRUE if the rho value provided is to be kept fixed, FALSE if it is just a guess. Default value = false.\nVegaWeighted: TRUE if the interpolation is weighted using options Vega. Default value = false.\nEndCriteria: EndCriteria object ID. Default value = .\nMethod: Optimization Method. Default value = .\nPermanent: object permanent/nonpermanent"
SmileSectionAtmLevel::usage = "SmileSectionAtmLevel[ObjecctId_Symbol] Returns the current value of the SmileSection underlying.
      \nObjectId: id of existing QuantLib::SmileSection object"
SmileSectionDayCounter::usage = "SmileSectionDayCounter[ObjecctId_Symbol] Returns the DayCounter of the SmileSection object.
      \nObjectId: id of existing QuantLib::SmileSection object"
SmileSectionExerciseDate::usage = "SmileSectionExerciseDate[ObjecctId_Symbol] Returns the exercise date of the SmileSection object.
      \nObjectId: id of existing QuantLib::SmileSection object"
SmileSectionFromSabrVolSurface::usage = "SmileSectionFromSabrVolSurface[ObjecctId_Symbol,SabrVolSurface_Symbol,OptionTime_?NumberQ] Construct an object of class SmileSectionFromSabrVolSurface and return its id
      \nObjectId: id of object to be created\nSabrVolSurface: SabrVolSurface object ID.\nOptionTime: smile's expiry as date.\nPermanent: object permanent/nonpermanent"
SmileSectionVariance::usage = "SmileSectionVariance[ObjecctId_Symbol] Returns the variance at a given strike from the SmileSection object.
      \nObjectId: id of existing QuantLib::SmileSection object\nStrike: strike. Default value = 0."
SmileSectionVolatility::usage = "SmileSectionVolatility[ObjecctId_Symbol] Returns the volatility at a given strike from the SmileSection object.
      \nObjectId: id of existing QuantLib::SmileSection object\nStrike: strike. Default value = 0."
Category[SmileSectionStructures] = {FlatSmileSection,InterpolatedSmileSection,SabrInterpolatedSmileSection,SabrInterpolatedSmileSection1,SabrInterpolatedSmileSectionAlpha,SabrInterpolatedSmileSectionBeta,SabrInterpolatedSmileSectionEndCriteria,SabrInterpolatedSmileSectionError,SabrInterpolatedSmileSectionMaxError,SabrInterpolatedSmileSectionNu,SabrInterpolatedSmileSectionRho,SabrSmileSection,SmileSectionAtmLevel,SmileSectionDayCounter,SmileSectionExerciseDate,SmileSectionFromSabrVolSurface,SmileSectionVariance,SmileSectionVolatility};
AppendTo[QLCategories,SmileSectionStructures]

(* Statistics *)

Statistics::usage = "functions to construct and use Statistics objects."

GaussianAverageShortfall::usage = "GaussianAverageShortfall[Target_?NumberQ] Returns the averaged shortfallness.
      \nTarget: the target.\nMean: The mean of the gaussian distribution. Default value = 0.0.\nStdDev: The standard deviation of the gaussian distribution. Default value = 1.0."
GaussianDownsideDeviation::usage = "GaussianDownsideDeviation[] Returns the square root of the downside variance.
      \nMean: mean of the gaussian distribution. Default value = 0.0.\nStdDev: standard deviation of the gaussian distribution. Default value = 1.0."
GaussianDownsideVariance::usage = "GaussianDownsideVariance[] Returns the variance of observations below zero.
      \nMean: the mean of the gaussian distribution. Default value = 0.0.\nStdDev: standard deviation of the gaussian distribution. Default value = 1.0."
GaussianExpectedShortfall::usage = "GaussianExpectedShortfall[Target_?NumberQ] Returns the expected loss in case that the loss exceeded a VaR threshold.
      \nTarget: the percentile.\nMean: The mean of the gaussian distribution. Default value = 0.0.\nStdDev: The standard deviation of the gaussian distribution. Default value = 1.0."
GaussianPercentile::usage = "GaussianPercentile[X_?NumberQ] Returns the x-th percentile.
      \nX: the percentile.\nMean: mean of the gaussian distribution. Default value = 0.0.\nStdDev: standard deviation of the gaussian distribution. Default value = 1.0."
GaussianPotentialUpside::usage = "GaussianPotentialUpside[Target_?NumberQ] Returns the reciprocal of VAR at a given percentile.
      \nTarget: the percentile.\nMean: The mean of the gaussian distribution. Default value = 0.0.\nStdDev: The standard deviation of the gaussian distribution. Default value = 1.0."
GaussianRegret::usage = "GaussianRegret[Target_?NumberQ] Returns the variance of observations below target.
      \nTarget: the target.\nMean: mean of the gaussian distribution. Default value = 0.0.\nStdDev: standard deviation of the gaussian distribution. Default value = 1.0."
GaussianShortfall::usage = "GaussianShortfall[Target_?NumberQ] Returns the probability of missing the given target.
      \nTarget: the target.\nMean: The mean of the gaussian distribution. Default value = 0.0.\nStdDev: The standard deviation of the gaussian distribution. Default value = 1.0."
GaussianTopPercentile::usage = "GaussianTopPercentile[X_?NumberQ] Returns the x-th top percentile.
      \nX: the percentile.\nMean: The mean of the gaussian distribution. Default value = 0.0.\nStdDev: The standard deviation of the gaussian distribution. Default value = 1.0."
GaussianValueAtRisk::usage = "GaussianValueAtRisk[Target_?NumberQ] Returns the value-at-risk at a given percentile.
      \nTarget: the percentile.\nMean: The mean of the gaussian distribution. Default value = 0.0.\nStdDev: The standard deviation of the gaussian distribution. Default value = 1.0."
IncrementalStatistics::usage = "IncrementalStatistics[ObjecctId_Symbol,Values_List /; VectorQ[Values, NumberQ],Weights_List /; VectorQ[Weights, NumberQ]] Construct an object of class IncrementalStatistics and return its id
      \nObjectId: id of object to be created\nValues: Sampled values. If omitted, an empty statistics is created. Default value = std::vector<QuantLib::Real>().\nWeights: Weights. If omitted, all sampled values have the same weight. Default value = std::vector<QuantLib::Real>().\nPermanent: object permanent/nonpermanent"
Statistics::usage = "Statistics[ObjecctId_Symbol,Values_List /; VectorQ[Values, NumberQ],Weights_List /; VectorQ[Weights, NumberQ]] Construct an object of class Statistics and return its id
      \nObjectId: id of object to be created\nValues: Sampled values. If omitted, an empty statistics is created. Default value = std::vector<QuantLib::Real>().\nWeights: Weights. If omitted, all sampled values have the same weight. Default value = std::vector<QuantLib::Real>().\nPermanent: object permanent/nonpermanent"
StatisticsAverageShortfall::usage = "StatisticsAverageShortfall[ObjecctId_Symbol,Target_?NumberQ] Returns the averaged shortfallness for the given Statistics object.
      \nObjectId: id of existing QuantLib::Statistics object\nTarget: the target."
StatisticsDownsideDeviation::usage = "StatisticsDownsideDeviation[ObjecctId_Symbol] Returns the square root of the downside variance for the given Statistics object.
      \nObjectId: id of existing QuantLib::Statistics object"
StatisticsDownsideVariance::usage = "StatisticsDownsideVariance[ObjecctId_Symbol] Returns the variance of observations below zero for the given Statistics object.
      \nObjectId: id of existing QuantLib::Statistics object"
StatisticsErrorEstimate::usage = "StatisticsErrorEstimate[ObjecctId_Symbol] Returns the error estimate on the mean value for the given Statistics object.
      \nObjectId: id of existing QuantLib::Statistics object"
StatisticsExpectedShortfall::usage = "StatisticsExpectedShortfall[ObjecctId_Symbol,Centile_?NumberQ] Returns the expected loss in case that the loss exceeded a VaR threshold for the given Statistics object.
      \nObjectId: id of existing QuantLib::Statistics object\nCentile: the centile."
StatisticsGaussianAverageShortfall::usage = "StatisticsGaussianAverageShortfall[ObjecctId_Symbol,Target_?NumberQ] Returns the averaged shortfallness for the given Statistics object.
      \nObjectId: id of existing QuantLib::Statistics object\nTarget: the target."
StatisticsGaussianDownsideDeviation::usage = "StatisticsGaussianDownsideDeviation[ObjecctId_Symbol] Returns the square root of the downside variance for the given Statistics object.
      \nObjectId: id of existing QuantLib::Statistics object"
StatisticsGaussianDownsideVariance::usage = "StatisticsGaussianDownsideVariance[ObjecctId_Symbol] Returns the variance of observations below zero for the given Statistics object.
      \nObjectId: id of existing QuantLib::Statistics object"
StatisticsGaussianExpectedShortfall::usage = "StatisticsGaussianExpectedShortfall[ObjecctId_Symbol,Target_?NumberQ] Returns the expected loss in case that the loss exceeded a VaR threshold for the given Statistics object.
      \nObjectId: id of existing QuantLib::Statistics object\nTarget: the percentile."
StatisticsGaussianPercentile::usage = "StatisticsGaussianPercentile[ObjecctId_Symbol,X_?NumberQ] Returns the x-th percentile for the given Statistics object.
      \nObjectId: id of existing QuantLib::Statistics object\nX: Must be in the range (0,1]."
StatisticsGaussianPotentialUpside::usage = "StatisticsGaussianPotentialUpside[ObjecctId_Symbol,Target_?NumberQ] Returns the reciprocal of VAR at a given percentile for the given Statistics object.
      \nObjectId: id of existing QuantLib::Statistics object\nTarget: the percentile."
StatisticsGaussianRegret::usage = "StatisticsGaussianRegret[ObjecctId_Symbol,Target_?NumberQ] Returns the variance of observations below the target for the given Statistics object.
      \nObjectId: id of existing QuantLib::Statistics object\nTarget: the target."
StatisticsGaussianShortfall::usage = "StatisticsGaussianShortfall[ObjecctId_Symbol,Target_?NumberQ] Returns the probability of missing the given target for the given Statistics object.
      \nObjectId: id of existing QuantLib::Statistics object\nTarget: the target."
StatisticsGaussianTopPercentile::usage = "StatisticsGaussianTopPercentile[ObjecctId_Symbol,X_?NumberQ] Returns the x-th top percentile for the given Statistics object.
      \nObjectId: id of existing QuantLib::Statistics object\nX: Must be in the range (0,1]."
StatisticsGaussianValueAtRisk::usage = "StatisticsGaussianValueAtRisk[ObjecctId_Symbol,Target_?NumberQ] Returns the value-at-risk at a given percentile for the given Statistics object.
      \nObjectId: id of existing QuantLib::Statistics object\nTarget: the percentile."
StatisticsKurtosis::usage = "StatisticsKurtosis[ObjecctId_Symbol] Returns the excess kurtosis for the given Statistics object.
      \nObjectId: id of existing QuantLib::Statistics object"
StatisticsMax::usage = "StatisticsMax[ObjecctId_Symbol] Returns the maximum sample value for the given Statistics object.
      \nObjectId: id of existing QuantLib::Statistics object"
StatisticsMean::usage = "StatisticsMean[ObjecctId_Symbol] Returns the mean for the given Statistics object.
      \nObjectId: id of existing QuantLib::Statistics object"
StatisticsMin::usage = "StatisticsMin[ObjecctId_Symbol] Returns the minimum sample value for the given Statistics object.
      \nObjectId: id of existing QuantLib::Statistics object"
StatisticsPercentile::usage = "StatisticsPercentile[ObjecctId_Symbol,X_?NumberQ] Returns the x-th percentile for the given Statistics object.
      \nObjectId: id of existing QuantLib::Statistics object\nX: Must be in the range (0,1]."
StatisticsPotentialUpside::usage = "StatisticsPotentialUpside[ObjecctId_Symbol,Centile_?NumberQ] Returns the reciprocal of VAR at a given percentile for the given Statistics object.
      \nObjectId: id of existing QuantLib::Statistics object\nCentile: the centile."
StatisticsRegret::usage = "StatisticsRegret[ObjecctId_Symbol,Target_?NumberQ] Returns the variance of observations below target for the given Statistics object.
      \nObjectId: id of existing QuantLib::Statistics object\nTarget: the target."
StatisticsSamples::usage = "StatisticsSamples[ObjecctId_Symbol] Returns the number of samples collected for the given Statistics object.
      \nObjectId: id of existing QuantLib::Statistics object"
StatisticsSemiDeviation::usage = "StatisticsSemiDeviation[ObjecctId_Symbol] Returns the square root of the semivariance for the given Statistics object.
      \nObjectId: id of existing QuantLib::Statistics object"
StatisticsSemiVariance::usage = "StatisticsSemiVariance[ObjecctId_Symbol] Returns the variance of observations below the mean for the given Statistics object.
      \nObjectId: id of existing QuantLib::Statistics object"
StatisticsShortfall::usage = "StatisticsShortfall[ObjecctId_Symbol,Target_?NumberQ] Returns the probability of missing the given target for the given Statistics object.
      \nObjectId: id of existing QuantLib::Statistics object\nTarget: the target."
StatisticsSkewness::usage = "StatisticsSkewness[ObjecctId_Symbol] Returns the skewness for the given Statistics object.
      \nObjectId: id of existing QuantLib::Statistics object"
StatisticsStandardDeviation::usage = "StatisticsStandardDeviation[ObjecctId_Symbol] Returns the the standard deviation for the given Statistics object.
      \nObjectId: id of existing QuantLib::Statistics object"
StatisticsTopPercentile::usage = "StatisticsTopPercentile[ObjecctId_Symbol,X_?NumberQ] Returns the x-th top percentile for the given Statistics object.
      \nObjectId: id of existing QuantLib::Statistics object\nX: Must be in the range (0,1]."
StatisticsValueAtRisk::usage = "StatisticsValueAtRisk[ObjecctId_Symbol,Target_?NumberQ] Returns the value-at-risk at a given percentile for the given Statistics object.
      \nObjectId: id of existing QuantLib::Statistics object\nTarget: the percentile."
StatisticsVariance::usage = "StatisticsVariance[ObjecctId_Symbol] Returns the variance for the given Statistics object.
      \nObjectId: id of existing QuantLib::Statistics object"
StatisticsWeightSum::usage = "StatisticsWeightSum[ObjecctId_Symbol] Returns the sum of data weights for the given Statistics object.
      \nObjectId: id of existing QuantLib::Statistics object"
Category[Statistics] = {GaussianAverageShortfall,GaussianDownsideDeviation,GaussianDownsideVariance,GaussianExpectedShortfall,GaussianPercentile,GaussianPotentialUpside,GaussianRegret,GaussianShortfall,GaussianTopPercentile,GaussianValueAtRisk,IncrementalStatistics,Statistics,StatisticsAverageShortfall,StatisticsDownsideDeviation,StatisticsDownsideVariance,StatisticsErrorEstimate,StatisticsExpectedShortfall,StatisticsGaussianAverageShortfall,StatisticsGaussianDownsideDeviation,StatisticsGaussianDownsideVariance,StatisticsGaussianExpectedShortfall,StatisticsGaussianPercentile,StatisticsGaussianPotentialUpside,StatisticsGaussianRegret,StatisticsGaussianShortfall,StatisticsGaussianTopPercentile,StatisticsGaussianValueAtRisk,StatisticsKurtosis,StatisticsMax,StatisticsMean,StatisticsMin,StatisticsPercentile,StatisticsPotentialUpside,StatisticsRegret,StatisticsSamples,StatisticsSemiDeviation,StatisticsSemiVariance,StatisticsShortfall,StatisticsSkewness,StatisticsStandardDeviation,StatisticsTopPercentile,StatisticsValueAtRisk,StatisticsVariance,StatisticsWeightSum};
AppendTo[QLCategories,Statistics]

(* Swap *)

Swaps::usage = "functions to construct and use Swap objects."

MakeCms::usage = "MakeCms[ObjecctId_Symbol,SwapTenor_String,SwapIndex_Symbol,IborIndex_Symbol,ForwardStart_String,CmsCouponPricer_Symbol] Construct an object of class Swap and return its id
      \nObjectId: id of object to be created\nSwapTenor: swap tenor period.\nSwapIndex: SwapIndex object ID.\nIborIndex: IborIndex object ID.\nIborSpread: spread over the ibor leg. Default value = QuantLib::Null<QuantLib::Spread>().\nForwardStart: forward start period.\nCmsCouponPricer: CmsCouponPricer object ID.\nPermanent: object permanent/nonpermanent"
Swap::usage = "Swap[ObjecctId_Symbol,LegIDs_List,Payer_List /; VectorQ[Payer, Element[#, Booleans] &]] Construct an object of class Swap and return its id
      \nObjectId: id of object to be created\nLegIDs: leg object IDs.\nPayer: TRUE for payed leg.\nPermanent: object permanent/nonpermanent"
SwapLegAnalysis::usage = "SwapLegAnalysis[ObjecctId_Symbol,LegNumber_Integer] Returns the cash flow analysis of the i-th leg for the given Swap object.
      \nObjectId: id of existing QuantLibAddin::Swap object\nLegNumber: Zero based leg number (e.g. use 0 for the first leg, 1 for the second leg, etc.)."
SwapLegBPS::usage = "SwapLegBPS[ObjecctId_Symbol,LegNumber_Integer] returns the BPS of the i-th leg for the given Swap object.
      \nObjectId: id of existing QuantLib::Swap object\nLegNumber: Zero based leg number (e.g. use 0 for the first leg, 1 for the second leg, etc.)."
SwapLegNPV::usage = "SwapLegNPV[ObjecctId_Symbol,LegNumber_Integer] returns the NPV of the i-th leg for the given Swap object.
      \nObjectId: id of existing QuantLib::Swap object\nLegNumber: Zero based leg number (e.g. use 0 for the first leg, 1 for the second leg, etc.)."
SwapMaturityDate::usage = "SwapMaturityDate[ObjecctId_Symbol] Returns the maturity (i.e. last payment) date for the given Swap object.
      \nObjectId: id of existing QuantLib::Swap object"
SwapStartDate::usage = "SwapStartDate[ObjecctId_Symbol] Returns the start (i.e. first accrual) date for the given Swap object.
      \nObjectId: id of existing QuantLib::Swap object"
Category[Swaps] = {MakeCms,Swap,SwapLegAnalysis,SwapLegBPS,SwapLegNPV,SwapMaturityDate,SwapStartDate};
AppendTo[QLCategories,Swaps]

(* Swaption *)

Swaptions::usage = "functions to construct and use Swaption objects."

MakeSwaption::usage = "MakeSwaption[ObjecctId_Symbol,SwapIndex_Symbol,OptionTenor_String,PricingEngineID_Symbol] Construct an object of class Swaption and return its id
      \nObjectId: id of object to be created\nSwapIndex: SwapIndex object ID.\nOptionTenor: option tenor as Period (e.g. '5Y').\nStrike: strike. Default value = Atm-Rate.\nPricingEngineID: Swaption PricingEngine object ID.\nPermanent: object permanent/nonpermanent"
Swaption::usage = "Swaption[ObjecctId_Symbol,VanillaSwap_Symbol,Exercise_Symbol] Construct an object of class Swaption and return its id
      \nObjectId: id of object to be created\nVanillaSwap: underlying (vanilla) swap object ID.\nExercise: Exercise object ID.\nSettlementType: settlement type (PhysicalSettlement, CashSettlement).\nPermanent: object permanent/nonpermanent"
SwaptionImpliedVolatility::usage = "SwaptionImpliedVolatility[ObjecctId_Symbol,Price_?NumberQ,YieldCurve_Symbol] Returns the volatility implied by the given price for the given Swaption object.
      \nObjectId: id of existing QuantLib::Swaption object\nPrice: Price used to infer the implied volatility.\nYieldCurve: discounting YieldTermStructure object ID.\nGuess: Volatility guess. Default value = 0.10.\nAccuracy: solver accuracy. Default value = 1.0e-6.\nMaxIter: solver max iterations. Default value = 100."
SwaptionSettlementType::usage = "SwaptionSettlementType[ObjecctId_Symbol] returns the settlement type (Cash or Delivery) for the given Swaption object.
      \nObjectId: id of existing QuantLib::Swaption object"
SwaptionType::usage = "SwaptionType[ObjecctId_Symbol] returns the type (Payer or Receiver) for the given Swaption object.
      \nObjectId: id of existing QuantLib::Swaption object"
Category[Swaption] = {MakeSwaption,Swaption,SwaptionImpliedVolatility,SwaptionSettlementType,SwaptionType};
AppendTo[QLCategories,Swaptions]

(* Swaption Volatility Term Structures *)

SwaptionVolatilityTermStructures::usage = "functions to construct and use SwaptionVolatilityStructure objects."

ConstantSwaptionVolatility::usage = "ConstantSwaptionVolatility[ObjecctId_Symbol,Volatility_] Construct an object of class ConstantSwaptionVolatility and return its id
      \nObjectId: id of object to be created\nNDays: number of days to advance from EvaluationDate: it fixes the date at which the variance = 0.0. Default value = 0.\nCalendar: holiday calendar (e.g. TARGET) used for calculating the exercise dates from the expiries.\nBusinessDayConvention: Business day convention used for calculating the exercise dates from the expiries.\nVolatility: cap/floor constant volatility Quote.\nDayCounter: DayCounter ID. Default value = Actual/365 (Fixed).\nPermanent: object permanent/nonpermanent"
DenseSabrParameters::usage = "DenseSabrParameters[ObjecctId_Symbol] returns results of Sabr calibration for the given SwaptionVolCube1 object.
      \nObjectId: id of existing QuantLibAddin::SwaptionVolCube1 object"
MarketVolCube::usage = "MarketVolCube[ObjecctId_Symbol] returns the market volatility cube for the given SwaptionVolCube1 object.
      \nObjectId: id of existing QuantLibAddin::SwaptionVolCube1 object"
RelinkableHandleSwaptionVolatilityStructure::usage = "RelinkableHandleSwaptionVolatilityStructure[ObjecctId_Symbol] Construct an object of class RelinkableHandleImpl<QuantLibAddin::SwaptionVolatilityStructure, QuantLib::SwaptionVolatilityStructure> and return its id
      \nObjectId: id of object to be created\nCurrentLink: SwaptionVolatilityStructure object ID. If omitted, nothing is linked by the RelinkableHandle. Default value = .\nPermanent: object permanent/nonpermanent"
SmileSectionByCube::usage = "SmileSectionByCube[ObjecctId_Symbol,VolCube_String,OptionDate_?DateQ,SwapTenor_String] Construct an object of class SmileSectionByCube and return its id
      \nObjectId: id of object to be created\nVolCube: Swaption volatility cube object ID.\nOptionDate: smile's expiry as date.\nSwapTenor: smile's underlying swap length.\nPermanent: object permanent/nonpermanent"
SmileSectionByCube2::usage = "SmileSectionByCube2[ObjecctId_Symbol,VolCube_String,OptionDate_String,SwapTenor_String] Construct an object of class SmileSectionByCube and return its id
      \nObjectId: id of object to be created\nVolCube: Swaption volatility cube object ID.\nOptionDate: smile's expiry as period.\nSwapTenor: smile's underlying swap length.\nPermanent: object permanent/nonpermanent"
SparseSabrParameters::usage = "SparseSabrParameters[ObjecctId_Symbol] returns results of Sabr calibration for the given SwaptionVolCube1 object.
      \nObjectId: id of existing QuantLibAddin::SwaptionVolCube1 object"
SpreadedSwaptionVolatility::usage = "SpreadedSwaptionVolatility[ObjecctId_Symbol,BaseVolStructure_Symbol,Spread_] Construct an object of class SpreadedSwaptionVolatility and return its id
      \nObjectId: id of object to be created\nBaseVolStructure: Base SwaptionVolatilityStructure object ID.\nSpread: spread.\nPermanent: object permanent/nonpermanent"
SwaptionVTSBlackVariance::usage = "SwaptionVTSBlackVariance[ObjecctId_Symbol,OptionDate_List,SwapTenor_String,Strike_?NumberQ] Returns variance from the given SwaptionVolatilityStructure object.
      \nObjectId: id of existing QuantLib::SwaptionVolatilityStructure object\nOptionDate: swaption expiry date.\nSwapTenor: underlying swap tenor.\nStrike: swaption strike vector.\nAllowExtrapolation: Extrapolation Flag (TRUE allows extrapolation). Default value = false."
SwaptionVTSBlackVariance2::usage = "SwaptionVTSBlackVariance2[ObjecctId_Symbol,OptionTenor_List,SwapTenor_String,Strike_?NumberQ] Returns variance from the given SwaptionVolatilityStructure object.
      \nObjectId: id of existing QuantLib::SwaptionVolatilityStructure object\nOptionTenor: swaption option tenor.\nSwapTenor: underlying swap tenor.\nStrike: swaption strike vector.\nAllowExtrapolation: Extrapolation Flag (TRUE allows extrapolation). Default value = false."
SwaptionVTSBusinessDayConvention::usage = "SwaptionVTSBusinessDayConvention[ObjecctId_Symbol] Returns the business day convention used for option date calculation by the given SwaptionVolatilityStructure object.
      \nObjectId: id of existing QuantLib::SwaptionVolatilityStructure object"
SwaptionVTSMatrix::usage = "SwaptionVTSMatrix[ObjecctId_Symbol,BusinessDayConvention_String,OptionTenors_List,SwapTenors_List,Volatilities_?MatrixQ] Construct an object of class SwaptionVolatilityMatrix and return its id
      \nObjectId: id of object to be created\nCalendar: holiday calendar (e.g. TARGET) used for calculating the exercise dates from the expiries.\nBusinessDayConvention: Business day convention used for calculating the exercise dates from the expiries.\nOptionTenors: swaption expiries as periods.\nSwapTenors: underlying swap lengths.\nVolatilities: vol quotes.\nDayCounter: DayCounter ID. Default value = Actual/365 (Fixed).\nPermanent: object permanent/nonpermanent"
SwaptionVTSMatrixLocate::usage = "SwaptionVTSMatrixLocate[ObjecctId_Symbol,OptionDate_?DateQ,SwapTenor_String] Returns the lower indexes of surrounding volatility matrix corners for the given SwaptionVolatilityMatrix object.
      \nObjectId: id of existing QuantLibAddin::SwaptionVolatilityMatrix object\nOptionDate: swaption expiry date.\nSwapTenor: Underlying swap length as period (e.g. 5Y)."
SwaptionVTSMatrixOptionDates::usage = "SwaptionVTSMatrixOptionDates[ObjecctId_Symbol] Returns the vector of swaption exercise dates for the given SwaptionVolatilityDiscrete object.
      \nObjectId: id of existing QuantLib::SwaptionVolatilityDiscrete object"
SwaptionVTSMatrixOptionTenors::usage = "SwaptionVTSMatrixOptionTenors[ObjecctId_Symbol] Returns the vector of swaption exercise tenors for the given SwaptionVolatilityDiscrete object.
      \nObjectId: id of existing QuantLib::SwaptionVolatilityDiscrete object"
SwaptionVTSMatrixSwapTenors::usage = "SwaptionVTSMatrixSwapTenors[ObjecctId_Symbol] Returns the vector of underlying swap tenors for the given SwaptionVolatilityDiscrete object.
      \nObjectId: id of existing QuantLib::SwaptionVolatilityDiscrete object"
SwaptionVTSMaxSwapTenor::usage = "SwaptionVTSMaxSwapTenor[ObjecctId_Symbol] Returns the max swap tenor (i.e. length) for which the given SwaptionVolatilityStructure object can return vols.
      \nObjectId: id of existing QuantLib::SwaptionVolatilityStructure object"
SwaptionVTSOptionDateFromTenor::usage = "SwaptionVTSOptionDateFromTenor[ObjecctId_Symbol,OptionTenor_List] Returns the option date corresponding to a given option tenor, taking calendar and business day convention into account, for the given SwaptionVolatilityStructure object.
      \nObjectId: id of existing QuantLib::SwaptionVolatilityStructure object\nOptionTenor: swaption option tenor."
SwaptionVTSSwapLength::usage = "SwaptionVTSSwapLength[ObjecctId_Symbol,SwapTenor_List] Returns the swap length corresponding to a given swap tenor for the given SwaptionVolatilityStructure object.
      \nObjectId: id of existing QuantLib::SwaptionVolatilityStructure object\nSwapTenor: swap tenor."
SwaptionVTSSwapLength2::usage = "SwaptionVTSSwapLength2[ObjecctId_Symbol,SwapStart_?DateQ,SwapEnd_?DateQ] Returns the swap length corresponding to a given swap start/end dates for the given SwaptionVolatilityStructure object.
      \nObjectId: id of existing QuantLib::SwaptionVolatilityStructure object\nSwapStart: swap start date.\nSwapEnd: swap end date."
SwaptionVTSVolatility::usage = "SwaptionVTSVolatility[ObjecctId_Symbol,OptionDate_?DateQ,SwapTenor_String,Strike_List /; VectorQ[Strike, NumberQ]] Returns volatility from the given SwaptionVolatilityStructure object.
      \nObjectId: id of existing QuantLib::SwaptionVolatilityStructure object\nOptionDate: swaption expiry date.\nSwapTenor: Underlying swap length as period (e.g. 5Y).\nStrike: swaption strike.\nAllowExtrapolation: Extrapolation Flag (TRUE allows extrapolation). Default value = false."
SwaptionVTSVolatility2::usage = "SwaptionVTSVolatility2[ObjecctId_Symbol,OptionTenor_String,SwapTenor_String,Strike_List /; VectorQ[Strike, NumberQ]] Returns volatility from the given SwaptionVolatilityStructure object.
      \nObjectId: id of existing QuantLib::SwaptionVolatilityStructure object\nOptionTenor: swaption option tenor.\nSwapTenor: Underlying swap length as period (e.g. 5Y).\nStrike: swaption strike.\nAllowExtrapolation: Extrapolation Flag (TRUE allows extrapolation). Default value = false."
SwaptionVTSatmStrike::usage = "SwaptionVTSatmStrike[ObjecctId_Symbol,OptionDate_List,SwapTenor_String] Returns the at-the-money swaption strike, for a given exercise date and underlying swap length, for the given SwaptionVolatilityCube object.
      \nObjectId: id of existing QuantLib::SwaptionVolatilityCube object\nOptionDate: swaption expiry date.\nSwapTenor: Underlying swap length as period (e.g. 5Y)."
SwaptionVTSatmStrike2::usage = "SwaptionVTSatmStrike2[ObjecctId_Symbol,OptionTenor_List,SwapTenor_String] Returns the at-the-money swaption strike, for a given option tenor and underlying swap length, for the given SwaptionVolatilityCube object.
      \nObjectId: id of existing QuantLib::SwaptionVolatilityCube object\nOptionTenor: swaption's option tenor.\nSwapTenor: Underlying swap length as period (e.g. 5Y)."
SwaptionVolCube1::usage = "SwaptionVolCube1[ObjecctId_Symbol,AtmVolStructure_Symbol,OptionTenors_List,SwapTenors_List,StrikeSpreads_List /; VectorQ[StrikeSpreads, NumberQ],SpreadVols_?MatrixQ,SwapIndexBase_Symbol,ShortSwapIndexBase_Symbol,Guess_?MatrixQ,IsFixed_List /; VectorQ[IsFixed, Element[#, Booleans] &],IsAtmCalibrated:(True | False)] Construct an object of class SwaptionVolCube1 and return its id
      \nObjectId: id of object to be created\nAtmVolStructure: At-the-money volatility structure.\nOptionTenors: smile cube's expiries as periods.\nSwapTenors: smile cube's underlying swap lengths.\nStrikeSpreads: smile cube's strike spreads over the ATM strike rate.\nSpreadVols: matrix of spread vol quotes.\nSwapIndexBase: Base SwapIndex object ID.\nShortSwapIndexBase: Short base SwapIndex object ID.\nVegaWeightedSmileFit: if TRUE the smile fit is weighted using options' vega. Default value = true.\nGuess: matrix of parameters guess quotes.\nIsFixed: if TRUE parameter guess is not calibrated.\nIsAtmCalibrated: if TRUE the cube is calibrated to atm matrix .\nEndCriteria: EndCriteria object ID. Default value = .\nMaxErrorTol: max error tolerance. Default value = 0.\nOptMethod: Optmization method object ID. Default value = .\nPermanent: object permanent/nonpermanent"
SwaptionVolCube2::usage = "SwaptionVolCube2[ObjecctId_Symbol,AtmVolStructure_Symbol,OptionTenor_List,SwapTenor_List,StrikeSpreads_List /; VectorQ[StrikeSpreads, NumberQ],SpreadVols_?MatrixQ,SwapIndexBase_Symbol,ShortSwapIndexBase_Symbol] Construct an object of class SwaptionVolCube2 and return its id
      \nObjectId: id of object to be created\nAtmVolStructure: At-the-money volatility structure.\nOptionTenor: smile cube's expiries as periods.\nSwapTenor: smile cube's underlying swap lengths.\nStrikeSpreads: smile cube's strike spreads over the ATM strike rate.\nSpreadVols: matrix of spread vol quotes.\nSwapIndexBase: Base SwapIndex object ID.\nShortSwapIndexBase: Short base SwapIndex object ID.\nVegaWeightedSmileFit: if TRUE the smile fit is weighted using options' vega. Default value = true.\nPermanent: object permanent/nonpermanent"
VolCubeAtmCalibrated::usage = "VolCubeAtmCalibrated[ObjecctId_Symbol] returns the volatility cube calibrated to ATM matrix for the given SwaptionVolCube1 object.
      \nObjectId: id of existing QuantLibAddin::SwaptionVolCube1 object"
Category[SwaptionVolatilityTermStructures] = {ConstantSwaptionVolatility,DenseSabrParameters,MarketVolCube,RelinkableHandleSwaptionVolatilityStructure,SmileSectionByCube,SmileSectionByCube2,SparseSabrParameters,SpreadedSwaptionVolatility,SwaptionVTSBlackVariance,SwaptionVTSBlackVariance2,SwaptionVTSBusinessDayConvention,SwaptionVTSMatrix,SwaptionVTSMatrixLocate,SwaptionVTSMatrixOptionDates,SwaptionVTSMatrixOptionTenors,SwaptionVTSMatrixSwapTenors,SwaptionVTSMaxSwapTenor,SwaptionVTSOptionDateFromTenor,SwaptionVTSSwapLength,SwaptionVTSSwapLength2,SwaptionVTSVolatility,SwaptionVTSVolatility2,SwaptionVTSatmStrike,SwaptionVTSatmStrike2,SwaptionVolCube1,SwaptionVolCube2,VolCubeAtmCalibrated};
AppendTo[QLCategories,SwaptionVolatilityTermStructures]

(* Yield Term Structures *)

YieldTermStructures::usage = "functions to construct and use YieldTermStructure objects."

DiscountCurve::usage = "DiscountCurve[ObjecctId_Symbol,CurveDates_List,CurveDiscounts_List /; VectorQ[CurveDiscounts, NumberQ]] Construct an object of class DiscountCurve and return its id
      \nObjectId: id of object to be created\nCurveDates: dates of the curve.\nCurveDiscounts: discount factors for the above dates.\nDayCounter: DayCounter ID. Default value = Actual/365 (Fixed).\nPermanent: object permanent/nonpermanent"
FlatForward::usage = "FlatForward[ObjecctId_Symbol,Rate_] Construct an object of class FlatForward and return its id
      \nObjectId: id of object to be created\nNDays: number of days to advance from EvaluationDate (usually zero or two): it fixes the date at which the discount factor = 1.0. Default value = 0.\nCalendar: holiday calendar (e.g. TARGET) to advance from global EvaluationDate. Default value = NullCalendar.\nRate: the flat forward curve level.\nDayCounter: DayCounter ID. Default value = Actual/365 (Fixed).\nCompounding: Interest rate coumpounding rule (Simple:1+rt, Compounded:(1+r)^t, Continuous:e^{rt}). Default value = Continuous.\nFrequency: frequency (e.g. Annual, Semiannual, Every4Month, Quarterly, Bimonthly, Monthly). Default value = Annual.\nPermanent: object permanent/nonpermanent"
ForwardCurve::usage = "ForwardCurve[ObjecctId_Symbol,CurveDates_List,ForwardYields_List /; VectorQ[ForwardYields, NumberQ]] Construct an object of class ForwardCurve and return its id
      \nObjectId: id of object to be created\nCurveDates: dates of the curve.\nForwardYields: forwards rates for the above dates.\nDayCounter: DayCounter ID. Default value = Actual/365 (Fixed).\nPermanent: object permanent/nonpermanent"
ForwardSpreadedTermStructure::usage = "ForwardSpreadedTermStructure[ObjecctId_Symbol,BaseYieldCurve_Symbol,Spread_] Construct an object of class ForwardSpreadedTermStructure and return its id
      \nObjectId: id of object to be created\nBaseYieldCurve: Base YieldTermStructure object ID.\nSpread: spread.\nPermanent: object permanent/nonpermanent"
ImpliedTermStructure::usage = "ImpliedTermStructure[ObjecctId_Symbol,BaseYieldCurve_Symbol,ReferenceDate_?DateQ] Construct an object of class ImpliedTermStructure and return its id
      \nObjectId: id of object to be created\nBaseYieldCurve: Base YieldTermStructure object ID.\nReferenceDate: the reference date the base YieldTermStructure should be shifted to.\nPermanent: object permanent/nonpermanent"
InterpolatedYieldCurve::usage = "InterpolatedYieldCurve[ObjecctId_Symbol,Dates_List,Data_List /; VectorQ[Data, NumberQ],Jumps_List,JumpDates_List] Construct an object of class InterpolatedYieldCurve and return its id
      \nObjectId: id of object to be created\nDates: vector of dates, the first one being the one at which discount factor = 1.0\nData: data vector. Each element should be of the type selected by TraitsID\nCalendar: holiday calendar (e.g. TARGET) to advance from global EvaluationDate.\nDayCounter: DayCounter ID. Default value = Actual/365 (Fixed).\nJumps: Jump quotes vector.\nJumpDates: Jump dates vector.\nTraitsID: Discount, ZeroYield, or ForwardRate. Default value = Discount.\nInterpolatorID: BackwardFlat, ForwardFlat, Linear, LogLinear, LogParabolic, KrugerLogCubic, etc. Default value = MonotonicLogCubicNaturalSpline.\nPermanent: object permanent/nonpermanent"
InterpolatedYieldCurveData::usage = "InterpolatedYieldCurveData[ObjecctId_Symbol] Retrieve Data for the given InterpolatedYieldCurve.
      \nObjectId: id of existing QuantLibAddin::InterpolatedYieldCurve object"
InterpolatedYieldCurveDates::usage = "InterpolatedYieldCurveDates[ObjecctId_Symbol] Retrieve list of Dates for the given InterpolatedYieldCurve.
      \nObjectId: id of existing QuantLibAddin::InterpolatedYieldCurve object"
InterpolatedYieldCurveJumpDates::usage = "InterpolatedYieldCurveJumpDates[ObjecctId_Symbol] Retrieve list of jump dates for the given InterpolatedYieldCurve.
      \nObjectId: id of existing QuantLibAddin::InterpolatedYieldCurve object"
InterpolatedYieldCurveJumpTimes::usage = "InterpolatedYieldCurveJumpTimes[ObjecctId_Symbol] Retrieve list of jump times for the given InterpolatedYieldCurve.
      \nObjectId: id of existing QuantLibAddin::InterpolatedYieldCurve object"
InterpolatedYieldCurveTimes::usage = "InterpolatedYieldCurveTimes[ObjecctId_Symbol] Retrieve list of Times for the given InterpolatedYieldCurve.
      \nObjectId: id of existing QuantLibAddin::InterpolatedYieldCurve object"
RelinkableHandleYieldTermStructure::usage = "RelinkableHandleYieldTermStructure[ObjecctId_Symbol] Construct an object of class RelinkableHandleImpl<QuantLibAddin::YieldTermStructure, QuantLib::YieldTermStructure> and return its id
      \nObjectId: id of object to be created\nCurrentLink: YieldTermStructure object ID. If omitted, nothing is linked by the RelinkableHandle. Default value = .\nPermanent: object permanent/nonpermanent"
TermStructureCalendar::usage = "TermStructureCalendar[ObjecctId_Symbol] Returns the calendar used by the given TermStructure object.
      \nObjectId: id of existing QuantLib::TermStructure object"
TermStructureDayCounter::usage = "TermStructureDayCounter[ObjecctId_Symbol] Returns the DayCounter used by the given TermStructure object.
      \nObjectId: id of existing QuantLib::TermStructure object"
TermStructureMaxDate::usage = "TermStructureMaxDate[ObjecctId_Symbol] Returns the max date for the given TermStructure object.
      \nObjectId: id of existing QuantLib::TermStructure object"
TermStructureReferenceDate::usage = "TermStructureReferenceDate[ObjecctId_Symbol] Returns the reference date for the given TermStructure object.
      \nObjectId: id of existing QuantLib::TermStructure object"
TermStructureSettlementDays::usage = "TermStructureSettlementDays[ObjecctId_Symbol] Returns the number of settlement days for the given TermStructure object.
      \nObjectId: id of existing QuantLib::TermStructure object"
TermStructureTimeFromReference::usage = "TermStructureTimeFromReference[ObjecctId_Symbol,Date_List] Returns the time from the reference date for the given TermStructure object.
      \nObjectId: id of existing QuantLib::TermStructure object\nDate: vector of dates."
YieldTSDiscount::usage = "YieldTSDiscount[ObjecctId_Symbol,DfDates_List] Returns a discount factor from the given YieldTermStructure object.
      \nObjectId: id of existing QuantLib::YieldTermStructure object\nDfDates: vector of dates.\nAllowExtrapolation: TRUE allows extrapolation. Default value = false."
YieldTSForwardRate::usage = "YieldTSForwardRate[ObjecctId_Symbol,D1_?DateQ,D2_List] Returns the forward interest rate from the given YieldTermStructure object.
      \nObjectId: id of existing QuantLib::YieldTermStructure object\nD1: first date.\nD2: second date.\nDayCounter: result DayCounter ID. Default value = Actual/365 (Fixed).\nCompounding: Interest rate compounding rule (Simple:1+rt, Compounded:(1+r)^t, Continuous:e^{rt}). Default value = Simple.\nFrequency: frequency (e.g. Annual, Semiannual, Every4Month, Quarterly, Bimonthly, Monthly). Default value = Annual.\nAllowExtrapolation: TRUE allows extrapolation. Default value = false."
YieldTSForwardRate2::usage = "YieldTSForwardRate2[ObjecctId_Symbol,Date_List,Period_String] Returns the forward interest rate from the given YieldTermStructure object.
      \nObjectId: id of existing QuantLib::YieldTermStructure object\nDate: first date.\nPeriod: Period (e.g. '7D', '3M', '1Y', etc).\nDayCounter: result DayCounter ID. Default value = Actual/365 (Fixed).\nCompounding: Interest rate compounding rule (Simple:1+rt, Compounded:(1+r)^t, Continuous:e^{rt}). Default value = Simple.\nFrequency: frequency (e.g. Annual, Semiannual, Every4Month, Quarterly, Bimonthly, Monthly). Default value = Annual.\nAllowExtrapolation: TRUE allows extrapolation. Default value = false."
YieldTSZeroRate::usage = "YieldTSZeroRate[ObjecctId_Symbol,Dates_List] Returns the zero interest rate from the given YieldTermStructure object.
      \nObjectId: id of existing QuantLib::YieldTermStructure object\nDates: date.\nResultDayCounter: resultDayCounter.\nCompounding: Interest rate coumpounding rule (Simple:1+rt, Compounded:(1+r)^t, Continuous:e^{rt}). Default value = Continuous.\nFrequency: frequency (e.g. Annual, Semiannual, Every4Month, Quarterly, Bimonthly, Monthly). Default value = Annual.\nAllowExtrapolation: TRUE allows extrapolation. Default value = false."
YieldTSDates::usage = "YieldTSDates[ObjecctId_Symbol] Returns the dates from a given YieldTermStructure object."
ZeroCurve::usage = "ZeroCurve[ObjecctId_Symbol,CurveDates_List,CurveYields_List /; VectorQ[CurveYields, NumberQ]] Construct an object of class ZeroCurve and return its id
      \nObjectId: id of object to be created\nCurveDates: dates of the curve.\nCurveYields: zero rates for the above dates.\nDayCounter: DayCounter ID. Default value = Actual/365 (Fixed).\nPermanent: object permanent/nonpermanent"
Category[YieldTermStructures] = {DiscountCurve,FlatForward,ForwardCurve,ForwardSpreadedTermStructure,ImpliedTermStructure,InterpolatedYieldCurve,InterpolatedYieldCurveData,InterpolatedYieldCurveDates,InterpolatedYieldCurveJumpDates,InterpolatedYieldCurveJumpTimes,InterpolatedYieldCurveTimes,RelinkableHandleYieldTermStructure,TermStructureCalendar,TermStructureDayCounter,TermStructureMaxDate,TermStructureReferenceDate,TermStructureSettlementDays,TermStructureTimeFromReference,YieldTSDiscount,YieldTSForwardRate,YieldTSForwardRate2,YieldTSZeroRate,YieldTSDates,ZeroCurve};
AppendTo[QLCategories,YieldTermStructures]

(* TimeGrids *)

TimeGrids::usage = "functions to construct and use TimeGrid objects."
TimeGrid::usage = " ";
AppendTo[QLCategories,TimeGrids]
(* TimeSeries *)

TimeSeries::usage = "functions to construct and use TimeSeries objects."

TimeSeries::usage = "TimeSeries[ObjecctId_Symbol,Dates_List,Values_List /; VectorQ[Values, NumberQ]] Construct an object of class TimeSeriesDef and return its id
      \nObjectId: id of object to be created\nDates: dates.\nValues: values.\nPermanent: object permanent/nonpermanent"
TimeSeriesDates::usage = "TimeSeriesDates[ObjecctId_Symbol] Returns the dates for which historical data exist.
      \nObjectId: id of existing QuantLib::TimeSeriesDef object"
TimeSeriesEmpty::usage = "TimeSeriesEmpty[ObjecctId_Symbol] Returns whether the series contains any data.
      \nObjectId: id of existing QuantLib::TimeSeriesDef object"
TimeSeriesFirstDate::usage = "TimeSeriesFirstDate[ObjecctId_Symbol] Returns the first date for which a historical datum exists.
      \nObjectId: id of existing QuantLib::TimeSeriesDef object"
TimeSeriesFromIndex::usage = "TimeSeriesFromIndex[ObjecctId_Symbol,Index_Symbol] Construct an object of class TimeSeriesDef and return its id
      \nObjectId: id of object to be created\nIndex: Index object ID.\nPermanent: object permanent/nonpermanent"
TimeSeriesLastDate::usage = "TimeSeriesLastDate[ObjecctId_Symbol] Returns the last date for which a historical datum exists.
      \nObjectId: id of existing QuantLib::TimeSeriesDef object"
TimeSeriesSize::usage = "TimeSeriesSize[ObjecctId_Symbol] Returns the first date for which a historical datum exists.
      \nObjectId: id of existing QuantLib::TimeSeriesDef object"
TimeSeriesValue::usage = "TimeSeriesValue[ObjecctId_Symbol,Dates_List] Returns returns the data corresponding to the given dates.
      \nObjectId: id of existing QuantLibAddin::TimeSeriesDef object\nDates: fixing date(s)."
TimeSeriesValues::usage = "TimeSeriesValues[ObjecctId_Symbol] Returns the historical data.
      \nObjectId: id of existing QuantLib::TimeSeriesDef object"
Category[TimeSeries] = {TimeSeries,TimeSeriesDates,TimeSeriesEmpty,TimeSeriesFirstDate,TimeSeriesFromIndex,TimeSeriesLastDate,TimeSeriesSize,TimeSeriesValue,TimeSeriesValues};
AppendTo[QLCategories,TimeSeries]

(* Utilities *)

Utilities::usage = "diagnostic and utility functions."

QLVersion::usage = "QLVersion[] returns the version number of QuantLib."
Category[Utilities] = {QLVersion};
AppendTo[QLCategories,Utilities]

(* Vanilla Swap *)

VanillaSwaps::usage = "functions to construct and use VanillaSwap objects."

MakeIMMSwap::usage = "MakeIMMSwap[ObjecctId_Symbol,SwapTenor_String,IborIndex_Symbol,PricingEngineID_Symbol] Construct an object of class VanillaSwap and return its id
      \nObjectId: id of object to be created\nSwapTenor: swap tenor period (e.g. 2Y).\nIborIndex: floating IborIndex object ID.\nFixedRate: the fixed leg rate. If missing atm rate is used. Default value = 0.\nFirstImmDate: First (IMM) date. Default value = Date[].\nFixDayCounter: fixed leg day counter. Default value = 30/360 (Bond Basis).\nSpread: floating leg spread. Default value = 0.0.\nPricingEngineID: DiscountSwapEngine object ID.\nPermanent: object permanent/nonpermanent"
MakeVanillaSwap::usage = "MakeVanillaSwap[ObjecctId_Symbol,SwapTenor_String,IborIndex_Symbol,ForwardStart_String,PricingEngineID_Symbol] Construct an object of class VanillaSwap and return its id
      \nObjectId: id of object to be created\nSwapTenor: swap tenor period (e.g. 5Y).\nIborIndex: floating IborIndex object ID.\nFixedRate: the fixed leg rate. If missing atm rate is used. Default value = 0.\nForwardStart: forward start period.\nFixedLegDayCounter: fixed leg day counter. Default value = 30/360 (Bond Basis).\nSpread: floating leg spread. Default value = 0.0.\nPricingEngineID: DiscountSwapEngine object ID.\nPermanent: object permanent/nonpermanent"
VanillaSwap::usage = "VanillaSwap[ObjecctId_Symbol,Nominal_,FixSchedule_Symbol,FixedRate_,FloatingLegSchedule_Symbol,IborIndex_Symbol,PayerReceiver_] Construct an object of class VanillaSwap and return its id
      \nObjectId: id of object to be created\nPayerReceiver: PAYER to pay the fixed rate, RECEIVER to receive it. Default value = Payer.\nNominal: Notional Amount. Default value = 100.\nFixSchedule: fixed leg Schedule object ID.\nFixedRate: the fixed leg rate. Default value = 0.0.\nFixDayCounter: fixed leg day counter (e.g. Actual/360).\nFloatingLegSchedule: floating leg Schedule object ID.\nIborIndex: floating leg IborIndex object ID.\nSpread: floating leg spread. Default value = 0.0.\nFloatingLegDayCounter: floating day counter (e.g. Actual/360). Default value = Automtatic. Automatic will set the day counter to the day counter of the IborIndex.\nPaymentConvention: Payment dates' business day convention. Default value = Following.\nPermanent: object permanent/nonpermanent"
VanillaSwapFairRate::usage = "VanillaSwapFairRate[ObjecctId_Symbol] returns the fair fixed leg rate which would zero the swap NPV for the given VanillaSwap object.
      \nObjectId: id of existing QuantLib::VanillaSwap object"
VanillaSwapFairSpread::usage = "VanillaSwapFairSpread[ObjecctId_Symbol] returns the fair spread over the floating rate which would zero the swap NPV for the given VanillaSwap object.
      \nObjectId: id of existing QuantLib::VanillaSwap object"
VanillaSwapFixedDayCount::usage = "VanillaSwapFixedDayCount[ObjecctId_Symbol] returns the fixed rate day count convention for the given VanillaSwap object.
      \nObjectId: id of existing QuantLib::VanillaSwap object"
VanillaSwapFixedLegAnalysis::usage = "VanillaSwapFixedLegAnalysis[ObjecctId_Symbol] returns the fixed rate leg cash flow analysis of the given VanillaSwap object.
      \nObjectId: id of existing QuantLibAddin::VanillaSwap object"
VanillaSwapFixedLegBPS::usage = "VanillaSwapFixedLegBPS[ObjecctId_Symbol] returns the BPS of the fixed rate leg for the given VanillaSwap object.
      \nObjectId: id of existing QuantLib::VanillaSwap object"
VanillaSwapFixedLegNPV::usage = "VanillaSwapFixedLegNPV[ObjecctId_Symbol] returns the NPV of the fixed rate leg for the given VanillaSwap object.
      \nObjectId: id of existing QuantLib::VanillaSwap object"
VanillaSwapFixedRate::usage = "VanillaSwapFixedRate[ObjecctId_Symbol] returns the fixed leg rate for the given VanillaSwap object.
      \nObjectId: id of existing QuantLib::VanillaSwap object"
VanillaSwapFloatingDayCount::usage = "VanillaSwapFloatingDayCount[ObjecctId_Symbol] returns the floating leg day count convention for the given VanillaSwap object.
      \nObjectId: id of existing QuantLib::VanillaSwap object"
VanillaSwapFloatingLegAnalysis::usage = "VanillaSwapFloatingLegAnalysis[ObjecctId_Symbol] returns the floating rate leg cash flow analysis.
      \nObjectId: id of existing QuantLibAddin::VanillaSwap object"
VanillaSwapFloatingLegBPS::usage = "VanillaSwapFloatingLegBPS[ObjecctId_Symbol] returns the BPS of the floating rate leg for the given VanillaSwap object.
      \nObjectId: id of existing QuantLib::VanillaSwap object"
VanillaSwapFloatingLegNPV::usage = "VanillaSwapFloatingLegNPV[ObjecctId_Symbol] returns the NPV of the floating rate leg for the given VanillaSwap object.
      \nObjectId: id of existing QuantLib::VanillaSwap object"
VanillaSwapFromSwapIndex::usage = "VanillaSwapFromSwapIndex[ObjecctId_Symbol,SwapIndex_Symbol,FixingDate_?DateQ] Construct an object of class VanillaSwap and return its id
      \nObjectId: id of object to be created\nSwapIndex: SwapIndex object ID.\nFixingDate: fixing date.\nPermanent: object permanent/nonpermanent"
VanillaSwapFromSwapRateHelper::usage = "VanillaSwapFromSwapRateHelper[ObjecctId_Symbol,SwapRateHelper_Symbol] Construct an object of class VanillaSwap and return its id
      \nObjectId: id of object to be created\nSwapRateHelper: SwapRateHelper object ID.\nPermanent: object permanent/nonpermanent"
VanillaSwapNominal::usage = "VanillaSwapNominal[ObjecctId_Symbol] returns the swap nominal for the given VanillaSwap object.
      \nObjectId: id of existing QuantLib::VanillaSwap object"
VanillaSwapPaymentConvention::usage = "VanillaSwapPaymentConvention[ObjecctId_Symbol] returns the payment business day convention for the given VanillaSwap object.
      \nObjectId: id of existing QuantLib::VanillaSwap object"
VanillaSwapSpread::usage = "VanillaSwapSpread[ObjecctId_Symbol] returns the spread over floating rate for the given VanillaSwap object.
      \nObjectId: id of existing QuantLib::VanillaSwap object"
VanillaSwapType::usage = "VanillaSwapType[ObjecctId_Symbol] returns the swap type (Payer or Receiver) of the given VanillaSwap object.
      \nObjectId: id of existing QuantLib::VanillaSwap object"
Category[VanillaSwaps] = {MakeIMMSwap,MakeVanillaSwap,VanillaSwap,VanillaSwapFairRate,VanillaSwapFairSpread,VanillaSwapFixedDayCount,VanillaSwapFixedLegAnalysis,VanillaSwapFixedLegBPS,VanillaSwapFixedLegNPV,VanillaSwapFixedRate,VanillaSwapFloatingDayCount,VanillaSwapFloatingLegAnalysis,VanillaSwapFloatingLegBPS,VanillaSwapFloatingLegNPV,VanillaSwapFromSwapIndex,VanillaSwapFromSwapRateHelper,VanillaSwapNominal,VanillaSwapPaymentConvention,VanillaSwapSpread,VanillaSwapType};
AppendTo[QLCategories,VanillaSwaps]

(* Volatilities *)

Volatilities::usage = "functions to construct and use volatility objects."

AbcdAtmVolCurve::usage = "AbcdAtmVolCurve[ObjecctId_Symbol,SettlementDays_Integer,OptionTenors_List,VolatilitiesQuotes_List,InclusionInInterpolation_List /; VectorQ[InclusionInInterpolation, Element[#, Booleans] &],Convention_String] Construct an object of class AbcdAtmVolCurve and return its id
      \nObjectId: id of object to be created\nSettlementDays: settlement days.\nCalendar: holiday calendar (e.g. TARGET).\nOptionTenors: options tenors.\nVolatilitiesQuotes: volatilities quotes.\nInclusionInInterpolation: inclusion flags. If omitted, all volatilities are interpolated.\nConvention: business day convention (e.g. Following).\nDayCounter: DayCounter ID. Default value = Actual/365 (Fixed).\nPermanent: object permanent/nonpermanent"
AtmCurve::usage = "AtmCurve[ObjecctId_Symbol] Returns the Atm volatility curve.
      \nObjectId: id of existing QuantLibAddin::SabrVolSurface object"
BlackAtmVolCurveAtmVariance::usage = "BlackAtmVolCurveAtmVariance[ObjecctId_Symbol,OptionDate_?DateQ] Returns the spot at-the-money (no-smile) variance at a given option date.
      \nObjectId: id of existing QuantLib::BlackAtmVolCurve object\nOptionDate: The date at which the volatility is evaluated.\nAllowExtrapolation: Extrapolation Flag (TRUE allows extrapolation). Default value = false."
BlackAtmVolCurveAtmVariance2::usage = "BlackAtmVolCurveAtmVariance2[ObjecctId_Symbol,OptionTenor_String] Returns the spot at-the-money (no-smile) variance at a given option tenor.
      \nObjectId: id of existing QuantLib::BlackAtmVolCurve object\nOptionTenor: The tenor at which the volatility is evaluated.\nAllowExtrapolation: Extrapolation Flag (TRUE allows extrapolation). Default value = false."
BlackAtmVolCurveAtmVariance3::usage = "BlackAtmVolCurveAtmVariance3[ObjecctId_Symbol,OptionTime_?NumberQ] Returns the spot at-the-money (no-smile) variance at a given option time.
      \nObjectId: id of existing QuantLib::BlackAtmVolCurve object\nOptionTime: The time at which the volatility is evaluated.\nAllowExtrapolation: Extrapolation Flag (TRUE allows extrapolation). Default value = false."
BlackAtmVolCurveAtmVol::usage = "BlackAtmVolCurveAtmVol[ObjecctId_Symbol,OptionDate_?DateQ] Returns the spot at-the-money (no-smile) volatility at a given option date.
      \nObjectId: id of existing QuantLib::BlackAtmVolCurve object\nOptionDate: The date at which the volatility is evaluated.\nAllowExtrapolation: Extrapolation Flag (TRUE allows extrapolation). Default value = false."
BlackAtmVolCurveAtmVol2::usage = "BlackAtmVolCurveAtmVol2[ObjecctId_Symbol,OptionTenor_String] Returns the spot at-the-money (no-smile) volatility at a given option tenor.
      \nObjectId: id of existing QuantLib::BlackAtmVolCurve object\nOptionTenor: The time at which the volatility is evaluated.\nAllowExtrapolation: Extrapolation Flag (TRUE allows extrapolation). Default value = false."
BlackAtmVolCurveAtmVol3::usage = "BlackAtmVolCurveAtmVol3[ObjecctId_Symbol,OptionTime_?NumberQ] Returns the spot at-the-money (no-smile) volatility at a given option time.
      \nObjectId: id of existing QuantLib::BlackAtmVolCurve object\nOptionTime: The time at which the volatility is evaluated.\nAllowExtrapolation: Extrapolation Flag (TRUE allows extrapolation). Default value = false."
BlackConstantVol::usage = "BlackConstantVol[ObjecctId_Symbol,SettlementDate_?DateQ,Volatility_?NumberQ] Construct an object of class BlackConstantVol and return its id
      \nObjectId: id of object to be created\nSettlementDate: settlement date.\nCalendar: holiday calendar (e.g. TARGET).\nVolatility: volatility.\nDayCounter: DayCounter ID. Default value = Actual/365 (Fixed).\nPermanent: object permanent/nonpermanent"
BlackVarianceSurface::usage = "BlackVarianceSurface[ObjecctId_Symbol,SettlementDate_?DateQ,Dates_List,Strikes_List /; VectorQ[Strikes, NumberQ],Volatilities_?MatrixQ] Construct an object of class BlackVarianceSurface and return its id
      \nObjectId: id of object to be created\nSettlementDate: settlement date.\nCalendar: holiday calendar (e.g. TARGET).\nDates: dates.\nStrikes: strikes.\nVolatilities: volatilities.\nDayCounter: DayCounter ID. Default value = Actual/365 (Fixed).\nPermanent: object permanent/nonpermanent"
BlackVolTermStructureBlackForwardVariance::usage = "BlackVolTermStructureBlackForwardVariance[ObjecctId_Symbol,ForwardDate_?DateQ,OptionDate_?DateQ,Strike_?NumberQ] Returns the black forward (at-the-money) variance at a given option date and strike.
      \nObjectId: id of existing QuantLib::BlackVolTermStructure object\nForwardDate: The forward date at which the volatility is evaluated.\nOptionDate: The date at which the variance is evaluated.\nStrike: The strike at which the variance is evaluated.\nAllowExtrapolation: Extrapolation Flag (TRUE allows extrapolation). Default value = false."
BlackVolTermStructureBlackForwardVol::usage = "BlackVolTermStructureBlackForwardVol[ObjecctId_Symbol,ForwardDate_?DateQ,OptionDate_?DateQ,Strike_?NumberQ] Returns the black forward (at-the-money) volatility at a given option date and strike.
      \nObjectId: id of existing QuantLib::BlackVolTermStructure object\nForwardDate: The forward date at which the volatility is evaluated.\nOptionDate: The option date at which the volatility is evaluated.\nStrike: The strike at which the volatility is evaluated.\nAllowExtrapolation: Extrapolation Flag (TRUE allows extrapolation). Default value = false."
BlackVolTermStructureBlackVariance::usage = "BlackVolTermStructureBlackVariance[ObjecctId_Symbol,OptionDate_?DateQ,Strike_?NumberQ] Returns the black spot variance at a given option date and strike.
      \nObjectId: id of existing QuantLib::BlackVolTermStructure object\nOptionDate: The date at which the variance is evaluated.\nStrike: The strike at which the variance is evaluated.\nAllowExtrapolation: Extrapolation Flag (TRUE allows extrapolation). Default value = false."
BlackVolTermStructureBlackVol::usage = "BlackVolTermStructureBlackVol[ObjecctId_Symbol,OptionDate_?DateQ,Strike_?NumberQ] Returns the black spot volatility at a given option date and strike.
      \nObjectId: id of existing QuantLib::BlackVolTermStructure object\nOptionDate: The date at which the volatility is evaluated.\nStrike: The strike at which the volatility is evaluated.\nAllowExtrapolation: Extrapolation Flag (TRUE allows extrapolation). Default value = false."
SabrVolSurface::usage = "SabrVolSurface[ObjecctId_Symbol,InterestRateIndex_Symbol,BlackAtmVolCurve_Symbol,OptionTenors_List,AtmRateSpreads_List /; VectorQ[AtmRateSpreads, NumberQ],VolatilitiesQuotes_?MatrixQ] Construct an object of class SabrVolSurface and return its id
      \nObjectId: id of object to be created\nInterestRateIndex: interest rate index object ID.\nBlackAtmVolCurve: the atm volatility curve.\nOptionTenors: options tenors.\nAtmRateSpreads: spreads.\nVolatilitiesQuotes: volatilities quotes.\nPermanent: object permanent/nonpermanent"
SabrVolatility::usage = "SabrVolatility[Strike_?NumberQ,Forward_?NumberQ,ExpTime_?NumberQ,Alpha_?NumberQ,Beta_?NumberQ,Nu_?NumberQ,Rho_?NumberQ] Sabr formula for smile volatility.
      \nStrike: option strike.\nForward: underlying forward value.\nExpTime: expiry time (in years).\nAlpha: alpha.\nBeta: beta.\nNu: nu.\nRho: rho."
VolatilitySpreads::usage = "VolatilitySpreads[ObjecctId_Symbol,OptionDate_?DateQ] Returns the volatilities spread at a given date.
      \nObjectId: id of existing QuantLib::SabrVolSurface object\nOptionDate: The date at which the volatility is evaluated."
VolatilitySpreads2::usage = "VolatilitySpreads2[ObjecctId_Symbol,OptionTenor_String] Returns the volatilities spread at a given date.
      \nObjectId: id of existing QuantLib::SabrVolSurface object\nOptionTenor: The tenor at which the volatility is evaluated."
VolatilityTermStructureBusinessDayConvention::usage = "VolatilityTermStructureBusinessDayConvention[ObjecctId_Symbol] Returns the business day convention used in tenor to date conversion.
      \nObjectId: id of existing QuantLib::VolatilityTermStructure object"
VolatilityTermStructureMaxStrike::usage = "VolatilityTermStructureMaxStrike[ObjecctId_Symbol] Returns the maximum strike for which the given VolatilityTermStructure can return vols.
      \nObjectId: id of existing QuantLib::VolatilityTermStructure object"
VolatilityTermStructureMinStrike::usage = "VolatilityTermStructureMinStrike[ObjecctId_Symbol] Returns the minimum strike for which the given VolatilityTermStructure can return vols.
      \nObjectId: id of existing QuantLib::VolatilityTermStructure object"
VolatilityTermStructureOptionDateFromTenor::usage = "VolatilityTermStructureOptionDateFromTenor[ObjecctId_Symbol,Tenor_String] Returns the option date corrisponding to a given option tenor.
      \nObjectId: id of existing QuantLib::VolatilityTermStructure object\nTenor: option tenor."
Category[Volatilities] = {AbcdAtmVolCurve,AtmCurve,BlackAtmVolCurveAtmVariance,BlackAtmVolCurveAtmVariance2,BlackAtmVolCurveAtmVariance3,BlackAtmVolCurveAtmVol,BlackAtmVolCurveAtmVol2,BlackAtmVolCurveAtmVol3,BlackConstantVol,BlackVarianceSurface,BlackVolTermStructureBlackForwardVariance,BlackVolTermStructureBlackForwardVol,BlackVolTermStructureBlackVariance,BlackVolTermStructureBlackVol,SabrVolSurface,SabrVolatility,VolatilitySpreads,VolatilitySpreads2,VolatilityTermStructureBusinessDayConvention,VolatilityTermStructureMaxStrike,VolatilityTermStructureMinStrike,VolatilityTermStructureOptionDateFromTenor};
AppendTo[QLCategories,Volatilities]

(* Market Model Volatility *)

MarketModelVolatility::usage = "functions to construct and use Market Model Volatility objects."

MarketModelLmExtLinearExponentialVolModel::usage = "MarketModelLmExtLinearExponentialVolModel[ObjecctId_Symbol,FixingTimes_List /; VectorQ[FixingTimes, NumberQ],A_?NumberQ,B_?NumberQ,C_?NumberQ,D_?NumberQ] Construct an object of class LmExtLinearExponentialVolModel and return its id
      \nObjectId: id of object to be created\nFixingTimes: rate fixing times.\nA: a parameter.\nB: b parameter.\nC: c parameter.\nD: d parameter.\nPermanent: object permanent/nonpermanent"
PiecewiseConstantAbcdVariance::usage = "PiecewiseConstantAbcdVariance[ObjecctId_Symbol,ResetIndex_Integer,RateTimes_List /; VectorQ[RateTimes, NumberQ]] Construct an object of class PiecewiseConstantAbcdVariance and return its id
      \nObjectId: id of object to be created\nA: coefficient in abcd vol parametrization. Used as guess if the object is later calibrated. Default value = -0.06.\nB: coefficient in the abcd vol parametrization. Used as guess if the object is later calibrated. Default value = 0.17.\nC: coefficient in the abcd vol parametrization. Used as guess if the object is later calibrated. Default value = 0.54.\nD: coefficient in the abcd vol parametrization. Used as guess if the object is later calibrated. Default value = 0.17.\nResetIndex: Index that defines the reset time of rate.\nRateTimes: rate fixing times.\nPermanent: object permanent/nonpermanent"
PiecewiseConstantVarianceRateTimes::usage = "PiecewiseConstantVarianceRateTimes[ObjecctId_Symbol] Returns the rate time of the PiecewiseConstantVariance object.
      \nObjectId: id of existing QuantLib::PiecewiseConstantVariance object"
PiecewiseConstantVarianceTotalVariance::usage = "PiecewiseConstantVarianceTotalVariance[ObjecctId_Symbol,TimeIndex_Integer] Returns the total variance at a given time index of the PiecewiseConstantVariance object.
      \nObjectId: id of existing QuantLib::PiecewiseConstantVariance object\nTimeIndex: time index."
PiecewiseConstantVarianceTotalVolatility::usage = "PiecewiseConstantVarianceTotalVolatility[ObjecctId_Symbol,TimeIndex_Integer] Returns the total variance at a given time index of the PiecewiseConstantVariance object.
      \nObjectId: id of existing QuantLib::PiecewiseConstantVariance object\nTimeIndex: time index."
PiecewiseConstantVarianceVariance::usage = "PiecewiseConstantVarianceVariance[ObjecctId_Symbol,TimeIndex_Integer] Returns the piecewise constant variance at a given time index.
      \nObjectId: id of existing QuantLib::PiecewiseConstantVariance object\nTimeIndex: time index."
PiecewiseConstantVarianceVariances::usage = "PiecewiseConstantVarianceVariances[ObjecctId_Symbol] Returns the piecewise constant variances.
      \nObjectId: id of existing QuantLib::PiecewiseConstantVariance object"
PiecewiseConstantVarianceVolatilities::usage = "PiecewiseConstantVarianceVolatilities[ObjecctId_Symbol] Returns the piecewise constant volatilities.
      \nObjectId: id of existing QuantLib::PiecewiseConstantVariance object"
PiecewiseConstantVarianceVolatility::usage = "PiecewiseConstantVarianceVolatility[ObjecctId_Symbol,TimeIndex_Integer] Returns the piecewise constant volatility at a given time index.
      \nObjectId: id of existing QuantLib::PiecewiseConstantVariance object\nTimeIndex: time index."
Category[MarketModelVolatility] = {MarketModelLmExtLinearExponentialVolModel,PiecewiseConstantAbcdVariance,PiecewiseConstantVarianceRateTimes,PiecewiseConstantVarianceTotalVariance,PiecewiseConstantVarianceTotalVolatility,PiecewiseConstantVarianceVariance,PiecewiseConstantVarianceVariances,PiecewiseConstantVarianceVolatilities,PiecewiseConstantVarianceVolatility};
AppendTo[QLCategories,MarketModelVolatility]



 SetEvaluationDate::usage = "Sets the evaluation date."
 EvaluationDate::usage = "Retrieves the evaluation date."

 NPV::usage="" 

 QLListObjects::usage="List IDs of all objects in repository. Returns empty list if repository is empty."
 QLDeleteObject::usage="Delete Object with given ID. Does nothing if no object exists with that ID."
 QLDeleteObjects::usage="Delete all objects in repository. Does nothing if repository is already empty."
 QLUpdate::usage="Updates the Mathematica representation of a QuantLib object."
 QLDump::usage="Dumps a QuantLib object."

 DateQ::usage ="DateQ[date] returns True if date represents a date and False otherwise."
 ToJulian::usage ="ToJulian[date] returns a julian representation of a date."
 ToCalendar::usage ="ToCalendar[julian_Integer] returns a calender representation of a julian number date."

QLMember::usage="Attribute set to True for member functions."
QLConstructor::usage="Attribute set to True for constructors."
QLType::usage="Object type for which a member is applicable."
QLProcedure::usage="Attribute set to True for procedure functions."
QLEnumerationMember::usage="Attribute set to True for enumeration member functions."

GetEnumerationClasses::usage="Returns the list of QuantLib enumeration classes.";
GetEnumerationTypes::usage="Returns the list of QuantLIb enumeration types.";
GetEnumerationType::usage="GetEnumerationType[enumeration] returns the values for a QuantLib enumeration.";




 QuantLibError::"msg" = "`1` `2`"
 
 Off[General::shdw]
 Mathlink::NaN::"msg" = "`1`"
 On[General::shdw]